Python bindings to TEOS-10

This package is still in beta testing phase and some of its functions are
likely to evolve over time.

Includes:
- Sea-Ice-Water (SIA) Library 3.0 + simple code fixes (for easy compilation)
- An extra module layer 'Liq_Ice_Air_5a.F90', 'Liq_Ice_Air_5b.F90', 'Liq_Ice_Air_5c.F90' and
    'Liq_Ice_Air_5d.F90' with the temperature, the entropy, the potential temperature,
    the equivalent potential temperature and the pseudo equivalent potential temperature
    valid over the whole region of validity of TEOS-10.
- Two other extra modules 'Liq_Air_4d.F90' and 'Ice_Air_4d.F90' that are very similar
    to 'Liq_Air_4b.F90' and 'Ice_Air_4b.F90' but where one can specify a maximum
    saturation mass fraction in the definition of the Gibbs function. This allows
    to compute the equivalent potential temperature in a clean manner.
- A framework to add python bindings to the Fortran version of TEOS-10 with basic examples.

This package provides a simple way to import the TEOS-10 SIA Library into python.
The current beta version offers a very basic interface to the library. Future versions
will include a better interface and a more extensive physical description of the different
routines available.

NOTE: This package requires a Fortran 90 compiler. Sometimes numpy.disutils will not find
      the installed Fortran compiler and will return an error. It this happens, download the
      source code and run:
        f2py -c --help-fcompiler      
      to find the list of available compilers and then compile:
        python setup.py build --fcompiler=g95
      if 'g95' was in the list.

VERSION HISTORY:

0.91 : Moved netCDF interface to package pyteos_nc

0.9 : Improve netCDF interface

0.8 : Fixed a warning signal with missing values

0.7 : The interpolation is now much faster

0.6 : Faster netcdf interface for computing interpolated thermodynamic quantities.


Frederic Laliberte, February 17 2015

module ice_vap_4

!#########################################################################

!THIS MODULE IMPLEMENTS THE PHASE EQUILBRIUM PROPERTIES OF ICE WITH WATER VAPOUR
!COMPUTED FROM IAPWS-95 AND IAPWS-06:

!RELEASE ON THE IAPWS FORMULATION 1995 FOR THE THERMODYNAMIC PROPERTIES OF
!ORDINARY WATER SUBSTANCE FOR GENERAL AND SCIENTIFIC USE
!THE INTERNATIONAL ASSOCIATION FOR THE PROPERTIES OF WATER AND STEAM
!FREDERICIA, DENMARK, SEPTEMBER 1996

!RELEASE ON AN EQUATION OF STATE FOR H2O ICE IH
!THE INTERNATIONAL ASSOCIATION FOR THE PROPERTIES OF WATER AND STEAM
!WITNEY, UK, SEPTEMBER 2006

!#########################################################################

!IMPLEMENTATION IN FORTRAN BY D.G. WRIGHT
!FOR PUBLICATION IN OCEAN SCIENCE, AS DESCRIBED IN THE PAPERS

!FEISTEL, R., WRIGHT, D.G., JACKETT, D.R., MIYAGAWA, K., REISSMANN, J.H.,
!WAGNER, W., OVERHOFF, U., GUDER, C., FEISTEL, A., MARION, G.M.:
!NUMERICAL IMPLEMENTATION AND OCEANOGRAPHIC APPLICATION OF THE THERMODYNAMIC
!POTENTIALS OF WATER, VAPOUR, ICE, SEAWATER AND AIR. PART I: BACKGROUND AND EQUATIONS. 
!OCEAN SCIENCES, 2009, IN PREPARATION.

!WRIGHT, D.G., FEISTEL, R., JACKETT, D.R., MIYAGAWA, K., REISSMANN, J.H., 
!WAGNER, W., OVERHOFF, U., GUDER, C., FEISTEL, A., MARION, G.M.:
!NUMERICAL IMPLEMENTATION AND OCEANOGRAPHIC APPLICATION OF THE THERMODYNAMIC
!POTENTIALS OF WATER, VAPOUR, ICE, SEAWATER AND AIR. PART II: THE LIBRARY ROUTINES, 
!OCEAN SCIENCES., 2009, IN PREPARATION.

!FEISTEL, R., KRETZSCHMAR, H.-J., SPAN, R., HAGEN, E., WRIGHT, D.G., JACKETT, D.R.:
!THERMODYNAMIC PROPERTIES OF SEA AIR.
!OCEAN SCIENCE DISCUSSION 6(2009)2193-2325.

!#########################################################################

!THIS MODULE REQUIRES THE LIBRARY MODULES:
!     CONSTANTS_0,  FILE CONSTANTS_0.F90
!     MATHS_0,      FILE MATHS_0.F90
!     FLU_1,        FILE FLU_1.F90
!     ICE_1,        FILE ICE_1.F90
!     FLU_2,        FILE FLU_2.F90
!     ICE_2,        FILE ICE_2.F90

!#########################################################################

use constants_0
use maths_0
use flu_1
use ice_1
use flu_2
use ice_2

implicit none
private

character*16, private :: version = '8 Jun 2010'

public :: ice_vap_chempot_si, ice_vap_density_ice_si, &
          ice_vap_density_vap_si, ice_vap_enthalpy_ice_si, &
          ice_vap_enthalpy_subl_si, ice_vap_enthalpy_vap_si, &
          ice_vap_entropy_ice_si, ice_vap_entropy_subl_si, &
          ice_vap_entropy_vap_si, ice_vap_pressure_vap_si, &
          ice_vap_sublimationpressure_si, ice_vap_sublimationtemp_si, &
          ice_vap_temperature_si, ice_vap_volume_subl_si, &
          set_ice_vap_eq_at_p, set_ice_vap_eq_at_t, &
          set_it_ctrl_ice_vap

integer, private :: equi_ice_vap_done
real*8,  private :: equi_ice_vap_p_vap, equi_ice_vap_t, &
         equi_ice_vap_g_ice,  equi_ice_vap_g_vap, equi_ice_vap_d_ice,  &
         equi_ice_vap_d_vap
integer, private :: ctrl_mode_ice, ctrl_initialized, ctrl_mode_vapour, &
         ctrl_mode_temperature, ctrl_loop_maximum
real*8,  private :: ctrl_init_t, ctrl_eps_exit_p_vap, ctrl_init_d_vap

contains

!==========================================================================
function ice_vap_chempot_si()
!==========================================================================

!RETURNS THE CHEMICAL POTENTIAL IN J/KG OF WATER VAPOUR AT THE VAPOUR-ICE EQUILIBRIUM
!AFTER EXECUTION OF SET_ICE_VAP_EQUILIBRIUM_TO_T OR SET_ICE_VAP_EQUILIBRIUM_TO_P

!CHECK VALUES WITH DEFAULT SETTINGS:
!set_ice_vap_eq_at_t 270
!ice_vap_chempot_si = -3895.26747392

!set_ice_vap_eq_at_p 100
!ice_vap_chempot_si = -26421.2820403

!NOTE: THE ACCURACY OF THIS FUNCTION DEPENDS ON THE ITERATION SETTINGS IN THIS MODULE

implicit none

real*8 ice_vap_chempot_si

ice_vap_chempot_si = errorreturn

if(equi_ice_vap_done /= isok) return

ice_vap_chempot_si = equi_ice_vap_g_vap

end function

!==========================================================================
function ice_vap_density_ice_si()
!==========================================================================

!RETURNS THE DENSITY IN KG/M3 OF ICE AT THE VAPOUR-ICE EQUILIBRIUM
!AFTER EXECUTION OF SET_ICE_VAP_EQUILIBRIUM_TO_T OR SET_ICE_VAP_EQUILIBRIUM_TO_P

!CHECK VALUES WITH DEFAULT SETTINGS:
!set_ice_vap_eq_at_t 270
!ice_vap_density_ice_si = 917.170465733

!SET_ICE_VAP_EQUILIBRIUM_TO_P 100
!ICE_VAP_DENSITY_ICE_SI = 919.600269745

!NOTE: THE ACCURACY OF THIS FUNCTION DEPENDS ON THE ITERATION SETTINGS IN THIS MODULE

implicit none

real*8 ice_vap_density_ice_si

ice_vap_density_ice_si = errorreturn

if(equi_ice_vap_done /= isok) return

ice_vap_density_ice_si = equi_ice_vap_d_ice

end function

!==========================================================================
function ice_vap_density_vap_si()
!==========================================================================

!RETURNS THE DENSITY OF WATER VAPOUR IN KG/M3 AT THE VAPOUR-ICE EQUILIBRIUM
!AFTER EXECUTION OF SET_ICE_VAP_EQUILIBRIUM_TO_T OR SET_ICE_VAP_EQUILIBRIUM_TO_P

!CHECK VALUES WITH DEFAULT SETTINGS:
!set_ice_vap_eq_at_t 270
!ice_vap_density_vap_si = 3.77406140772E-03

!set_ice_vap_eq_at_p 100
!ice_vap_density_vap_si = 8.57185487853E-04

!NOTE: THE ACCURACY OF THIS FUNCTION DEPENDS ON THE ITERATION SETTINGS IN THIS MODULE

implicit none

real*8 ice_vap_density_vap_si

ice_vap_density_vap_si = errorreturn

if(equi_ice_vap_done /= isok) return

ice_vap_density_vap_si = equi_ice_vap_d_vap

end function

!==========================================================================
function ice_vap_enthalpy_ice_si()
!==========================================================================

!RETURNS THE SPECIFIC ENTHALPY OF ICE IN J/KG AT THE VAPOUR-ICE EQUILIBRIUM
!AFTER EXECUTION OF SET_ICE_VAP_EQUILIBRIUM_TO_T OR SET_ICE_VAP_EQUILIBRIUM_TO_P

!CHECK VALUES WITH DEFAULT SETTINGS:
!set_ice_vap_eq_at_t 270
!ICE_VAP_ENTHALPY_ICE_SI = -340033.434649

!SET_ICE_VAP_EQUILIBRIUM_TO_P 100
!ICE_VAP_ENTHALPY_ICE_SI = -374576.247867

!NOTE: THE ACCURACY OF THIS FUNCTION DEPENDS ON THE ITERATION SETTINGS IN THIS MODULE

implicit none

real*8 ice_vap_enthalpy_ice_si

ice_vap_enthalpy_ice_si = errorreturn

if(equi_ice_vap_done /= isok) return

ice_vap_enthalpy_ice_si = ice_enthalpy_si(equi_ice_vap_t, equi_ice_vap_p_vap)

end function

!==========================================================================
function ice_vap_enthalpy_vap_si()
!==========================================================================

!RETURNS THE SPECIFIC ENTHALPY OF WATER VAPOUR IN J/KG AT THE VAPOUR-ICE EQUILIBRIUM
!AFTER EXECUTION OF SET_ICE_VAP_EQUILIBRIUM_TO_T OR SET_ICE_VAP_EQUILIBRIUM_TO_P

!CHECK VALUES WITH DEFAULT SETTINGS:
!set_ice_vap_eq_at_t 270
!ice_vap_enthalpy_vap_si = 2495132.21977

!set_ice_vap_eq_at_p 100
!ice_vap_enthalpy_vap_si = 2463525.19629

!NOTE: THE ACCURACY OF THIS FUNCTION DEPENDS ON THE ITERATION SETTINGS IN THIS MODULE

implicit none

real*8 ice_vap_enthalpy_vap_si

ice_vap_enthalpy_vap_si = errorreturn

if(equi_ice_vap_done /= isok) return

ice_vap_enthalpy_vap_si = flu_enthalpy_si(equi_ice_vap_t, equi_ice_vap_d_vap)

end function

!==========================================================================
function ice_vap_entropy_ice_si()
!==========================================================================

!RETURNS THE SPECIFIC ENTROPY OF ICE IN J/(KG K) AT THE VAPOUR-ICE EQUILIBRIUM
!AFTER EXECUTION OF SET_ICE_VAP_EQUILIBRIUM_TO_T OR SET_ICE_VAP_EQUILIBRIUM_TO_P

!CHECK VALUES WITH DEFAULT SETTINGS:
!set_ice_vap_eq_at_t 270
!ice_vap_entropy_ice_si = -1244.95617472

!set_ice_vap_eq_at_p 100
!ice_vap_entropy_ice_si = -1377.09771247

!NOTE: THE ACCURACY OF THIS FUNCTION DEPENDS ON THE ITERATION SETTINGS IN THIS MODULE

implicit none

real*8 ice_vap_entropy_ice_si

ice_vap_entropy_ice_si = errorreturn

if(equi_ice_vap_done /= isok) return

ice_vap_entropy_ice_si = ice_entropy_si(equi_ice_vap_t, equi_ice_vap_p_vap)

end function

!==========================================================================
function ice_vap_entropy_vap_si()
!==========================================================================

!RETURNS THE SPECIFIC ENTROPY OF WATER VAPOUR IN J/(KG K) AT THE VAPOUR-ICE EQUILIBRIUM
!AFTER EXECUTION OF SET_ICE_VAP_EQUILIBRIUM_TO_T OR SET_ICE_VAP_EQUILIBRIUM_TO_P

!CHECK VALUES WITH DEFAULT SETTINGS:
!set_ice_vap_eq_at_t 270
!ice_vap_entropy_vap_si = 9255.65736018

!set_ice_vap_eq_at_p 100
!ice_vap_entropy_vap_si = 9848.77406912

!NOTE: THE ACCURACY OF THIS FUNCTION DEPENDS ON THE ITERATION SETTINGS IN THIS MODULE

implicit none

real*8 ice_vap_entropy_vap_si

ice_vap_entropy_vap_si = errorreturn

if(equi_ice_vap_done /= isok) return

ice_vap_entropy_vap_si = flu_entropy_si(equi_ice_vap_t, equi_ice_vap_d_vap)

end function

!==========================================================================
function ice_vap_pressure_vap_si()
!==========================================================================

!RETURNS THE ABSOLUTE PRESSURE IN PA OF WATER VAPOUR AT THE VAPOUR-ICE EQUILIBRIUM 
!AFTER EXECUTION OF SET_ICE_VAP_EQUILIBRIUM_TO_T OR SET_ICE_VAP_EQUILIBRIUM_TO_P

!CHECK VALUES WITH DEFAULT SETTINGS:
!set_ice_vap_eq_at_t 270
!ice_vap_pressure_vap_si = 470.059067981

!set_ice_vap_eq_at_p 100
!ice_vap_pressure_vap_si = 100

!NOTE: THE ACCURACY OF THIS FUNCTION DEPENDS ON THE ITERATION SETTINGS IN THIS MODULE

implicit none

real*8 ice_vap_pressure_vap_si

ice_vap_pressure_vap_si = errorreturn

if(equi_ice_vap_done /= isok) return

ice_vap_pressure_vap_si = equi_ice_vap_p_vap

end function

!==========================================================================
function ice_vap_sublimationpressure_si(t_si)
!==========================================================================

!RETURNS THE ABSOLUTE PRESSURE IN PA OF WATER VAPOUR AT THE VAPOUR-ICE EQUILIBRIUM
!AS A FUNCTION OF ABSOLUTE TEMPERATURE T_SI IN K

!CHECK VALUE WITH DEFAULT SETTINGS: ice_vap_sublimationpressure_si(270) = 470.059067981

!NOTE: THE ACCURACY OF THIS FUNCTION DEPENDS ON THE ITERATION SETTINGS IN THIS MODULE

implicit none

real*8 ice_vap_sublimationpressure_si
real*8 t_si

ice_vap_sublimationpressure_si = errorreturn

if(set_ice_vap_eq_at_t(t_si) == errorreturn) return

ice_vap_sublimationpressure_si = equi_ice_vap_p_vap

end function

!==========================================================================
function ice_vap_sublimationtemp_si(p_si)
!==========================================================================

!RETURNS THE ABSOLUTE TEMPERATURE IN K AT THE VAPOUR-ICE EQUILIBRIUM
!AS A FUNCTION OF ABSOLUTE PRESSURE P_SI IN PA

!CHECK VALUE WITH DEFAULT SETTINGS: ice_vap_sublimationtemp_si(100) = 252.817910215

!NOTE: THE ACCURACY OF THIS FUNCTION DEPENDS ON THE ITERATION SETTINGS IN THIS MODULE

implicit none
 
real*8 ice_vap_sublimationtemp_si
real*8 p_si

ice_vap_sublimationtemp_si = errorreturn

if(set_ice_vap_eq_at_p(p_si) == errorreturn) return

ice_vap_sublimationtemp_si = equi_ice_vap_t

end function

!==========================================================================
function ice_vap_temperature_si()
!==========================================================================

!RETURNS THE ABSOLUTE TEMPERATURE OF WATER VAPOUR IN K AT THE VAPOUR-ICE EQUILIBRIUM
!AFTER EXECUTION OF SET_ICE_VAP_EQUILIBRIUM_TO_T OR SET_ICE_VAP_EQUILIBRIUM_TO_P

!CHECK VALUES WITH DEFAULT SETTINGS:
!set_ice_vap_eq_at_t 270
!ice_vap_temperature_si = 270

!set_ice_vap_eq_at_p 100
!ice_vap_temperature_si = 252.817910215

!NOTE: THE ACCURACY OF THIS FUNCTION DEPENDS ON THE ITERATION SETTINGS IN THIS MODULE

implicit none

real*8 ice_vap_temperature_si

ice_vap_temperature_si = errorreturn

if(equi_ice_vap_done /= isok) return

ice_vap_temperature_si = equi_ice_vap_t

end function

!==========================================================================
function ice_vap_volume_subl_si()
!==========================================================================

!RETURNS THE SPECIFIC SUBLIMATION VOLUME IN M3/KG OF WATER
!AFTER EXECUTION OF SET_ICE_VAP_EQUILIBRIUM_TO_T OR SET_ICE_VAP_EQUILIBRIUM_TO_P

!CHECK VALUES WITH DEFAULT SETTINGS:
!set_ice_vap_eq_at_t 270
!ice_vap_volume_subl_si = 264.965451558

!set_ice_vap_eq_at_p 100
!ice_vap_volume_subl_si = 1166.60755699

!NOTE: THE ACCURACY OF THIS FUNCTION DEPENDS ON THE ITERATION SETTINGS IN THIS MODULE

implicit none

real*8 ice_vap_volume_subl_si

ice_vap_volume_subl_si = errorreturn

if(equi_ice_vap_done /= isok) return

if(equi_ice_vap_d_ice <= 0d0) return
if(equi_ice_vap_d_vap <= 0d0) return

ice_vap_volume_subl_si = 1d0 / equi_ice_vap_d_vap - 1d0 / equi_ice_vap_d_ice

end function

!==========================================================================
function ice_vap_entropy_subl_si()
!==========================================================================

!RETURNS THE SPECIFIC SUBLIMATION ENTROPY IN J/(KG K) OF WATER
!AFTER EXECUTION OF SET_ICE_VAP_EQUILIBRIUM_TO_T OR SET_ICE_VAP_EQUILIBRIUM_TO_P

!CHECK VALUES WITH DEFAULT SETTINGS:
!set_ice_vap_eq_at_t 270
!ice_vap_entropy_subl_si = 10500.6135349

!set_ice_vap_eq_at_p 100
!ice_vap_entropy_subl_si = 11225.8717816

!NOTE: THE ACCURACY OF THIS FUNCTION DEPENDS ON THE ITERATION SETTINGS IN THIS MODULE

implicit none

real*8 ice_vap_entropy_subl_si
real*8 si, sv

ice_vap_entropy_subl_si = errorreturn

if(equi_ice_vap_done /= isok) return

si = ice_entropy_si(equi_ice_vap_t, equi_ice_vap_p_vap)
if(si == errorreturn) return
sv = flu_entropy_si(equi_ice_vap_t, equi_ice_vap_d_vap)
if(sv == errorreturn) return

ice_vap_entropy_subl_si = sv - si

end function

!==========================================================================
function ice_vap_enthalpy_subl_si()
!==========================================================================

!RETURNS THE SPECIFIC SUBLIMATION ENTHALPY IN J/KG OF WATER
!AFTER EXECUTION OF SET_ICE_VAP_EQUILIBRIUM_TO_T OR SET_ICE_VAP_EQUILIBRIUM_TO_P

!CHECK VALUES WITH DEFAULT SETTINGS:
!set_ice_vap_eq_at_t 270
!ice_vap_enthalpy_subl_si = 2835165.65442

!set_ice_vap_eq_at_p 100
!ice_vap_enthalpy_subl_si = 2838101.44416

!NOTE: THE ACCURACY OF THIS FUNCTION DEPENDS ON THE ITERATION SETTINGS IN THIS MODULE

implicit none

real*8 ice_vap_enthalpy_subl_si
real*8 hi, hv

ice_vap_enthalpy_subl_si = errorreturn

if(equi_ice_vap_done /= isok) return

hi = ice_enthalpy_si(equi_ice_vap_t, equi_ice_vap_p_vap)
if(hi == errorreturn) return
hv = flu_enthalpy_si(equi_ice_vap_t, equi_ice_vap_d_vap)
if(hv == errorreturn) return

ice_vap_enthalpy_subl_si = hv - hi

end function

!==========================================================================
function set_ice_vap_eq_at_p(p_si)
!==========================================================================

!THIS FUNCTION COMPUTES THE ICE-VAPOUR EQUILIBRIUM AT GIVEN PRESSURE
!BY 2-DIMENSIONAL NEWTON ITERATION

implicit none

integer maxit
real*8 set_ice_vap_eq_at_p
       
real*8 dv_triple, t_triple
real*8 t_si, p_si
real*8 pv
real*8 gi, gv
real*8 di, dv
real*8 eps

!TRIPLE POINT
dv_triple = tp_density_vap_iapws95_si
t_triple = tp_temperature_si

if(equi_ice_vap_done == isok .and.  &
   p_si == equi_ice_vap_p_vap) then
  !THE REQUESTED STATE HAS ALREADY BEEN COMPUTED EARLIER
  set_ice_vap_eq_at_p = isok
  return
end if

call clear_ice_vap_state !WASTE ANY PREVIOUS STATE

set_ice_vap_eq_at_p = errorreturn

if(p_si <= 0) return

call init_it_ctrl_ice_vap

!SET INITIAL TEMPERATURE GUESS
select case (ctrl_mode_temperature)
  case (0); t_si = aux_temperature_correlation(p_si)
            if(t_si == errorreturn) return
  case (-1); t_si = t_triple
  case (1);  t_si = ctrl_init_t
  case default; return
end select

!SET INITIAL VAPOUR DENSITY GUESS
select case (ctrl_mode_vapour)
  case (0);  dv = aux_vap_density_correlation(t_si)
  case (-1); dv = dv_triple
  case (1);  dv = ctrl_init_d_vap
  case default; return
end select

!SET MAX. ITERATION NUMBER
if(ctrl_loop_maximum == 0)then; maxit = 100
elseif(ctrl_loop_maximum == (-1))then 
   pv = flu_pressure_si(t_si, dv)
   gi = ice_g_si(0, 0, t_si, pv)
   gv = flu_gibbs_energy_si(t_si, dv)
   di = ice_g_si(0, 1, t_si, pv)
   if(di == errorreturn .or. di <= 0d0) return
   di = 1d0 / di
   call set_ice_vap_state(t_si, pv, gi, gv, di, dv)
   set_ice_vap_eq_at_p = isok
   return
elseif(ctrl_loop_maximum > 0)then; maxit = ctrl_loop_maximum
else; return
endif

!SET ITERATION ACCURACY LIMIT
eps = ctrl_eps_exit_p_vap
if(eps == 0d0) return

!RUN ITERATION LOOP
if(ice_vap_iteration_at_p(p_si, maxit, eps, t_si, di, dv, gi, gv, pv) == errorreturn) then
  return
end if

call set_ice_vap_state(t_si, pv, gi, gv, di, dv)

set_ice_vap_eq_at_p = isok

end function

!==========================================================================
function set_ice_vap_eq_at_t(t_si)
!==========================================================================

!THIS FUNCTION COMPUTES THE ICE-VAPOUR EQUILIBRIUM AT GIVEN TEMPERATURE
!BY NEWTON ITERATION

implicit none

integer maxit
real*8 set_ice_vap_eq_at_t
real*8 t_triple, dv_triple
real*8 t_si, pv
real*8 gi, gv
real*8 di, dv
real*8 eps

!TRIPLE POINT
t_triple = tp_temperature_si
dv_triple = tp_density_vap_iapws95_si

if(equi_ice_vap_done == isok .and.  &
   t_si == equi_ice_vap_t) then
  !THE REQUESTED STATE HAS ALREADY BEEN COMPUTED EARLIER
  set_ice_vap_eq_at_t = isok
  return
end if

call clear_ice_vap_state !WASTE ANY PREVIOUS STATE

set_ice_vap_eq_at_t = errorreturn

if(t_si <= 0d0) return
if(t_si > t_triple) return

call init_it_ctrl_ice_vap

!SET INITIAL VAPOUR DENSITY GUESS
select case (ctrl_mode_vapour)
  case (0); dv = aux_vap_density_correlation(t_si)
  case (-1); dv = dv_triple
  case (1);  dv = ctrl_init_d_vap
  case default; return
end select

!SET MAX. ITERATION NUMBER
if(ctrl_loop_maximum == 0)then; maxit = 100
elseif(ctrl_loop_maximum == (-1))then 
   pv = flu_pressure_si(t_si, dv)
   gi = ice_g_si(0, 0, t_si, pv)
   gv = flu_gibbs_energy_si(t_si, dv)
   di = ice_g_si(0, 1, t_si, pv)
   if(di == errorreturn .or. di <= 0d0) return
   di = 1d0 / di
   call set_ice_vap_state(t_si, pv, gi, gv, di, dv)
   set_ice_vap_eq_at_t = isok
   return
elseif(ctrl_loop_maximum > 0)then; maxit = ctrl_loop_maximum
else; return
endif

!SET ITERATION ACCURACY LIMIT
eps = ctrl_eps_exit_p_vap
if(eps == 0d0) return

!RUN ITERATION LOOP
if(ice_vap_iteration_at_t(t_si, maxit, eps, di, dv, gi, gv, pv) == errorreturn) then
  return
end if

call set_ice_vap_state(t_si, pv, gi, gv, di, dv)

set_ice_vap_eq_at_t = isok

end function

!==========================================================================
function ice_vap_iteration_at_p(p_si, maxit, eps, t_si, d_ice_si,  &
                                d_vap_si, g_ice_si, g_vap_si, p_vap_si)
!==========================================================================

!THIS FUNCTION RETURNS THE ICE-VAPOUR PHASE EQUILIBRIUM FROM EQUAL PRESSURES,
!TEMPERATURES AND CHEMICAL POTENTIALS OF THE TWO PHASES AT GIVEN PRESSURE, P_SI,
!FROM INITIAL GUESSES FOR THE VAPOUR DENSITY, D_VAP_SI, AND THE TEMPERATURE, T_SI
!THE ITERATION LIMIT EPS REFERS TO THE ERROR IN VAPOUR PRESSURE

!OUTPUT: 
!        ICE_VAP_ITERATION_AT_T = ISOK IF SUCCESSFUL
!        ICE_VAP_ITERATION_AT_T = ERRORRETURN IS RETURNED IF
!        - THE MAXIMUM NUMBER OF ITERATIONS IS EXCEEDED WITHOUT MEETING THE EXIT CRITERION
!        - THE FUNCTION CALL TO FLU_F_SI OR TO ICE_G_SI HAS RETURNED AN ERROR
!        - DENSITY OR TEMPERATURE HAVE TAKEN A ZERO OR NEGATIVE VALUE DURING THE ITERATION
!     T_SI: ABSOLUTE TEMPERATURE IN K
! D_ICE_SI: ICE DENSITY IN KG/M3 AT THE ICE-VAPOUR EQUILIBRIUM
! D_VAP_SI: VAPOUR DENSITY IN KG/M3 AT THE ICE-VAPOUR EQUILIBRIUM
! G_ICE_SI: ICE CHEMICAL POTENTIAL IN J/KG AT THE ICE-VAPOUR EQUILIBRIUM
! G_VAP_SI: VAPOUR CHEMICAL POTENTIAL J/KG AT IN THE ICE-VAPOUR EQUILIBRIUM
! P_VAP_SI: VAPOUR PRESSURE IN PA AT THE ICE-VAPOUR EQUILIBRIUM

!INPUT: 
!       P_SI: ABSOLUTE PRESSURE IN PA
!      MAXIT: MAXIMUM NUMBER OF ITERATION STEPS TO BE DONE
!        EPS: REQUIRED ACCURACY OF VAPOUR PRESSURE
!             EPS > 0: ABSOLUTE VAPOUR PRESSURE TOLERANCE IN PA
!             EPS < 0: RELATIVE VAPOUR PRESSURE TOLERANCE
!       T_SI: INITIAL GUESS OF ABSOLUTE TEMPERATURE IN K
!   D_VAP_SI: INITIAL GUESS OF VAPOUR DENSITY IN KG/M3

implicit none

integer it, maxit
real*8 p_si, t_si, eps, d_ice_si, d_vap_si, g_ice_si, g_vap_si, p_vap_si
real*8 ice_vap_iteration_at_p
real*8 vi, dv
real*8 pv, gv
real*8 gi, gi_t
real*8 t, tt
real*8 fv, fv_d, fv_dd
real*8 fv_t, fv_td
real*8 a(2, 2), b(2), x(2)
real*8 ddv, dt, pv_old

tt = tp_temperature_si !TRIPLE POINT IN K

ice_vap_iteration_at_p = errorreturn

if((t_si <= 0d0) .or. &
  (d_vap_si <= 0d0)) then
  t_si = errorreturn
  d_ice_si = errorreturn
  d_vap_si = errorreturn
  g_ice_si = errorreturn
  g_vap_si = errorreturn
  p_vap_si = errorreturn
  return
endif

if(check_limits == 1) then
  !ICE_LIMITS
  if(p_si <= ice_pmin .or. p_si > ice_pmax) then
    t_si = errorreturn
    d_ice_si = errorreturn
    d_vap_si = errorreturn
    g_ice_si = errorreturn
    g_vap_si = errorreturn
    p_vap_si = errorreturn
    return
  endif
else
  if(p_si <= 0d0) then
    t_si = errorreturn
    d_ice_si = errorreturn
    d_vap_si = errorreturn
    g_ice_si = errorreturn
    g_vap_si = errorreturn
    p_vap_si = errorreturn
    return
  endif
endif

check_limits = check_limits - 1

dv = d_vap_si
t = t_si

do it = 0, maxit

  !DERIVATIVES OF THE GIBBS & HELMHOLTZ FUNCTIONS FOR 2D-NEWTON ITERATION
  !WRITE(*,*)' '
  fv = flu_f_si(0, 0, t, dv)
  !WRITE(*,*)'IN ICE_VAP_ITERATION_AT_P: CALLED FLU_F_SI(0, 0, T, DV) WITH T,DV=',T,DV,' AND GOT ',FV
  if(fv == errorreturn) go to 999
  
  fv_d = flu_f_si(0, 1, t, dv)
  if(fv_d == errorreturn) go to 999
  fv_dd = flu_f_si(0, 2, t, dv)
  if(fv_dd == errorreturn) go to 999
  
  fv_t = flu_f_si(1, 0, t, dv)
  if(fv_t == errorreturn) go to 999
  fv_td = flu_f_si(1, 1, t, dv)
  if(fv_td == errorreturn) go to 999

  pv_old = pv  !KEEP PREVIOUS PV TO CHECK ACCURACY
  !VAPOUR PRESSURE AND ICE + VAPOUR CHEMICAL POTENTIALS
  pv = dv ** 2 * fv_d    !PRESSURE OF VAPOUR
  gv = fv + dv * fv_d    !CHEM. POT. OF VAPOUR
  
  gi = ice_g_si(0, 0, t, pv)
  if(gi == errorreturn) go to 999
  gi_t = ice_g_si(1, 0, t, pv)
  if(gi_t == errorreturn) go to 999

  if(it > 0) then
    !CHECK ABSOLUTE OR RELATIVE ERROR LIMIT
    if((eps > 0d0 .and. abs(pv - pv_old) < eps) .or.  &
       (eps < 0d0 .and. abs(pv - pv_old) < -eps * pv)) then
      p_vap_si = pv
      g_ice_si = gi
      g_vap_si = gv
      vi = ice_g_si(0, 1, t, pv)
      if(vi == errorreturn .or. vi <= 0) go to 999
      d_ice_si = 1d0 / vi
      d_vap_si = dv
      t_si = t
      ice_vap_iteration_at_p = isok
      go to 999
    end if
  end if
  
  if(it == maxit) go to 999
  
  !COEFFICIENT MATRIX
  a(1, 1) = dv * (2d0 * fv_d + dv * fv_dd)
  a(1, 2) = dv ** 2d0 * fv_td
  a(2, 1) = (2d0 * fv_d + dv * fv_dd)
  a(2, 2) = -gi_t + fv_t + dv * fv_td

  !RIGHT-HAND SIDES, MUST VANISH IN EQUILIBRIUM
  b(1) = p_si - pv
  b(2) = gi - gv

  !SOLVE EQUATIONS
  if(matrix_solve(a, b, x, 2) /= 0) go to 999 !MATRIX SINGULAR
  ddv = x(1)
  dt = x(2)
  
  !update density & temperature
  dv = dv + ddv
  if(dv <= 0d0) go to 999
  t = t + dt
  if(t <= 0d0) go to 999
  
enddo

999 continue

check_limits = check_limits + 1

if(check_limits == 1) then
  !FLU_LIMITS
  if(t_si < flu_tmin .or. t_si > flu_tmax .or. &
  d_vap_si <= flu_dmin .or. d_vap_si > flu_dmax .or. &
  p_vap_si < 0d0) then
    t_si = errorreturn
    d_ice_si = errorreturn
    d_vap_si = errorreturn
    g_ice_si = errorreturn
    g_vap_si = errorreturn
    p_vap_si = errorreturn
    ice_vap_iteration_at_p = errorreturn
    return
  endif
  !ICE_LIMITS
  if(t_si <= ice_tmin .or. t_si > ice_tmax .or. &
  d_ice_si <= 0d0) then
    t_si = errorreturn
    d_ice_si = errorreturn
    d_vap_si = errorreturn
    g_ice_si = errorreturn
    g_vap_si = errorreturn
    p_vap_si = errorreturn
    ice_vap_iteration_at_p = errorreturn
    return
  endif
endif

end function

!==========================================================================
function ice_vap_iteration_at_t(t_si, maxit, eps, d_ice_si, d_vap_si,  &
                                g_ice_si, g_vap_si, p_vap_si)
!==========================================================================

!THIS FUNCTION RETURNS THE ICE-VAPOUR PHASE EQUILIBRIUM FROM EQUAL PRESSURES
!AND CHEMICAL POTENTIALS OF THE TWO PHASES AT GIVEN TEMPERATURE, T_SI, IN K
!FROM AN INITIAL GUESS FOR THE VAPOUR DENSITY, D_VAP_SI, IN KG/M3
!THE ITERATION LIMIT EPS REFERS TO THE ERROR IN VAPOUR PRESSURE

!OUTPUT: 
!        ICE_VAP_ITERATION = ISOK IF SUCCESSFULLY DONE
!        ICE_VAP_ITERATION = ERRORRETURN IS RETURNED IF
!           - THE MAXIMUM NUMBER OF ITERATIONS IS EXCEEDED WITHOUT MEETING THE EXIT CRITERION
!           - THE FUNCTION CALL TO FLU_F_SI OR ICE_G_SI HAS RETURNED AN ERROR
!           - DENSITIES HAVE TAKEN A ZERO OR NEGATIVE VALUE DURING THE ITERATION

!        D_VAP_SI: VAPOUR DENSITY IN KG/M3 AT THE ICE-VAPOUR EQUILIBRIUM
!        D_ICE_SI: ICE DENSITY IN KG/M3 AT THE THE ICE-VAPOUR EQUILIBRIUM
!        G_VAP_SI: VAPOUR CHEMICAL POTENTIAL IN J/KG AT THE ICE-VAPOUR EQUILIBRIUM
!        G_ICE_SI: ICE CHEMICAL POTENTIAL IN J/KG AT THE ICE-VAPOUR EQUILIBRIUM
!        P_VAP_SI: VAPOUR PRESSURE IN PA AT THE ICE-VAPOUR EQUILIBRIUM

!INPUT: 
!        T_SI: ABSOLUTE TEMPERATURE IN K
!        MAXIT: MAXIMUM NUMBER OF ITERATION STEPS TO BE DONE
!        EPS: REQUIRED ACCURACY OF VAPOUR PRESSURE
!             EPS > 0: ABSOLUTE PRESSURE TOLERANCE IN PA
!             EPS < 0: RELATIVE PRESSURE TOLERANCE
!        D_VAP_SI: INITIAL GUESS OF VAPOUR DENSITY IN KG/M3

implicit none

integer it, maxit
real*8 ice_vap_iteration_at_t
real*8 vi, dv
real*8 pv
real*8 gi, gv
real*8 fv, fv_d, fv_dd
real*8 ddv, pv_old
real*8 t_si, eps, d_ice_si, d_vap_si,  &
       g_ice_si, g_vap_si, p_vap_si

ice_vap_iteration_at_t = errorreturn

if(d_vap_si <= 0d0) return
if(t_si <= 0d0) return

if(check_limits == 1) then
  !FLU_LIMITS
  if(t_si < flu_tmin .or. t_si > flu_tmax) then
    d_vap_si = errorreturn
    d_ice_si = errorreturn
    g_vap_si = errorreturn
    g_ice_si = errorreturn
    p_vap_si = errorreturn
    return
  endif
  !ICE_LIMITS
  if(t_si <= ice_tmin .or. t_si > ice_tmax) then
    d_vap_si = errorreturn
    d_ice_si = errorreturn
    g_vap_si = errorreturn
    g_ice_si = errorreturn
    p_vap_si = errorreturn
    return
  endif
else
  if(t_si <= 0d0) then
    d_vap_si = errorreturn
    d_ice_si = errorreturn
    g_vap_si = errorreturn
    g_ice_si = errorreturn
    p_vap_si = errorreturn
    return
  endif
endif

check_limits = check_limits - 1

dv = d_vap_si

do it = 0, maxit

  !DERIVATIVES OF THE HELMHOLTZ FUNCTION FOR NEWTON ITERATION
  fv = flu_f_si(0, 0, t_si, dv)
  if(fv == errorreturn) go to 999
  fv_d = flu_f_si(0, 1, t_si, dv)
  if(fv_d == errorreturn) go to 999
  fv_dd = flu_f_si(0, 2, t_si, dv)
  if(fv_dd == errorreturn) go to 999
  
  pv_old = pv            !KEEP PREVIOUS PV TO CHECK ACCURACY
  !VAPOUR AND ICE PRESSURE  + VAPOUR CHEMICAL POTENTIAL
  pv = dv ** 2 * fv_d    !PRESSURE OF VAPOUR
  gv = fv + dv * fv_d    !CHEM. POT. OF VAPOUR
  
  !DERIVATIVES OF THE GIBBS FUNCTION OF ICE FOR NEWTON ITERATION
  gi = ice_g_si(0, 0, t_si, pv)
  if(gi == errorreturn) go to 999
  vi = ice_g_si(0, 1, t_si, pv)
  if(vi == errorreturn) go to 999
  if(vi <= 0d0) go to 999
  
  if(it > 0) then
    !CHECK ABSOLUTE OR RELATIVE ERROR LIMIT
    if((eps > 0d0 .and. abs(pv - pv_old) < eps) .or.  &
       (eps < 0d0 .and. abs(pv - pv_old) < -eps * pv)) then
      ice_vap_iteration_at_t = isok
      p_vap_si = pv
      g_ice_si = gi
      g_vap_si = gv
      d_ice_si = 1d0 / vi
      d_vap_si = dv
      go to 999
    end if
  end if

  if(it == maxit) go to 999
  
  !ITERATION STEP
  ddv = (2d0 * fv_d + dv * fv_dd) * (vi * dv - 1d0)
  if(ddv == 0d0) go to 999
  ddv = (gv - gi) / ddv
  
  !UPDATE VAPOUR DENSITY
  dv = dv + ddv
  if(dv <= 0d0) go to 999

enddo

999 continue

check_limits = check_limits + 1

if(check_limits == 1) then
  !FLU_LIMITS
  if(d_vap_si <= flu_dmin .or. d_vap_si > flu_dmax .or. &
  p_vap_si <= 0d0) then
    p_vap_si = errorreturn
    g_ice_si = errorreturn
    g_vap_si = errorreturn
    d_ice_si = errorreturn
    d_vap_si = errorreturn
    ice_vap_iteration_at_t = errorreturn
    return
  endif
  !ICE_LIMITS
  if(d_ice_si  <= 0d0) then
    p_vap_si = errorreturn
    g_ice_si = errorreturn
    g_vap_si = errorreturn
    d_ice_si = errorreturn
    d_vap_si = errorreturn
    ice_vap_iteration_at_t = errorreturn
  endif
endif

end function

!==========================================================================
function aux_vap_density_correlation(t_si)
!==========================================================================

!THIS FUNCTION IMPLEMENTS THE VAPOUR DENSITY OF SUBLIMATION FROM THE
!CLAUSIUS-CLAPEYRON EQUATION AS A FIRST GUESS FOR THE SUBLIMATION ITERATION

implicit none

real*8 aux_vap_density_correlation
real*8 rt, t_si
real*8 r, q, pt, tt

r = gas_constant_h2o_si      !SPECIFIC GAS CONSTANT OF H2O IN J/(KG K)
q = tp_enthalpy_vap_si - tp_enthalpy_ice_si ! = 2834359.44543354   !SUBLIMATION ENTHALPY IN J/KG
pt = tp_pressure_iapws95_si  !IAPWS-95 TRIPLE POINT PRESSURE IN PA
tt = tp_temperature_si

rt = r * t_si

aux_vap_density_correlation = (pt / rt) * exp((t_si / tt - 1d0) * q / rt)

end function

!==========================================================================
function aux_temperature_correlation(p_si)
!==========================================================================

!THIS FUNCTION IMPLEMENTS THE SUBLIMATION TEMPERATURE COMPUTED FROM THE PRESSURE BY A
!CLAUSIUS-CLAPEYRON EQUATION AS A FIRST GUESS FOR THE SUBLIMATION ITERATION

implicit none

real*8 aux_temperature_correlation
real*8 t, p_si
real*8 r, q, pt, tt

r = gas_constant_h2o_si      !SPECIFIC GAS CONSTANT OF H2O IN J/(KG K)
q = tp_enthalpy_vap_si - tp_enthalpy_ice_si ! = 2834359.44543354   !SUBLIMATION ENTHALPY IN J/KG
pt = tp_pressure_iapws95_si  !IAPWS-95 TRIPLE POINT PRESSURE IN PA
tt = tp_temperature_si

aux_temperature_correlation = errorreturn

if(p_si <= 0d0) return

t = 1d0 / tt - (r / q) * log(p_si / pt)
if(t <= 0d0) return

aux_temperature_correlation = 1d0 / t

end function

!==========================================================================
subroutine init_it_ctrl_ice_vap()
!==========================================================================

implicit none

real*8 dv_triple, t_triple

!TRIPLE POINT
dv_triple = tp_density_vap_iapws95_si
t_triple = tp_temperature_si

if(ctrl_initialized == isok) return

ctrl_initialized = isok

!SET DEFAULT VALUES AND MODES FOR THE ITERATION
ctrl_mode_ice = 0
ctrl_mode_vapour = 0
ctrl_mode_temperature = 0
ctrl_loop_maximum = 100
ctrl_init_d_vap = dv_triple
ctrl_init_t = t_triple
ctrl_eps_exit_p_vap = -0.0000001d0 !RELATIVE, 0.1 PPM

end subroutine

!==========================================================================
subroutine set_it_ctrl_ice_vap(key, value)
!==========================================================================

implicit none

character*13 key
real*8 value

!THIS SUB SETS CONTROL PARAMETERS FOR THE ITERATION USED TO COMPUTE
!ICE-VAPOUR EQUILIBRIUM

!KEY                    VALUE
!'IT_STEPS     '        0           SET ITERATION NUMBER TO DEFAULT (100)
!'IT_STEPS     '        N > 0       SET ITERATION NUMBER TO N
!'IT_STEPS     '       -1           DO NOT ITERATE, USE INITIAL VAPOUR DENSITY TO COMPUTE VAPOUR PRESSURE

!'INIT_VAP_DENS'        0           USE DEFAULT VAPOUR DENSITY TO START =
!                                   VAPOUR DENSITY CORRELATION FUNCTION, D = AUX_VAP_DENSITY_CORRELATION(T)
!'INIT_VAP_DENS'       -1           USE TRIPLE POINT VAPOUR DENSITY TO START
!'INIT_VAP_DENS'        D > 0       USE VALUE D AS VAPOUR DENSITY TO START

!'INIT_TEMP    '        0           USE DEFAULT TEMPERATURE TO START ( = AUX_SUBL_TEMPERATURE(P))
!'INIT_TEMP    '       -1           USE TRIPLE POINT TEMPERATURE TO START
!'INIT_TEMP    '        T > 0       USE VALUE T AS TEMPERATURE TO START

!'TOL_VAP_PRESS'        0           USE DEFAULT EXIT ACCURACY FOR VAPOUR PRESSURE (0.1 PPM)
!'TOL_VAP_PRESS'        EPS         USE EPS AS EXIT ACCURACY FOR VAPOUR PRESSURE (EPS < 0 MEANS RELATIVE ERROR)


call init_it_ctrl_ice_vap

call clear_ice_vap_state

select case (trim(key))

  case ('it_steps')                                      !ITERATION STEPS
     if(value == 0d0)then;     ctrl_loop_maximum = 100   !DEFAULT = 100
     elseif(value < 0d0)then; ctrl_loop_maximum = -1
     else;   ctrl_loop_maximum = nint(value)
     endif

  case ('init_vap_dens')                                 !START VAPOUR DENSITY
     if(value == 0d0)then;       ctrl_mode_vapour = 0    !DEFAULT = AUX POLYNOMIAL
     elseif(value < -1d0)then;                          !IGNORE IT
     elseif(value < 0d0)then;  ctrl_mode_vapour = nint(value)
     else; ctrl_mode_vapour = 1; ctrl_init_d_vap = value
     endif

  case ('init_temp')                                     !START TEMPERATURE
     if(value == 0d0)then; ctrl_mode_temperature = 0     !DEFAULT = AUX POLYNOMIAL
     elseif(value < (-1d0))then;                        !IGNORE IT
     elseif(value < 0d0)then; ctrl_mode_temperature = nint(value)
     else; ctrl_mode_temperature = 1; ctrl_init_t = value
     endif

  case ('tol_vap_press')                                 !REQUIRED VAPOUR DENSITY TOLERANCE
     if(value == 0d0)then; ctrl_eps_exit_p_vap = -0.0000001d0   !DEFAULT = 0.1 PPM RELATIVE
     else; ctrl_eps_exit_p_vap = value
     endif

  case default; write(*,*)key,' not supported'

end select

end subroutine

!==========================================================================
subroutine set_ice_vap_state(t, pv, gi, gv, di, dv)
!==========================================================================

!STORES THE ACTUAL PROPERTIES AS THE CURRENT EQUILIBRIUM STATE DESCRIPTOR

implicit none

real*8 t, pv, gi, gv, di, dv

equi_ice_vap_done = isok

equi_ice_vap_t = t
equi_ice_vap_p_vap = pv
equi_ice_vap_g_ice = gi
equi_ice_vap_g_vap = gv
equi_ice_vap_d_ice = di
equi_ice_vap_d_vap = dv

end subroutine

!==========================================================================
subroutine clear_ice_vap_state
!==========================================================================

!CLEARS THE CURRENT EQUILIBRIUM STATE DESCRIPTOR

implicit none

equi_ice_vap_done = 0

end subroutine

end module ice_vap_4

module maths_0

!#########################################################################

!THIS MODULE IMPLEMENTS MATHEMATICAL FUNCTIONS

!#########################################################################

!IMPLEMENTATION IN VB6 BY RAINER FEISTEL
!IMPLEMENTATION IN FORTRAN BY D.G. WRIGHT
!FOR PUBLICATION IN OCEAN SCIENCE, AS DESCRIBED IN THE PAPERS

!FEISTEL, R., WRIGHT, D.G., JACKETT, D.R., MIYAGAWA, K., REISSMANN, J.H.,
!WAGNER, W., OVERHOFF, U., GUDER, C., FEISTEL, A., MARION, G.M.:
!NUMERICAL IMPLEMENTATION AND OCEANOGRAPHIC APPLICATION OF THE THERMODYNAMIC
!POTENTIALS OF WATER, VAPOUR, ICE, SEAWATER AND AIR. PART I: BACKGROUND AND EQUATIONS. 
!OCEAN SCIENCES, 2009, IN PREPARATION.

!WRIGHT, D.G., FEISTEL, R., JACKETT, D.R., MIYAGAWA, K., REISSMANN, J.H., 
!WAGNER, W., OVERHOFF, U., GUDER, C., FEISTEL, A., MARION, G.M.:
!NUMERICAL IMPLEMENTATION AND OCEANOGRAPHIC APPLICATION OF THE THERMODYNAMIC
!POTENTIALS OF WATER, VAPOUR, ICE, SEAWATER AND AIR. PART II: THE LIBRARY ROUTINES, 
!OCEAN SCIENCES., 2009, IN PREPARATION.

!FEISTEL, R., KRETZSCHMAR, H.-J., SPAN, R., HAGEN, E., WRIGHT, D.G., JACKETT, D.R.:
!THERMODYNAMIC PROPERTIES OF SEA AIR.
!OCEAN SCIENCE DISCUSSION 6(2009)2193-2325.

!#########################################################################

!THIS MODULE REQUIRES THE LIBRARY MODULE
!     CONSTANTS_0, FILE CONSTANTS_0.F90

!#########################################################################

use constants_0

implicit none
private

character*16, private :: version = '8 Jun 2010'

public :: get_cubicroots, matrix_solve 

contains

!==========================================================================
function get_cubicroots(r, s, t, x1, x2, x3)
!==========================================================================

!INPUT:  R,S,T ARE THE COEFFICIENTS OF THE POLYNOMIAL
!        X^3 + R * X^2 + S * X + T = 0
!OUTPUT: X1, X2, X3 ARE THE ROOTS OF THE POLYNOMIAL

!RETURNS:
!        GET_CUBICROOTS = 1:  X1 REAL SOLUTION, X2 REAL PART, X3 IMAG PART OF THE COMPLEX PAIR
!        GET_CUBICROOTS = 3:  X1, X2, X3 REAL SOLUTIONS

!REQUIRES THE FUNCTION ARCCOS(X)

implicit none

integer get_cubicroots
real*8 r, s, t, x1, x2, x3
real*8 p, q
real*8 a, phi, u, v

p = s - r ** 2 / 3d0
q = 2d0 * r ** 3 / 27d0 - r * s / 3d0 + t

a = (q / 2d0) ** 2 + (p / 3d0) ** 3
if(a >= 0d0) then
  u = -q / 2d0 + sqrt(a)
  if(u >= 0d0) then
    u = u ** (1d0 / 3d0)
  else
    u = -(-u) ** (1d0 / 3d0)
  end if
  v = -q / 2d0 - sqrt(a)
  if(v >= 0d0) then
    v = v ** (1d0 / 3d0)
  else
    v = -(-v) ** (1d0 / 3d0)
  end if
  if(a == 0d0) then
  !2 equal + 1 real solution
    get_cubicroots = 3
    x1 = u + v - r / 3d0
    x2 = -(u + v) / 2d0 - r / 3d0
    x3 = x2
  else
    get_cubicroots = 1
    !2 complex solutions + 1 real solution
    x1 = u + v - r / 3d0
    x2 = -(u + v) / 2d0 - r / 3d0    !real part
    x3 = (u - v) * 0.5d0 * sqrt(3d0)   !imag part
  end if
  return
end if

!3 REAL SOLUTIONS
get_cubicroots = 3
a = sqrt(-p ** 3 / 27d0)
phi = acos(-q / (2d0 * a))

if(phi == errorreturn) then
  get_cubicroots = 0
  return
end if

a = 2d0 * a ** (1d0 / 3d0)
x1 = a * cos(phi / 3d0) - r / 3d0
x2 = a * cos((phi + 2d0 * pi) / 3d0) - r / 3d0
x3 = a * cos((phi + 4d0 * pi) / 3d0) - r / 3d0

end function

!==========================================================================
function matrix_solve(a, b, x, n)
!==========================================================================

!SOLVES A SYSTEM OF LINEAR EQUATION BY MATRIX INVERSION

implicit none

integer matrix_solve, notok, i, j, n
real*8 a(n,n), b(n), x(n)

notok = matrix_invert(a, n)
if(notok /= 0) then  !singular
  matrix_solve = notok
  return
end if

do i = 1, n
  x(i) = 0d0
  do j = 1, n
    x(i) = x(i) + a(i, j) * b(j)
  enddo
enddo

matrix_solve = 0

end function

!==========================================================================
function matrix_invert(a, n)
!==========================================================================

!INVERTS A MATRIX IN PLACE BY GAUSS ELIMINATION WITHOUT PIVOTING

implicit none

integer matrix_invert, n, i, j, k
real*8 a(n,n)

do i = 1, n
  if(a(i, i) == 0d0) then  !matrix singular
    matrix_invert = i
    return
  end if
  a(i, i) = 1d0 / a(i, i)
  do j = 1, n
    if(j /= i) then
      a(j, i) = -a(j, i) * a(i, i)
      do k = 1, n
        if(k /= i) a(j, k) = a(j, k) + a(j, i) * a(i, k)
      enddo
    end if
  enddo
  do k = 1, n
    if(k /= i) a(i, k) = a(i, i) * a(i, k)
  enddo
enddo

matrix_invert = 0  !no error

end function

end module maths_0

module liq_ice_air_5

!#########################################################################

!THIS MODULE IMPLEMENTS THE EQUILIBRIUM PROPERTIES OF WET ICE AIR, 
!I.E., BETWEEN LIQUID WATER, ICE AND HUMID AIR

!#########################################################################

!IMPLEMENTATION IN FORTRAN BY D.G. WRIGHT
!FOR PUBLICATION IN OCEAN SCIENCE, AS DESCRIBED IN THE PAPERS

!FEISTEL, R., WRIGHT, D.G., JACKETT, D.R., MIYAGAWA, K., REISSMANN, J.H.,
!WAGNER, W., OVERHOFF, U., GUDER, C., FEISTEL, A., MARION, G.M.:
!NUMERICAL IMPLEMENTATION AND OCEANOGRAPHIC APPLICATION OF THE THERMODYNAMIC
!POTENTIALS OF WATER, VAPOUR, ICE, SEAWATER AND AIR. PART I: BACKGROUND AND EQUATIONS. 
!OCEAN SCIENCES, 2009, IN PREPARATION.

!WRIGHT, D.G., FEISTEL, R., JACKETT, D.R., MIYAGAWA, K., REISSMANN, J.H., 
!WAGNER, W., OVERHOFF, U., GUDER, C., FEISTEL, A., MARION, G.M.:
!NUMERICAL IMPLEMENTATION AND OCEANOGRAPHIC APPLICATION OF THE THERMODYNAMIC
!POTENTIALS OF WATER, VAPOUR, ICE, SEAWATER AND AIR. PART II: THE LIBRARY ROUTINES, 
!OCEAN SCIENCES., 2009, IN PREPARATION.

!FEISTEL, R., KRETZSCHMAR, H.-J., SPAN, R., HAGEN, E., WRIGHT, D.G., HERRMANN, S.:
!THERMODYNAMIC PROPERTIES OF SEA AIR.
!OCEAN SCIENCE DISCUSSION 6(2009)2193-2325.

!#########################################################################

!THIS MODULE REQUIRES THE LIBRARY MODULES:
!     CONSTANTS_0,  FILE CONSTANTS_0.F90
!     CONVERT_0,    FILE CONVERT_0.F90
!     MATHS_0,      FILE MATHS_0.F90
!     AIR_1,        FILE AIR_1.F90
!     FLU_1,        FILE FLU_1.F90
!     ICE_1,        FILE ICE_1.F90
!     AIR_2,        FILE AIR_2.F90
!     FLU_2,        FILE FLU_2.F90
!     ICE_2,        FILE ICE_2.F90
!     AIR_3B,       FILE AIR_3B.F90
!     ICE_LIQ_4,    FILE ICE_LIQ_4.F90

!NESTED USE ASSOCIATIONS
!     AIR_3A,       FILE AIR_3A.F90

!#########################################################################

use constants_0
use convert_0
use maths_0
use air_1
use flu_1
use ice_1
use air_2
use flu_2
use ice_2
use air_3b
use air_3c
use ice_liq_4

use ice_vap_4
use liq_vap_4

use liq_air_4a
use liq_air_4b
use liq_air_4c
use ice_air_4a
use ice_air_4b
use ice_air_4c
use liq_ice_air_4

implicit none
private

character*16, private :: version = 'August 2012'

public :: liq_ice_air_pottemp_si, liq_ice_air_pottemp_equi_si, &
          liq_ice_air_pottemp_equi_sat_si, &
          liq_ice_air_g_entropy_si, liq_ice_air_g_entropy_moist_si, &
          liq_ice_air_massfraction_air_si
          !liq_ice_air_g_entropy_mixed_si, &

contains

function liq_ice_air_pottemp_si(a_si, t_si, p_si, pr_si)
!THIS FUNCTION COMPUTES POTENTIAL TEMPERATURE OF AIR AND CHECK IF THERE IS ICE AT THE ORIGINAL POSITION
!AND AT THE FINAL POSITION

!OUTPUT:
!THETA(A,T,P,PR) ABSOLUTE POTENTIAL TEMPERATURE OF ICE AIR IN K

!INPUTS:
!A_SI      ABSOLUTE DRY-AIR MASS FRACTION IN KG/KG
!T_SI      ABSOLUTE IN-SITU TEMPERATURE IN K
!P_SI      ABSOLUTE IN-SITU PRESSURE IN PA
!PR_SI     ABSOLUTE REFERENCE PRESSURE IN PA

!NOTE: THE ACCURACY OF THIS FUNCTION DEPENDS ON THE ITERATION SETTINGS FOR
!      DENSITY COMPUTED IN AIR_3A,
!      AND ON THE ITERATION SETTINGS FOR TEMPERATURE BY SET_IT_CTRL_ICE_AIR_POTTEMP OF THIS MODULE_SI

real*8 liq_ice_air_pottemp_si, a_si, t_si, p_si, pr_si

real*8 s
real*8 a_sat, iml, ifl

liq_ice_air_pottemp_si = errorreturn

if(a_si < 0d0 .or. a_si >= 1d0) return
if(t_si < 0d0) return
if(p_si < 0d0) return
if(pr_si < 0d0) return


if(p_si == pr_si) then
  liq_ice_air_pottemp_si = t_si
  return
end if

s=liq_ice_air_g_entropy_si(a_si,t_si,p_si)
if(s == errorreturn) return

liq_ice_air_pottemp_si = liq_ice_air_h_temperature_si(a_si, s, pr_si)

end function

function liq_ice_air_h_temperature_si(a_si, eta_si, p_si)

real*8 liq_ice_air_h_temperature_si, a_si, eta_si, p_si
real*8 t_triple

liq_ice_air_h_temperature_si = errorreturn

if(a_si < 0d0 .or. a_si >= 1d0) return
if(p_si < 0d0) return

if(set_liq_ice_air_eq_at_p(p_si) == errorreturn) return
t_triple=liq_ice_air_temperature_si()

!Equilibrium agains ice:
liq_ice_air_h_temperature_si = ice_air_h_temperature_si(a_si, eta_si, p_si)
if(liq_ice_air_h_temperature_si/=errorreturn.and.liq_ice_air_h_temperature_si<t_triple) return

liq_ice_air_h_temperature_si = liq_air_h_temperature_si(a_si, eta_si, p_si)
if(liq_ice_air_h_temperature_si/=errorreturn.and.liq_ice_air_h_temperature_si>t_triple) return

liq_ice_air_h_temperature_si = air_temperature_si(a_si, eta_si, p_si)

end function


function liq_ice_air_massfraction_air_si(t_si, p_si)
real*8 liq_ice_air_massfraction_air_si, t_si, p_si
real*8 t_triple

liq_ice_air_massfraction_air_si = errorreturn

if(t_si < 0d0) return
if(p_si < 0d0) return

if(set_liq_ice_air_eq_at_p(p_si) == errorreturn) return
t_triple=liq_ice_air_temperature_si()
if(t_triple==errorreturn) return
if(t_si<t_triple) then
    liq_ice_air_massfraction_air_si=ice_air_massfraction_air_si(t_si,p_si)
else
   liq_ice_air_massfraction_air_si=liq_air_massfraction_air_si(t_si,p_si)
endif

end function

function liq_ice_air_g_entropy_moist_si(a_si, t_si, p_si)
!THIS FUNCTION COMPUTES THE ENTROPY OF MIXED ICE/LIQUID/WET AIR

real*8 liq_ice_air_g_entropy_moist_si, a_si, t_si, p_si
real*8 a_sat, rh_max, theta_e

liq_ice_air_g_entropy_moist_si = errorreturn

if(a_si < 0d0 .or. a_si >= 1d0) return
if(t_si < 0d0) return
if(p_si < 0d0) return

!Find the equivalent potential temperature:
theta_e=liq_ice_air_pottemp_equi_si(a_si,t_si,p_si,p_si)

a_sat=liq_ice_air_massfraction_air_si(theta_e,p_si)

rh_max=1d-3
a_sat = 1d0/(rh_max*(1d0/a_sat-1d0)+1d0)

!Compute the entropy of the equivalent potential temperature:
liq_ice_air_g_entropy_moist_si = liq_ice_air_g_entropy_si(a_sat, theta_e, p_si)

end function

function liq_ice_air_g_entropy_si(a_si, t_si, p_si)
!THIS FUNCTION COMPUTES THE ENTROPY OF MIXED ICE/LIQUID/WET AIR

real*8 liq_ice_air_g_entropy_si, a_si, t_si, p_si
real*8 a_sat, t_triple

liq_ice_air_g_entropy_si = errorreturn

if(a_si < 0d0 .or. a_si >= 1d0) return
if(t_si < 0d0) return
if(p_si < 0d0) return

a_sat=liq_ice_air_massfraction_air_si(t_si,p_si)

if(set_liq_ice_air_eq_at_p(p_si) == errorreturn) return
t_triple=liq_ice_air_temperature_si()
if(t_triple==errorreturn) return

if(a_sat<=a_si.or.a_sat==errorreturn) then
        !no condensation
        liq_ice_air_g_entropy_si=air_g_entropy_si(a_si, t_si, p_si)
else
    if(t_si<t_triple) then
        !condensation against ice
        liq_ice_air_g_entropy_si=ice_air_g_entropy_si(a_si, t_si, p_si)
    elseif(t_si>t_triple) then
        !condensation against liquid
        liq_ice_air_g_entropy_si=liq_air_g_entropy_si(a_si, t_si, p_si)
    else
        !at triple point
        liq_ice_air_g_entropy_si=liq_ice_air_entropy_si()
    endif
endif

end function

!function liq_ice_air_g_entropy_mixed_si(a_si, t_si, p_si, rh_wmo_max)
!THIS FUNCTION COMPUTES THE ENTROPY OF MIXED ICE/LIQUID/WET AIR

!real*8 liq_ice_air_g_entropy_mixed_si, a_si, t_si, p_si, rh_wmo_max
!real*8 a_sat, t_triple
!real*8 g_t

!liq_ice_air_g_entropy_mixed_si = errorreturn

!if(a_si < 0d0 .or. a_si >= 1d0) return
!if(t_si < 0d0) return
!if(p_si < 0d0) return

!a_sat=liq_ice_air_massfraction_air_si(t_si,p_si)

!a_sat = 1d0/(rh_wmo_max*(1d0/a_sat-1d0)+1d0)

!if(set_liq_ice_air_eq_at_p(p_si) == errorreturn) return
!t_triple=liq_ice_air_temperature_si()
!if(t_triple==errorreturn) return
!
!if(a_sat<=a_si.or.a_sat==errorreturn) then
!        !no condensation
!        liq_ice_air_g_entropy_mixed_si = air_g_entropy_si(a_si, t_si, p_si) 
!else
!    if(t_si<t_triple) then
!        !condensation against ice
!        g_t = ice_air_g_si(0, 1, 0, a_si, t_si, p_si, rh_wmo_max)
!        if(g_t == errorreturn) return
!
!        liq_ice_air_g_entropy_mixed_si = -g_t
!    elseif(t_si>t_triple) then
!        !condensation against liquid
!        g_t = liq_air_g_si(0, 1, 0, a_si, t_si, p_si, rh_wmo_max)
!        if(g_t == errorreturn) return
!
!        liq_ice_air_g_entropy_mixed_si = -g_t
!    else
!        !at triple point
!        liq_ice_air_g_entropy_mixed_si=liq_ice_air_entropy_si()
!    endif
!endif

!end function

function liq_ice_air_g_cp_si(a_si, t_si, p_si)
!THIS FUNCTION COMPUTES THE ENTROPY OF MIXED ICE/LIQUID/WET AIR

real*8 liq_ice_air_g_cp_si, a_si, t_si, p_si
real*8 a_sat, t_triple

liq_ice_air_g_cp_si = errorreturn

if(a_si < 0d0 .or. a_si >= 1d0) return
if(t_si < 0d0) return
if(p_si < 0d0) return

a_sat=liq_ice_air_massfraction_air_si(t_si,p_si)

if(set_liq_ice_air_eq_at_p(p_si) == errorreturn) return
t_triple=liq_ice_air_temperature_si()
if(t_triple==errorreturn) return

if(t_si<t_triple) then
    !equilibrium against ice
    if(a_sat<=a_si.or.a_sat==errorreturn) then
        !no condensation
        liq_ice_air_g_cp_si=air_g_cp_si(a_si, t_si, p_si)
    else
        !condensation against ice
        liq_ice_air_g_cp_si=ice_air_g_cp_si(a_si, t_si, p_si)
    endif
elseif(t_si>t_triple) then
    !equilibrium against liquid
    if(a_sat<=a_si .or. a_sat==errorreturn) then
        !no condensation
        liq_ice_air_g_cp_si=air_g_cp_si(a_si, t_si, p_si)
    else
        !condensation against liquid
        liq_ice_air_g_cp_si=liq_air_g_cp_si(a_si, t_si, p_si)
    endif
else
    !at triple point
    liq_ice_air_g_cp_si=liq_ice_air_entropy_si()
endif

end function

function liq_ice_air_pottemp_equi_si(a_si, t_si, p_si, pr_si)
!THIS FUNCTION COMPUTES THE EQUIVALENT TEMPERATURE OF AIR AT FIXED PRESSURE AND FIXED DRY AIR MASS FRACTION.

!OUTPUT:
!TEQ(A,T,P,PR) ABSOLUTE EQUIVALENT TEMPERATURE OF ICE AIR OR LIQUID AIR IN K

!INPUTS:
!A_SI      ABSOLUTE DRY-AIR MASS FRACTION IN KG/KG
!T_SI      ABSOLUTE IN-SITU TEMPERATURE IN K
!P_SI      ABSOLUTE IN-SITU PRESSURE IN PA
!PR_SI     REFERENCE PRESSURE IN PA

real*8 liq_ice_air_pottemp_equi_si, a_si, t_si, p_si, pr_si

real*8 s, tmin, p_toa, t_toa, t_triple, a_sat, rh_max

liq_ice_air_pottemp_equi_si = errorreturn

if(a_si < 0d0 .or. a_si >= 1d0) return
if(t_si < 0d0) return
if(p_si < 0d0) return
if(pr_si < 0d0) return

s = liq_ice_air_g_entropy_si(a_si, t_si, p_si)

if(s == errorreturn) return

!Find the level at which the dry temperature is equal to tmin:
tmin=200d0
p_toa = aux_ice_air_pressure_si(a_si, s, tmin)

!Find the temperature at that location:
t_toa = liq_ice_air_pottemp_si(a_si, t_si, p_si, p_toa)

a_sat=liq_ice_air_massfraction_air_si(t_toa,p_toa)

rh_max=1d-3
a_sat = 1d0/(rh_max*(1d0/a_sat-1d0)+1d0)
liq_ice_air_pottemp_equi_si=liq_ice_air_pottemp_si(a_sat, t_toa, p_toa, pr_si)

end function

!function liq_ice_air_pottemp_equi_ams_si(a_si, t_si, p_si, pr_si)
!THIS FUNCTION COMPUTES THE EQUIVALENT TEMPERATURE OF AIR AT FIXED PRESSURE AND FIXED DRY AIR MASS FRACTION.

!OUTPUT:
!TEQ(A,T,P,PR) ABSOLUTE EQUIVALENT TEMPERATURE OF ICE AIR OR LIQUID AIR IN K

!INPUTS:
!A_SI      ABSOLUTE DRY-AIR MASS FRACTION IN KG/KG
!T_SI      ABSOLUTE IN-SITU TEMPERATURE IN K
!P_SI      ABSOLUTE IN-SITU PRESSURE IN PA
!PR_SI     REFERENCE PRESSURE IN PA

!real*8 liq_ice_air_pottemp_equi_ams_si, a_si, t_si, p_si, pr_si
!
!real*8 equi_temp
!
!liq_ice_air_pottemp_equi_ams_si = errorreturn
!
!if(a_si < 0d0 .or. a_si >= 1d0) return
!if(t_si < 0d0) return
!if(p_si < 0d0) return
!if(pr_si < 0d0) return
!
!equi_temp=exp(-(1d0-a_si)*Rv/cp
!
!liq_ice_air_pottemp_equi_si=liq_ice_air_pottemp_si(a_si, t_si, p_toa, pr_si)
!
!end function


function liq_ice_air_pottemp_equi_sat_si(a_si, t_si, p_si, pr_si)
!THIS FUNCTION COMPUTES THE SATURATION EQUIVALENT TEMPERATURE OF AIR AT FIXED PRESSURE AND FIXED DRY AIR MASS FRACTION.

!OUTPUT:
!TEQ(A,T,P,PR) ABSOLUTE EQUIVALENT TEMPERATURE OF ICE AIR OR LIQUID AIR IN K

!INPUTS:
!A_SI      ABSOLUTE DRY-AIR MASS FRACTION IN KG/KG
!T_SI      ABSOLUTE IN-SITU TEMPERATURE IN K
!P_SI      ABSOLUTE IN-SITU PRESSURE IN PA
!PR_SI     REFERENCE PRESSURE IN PA

real*8 liq_ice_air_pottemp_equi_sat_si, a_si, t_si, p_si, pr_si

real*8 s, a_sat, t_triple

liq_ice_air_pottemp_equi_sat_si = errorreturn

if(a_si < 0d0 .or. a_si >= 1d0) return
if(t_si < 0d0) return
if(p_si < 0d0) return
if(pr_si < 0d0) return

!Find the saturation air mass fraction:
a_sat=liq_ice_air_massfraction_air_si(t_si,p_si)

if(a_si>a_sat) then
    liq_ice_air_pottemp_equi_sat_si=liq_ice_air_pottemp_equi_si(a_sat, t_si, p_si, pr_si)
else
    liq_ice_air_pottemp_equi_sat_si=liq_ice_air_pottemp_equi_si(a_si, t_si, p_si, pr_si)
endif

end function

!=========================================================================
function aux_ice_air_pressure_si(wa_si, eta_si, t_si)
!==========================================================================

!THIS FUNCTION ESTIMATES THE PRESSURE OF ICE AIR FROM ITS DRY-AIR FRACTION WA_SI IN KG/KG,
!ITS SPECIFIC ENTROPY ETA_SI IN J/(KG K), AND ITS ABSOLUTE TEMPERATURE, T_SI IN K

real*8 aux_ice_air_pressure_si, wa_si, eta_si, t_si
real*8 numer, denom, p, tf

real*8 tt, pt, cpa, cpi, sat, sit, ra

tt = tp_temperature_si           !TRIPLE-POINT TEMPERATURE IN K
pt = tp_pressure_iapws95_si      !TRIPLE-POINT PRESSURE IN Pa

cpa = 1003.68997553091d0         !TRIPLE-POINT HEAT CAPACITY OF AIR IN J/(KG K)
cpi = 2096.78431621667d0         !TRIPLE-POINT HEAT CAPACITY OF ICE IN J/(KG K)

sat = 1467.66694249983d0         !TRIPLE-POINT ENTROPY OF AIR IN J/(KG K)
sit = -1220.69433939648d0        !TRIPLE-POINT ENTROPY OF ICE IN J/(KG K)

ra = gas_constant_air_si

aux_ice_air_pressure_si = errorreturn
if(t_si <= 0d0) return
if(wa_si < 0d0 .or. wa_si > 1d0) return

!ASSUME CONSTANT HEAT CAPACITY CP OF ICE AND AIR, USE IDEAL-GAS EQUATION,
!NEGLECT THE VAPOUR FRACTION IN HUMID AIR:

denom = cpa

p = pt*exp((denom*log(t_si/tt) - eta_si + sit + wa_si*(sat-sit))/(wa_si*ra))

!CHECK IF T_SI IS BELOW FREEZING POINT????

aux_ice_air_pressure_si = p

end function

end module liq_ice_air_5

module sea_5a

!#########################################################################

!THIS MODULE IMPLEMENTS SEAWATER PROPERTIES RELATED TO POTENTIAL TEMPERATURE 
!AND CONSERVATIVE TEMPERATURE. 

!#########################################################################

!IMPLEMENTATION IN FORTRAN BY D.G. WRIGHT AND D.R. JACKETT
!FOR PUBLICATION IN OCEAN SCIENCE, AS DESCRIBED IN THE PAPERS

!FEISTEL, R., WRIGHT, D.G., JACKETT, D.R., MIYAGAWA, K., REISSMANN, J.H.,
!WAGNER, W., OVERHOFF, U., GUDER, C., FEISTEL, A., MARION, G.M.:
!NUMERICAL IMPLEMENTATION AND OCEANOGRAPHIC APPLICATION OF THE THERMODYNAMIC
!POTENTIALS OF WATER, VAPOUR, ICE, SEAWATER AND AIR. PART I: BACKGROUND AND EQUATIONS. 
!OCEAN SCIENCES, 2009, IN PREPARATION.

!WRIGHT, D.G., FEISTEL, R., JACKETT, D.R., MIYAGAWA, K., REISSMANN, J.H., 
!WAGNER, W., OVERHOFF, U., GUDER, C., FEISTEL, A., MARION, G.M.:
!NUMERICAL IMPLEMENTATION AND OCEANOGRAPHIC APPLICATION OF THE THERMODYNAMIC
!POTENTIALS OF WATER, VAPOUR, ICE, SEAWATER AND AIR. PART II: THE LIBRARY ROUTINES, 
!OCEAN SCIENCES., 2009, IN PREPARATION.

!FEISTEL, R., KRETZSCHMAR, H.-J., SPAN, R., HAGEN, E., WRIGHT, D.G., JACKETT, D.R.:
!THERMODYNAMIC PROPERTIES OF SEA AIR.
!OCEAN SCIENCE DISCUSSION 6(2009)2193-2325.

!#########################################################################

!THIS MODULE REQUIRES THE LIBRARY MODULES:
!     CONSTANTS_0, FILE CONSTANTS_0.F90
!     SEA_3A,      FILE SEA_3A.F90
!     SEA_3B,      FILE SEA_3B.F90
!     SEA_3C,      FILE SEA_3C.F90

!NESTED USE ASSOCIATIONS
!     CONVERT_0,   FILE CONVERT_0.F90
!     MATHS_0,     FILE MATHS_0.F90
!     FLU_1,       FILE FLU_1.F90
!     SAL_1,       FILE SAL_1.F90
!     SAL_2,       FILE SAL_2.F90
!     FLU_3A,      FILE FLU_3A.F90

!#########################################################################

use constants_0
use sea_3a
use sea_3b
use sea_3c

implicit none
private

character*16, private :: version = '8 Jun 2010'

public :: sea_alpha_ct_si, sea_alpha_pt0_si, sea_alpha_t_si, &
          sea_beta_ct_si,  sea_beta_pt0_si,  sea_beta_t_si,  &
          sea_cabb_ct_si, sea_cabb_pt0_si, &
          sea_ctmp_from_ptmp0_si, sea_ptmp0_from_ctmp_si, &
          sea_thrmb_ct_si, sea_thrmb_pt0_si

contains

!==========================================================================
function sea_ctmp_from_ptmp0_si(sa_si,tpot_si)
!==========================================================================

!CONSERVATIVE TEMPERATURE FROM POTENTIAL TEMPERATURE OF SEAWATER  
!
!SA_SI         : ABSOLUTE SALINITY                        [KG/KG]
!TPOT_SI       : POTENTIAL TEMPERATURE WITH               [K]
!                REFERENCE PRESSURE OF 101325 PA
!
!RESULT        : CONSERVATIVE TEMPERATURE                 [K]

!CHECK VALUE:
!SEA_CTMP_FROM_PTMP0_SI(0.035, 300) =   0.300010069445E+03

implicit none
real*8 sa_si, tpot_si, sea_ctmp_from_ptmp0_si
real*8 cp0, pr_si, ct

sea_ctmp_from_ptmp0_si = errorreturn

cp0 = 3991.86795711963d0     ! IN CONCRETE 02/12/08

pr_si = 101325d0

ct = sea_enthalpy_si(sa_si, tpot_si, pr_si)
if (ct == errorreturn) return

sea_ctmp_from_ptmp0_si = 273.15d0 + ct / cp0

end function


!==========================================================================
function sea_ptmp0_from_ctmp_si(sa_si,ct_si)
!==========================================================================

!POTENTIAL TEMPERATURE OF SEAWATER FROM CONSERVATIVE TEMPERATURE
!
!SA_SI               : ABSOLUTE SALINITY                  [KG/KG]
!CT_SI               : CONSERVATIVE TEMPERATURE           [K]
!
!RESULT              : POTENTIAL TEMPERATURE WITH         [K]
!                      REFERENCE PRESSURE OF  101325 PA

!CHECK VALUE:
!SEA_PTMP0_FROM_CTMP_SI(0.035, 300.010069445) =   300

implicit none
integer nloops, n
real*8 sa_si, ct_si, s1, ct1, p0, sea_ptmp0_from_ctmp_si, cp0 
real*8 a0, a1, a2, a3, a4, a5, b0, b1, b2, b3
real*8 a5ct, b3ct, ct_factor, th0_num, rec_th0_den
real*8 th0, ct0, dth_dct, theta, dct, dct_dth, factor

sea_ptmp0_from_ctmp_si = errorreturn

cp0 = 3991.86795711963d0    
s1 = sa_si*35d0/35.16504d0; ct1 = ct_si-273.15d0; p0 = 101325d0

a0 = -1.446013646344788d-2;     b0 =  1.000000000000000d+0
a1 = -3.305308995852924d-3;     b1 =  6.506097115635800d-4
a2 =  1.062415929128982d-4;     b2 =  3.830289486850898d-3
a3 =  9.477566673794488d-1;     b3 =  1.247811760368034d-6
a4 =  2.166591947736613d-3
a5 =  3.828842955039902d-3

a5ct = a5*ct1; b3ct = b3*ct1
ct_factor = (a3+a4*s1+a5ct)
th0_num = a0+s1*(a1+a2*s1)+ct1*ct_factor
rec_th0_den = 1d0/(b0+b1*s1+ct1*(b2+b3ct))
th0 = th0_num*rec_th0_den

ct0 = sea_ctmp_from_ptmp0_si(sa_si,273.15d0+th0) 
if(ct0 == errorreturn) return

dth_dct = (ct_factor+a5ct-(b2+b3ct+b3ct)*th0)*rec_th0_den 
theta = th0-(ct0-ct_si)*dth_dct

nloops = 1   !DEFAULT
             !NOTE: NLOOPS = 1 GIVES THETA WITH A MAXIMUM ERROR OF & !dbg truncated sentence
n = 0; 
do while(n <= nloops)
  factor = sea_ctmp_from_ptmp0_si(sa_si,273.15d0+theta)
  if(factor == errorreturn) return
  dct = factor-ct_si

  factor = sea_g_si(0,2,0,sa_si,273.15d0+theta,p0)
  if(factor == errorreturn) return
  dct_dth = -(theta+273.15d0)*factor/cp0   

  theta = theta - dct/dct_dth
  n = n+1
end do

sea_ptmp0_from_ctmp_si = theta + 273.15d0

end function


!==========================================================================
function sea_alpha_ct_si(sa_si,t_si,p_si)
!==========================================================================

!THERMAL EXPANSION COEFFICIENT OF SEAWATER WRT CONSERVATIVE TEMPERATURE
!
!SA_SI                  : ABSOLUTE SALINITY                  [KG/KG]
!T_SI                   : IN SITU TEMPERATURE                [K]
!P_SI                   : ABSOLUTE PRESSURE                  [PA]
!
!SEA_ALPHA_CT_SI        : THERMAL EXPANSION COEFFICIENT      [1/K]
!                         WRT CONSERVATIVE TEMPERATURE

!CHECK VALUE WITH DEFAULT SETTINGS:
!SEA_ALPHA_CT_SI(0.035, 300, 1E8) = 3.91772847589E-04

implicit none
character *13 key
real*8 sa_si, t_si, p_si, sea_alpha_ct_si
real*8 pr_si, ah, cp0

cp0 = 3991.86795711963d0     ! IN CONCRETE 02/12/08

sea_alpha_ct_si = errorreturn

pr_si = 101325d0

key = "t"
ah = sea_eta_expansion_h_si(sa_si, t_si, p_si, pr_si, key)
if (ah == errorreturn) return

sea_alpha_ct_si = cp0 * ah

end function


!==========================================================================
function sea_alpha_pt0_si(sa_si,t_si,p_si)
!==========================================================================

!THERMAL EXPANSION COEFFICIENT OF SEAWATER WRT POTENTIAL TEMPERATURE

!SA_SI                  : ABSOLUTE SALINITY                  [KG/KG]
!T_SI                   : IN SITU TEMPERATURE                [K]
!P_SI                   : ABSOLUTE PRESSURE                  [PA]
!
!SEA_ALPHA_PT0_SI       : THERMAL EXPANSION COEFFICIENT      [1/K]
!                         WRT POTENTIAL TEMPERATURE

!CHECK VALUE WITH DEFAULT SETTINGS:
!SEA_ALPHA_PT0_SI(0.035, 300, 1E8) = 3.92515634064E-04

implicit none
character*13 key
real*8 sa_si, t_si, p_si, sea_alpha_pt0_si
real*8 pr_si

pr_si = 101325d0
key = "t"
sea_alpha_pt0_si = sea_eta_expansion_theta_si(sa_si, t_si, p_si, pr_si, key)

end function


!==========================================================================
function sea_alpha_t_si(sa_si,t_si,p_si)
!==========================================================================

!THERMAL EXPANSION COEFFICIENT OF SEAWATER WRT IN SITU TEMPERATURE
!
!SA_SI                  : ABSOLUTE SALINITY                  [KG/KG]
!T_SI                   : IN SITU TEMPERATURE                [K]
!P_SI                   : ABSOLUTE PRESSURE                  [PA]
!
!SEA_ALPHA_T_SI         : THERMAL EXPANSION COEFFICIENT      [1/K]
!                         WRT IN SITU TEMPERATURE

!CHECK VALUE WITH DEFAULT SETTINGS:
!SEA_ALPHA_T_SI(0.035, 300, 1E8) = 3.73608885178E-04

implicit none
real*8 sa_si, t_si, p_si, sea_alpha_t_si

sea_alpha_t_si = sea_g_expansion_t_si(sa_si, t_si, p_si)

end function


!==========================================================================
function sea_beta_ct_si(sa_si,t_si,p_si)
!==========================================================================

!HALINE CONTRACTION COEFFICIENT OF SEAWATER WRT CONSTANT CONSERVATIVE TEMPERATURE
!
!SA_SI                  : ABSOLUTE SALINITY                  [KG/KG]
!T_SI                   : IN SITU TEMPERATURE                [K]
!P_SI                   : ABSOLUTE PRESSURE                  [PA]
!
!RESULT                 : HALINE CONTRACTION COEFFICIENT     [KG/KG]
!                         WRT CONSTANT CONSERVATIVE TEMPERATURE

!CHECK VALUE WITH DEFAULT SETTINGS:
!SEA_BETA_CT_SI(0.035, 300, 1E8) = 0.649596383654

implicit none
character*13 key
real*8 sa_si, t_si, p_si, sea_beta_ct_si
real*8 pr_si

pr_si = 101325d0
key = "t"
sea_beta_ct_si = sea_eta_contraction_h_si(sa_si, t_si, p_si, pr_si, key)

end function


!==========================================================================
function sea_beta_pt0_si(sa_si,t_si,p_si)
!==========================================================================

!HALINE CONTRACTION COEFFICIENT OF SEAWATER WRT CONSTANT POTENTIAL TEMPERATURE 
!
!SA_SI                  : ABSOLUTE SALINITY                  [KG/KG]
!T_SI                   : IN SITU TEMPERATURE                [K]
!P_SI                   : ABSOLUTE PRESSURE                  [PA]
!
!RESULT                 : HALINE CONTRACTION COEFFICIENT     [KG/KG]
!                         WITH CONSTANT POTENTIAL TEMPERATURE

!CHECK VALUE WITH DEFAULT SETTINGS:
!SEA_BETA_PT0_SI(0.035, 300, 1E8) = 0.663973579411

implicit none
character*13 key
real*8 sa_si, t_si, p_si, sea_beta_pt0_si
real*8 pr_si

pr_si = 101325d0
key = "t"
sea_beta_pt0_si = sea_eta_contraction_theta_si(sa_si, t_si, p_si, pr_si, key)

end function


!==========================================================================
function sea_beta_t_si(sa_si,t_si,p_si)
!==========================================================================

!HALINE CONTRACTION COEFFICIENT OF SEAWATER WRT IN SITU TEMPERATURE 
!
!SA_SI                  : ABSOLUTE SALINITY                  [KG/KG]
!T_SI                   : IN SITU TEMPERATURE                [K]
!P_SI                   : ABSOLUTE PRESSURE                  [PA]
!
!RESULT                 : HALINE CONTRACTION COEFFICIENT     [KG/KG]

!CHECK VALUE WITH DEFAULT SETTINGS:
!SEA_BETA_T_SI(0.035, 300, 1E8) = 0.666238827368

implicit none
real*8 sa_si, t_si, p_si, sea_beta_t_si

sea_beta_t_si = sea_g_contraction_t_si(sa_si, t_si, p_si)

end function


!==========================================================================
function sea_cabb_ct_si(sa_si,t_si,p_si)
!==========================================================================

!CABBELING COEFFICIENT OF SEAWATER WRT CONSERVATIVE TEMPERATURE 

!SA_SI                  : ABSOLUTE SALINITY                  [KG/KG]
!T_SI                   : IN SITU TEMPERATURE                [K]
!P_SI                   : SEA (GAUGE) PRESSURE               [PA]
!
!RESULT                 : CABBELING COEFFICIENT              [1/(K**2)] 
!                         WRT CONSERVATIVE TEMPERATURE

!CHECK VALUE:
!SEA_CABB_CT_SI(0.035, 300, 1E5) = 8.612525|67438267E-06  !DEFAULT TOLERANCE
!SEA_CABB_CT_SI(0.035, 300, 1E5) = 8.6125256|4750277E-06  !TOLERANCE RESET TO -1D-12


implicit none
!character*13 key0 
!real*8 eps0
real*8 sa_si, t_si, p_si, sea_cabb_ct_si
real*8 pr0, th, th_l, th_u, t_l, t_u, alpha, beta, alpha_ct, ratio
real*8 ct, dct, ct_l, ct_u, dsa, sa_l, sa_u, alpha_sa, beta_sa, factor1, factor2

!EXPERIMENTATION WITH DIFFERENT ERROR TOLERANCES DID NOT LEAD TO SYSTEMATIC IMPROVEMENT
!key0="tol_liq_dens"
!eps0 = get_it_ctrl_density(key0)
!call set_it_ctrl_density(key0, -1d-12)

sea_cabb_ct_si = errorreturn

pr0 = 101325d0; 

th = sea_pottemp_si(sa_si,t_si,p_si,pr0);    ! NOTE: CT = CONST <==> THETA = CONST
if (th == errorreturn) return
ct = sea_ctmp_from_ptmp0_si(sa_si,th)  
if (ct == errorreturn) return

!CT DERIVATIVE: The modification made here is to ensure centered differences
dct = 1d-3;     
               
ct_l = ct - dct; ct_u = ct + dct; 

th_l = sea_ptmp0_from_ctmp_si(sa_si,ct_l)
if (th_l == errorreturn) return
th_u =  sea_ptmp0_from_ctmp_si(sa_si,ct_u)
if (th_u == errorreturn) return

t_l = sea_pottemp_si(sa_si,th_l,pr0,p_si)
if (t_l == errorreturn) return
t_u = sea_pottemp_si(sa_si,th_u,pr0,p_si)
if (t_u == errorreturn) return

alpha = sea_alpha_ct_si(sa_si,t_si,p_si)
if(alpha == errorreturn) return
beta = sea_beta_ct_si(sa_si,t_si,p_si)
if(beta == errorreturn .or. beta == 0d0) return
ratio = alpha/beta

factor1 = sea_alpha_ct_si(sa_si,t_u,p_si)
if(factor1 == errorreturn) return
factor2 = sea_alpha_ct_si(sa_si,t_l,p_si)
if(factor2 == errorreturn) return

!calculate d(alpha_ct)/dct
if (ct_u == ct_l) return
alpha_ct = (factor1-factor2)/(ct_u-ct_l)

!SA DERIVATIVES
dsa = min(sa_si,1d-5);
if(sa_si >= dsa)then
  sa_l = sa_si - dsa; sa_u = sa_si + dsa; 
elseif(sa_si >= 0d0)then
  sa_l = 0d0; sa_u = dsa; 
else
  print *, '****    sa_si<0 in sea_cabb_ct    ****' 
  sea_cabb_ct_si = errorreturn
  return
end if

if (sa_u == sa_l) return

factor1 = sea_alpha_ct_si(sa_u,t_si,p_si)
if(factor1 == errorreturn) return
factor2 = sea_alpha_ct_si(sa_l,t_si,p_si)
if(factor2 == errorreturn) return
alpha_sa = (factor1-factor2)/(sa_u-sa_l)

factor1 = sea_beta_ct_si(sa_u,t_si,p_si)
if(factor1 == errorreturn) return
factor2 = sea_beta_ct_si(sa_l,t_si,p_si)
if(factor2 == errorreturn) return
beta_sa =  (factor1-factor2)/(sa_u-sa_l)


!CABBELING COEFFICIENT
sea_cabb_ct_si = alpha_ct + ratio*(2d0*alpha_sa - ratio*beta_sa)

!call set_it_ctrl_density(key0, eps0)

end function


!==========================================================================
function sea_cabb_pt0_si(sa_si,t_si,p_si)
!==========================================================================

!CABBELING COEFFICIENT OF SEAWATER WRT POTENTIAL TEMPERATURE 

!SA_SI                  : ABSOLUTE SALINITY                  [KG/KG]
!T_SI                   : IN SITU TEMPERATURE                [K]
!P_SI                   : SEA (GAUGE) PRESSURE               [PA]
!
!RESULT                 : CABBELING COEFFICIENT              [1/(K**2)] 
!                         WRT POTENTIAL TEMPERATURE

!CHECK VALUE:
!SEA_CABB_PT0_SI(0.035, 300, 1E5) = 8.3387453|7690444E-06  !DEFAULT TOLERANCES
!SEA_CABB_PT0_SI(0.035, 300, 1E5) = 8.3387453|0126243E-06  !TOLERANCE RESET TO -1D-12



implicit none
!character*13 key0
!real*8 eps0
real*8 sa_si, t_si, p_si, sea_cabb_pt0_si
real*8 pr0, th, dth, th_l, th_u, t_l, t_u, alpha, beta, alpha_pt0, ratio
real*8 dsa, sa_l, sa_u, alpha_sa, beta_sa, factor1, factor2

!EXPERIMENTATION WITH DIFFERENT ERROR TOLERANCES DID NOT LEAD TO SYSTEMATIC IMPROVEMENT
!key0="tol_liq_dens"
!eps0 = get_it_ctrl_density(key0)
!call set_it_ctrl_density(key0,-1d-12)
 
sea_cabb_pt0_si = errorreturn

pr0 = 101325d0; 

sea_cabb_pt0_si = errorreturn
th = sea_pottemp_si(sa_si,t_si,p_si,pr0);
if (th == errorreturn) return

!TH DERIVATIVE
dth = 1d-3
th_l = th - dth; th_u = th + dth; 

t_l = sea_pottemp_si(sa_si,th_l,pr0,p_si)
if (t_l == errorreturn) return
t_u = sea_pottemp_si(sa_si,th_u,pr0,p_si)
if (t_u == errorreturn .or. t_u == t_l) return

alpha = sea_alpha_pt0_si(sa_si,t_si,p_si) 
if(alpha == errorreturn) return
beta = sea_beta_pt0_si(sa_si,t_si,p_si)
if(beta == errorreturn .or. beta == 0d0) return
ratio = alpha/beta

factor1 = sea_alpha_pt0_si(sa_si,t_u,p_si)
if(factor1 == errorreturn) return
factor2 = sea_alpha_pt0_si(sa_si,t_l,p_si)
if(factor2 == errorreturn) return
alpha_pt0 = (factor1-factor2)/(th_u-th_l)

!SA DERIVATIVES
dsa = min(sa_si,1d-5)
if(sa_si >= dsa) then
  sa_l = sa_si - dsa; sa_u = sa_si + dsa; 
elseif(sa_si >= 0d0)then
  sa_l = 0d0; sa_u = dsa; 
else
    print *, '****    sa_si<0 in sea_cabb_pt0    ****'; stop
end if

if (sa_u == sa_l) return

factor1 = sea_alpha_pt0_si(sa_u,t_si,p_si)
if(factor1 == errorreturn) return
factor2 = sea_alpha_pt0_si(sa_l,t_si,p_si)
if(factor2 == errorreturn) return
alpha_sa = (factor1-factor2)/(sa_u-sa_l)

beta_sa =  (sea_beta_pt0_si(sa_u,t_si,p_si)-sea_beta_pt0_si(sa_l,t_si,p_si))/(sa_u-sa_l)

!CABBELING COEFFICIENT
sea_cabb_pt0_si = alpha_pt0 + ratio*(2d0*alpha_sa - ratio*beta_sa)

!call set_it_ctrl_density(key0, eps0)

end function


!==========================================================================
function sea_thrmb_ct_si(sa_si,t_si,p_si)
!==========================================================================

!THERMOBARIC COEFFICIENT OF SEAWATER WRT CONSERVATIVE TEMPERATURE 
!
!SA_SI                  : ABSOLUTE SALINITY                  [KG/KG]
!T_SI                   : IN SITU TEMPERATURE                [K]
!P_SI                   : SEA (GAUGE) PRESSURE               [PA]
!
!RESULT                 : THERMOBARIC COEFFICIENT            [1/(K PA)]
!                         WRT CONSERVATIVE TEMPERATURE

!CHECK VALUE:
!SEA_THRMB_CT_SI(0.035, 300, 1E5) = 1.4810927|1668362E-12  !DEFAULT TOLERANCES
!SEA_THRMB_CT_SI(0.035, 300, 1E5) = 1.4810927|5172403E-12  !TOLERANCE RESET TO -1D-12


implicit none
!character*13 key0
!real*8 eps0
real*8 sa_si, t_si, p_si, sea_thrmb_ct_si
real*8 pr0, theta, dp, p_l, p_u, t_l, t_u
real*8 beta, alpha_u, beta_u, alpha_l, beta_l

!EXPERIMENTATION WITH DIFFERENT ERROR TOLERANCES DID NOT LEAD TO SYSTEMATIC IMPROVEMENT
!key0="tol_liq_dens"
!eps0 = get_it_ctrl_density(key0)
!call set_it_ctrl_density(key0, -1d-12)

sea_thrmb_ct_si = errorreturn

dp = 1d3
pr0 = 101325d0; 
theta = sea_pottemp_si(sa_si,t_si,p_si,pr0)
if (theta == errorreturn) return

if(p_si >= dp) then
  p_l = p_si - dp; p_u = p_si + dp;
else
  p_l = 0d0; p_u = dp;
end if
if (p_u == p_l) return

t_l = sea_pottemp_si(sa_si,theta,pr0,p_l);    ! CT = CONST ==> THETA = CONST
if (t_l == errorreturn) return

t_u = sea_pottemp_si(sa_si,theta,pr0,p_u)
if (t_u == errorreturn) return

beta = sea_beta_ct_si(sa_si,t_si,p_si)
if (beta == errorreturn) return

alpha_u = sea_alpha_ct_si(sa_si,t_u,p_u)
if (alpha_u == errorreturn) return
beta_u = sea_beta_ct_si(sa_si,t_u,p_u)
if(beta_u == errorreturn .or. beta_u == 0d0) return

alpha_l = sea_alpha_ct_si(sa_si,t_l,p_l)
if (alpha_l == errorreturn) return
beta_l = sea_beta_ct_si(sa_si,t_l,p_l)
if(beta_l == errorreturn .or. beta_l == 0d0) return

sea_thrmb_ct_si = beta * (alpha_u/beta_u - alpha_l/beta_l)/(p_u - p_l)

!call set_it_ctrl_density(key0, eps0)

end function


!==========================================================================
function sea_thrmb_pt0_si(sa_si,t_si,p_si)
!==========================================================================

!THERMOBARIC COEFFICIENT OF SEAWATER WRT POTENTIAL TEMPERATURE 
!
!SA_SI                  : ABSOLUTE SALINITY                  [KG/KG]
!T_SI                   : IN SITU TEMPERATURE                [K]
!P_SI                   : SEA (GAUGE) PRESSURE               [PA]
!
!RESULT                 : THERMOBARIC COEFFICIENT            [1/(K PA)]
!                         WRT POTENTIAL TEMPERATURE

!CHECK VALUE:
!SEA_THRMB_PT0_SI(0.035, 300, 1E5) = 1.4594101|0702991E-12   !DEFAULT TOLERANCES
!SEA_THRMB_PT0_SI(0.035, 300, 1E5) = 1.4594101|3482853E-12   !TOLERANCE RESET TO -1D-12


implicit none
!character*13 key0
!real*8 eps0
real*8 sa_si, t_si, p_si, sea_thrmb_pt0_si
real*8 pr0, theta, dp, p_l, p_u, t_l, t_u
real*8 beta, alpha_u, beta_u, alpha_l, beta_l

!EXPERIMENTATION WITH DIFFERENT ERROR TOLERANCES DID NOT LEAD TO SYSTEMATIC IMPROVEMENT
!key0="tol_liq_dens"
!eps0 = get_it_ctrl_density(key0)
!call set_it_ctrl_density(key0, -1d-12)

sea_thrmb_pt0_si = errorreturn

dp = 1d3
pr0 = 101325d0

theta = sea_pottemp_si(sa_si,t_si,p_si,pr0)
if (theta == errorreturn) return

if(p_si >= dp) then
  p_l = p_si - dp; p_u = p_si + dp;
else
  p_l = 0d0; p_u = dp;
end if
if (p_u == p_l) return

t_l = sea_pottemp_si(sa_si,theta,pr0,p_l)
if (t_l == errorreturn) return

t_u = sea_pottemp_si(sa_si,theta,pr0,p_u)
if (t_u == errorreturn) return

beta = sea_beta_pt0_si(sa_si,t_si,p_si)
if (beta == errorreturn) return

alpha_u = sea_alpha_pt0_si(sa_si,t_u,p_u)
if (alpha_u == errorreturn) return
beta_u = sea_beta_pt0_si(sa_si,t_u,p_u)
if(beta_u == errorreturn) return
if(beta_u == errorreturn .or. beta_u == 0d0) return

alpha_l = sea_alpha_pt0_si(sa_si,t_l,p_l)
if (alpha_l == errorreturn) return
beta_l = sea_beta_pt0_si(sa_si,t_l,p_l)
if(beta_l == errorreturn .or. beta_l == 0d0) return

sea_thrmb_pt0_si = beta * (alpha_u/beta_u - alpha_l/beta_l)/(p_u - p_l)

!call set_it_ctrl_density(key0, eps0)

end function

end module sea_5a

module liq_ice_air_5b

!#########################################################################

!THIS MODULE IMPLEMENTS THE EQUILIBRIUM PROPERTIES OF WET ICE AIR, 
!I.E., BETWEEN LIQUID WATER, ICE AND HUMID AIR
!
!THIS MODULE ALSO PROVIDES SIMPLE IMPLEMENTATIONS OF DERIVED METEOROLOGICAL
!QUANTITIES LIKE THE EQUIVALENT POTENTIAL TEMPERATURE, ETC.

!#########################################################################

!IMPLEMENTATION IN FORTRAN BY F.B. LALIBERTE AT THE UNIVERSITY OF TORONTO, 2012
!FOR PROBABLE FUTURE PUBLICATION WITH THE DEVELOPERS OF TEOS-10

!#########################################################################

!THIS MODULE REQUIRES THE LIBRARY MODULES:
!     CONSTANTS_0,  FILE CONSTANTS_0.F90
!     CONVERT_0,    FILE CONVERT_0.F90
!     MATHS_0,      FILE MATHS_0.F90
!     AIR_1,        FILE AIR_1.F90
!     FLU_1,        FILE FLU_1.F90
!     ICE_1,        FILE ICE_1.F90
!     AIR_2,        FILE AIR_2.F90
!     FLU_2,        FILE FLU_2.F90
!     ICE_2,        FILE ICE_2.F90
!     AIR_3B,       FILE AIR_3B.F90
!     AIR_3C,       FILE AIR_3C.F90
!     ICE_LIQ_4,    FILE ICE_LIQ_4.F90
!     ICE_VAP_4,    FILE ICE_VAP_4.F90
!     LIQ_VAP_4,    FILE LIQ_VAP_4.F90

!     LIQ_AIR_4A,   FILE LIQ_AIR_4A.F90
!     LIQ_AIR_4B,   FILE LIQ_AIR_4B.F90
!     LIQ_AIR_4C,   FILE LIQ_AIR_4C.F90

!     ICE_AIR_4A,   FILE ICE_AIR_4A.F90
!     ICE_AIR_4B,   FILE ICE_AIR_4B.F90
!     ICE_AIR_4C,   FILE ICE_AIR_4C.F90

!     LIQ_ICE_AIR_4,FILE LIQ_ICE_AIR_4.F90 

!#########################################################################

use constants_0
use convert_0
use maths_0
use air_1
use flu_1
use ice_1
use air_2
use flu_2
use ice_2
use air_3b
use air_3c
use ice_liq_4

use ice_vap_4
use liq_vap_4

use liq_air_4a
use liq_air_4b
use liq_air_4c
use liq_air_4d
use ice_air_4a
use ice_air_4b
use ice_air_4c
use ice_air_4d
use liq_ice_air_4

implicit none
private

character*16, private :: version = 'October 2012'

public :: &
          liq_ice_air_massfraction_air_si,&
          liq_ice_air_g_entropy_si, &
          liq_ice_air_g_density_si, &
          liq_ice_air_g_enthalpy_si, &
          liq_ice_air_g_cp_si, &
          liq_ice_air_g_rh_wmo_si

contains

function liq_ice_air_massfraction_air_si(t_si, p_si)
!THIS FUNCTION COMPUTES THE MASSFRACTION OF SATURATED AIR
!SHOULD BE VALID OVER THE WHOLE REGION OF VALIDILITY OF TEOS-10

!OUTPUT:
!A_SAT(T,P) MASSFRACTION OF SATURATED AIR (LIQ-VAP-AIR OR ICE-VAP-AIR OR VAP-AIR)

!INPUTS:
!T_SI      ABSOLUTE IN-SITU TEMPERATURE IN K
!P_SI      ABSOLUTE IN-SITU PRESSURE IN PA

real*8 liq_ice_air_massfraction_air_si, t_si, p_si
real*8 t_freeze

liq_ice_air_massfraction_air_si = errorreturn

if(t_si < 0d0) return
if(p_si < 0d0) return

if(set_liq_ice_air_eq_at_p(p_si) /= errorreturn) then
    !Above or at triple point

    t_freeze=liq_ice_air_temperature_si()
    if(t_freeze==errorreturn) return

    if(t_si<t_freeze) then
        !Pure ice:
        liq_ice_air_massfraction_air_si=ice_air_massfraction_air_si(t_si,p_si)
    elseif (t_si>t_freeze) then 
        !Pure water:
        liq_ice_air_massfraction_air_si=liq_air_massfraction_air_si(t_si,p_si)
    else
        liq_ice_air_massfraction_air_si=liq_ice_air_airfraction_si()
    endif
else
    !Below the triple point. Pure ice:
    liq_ice_air_massfraction_air_si=ice_air_massfraction_air_si(t_si,p_si)
endif

if(liq_ice_air_massfraction_air_si==errorreturn) then
   !massfraction should be 0
   liq_ice_air_massfraction_air_si=0.0
endif

end function

function liq_ice_air_g_entropy_si(wa_si, t_si, p_si)
!THIS FUNCTION COMPUTES THE ENTROPY OF AIR AT FIXED PRESSURE AND FIXED DRY AIR MASS FRACTION.

!OUTPUT:
!ETA(A,T,P,PR) ENTROPY OF ICE AIR OR LIQUID AIR J/(K KG)

!INPUTS:
!A_SI      ABSOLUTE DRY-AIR MASS FRACTION IN KG/KG
!T_SI      ABSOLUTE IN-SITU TEMPERATURE IN K
!P_SI      ABSOLUTE IN-SITU PRESSURE IN PA

real*8 liq_ice_air_g_entropy_si, wa_si, t_si, p_si
real*8 t_freeze, icl

liq_ice_air_g_entropy_si = errorreturn

if(wa_si < 0d0 .or. wa_si > 1d0) return
if(t_si < 0d0) return
if(p_si < 0d0) return

if(wa_si==1d0) then
    liq_ice_air_g_entropy_si = air_g_entropy_si(wa_si, t_si, p_si)
    return
endif

if(set_liq_ice_air_eq_at_p(p_si) /= errorreturn) then
    !Above or at triple point
    t_freeze=liq_ice_air_temperature_si()
    if(t_freeze==errorreturn) return

    if(t_si<t_freeze) then
        icl = ice_air_icl_si(wa_si,t_si,p_si)
        if(icl==errorreturn.or.(icl/=errorreturn.and.icl<p_si)) then
            liq_ice_air_g_entropy_si=air_g_entropy_si(wa_si, t_si, p_si)
        else
            liq_ice_air_g_entropy_si=ice_air_g_entropy_si(wa_si, t_si, p_si)
        endif
    elseif(t_si>t_freeze) then
        icl = liq_air_icl_si(wa_si,t_si,p_si)
        if(icl==errorreturn.or.(icl/=errorreturn.and.icl<p_si)) then
            liq_ice_air_g_entropy_si=air_g_entropy_si(wa_si, t_si, p_si)
        else
            liq_ice_air_g_entropy_si=liq_air_g_entropy_si(wa_si, t_si, p_si)
        endif
    else
        !at freezing point
        liq_ice_air_g_entropy_si=liq_ice_air_entropy_si()
    endif
else
    !Below triple point
    icl = ice_air_icl_si(wa_si,t_si,p_si)
    if(icl==errorreturn.or.(icl/=errorreturn.and.icl<p_si)) then
        liq_ice_air_g_entropy_si=air_g_entropy_si(wa_si, t_si, p_si)
    else
        liq_ice_air_g_entropy_si=ice_air_g_entropy_si(wa_si, t_si, p_si)
    endif
endif

end function

function liq_ice_air_g_density_si(a_si, t_si, p_si)
!THIS FUNCTION COMPUTES THE ENTROPY OF AIR AT FIXED PRESSURE AND FIXED DRY AIR MASS FRACTION.

!OUTPUT:
!D(A,T,P) = 1/(DG/DP)  DENSITY OF MOIST (LIQ-VAP-AIR OR ICE-VAP-AIR OR VAP-AIR) AIR IN KG/M3

!INPUTS:
!A_SI      ABSOLUTE DRY-AIR MASS FRACTION IN KG/KG
!T_SI      ABSOLUTE IN-SITU TEMPERATURE IN K
!P_SI      ABSOLUTE IN-SITU PRESSURE IN PA

real*8 liq_ice_air_g_density_si, a_si, t_si, p_si
real*8 t_freeze, icl

liq_ice_air_g_density_si = errorreturn

if(a_si < 0d0 .or. a_si > 1d0) return
if(t_si < 0d0) return
if(p_si < 0d0) return

if(a_si==1d0) then
    liq_ice_air_g_density_si = air_g_density_si(a_si, t_si, p_si)
    return
endif

if(set_liq_ice_air_eq_at_p(p_si) /= errorreturn) then
    !Above or at triple point
    t_freeze=liq_ice_air_temperature_si()
    if(t_freeze==errorreturn) return

    if(t_si<t_freeze) then
        icl = ice_air_icl_si(a_si,t_si,p_si)
        if(icl==errorreturn.or.(icl/=errorreturn.and.icl<p_si)) then
            liq_ice_air_g_density_si=air_g_density_si(a_si, t_si, p_si)
        else
            liq_ice_air_g_density_si=ice_air_g_density_si(a_si, t_si, p_si)
        endif
    elseif(t_si>t_freeze) then
        icl = liq_air_icl_si(a_si,t_si,p_si)
        if(icl==errorreturn.or.(icl/=errorreturn.and.icl<p_si)) then
            liq_ice_air_g_density_si=air_g_density_si(a_si, t_si, p_si)
        else
            liq_ice_air_g_density_si=liq_air_g_density_si(a_si, t_si, p_si)
        endif
    else
        liq_ice_air_g_density_si=liq_ice_air_density_si()
    endif
else
    !Below triple point
    icl = ice_air_icl_si(a_si,t_si,p_si)
    if(icl==errorreturn.or.(icl/=errorreturn.and.icl<p_si)) then
        liq_ice_air_g_density_si=air_g_density_si(a_si, t_si, p_si)
    else
        liq_ice_air_g_density_si=ice_air_g_density_si(a_si, t_si, p_si)
    endif
endif

end function

function liq_ice_air_g_enthalpy_si(a_si, t_si, p_si)
!THIS FUNCTION COMPUTES THE ENTROPY OF AIR AT FIXED PRESSURE AND FIXED DRY AIR MASS FRACTION.

!OUTPUT:
!D(A,T,P) = 1/(DG/DP)  DENSITY OF MOIST (LIQ-VAP-AIR OR ICE-VAP-AIR OR VAP-AIR) AIR IN KG/M3

!INPUTS:
!A_SI      ABSOLUTE DRY-AIR MASS FRACTION IN KG/KG
!T_SI      ABSOLUTE IN-SITU TEMPERATURE IN K
!P_SI      ABSOLUTE IN-SITU PRESSURE IN PA

real*8 liq_ice_air_g_enthalpy_si, a_si, t_si, p_si
real*8 t_freeze, icl

liq_ice_air_g_enthalpy_si = errorreturn

if(a_si < 0d0 .or. a_si > 1d0) return
if(t_si < 0d0) return
if(p_si < 0d0) return

if(a_si==1d0) then
    liq_ice_air_g_enthalpy_si = air_g_enthalpy_si(a_si, t_si, p_si)
    return
endif

if(set_liq_ice_air_eq_at_p(p_si) == errorreturn) then
    !Above or at triple point
    t_freeze=liq_ice_air_temperature_si()
    if(t_freeze==errorreturn) return

    if(t_si<t_freeze) then
        icl = ice_air_icl_si(a_si,t_si,p_si)
        if(icl==errorreturn.or.(icl/=errorreturn.and.icl<p_si)) then
            liq_ice_air_g_enthalpy_si=air_g_enthalpy_si(a_si, t_si, p_si)
        else
            liq_ice_air_g_enthalpy_si=ice_air_g_enthalpy_si(a_si, t_si, p_si)
        endif
    elseif(t_si>t_freeze) then
        icl = liq_air_icl_si(a_si,t_si,p_si)
        if(icl==errorreturn.or.(icl/=errorreturn.and.icl<p_si)) then
            liq_ice_air_g_enthalpy_si=air_g_enthalpy_si(a_si, t_si, p_si)
        else
            liq_ice_air_g_enthalpy_si=liq_air_g_enthalpy_si(a_si, t_si, p_si)
        endif
    else
        liq_ice_air_g_enthalpy_si=liq_ice_air_enthalpy_si()
    endif
else
    icl = ice_air_icl_si(a_si,t_si,p_si)
    if(icl==errorreturn.or.(icl/=errorreturn.and.icl<p_si)) then
        liq_ice_air_g_enthalpy_si=air_g_enthalpy_si(a_si, t_si, p_si)
    else
        liq_ice_air_g_enthalpy_si=ice_air_g_enthalpy_si(a_si, t_si, p_si)
    endif
endif

end function


function liq_ice_air_g_cp_si(a_si, t_si, p_si)
!THIS FUNCTION COMPUTES THE SPECIFIC HEAT OF AIR AT FIXED PRESSURE AND FIXED DRY AIR MASS FRACTION.

!OUTPUT:
!CP(A,T,P,PR) SPECIFIC HEAT OF ICE AIR OR LIQUID AIR (J / K)

!INPUTS:
!A_SI      ABSOLUTE DRY-AIR MASS FRACTION IN KG/KG
!T_SI      ABSOLUTE IN-SITU TEMPERATURE IN K
!P_SI      ABSOLUTE IN-SITU PRESSURE IN PA
!PR_SI     REFERENCE PRESSURE IN PA

real*8 liq_ice_air_g_cp_si, a_si, t_si, p_si
real*8 t_freeze, icl

liq_ice_air_g_cp_si = errorreturn

if(a_si < 0d0 .or. a_si > 1d0) return
if(t_si < 0d0) return
if(p_si < 0d0) return

if(set_liq_ice_air_eq_at_p(p_si) == errorreturn) then
    !Above or at triple point
    t_freeze=liq_ice_air_temperature_si()
    if(t_freeze==errorreturn) return

    if(t_si<t_freeze) then
        icl = ice_air_icl_si(a_si,t_si,p_si)
        if(icl==errorreturn.or.(icl/=errorreturn.and.icl<p_si)) then
            liq_ice_air_g_cp_si=ice_air_g_cp_si(a_si, t_si, p_si)
        endif
    elseif(t_si>=t_freeze) then
        icl = liq_air_icl_si(a_si,t_si,p_si)
        if(icl==errorreturn.or.(icl/=errorreturn.and.icl<p_si)) then
            liq_ice_air_g_cp_si=liq_air_g_cp_si(a_si, t_si, p_si)
        endif
    !else
    !    !at freezing point
    !    !cp is not provided at freezing.
    !    liq_ice_air_g_cp_si=liq_ice_air_cp_si()
    endif
else
    !Below triple point
    icl = ice_air_icl_si(a_si,t_si,p_si)
    if(icl==errorreturn.or.(icl/=errorreturn.and.icl<p_si)) then
        liq_ice_air_g_cp_si=ice_air_g_cp_si(a_si, t_si, p_si)
    endif
endif

if(liq_ice_air_g_cp_si==errorreturn) then
    liq_ice_air_g_cp_si = air_g_cp_si(a_si, t_si, p_si)
endif

end function

function liq_ice_air_g_rh_wmo_si(a_si, t_si, p_si)
!THIS FUNCTION COMPUTES THE RELATIVE HUMIDITY (WMO).

!OUTPUT:
!RH(A,T,P) RELATIVE HUMIDITY WMO

!INPUTS:
!A_SI      ABSOLUTE DRY-AIR MASS FRACTION IN KG/KG
!T_SI      ABSOLUTE IN-SITU TEMPERATURE IN K
!P_SI      ABSOLUTE IN-SITU PRESSURE IN PA

real*8 liq_ice_air_g_rh_wmo_si, a_si, t_si, p_si
real*8 t_freeze, icl

liq_ice_air_g_rh_wmo_si = errorreturn

if(a_si < 0d0 .or. a_si > 1d0) return
if(t_si < 0d0) return
if(p_si < 0d0) return

if(set_liq_ice_air_eq_at_p(p_si) == errorreturn) then
    !Above or at triple point
    t_freeze=liq_ice_air_temperature_si()
    if(t_freeze==errorreturn) return

    if(t_si<t_freeze) then
        icl = ice_air_icl_si(a_si,t_si,p_si)
        if(icl==errorreturn.or.(icl/=errorreturn.and.icl<p_si)) then
            liq_ice_air_g_rh_wmo_si=ice_air_rh_wmo_from_a_si(a_si, t_si, p_si)
        else
            liq_ice_air_g_rh_wmo_si=1d0
        endif
    !elseif(t_si>t_freeze) then
    elseif(t_si>=t_freeze) then
        icl = liq_air_icl_si(a_si,t_si,p_si)
        if(icl==errorreturn.or.(icl/=errorreturn.and.icl<p_si)) then
            liq_ice_air_g_rh_wmo_si=liq_air_rh_wmo_from_a_si(a_si, t_si, p_si)
        else
            liq_ice_air_g_rh_wmo_si=1d0
        endif
    !else
        !at freezing point
        !rh_wmo is not provided at freezing.
        !liq_ice_air_g_rh_wmo_si=liq_ice_air_rh_wmo_si()
    endif
else
    !Below triple point
    icl = ice_air_icl_si(a_si,t_si,p_si)
    if(icl==errorreturn.or.(icl/=errorreturn.and.icl<p_si)) then
        liq_ice_air_g_rh_wmo_si=ice_air_rh_wmo_from_a_si(a_si, t_si, p_si)
    else
        liq_ice_air_g_rh_wmo_si=1d0
    endif
endif

end function


end module liq_ice_air_5b

module ice_air_4b

!#########################################################################

!THIS MODULE IMPLEMENTS THE GIBBS FUNCTION OF ICE AIR, I.E., OF THE COMPOSITE
!SYSTEM OF ICE AND HUMID AIR IN MUTUAL EQUILIBRIUM ("ICY AIR", E.G. CIRRUS CLOUDS)
!THEREFORE, THE AIR PROPERTIES COMPUTED HERE REFER TO SATURATED AIR.

!#########################################################################

!IMPLEMENTATION IN FORTRAN BY D.G. WRIGHT
!FOR PUBLICATION IN OCEAN SCIENCE, AS DESCRIBED IN THE PAPERS

!FEISTEL, R., WRIGHT, D.G., JACKETT, D.R., MIYAGAWA, K., REISSMANN, J.H.,
!WAGNER, W., OVERHOFF, U., GUDER, C., FEISTEL, A., MARION, G.M.:
!NUMERICAL IMPLEMENTATION AND OCEANOGRAPHIC APPLICATION OF THE THERMODYNAMIC
!POTENTIALS OF WATER, VAPOUR, ICE, SEAWATER AND AIR. PART I: BACKGROUND AND EQUATIONS. 
!OCEAN SCIENCES, 2009, IN PREPARATION.

!WRIGHT, D.G., FEISTEL, R., JACKETT, D.R., MIYAGAWA, K., REISSMANN, J.H., 
!WAGNER, W., OVERHOFF, U., GUDER, C., FEISTEL, A., MARION, G.M.:
!NUMERICAL IMPLEMENTATION AND OCEANOGRAPHIC APPLICATION OF THE THERMODYNAMIC
!POTENTIALS OF WATER, VAPOUR, ICE, SEAWATER AND AIR. PART II: THE LIBRARY ROUTINES, 
!OCEAN SCIENCES., 2009, IN PREPARATION.

!FEISTEL, R., KRETZSCHMAR, H.-J., SPAN, R., HAGEN, E., WRIGHT, D.G., HERRMANN, S.:
!THERMODYNAMIC PROPERTIES OF SEA AIR.
!OCEAN SCIENCE DISCUSSION 6(2009)2193-2325.

!#########################################################################

!THIS MODULE REQUIRES THE LIBRARY MODULES:
!     CONSTANTS_0,  FILE CONSTANTS_0.F90
!     CONVERT_0,    FILE CONVERT_0.F90
!     ICE_1,        FILE ICE_1.F90
!     AIR_3A,       FILE AIR_3A.F90
!     ICE_AIR_4A,   FILE ICE_AIR_4A.F90

!NESTED USE ASSOCIATIONS
!     MATHS_0,      FILE MATHS_0.F90
!     AIR_1,        FILE AIR_1.F90
!     FLU_1,        FILE FLU_1.F90
!     AIR_2,        FILE AIR_2.F90
!     FLU_2,        FILE FLU_2.F90
!     ICE_2,        FILE ICE_2.F90
!     AIR_3B,       FILE AIR_3B.F90
!     ICE_VAP_4,    FILE ICE_VAP_4.F90

!#########################################################################

use constants_0
use convert_0
use ice_1
use air_3a
use ice_air_4a

implicit none
private

character*16, private :: version = '8 Jun 2010'

public :: ice_air_g_si, ice_air_g_cp_si, ice_air_g_density_si, &
          ice_air_g_enthalpy_si, ice_air_g_entropy_si, &
          ice_air_g_expansion_si, ice_air_g_kappa_t_si,  &
          ice_air_g_lapserate_si, ice_air_solidfraction_si, &
          ice_air_vapourfraction_si

contains

!==========================================================================
function ice_air_g_si(drv_wa, drv_t, drv_p, wa_si, t_si, p_si)
!==========================================================================

!THIS IMPLEMENTS THE GIBBS FUNCTION OF ICE AIR COMPUTED FROM ITS HELMHOLTZ FUNCTION
!AND ITS FIRST AND SECOND DERIVATIVES WITH RESPECT TO THE AIR FRACTION WA_SI,
!THE ABSOLUTE TEMPERATURE T_SI AND THE ABSOLUTE PRESSURE P_SI

!NOTE: THIS GIBBS FUNCTION IS NOT DESIGNED FOR LIQUID OR CRITICAL AIR STATES
!NOTE: THE ACCURACY OF THIS FUNCTIONS DEPENDS ON THE ITERATION SETTINGS OF THIS MODULE

!OUTPUT: ICE_AIR_G_SI = SPECIFIC GIBBS ENERGY IN J/KG OR ITS DERIVATIVE

!G(WA,T,P) = (1-W) * GI(T,P) + W * GH(A(T,P),T,P)

!W = MASS FRACTION OF HUMID AIR IN ICE AIR, W(WA, T, P) = WA/A(T,P)
!(1-W) = SOLID MASS FRACTION OF ICE AIR
!A = SATURATED AIR MASS FRACTION OF HUMID AIR
!(1-A) = SATURATED SPECIFIC HUMIDITY OF THE HUMID-AIR COMPONENT
!GI = GIBBS FUNCTION OF ICE
!GH = GIBBS FUNCTION OF HUMID AIR

!WA_SI = ABSOLUTE DRY-AIR FRACTION IN KG/KG, I.E. THE MASS FRACTION OF DRY AIR IN ICE AIR
!T_SI  = T = ABSOLUTE TEMPERATURE IN K, ITS-90
!P_SI  = P = ABSOLUTE PRESSURE IN PA

!CHECK VALUES WITH DEFAULT SETTINGS, V1.0:
!ice_air_g_si( 0, 0, 0, 0.5, 270, 1E5) =-2595.73785825
!ice_air_g_si( 1, 0, 0, 0.5, 270, 1E5) = 2382.02354606
!ice_air_g_si( 0, 1, 0, 0.5, 270, 1E5) = 610.261631357
!ice_air_g_si( 0, 0, 1, 0.5, 270, 1E5) = 0.389737675174
!ice_air_g_si( 2, 0, 0, 0.5, 270, 1E5) = 0
!ice_air_g_si( 1, 1, 0, 0.5, 270, 1E5) =-1269.42344741
!ice_air_g_si( 1, 0, 1, 0.5, 270, 1E5) = 0.777294756075
!ice_air_g_si( 0, 2, 0, 0.5, 270, 1E5) =-7.00885819160
!ice_air_g_si( 0, 1, 1, 0.5, 270, 1E5) = 1.60133877466E-03
!ice_air_g_si( 0, 0, 2, 0.5, 270, 1E5) =-3.91271268873E-06

!CHECK VALUES WITH DEFAULT SETTINGS, V1.1:
!ice_air_g_si( 0, 0, 0, 0.5, 270, 1E5) =-2595.57166634
!ice_air_g_si( 1, 0, 0, 0.5, 270, 1E5) = 2382.35592988
!ice_air_g_si( 0, 1, 0, 0.5, 270, 1E5) = 610.264515318
!ice_air_g_si( 0, 0, 1, 0.5, 270, 1E5) = 0.389645501224
!ice_air_g_si( 2, 0, 0, 0.5, 270, 1E5) = 0
!ice_air_g_si( 1, 1, 0, 0.5, 270, 1E5) =-1269.41767949
!ice_air_g_si( 1, 0, 1, 0.5, 270, 1E5) = 0.777110408175
!ice_air_g_si( 0, 2, 0, 0.5, 270, 1E5) =-7.00810930740
!ice_air_g_si( 0, 1, 1, 0.5, 270, 1E5) = 1.60095965101E-03
!ice_air_g_si( 0, 0, 2, 0.5, 270, 1E5) =-3.91178603885E-06


real*8 ice_air_g_si, wa_si, t_si, p_si
real*8 g, a, w, d
real*8 gh, gi
real*8 gh_p, gi_p
real*8 gh_t, gi_t
real*8 gh_pp, gi_pp, gc_pp
real*8 gh_tp, gi_tp, gc_tp
real*8 gh_tt, gi_tt, gc_tt

real*8 a_p, a_t

integer drv_wa, drv_t, drv_p

ice_air_g_si = errorreturn
d = errorreturn

if(wa_si < 0d0 .or. wa_si > 1d0) return
if(t_si <= 0d0) return
if(p_si <= 0d0) return

if(drv_wa < 0) return
if(drv_t < 0 .or. drv_t > 2) return
if(drv_p < 0 .or. drv_p > 2) return

if(drv_wa > 1) then                        !G IS LINEAR IN WA_SI
  ice_air_g_si = 0d0
  return
end if

a = ice_air_massfraction_air_si(t_si, p_si)    !SATURATED AIR MASS FRACTION
if(a == errorreturn) return
if(a <= 0d0 .or. a >= 1d0) return

!NOTE: A <= WA_SI IS NECESSARY FOR VALIDITY, HOWEVER, THIS TEST MAY FAIL
!DUE TO INSUFFICIENT ACCURACY OF ESTIMATED INITIAL ITERATION VALUES
!IF THE DIFFERENCE BETWEEN A AND WA_SI IS VERY SMALL
!THEREFORE, THE FOLLOWING CHECK IS SUPPRESSED (22 JAN 2009):
!IF(A < WA_SI) RETURN

w = wa_si / a                                 !GASEOUS MASS FRACTION OF ICE AIR

if(drv_t + drv_p > 1) then
  d = a**2 * air_g_si(2, 0, 0, a, t_si, p_si) !AIR COEFFICIENT DA = A^2 * G_AA
end if

select case(drv_wa)

  case(0)

    select case(drv_t)

      case(0) 

        select case(drv_p)

          case(0)   
            gh = air_g_si(0, 0, 0, a, t_si, p_si)
            if(gh == errorreturn) return
            gi = ice_g_si(0, 0, t_si, p_si)
            if(gi == errorreturn) return
            g = (1d0 - w) * gi + w * gh                        !G

          case(1)
            gh_p = air_g_si(0, 0, 1, a, t_si, p_si)
            if(gh_p == errorreturn) return
            gi_p = ice_g_si(0, 1, t_si, p_si)
            if(gi_p == errorreturn) return
            g = (1d0 - w) * gi_p + w * gh_p                    !V = G_P

          case(2)
            a_p = ice_air_a_si(0, 1, t_si, p_si)
            if(a_p == errorreturn) return
            gc_pp = -d * a_p**2 / a                            !LATENT CONDENSATION DERIVATIVE
            gh_pp = air_g_si(0, 0, 2, a, t_si, p_si)
            if(gh_pp == errorreturn) return
            gi_pp = ice_g_si(0, 2, t_si, p_si)
            if(gi_pp == errorreturn) return
            g = (1d0 - w) * gi_pp + w * (gh_pp + gc_pp)        !G_PP

          case default; return

        end select

      case(1)     !D/DT

        select case(drv_p)

          case(0) 
            gh_t = air_g_si(0, 1, 0, a, t_si, p_si)
            if(gh_t == errorreturn) return
            gi_t = ice_g_si(1, 0, t_si, p_si)
            if(gi_t == errorreturn) return
            g = (1d0 - w) * gi_t + w * gh_t              !-ETA = G_T

          case(1) 
            a_t = ice_air_a_si(1, 0, t_si, p_si)
            if(a_t == errorreturn) return
            a_p = ice_air_a_si(0, 1, t_si, p_si)
            if(a_p == errorreturn) return
            gc_tp = -d * a_t * a_p / a                   !LATENT DERIVATIVE
            gh_tp = air_g_si(0, 1, 1, a, t_si, p_si)
            if(gh_tp == errorreturn) return
            gi_tp = ice_g_si(1, 1, t_si, p_si)
            if(gi_tp == errorreturn) return
            g = (1d0 - w) * gi_tp + w * (gh_tp + gc_tp)  !G_TP

          case default; return

        end select

      case(2)     !D2/DT2

        select case(drv_p)

          case(0)
            a_t = ice_air_a_si(1, 0, t_si, p_si)
            if(a_t == errorreturn) return
            gc_tt = -d * a_t**2 / a                      !LATENT DERIVATIVE
            gh_tt = air_g_si(0, 2, 0, a, t_si, p_si)
            if(gh_tt == errorreturn) return
            gi_tt = ice_g_si(2, 0, t_si, p_si)
            if(gi_tt == errorreturn) return
            g = (1d0 - w) * gi_tt + w * (gh_tt + gc_tt)  !G_TT

          case default; return

        end select

       case default; return

    end select

  case(1)       !g_w, g_wp, g_wt
    gh = air_g_si(0, drv_t, drv_p, a, t_si, p_si)
    if( gh == errorreturn) return
    gi = ice_g_si(drv_t, drv_p, t_si, p_si)
    if( gi == errorreturn) return
    g = (gh - gi) / a

  case(2); g = 0     !G_WW

  case default; return

end select

ice_air_g_si = g

end function

!=========================================================================
function ice_air_g_cp_si(wa_si, t_si, p_si)
!=========================================================================

!OUTPUT:
!CP(WA,T,P) = T * (D2G/DT2) HEAT CAPACITY OF ICE AIR IN J/(KG K)

!INPUTS:
!WA_SI     MASS FRACTION OF DRY AIR IN ICE AIR IN KG/KG
!T_SI      ABSOLUTE TEMPERATURE IN K
!P_SI      ABSOLUTE PRESSURE IN PA

!CHECK VALUE WITH DEFAULT SETTINGS, V1.0: 
!ice_air_g_cp_si(0.5, 270, 1E5) = 1892.39171173

!CHECK VALUE WITH DEFAULT SETTINGS, V1.1: 
!ice_air_g_cp_si(0.5, 270, 1E5) = 1892.18951300

real*8 ice_air_g_cp_si, wa_si, t_si, p_si
real*8 g_tt

ice_air_g_cp_si = errorreturn

if(wa_si < 0d0 .or. wa_si > 1d0) return
if(t_si <= 0d0) return
if(p_si <= 0d0) return

g_tt = ice_air_g_si(0, 2, 0, wa_si, t_si, p_si)
if(g_tt == errorreturn) return

ice_air_g_cp_si = -t_si * g_tt

end function

!=========================================================================
function ice_air_g_density_si(wa_si, t_si, p_si)
!=========================================================================

!OUTPUT:
!D(WA,T,P) = 1/(DG/DP)_T  DENSITY OF ICE AIR IN KG/M3

!INPUTS:
!WA_SI     MASS FRACTION OF DRY AIR IN ICE AIR IN KG/KG
!T_SI      ABSOLUTE TEMPERATURE IN K
!P_SI      ABSOLUTE PRESSURE IN PA

!CHECK VALUE WITH DEFAULT SETTINGS, V1.0: 
!ice_air_g_density_si(0.5, 270, 1E5) = 2.56582841152

!CHECK VALUE WITH DEFAULT SETTINGS, V1.1: 
!ice_air_g_density_si(0.5, 270, 1E5) = 2.56643538000

real*8 ice_air_g_density_si, wa_si, t_si, p_si
real*8 g_p

ice_air_g_density_si = errorreturn

if(wa_si < 0d0 .or. wa_si > 1d0) return
if(t_si <= 0d0) return
if(p_si <= 0d0) return

g_p = ice_air_g_si(0, 0, 1, wa_si, t_si, p_si)
if(g_p == errorreturn) return
if(g_p <= 0d0) return

ice_air_g_density_si = 1d0 / g_p

end function

!=========================================================================
function ice_air_g_enthalpy_si(wa_si, t_si, p_si)
!=========================================================================

!OUTPUT:
!H(WA,T,P) = G - T * (DG/DT)  ENTHALPY OF ICE AIR IN J/KG

!INPUTS:
!WA_SI     MASS FRACTION OF DRY AIR IN ICE AIR IN KG/KG
!T_SI      ABSOLUTE TEMPERATURE IN K
!P_SI      ABSOLUTE PRESSURE IN PA

!CHECK VALUE WITH DEFAULT SETTINGS, V1.0: 
!ice_air_g_enthalpy_si(0.5, 270, 1E5) = -167366.378325

!CHECK VALUE WITH DEFAULT SETTINGS, V1.1: 
!ice_air_g_enthalpy_si(0.5, 270, 1E5) = -167366.990802

real*8 ice_air_g_enthalpy_si, wa_si, t_si, p_si
real*8 g, g_t

ice_air_g_enthalpy_si = errorreturn

if(wa_si < 0d0 .or. wa_si > 1d0) return
if(t_si <= 0d0) return
if(p_si <= 0d0) return

g = ice_air_g_si(0, 0, 0, wa_si, t_si, p_si)
if(g == errorreturn) return
g_t = ice_air_g_si(0, 1, 0, wa_si, t_si, p_si)
if(g_t == errorreturn) return

ice_air_g_enthalpy_si = g - t_si * g_t

end function

!=========================================================================
function ice_air_g_entropy_si(wa_si, t_si, p_si)
!=========================================================================

!OUTPUT:
!ETA(WA,T,P) = - (DG/DT)  ENTROPY OF ICE AIR IN J/(KG K)

!INPUTS:
!WA_SI     MASS FRACTION OF DRY AIR IN ICE AIR IN KG/KG
!T_SI      ABSOLUTE TEMPERATURE IN K
!P_SI      ABSOLUTE PRESSURE IN PA

!CHECK VALUE WITH DEFAULT SETTINGS, V1.0: 
!ice_air_g_entropy_si(0.5, 270, 1E5) = -610.261631357

!CHECK VALUE WITH DEFAULT SETTINGS, V1.1: 
!ice_air_g_entropy_si(0.5, 270, 1E5) = -610.264515318

real*8 ice_air_g_entropy_si, wa_si, t_si, p_si
real*8 g_t

ice_air_g_entropy_si = errorreturn

if(wa_si < 0d0 .or. wa_si > 1d0) return
if(t_si <= 0) return
if(p_si <= 0) return

g_t = ice_air_g_si(0, 1, 0, wa_si, t_si, p_si)
if(g_t == errorreturn) return

ice_air_g_entropy_si = -g_t

end function

!=========================================================================
function ice_air_g_expansion_si(wa_si, t_si, p_si)
!=========================================================================

!OUTPUT:
!ALPHAI(WA,T,P) = (D2G/DTDP)/(DG/DP)_T  THERMAL EXPANSION OF ICE AIR IN 1/K

!INPUTS:
!WA_SI     MASS FRACTION OF DRY AIR IN ICE AIR IN KG/KG
!T_SI      ABSOLUTE TEMPERATURE IN K
!P_SI      ABSOLUTE PRESSURE IN PA

!CHECK VALUE WITH DEFAULT SETTINGS, V1.0: 
!ice_air_g_expansion_si(0.5, 270, 1E5) = 4.10876052449E-03

!CHECK VALUE WITH DEFAULT SETTINGS, V1.1: 
!ice_air_g_expansion_si(0.5, 270, 1E5) = 4.10875949031E-03

real*8 ice_air_g_expansion_si, wa_si, t_si, p_si
real*8 g_p, g_tp

ice_air_g_expansion_si = errorreturn

if(wa_si < 0d0 .or. wa_si > 1d0) return
if(t_si <= 0d0) return
if(p_si <= 0d0) return

g_p = ice_air_g_si(0, 0, 1, wa_si, t_si, p_si)
if(g_p == errorreturn) return
if(g_p <= 0d0) return
g_tp = ice_air_g_si(0, 1, 1, wa_si, t_si, p_si)
if(g_tp == errorreturn) return

ice_air_g_expansion_si = g_tp / g_p

end function

!=========================================================================
function ice_air_g_kappa_t_si(wa_si, t_si, p_si)
!=========================================================================

!OUTPUT:
!KAPPA_T(WA,T,P) = - (D2G/DP2)/(DG/DP)_T  ISOTHERMAL COMPRESSIBILITY OF ICE AIR IN 1/PA

!INPUTS:
!WA_SI     MASS FRACTION OF DRY AIR IN ICE AIR IN KG/KG
!T_SI      ABSOLUTE TEMPERATURE IN K
!P_SI      ABSOLUTE PRESSURE IN PA

!CHECK VALUE WITH DEFAULT SETTINGS, V1.0: 
!ice_air_g_kappa_t_si(0.5, 270, 1E5) = 1.00393493829E-05

!CHECK VALUE WITH DEFAULT SETTINGS, V1.1: 
!ice_air_g_kappa_t_si(0.5, 270, 1E5) = 1.00393460891E-05

real*8 ice_air_g_kappa_t_si, wa_si, t_si, p_si
real*8 g_p, g_pp

ice_air_g_kappa_t_si = errorreturn

if(wa_si < 0d0 .or. wa_si > 1d0) return
if(t_si <= 0d0) return
if(p_si <= 0d0) return

g_p = ice_air_g_si(0, 0, 1, wa_si, t_si, p_si)
if(g_p == errorreturn) return
if(g_p <= 0d0) return
g_pp = ice_air_g_si(0, 0, 2, wa_si, t_si, p_si)
if(g_pp == errorreturn) return

ice_air_g_kappa_t_si = -g_pp / g_p

end function

!=========================================================================
function ice_air_g_lapserate_si(wa_si, t_si, p_si)
!=========================================================================

!OUTPUT:
!GAMMA(WA,T,P) = - (D2G/DTDP)/(D2G/DT2)_P "MOIST" ADIABATIC LAPSE RATE OF ICE AIR IN K/PA

!INPUTS:
!WA_SI     MASS FRACTION OF DRY AIR IN ICE AIR IN KG/KG
!T_SI      ABSOLUTE TEMPERATURE IN K
!P_SI      ABSOLUTE PRESSURE IN PA

!CHECK VALUE WITH DEFAULT SETTINGS, V1.0: 
!ice_air_g_lapserate_si(0.5, 270, 1E5) = 2.28473558871E-04

!CHECK VALUE WITH DEFAULT SETTINGS, V1.1: 
!ice_air_g_lapserate_si(0.5, 270, 1E5) = 2.28443875629E-04

real*8 ice_air_g_lapserate_si, wa_si, t_si, p_si
real*8 g_tp, g_tt

ice_air_g_lapserate_si = errorreturn

if(wa_si < 0d0 .or. wa_si > 1d0) return
if(t_si <= 0d0) return
if(p_si <= 0d0) return

g_tp = ice_air_g_si(0, 1, 1, wa_si, t_si, p_si)
if(g_tp == errorreturn) return
if(g_tp <= 0d0) return
g_tt = ice_air_g_si(0, 2, 0, wa_si, t_si, p_si)
if(g_tt == errorreturn) return
if(g_tt >= 0d0) return

ice_air_g_lapserate_si = -g_tp / g_tt

end function

!=========================================================================
function ice_air_solidfraction_si(wa_si, t_si, p_si)
!=========================================================================

!OUTPUT:
!1 - W(WA, T, P) = 1 - WA/A(T,P) MASS FRACTION OF SOLID WATER IN ICE AIR (0 < W < 1)

!INPUTS:
!WA_SI     DRY AIR MASS FRACTION OF ICE AIR IN KG/KG
!T_SI      ABSOLUTE TEMPERATURE IN K
!P_SI      ABSOLUTE PRESSURE IN PA

!CHECK VALUE WITH DEFAULT SETTINGS, V1.0: 
!ice_air_solidfraction_si(0.5, 270, 1E5) = 0.498524741260

!CHECK VALUE WITH DEFAULT SETTINGS, V1.1: 
!ice_air_solidfraction_si(0.5, 270, 1E5) = 0.498525089434

real*8 ice_air_solidfraction_si, wa_si, t_si, p_si
real*8 a

ice_air_solidfraction_si = errorreturn

if(wa_si < 0d0 .or. wa_si > 1d0) return
if(t_si <= 0d0) return
if(p_si <= 0d0) return

a = ice_air_massfraction_air_si(t_si, p_si)
if(a == errorreturn) return
if(a < wa_si) return

ice_air_solidfraction_si = 1d0 - wa_si / a

end function

!=========================================================================
function ice_air_vapourfraction_si(wa_si, t_si, p_si)
!=========================================================================

!OUTPUT:
!WV = WA*/(1/A(T,P)-1) MASS FRACTION OF VAPOUR IN ICE AIR (0 < W < 1)

!INPUTS:
!WA_SI     DRY-AIR MASS FRACTION OF ICE AIR IN KG/KG
!T_SI      ABSOLUTE TEMPERATURE IN K
!P_SI      ABSOLUTE PRESSURE IN PA

!CHECK VALUE WITH DEFAULT SETTINGS, V1.0: 
!ice_air_vapourfraction_si(0.5, 270, 1E5) = 1.47525873976E-03

!CHECK VALUE WITH DEFAULT SETTINGS, V1.1: 
!ice_air_vapourfraction_si(0.5, 270, 1E5) = 1.47491056602E-03

real*8 ice_air_vapourfraction_si, wa_si, t_si, p_si
real*8 a

ice_air_vapourfraction_si = errorreturn

if(wa_si < 0d0 .or. wa_si > 1d0) return
if(t_si <= 0d0) return
if(p_si <= 0d0) return

a = ice_air_massfraction_air_si(t_si, p_si)
if(a == errorreturn) return
if(a < wa_si) return

ice_air_vapourfraction_si = wa_si * (1d0 / a - 1d0)

end function

!=========================================================================
function ice_air_a_si(drv_t, drv_p, t_si, p_si)
!=========================================================================

!THIS FUNCTION RETURNS THE AIR FRACTION A OF SATURATED HUMID AIR IN KG/KG,
!AND ITS PARTIAL DERIVATIVES (D/DT)^DRV_T (D/DP)^DRV_P A(T,P)
!AS A FUNCTION OF ABSOLUTE TEMPERATURE, T_SI, IN K, AND ABSOLUTE PRESSURE, P_SI, IN PA

real*8 ice_air_a_si, t_si, p_si
real*8 d  !da coefficient
real*8 a  !air fraction

real*8 gh_p, gi_p, gh_ap
real*8 gh_t, gi_t, gh_at

integer drv_t, drv_p

ice_air_a_si = errorreturn
d = errorreturn

if(drv_t < 0 .or. drv_t > 1) return
if(drv_p < 0 .or. drv_p > 1) return

if(t_si < 0) return
if(p_si < 0) return

a = ice_air_massfraction_air_si(t_si, p_si)
if(a == errorreturn) return
if(a < 0d0 .or. a >= 1d0) return

if(drv_t > 0 .or. drv_p > 0) then
  d = a**2 * air_g_si(2, 0, 0, a, t_si, p_si) !air coefficient da = a^2 * g_aa
  if(d == errorreturn) return
  if(d <= 0) return
end if

select case(drv_t)

  case(0)

    select case(drv_p)

      case(0) 
        ice_air_a_si = a

      case(1)
        gh_p = air_g_si(0, 0, 1, a, t_si, p_si)
        if(gh_p == errorreturn) return
        gh_ap = air_g_si(1, 0, 1, a, t_si, p_si)
        if(gh_ap == errorreturn) return
        gi_p = ice_g_si(0, 1, t_si, p_si)
        if(gi_p == errorreturn) return
        ice_air_a_si = a * (gh_p - gi_p - a * gh_ap) / d

    end select

  case(1)

    select case(drv_p)

      case(0)
        gh_t = air_g_si(0, 1, 0, a, t_si, p_si)
        if(gh_t == errorreturn) return
        gh_at = air_g_si(1, 1, 0, a, t_si, p_si)
        if(gh_at == errorreturn) return
        gi_t = ice_g_si(1, 0, t_si, p_si)
        if(gi_t == errorreturn) return
        ice_air_a_si = a * (gh_t - gi_t - a * gh_at) / d

    end select

end select

end function

end module ice_air_4b

module convert_0

!#########################################################################

!THIS MODULE IMPLEMENTS CONVERSION BETWEEN MASS FRACTIONS AND MOLE FRACTIONS
!AND PROVIDES A CONVERSION FROM PRACTICAL SALINITY TO ABSOLUTE SALINITY

!#########################################################################

!IMPLEMENTATION IN FORTRAN BY D.G. WRIGHT
!FOR PUBLICATION IN OCEAN SCIENCE, AS DESCRIBED IN THE PAPERS

!FEISTEL, R., WRIGHT, D.G., JACKETT, D.R., MIYAGAWA, K., REISSMANN, J.H.,
!WAGNER, W., OVERHOFF, U., GUDER, C., FEISTEL, A., MARION, G.M.:
!NUMERICAL IMPLEMENTATION AND OCEANOGRAPHIC APPLICATION OF THE THERMODYNAMIC
!POTENTIALS OF WATER, VAPOUR, ICE, SEAWATER AND AIR. PART I: BACKGROUND AND EQUATIONS. 
!OCEAN SCIENCES, 2009, IN PREPARATION.

!WRIGHT, D.G., FEISTEL, R., JACKETT, D.R., MIYAGAWA, K., REISSMANN, J.H., 
!WAGNER, W., OVERHOFF, U., GUDER, C., FEISTEL, A., MARION, G.M.:
!NUMERICAL IMPLEMENTATION AND OCEANOGRAPHIC APPLICATION OF THE THERMODYNAMIC
!POTENTIALS OF WATER, VAPOUR, ICE, SEAWATER AND AIR. PART II: THE LIBRARY ROUTINES, 
!OCEAN SCIENCES., 2009, IN PREPARATION.

!FEISTEL, R., KRETZSCHMAR, H.-J., SPAN, R., HAGEN, E., !WRIGHT, D.G., JACKETT, D.R.:
!THERMODYNAMIC PROPERTIES OF SEA AIR.
!OCEAN SCIENCE DISCUSSION 6(2009)2193-2325.

!#########################################################################

!THIS MODULE REQUIRES THE LIBRARY MODULES
!     CONSTANTS_0, FILE CONSTANTS_0.F90

!#########################################################################

use constants_0

implicit none
private

character*16, private :: version = '28th June 2011'

public :: air_massfraction_air_si, air_massfraction_vap_si, &
          air_molar_mass_si, air_molfraction_air_si, &
          air_molfraction_vap_si, sa_from_sp, sp_from_sa

real*8 ::  mw = molar_mass_h2o_si      !MOLAR MASS OF H2O IN KG/MOL
real*8 ::  ma = molar_mass_air_L2000   !MOLAR MASS OF AIR IN KG/MOL USED BY LEMMON et al. 2000
integer :: flag_saar



contains

!==========================================================================
function air_molar_mass_si(a_si)
!==========================================================================

!OUTPUT:  
!air_molar_mass_si = MOLAR MASS OF HUMID AIR IN KG MOL-1

!INPUT:  
!A_SI = AIR MASS FRACTION, IN KG/KG

!CHECK VALUE: air_molar_mass_si(0.5) = 2.22122197774E-02
integer, parameter :: r14 = selected_real_kind(14,30)

real (r14) :: air_molar_mass_si, a_si

air_molar_mass_si = errorreturn

if (a_si < 0d0 .or. a_si > 1d0) return

air_molar_mass_si = 1d0 / ((1d0 - a_si) / mw + a_si / ma)

return
end function

!==========================================================================
function air_molfraction_vap_si(a_si)
!==========================================================================

!OUTPUT: 
!MOLE FRACTION OF VAPOUR IN HUMID AIR IN MOL MOL-1

!INPUT: 
!A_SI = AIR MASS FRACTION, IN KG/KG

!CHECK VALUE: air_molfraction_vap_si(0.5) = 0.616483190186

integer, parameter :: r14 = selected_real_kind(14,30)

real (r14) :: air_molfraction_vap_si, a_si

air_molfraction_vap_si = errorreturn

if (a_si < 0d0 .or. a_si > 1d0) return

air_molfraction_vap_si = (1d0 - a_si) / (1d0 - a_si * (1d0 - mw / ma))

return
end function

!==========================================================================
function air_molfraction_air_si(a_si)
!==========================================================================

!OUTPUT: 
!MOLE FRACTION OF DRY AIR IN HUMID AIR IN MOL MOL-1

!INPUT: 
!A_SI = AIR MASS FRACTION, IN KG/KG

!CHECK VALUE: air_molfraction_air_si(0.5) = 0.383516809814

integer, parameter :: r14 = selected_real_kind(14,30)

real (r14) :: air_molfraction_air_si, a_si

air_molfraction_air_si = errorreturn

if (a_si < 0d0 .or. a_si > 1d0) return

air_molfraction_air_si = (a_si * mw / ma) / (1d0 - a_si * (1d0 - mw / ma))

return
end function

!==========================================================================
function air_massfraction_air_si(x_si)
!==========================================================================

!OUTPUT: 
!A_SI = MASS FRACTION OF AIR IN HUMID AIR IN KG/KG

!INPUT: 
!X_SI = MOLE FRACTION OF AIR IN HUMID AIR IN MOL/MOL

!CHECK VALUE: air_massfraction_air_si(0.5) = 0.616483190186

integer, parameter :: r14 = selected_real_kind(14,30)

real (r14):: air_massfraction_air_si, x_si

air_massfraction_air_si = errorreturn

if (x_si < 0d0 .or. x_si > 1d0) return

air_massfraction_air_si = x_si / (x_si + (1d0 - x_si) * mw / ma)

return
end function

!==========================================================================
function air_massfraction_vap_si(x_si)
!==========================================================================

!OUTPUT: 
!AIR_MASSFRACTION_VAP_SI = MASS FRACTION OF VAPOUR IN HUMID AIR IN KG/KG

!INPUT: 
!X_SI = DRY AIR MOLE FRACTION, IN MOL MOL-1

!CHECK VALUE: air_massfraction_vap_si(0.5) = 0.383516809814

integer, parameter :: r14 = selected_real_kind(14,30)

real (r14):: air_massfraction_vap_si, x_si

air_massfraction_vap_si = errorreturn

if (x_si < 0d0 .or. x_si > 1d0) return

air_massfraction_vap_si = (1d0 - x_si) / (1d0 - x_si * (1d0 - ma / mw))

return
end function


!=====================================================
function sa_from_sp(sp_si,lon0,lat0,p_si)
!=====================================================

! CONVERT PRACTICAL SALINITY TO ABSOLUTE SALINITY 
!
! SP                  : PRACTICAL SALINITY                 [PSU]
! P_SI                : ABSOLUTE PRESSURE                  [PA]
! LONGS0              : LONGITUDE                          [DEG E]     
! LATS0               : LATITUDE                           [DEG N]
!
! RESULT              : ABSOLUTE SALINITY                  [KG/KG]
!
!CHECK VALUE:
!ASAL_FROM_PSAL(0.0357, 201, -21, 101325+1023d4) = 0.035873322343341172
!ASAL_FROM_PSAL(0.035, 180, 40, 101325 + 2d7) =   0.035189093288995807  !NORTH PACIFIC SILICATE
!ASAL_FROM_PSAL(0.008, 20, 57, 101325) =     0.0081048377142857131      !CENTRAL BALTIC SEA

implicit none
integer, parameter :: r14 = selected_real_kind(14,30)

real (r14) :: sa0, sp_si, sp0, lon0, lat0, p_si, p0
real (r14) :: sa_from_sp

p0 = (p_si - 101325d0)/1d4
sp0 = sp_si*1d3
sa0 = gsw_sa_from_sp(sp0,p0,lon0,lat0)
sa_from_sp = sa0*1d-3

return
end function


!=====================================================
function sp_from_sa(p_si,sa_si,lon0,lat0)
!=====================================================

! CONVERT ABSOLUTE SALINITY TO PRACTICAL SALINITY 
!
! SA_SI               : ABSOLUTE SALINITY                  [KG/KG]
! P_SI                : ABSOLUTE PRESSURE                  [PA]
! LONGS0              : LONGITUDE                          [DEG E]     
! LATS0               : LATITUDE                           [DEG N]
!
! PSAL_FROM_ASAL  : PRACTICAL SALINITY                     [PSU]

!CHECK VALUE
!PSAL_FROM_ASAL(0.035873322343341172, 201, -21, 101325+1023d4) =   0.035700000000000010

implicit none
integer, parameter :: r14 = selected_real_kind(14,30)

real (r14) :: sp0, sa_si, sa0, lon0, lat0, p_si, p0
real (r14) :: sp_from_sa

p0 = (p_si - 101325d0)/1d4
sa0 = sa_si*1d3
sp0 = gsw_sp_from_sa(sa0,p0,lon0,lat0)
sp_from_sa = sp0*1d-3

return
end function

!=====================================================
function sstar_from_sp(sp_si,p_si,lon0,lat0)
!=====================================================

! CONVERT PRACTICAL SALINITY TO PREFORMED SALINITY 
!
! SP_SI               : PRACTICAL SALINITY                 [PSU]
! P_SI                : ABSOLUTE PRESSURE                  [PA]
! LONGS0              : LONGITUDE                          [DEG E]     
! LATS0               : LATITUDE                           [DEG N]
!
! SSTAR_FROM_SP       : PREFORMED SALINITY                 [PSU]

implicit none
integer, parameter :: r14 = selected_real_kind(14,30)

real (r14) :: sp_si, sp0, lon0, lat0, p_si, p0, sstar0, sstar_from_sp

p0 = (p_si - 101325d0)/1d4
sp0 = sp_si*1d3
sstar0 = gsw_sstar_from_sp(sp0,p0,lon0,lat0)
sstar_from_sp = sstar0*1d-3

return
end function

!=====================================================
function deltasa_from_sp(sp_si,p_si,lon0,lat0)
!=====================================================

! CONVERT PRACTICAL SALINITY TO ABSOLUTE SALINITY ANOMALY 
!
! SP_SI               : PRACTICAL SALINITY                 [PSU]
! P_SI                : ABSOLUTE PRESSURE                  [PA]
! LONGS0              : LONGITUDE                          [DEG E]     
! LATS0               : LATITUDE                           [DEG N]
!
! DELTASA_FROM_SP     : ABSOLUTE SALINITY ANOMALY          [KG/KG]

implicit none
integer, parameter :: r14 = selected_real_kind(14,30)

real (r14) :: sp_si, sp0, lon0, lat0, p_si, p0, deltasa0, deltasa_from_sp

p0 = (p_si - 101325d0)/1d4
sp0 = sp_si*1d3
deltasa0 = gsw_deltasa_from_sp(sp0,p0,lon0,lat0)
deltasa_from_sp = deltasa0*1d-3

return
end function

!=====================================================
function sr_from_sp(sp_si)
!=====================================================

! CONVERT PRACTICAL SALINITY TO ABSOLUTE SALINITY ANOMALY 
!
! SP_SI               : PRACTICAL SALINITY                 [PSU]
!
! SR_SI               : PREFORMED SALINITY                 [KG/KG]

implicit none
integer, parameter :: r14 = selected_real_kind(14,30)

real (r14) :: sp_si, sp0, sr0, sr_from_sp

sp0 = sp_si*1d3
sr0 = gsw_sr_from_sp(sp0)
sr_from_sp = sr0*1d-3

return
end function

!=====================================================
function sstar_from_sa(sa_si,p_si,lon0,lat0)
!=====================================================

! CONVERT ABSOLUTE SALINITY TO PREFORMED SALINITY 
!
! SA_SI               : ABSOLUTE SALINITY                  [KG/KG]
! P_SI                : ABSOLUTE PRESSURE                  [PA]
! LONGS0              : LONGITUDE                          [DEG E]     
! LATS0               : LATITUDE                           [DEG N]
!
! SSTAR_FROM_SA       : PREFORMED SALINITY                 [KG/KG]

implicit none
integer, parameter :: r14 = selected_real_kind(14,30)

real (r14) :: sa_si, sa0, lon0, lat0, p_si, p0, sstar0, sstar_from_sa

p0 = (p_si - 101325d0)/1d4
sa0 = sa_si*1d3
sstar0 = gsw_sstar_from_sa(sa0,p0,lon0,lat0)
sstar_from_sa = sstar0*1d-3

return
end function


!=====================================================
function sp_from_sstar(sstar_si,p_si,lon0,lat0)
!=====================================================

! CONVERT PREFORMED SALINITY TO PRACTICAL SALINITY
!
! SP_SI               : PREFORMED SALINITY                 [PSU]
! P_SI                : ABSOLUTE PRESSURE                  [PA]
! LONGS0              : LONGITUDE                          [DEG E]     
! LATS0               : LATITUDE                           [DEG N]
!
! SP_FROM_SSTAR       : PRACTICAL SALINITY                 [PSU]

implicit none
integer, parameter :: r14 = selected_real_kind(14,30)

real (r14) :: sstar_si, sp0, lon0, lat0, p_si, p0, sstar0, sp_from_sstar

p0 = (p_si - 101325d0)/1d4
sstar0 = sstar_si*1d3
sp0 = gsw_sp_from_sstar(sstar0,p0,lon0,lat0)
sp_from_sstar = sp0*1d-3

return
end function

!=====================================================
function sa_from_sstar(sstar_si,p_si,lon0,lat0)
!=====================================================

! CONVERT PREFORMED SALINITY TO PRACTICAL SALINITY
!
! SP_SI               : PREFORMED SALINITY                 [PSU]
! P_SI                : ABSOLUTE PRESSURE                  [PA]
! LONGS0              : LONGITUDE                          [DEG E]     
! LATS0               : LATITUDE                           [DEG N]
!
! SP_FROM_SSTAR       : ABSOLUTE SALINITY                  [KG/KG]

implicit none
integer, parameter :: r14 = selected_real_kind(14,30)

real (r14) :: sstar_si, sa0, lon0, lat0, p_si, p0, sstar0, sa_from_sstar

p0 = (p_si - 101325d0)/1d4
sstar0 = sstar_si*1d3
sa0 = gsw_sa_from_sstar(sstar0,p0,lon0,lat0)
sa_from_sstar = sa0*1d-3

return
end function

!=====================================================
function saar(p_si,lon0,lat0)
!=====================================================

! CALCULATE THE ABSOLUTE SALINITY ANOMALY RATIO
!
! P_SI                : ABSOLUTE PRESSURE                  [PA]
! LONGS0              : LONGITUDE                          [DEG E]     
! LATS0               : LATITUDE                           [DEG N]
!
! SAAR                : ABSOLUTE SALINITY ANOMALY RATIO    [UNITLESS]

implicit none
integer, parameter :: r14 = selected_real_kind(14,30)

real (r14) :: lon0, lat0, p_si, p0, saar0, saar

p0 = (p_si - 101325d0)/1d4
saar0 = gsw_saar(p0,lon0,lat0)
saar = saar0*1d-3

return
end function

!=====================================================
function delta_sa_ref(p_si,lon0,lat0)
!=====================================================

! CALCULATE THE ABSOLUTE SALINITY ANOMALY REFERENCE VALUE
!
! P_SI                : ABSOLUTE PRESSURE                  [PA]
! LONGS0              : LONGITUDE                          [DEG E]     
! LATS0               : LATITUDE                           [DEG N]
!
! DELTA_SA_REF        : ABSOLUTE SALINITY ANOMALY REF. VALUE  [KG/KG]

implicit none
integer, parameter :: r14 = selected_real_kind(14,30)

real (r14) :: lon0, lat0, p_si, p0, delta_sa_ref0, delta_sa_ref

p0 = (p_si - 101325d0)/1d4
delta_sa_ref0 = gsw_delta_sa_ref(p0,lon0,lat0)
delta_sa_ref = delta_sa_ref0*1d-3

return
end function


!=====================================================
function fdelta(p_si,lon0,lat0)
!=====================================================

! CALCULATE THE RATIO OF ABSOLUTE SALINITY TO PREFORMED SALINITY MINUS 1
!
! P_SI                : ABSOLUTE PRESSURE                  [PA]
! LONGS0              : LONGITUDE                          [DEG E]     
! LATS0               : LATITUDE                           [DEG N]
!
! DELTA_SA_REF        : RATIO OF SA TO SSTAR MINUS 1       [UNITLESS]

implicit none
integer, parameter :: r14 = selected_real_kind(14,30)

real (r14) :: lon0, lat0, p_si, p0, Fdelta0, Fdelta

p0 = (p_si - 101325d0)/1d4
fdelta0 = gsw_fdelta(p0,lon0,lat0)
fdelta = fdelta0*1d-3

return
end function


!==========================================================================
!==========================================================================
!==========================================================================
! THIS IS THE GSW ABSOLUTE SALINITY ALGORITHM IMPLEMENTED IN FORTRAN
!==========================================================================
!==========================================================================
!==========================================================================
!
! AS DEFINED IN 
!
! MCDOUGALL, T.J., JACKETT, D.R. AND MILLERO, F.J., 2009: AN ALGORITHM FOR ESTIMATING  
!            ABSOLUTE SALINITY IN THE GLOBAL OCEAN, OCEAN SCIENCE, SUBMITTED.  
!     
! 	
! DAVID JACKETT
! JANUARY 2009
!

!==========================================================================
! Gibbs SeaWater (GSW) Oceanographic Toolbox of TEOS-10 version 3.0 (Fortran)
!==========================================================================
!
! This is the salinity functions contained in the Gibbs SeaWater (GSW) 
! Oceanographic Toolbox of TEOS-10 (version 3.0).
! 
!
! salinity conversions
! gsw_sa_from_sp          - Absolute Salinity from Practical Salinity
! gsw_sstar_from_sp       - Preformed Salinity from Practical Salinity
!
! gsw_deltasa_from_sp     - Absolute Salinity Anomaly from Practical Salinity
! gsw_sr_from_sp          - Reference Salinity from Practical Salinity
! gsw_sp_from_sr          - Practical Salinity from Reference Salinity
! gsw_sp_from_sa          - Practical Salinity from Absolute Salinity
! gsw_sstar_from_sa       - Preformed Salinity from Absolute Salinity
! gsw_sp_from_sstar       - Practical Salinity from Preformed Salinity
! gsw_sa_from_sstar       - Absolute Salinity from Preformed Salinity
!
! Library functions of the GSW toolbox
! gsw_saar                - Absolute Salinity Anomaly Ratio (excluding the Baltic Sea)
! gsw_delta_sa_ref        - Absolute Salinity Anomaly ref. value (excluding the Baltic Sea)
! gsw_fdelta              - ratio of Absolute to Preformed Salinity, minus 1
! gsw_sa_from_sp_baltic   - Absolute Salinity Anomaly from Practical Salinity in the Baltic Sea
! gsw_sp_from_sa_baltic   - Practical Salinity from Absolute Salinity in the Baltic Sea
!
!
! Version 1.0 written by David Jackett
! Modified by Paul Barker (version 3.0)
!
! For help with this Oceanographic Toolbox email:- help_gsw@csiro.au
!
! This software is available from http://www.teos-10.org
!
!==========================================================================

!--------------------------------------------------------------------------
! salinity conversions
!--------------------------------------------------------------------------

!==========================================================================
function gsw_sa_from_sp(sp,p,long,lat)
!==========================================================================

! Calculates Absolute Salinity, SA, from Practical Salinity, SP
!
! sp     : Practical Salinity                              [unitless]
! p      : sea pressure                                    [dbar]
! long   : longitude                                       [DEG E]     
! lat    : latitude                                        [DEG N]
!
! gsw_sa_from_sp   : Absolute Salinity                     [g/kg]

implicit none
integer, parameter :: r14 = selected_real_kind(14,30)

real (r14) :: sp, long, lat, p, gsw_sa_from_sp, saar
real (r14) :: gsw_sa_baltic

saar = gsw_saar(p,long,lat)

gsw_sa_from_sp = (35.16504d0/35.d0)*sp*(1.d0 + saar)

gsw_sa_baltic = gsw_sa_from_sp_baltic(sp,long,lat)

if (gsw_sa_baltic.lt.1d10) then
   gsw_sa_from_sp = gsw_sa_baltic
end if

if (saar.eq.9d15) then
   gsw_sa_from_sp = 9d15
end if

return
end function

!--------------------------------------------------------------------------

!==========================================================================
function gsw_sstar_from_sp(sp,p,long,lat)
!==========================================================================

! Calculates Preformed Salinity, Sstar, from Practical Salinity, SP. 
!
! sp     : Practical Salinity                              [unitless]
! p      : sea pressure                                    [dbar]
! long   : longitude                                       [deg E]     
! lat    : latitude                                        [deg N]
!
! gsw_sstar_from_sp  : Preformed salinity                  [g/kg]

implicit none

integer, parameter :: r14 = selected_real_kind(14,30)

real (r14) :: sp, long, lat, p
real (r14) :: saar, gsw_sstar_from_sp, sstar_baltic

saar = gsw_saar(p,long,lat)

gsw_sstar_from_sp = (35.16504d0/35.d0)*sp*(1 - 0.35d0*saar);

!In the Baltic Sea, Sstar = sa.
sstar_baltic = gsw_sa_from_sp_baltic(sp,long,lat);

if (sstar_baltic.lt.1d10) then
    gsw_sstar_from_sp = sstar_baltic;
end if

if (saar.eq.9d15) then
    gsw_sstar_from_sp = 9d15
end if

return
end function

!--------------------------------------------------------------------------

!==========================================================================
function gsw_deltasa_from_sp(sp,p,long,lat)
!==========================================================================

! Calculates Absolute Salinity Anomaly, deltaSA, from Practical Salinity, SP. 
!
! sp     : Practical Salinity                              [unitless]
! p      : sea pressure                                    [dbar]
! long   : longitude                                       [deg E]     
! lat    : latitude                                        [deg N]
!
! gsw_deltasa_from_sp : Absolute Salinty Anomaly           [g/kg]

implicit none

integer, parameter :: r14 = selected_real_kind(14,30)

real (r14) :: sp, long, lat, p
real (r14) :: gsw_deltasa_from_sp

gsw_deltasa_from_sp = gsw_sa_from_sp(sp,p,long,lat) - gsw_sr_from_sp(sp)

if (gsw_deltasa_from_sp.gt.1d10) then
    gsw_deltasa_from_sp = 9d15
end if

return
end function

!--------------------------------------------------------------------------

!==========================================================================
function gsw_sr_from_sp(sp)
!==========================================================================

! Calculates Reference Salinity, SR, from Practical Salinity, SP. 
!
! sp     : Practical Salinity                              [unitless]
!
! gsw_sr_from_sp : Reference Salinity                      [g/kg]

implicit none

integer, parameter :: r14 = selected_real_kind(14,30)

real (r14) :: sp, gsw_sr_from_sp

gsw_sr_from_sp = 1.004715428571429*sp;

if (gsw_sr_from_sp.ge.1.d10) then
    gsw_sr_from_sp = 9.d15
end if

return
end function

!--------------------------------------------------------------------------

!==========================================================================
function gsw_sp_from_sr(sr)
!==========================================================================

! Calculates Practical Salinity, sp, from Reference Salinity, SR. 
!
! SR     : Reference Salinity                              [g/kg]
!
! gsw_sp_from_sr  : Practical Salinity                     [unitless]

implicit none

integer, parameter :: r14 = selected_real_kind(14,30)

real (r14) :: sr, gsw_sp_from_sr

gsw_sp_from_sr = 0.995306702338459*sr;

if (gsw_sp_from_sr.gt.1d10) then
    gsw_sp_from_sr = 9d15
end if

return
end function

!--------------------------------------------------------------------------

!==========================================================================
function gsw_sp_from_sa(sa,p,long,lat)
!==========================================================================

! Calculates Practical salinity, sp, from Absolute salinity, sa  
!
! sa     : Absolute Salinity                               [g/kg]
! p      : sea pressure                                    [dbar]
! long   : longitude                                       [DEG E]     
! lat    : latitude                                        [DEG N]
!
! gsw_sp_from_sa      : Practical Salinity                 [unitless]

implicit none

integer, parameter :: r14 = selected_real_kind(14,30)

real (r14) :: sa, long, lat, p, gsw_sp_from_sa, saar
real (r14) :: gsw_sp_baltic

saar = gsw_saar(p,long,lat)

gsw_sp_from_sa = (35.d0/35.16504d0)*sa/(1d0 + saar)

gsw_sp_baltic = gsw_sp_from_sa_baltic(sa,long,lat);

if (gsw_sp_baltic.lt.1d10) then
   gsw_sp_from_sa = gsw_sp_baltic
end if

if (saar.eq.9d15) then
   gsw_sp_from_sa = 9d15
end if

return
end function

!--------------------------------------------------------------------------

!==========================================================================
function gsw_sstar_from_sa(sa,p,long,lat)
!==========================================================================

! Calculates Preformed Salinity, Sstar, from Absolute Salinity, SA. 
!
! sa     : Absolute Salinity                               [g/kg]
! p      : sea pressure                                    [dbar]
! long   : longitude                                       [deg E]     
! lat    : latitude                                        [deg N]
!
! gsw_sstar_from_sa : Preformed Salinity                   [g/kg]

implicit none

integer, parameter :: r14 = selected_real_kind(14,30)

real (r14) :: sa, long, lat, p
real (r14) :: saar, gsw_sstar_from_sa

saar = gsw_saar(p,long,lat)

gsw_sstar_from_sa = sa*(1d0 - 0.35d0*saar)/(1d0 + saar)

! In the Baltic Sea, Sstar = sa, and note that gsw_saar returns zero
! for saar in the Baltic.

if (saar.eq.9d15) then
    gsw_sstar_from_sa = 9d15
end if

return
end function

!--------------------------------------------------------------------------

!==========================================================================
function gsw_sa_from_sstar(sstar,p,long,lat)
!==========================================================================

! Calculates Absolute Salinity, SA, from Preformed Salinity, Sstar.
!
! Sstar  : Preformed Salinity                              [g/kg]
! p      : sea pressure                                    [dbar]
! long   : longitude                                       [deg E]     
! lat    : latitude                                        [deg N]
!
! gsw_sa_from_sstar   : Absolute Salinity                  [g/kg]

implicit none

integer, parameter :: r14 = selected_real_kind(14,30)

real (r14) :: long, lat, p
real (r14) :: saar, gsw_sa_from_sstar, sstar

saar = gsw_saar(p,long,lat)

gsw_sa_from_sstar = sstar*(1d0 + saar)/(1d0 - 0.35d0*saar)

! In the Baltic Sea, Sstar = SA, and note that gsw_saar returns zero
! for SAAR in the Baltic.

if (saar.eq.9d15) then
    gsw_sa_from_sstar = 9d15
end if

return
end function

!--------------------------------------------------------------------------

!==========================================================================
function gsw_sp_from_sstar(sstar,p,long,lat)
!==========================================================================

! Calculates Practical Salinity, SP, from Preformed Salinity, Sstar. 
!
! sstar  : Preformed Salinity                              [g/kg]
! p      : sea pressure                                    [dbar]
! long   : longitude                                       [deg E]     
! lat    : latitude                                        [deg N]
!
! gsw_sp_from_Sstar : Preformed Salinity                   [g/kg]

implicit none

integer, parameter :: r14 = selected_real_kind(14,30)

real (r14) :: long, lat, p
real (r14) :: saar, gsw_sp_from_sstar, sp_baltic, Sstar

saar = gsw_saar(p,long,lat)

gsw_sp_from_sstar = (35.d0/35.16504d0)*Sstar/(1 - 0.35d0*saar);

!In the Baltic Sea, SA = Sstar.
sp_baltic = gsw_sp_from_sa_baltic(sstar,long,lat);

if (sp_Baltic.lt.1d10) then
    gsw_sp_from_sstar = sp_baltic;
end if

if (saar.eq.9d15) then
    gsw_sp_from_sstar = 9d15
end if

return
end function

!--------------------------------------------------------------------------

!--------------------------------------------------------------------------
! Library functions of the GSW toolbox
!--------------------------------------------------------------------------

!==========================================================================
function gsw_saar(p,long,lat)
!==========================================================================

! Calculates the Absolute Salinity Anomaly Ratio, SAAR.
!
! p      : sea pressure                                    [dbar]
! long   : longitude                                       [deg E]     
! lat    : latitude                                        [deg N]
!
! gsw_saar : Absolute Salinity Anomaly Ratio               [unitless]

implicit none

!integer, parameter :: int9 = selected_int_kind(9) 
integer, parameter :: r14 = selected_real_kind(14,30)

integer, parameter :: nx=91, ny=45, nz=45

integer :: indx0, indy0, indz0, i, j, icalled, k
integer :: flag_saar
integer, dimension(4) :: deli, delj

real (r14), dimension(4) :: saar, saar_old
real (r14), dimension(nz) :: p_ref
real (r14), dimension(ny) :: lats_ref
real (r14), dimension(nx) :: longs_ref
real (r14), dimension(ny,nx) :: ndepth_ref 
real (r14), dimension(nz,ny,nx) :: saar_ref
!real (r14), dimension(nz,ny,nx) :: delta_sa_ref
real (r14) :: p, lat, long, dlong, dlat
real (r14) :: gsw_saar, p0_original, sa_upper, sa_lower 
real (r14) :: r1, s1, t1, ndepth_max

data deli/0,1,1,0/, delj/0,0,1,1/

data icalled/0/

save icalled, longs_ref, lats_ref, p_ref, ndepth_ref, saar_ref

flag_saar = 0
gsw_saar = 9d15

if(lat .lt. -86d0 .or. lat .gt. 90d0) then
 gsw_saar = 9d15
 return
end if

if(long .lt. 0) then
 long = long + 360
end if

if(icalled.eq.0) then
   icalled = 1
   open(10,file='gsw_data_v3_0.dat',status='old',err=1)
   flag_saar = 1
   read(10,*) (longs_ref(i), i=1,nx)
   read(10,*) (lats_ref(i), i=1,ny)
   read(10,*) (p_ref(i), i=1,nz)
   read(10,*) ((ndepth_ref(j,i), j=1,ny), i=1,nx)
   read(10,*) (((saar_ref(k,j,i), k=1,nz), j=1,ny), i=1,nx)
   !read(10,*) (((delta_sa_ref(k,j,i), k=1,nz), j=1,ny), i=1,nx)
   close(10)
   go to 2
1  saar_ref = 9d15
   flag_saar = 0
2  continue
end if

if (flag_saar.eq.0) then
   write(*,*) "*** gsw_data_v3_0.dat is missing !!! ***"
   write(*,*) "Set the full path of gsw_data_v3_0.dat in gsw_saar"
end if

!Set gsw_saar = 9d15 and return if there is no data file present
if(flag_saar .eq. 0) then
 gsw_saar = 9d15
 return
endif

dlong = longs_ref(2)-longs_ref(1)
dlat = lats_ref(2)-lats_ref(1)

indx0 = floor(1 + (nx-1)*(long-longs_ref(1))/(longs_ref(nx)-longs_ref(1)))
if(indx0.eq.nx) then
   indx0 = nx-1
end if

indy0 = floor(1 + (ny-1)*(lat-lats_ref(1))/(lats_ref(ny)-lats_ref(1)))
if(indy0.eq.ny) then
   indy0 = ny-1
end if

ndepth_max = -1
do k = 1,4
   if(ndepth_ref(indy0+delj(k),indx0+deli(k)).gt.0.d0) then
      ndepth_max = max(ndepth_max,ndepth_ref(indy0+delj(k),indx0+deli(k)))
   end if
end do

if(ndepth_max.eq.-1.d0) then
  gsw_saar = 0d0 
   return
end if 

p0_original = p
if(p.gt.p_ref(int(ndepth_max))) then
 p = p_ref(int(ndepth_max))
end if
call indx(p_ref,nz,p,indz0)
    
r1 = (long-longs_ref(indx0))/(longs_ref(indx0+1)-longs_ref(indx0));
s1 = (lat-lats_ref(indy0))/(lats_ref(indy0+1)-lats_ref(indy0));
t1 = (p-p_ref(indz0))/(p_ref(indz0+1)-p_ref(indz0));

do k = 1,4
   saar(k) = saar_ref(indz0,indy0+delj(k),indx0+deli(k))
end do

if(260.d0.le.long.and.long.le.291.999d0.and.3.4d0.le.lat.and.lat.le.19.55d0) then
  saar_old = saar
  call gsw_add_barrier(saar_old,long,lat,longs_ref(indx0),lats_ref(indy0),dlong,dlat,saar)
else if(abs(sum(saar)) .ge. 1d10) then 
   saar = gsw_add_mean(saar)
end if

sa_upper = (1.d0-s1)*(saar(1) + r1*(saar(2)-saar(1))) + s1*(saar(4) + r1*(saar(3)-saar(4)))

do k = 1,4
   saar(k) = saar_ref(indz0+1,indy0+delj(k),indx0+deli(k))
end do

if(260.d0.le.long.and.long.le.291.999d0.and.3.4d0.le.lat.and.lat.le.19.55d0) then
   saar_old = saar
   call gsw_add_barrier(saar_old,long,lat,longs_ref(indx0),lats_ref(indy0),dlong,dlat,saar)
else if(abs(sum(saar)) .ge. 1d10) then 
   saar = gsw_add_mean(saar)
end if

sa_lower = (1.d0-s1)*(saar(1) + r1*(saar(2)-saar(1))) + s1*(saar(4) + r1*(saar(3)-saar(4)))
if(abs(sa_lower) .ge. 1d10) then
  sa_lower = sa_upper
end if
gsw_saar = sa_upper + t1*(sa_lower-sa_upper)

if(abs(gsw_saar).ge.1d10) then
   gsw_saar = 9d15
endif

p = p0_original
  
return
end function

!--------------------------------------------------------------------------

!==========================================================================
function gsw_delta_sa_ref(p,long,lat)
!==========================================================================

! Calculates the Absolute Salinity Anomaly reference value, delta_SA_ref.
!
! p      : sea pressure                                    [dbar]
! long   : longiture                                       [deg E]     
! lat    : latitude                                        [deg N]
!
! gsw_delta_sa_ref : Absolute Salinity Anomaly reference value    [g/kg]

implicit none

!integer, parameter :: int9 = selected_int_kind(9) 
integer, parameter :: r14 = selected_real_kind(14,30)

integer, parameter :: nx=91, ny=45, nz=45

integer :: indx0, indy0, indz0, i, j, icalled2, k
integer :: flag_dsar
integer, dimension(4) :: deli, delj

real (r14), dimension(4) :: dsar, dsar_old
real (r14), dimension(nz) :: p_ref
real (r14), dimension(ny) :: lats_ref
real (r14), dimension(nx) :: longs_ref
real (r14), dimension(ny,nx) :: ndepth_ref 
real (r14), dimension(nz,ny,nx) :: saar_ref, delta_sa_ref
real (r14) :: p, lat, long, dlong, dlat
real (r14) :: gsw_delta_sa_ref, p0_original, sa_upper, sa_lower 
real (r14) :: r1, s1, t1, ndepth_max

data deli/0,1,1,0/, delj/0,0,1,1/

data icalled2/0/

save icalled2, longs_ref, lats_ref, p_ref, ndepth_ref, delta_sa_ref

flag_dsar = 0
gsw_delta_sa_ref = 9d15

if(lat .lt. -86d0 .or. lat .gt. 90d0) then
 gsw_delta_sa_ref = 9d15
 return
end if

if(long .lt. 0) then
 long = long + 360
end if

if(icalled2.eq.0) then
   icalled2 = 1
   open(10,file='gsw_data_v3_0.dat',status='old',err=1)
   flag_dsar = 1
   read(10,*) (longs_ref(i), i=1,nx)
   read(10,*) (lats_ref(i), i=1,ny)
   read(10,*) (p_ref(i), i=1,nz)
   read(10,*) ((ndepth_ref(j,i), j=1,ny), i=1,nx)
   read(10,*) (((saar_ref(k,j,i), k=1,nz), j=1,ny), i=1,nx)
   read(10,*) (((delta_sa_ref(k,j,i), k=1,nz), j=1,ny), i=1,nx)
   close(10)
   go to 2
1  delta_sa_ref = 9d15
   flag_dsar = 0
2  continue
end if

if (flag_dsar.eq.0) then
   write(*,*) "*** gsw_data_v3_0.dat is missing !!! ***"
   write(*,*) "Set the full path of gsw_data_v3_0.dat in gsw_delta_sa_ref"
end if

!Set gsw_delta_sa_ref = 9d15 and return if there is no data set present
if(flag_dsar.eq.0) then
 gsw_delta_sa_ref = 9d15
 return
endif

dlong = longs_ref(2)-longs_ref(1)
dlat = lats_ref(2)-lats_ref(1)

indx0 = floor(1 + (nx-1)*(long-longs_ref(1))/(longs_ref(nx)-longs_ref(1)))
if(indx0.eq.nx) then
   indx0 = nx-1
end if

indy0 = floor(1 + (ny-1)*(lat-lats_ref(1))/(lats_ref(ny)-lats_ref(1)))
if(indy0.eq.ny) then
   indy0 = ny-1
end if

ndepth_max = -1
do k = 1,4
   if(ndepth_ref(indy0+delj(k),indx0+deli(k)).gt.0.d0) then
      ndepth_max = max(ndepth_max,ndepth_ref(indy0+delj(k),indx0+deli(k)))
   end if
end do

if(ndepth_max.eq.-1.d0) then
  gsw_delta_sa_ref = 0d0 
   return
end if 

p0_original = p
if(p.gt.p_ref(int(ndepth_max))) then
 p = p_ref(int(ndepth_max))
end if
call indx(p_ref,nz,p,indz0)
    
r1 = (long-longs_ref(indx0))/(longs_ref(indx0+1)-longs_ref(indx0));
s1 = (lat-lats_ref(indy0))/(lats_ref(indy0+1)-lats_ref(indy0));
t1 = (p-p_ref(indz0))/(p_ref(indz0+1)-p_ref(indz0));

do k = 1,4
   dsar(k) = delta_sa_ref(indz0,indy0+delj(k),indx0+deli(k))
end do

if(260.d0.le.long.and.long.le.291.999d0.and.3.4d0.le.lat.and.lat.le.19.55d0) then
  dsar_old = dsar
  call gsw_add_barrier(dsar_old,long,lat,longs_ref(indx0),lats_ref(indy0),dlong,dlat,dsar)
else if(abs(sum(dsar)) .ge. 1d10) then 
   dsar = gsw_add_mean(dsar)
end if

sa_upper = (1.d0-s1)*(dsar(1) + r1*(dsar(2)-dsar(1))) + s1*(dsar(4) + r1*(dsar(3)-dsar(4)))

do k = 1,4
   dsar(k) = delta_sa_ref(indz0+1,indy0+delj(k),indx0+deli(k))
end do

if(260.d0.le.long.and.long.le.291.999d0.and.3.4d0.le.lat.and.lat.le.19.55d0) then
   dsar_old = dsar
   call gsw_add_barrier(dsar_old,long,lat,longs_ref(indx0),lats_ref(indy0),dlong,dlat,dsar)
else if(abs(sum(dsar)) .ge. 1d10) then 
   dsar = gsw_add_mean(dsar)
end if

sa_lower = (1.d0-s1)*(dsar(1) + r1*(dsar(2)-dsar(1))) + s1*(dsar(4) + r1*(dsar(3)-dsar(4)))
if(abs(sa_lower) .ge. 1d10) then
  sa_lower = sa_upper
end if
gsw_delta_sa_ref = sa_upper + t1*(sa_lower-sa_upper)

if(abs(gsw_delta_sa_ref).ge.1d10) then
   gsw_delta_sa_ref = 9d15
endif

p = p0_original
  
return
end function

!--------------------------------------------------------------------------

!==========================================================================
subroutine gsw_add_barrier(input_data,long,lat,long_grid,lat_grid,dlong_grid,dlat_grid,output_data)
!==========================================================================

!  Adds a barrier through Central America (Panama) and then averages
!  over the appropriate side of the barrier
! 
!  data_in      :  data                                                     [unitless]
!  long         :  Longitudes of data in decimal degrees east               [ 0 ... +360 ]
!  lat          :  Latitudes of data in decimal degrees north               [ -90 ... +90 ]
!  longs_grid   :  Longitudes of regular grid in decimal degrees east       [ 0 ... +360 ]
!  lats_grid    :  Latitudes of regular grid in decimal degrees north       [ -90 ... +90 ]
!  dlongs_grid  :  Longitude difference of regular grid in decimal degrees  [ deg longitude ]
!  dlats_grid   :  Latitude difference of regular grid in decimal degrees   [ deg latitude ]
!
! gsw_add_barrier  : average of data depending on which side of the 
!                    Panama cannal it is on                                 [unitless]

implicit none

integer, parameter :: r14 = selected_real_kind(14,30)

integer, dimension(4) :: above_line
integer k, nmean, above_line0, kk
real (r14), dimension(4) :: input_data, output_data
real (r14), dimension(6) :: longs_pan, lats_pan
real (r14) :: long, lat, r, lats_line, long_grid, lat_grid
real (r14) :: dlong_grid, dlat_grid, data_mean

data longs_pan/260.0000, 272.5900, 276.5000, 278.6500, 280.7300, 292.000/ 
data  lats_pan/ 19.5500,  13.9700,   9.6000,   8.1000,   9.3300,   3.400/ 

call indx(longs_pan,6,long,k)                            !   the long/lat point
r = (long-longs_pan(k))/(longs_pan(k+1)-longs_pan(k))
lats_line = lats_pan(k) + r*(lats_pan(k+1)-lats_pan(k))

if(lats_line.le.lat) then
   above_line0 = 1
else
   above_line0 = 0
end if

call indx(longs_pan,6,long_grid,k)                                     !  the 1 and 4 long/lat points 
r = (long_grid-longs_pan(k))/(longs_pan(k+1)-longs_pan(k))
lats_line = lats_pan(k) + r*(lats_pan(k+1)-lats_pan(k))

if(lats_line.le.lat_grid) then
   above_line(1) = 1
else
   above_line(1) = 0
end if

if(lats_line.le.lat_grid+dlat_grid) then
   above_line(4) = 1
else
   above_line(4) = 0
end if

call indx(longs_pan,6,long_grid+dlong_grid,k)                              !  the 2 and 3 long/lat points 
r = (long_grid+dlong_grid-longs_pan(k))/(longs_pan(k+1)-longs_pan(k))
lats_line = lats_pan(k) + r*(lats_pan(k+1)-lats_pan(k))

if(lats_line.le.lat_grid) then
   above_line(2) = 1
else
   above_line(2) = 0
end if

if(lats_line.le.lat_grid+dlat_grid) then
   above_line(3) = 1
else
   above_line(3) = 0
end if

nmean = 0 
data_mean = 0.d0

do kk = 1,4
   if ((abs(input_data(kk)).le.100d0).and.above_line0.eq.above_line(kk)) then
      nmean = nmean+1
      data_mean = data_mean+input_data(kk)
   end if
end do

if(nmean == 0)then
   data_mean = 0d0    !errorreturn
else
   data_mean = data_mean/nmean
endif

do kk = 1,4
   if((abs(input_data(kk)).ge.1d10).or.above_line0.ne.above_line(kk)) then
      output_data(kk) = data_mean
   else
      output_data(kk) = input_data(kk)
   end if
end do

return
end subroutine

!--------------------------------------------------------------------------

!==========================================================================
function gsw_add_mean(data_in)
!==========================================================================

! Replaces NaN's with non-nan mean of the 4 adjacent neighbours
!
! data   : data set of the 4 adjacent neighbours   
! p      : sea pressure                                        [dbar]
!
! gsw_add_mean : non-nan mean of the 4 adjacent neighbours     [unitless]

implicit none

integer, parameter :: int9 = selected_int_kind(9)
integer, parameter :: r14 = selected_real_kind(14,30)

integer :: k, nmean

real (r14), dimension(4) :: data_in, gsw_add_mean
real (r14) :: data_mean

nmean = 0
data_mean = 0.d0
gsw_add_mean = data_in

do k = 1,4
   if (abs(data_in(k)).le.100d0) then
      nmean = nmean+1
      data_mean = data_mean+data_in(k)
   end if
end do

if(nmean.eq.0)then
   data_mean = 0d0    !errorreturn
else
   data_mean = data_mean/nmean
endif

do k = 1,4
   if(abs(data_in(k)).ge.100d0) then
      gsw_add_mean(k) = data_mean
   end if
end do

return
end function

!--------------------------------------------------------------------------

!==========================================================================
function xinterp1(x,y,n,x0)
!==========================================================================

! Linearly interpolate a real array   
!
! x      : y array (Must be monotonic)               
! y      : y array     
! n      : length of X and Y arrays
! x0     : value to be interpolated
!
! xinterp1 : Linearly interpolated value

implicit none

integer, parameter :: r14 = selected_real_kind(14,30)

integer :: n, k

real (r14), dimension(n) :: x, y
real (r14) :: x0, r, xinterp1

call indx(x,n,x0,k)
r = (x0-x(k))/(x(k+1)-x(k))
xinterp1 = y(k) + r*(y(k+1)-y(k))

return
end function

!--------------------------------------------------------------------------

!==========================================================================
subroutine indx(x,n,z,k)
!==========================================================================

!  Finds the index of the value in a monotonically increasing array
!
!  x	 :  array of monotonically increasing values
!  n     :  length of the array
!  z     :  value to be indexed
!
!  K      : index K - if X(K) <= Z < X(K+1), or
!  N-1     		    - if Z = X(N)
!

integer, parameter :: r14 = selected_real_kind(14,30)

integer :: n, k, ku, kl, km

real (r14), dimension(n) :: x
real (r14) :: z

if(z.gt.x(1).and.z.lt.x(n)) then
   kl=1
   ku=n
   do while (ku-kl.gt.1)
      km=(ku+kl)/2
      if(z.gt.x(km)) then
         kl=km
      else
         ku=km
      endif
   end do
   k=kl
   if(z.eq.x(k+1)) then 
     k = k+1
   end if
elseif (z.le.x(1)) then
      k = 1
elseif (z.ge.x(n)) then
      k = n-1
else
      write(*,*) 'ERROR in subroutine indx : out of range'
      write(*,*) 'z = ', z, 'n = ', n, 'x = ',x
end if

return
end subroutine

!--------------------------------------------------------------------------

!==========================================================================
function gsw_fdelta(p,long,lat)
!==========================================================================

! Calculates fdelta. 
!
! sp     : Practical Salinity                              [unitless]
! p      : sea pressure                                    [dbar]
! long   : longitude                                       [deg E]     
! lat    : latitude                                        [deg N]
!
! gsw_fdelta : Absolute Salinty Anomaly                    [unitless]

implicit none

integer, parameter :: r14 = selected_real_kind(14,30)

real (r14) :: long, lat, p, saar, gsw_fdelta

saar = gsw_saar(p,long,lat)

gsw_fdelta = ((1d0 + 0.35d0)*saar)/(1d0 - 0.35d0*saar);

if (saar.gt.1d10) then
    gsw_fdelta = 9d15
end if

return
end function

!--------------------------------------------------------------------------

!==========================================================================
function gsw_sa_from_sp_baltic(sp,long,lat)
!==========================================================================

! For the Baltic Sea, calculates Absolute Salinity with a value
! computed analytically from Practical Salinity
!
! sp     : Practical Salinity                              [unitless]
! long   : longitude                                       [deg E]     
! lat    : latitude                                        [deg N]
! p      : sea pressure                                    [dbar]
!
! gsw_sa_from_sp_baltic : Absolute Salinity                [g/kg]                         

implicit none

integer, parameter :: r14 = selected_real_kind(14,30)

real (r14), dimension(2) :: xb_right, yb_right
real (r14), dimension(3) :: xb_left, yb_left
real (r14) :: sp, long, lat, gsw_sa_from_sp_baltic, xx_left, xx_right

data xb_left/12.6d0, 7.d0, 26.d0/, yb_left/50.d0, 59.d0, 69.d0/
data xb_right/45.d0, 26.d0/, yb_right/50.d0, 69.d0/

if(xb_left(2).lt.long .and. long.lt.xb_right(1) .and. yb_left(1).lt.lat .and. lat.lt.yb_left(3)) then
  
    xx_left = xinterp1(yb_left, xb_left, 3, lat)
    
    xx_right = xinterp1(yb_right, xb_right, 2, lat)
    
    if(xx_left.le.long .and. long.le.xx_right) then
        gsw_sa_from_sp_baltic =((35.16504d0 - 0.087d0)/35d0)*sp + 0.087d0
    else
        gsw_sa_from_sp_baltic = 9d15
    end if

else
    gsw_sa_from_sp_baltic = 9d15
end if

return
end function

!--------------------------------------------------------------------------

!==========================================================================
function gsw_sp_from_sa_baltic(sa,long,lat)
!==========================================================================

! For the Baltic Sea, calculates Practical Salinity with a value
! computed analytically from Absolute Salinity
!
! sa     : Absolute Salinity                               [g/kg]
! long   : longitude                                       [deg E]     
! lat    : latitude                                        [deg N]
! p      : sea pressure                                    [dbar]
!
! gsw_sp_from_sa_baltic  : Practical Salinity              [unitless]

implicit none

integer, parameter :: r14 = selected_real_kind(14,30)

real (r14), dimension(2) :: xb_right, yb_right
real (r14), dimension(3) :: xb_left, yb_left
real (r14) :: sa, long, lat, gsw_sp_from_sa_baltic, xx_left, xx_right

data xb_left/12.6d0, 7.d0, 26.d0/, yb_left/50.d0, 59.d0, 69.d0/
data xb_right/45.d0, 26.d0/, yb_right/50.d0, 69.d0/

if(xb_left(2).lt.long .and. long.lt.xb_right(1) .and. yb_left(1).lt.lat .and. lat.lt.yb_left(3)) then
  
    xx_left = xinterp1(yb_left, xb_left, 3, lat)
    
    xx_right = xinterp1(yb_right, xb_right, 2, lat)
    
    if(xx_left.le.long .and. long.le.xx_right) then
        gsw_sp_from_sa_baltic = (35.d0/(35.16504d0 - 0.087d0))*(sa - 0.087d0)
    else
        gsw_sp_from_sa_baltic = 9d15
    end if
     
else
    gsw_sp_from_sa_baltic = 9d15
end if

return
end function

!--------------------------------------------------------------------------

!==========================================================================


end module convert_0

module ice_air_4c

!#########################################################################

!THIS MODULE IMPLEMENTS THE ENTHALPY OF ICE AIR, AS WELL AS ITS PARTIAL 
!DERIVATIVES, DEPENDING ON DRY-AIR FRACTION, ENTROPY AND PRESSURE.

!#########################################################################

!IMPLEMENTATION IN FORTRAN BY D.G. WRIGHT
!FOR PUBLICATION IN OCEAN SCIENCE, AS DESCRIBED IN THE PAPERS

!FEISTEL, R., WRIGHT, D.G., JACKETT, D.R., MIYAGAWA, K., REISSMANN, J.H.,
!WAGNER, W., OVERHOFF, U., GUDER, C., FEISTEL, A., MARION, G.M.:
!NUMERICAL IMPLEMENTATION AND OCEANOGRAPHIC APPLICATION OF THE THERMODYNAMIC
!POTENTIALS OF WATER, VAPOUR, ICE, SEAWATER AND AIR. PART I: BACKGROUND AND EQUATIONS. 
!OCEAN SCIENCES, 2009, IN PREPARATION.

!WRIGHT, D.G., FEISTEL, R., JACKETT, D.R., MIYAGAWA, K., REISSMANN, J.H., 
!WAGNER, W., OVERHOFF, U., GUDER, C., FEISTEL, A., MARION, G.M.:
!NUMERICAL IMPLEMENTATION AND OCEANOGRAPHIC APPLICATION OF THE THERMODYNAMIC
!POTENTIALS OF WATER, VAPOUR, ICE, SEAWATER AND AIR. PART II: THE LIBRARY ROUTINES, 
!OCEAN SCIENCES., 2009, IN PREPARATION.

!FEISTEL, R., KRETZSCHMAR, H.-J., SPAN, R., HAGEN, E., WRIGHT, D.G., HERRMANN, S.:
!THERMODYNAMIC PROPERTIES OF SEA AIR.
!OCEAN SCIENCE DISCUSSION 6(2009)2193-2325.

!#########################################################################

!THIS MODULE REQUIRES THE LIBRARY MODULES:
!     CONSTANTS_0,  FILE CONSTANTS_0.F90
!     CONVERT_0,    FILE CONVERT_0.F90
!     ICE_LIQ_4,    FILE ICE_LIQ_4.F90
!     ICE_AIR_4B,   FILE ICE_AIR_4B.F90

!NESTED USE ASSOCIATIONS
!     MATHS_0,      FILE MATHS_0.F90
!     AIR_1,        FILE AIR_1.F90
!     FLU_1,        FILE FLU_1.F90
!     ICE_1,        FILE ICE_1.F90
!     AIR_2,        FILE AIR_2.F90
!     FLU_2,        FILE FLU_2.F90
!     ICE_2,        FILE ICE_2.F90
!     AIR_3A,       FILE AIR_3A.F90
!     AIR_3B,       FILE AIR_3B.F90
!     ICE_VAP_4,    FILE ICE_VAP_4.F90
!     ICE_AIR_4A,   FILE ICE_AIR_4A.F90

!#########################################################################

use constants_0
use convert_0
use ice_liq_4
use ice_air_4b

implicit none
private

character*16, private :: version = '8 Jun 2010'

public :: ice_air_h_si, ice_air_h_cp_si, ice_air_h_density_si, &
          ice_air_h_kappa_s_si, ice_air_h_lapserate_si, &
          ice_air_h_temperature_si, ice_air_potdensity_si, &
          ice_air_potenthalpy_si, ice_air_pottemp_si, &
          set_it_ctrl_ice_air_pottemp

!CONTROL PARAMETERS OF THE TEMPERATURE ITERATION
integer ctrl_initialized

integer ctrl_mode_pottemp
integer ctrl_loop_maximum

real*8 ctrl_init_pottemp
real*8 ctrl_eps_exit_pottemp

contains

!==========================================================================
function ice_air_h_si(drv_wa, drv_eta, drv_p, wa_si, eta_si, p_si)
!==========================================================================

!THIS FUNCTION IMPLEMENTS ENTHALPY OF ICE AIR AS A THERMODYNAMIC POTENTIAL,
!DEPENDING ON AIR MASS FRACTION, ENTROPY AND PRESSURE

!RETURNS ICE_AIR_H_SI AS THE WA-ETA-P DERIVATIVE
!(D/DWA)^DRV_WA (D/DETA)^DRV_ETA (D/DP)^DRV_P H(WA,ETA,P)
!OF THE SPECIFIC ENTHALPY OF ICE AIR, H(WA,ETA,P), IN J/KG

!OUTPUT:
!ICE_AIR_H_SI POTENTIAL RESULTS

!INPUTS:
!WA_SI     DRY-AIR MASS FRACTION OF ICE AIR IN KG/KG
!ETA_SI    SPECIFIC ENTROPY IN J/(KG K),
!P_SI      ABSOLUTE PRESSURE IN PA

!NOTE: THE ACCURACY OF THIS FUNCTION DEPENDS ON THE ITERATION SETTINGS FOR
!      DENSITY COMPUTED IN AIR_3A, AND ON THE ITERATION SETTINGS
!      FOR TEMPERATURE BY SET_IT_CTRL_ICE_AIR_POTTEMP OF THIS MODULE

real*8 ice_air_h_si, wa_si, eta_si, p_si
real*8 t

!CHECK VALUES WITH DEFAULT SETTINGS, V1.0:
!ice_air_h_si( 0, 0, 0, 0.5, -600, 1E5) =-164588.277175
!ice_air_h_si( 1, 0, 0, 0.5, -600, 1E5) = 543.382787268
!ice_air_h_si( 0, 1, 0, 0.5, -600, 1E5) = 271.449435548
!ice_air_h_si( 0, 0, 1, 0.5, -600, 1E5) = 0.392073699416
!ice_air_h_si( 2, 0, 0, 0.5, -600, 1E5) = 224938.714580
!ice_air_h_si( 1, 1, 0, 0.5, -600, 1E5) =-177.440249223
!ice_air_h_si( 1, 0, 1, 0.5, -600, 1E5) = 0.781966303025
!ice_air_h_si( 0, 2, 0, 0.5, -600, 1E5) = 0.139971645623
!ice_air_h_si( 0, 1, 1, 0.5, -600, 1E5) = 2.26942461987E-04
!ice_air_h_si( 0, 0, 2, 0.5, -600, 1E5) =-3.57055653968E-06

!CHECK VALUES WITH DEFAULT SETTINGS, V1.1:
!ice_air_h_si( 0, 0, 0, 0.5, -600, 1E5) =-164588.106002
!ice_air_h_si( 1, 0, 0, 0.5, -600, 1E5) = 543.016638396
!ice_air_h_si( 0, 1, 0, 0.5, -600, 1E5) = 271.449994437
!ice_air_h_si( 0, 0, 1, 0.5, -600, 1E5) = 0.391981878510
!ice_air_h_si( 2, 0, 0, 0.5, -600, 1E5) = 224958.525864
!ice_air_h_si( 1, 1, 0, 0.5, -600, 1E5) =-177.457078495
!ice_air_h_si( 1, 0, 1, 0.5, -600, 1E5) = 0.781782661019
!ice_air_h_si( 0, 2, 0, 0.5, -600, 1E5) = 0.139985868894
!ice_air_h_si( 0, 1, 1, 0.5, -600, 1E5) = 2.26912930199E-04
!ice_air_h_si( 0, 0, 2, 0.5, -600, 1E5) =-3.56976697603E-06

integer drv_wa, drv_eta, drv_p

ice_air_h_si = errorreturn

if(drv_wa < 0) return
if(drv_eta < 0) return
if(drv_p < 0) return
if(drv_wa + drv_eta + drv_p > 2) return

if(wa_si < 0d0 .or. wa_si > 1d0) return
if(p_si < 0d0) return

!COMPUTE TEMPERATURE FROM ENTROPY.
!IF P_SI = IN-SITU PRESSURE, THIS IS IN-SITU TEMPERATURE
!IF P_SI = REFERENCE PRESSURE, THIS IS POTENTIAL TEMPERATURE
t = ice_air_h_temperature_si(wa_si, eta_si, p_si)
if(t == errorreturn) return

ice_air_h_si = ice_air_a_eta_p_derivatives_si(drv_wa, drv_eta, drv_p, wa_si, t, p_si)

end function

!=========================================================================
function ice_air_h_cp_si(wa_si, eta_si, p_si)
!==========================================================================
                                 
!OUTPUT:
!CP(A,ETA,P) = T/(D2H/DETA2)_A_P  HEAT CAPACITY OF ICE AIR IN J/(KG K)

!INPUTS:
!WA_SI     DRY-AIR MASS FRACTION OF ICE AIR IN KG/KG
!ETA_SI    SPECIFIC ENTROPY IN J/(KG K)
!P_SI      ABSOLUTE PRESSURE IN PA

!CHECK VALUE WITH DEFAULT SETTINGS, V1.0: 
!ice_air_h_cp_si(0.9, -100, 1e5) = 1766.84429536

!CHECK VALUE WITH DEFAULT SETTINGS, V1.1: 
!ice_air_h_cp_si(0.9, -100, 1e5) = 1766.52051488

!NOTE: THE ACCURACY OF THIS FUNCTION DEPENDS ON THE ITERATION SETTINGS FOR
!      DENSITY COMPUTED IN AIR_3A AND ON THOSE MADE IN THIS MODULE

real*8 ice_air_h_cp_si, wa_si, eta_si, p_si
real*8 t

ice_air_h_cp_si = errorreturn

t = ice_air_h_temperature_si(wa_si, eta_si, p_si)

if(t == errorreturn) return
if(t <= 0d0) return

ice_air_h_cp_si = ice_air_g_cp_si(wa_si, t, p_si)

end function

!=========================================================================
function ice_air_h_density_si(wa_si, eta_si, p_si)
!==========================================================================
                                 
!OUTPUT:
!D(A,ETA,P) = 1/(DH/DP)_A_ETA DENSITY OF ICE AIR IN KG/M3

!INPUTS:
!WA_SI     DRY-AIR MASS FRACTION OF ICE AIR IN KG/KG
!ETA_SI    SPECIFIC ENTROPY IN J/(KG K)
!P_SI      ABSOLUTE PRESSURE IN PA

!CHECK VALUE WITH DEFAULT SETTINGS, V1.0: 
!ice_air_h_density_si(0.9, -100, 1e5) = 1.42498657691

!CHECK VALUE WITH DEFAULT SETTINGS, V1.1: 
!ice_air_h_density_si(0.9, -100, 1e5) = 1.4253189599

!NOTE: THE ACCURACY OF THIS FUNCTION DEPENDS ON THE ITERATION SETTINGS FOR
!      DENSITY COMPUTED IN AIR_3A AND ON THOSE MADE IN THIS MODULE

real*8 ice_air_h_density_si, wa_si, eta_si, p_si
real*8 t

ice_air_h_density_si = errorreturn

t = ice_air_h_temperature_si(wa_si, eta_si, p_si)
if(t == errorreturn) return
if(t <= 0d0) return

ice_air_h_density_si = ice_air_g_density_si(wa_si, t, p_si)

end function

!=========================================================================
function ice_air_h_kappa_s_si(wa_si, eta_si, p_si)
!==========================================================================
                                 
!OUTPUT:
!KAPPA(A,ETA,P) = - (D2H_DP2)_A_ETA/(DH_P)_A_ETA ADIABATIC COMPRESSIBILITY OF ICE AIR IN 1/PA

!INPUTS:
!WA_SI     DRY-AIR MASS FRACTION OF ICE AIR IN KG/KG
!ETA_SI    SPECIFIC ENTROPY IN J/(KG K)
!P_SI      ABSOLUTE PRESSURE IN PA

!CHECK VALUE WITH DEFAULT SETTINGS, V1.0: 
!ice_air_h_kappa_s_si(0.9, -100, 1e5) = 8.23024116522E-06

!CHECK VALUE WITH DEFAULT SETTINGS, V1.1: 
!ice_air_h_kappa_s_si(0.9, -100, 1e5) = 8.23031581047E-06

!NOTE: THE ACCURACY OF THIS FUNCTION DEPENDS ON THE ITERATION SETTINGS FOR
!      DENSITY COMPUTED IN AIR_3A AND ON THOSE MADE IN THIS MODULE

real*8 ice_air_h_kappa_s_si, wa_si, eta_si, p_si
real*8 d, c

ice_air_h_kappa_s_si = errorreturn

d = ice_air_h_density_si(wa_si, eta_si, p_si)
if(d == errorreturn) return
if(d <= 0d0) return

c = ice_air_h_si(0, 0, 2, wa_si, eta_si, p_si)
if(c == errorreturn) return
if(c >= 0d0) return

ice_air_h_kappa_s_si = -d * c

end function

!=========================================================================
function ice_air_h_lapserate_si(wa_si, eta_si, p_si)
!==========================================================================
                                 
!OUTPUT:
!GAMMA(A,ETA,P) = (D2H/DETA DP)_A  ICE-ADIABATIC LAPSE RATE IN K/PA

!INPUTS:
!WA_SI     DRY-AIR MASS FRACTION OF ICE AIR IN KG/KG
!ETA_SI    SPECIFIC ENTROPY IN J/(KG K)
!P_SI      ABSOLUTE PRESSURE IN PA

!CHECK VALUE WITH DEFAULT SETTINGS, V1.0: 
!ice_air_h_lapserate_si(0.9, -100, 1e5) = 4.42476802729E-04

!CHECK VALUE WITH DEFAULT SETTINGS, V1.0: 
!ice_air_h_lapserate_si(0.9, -100, 1e5) = 4.42457786755E-04

!NOTE: THE ACCURACY OF THIS FUNCTION DEPENDS ON THE ITERATION SETTINGS FOR
!      DENSITY COMPUTED IN AIR_3A AND ON THOSE MADE IN THIS MODULE

real*8 ice_air_h_lapserate_si, wa_si, eta_si, p_si

ice_air_h_lapserate_si = ice_air_h_si(0, 1, 1, wa_si, eta_si, p_si)

end function

!=========================================================================
function ice_air_h_temperature_si(wa_si, eta_si, p_si)
!==========================================================================
                                 
!OUTPUT:
!T(A,ETA,P) (POTENTIAL) TEMPERATURE OF ICE AIR IN K

!INPUTS:
!WA_SI     DRY-AIR MASS FRACTION OF ICE AIR IN KG/KG
!ETA_SI    ENTROPY IN J/(KG K)
!P_SI      ABSOLUTE (REFERENCE) PRESSURE IN PA

!CHECK VALUE WITH DEFAULT SETTINGS, V1.0: 
!ice_air_h_temperature_si(0.9, -100, 1e5) = 270.382806934

!CHECK VALUE WITH DEFAULT SETTINGS, V1.1: 
!ice_air_h_temperature_si(0.9, -100, 1e5) = 270.383680119

!THIS IS THE INVERSE FUNCTION TO
!    ETA_SI = ICE_AIR_G_ENTROPY_SI(WA_SI, T_SI, P_SI)
!IN ICE_AIR_4B

!NOTE: THE ACCURACY OF THIS FUNCTION DEPENDS ON THE ITERATION SETTINGS FOR
!      DENSITY COMPUTED IN AIR_3A AND ON THOSE MADE IN THIS MODULE

real*8 ice_air_h_temperature_si, wa_si, eta_si, p_si
real*8 t, eps
integer maxit

ice_air_h_temperature_si = errorreturn

call init_it_ctrl_pottemp

select case(ctrl_mode_pottemp)
  case(0);   t = aux_ice_air_temperature_si(wa_si, eta_si, p_si)
  case default; t = ctrl_init_pottemp
end select

if(t <= 0d0) return
if(t == errorreturn) return

  if(ctrl_loop_maximum == 0) then
     maxit = 100
  elseif(ctrl_loop_maximum == (-1)) then
     ice_air_h_temperature_si = t
     return
  elseif(ctrl_loop_maximum > 0) then
     maxit = ctrl_loop_maximum
  else
     return
  endif

eps = ctrl_eps_exit_pottemp
if(eps <= 0d0) return

!RUN THE ITERATION
ice_air_h_temperature_si = pottemp_iteration(wa_si, eta_si, p_si, t, maxit, eps)

end function

!==========================================================================
function ice_air_potdensity_si(a_si, t_si, p_si, pr_si)
!==========================================================================
                               
!THIS FUNCTION COMPUTES POTENTIAL DENSITY OF ICE AIR

!OUTPUT:
!RHO_THETA(A,T,P,PR) POTENTIAL DENSITY OF ICE AIR IN KG/M³

!INPUTS:
!A_SI      ABSOLUTE DRY-AIR MASS FRACTION OF ICE AIR IN KG/KG
!T_SI      ABSOLUTE IN-SITU TEMPERATURE IN K
!P_SI      ABSOLUTE IN-SITU PRESSURE IN PA
!PR_SI     ABSOLUTE REFERENCE PRESSURE IN PA

!CHECK VALUE WITH DEFAULT SETTINGS, V1.0: 
!ice_air_potdensity_si(0.9, 230, 5e4, 1e5) = 1.45013106603

!CHECK VALUE WITH DEFAULT SETTINGS, V1.1: 
!ice_air_potdensity_si(0.9, 230, 5e4, 1e5) = 1.45048110422

!NOTE: THE ACCURACY OF THIS FUNCTION DEPENDS ON THE ITERATION SETTINGS FOR
!      DENSITY COMPUTED IN AIR_3A,
!      AND ON THE ITERATION SETTINGS FOR TEMPERATURE BY SET_IT_CTRL_ICE_AIR_POTTEMP OF THIS MODULE

real*8 ice_air_potdensity_si, a_si, t_si, p_si, pr_si
real*8 s, v

ice_air_potdensity_si = errorreturn

if(a_si < 0d0 .or. a_si >= 1d0) return
if(t_si < 0d0) return
if(p_si < 0d0) return
if(pr_si < 0d0) return

s = ice_air_g_entropy_si(a_si, t_si, p_si)  !SPECIFIC ENTROPY IN-SITU
if(s == errorreturn) return

v = ice_air_h_si(0, 0, 1, a_si, s, pr_si)   !SPECIFIC VOLUME AT REFERENCE PRESSURE
if(v == errorreturn) return
if(v <= 0d0) return

ice_air_potdensity_si = 1d0 / v

end function

!==========================================================================
function ice_air_potenthalpy_si(a_si, t_si, p_si, pr_si)
!==========================================================================
                               
!THIS FUNCTION COMPUTES POTENTIAL ENTHALPY OF ICE AIR

!OUTPUT:
!H_THETA(A,T,P,PR) POTENTIAL ENTHALPY OF ICE AIR IN J/KG

!INPUTS:
!A_SI      ABSOLUTE DRY-AIR MASS FRACTION OF ICE AIR IN KG/KG
!T_SI      ABSOLUTE IN-SITU TEMPERATURE IN K
!P_SI      ABSOLUTE IN-SITU PRESSURE IN PA
!PR_SI     ABSOLUTE REFERENCE PRESSURE IN PA

!CHECK VALUE WITH DEFAULT SETTINGS, V1.0: 
!ice_air_potenthalpy_si(0.9, 230, 5e4, 1e5) = -35779.7348519

!CHECK VALUE WITH DEFAULT SETTINGS, V1.1: 
!ice_air_potenthalpy_si(0.9, 230, 5e4, 1e5) = -35781.2564451

!NOTE: THE ACCURACY OF THIS FUNCTION DEPENDS ON THE ITERATION SETTINGS FOR
!      DENSITY COMPUTED IN AIR_3A,
!      AND ON THE ITERATION SETTINGS FOR TEMPERATURE BY SET_IT_CTRL_ICE_AIR_POTTEMP OF THIS MODULE

real*8 ice_air_potenthalpy_si, a_si, t_si, p_si, pr_si
real*8 s

ice_air_potenthalpy_si = errorreturn

if(a_si < 0d0 .or. a_si >= 1d0) return
if(t_si < 0d0) return
if(p_si < 0d0) return
if(pr_si < 0d0) return

s = ice_air_g_entropy_si(a_si, t_si, p_si)  !SPECIFIC ENTROPY IN-SITU
if(s == errorreturn) return

ice_air_potenthalpy_si = ice_air_h_si(0, 0, 0, a_si, s, pr_si)

end function

!==========================================================================
function ice_air_pottemp_si(a_si, t_si, p_si, pr_si)
!==========================================================================
                               
!THIS FUNCTION COMPUTES POTENTIAL TEMPERATURE OF ICE AIR

!OUTPUT:
!THETA(A,T,P,PR) ABSOLUTE POTENTIAL TEMPERATURE OF ICE AIR IN K

!INPUTS:
!A_SI      ABSOLUTE DRY-AIR MASS FRACTION IN KG/KG
!T_SI      ABSOLUTE IN-SITU TEMPERATURE IN K
!P_SI      ABSOLUTE IN-SITU PRESSURE IN PA
!PR_SI     ABSOLUTE REFERENCE PRESSURE IN PA

!CHECK VALUE WITH DEFAULT SETTINGS, V1.0: 
!ice_air_pottemp_si(0.9, 230, 5E4, 1E5) = 266.106323310

!CHECK VALUE WITH DEFAULT SETTINGS, V1.1: 
!ice_air_pottemp_si(0.9, 230, 5E4, 1E5) = 266.105208871

!NOTE: THE ACCURACY OF THIS FUNCTION DEPENDS ON THE ITERATION SETTINGS FOR
!      DENSITY COMPUTED IN AIR_3A,
!      AND ON THE ITERATION SETTINGS FOR TEMPERATURE BY SET_IT_CTRL_ICE_AIR_POTTEMP OF THIS MODULE_SI

real*8 ice_air_pottemp_si, a_si, t_si, p_si, pr_si
real*8 s

ice_air_pottemp_si = errorreturn

if(a_si < 0d0 .or. a_si >= 1d0) return
if(t_si < 0d0) return
if(p_si < 0d0) return
if(pr_si < 0d0) return

if(p_si == pr_si) then
  ice_air_pottemp_si = t_si
  return
end if

s = ice_air_g_entropy_si(a_si, t_si, p_si)  !SPECIFIC ENTROPY IN-SITU
if(s == errorreturn) return

ice_air_pottemp_si = ice_air_h_temperature_si(a_si, s, pr_si)

end function

!=========================================================================
function pottemp_iteration(wa_si, eta_si, p_si, t_si, maxit, eps)
!==========================================================================

!OUTPUT:
!THETA =  ABSOLUTE POTENTIAL TEMPERATURE OF ICE AIR IN K,
!         I.E. THE TEMPERATURE THAT SOLVES THE EQUATION

!INPUTS:
!          ETA_SI = ICE_AIR_G_ENTROPY_SI(WA_SI, THETA, P_SI)
!WA_SI     DRY-AIR MASS FRACTION OF ICE AIR IN KG/KG
!ETA_SI    ENTROPY IN J/(KG K)
!P_SI      ABSOLUTE (REFERENCE) PRESSURE IN PA
!T_SI      ABSOLUTE (POTENTIAL) TEMPERATURE IN K, INITIAL VALUE
!MAXIT     MAX. NUMBER OF ITERATIONS
!EPS       REQUIRED TOLERANCE IN K

real*8 pottemp_iteration, wa_si, eta_si, p_si, t_si, eps
real*8 s, theta, cp, dt
integer i, maxit

pottemp_iteration = errorreturn

if(wa_si < 0d0 .or. wa_si > 1d0 .or. &
  eps <= 0d0 .or. &
  maxit <= 0) return

if(check_limits == 1) then
  !ICE_LIMITS
  if(t_si <= ice_tmin .or. t_si > ice_tmax .or. &
  p_si <= ice_pmin .or. p_si > ice_pmax) return
  !AIR_LIMITS
  if(t_si < dry_air_tmin .or. t_si > dry_air_tmax) return
else
  if(t_si <= 0d0 .or. &
     p_si <= 0d0) return
endif

check_limits = check_limits - 1

theta = t_si

do i = 1, maxit

  !GET ENTROPY AND ITS FIRST DERIVATIVE FOR NEWTON ITERATION
  s = ice_air_g_entropy_si(wa_si, theta, p_si)
  cp = ice_air_g_cp_si(wa_si, theta, p_si)
    
  if(s == errorreturn) go to 999
  if(cp == errorreturn) go to 999
  if(cp <= 0d0) go to 999
  
  !NEXT TEMPERATURE IMPROVEMENT STEP
  dt = theta * (eta_si - s) / cp
  theta = theta + dt
  if(theta <= 0d0) go to 999
    
  if(abs(dt) < eps) then
    pottemp_iteration = theta
    go to 999
  end if
  
enddo

999 continue

check_limits = check_limits + 1

if(check_limits == 1) then
  !ICE_LIMITS
  if(theta <= ice_tmin .or. theta > ice_tmax) then
    pottemp_iteration = errorreturn
    return
  endif
  !AIR_LIMITS
  if(theta < dry_air_tmin .or. theta > dry_air_tmax) then
    pottemp_iteration = errorreturn
    return
  endif
endif

end function

!==========================================================================
function ice_air_a_eta_p_derivatives_si(drv_wa, drv_eta, drv_p, wa_si, t_si, p_si)
!==========================================================================
                                              
!THIS FUNCTION COMPUTES ICE-AIR WA-ETA-P DERIVATIVES OF H FROM WA-T-P DERIVATIVES OF G

real*8 ice_air_a_eta_p_derivatives_si, wa_si, t_si, p_si
real*8 g, g_t, g_p, g_a
real*8 g_aa, g_at, g_ap
real*8 g_tt, g_pp, g_tp

real*8 h
 
integer drv_wa, drv_eta, drv_p

!IN ONE CASE WE DO NOT AT ALL NEED TO COMPUTE THE GIBBS FUNCTION:
if(drv_wa == 0 .and. drv_eta == 1 .and. drv_p == 0) then
  ice_air_a_eta_p_derivatives_si = t_si
  return
end if

ice_air_a_eta_p_derivatives_si = errorreturn
g_tp = errorreturn

select case(drv_wa)

  case(0)
    select case(drv_eta)
    
      case(0)
        select case(drv_p)
        
          case(0) 
            g = ice_air_g_si(0, 0, 0, wa_si, t_si, p_si)
            if(g == errorreturn) return
            g_t = ice_air_g_si(0, 1, 0, wa_si, t_si, p_si)
            if(g_t == errorreturn) return
            h = g - t_si * g_t                          !H
          
          case(1)
            g_p = ice_air_g_si(0, 0, 1, wa_si, t_si, p_si)
            if(g_p == errorreturn) return
            h = g_p                                      !DH/DP
                  
          case(2)
            g_tt = ice_air_g_si(0, 2, 0, wa_si, t_si, p_si)
            if(g_tt == errorreturn) return
            if(g_tt == 0d0) return
            g_tp = ice_air_g_si(0, 1, 1, wa_si, t_si, p_si)
            if(g_tp == errorreturn) return
            g_pp = ice_air_g_si(0, 0, 2, wa_si, t_si, p_si)
            if(g_pp == errorreturn) return
            h = (g_tt * g_pp - g_tp**2) / g_tt           !D2H/DP2
                  
          case default; return
        end select
        
      case(1)
        select case(drv_p)
          case(0)
            h = t_si                                     !DH/DETA, HAS ALREADY BEEN HANDLED INITIALLY
          
          case(1)
            g_tt = ice_air_g_si(0, 2, 0, wa_si, t_si, p_si)
            if(g_tt == errorreturn) return
            if(g_tt == 0d0) return
            g_tp = ice_air_g_si(0, 1, 1, wa_si, t_si, p_si)
            if(g_tp == errorreturn) return
            h = -g_tp / g_tt                             !D2H/DETADP
                  
          case default; return
        end select

      case(2)
        select case(drv_p)
          case(0) 
            g_tt = ice_air_g_si(0, 2, 0, wa_si, t_si, p_si)
            if(g_tt == errorreturn) return
            if(g_tt == 0d0) return
            h = -1d0 / g_tt                              !D2H/DETA2
                  
          case default; return
        end select

      case default; return
    end select
    
  case(1)
    select case(drv_eta)
    
      case(0)
        select case(drv_p)
        
          case(0)
            g_a = ice_air_g_si(1, 0, 0, wa_si, t_si, p_si)
            if(g_a == errorreturn) return
            h = g_a                                      !DH/DA
          
          case(1)
            g_tt = ice_air_g_si(0, 2, 0, wa_si, t_si, p_si)
            if(g_tt == errorreturn) return
            if(g_tt == 0d0) return
            g_at = ice_air_g_si(1, 1, 0, wa_si, t_si, p_si)
            if(g_at == errorreturn) return
            g_ap = ice_air_g_si(1, 0, 1, wa_si, t_si, p_si)
            if(g_ap == errorreturn) return
            h = (g_tt * g_ap - g_at * g_tp) / g_tt       !D2H/DADP
          
          case default; return
        end select

      case(1)
        select case(drv_p)
        
          case(0)
            g_tt = ice_air_g_si(0, 2, 0, wa_si, t_si, p_si)
            if(g_tt == errorreturn) return
            if(g_tt == 0d0) return
            g_at = ice_air_g_si(1, 1, 0, wa_si, t_si, p_si)
            if(g_at == errorreturn) return
            h = -g_at / g_tt                             !D2H/DADETA
          
          case default; return
        end select

      case default; return
    end select

  
  case(2)
    select case(drv_eta)
    
      case(0)
        select case(drv_p)
        
          case(0) 
            g_tt = ice_air_g_si(0, 2, 0, wa_si, t_si, p_si)
            if(g_tt == errorreturn) return
            if(g_tt == 0d0) return
            g_at = ice_air_g_si(1, 1, 0, wa_si, t_si, p_si)
            if(g_at == errorreturn) return
            g_aa = ice_air_g_si(2, 0, 0, wa_si, t_si, p_si)
            if(g_aa == errorreturn) return
            h = (g_tt * g_aa - g_at**2) / g_tt           !D2H/DA2
          
          case default; return
        end select

      case default; return
    end select

  case default; return
end select

ice_air_a_eta_p_derivatives_si = h

end function

!=========================================================================
function aux_ice_air_temperature_si(wa_si, eta_si, p_si)
!==========================================================================

!THIS FUNCTION ESTIMATES THE TEMPERATURE OF ICE AIR FROM ITS DRY-AIR FRACTION WA_SI IN KG/KG,
!ITS SPECIFIC ENTROPY ETA_SI IN J/(KG K), AND ITS ABSOLUTE PRESSURE, P_SI IN PA

real*8 aux_ice_air_temperature_si, wa_si, eta_si, p_si
real*8 numer, denom, t, tf

real*8 tt, pt, cpa, cpi, sat, sit, ra

tt = tp_temperature_si           !TRIPLE-POINT TEMPERATURE IN K
pt = tp_pressure_iapws95_si      !TRIPLE-POINT PRESSURE IN Pa

cpa = 1003.68997553091d0         !TRIPLE-POINT HEAT CAPACITY OF AIR IN J/(KG K)
cpi = 2096.78431621667d0         !TRIPLE-POINT HEAT CAPACITY OF ICE IN J/(KG K)

sat = 1467.66694249983d0         !TRIPLE-POINT ENTROPY OF AIR IN J/(KG K)
sit = -1220.69433939648d0        !TRIPLE-POINT ENTROPY OF ICE IN J/(KG K)

ra = gas_constant_air_si

aux_ice_air_temperature_si = errorreturn
if(p_si <= 0d0) return
if(wa_si < 0d0 .or. wa_si > 1d0) return

!ASSUME CONSTANT HEAT CAPACITY CP OF ICE AND AIR, USE IDEAL-GAS EQUATION,
!NEGLECT THE VAPOUR FRACTION IN HUMID AIR:

numer = eta_si - sit - wa_si * (sat - sit - ra * log(p_si / pt))

denom = cpi + wa_si * (cpa - cpi)
if(denom == 0d0) return

t = tt * exp(numer / denom)

!IF ESTIMATE IS ABOVE THE FREEZING POINT, RATHER TAKE THE FREEZING POINT
tf = ice_liq_meltingtemperature_si(p_si)
if(tf /= errorreturn .and. tf > 0) then
  if(t > tf) t = tf
end if

aux_ice_air_temperature_si = t

end function

!==========================================================================
subroutine init_it_ctrl_pottemp()

if(ctrl_initialized == -1) return

ctrl_initialized = -1

!SET DEFAULT VALUES AND MODES FOR TEMPERATURE ITERATION
ctrl_loop_maximum = 100
ctrl_mode_pottemp = 0           !DEFAULT: THETA = AUX_ICE_AIR_TEMPERATURE_SI
ctrl_init_pottemp = 273.15d0
ctrl_eps_exit_pottemp = 0.0001d0  !DEFAULT = 0.1 MK

end subroutine

!==========================================================================
subroutine set_it_ctrl_ice_air_pottemp(key, value)

!THIS SUBROUTINE SETS CONTROL PARAMETERS FOR THE NEWTON ITERATION 
!USED TO COMPUTE POTENTIAL TEMPERATURE FROM REFERENCE PRESSURE

!KEY             VALUE
!IT_STEPS        0           SET ITERATION NUMBER TO DEFAULT (100)
!IT_STEPS        N > 0    SET ITERATION NUMBER TO N
!IT_STEPS       -1           DO NOT ITERATE, USE INITIAL VALUE

!INIT_THETA      0           USE DEFAULT POTENTIAL TEMPERATURE THETA = AUX_TEMPERATURE_MIN_SI TO START
!INIT_THETA      T > 0    USE VALUE T AS POTENTIAL TEMPERATURE TO START

!TOL_THETA       0           USE DEFAULT EXIT ACCURACY FOR POTENTIAL TEMPERATURE (0.1 MK)
!TOL_THETA       EPS > 0  USE EPS AS EXIT ACCURACY FOR POTENTIAL TEMPERATURE

real*8 value
character*13 key

call init_it_ctrl_pottemp

select case (trim(key))

  case ("it_steps");   !ITERATION STEPS
      if(value == 0d0)then
         ctrl_loop_maximum = 100      !DEFAULT = 100
      elseif(value < 0d0) then
         ctrl_loop_maximum = -1
      else
         ctrl_loop_maximum = nint(value)
      endif

  case ("init_theta");   !START THETA
      if(value == 0d0) then
         ctrl_mode_pottemp = 0        !DEFAULT: AUX_TEMPERATURE_MIN_SI
      elseif(value > 0d0) then
         ctrl_mode_pottemp = 1
         ctrl_init_pottemp = value
      endif

  case ("tol_theta");                 !REQUIRED THETA TOLERANCE
      if(value == 0d0) then
         ctrl_eps_exit_pottemp = 0.0001d0 !DEFAULT = 0.1 MK
      elseif(value > 0d0) then
         ctrl_eps_exit_pottemp = value
      endif

  case default; write(*,*)key,' not supported'

end select

end subroutine

end module ice_air_4c

module liq_f03_5

!#########################################################################

!THIS MODULE IMPLEMENTS THE GIBBS POTENTIALS OF LIQUID WATER AND ITS
!FIRST AND SECOND PARTIAL DERIVATIVES WITH RESPECT TO TEMPERATURE AND
!DENSITY, AS DEFINED CONSISTENTLY WITH IAPWS-95 FOR THE OCEANOGRAPHIC
!RANGE -6 - 40 °C, 0 - 100 MPA, IN THE ARTICLE:

!R. FEISTEL:
!A NEW EXTENDED GIBBS THERMODYNAMIC POTENTIAL OF SEAWATER.
!PROGRESS IN OCEANOGRAPHY, 58 (2003) 43-115

!AND IN THE IAPWS-09 DOCUMENT:
!SUPPLEMENTARY RELEASE ON A COMPUTATIONALLY EFFICIENT THERMODYNAMIC FORMULATION
!FOR LIQUID WATER FOR OCEANOGRAPHIC USE.
!THE INTERNATIONAL ASSOCIATION FOR THE PROPERTIES OF WATER AND STEAM
!DOORWERTH, THE NETHERLANDS, SEPTEMBER 2009

!#########################################################################

!IMPLEMENTATION IN FORTRAN BY D.G. WRIGHT
!FOR PUBLICATION IN OCEAN SCIENCE, AS DESCRIBED IN THE PAPERS

!FEISTEL, R., WRIGHT, D.G., JACKETT, D.R., MIYAGAWA, K., REISSMANN, J.H.,
!WAGNER, W., OVERHOFF, U., GUDER, C., FEISTEL, A., MARION, G.M.:
!NUMERICAL IMPLEMENTATION AND OCEANOGRAPHIC APPLICATION OF THE THERMODYNAMIC
!POTENTIALS OF WATER, VAPOUR, ICE, SEAWATER AND AIR. PART I: BACKGROUND AND EQUATIONS. 
!OCEAN SCIENCES, 2009, IN PREPARATION.

!WRIGHT, D.G., FEISTEL, R., JACKETT, D.R., MIYAGAWA, K., REISSMANN, J.H., 
!WAGNER, W., OVERHOFF, U., GUDER, C., FEISTEL, A., MARION, G.M.:
!NUMERICAL IMPLEMENTATION AND OCEANOGRAPHIC APPLICATION OF THE THERMODYNAMIC
!POTENTIALS OF WATER, VAPOUR, ICE, SEAWATER AND AIR. PART II: THE LIBRARY ROUTINES, 
!OCEAN SCIENCES., 2009, IN PREPARATION.

!FEISTEL, R., KRETZSCHMAR, H.-J., SPAN, R., HAGEN, E., WRIGHT, D.G., JACKETT, D.R.:
!THERMODYNAMIC PROPERTIES OF SEA AIR.
!OCEAN SCIENCE DISCUSSION 6(2009)2193-2325.

!#########################################################################

!THIS MODULE REQUIRES THE LIBRARY MODULE
!     CONSTANTS_0, FILE CONSTANTS_0.F90

!#########################################################################

use constants_0

implicit none
private

character*16, private :: version = '8 Jun 2010'

public :: chk_iapws09_table6, &
          fit_liq_cp_f03_si, fit_liq_density_f03_si, &
          fit_liq_expansion_f03_si, fit_liq_g_f03_si, &
          fit_liq_kappa_t_f03_si, fit_liq_soundspeed_f03_si

real*8, private :: gc03(0:7, 0:6)

contains

!==========================================================================
function fit_liq_g_f03_si(drv_t, drv_p, t_si, p_si)
!==========================================================================

!THIS FUNCTION IMPLEMENTS THE GIBBS FUNCTION OF PURE WATER AS DEFINED IN
!R. FEISTEL:
!A NEW EXTENDED GIBBS THERMODYNAMIC POTENTIAL OF SEAWATER.
!PROGRESS IN OCEANOGRAPHY, 58 (2003) 43-115

!CHECK VALUES:
!FIT_LIQ_G_F03_SI(0,0,300,1E5) =  -0.526505056073E+04
!FIT_LIQ_G_F03_SI(1,0,300,1E5) =  -0.393062597709E+03
!FIT_LIQ_G_F03_SI(0,1,300,1E5) =   0.100345554745E-02
!FIT_LIQ_G_F03_SI(2,0,300,1E5) =  -0.139354762020E+02
!FIT_LIQ_G_F03_SI(1,1,300,1E5) =   0.275754520492E-06
!FIT_LIQ_G_F03_SI(0,2,300,1E5) =  -0.452067557155E-12


implicit none

integer drv_t, drv_p
real*8 fit_liq_g_f03_si
real*8 t_si, p_si
real*8 t0, tu, p0, pu
real*8 y, z, g

t0 = celsius_temperature_si     !IN K
tu = 40d0                       !IN K
p0 = sealevel_pressure_si       !IN PA
pu = 100000000d0 !in pa

fit_liq_g_f03_si = errorreturn

if(drv_t < 0) return
if(drv_p < 0) return
if(t_si <= 0d0) return
if(p_si <= 0d0) return

call init_f03

y = (t_si - t0) / tu
z = (p_si - p0) / pu

g = polyf03_gyz(drv_t, drv_p, y, z)
if(g == errorreturn) return

fit_liq_g_f03_si = g / (tu ** drv_t * pu ** drv_p)

end function

!==========================================================================
function fit_liq_cp_f03_si(t_si, p_si)
!==========================================================================

!THIS FUNCTION RETURNS THE HEAT CAPACITY CP OF LIQUID WATER COMPUTED FROM THE
!GIBBS FUNCTION 2003 OF SEAWATER AS A FUNCTION OF TEMPERATURE
!AND PRESSURE, PUBLISHED IN

!R. FEISTEL:
!A NEW EXTENDED GIBBS THERMODYNAMIC POTENTIAL OF SEAWATER.
!PROGRESS IN OCEANOGRAPHY, 58/1 (2003) 43-115

!OUTPUT:  
!FIT_LIQ_DENSITY_F03_SI: CP IN J/(KG K)

!INPUT:   
!T_SI: ABSOLUTE TEMPERATURE IN K
!P_SI: ABSOLUTE PRESSURE IN PA

!CHECK VALUE:
!FIT_LIQ_CP_F03_SI(300, 1E5) = 0.418064286060E+04

real*8 fit_liq_cp_f03_si, t_si, p_si
real*8 g_tt 

fit_liq_cp_f03_si = errorreturn

if (t_si <= 0d0) return
if (p_si <= 0d0) return

g_tt = fit_liq_g_f03_si(2, 0, t_si, p_si)

if (g_tt == errorreturn) return
if (g_tt >= 0d0) return

fit_liq_cp_f03_si = -t_si * g_tt

end function

!==========================================================================
function fit_liq_density_f03_si(t_si, p_si)
!==========================================================================

!THIS FUNCTION RETURNS THE DENSITY OF LIQUID WATER COMPUTED FROM THE
!GIBBS FUNCTION 2003 OF SEAWATER AS A FUNCTION OF TEMPERATURE
!AND PRESSURE, PUBLISHED IN

!R. FEISTEL:
!A NEW EXTENDED GIBBS THERMODYNAMIC POTENTIAL OF SEAWATER.
!PROGRESS IN OCEANOGRAPHY, 58/1 (2003) 43-115

!OUTPUT:  
!FIT_LIQ_DENSITY_F03_SI: DENSITY IN KG/M3

!INPUT:   
!T_SI: ABSOLUTE TEMPERATURE IN K
!P_SI: ABSOLUTE PRESSURE IN PA

!CHECK VALUE:
!FIT_LIQ_DENSITY_F03_SI(300, 1E5) = 0.996556352243E+03

implicit none

real*8 fit_liq_density_f03_si
real*8 t_si, p_si
real*8 d

fit_liq_density_f03_si = errorreturn

if(t_si <= 0d0) return
if(p_si <= 0d0) return

d = fit_liq_g_f03_si(0, 1, t_si, p_si)

if(d == errorreturn) return
if(d <= 0d0) return

fit_liq_density_f03_si = 1d0 / d

end function

!==========================================================================
function fit_liq_expansion_f03_si(t_si, p_si)
!==========================================================================

!THIS FUNCTION RETURNS THE THERMAL EXPANSION OF LIQUID WATER COMPUTED FROM THE
!GIBBS FUNCTION 2003 OF SEAWATER AS A FUNCTION OF TEMPERATURE
!AND PRESSURE, PUBLISHED IN

!R. FEISTEL:
!A NEW EXTENDED GIBBS THERMODYNAMIC POTENTIAL OF SEAWATER.
!PROGRESS IN OCEANOGRAPHY, 58/1 (2003) 43-115

!OUTPUT:  
!FIT_LIQ_EXPANSION_F03_SI: ALPHA IN 1/K

!INPUT:   
!T_SI: ABSOLUTE TEMPERATURE IN K
!P_SI: ABSOLUTE PRESSURE IN PA

!CHECK VALUE:
!FIT_LIQ_EXPANSION_F03_SI(300, 1E5) = 0.274804919056E-03

real*8 fit_liq_expansion_f03_si
real*8 t_si, p_si
real*8 g_p, g_tp

fit_liq_expansion_f03_si = errorreturn

if (t_si <= 0d0)return
if (p_si <= 0d0)return

g_p = fit_liq_g_f03_si(0, 1, t_si, p_si)
if (g_p == errorreturn) return
if (g_p <= 0d0) return

g_tp = fit_liq_g_f03_si(1, 1, t_si, p_si)
if (g_tp == errorreturn) return

fit_liq_expansion_f03_si = g_tp / g_p

end function

!==========================================================================
function fit_liq_kappa_t_f03_si(t_si, p_si)
!==========================================================================

!THIS FUNCTION RETURNS THE ISOTHERMAL COMPRESSIBILITY OF LIQUID WATER COMPUTED FROM THE
!GIBBS FUNCTION 2003 OF SEAWATER AS A FUNCTION OF TEMPERATURE
!AND PRESSURE, PUBLISHED IN

!R. FEISTEL:
!A NEW EXTENDED GIBBS THERMODYNAMIC POTENTIAL OF SEAWATER.
!PROGRESS IN OCEANOGRAPHY, 58/1 (2003) 43-115

!OUTPUT:  
!FIT_LIQ_KAPPA_T_F03_SI: KAPPA_T IN 1/PA

!INPUT:   
!T_SI: ABSOLUTE TEMPERATURE IN K
!P_SI: ABSOLUTE PRESSURE IN PA

!CHECK VALUE:
!FIT_LIQ_KAPPA_T_F03_SI(300, 1E5) = 0.450510795725E-09

real*8 fit_liq_kappa_t_f03_si, t_si, p_si
real*8 g_p, g_pp

fit_liq_kappa_t_f03_si = errorreturn

if (t_si <= 0d0) return
if (p_si <= 0d0) return

g_p = fit_liq_g_f03_si(0, 1, t_si, p_si)
if (g_p == errorreturn) return
if (g_p <= 0d0) return

g_pp = fit_liq_g_f03_si(0, 2, t_si, p_si)
if (g_pp == errorreturn) return
if (g_pp >= 0d0) return

fit_liq_kappa_t_f03_si = -g_pp / g_p

end function

!==========================================================================
function fit_liq_soundspeed_f03_si(t_si, p_si)
!==========================================================================

!THIS FUNCTION RETURNS THE SOUND SPEED OF LIQUID WATER COMPUTED FROM THE
!GIBBS FUNCTION 2003 OF SEAWATER AS A FUNCTION OF TEMPERATURE
!AND PRESSURE, PUBLISHED IN

!R. FEISTEL:
!A NEW EXTENDED GIBBS THERMODYNAMIC POTENTIAL OF SEAWATER.
!PROGRESS IN OCEANOGRAPHY, 58/1 (2003) 43-115

!OUTPUT:  
!FIT_LIQ_SOUNDSPEED_F03_SI: SPEED IN M/S

!INPUT:   
!T_SI: ABSOLUTE TEMPERATURE IN K
!P_SI: ABSOLUTE PRESSURE IN PA

!CHECK VALUE:
!FIT_LIQ_SOUNDSPEED_F03_SI(300, 1e5) = 0.150152808421E+04

real*8 fit_liq_soundspeed_f03_si, t_si, p_si
real*8  g_p, g_tt, g_tp, g_pp, c

fit_liq_soundspeed_f03_si = errorreturn

if (t_si <= 0d0) return
if (p_si <= 0d0) return

g_p = fit_liq_g_f03_si(0, 1, t_si, p_si)
if (g_p == errorreturn) return
if( g_p <= 0d0) return

g_tt = fit_liq_g_f03_si(2, 0, t_si, p_si)
if (g_tt == errorreturn) return
if (g_tt >= 0d0) return

g_tp = fit_liq_g_f03_si(1, 1, t_si, p_si)
if (g_tp == errorreturn) return

g_pp = fit_liq_g_f03_si(0, 2, t_si, p_si)
if (g_pp == errorreturn) return
if (g_pp >= 0d0) return

c = g_tp * g_tp - g_tt * g_pp
if (c == 0d0) return
c = g_tt / c
if (c < 0d0) return

fit_liq_soundspeed_f03_si = g_p * sqrt(c)

end function

!==========================================================================
function polyf03_gyz(drv_y, drv_z, y, z)
!==========================================================================

!RETURNS THE VALUE OF THE POLYNOMIAL DERIVATIVE
!(D/DY)^DRV_Y (D/DZ)^DRV_Z SUM(J,K) GC03(J,K)*Y^J*Z^K

implicit none

integer drv_y, drv_z
integer j, jmax
integer k, kmax
integer l
integer maxt, maxp
real*8 polyf03_gyz, g
real*8 y, z
real*8 yj, zk
real*8 c

maxt = 7
maxp = 6

g = 0d0
if(y == 0d0) then 
   jmax = drv_y 
else 
   jmax = maxt
endif

if(z == 0d0) then 
   kmax = drv_z 
else 
   kmax = maxp
endif

yj = 1d0
do j = drv_y, jmax   !loop over powers of y

  zk = 1d0
  do k = drv_z, kmax    !loop over powers of z

    if(gc03(j, k) /= 0d0) then
      c = gc03(j, k) * yj * zk

      do l = 1, drv_y            !factors from y-derivatives
        c = c * dfloat(j - l + 1)
      enddo

      do l = 1, drv_z            !factors from z-derivatives
        c = c * dfloat(k - l + 1)
      enddo

      g = g + c
    end if

    if(k < kmax) zk = zk * z

  enddo

  if(j < jmax) yj = yj * y
enddo

polyf03_gyz = g

end function

!==========================================================================
subroutine init_f03
!==========================================================================

! G(T,P) = SUM GC03(J,K) * (T/40°C)^J * (P/100 MPA)^K
!          J,K

implicit none

real*8 g, g_t, g_p
real*8 tt, t0, tu, pt, p0, pu, yt, zt

tt = tp_temperature_si
t0 = celsius_temperature_si
tu = 40d0

pt = tp_pressure_iapws95_si !iapws-95 triple point pressure
p0 = sealevel_pressure_si
pu = 100000000d0

!WRITE(*,*)"TT, T0, TU =", tt, t0, tu
!WRITE(*,*)"PT, P0, PU =", pt, p0, pu
yt = (tt - t0) / tu
zt = (pt - p0) / pu

if(gc03(2, 0) == -12357.785933039d0) return

gc03 = 0d0

gc03(2, 0) = -12357.785933039d0
gc03(3, 0) = 736.741204151612d0
gc03(4, 0) = -148.185936433658d0
gc03(5, 0) = 58.0259125842571d0
gc03(6, 0) = -18.9843846514172d0
gc03(7, 0) = 3.05081646487967d0
gc03(0, 1) = 100015.695367145d0
gc03(1, 1) = -270.983805184062d0
gc03(2, 1) = 1455.0364540468d0
gc03(3, 1) = -672.50778314507d0
gc03(4, 1) = 397.968445406972d0
gc03(5, 1) = -194.618310617595d0
gc03(6, 1) = 63.5113936641785d0
gc03(7, 1) = -9.63108119393062d0
gc03(0, 2) = -2544.5765420363d0
gc03(1, 2) = 776.153611613101d0
gc03(2, 2) = -756.558385769359d0
gc03(3, 2) = 499.360390819152d0
gc03(4, 2) = -301.815380621876d0
gc03(5, 2) = 120.520654902025d0
gc03(6, 2) = -22.2897317140459d0
gc03(0, 3) = 284.517778446287d0
gc03(1, 3) = -196.51255088122d0
gc03(2, 3) = 273.479662323528d0
gc03(3, 3) = -239.545330654412d0
gc03(4, 3) = 152.196371733841d0
gc03(5, 3) = -55.2723052340152d0
gc03(6, 3) = 8.17060541818112d0
gc03(0, 4) = -33.3146754253611d0
gc03(1, 4) = 28.9796526294175d0
gc03(1, 4) = 28.9796526294175d0
gc03(2, 4) = -55.5604063817218d0
gc03(2, 4) = -55.5604063817218d0
gc03(3, 4) = 48.8012518593872d0
gc03(4, 4) = -26.3748377232802d0
gc03(5, 4) = 6.48190668077221d0
gc03(0, 5) = 4.20263108803084d0
gc03(1, 5) = -2.13290083518327d0
gc03(2, 5) = 4.34420671917197d0
gc03(3, 5) = -1.66307106208905d0
gc03(0, 6) = -0.546428511471039d0

!IAPWS-95 REFERENCE STATE CONDITION
!ENERGY = 0 AND ENTROPY = 0 AT THE TRIPLE POINT:
!THESE ARE ONLY USED AS A FIRST GUESS HERE SO HIGH ACCURACY IS NOT REQUIRED.
!GC03(0, 0) = 101.342743139672D0
GC03(0, 0) = 101.342743139674D0
!GC03(1, 0) = 5.90578348518236D0
gc03(1, 0) =  5.90578347909402d0

!NEVERTHELESS, THE ACCURACY CAN BE IMPROVED FOLLOWING KIYOSHI'S SUGGESTION.
!ADJUSTMENT OF COEFFICIENTS


!WRITE(*,*)"GC00, GC10: FIRST ESTIMATES = ", gc03(0,0), gc03(1,0)

g = polyf03_gyz(0, 0, yt, zt)
g_t = polyf03_gyz(1, 0, yt, zt) / tu
g_p = polyf03_gyz(0, 1, yt, zt) / pu

!WRITE(*,*)'G,G_T,G_P=',G,G_T,G_P
gc03(0, 0) = gc03(0, 0) - g + pt * g_p
gc03(1, 0) = gc03(1, 0) - g_t * tu

!WRITE(*,*)"GC00, GC10: SECOND ESTIMATES = ", gc03(0,0), gc03(1,0)

end subroutine

!==========================================================================
subroutine chk_iapws09_table6
!==========================================================================

!TABLE 6  NUMERICAL CHECK VALUES FOR THE GIBBS FUNCTION G AND ITS DERIVATIVES, TABLE 4,
!THE NUMERICAL FUNCTIONS EVALUATED HERE AT GIVEN POINTS (T, P) ARE DEFINED IN TABLES 3 AND 4.
!
!QUANTITY       VALUE              VALUE             VALUE          UNIT
!T              273.15             273.15            313.15         K
!P              101325             1E8               101325         PA
!G             0.101342743E3     0.977303868E5    -0.116198898E5    J KG-1
!(DG/DT)_P     0.147644587       0.851506346E1    -0.572365181E3    J KG-1 K-1
!(DG/DP)_T     0.100015695E-2    0.956683354E-3    0.100784471E-2   M3 KG-1
!(D2G/DT2)_P  -0.154472324E2    -0.142970174E2    -0.133463968E2    J KG-1 K-2
! D2G/DTDP    -0.677459513E-7    0.199088060E-6    0.388499694E-6   M3 KG-1 K-1
!(D2G/DP2)_T  -0.508915308E-12  -0.371527164E-12  -0.445841077E-12  M3 KG-1 Pa-1
!H             0.610136242E2     0.954044973E5     0.167616267E6    J KG-1
!F             0.183980891E-2    0.206205140E4    -0.117220097E5    J KG-1
!U            -0.403272791E2    -0.263838183E3     0.167514147E6    J KG-1
!S            -0.147644587      -0.851506346E1     0.572365181E3    J KG-1 K-1
!RHO           0.999843071E3     0.104527793E4     0.992216354E3    KG M-3
!CP            0.421941153E4     0.390523030E4     0.417942416E4    J KG-1 K-1
!W             0.140240099E4     0.157543089E4     0.152891242E4    M S-1

real*8 t, p, q(3)
integer i, j

                                            
write(*,*) " "
write(*,*) " "
write(*,*) " "
write(*,*) "****************************************************************"
write(*,*) "****************************************************************"
write(*,*) "****************************************************************"
write(*,*) " "
write(*,*) "Implementation of IAPWS-09 in Fortran"
write(*,*) "for Publication in Ocean Science, 2009"
write(*,*) "D. Wright, BIO, VERSION ", version
write(*,*) " "

write(*,*) "Function values as given in Table 6 of IAPWS-09:"
write(*,*) "Top row is tabulated value; bottom calculated now"
write(*,*) " "

write(*,*) "Quantity    Value            Value             Value          Unit" 
write(*,*) " "

do i = 1, 15
  Select Case (i)
    Case (1);  write(*,*) "T           273.15           273.15            313.15          K"
    Case (2);  write(*,*) "p           101325           1E8               101325          Pa";
               write(*,*) " "
    Case (3);  write(*,*) "g         0.101342743E+3    0.977303868E+5   -0.116198898E+5   J kg-1"
    Case (4);  write(*,*) "dg/dT     0.147644587       0.851506346E+1   -0.572365181E+3   J kg-1 K-1"
    Case (5);  write(*,*) "dg/dp     0.100015695E-2    0.956683354E-3    0.100784471E-2   m3 kg-1"
    Case (6);  write(*,*) "d2g/dT2  -0.154472324E+2   -0.142970174E+2   -0.133463968E+2   J kg-1 K-2"
    Case (7);  write(*,*) "d2g/dTdp -0.677459513E-7    0.199088060E-6    0.388499694E-6   m3 kg-1 K-1"
    Case (8);  write(*,*) "d2g/dp2  -0.508915308E-12  -0.371527164E-12  -0.445841077E-12  m3 kg-1 Pa-1"
    Case (9);  write(*,*) "h         0.610136242E+2    0.954044973E+5    0.167616267E+6   J kg-1"
    Case (10); write(*,*) "f         0.183980891E-2    0.206205140E+4   -0.117220097E+5   J kg-1"
    Case (11); write(*,*) "u        -0.403272791E+2   -0.263838183E+3    0.167514147E+6   J kg-1"
    Case (12); write(*,*) "s        -0.147644587      -0.851506346E+1    0.572365181E+3   J kg-1 K-1"
    Case (13); write(*,*) "rho       0.999843071E+3    0.104527793E+4    0.992216354E+3   kg m-3"
    Case (14); write(*,*) "cp        0.421941153E+4    0.390523030E+4    0.417942416E+4   J kg-1 K-1"
    Case (15); write(*,*) "w         0.140240099E+4    0.157543089E+4    0.152891242E+4   m s-1"
  end select

  
  if(i > 2) then
    
    do j = 1, 3
      if(j == 1)then
         t = 273.15d0
         p = 101325d0
      elseif(j == 2)then
         t = 273.15d0
         p = 1d8
      elseif(j == 3)then
         t = 313.15d0
         p = 101325d0
      endif
      q(j) = 0d0
      Select Case (i)
        Case (1); q(j) = t
        Case (2); q(j) = p
        Case (3); q(j) = fit_liq_g_f03_si(0, 0, t, p)
        Case (4); q(j) = fit_liq_g_f03_si(1, 0, t, p)
        Case (5); q(j) = fit_liq_g_f03_si(0, 1, t, p)
        Case (6); q(j) = fit_liq_g_f03_si(2, 0, t, p)
        Case (7); q(j) = fit_liq_g_f03_si(1, 1, t, p)
        Case (8); q(j) = fit_liq_g_f03_si(0, 2, t, p)
        Case (9); q(j) = fit_liq_g_f03_si(0, 0, t, p) - t * fit_liq_g_f03_si(1, 0, t, p)
        Case (10); q(j) = fit_liq_g_f03_si(0, 0, t, p) - p * fit_liq_g_f03_si(0, 1, t, p)
        Case (11); q(j) = fit_liq_g_f03_si(0, 0, t, p) - p * fit_liq_g_f03_si(0, 1, t, p) &
                                                       - t * fit_liq_g_f03_si(1, 0, t, p)
        Case (12); q(j) = -fit_liq_g_f03_si(1, 0, t, p)
        Case (13); q(j) = fit_liq_density_f03_si(t, p)
        Case (14); q(j) = fit_liq_cp_f03_si(t, p)
        Case (15); q(j) = fit_liq_soundspeed_f03_si(t, p)
      End Select
    enddo
    write(*,'(10x, e16.9, 2x, e16.9, 2x, e16.9)')q(1), q(2), q(3)
    write(*,*)" "
  end if
enddo

end subroutine

end module liq_f03_5

module liq_air_4a

!#########################################################################

!THIS MODULE IMPLEMENTS THE PHASE EQUILIBRIUM PROPERTIES OF LIQUID WATER
!WITH HUMID AIR, COMMONLY REGARDED AS "SATURATED AIR" OR "HUMIDITY 100%".
!THEREFORE, THE AIR PROPERTIES COMPUTED HERE REFER TO SATURATED AIR.

!#########################################################################

!IMPLEMENTATION IN FORTRAN BY D.G. WRIGHT
!FOR PUBLICATION IN OCEAN SCIENCE, AS DESCRIBED IN THE PAPERS

!FEISTEL, R., WRIGHT, D.G., JACKETT, D.R., MIYAGAWA, K., REISSMANN, J.H.,
!WAGNER, W., OVERHOFF, U., GUDER, C., FEISTEL, A., MARION, G.M.:
!NUMERICAL IMPLEMENTATION AND OCEANOGRAPHIC APPLICATION OF THE THERMODYNAMIC
!POTENTIALS OF WATER, VAPOUR, ICE, SEAWATER AND AIR. PART I: BACKGROUND AND EQUATIONS. 
!OCEAN SCIENCES, 2009, IN PREPARATION.

!WRIGHT, D.G., FEISTEL, R., JACKETT, D.R., MIYAGAWA, K., REISSMANN, J.H., 
!WAGNER, W., OVERHOFF, U., GUDER, C., FEISTEL, A., MARION, G.M.:
!NUMERICAL IMPLEMENTATION AND OCEANOGRAPHIC APPLICATION OF THE THERMODYNAMIC
!POTENTIALS OF WATER, VAPOUR, ICE, SEAWATER AND AIR. PART II: THE LIBRARY ROUTINES, 
!OCEAN SCIENCES., 2009, IN PREPARATION.

!FEISTEL, R., KRETZSCHMAR, H.-J., SPAN, R., HAGEN, E., WRIGHT, D.G., HERRMANN, S.:
!THERMODYNAMIC PROPERTIES OF SEA AIR.
!OCEAN SCIENCE DISCUSSION 6(2009)2193-2325.

!#########################################################################

!THIS MODULE REQUIRES THE LIBRARY MODULES:
!     CONSTANTS_0, FILE CONSTANTS_0.F90
!     CONVERT_0,   FILE CONVERT_0.F90
!     MATHS_0,     FILE MATHS_0.F90
!     AIR_1,       FILE AIR_1.F90
!     FLU_1,       FILE FLU_1.F90
!     AIR_2,       FILE AIR_2.F90
!     FLU_2,       FILE FLU_2.F90
!     AIR_3A,      FILE AIR_3A.F90
!     AIR_3B,      FILE AIR_3A.F90
!     FLU_3A,      FILE FLU_3A.F90
!     LIQ_VAP_4,   FILE LIQ_VAP_4.F90

!#########################################################################

use constants_0
use convert_0
use maths_0
use air_1
use flu_1
use air_2
use flu_2
use air_3a
use air_3b
use flu_3a
use liq_vap_4

implicit none
private

character*16, private :: version = '8 Jun 2010'

public :: liq_air_a_from_rh_cct_si, liq_air_a_from_rh_wmo_si, &
          liq_air_condensationpressure_si, liq_air_density_air_si, &
          liq_air_density_liq_si, liq_air_density_vap_si, &
          liq_air_dewpoint_si, liq_air_enthalpy_evap_si, &
          liq_air_entropy_air_si, liq_air_icl_si, liq_air_ict_si, &
          liq_air_massfraction_air_si, liq_air_pressure_si,  &
          liq_air_rh_cct_from_a_si,  liq_air_rh_wmo_from_a_si, &
          liq_air_temperature_si, set_it_ctrl_liq_air, &
          set_liq_air_eq_at_a_eta, set_liq_air_eq_at_a_p, &
          set_liq_air_eq_at_a_t, set_liq_air_eq_at_t_p


!CONTROL PARAMETERS OF THE VAPOUR PRESSURE ITERATION
integer ctrl_initialized 

!SELECT INITIAL GUESSING METHOD
integer ctrl_mode_humidity 
integer ctrl_mode_temperature 
integer ctrl_mode_pressure 

!STORE CUSTOMIZED INITIAL VALUES HERE
integer ctrl_loop_maximum 
real*8 ctrl_init_t 
real*8 ctrl_init_a 
real*8 ctrl_init_p 

!SET TOLERANCE OF THE ITERATION LOOP FOR
real*8 ctrl_eps_exit_p_vap    !VAPOUR PARTIAL PRESSURE
real*8 ctrl_eps_exit_temp     !TEMPERATURE
real*8 ctrl_eps_exit_press    !PRESSURE

!PROPERTIES OF THE CURRENT LIQUID-VAPOUR EQUILIBRIUM STATE
integer equi_liq_air_done 

!STORAGE OF THE ITERATION RESULTS = THE EQUILIBRIUM STATE (SATURATED AIR)
real*8 equi_liq_air_a         !DRY AIR MASS FRACTION OF HUMID AIR
real*8 equi_liq_air_t         !TEMPERATURE
real*8 equi_liq_air_p         !PRESSURE
real*8 equi_liq_air_eta       !HUMID AIR ENTROPY
real*8 equi_liq_air_d_liq     !LIQUID WATER DENSITY
real*8 equi_liq_air_d_air     !HUMID AIR DENSITY

contains

!==========================================================================
function liq_air_a_from_rh_wmo_si(rh_si, t_si, p_si)
!==========================================================================

!RETURNS THE DRY_AIR MASS FRACTION OF HUMID AIR FROM RELATIVE HUMIDITY,
!TEMPERATURE AND PRESSURE

!OUTPUT: 
!A_SI  MASS FRACTION OF DRY AIR IN HUMID AIR, IN KG/KG

!INPUT:  
!RH_SI RELATIVE HUMIDITY, WMO DEFINITION, 0 < RH < 1
!T_SI  ABSOLUTE DEWPOINT TEMPERATURE IN K
!P_SI  ABSOLUTE PRESSURE OF HUMID AIR IN PA

!CHECK VALUE AT DEFAULT SETTINGS, V1.0:
!liq_air_a_from_rh_wmo_si(0.8, 300, 1e5) = 0.981999860485

!CHECK VALUE AT DEFAULT SETTINGS, V1.1:
!liq_air_a_from_rh_wmo_si(0.8, 300, 1e5) = 0.982004037135

real*8 liq_air_a_from_rh_wmo_si, rh_si, t_si, p_si
real*8 a_sat

liq_air_a_from_rh_wmo_si = errorreturn

if(t_si <= 0d0) return
if(p_si <= 0d0) return
if(rh_si < 0d0 .or. rh_si > 1d0) return

if(rh_si == 0d0) then !DRY AIR
  liq_air_a_from_rh_wmo_si = 1d0
  return
end if

a_sat = liq_air_massfraction_air_si(t_si, p_si) !SATURATED AIR FRACTION
if(a_sat == errorreturn) return
if(a_sat <= 0d0 .or. a_sat > 1d0) return

!NOTE: RH_WMO = (1-A)*A_SAT/((1-A_SAT)*A) (ALL MASS FRACTIONS)
liq_air_a_from_rh_wmo_si = 1d0 / (1d0 + rh_si * (1d0 / a_sat - 1d0))

end function

!==========================================================================
function liq_air_a_from_rh_cct_si(rh_si, t_si, p_si)
!==========================================================================

!RETURNS THE DRY-AIR MASS FRACTION OF HUMID AIR FROM RELATIVE HUMIDITY,
!TEMPERATURE AND PRESSURE

!OUTPUT: 
!A_SI  MASS FRACTION OF DRY AIR IN HUMID AIR, IN KG/KG

!INPUT:  
!RH_SI RELATIVE HUMIDITY, CCT/IUPAC DEFINITION, 0 < RH < 1
!T_SI  ABSOLUTE DEWPOINT TEMPERATURE IN K
!P_SI  ABSOLUTE PRESSURE OF HUMID AIR IN PA

!CHECK VALUE AT DEFAULT SETTINGS, V1.0:
!liq_air_a_from_rh_cct_si(0.8, 300, 1e5) = 0.982129130677

!CHECK VALUE AT DEFAULT SETTINGS, V1.1:
!liq_air_a_from_rh_cct_si(0.8, 300, 1e5) = 0.982133277948

real*8 liq_air_a_from_rh_cct_si, rh_si, t_si, p_si
real*8 a_sat

liq_air_a_from_rh_cct_si = errorreturn

if(t_si <= 0d0) return
if(p_si <= 0d0) return
if(rh_si < 0d0 .or. rh_si > 1d0) return

if(rh_si == 0d0) then !DRY AIR
  liq_air_a_from_rh_cct_si = 1
  return
end if

a_sat = liq_air_massfraction_air_si(t_si, p_si) !SATURATED AIR FRACTION
if(a_sat == errorreturn) return
if(a_sat <= 0d0 .or. a_sat > 1d0) return

a_sat = air_molfraction_vap_si(a_sat)          !SATURATED VAPOUR MOLE FRACTION
if (a_sat == errorreturn) return
If (a_sat <= 0 .or. a_sat > 1) return

liq_air_a_from_rh_cct_si = air_massfraction_air_si(1d0 - rh_si * a_sat)

end function

!==========================================================================
function liq_air_massfraction_air_si(t_si, p_si)
!==========================================================================

!RETURNS THE AIR MASS FRACTION IN KG/KG OF SATURATED HUMID AIR

!OUTPUT: 
!A_SI  MASS FRACTION OF DRY AIR IN SATURATED HUMID AIR, IN KG/KG

!INPUT:  
!T_SI  ABSOLUTE TEMPERATURE IN K
!P_SI  ABSOLUTE PRESSURE OF HUMID AIR IN PA

!CHECK VALUE AT DEFAULT SETTINGS, V1.0:
!liq_air_massfraction_air_si(300, 1e5) = 0.977600623582

!CHECK VALUE AT DEFAULT SETTINGS, V1.1:
!liq_air_massfraction_air_si(300, 1e5) = 0.977605797727

real*8 liq_air_massfraction_air_si, t_si, p_si

liq_air_massfraction_air_si = errorreturn

if(set_liq_air_eq_at_t_p(t_si, p_si) == errorreturn) return

liq_air_massfraction_air_si = equi_liq_air_a

end function

!==========================================================================
function liq_air_condensationpressure_si(a_si, t_si)
!==========================================================================

!RETURNS THE CONDENSATION PRESSURE OF HUMID AIR

!OUTPUT: 
!P_SI  ABSOLUTE PRESSURE OF HUMID AIR IN PA

!INPUT:  
!A_SI  MASS FRACTION OF DRY AIR IN HUMID AIR, IN KG/KG
!T_SI  ABSOLUTE DEWPOINT TEMPERATURE IN K

!CHECK VALUE AT DEFAULT SETTINGS, V1.0:
!liq_air_condensationpressure_si(0.9, 300) = 23385.9346276

!CHECK VALUE AT DEFAULT SETTINGS, V1.1:
!liq_air_condensationpressure_si(0.9, 300) = 23381.2332935

real*8 liq_air_condensationpressure_si, a_si, t_si

liq_air_condensationpressure_si = errorreturn

if(set_liq_air_eq_at_a_t(a_si, t_si) == errorreturn) return

liq_air_condensationpressure_si = equi_liq_air_p

end function

!==========================================================================
function liq_air_density_air_si()
!==========================================================================

!RETURNS THE SATURATED HUMID-AIR DENSITY IN KG/M3
!AFTER SETTING THE EQUILIBRIUM STATE BY CALLING SET_LIQ_AIR_EQUILIBRIUM_TO_T_P ETC

!CHECK VALUES WITH DEFAULT SETTINGS, V1.0:
!set_liq_air_eq_at_a_eta(0.99, 100)
!liq_air_density_air_si = 1.45116943913

!set_liq_air_eq_at_a_p(0.99, 1E5)
!liq_air_density_air_si = 1.20649187941

!set_liq_air_eq_at_a_t(0.99, 300)
!liq_air_density_air_si = 2.57657751339

!set_liq_air_eq_at_t_p(300, 1E5)
!liq_air_density_air_si = 1.14587677780

!CHECK VALUES WITH DEFAULT SETTINGS, V1.1:
!set_liq_air_eq_at_a_eta(0.99, 100)
!liq_air_density_air_si = 1.45154665083

!set_liq_air_eq_at_a_p(0.99, 1E5)
!liq_air_density_air_si = 1.20675806022

!set_liq_air_eq_at_a_t(0.99, 300)
!liq_air_density_air_si = 2.57657653270

!set_liq_air_eq_at_t_p(300, 1E5)
!liq_air_density_air_si = 1.14614215827

real*8 liq_air_density_air_si

liq_air_density_air_si = errorreturn

if(equi_liq_air_done /= isok) return

liq_air_density_air_si = equi_liq_air_d_air

end function

!==========================================================================
function liq_air_density_liq_si()
!==========================================================================

!RETURNS THE LIQUID-WATER DENSITY IN KG/M3 OF WET AIR
!AFTER SETTING THE EQUILIBRIUM STATE BY CALLING SET_LIQ_AIR_EQUILIBRIUM_TO_T_P ETC

!CHECK VALUES WITH DEFAULT SETTINGS, V1.0:
!set_liq_air_eq_at_a_eta(0.99, 100)
!liq_air_density_liq_si = 998.795484566

!set_liq_air_eq_at_a_p(0.99, 1E5)
!liq_air_density_liq_si = 999.257178499

!set_liq_air_eq_at_a_t(0.99, 300)
!liq_air_density_liq_si = 996.611605025

!set_liq_air_eq_at_t_p(300, 1E5)
!liq_air_density_liq_si = 996.556340389

!CHECK VALUES WITH DEFAULT SETTINGS, V1.1:
!set_liq_air_eq_at_a_eta(0.99, 100)
!liq_air_density_liq_si = 998.794738784

!set_liq_air_eq_at_a_p(0.99, 1E5)
!liq_air_density_liq_si = 999.256685197

!set_liq_air_eq_at_a_t(0.99, 300)
!liq_air_density_liq_si = 996.611581662

!set_liq_air_eq_at_t_p(300, 1E5)
!liq_air_density_liq_si = 996.556340389

real*8 liq_air_density_liq_si

liq_air_density_liq_si = errorreturn

if(equi_liq_air_done /= isok) return

liq_air_density_liq_si = equi_liq_air_d_liq

end function

!==========================================================================
function liq_air_density_vap_si()
!==========================================================================

!RETURNS THE VAPOUR DENSITY IN KG/M3 OF SATURATED AIR
!AFTER SETTING THE EQUILIBRIUM STATE BY CALLING SET_LIQ_AIR_EQUILIBRIUM_TO_T_P ETC

!CHECK VALUES WITH DEFAULT SETTINGS, V1.0:
!set_liq_air_eq_at_a_eta(0.99, 100)
!liq_air_density_vap_si = 1.45116943913E-02

!set_liq_air_eq_at_a_p(0.99, 1E5)
!liq_air_density_vap_si = 1.20649187941E-02

!set_liq_air_eq_at_a_t(0.99, 300)
!liq_air_density_vap_si = 2.57657751339E-02

!set_liq_air_eq_at_t_p(300, 1E5)
!liq_air_density_vap_si = 2.56669252749E-02

!CHECK VALUES WITH DEFAULT SETTINGS, V1.1:
!set_liq_air_eq_at_a_eta(0.99, 100)
!liq_air_density_vap_si = 1.45154665083E-02

!set_liq_air_eq_at_a_p(0.99, 1E5)
!liq_air_density_vap_si = 0.01206758060

!set_liq_air_eq_at_a_t(0.99, 300)
!liq_air_density_vap_si = 2.57657653270E-02

!set_liq_air_eq_at_t_p(300, 1E5)
!liq_air_density_vap_si = 2.56669393257E-02

real*8 liq_air_density_vap_si

liq_air_density_vap_si = errorreturn

if(equi_liq_air_done /= isok) return

liq_air_density_vap_si = equi_liq_air_d_air * (1d0 - equi_liq_air_a)

end function

!==========================================================================
function liq_air_dewpoint_si(a_si, p_si)
!==========================================================================

!RETURNS THE DEWPOINT TEMPERATURE OF HUMID AIR

!OUTPUT: 
!T_SI  ABSOLUTE DEWPOINT TEMPERATURE IN K

!INPUT:  
!A_SI  MASS FRACTION OF DRY AIR IN HUMID AIR, IN KG/KG
!P_SI  ABSOLUTE PRESSURE OF HUMID AIR IN PA

!CHECK VALUES WITH DEFAULT SETTINGS, V1.0:
!liq_air_dewpoint_si(0.99, 1E5) = 287.074721927

!CHECK VALUES WITH DEFAULT SETTINGS, V1.1:
!liq_air_dewpoint_si(0.99, 1E5) = 287.078299795

real*8 liq_air_dewpoint_si, a_si, p_si

liq_air_dewpoint_si = errorreturn

if(set_liq_air_eq_at_a_p(a_si, p_si) == errorreturn) return

liq_air_dewpoint_si = equi_liq_air_t

end function

!==========================================================================
function liq_air_enthalpy_evap_si()
!==========================================================================

!RETURNS THE LATENT HEAT IN J/KG OF SATURATED AIR
!AFTER SETTING THE EQUILIBRIUM STATE BY CALLING SET_LIQ_AIR_EQUILIBRIUM_TO_T_P ETC

!CHECK VALUES WITH DEFAULT SETTINGS, V1.0:
!set_liq_air_eq_at_a_eta(0.99, 100)
!liq_air_enthalpy_evap_si = 2458132.60500

!set_liq_air_eq_at_a_p(0.99, 1E5)
!liq_air_enthalpy_evap_si = 2465665.32464

!set_liq_air_eq_at_a_t(0.99, 300)
!liq_air_enthalpy_evap_si = 2433111.45416

!set_liq_air_eq_at_t_p(300, 1E5)
!liq_air_enthalpy_evap_si = 2434585.86630

!CHECK VALUES WITH DEFAULT SETTINGS, V1.1:
!set_liq_air_eq_at_a_eta(0.99, 100)
!liq_air_enthalpy_evap_si = 2458121.74961

!set_liq_air_eq_at_a_p(0.99, 1E5)
!liq_air_enthalpy_evap_si = 2465656.38630

!set_liq_air_eq_at_a_t(0.99, 300)
!liq_air_enthalpy_evap_si = 2433111.29696

!set_liq_air_eq_at_t_p(300, 1E5)
!liq_air_enthalpy_evap_si = 2434585.53919

real*8 liq_air_enthalpy_evap_si
real*8 a, t, dh, dl
real*8 hh, hh_a, hl
real*8 fh_a, fh_d
real*8 fh_at, fh_ad
real*8 fh_td, fh_dd
real*8 p_a, p_d
real*8 h_a, h_d

liq_air_enthalpy_evap_si = errorreturn

if(equi_liq_air_done /= isok) return

!GET THE EQUILIBRIUM PROPERTIES
a = equi_liq_air_a
if(a == errorreturn) return
if(a < 0d0 .or. a > 1d0) return
t = equi_liq_air_t
if(t == errorreturn) return
if(t <= 0d0) return
dh = equi_liq_air_d_air
if(dh == errorreturn) return
if(dh <= 0d0) return
dl = equi_liq_air_d_liq
if(dl == errorreturn) return
if(dl <= 0d0) return

!ENTHALPY OF HUMID AIR
hh = air_f_enthalpy_si(a, t, dh)
if(hh == errorreturn) return

!DERIVATIVE HH_A = (DH/DA)_T_P OF ENTHALPY OF HUMID AIR
fh_a = air_f_si(1, 0, 0, a, t, dh)
if(fh_a == errorreturn) return
fh_d = air_f_si(0, 0, 1, a, t, dh)
if(fh_d == errorreturn) return
fh_at = air_f_si(1, 1, 0, a, t, dh)
if(fh_at == errorreturn) return
fh_ad = air_f_si(1, 0, 1, a, t, dh)
if(fh_ad == errorreturn) return
fh_td = air_f_si(0, 1, 1, a, t, dh)
if(fh_td == errorreturn) return
fh_dd = air_f_si(0, 0, 2, a, t, dh)
if(fh_dd == errorreturn) return

p_a = dh * fh_ad                            !DP/DA AT CONST T,D
p_d = dh * (2d0 * fh_d + dh * fh_dd)        !DP/DD AT CONST A,T
if(p_d == 0d0) return
h_a = fh_a + dh * fh_ad - t * fh_at         !DH/DA AT CONST T,D
h_d = 2d0 * fh_d + dh * fh_dd - t * fh_td   !DH/DD AT CONST A,T

hh_a = h_a - h_d * p_a / p_d                !DH/DA AT CONST T,P

!ENTHALPY OF LIQUID WATER
hl = flu_enthalpy_si(t, dl)
if(hl == errorreturn) return

!COMPUTE THE LATENT HEAT
liq_air_enthalpy_evap_si = hh - a * hh_a - hl

end function

!==========================================================================
function liq_air_entropy_air_si()
!==========================================================================

!RETURNS THE SATURATED HUMID-AIR ENTROPY IN J/KG
!AFTER SETTING THE EQUILIBRIUM STATE BY CALLING SET_LIQ_AIR_EQUILIBRIUM_TO_T_P ETC

!CHECK VALUES WITH DEFAULT SETTINGS, V1.0:
!set_liq_air_eq_at_a_eta(0.99, 100)
!liq_air_entropy_air_si = 100

!set_liq_air_eq_at_a_p(0.99, 1E5)
!liq_air_entropy_air_si = 145.864613600

!set_liq_air_eq_at_a_t(0.99, 300)
!liq_air_entropy_air_si = -42.0969943912

!set_liq_air_eq_at_t_p(300, 1E5)
!liq_air_entropy_air_si = 296.780112468

!CHECK VALUES WITH DEFAULT SETTINGS, V1.1:
!set_liq_air_eq_at_a_eta(0.99, 100)
!liq_air_entropy_air_si = 100

!set_liq_air_eq_at_a_p(0.99, 1E5)
!liq_air_entropy_air_si = 145.863545194

!set_liq_air_eq_at_a_t(0.99, 300)
!liq_air_entropy_air_si = -41.9991507402

!set_liq_air_eq_at_t_p(300, 1E5)
!liq_air_entropy_air_si = 296.711483507

real*8 liq_air_entropy_air_si

liq_air_entropy_air_si = errorreturn

if(equi_liq_air_done /= isok) return

liq_air_entropy_air_si = equi_liq_air_eta

end function

!==========================================================================
function liq_air_icl_si(a_si, t_si, p_si)
!==========================================================================

!RETURNS THE ISENTROPIC CONDENSATION LEVEL ICL OF HUMID AIR

!OUTPUT: 
!ICL_SI  ABSOLUTE ISENTROPIC CONDENSATION PRESSURE IN PA

!INPUT:  
!A_SI  MASS FRACTION OF DRY AIR IN HUMID AIR, IN KG/KG
!T_SI  ABSOLUTE TEMPERATURE IN K
!P_SI  ABSOLUTE PRESSURE OF HUMID AIR IN PA

!CHECK VALUE WITH DEFAULT SETTINGS, V1.0:
!liq_air_icl_si(0.99, 300, 1E5) = 82719.2377442

!CHECK VALUE WITH DEFAULT SETTINGS, V1.1:
!liq_air_icl_si(0.99, 300, 1E5) = 82723.6047631

real*8 liq_air_icl_si, a_si, t_si, p_si
real*8 eta

liq_air_icl_si = errorreturn

eta = air_g_entropy_si(a_si, t_si, p_si)
if(eta == errorreturn) return

if(set_liq_air_eq_at_a_eta(a_si, eta) == errorreturn) return

liq_air_icl_si = equi_liq_air_p

end function

!==========================================================================
function liq_air_ict_si(a_si, t_si, p_si)
!==========================================================================

!RETURNS THE ISENTROPIC CONDENSATION TEMPERATURE ICT OF HUMID AIR

!OUTPUT: 
!ICT_SI  ABSOLUTE ISENTROPIC CONDENSATION TEMPERATURE IN K

!INPUT:  
!A_SI  MASS FRACTION OF DRY AIR IN HUMID AIR, IN KG/KG
!T_SI  ABSOLUTE TEMPERATURE IN K
!P_SI  ABSOLUTE PRESSURE OF HUMID AIR IN PA

!CHECK VALUE WITH DEFAULT SETTINGS, V1.0:
!liq_air_ict_si(0.99, 300, 1E5) = 284.195916825

!CHECK VALUE WITH DEFAULT SETTINGS, V1.1:
!liq_air_ict_si(0.99, 300, 1E5) = 284.200207629

real*8 liq_air_ict_si, a_si, t_si, p_si
real*8 eta

liq_air_ict_si = errorreturn

eta = air_g_entropy_si(a_si, t_si, p_si)
if(eta == errorreturn) return

if(set_liq_air_eq_at_a_eta(a_si, eta) == errorreturn) return

liq_air_ict_si = equi_liq_air_t

end function

!==========================================================================
function liq_air_pressure_si()
!==========================================================================

!RETURNS THE PRESSURE IN PA OF SATURATED AIR
!AFTER SETTING THE EQUILIBRIUM STATE BY CALLING SET_LIQ_AIR_EQUILIBRIUM_TO_A_T ETC

!CHECK VALUES WITH DEFAULT SETTINGS, V1.0:
!set_liq_air_eq_at_a_eta(0.99, 100)
!liq_air_pressure_si = 121541.303927

!set_liq_air_eq_at_a_p(0.99, 1E5)
!liq_air_pressure_si = 100000

!set_liq_air_eq_at_a_t(0.99, 300)
!liq_air_pressure_si = 223109.793432

!set_liq_air_eq_at_t_p(300, 1E5)
!liq_air_pressure_si = 100000

!CHECK VALUES WITH DEFAULT SETTINGS, V1.1:
!set_liq_air_eq_at_a_eta(0.99, 100)
!liq_air_pressure_si = 121546.373652

!set_liq_air_eq_at_a_p(0.99, 1E5)
!liq_air_pressure_si = 100000

!set_liq_air_eq_at_a_t(0.99, 300)
!liq_air_pressure_si = 223057.741750

!set_liq_air_eq_at_t_p(300, 1E5)
!liq_air_pressure_si = 100000


real*8 liq_air_pressure_si

liq_air_pressure_si = errorreturn

if(equi_liq_air_done /= isok) return

liq_air_pressure_si = equi_liq_air_p

end function

!==========================================================================
function liq_air_rh_cct_from_a_si(a_si, t_si, p_si)
!==========================================================================

!RETURNS THE RELATIVE HUMIDITY FROM AIR MASS FRACTION, TEMPERATURE AND PRESSURE

!OUTPUT: 
!RELATIVE HUMIDITY, CCT/IUPAC DEFINITION

!INPUT:  
!A_SI  MASS FRACTION OF DRY AIR IN HUMID AIR, IN KG/KG
!T_SI  ABSOLUTE TEMPERATURE IN K
!P_SI  ABSOLUTE PRESSURE OF HUMID AIR IN PA

!CHECK VALUE WITH DEFAULT SETTINGS, V1.0:
!liq_air_rh_cct_from_a_si(0.99, 300, 1E5) = 0.449783278144

!CHECK VALUE WITH DEFAULT SETTINGS, V1.1:
!liq_air_rh_cct_from_a_si(0.99, 300, 1E5) = 0.449887886959

real*8 liq_air_rh_cct_from_a_si, a_si, t_si, p_si
real*8 a_sat

liq_air_rh_cct_from_a_si = errorreturn

if(t_si <= 0d0) return
if(p_si <= 0d0) return
if(a_si <= 0d0 .or. a_si > 1d0) return

if(a_si == 1d0) then !DRY AIR
  liq_air_rh_cct_from_a_si = 0
  return
end if

a_sat = liq_air_massfraction_air_si(t_si, p_si) !SATURATED AIR MASS FRACTION
if(a_sat == errorreturn) return
if(a_sat <= 0d0 .or. a_sat > a_si) return

if(a_sat == 1d0) then !DRY AIR
  liq_air_rh_cct_from_a_si = 0d0
  return
end if

liq_air_rh_cct_from_a_si = air_molfraction_vap_si(a_si) / air_molfraction_vap_si(a_sat)

end function

!==========================================================================
function liq_air_rh_wmo_from_a_si(a_si, t_si, p_si)
!==========================================================================

!RETURNS THE RELATIVE HUMIDITY FROM AIR MASS FRACTION, TEMPERATURE AND PRESSURE

!OUTPUT: 
!RELATIVE HUMIDITY, WMO DEFINITION

!INPUT:  
!A_SI  MASS FRACTION OF DRY AIR IN HUMID AIR, IN KG/KG
!T_SI  ABSOLUTE TEMPERATURE IN K
!P_SI  ABSOLUTE PRESSURE OF HUMID AIR IN PA

!CHECK VALUE WITH DEFAULT SETTINGS, V1.0:
!liq_air_rh_wmo_from_a_si(0.99, 300, 1E5) = 0.440849494608

!CHECK VALUE WITH DEFAULT SETTINGS, V1.1:
!liq_air_rh_wmo_from_a_si(0.99, 300, 1E5) = 0.440953686019

real*8 liq_air_rh_wmo_from_a_si, a_si, t_si, p_si
real*8 a_sat

liq_air_rh_wmo_from_a_si = errorreturn

if(t_si <= 0d0) return
if(p_si <= 0d0) return
if(a_si <= 0d0 .or. a_si > 1d0) return

if(a_si == 1d0) then !DRY AIR
  liq_air_rh_wmo_from_a_si = 0d0
  return
end if

a_sat = liq_air_massfraction_air_si(t_si, p_si) !SATURATED AIR FRACTION
if(a_sat == errorreturn) return
if(a_sat <= 0d0 .or. a_sat > a_si) return

if(a_sat == 1d0) then !DRY AIR
  liq_air_rh_wmo_from_a_si = 0d0
  return
end if

liq_air_rh_wmo_from_a_si = (1d0 / a_si - 1d0) / (1d0 / a_sat - 1d0)

end function


!==========================================================================
function liq_air_temperature_si()
!==========================================================================

!RETURNS THE TEMPERATURE IN K OF SATURATED AIR
!AFTER SETTING THE EQUILIBRIUM STATE BY CALLING SET_LIQ_AIR_EQUILIBRIUM_TO_T_P ETC

!CHECK VALUES WITH DEFAULT SETTINGS, V1.0:
!set_liq_air_eq_at_a_eta(0.99, 100)
!liq_air_temperature_si = 290.103069429

!set_liq_air_eq_at_a_p(0.99, 1E5)
!liq_air_temperature_si = 287.074721927

!set_liq_air_eq_at_a_t(0.99, 300)
!liq_air_temperature_si = 300

!set_liq_air_eq_at_t_p(300, 1E5)
!liq_air_temperature_si = 300

!CHECK VALUES WITH DEFAULT SETTINGS, V1.1:
!set_liq_air_eq_at_a_eta(0.99, 100)
!liq_air_temperature_si = 290.107386673

!set_liq_air_eq_at_a_p(0.99, 1E5)
!liq_air_temperature_si = 287.078299795

!set_liq_air_eq_at_a_t(0.99, 300)
!liq_air_temperature_si = 300

!set_liq_air_eq_at_t_p(300, 1E5)
!liq_air_temperature_si = 300


real*8 liq_air_temperature_si

liq_air_temperature_si = errorreturn

if(equi_liq_air_done /= isok) return

liq_air_temperature_si = equi_liq_air_t

end function

!==========================================================================
function set_liq_air_eq_at_a_eta(a_si, eta_si)
!==========================================================================
                                             
!THIS FUNCTION COMPUTES THE SATURATION EQUILIBRIUM STATE BETWEEN HUMID AIR AND
!LIQUID WATER, IN PARTICULAR, THE ISENTROPIC CONDENSATION TEMPERATURE AND PRESSURE.

!NOTE: THERE IS NO CHECK MADE WHETHER THE LIQUID WATER PHASE IS UNDERCOOLED, I.E. THE
!RESULT MAY APPLY TO METASTABLE WATER IF THE TEMPERATURE IS BELOW THE FREEZING POINT.

!INPUT:  A_SI  MASS FRACTION OF DRY AIR IN HUMID AIR IN KG/KG
!        ETA_SI  SPECIFIC ENTROPY OF HUMID AIR IN J/(KG K)

real*8 set_liq_air_eq_at_a_eta, a_si, eta_si
real*8 p_si, t_si, dl, dh, eps

integer maxit

if(equi_liq_air_done == isok .and. &
   a_si == equi_liq_air_a .and.    &
   eta_si == equi_liq_air_eta) then
   !THE REQUESTED STATE HAS ALREADY BEEN COMPUTED EARLIER
   set_liq_air_eq_at_a_eta = isok
   return
end if

call clear_liq_air_state !WASTE ANY PREVIOUS STATE

set_liq_air_eq_at_a_eta = errorreturn

if(a_si < 0d0 .or. a_si >= 1d0) return

call init_it_ctrl_liq_air

!SET INITIAL TEMPERATURE GUESS
select case(ctrl_mode_temperature)
  case(0); t_si = aux_ict_si(a_si, eta_si)
  case(1); t_si = ctrl_init_t
  case default; return
end select
if(t_si == errorreturn) return
if(t_si <= 0d0) return

!SET INITIAL PRESSURE GUESS
select case(ctrl_mode_pressure)
  case(0); p_si = aux_pressure_si(a_si, t_si)
  case(1); p_si = ctrl_init_p
  case default; return
end select
if(p_si == errorreturn) return
if(p_si <= 0d0) return

!SET INITIAL LIQUID DENSITY
dl = liq_density_si(t_si, p_si)
if(dl == errorreturn) return
if(dl <= 0d0) return

!SET INITIAL HUMID AIR DENSITY
dh = air_density_si(a_si, t_si, p_si)
if(dh == errorreturn) return
if(dh <= 0d0) return

!SET MAX. ITERATION NUMBER
  if(ctrl_loop_maximum == 0) then
    maxit = 100
  elseif(ctrl_loop_maximum == (-1)) then
    set_liq_air_eq_at_a_eta = isok
    call set_liq_air_state(a_si, t_si, p_si, eta_si, dl, dh)
    return
  elseif(ctrl_loop_maximum > 0) then
    maxit = ctrl_loop_maximum
  else
    return
  endif

!SET ITERATION ACCURACY LIMIT FOR THE VAPOUR PARTIAL PRESSURE
eps = ctrl_eps_exit_p_vap
if(eps == 0d0) return

!RUN ITERATION LOOP
if(liq_air_iteration_at_a_eta(a_si, eta_si, maxit, eps, t_si, p_si, dl, dh) == errorreturn) then
  return
end if

call set_liq_air_state(a_si, t_si, p_si, eta_si, dl, dh)

set_liq_air_eq_at_a_eta = isok

end function

!==========================================================================
function set_liq_air_eq_at_a_p(a_si, p_si)
!==========================================================================
                                             
!THIS FUNCTION COMPUTES THE SATURATION EQUILIBRIUM STATE BETWEEN HUMID AIR AND
!LIQUID WATER, IN PARTICULAR, THE DEWPOINT TEMPERATURE.

!NOTE: THERE IS NO CHECK MADE WHETHER THE LIQUID WATER PHASE IS UNDERCOOLED, I.E. THE
!RESULT MAY APPLY TO METASTABLE WATER IF THE TEMPERATURE IS BELOW THE FREEZING POINT.

!INPUT:  A_SI  MASS FRACTION OF DRY AIR IN HUMID AIR IN KG/KG
!        P_SI  ABSOLUTE PRESSURE OF HUMID AIR IN PA

real*8 set_liq_air_eq_at_a_p, a_si, p_si
real*8 t_si, dl, dh, eta, eps

integer maxit

if(equi_liq_air_done == isok .and. &
  a_si == equi_liq_air_a .and.    &
  p_si == equi_liq_air_p) then
  !THE REQUESTED STATE HAS ALREADY BEEN COMPUTED EARLIER
  set_liq_air_eq_at_a_p = isok
  return
end if

call clear_liq_air_state !WASTE ANY PREVIOUS STATE

set_liq_air_eq_at_a_p = errorreturn

if(a_si < 0d0 .or. a_si >= 1d0) return
if(p_si <= 0d0) return

call init_it_ctrl_liq_air

!SET INITIAL TEMPERATURE GUESS
select case(ctrl_mode_temperature)
  case(0); t_si = aux_temperature_si(a_si, p_si)
  case(1); t_si = ctrl_init_t
  case default; return
end select
if(t_si == errorreturn) return
if(t_si <= 0d0) return

!SET INITIAL LIQUID DENSITY
dl = liq_density_si(t_si, p_si)
if(dl == errorreturn) return
if(dl <= 0d0) return

!SET INITIAL HUMID AIR DENSITY
dh = air_density_si(a_si, t_si, p_si)
if(dh == errorreturn) return
if(dh <= 0d0) return

!SET MAX. ITERATION NUMBER
  if(ctrl_loop_maximum == 0) then
    maxit = 100
  elseif(ctrl_loop_maximum == (-1)) then
    set_liq_air_eq_at_a_p = isok
    eta = air_f_entropy_si(a_si, t_si, dh)
    call set_liq_air_state(a_si, t_si, p_si, eta, dl, dh)
    return
  elseif(ctrl_loop_maximum > 0) then
    maxit = ctrl_loop_maximum
  else
    return
  endif

!SET ITERATION ACCURACY LIMIT FOR THE VAPOUR PARTIAL PRESSURE
eps = ctrl_eps_exit_p_vap
if(eps == 0d0) return

!RUN ITERATION LOOP
if(liq_air_iteration_at_a_p(a_si, p_si, maxit, eps, t_si, dl, dh) == errorreturn) then
  return
end if

eta = air_f_entropy_si(a_si, t_si, dh)
call set_liq_air_state(a_si, t_si, p_si, eta, dl, dh)

set_liq_air_eq_at_a_p = isok

end function

!==========================================================================
function set_liq_air_eq_at_a_t(a_si, t_si)
!==========================================================================
                                             
!THIS FUNCTION COMPUTES THE SATURATION EQUILIBRIUM STATE BETWEEN HUMID AIR AND
!LIQUID WATER, IN PARTICULAR, THE CONDENSATION PRESSURE.

!NOTE: THERE IS NO CHECK MADE WHETHER THE LIQUID WATER PHASE IS UNDERCOOLED, I.E. THE
!RESULT MAY APPLY TO METASTABLE WATER IF THE TEMPERATURE IS BELOW THE FREEZING POINT.

!INPUT:  A_SI  MASS FRACTION OF DRY AIR IN HUMID AIR IN KG/KG
!        T_SI  ABSOLUTE TEMPERATURE OF HUMID AIR IN K

real*8 set_liq_air_eq_at_a_t, a_si, t_si
real*8 p_si, dl, dh, eta, eps

integer maxit

if(equi_liq_air_done == isok .and.  &
  a_si == equi_liq_air_a .and.     &
  t_si == equi_liq_air_t) then
  !THE REQUESTED STATE HAS ALREADY BEEN COMPUTED EARLIER
  set_liq_air_eq_at_a_t = isok
  return
end if

call clear_liq_air_state !WASTE ANY PREVIOUS STATE

set_liq_air_eq_at_a_t = errorreturn

if(a_si < 0d0 .or. a_si >= 1d0) return
if(t_si <= 0d0) return

call init_it_ctrl_liq_air

!SET INITIAL PRESSURE GUESS
select case(ctrl_mode_pressure)
  case(0); p_si = aux_pressure_si(a_si, t_si)
  case(1); p_si = ctrl_init_p
  case default; return
end select
if(p_si == errorreturn) return
if(p_si <= 0d0) return

!SET INITIAL LIQUID DENSITY
dl = liq_density_si(t_si, p_si)
if(dl == errorreturn) return
if(dl <= 0d0) return

!SET INITIAL HUMID AIR DENSITY
dh = air_density_si(a_si, t_si, p_si)
if(dh == errorreturn) return
if(dh <= 0d0) return

!SET MAX. ITERATION NUMBER
  if(ctrl_loop_maximum == 0) then
    maxit = 100
  elseif(ctrl_loop_maximum == (-1)) then
    set_liq_air_eq_at_a_t = isok
    eta = air_f_entropy_si(a_si, t_si, dh)
    call set_liq_air_state(a_si, t_si, p_si, eta, dl, dh)
    return
  elseif(ctrl_loop_maximum > 0) then
    maxit = ctrl_loop_maximum
  else
    return
  endif

!SET ITERATION ACCURACY LIMIT FOR THE VAPOUR PARTIAL PRESSURE
eps = ctrl_eps_exit_p_vap
if(eps == 0d0) return

!RUN ITERATION LOOP
if(liq_air_iteration_at_a_t(a_si, t_si, maxit, eps, p_si, dl, dh) == errorreturn) then
  return
end if

eta = air_f_entropy_si(a_si, t_si, dh)
call set_liq_air_state(a_si, t_si, p_si, eta, dl, dh)

set_liq_air_eq_at_a_t = isok

end function

!==========================================================================
function set_liq_air_eq_at_t_p(t_si, p_si)
!==========================================================================
                                             
!THIS FUNCTION COMPUTES THE SATURATION EQUILIBRIUM STATE BETWEEN HUMID AIR AND
!LIQUID WATER, IN PARTICULAR, THE SATURATED SPECIFIC HUMIDITY OF AIR.

!NOTE: THERE IS NO CHECK MADE WHETHER THE LIQUID WATER PHASE IS UNDERCOOLED, I.E. THE
!RESULT MAY APPLY TO METASTABLE WATER IF THE TEMPERATURE IS BELOW THE FREEZING POINT.

!INPUT:  
!T_SI  ABSOLUTE TEMPERATURE IN K
!p_si  ABSOLUTE PRESSURE OF HUMID AIR IN PA

real*8 set_liq_air_eq_at_t_p, t_si, p_si
real*8 a_si, dl, dh, eta, eps

integer maxit

if(equi_liq_air_done == isok .and.  &
  t_si == equi_liq_air_t .and.  &
  p_si == equi_liq_air_p) then
  !THE REQUESTED STATE HAS ALREADY BEEN COMPUTED EARLIER
  set_liq_air_eq_at_t_p = isok
  return
end if

call clear_liq_air_state !WASTE ANY PREVIOUS STATE

set_liq_air_eq_at_t_p = errorreturn

if(t_si <= 0d0) return
if(p_si <= 0d0) return

call init_it_ctrl_liq_air

!SET INITIAL AIR FRACTION GUESS
select case(ctrl_mode_humidity)
  case(0)
    a_si = aux_airfraction_si(t_si, p_si)
    if(a_si == errorreturn) return
    if(a_si < 0d0 .or. a_si > 1d0) return
  case(1)
    a_si = ctrl_init_a
  case default; return
end select
if(a_si == errorreturn) return
if(a_si < 0d0 .or. a_si > 1d0) return

!LIQUID DENSITY CAN BE COMPUTED WITHOUT KNOWING A_SI
dl = liq_density_si(t_si, p_si)
if(dl == errorreturn) return
if(dl <= 0d0) return

dh = air_density_si(a_si, t_si, p_si)
if(dh == errorreturn) return
if(dh <= 0d0) return

!SET MAX. ITERATION NUMBER
if(ctrl_loop_maximum == 0) then
  maxit = 100
elseif(ctrl_loop_maximum == (-1)) then
  set_liq_air_eq_at_t_p = isok
  eta = air_f_entropy_si(a_si, t_si, dh)
  call set_liq_air_state(a_si, t_si, p_si, eta, dl, dh)
  return
elseif(ctrl_loop_maximum > 0) then
  maxit = ctrl_loop_maximum
else
  return
endif

!SET ITERATION ACCURACY LIMIT FOR THE VAPOUR PARTIAL PRESSURE
eps = ctrl_eps_exit_p_vap
if(eps == 0d0) return

!RUN ITERATION LOOP
if(liq_air_iteration_at_t_p(t_si, p_si, dl, maxit, eps, a_si, dh) == errorreturn) then
  return
end if

eta = air_f_entropy_si(a_si, t_si, dh)
call set_liq_air_state(a_si, t_si, p_si, eta, dl, dh)

set_liq_air_eq_at_t_p = isok

end function

!==========================================================================
function liq_air_iteration_at_t_p(t_si, p_si, d_liq_si, maxit, eps, &
                                  a_si, d_air_si)
!==========================================================================

!THIS FUNCTION RETURNS THE LIQUID-HUMID-AIR PHASE EQUILIBRIUM FROM EQUAL PRESSURE,
!TEMPERATURE AND CHEMICAL POTENTIAL OF WATER OF BOTH PHASES AT GIVEN PRESSURE, P_SI,
!AND TEMPERATURE, T_SI, FROM INITIAL GUESSES FOR THE HUMID-AIR DENSITY, D_AIR_SI,
!AND THE AIR FRACTION, A_SI

!THE ITERATION LIMIT EPS REFERS TO THE ERROR IN VAPOUR PARTIAL PRESSURE

!OUTPUT: 
!        LIQ_AIR_ITERATION_AT_T_P = ISOK IF SUCCESSFUL
!        LIQ_AIR_ITERATION_AT_T_P = ERRORRETURN IS RETURNED IF
!        - THE MAXIMUM NUMBER OF ITERATIONS IS EXCEEDED WITHOUT MEETING THE EXIT CRITERION
!        - FUNCTION CALLS TO FLU_F_SI OR AIR_F_SI HAVE RETURNED AN ERROR
!        - DENSITY OR AIR FRACTION HAVE TAKEN A ZERO OR NEGATIVE VALUE DURING THE ITERATION
!     A_SI: MASS FRACTION OF DRY AIR IN HUMID AIR, KG/KG
! D_AIR_SI: HUMID-AIR DENSITY AT THE SATURATION EQUILIBRIUM

!INPUT: 
!       P_SI: ABSOLUTE PRESSURE IN PA
!       T_SI: ABSOLUTE TEMPERATURE IN K
!   D_LIQ_SI: LIQUID DENSITY AT T_SI, P_SI
!      MAXIT: MAXIMUM NUMBER OF ITERATION STEPS TO BE DONE
!        EPS: REQUIRED ACCURACY OF VAPOUR PRESSURE
!             EPS > 0: ABSOLUTE VAPOUR PRESSURE TOLERANCE IN PA
!             EPS < 0: RELATIVE VAPOUR PRESSURE TOLERANCE
!       A_SI: INITIAL GUESS OF THE MASS FRACTION OF DRY AIR IN HUMID AIR, KG/KG
!   D_AIR_SI: INITIAL GUESS OF HUMID-AIR DENSITY IN KG/M3

real*8 liq_air_iteration_at_t_p, t_si, p_si, d_liq_si, eps, &
       a_si, d_air_si
real*8 ah, fh_a, fh_aa, fh_ad
real*8 gl
real*8 fh, fh_d, fh_dd
real*8 dh
real*8 pv, pv_old
real*8 a(2, 2), b(2), x(2)

integer it, maxit

liq_air_iteration_at_t_p = errorreturn
pv = errorreturn

!CHECK FOR INVALID INPUT VALUES
if(a_si < 0d0 .or. a_si > 1d0 .or. &
  d_air_si <= 0d0 .or. &
  p_si <= 0d0) then
  a_si = errorreturn
  d_air_si = errorreturn
  return
endif

if(check_limits == 1) then
  !FLU_LIMITS
  if(t_si < flu_tmin .or. t_si > flu_tmax .or. &
  d_liq_si <= flu_dmin .or. d_liq_si > flu_dmax) then
    a_si = errorreturn
    d_air_si = errorreturn
    return
  endif
  !AIR_LIMITS
  if(t_si < dry_air_tmin .or. t_si > dry_air_tmax) then
    a_si = errorreturn
    d_air_si = errorreturn
    return
  endif
else
  if(t_si <= 0d0 .or. &
    d_liq_si <= 0d0) then
    a_si = errorreturn
    d_air_si = errorreturn
    return
  endif
endif

check_limits = check_limits - 1

ah = a_si
dh = d_air_si

!CHEMICAL POTENTIAL OF WATER
gl = flu_gibbs_energy_si(t_si, d_liq_si)
if(gl == errorreturn) go to 999

do it = 0, maxit

  !DERIVATIVES OF THE HELMHOLTZ FUNCTION FOR 2D-NEWTON ITERATION
  !HUMID AIR:
  fh = air_f_si(0, 0, 0, ah, t_si, dh)
  if(fh == errorreturn) go to 999
  fh_a = air_f_si(1, 0, 0, ah, t_si, dh)
  if(fh_a == errorreturn) go to 999
  fh_d = air_f_si(0, 0, 1, ah, t_si, dh)
  if(fh_d == errorreturn) go to 999
  fh_aa = air_f_si(2, 0, 0, ah, t_si, dh)
  if(fh_aa == errorreturn) go to 999
  fh_ad = air_f_si(1, 0, 1, ah, t_si, dh)
  if(fh_ad == errorreturn) go to 999
  fh_dd = air_f_si(0, 0, 2, ah, t_si, dh)
  if(fh_dd == errorreturn) go to 999
  
  !VAPOUR PARTIAL PRESSURE FOR ERROR CHECKING
  pv_old = pv
  pv = air_molfraction_vap_si(ah)
  if(pv == errorreturn) go to 999
  pv = p_si * pv
  
  if(it > 0) then
    !CHECK ABSOLUTE OR RELATIVE ERROR LIMIT
    if((eps > 0d0 .and. abs(pv - pv_old) < eps) .or. &
      (eps < 0d0 .and. abs(pv - pv_old) < -eps * pv)) then
      liq_air_iteration_at_t_p = isok
      d_air_si = dh
      a_si = ah
      go to 999
    end if
  end if
  
  if(it == maxit) go to 999
  
  !COEFFICIENT MATRIX
  a(1, 1) = -ah * fh_aa
  a(1, 2) = fh_d - ah * fh_ad - p_si / dh**2
  a(2, 1) = dh * fh_ad
  a(2, 2) = 2d0 * fh_d + dh * fh_dd

  !RIGHT-HAND SIDES, MUST VANISH AT EQUILIBRIUM
  b(1) = gl - fh - p_si / dh + ah * fh_a
  b(2) = p_si / dh - dh * fh_d
  
  !SOLVE EQUATIONS
  if(matrix_solve(a, b, x, 2) /= 0) go to 999 !MATRIX SINGULAR

  !UPDATE AIR FRACTION & DENSITY
  ah = ah + x(1)
  if(ah < 0d0 .or. ah > 1d0) go to 999
  dh = dh + x(2)
  if(dh <= 0d0) go to 999

enddo

999 continue

check_limits = check_limits + 1

if(check_limits == 1) then
  if(a_si < 0d0 .or. a_si > 1d0 .or. &
  d_air_si <= dry_air_dmin .or. d_air_si > dry_air_dmax) then
    a_si = errorreturn
    d_air_si = errorreturn
    liq_air_iteration_at_t_p = errorreturn
    return
  endif
endif

end function

!==========================================================================
function liq_air_iteration_at_a_t(a_si, t_si, maxit, eps, p_si, &
                                  d_liq_si, d_air_si)
!==========================================================================

!THIS FUNCTION RETURNS THE LIQUID-HUMID-AIR PHASE EQUILIBRIUM FROM EQUAL PRESSURE,
!TEMPERATURE AND CHEMICAL POTENTIAL OF WATER OF BOTH PHASES AT GIVEN TEMPERATURE, T_SI,
!AND AIR FRACTION, A_SI, FROM INITIAL GUESSES FOR THE LIQUID DENSITY, D_LIQ_SI,
!THE HUMID-AIR DENSITY, D_AIR_SI, AND THE PRESSURE, P_SI

!THE ITERATION LIMIT EPS REFERS TO THE ERROR IN THE PRESSURE

!OUTPUT: 
!        LIQ_AIR_ITERATION_AT_A_T = ISOK IF SUCCESSFUL
!        LIQ_AIR_ITERATION_AT_A_T = ERRORRETURN IS RETURNED IF
!        - THE MAXIMUM NUMBER OF ITERATIONS IS EXCEEDED WITHOUT MEETING THE EXIT CRITERION
!        - FUNCTION CALLS TO FLU_F_SI OR AIR_F_SI HAVE RETURNED AN ERROR
!        - DENSITY OR PRESSURE HAVE TAKEN A ZERO OR NEGATIVE VALUE DURING THE ITERATION
!     P_SI: ABSOLUTE PRESSURE IN PA
! D_LIQ_SI: LIQUID DENSITY AT T_SI, P_SI
! D_AIR_SI: HUMID-AIR DENSITY AT THE SATURATION EQUILIBRIUM

!INPUT: 
!       T_SI: ABSOLUTE TEMPERATURE IN K
!       A_SI: MASS FRACTION OF DRY AIR IN HUMID AIR, KG/KG
!      MAXIT: MAXIMUM NUMBER OF ITERATION STEPS TO BE DONE
!        EPS: REQUIRED ACCURACY OF VAPOUR PRESSURE
!             EPS > 0: ABSOLUTE PRESSURE TOLERANCE IN PA
!             EPS < 0: RELATIVE PRESSURE TOLERANCE
!       P_SI: INITIAL GUESS OF ABSOLUTE PRESSURE IN PA
!   D_LIQ_SI: INITIAL GUESS OF LIQUID DENSITY AT P_SI, T_SI
!   D_AIR_SI: INITIAL GUESS OF HUMID-AIR DENSITY


real*8 liq_air_iteration_at_a_t, a_si, t_si, eps, p_si, &
       d_liq_si, d_air_si
real*8 fh, fh_a, fh_d
real*8 fh_ad, fh_dd
real*8 fl, fl_d, fl_dd
real*8 dl, dh, p
real*8 a(3, 3), b(3), x(3)

integer it, maxit

liq_air_iteration_at_a_t = errorreturn

!CHECK FOR INVALID INPUT VALUES
if(d_air_si <= 0d0 .or. &
  d_liq_si <= 0d0 .or. &
  p_si <= 0d0) then
  p_si = errorreturn
  d_liq_si = errorreturn
  d_air_si = errorreturn
  return
endif

if(check_limits == 1) then
  !FLU_LIMITS
  if(t_si < flu_tmin .or. t_si > flu_tmax) then
    p_si = errorreturn
    d_liq_si = errorreturn
    d_air_si = errorreturn
    return
  endif
  !AIR_LIMITS
  if(t_si < dry_air_tmin .or. t_si > dry_air_tmax .or. &
  a_si < 0d0 .or. a_si > 1d0) then
    p_si = errorreturn
    d_liq_si = errorreturn
    d_air_si = errorreturn
    return
  endif
else
  if(a_si < 0d0 .or. a_si >= 1d0 .or. &
    t_si <= 0d0) then
    p_si = errorreturn
    d_liq_si = errorreturn
    d_air_si = errorreturn
    return
  endif
endif

check_limits = check_limits - 1

p = p_si
dh = d_air_si
dl = d_liq_si

do it = 1, maxit

  !DERIVATIVES OF THE HELMHOLTZ FUNCTION FOR 3D-NEWTON ITERATION
  !HUMID AIR:
  fh = air_f_si(0, 0, 0, a_si, t_si, dh)
  if(fh == errorreturn) go to 999
  fh_a = air_f_si(1, 0, 0, a_si, t_si, dh)
  if(fh_a == errorreturn) go to 999
  fh_d = air_f_si(0, 0, 1, a_si, t_si, dh)
  if(fh_d == errorreturn) go to 999
  fh_ad = air_f_si(1, 0, 1, a_si, t_si, dh)
  if(fh_ad == errorreturn) go to 999
  fh_dd = air_f_si(0, 0, 2, a_si, t_si, dh)
  if(fh_dd == errorreturn) go to 999

  !LIQUID WATER:
  fl = flu_f_si(0, 0, t_si, dl)
  if(fl == errorreturn) go to 999
  fl_d = flu_f_si(0, 1, t_si, dl)
  if(fl_d == errorreturn) go to 999
  fl_dd = flu_f_si(0, 2, t_si, dl)
  if(fl_dd == errorreturn) go to 999

  !COEFFICIENT MATRIX
  a(1, 1) = 1d0 / dh - 1d0 / dl
  a(1, 2) = fh_d - a_si * fh_ad - p / dh**2
  a(1, 3) = -fl_d + p / dl**2
  a(2, 1) = -1d0 / dh
  a(2, 2) = 2d0 * fh_d + dh * fh_dd
  a(2, 3) = 0d0
  a(3, 1) = -1d0 / dl
  a(3, 2) = 0d0
  a(3, 3) = 2d0 * fl_d + dl * fl_dd

  !RIGHT-HAND SIDES, MUST VANISH AT EQUILIBRIUM
  b(1) = fl - fh + a_si * fh_a + p * (1d0 / dl - 1d0 / dh)
  b(2) = p / dh - dh * fh_d
  b(3) = p / dl - dl * fl_d
  
  !SOLVE EQUATIONS
  if(matrix_solve(a, b, x, 3) /= 0) go to 999 !MATRIX SINGULAR

  !UPDATE PRESSURE & DENSITIES
  p = p + x(1)
  if(p <= 0d0) go to 999
  dh = dh + x(2)
  if(dh <= 0d0) go to 999
  dl = dl + x(3)
  if(dl <= 0d0) go to 999

  !CHECK ABSOLUTE OR RELATIVE ERROR LIMIT
  if((eps > 0d0 .and. abs(x(1)) < eps) .or. &
    (eps < 0d0 .and. abs(x(1)) < -eps * p)) then
    liq_air_iteration_at_a_t = isok
    d_air_si = dh
    d_liq_si = dl
    p_si = p
    go to 999
  end if

enddo

999 continue

check_limits = check_limits + 1

if(check_limits == 1) then
  !FLU_LIMITS
  if(d_liq_si <= flu_dmin .or. d_liq_si > flu_dmax .or. &
    p_si <= 0d0) then
    p_si = errorreturn
    d_liq_si = errorreturn
    d_air_si = errorreturn
    liq_air_iteration_at_a_t = errorreturn
    return
  endif
  !AIR_LIMITS
  if(d_air_si <= dry_air_dmin .or. d_air_si > dry_air_dmax .or. &
    p_si <= 0d0) then
    p_si = errorreturn
    d_liq_si = errorreturn
    d_air_si = errorreturn
    liq_air_iteration_at_a_t = errorreturn
    return
  endif
endif

end function

!==========================================================================
function liq_air_iteration_at_a_eta(a_si, eta_si, maxit, eps, &
                                    t_si, p_si, d_liq_si, d_air_si)
!==========================================================================

!THIS FUNCTION RETURNS THE LIQUID-HUMID-AIR PHASE EQUILIBRIUM FROM EQUAL PRESSURE,
!TEMPERATURE AND CHEMICAL POTENTIAL OF WATER OF BOTH PHASES AT GIVEN ENTROPY, ETA_SI,
!AND AIR FRACTION, A_SI, FROM INITIAL GUESSES FOR THE LIQUID DENSITY, D_LIQ_SI,
!THE HUMID-AIR DENSITY, D_AIR_SI, THE TEMPERATURE, T_SI, AND THE PRESSURE, P_SI

!THE ITERATION LIMIT EPS REFERS TO THE ERROR IN THE PRESSURE

!OUTPUT: 
!        LIQ_AIR_ITERATION_AT_A_ETA = ISOK IF SUCCESSFUL
!        LIQ_AIR_ITERATION_AT_A_ETA = ERRORRETURN IS RETURNED IF
!        - THE MAXIMUM NUMBER OF ITERATIONS IS EXCEEDED WITHOUT MEETING THE EXIT CRITERION
!        - FUNCTION CALLS TO FLU_F_SI OR AIR_F_SI HAVE RETURNED AN ERROR
!        - DENSITY, PRESSURE OR TEMPERATURE HAVE TAKEN A ZERO OR NEGATIVE VALUE DURING THE ITERATION
!     T_SI: ABSOLUTE TEMPERATURE IN K
!     P_SI: ABSOLUTE PRESSURE IN PA
! D_LIQ_SI: LIQUID DENSITY AT T_SI, P_SI
! D_AIR_SI: HUMID-AIR DENSITY AT THE SATURATION EQUILIBRIUM

!INPUT: 
!     ETA_SI: SPECIFIC ENTROPY IN J/(KG K)
!       A_SI: MASS FRACTION OF DRY AIR IN HUMID AIR, KG/KG
!      MAXIT: MAXIMUM NUMBER OF ITERATION STEPS TO BE DONE
!        EPS: REQUIRED ACCURACY OF VAPOUR PRESSURE
!             EPS > 0: ABSOLUTE PRESSURE TOLERANCE IN PA
!             EPS < 0: RELATIVE PRESSURE TOLERANCE
!       T_SI: INITIAL GUESS OF ABSOLUTE TEMPERATURE IN K
!       P_SI: INITIAL GUESS OF ABSOLUTE PRESSURE IN PA
!   D_LIQ_SI: INITIAL GUESS OF LIQUID DENSITY AT P_SI, T_SI
!   D_AIR_SI: INITIAL GUESS OF HUMID-AIR DENSITY


real*8 liq_air_iteration_at_a_eta, a_si, eta_si, eps, &
       t_si, p_si, d_liq_si, d_air_si
real*8 fh, fh_a, fh_d
real*8 fh_ad, fh_dd
real*8 fh_t, fh_at, fh_td, fh_tt
real*8 fl, fl_d, fl_dd
real*8 fl_t, fl_td
real*8 dl, dh, p, t
real*8 a(4, 4), b(4), x(4)

integer it, maxit

liq_air_iteration_at_a_eta = errorreturn

!CHECK FOR INVALID INPUT VALUES
if((d_air_si <= 0d0) .or. &
  (d_liq_si <= 0d0) .or. &
  (t_si <= 0d0) .or. &
  (p_si <= 0d0)) then
  t_si = errorreturn
  p_si = errorreturn
  d_liq_si = errorreturn
  d_air_si = errorreturn
  return
endif

if(check_limits == 1) then
  !AIR_LIMITS
  if(a_si < 0d0 .or. a_si > 1d0) then
    t_si = errorreturn
    p_si = errorreturn
    d_liq_si = errorreturn
    d_air_si = errorreturn
    return
  endif
else
  if(a_si < 0d0 .or. a_si >= 1d0) then
    t_si = errorreturn
    p_si = errorreturn
    d_liq_si = errorreturn
    d_air_si = errorreturn
    return
  endif
endif

check_limits = check_limits - 1

p = p_si
dh = d_air_si
dl = d_liq_si
t = t_si

do it = 1, maxit

  !DERIVATIVES OF THE HELMHOLTZ FUNCTION FOR 4D-NEWTON ITERATION
  !HUMID AIR:
  fh = air_f_si(0, 0, 0, a_si, t, dh)
  if(fh == errorreturn) go to 999
  fh_a = air_f_si(1, 0, 0, a_si, t, dh)
  if(fh_a == errorreturn) go to 999
  fh_t = air_f_si(0, 1, 0, a_si, t, dh)
  if(fh_t == errorreturn) go to 999
  fh_d = air_f_si(0, 0, 1, a_si, t, dh)
  if(fh_d == errorreturn) go to 999
  fh_ad = air_f_si(1, 0, 1, a_si, t, dh)
  if(fh_ad == errorreturn) go to 999
  fh_at = air_f_si(1, 1, 0, a_si, t, dh)
  if(fh_at == errorreturn) go to 999
  fh_tt = air_f_si(0, 2, 0, a_si, t, dh)
  if(fh_tt == errorreturn) go to 999
  fh_td = air_f_si(0, 1, 1, a_si, t, dh)
  if(fh_td == errorreturn) go to 999
  fh_dd = air_f_si(0, 0, 2, a_si, t, dh)
  if(fh_dd == errorreturn) go to 999

  !LIQUID WATER:
  fl = flu_f_si(0, 0, t, dl)
  if(fl == errorreturn) go to 999
  fl_t = flu_f_si(1, 0, t, dl)
  if(fl_t == errorreturn) go to 999
  fl_d = flu_f_si(0, 1, t, dl)
  if(fl_d == errorreturn) go to 999
  fl_td = flu_f_si(1, 1, t, dl)
  if(fl_td == errorreturn) go to 999
  fl_dd = flu_f_si(0, 2, t, dl)
  if(fl_dd == errorreturn) go to 999

  !COEFFICIENT MATRIX
  a(1, 1) = 1d0 / dh - 1d0 / dl
  a(1, 2) = fh_d - a_si * fh_ad - p / dh**2
  a(1, 3) = -fl_d + p / dl**2
  a(1, 4) = fh_t - a_si * fh_at - fl_t
  a(2, 1) = -1d0 / dh
  a(2, 2) = 2d0 * fh_d + dh * fh_dd
  a(2, 3) = 0d0
  a(2, 4) = dh * fh_td
  a(3, 1) = -1d0 / dl
  a(3, 2) = 0d0
  a(3, 3) = 2d0 * fl_d + dl * fl_dd
  a(3, 4) = dl * fl_td
  a(4, 1) = 0d0
  a(4, 2) = fh_td
  a(4, 3) = 0d0
  a(4, 4) = fh_tt

  !RIGHT-HAND SIDES, MUST VANISH AT EQUILIBRIUM
  b(1) = fl - fh + a_si * fh_a + p * (1d0 / dl - 1d0 / dh)
  b(2) = p / dh - dh * fh_d
  b(3) = p / dl - dl * fl_d
  b(4) = -eta_si - fh_t
  
  !SOLVE EQUATIONS
  if(matrix_solve(a, b, x, 4) /= 0) go to 999 !MATRIX SINGULAR

  !UPDATE PRESSURE, DENSITIES AND TEMPERATURES
  p = p + x(1)
  if(p <= 0d0) go to 999
  dh = dh + x(2)
  if(dh <= 0d0) go to 999
  dl = dl + x(3)
  if(dl <= 0d0) go to 999
  t = t + x(4)
  if(t <= 0d0) go to 999

  !CHECK ABSOLUTE OR RELATIVE ERROR LIMIT
  if((eps > 0d0 .and. abs(x(1)) < eps) .or. &
    (eps < 0d0 .and. abs(x(1)) < -eps * p)) then
    liq_air_iteration_at_a_eta = isok
    d_air_si = dh
    d_liq_si = dl
    t_si = t
    p_si = p
    go to 999
  end if

enddo

999 continue

check_limits = check_limits + 1

if(check_limits == 1) then
  !FLU_LIMITS
  if(t_si < flu_tmin .or. t_si > flu_tmax .or. &
  p_si <= 0d0 .or. &
  d_liq_si <= flu_dmin .or. d_liq_si > flu_dmax) then
    t_si = errorreturn
    p_si = errorreturn
    d_liq_si = errorreturn
    d_air_si = errorreturn
    liq_air_iteration_at_a_eta = errorreturn
    return
  endif
  !AIR_LIMITS
  if(t_si < dry_air_tmin .or. t_si > dry_air_tmax .or. &
  p_si <= 0d0 .or.  &
  d_air_si <= dry_air_dmin .or. d_air_si > dry_air_dmax) then
    t_si = errorreturn
    p_si = errorreturn
    d_liq_si = errorreturn
    d_air_si = errorreturn
    liq_air_iteration_at_a_eta = errorreturn
    return
  endif
endif

end function

!==========================================================================
function liq_air_iteration_at_a_p(a_si, p_si, maxit, eps, &
                                  t_si, d_liq_si, d_air_si)
!==========================================================================

!THIS FUNCTION RETURNS THE LIQUID-HUMID-AIR PHASE EQUILIBRIUM FROM EQUAL PRESSURES,
!TEMPERATURES AND CHEMICAL POTENTIAL OF WATER OF BOTH PHASES AT GIVEN PRESSURE, P_SI,
!AND AIR FRACTION, A_SI, FROM INITIAL GUESSES FOR THE LIQUID DENSITY, D_LIQ_SI,
!THE HUMID-AIR DENSITY, D_AIR_SI, AND THE TEMPERATURE, T_SI

!THE ITERATION LIMIT EPS REFERS TO THE ERROR IN THE TEMPERATURE

!OUTPUT: 
!        LIQ_AIR_ITERATION_AT_A_P = ISOK IF SUCCESSFUL
!        LIQ_AIR_ITERATION_AT_A_P = ERRORRETURN IS RETURNED IF
!        - THE MAXIMUM NUMBER OF ITERATIONS IS EXCEEDED WITHOUT MEETING THE EXIT CRITERION
!        - FUNCTION CALLS TO FLU_F_SI OR AIR_F_SI HAVE RETURNED AN ERROR
!        - DENSITY OR TEMPERATURE HAVE TAKEN A ZERO OR NEGATIVE VALUE DURING THE ITERATION
!     T_SI: ABSOLUTE TEMPERATURE IN K
! D_LIQ_SI: LIQUID DENSITY AT T_SI, P_SI
! D_AIR_SI: HUMID-AIR DENSITY AT THE SATURATION EQUILIBRIUM

!INPUT: 
!       P_SI: ABSOLUTE PRESSURE IN PA
!       A_SI: MASS FRACTION OF DRY AIR IN HUMID AIR, KG/KG
!      MAXIT: MAXIMUM NUMBER OF ITERATION STEPS TO BE DONE
!        EPS: REQUIRED ACCURACY OF VAPOUR PRESSURE
!             EPS > 0: ABSOLUTE TEMPERATURE TOLERANCE IN K
!             EPS < 0: RELATIVE TEMPERATURE TOLERANCE
!       T_SI: INITIAL GUESS OF ABSOLUTE TEMPERATURE IN K
!   D_LIQ_SI: INITIAL GUESS OF LIQUID DENSITY AT P_SI, T_SI
!   D_AIR_SI: INITIAL GUESS OF HUMID-AIR DENSITY


real*8 liq_air_iteration_at_a_p, a_si, p_si, eps, &
       t_si, d_liq_si, d_air_si
real*8 fh, fh_a, fh_t, fh_d
real*8 fh_ad, fh_at, fh_td, fh_dd
real*8 fl, fl_d, fl_t, fl_td, fl_dd
real*8 dl, dh, t
real*8 a(3, 3), b(3), x(3)

integer it, maxit

liq_air_iteration_at_a_p = errorreturn

!CHECK FOR INVALID INPUT VALUES
if(a_si < 0d0 .or. a_si > 1d0 .or. &
  d_air_si <= 0d0 .or. &
  d_liq_si <= 0d0 .or. &
  t_si <= 0d0 .or. &
  p_si <= 0d0) then
  t_si = errorreturn
  d_liq_si = errorreturn
  d_air_si = errorreturn
  return
endif

check_limits = check_limits - 1

t = t_si
dh = d_air_si
dl = d_liq_si

do it = 1, maxit

  !DERIVATIVES OF THE HELMHOLTZ FUNCTION FOR 3D-NEWTON ITERATION
  !HUMID AIR:
  fh = air_f_si(0, 0, 0, a_si, t, dh)
  if(fh == errorreturn) go to 999
  fh_a = air_f_si(1, 0, 0, a_si, t, dh)
  if(fh_a == errorreturn) go to 999
  fh_t = air_f_si(0, 1, 0, a_si, t, dh)
  if(fh_t == errorreturn) go to 999
  fh_d = air_f_si(0, 0, 1, a_si, t, dh)
  if(fh_d == errorreturn) go to 999
  fh_ad = air_f_si(1, 0, 1, a_si, t, dh)
  if(fh_ad == errorreturn) go to 999
  fh_at = air_f_si(1, 1, 0, a_si, t, dh)
  if(fh_at == errorreturn) go to 999
  fh_td = air_f_si(0, 1, 1, a_si, t, dh)
  if(fh_td == errorreturn) go to 999
  fh_dd = air_f_si(0, 0, 2, a_si, t, dh)
  if(fh_dd == errorreturn) go to 999

  !LIQUID WATER:
  fl = flu_f_si(0, 0, t, dl)
  if(fl == errorreturn) go to 999
  fl_t = flu_f_si(1, 0, t, dl)
  if(fl_t == errorreturn) go to 999
  fl_d = flu_f_si(0, 1, t, dl)
  if(fl_d == errorreturn) go to 999
  fl_td = flu_f_si(0, 2, t, dl)
  if(fl_td == errorreturn) go to 999
  fl_dd = flu_f_si(0, 2, t, dl)
  if(fl_dd == errorreturn) go to 999

  !COEFFICIENT MATRIX
  a(1, 1) = fh_t - a_si * fh_at - fl_t
  a(1, 2) = fh_d - a_si * fh_ad - p_si / dh**2
  a(1, 3) = -fl_d + p_si / dl**2
  a(2, 1) = dh * fh_td
  a(2, 2) = 2d0 * fh_d + dh * fh_dd
  a(2, 3) = 0d0
  a(3, 1) = dl * fl_td
  a(3, 2) = 0d0
  a(3, 3) = 2d0 * fl_d + dl * fl_dd

  !RIGHT-HAND SIDES, MUST VANISH AT EQUILIBRIUM
  b(1) = fl - fh + a_si * fh_a + p_si * (1d0 / dl - 1d0 / dh)
  b(2) = p_si / dh - dh * fh_d
  b(3) = p_si / dl - dl * fl_d
  
  !SOLVE EQUATIONS
  if(matrix_solve(a, b, x, 3) /= 0) go to 999 !MATRIX SINGULAR

  !UPDATE TEMPERATURE & DENSITIES
  t = t + x(1)
  if(t <= 0d0) go to 999
  dh = dh + x(2)
  if(dh <= 0d0) go to 999
  dl = dl + x(3)
  if(dl <= 0d0) go to 999

  !CHECK ABSOLUTE OR RELATIVE ERROR LIMIT
  if((eps > 0d0 .and. abs(x(1)) < eps) .or. &
     (eps < 0d0 .and. abs(x(1)) < -eps * t)) then
    liq_air_iteration_at_a_p = isok
    d_air_si = dh
    d_liq_si = dl
    t_si = t
    go to 999
  end if

enddo

999 continue

check_limits = check_limits + 1

if(check_limits == 1) then
  !FLU_LIMITS
  if(t_si < flu_tmin .or. t_si > flu_tmax .or. &
  d_liq_si <= flu_dmin .or. d_liq_si > flu_dmax) then
    t_si = errorreturn
    d_liq_si = errorreturn
    d_air_si = errorreturn
    liq_air_iteration_at_a_p = errorreturn
    return
  endif
  !AIR_LIMITS
  if(t_si < dry_air_tmin .or. t_si > dry_air_tmax .or. &
  d_air_si <= dry_air_dmin .or. d_air_si > dry_air_dmax) then
    t_si = errorreturn
    d_liq_si = errorreturn
    d_air_si = errorreturn
    liq_air_iteration_at_a_p = errorreturn
    return
  endif
endif

end function

!==========================================================================
function aux_airfraction_si(t_si, p_si)
!==========================================================================

!FUNCTION RETURNS AN ESTIMATE OF THE AIR MASS FRACTION OF SATURATED
!HUMID AIR AT GIVEN ABSOLUTE TEMPERATURE, T_SI, IN K AND ABSOLUTE
!PRESSURE, P_SI, IN PA

real*8 aux_airfraction_si, t_si, p_si
real*8 dh, dv, pv

aux_airfraction_si = errorreturn
if(t_si <= 0d0) return
if(p_si <= 0d0) return

!AS AN ESTIMATE, ADD THE DENSITIES OF DRY AIR AND VAPOUR

!VAPOUR PRESSURE
pv = liq_vap_vapourpressure_si(t_si)
if(pv == errorreturn) return
if(pv > p_si) return

if(pv == p_si) then
  aux_airfraction_si = 0
  return
end if

!VAPOUR DENSITY
dv = liq_vap_density_vap_si()
if(dv == errorreturn) return
if(dv <= 0d0) return

!DRY AIR DENSITY AT REMAINING PARTIAL PRESSURE
dh = air_density_si(1d0, t_si, p_si - pv)
if(dh == errorreturn) return
if(dh <= 0d0) return

!AIR FRACTION OF THE IDEAL MIXTURE
aux_airfraction_si = dh / (dh + dv)
           
end function

!==========================================================================
function aux_temperature_si(a_si, p_si)
!==========================================================================

!FUNCTION RETURNS AN ESTIMATE OF THE TEMPERATURE IN K OF SATURATED
!HUMID AIR AT GIVEN AIR MASS FRACTION, A_SI, IN KG/KG AND ABSOLUTE
!PRESSURE, P_SI, IN PA

real*8 aux_temperature_si, a_si, p_si
real*8 pv, t

aux_temperature_si = errorreturn
if(a_si < 0d0 .or. a_si >= 1d0) return
if(p_si <= 0d0) return

!AS AN ESTIMATE, IGNORE THE AIR INFLUENCE ON THE BOILING TEMPERATURE

!PARTIAL VAPOUR PRESSURE
pv = p_si * air_molfraction_vap_si(a_si)

!RELATED SATURATION TEMPERATURE
t = liq_vap_boilingtemperature_si(pv)
if(t == errorreturn) return
if(t <= 0d0) return

aux_temperature_si = t

end function

!==========================================================================
function aux_ict_si(a_si, eta_si)
!==========================================================================

!FUNCTION RETURNS AN ESTIMATE OF THE ISENTROPIC CONDENSATION TEMPERATURE
!IN K OF HUMID AIR AT GIVEN AIR MASS FRACTION, A_SI, IN KG/KG AND ENTROPY
!ETA_SI, IN J/(KG K)

real*8 aux_ict_si, a_si, eta_si
real*8 tt, pt, ra, rw, cpa, cpv, l

real*8 etat, rav, xv
real*8 numer, denom

tt = tp_temperature_si
pt = tp_pressure_iapws95_si

ra = gas_constant_air_si
rw = gas_constant_h2o_si

!PROPERTIES AT THE TRIPLE POINT
cpa = 1003.69d0  !HEAT CAPACITY OF AIR, IN J/(KG K)
cpv = 1884.352d0 !HEAT CAPACITY OF VAPOUR, IN J/(KG K)
l = tp_enthalpy_vap_si - pt / tp_density_liq_iapws95_si !LATENT HEAT

aux_ict_si = errorreturn
if(a_si < 0d0 .or. a_si >= 1d0) return

!TO ESTIMATE T FROM ETA AND A, USE THE CLAUSIUS-CLAPEYRON EQUATION PVAP(T)
!FOR THE PARTIAL VAPOUR PRESSURE TO ELIMINATE PVAP FROM THE IDEAL-GAS
!EQUATION ETA(A,T,P) = CONST, AND SOLVE IT FOR T

etat = air_g_entropy_si(a_si, tt, pt)  !ENTROPY OF HUMID AIR AT THE TRIPLE POINT
if(etat == errorreturn) return
rav = a_si * ra + (1d0 - a_si) * rw    !GAS CONSTANT OF HUMID AIR
xv = air_molfraction_vap_si(a_si)
if(xv == errorreturn) return
if(xv <= 0d0) return

denom = a_si * (cpa - ra * l / (rw * tt)) + (1d0 - a_si) * (cpv - l / tt)
if(denom == 0d0) return

numer = eta_si - etat - rav * log(xv)

aux_ict_si = tt * exp(numer / denom)

end function

!==========================================================================
function aux_pressure_si(a_si, t_si)
!==========================================================================

!FUNCTION RETURNS AN ESTIMATE OF THE PRESSURE IN PA OF SATURATED
!HUMID AIR AT GIVEN AIR MASS FRACTION, A_SI, IN KG/KG AND ABSOLUTE
!TEMPERATURE, T_SI, IN K

real*8 aux_pressure_si, a_si, t_si
real*8 pv, pa, d

aux_pressure_si = errorreturn
if(a_si < 0d0 .or. a_si >= 1d0) return
if(t_si <= 0d0) return

!AS AN ESTIMATE, IGNORE THE AIR-VAPOUR INTERACTION

!PARTIAL VAPOUR PRESSURE
pv = liq_vap_vapourpressure_si(t_si)
if(pv == errorreturn) return
if(pv <= 0d0) return
d = liq_vap_density_vap_si()
if(d == errorreturn) return
if(d <= 0d0) return  !VAPOUR DENSITY

!PARTIAL AIR PRESSURE
d = a_si / (1d0 - a_si) * d !AIR DENSITY
pa = air_f_pressure_si(1d0, t_si, d)
if(pa == errorreturn) return
if(pa <= 0d0) return

aux_pressure_si = pa + pv

end function

!==========================================================================
subroutine set_liq_air_state(a, t, p, eta, dl, dh)
!==========================================================================

real*8 a, t, p, eta, dl, dh

!STORES THE ACTUAL PROPERTIES AS THE CURRENT EQUILIBRIUM STATE DESCRIPTOR
equi_liq_air_done = isok

equi_liq_air_a = a
equi_liq_air_t = t
equi_liq_air_p = p
equi_liq_air_eta = eta
equi_liq_air_d_liq = dl
equi_liq_air_d_air = dh

end subroutine

!==========================================================================
subroutine clear_liq_air_state()
!==========================================================================

!CLEARS THE CURRENT EQUILIBRIUM STATE DESCRIPTOR

equi_liq_air_done = 0

end subroutine

!==========================================================================
subroutine init_it_ctrl_liq_air()
!==========================================================================

real*8 t_triple, p_triple

!TRIPLE POINT VALUES
t_triple = tp_temperature_si
p_triple = tp_pressure_iapws95_si

if(ctrl_initialized == isok) return

ctrl_initialized = isok

!SET DEFAULT VALUES AND MODES FOR DENSITY ITERATION
ctrl_mode_pressure = 0
ctrl_mode_temperature = 0
ctrl_mode_humidity = 0

ctrl_loop_maximum = 100
ctrl_init_t = t_triple
ctrl_init_p = p_triple
ctrl_init_a = 1d0 - 0.001d0

ctrl_eps_exit_p_vap = -0.0000001d0 !RELATIVE, 0.1 PPM
ctrl_eps_exit_temp =  -0.0000001d0 !RELATIVE, 0.1 PPM
ctrl_eps_exit_press = -0.0000001d0 !RELATIVE, 0.1 PPM

end subroutine

!==========================================================================
subroutine set_it_ctrl_liq_air(key, value)
!==========================================================================

!THIS SUB SETS CONTROL PARAMETERS FOR THE ITERATION USED TO COMPUTE
!SATURATED HUMID AIR PROPERTIES

!KEY              VALUE
!IT_STEPS         0           SET ITERATION NUMBER TO DEFAULT (100)
!IT_STEPS         N > 0    SET ITERATION NUMBER TO N
!IT_STEPS        -1           DO NOT ITERATE, USE INITIAL VALUES AS THE SATURATION STATE

!INIT_HUM         0           USE DEFAULT AIR FRACTION TO START ( = AUX_AIRFRACTION_SI(T, P))
!INIT_HUM         A > 0    USE VALUE A AS AIR FRACTION TO START

!INIT_TEMP        0           USE DEFAULT TEMPERATURE TO START ( = AUX_TEMPERATURE_SI(A, P))
!INIT_TEMP        T > 0    USE VALUE T AS TEMPERATURE TO START

!INIT_PRESS       0           USE DEFAULT PRESSURE TO START ( = AUX_PRESSURE_SI(A, T))
!INIT_PRESS       P > 0    USE VALUE P AS PRESSURE TO START

!TOL_VAP_PRESS    0           USE DEFAULT EXIT ACCURACY FOR VAPOUR PRESSURE (0.1 PPM)
!TOL_VAP_PRESS    EPS         USE EPS AS EXIT ACCURACY FOR VAPOUR PRESSURE (EPS < 0 MEANS RELATIVE ERROR)

!TOL_TEMP         0           USE DEFAULT EXIT ACCURACY FOR TEMPERATURE (0.1 PPM)
!TOL_TEMP         EPS         USE EPS AS EXIT ACCURACY FOR TEMPERATURE (EPS < 0 MEANS RELATIVE ERROR)

!TOL_PRESS        0           USE DEFAULT EXIT ACCURACY FOR PRESSURE (0.1 PPM)
!TOL_PRESS        EPS         USE EPS AS EXIT ACCURACY FOR PRESSURE (EPS < 0 MEANS RELATIVE ERROR)

character*13 key
real*8 value

call init_it_ctrl_liq_air

call clear_liq_air_state

select case (trim(key))

  case ("it_steps");               !ITERATION STEPS
    if(value == 0d0) then
      ctrl_loop_maximum = 100   !DEFAULT = 100
    elseif(value < 0d0) then
      ctrl_loop_maximum = -1
    else
      ctrl_loop_maximum = nint(value)
    endif

  case ("init_hum");               !START AIR FRACTION
    if(value == 0d0) then
      ctrl_mode_humidity = 0    !DEFAULT = AUX POLYNOMIAL
    else
      ctrl_mode_humidity = 1
      ctrl_init_a = value
    endif
    
  case ("init_temp");              !START TEMPERATURE
    if(value == 0d0) then
      ctrl_mode_temperature = 0 !DEFAULT = AUX POLYNOMIAL
    else
      ctrl_mode_temperature = 1
      ctrl_init_t = value
    endif

  case ("init_press");             !START PRESSURE
    if(value == 0d0) then
      ctrl_mode_pressure = 0    !DEFAULT = AUX POLYNOMIAL
    else
      ctrl_mode_pressure = 1
      ctrl_init_p = value
    endif

  case ("tol_vap_press");          !REQUIRED VAPOUR PRESSURE TOLERANCE
    if(value == 0d0) then
      ctrl_eps_exit_p_vap = -0.0000001d0   !DEFAULT = 0.1 PPM RELATIVE
    else
      ctrl_eps_exit_p_vap = value
    endif

  case ("tol_temp");               !REQUIRED TEMPERATURE TOLERANCE
    if(value == 0d0) then
      ctrl_eps_exit_temp = -0.0000001d0   !DEFAULT = 0.1 PPM RELATIVE
    else
      ctrl_eps_exit_temp = value
    endif

  case ("tol_press");              !REQUIRED TOTAL PRESSURE TOLERANCE
    if(value == 0d0) then
      ctrl_eps_exit_press = -0.0000001d0   !DEFAULT = 0.1 PPM RELATIVE
    else
      ctrl_eps_exit_press = value
    endif

  case default; write(*,*)key,' not supported'

end select

end subroutine

end module liq_air_4a

module air_3b

!#########################################################################

!THIS MODULE IMPLEMENTS THERMODYNAMIC PROPERTIES OF HUMID AIR AS FUNCTIONS
!OF AIR FRACTION, TEMPERATURE AND PRESSURE, COMPUTED NUMERICALLY FROM
!THE GIBBS FUNCTION OF HUMID AIR.

!#########################################################################

!IMPLEMENTATION IN FORTRAN BY D.G. WRIGHT
!FOR PUBLICATION IN OCEAN SCIENCE, AS DESCRIBED IN THE PAPERS

!FEISTEL, R., WRIGHT, D.G., JACKETT, D.R., MIYAGAWA, K., REISSMANN, J.H.,
!WAGNER, W., OVERHOFF, U., GUDER, C., FEISTEL, A., MARION, G.M.:
!NUMERICAL IMPLEMENTATION AND OCEANOGRAPHIC APPLICATION OF THE THERMODYNAMIC
!POTENTIALS OF WATER, VAPOUR, ICE, SEAWATER AND AIR. PART I: BACKGROUND AND EQUATIONS. 
!OCEAN SCIENCES, 2009, IN PREPARATION.

!WRIGHT, D.G., FEISTEL, R., JACKETT, D.R., MIYAGAWA, K., REISSMANN, J.H., 
!WAGNER, W., OVERHOFF, U., GUDER, C., FEISTEL, A., MARION, G.M.:
!NUMERICAL IMPLEMENTATION AND OCEANOGRAPHIC APPLICATION OF THE THERMODYNAMIC
!POTENTIALS OF WATER, VAPOUR, ICE, SEAWATER AND AIR. PART II: THE LIBRARY ROUTINES, 
!OCEAN SCIENCES., 2009, IN PREPARATION.

!FEISTEL, R., KRETZSCHMAR, H.-J., SPAN, R., HAGEN, E., !WRIGHT, D.G., HERRMANN, S.:
!THERMODYNAMIC PROPERTIES OF SEA AIR.
!OCEAN SCIENCE DISCUSSION 6(2009)2193-2325.

!#########################################################################

!THIS MODULE REQUIRES THE LIBRARY MODULES:
!     CONSTANTS_0, FILE CONSTANTS_0.F90
!     CONVERT_0,   FILE CONVERT_0.F90
!     AIR_1,       FILE AIR_1.F90
!     AIR_2,       FILE AIR_2.F90
!     AIR_3A,      FILE AIR_3A.F90

!NESTED USE ASSOCIATIONS
!     MATHS_0,     FILE MATHS_0.F90
!     FLU_1,       FILE FLU_1.F90

!#########################################################################

use constants_0
use convert_0
use air_1
use air_2
use air_3a

implicit none
private

character*16, private :: version = '8 Jun 2010'

public :: air_g_chempot_vap_si, air_g_compressibilityfactor_si, &
          air_g_contraction_si, air_g_cp_si, air_g_cv_si, air_g_density_si, &
          air_g_enthalpy_si, air_g_entropy_si, air_g_expansion_si, &
          air_g_gibbs_energy_si, air_g_internal_energy_si, &
          air_g_kappa_s_si, air_g_kappa_t_si, air_g_lapserate_si, &
          air_g_soundspeed_si, chk_lemmon_etal_2000

contains

!=========================================================================
function air_g_chempot_vap_si(a_si, t_si, p_si)
!=========================================================================

!THIS FUNCTION COMPUTES THE CHEMICAL POTENTIAL OF VAPOUR IN HUMID AIR
!FROM THE MASS FRACTION OF AIR, TEMPERATURE AND PRESSURE

!OUTPUT: 
!CHEMICAL POTENTIAL IN J/KG

!INPUT:  
!A_SI:  MASS FRACTION OF DRY AIR IN HUMID AIR IN KG/KG
!T_SI:  ABSOLUTE TEMPERATURE IN K
!P_SI:  ABSOLUTE PRESSURE IN PA

!CHECK VALUE WITH DEFAULT SETTINGS, V1.0:
!AIR_G_CHEMPOT_VAP_SI(0.9,300,1E5) = 193678.583379

!CHECK VALUE WITH DEFAULT SETTINGS, V1.1:
!AIR_G_CHEMPOT_VAP_SI(0.9,300,1E5) = 193705.688576

real*8 air_g_chempot_vap_si, a_si, t_si, p_si
real*8  g, g_a

air_g_chempot_vap_si = errorreturn

if(a_si < 0 .or. a_si > 1) return
if(t_si <= 0) return
if(p_si <= 0) return

!G
g = air_g_si(0, 0, 0, a_si, t_si, p_si)
if(g == errorreturn ) return

!DG/DA
g_a = air_g_si(1, 0, 0, a_si, t_si, p_si)
if(g == errorreturn) return

air_g_chempot_vap_si = g - a_si * g_a  !g - A(dg/dA)

end function

!=========================================================================
function air_g_compressibilityfactor_si(a_si, t_si, p_si)  !dbg
!=========================================================================

!THIS FUNCTION COMPUTES THE COMPRESSIBILITY FACTOR OF HUMID AIR
!FROM THE MASS FRACTION OF AIR, TEMPERATURE AND PRESSURE

!OUTPUT:
!Z = P * V/(RAV * T)  COMPRESSIBILITY FACTOR OF HUMID AIR

!INPUT:
!A_SI      MASS FRACTION OF DRY AIR IN HUMID AIR IN KG/KG
!T_SI      ABSOLUTE TEMPERATURE IN K
!P_SI      ABSOLUTE PRESSURE IN PA

!CHECK VALUE WITH DEFAULT SETTINGS, V1.0: 
!AIR_G_COMPRESSIBILITYFACTOR_SI(0.9, 300, 1E5) = 0.99782665440423

!CHECK VALUE WITH DEFAULT SETTINGS, V1.1: 
!AIR_G_COMPRESSIBILITYFACTOR_SI(0.9, 300, 1E5) = 0.997825670991

!NOTE: THE ACCURACY OF THIS FUNCTION DEPENDS ON THE ITERATION SETTINGS FOR
!      DENSITY COMPUTED IN AIR_3A

real*8 air_g_compressibilityfactor_si, a_si, t_si, p_si
real*8 d, rav

air_g_compressibilityfactor_si = errorreturn

if(a_si < 0d0 .or. a_si > 1d0) return
if(t_si <= 0d0) return
if(p_si <= 0d0) return

d = air_density_si(a_si, t_si, p_si)
if(d == errorreturn) return
if(d <= 0d0) return

rav = air_molar_mass_si(a_si)
if(rav == errorreturn) return
if(rav <= 0d0) return
rav = gas_constant_molar_L2000 / rav

air_g_compressibilityfactor_si = p_si / (d * rav * t_si)

end function

!=========================================================================
function air_g_contraction_si(a_si, t_si, p_si)
!=========================================================================

!THIS FUNCTION COMPUTES THE CONTRACTION COEFFICIENT OF HUMID AIR
!FROM THE MASS FRACTION OF AIR, TEMPERATURE AND PRESSURE

!OUTPUT:   
!BETA = -(1/V) * (DV/DA)_T_P  CONTRACTION COEFFICIENT OF HUMID AIR IN KG/KG,
!       I.E. THE RELATIVE DENSITY INCREASE IF SOME VAPOUR IS REPLACED BY AIR

!INPUT:
!A_SI      MASS FRACTION OF DRY AIR IN HUMID AIR IN KG/KG
!T_SI      ABSOLUTE TEMPERATURE IN K
!P_SI      ABSOLUTE PRESSURE IN PA

!NOTE: THE ACCURACY OF THIS FUNCTION DEPENDS ON THE ITERATION SETTINGS FOR
!      DENSITY COMPUTED IN AIR_3A

!CHECK VALUE WITH DEFAULT SETTINGS, V1.0: 
!AIR_G_CONTRACTION_SI(0.9, 300, 1E5) = 0.529966294386

!CHECK VALUE WITH DEFAULT SETTINGS, V1.1: 
!AIR_G_CONTRACTION_SI(0.9, 300, 1E5) = 0.530280645260

real*8 air_g_contraction_si, a_si, t_si,p_si
real*8 d, g_ap

air_g_contraction_si = errorreturn

if(a_si < 0d0 .or. a_si > 1d0) return
if(t_si <= 0d0) return
if(p_si <= 0d0) return

d = air_density_si(a_si, t_si, p_si)
if(d == errorreturn) return

g_ap = air_g_si(1, 0, 1, a_si, t_si, p_si)
if(g_ap == errorreturn) return

air_g_contraction_si = -d * g_ap

end function

!=========================================================================
function air_g_cp_si(a_si, t_si, p_si)
!=========================================================================

!THIS FUNCTION COMPUTES THE ISOBARIC HEAT CAPACITY OF HUMID AIR
!FROM THE MASS FRACTION OF AIR, TEMPERATURE AND PRESSURE

!OUTPUT:
!CP = T * (DETA/DT)_P  ISOBARIC HEAT CAPACITY OF HUMID AIR IN J/(KG K)

!INPUT:
!A_SI      MASS FRACTION OF DRY AIR IN HUMID AIR IN KG/KG
!T_SI      ABSOLUTE TEMPERATURE IN K
!P_SI      ABSOLUTE PRESSURE IN PA

!CHECK VALUE WITH DEFAULT SETTINGS, V1.0: 
!AIR_G_CP_SI(0.9, 300, 1E5) = 1246.47586191

!CHECK VALUE WITH DEFAULT SETTINGS, V1.1: 
!AIR_G_CP_SI(0.9, 300, 1E5) = 1246.34991644

!NOTE: THE ACCURACY OF THIS FUNCTION DEPENDS ON THE ITERATION SETTINGS FOR
!      DENSITY COMPUTED IN AIR_3A

real*8 air_g_cp_si, a_si, t_si, p_si
real*8 d

air_g_cp_si = errorreturn

if(a_si < 0d0 .or. a_si > 1d0) return
if(t_si <= 0d0) return
if(p_si <= 0d0) return

d = air_density_si(a_si, t_si, p_si)
if(d == errorreturn) return

air_g_cp_si = air_f_cp_si(a_si, t_si, d)

end function

!=========================================================================
function air_g_cv_si(a_si, t_si, p_si)
!=========================================================================

!THIS FUNCTION COMPUTES THE ISOCHORIC HEAT CAPACITY OF HUMID AIR
!FROM THE MASS FRACTION OF AIR, TEMPERATURE AND PRESSURE

!OUTPUT:
!CV = T * (D2F/DT2)_D  ISOCHORIC HEAT CAPACITY OF HUMID AIR IN J/(KG K)

!INPUT:
!A_SI      MASS FRACTION OF DRY AIR IN HUMID AIR IN KG/KG
!T_SI      ABSOLUTE TEMPERATURE IN K
!P_SI      ABSOLUTE PRESSURE IN PA

!CHECK VALUE WITH DEFAULT SETTINGS, V1.0: 
!AIR_G_CV_SI(0.9, 300, 1E5) = 920.676202551

!CHECK VALUE WITH DEFAULT SETTINGS, V1.1: 
!AIR_G_CV_SI(0.9, 300, 1E5) = 920.600781012

!NOTE: THE ACCURACY OF THIS FUNCTION DEPENDS ON THE ITERATION SETTINGS FOR
!      DENSITY COMPUTED IN AIR_3A

real*8 air_g_cv_si, a_si, t_si, p_si
real*8 d

air_g_cv_si = errorreturn

if(a_si < 0d0 .or. a_si > 1d0) return
if(t_si <= 0d0) return
if(p_si <= 0d0) return

d = air_density_si(a_si, t_si, p_si)
if(d == errorreturn) return

air_g_cv_si = air_f_cv_si(a_si, t_si, d)

end function

!=========================================================================
function air_g_density_si(a_si, t_si, p_si)
!=========================================================================

!THIS SIMPLY WRAPS THE DENSITY CALL AIR_DENSITY_SI() OF AIR_3A
!FOR A UNIFORM APPEARANCE AIR_G_... IF A, T, P ARE THE ARGUMENTS

!OUTPUT:
!RHO = 1/(DG/DT)_A_T  DENSITY OF HUMID AIR IN KG/M3

!INPUT:
!A_SI      MASS FRACTION OF DRY AIR IN HUMID AIR IN KG/KG
!T_SI      ABSOLUTE TEMPERATURE IN K
!P_SI      ABSOLUTE PRESSURE IN PA

!CHECK VALUE WITH DEFAULT SETTINGS, V1.0: 
!AIR_G_DENSITY_SI(0.9, 300, 1E5) = 1.09686619009

!CHECK VALUE WITH DEFAULT SETTINGS, V1.1: 
!AIR_G_DENSITY_SI(0.9, 300, 1E5) = 1.09708772444

!NOTE: THE ACCURACY OF THIS FUNCTION DEPENDS ON THE ITERATION SETTINGS FOR
!      DENSITY COMPUTED IN AIR_3A

real*8 air_g_density_si, a_si, t_si, p_si

air_g_density_si = air_density_si(a_si, t_si, p_si)

end function

!=========================================================================
function air_g_enthalpy_si(a_si, t_si, p_si)
!=========================================================================

!THIS FUNCTION COMPUTES THE ENTHALPY OF HUMID AIR
!FROM THE MASS FRACTION OF AIR, TEMPERATURE AND PRESSURE

!OUTPUT:
!H = G - T*(DG/DT)_A_P ENTHALPY OF HUMID AIR IN J/KG

!INPUT:
!A_SI      MASS FRACTION OF DRY AIR IN HUMID AIR IN KG/KG
!T_SI      ABSOLUTE TEMPERATURE IN K
!P_SI      ABSOLUTE PRESSURE IN PA

!CHECK VALUE WITH DEFAULT SETTINGS, V1.0: 
!AIR_G_ENTHALPY_SI(0.9, 300, 1E5) = 277935.361122

!CHECK VALUE WITH DEFAULT SETTINGS, V1.1: 
!AIR_G_ENTHALPY_SI(0.9, 300, 1E5) = 277928.954795

!NOTE: THE ACCURACY OF THIS FUNCTION DEPENDS ON THE ITERATION SETTINGS FOR
!      DENSITY COMPUTED IN AIR_3A

real*8 air_g_enthalpy_si, a_si, t_si, p_si
real*8 d

air_g_enthalpy_si = errorreturn

if(a_si < 0d0 .or. a_si > 1d0) return
if(t_si <= 0d0) return
if(p_si <= 0d0) return

d = air_density_si(a_si, t_si, p_si)
if(d == errorreturn) return

air_g_enthalpy_si = air_f_enthalpy_si(a_si, t_si, d)

end function

!=========================================================================
function air_g_entropy_si(a_si, t_si, p_si)
!=========================================================================

!THIS FUNCTION COMPUTES THE ENTROPY OF HUMID AIR
!FROM THE MASS FRACTION OF AIR, TEMPERATURE AND PRESSURE

!OUTPUT:
!ETA = - (DG/DT)_A_P ENTROPY OF HUMID AIR IN J/(KG K)

!INPUT:
!A_SI      MASS FRACTION OF DRY AIR IN HUMID AIR IN KG/KG
!T_SI      ABSOLUTE TEMPERATURE IN K
!P_SI      ABSOLUTE PRESSURE IN PA

!CHECK VALUE WITH DEFAULT SETTINGS, V1.0: 
!AIR_G_ENTROPY_SI(0.9, 300, 1E5) = 911.203092171

!CHECK VALUE WITH DEFAULT SETTINGS, V1.1: 
!AIR_G_ENTROPY_SI(0.9, 300, 1E5) = 911.170080461

!NOTE: THE ACCURACY OF THIS FUNCTION DEPENDS ON THE ITERATION SETTINGS FOR
!      DENSITY COMPUTED IN AIR_3A

real*8 air_g_entropy_si, a_si, t_si, p_si
real*8 d

air_g_entropy_si = errorreturn

if(a_si < 0d0 .or. a_si > 1d0) return
if(t_si <= 0d0) return
if(p_si <= 0d0) return

d = air_density_si(a_si, t_si, p_si)
if(d == errorreturn) return

air_g_entropy_si = air_f_entropy_si(a_si, t_si, d)

end function

!=========================================================================
function air_g_expansion_si(a_si, t_si, p_si)
!=========================================================================

!THIS FUNCTION COMPUTES THE THERMAL EXPANSION COEFFICIENT OF HUMID AIR
!FROM THE MASS FRACTION OF AIR, TEMPERATURE AND PRESSURE

!OUTPUT:
!ALPHA = -(1/V) * (DV/DT)_A_P  THERMAL EXPANSION COEFFICIENT OF HUMID AIR IN 1/K

!INPUT:
!A_SI      MASS FRACTION OF DRY AIR IN HUMID AIR IN KG/KG
!T_SI      ABSOLUTE TEMPERATURE IN K
!P_SI      ABSOLUTE PRESSURE IN PA

!CHECK VALUE WITH DEFAULT SETTINGS, V1.0: 
!AIR_G_EXPANSION_SI(0.9, 300, 1E5) = 3.45696232117E-03

!CHECK VALUE WITH DEFAULT SETTINGS, V1.1: 
!AIR_G_EXPANSION_SI(0.9, 300, 1E5) = 3.45704654420E-03

!NOTE: THE ACCURACY OF THIS FUNCTION DEPENDS ON THE ITERATION SETTINGS FOR
!      DENSITY COMPUTED IN AIR_3A

real*8 air_g_expansion_si, a_si, t_si, p_si
real*8 d

air_g_expansion_si = errorreturn

if(a_si < 0d0 .or. a_si > 1d0) return
if(t_si <= 0d0) return
if(p_si <= 0d0) return

d = air_density_si(a_si, t_si, p_si)
if(d == errorreturn) return

air_g_expansion_si = air_f_expansion_si(a_si, t_si, d)

end function

!=========================================================================
function air_g_gibbs_energy_si(a_si, t_si, p_si)
!=========================================================================

!THIS FUNCTION COMPUTES THE GIBBS ENERGY OF HUMID AIR
!FROM THE MASS FRACTION OF AIR, TEMPERATURE AND PRESSURE

!OUTPUT:
!G = F + D*(DF/DD)_A_T   GIBBS ENERGY OF HUMID AIR IN J/KG

!INPUT:
!A_SI      MASS FRACTION OF DRY AIR IN HUMID AIR IN KG/KG
!T_SI      ABSOLUTE TEMPERATURE IN K
!P_SI      ABSOLUTE PRESSURE IN PA

!CHECK VALUE WITH DEFAULT SETTINGS, V1.0: 
!AIR_G_GIBBS_ENERGY_SI(0.9, 300, 1E5) = 4574.43347102

!CHECK VALUE WITH DEFAULT SETTINGS, V1.1: 
!AIR_G_GIBBS_ENERGY_SI(0.9, 300, 1E5) = 4577.93065689

!NOTE: THE ACCURACY OF THIS FUNCTION DEPENDS ON THE ITERATION SETTINGS FOR
!      DENSITY COMPUTED IN AIR_3A

real*8 air_g_gibbs_energy_si, a_si, t_si, p_si
real*8 d

air_g_gibbs_energy_si = errorreturn

if(a_si < 0d0 .or. a_si > 1d0) return
if(t_si <= 0d0) return
if(p_si <= 0d0) return

d = air_density_si(a_si, t_si, p_si)
if(d == errorreturn) return

air_g_gibbs_energy_si = air_f_gibbs_energy_si(a_si, t_si, d)

end function

!=========================================================================
function air_g_internal_energy_si(a_si, t_si, p_si)
!=========================================================================

!THIS FUNCTION COMPUTES THE INTERNAL ENERGY OF HUMID AIR
!FROM THE MASS FRACTION OF AIR, TEMPERATURE AND PRESSURE

!OUTPUT:
!U(T,P) = G - T*(DG/DT)_A_P -P*(DG/DP)_A_T INTERNAL ENERGY OF HUMID AIR IN J/KG

!INPUT:
!A_SI      MASS FRACTION OF DRY AIR IN HUMID AIR IN KG/KG
!T_SI      ABSOLUTE TEMPERATURE IN K
!P_SI      ABSOLUTE PRESSURE IN PA

!CHECK VALUE WITH DEFAULT SETTINGS, V1.0: 
!AIR_G_INTERNAL_ENERGY_SI(0.9, 300, 1E5) = 186766.537702

!CHECK VALUE WITH DEFAULT SETTINGS, V1.1: 
!AIR_G_INTERNAL_ENERGY_SI(0.9, 300, 1E5) = 186778.541048

!NOTE: THE ACCURACY OF THIS FUNCTION DEPENDS ON THE ITERATION SETTINGS FOR
!      DENSITY COMPUTED IN AIR_3A

real*8 air_g_internal_energy_si, a_si, t_si, p_si
real*8 d

air_g_internal_energy_si = errorreturn

if(a_si < 0d0 .or. a_si > 1d0) return
if(t_si <= 0d0) return
if(p_si <= 0d0) return

d = air_density_si(a_si, t_si, p_si)
if(d == errorreturn) return

air_g_internal_energy_si = air_f_internal_energy_si(a_si, t_si, d)

end function

!=========================================================================
function air_g_kappa_s_si(a_si, t_si, p_si)
!=========================================================================

!THIS FUNCTION COMPUTES THE ISENTROPIC COMPRESSIBILITY OF HUMID AIR
!FROM THE MASS FRACTION OF AIR, TEMPERATURE AND PRESSURE

!OUTPUT:
!KAPPA_S = (1/V) * (DV/DP)_A_ETA  ISENTROPIC COMPRESSIBILITY OF HUMID AIR IN 1/PA

!INPUT:
!A_SI      MASS FRACTION OF DRY AIR IN HUMID AIR IN KG/KG
!T_SI      ABSOLUTE TEMPERATURE IN K
!P_SI      ABSOLUTE PRESSURE IN PA

!CHECK VALUE WITH DEFAULT SETTINGS, V1.0: 
!AIR_G_KAPPA_S_SI(0.9, 300, 1E5) = 7.41018952703E-06

!CHECK VALUE WITH DEFAULT SETTINGS, V1.1: 
!AIR_G_KAPPA_S_SI(0.9, 300, 1E5) = 7.41034505449E-06

!NOTE: THE ACCURACY OF THIS FUNCTION DEPENDS ON THE ITERATION SETTINGS FOR
!      DENSITY COMPUTED IN AIR_3A

real*8 air_g_kappa_s_si, a_si, t_si, p_si
real*8 d

air_g_kappa_s_si = errorreturn

if(a_si < 0d0 .or. a_si > 1d0) return
if(t_si <= 0d0) return
if(p_si <= 0d0) return

d = air_density_si(a_si, t_si, p_si)
if(d == errorreturn) return

air_g_kappa_s_si = air_f_kappa_s_si(a_si, t_si, d)

end function

!=========================================================================
function air_g_kappa_t_si(a_si, t_si, p_si)
!=========================================================================

!THIS FUNCTION COMPUTES THE ISOTHERMAL COMPRESSIBILITY OF HUMID AIR
!FROM THE MASS FRACTION OF AIR, TEMPERATURE AND PRESSURE

!OUTPUT:
!KAPPA_T = (1/V) * (DV/DP)_A_T  ISOTHERMAL COMPRESSIBILITY OF HUMID AIR IN 1/PA

!INPUT:
!A_SI      MASS FRACTION OF DRY AIR IN HUMID AIR IN KG/KG
!T_SI      ABSOLUTE TEMPERATURE IN K
!P_SI      ABSOLUTE PRESSURE IN PA

!CHECK VALUE WITH DEFAULT SETTINGS, V1.0: 
!AIR_G_KAPPA_T_SI(0.9, 300, 1E5) = 1.00324330660E-05

!CHECK VALUE WITH DEFAULT SETTINGS, V1.1: 
!AIR_G_KAPPA_T_SI(0.9, 300, 1E5) = 1.00324517749E-05

!NOTE: THE ACCURACY OF THIS FUNCTION DEPENDS ON THE ITERATION SETTINGS FOR
!      DENSITY COMPUTED IN AIR_3A

real*8 air_g_kappa_t_si, a_si, t_si, p_si
real*8 d

air_g_kappa_t_si = errorreturn

if(a_si < 0d0 .or. a_si > 1d0) return
if(t_si <= 0d0) return
if(p_si <= 0d0) return

d = air_density_si(a_si, t_si, p_si)
if(d == errorreturn) return

air_g_kappa_t_si = air_f_kappa_t_si(a_si, t_si, d)

end function

!=========================================================================
function air_g_lapserate_si(a_si, t_si, p_si)
!=========================================================================

!THIS FUNCTION COMPUTES THE "DRY"-ADIABATIC LAPSE RATE OF HUMID AIR
!FROM THE MASS FRACTION OF AIR, TEMPERATURE AND PRESSURE

!OUTPUT:
!GAMMA = (DT/DP)_A_ETA  "DRY"-ADIABATIC LAPSE RATE OF HUMID AIR IN K/PA

!INPUT:
!A_SI      MASS FRACTION OF DRY AIR IN HUMID AIR IN KG/KG
!T_SI      ABSOLUTE TEMPERATURE IN K
!P_SI      ABSOLUTE PRESSURE IN PA

!CHECK VALUE WITH DEFAULT SETTINGS, V1.0: 
!AIR_G_LAPSERATE_SI(0.9, 300, 1E5) = 7.58539809057E-04

!CHECK VALUE WITH DEFAULT SETTINGS, V1.0: 
!AIR_G_LAPSERATE_SI(0.9, 300, 1E5) = 7.58481752251E-04

!NOTE: THE ACCURACY OF THIS FUNCTION DEPENDS ON THE ITERATION SETTINGS FOR
!      DENSITY COMPUTED IN AIR_3A

real*8 air_g_lapserate_si, a_si, t_si, p_si
real*8 d

air_g_lapserate_si = errorreturn

if(a_si < 0d0 .or. a_si > 1d0) return

if(t_si <= 0d0) return
if(p_si <= 0d0) return

d = air_density_si(a_si, t_si, p_si)
if(d == errorreturn) return

air_g_lapserate_si = air_f_lapserate_si(a_si, t_si, d)

end function

!=========================================================================
function air_g_soundspeed_si(a_si, t_si, p_si)
!=========================================================================

!THIS FUNCTION COMPUTES THE SOUND SPEED IN HUMID AIR
!FROM THE MASS FRACTION OF AIR, TEMPERATURE AND PRESSURE

!OUTPUT:
!C = SQRT[(DP/dD)_A_ETA] SOUND SPEED IN HUMID AIR IN M/S

!INPUT:
!A_SI      MASS FRACTION OF DRY AIR IN HUMID AIR IN KG/KG
!T_SI      ABSOLUTE TEMPERATURE IN K
!P_SI      ABSOLUTE PRESSURE IN PA

!CHECK VALUE WITH DEFAULT SETTINGS, V1.0: 
!AIR_G_SOUNDSPEED_SI(0.9, 300, 1E5) = 350.758752725

!CHECK VALUE WITH DEFAULT SETTINGS, V1.1: 
!AIR_G_SOUNDSPEED_SI(0.9, 300, 1E5) = 350.719656182

!NOTE: THE ACCURACY OF THIS FUNCTION DEPENDS ON THE ITERATION SETTINGS FOR
!      DENSITY COMPUTED IN AIR_3A

real*8 air_g_soundspeed_si, a_si, t_si, p_si
real*8 d

air_g_soundspeed_si = errorreturn

if(a_si < 0d0 .or. a_si > 1d0) return
if(t_si <= 0d0) return
if(p_si <= 0d0) return

d = air_density_si(a_si, t_si, p_si)
if(d == errorreturn) return

air_g_soundspeed_si = air_f_soundspeed_si(a_si, t_si, d)

end function

!==========================================================================
subroutine chk_lemmon_etal_2000(mode)
!==========================================================================

!COMPARISON OF COMPUTED SELECTED VALUES FROM THE PAPER
!LEMMON, E.W., JACOBSEN, R.T., PENONCELLO, S.G., FRIEND, D.G.
!THERMODYNAMIC PROPERTIES OF AIR AND MIXTURES OF NITROGEN, ARGON AND OXYGEN
!FROM 60 TO 2000 K AT PRESSURES TO 2000 MPA.
!J. PHYS. CHEM. REF. DATA 29(2000)331-362.

real*8 ma, d, t, x, p
real*8 temp, dens, pres, inte, enth, entr, cv, cp, cs
integer mode, i
!character*130 row
character*90 fmt
character*9 fmt_d
character*4 fmt_t,fmt_p,fmt_i,fmt_enth,fmt_entr,fmt_cv,fmt_cp,fmt_cs

ma = molar_mass_air_L2000    !MOLAR MASS OF AIR IN KG/MOL USED BY LEMMON ET AL 2000

!TEMPERATURE DENSITY  PRESSURE INT.ENERGY ENTHALPY ENTROPY    CV         CP          SOUNDSPEED
!K           MOL/DM3  MPA      J/MOL      J/MOL    J/(MOL K)  J/(MOL K)  J/(MOL K)   M/S
!
!140         0.087718 0.101325 2873.2     4028.3   176.60     20.81      29.38       236.4
!270         0.045164 0.101325 5578.9     7822.4   195.78     20.76      29.13       329.6
!400         0.030461 0.101325 8294.3     11621.0  207.26     21.04      29.38       400.5
!2000        0.006092 0.101325 48610.0    65242.0  259.62     27.90      36.21       863.5
!140         19.810   10.0     -329.46    175.34   118.30     25.82      72.88       418.1
!270         4.6064   10.0     4911.3     7082.2   155.25     21.61      35.28       349.7
!400         2.9202   10.0     7923.0     11347.0  168.19     21.38      31.50       425.6
!2000        0.59094  10.0     48600.0    65522.0  221.44     27.93      36.25       878.6
!270         47.327   2000.0   4354.8     46614.0  96.232     37.64      45.74       2899.8
!400         45.208   2000.0   8076.2     52316.0  113.52     34.45      42.27       2822.9
!2000        32.893   2000.0   53433.0    114240.0 176.45     31.86      38.21       2472.1

!mode = 1: check the Helmholtz function
!mode = 2: check the Gibbs function
                                            
write(*,*) " "
write(*,*) " "
write(*,*) " "
write(*,*) "****************************************************************"
write(*,*) "****************************************************************"
write(*,*) "****************************************************************"
write(*,*) " "
if (mode == 1) then
  write(*,*) "Implementation of the Dry-Air HELMHOLTZ function in Fortran"
else
  write(*,*) "Implementation of the Dry-Air GIBBS function in Fortran"
end if
write(*,*) "for Publication in Ocean Science, 2009"
write(*,*) "D. Wright, BIO, VERSION ", version
write(*,*) ' '
write(*,*) "Selected function values as given in Lemmon et al., "
write(*,*) "J. Phys. Chem. Ref. Data 29(2000)331-362:"
write(*,*) "Note that these values are determined with the original coefficients"
write(*,*) "Top row gives published values, bottom row computed now"
write(*,*) " "

call dry_init_Lemmon2000  !set original adjustable constants

x = errorreturn

write(*,*) "Temp       Density  Pr    IntEnergy Enthalpy  Entropy    Cv        Cp    SndSpd"
write(*,*) "K          mol/dm3  MPa     J/mol    J/mol   J/(mol K) J/(mol K) J/(mol K) m/s"

Do i = 1, 11
  write(*,*) ' '
  select case (i)
    case (1)
      write(*,*) "   140   0.087718 0.101325   2873.2   4028.3   176.60    20.81    29.38    236.4"
      t =  140d0
      d = 0.087718d0
      p = 0.101325d0
      if (mode == 1) then
        temp = t
        dens = d
           x = 0.000001d0 * air_f_pressure_si(1d0, t, d * ma * 1000d0)
        pres = x
           x = ma * air_f_internal_energy_si(1d0, t, d * ma * 1000d0)
        inte = x
           x = ma * air_f_enthalpy_si(1d0, t, d * ma * 1000d0)
        enth = x
           x = ma * air_f_entropy_si(1d0, t, d * ma * 1000d0)
        entr = x
        cv = ma * air_f_cv_si(1d0, t, d * ma * 1000d0)
        cp = ma * air_f_cp_si(1d0, t, d * ma * 1000d0)
        cs = air_f_soundspeed_si(1d0, t, d * ma * 1000d0)
      else
        temp = t
           x = 0.001 * air_g_density_si(1d0, t, p * 1000000d0) / ma
        dens = x
        pres = p
           x = ma * air_g_internal_energy_si(1d0, t, p * 1000000d0)
        inte = x
           x = ma * air_g_enthalpy_si(1d0, t, p * 1000000d0)
        enth = x
           x = ma * air_g_entropy_si(1d0, t, p * 1000000d0)
        entr = x
        cv = ma * air_g_cv_si(1d0, t, p * 1000000d0)
        cp = ma * air_g_cp_si(1d0, t, p * 1000000d0)
        cs = air_g_soundspeed_si(1d0, t, p * 1000000d0)
      endif
    case (2)
      write(*,*) "   270   0.045164 0.101325   5578.9   7822.4   195.78    20.76    29.13    329.6"
      t = 270d0
      d = 0.045164d0
      p = 0.101325d0
      if (mode == 1) then
        temp = t
        dens = d
           x = 0.000001d0 * air_f_pressure_si(1d0, t, d * ma * 1000d0)
        pres = x
           x = ma * air_f_internal_energy_si(1d0, t, d * ma * 1000d0)
        inte = x
           x = ma * air_f_enthalpy_si(1d0, t, d * ma * 1000d0)
        enth = x
           x = ma * air_f_entropy_si(1d0, t, d * ma * 1000d0)
        entr = x
        cv = ma * air_f_cv_si(1d0, t, d * ma * 1000d0)
        cp = ma * air_f_cp_si(1d0, t, d * ma * 1000d0)
        cs = air_f_soundspeed_si(1d0, t, d * ma * 1000d0)
      else
        temp = t
           x = 0.001d0 * air_g_density_si(1d0, t, p * 1000000d0) / ma
        dens = x
        pres = p
           x = ma * air_g_internal_energy_si(1d0, t, p * 1000000d0)
        inte = x
           x = ma * air_g_enthalpy_si(1d0, t, p * 1000000d0)
        enth = x
           x = ma * air_g_entropy_si(1d0, t, p * 1000000d0)
        entr = x
        cv = ma * air_g_cv_si(1d0, t, p * 1000000d0)
        cp = ma * air_g_cp_si(1d0, t, p * 1000000d0)
        cs = air_g_soundspeed_si(1d0, t, p * 1000000d0)
      endif
    case (3)
      write(*,*) "   400   0.030461 0.101325   8294.3  11621.0   207.26    21.04    29.38    400.5"
      t = 400d0
      d = 0.030461d0
      p = 0.101325d0
      if (mode == 1) then
        temp = t
        dens = d
           x = 0.000001d0 * air_f_pressure_si(1d0, t, d * ma * 1000d0)
        pres = x
           x = ma * air_f_internal_energy_si(1d0, t, d * ma * 1000d0)
        inte = x
           x = ma * air_f_enthalpy_si(1d0, t, d * ma * 1000d0)
        enth = x
           x = ma * air_f_entropy_si(1d0, t, d * ma * 1000d0)
        entr = x
        cv = ma * air_f_cv_si(1d0, t, d * ma * 1000d0)
        cp = ma * air_f_cp_si(1d0, t, d * ma * 1000d0)
        cs = air_f_soundspeed_si(1d0, t, d * ma * 1000d0)
      else
        temp = t
           x = 0.001d0 * air_g_density_si(1d0, t, p * 1000000d0) / ma
        dens = x
        pres = p
           x = ma * air_g_internal_energy_si(1d0, t, p * 1000000d0)
        inte = x
           x = ma * air_g_enthalpy_si(1d0, t, p * 1000000d0)
        enth = x
           x = ma * air_g_entropy_si(1d0, t, p * 1000000d0)
        entr = x
        cv = ma * air_g_cv_si(1d0, t, p * 1000000d0)
        cp = ma * air_g_cp_si(1d0, t, p * 1000000d0)
        cs = air_g_soundspeed_si(1d0, t, p * 1000000d0)
      endif
    case (4)
      write(*,*) "  2000   0.006092 0.101325  48610.0  65242.0   259.62    27.90    36.21    863.5"
      t = 2000d0
      d = 0.006092d0
      p = 0.101325d0
      if (mode == 1) then
        temp = t
        dens = d
           x = 0.000001d0 * air_f_pressure_si(1d0, t, d * ma * 1000d0)
        pres = x
           x = ma * air_f_internal_energy_si(1d0, t, d * ma * 1000d0)
        inte = x
           x = ma * air_f_enthalpy_si(1d0, t, d * ma * 1000d0)
        enth = x
           x = ma * air_f_entropy_si(1d0, t, d * ma * 1000d0)
        entr = x
        cv = ma * air_f_cv_si(1d0, t, d * ma * 1000d0)
        cp = ma * air_f_cp_si(1d0, t, d * ma * 1000d0)
        cs = air_f_soundspeed_si(1d0, t, d * ma * 1000d0)
      else
        temp = t
           x = 0.001d0 * air_g_density_si(1d0, t, p * 1000000d0) / ma
        dens = x
        pres = p
           x = ma * air_g_internal_energy_si(1d0, t, p * 1000000d0)
        inte = x
           x = ma * air_g_enthalpy_si(1d0, t, p * 1000000d0)
        enth = x
           x = ma * air_g_entropy_si(1d0, t, p * 1000000d0)
        entr = x
        cv = ma * air_g_cv_si(1d0, t, p * 1000000d0)
        cp = ma * air_g_cp_si(1d0, t, p * 1000000d0)
        cs = air_g_soundspeed_si(1d0, t, p * 1000000d0)
      endif
    case (5)
      write(*,*) "   140     19.810     10.0  -329.46   175.34   118.30    25.82    72.88    418.1"
      t = 140d0
      d = 19.810d0
      p = 10.0d0
      if (mode == 1) then
        temp = t
        dens = d
           x = 0.000001d0 * air_f_pressure_si(1d0, t, d * ma * 1000d0)
        pres = x
           x = ma * air_f_internal_energy_si(1d0, t, d * ma * 1000d0)
        inte = x
           x = ma * air_f_enthalpy_si(1d0, t, d * ma * 1000d0)
        enth = x
           x = ma * air_f_entropy_si(1d0, t, d * ma * 1000d0)
        entr = x
        cv = ma * air_f_cv_si(1d0, t, d * ma * 1000d0)
        cp = ma * air_f_cp_si(1d0, t, d * ma * 1000d0)
        cs = air_f_soundspeed_si(1d0, t, d * ma * 1000d0)
      else
        temp = t
           x = 0.001d0 * air_g_density_si(1d0, t, p * 1000000d0) / ma
        dens = x
        pres = p
           x = ma * air_g_internal_energy_si(1d0, t, p * 1000000d0)
        inte = x
           x = ma * air_g_enthalpy_si(1d0, t, p * 1000000d0)
        enth = x
           x = ma * air_g_entropy_si(1d0, t, p * 1000000d0)
        entr = x
        cv = ma * air_g_cv_si(1d0, t, p * 1000000d0)
        cp = ma * air_g_cp_si(1d0, t, p * 1000000d0)
        cs = air_g_soundspeed_si(1d0, t, p * 1000000d0)
      endif
    case (6)
      write(*,*) "   270     4.6064     10.0   4911.3   7082.2   155.25    21.61    35.28    349.7"
      t = 270d0
      d = 4.6064d0
      p = 10.0d0
      if (mode == 1) then
        temp = t
        dens = d
           x = 0.000001d0 * air_f_pressure_si(1d0, t, d * ma * 1000d0)
        pres = x
           x = ma * air_f_internal_energy_si(1d0, t, d * ma * 1000d0)
        inte = x
           x = ma * air_f_enthalpy_si(1d0, t, d * ma * 1000d0)
        enth = x
           x = ma * air_f_entropy_si(1d0, t, d * ma * 1000d0)
        entr = x
        cv = ma * air_f_cv_si(1d0, t, d * ma * 1000d0)
        cp = ma * air_f_cp_si(1d0, t, d * ma * 1000d0)
        cs = air_f_soundspeed_si(1d0, t, d * ma * 1000d0)
      else
        temp = t
           x = 0.001d0 * air_g_density_si(1d0, t, p * 1000000d0) / ma
        dens = x
        pres = p
           x = ma * air_g_internal_energy_si(1d0, t, p * 1000000d0)
        inte = x
           x = ma * air_g_enthalpy_si(1d0, t, p * 1000000d0)
        enth = x
           x = ma * air_g_entropy_si(1d0, t, p * 1000000d0)
        entr = x
        cv = ma * air_g_cv_si(1d0, t, p * 1000000d0)
        cp = ma * air_g_cp_si(1d0, t, p * 1000000d0)
        cs = air_g_soundspeed_si(1d0, t, p * 1000000d0)
      endif
    case (7)
      write(*,*) "   400     2.9202     10.0   7923.0  11347.0   168.19    21.38    31.50    425.6"
      t = 400d0
      d = 2.9202d0
      p = 10.0d0
      if (mode == 1) then
        temp = t
        dens = d
           x = 0.000001d0 * air_f_pressure_si(1d0, t, d * ma * 1000d0)
        pres = x
           x = ma * air_f_internal_energy_si(1d0, t, d * ma * 1000d0)
        inte = x
           x = ma * air_f_enthalpy_si(1d0, t, d * ma * 1000d0)
        enth = x
           x = ma * air_f_entropy_si(1d0, t, d * ma * 1000d0)
        entr = x
        cv = ma * air_f_cv_si(1d0, t, d * ma * 1000d0)
        cp = ma * air_f_cp_si(1d0, t, d * ma * 1000d0)
        cs = air_f_soundspeed_si(1d0, t, d * ma * 1000d0)
      else
        temp = t
           x = 0.001d0 * air_g_density_si(1d0, t, p * 1000000d0) / ma
        dens = x
        pres = p
           x = ma * air_g_internal_energy_si(1d0, t, p * 1000000d0)
        inte = x
           x = ma * air_g_enthalpy_si(1d0, t, p * 1000000d0)
        enth = x
           x = ma * air_g_entropy_si(1d0, t, p * 1000000d0)
        entr = x
        cv = ma * air_g_cv_si(1d0, t, p * 1000000d0)
        cp = ma * air_g_cp_si(1d0, t, p * 1000000d0)
        cs = air_g_soundspeed_si(1d0, t, p * 1000000d0)
      endif
    case (8)
      write(*,*) "  2000    0.59094     10.0  48600.0  65522.0   221.44    27.93    36.25    878.6"
      t = 2000d0
      d = 0.59094d0
      p = 10.0d0
      if (mode == 1) then
        temp = t
        dens = d
           x = 0.000001d0 * air_f_pressure_si(1d0, t, d * ma * 1000d0)
        pres = x
           x = ma * air_f_internal_energy_si(1d0, t, d * ma * 1000d0)
        inte = x
           x = ma * air_f_enthalpy_si(1d0, t, d * ma * 1000d0)
        enth = x
           x = ma * air_f_entropy_si(1d0, t, d * ma * 1000d0)
        entr = x
        cv = ma * air_f_cv_si(1d0, t, d * ma * 1000d0)
        cp = ma * air_f_cp_si(1d0, t, d * ma * 1000d0)
        cs = air_f_soundspeed_si(1d0, t, d * ma * 1000d0)
      else
        temp = t
           x = 0.001d0 * air_g_density_si(1d0, t, p * 1000000d0) / ma
        dens = x
        pres = p
           x = ma * air_g_internal_energy_si(1d0, t, p * 1000000d0)
        inte = x
           x = ma * air_g_enthalpy_si(1d0, t, p * 1000000d0)
        enth = x
           x = ma * air_g_entropy_si(1d0, t, p * 1000000d0)
        entr = x
        cv = ma * air_g_cv_si(1d0, t, p * 1000000d0)
        cp = ma * air_g_cp_si(1d0, t, p * 1000000d0)
        cs = air_g_soundspeed_si(1d0, t, p * 1000000d0)
      endif
    case (9)
      write(*,*) "   270     47.327   2000.0   4354.8  46614.0   96.232    37.64    45.74   2899.8"
      t = 270d0
      d = 47.327d0
      p = 2000.0d0
      if (mode == 1) then
        temp = t
        dens = d
           x = 0.000001d0 * air_f_pressure_si(1d0, t, d * ma * 1000d0)
        pres = x
           x = ma * air_f_internal_energy_si(1d0, t, d * ma * 1000d0)
        inte = x
           x = ma * air_f_enthalpy_si(1d0, t, d * ma * 1000d0)
        enth = x
           x = ma * air_f_entropy_si(1d0, t, d * ma * 1000d0)
        entr = x
        cv = ma * air_f_cv_si(1d0, t, d * ma * 1000d0)
        cp = ma * air_f_cp_si(1d0, t, d * ma * 1000d0)
        cs = air_f_soundspeed_si(1d0, t, d * ma * 1000d0)
      else
        temp = t
           x = 0.001d0 * air_g_density_si(1d0, t, p * 1000000d0) / ma
        dens = x
        pres = p
           x = ma * air_g_internal_energy_si(1d0, t, p * 1000000d0)
        inte = x
           x = ma * air_g_enthalpy_si(1d0, t, p * 1000000d0)
        enth = x
           x = ma * air_g_entropy_si(1d0, t, p * 1000000d0)
        entr = x
        cv = ma * air_g_cv_si(1d0, t, p * 1000000d0)
        cp = ma * air_g_cp_si(1d0, t, p * 1000000d0)
        cs = air_g_soundspeed_si(1d0, t, p * 1000000d0)
      endif
    case (10)
      write(*,*) "   400     45.208   2000.0   8076.2  52316.0   113.52    34.45    42.27   2822.9"
      t = 400d0
      d = 45.208d0
      p = 2000.0d0
      if (mode == 1) then
        temp = t
        dens = d
           x = 0.000001d0 * air_f_pressure_si(1d0, t, d * ma * 1000d0)
        pres = x
           x = ma * air_f_internal_energy_si(1d0, t, d * ma * 1000d0)
        inte = x
           x = ma * air_f_enthalpy_si(1d0, t, d * ma * 1000d0)
        enth = x
           x = ma * air_f_entropy_si(1d0, t, d * ma * 1000d0)
        entr = x
        cv = ma * air_f_cv_si(1d0, t, d * ma * 1000d0)
        cp = ma * air_f_cp_si(1d0, t, d * ma * 1000d0)
        cs = air_f_soundspeed_si(1d0, t, d * ma * 1000d0)
      else
        temp = t
           x = 0.001 * air_g_density_si(1d0, t, p * 1000000d0) / ma
        dens = x
        pres = p
           x = ma * air_g_internal_energy_si(1d0, t, p * 1000000d0)
        inte = x
           x = ma * air_g_enthalpy_si(1d0, t, p * 1000000d0)
        enth = x
           x = ma * air_g_entropy_si(1d0, t, p * 1000000d0)
        entr = x
        cv = ma * air_g_cv_si(1d0, t, p * 1000000d0)
        cp = ma * air_g_cp_si(1d0, t, p * 1000000d0)
        cs = air_g_soundspeed_si(1d0, t, p * 1000000d0)
      endif
    case (11)
      write(*,*) "  2000     32.893   2000.0  53433.0 114240.0   176.45    31.86    38.21   2472.1"
      t = 2000d0
      d = 32.893d0
      p = 2000.0D0
      if (mode == 1) then
        temp = t
        dens = d
           x = 0.000001d0 * air_f_pressure_si(1d0, t, d * ma * 1000d0)
        pres = x
           x = ma * air_f_internal_energy_si(1d0, t, d * ma * 1000d0)
        inte = x
           x = ma * air_f_enthalpy_si(1d0, t, d * ma * 1000d0)
        enth = x
           x = ma * air_f_entropy_si(1d0, t, d * ma * 1000d0)
        entr = x
        cv = ma * air_f_cv_si(1d0, t, d * ma * 1000)
        cp = ma * air_f_cp_si(1d0, t, d * ma * 1000)
        cs = air_f_soundspeed_si(1d0, t, d * ma * 1000)
      else
        temp = t
           x = 0.001d0 * air_g_density_si(1d0, t, p * 1000000d0) / ma
        dens = x
        pres = p
           x = ma * air_g_internal_energy_si(1d0, t, p * 1000000d0)
        inte = x
           x = ma * air_g_enthalpy_si(1d0, t, p * 1000000d0)
        enth = x
           x = ma * air_g_entropy_si(1d0, t, p * 1000000d0)
        entr = x
        cv = ma * air_g_cv_si(1d0, t, p * 1000000d0)
        cp = ma * air_g_cp_si(1d0, t, p * 1000000d0)
        cs = air_g_soundspeed_si(1d0, t, p * 1000000d0)
      endif
  end select

fmt_t = "F8.0"
fmt_d = "F9.6"
if (pres < 1d0) then
   fmt_p = "F8.6"
else 
   fmt_p = "F8.1"
endif
if (dens < 0.1d0) then
  fmt_d = "F9.6"
elseif (dens < 1d0) then
  fmt_d = "1X,F8.5"
elseif (dens < 10d0) then
  fmt_d = "2X,F7.4"
else
  fmt_d = "3X,F6.3"
end if
if (abs(inte) < 1000d0) then
   fmt_i = "F8.2"
else
   fmt_i = "F8.1"
endif
if (abs(enth) < 1000d0) then 
   fmt_enth = "F8.2"
else 
   fmt_enth = "F8.1"
endif
if (x < 100d0) then 
   fmt_entr = "F8.3"
else 
   fmt_entr = "F8.2"
endif
fmt_cv = "F8.2"
fmt_cp = "F8.2"
fmt_cs = "F8.1"
fmt = "("//fmt_t//",1X,"//fmt_d//",1X,"//fmt_p//",1X,"//fmt_i//",1X,"//fmt_enth//",1X,"// &
fmt_entr//",1X,"//fmt_cv//",1X,"//fmt_cp//",1X,"//fmt_cs//")"
!write(*,*)fmt
write(*,fmt)temp, dens, pres, inte, enth, entr, cv, cp, cs
    
enddo

call dry_init_clear  !restore sea-air adjustable coefficients

write(*,*) ' '
write(*,*) "Note that for this comparison, the originally published adjustable coefficients"
write(*,*) "in Lemmon et al. (2000) were used"
write(*,*) " "
write(*,*) "Note: The molar mass of air used in SIA Version 1.1 results in minor offsets"
write(*,*) "Note: For this comparison, check_limits =", check_limits
write(*,*) ' '
write(*,*) ' '

return

!V1.1
!=================================
!PRINT CHK_LEMMON_ETAL_2000(0):

!CHECK FOR PUBLICATION IN OCEAN SCIENCE, 2009
!R. FEISTEL, IOW, VERSION 12 APR 2009
!COMPILED ON 13.04.2009 09:45:57
!
!SELECTED FUNCTION VALUES AS GIVEN IN LEMMON ET AL.,
!J. PHYS. CHEM. REF. DATA 29(2000)331-362:
!
!              TEMPERATURE   DENSITY   PRESSURE  INT.ENERGY  ENTHALPY  ENTROPY     CV          CP            SOUNDSPEED
!              K             MOL/DM3   MPA       J/MOL       J/MOL     J/(MOL K)   J/(MOL K)   J/(MOL K)     M/S
!TABLE VALUE:  140           0.087718  0.101325  2873.2      4028.3    176.60      20.81       29.38         236.4
!COMPUTED:     140           0.087718  0.101324  2873.2      4028.3    176.6       20.8        29.38         236.4
!TABLE VALUE:  270           0.045164  0.101325  5578.9      7822.4    195.78      20.76       29.13         329.6
!COMPUTED:     270           0.045164  0.101324  5578.9      7822.4    195.78      20.76       29.13         329.5
!TABLE VALUE:  400           0.030461  0.101325  8294.3      11621.0   207.26      21.04       29.38         400.5
!COMPUTED:     400           0.030461  0.101326  8294.3      11620.8   207.26      21.04       29.38         400.4
!TABLE VALUE:  2000          0.006092  0.101325  48610.0     65242.0   259.62      27.90       36.21         863.5
!COMPUTED:     2000          0.006092  0.101322  48610.4     65242.4   259.62      27.9        36.21         863.4
!TABLE VALUE:  140           19.810    10.0      -329.46     175.34    118.30      25.82       72.88         418.1
!COMPUTED:     140           19.81     10        -329.5      175.32    118.3       25.82       72.88         418.1
!TABLE VALUE:  270           4.6064    10.0      4911.3      7082.2    155.25      21.61       35.28         349.7
!COMPUTED:     270           4.6064    10        4911.3      7082.2    155.25      21.61       35.28         349.7
!TABLE VALUE:  400           2.9202    10.0      7923.0      11347.0   168.19      21.38       31.50         425.6
!COMPUTED:     400           2.9202    10        7923        11347.4   168.19      21.38       31.5          425.5
!TABLE VALUE:  2000          0.59094   10.0      48600.0     65522.0   221.44      27.93       36.25         878.6
!COMPUTED:     2000          0.59094   10        48599.8     65522     221.44      27.93       36.25         878.5
!TABLE VALUE:  270           47.327    2000.0    4354.8      46614.0   96.232      37.64       45.74         2899.8
!COMPUTED:     270           47.327    2000      4354.9      46615     96.232      37.64       45.74         2899.5
!TABLE VALUE:  400           45.208    2000.0    8076.2      52316.0   113.52      34.45       42.27         2822.9
!COMPUTED:     400           45.208    2000      8076.1      52315.6   113.52      34.45       42.27         2822.5
!TABLE VALUE:  2000          32.893    2000.0    53433.0     114240.0  176.45      31.86       38.21         2472.1
!COMPUTED:     2000          32.893    2000      53432.6     114236.2  176.45      31.86       38.21         2471.8
!
!NOTE: FOR THIS COMPARISON, THE ORIGINALLY PUBLISHED ADJUSTABLE COEFFICIENTS WERE USED

!NOTE: THE MOLAR MASS OF AIR USED IN sia vERSION 1.1 RESULTS IN MINOR OFFSETS

!NOTE: fOR THIS COMPARISON, CHECK_LIMITS = 0 WAS INITILIALIZED 


!V1.1
!=================================
!PRINT CHK_LEMMON_ETAL_2000(1):

!CHECK FOR PUBLICATION IN OCEAN SCIENCE, 2009
!R. FEISTEL, IOW, VERSION 12 APR 2009
!COMPILED ON 13.04.2009 09:46:04
!
!SELECTED FUNCTION VALUES AS GIVEN IN LEMMON ET AL.,
!J. PHYS. CHEM. REF. DATA 29(2000)331-362:
!
!              TEMPERATURE   DENSITY   PRESSURE  INT.ENERGY  ENTHALPY  ENTROPY     CV          CP            SOUNDSPEED
!              K             MOL/DM3   MPA       J/MOL       J/MOL     J/(MOL K)   J/(MOL K)   J/(MOL K)     M/S
!TABLE VALUE:  140           0.087718  0.101325  2873.2      4028.3    176.60      20.81       29.38         236.4
!COMPUTED:     140           0.087718  0.101325  2873.2      4028.3    176.6       20.81       29.38         236.4
!TABLE VALUE:  270           0.045164  0.101325  5578.9      7822.4    195.78      20.76       29.13         329.6
!COMPUTED:     270           0.045164  0.101325  5578.9      7822.4    195.78      20.76       29.13         329.5
!TABLE VALUE:  400           0.030461  0.101325  8294.3      11621.0   207.26      21.04       29.38         400.5
!COMPUTED:     400           0.030461  0.101325  8294.3      11620.8   207.26      21.04       29.38         400.4
!TABLE VALUE:  2000          0.006092  0.101325  48610.0     65242.0   259.62      27.90       36.21         863.5
!COMPUTED:     2000          0.006092  0.101325  48610.4     65242.4   259.62      27.9        36.21         863.4
!TABLE VALUE:  140           19.810    10.0      -329.46     175.34    118.30      25.82       72.88         418.1
!COMPUTED:     140           19.81     10        -329.46     175.34    118.3       25.82       72.88         418.1
!TABLE VALUE:  270           4.6064    10.0      4911.3      7082.2    155.25      21.61       35.28         349.7
!COMPUTED:     270           4.6064    10        4911.3      7082.2    155.25      21.61       35.28         349.7
!TABLE VALUE:  400           2.9202    10.0      7923.0      11347.0   168.19      21.38       31.50         425.6
!COMPUTED:     400           2.9202    10        7923        11347.4   168.19      21.38       31.5          425.5
!TABLE VALUE:  2000          0.59094   10.0      48600.0     65522.0   221.44      27.93       36.25         878.6
!COMPUTED:     2000          0.59094   10        48599.8     65522     221.44      27.93       36.25         878.5
!TABLE VALUE:  270           47.327    2000.0    4354.8      46614.0   96.232      37.64       45.74         2899.8
!COMPUTED:     270           47.327    2000      4354.8      46614.2   96.232      37.64       45.74         2899.5
!TABLE VALUE:  400           45.208    2000.0    8076.2      52316.0   113.52      34.45       42.27         2822.9
!COMPUTED:     400           45.208    2000      8076.2      52316     113.52      34.45       42.27         2822.5
!TABLE VALUE:  2000          32.893    2000.0    53433.0     114240.0  176.45      31.86       38.21         2472.1
!COMPUTED:     2000          32.893    2000      53432.6     114235.9  176.45      31.86       38.21         2471.8
!
!NOTE: FOR THIS COMPARISON, THE ORIGINALLY PUBLISHED ADJUSTABLE COEFFICIENTS WERE USED

!NOTE: THE MOLAR MASS OF AIR USED IN SIA VERSION 1.1 RESULTS IN MINOR OFFSETS

!NOTE: FOR THIS COMPARISON, CHECK_LIMITS = 0 WAS INITILIALIZED 


!V1.0
!=================================
!PRINT CHK_LEMMON_ETAL_2000(0):

!CHECK FOR PUBLICATION IN OCEAN SCIENCE, 2009
!R. FEISTEL, IOW, VERSION 12 APR 2009
!COMPILED ON 13.04.2009 09:45:57
!
!SELECTED FUNCTION VALUES AS GIVEN IN LEMMON ET AL.,
!J. PHYS. CHEM. REF. DATA 29(2000)331-362:
!
!              TEMPERATURE   DENSITY   PRESSURE  INT.ENERGY  ENTHALPY  ENTROPY     CV          CP            SOUNDSPEED
!              K             MOL/DM3   MPA       J/MOL       J/MOL     J/(MOL K)   J/(MOL K)   J/(MOL K)     M/S
!TABLE VALUE:  140           0.087718  0.101325  2873.2      4028.3    176.60      20.81       29.38         236.4
!COMPUTED:     140           0.087718  0.101324  2873.2      4028.3    176.6       20.81       29.38         236.4
!TABLE VALUE:  270           0.045164  0.101325  5578.9      7822.4    195.78      20.76       29.13         329.6
!COMPUTED:     270           0.045164  0.101324  5578.9      7822.4    195.78      20.76       29.13         329.5
!TABLE VALUE:  400           0.030461  0.101325  8294.3      11621.0   207.26      21.04       29.38         400.5
!COMPUTED:     400           0.030461  0.101326  8294.3      11620.8   207.26      21.04       29.38         400.4
!TABLE VALUE:  2000          0.006092  0.101325  48610.0     65242.0   259.62      27.90       36.21         863.5
!COMPUTED:     2000          0.006092  0.101322  48610.4     65242.4   259.62      27.9        36.21         863.4
!TABLE VALUE:  140           19.810    10.0      -329.46     175.34    118.30      25.82       72.88         418.1
!COMPUTED:     140           19.81     10        -329.5      175.32    118.3       25.82       72.88         418.1
!TABLE VALUE:  270           4.6064    10.0      4911.3      7082.2    155.25      21.61       35.28         349.7
!COMPUTED:     270           4.6064    10        4911.3      7082.2    155.25      21.61       35.28         349.6
!TABLE VALUE:  400           2.9202    10.0      7923.0      11347.0   168.19      21.38       31.50         425.6
!COMPUTED:     400           2.9202    10        7923        11347.4   168.19      21.38       31.5          425.5
!TABLE VALUE:  2000          0.59094   10.0      48600.0     65522.0   221.44      27.93       36.25         878.6
!COMPUTED:     2000          0.59094   10        48599.8     65522     221.44      27.93       36.25         878.5
!TABLE VALUE:  270           47.327    2000.0    4354.8      46614.0   96.232      37.64       45.74         2899.8
!COMPUTED:     270           47.327    2000      4354.9      46615     96.232      37.64       45.74         2899.5
!TABLE VALUE:  400           45.208    2000.0    8076.2      52316.0   113.52      34.45       42.27         2822.9
!COMPUTED:     400           45.208    2000      8076.1      52315.6   113.52      34.45       42.27         2822.5
!TABLE VALUE:  2000          32.893    2000.0    53433.0     114240.0  176.45      31.86       38.21         2472.1
!COMPUTED:     2000          32.893    2000      53432.6     114236.2  176.45      31.86       38.21         2471.8
!
!NOTE: FOR THIS COMPARISON, THE ORIGINALLY PUBLISHED ADJUSTABLE COEFFICIENTS WERE USED

!NOTE: FOR THIS COMPARISON, CHECK_LIMITS_VALUE = 0 WAS INITILIALIZED

!V1.0
!=================================
!PRINT CHK_LEMMON_ETAL_2000(1):

!CHECK FOR PUBLICATION IN OCEAN SCIENCE, 2009
!R. FEISTEL, IOW, VERSION 12 APR 2009
!COMPILED ON 13.04.2009 09:46:04
!
!SELECTED FUNCTION VALUES AS GIVEN IN LEMMON ET AL.,
!J. PHYS. CHEM. REF. DATA 29(2000)331-362:
!
!              TEMPERATURE   DENSITY   PRESSURE  INT.ENERGY  ENTHALPY  ENTROPY     CV          CP            SOUNDSPEED
!              K             MOL/DM3   MPA       J/MOL       J/MOL     J/(MOL K)   J/(MOL K)   J/(MOL K)     M/S
!TABLE VALUE:  140           0.087718  0.101325  2873.2      4028.3    176.60      20.81       29.38         236.4
!COMPUTED:     140           0.087718  0.101325  2873.2      4028.3    176.6       20.8        29.38         236.4
!TABLE VALUE:  270           0.045164  0.101325  5578.9      7822.4    195.78      20.76       29.13         329.6
!COMPUTED:     270           0.045164  0.101325  5578.9      7822.4    195.78      20.76       29.13         329.5
!TABLE VALUE:  400           0.030461  0.101325  8294.3      11621.0   207.26      21.04       29.38         400.5
!COMPUTED:     400           0.030461  0.101325  8294.3      11620.8   207.26      21.04       29.38         400.4
!TABLE VALUE:  2000          0.006092  0.101325  48610.0     65242.0   259.62      27.90       36.21         863.5
!COMPUTED:     2000          0.006092  0.101325  48610.4     65242.4   259.62      27.9        36.21         863.4
!TABLE VALUE:  140           19.810    10.0      -329.46     175.34    118.30      25.82       72.88         418.1
!COMPUTED:     140           19.81     10        -329.46     175.34    118.3       25.82       72.88         418.1
!TABLE VALUE:  270           4.6064    10.0      4911.3      7082.2    155.25      21.61       35.28         349.7
!COMPUTED:     270           4.6064    10        4911.3      7082.2    155.25      21.61       35.28         349.7
!TABLE VALUE:  400           2.9202    10.0      7923.0      11347.0   168.19      21.38       31.50         425.6
!COMPUTED:     400           2.9202    10        7923        11347.4   168.19      21.38       31.5          425.5
!TABLE VALUE:  2000          0.59094   10.0      48600.0     65522.0   221.44      27.93       36.25         878.6
!COMPUTED:     2000          0.59094   10        48599.8     65522     221.44      27.93       36.25         878.5
!TABLE VALUE:  270           47.327    2000.0    4354.8      46614.0   96.232      37.64       45.74         2899.8
!COMPUTED:     270           47.327    2000      4354.8      46614.2   96.232      37.64       45.74         2899.5
!TABLE VALUE:  400           45.208    2000.0    8076.2      52316.0   113.52      34.45       42.27         2822.9
!COMPUTED:     400           45.208    2000      8076.2      52316     113.52      34.45       42.27         2822.5
!TABLE VALUE:  2000          32.893    2000.0    53433.0     114240.0  176.45      31.86       38.21         2472.1
!COMPUTED:     2000          32.893    2000      53432.6     114235.9  176.45      31.86       38.21         2471.8
!
!NOTE: fOR THIS COMPARISON, THE ORIGINALLY PUBLISHED ADJUSTABLE COEFFICIENTS WERE USED

!NOTE: FOR THIS COMPARISON, CHECK_LIMITS_VALUE = 0 WAS INITILIALIZED

end subroutine

end module air_3b

module constants_0

!#########################################################################

!THIS MODULE INITIALIZES CONSTANTS AND PARAMETER VALUES USED IN THE LIBRARY
!IT IS SELF-CONTAINED AND DOES NOT REQUIRE OTHER LIBRARY MODULES

!THE VALUES OF THESE CONSTANTS ARE CONSISTENT WITH THE FUNCTIONS AND
!CONSTANTS USED IN THIS SOURCE CODE LIBRARY, RATHER THAN BEING INDEPENDENT 
!ENTITIES.  FUTURE UPDATES ARE ONLY POSSIBLE IF THIS CONSISTENCY IS 
!CAREFULLY MAINTAINED

!#########################################################################

implicit none

character*16, private :: version = '8 Jun 2010'

!TO EXTEND THE GIbbS FUNCTION AS DESCRIBED IN:

!R. FEISTEL
!EXTENDED EQUATION OF STATE FOR SEAWATER AT ELEVATED TEMPERATURE AND SALINITY
!DESALINATION, 250, 14-18, 2010.

!TO COVER THE MEASUREMENTS OF

!F. MILLERO AND F. HUANG
!OCEAN SCI. DISCUSS. 6 (2009) 153-169.
!HTTP://WWW.OCEAN-SCI-DISCUSS.NET/6/153/2009/

!SET THIS CONSTANT TO TRUE:
!logical, public :: IsExtension2010 = .true.
!NOTE THAT THIS OPTIONAL GIBBS FUNCTION IS NOT ENDORSED BY IAPWS

logical, public :: IsExtension2010 = .false.

!IMPOSE NECESSARY PARAMETER LIMITS
!TO INCLUDE RANGE CHECKS, INITIALIZE CHECK_LIMITS TO 1. IT IS USED INTERNALLY
!TO TURN ALL LIMIT CHECKING OFF WITHIN THE ITERATIVE SOLUTION ROUTINES.

!INITIALIZE CHECK_LIMITS TO 0 TO USE VERY LOOSE RANGE CHECKING.
!INITIALIZE CHECK_LIMITS TO 1 TO IMPOSE MORE RESTRICTIVE RANGE CHECKING. 
!IN THE LATTER CASE, CHECK_LIMITS IS USED INTERNALLY TO TURN ALL
!LIMIT CHECKING OFF WITHIN THE ITERATIVE SOLUTION ROUTINES.

integer, public :: check_limits = 1

real*8, public, parameter :: dry_air_tmin = 60d0
real*8, public, parameter :: dry_air_tmax = 873d0
real*8, public, parameter :: dry_air_dmin = 0d0
real*8, public, parameter :: dry_air_dmax = 1035d0

real*8, public, parameter :: mix_air_tmin = 193d0     !or perhaps 173d0
real*8, public, parameter :: mix_air_tmax = 473d0
real*8, public, parameter :: mix_air_dmin = 0d0
real*8, public, parameter :: mix_air_dmax = 100d0

real*8, public, parameter :: flu_tmin = 50d0          !130d0
real*8, public, parameter :: flu_tmax = 1273d0
real*8, public, parameter :: flu_dmin = 0d0
real*8, public, parameter :: flu_dmax = 1240d0        !1200

real*8, public, parameter :: ice_tmin = 0d0
real*8, public, parameter :: ice_tmax = 273.16d0
real*8, public, parameter :: ice_pmin = 0d0
real*8, public, parameter :: ice_pmax = 2d8

real*8, public, parameter :: sal_tmin = 262d0
real*8, public, parameter :: sal_tmax = 353d0
real*8, public, parameter :: sal_pmin = 100d0
real*8, public, parameter :: sal_pmax = 1d8
real*8, public, parameter :: sal_smin = 0d0
real*8, public, parameter :: sal_smax = 0.12d0

!PROCEDURE RETURN CODES
real*8, public, parameter :: errorreturn = 9.99999999d+98
integer, public, parameter :: isok = -1

!MATHEMATICAL CONSTANTS
real*8, public, parameter :: pi = 3.14159265358979d0

!FUNDAMENTAL PHYSICAL CONSTANTS
real*8, public, parameter :: gas_constant_molar_si = 8.314472d0      !MOLAR GAS CONSTANT J MOL-1 K-1,IAPWS 2005
real*8, public, parameter :: gas_constant_molar_L2000 = 8.31451d0    !MOLAR GAS CONSTANT J MOL-1 K-1, LEMMON ET AL. 2000

real*8, public, parameter :: molar_mass_h2o_si = 0.018015268d0       !MOLAR MASS OF H2O IN KG/MOL, IAPWS 2009
real*8, public, parameter :: molar_mass_seasalt_si = 0.0314038218d0  !MOLAR MASS OF SEA SALT IN KG/MOL, MILLERO ET AL. 2008
real*8, public, parameter :: molar_mass_air_si = 0.02896546d0        !MOLAR MASS OF DRY AIR IN KG MOL-1,  PICARD ET AL. 2008

!*****************************************************************************************************************************
!LEMMON ET AL. (2000) DECIDED TO USE THE LATEST MOLAR MASS WITH THEIR MOLAR FORMULATION.
!FOR CONSISTENCY WITH IAPWS-10, THE SIA LIBRARY VERSION 1.1 INTRODUCED IN May 2010 USES THIS VALUE

!VERSION 1.0 (V1.0)
!real*8, public, parameter :: molar_mass_air_L2000 = 0.0289586d0      !MOLAR MASS OF DRY AIR IN KG MOL-1,  LEMMON ET AL. 2000

!VERSION 1.1 (V1.1)
real*8, public, parameter :: molar_mass_air_L2000 = molar_mass_air_si !MOLAR MASS OF DRY AIR IN KG MOL-1,  LEMMON ET AL. 2000
!*****************************************************************************************************************************

real*8, public, parameter :: gas_constant_h2o_si = gas_constant_molar_si / molar_mass_h2o_si            !SPECIFIC GAS CONSTANT OF H2O IN J KG-1 K-1, IAPWS 2005


real*8, public, parameter :: gas_constant_h2o_iapws95 = 461.51805d0                                     !SPECIFIC GAS CONSTANT OF H2O IN J KG-1 K-1, IAPWS-95


real*8, public, parameter :: gas_constant_air_si = gas_constant_molar_si / molar_mass_air_si           !SPECIFIC GAS CONSTANT OF AIR IN J KG-1 K-1, PICARD ET AL. 2008
real*8, public, parameter :: gas_constant_air_L2000 = gas_constant_molar_L2000 / molar_mass_air_L2000  !SPECIFIC GAS CONSTANT OF AIR IN J KG-1 K-1, LEMMON ET AL. 2000

real*8, public, parameter :: sealevel_pressure_si = 101325d0                   !PA
real*8, public, parameter :: celsius_temperature_si = 273.15d0                 !K,          ITS-90 DEFINITION

!STANDARD OCEAN PROPERTIES,MILLERO ET AL. 2008
real*8, public, parameter :: so_salinity_si = 0.03516504d0                     !KG KG-1 OF KCL-NORMALISED SEAWATER, Millero et al. 2008
real*8, public, parameter :: so_temperature_si = celsius_temperature_si        !K
real*8, public, parameter :: so_pressure_si = sealevel_pressure_si             !PA

!CRITICAL POINT OF PURE WATER, IAPWS-95
real*8, public, parameter :: cp_density_si = 322d0                             !KG M-3
real*8, public, parameter :: cp_temperature_si = 647.096d0                     !K
real*8, public, parameter :: cp_pressure_si = 22064000d0                       !PA
real*8, public, parameter :: cp_chempot_si = -767471.156792841d0               !IN J KG-1

!TRIPLE POINT OF PURE WATER
real*8, public, parameter :: tp_temperature_si = 273.16d0                      !K   ITS-90 DEFINITION
real*8, public, parameter :: tp_pressure_exp_si = 611.657d0                    !PA  EXPERIMENTAL TRIPLE POINT PRESSURE
!REAL*8, PUBLIC, PARAMETER :: TP_PRESSURE_IAPWS95_SI =611.6547710078944264442598D-6    !FROM QUADRUPLE-PRECISION COMPUTATION
real*8, public, parameter :: tp_pressure_iapws95_si = 611.654771007894d0       !Pa
!REAL*8, PUBLIC, PARAMETER :: TP_DENSITY_VAP_IAPWS95_SI =4.854575724778588417176210D-3 !FROM QUADRUPLE-PRECISION COMPUTATION
real*8, public, parameter :: tp_density_vap_iapws95_si = 4.85457572477859d-03  !KG M-3
!REAL*8, PUBLIC, PARAMETER :: TP_DENSITY_LIQ_IAPWS95_SI =999.792520031620646603898354735d0 !FROM QUADRUPLE-PRECISION COMPUTATION
real*8, public, parameter :: tp_density_liq_iapws95_si = 999.792520031621d0    !KG M-3
real*8, public, parameter :: tp_density_ice_iapws95_si = 916.709492199488d0    !KG M-3
real*8, public, parameter :: tp_enthalpy_vap_si = 2500915.1914657d0            !J KG-1
real*8, public, parameter :: tp_enthalpy_ice_si = -333444.253967839d0          !J KG-1


!References:

!FEISTEL ET AL. 2008:
!FEISTEL, R., WRIGHT, D.G., MIYAGAWA, K., HARVEY, A.H., HRUBY, j., JACKETT, D.R., MCdOUGALL, T.J. AND WAGNER, W.:
!MUTUALLY CONSISTENT THERMODYNAMIC POTENTIALS FOR FLUID WATER, ICE, AND SEAWATER: a NEW STANDARD FOR OCEANOGRAPHY,
!OCEAN SCI., 4, 275-291, 2008, AVAILABLE AT: WWW.OCEAN-SCI.NET/4/275/2008/

!IAPWS-95:
!RELEASE ON THE IAPWS FORMULATION 1995 FOR THE THERMODYNAMIC PROPERTIES OF ORDINARY WATER SUBSTANCE FOR GENERAL AND SCIENTIFIC USE
!THE INTERNATIONAL ASSOCIATION FOR THE PROPERTIES OF WATER AND STEAM
!DOORWERTH, THE NETHERLANDS, SEPTEMBER 2009
!(ORIGINAL RELEASE: FREDERICIA, DENMARK, SEPTEMBER 1996)
!AVAILABLE AT:  HTTP://WWW.IAPWS.ORG

!IAPWS 2005:
!IAPWS: GUIDELINE ON THE USE OF FUNDAMENTAL PHYSICAL CONSTANTS AND BASIC CONSTANTS OF WATER.
!THE INTERNATIONAL ASSOCIATION FOR THE PROPERTIES OF WATER AND STEAM. GAITHERSBURG, MAYLAND, USA, SEPTEMBER 2001.
!REVISION JULY 2005, AVAILABLE AT: HTTP://WWW.IAPWS.ORG

!LEMMON ET AL. 2000:
!LEMMON, E.W., JACOBSEN, R.T., PENONCELLO, S.G. AND FRIEND, D.G.:
!THERMODYNAMIC PROPERTIES OF AIR AND MIXTURES OF NITROGEN, ARGON AND OXYGEN FROM 60 TO 2000 K AT PRESSURES TO 2000 MPa,
!J. PHYS. CHEM. REF. DATA, 29, 331-362, 2000

!MILLERO ET AL. 2008:
!MILLERO, F.J., FEISTEL, R., WRIGHT, D.G. AND MCDOUGALL, T.J.:
!THE COMPOSITION OF STANDARD SEAWATER AND THE DEFINITION OF THE REFERENCE-COMPOSITION SALINITY SCALE,
!DEEP-SEA RES. I, 55, 50-72, 2008

!PICARD ET AL. 2008:
!PICARD, A., DAVIS, R.S., GLASER, M. AND FUJII, K.:
!REVISED FORMULA FOR THE DENSITY OF MOIST AIR (CIPM-2007),
!METROLOGIA, 45, 149-155, 2008

end module constants_0

!FBL August 2012, University of Toronto
!
!1. Compile the teos with -fPIC:
!   bash compile_LIBRARY.sh
!
!2. Create a library teos.a:
!   ar -rcs teos.a *.o
!
!3. Create a fyp2 signature file:
!   f2py -m pyteos_air -h pyteos_air.pyf pyteos_air.F90 teos.a
!
!4. Compile the python library:
!   f2py teos.a -c pyteos_air.pyf pyteos_air.F90


subroutine air_g(in_name, in_q, in_t, in_p, k, l, m, n, out_val)
    !This subroutine is a wrapper for the Gibbs function formulation of humid air thermodynamics
    !Available routines taking q, t, p as arguments unles otherwise noted:
    !
    ! Air3b:
    ! chempot_vap
    ! compressibilityfactor
    ! contraction
    ! cp
    ! cv
    ! density
    ! enthalpy
    ! entropy
    ! expansion
    ! gibbs
    ! internal_energy
    ! kappa_s: isentropic compressibility
    ! kappa_t: isothermal compressibility
    ! lapserate: dry adiabatic lapse rate of humid air
    ! soundspeed

    ! Air3c:
    ! temperature: temperature from q, entropy, p
    ! 
    use air_3b
    use air_3c
    implicit none
    integer :: k, l, m, n, idk, idl, idm, idn
    real(8) :: in_q(k,l,m,n), in_t(k,l,m,n), in_p(k,l,m,n)
    real(8) :: out_val(k,l,m,n)
    character(len = *) :: in_name

!f2py real(8), intent(out), dimension(k,l,m,n) :: out_val
!f2py real(8), intent(in), dimension(k,l,m,n) :: in_q, in_t, in_p
!f2py character(len = *), intent(in) :: in_name
!f2py integer, intent(in) :: k,l,m,n
    

    do idk=1,k
    do idl=1,l
    do idm=1,m
    do idn=1,n
            select case( in_name )
                !Air 3b
                case( 'chempot_vap' )
                    out_val(idk,idl,idn,idm)=air_g_chempot_vap_si(in_q(idk,idl,idn,idm),&
                    in_t(idk,idl,idn,idm), in_p(idk,idl,idn,idm))
                case( 'compressibilityfactor' )
                    out_val(idk,idl,idn,idm)=air_g_compressibilityfactor_si(in_q(idk,idl,idn,idm),&
                    in_t(idk,idl,idn,idm), in_p(idk,idl,idn,idm))
                case( 'contraction' )
                    out_val(idk,idl,idn,idm)=air_g_contraction_si(in_q(idk,idl,idn,idm),&
                    in_t(idk,idl,idn,idm), in_p(idk,idl,idn,idm))
                case( 'cp' )
                    out_val(idk,idl,idn,idm)=air_g_cp_si(in_q(idk,idl,idn,idm),&
                    in_t(idk,idl,idn,idm), in_p(idk,idl,idn,idm))
                case( 'cv' )
                    out_val(idk,idl,idn,idm)=air_g_cv_si(in_q(idk,idl,idn,idm),&
                    in_t(idk,idl,idn,idm), in_p(idk,idl,idn,idm))
                case( 'density' )
                    out_val(idk,idl,idn,idm)=air_g_density_si(in_q(idk,idl,idn,idm),&
                    in_t(idk,idl,idn,idm), in_p(idk,idl,idn,idm))
                case( 'enthalpy' )
                    out_val(idk,idl,idn,idm)=air_g_enthalpy_si(in_q(idk,idl,idn,idm),&
                    in_t(idk,idl,idn,idm), in_p(idk,idl,idn,idm))
                case( 'entropy' )
                    out_val(idk,idl,idn,idm)=air_g_entropy_si(in_q(idk,idl,idn,idm),&
                    in_t(idk,idl,idn,idm), in_p(idk,idl,idn,idm))
                case( 'expansion' )
                    out_val(idk,idl,idn,idm)=air_g_expansion_si(in_q(idk,idl,idn,idm),&
                    in_t(idk,idl,idn,idm), in_p(idk,idl,idn,idm))
                case( 'gibbs_energy' )
                    out_val(idk,idl,idn,idm)=air_g_gibbs_energy_si(in_q(idk,idl,idn,idm),&
                    in_t(idk,idl,idn,idm), in_p(idk,idl,idn,idm))
                case( 'internal_energy' )
                    out_val(idk,idl,idn,idm)=air_g_internal_energy_si(in_q(idk,idl,idn,idm),&
                    in_t(idk,idl,idn,idm), in_p(idk,idl,idn,idm))
                case( 'kappa_s' )
                    out_val(idk,idl,idn,idm)=air_g_kappa_s_si(in_q(idk,idl,idn,idm),&
                    in_t(idk,idl,idn,idm), in_p(idk,idl,idn,idm))
                case( 'kappa_t' )
                    out_val(idk,idl,idn,idm)=air_g_kappa_t_si(in_q(idk,idl,idn,idm),&
                    in_t(idk,idl,idn,idm), in_p(idk,idl,idn,idm))
                case( 'lapserate' )
                    out_val(idk,idl,idn,idm)=air_g_lapserate_si(in_q(idk,idl,idn,idm),&
                    in_t(idk,idl,idn,idm), in_p(idk,idl,idn,idm))
                case( 'soundspeed' )
                    out_val(idk,idl,idn,idm)=air_g_soundspeed_si(in_q(idk,idl,idn,idm),&
                    in_t(idk,idl,idn,idm), in_p(idk,idl,idn,idm))
                !Air 3c
                case( 'temperature' ) !From Air_3c. Requires entropy instead of temperature
                    out_val(idk,idl,idn,idm)=air_temperature_si(in_q(idk,idl,idn,idm),&
                    in_t(idk,idl,idn,idm), in_p(idk,idl,idn,idm))
                case default
                    write(*,*) 'Unknown function'
            end select
    enddo
    enddo
    enddo
    enddo
 
end subroutine air_g

subroutine air_g_ref(in_name,in_q,in_t,in_p, in_ref, k, l, m, n, out_val)
    !This subroutine is a wrapper for the Gibbs function formulation of humid air thermodynamics.
    !All of these functions require a reference value
    !Available routines:
    !
    ! Air_3c:
    ! potdensity
    ! potenthalpy
    ! pottemp

    use air_3c
    implicit none
    integer :: k, l, m, n, idk, idl, idm, idn
    real(8) :: in_q(k,l,m,n), in_t(k,l,m,n), in_p(k,l,m,n)
    real(8) :: in_ref
    real(8) :: out_val(k,l,m,n)
    character (len = *) :: in_name

!f2py real(8), intent(out), dimension(k,l,m,n) :: out_val
!f2py real(8), intent(in), dimension(k,l,m,n) :: in_q, in_t, in_p
!f2py real(8), intent(in) :: in_ref
!f2py integer, intent(in) :: k,l,m,n
!f2py character(len = *), intent(in) :: in_name

    do idk=1,k
    do idl=1,l
    do idm=1,m
    do idn=1,n
            select case(in_name)
                case( 'potdensity' )
                    out_val(idk,idl,idm,idm)=air_potdensity_si(in_q(idk,idl,idm,idm),&
                    in_t(idk,idl,idm,idm), in_p(idk,idl,idm,idm), in_ref)
                case( 'potenthalpy' )
                    out_val(idk,idl,idm,idm)=air_potenthalpy_si(in_q(idk,idl,idm,idm),&
                    in_t(idk,idl,idm,idm), in_p(idk,idl,idm,idm), in_ref)
                case( 'pottemp' )
                    out_val(idk,idl,idm,idm)=air_pottemp_si(in_q(idk,idl,idm,idm),&
                    in_t(idk,idl,idm,idm), in_p(idk,idl,idm,idm), in_ref)
                case default
                    write(*,*) 'Unknown function'
            end select
    enddo
    enddo
    enddo
    enddo
 
end subroutine air_g_ref

subroutine liq_air_sat(in_name,in_t,in_p, k, l, m, n, out_val)
    !This subroutine is a wrapper for the Gibbs function formulation for wet air saturation.
    !Available routines:
    !
    ! Liq_Air_4a:
    ! massfraction: t and p
    ! condensationpressure: a and t
    ! dewpoint: a and p
    !
    ! Liq_Ice_Air_4:
    ! ifl: isentropic freezing level: q and s
    ! iml: isentropic melting level: q and s

    use liq_air_4a
    implicit none
    integer :: k, l, m, n, idk, idl, idm, idn
    real(8) :: in_t(k,l,m,n), in_p(k,l,m,n)
    real(8) :: out_val(k,l,m,n)
    character (len = *) :: in_name

!f2py real(8), intent(out), dimension(k,l,m,n) :: out_val
!f2py real(8), intent(in), dimension(k,l,m,n) :: in_t, in_p
!f2py character(len = *), intent(in) :: in_name
!f2py integer, intent(in) :: k,l,m,n

    do idk=1,k
    do idl=1,l
    do idm=1,m
    do idn=1,n
            select case(in_name)
                !Liq_Air_4a:
                case( 'massfraction' )
                    out_val(idk,idl,idm,idm)=liq_air_massfraction_air_si(&
                    in_t(idk,idl,idm,idm), in_p(idk,idl,idm,idm))
                case( 'condensationpressure' )
                    out_val(idk,idl,idm,idm)=liq_air_condensationpressure_si(&
                    in_t(idk,idl,idm,idm), in_p(idk,idl,idm,idm))
                case( 'dewpoint' )
                    out_val(idk,idl,idm,idm)=liq_air_dewpoint_si(&
                    in_t(idk,idl,idm,idm), in_p(idk,idl,idm,idm))
                case default
                    write(*,*) 'Unknown function'
            end select
    enddo
    enddo
    enddo
    enddo
 
end subroutine liq_air_sat

subroutine liq_air_g(in_name, in_q,in_t,in_p, k, l, m, n, out_val)
    !This subroutine is a wrapper for the Gibbs function formulation of wet air thermodynamics
    !Available routines taking q, t, p as arguments unles otherwise noted:
    !
    ! Liq_Air_4a:
    ! massfrac_wmo: mass fraction from rh, t, p
    ! massfrac_cct: mass fraction from rh, t, p
    ! rh_cct
    ! rh_wmo
    ! icl: isentropic condensation level
    ! ict: isentropic condensation temperature

    ! Liq_Air_4b:
    ! density
    ! enthalpy
    ! entropy
    ! expansion
    ! kappa_t
    ! lapserate
    ! liquidfraction
    ! vapourfraction

    use liq_air_4a
    use liq_air_4b
    implicit none
    integer :: k, l, m, n, idk, idl, idm, idn
    real(8) :: in_q(k,l,m,n), in_t(k,l,m,n), in_p(k,l,m,n)
    real(8) :: out_val(k,l,m,n)
    character (len = *) :: in_name

!f2py real(8), intent(out), dimension(k,l,m,n) :: out_val
!f2py real(8), intent(in), dimension(k,l,m,n) :: in_q, in_t, in_p
!f2py character(len = *), intent(in) :: in_name
!f2py integer, intent(in) :: k,l,m,n

    do idk=1,k
    do idl=1,l
    do idm=1,m
    do idn=1,n
            select case( in_name )
                !Liq_Air_4a
                case( 'massfrac_wmo' ) 
                    out_val(idk,idl,idm,idm)=liq_air_a_from_rh_wmo_si(in_q(idk,idl,idm,idm),&
                    in_t(idk,idl,idm,idm), in_p(idk,idl,idm,idm))
                case( 'massfrac_cct' ) 
                    out_val(idk,idl,idm,idm)=liq_air_a_from_rh_cct_si(in_q(idk,idl,idm,idm),&
                    in_t(idk,idl,idm,idm), in_p(idk,idl,idm,idm))
                case( 'rhl_wmo' ) 
                    out_val(idk,idl,idm,idm)=liq_air_rh_wmo_from_a_si(in_q(idk,idl,idm,idm),&
                    in_t(idk,idl,idm,idm), in_p(idk,idl,idm,idm))
                case( 'rhl_cct' ) 
                    out_val(idk,idl,idm,idm)=liq_air_rh_cct_from_a_si(in_q(idk,idl,idm,idm),&
                    in_t(idk,idl,idm,idm), in_p(idk,idl,idm,idm))
                case( 'icl' ) 
                    out_val(idk,idl,idm,idm)=liq_air_icl_si(in_q(idk,idl,idm,idm),&
                    in_t(idk,idl,idm,idm), in_p(idk,idl,idm,idm))
                case( 'ict' ) 
                    out_val(idk,idl,idm,idm)=liq_air_ict_si(in_q(idk,idl,idm,idm),&
                    in_t(idk,idl,idm,idm), in_p(idk,idl,idm,idm))
                !Liq_Air_4b
                case( 'cp' ) 
                    out_val(idk,idl,idm,idm)=liq_air_g_cp_si(in_q(idk,idl,idm,idm),&
                    in_t(idk,idl,idm,idm), in_p(idk,idl,idm,idm))
                case( 'density' ) 
                    out_val(idk,idl,idm,idm)=liq_air_g_density_si(in_q(idk,idl,idm,idm),&
                    in_t(idk,idl,idm,idm), in_p(idk,idl,idm,idm))
                case( 'enthalpy' ) 
                    out_val(idk,idl,idm,idm)=liq_air_g_enthalpy_si(in_q(idk,idl,idm,idm),&
                    in_t(idk,idl,idm,idm), in_p(idk,idl,idm,idm))
                case( 'entropy' ) 
                    out_val(idk,idl,idm,idm)=liq_air_g_entropy_si(in_q(idk,idl,idm,idm),&
                    in_t(idk,idl,idm,idm), in_p(idk,idl,idm,idm))
                case( 'expansion' ) 
                    out_val(idk,idl,idm,idm)=liq_air_g_expansion_si(in_q(idk,idl,idm,idm),&
                    in_t(idk,idl,idm,idm), in_p(idk,idl,idm,idm))
                case( 'kappa_t' ) 
                    out_val(idk,idl,idm,idm)=liq_air_g_kappa_t_si(in_q(idk,idl,idm,idm),&
                    in_t(idk,idl,idm,idm), in_p(idk,idl,idm,idm))
                case( 'lapserate' ) 
                    out_val(idk,idl,idm,idm)=liq_air_g_lapserate_si(in_q(idk,idl,idm,idm),&
                    in_t(idk,idl,idm,idm), in_p(idk,idl,idm,idm))
                case( 'liquidfraction' ) 
                    out_val(idk,idl,idm,idm)=liq_air_liquidfraction_si(in_q(idk,idl,idm,idm),&
                    in_t(idk,idl,idm,idm), in_p(idk,idl,idm,idm))
                case( 'vapourfraction' ) 
                    out_val(idk,idl,idm,idm)=liq_air_vapourfraction_si(in_q(idk,idl,idm,idm),&
                    in_t(idk,idl,idm,idm), in_p(idk,idl,idm,idm))
            end select
    enddo
    enddo
    enddo
    enddo
end subroutine liq_air_g

subroutine liq_air_h(in_name, in_q,in_s,in_p, k, l, m, n, out_val)
    !This subroutine is a wrapper for the Gibbs function formulation of wet air thermodynamics
    !Available routines taking q, s, p as arguments unles otherwise noted:
    !
    ! Liq_Air_4c:
    ! cp
    ! density
    ! kappa_s
    ! temperature
    ! lapserate

    use liq_air_4c
    implicit none
    integer :: k, l, m, n, idk, idl, idm, idn
    real(8) :: in_q(k,l,m,n), in_s(k,l,m,n), in_p(k,l,m,n)
    real(8) :: out_val(k,l,m,n)
    character (len = *) :: in_name

!f2py real(8), intent(out), dimension(k,l,m,n) :: out_val
!f2py real(8), intent(in), dimension(k,l,m,n) :: in_q, in_s, in_p
!f2py character(len = *), intent(in) :: in_name
!f2py integer, intent(in) :: k,l,m,n

    do idk=1,k
    do idl=1,l
    do idm=1,m
    do idn=1,n
            select case( in_name )
                case( 'cp' ) 
                    out_val(idk,idl,idm,idm)=liq_air_h_cp_si(in_q(idk,idl,idm,idm),&
                    in_s(idk,idl,idm,idm), in_p(idk,idl,idm,idm))
                case( 'density' ) 
                    out_val(idk,idl,idm,idm)=liq_air_h_density_si(in_q(idk,idl,idm,idm),&
                    in_s(idk,idl,idm,idm), in_p(idk,idl,idm,idm))
                case( 'kappa_s' ) 
                    out_val(idk,idl,idm,idm)=liq_air_h_kappa_s_si(in_q(idk,idl,idm,idm),&
                    in_s(idk,idl,idm,idm), in_p(idk,idl,idm,idm))
                case( 'temperature' ) 
                    out_val(idk,idl,idm,idm)=liq_air_h_temperature_si(in_q(idk,idl,idm,idm),&
                    in_s(idk,idl,idm,idm), in_p(idk,idl,idm,idm))
                case( 'lapserate' ) 
                    out_val(idk,idl,idm,idm)=liq_air_h_lapserate_si(in_q(idk,idl,idm,idm),&
                    in_s(idk,idl,idm,idm), in_p(idk,idl,idm,idm))
            end select
    enddo
    enddo
    enddo
    enddo
end subroutine liq_air_h


subroutine liq_air_g_ref(in_name,in_q,in_t,in_p, in_ref, k, l, m, n, out_val)
    !This subroutine is a wrapper for the Gibbs function formulation of humid air thermodynamics.
    !All of these functions require a reference value
    !Available routines:
    !
    ! Liq_Air_4c
    ! potdensity
    ! potenthalpy
    ! pottemp
    ! pottempequi

    use liq_air_4c
    !use liq_air_5
    implicit none
    integer :: k, l, m, n, idk, idl, idm, idn
    real(8) :: in_q(k,l,m,n), in_t(k,l,m,n), in_p(k,l,m,n)
    real(8) :: in_ref
    real(8) :: out_val(k,l,m,n)
    character (len = *) :: in_name

!f2py real(8), intent(out), dimension(k,l,m,n) :: out_val
!f2py real(8), intent(in), dimension(k,l,m,n) :: in_q, in_t, in_p
!f2py real(8), intent(in) :: in_ref
!f2py integer, intent(in) :: k,l,m,n
!f2py character(len = *), intent(in) :: in_name

    do idk=1,k
    do idl=1,l
    do idm=1,m
    do idn=1,n
            select case(in_name)
                case( 'potdensity' )
                    out_val(idk,idl,idm,idm)=liq_air_potdensity_si(in_q(idk,idl,idm,idm),&
                    in_t(idk,idl,idm,idm), in_p(idk,idl,idm,idm), in_ref)
                case( 'potenthalpy' )
                    out_val(idk,idl,idm,idm)=liq_air_potenthalpy_si(in_q(idk,idl,idm,idm),&
                    in_t(idk,idl,idm,idm), in_p(idk,idl,idm,idm), in_ref)
                case( 'pottemp' )
                    out_val(idk,idl,idm,idm)=liq_air_pottemp_si(in_q(idk,idl,idm,idm),&
                    in_t(idk,idl,idm,idm), in_p(idk,idl,idm,idm), in_ref)
            end select
    enddo
    enddo
    enddo
    enddo
 
end subroutine liq_air_g_ref

subroutine ice_air_sat(in_name,in_t,in_p, k, l, m, n, out_val)
    !This subroutine is a wrapper for the Gibbs function formulation for wet air saturation.
    !Available routines:
    !
    ! Liq_Air_4a:
    ! massfraction: t and p
    ! condensationpressure: a and t
    ! dewpoint: a and p
    !

    use ice_air_4a
    implicit none
    integer :: k, l, m, n, idk, idl, idm, idn
    real(8) :: in_t(k,l,m,n), in_p(k,l,m,n)
    real(8) :: out_val(k,l,m,n)
    character (len = *) :: in_name

!f2py real(8), intent(out), dimension(k,l,m,n) :: out_val
!f2py real(8), intent(in), dimension(k,l,m,n) :: in_t, in_p
!f2py character(len = *), intent(in) :: in_name
!f2py integer, intent(in) :: k,l,m,n

    do idk=1,k
    do idl=1,l
    do idm=1,m
    do idn=1,n
            select case(in_name)
                !Ice_Air_4a:
                case( 'massfraction' )
                    out_val(idk,idl,idm,idm)=ice_air_massfraction_air_si(&
                    in_t(idk,idl,idm,idm), in_p(idk,idl,idm,idm))
                case( 'condensationpressure' )
                    out_val(idk,idl,idm,idm)=ice_air_condensationpressure_si(&
                    in_t(idk,idl,idm,idm), in_p(idk,idl,idm,idm))
                case( 'frostpoint' )
                    out_val(idk,idl,idm,idm)=ice_air_frostpoint_si(&
                    in_t(idk,idl,idm,idm), in_p(idk,idl,idm,idm))
                case default
                    write(*,*) 'Unknown function'
            end select
    enddo
    enddo
    enddo
    enddo
 
end subroutine ice_air_sat


subroutine ice_air_g(in_name, in_q,in_t,in_p, k, l, m, n, out_val)
    !This subroutine is a wrapper for the Gibbs function formulation of wet air thermodynamics
    !Available routines taking q, t, p as arguments unles otherwise noted:
    !
    ! Ice_Air_4a:
    ! massfrac_wmo: mass fraction from rh, t, p
    ! massfrac_cct: mass fraction from rh, t, p
    ! rh_cct
    ! rh_wmo
    ! icl: isentropic condensation level
    ! ict: isentropic condensation temperature
    !
    ! Ice_Air_4b:
    ! density
    ! enthalpy
    ! expansion
    ! kappa_t
    ! lapserate
    ! solidfraction
    ! vapourfraction

    use ice_air_4a
    use ice_air_4b
    implicit none
    integer :: k, l, m, n, idk, idl, idm, idn
    real(8) :: in_q(k,l,m,n), in_t(k,l,m,n), in_p(k,l,m,n)
    real(8) :: out_val(k,l,m,n)
    character (len = *) :: in_name

!f2py real(8), intent(out), dimension(k,l,m,n) :: out_val
!f2py real(8), intent(in), dimension(k,l,m,n) :: in_q, in_t, in_p
!f2py integer, intent(in) :: k,l,m,n
!f2py character(len = *), intent(in) :: in_name

    do idk=1,k
    do idl=1,l
    do idm=1,m
    do idn=1,n
            select case( in_name )
                !Ice_Air_4a
                case( 'massfrac_wmo' ) 
                    out_val(idk,idl,idm,idm)=ice_air_a_from_rh_wmo_si(in_q(idk,idl,idm,idm),&
                    in_t(idk,idl,idm,idm), in_p(idk,idl,idm,idm))
                case( 'massfrac_cct' ) 
                    out_val(idk,idl,idm,idm)=ice_air_a_from_rh_cct_si(in_q(idk,idl,idm,idm),&
                    in_t(idk,idl,idm,idm), in_p(idk,idl,idm,idm))
                case( 'rhl_wmo' ) 
                    out_val(idk,idl,idm,idm)=ice_air_rh_wmo_from_a_si(in_q(idk,idl,idm,idm),&
                    in_t(idk,idl,idm,idm), in_p(idk,idl,idm,idm))
                case( 'rhl_cct' ) 
                    out_val(idk,idl,idm,idm)=ice_air_rh_cct_from_a_si(in_q(idk,idl,idm,idm),&
                    in_t(idk,idl,idm,idm), in_p(idk,idl,idm,idm))
                case( 'icl' ) 
                    out_val(idk,idl,idm,idm)=ice_air_icl_si(in_q(idk,idl,idm,idm),&
                    in_t(idk,idl,idm,idm), in_p(idk,idl,idm,idm))
                case( 'ict' ) 
                    out_val(idk,idl,idm,idm)=ice_air_ict_si(in_q(idk,idl,idm,idm),&
                    in_t(idk,idl,idm,idm), in_p(idk,idl,idm,idm))
                !Ice_Air_4b
                case( 'cp' ) 
                    out_val(idk,idl,idm,idm)=ice_air_g_cp_si(in_q(idk,idl,idm,idm),&
                    in_t(idk,idl,idm,idm), in_p(idk,idl,idm,idm))
                case( 'density' ) 
                    out_val(idk,idl,idm,idm)=ice_air_g_density_si(in_q(idk,idl,idm,idm),&
                    in_t(idk,idl,idm,idm), in_p(idk,idl,idm,idm))
                case( 'enthalpy' ) 
                    out_val(idk,idl,idm,idm)=ice_air_g_enthalpy_si(in_q(idk,idl,idm,idm),&
                    in_t(idk,idl,idm,idm), in_p(idk,idl,idm,idm))
                case( 'entropy' ) 
                    out_val(idk,idl,idm,idm)=ice_air_g_entropy_si(in_q(idk,idl,idm,idm),&
                    in_t(idk,idl,idm,idm), in_p(idk,idl,idm,idm))
                case( 'expansion' ) 
                    out_val(idk,idl,idm,idm)=ice_air_g_expansion_si(in_q(idk,idl,idm,idm),&
                    in_t(idk,idl,idm,idm), in_p(idk,idl,idm,idm))
                case( 'kappa_t' ) 
                    out_val(idk,idl,idm,idm)=ice_air_g_kappa_t_si(in_q(idk,idl,idm,idm),&
                    in_t(idk,idl,idm,idm), in_p(idk,idl,idm,idm))
                case( 'lapserate' ) 
                    out_val(idk,idl,idm,idm)=ice_air_g_lapserate_si(in_q(idk,idl,idm,idm),&
                    in_t(idk,idl,idm,idm), in_p(idk,idl,idm,idm))
                case( 'solidraction' ) 
                    out_val(idk,idl,idm,idm)=ice_air_solidfraction_si(in_q(idk,idl,idm,idm),&
                    in_t(idk,idl,idm,idm), in_p(idk,idl,idm,idm))
                case( 'vapourfraction' ) 
                    out_val(idk,idl,idm,idm)=ice_air_vapourfraction_si(in_q(idk,idl,idm,idm),&
                    in_t(idk,idl,idm,idm), in_p(idk,idl,idm,idm))
            end select
    enddo
    enddo
    enddo
    enddo
end subroutine ice_air_g

subroutine ice_air_h(in_name, in_q,in_s,in_p, k, l, m, n, out_val)
    !This subroutine is a wrapper for the Gibbs function formulation of wet air thermodynamics
    !Available routines taking q, s, p as arguments unles otherwise noted:
    !
    ! Liq_Air_4c:
    ! cp
    ! density
    ! kappa_s
    ! temperature
    ! lapserate

    use ice_air_4c
    implicit none
    integer :: k, l, m, n, idk, idl, idm, idn
    real(8) :: in_q(k,l,m,n), in_s(k,l,m,n), in_p(k,l,m,n)
    real(8) :: out_val(k,l,m,n)
    character (len = *) :: in_name

!f2py real(8), intent(out), dimension(k,l,m,n) :: out_val
!f2py real(8), intent(in), dimension(k,l,m,n) :: in_q, in_s, in_p
!f2py character(len = *), intent(in) :: in_name
!f2py integer, intent(in) :: k,l,m,n

    do idk=1,k
    do idl=1,l
    do idm=1,m
    do idn=1,n
            select case( in_name )
                case( 'cp' ) 
                    out_val(idk,idl,idm,idm)=ice_air_h_cp_si(in_q(idk,idl,idm,idm),&
                    in_s(idk,idl,idm,idm), in_p(idk,idl,idm,idm))
                case( 'density' ) 
                    out_val(idk,idl,idm,idm)=ice_air_h_density_si(in_q(idk,idl,idm,idm),&
                    in_s(idk,idl,idm,idm), in_p(idk,idl,idm,idm))
                case( 'kappa_s' ) 
                    out_val(idk,idl,idm,idm)=ice_air_h_kappa_s_si(in_q(idk,idl,idm,idm),&
                    in_s(idk,idl,idm,idm), in_p(idk,idl,idm,idm))
                case( 'temperature' ) 
                    out_val(idk,idl,idm,idm)=ice_air_h_temperature_si(in_q(idk,idl,idm,idm),&
                    in_s(idk,idl,idm,idm), in_p(idk,idl,idm,idm))
                case( 'lapserate' ) 
                    out_val(idk,idl,idm,idm)=ice_air_h_lapserate_si(in_q(idk,idl,idm,idm),&
                    in_s(idk,idl,idm,idm), in_p(idk,idl,idm,idm))
            end select
    enddo
    enddo
    enddo
    enddo
end subroutine ice_air_h

subroutine ice_air_g_ref(in_name,in_q,in_t,in_p, in_ref, k, l, m, n, out_val)
    !This subroutine is a wrapper for the Gibbs function formulation of humid air thermodynamics.
    !All of these functions require a reference value
    !Available routines:
    !
    ! Liq_Air_4c
    ! potdensity
    ! potenthalpy
    ! pottemp

    use ice_air_4c
    implicit none
    integer :: k, l, m, n, idk, idl, idm, idn
    real(8) :: in_q(k,l,m,n), in_t(k,l,m,n), in_p(k,l,m,n)
    real(8) :: in_ref
    real(8) :: out_val(k,l,m,n)
    character (len = *) :: in_name

!f2py real(8), intent(out), dimension(k,l,m,n) :: out_val
!f2py real(8), intent(in), dimension(k,l,m,n) :: in_q, in_t, in_p
!f2py real(8), intent(in) :: in_ref
!f2py integer, intent(in) :: k,l,m,n
!f2py character(len = *), intent(in) :: in_name

    do idk=1,k
    do idl=1,l
    do idm=1,m
    do idn=1,n
            select case(in_name)
                case( 'potdensity' )
                    out_val(idk,idl,idm,idm)=ice_air_potdensity_si(in_q(idk,idl,idm,idm),&
                    in_t(idk,idl,idm,idm), in_p(idk,idl,idm,idm), in_ref)
                case( 'potenthalpy' )
                    out_val(idk,idl,idm,idm)=ice_air_potenthalpy_si(in_q(idk,idl,idm,idm),&
                    in_t(idk,idl,idm,idm), in_p(idk,idl,idm,idm), in_ref)
                case( 'pottemp' )
                    out_val(idk,idl,idm,idm)=ice_air_pottemp_si(in_q(idk,idl,idm,idm),&
                    in_t(idk,idl,idm,idm), in_p(idk,idl,idm,idm), in_ref)
            end select
    enddo
    enddo
    enddo
    enddo
 
end subroutine ice_air_g_ref

subroutine liq_ice_air_sat(in_name,in_t,in_p, k, l, m, n, out_val)
    !This subroutine is a wrapper for the Gibbs function formulation for wet air saturation.
    !Available routines:
    !
    ! Liq_Air_4a:
    ! massfraction: t and p
    ! condensationpressure: a and t
    ! dewpoint: a and p
    !
    ! Liq_Ice_Air_4:
    ! ifl: isentropic freezing level: q and s
    ! iml: isentropic melting level: q and s

    use liq_ice_air_4
    use liq_ice_air_5
    implicit none
    integer :: k, l, m, n, idk, idl, idm, idn
    real(8) :: in_t(k,l,m,n), in_p(k,l,m,n)
    real(8) :: out_val(k,l,m,n)
    character (len = *) :: in_name

!f2py real(8), intent(out), dimension(k,l,m,n) :: out_val
!f2py real(8), intent(in), dimension(k,l,m,n) :: in_t, in_p
!f2py character(len = *), intent(in) :: in_name
!f2py integer, intent(in) :: k,l,m,n

    do idk=1,k
    do idl=1,l
    do idm=1,m
    do idn=1,n
            select case(in_name)
                !Liq_Ice_air_4:
                case( 'iml' )
                    out_val(idk,idl,idm,idm)=liq_ice_air_iml_si(&
                    in_t(idk,idl,idm,idm), in_p(idk,idl,idm,idm))
                case( 'ifl' )
                    out_val(idk,idl,idm,idm)=liq_ice_air_ifl_si(&
                    in_t(idk,idl,idm,idm), in_p(idk,idl,idm,idm))
                case( 'massfraction' )
                    out_val(idk,idl,idm,idm)=liq_ice_air_massfraction_air_si(&
                    in_t(idk,idl,idm,idm), in_p(idk,idl,idm,idm))
                case default
                    write(*,*) 'Unknown function'
            end select
    enddo
    enddo
    enddo
    enddo
 
end subroutine liq_ice_air_sat


subroutine liq_ice_air_g_ref(in_name,in_q,in_t,in_p, in_ref, k, l, m, n, out_val)
    !This subroutine is a wrapper for the Gibbs function formulation of humid air thermodynamics.
    !All of these functions require a reference value
    !Available routines:
    !
    ! Liq_Ice_Air_5
    ! pottemp
    ! pottemp_equi

    use liq_ice_air_5
    implicit none
    integer :: k, l, m, n, idk, idl, idm, idn
    real(8) :: in_q(k,l,m,n), in_t(k,l,m,n), in_p(k,l,m,n)
    real(8) :: in_ref
    real(8) :: out_val(k,l,m,n)
    character (len = *) :: in_name

!f2py real(8), intent(out), dimension(k,l,m,n) :: out_val
!f2py real(8), intent(in), dimension(k,l,m,n) :: in_q, in_t, in_p
!f2py real(8), intent(in) :: in_ref
!f2py integer, intent(in) :: k,l,m,n
!f2py character(len = *), intent(in) :: in_name

    do idk=1,k
    do idl=1,l
    do idm=1,m
    do idn=1,n
            select case(in_name)
                case( 'pottemp' )
                    out_val(idk,idl,idm,idm)=liq_ice_air_pottemp_si(in_q(idk,idl,idm,idm),&
                    in_t(idk,idl,idm,idm), in_p(idk,idl,idm,idm), in_ref)
                case( 'pottemp_equi' )
                    out_val(idk,idl,idm,idm)=liq_ice_air_pottemp_equi_si(in_q(idk,idl,idm,idm),&
                    in_t(idk,idl,idm,idm), in_p(idk,idl,idm,idm), in_ref)
                case( 'pottemp_equi_sat' )
                    out_val(idk,idl,idm,idm)=liq_ice_air_pottemp_equi_sat_si(in_q(idk,idl,idm,idm),&
                    in_t(idk,idl,idm,idm), in_p(idk,idl,idm,idm), in_ref)
                !case( 'entropy_mixed' )
                !    out_val(idk,idl,idm,idm)=liq_ice_air_g_entropy_mixed_si(in_q(idk,idl,idm,idm),&
                !    in_t(idk,idl,idm,idm), in_p(idk,idl,idm,idm), in_ref)
            end select
    enddo
    enddo
    enddo
    enddo
 
end subroutine liq_ice_air_g_ref

subroutine liq_ice_air_g(in_name,in_q,in_t,in_p, k, l, m, n, out_val)
    !This subroutine is a wrapper for the Gibbs function formulation of humid air thermodynamics.
    !All of these functions require a reference value
    !Available routines:
    !
    ! Liq_Ice_Air_5
    ! entropy

    use liq_ice_air_5
    implicit none
    integer :: k, l, m, n, idk, idl, idm, idn
    real(8) :: in_q(k,l,m,n), in_t(k,l,m,n), in_p(k,l,m,n)
    real(8) :: out_val(k,l,m,n)
    character (len = *) :: in_name

!f2py real(8), intent(out), dimension(k,l,m,n) :: out_val
!f2py real(8), intent(in), dimension(k,l,m,n) :: in_q, in_t, in_p
!f2py real(8), intent(in) :: in_ref
!f2py integer, intent(in) :: k,l,m,n
!f2py character(len = *), intent(in) :: in_name

    do idk=1,k
    do idl=1,l
    do idm=1,m
    do idn=1,n
            select case(in_name)
                case( 'entropy' )
                    out_val(idk,idl,idm,idm)=liq_ice_air_g_entropy_si(in_q(idk,idl,idm,idm),&
                    in_t(idk,idl,idm,idm), in_p(idk,idl,idm,idm))
                case( 'entropy_moist' )
                    out_val(idk,idl,idm,idm)=liq_ice_air_g_entropy_moist_si(&
                    in_q(idk,idl,idm,idm),&
                    in_t(idk,idl,idm,idm), in_p(idk,idl,idm,idm))
            end select
    enddo
    enddo
    enddo
    enddo
 
end subroutine liq_ice_air_g

module gsw_library_5

!#########################################################################

!THIS MODULE IMPLEMENTS THE GIBBS SEAWATER (GSW) LIBRARY, A SUBSET OF
!TAYLORED FUNCTIONS BASED ON THE GENERAL SEA-ICE-AIR (SIA) LIBRARY

!#########################################################################

!IMPLEMENTATION IN FORTRAN BY D.G. WRIGHT AND D. JACKETT

!#########################################################################

!THIS MODULE REQUIRES THE LIBRARY MODULES
!    CONSTANTS_0,  FILE CONSTANTS_0.F90  
!    CONVERT_0,    FILE CONVERT_0.F90
!    MATHS_0,      FILE MATHS_0.F90  
!    FLU_1,        FILE FLU_1.F90  
!    SAL_1,        FILE SAL_1.F90  
!    SAL_2,        FILE SAL_2.F90  
!    FLU_3A,       FILE FLU_3A.F90  
!    SEA_3A,       FILE SEA_3A.F90  
!    SEA_3B,       FILE SEA_3B.F90  
!    LIQ_F03_5,    FILE LIQ_F03_5.F90  
!    SEA_5A,       FILE SEA_5A.F90  

!#########################################################################

use constants_0
use convert_0
use maths_0
use flu_1
use sal_1
use sal_2
use flu_3a
use sea_3a
use sea_3b
use liq_f03_5
use sea_5a

implicit none
private

character*16, private :: version = '1 Feb 2011'

public :: gsw_alpha_ct, gsw_alpha_pt0, &
          gsw_alpha_t, gsw_asal_from_psal, &
          gsw_beta_ct, gsw_beta_pt0, gsw_beta_t, &
          gsw_cabb_ct, gsw_cabb_pt0, &
          gsw_cp, gsw_ctmp_from_ptmp0, gsw_dens, &
          gsw_enthalpy, gsw_entropy, gsw_g, &
          gsw_kappa, gsw_kappa_t, gsw_pden, &
          gsw_psal_from_asal, gsw_ptmp, &
          gsw_ptmp0_from_ctmp, gsw_specvol, gsw_svel, &
          gsw_thrmb_ct, gsw_thrmb_pt0



!============================================================================
! This is the gsw thermodynamic Gibbs function library implemented in Fortran
!============================================================================
!
! consisting of the sum of pure water and saline components defined by 
!
!	Feistel, R., 2003: A new extended Gibbs thermodynamic potential of seawater,  
!                      Progr. Oceanogr., 58, 43-114.
!
! for the pure water component and by 
!
!	Feistel, R., 2008: A Gibbs function for seawater thermodynamics for -6 to 80°C  
!                      and salinity up to 120 G/KG, Deep-Sea Res. I, 55, 1639-1671, and  
!     
!  	IAPWS 2008: Release on the IAPWS Formulation 2008 for the Thermodynamic Properties of Seawater, 
!               The International Association for the Properties of Water and Steam, 
!               Berlin, Germany, September 2008, available at http://www.iapws.org
!  	
! for the saline componentr., 
!
! The basic routines are copies of those written by David Jackett for the GSW library
! on the TEOS-10 site.  However, they been modified to use the routines and approaches 
! used in the SIA library in order to provide a cross-check between the two libraries.
!
! September 2009
!============================================================================

contains

!============================================================================
function gsw_g(drv_s, drv_t, drv_p, sa, t, p)
!============================================================================

! SEAWATER SPECIFIC GIBBS FREE ENERGY AND DERIVATIVES UP TO ORDER 2
!
! DRV_S               : ORDER OF S DERIVATIVE
! DRV_T               : ORDER OF T DERIVATIVE
! DRV_P               : ORDER OF P DERIVATIVE
! SA                  : ABSOLUTE SALINITY                  [G/KG]
! T                   : TEMPERATURE                        [DEG C]
! P                   : SEA (GAUGE) PRESSURE               [DBAR]
! 
!OUTPUT: gsw_g        : SPECIFIC GIBBS ENERGY OR ITS DERIVATIVE
!GSW_G IS THE S-T-P DERIVATIVE
!(D/DS)^DRV_S (D/DT)^DRV_T (D/DP)^DRV_P G(S,T,P)
!OF THE SPECIFIC GIBBS ENERGY OF SEAWATER, G(S,T,P), IN J/KG
!T AND P DERIVATIVES ARE IN UNITS OF 1/K AND 1/PA
!S DERIVATIVES ARE IN UNITS OF 1/(G/KG)

!CHECK VALUES:
!GSW_G(0,0,0,35,26.85,0d0) = -5113.70064124
!GSW_G(1,0,0,35,26.85,0d0) =  78.5928261339
!GSW_G(0,1,0,35,26.85,0d0) = -374.452000830
!GSW_G(0,0,1,35,26.85,0d0) =  0.977858058750E-03
!GSW_G(2,0,0,35,26.85,0d0) =  2.24755137017
!GSW_G(1,1,0,35,26.85,0d0) =  0.789935187192
!GSW_G(1,0,1,35,26.85,0d0) = -0.716680931996E-06
!GSW_G(0,2,0,35,26.85,0d0) = -13.3358337534
!GSW_G(0,1,1,35,26.85,0d0) =  0.304607508052E-06
!GSW_G(0,0,2,35,26.85,0d0) = -0.410939723950E-12

implicit none
integer drv_s, drv_t, drv_p
real*8 gsw_g, sa, t, p, sa_si, t_si, p_si
real*8 gw, gs

sa_si = sa * 1d-3
t_si = t + 273.15d0
p_si = 1d4 * p + 101325d0

gsw_g = errorreturn

if(sa_si < 0d0 .or. sa_si >= 1d0) return
if(t_si <= 0d0) return
if(p_si <= 0d0) return

if(drv_s < 0 .or. drv_s > 3) return
if(drv_t < 0) return
if(drv_p < 0) return
if(drv_s + drv_t + drv_p > 2) return

!WATER PART
gw = 0d0
if(drv_s == 0) then
  gw = fit_liq_g_f03_si(drv_t, drv_p, t_si, p_si)
  if(gw == errorreturn) return
end if

!SALINE PART
gs = sal_g_si(drv_s, drv_t, drv_p, sa_si, t_si, p_si)
if(gs == errorreturn) return

gsw_g = gw + gs
    
!It appears that the gsw library works with gsw_g in G/KG, DEGC, Pa
gsw_g = gsw_g * (1d-3)**drv_s

return
end function


!============================================================================
function gsw_alpha_t(sa, t, p)
!============================================================================

! THERMAL EXPANSION COEFFICIENT OF SEAWATER 
!
! SA                  : ABSOLUTE SALINITY                  [G/KG]
! T                   : TEMPERATURE                        [DEG C]
! P                   : SEA (GAUGE) PRESSURE               [DBAR]
!
! GSW_ALPHA_T         : THERMAL EXPANSION COEFFICIENT      [1/K]
!                       WRT (IN SITU) TEMPERATURE

!CHECKVALUE: gsw_alpha_t(35.7d0, 25.5d0, 1023d0) = 0.000309837839319d0

implicit none
real*8 sa, t, p, gsw_alpha_t, gtp, gp

gsw_alpha_t = errorreturn

gtp = gsw_g(0, 1, 1, sa, t, p)
if(gtp == 0d0) return
gp = gsw_g(0, 0, 1, sa, t, p)
if(gp == errorreturn .or. gp <= 0d0) return

gsw_alpha_t = gtp / gp

end function


!============================================================================
function gsw_beta_t(sa, t, p)
!============================================================================

! HALINE CONTRACTION COEFFICIENT OF SEAWATER
!
! SA                  : ABSOLUTE SALINITY                  [G/KG]
! T                   : TEMPERATURE                        [DEG C]
! P                   : SEA (GAUGE) PRESSURE               [DBAR]
! 
! RESULT              : HALINE CONTRACTION COEFFICIENT     [KG/G]

!CHECKVALUE: gsw_beta_t(35.7d0, 25.5d0, 1023d0) = 0.000725729797839d0

implicit none
real*8 sa, t, p, gsw_beta_t, gsp, gp

gsw_beta_t = errorreturn

gsp = gsw_g(1, 0, 1, sa, t, p)
if(gsp == errorreturn) return
gp = gsw_g(0, 0, 1, sa, t, p)
if(gp == errorreturn .or. gp <= 0d0) return

gsw_beta_t = -gsp / gp

return
end function


!============================================================================
function gsw_cp(sa, t, p)
!============================================================================

! ISOBARIC HEAT CAPACITY OF SEAWATER
!
! SA                  : ABSOLUTE SALINITY                  [G/KG]
! T                   : TEMPERATURE                        [DEG C]
! P                   : SEA (GAUGE) PRESSURE               [DBAR]
! 
! RESULT              : HEAT CAPACITY                      [J/(KG K)]

!CHECKVALUE: gsw_cp(35.7d0, 25.5d0, 1023d0) = 3974.42541260

implicit none
real*8 sa, t, p, gsw_cp, gtt

gsw_cp = errorreturn

gtt = gsw_g(0, 2, 0, sa, t, p)
if(gtt == errorreturn)return

gsw_cp = -(T + 273.15d0) * gtt

return
end function


!============================================================================
function gsw_dens(sa, t, p)
!============================================================================

! DENSITY OF SEAWATER
!
! SA                  : ABSOLUTE SALINITY                  [G/KG]
! T                   : TEMPERATURE                        [DEG C]
! P                   : SEA (GAUGE) PRESSURE               [DBAR]
! 
! RESULT              : DENSITY                            [KG/M^3]

!CHECKVALUE: gsw_dens(35.7d0, 25.5d0, 1023d0) = 1027.95249316d0

implicit none
real*8 sa, t, p, gsw_dens, gp

gsw_dens = errorreturn

gp = gsw_g(0, 0, 1, sa, t, p)
if(gp == errorreturn .or. gp <= 0d0) return

gsw_dens = 1d0 / gp

return
end function


!============================================================================
function gsw_enthalpy(sa, t, p)
!============================================================================

! SPECIFIC ENTHALPY OF SEAWATER
!
! SA                  : ABSOLUTE SALINITY                  [G/KG]
! T                   : TEMPERATURE                        [DEG C]
! P                   : SEA (GAUGE) PRESSURE               [DBAR]
! 
! RESULT              : SPECIFIC ENTHALPY                  [J/KG]

!CHECKVALUE: gsw_enthalpy(35.7d0, 25.5d0, 1023d0) = 110776.712409d0

implicit none
real*8 sa, t, p, gsw_enthalpy, g, gt

gsw_enthalpy = errorreturn

g = gsw_g(0, 0, 0, sa, t, p)
if(g == errorreturn) return
gt = gsw_g(0, 1, 0, sa, T, P)
if(gt == errorreturn) return

gsw_enthalpy = g - (t + 273.15d0) * gt


return
end function


!============================================================================
function gsw_entropy(sa, t, p)
!============================================================================

! SPECIFIC ENTROPY OF SEAWATER
!
! SA                  : ABSOLUTE SALINITY                  [G/KG]
! T                   : TEMPERATURE                        [DEGC]
! P                   : SEA (GAUGE) PRESSURE               [DBAR]
! 
! RESULT              : SPECIFIC ENTROPY                   [J/(KG K)]

!CHECKVALUE: gsw_entropy(35.7d0, 25.5d0, 1023d0) = 352.818797715d0

implicit none
real*8 sa, t, p, gsw_entropy, gt

gsw_entropy = errorreturn

gt = gsw_g(0, 1, 0, sa, t, p)
if(gt == errorreturn) return

gsw_entropy = -gt


return
end function


!============================================================================
function gsw_kappa(sa, t, p)
!============================================================================

! ISENTROPIC COMPRESSIBILITY OF SEAWATER
!
! SA                  : ASOLUTE SALINITY                   [G/KG]
! T                   : TEMPERATURE                        [DEGC]
! P                   : SEA (GAUGE) PRESSURE               [DBAR]
! 
! RESULT              : ISENTROPIC COMPRESSIBILITY         [1/DBAR]

!CHECKVALUE: gsw_kappa(35.7d0, 25.5d0, 1023d0) = 4.03386268546d-6

implicit none
real*8 sa, t, p, gp, gpp, gtt, gtp, gsw_kappa

gsw_kappa = errorreturn

gtt = gsw_g(0, 2, 0, sa, t, p)
if(gtt == errorreturn .or. gtt >= 0) return
gtp = gsw_g(0, 1, 1, sa, t, p)
if(gtp == errorreturn) return
gpp = gsw_g(0, 0, 2, sa, t, p)
if(gpp == errorreturn) return
gp = gsw_g(0, 0, 1, sa, t, p)
if(gp == errorreturn .or. gp <= 0d0) return

gsw_kappa = 10000d0 * (gtp * gtp - gtt * gpp) / (gp * gtt)

return
end function


!============================================================================
function gsw_kappa_t(sa, t, p)
!============================================================================

! ISOTHERMAL COMPRESSIBILITY OF SEAWATER
!
! SA                  : ASOLUTE SALINITY                   [G/KG]
! T                   : TEMPERATURE                        [DEGC]
! P                   : SEA (GAUGE) PRESSURE               [DBAR]
! 
! RESULT              : ISOTHERMAL COMPRESSIBILITY         [1/DBAR]

!CHECKVALUE: gsw_kappa_t(35.7d0, 25.5d0, 1023d0) = 4.10403794615d-6

implicit none
real*8 sa, t, p, gsw_kappa_t, gpp, gp

gsw_kappa_t = errorreturn

gpp = gsw_g(0, 0, 2, sa, t, p)
if(gpp == errorreturn) return
gp = gsw_g(0, 0, 1, sa, t, p)
if(gp == errorreturn .or. gp <= 0d0) return

gsw_kappa_t = -10000d0 * gpp / gp

return
end function



!============================================================================
function gsw_specvol(sa, t, p)
!============================================================================

! SPECIFIC VOLUME OF SEAWATER
!
! SA                  : ASOLUTE SALINITY                   [G/KG]
! T                   : TEMPERATURE                        [DEGC]
! P                   : SEA (GAUGE) PRESSURE               [DBAR]
! 
! RESULT              : SPECIFIC VOLUME                    [M^3/KG]  !dbg invert units

!CHECKVALUE: gsw_specvol(35.7d0, 25.5d0, 1023d0) = 0.000972807602158d0

implicit none
real*8 sa, t, p, gsw_specvol

gsw_specvol = gsw_g(0,0,1,sa,t,p)

return
end function


!============================================================================
function gsw_svel(sa, t, p)
!============================================================================

! SOUND SPEED OF SEAWATER
!
! sa                  : ASOLUTE SALINITY                   [G/KG]
! T                   : TEMPERATURE                        [DEGC]
! P                   : SEA (GAUGE) PRESSURE               [DBAR]
! 
! RESULT              : SOUND SPEED                        [M/S]

!CHECKVALUE: gsw_svel(35.7d0, 25.5d0, 1023d0) = 1552.93372863d0

implicit none
real*8 sa, t, p, gp, gtt, gtp, gpp, gsw_svel

gsw_svel = errorreturn

gtt = gsw_g(0, 2, 0, sa, t, p)
if(gtt == errorreturn .or. gtt >= 0d0) return
gtp = gsw_g(0, 1, 1, sa, t, p)
if(gtp == errorreturn) return
gpp = gsw_g(0, 0, 2, sa, t, p)
if(gpp == errorreturn) return
gp = gsw_g(0, 0, 1, sa, t, p)
if(gp == errorreturn .or. gp <= 0d0) return
if(gtp * gtp >= gtt * gpp) return

gsw_svel = gp * sqrt(gtt/(gtp**2d0 - gtt*gpp))
                                      
return
end function


!============================================================================
function gsw_ctmp_from_ptmp0(sa, tpot)
!============================================================================

!CONSERVATIVE TEMPERATURE FROM POTENTIAL TEMPERATURE OF SEAWATER  
!BASED ON GSW_CT_FROM_PT0_SI BUT USES GSW_G
!
!SA         : ABSOLUTE SALINITY                        [G/KG]
!TPOT       : POTENTIAL TEMPERATURE WITH               [DEGC]
!             REFERENCE PRESSURE OF 101325 PA
!
!RESULT     : CONSERVATIVE TEMPERATURE                 [DEGC]

!CHECKVALUE: gsw_ctmp_from_ptmp0(35.7d0, 25.5d0) = 25.4805463842d0

implicit none
real*8 sa, tpot, gsw_ctmp_from_ptmp0
real*8 cp0, pr, ct

gsw_ctmp_from_ptmp0 = errorreturn

cp0 = 3991.86795711963d0     ! IN CONCRETE 02/12/08

pr = 0d0

ct = gsw_enthalpy(sa, tpot, pr)
if (ct == errorreturn) return

gsw_ctmp_from_ptmp0 = ct / cp0

end function


!============================================================================
function gsw_ptmp0_from_ctmp(sa, ct)
!============================================================================

! POTENTIAL TEMPERATURE OF SEAWATER FROM CONSERVATIVE TEMPERATURE
! THIS CODE IS CONSISTENT WITH SEA_PTMP0_FROM_CTMP_SI IN SEA_5A
! BUT USED GSW ROUTINES AND DIFFERENT UNITS
!
! SA                  : ASOLUTE SALINITY                   [G/KG]
! CT                  : CONSERVATIVE TEMPERATURE           [DEGC]
!
! RESULT              : POTENTIAL TEMPERATURE WITH         [DEGC]
!                       REFERENCE PRESSURE OF  0 DBAR

!CHECKVALUE: gsw_ptmp0_from_ctmp(35.7d0, 25.4805463842239) = 25.5d0

implicit none
real*8 SA, ct, gsw_ptmp0_from_ctmp
integer nloops, n
real*8 s1, ct1, p0, cp0 
real*8 a0, a1, a2, a3, a4, a5, b0, b1, b2, b3
real*8 a5ct, b3ct, ct_factor, th0_num, rec_th0_den
real*8 th0, ct0, dth_dct, theta, dct, dct_dth
real*8 gtt

gsw_ptmp0_from_ctmp = errorreturn

cp0 = 3991.86795711963d0    

s1 = SA*35.d0/35.16504d0; ct1 = ct; p0 = 0.d0

a0 = -1.446013646344788d-2;     b0 =  1.000000000000000d+0
a1 = -3.305308995852924d-3;     b1 =  6.506097115635800d-4
a2 =  1.062415929128982d-4;     b2 =  3.830289486850898d-3
a3 =  9.477566673794488d-1;     b3 =  1.247811760368034d-6
a4 =  2.166591947736613d-3
a5 =  3.828842955039902d-3

a5ct = a5*ct1; b3ct = b3*ct1
ct_factor = (a3+a4*s1+a5ct)
th0_num = a0+s1*(a1+a2*s1)+ct1*ct_factor
rec_th0_den = 1.d0/(b0+b1*s1+ct1*(b2+b3ct))
th0 = th0_num*rec_th0_den 
ct0 = gsw_ctmp_from_ptmp0(sa,th0)
if(ct0 == errorreturn) return
dth_dct = (ct_factor+a5ct-(b2+b3ct+b3ct)*th0)*rec_th0_den 
theta = th0-(ct0-ct)*dth_dct

nloops = 1                  ! default

!    NOTE: nloops = 1 gives theta with a maximum error of & 

n = 0; 

do while(n.le.nloops)
    dct = gsw_ctmp_from_ptmp0(sa,theta)
    if(dct == errorreturn) return
    dct = dct - ct
    gtt = gsw_g(0, 2, 0, sa, theta, p0)
    if(gtt == errorreturn .or. gtt >= 0d0) return
    dct_dth = -(theta+273.15d0)*gtt / cp0
    if(dct_dth == 0d0) return
    theta = theta - dct/dct_dth
    n = n+1
end do

gsw_ptmp0_from_ctmp = theta

end function


!============================================================================
function gsw_ptmp(sa, t, p, pr)
!============================================================================
                               
!THIS FUNCTION COMPUTES POTENTIAL TEMPERATURE OF SEAWATER
!BASED ON SEA_POTTEMP_SI BUT USES GSW_G

!OUTPUT:
!THETA(S,T,P,PR) POTENTIAL TEMPERATURE OF SEAWATER IN DEGC

!INPUT:
!SA     ABSOLUTE SALINITY IN G/KG
!T      ABSOLUTE IN-SITU TEMPERATURE IN DEGC
!P      SEA PRESSURE IN DBAR
!PR     REFERENCE SEA PRESSURE IN DBAR

!CHECKVALUE: gsw_ptmp(35.7d0, 25.2720983155409d0, 0d0, 1023d0) = 25.5
!CHECKVALUE: gsw_ptmp(35.7d0, 25.5d0, 1023d0, 0d0) = 25.2720983155d0

implicit none
integer maxit
real*8 gsw_ptmp, sa, t, p, pr
real*8 sp, s, eps, theta

gsw_ptmp = errorreturn

if(p == pr) then
  gsw_ptmp = t
  return
end if

s = gsw_entropy(sa, t, p)  !SPECIFIC ENTROPY IN-SITU

!use David's initial estimate for theta
sp = sa * 35d0 / 35.16504d0
theta = t+(p-pr)*( 8.65483913395442d-6  - &
            sp  *  1.41636299744881d-6  - &
         (p+pr) *  7.38286467135737d-9  + &
             t  *(-8.38241357039698d-6  + &
            sp  *  2.83933368585534d-8  + &
             t  *  1.77803965218656d-8  + &
         (p+pr) *  1.71155619208233d-10))

maxit = 100
eps = 1d-12

!RUN THE ITERATION
gsw_ptmp = gsw_pottemp_iteration(sa, s, pr, theta, maxit, eps)

end function


!============================================================================
function gsw_pden(sa, t, p, pr)
!============================================================================

! POTENTIAL DENSITY OF SEAWATER
!
! SA                  : ASOLUTE SALINITY                   [G/KG]
! T                   : TEMPERATURE                        [DEGC]
! P                   : SEA (GAUGE) PRESSURE               [DBAR]
! PR                  : REFERENCE (GAUGE) PRESSURE         [DBAR]
! 
! RESULT              : POTENTIAL DENSITY                  [KG/M^3]

!CHECKVALUE: gsw_pden(35.7d0, 25.5d0, 1023d0, 0d0) = 1023.66254941d0

implicit none
real*8 sa, t, p, pr, gsw_pden, theta

gsw_pden = errorreturn

theta = gsw_ptmp(sa,t,p,pr);
if(theta == errorreturn) return

gsw_pden = gsw_dens(sa,theta,pr);

return
end function


!===========================================================================
function gsw_pottemp_iteration(sa, eta, p, theta, maxit, eps)
!============================================================================

!BASED ON POTTEMP_ITERATION FROM SEA_3B

!OUTPUT:
!THETA =   POTENTIAL TEMPERATURE OF SEAWATER IN DEGC
!          I.E. THE TEMPERATURE THAT SOLVES ETA_SI = GSW_ENTROPY_SI(SA, T, P)

!INPUT:
!SA     ABSOLUTE SALINITY IN G/KG
!ETA    ENTROPY IN J/(KG K)
!P      (REFERENCE) SEA PRESSURE IN DBAR
!T      (POTENTIAL) SEA TEMPERATURE IN DEGC, INITIAL VALUE
!MAXIT  MAX. NUMBER OF ITERATIONS
!EPS    REQUIRED TOLERANCE IN K

implicit none
integer i, maxit
real*8 gsw_pottemp_iteration, sa, eta, p, eps
real*8 s, theta, cp, dt

gsw_pottemp_iteration = errorreturn

if(eps <= 0d0) return
if(maxit <= 0d0) return

do i = 1, maxit

  !get entropy and its first derivative for newton iteration
  s = gsw_entropy(sa, theta, p)
  if(s == errorreturn) return
  cp = gsw_cp(sa, theta, p)
  if(cp == errorreturn .or. cp == 0d0) return
  
  !next temperature improvement step
  dt = (273.15d0 + theta) * (eta - s) / cp
  theta = theta + dt
  if(theta <= -273.15d0) return
  
  if(abs(dt) < eps) then
    gsw_pottemp_iteration = theta
    return
  end if
  
enddo

end function


!==========================================================================
function gsw_alpha_ct(sa, t, p)
!==========================================================================

! THERMAL EXPANSION COEFFICIENT OF SEAWATER WRT CONSERVATIVE TEMPERATURE

! SA_GKG                : ABSOLUTE SALINITY                  [G/KG]
! T_C                   : IN SITU TEMPERATURE                [DEG C]
! P_DBAR                : SEA PRESSURE                       [DBAR]
!
! GSW_ALPHA_CT        : THERMAL EXPANSION COEFFICIENT      [1/DEG C]
!                         WRT CONSERVATIVE TEMPERATURE

!CHECK VALUE WITH DEFAULT SETTINGS:
!GSW_ALPHA_CT(35, 20, 1000) = 2.69418609861E-04

implicit none
real*8 sa, t, p, gsw_alpha_ct
real*8 sa_si, p_si, t_si

!CONVERT PRACTICAL INPUT UNITS TO BASIC SI UNITS
sa_si = sa * 0.001d0
p_si = SO_pressure_si + p * 10000d0
t_si = SO_temperature_si + t

!AND CALL THE SI VERSION
gsw_alpha_ct = sea_alpha_ct_si(sa_si, t_si, p_si)

end function


!==========================================================================
function gsw_alpha_pt0(sa,t,p)
!==========================================================================

!THERMAL EXPANSION COEFFICIENT OF SEAWATER WRT POTENTIAL TEMPERATURE

!SA_GKG                 : ABSOLUTE SALINITY                  [G/KG]
!T_C                    : IN SITU TEMPERATURE                [DEG C]
!P_DBAR                 : SEA PRESSURE                       [DBAR]
!
!GSW_ALPHA_PT0_SI       : THERMAL EXPANSION COEFFICIENT      [1/DEG C]
!                         WRT POTENTIAL TEMPERATURE

!CHECK VALUE WITH DEFAULT SETTINGS:
!GSW_ALPHA_PT0(35, 20, 1000) = 2.6975373331|7E-04

implicit none
real*8 gsw_alpha_pt0, sa, t, p
real*8 sa_si, t_si, p_si

!CONVERT PRACTICAL INPUT UNITS TO BASIC SI UNITS
sa_si = sa * 0.001d0
p_si = SO_pressure_si + p * 10000d0
t_si = SO_temperature_si + t

!and call the SI version
gsw_alpha_pt0 = sea_alpha_pt0_si(sa_si, t_si, p_si)

end function


!==========================================================================
function gsw_beta_ct(sa, t, p)
!==========================================================================

! HALINE CONTRACTION COEFFICIENT OF SEAWATER WRT CONSTANT CONSERVATIVE TEMPERATURE

! SA_GKG                 : ABSOLUTE SALINITY                  [G/KG]
! T_C                    : IN SITU TEMPERATURE                [DEG C]
! P_DBAR                 : SEA PRESSURE                       [DBAR]

! RESULT                 : HALINE CONTRACTION COEFFICIENT     [KG/G]
!                          WRT CONSTANT CONSERVATIVE TEMPERATURE

!CHECK VALUE WITH DEFAULT SETTINGS:
!GSW_BETA_CT(35, 20, 1000) = 7.23213672954E-04

real*8 gsw_beta_ct, sa, t, p
real*8 sa_si, p_si, t_si, bt

gsw_beta_ct = ErrorReturn

!CONVERT PRACTICAL INPUT UNITS TO BASIC SI UNITS
sa_si = sa * 0.001d0
p_si = SO_pressure_si + p * 10000d0
t_si = SO_temperature_si + t

!CALL THE SI VERSION
bt = sea_beta_ct_si(sa_si, t_si, p_si)
if (bt == errorreturn) return 

!AND CONVERT THE RESULT TO KG/G, THE UNIT OF 1/SA_GKG
gsw_beta_ct = bt * 0.001d0 !1 KG/KG = 0.001 KG/G

end function


!==========================================================================
function gsw_beta_pt0(sa, t, p)
!==========================================================================

! HALINE CONTRACTION COEFFICIENT OF SEAWATER WRT CONSTANT POTENTIAL TEMPERATURE

! SA_GKG                 : ABSOLUTE SALINITY                  [G/KG]
! T_C                    : IN SITU TEMPERATURE                [\260C]
! P_DBAR                 : SEA PRESSURE                       [DBAR]

! RESULT                 : HALINE CONTRACTION COEFFICIENT     [KG/G]
!                          WRT CONSTANT POTENTIAL TEMPERATURE

!CHECK VALUE WITH DEFAULT SETTINGS:
!GSW_BETA_PT0(35, 20, 1000) = 7.31582583383E-04

real*8 gsw_beta_pt0, sa, t, p
real*8 sa_si, p_si, t_si, bt

gsw_beta_pt0 = ErrorReturn

!CONVERT PRACTICAL INPUT UNITS TO BASIC SI UNITS
sa_si = sa * 0.001d0
p_si = SO_pressure_si + p * 10000d0
t_si = SO_temperature_si + t

!CALL THE SI VERSION
bt = sea_beta_pt0_si(sa_si, t_si, p_si)
if (bt == errorreturn) return

!AND CONVERT THE RESULT TO KG/G, THE UNIT OF 1/SA_GKG
gsw_beta_pt0 = bt * 0.001d0 !1 KG/KG = 0.001 KG/G

end function







!==========================================================================
function gsw_cabb_ct(sa,t,p)
!==========================================================================

!CABBELING COEFFICIENT OF SEAWATER WRT CONSERVATIVE TEMPERATURE 

!SA                  : ABSOLUTE SALINITY                  [G/KG]
!T                   : IN SITU TEMPERATURE                [DEGC]
!P                   : SEA (GAUGE) PRESSURE               [DBAR]
!
!RESULT              : CABBELING COEFFICIENT              [1/(DEGC**2)] 
!                      WRT CONSERVATIVE TEMPERATURE

!check value:
!gsw_cabb_ct(35, 20, 1d3) = 0.8969073|83083E-05  

implicit none
real*8 sa, t, p, sa_si, t_si, p_si, gsw_cabb_ct

sa_si = 1d-3 * sa
t_si = t + 273.15d0
p_si = 101325d0 + 1d4 * p

gsw_cabb_ct = sea_cabb_ct_si(sa_si, t_si, p_si)

end function


!==========================================================================
function gsw_cabb_pt0(sa,t,p)
!==========================================================================

!CABBELING COEFFICIENT OF SEAWATER WRT POTENTIAL TEMPERATURE 

!SA                  : ABSOLUTE SALINITY                  [G/KG]
!T                   : IN SITU TEMPERATURE                [DEGC]
!P                   : SEA (GAUGE) PRESSURE               [DBAR]
!
!RESULT              : CABBELING COEFFICIENT              [1/(DEGC**2)] 
!                      WRT POTENTIAL TEMPERATURE

!check value:
!gsw_cabb_pt0(35, 20, 1d3) = 0.8759631|54048E-05  

implicit none
real*8 sa, t, p, sa_si, t_si, p_si, gsw_cabb_pt0

sa_si = 1d-3 * sa
t_si = t + 273.15d0
p_si = 101325d0 + 1d4 * p

gsw_cabb_pt0 = sea_cabb_pt0_si(sa_si, t_si, p_si)

end function


!==========================================================================
function gsw_thrmb_ct(sa,t,p)
!==========================================================================

!THERMOBARIC COEFFICIENT OF SEAWATER WRT CONSERVATIVE TEMPERATURE 
!
!SA                  : ABSOLUTE SALINITY                  [G/KG]
!T                   : IN SITU TEMPERATURE                [DEGC]
!P                   : SEA (GAUGE) PRESSURE               [DBAR]
!
!RESULT              : THERMOBARIC COEFFICIENT            [1/(DEGC DBAR)]
!                      WRT CONSERVATIVE TEMPERATURE

!check value:
!gsw_thrmb_ct(35, 20, 1d3) = 0.1727083|65652E-07  

implicit none
real*8 sa, t, p, sa_si, t_si, p_si, gsw_thrmb_ct

sa_si = 1d-3 * sa
t_si = t + 273.15d0
p_si = 101325d0 + 1d4 * p

gsw_thrmb_ct = 1d4 * sea_thrmb_ct_si(sa_si, t_si, p_si)

end function

!==========================================================================
function gsw_thrmb_pt0(sa,t,p)
!==========================================================================

!THERMOBARIC COEFFICIENT OF SEAWATER WRT POTENTIAL TEMPERATURE 
!
!SA                  : ABSOLUTE SALINITY                  [G/KG]
!T                   : IN SITU TEMPERATURE                [DEGC]
!P                   : SEA (GAUGE) PRESSURE               [DBAR]
!
!RESULT              : THERMOBARIC COEFFICIENT            [1/(DEGC DBAR)]
!                      WRT POTENTIAL TEMPERATURE

!check value:
!gsw_thrmb_pt0(35, 20, 1d3) = 0.1709450|45984E-07  

implicit none
real*8 sa, t, p, sa_si, t_si, p_si, gsw_thrmb_pt0

sa_si = 1d-3 * sa
t_si = t + 273.15d0
p_si = 101325d0 + 1d4 * p

gsw_thrmb_pt0 = 1d4 * sea_thrmb_pt0_si(sa_si, t_si, p_si)

end function

!=====================================================
function gsw_asal_from_psal(sp,lon0,lat0,p0)
!=====================================================

! CONVERT PRACTICAL SALINITY TO ABSOLUTE SALINITY 
!
! SP                  : PRACTICAL SALINITY                 [PSU, PSS]
! P0                  : SEA PRESSURE                       [DBAR]
! LONGS0              : LONGITUDE                          [DEG E]     
! LATS0               : LATITUDE                           [DEG N]
!
! RESULT              : ABSOLUTE SALINITY                  [G/KG]

!CHECK VALUE:
!GSW_ASAL_FROM_PSAL(35.527515065427778, 201, -21, 1023) = 35.7
!GSW_ASAL_FROM_PSAL(35, 180, 40, 2d3) = 35.1890932889958041
!GSW_ASAL_FROM_PSAL(8, 20, 57, 0) = 8.10483771428571406

implicit none
real*8 sp, lon0, lat0, p_si, p0, gsw_asal_from_psal

p_si = 101325d0 + 1d4 * p0
gsw_asal_from_psal = sa_from_sp(sp, lon0, lat0, p_si)

return
end function

!=====================================================
function gsw_psal_from_asal(sa,lon0,lat0,p0)
!=====================================================

! CONVERT ABSOLUTE SALINITY TO PRACTICAL SALINITY 
!
! SA                  : ABSOLUTE SALINITY                  [G/KG]
! P0                  : SEA PRESSURE                       [DBAR]
! LONGS0              : LONGITUDE                          [DEG E]     
! LATS0               : LATITUDE                           [DEG N]
!
! GSW_PSAL_FROM_ASAL  : PRACTICAL SALINITY                 [PSU, PSS]

!CHECK VALUE
!GSW_PSAL_FROM_ASAL(35.7, 201, -21, 1023) = 35.527515065427778


implicit none
real*8 sa_si, sa, lon0, lat0, p_si, p0, gsw_psal_from_asal

p_si = 101325d0 + 1d4 * p0
sa_si = 1d-3 * sa
gsw_psal_from_asal = sp_from_sa(sa_si, lon0, lat0, p_si)

return
end function


end module gsw_library_5

module air_5

!#########################################################################

!THIS MODULE IMPLEMENTS PROPERTIES OF HUMID AIR THAT ARE EXPRESSED IN
!NON-BASIC SI UNITS OR REQUIRE ADDITIONAL EMPIRICAL CONSTANTS.

!#########################################################################

!IMPLEMENTATION IN FORTRAN BY D.G. WRIGHT
!FOR PUBLICATION IN OCEAN SCIENCE, AS DESCRIBED IN THE PAPERS

!FEISTEL, R., WRIGHT, D.G., JACKETT, D.R., MIYAGAWA, K., REISSMANN, J.H.,
!WAGNER, W., OVERHOFF, U., GUDER, C., FEISTEL, A., MARION, G.M.:
!NUMERICAL IMPLEMENTATION AND OCEANOGRAPHIC APPLICATION OF THE THERMODYNAMIC
!POTENTIALS OF WATER, VAPOUR, ICE, SEAWATER AND AIR. PART I: BACKGROUND AND EQUATIONS. 
!OCEAN SCIENCES, 2009, IN PREPARATION.

!WRIGHT, D.G., FEISTEL, R., JACKETT, D.R., MIYAGAWA, K., REISSMANN, J.H., 
!WAGNER, W., OVERHOFF, U., GUDER, C., FEISTEL, A., MARION, G.M.:
!NUMERICAL IMPLEMENTATION AND OCEANOGRAPHIC APPLICATION OF THE THERMODYNAMIC
!POTENTIALS OF WATER, VAPOUR, ICE, SEAWATER AND AIR. PART II: THE LIBRARY ROUTINES, 
!OCEAN SCIENCES., 2009, IN PREPARATION.

!FEISTEL, R., KRETZSCHMAR, H.-J., SPAN, R., HAGEN, E., !WRIGHT, D.G., JACKETT, D.R.:
!THERMODYNAMIC PROPERTIES OF SEA AIR.
!OCEAN SCIENCE DISCUSSION 6(2009)2193-2325.

!#########################################################################

!THIS MODULE REQUIRES THE LIBRARY MODULES:
!     CONSTANTS_0  FROM FILE CONSTANTS_0.F90 
!     AIR_3B       FROM FILE AIR_3B.F90 
!     LIQ_AIR_4A   FROM FILE LIQ_AIR_4A.F90

!NESTED USE ASSOCIATIONS
!     CONVERT_0    FROM FILE CONVERT_0.F90 
!     MATHS_0      FROM FILE MATHS_0.F90 
!     AIR_1        FROM FILE AIR_1.F90 
!     FLU_1        FROM FILE FLU_1.F90 
!     AIR_2        FROM FILE AIR_2.F90 
!     FLU_2        FROM FILE FLU_2.F90 
!     AIR_3A       FROM FILE AIR_3A.F90 
!     FLU_3A       FROM FILE FLU_3A.F90 
!     LIQ_VAP_4    FROM FILE LIQ_VAP_4.F90 

!#########################################################################

use constants_0
use air_3b
use liq_air_4a

implicit none
private

character*16, private :: version = '8 Jun 2010'

public :: air_lapserate_moist_c100m

contains

!==========================================================================
function air_lapserate_moist_c100m(rh_percent, t_c, p_hPa)
!==========================================================================

!THIS FUNCTION RETURNS THE ADIABATIC LAPSE RATE OF HUMID AIR IN DEG C PER 100 M ALTITUDE

!INPUT PARAMETERS
!RH_PERCENT:  RELATIVE HUMIDITY WMO DEFINITION IN % BETWEEN 0 AND 100
!T_C:         TEMPERATURE IN DEG C
!P_HPa:       PRESSURE IN HECTOPASCALIS (MILLIBARS)  !dbg

!CHECK VALUE, V1.0:
!AIR_LAPSERATE_MOIST_C100M(50, 20, 1000) = 0.971359680720

!CHECK VALUE, V1.1:
!AIR_LAPSERATE_MOIST_C100M(50, 20, 1000) = 0.971588085046

real*8 air_lapserate_moist_c100m, rh_percent, t_c, p_hPa
real*8 g, h, lr, d, a_si, t_si, p_si

g = 9.81d0  !m/s2   gravity
h = 100d0   !m      altitude difference

air_lapserate_moist_c100m = errorreturn

!convert to basic SI units:
t_si = 273.15d0 + t_c
p_si = p_hPa * 100d0

!compute dry-air fraction from RH
a_si = liq_air_a_from_rh_wmo_si(rh_percent * 0.01d0, t_si, p_si)
if (a_si == errorreturn) return

!compute lapse rate wrt pressure
lr = air_g_lapserate_si(a_si, t_si, p_si)
if (lr == errorreturn) return

!compute humid air density
d = air_g_density_si(a_si, t_si, p_si)
if (d == errorreturn) return

!get the lapse rate wrt 100 m sinking
air_lapserate_moist_c100m = lr * d * g * h

end function

end module air_5

Module Sea_3c

!#########################################################################

!THIS MODULE IMPLEMENTS THE ENTROPY OF SEAWATER DEPENDING ON SALINITY, 
!ENTHALPY AND PRESSURE.

!#########################################################################

!IMPLEMENTATION IN FORTRAN BY D.G. WRIGHT
!FOR PUBLICATION IN OCEAN SCIENCE, AS DESCRIBED IN THE PAPERS

!FEISTEL, R., WRIGHT, D.G., JACKETT, D.R., MIYAGAWA, K., REISSMANN, J.H.,
!WAGNER, W., OVERHOFF, U., GUDER, C., FEISTEL, A., MARION, G.M.:
!NUMERICAL IMPLEMENTATION AND OCEANOGRAPHIC APPLICATION OF THE THERMODYNAMIC
!POTENTIALS OF WATER, VAPOUR, ICE, SEAWATER AND AIR. PART I: BACKGROUND AND EQUATIONS. 
!OCEAN SCIENCES, 2009, IN PREPARATION.

!WRIGHT, D.G., FEISTEL, R., JACKETT, D.R., MIYAGAWA, K., REISSMANN, J.H., 
!WAGNER, W., OVERHOFF, U., GUDER, C., FEISTEL, A., MARION, G.M.:
!NUMERICAL IMPLEMENTATION AND OCEANOGRAPHIC APPLICATION OF THE THERMODYNAMIC
!POTENTIALS OF WATER, VAPOUR, ICE, SEAWATER AND AIR. PART II: THE LIBRARY ROUTINES, 
!OCEAN SCIENCES., 2009, IN PREPARATION.

!FEISTEL, R., KRETZSCHMAR, H.-J., SPAN, R., HAGEN, E., WRIGHT, D.G., JACKETT, D.R.:
!THERMODYNAMIC PROPERTIES OF SEA AIR.
!OCEAN SCIENCE DISCUSSION 6(2009)2193-2325.

!#########################################################################

!THIS MODULE REQUIRES THE LIBRARY MODULES:
!     CONSTANTS_0, FILE CONSTANTS_0.F90
!     SEA_3A,      FILE SEA_3A.F90
!     SEA_3B,      FILE SEA_3B.F90

!NESTED USE ASSOCIATIONS
!     CONVERT_0,   FILE CONVERT_0.F90
!     MATHS_0,     FILE MATHS_0.F90
!     FLU_1,       FILE FLU_1.F90
!     SAL_1,       FILE SAL_1.F90
!     SAL_2,       FILE SAL_2.F90
!     FLU_3A,      FILE FLU_3A.F90

!#########################################################################

use constants_0
use sea_3a
use sea_3b

implicit none
private

character*16, private :: version = '8 Jun 2010'

public :: sea_eta_contraction_h_si, sea_eta_contraction_t_si, &
          sea_eta_contraction_theta_si, sea_eta_density_si, &
          sea_eta_entropy_si, sea_eta_expansion_h_si, &
          sea_eta_expansion_t_si, sea_eta_expansion_theta_si, &
          sea_eta_potdensity_si, sea_eta_pottemp_si, &
          sea_eta_temperature_si, set_it_ctrl_entropy

!Control parameters of the entropy iteration
Integer ctrl_initialized
Integer ctrl_mode_entropy
Integer ctrl_loop_maximum
real*8 ctrl_init_entropy
real*8 ctrl_eps_exit_entropy

contains

!==========================================================================
function sea_eta_entropy_si(sa_si, h_si, p_si)
!==========================================================================

!THIS FUNCTION COMPUTES SPECIFIC ENTROPY OF SEAWATER FROM ENTHALPY
!(THE THERMODYNAMIC POTENTIAL IN TERMS OF SALINITY, ENTHALPY AND PRESSURE IS ENTROPY)

!RETURNS   ENTROPY OF SEAWATER IN J/(KG K),

!EITHER FROM
!SA_SI     ABSOLUTE SALINITY IN KG/KG
!H_SI      IN-SITU ENTHALPY IN J/KG,
!P_SI      ABSOLUTE IN-SITU PRESSURE IN PA

!OR FROM
!SA_SI     ABSOLUTE SALINITY IN KG/KG
!H_SI      POTENTIAL ENTHALPY IN J/KG,
!P_SI      ABSOLUTE REFERENCE PRESSURE IN PA

!CHECK VALUE WITH DEFAULT SETTINGS: 
!SEA_ETA_ENTROPY_SI(0.035, 1E5, 1E5) = 350.310622663

!NOTE: THE ACCURACY OF THIS FUNCTION DEPENDS ON THE ITERATION SETTINGS FOR
!      ENTROPY COMPUTED IN SEA_3B AND ON THOSE MADE IN THIS MODULE

implicit none

Integer maxit
real*8 sea_eta_entropy_si, sa_si, h_si, p_si
real*8 eta, eps

sea_eta_entropy_si = errorreturn

if(sa_si < 0d0 .or. sa_si >= 1d0) return
if(p_si <= 0d0) return

sea_eta_entropy_si = errorreturn

call init_it_ctrl_entropy

select case (ctrl_mode_entropy)
  case (0);    eta = h_si / 273.15d0
  case Default; eta = ctrl_init_entropy
end select

if(ctrl_loop_maximum == 0)then
  maxit = 100
elseif(ctrl_loop_maximum == (-1))then
  sea_eta_entropy_si = eta
  return
elseif(ctrl_loop_maximum > 0)then
  maxit = ctrl_loop_maximum
else
  return
endif

eps = ctrl_eps_exit_entropy
if(eps <= 0d0) return

sea_eta_entropy_si = entropy_iteration(sa_si, h_si, p_si, eta, maxit, eps)

end function

!=========================================================================
function sea_eta_temperature_si(sa_si, h_si, p_si, pref_si, key)
!=========================================================================

!THIS FUNCTION COMPUTES IN-SITU TEMPERATURE OF SEAWATER FROM EITHER IN-SITU ENTHALPY OR POTENTIAL ENTHALPY

!RETURNS   TEMPERATURE OF SEAWATER IN K

!EITHER FROM
!SA_SI     ABSOLUTE SALINITY IN KG/KG
!H_SI      IN-SITU ENTHALPY IN J/KG
!P_SI      ABSOLUTE IN-SITU PRESSURE IN PA
!PREF_SI   NOT REQUIRED
!KEY       "H"

!OR FROM
!SA_SI     ABSOLUTE SALINITY IN KG/KG
!H_SI      POTENTIAL ENTHALPY IN J/KG
!P_SI      ABSOLUTE IN-SITU PRESSURE IN PA
!PREF_SI   ABSOLUTE REFERENCE PRESSURE IN PA
!KEY       "HPOT"

!CHECK VALUES WITH DEFAULT SETTINGS:
!SEA_ETA_TEMPERATURE_SI(0.035,1E5,1E7,1E5,"h") = 295.985682129
!SEA_ETA_TEMPERATURE_SI(0.035,1E5,1E7,1E5,"hpot") = 298.413424848

!NOTE: THE ACCURACY OF THIS FUNCTION DEPENDS ON THE ITERATION SETTINGS FOR
!      ENTROPY COMPUTED IN SEA_3B AND ON THOSE MADE IN THIS MODULE

implicit none
character*13 key
real*8 sea_eta_temperature_si, sa_si, h_si, p_si, pref_si 
real*8 eta

sea_eta_temperature_si = errorreturn

if (sa_si < 0d0 .or. sa_si >= 1d0) return
if (p_si <= 0d0) return
if (pref_si <= 0d0) return
if (key /= "h" .and. key /= "hpot") return
if (key == "hpot" .and. pref_si <= 0d0) return

if (key == "hpot") then
  eta = sea_eta_entropy_si(sa_si, h_si, pref_si)  !ENTROPY FROM POT. ENTHALPY
else
  eta = sea_eta_entropy_si(sa_si, h_si, p_si)     !ENTROPY FROM IN-SITU ENTHALPY
end if
if (eta == errorreturn) return

sea_eta_temperature_si = sea_h_si(0, 1, 0, sa_si, eta, p_si)

end function

!=========================================================================
function sea_eta_pottemp_si(sa_si, h_si, p_si, pref_si, key)
!=========================================================================

!THIS FUNCTION COMPUTES  POTENTIAL TEMPERATURE OF SEAWATER FROM EITHER IN-SITU ENTHALPY OR POTENTIAL ENTHALPY

!RETURNS   ABSOLUTE POTENTIAL TEMPERATURE OF SEAWATER IN K,

!EITHER FROM
!SA_SI     ABSOLUTE SALINITY IN KG/KG
!H_SI      IN-SITU ENTHALPY IN J/KG
!P_SI      ABSOLUTE IN-SITU PRESSURE IN PA
!PREF_SI   ABSOLUTE REFERENCE PRESSURE IN PA
!KEY       "H"

!OR FROM
!SA_SI     ABSOLUTE SALINITY IN KG/KG
!H_SI      POTENTIAL ENTHALPY IN J/KG
!P_SI      NOT REQUIRED
!PREF_SI   ABSOLUTE REFERENCE PRESSURE IN PA
!KEY       "HPOT"

!CHECK VALUES WITH DEFAULT SETTINGS:
!SEA_ETA_POTTEMP_SI(0.035,1E5,1E7,1E5,"h") = 295.782199115
!SEA_ETA_POTTEMP_SI(0.035,1E5,1E7,1E5,"hpot") = 298.194955182

!NOTE: THE ACCURACY OF THIS FUNCTION DEPENDS ON THE ITERATION SETTINGS FOR
!      ENTROPY COMPUTED IN SEA_3B AND ON THOSE MADE IN THIS MODULE

implicit none
character*13 key
real*8 sea_eta_pottemp_si, sa_si, h_si, p_si, pref_si
real*8 eta

sea_eta_pottemp_si = errorreturn

if (sa_si < 0d0 .or. sa_si >= 1d0) return
if (p_si <= 0d0) return
if (pref_si <= 0d0) return
if (key /= "h" .and. key /= "hpot") return
if (key == "hpot" .and. pref_si <= 0d0) return

if (key == "hpot") then
  eta = sea_eta_entropy_si(sa_si, h_si, pref_si)  !ENTROPY FROM POT. ENTHALPY
else
  eta = sea_eta_entropy_si(sa_si, h_si, p_si)     !ENTROPY FROM IN-SITU ENTHALPY
end if
if (eta == errorreturn) return

sea_eta_pottemp_si = sea_h_si(0, 1, 0, sa_si, eta, pref_si)

end function

!=========================================================================
function sea_eta_density_si(sa_si, h_si, p_si, pref_si, key)
!=========================================================================

!THIS FUNCTION COMPUTES IN-SITU DENSITY OF SEAWATER FROM EITHER IN-SITU ENTHALPY OR POTENTIAL ENTHALPY

!RETURNS   DENSITY OF SEAWATER IN KG/M3

!EITHER FROM
!SA_SI     ABSOLUTE SALINITY IN KG/KG
!H_SI      IN-SITU ENTHALPY IN J/KG
!P_SI      ABSOLUTE IN-SITU PRESSURE IN PA
!PREF_SI   NOT REQUIRED
!KEY       "H"

!OR FROM
!SA_SI     ABSOLUTE SALINITY IN KG/KG
!H_SI      POTENTIAL ENTHALPY IN J/KG,
!P_SI      ABSOLUTE IN-SITU PRESSURE IN PA
!PREF_SI   ABSOLUTE REFERENCE PRESSURE IN PA
!KEY       "HPOT"

!NOTE: THE ACCURACY OF THIS FUNCTION DEPENDS ON THE ITERATION SETTINGS FOR
!      ENTROPY COMPUTED IN SEA_3B AND ON THOSE MADE IN THIS MODULE

!CHECK VALUES WITH DEFAULT SETTINGS:
!SEA_ETA_DENSITY_SI(0.035,1E5,1E7,1E5,"h") = 1028.10986556
!SEA_ETA_DENSITY_SI(0.035,1E5,1E7,1E5,"hpot") = 1027.36529798

implicit none
character*13 key
real*8 sea_eta_density_si, sa_si, h_si, p_si, pref_si
real*8 eta, v

sea_eta_density_si = errorreturn

if (sa_si < 0d0 .or. sa_si >= 1d0) return
if (p_si <= 0d0) return
if (pref_si <= 0d0) return
if (key /= "h" .and. key /= "hpot") return
if (key == "hpot" .and. pref_si <= 0d0) return

if (key == "hpot") then
  eta = sea_eta_entropy_si(sa_si, h_si, pref_si)  !ENTROPY FROM POT. ENTHALPY
else
  eta = sea_eta_entropy_si(sa_si, h_si, p_si)     !ENTROPY FROM IN-SITU ENTHALPY
end if
if (eta == errorreturn) return

v = sea_h_si(0, 0, 1, sa_si, eta, p_si)      !SPECIFIC VOLUME
if (v == errorreturn .or. v <= 0d0) return

sea_eta_density_si = 1d0 / v

end function

!=========================================================================
function sea_eta_potdensity_si(sa_si, h_si, p_si, pref_si, key)
!=========================================================================

!THIS FUNCTION COMPUTES POTENTIAL DENSITY OF SEAWATER FROM EITHER IN-SITU ENTHALPY OR POTENTIAL ENTHALPY

!RETURNS   POTENTIAL DENSITY OF SEAWATER IN KG/M3

!EITHER FROM
!SA_SI     ABSOLUTE SALINITY IN KG/KG
!H_SI      IN-SITU ENTHALPY IN J/KG,
!P_SI      ABSOLUTE IN-SITU PRESSURE IN PA
!PREF_SI   ABSOLUTE REFERENCE PRESSURE IN PA
!KEY       "H"


!OR FROM
!SA_SI     ABSOLUTE SALINITY IN KG/KG
!H_SI      POTENTIAL ENTHALPY IN J/KG,
!P_SI      NOT REQUIRED
!PREF_SI   ABSOLUTE REFERENCE PRESSURE IN PA
!KEY       "HPOT"

!NOTE: THE ACCURACY OF THIS FUNCTION DEPENDS ON THE ITERATION SETTINGS FOR
!      ENTROPY COMPUTED IN SEA_3B AND ON THOSE MADE IN THIS MODULE

!CHECK VALUES WITH DEFAULT SETTINGS:
!SEA_ETA_POTDENSITY_SI(0.035,1E5,1E7,1E5,"h") = 1023.91737474
!SEA_ETA_POTDENSITY_SI(0.035,1E5,1E7,1E5,"hpot") = 1023.20527737

implicit none
character*13 key
real*8 sea_eta_potdensity_si, sa_si, h_si, p_si, pref_si
real*8 eta, v

sea_eta_potdensity_si = errorreturn

if (sa_si < 0d0 .or. sa_si >= 1d0) return
if (p_si <= 0d0) return
if (pref_si <= 0d0) return

if (key == "hpot") then
  eta = sea_eta_entropy_si(sa_si, h_si, pref_si)  !ENTROPY FROM POT. ENTHALPY
else
  eta = sea_eta_entropy_si(sa_si, h_si, p_si)     !ENTROPY FROM IN-SITU ENTHALPY
end if
if (eta == errorreturn) return

v = sea_h_si(0, 0, 1, sa_si, eta, pref_si)      !POT. SPECIFIC VOLUME
if (v == errorreturn .or. v <= 0d0) return

sea_eta_potdensity_si = 1d0 / v

end function

!=========================================================================
function sea_eta_contraction_t_si(sa_si, x_si, p_si, pref_si, key)
!=========================================================================

!THIS FUNCTION COMPUTES THE HALINE CONTRACTION COEFFICIENT OF SEAWATER AT CONSTANT TEMPERATURE
!FROM EITHER IN-SITU ENTHALPY (KEY="H") OR POTENTIAL ENTHALPY (KEY = "HPOT")
!OR FROM IN-SITU TEMPERATURE (KEY="T") OR POTENTIAL TEMPERATURE (KEY = "TPOT")

!RETURNS   HALINE CONTRACTION -(1/V)*(DV/DS)_T_P OF SEAWATER IN KG/KG

!EITHER FROM
!SA_SI     ABSOLUTE SALINITY IN KG/KG
!X_SI      IN-SITU ENTHALPY IN J/KG,
!P_SI      ABSOLUTE IN-SITU PRESSURE IN PA
!PREF_SI   NOT REQUIRED
!KEY       "H"

!OR FROM
!SA_SI     ABSOLUTE SALINITY IN KG/KG
!X_SI      POTENTIAL ENTHALPY IN J/KG
!P_SI      ABSOLUTE IN-SITU PRESSURE IN PA
!PREF_SI   ABSOLUTE REFERENCE PRESSURE IN PA
!KEY       "HPOT"
  
!OR FROM
!SA_SI     ABSOLUTE SALINITY IN KG/KG
!X_SI      IN-SITU TEMPERATURE IN K
!P_SI      ABSOLUTE IN-SITU PRESSURE IN PA
!PREF_SI   NOT REQUIRED
!KEY       "T"

!OR FROM
!SA_SI     ABSOLUTE SALINITY IN KG/KG
!X_SI      POTENTIAL TEMPERATURE IN K
!P_SI      ABSOLUTE IN-SITU PRESSURE IN PA
!PREF_SI   ABSOLUTE REFERENCE PRESSURE IN PA
!KEY       "TPOT"

!NOTE: THE ACCURACY OF THIS FUNCTION DEPENDS ON THE ITERATION SETTINGS FOR
!      ENTROPY COMPUTED IN SEA_3B AND ON THOSE MADE IN THIS MODULE

!CHECK VALUES WITH DEFAULT SETTINGS:
!sea_eta_contraction_t_SI(0.035,1E5,1E7,1E5,"h") = 0.728755239644
!SEA_ETA_CONTRACTION_T_SI(0.035,1E5,1E7,1E5,"hpot") = 0.726349317428
!SEA_ETA_CONTRACTION_T_SI(0.035,300,1E7,1E5,"t") = 0.724913833446
!SEA_ETA_CONTRACTION_T_SI(0.035,300,1E7,1E5,"tpot") = 0.724714253918

implicit none
character*13 key
real*8 sea_eta_contraction_t_si, sa_si, x_si, p_si, pref_si
real*8 eta

sea_eta_contraction_t_si = errorreturn

if (sa_si < 0d0 .or. sa_si >= 1d0) return
if (p_si <= 0d0) return
if (pref_si <= 0d0) return

eta = sea_eta_entropy_x_si(sa_si, x_si, p_si, pref_si, key)  !ENTROPY
if (eta == errorreturn) return

sea_eta_contraction_t_si = sea_h_contraction_t_si(sa_si, eta, p_si)

end function

!=========================================================================
function sea_eta_contraction_theta_si(sa_si, x_si, p_si, pref_si, key)
!=========================================================================

!THIS FUNCTION COMPUTES THE HALINE CONTRACTION COEFFICIENT OF SEAWATER AT CONSTANT POTENTIAL TEMPERATURE
!FROM EITHER IN-SITU ENTHALPY (KEY="H") OR POTENTIAL ENTHALPY (KEY = "HPOT")
!OR FROM IN-SITU TEMPERATURE (KEY="T") OR POTENTIAL TEMPERATURE (KEY = "TPOT")

!RETURNS   HALINE CONTRACTION - (1/V)*(DV/DS) OF SEAWATER IN KG/KG

!EITHER FROM
!SA_SI     ABSOLUTE SALINITY IN KG/KG
!X_SI      IN-SITU ENTHALPY IN J/KG
!P_SI      ABSOLUTE IN-SITU PRESSURE IN PA
!PREF_SI   ABSOLUTE REFERENCE PRESSURE IN PA
!KEY       "H"

!OR FROM
!SA_SI     ABSOLUTE SALINITY IN KG/KG
!X_SI      POTENTIAL ENTHALPY IN J/KG,
!P_SI      ABSOLUTE IN-SITU PRESSURE IN PA
!PREF_SI   ABSOLUTE REFERENCE PRESSURE IN PA
!KEY       "HPOT"

!OR FROM
!SA_SI     ABSOLUTE SALINITY IN KG/KG
!X_SI      IN-SITU TEMPERATURE IN K
!P_SI      ABSOLUTE IN-SITU PRESSURE IN PA
!PREF_SI   ABSOLUTE REFERENCE PRESSURE IN PA
!KEY       "T"

!OR FROM
!SA_SI     ABSOLUTE SALINITY IN KG/KG
!X_SI      POTENTIAL TEMPERATURE IN K
!P_SI      ABSOLUTE IN-SITU PRESSURE IN PA
!PREF_SI   ABSOLUTE REFERENCE PRESSURE IN PA
!KEY       "TPOT"

!NOTE: THE ACCURACY OF THIS FUNCTION DEPENDS ON THE ITERATION SETTINGS FOR
!      ENTROPY COMPUTED IN SEA_3B AND ON THOSE MADE IN THIS MODULE

!CHECK VALUES WITH DEFAULT SETTINGS:
!SEA_ETA_CONTRACTION_THETA_SI(0.035,1E5,1E7,1E5,"h") = 0.728499505688
!SEA_ETA_CONTRACTION_THETA_SI(0.035,1E5,1E7,1E5,"hpot") = 0.726099732703
!SEA_ETA_CONTRACTION_THETA_SI(0.035,300,1E7,1E5,"t") = 0.724667977117
!SEA_ETA_CONTRACTION_THETA_SI(0.035,300,1E7,1E5,"tpot") = 0.724468894946

implicit none
character*13 key
real*8 sea_eta_contraction_theta_si, sa_si, x_si, p_si, pref_si
real*8 eta

sea_eta_contraction_theta_si = errorreturn

if (sa_si < 0d0 .or. sa_si >= 1d0) return
if (p_si <= 0d0) return
if (pref_si <= 0d0) return

eta = sea_eta_entropy_x_si(sa_si, x_si, p_si, pref_si, key)  !ENTROPY
if (eta == errorreturn) return

sea_eta_contraction_theta_si = sea_h_contraction_theta_si(sa_si, eta, p_si, pref_si)

end function

!=========================================================================
function sea_eta_contraction_h_si(sa_si, x_si, p_si, pref_si, key)
!=========================================================================

!THIS FUNCTION COMPUTES THE HALINE CONTRACTION COEFFICIENT OF SEAWATER AT CONSTANT POTENTIAL ENTHALPY
!FROM EITHER IN-SITU ENTHALPY (KEY="H") OR POTENTIAL ENTHALPY (KEY = "HPOT")
!OR FROM IN-SITU TEMPERATURE (KEY="T") OR POTENTIAL TEMPERATURE (KEY = "TPOT")

!RETURNS   HALINE CONTRACTION - (1/V)*(DV/DS) OF SEAWATER IN KG/KG

!EITHER FROM
!SA_SI     ABSOLUTE SALINITY IN KG/KG
!X_SI      IN-SITU ENTHALPY IN J/KG
!P_SI      ABSOLUTE IN-SITU PRESSURE IN PA
!PREF_SI   ABSOLUTE REFERENCE PRESSURE IN PA
!KEY       "H"

!OR FROM
!SA_SI     ABSOLUTE SALINITY IN KG/KG
!X_SI      POTENTIAL ENTHALPY IN J/KG
!P_SI      ABSOLUTE IN-SITU PRESSURE IN PA
!PREF_SI   ABSOLUTE REFERENCE PRESSURE IN PA
!KEY       "HPOT"

!OR FROM
!SA_SI     ABSOLUTE SALINITY IN KG/KG
!X_SI      IN-SITU TEMPERATURE IN K
!P_SI      ABSOLUTE IN-SITU PRESSURE IN PA
!PREF_SI   ABSOLUTE REFERENCE PRESSURE IN PA
!KEY       "T"

!OR FROM
!SA_SI     ABSOLUTE SALINITY IN KG/KG
!X_SI      POTENTIAL TEMPERATURE IN K
!P_SI      ABSOLUTE IN-SITU PRESSURE IN PA
!PREF_SI   ABSOLUTE REFERENCE PRESSURE IN PA
!KEY       "TPOT"

!CHECK VALUES WITH DEFAULT SETTINGS:
!SEA_ETA_CONTRACTION_H_SI(0.035,1E5,1E7,1E5,"h") = 0.718452125957
!SEA_ETA_CONTRACTION_H_SI(0.035,1E5,1E7,1E5,"hpot") = 0.714531922616
!SEA_ETA_CONTRACTION_H_SI(0.035,300,1E7,1E5,"t") = 0.712069013013
!SEA_ETA_CONTRACTION_H_SI(0.035,300,1E7,1E5,"tpot") = 0.711718411190

!NOTE: THE ACCURACY OF THIS FUNCTION DEPENDS ON THE ITERATION SETTINGS FOR
!      ENTROPY COMPUTED IN SEA_3B AND ON THOSE MADE IN THIS MODULE

implicit none
character*13 key
real*8 sea_eta_contraction_h_si, sa_si, x_si, p_si, pref_si
real*8 eta

sea_eta_contraction_h_si = errorreturn

if (sa_si < 0d0 .or. sa_si >= 1d0) return
if (p_si <= 0d0) return
if (pref_si <= 0d0) return

eta = sea_eta_entropy_x_si(sa_si, x_si, p_si, pref_si, key)  !entropy
if (eta == errorreturn) return

sea_eta_contraction_h_si = sea_h_contraction_h_si(sa_si, eta, p_si, pref_si)

end function

!=========================================================================
function sea_eta_expansion_t_si(sa_si, x_si, p_si, pref_si, key)
!=========================================================================

!THIS FUNCTION COMPUTES THE THERMAL EXPANSION COEFFICIENT OF SEAWATER WRT TEMPERATURE
!FROM EITHER IN-SITU ENTHALPY (KEY="H") OR POTENTIAL ENTHALPY (KEY = "HPOT")
!OR FROM IN-SITU TEMPERATURE (KEY="T") OR POTENTIAL TEMPERATURE (KEY = "TPOT")

!RETURNS   THERMAL EXPANSION  (1/V)*(DV/DT) OF SEAWATER IN 1/K
!          AT CONSTANT SALINITY AND PRESSURE.

!EITHER FROM
!SA_SI     ABSOLUTE SALINITY IN KG/KG
!X_SI      IN-SITU ENTHALPY IN J/KG
!P_SI      ABSOLUTE IN-SITU PRESSURE IN PA
!PREF_SI   NOT USED
!KEY       "H"

!OR FROM
!SA_SI     ABSOLUTE SALINITY IN KG/KG
!X_SI      POTENTIAL ENTHALPY IN J/KG
!P_SI      ABSOLUTE IN-SITU PRESSURE IN PA
!PREF_SI   ABSOLUTE REFERENCE PRESSURE IN PA
!KEY       "HPOT"

!OR FROM
!SA_SI     ABSOLUTE SALINITY IN KG/KG
!X_SI      IN-SITU TEMPERATURE IN K
!P_SI      ABSOLUTE IN-SITU PRESSURE IN PA
!PREF_SI   NOT USED
!KEY       "T"

!OR FROM
!SA_SI     ABSOLUTE SALINITY IN KG/KG
!X_SI      POTENTIAL TEMPERATURE IN K
!P_SI      ABSOLUTE IN-SITU PRESSURE IN PA
!PREF_SI   ABSOLUTE REFERENCE PRESSURE IN PA
!KEY       "TPOT"

!CHECK VALUES WITH DEFAULT SETTINGS:
!SEA_ETA_EXPANSION_T_SI(0.035,1E5,1E7,1E5,"h") = 2.89480851145E-04
!SEA_ETA_EXPANSION_T_SI(0.035,1E5,1E7,1E5,"hpot") = 3.07242256461E-04
!SEA_ETA_EXPANSION_T_SI(0.035,300,1E7,1E5,"t") = 3.18513471410E-04
!SEA_ETA_EXPANSION_T_SI(0.035,300,1E7,1E5,"tpot") = 3.20122324740E-04

!NOTE: THE ACCURACY OF THIS FUNCTION DEPENDS ON THE ITERATION SETTINGS FOR
!      ENTROPY COMPUTED IN SEA_3B AND ON THOSE MADE IN THIS MODULE

implicit none
character*13 key
real*8 sea_eta_expansion_t_si, sa_si, x_si, p_si, pref_si
real*8 eta

sea_eta_expansion_t_si = errorreturn

if (sa_si < 0d0 .or. sa_si >= 1d0) return
if (p_si <= 0d0) return
if (pref_si <= 0d0) return

eta = sea_eta_entropy_x_si(sa_si, x_si, p_si, pref_si, key)  !entropy
if (eta == errorreturn) return

sea_eta_expansion_t_si = sea_h_expansion_t_si(sa_si, eta, p_si)

end function

!=========================================================================
function sea_eta_expansion_theta_si(sa_si, x_si, p_si, pref_si, key)
!=========================================================================

!THIS FUNCTION COMPUTES THE THERMAL EXPANSION COEFFICIENT OF SEAWATER WRT POTENTIAL TEMPERATURE
!FROM EITHER IN-SITU ENTHALPY (KEY="H") OR POTENTIAL ENTHALPY (KEY = "HPOT")
!OR FROM IN-SITU TEMPERATURE (KEY="T") OR POTENTIAL TEMPERATURE (KEY = "TPOT")

!RETURNS   EXPANSION  (1/V)*(DV/DTHETA) OF SEAWATER IN 1/K
!          AT CONSTANT SALINITY AND PRESSURE. THETA IS POTENTIAL TEMPERATURE

!EITHER FROM
!SA_SI     ABSOLUTE SALINITY IN KG/KG
!X_SI      IN-SITU ENTHALPY IN J/KG
!P_SI      ABSOLUTE IN-SITU PRESSURE IN PA
!PREF_SI   ABSOLUTE REFERENCE PRESSURE IN PA
!KEY       "H"

!OR FROM
!SA_SI     ABSOLUTE SALINITY IN KG/KG
!X_SI      POTENTIAL ENTHALPY IN J/KG
!P_SI      ABSOLUTE IN-SITU PRESSURE IN PA
!PREF_SI   ABSOLUTE REFERENCE PRESSURE IN PA
!KEY       "HPOT"

!OR FROM
!SA_SI     ABSOLUTE SALINITY IN KG/KG
!X_SI      IN-SITU TEMPERATURE IN K
!P_SI      ABSOLUTE IN-SITU PRESSURE IN PA
!PREF_SI   ABSOLUTE REFERENCE PRESSURE IN PA
!KEY       "T"

!OR FROM
!SA_SI     ABSOLUTE SALINITY IN KG/KG
!X_SI      POTENTIAL TEMPERATURE IN K
!P_SI      ABSOLUTE IN-SITU PRESSURE IN PA
!PREF_SI   ABSOLUTE REFERENCE PRESSURE IN PA
!KEY       "TPOT"

!CHECK VALUES WITH DEFAULT SETTINGS:
!SEA_ETA_EXPANSION_THETA_SI(0.035,1E5,1E7,1E5,"h") = 2.91293979902E-04
!SEA_ETA_EXPANSION_THETA_SI(0.035,1E5,1E7,1E5,"hpot") = 3.09134848554E-04
!SEA_ETA_EXPANSION_THETA_SI(0.035,300,1E7,1E5,"t") = 3.20454167783E-04
!SEA_ETA_EXPANSION_THETA_SI(0.035,300,1E7,1E5,"tpot") = 3.22069710839E-04

!NOTE: THE ACCURACY OF THIS FUNCTION DEPENDS ON THE ITERATION SETTINGS FOR
!      ENTROPY COMPUTED IN SEA_3B AND ON THOSE MADE IN THIS MODULE

implicit none
character*13 key
real*8 sea_eta_expansion_theta_si, sa_si, x_si, p_si, pref_si
real*8 eta

sea_eta_expansion_theta_si = errorreturn

if (sa_si < 0d0 .or. sa_si >= 1d0) return
if (p_si <= 0d0) return
if (pref_si <= 0d0) return

eta = sea_eta_entropy_x_si(sa_si, x_si, p_si, pref_si, key)  !entropy
if (eta == errorreturn) return

sea_eta_expansion_theta_si = sea_h_expansion_theta_si(sa_si, eta, p_si, pref_si)

end function

!=========================================================================
function sea_eta_expansion_h_si(sa_si, x_si, p_si, pref_si, key)
!=========================================================================

!THIS FUNCTION COMPUTES THE THERMAL EXPANSION COEFFICIENT OF SEAWATER WRT POTENTIAL ENTHALPY
!FROM EITHER IN-SITU ENTHALPY (KEY="H") OR POTENTIAL ENTHALPY (KEY = "HPOT")
!OR FROM IN-SITU TEMPERATURE (KEY="T") OR POTENTIAL TEMPERATURE (KEY = "TPOT")

!RETURNS   THERMAL EXPANSION  (1/V)*(DV/DHPOT)_S_P OF SEAWATER IN KG / J
!          AT CONSTANT SALINITY AND PRESSURE. HPOT IS POTENTIAL ENTHALPY.

!EITHER FROM
!SA_SI     ABSOLUTE SALINITY IN KG/KG
!X_SI      IN-SITU ENTHALPY IN J/KG
!P_SI      ABSOLUTE IN-SITU PRESSURE IN PA
!PREF_SI   ABSOLUTE REFERENCE PRESSURE IN PA
!KEY       "H"

!OR FROM
!SA_SI     ABSOLUTE SALINITY IN KG/KG
!X_SI      POTENTIAL ENTHALPY IN J/KG
!P_SI      ABSOLUTE IN-SITU PRESSURE IN PA
!PREF_SI   ABSOLUTE REFERENCE PRESSURE IN PA
!KEY       "HPOT"

!OR FROM
!SA_SI     ABSOLUTE SALINITY IN KG/KG
!X_SI      IN-SITU TEMPERATURE IN K
!P_SI      ABSOLUTE IN-SITU PRESSURE IN PA
!PREF_SI   ABSOLUTE REFERENCE PRESSURE IN PA
!KEY       "T"

!OR FROM
!SA_SI     ABSOLUTE SALINITY IN KG/KG
!X_SI      POTENTIAL TEMPERATURE IN K
!P_SI      ABSOLUTE IN-SITU PRESSURE IN PA
!PREF_SI   ABSOLUTE REFERENCE PRESSURE IN PA
!KEY       "TPOT"

!NOTE: THE ACCURACY OF THIS FUNCTION DEPENDS ON THE ITERATION SETTINGS FOR
!      ENTROPY COMPUTED IN SEA_3B AND ON THOSE MADE IN THIS MODULE
!
!CHECK VALUES WITH DEFAULT SETTINGS:
!SEA_ETA_EXPANSION_H_SI(0.035,1E5,1E7,1E5,"h") = 7.28514646021E-08
!SEA_ETA_EXPANSION_H_SI(0.035,1E5,1E7,1E5,"hpot") = 7.72876772245E-08
!SEA_ETA_EXPANSION_H_SI(0.035,300,1E7,1E5,"t") = 8.01009066333E-08
!SEA_ETA_EXPANSION_H_SI(0.035,300,1E7,1E5,"tpot") = 8.05023387611E-08

implicit none
character*13 key
real*8 sea_eta_expansion_h_si, sa_si, x_si, p_si, pref_si
real*8 eta

sea_eta_expansion_h_si = errorreturn

if (sa_si < 0d0 .or. sa_si >= 1d0) return
if (p_si <= 0d0) return
if (pref_si <= 0d0) return

eta = sea_eta_entropy_x_si(sa_si, x_si, p_si, pref_si, key)  !entropy
if (eta == errorreturn) return

sea_eta_expansion_h_si = sea_h_expansion_h_si(sa_si, eta, p_si, pref_si)

end function

!=========================================================================
function entropy_iteration(sa_si, h_si, p_si, eta_si, maxit, eps)
!==========================================================================

!RETURNS   ETA =  ENTROPY OF SEAWATER IN J/(KG K)
!          I.E. THE ENTROPY THAT SOLVES H_SI = SEA_ENTHALPY_SI(SA_SI, ETA_SI, P_SI)
!          FOR ETA_SI AT GIVEN H_SI

!SA_SI     ABSOLUTE SALINITY IN KG/KG
!H_SI      ENTHALPY IN J/KG
!P_SI      ABSOLUTE PRESSURE IN PA
!ETA_SI    ENTROPY IN J/(KG K), INITIAL VALUE
!MAXIT     MAX. NUMBER OF ITERATIONS
!EPS       REQUIRED TOLERANCE IN J/(KG K)

implicit none

Integer maxit, i
real*8 entropy_iteration, sa_si, h_si, p_si, eta_si, eps
real*8 h, eta, t, de

entropy_iteration = errorreturn

if((eps <= 0d0) .or. (maxit <= 0)) return

if(check_limits == 1) then
  !SAL_LIMITS
  if(sa_si < sal_smin .or. sa_si > sal_smax .or. &
  p_si < sal_pmin .or. p_si > sal_pmax) return
else
  if(sa_si < 0d0 .or. sa_si >= 1d0 .or. &
  p_si <= 0d0) return
endif

check_limits = check_limits - 1

eta = eta_si

do i = 1, maxit

  !GET ENTHALPY AND ITS FIRST DERIVATIVE FOR NEWTON ITERATION
  h = sea_h_si(0, 0, 0, sa_si, eta, p_si)
  if(h == errorreturn) go to 999
  t = sea_h_si(0, 1, 0, sa_si, eta, p_si)
  if(t == errorreturn) go to 999
  if(t <= 0d0) go to 999
  
  !NEXT ENTROPY IMPROVEMENT STEP
  de = (h_si - h) / t
  eta = eta + de

  if(abs(de) < eps) then
    entropy_iteration = eta
    go to 999
  end if
  
enddo

999 continue

check_limits = check_limits + 1

end function

!=========================================================================
function sea_eta_entropy_x_si(sa_si, x_si, p_si, pref_si, key)
!=========================================================================

!THIS FUNCTION COMPUTES THE ENTROPY OF SEAWATER
!FROM EITHER IN-SITU ENTHALPY (KEY="H") OR POTENTIAL ENTHALPY (KEY = "HPOT")
!OR FROM IN-SITU TEMPERATURE (KEY="T") OR POTENTIAL TEMPERATURE (KEY = "TPOT")

!RETURNS   ENTROPY OF SEAWATER IN J/(KG K)

!EITHER FROM
!SA_SI     ABSOLUTE SALINITY IN KG/KG
!X_SI      IN-SITU ENTHALPY IN J/KG
!P_SI      ABSOLUTE IN-SITU PRESSURE IN PA
!PREF_SI   NOT REQUIRED
!KEY       "H"

!OR FROM
!SA_SI     ABSOLUTE SALINITY IN KG/KG
!X_SI      POTENTIAL ENTHALPY IN J/KG
!P_SI      ABSOLUTE IN-SITU PRESSURE IN PA
!PREF_SI   ABSOLUTE REFERENCE PRESSURE IN PA
!KEY       "HPOT"

!OR FROM
!SA_SI     ABSOLUTE SALINITY IN KG/KG
!X_SI      IN-SITU TEMPERATURE IN K
!P_SI      ABSOLUTE IN-SITU PRESSURE IN PA
!PREF_SI   NOT REQUIRED
!KEY       "T"

!OR FROM
!SA_SI     ABSOLUTE SALINITY IN KG/KG
!X_SI      POTENTIAL TEMPERATURE IN K
!P_SI      ABSOLUTE IN-SITU PRESSURE IN PA
!PREF_SI   ABSOLUTE REFERENCE PRESSURE IN PA
!KEY       "TPOT"

character*13 key
real*8 sea_eta_entropy_x_si, sa_si, x_si, p_si, pref_si

sea_eta_entropy_x_si = errorreturn

if (sa_si < 0d0 .or. sa_si >= 1d0) return
if (p_si <= 0d0) return
if (pref_si <= 0d0) return

select case (key)
  case ("hpot")
    if (pref_si <= 0) return
    sea_eta_entropy_x_si = sea_eta_entropy_si(sa_si, x_si, pref_si)  !ENTROPY FROM POT. ENTHALPY

  case ("h")
    sea_eta_entropy_x_si = sea_eta_entropy_si(sa_si, x_si, p_si)     !ENTROPY FROM IN-SITU ENTHALPY

  case ("tpot")
    if (pref_si <= 0d0) return
    if (x_si <= 0d0) return
    sea_eta_entropy_x_si = sea_entropy_si(sa_si, x_si, pref_si)      !ENTROPY FROM POT. TEMPERATURE

  case ("t")
    if (x_si <= 0d0) return
    sea_eta_entropy_x_si = sea_entropy_si(sa_si, x_si, p_si)         !ENTROPY FROM IN-SITU TEMPERATURE

   case default; write(*,*)key,' not supported'

end select

end function

!==========================================================================
subroutine set_it_ctrl_entropy(key, value)
!==========================================================================

!THIS SUB SETS CONTROL PARAMETERS FOR THE NEWTON ITERATION USED TO COMPUTE
!ENTROPY FROM ENTHALPY

!KEY            VALUE
!IT_STEPS       0           SET ITERATION NUMBER TO DEFAULT (100)
!IT_STEPS       N > 0       SET ITERATION NUMBER TO N
!IT_STEPS      -1           DO NOT ITERATE, USE INITIAL VALUE

!MODE_ETA       0           USE DEFAULT ENTROPY ETA = H/273.15 TO START
!MODE_ETA       1           USE VALUE SET BY INIT_ETA AS ENTROPY TO START

!INIT_ETA       ETA         USE VALUE ETA AS ENTROPY TO START IF MODE_ETA = 1

!TOL_ETA        0           USE DEFAULT EXIT ACCURACY FOR ENTROPY (1E-4 J/(KG K))
!TOL_ETA        EPS > 0     USE EPS AS EXIT ACCURACY FOR ENTROPY

implicit none
character*13 key
real*8 value

call init_it_ctrl_entropy

select case (Trim(key))

  case ("it_steps")                   !ITERATION STEPS
      if(value == 0d0)then 
         ctrl_loop_maximum = 100      !DEFAULT = 100
      elseif(value < 0d0) then 
         ctrl_loop_maximum = -1
      else
         ctrl_loop_maximum = value
      endif

  case ("mode_eta")   !start eta
      if(value == 0d0)then 
         ctrl_mode_entropy = 0        !DEFAULT: ETA = H/T0
      elseif(value == 1d0) then
         ctrl_mode_entropy = 1        !DEFAULT: ETA = INIT_ETA
      endif

  case ("init_eta")                   !START ETA IF CTRL_MODE_ENTROPY = 1
      ctrl_init_entropy = value

  case ("tol_eta")                    !REQUIRED ETA TOLERANCE
      if(value == 0d0)then
         ctrl_eps_exit_entropy = 0.0001d0 !DEFAULT = 1e-4 J/(KG K)
      elseif(value > 0d0) then
         ctrl_eps_exit_entropy = value
      endif

   case default; write(*,*)key,' not supported'

end select

end subroutine

!==========================================================================
subroutine init_it_ctrl_entropy()
!==========================================================================

implicit none

if(ctrl_initialized == -1) return

ctrl_initialized = -1

!Set default values and modes for entropy iteration
ctrl_loop_maximum = 100
ctrl_mode_entropy = 0             !DEFAULT: ETA = H/T0
ctrl_eps_exit_entropy = 0.0001d0  !DEFAULT = 1E-4 J/(KG K)
ctrl_init_entropy = 0

end subroutine

end module sea_3c

module sea_air_4

!#########################################################################

!THIS MODULE IMPLEMENTS THE PHASE EQUILIBRIUM PROPERTIES OF SEAWATER WITH HUMID AIR

!#########################################################################

!IMPLEMENTATION IN FORTRAN BY D.G. WRIGHT
!FOR PUBLICATION IN OCEAN SCIENCE, AS DESCRIBED IN THE PAPERS

!FEISTEL, R., WRIGHT, D.G., JACKETT, D.R., MIYAGAWA, K., REISSMANN, J.H.,
!WAGNER, W., OVERHOFF, U., GUDER, C., FEISTEL, A., MARION, G.M.:
!NUMERICAL IMPLEMENTATION AND OCEANOGRAPHIC APPLICATION OF THE THERMODYNAMIC
!POTENTIALS OF WATER, VAPOUR, ICE, SEAWATER AND AIR. PART I: BACKGROUND AND EQUATIONS. 
!OCEAN SCIENCES, 2009, IN PREPARATION.

!WRIGHT, D.G., FEISTEL, R., JACKETT, D.R., MIYAGAWA, K., REISSMANN, J.H., 
!WAGNER, W., OVERHOFF, U., GUDER, C., FEISTEL, A., MARION, G.M.:
!NUMERICAL IMPLEMENTATION AND OCEANOGRAPHIC APPLICATION OF THE THERMODYNAMIC
!POTENTIALS OF WATER, VAPOUR, ICE, SEAWATER AND AIR. PART II: THE LIBRARY ROUTINES, 
!OCEAN SCIENCES., 2009, IN PREPARATION.

!FEISTEL, R., KRETZSCHMAR, H.-J., SPAN, R., HAGEN, E., WRIGHT, D.G., HERRMANN, S.:
!THERMODYNAMIC PROPERTIES OF SEA AIR.
!OCEAN SCIENCE DISCUSSION 6(2009)2193-2325.

!#########################################################################

!THIS MODULE REQUIRES THE LIBRARY MODULES:
!     CONSTANTS_0,   FILE CONSTANTS_0.F90
!     CONVERT_0,     FILE CONVERT_0.F90
!     MATHS_0,       FILE MATHS_0.F90
!     AIR_1,         FILE AIR_1.F90
!     FLU_1,         FILE FLU_1.F90
!     SAL_1,         FILE SAL_1.F90
!     AIR_2,         FILE AIR_2.F90
!     FLU_2,         FILE FLU_2.F90
!     SAL_2,         FILE SAL_2.F90
!     AIR_3A,        FILE AIR_3A.F90
!     AIR_3B,        FILE AIR_3B.F90
!     FLU_3A,        FILE FLU_3A.F90
!     LIQ_VAP_4,     FILE LIQ_VAP_4.F90
!     LIQ_AIR_4A,    FILE LIQ_AIR_4A.F90

!#########################################################################

use constants_0
use convert_0
use maths_0
use air_1
use flu_1
use sal_1
use air_2
use flu_2
use sal_2
use air_3a
use air_3b
use flu_3a
use sea_3a
use liq_vap_4
use liq_air_4a

implicit none
private

character*16, private :: version = '8 Jun 2010'

public :: sea_air_chempot_evap_si, sea_air_condense_temp_si, &
          sea_air_density_air_si, sea_air_density_vap_si, &
          sea_air_enthalpy_evap_si, sea_air_entropy_air_si, &
          sea_air_massfraction_air_si, sea_air_vapourpressure_si, &
          set_it_ctrl_sea_air, set_sea_air_eq_at_s_a_p, &
          set_sea_air_eq_at_s_t_p

!CONTROL PARAMETERS OF THE VAPOUR PRESSURE ITERATION
integer ctrl_initialized

!SELECT INITIAL GUESSING METHOD
integer ctrl_mode_humidity
integer ctrl_mode_temperature
integer ctrl_mode_pressure

!STORE CUSTOMIZED INITIAL VALUES HERE
integer ctrl_loop_maximum
real*8 ctrl_init_t
real*8 ctrl_init_a
real*8 ctrl_init_p

!SET TOLERANCE OF THE ITERATION LOOP FOR
real*8 ctrl_eps_exit_p_vap   !vapour partial pressure
real*8 ctrl_eps_exit_temp    !temperature
real*8 ctrl_eps_exit_press    !pressure

!PROPERTIES OF THE CURRENT LIQUID-VAPOUR EQUILIBRIUM STATE
integer equi_sea_air_done

!STORAGE OF THE ITERATION RESULTS = THE EQUILIBRIUM STATE (SATURATED AIR)
real*8 equi_sea_air_s        !salinity
real*8 equi_sea_air_a        !dry air mass fraction of humid air
real*8 equi_sea_air_t        !temperature
real*8 equi_sea_air_p        !pressure
real*8 equi_sea_air_d_liq    !liquid water density
real*8 equi_sea_air_d_air    !humid air density

contains

!==========================================================================
function sea_air_massfraction_air_si(sa_si, t_si, p_si)
!==========================================================================

!RETURNS THE AIR MASS FRACTION IN KG/KG OF SEA AIR

!OUTPUT: 
!A_SI  MASS FRACTION OF DRY AIR IN SEA AIR, IN KG/KG

!INPUTS: 
!SA_SI  ABSOLUTE SALINITY IN KG/KG
! T_SI  ABSOLUTE TEMPERATURE IN K
! P_SI  ABSOLUTE PRESSURE OF HUMID AIR IN PA

!CHECK VALUE WITH DEFAULT SETTINGS, V1.0:
!SEA_AIR_MASSFRACTION_AIR_SI(0.035, 300, 1E5) = 0.978024405439

!CHECK VALUE WITH DEFAULT SETTINGS, V1.1:
!SEA_AIR_MASSFRACTION_AIR_SI(0.035, 300, 1E5) = 0.978029483888

real*8 sea_air_massfraction_air_si, sa_si, t_si, p_si

sea_air_massfraction_air_si = errorreturn

if(set_sea_air_eq_at_s_t_p(sa_si, t_si, p_si) == errorreturn) return

sea_air_massfraction_air_si = equi_sea_air_a

end function

!==========================================================================
function sea_air_vapourpressure_si(sa_si, t_si, p_si)
!==========================================================================
 
!RETURNS THE PARTIAL PRESSURE OF VAPOUR IN HUMID AIR AT EQUILIBRIUM WITH SEAWATER,
!FROM ABSOLUTE SALINITY, TEMPERATURE AND TOTAL PRESSURE
 
!INPUT:  SA_SI ABSOLUTE SALINITY IN KG/KG
!        T_SI  ABSOLUTE TEMPERATURE IN K
!        P_SI  ABSOLUTE (TOTAL) PRESSURE IN PA
!OUTPUT: VAPOUR PRESSURE IN PA
 
!CHECK VALUE WITH DEFAULT SETTINGS, V1.0: 
!SEA_AIR_VAPOURPRESSURE_SI(0.035,300,1E5) = 3485.92802425
 
!CHECK VALUE WITH DEFAULT SETTINGS, V1.1: 
!SEA_AIR_VAPOURPRESSURE_SI(0.035,300,1E5) = 3485.92986681
 
real*8 sa_si, t_si, p_si, sea_air_vapourpressure_si
real*8 a_sat, xv
 
sea_air_vapourpressure_si = errorreturn
 
if(sa_si < 0d0 .or. sa_si >= 1d0) return
if(t_si <= 0d0) return
if(p_si <= 0d0) return
 
!GET THE AIR FRACTION AT EQUILIBRIUM WITH SEAWATER
a_sat = sea_air_massfraction_air_si(sa_si, t_si, p_si)
if(a_sat == errorreturn) return
if(a_sat <= 0d0 .or. a_sat > 1d0) return
 
!CONVERT AIR MASS FRACTION TO VAPOUR MOLE FRACTION
xv = air_molfraction_vap_si(a_sat)
if(xv == errorreturn) return
if(xv <= 0d0 .or. xv > 1d0) return
 
!COMPUTE THE PARTIAL PRESSURE
sea_air_vapourpressure_si = xv * p_si
 
end function

!==========================================================================
function sea_air_chempot_evap_si(a_si, sa_si, t_si, p_si)
!==========================================================================

!THIS FUNCTION RETURNS THE CHEMICAL POTENTIAL DIFFERENCE X_SA = LN(PHI(A_SI)/PHI(SA_SI))
!COMPUTED FROM THE RELATIVE FUGACITY OF HUMID AIR, PHI(A), AND OF SEA AIR, PHI(SA)
!AS A MEASURE FOR THE DEVIATION FROM AIR-SEA EQUILIBRIUM (ONSAGER FORCE)

!INPUT:  A_SI:  MASS FRACTION OF DRY AIR IN HUMID AIR, IN KG/KG
!        SA_SI: ABSOLUTE SALINITY OF SEAWATER
!        T_SI:  ABSOLUTE TEMPERATURE IN K
!        P_SI:  ABSOLUTE PRESSURE IN PA
!OUTPUT: CHEMICAL POTENTIAL DIFFERENCE /(R_W T), UNITLESS

!CHECK VALUE WITH DEFAULT SETTINGS, V1.0:
!SEA_AIR_CHEMPOT_EVAP_SI(0.9,0.035,300,1E5) = 1.45564492467

!CHECK VALUE WITH DEFAULT SETTINGS, V1.1:
!SEA_AIR_CHEMPOT_EVAP_SI(0.9,0.035,300,1E5) = 1.45584069071

real*8 sea_air_chempot_evap_si, a_si, sa_si, t_si, p_si
real*8 mu_v, mu_w

sea_air_chempot_evap_si = errorreturn

if(a_si < 0d0 .or. a_si > 1d0)return
if(sa_si < 0d0 .or. sa_si >= 1d0)return
if(t_si <= 0d0)return
if(p_si <= 0d0)return

!CHEMICAL POTENTIAL OF VAPOUR IN HUMID AIR
mu_v = air_g_chempot_vap_si(a_si, t_si, p_si)
if(mu_v == errorreturn)return

!CHEMICAL POTENTIAL OF WATER IN SEAWATER
mu_w = sea_chempot_h2o_si(sa_si, t_si, p_si)
if(mu_w == errorreturn)return

sea_air_chempot_evap_si = (mu_v - mu_w) / (gas_constant_h2O_si * t_si)

end function

!==========================================================================
function sea_air_condense_temp_si(sa_si, a_si, p_si)
!==========================================================================

!RETURNS THE SEAWATER CONDENSATION TEMPERATURE OF UNSATURATED HUMID AIR

!OUTPUT: 
!T_SI  ABSOLUTE CONDENSATION TEMPERATURE IN K

!INPUT: 
!SA_SI  ABSOLUTE SALINITY IN KG/KG
! A_SI  MASS FRACTION OF DRY AIR IN HUMID AIR, IN KG/KG
! P_SI  ABSOLUTE PRESSURE OF HUMID AIR IN PA

!CHECK VALUE WITH DEFAULT SETTINGS, V1.0:
!SEA_AIR_CONDENSE_TEMP_SI(0.035, 0.99, 1E5) = 287.363869941

!CHECK VALUE WITH DEFAULT SETTINGS, V1.1:
!SEA_AIR_CONDENSE_TEMP_SI(0.035, 0.99, 1E5) = 287.367456468

real*8 sea_air_condense_temp_si, sa_si, a_si, p_si

sea_air_condense_temp_si = errorreturn

if(sa_si == 0d0) then
  sea_air_condense_temp_si = liq_air_dewpoint_si(a_si, p_si)
  return
end if

if(set_sea_air_eq_at_s_a_p(sa_si, a_si, p_si) == errorreturn) return

sea_air_condense_temp_si = equi_sea_air_t

end function

!==========================================================================
function sea_air_density_air_si()
!==========================================================================

!RETURNS THE HUMID AIR DENSITY IN KG/M3 OF SEA AIR
!AFTER SETTING THE EQUILIBRIUM STATE BY CALLING SET_SEA_AIR_EQUILIBRIUM_TO_S_T_P ETC

!CHECK VALUES WITH DEFAULT SETTINGS, V1.0:
!SET_SEA_AIR_EQ_AT_S_A_P(0.035, 0.99, 1E5)
!SEA_AIR_DENSITY_AIR_SI = 1.20527399511

!SET_SEA_AIR_EQ_AT_S_T_P(0.035, 300, 1E5)
!SEA_AIR_DENSITY_AIR_SI = 1.14616388271

!CHECK VALUES WITH DEFAULT SETTINGS, V1.1:
!SET_SEA_AIR_EQ_AT_S_A_P(0.035, 0.99, 1E5)
!SEA_AIR_DENSITY_AIR_SI = 1.20553988598

!SET_SEA_AIR_EQ_AT_S_T_P(0.035, 300, 1E5)
!SEA_AIR_DENSITY_AIR_SI = 1.14642944448

real*8 sea_air_density_air_si

sea_air_density_air_si = errorreturn

if(equi_sea_air_done /= isok) return

sea_air_density_air_si = equi_sea_air_d_air

end function

!==========================================================================
function sea_air_density_vap_si()
!==========================================================================

!RETURNS THE VAPOUR DENSITY IN KG/M3 OF SEA AIR
!AFTER SETTING THE EQUILIBRIUM STATE BY CALLING SET_SEA_AIR_EQUILIBRIUM_TO_S_T_P ETC

!CHECK VALUES WITH DEFAULT SETTINGS, V1.0:
!SET_SEA_AIR_EQ_AT_S_A_P(0.035, 0.99, 1E5)
!SEA_AIR_DENSITY_VAP_SI = 1.20527399511E-02

!SET_SEA_AIR_EQ_AT_S_T_P(0.035, 300, 1E5)
!SEA_AIR_DENSITY_VAP_SI = 0.0251876327865

!CHECK VALUES WITH DEFAULT SETTINGS, V1.1:
!SET_SEA_AIR_EQ_AT_S_A_P(0.035, 0.99, 1E5)
!SEA_AIR_DENSITY_VAP_SI = 1.20553988598E-02

!SET_SEA_AIR_EQ_AT_S_T_P(0.035, 300, 1E5)
!SEA_AIR_DENSITY_VAP_SI = 2.51876465812E-02

real*8 sea_air_density_vap_si

sea_air_density_vap_si = errorreturn

if(equi_sea_air_done /= isok) return

sea_air_density_vap_si = equi_sea_air_d_air * (1d0 - equi_sea_air_a)

end function

!==========================================================================
function sea_air_enthalpy_evap_si()
!==========================================================================

!RETURNS THE LATENT HEAT IN J/KG OF SEA AIR
!AFTER SETTING THE EQUILIBRIUM STATE BY CALLING SET_SEA_AIR_EQUILIBRIUM_TO_S_T_P ETC

!CHECK VALUES WITH DEFAULT SETTINGS, V1.0:
!SET_SEA_AIR_EQ_AT_S_A_P(0.035, 0.99, 1E5)
!SEA_AIR_ENTHALPY_EVAP_SI = 2464747.68964

!SET_SEA_AIR_EQ_AT_S_T_P(0.035, 300, 1E5)
!SEA_AIR_ENTHALPY_EVAP_SI = 2434550.22477

!CHECK VALUES WITH DEFAULT SETTINGS, V1.1:
!SET_SEA_AIR_EQ_AT_S_A_P(0.035, 0.99, 1E5)
!SEA_AIR_ENTHALPY_EVAP_SI = 2464738.79136

!SET_SEA_AIR_EQ_AT_S_T_P(0.035, 300, 1E5)
!SEA_AIR_ENTHALPY_EVAP_SI = 2434549.89770

real*8 sea_air_enthalpy_evap_si
real*8 a, t, dh, dl
real*8 hh, hh_a, hl
real*8 fh_a, fh_d
real*8 fh_at, fh_ad
real*8 fh_td, fh_dd
real*8 p_a, p_d
real*8 h_a, h_d
real*8 s, p, hs, hs_s
real*8 gs, gs_s, gs_t, gs_st

sea_air_enthalpy_evap_si = errorreturn

if(equi_sea_air_done /= isok) return

!GET THE EQUILIBRIUM PROPERTIES
s = equi_sea_air_s
if(s == errorreturn) return
if(s < 0d0 .or. s >= 1d0) return
a = equi_sea_air_a
if(a == errorreturn) return
if(a < 0d0 .or. a > 1d0) return
t = equi_sea_air_t
if(t == errorreturn) return
if(t <= 0d0) return
p = equi_sea_air_p
if(p == errorreturn) return
if(p <= 0d0) return
dh = equi_sea_air_d_air
if(dh == errorreturn) return
if(dh <= 0d0) return
dl = equi_sea_air_d_liq
if(dl == errorreturn) return
if(dl <= 0d0) return

!ENTHALPY OF HUMID AIR
hh = air_f_enthalpy_si(a, t, dh)
if(hh == errorreturn) return

!DERIVATIVE HH_A = (DH/DA)_T_P OF ENTHALPY OF HUMID AIR
fh_a = air_f_si(1, 0, 0, a, t, dh)
if(fh_a == errorreturn) return
fh_d = air_f_si(0, 0, 1, a, t, dh)
if(fh_d == errorreturn) return
fh_at = air_f_si(1, 1, 0, a, t, dh)
if(fh_at == errorreturn) return
fh_ad = air_f_si(1, 0, 1, a, t, dh)
if(fh_ad == errorreturn) return
fh_td = air_f_si(0, 1, 1, a, t, dh)
if(fh_td == errorreturn) return
fh_dd = air_f_si(0, 0, 2, a, t, dh)
if(fh_dd == errorreturn) return

p_a = dh * fh_ad                            !DP/DA AT CONST T,D
p_d = dh * (2d0 * fh_d + dh * fh_dd)        !DP/DD AT CONST A,T
if(p_d == 0d0) return
h_a = fh_a + dh * fh_ad - t * fh_at         !DH/DA AT CONST T,D
h_d = 2d0 * fh_d + dh * fh_dd - t * fh_td   !DH/DD AT CONST A,T

hh_a = h_a - h_d * p_a / p_d                !DH/DA AT CONST T,P

!ENTHALPY OF LIQUID WATER
hl = flu_enthalpy_si(t, dl)
if(hl == errorreturn) return

if(s == 0d0) then !treat the pure-water case separately
  !compute the latent heat of water
  sea_air_enthalpy_evap_si = hh - a * hh_a - hl
  return
end if

!SALINE ENTHALPY
gs = sal_g_si(0, 0, 0, s, t, p)
if(gs == errorreturn) return
gs_t = sal_g_si(0, 1, 0, s, t, p)
if(gs_t == errorreturn) return
hs = gs - t * gs_t
gs_s = sal_g_si(1, 0, 0, s, t, p)
if(gs_s == errorreturn) return
gs_st = sal_g_si(1, 1, 0, s, t, p)
if(gs_st == errorreturn) return
hs_s = gs_s - t * gs_st

!COMPUTE THE LATENT HEAT OF SEAWATER
sea_air_enthalpy_evap_si = hh - a * hh_a - hl - hs + s * hs_s

end function

!==========================================================================
function sea_air_entropy_air_si(sa_si, t_si, p_si)
!==========================================================================

!RETURNS THE HUMID-AIR ENTROPY IN J/(KG K) OF SEA AIR

!OUTPUT: 
!ETA_SI  ENTROPY OF HUMID AIR, IN J/(KG K)

!INPUTS: 
!SA_SI  ABSOLUTE SALINITY IN KG/KG OF THE SEAWATER FRACTION
! T_SI  ABSOLUTE TEMPERATURE IN K
! P_SI  ABSOLUTE PRESSURE OF HUMID AIR IN PA

!CHECK VALUE WITH DEFAULT SETTINGS, V1.0:
!SEA_AIR_ENTROPY_AIR_SI(0.035, 300, 1E5) = 293.218508134

!CHECK VALUE WITH DEFAULT SETTINGS, V1.1:
!SEA_AIR_ENTROPY_AIR_SI(0.035, 300, 1E5) = 293.150672957

real*8 sea_air_entropy_air_si
real*8 sa_si, t_si, p_si

sea_air_entropy_air_si = errorreturn

if (set_sea_air_eq_at_s_t_p(sa_si, t_si, p_si) == errorreturn) return

sea_air_entropy_air_si = air_g_entropy_si(equi_sea_air_a, t_si, p_si)

end function

!==========================================================================
function set_sea_air_eq_at_s_a_p(sa_si, a_si, p_si)
!==========================================================================

!THIS FUNCTION COMPUTES THE EQUILIBRIUM STATE BETWEEN HUMID AIR AND SEAWATER,
!IN PARTICULAR, THE SEA-AIR TEMPERATURE AT WHICH HUMID AIR CONDENSATES
!AT THE SEA SURFACE (ALREADY BEFORE THE DEWPOINT IS REACHED)

!INPUTS: 
!SA_SI  ABSOLUTE SALINITY IN KG/KG
! A_SI  MASS FRACTION OF DRY AIR IN HUMID AIR IN KG/KG
! P_SI  ABSOLUTE PRESSURE OF HUMID AIR IN PA

real*8 set_sea_air_eq_at_s_a_p, sa_si, a_si, p_si
real*8 t_si, dl, dh, eps

integer maxit

if(equi_sea_air_done == isok .and. &
   sa_si == equi_sea_air_s .and. &
   a_si == equi_sea_air_a .and. &
   p_si == equi_sea_air_p) then
  !the requested state has already been computed earlier
  set_sea_air_eq_at_s_a_p = isok
  return
end if

call clear_sea_air_state !waste any previous state

set_sea_air_eq_at_s_a_p = errorreturn

if(sa_si < 0d0 .or. sa_si >= 1d0) return
if(a_si < 0d0 .or. a_si >= 1d0) return
if(p_si <= 0d0) return

call init_it_ctrl_sea_air

!SET INITIAL TEMPERATURE GUESS
select case(ctrl_mode_temperature)
  case(0); t_si = aux_temperature_si(a_si, p_si)
  case(1); t_si = ctrl_init_t
  case default; return
end select
if(t_si == errorreturn) return
if(t_si <= 0d0) return

!SET INITIAL LIQUID DENSITY
dl = liq_density_si(t_si, p_si)
if(dl == errorreturn) return
if(dl <= 0d0) return

!SET INITIAL HUMID AIR DENSITY
dh = air_density_si(a_si, t_si, p_si)
if(dh == errorreturn) return
if(dh <= 0d0) return

!SET MAX. ITERATION NUMBER
if(ctrl_loop_maximum == 0) then
  maxit = 100
elseif(ctrl_loop_maximum == (-1)) then
  set_sea_air_eq_at_s_a_p = isok
  call set_sea_air_state(sa_si, a_si, t_si, p_si, dl, dh)
  return
elseif(ctrl_loop_maximum > 0) then 
  maxit = ctrl_loop_maximum
else
  return
endif

!SET ITERATION ACCURACY LIMIT FOR THE VAPOUR PARTIAL PRESSURE
eps = ctrl_eps_exit_p_vap
if(eps == 0d0) return

!RUN ITERATION LOOP
if(sea_air_iteration_at_s_a_p(sa_si, a_si, p_si, maxit, eps, t_si, dl, dh) == errorreturn) then
  return
end if

call set_sea_air_state(sa_si, a_si, t_si, p_si, dl, dh)

set_sea_air_eq_at_s_a_p = isok

end function

!==========================================================================
function set_sea_air_eq_at_s_t_p(sa_si, t_si, p_si)
!==========================================================================
                                             
!THIS FUNCTION COMPUTES THE EQUILIBRIUM STATE BETWEEN HUMID AIR AND
!SEAWATER, IN PARTICULAR, THE SPECIFIC HUMIDITY OF SEA AIR.

!INPUTS: 
!SA_SI  ABSOLUTE SALINITY IN KG/KG
! T_SI  ABSOLUTE TEMPERATURE IN K
! P_SI  ABSOLUTE PRESSURE OF HUMID AIR IN PA

real*8 set_sea_air_eq_at_s_t_p, sa_si, t_si, p_si
real*8 a_si, dl, dh, eps

integer maxit

if(equi_sea_air_done == isok .and. &
  sa_si == equi_sea_air_s .and. &
  t_si == equi_sea_air_t .and. &
  p_si == equi_sea_air_p) then
  !the requested state has already been computed earlier
  set_sea_air_eq_at_s_t_p = isok
  return
end if

call clear_sea_air_state !waste any previous state

set_sea_air_eq_at_s_t_p = errorreturn

if(sa_si < 0d0 .or. sa_si >= 1d0) return
if(t_si <= 0d0) return
if(p_si <= 0d0) return

call init_it_ctrl_sea_air

!SET INITIAL AIR FRACTION GUESS: USE PURE WATER
select case(ctrl_mode_humidity)
  case(0)
    a_si = aux_airfraction_si(t_si, p_si)
    if(a_si == errorreturn) return
    if(a_si < 0d0 .or. a_si > 1d0) return
  case(1)
    a_si = ctrl_init_a
  case default; return
end select
if(a_si == errorreturn) return
if(a_si < 0d0 .or. a_si > 1d0) return

!LIQUID DENSITY CAN BE COMPUTED FROM T, P
dl = liq_density_si(t_si, p_si)
if(dl == errorreturn) return
if(dl <= 0d0) return

dh = air_density_si(a_si, t_si, p_si)
if(dh == errorreturn) return
if(dh <= 0d0) return

!SET MAX. ITERATION NUMBER
if(ctrl_loop_maximum == 0) then
  maxit = 100
elseif(ctrl_loop_maximum == (-1)) then
  set_sea_air_eq_at_s_t_p = isok
  call set_sea_air_state(sa_si, a_si, t_si, p_si, dl, dh)
  return
elseif(ctrl_loop_maximum > 0) then
  maxit = ctrl_loop_maximum
else
  return
endif

!SET ITERATION ACCURACY LIMIT FOR THE VAPOUR PARTIAL PRESSURE
eps = ctrl_eps_exit_p_vap
if(eps == 0d0) return

!RUN ITERATION LOOP
if(sea_air_iteration_at_s_t_p(sa_si, t_si, p_si, dl, maxit, eps, a_si, dh) == errorreturn) then
  return
end if

call set_sea_air_state(sa_si, a_si, t_si, p_si, dl, dh)

set_sea_air_eq_at_s_t_p = isok

end function

!==========================================================================
function sea_air_iteration_at_s_t_p(sa_si, t_si, p_si, d_liq_si, maxit, eps, a_si, d_air_si)
!==========================================================================

!THIS FUNCTION RETURNS THE SEAWATER-HUMID-AIR PHASE EQUILIBRIUM FROM EQUAL PRESSURES,
!TEMPERATURES AND CHEMICAL POTENTIAL OF WATER OF THE TWO PHASES AT GIVEN SALINITY, SA_SI,
!PRESSURE, P_SI, AND  TEMPERATURE, T_SI, FROM INITIAL GUESSES FOR THE HUMID-AIR DENSITY,
!D_AIR_SI, AND THE AIR FRACTION, A_SI

!THE ITERATION LIMIT EPS REFERS TO THE ERROR IN VAPOUR PARTIAL PRESSURE

!OUTPUT: 
!        SEA_AIR_ITERATION_AT_S_T_P = ISOK IF SUCCESSFUL
!        SEA_AIR_ITERATION_AT_S_T_P = ERRORRETURN IS RETURNED IF
!        - THE MAXIMUM NUMBER OF ITERATIONS IS EXCEEDED WITHOUT MEETING THE EXIT CRITERION
!        - FUNCTION CALLS TO SAL_G_SI, FLU_F_SI OR AIR_F_SI HAVE RETURNED AN ERROR
!        - DENSITIES OR AIR FRACTION HAVE TAKEN AN INVALID VALUE DURING THE ITERATION
!     A_SI: MASS FRACTION OF DRY AIR IN HUMID AIR, KG/KG
! D_AIR_SI: HUMID-AIR DENSITY AT THE EQUILIBRIUM

!INPUTS: 
!      SA_SI: ABSOLUTE SALINITY IN KG/KG
!       P_SI: ABSOLUTE PRESSURE IN PA
!       T_SI: ABSOLUTE TEMPERATURE IN K
!   D_LIQ_SI: LIQUID PURE-WATER DENSITY AT T_SI, P_SI
!      MAXIT: MAXIMUM NUMBER OF ITERATION STEPS TO BE DONE
!        EPS: REQUIRED ACCURACY OF VAPOUR PRESSURE
!             EPS > 0: ABSOLUTE VAPOUR PRESSURE TOLERANCE IN PA
!             EPS < 0: RELATIVE VAPOUR PRESSURE TOLERANCE
!       A_SI: INITIAL GUESS OF THE MASS FRACTION OF DRY AIR IN HUMID AIR, KG/KG
!   D_AIR_SI: INITIAL GUESS OF HUMID-AIR DENSITY

real*8 sea_air_iteration_at_s_t_p, sa_si, t_si, p_si, d_liq_si, eps, a_si, d_air_si
real*8 ah, fh_a, fh_aa, fh_ad
real*8 gl, gss
real*8 fh, fh_d, fh_dd
real*8 dh
real*8 pv, pv_old
real*8 a(2, 2), b(2), x(2)

integer it, maxit

sea_air_iteration_at_s_t_p = errorreturn
pv = errorreturn

!CHECK FOR INVALID INPUT VALUES
if((a_si < 0d0 .or. a_si > 1d0) .or. &
  (d_air_si <= 0d0)) then
  a_si = errorreturn
  d_air_si = errorreturn
  return
endif

if(check_limits == 1) then
  !AIR_LIMITS
  if(t_si < dry_air_tmin .or. t_si > dry_air_tmax) then
    a_si = errorreturn
    d_air_si = errorreturn
    return
  endif
  !FLU_LIMITS
  if(t_si < flu_tmin .or. t_si > flu_tmax .or. &
  d_liq_si <= flu_dmin .or. d_liq_si > flu_dmax) then
    a_si = errorreturn
    d_air_si = errorreturn
    return
  endif
  !SAL_LIMITS
  if(t_si < sal_tmin .or. t_si > sal_tmax .or. &
  sa_si < sal_smin .or. sa_si > sal_smax .or. &
  p_si < sal_pmin .or. p_si > sal_pmax) then
    a_si = errorreturn
    d_air_si = errorreturn
    return
  endif
else
  if(d_liq_si <= 0d0 .or. &
    sa_si < 0d0 .or. sa_si >= 1d0 .or. &
    t_si <= 0d0 .or. &
    p_si <= 0d0) then
    a_si = errorreturn
    d_air_si = errorreturn
    return
  endif
endif

check_limits = check_limits - 1

ah = a_si
dh = d_air_si

!CHEMICAL POTENTIAL OF WATER
gl = flu_gibbs_energy_si(t_si, d_liq_si)
if(gl == errorreturn) go to 999
gss = sal_chempot_h2o_si(sa_si, t_si, p_si)
if(gss == errorreturn) go to 999

do it = 0, maxit

  !DERIVATIVES OF THE HELMHOLTZ FUNCTION FOR 2D-NEWTON ITERATION
  !HUMID AIR:
  fh = air_f_si(0, 0, 0, ah, t_si, dh)
  if(fh == errorreturn) go to 999
  fh_a = air_f_si(1, 0, 0, ah, t_si, dh)
  if(fh_a == errorreturn) go to 999
  fh_d = air_f_si(0, 0, 1, ah, t_si, dh)
  if(fh_d == errorreturn) go to 999
  fh_aa = air_f_si(2, 0, 0, ah, t_si, dh)
  if(fh_aa == errorreturn) go to 999
  fh_ad = air_f_si(1, 0, 1, ah, t_si, dh)
  if(fh_ad == errorreturn) go to 999
  fh_dd = air_f_si(0, 0, 2, ah, t_si, dh)
  if(fh_dd == errorreturn) go to 999
  
  !VAPOUR PARTIAL PRESSURE FOR ERROR CHECKING
  pv_old = pv
  pv = air_molfraction_vap_si(ah)
  if(pv == errorreturn) go to 999
  pv = p_si * pv
  
  if(it > 0) then
    !CHECK ABSOLUTE OR RELATIVE ERROR LIMIT
    if((eps > 0d0 .and. abs(pv - pv_old) < eps) .or. &
      (eps < 0d0 .and. abs(pv - pv_old) < -eps * pv)) then
      sea_air_iteration_at_s_t_p = isok
      d_air_si = dh
      a_si = ah
      go to 999
    end if
  end if
  
  if(it == maxit) go to 999
  
  !COEFFICIENT MATRIX
  a(1, 1) = -ah * fh_aa
  a(1, 2) = fh_d - ah * fh_ad - p_si / dh**2
  a(2, 1) = dh * fh_ad
  a(2, 2) = 2d0 * fh_d + dh * fh_dd

  !RIGHT-HAND SIDES, MUST VANISH IN EQUILIBRIUM
  b(1) = gl - fh - p_si / dh + ah * fh_a + gss
  b(2) = p_si / dh - dh * fh_d
  
  !SOLVE EQUATIONS
  if(matrix_solve(a, b, x, 2) /= 0) go to 999 !matrix singular

  !UPDATE AIR FRACTION & DENSITY
  ah = ah + x(1)
  if(ah < 0d0 .or. ah > 1d0) go to 999
  dh = dh + x(2)
  if(dh <= 0d0) go to 999

enddo

999 continue

check_limits = check_limits + 1

if(check_limits == 1) then
  !AIR_LIMITS
  if(a_si < 0d0 .or. a_si > 1d0 .or. &
  d_air_si <= dry_air_dmin .or. d_air_si > dry_air_dmax) then
    a_si = errorreturn
    d_air_si = errorreturn
    sea_air_iteration_at_s_t_p = errorreturn
    return
  endif
endif

end function

!==========================================================================
function sea_air_iteration_at_s_a_p(sa_si, a_si, p_si, maxit, eps, t_si, &
                                    d_liq_si, d_air_si)
!==========================================================================

!THIS FUNCTION RETURNS THE SEAWATER-HUMID-AIR PHASE EQUILIBRIUM FROM EQUAL PRESSURES,
!TEMPERATURES AND CHEMICAL POTENTIAL OF WATER OF THE TWO PHASES AT GIVEN PRESSURE, P_SI,
!SALINITY, SA_SI, AND AIR FRACTION, A_SI, FROM INITIAL GUESSES FOR THE LIQUID DENSITY,
!D_LIQ_SI, THE HUMID-AIR DENSITY, D_AIR_SI, AND THE TEMPERATURE, T_SI

!THE ITERATION LIMIT EPS REFERS TO THE ERROR IN THE TEMPERATURE

!OUTPUT: 
!        SEA_AIR_ITERATION_AT_S_A_P = ISOK IF SUCCESSFUL
!        SEA_AIR_ITERATION_AT_S_A_P = ERRORRETURN IS RETURNED IF
!        - THE MAXIMUM NUMBER OF ITERATIONS IS EXCEEDED WITHOUT MEETING THE EXIT CRITERION
!        - FUNCTION CALLS TO SAL_G_SI, FLU_F_SI OR AIR_F_SI HAVE RETURNED AN ERROR
!        - DENSITIES OR TEMPERATURE HAVE TAKEN A ZERO OR NEGATIVE VALUE DURING THE ITERATION
!     T_SI: ABSOLUTE TEMPERATURE IN K
! D_LIQ_SI: LIQUID DENSITY AT T_SI, P_SI
! D_AIR_SI: HUMID-AIR DENSITY AT THE SATURATION EQUILIBRIUM

!INPUTS: 
!      SA_SI: ABSOLUTE SALINITY IN KG/KG
!       P_SI: ABSOLUTE PRESSURE IN PA
!       A_SI: MASS FRACTION OF DRY AIR IN HUMID AIR, KG/KG
!      MAXIT: MAXIMUM NUMBER OF ITERATION STEPS TO BE DONE
!        EPS: REQUIRED ACCURACY OF TEMPERATURE
!             EPS > 0: ABSOLUTE TEMPERATURE TOLERANCE IN PA
!             EPS < 0: RELATIVE TEMPERATURE TOLERANCE
!       T_SI: INITIAL GUESS OF ABSOLUTE TEMPERATURE IN K
!   D_LIQ_SI: INITIAL GUESS OF LIQUID DENSITY AT P_SI, T_SI
!   D_AIR_SI: INITIAL GUESS OF HUMID-AIR DENSITY


real*8 sea_air_iteration_at_s_a_p, sa_si, a_si, p_si, eps, &
       t_si, d_liq_si, d_air_si
real*8 fh, fh_a, fh_t, fh_d
real*8 fh_ad, fh_at, fh_td, fh_dd
real*8 fl, fl_d, fl_t, fl_td, fl_dd
real*8 dl, dh, t
real*8 gss, gs_t, gs_st
real*8 a(3, 3), b(3), x(3)

integer it, maxit

sea_air_iteration_at_s_a_p = errorreturn

!CHECK FOR INVALID INPUT VALUES
if(d_air_si <= 0d0 .or. &
  d_liq_si <= 0d0 .or. &
  a_si < 0d0 .or. a_si >= 1d0 .or. &
  t_si <= 0d0) then
  t_si = errorreturn
  d_liq_si = errorreturn
  d_air_si = errorreturn
  return
endif

if(check_limits == 1) then
  !SAL_LIMITS
  if(sa_si < sal_smin .or. sa_si > sal_smax .or. &
    p_si <  sal_pmin .or. p_si > sal_pmax) then
    t_si = errorreturn
    d_liq_si = errorreturn
    d_air_si = errorreturn
    return
  endif
else
  if((sa_si < 0d0 .or. sa_si >= 1d0) .or. &
    (p_si <= 0d0)) then
    t_si = errorreturn
    d_liq_si = errorreturn
    d_air_si = errorreturn
    return
  endif
endif

check_limits = check_limits - 1

t = t_si
dh = d_air_si
dl = d_liq_si

do it = 1, maxit

  !DERIVATIVES OF THE HELMHOLTZ FUNCTION FOR 3D-NEWTON ITERATION
  !HUMID AIR:
  fh = air_f_si(0, 0, 0, a_si, t, dh)
  if(fh == errorreturn) go to 999
  fh_a = air_f_si(1, 0, 0, a_si, t, dh)
  if(fh_a == errorreturn) go to 999
  fh_t = air_f_si(0, 1, 0, a_si, t, dh)
  if(fh_t == errorreturn) go to 999
  fh_d = air_f_si(0, 0, 1, a_si, t, dh)
  if(fh_d == errorreturn) go to 999
  fh_ad = air_f_si(1, 0, 1, a_si, t, dh)
  if(fh_ad == errorreturn) go to 999
  fh_at = air_f_si(1, 1, 0, a_si, t, dh)
  if(fh_at == errorreturn) go to 999
  fh_td = air_f_si(0, 1, 1, a_si, t, dh)
  if(fh_td == errorreturn) go to 999
  fh_dd = air_f_si(0, 0, 2, a_si, t, dh)
  if(fh_dd == errorreturn) go to 999

  !LIQUID WATER:
  fl = flu_f_si(0, 0, t, dl)
  if(fl == errorreturn) go to 999
  fl_t = flu_f_si(1, 0, t, dl)
  if(fl_t == errorreturn) go to 999
  fl_d = flu_f_si(0, 1, t, dl)
  if(fl_d == errorreturn) go to 999
  fl_td = flu_f_si(0, 2, t, dl)
  if(fl_td == errorreturn) go to 999
  fl_dd = flu_f_si(0, 2, t, dl)
  if(fl_dd == errorreturn) go to 999
  
  !SEAWATER
  gss = sal_chempot_h2o_si(sa_si, t, p_si)
  if(gss == errorreturn) go to 999
  gs_t = sal_g_si(0, 1, 0, sa_si, t, p_si)
  if(gs_t == errorreturn) go to 999
  gs_st = sal_g_si(1, 1, 0, sa_si, t, p_si)
  if(gs_st == errorreturn) go to 999
  
  !COEFFICIENT MATRIX
  a(1, 1) = fh_t - a_si * fh_at - fl_t - gs_t + sa_si * gs_st
  a(1, 2) = fh_d - a_si * fh_ad - p_si / dh**2
  a(1, 3) = -fl_d + p_si / dl**2
  a(2, 1) = dh * fh_td
  a(2, 2) = 2d0 * fh_d + dh * fh_dd
  a(2, 3) = 0d0
  a(3, 1) = dl * fl_td
  a(3, 2) = 0d0
  a(3, 3) = 2d0 * fl_d + dl * fl_dd

  !RIGHT-HAND SIDES, MUST VANISH IN EQUILIBRIUM
  b(1) = fl - fh + a_si * fh_a + p_si * (1d0 / dl - 1d0 / dh) + gss
  b(2) = p_si / dh - dh * fh_d
  b(3) = p_si / dl - dl * fl_d
  
  !SOLVE EQUATIONS
  if(matrix_solve(a, b, x, 3) /= 0) go to 999 !matrix singular

  !UPDATE TEMPERATURE & DENSITIES
  t = t + x(1)
  if(t <= 0d0) go to 999
  dh = dh + x(2)
  if(dh <= 0d0) go to 999
  dl = dl + x(3)
  if(dl <= 0d0) go to 999

  !CHECK ABSOLUTE OR RELATIVE ERROR LIMIT
  if((eps > 0d0 .and. abs(x(1)) < eps) .or. &
    (eps < 0d0 .and. abs(x(1)) < -eps * t)) then
    sea_air_iteration_at_s_a_p = isok
    d_air_si = dh
    d_liq_si = dl
    t_si = t
    go to 999
  end if

enddo

999 continue

check_limits = check_limits + 1

if(check_limits == 1) then
  !AIR_LIMITS
  if(t_si < dry_air_tmin .or. t_si > dry_air_tmax .or. &
  d_air_si <= dry_air_dmin .or. d_air_si > dry_air_dmax) then
    a_si = errorreturn
    d_liq_si = errorreturn
    d_air_si = errorreturn
    sea_air_iteration_at_s_a_p = errorreturn
    return
  endif
  !FLU_LIMITS
  if(t_si < flu_tmin .or. t_si > flu_tmax .or. &
  d_liq_si <= flu_dmin .or. d_liq_si > flu_dmax) then
    a_si = errorreturn
    d_liq_si = errorreturn
    d_air_si = errorreturn
    sea_air_iteration_at_s_a_p = errorreturn
    return
  endif
endif

end function

!==========================================================================
function aux_airfraction_si(t_si, p_si)
!==========================================================================

!FUNCTION RETURNS AN ESTIMATE OF THE AIR MASS FRACTION OF SATURATED
!HUMID AIR AT GIVEN ABSOLUTE TEMPERATURE, T_SI, IN K AND ABSOLUTE
!PRESSURE, P_SI, IN PA

real*8 aux_airfraction_si, t_si, p_si
real*8 dh, dv, pv

aux_airfraction_si = errorreturn
if(t_si <= 0d0) return
if(p_si <= 0d0) return

!AS AN ESTIMATE, ADD THE DENSITIES OF DRY AIR AND VAPOUR

!VAPOUR PRESSURE
pv = liq_vap_vapourpressure_si(t_si)
if(pv == errorreturn) return
if(pv > p_si) return

if(pv == p_si) then
  aux_airfraction_si = 0d0
  return
end if

!VAPOUR DENSITY
dv = liq_vap_density_vap_si()
if(dv == errorreturn) return
if(dv <= 0d0) return

!DRY AIR DENSITY AT REMAINING PARTIAL PRESSURE
dh = air_density_si(1d0, t_si, p_si - pv)
if(dh == errorreturn) return
if(dh <= 0d0) return

!AIR FRACTION OF THE IDEAL MIXTURE
aux_airfraction_si = dh / (dh + dv)
           
end function

!==========================================================================
function aux_temperature_si(a_si, p_si)
!==========================================================================

!FUNCTION RETURNS AN ESTIMATE OF THE TEMPERATURE IN K OF SATURATED
!HUMID AIR AT GIVEN AIR MASS FRACTION, A_SI, IN KG/KG AND ABSOLUTE
!PRESSURE, P_SI, IN PA

real*8 aux_temperature_si, a_si, p_si
real*8 pv, t

aux_temperature_si = errorreturn
if(a_si < 0d0 .or. a_si >= 1d0) return
if(p_si <= 0d0) return

!AS AN ESTIMATE, IGNORE THE AIR PRESENT

!PARTIAL VAPOUR PRESSURE
pv = p_si * air_molfraction_vap_si(a_si)
!RELATED SATURATION TEMPERATURE
t = liq_vap_boilingtemperature_si(pv)
if(t == errorreturn) return
if(t <= 0d0) return

aux_temperature_si = t

end function

!==========================================================================
subroutine set_sea_air_state(s, a, t, p, dl, dh)
!==========================================================================

real*8 s, a, t, p, dl, dh

!STORES THE ACTUAL PROPERTIES AS THE CURRENT EQUILIBRIUM STATE DESCRIPTOR
equi_sea_air_done = isok

equi_sea_air_s = s
equi_sea_air_a = a
equi_sea_air_t = t
equi_sea_air_p = p
equi_sea_air_d_liq = dl
equi_sea_air_d_air = dh

end subroutine

!==========================================================================
subroutine clear_sea_air_state()
!==========================================================================

!CLEARS THE CURRENT EQUILIBRIUM STATE DESCRIPTOR

equi_sea_air_done = 0

end subroutine

!==========================================================================
subroutine init_it_ctrl_sea_air()
!==========================================================================

real*8 t_triple, p_triple

!TRIPLE POINT VALUES
t_triple = tp_temperature_si
p_triple = tp_pressure_iapws95_si

if(ctrl_initialized == isok) return

ctrl_initialized = isok

!SET DEFAULT VALUES AND MODES FOR ITERATION
ctrl_mode_pressure = 0
ctrl_mode_temperature = 0
ctrl_mode_humidity = 0

ctrl_loop_maximum = 100
ctrl_init_t = t_triple
ctrl_init_p = p_triple
ctrl_init_a = 1d0 - 0.001d0

ctrl_eps_exit_p_vap = -0.0000001d0 !RELATIVE, 0.1 PPM
ctrl_eps_exit_temp =  -0.0000001d0 !RELATIVE, 0.1 PPM
ctrl_eps_exit_press = -0.0000001d0 !RELATIVE, 0.1 PPM

end subroutine

!==========================================================================
subroutine set_it_ctrl_sea_air(key, value)
!==========================================================================

!THIS SUB SETS CONTROL PARAMETERS FOR THE ITERATION USED TO COMPUTE
!SATURATED HUMID AIR PROPERTIES

!KEY              VALUE
!IT_STEPS         0           SET ITERATION NUMBER TO DEFAULT (100)
!IT_STEPS         N > 0    SET ITERATION NUMBER TO N
!IT_STEPS        -1           DO NOT ITERATE, USE INITIAL VALUES AS THE SATURATION STATE

!INIT_AIR         0           USE DEFAULT AIR FRACTION TO START ( = AUX_AIRFRACTION_SI(T, P))
!INIT_AIR         A > 0    USE VALUE A AS AIR FRACTION TO START

!INIT_TEMP        0           USE DEFAULT TEMPERATURE TO START ( = AUX_TEMPERATURE_SI(A, P))
!INIT_TEMP        T > 0    USE VALUE T AS TEMPERATURE TO START

!INIT_PRESS       0           USE DEFAULT PRESSURE TO START ( = AUX_PRESSURE_SI(A, T))
!INIT_PRESS       P > 0    USE VALUE P AS PRESSURE TO START

!TOL_VAP_PRESS    0           USE DEFAULT EXIT ACCURACY FOR VAPOUR PRESSURE (0.1 PPM)
!TOL_VAP_PRESS    EPS         USE EPS AS EXIT ACCURACY FOR VAPOUR PRESSURE (EPS < 0 MEANS RELATIVE ERROR)

!TOL_TEMP         0           USE DEFAULT EXIT ACCURACY FOR TEMPERATURE (0.1 PPM)
!TOL_TEMP         EPS         USE EPS AS EXIT ACCURACY FOR TEMPERATURE (EPS < 0 MEANS RELATIVE ERROR)

!TOL_PRESS        0           USE DEFAULT EXIT ACCURACY FOR PRESSURE (0.1 PPM)
!TOL_PRESS        EPS         USE EPS AS EXIT ACCURACY FOR PRESSURE (EPS < 0 MEANS RELATIVE ERROR)

real*8 value
character*13 key

call init_it_ctrl_sea_air

call clear_sea_air_state

select case (trim(key))

  case ("it_steps");                !ITERATION STEPS
    if(value == 0d0) then
      ctrl_loop_maximum = 100    !DEFAULT = 100
    elseif(value < 0d0) then
      ctrl_loop_maximum = -1
    else
      ctrl_loop_maximum = nint(value)
    endif

  case ("init_air");                !START AIR FRACTION
    if(value == 0d0) then
      ctrl_mode_humidity = 0     !DEFAULT = AUX POLYNOMIAL
    else
      ctrl_mode_humidity = 1
      ctrl_init_a = value
    endif
    
  case ("init_temp");               !START TEMPERATURE
    if(value == 0d0) then
      ctrl_mode_temperature = 0  !DEFAULT = AUX POLYNOMIAL
    else
      ctrl_mode_temperature = 1
      ctrl_init_t = value
    endif
    
  case ("init_press");              !START PRESSURE
    if(value == 0d0) then
      ctrl_mode_pressure = 0     !DEFAULT = AUX POLYNOMIAL
    else
      ctrl_mode_pressure = 1
      ctrl_init_p = value
    endif

  case ("tol_vap_press");           !REQUIRED VAPOUR PRESSURE TOLERANCE
    if(value == 0d0) then
      ctrl_eps_exit_p_vap = -0.0000001d0   !DEFAULT = 0.1 PPM RELATIVE
    else
      ctrl_eps_exit_p_vap = value
    endif

  case ("tol_temp");                !REQUIRED TEMPERATURE TOLERANCE
    if(value == 0d0) then
      ctrl_eps_exit_temp = -0.0000001d0   !DEFAULT = 0.1 PPM RELATIVE
    else
      ctrl_eps_exit_temp = value
    endif

  case ("tol_press");               !REQUIRED TOTAL PRESSURE TOLERANCE
    if(value == 0d0) then
      ctrl_eps_exit_press = -0.0000001d0   !DEFAULT = 0.1 PPM RELATIVE
    else
      ctrl_eps_exit_press = value

    endif

  case default; write(*,*)key,' not supported'

end select

end subroutine

end module sea_air_4

Module ice_liq_4

!#########################################################################

!THIS MODULE IMPLEMENTS THE PHASE EQUILBRIA PROPERTIES OF ICE WITH LIQUID WATER
!COMPUTED FROM IAPWS-95 AND IAPWS-06:

!RELEASE ON THE IAPWS FORMULATION 1995 FOR THE THERMODYNAMIC PROPERTIES OF
!ORDINARY WATER SUBSTANCE FOR GENERAL AND SCIENTIFIC USE
!THE INTERNATIONAL ASSOCIATION FOR THE PROPERTIES OF WATER AND STEAM
!FREDERICIA, DENMARK, SEPTEMBER 1996

!RELEASE ON AN EQUATION OF STATE FOR H2O ICE IH
!THE INTERNATIONAL ASSOCIATION FOR THE PROPERTIES OF WATER AND STEAM
!WITNEY, UK, SEPTEMBER 2006

!#########################################################################

!IMPLEMENTATION IN FORTRAN BY D.G. WRIGHT
!FOR PUBLICATION IN OCEAN SCIENCE, AS DESCRIBED IN THE PAPERS

!FEISTEL, R., WRIGHT, D.G., JACKETT, D.R., MIYAGAWA, K., REISSMANN, J.H.,
!WAGNER, W., OVERHOFF, U., GUDER, C., FEISTEL, A., MARION, G.M.:
!NUMERICAL IMPLEMENTATION AND OCEANOGRAPHIC APPLICATION OF THE THERMODYNAMIC
!POTENTIALS OF WATER, VAPOUR, ICE, SEAWATER AND AIR. PART I: BACKGROUND AND EQUATIONS. 
!OCEAN SCIENCES, 2009, IN PREPARATION.

!WRIGHT, D.G., FEISTEL, R., JACKETT, D.R., MIYAGAWA, K., REISSMANN, J.H., 
!WAGNER, W., OVERHOFF, U., GUDER, C., FEISTEL, A., MARION, G.M.:
!NUMERICAL IMPLEMENTATION AND OCEANOGRAPHIC APPLICATION OF THE THERMODYNAMIC
!POTENTIALS OF WATER, VAPOUR, ICE, SEAWATER AND AIR. PART II: THE LIBRARY ROUTINES, 
!OCEAN SCIENCES., 2009, IN PREPARATION.

!FEISTEL, R., KRETZSCHMAR, H.-J., SPAN, R., HAGEN, E., WRIGHT, D.G., JACKETT, D.R.:
!THERMODYNAMIC PROPERTIES OF SEA AIR.
!OCEAN SCIENCE DISCUSSION 6(2009)2193-2325.

!#########################################################################

!THIS MODULE REQUIRES THE LIBRARY MODULES:
!     CONSTANTS_0,     FILE CONSTANTS_0.F90
!     MATHS_0,         FILE MATHS_0.F90
!     FLU_1,           FILE FLU_1.F90
!     ICE_1,           FILE ICE_1.F90
!     FLU_2,           FILE FLU_2.F90
!     ICE_2,           FILE ICE_2.F90

!#########################################################################

use constants_0
use maths_0
use flu_1
use ice_1
use flu_2
use ice_2

implicit none
private

character*16, private :: version = '8 Jun 2010'

public :: ice_liq_chempot_si, ice_liq_density_ice_si, &
          ice_liq_density_liq_si, ice_liq_enthalpy_ice_si, &
          ice_liq_enthalpy_liq_si, ice_liq_enthalpy_melt_si, &
          ice_liq_entropy_ice_si, ice_liq_entropy_liq_si, &
          ice_liq_entropy_melt_si, ice_liq_meltingpressure_si, &
          ice_liq_meltingtemperature_si, ice_liq_pressure_liq_si, &
          ice_liq_temperature_si, ice_liq_volume_melt_si, &
          set_ice_liq_eq_at_p, set_ice_liq_eq_at_t, &
          set_it_ctrl_ice_liq 

real*8, private :: equi_ice_liq_done, equi_ice_liq_t, equi_ice_liq_p, &
        equi_ice_liq_g_ice, equi_ice_liq_g_liq, equi_ice_liq_d_ice, &
        equi_ice_liq_d_liq

integer, private :: ctrl_mode_temperature, ctrl_mode_liquid, ctrl_mode_ice, &
         ctrl_loop_maximum, ctrl_initialized
real*8, private :: ctrl_init_t, ctrl_init_d_liq, ctrl_eps_exit_p

contains

!==========================================================================
function ice_liq_chempot_si()
!==========================================================================

!RETURNS THE CHEMICAL POTENTIAL IN J/KG LIQUID WATER IN LIQUID-ICE EQUILIBRIUM
!AFTER EXECUTION OF SET_ICE_LIQ_EQUILIBRIUM_TO_T OR SET_ICE_LIQ_EQUILIBRIUM_TO_P

!CHECK VALUES WITH DEFAULT SETTINGS:
!set_ice_liq_eq_at_p 1e7
!ice_liq_chempot_si = 9972.8817138|1

!set_ice_liq_eq_at_t 270
!ice_liq_chempot_si = 38870.060519|2

!NOTE: THE ACCURACY OF THIS FUNCTION DEPENDS ON THE ITERATION SETTINGS IN THIS MODULE

implicit none

real*8 ice_liq_chempot_si

ice_liq_chempot_si = errorreturn

if(equi_ice_liq_done /= isok) return

ice_liq_chempot_si = equi_ice_liq_g_liq

return

end function

!==========================================================================
function ice_liq_density_ice_si()
!==========================================================================

!RETURNS THE DENSITY  IN KG/M3 OF ICE AT THE LIQUID-ICE EQUILIBRIUM
!AFTER EXECUTION OF SET_ICE_LIQ_EQUILIBRIUM_TO_T OR SET_ICE_LIQ_EQUILIBRIUM_TO_P

!CHECK VALUES WITH DEFAULT SETTINGS:
!set_ice_liq_eq_at_p 1e7
!ice_liq_density_ice_si = 917.896690831

!set_ice_liq_eq_at_t 270
!ice_liq_density_ice_si = 921.359428514

!NOTE: THE ACCURACY OF THIS FUNCTION DEPENDS ON THE ITERATION SETTINGS IN THIS MODULE

implicit none

real*8 ice_liq_density_ice_si

ice_liq_density_ice_si = errorreturn

if(equi_ice_liq_done /= isok) return

ice_liq_density_ice_si = equi_ice_liq_d_ice

return

end function

!==========================================================================
function ice_liq_density_liq_si()
!==========================================================================

!RETURNS THE DENSITY IN KG/M3 OF WATER AT THE LIQUID-ICE EQUILIBRIUM
!AFTER EXECUTION OF SET_ICE_LIQ_EQUILIBRIUM_TO_T OR SET_ICE_LIQ_EQUILIBRIUM_TO_P

!CHECK VALUES WITH DEFAULT SETTINGS:
!set_ice_liq_eq_at_p 1e7
!ice_liq_density_liq_si = 1004.79353660

!set_ice_liq_eq_at_t 270
!ice_liq_density_liq_si = 1019.05568894

!NOTE: THE ACCURACY OF THIS FUNCTION DEPENDS ON THE ITERATION SETTINGS IN THIS MODULE

implicit none

real*8 ice_liq_density_liq_si

ice_liq_density_liq_si = errorreturn

if(equi_ice_liq_done /= isok) return

ice_liq_density_liq_si = equi_ice_liq_d_liq

return

end function

!==========================================================================
function ice_liq_enthalpy_ice_si()
!==========================================================================

!RETURNS THE SPECIFIC ENTHALPY J/KG OF ICE AT THE LIQUID-ICE EQUILIBRIUM
!AFTER EXECUTION OF SET_ICE_LIQ_EQUILIBRIUM_TO_T OR SET_ICE_LIQ_EQUILIBRIUM_TO_P

!CHECK VALUES WITH DEFAULT SETTINGS:
!set_ice_liq_eq_at_p 1e7
!ice_liq_enthalpy_ice_si = -324602.983812

!set_ice_liq_eq_at_t 270
!ice_liq_enthalpy_ice_si = -299055.938629

!NOTE: THE ACCURACY OF THIS FUNCTION DEPENDS ON THE ITERATION SETTINGS IN THIS MODULE

implicit none

real*8 ice_liq_enthalpy_ice_si

ice_liq_enthalpy_ice_si = errorreturn

if(equi_ice_liq_done /= isok) return

ice_liq_enthalpy_ice_si = ice_enthalpy_si(equi_ice_liq_t, equi_ice_liq_p)

return

end function

!==========================================================================
function ice_liq_enthalpy_liq_si()
!==========================================================================

!RETURNS THE SPECIFIC ENTHALPY IN J/KG OF WATER AT THE LIQUID-ICE EQUILIBRIUM
!AFTER EXECUTION OF SET_ICE_LIQ_EQUILIBRIUM_TO_T OR SET_ICE_LIQ_EQUILIBRIUM_TO_P

!CHECK VALUES WITH DEFAULT SETTINGS:
!set_ice_liq_eq_at_p 1e7
!ice_liq_enthalpy_liq_si = 6945.9270048|3

!set_ice_liq_eq_at_t 270
!ice_liq_enthalpy_liq_si = 26110.7481094

!NOTE: THE ACCURACY OF THIS FUNCTION DEPENDS ON THE ITERATION SETTINGS IN THIS MODULE

implicit none

real*8 ice_liq_enthalpy_liq_si

ice_liq_enthalpy_liq_si = errorreturn

if(equi_ice_liq_done /= isok) return

ice_liq_enthalpy_liq_si = flu_enthalpy_si(equi_ice_liq_t, equi_ice_liq_d_liq)

return

end function

!==========================================================================
function ice_liq_enthalpy_melt_si()
!==========================================================================

!RETURNS THE SPECIFIC MELTING ENTHALPY OF WATER IN J/KG
!AFTER EXECUTION OF SET_ICE_LIQ_EQUILIBRIUM_TO_T OR SET_ICE_LIQ_EQUILIBRIUM_TO_P

!CHECK VALUES WITH DEFAULT SETTINGS:
!set_ice_liq_eq_at_p 1e7
!ice_liq_enthalpy_melt_si = 331548.910817

!set_ice_liq_eq_at_t 270
!ice_liq_enthalpy_melt_si = 325166.686739

!NOTE: THE ACCURACY OF THIS FUNCTION DEPENDS ON THE ITERATION SETTINGS IN THIS MODULE

implicit none

real*8 ice_liq_enthalpy_melt_si
real*8 hi, hl

ice_liq_enthalpy_melt_si = errorreturn

if(equi_ice_liq_done /= isok) return

hi = ice_enthalpy_si(equi_ice_liq_t, equi_ice_liq_p)
if(hi == errorreturn) return
hl = flu_enthalpy_si(equi_ice_liq_t, equi_ice_liq_d_liq)
if(hl == errorreturn) return

ice_liq_enthalpy_melt_si = hl - hi

return

end function

!==========================================================================
function ice_liq_entropy_ice_si()
!==========================================================================

!RETURNS THE SPECIFIC ENTROPY IN J/(KG K) OF ICE AT THE LIQUID-ICE EQUILIBRIUM
!AFTER EXECUTION OF SET_ICE_LIQ_EQUILIBRIUM_TO_T OR SET_ICE_LIQ_EQUILIBRIUM_TO_P

!CHECK VALUES WITH DEFAULT SETTINGS:
!set_ice_liq_eq_at_p 1e7
!ice_liq_entropy_ice_si = -1228.24464139

!set_ice_liq_eq_at_t 270
!ice_liq_entropy_ice_si = -1251.57777462

!NOTE: THE ACCURACY OF THIS FUNCTION DEPENDS ON THE ITERATION SETTINGS IN THIS MODULE

implicit none

real*8 ice_liq_entropy_ice_si

ice_liq_entropy_ice_si = errorreturn

if(equi_ice_liq_done /= isok) return

ice_liq_entropy_ice_si = ice_entropy_si(equi_ice_liq_t, equi_ice_liq_p)

return

end function

!==========================================================================
function ice_liq_entropy_liq_si()
!==========================================================================

!RETURNS THE SPECIFIC ENTROPY J/(KG K) OF WATER AT THE LIQUID-ICE EQUILIBRIUM
!AFTER EXECUTION OF SET_ICE_LIQ_EQUILIBRIUM_TO_T OR SET_ICE_LIQ_EQUILIBRIUM_TO_P

!CHECK VALUES WITH DEFAULT SETTINGS:
!set_ice_liq_eq_at_p 1e7
!ice_liq_entropy_liq_si = -11.112101272|3

!set_ice_liq_eq_at_t 270
!ice_liq_entropy_liq_si = -47.2567126291

!NOTE: THE ACCURACY OF THIS FUNCTION DEPENDS ON THE ITERATION SETTINGS IN THIS MODULE

implicit none

real*8 ice_liq_entropy_liq_si

ice_liq_entropy_liq_si = errorreturn

if(equi_ice_liq_done /= isok) return

ice_liq_entropy_liq_si = flu_entropy_si(equi_ice_liq_t, equi_ice_liq_d_liq)

return

end function

!==========================================================================
function ice_liq_entropy_melt_si()
!==========================================================================

!RETURNS THE SPECIFIC MELTING ENTROPY IN J/(KG K) OF WATER
!AFTER EXECUTION OF SET_ICE_LIQ_EQUILIBRIUM_TO_T OR SET_ICE_LIQ_EQUILIBRIUM_TO_P

!CHECK VALUES WITH DEFAULT SETTINGS:
!set_ice_liq_eq_at_p 1e7
!ice_liq_entropy_melt_si = 1217.13254011

!set_ice_liq_eq_at_t 270
!ice_liq_entropy_melt_si = 1204.32106199

!NOTE: THE ACCURACY OF THIS FUNCTION DEPENDS ON THE ITERATION SETTINGS IN THIS MODULE

implicit none

real*8 ice_liq_entropy_melt_si
real*8 si, sl

ice_liq_entropy_melt_si = errorreturn

if(equi_ice_liq_done /= isok) return

si = ice_entropy_si(equi_ice_liq_t, equi_ice_liq_p)
if(si == errorreturn) return
sl = flu_entropy_si(equi_ice_liq_t, equi_ice_liq_d_liq)
if(sl == errorreturn) return

ice_liq_entropy_melt_si = sl - si

return

end function

!==========================================================================
function ice_liq_meltingpressure_si(t_si)
!==========================================================================

!RETURNS THE ABSOLUTE PRESSURE OF WATER IN LIQUID-ICE EQUILIBRIUM IN PA
!AS A FUNCTION OF ABSOLUTE TEMPERATURE T_SI IN K

!CHECK VALUE WITH DEFAULT SETTINGS: ice_liq_meltingpressure_si(270) = 39313338.8825

!NOTE: THE ACCURACY OF THIS FUNCTION DEPENDS ON THE ITERATION SETTINGS IN THIS MODULE

implicit none

real*8 ice_liq_meltingpressure_si
real*8 t_si

ice_liq_meltingpressure_si = errorreturn

if(set_ice_liq_eq_at_t(t_si) == errorreturn) return

ice_liq_meltingpressure_si = equi_ice_liq_p

return

end function

!==========================================================================
function ice_liq_meltingtemperature_si(p_si)
!==========================================================================

!RETURNS THE ABSOLUTE TEMPERATURE OF LIQUID-ICE EQUILIBRIUM IN K
!AS A FUNCTION OF ABSOLUTE PRESSURE P_SI IN PA

!CHECK VALUE WITH DEFAULT SETTINGS: ice_liq_meltingtemperature_si(1E7) = 272.401648869

!NOTE: THE ACCURACY OF THIS FUNCTION DEPENDS ON THE ITERATION SETTINGS IN THIS MODULE

implicit none

real*8 ice_liq_meltingtemperature_si
real*8 p_si

ice_liq_meltingtemperature_si = errorreturn

if(set_ice_liq_eq_at_p(p_si) == errorreturn) return

ice_liq_meltingtemperature_si = equi_ice_liq_t

return

end function

!==========================================================================
function ice_liq_pressure_liq_si()
!==========================================================================

!RETURNS THE ABSOLUTE PRESSURE IN PA OF WATER AT THE  LIQUID-ICE EQUILIBRIUM
!AFTER EXECUTION OF SET_ICE_LIQ_EQUILIBRIUM_TO_T OR SET_ICE_LIQ_EQUILIBRIUM_TO_P

!CHECK VALUES WITH DEFAULT SETTINGS:
!set_ice_liq_eq_at_p 1e7
!ice_liq_pressure_liq_si = 10000000.0070

!set_ice_liq_eq_at_t 270
!ice_liq_pressure_liq_si = 39313338.8825

!NOTE: THE ACCURACY OF THIS FUNCTION DEPENDS ON THE ITERATION SETTINGS IN THIS MODULE

implicit none

real*8 ice_liq_pressure_liq_si

ice_liq_pressure_liq_si = errorreturn

if(equi_ice_liq_done /= isok) return

ice_liq_pressure_liq_si = equi_ice_liq_p

return

end function

!==========================================================================
function ice_liq_temperature_si()
!==========================================================================

!RETURNS THE ABSOLUTE PRESSURE OF WATER IN LIQUID-ICE EQUILIBRIUM IN PA
!AFTER EXECUTION OF SET_ICE_LIQ_EQUILIBRIUM_TO_T OR SET_ICE_LIQ_EQUILIBRIUM_TO_P

!CHECK VALUES WITH DEFAULT SETTINGS:
!set_ice_liq_eq_at_p 1e7
!ice_liq_temperature_si = 272.401648869

!set_ice_liq_eq_at_t 270
!ice_liq_temperature_si = 270

!NOTE: THE ACCURACY OF THIS FUNCTION DEPENDS ON THE ITERATION SETTINGS IN THIS MODULE

implicit none

real*8 ice_liq_temperature_si

ice_liq_temperature_si = errorreturn

if(equi_ice_liq_done /= isok) return

ice_liq_temperature_si = equi_ice_liq_t

return

end function

!==========================================================================
function ice_liq_volume_melt_si()
!==========================================================================

!RETURNS THE SPECIFIC MELTING VOLUME IN M3/KG AT THE LIQUID-ICE EQUILIBRIUM
!AFTER EXECUTION OF SET_ICE_LIQ_EQUILIBRIUM_TO_T OR SET_ICE_LIQ_EQUILIBRIUM_TO_P

!CHECK VALUES WITH DEFAULT SETTINGS:
!set_ice_liq_eq_at_p 1e7
!ice_liq_volume_melt_si = -9.42178903288E-05

!set_ice_liq_eq_at_t 270
!ice_liq_volume_melt_si = -1.04052121182E-04

!NOTE: THE ACCURACY OF THIS FUNCTION DEPENDS ON THE ITERATION SETTINGS IN THIS MODULE

implicit none

real*8 ice_liq_volume_melt_si

ice_liq_volume_melt_si = errorreturn

if(equi_ice_liq_done /= isok) return

if(equi_ice_liq_d_ice <= 0d0) return
if(equi_ice_liq_d_liq <= 0d0) return

ice_liq_volume_melt_si = 1d0 / equi_ice_liq_d_liq - 1d0 / equi_ice_liq_d_ice

return

end function

!==========================================================================
function set_ice_liq_eq_at_p(p_si)
!==========================================================================

!THIS FUNCTION COMPUTES THE ICE-LIQUID EQUILIBRIUM AT GIVEN PRESSURE
!BY 2-DIMENSIONAL NEWTON ITERATION

implicit none

integer maxit
real*8 p_si
real*8 set_ice_liq_eq_at_p
real*8  t, pl, gi, gl, di, dl, eps
real *8 dl_triple, t_triple

!TRIPLE POINT
dl_triple = tp_density_liq_iapws95_si
t_triple = tp_temperature_si

if(equi_ice_liq_done == isok .and. &
   p_si == equi_ice_liq_p) then
  !the requested state has already been computed earlier
  set_ice_liq_eq_at_p = isok
  return
end if

call clear_ice_liq_state !waste any previous state

set_ice_liq_eq_at_p = errorreturn

if(p_si <= 0d0) return

call init_it_ctrl_ice_liq

!SET INITIAL TEMPERATURE GUESS
select case (ctrl_mode_temperature)
  case (0);  t = aux_temperature_correlation(p_si)
             if(t == errorreturn) return
  case (-1); t = t_triple
  case (1);  t = ctrl_init_t
  case default; return
end select

!SET INITIAL LIQUID DENSITY GUESS
select case (ctrl_mode_liquid)
  case (0);  dl = aux_liq_density_correlation(t)
  case (-1); dl = dl_triple
  case (1);  dl = ctrl_init_d_liq
  case default; return
end select

!SET MAX. ITERATION NUMBER
if(ctrl_loop_maximum == 0)then
   maxit = 100
elseif (ctrl_loop_maximum == (-1))then
   pl = flu_pressure_si(t, dl)
   gi = ice_g_si(0, 0, t, pl)
   gl = flu_gibbs_energy_si(t, dl)
   di = ice_g_si(0, 1, t, pl)
   if(di == errorreturn .or. di <= 0d0) return
   di = 1d0 / di
   call set_ice_liq_state (t, pl, gi, gl, di, dl)
   set_ice_liq_eq_at_p = isok
   return
elseif(ctrl_loop_maximum > 0)then
   maxit = ctrl_loop_maximum
else
   return
endif

!SET ITERATION ACCURACY LIMIT
eps = ctrl_eps_exit_p
if(eps == 0d0) return

!RUN ITERATION LOOP
if(ice_liq_iteration_at_p(p_si, maxit, eps, t, di, dl, gi, gl, pl) == errorreturn) then
  return
end if

call set_ice_liq_state (t, pl, gi, gl, di, dl)

set_ice_liq_eq_at_p = isok

return

end function

!==========================================================================
function set_ice_liq_eq_at_t(t_si)
!==========================================================================

!THIS FUNCTION COMPUTES THE ICE-LIQUID EQUILIBRIUM AT GIVEN TEMPERATURE
!BY NEWTON ITERATION

implicit none

integer maxit
real*8 t_si
real*8 set_ice_liq_eq_at_t

real*8 pl, gi, gl, di, dl, eps
real*8 t_triple, dl_triple

!TRIPLE POINT
t_triple = tp_temperature_si
dl_triple = tp_density_liq_iapws95_si

if(equi_ice_liq_done == isok .and. &
  t_si == equi_ice_liq_t) then
  !the requested state has already been computed earlier
  set_ice_liq_eq_at_t = isok
  return
end if

call clear_ice_liq_state !waste any previous state

set_ice_liq_eq_at_t = errorreturn

if(t_si <= 0d0) return
if(t_si > t_triple) return

call init_it_ctrl_ice_liq

!SET INITIAL LIQUID DENSITY GUESS
select case (ctrl_mode_liquid)
  case (0);  dl = aux_liq_density_correlation(t_si)
  case (-1); dl = dl_triple
  case (1);  dl = ctrl_init_d_liq
  case default; return
end select

!SET MAX. ITERATION NUMBER
if (ctrl_loop_maximum == 0)then
   maxit = 100
elseif (ctrl_loop_maximum == (-1))then
   pl = flu_pressure_si(t_si, dl)
   gi = ice_g_si(0, 0, t_si, pl)
   gl = flu_gibbs_energy_si(t_si, dl)
   di = ice_g_si(0, 1, t_si, pl)
   if(di == errorreturn .or. di <= 0d0) return
   di = 1d0 / di
   call set_ice_liq_state (t_si, pl, gi, gl, di, dl)
   set_ice_liq_eq_at_t = isok
   return
elseif (ctrl_loop_maximum > 0)then
   maxit = ctrl_loop_maximum
else
   return
endif

!SET ITERATION ACCURACY LIMIT
eps = ctrl_eps_exit_p
if(eps == 0d0) return

!RUN ITERATION LOOP
if(ice_liq_iteration_at_t(t_si, maxit, eps, di, dl, gi, gl, pl) == errorreturn) then
  return
end if

call set_ice_liq_state (t_si, pl, gi, gl, di, dl)

set_ice_liq_eq_at_t = isok

return

end function

!==========================================================================
function ice_liq_iteration_at_p(p_si, maxit, eps, t_si, d_ice_si, d_liq_si, &
                                g_ice_si, g_liq_si, p_liq_si)
!==========================================================================

!THIS FUNCTION RETURNS THE ICE-LIQUID PHASE EQUILIBRIUM FROM EQUAL PRESSURES,
!TEMPERATURES AND CHEMICAL POTENTIALS OF THE TWO PHASES AT GIVEN PRESSURE, P_SI,
!FROM INITIAL GUESSES FOR THE LIQUID DENSITY, D_LIQ_SI, AND THE TEMPERATURE, T_SI
!THE ITERATION LIMIT EPS REFERS TO THE ERROR IN LIQUID PRESSURE

!OUTPUT: ICE_LIQ_ITERATION_AT_T = ISOK IF SUCCESSFUL
!        ICE_LIQ_ITERATION_AT_T = ERRORRETURN IS RETURNED IF
!        - THE MAXIMUM NUMBER OF ITERATIONS IS EXCEEDED WITHOUT MEETING THE EXIT CRITERION
!        - THE FUNCTION CALL TO FLU_F_SI OR TO ICE_G_SI HAS RETURNED AN ERROR
!        - DENSITY OR TEMPERATURE HAVE TAKEN A ZERO OR NEGATIVE VALUE DURING THE ITERATION
!     T_SI: ABSOLUTE TEMPERATURE IN K
! D_ICE_SI: ICE DENSITY IN KG/M3 AT THE ICE-LIQUID EQUILIBRIUM
! D_LIQ_SI: LIQUID DENSITY IN KG/M3 AT THE ICE-LIQUID EQUILIBRIUM
! G_ICE_SI: ICE CHEMICAL POTENTIAL IN J/KG AT THE ICE-LIQUID EQUILIBRIUM
! G_LIQ_SI: LIQUID CHEMICAL POTENTIALIN J/KG AT THE ICE-LIQUID EQUILIBRIUM
! P_LIQ_SI: LIQUID PRESSURE IN PA AT THE ICE-LIQUID EQUILIBRIUM

!INPUT: P_SI: ABSOLUTE PRESSURE IN PA
!      MAXIT: MAXIMUM NUMBER OF ITERATION STEPS TO BE DONE
!        EPS: REQUIRED ACCURACY OF LIQUID PRESSURE
!             EPS > 0: ABSOLUTE LIQUID PRESSURE TOLERANCE IN PA
!             EPS < 0: RELATIVE LIQUID PRESSURE TOLERANCE
!       T_SI: INITIAL GUESS OF ABSOLUTE TEMPERATURE IN K
!   D_LIQ_SI: INITIAL GUESS OF LIQUID DENSITY IN KG/M3

implicit none

integer it, maxit
real*8 ice_liq_iteration_at_p
real*8 p_si, eps, t_si, d_ice_si, d_liq_si,  &
       g_ice_si, g_liq_si, p_liq_si
real*8 vi, dl, pl, gl, gi, gi_t, t, fl, fl_d, fl_dd, &
       fl_t, fl_td, a(2, 2), b(2), x(2), ddl, dt, pl_old 
real*8 tt

tt = tp_temperature_si !TRIPLE POINT TEMPERATURE IN K

ice_liq_iteration_at_p = errorreturn

if(t_si <= 0d0 .or. &
  d_liq_si <= 0d0) then
  t_si = errorreturn
  d_ice_si = errorreturn
  d_liq_si = errorreturn
  g_ice_si = errorreturn
  g_liq_si = errorreturn
  p_liq_si = errorreturn
  return
endif

if(check_limits == 1) then
  !ICE_LIMITS
  if(p_si <= ice_pmin .or. p_si > ice_pmax) then
    t_si = errorreturn
    d_ice_si = errorreturn
    d_liq_si = errorreturn
    g_ice_si = errorreturn
    g_liq_si = errorreturn
    p_liq_si = errorreturn
    return
  endif
else
  if(p_si <= 0d0) then
    t_si = errorreturn
    d_ice_si = errorreturn
    d_liq_si = errorreturn
    g_ice_si = errorreturn
    g_liq_si = errorreturn
    p_liq_si = errorreturn
    return
  endif
endif

check_limits = check_limits - 1

dl = d_liq_si
t = t_si

do it = 0, maxit

  !DERIVATIVES OF THE GIBBS & HELMHOLTZ FUNCTIONS FOR 2D-NEWTON ITERATION
  fl = flu_f_si(0, 0, t, dl)
  if(fl == errorreturn) go to 999
  
  fl_d = flu_f_si(0, 1, t, dl)
  if(fl_d == errorreturn) go to 999
  fl_dd = flu_f_si(0, 2, t, dl)
  if(fl_dd == errorreturn) go to 999
  
  fl_t = flu_f_si(1, 0, t, dl)
  if(fl_t == errorreturn) go to 999
  fl_td = flu_f_si(1, 1, t, dl)
  if(fl_td == errorreturn) go to 999

  pl_old = pl             !KEEP PREVIOUS PL TO CHECK ACCURACY
  !LIQUID AND ICE PRESSURE + LIQUID CHEMICAL POTENTIALS
  pl = dl ** 2 * fl_d     !PRESSURE OF LIQUID
  gl = fl + dl * fl_d     !CHEM. POT. OF LIQUID
  
  gi = ice_g_si(0, 0, t, pl)
  if(gi == errorreturn) go to 999
  gi_t = ice_g_si(1, 0, t, pl)
  if(gi_t == errorreturn) go to 999

  if(it > 0) then
    !CHECK ABSOLUTE OR RELATIVE ERROR LIMIT
    if((eps > 0d0 .and. abs(pl - pl_old) < eps) .or. &
       (eps < 0 .and. abs(pl - pl_old) < -eps * pl)) then
      p_liq_si = pl
      g_ice_si = gi
      g_liq_si = gl
      vi = ice_g_si(0, 1, t, pl)
      if(vi == errorreturn .or. vi <= 0d0) go to 999
      d_ice_si = 1d0 / vi
      d_liq_si = dl
      t_si = t
      ice_liq_iteration_at_p = isok
      go to 999
    end if
  end if
  
  if(it == maxit) go to 999
  
  !COEFFICIENT MATRIX
  a(1, 1) = dl * (2d0 * fl_d + dl * fl_dd)
  a(1, 2) = dl ** 2 * fl_td
  a(2, 1) = (2d0 * fl_d + dl * fl_dd)
  a(2, 2) = -gi_t + fl_t + dl * fl_td

  !RIGHT-HAND SIDES, MUST VANISH IN EQUILIBRIUM
  b(1) = p_si - pl
  b(2) = gi - gl

  !SOLVE EQUATIONS
  if(matrix_solve(a, b, x, 2) /= 0) go to 999 !MATRIX SINGULAR
  ddl = x(1)
  dt = x(2)
  
  !UPDATE DENSITY & TEMPERATURE
  dl = dl + ddl
  if(dl <= 0d0) go to 999
  t = t + dt
  if(t <= 0d0) go to 999
  
enddo

999 continue

check_limits = check_limits + 1

if(check_limits == 1) then
  !FLU_LIMITS
  if(t_si < flu_tmin .or. t_si > flu_tmax .or. &
  p_liq_si <= 0d0 .or. &
  d_liq_si <= flu_dmin .or. d_liq_si > flu_dmax) then
    t_si = errorreturn
    d_ice_si = errorreturn
    d_liq_si = errorreturn
    g_ice_si = errorreturn
    g_liq_si = errorreturn
    p_liq_si = errorreturn
    ice_liq_iteration_at_p = errorreturn
    return
  endif
  !ICE_LIMITS
  if(t_si <= ice_tmin .or. t_si > ice_tmax .or. &
  d_ice_si <= 0d0) then
    t_si = errorreturn
    d_ice_si = errorreturn
    d_liq_si = errorreturn
    g_ice_si = errorreturn
    g_liq_si = errorreturn
    p_liq_si = errorreturn
    ice_liq_iteration_at_p = errorreturn
    return
  endif
endif

end function

!==========================================================================
function ice_liq_iteration_at_t(t_si, maxit, eps, d_ice_si, d_liq_si,  &
                                g_ice_si, g_liq_si, p_liq_si)
!==========================================================================

!THIS FUNCTION RETURNS THE ICE-LIQUID PHASE EQUILIBRIUM FROM EQUAL PRESSURES
!AND CHEMICAL POTENTIALS OF THE TWO PHASES AT GIVEN TEMPERATURE, T_SI,
!FROM AN INITIAL GUESS FOR THE LIQUID DENSITY, D_LIQ_SI.
!THE ITERATION LIMIT EPS REFERS TO THE ERROR IN LIQUID PRESSURE

!OUTPUT: ICE_LIQ_ITERATION = ISOK IF SUCCESSFULLY DONE
!        ICE_LIQ_ITERATION = ERRORRETURN IS RETURNED IF
!        - THE MAXIMUM NUMBER OF ITERATIONS IS EXCEEDED WITHOUT MEETING THE EXIT CRITERION
!        - THE FUNCTION CALL TO FLU_F_SI HAS RETURNED AN ERROR
!        - DENSITIES OR PRESSURES HAVE TAKEN A ZERO OR NEGATIVE VALUE DURING THE ITERATION
! D_LIQ_SI: LIQUID DENSITY IN KG/M3 AT THE ICE-LIQUID EQUILIBRIUM
! D_ICE_SI: ICE DENSITY IN KG/M3 AT THE ICE-LIQUID EQUILIBRIUM
! G_LIQ_SI: LIQUID CHEMICAL POTENTIAL IN J/KG AT THE ICE-LIQUID EQUILIBRIUM
! G_ICE_SI: ICE CHEMICAL POTENTIAL IN J/KG AT THE ICE-LIQUID EQUILIBRIUM
! P_LIQ_SI: LIQUID PRESSURE IN PA AT THE ICE-LIQUID EQUILIBRIUM

!INPUT: T_SI: ABSOLUTE TEMPERATURE IN K
!      MAXIT: MAXIMUM NUMBER OF ITERATION STEPS TO BE DONE
!        EPS: REQUIRED ACCURACY OF PRESSURE
!             EPS > 0: ABSOLUTE PRESSURE TOLERANCE IN KG/M3
!             EPS < 0: RELATIVE PRESSURE TOLERANCE
!   D_LIQ_SI: INITIAL GUESS OF LIQUID DENSITY IN KG/M3

implicit none

integer it, maxit
real*8 t_si, eps
real*8 d_ice_si, d_liq_si,g_ice_si, g_liq_si, p_liq_si
real*8 ice_liq_iteration_at_t
real*8 vi, dl, pl, gi, gl, fl, fl_d, fl_dd, ddl, pl_old

ice_liq_iteration_at_t = errorreturn

If(t_si <= 0) return

if(d_liq_si <= 0d0) then
  d_ice_si = errorreturn
  d_liq_si = errorreturn
  g_ice_si = errorreturn
  g_liq_si = errorreturn
  p_liq_si = errorreturn
  return
endif

if(check_limits == 1) then
  !FLU_LIMITS
  if(t_si < flu_tmin .or. t_si > flu_tmax) then
    d_ice_si = errorreturn
    d_liq_si = errorreturn
    g_ice_si = errorreturn
    g_liq_si = errorreturn
    p_liq_si = errorreturn
    return
  endif
  !ICE_LIMITS
  if(t_si <= ice_tmin .or. t_si > ice_tmax) then
    d_ice_si = errorreturn
    d_liq_si = errorreturn
    g_ice_si = errorreturn
    g_liq_si = errorreturn
    p_liq_si = errorreturn
    return
  endif
else
  if(t_si <= 0d0) then
    d_ice_si = errorreturn
    d_liq_si = errorreturn
    g_ice_si = errorreturn
    g_liq_si = errorreturn
    p_liq_si = errorreturn
    return
  endif
endif

check_limits = check_limits - 1

dl = d_liq_si

do it = 0, maxit

  !DERIVATIVES OF THE HELMHOLTZ FUNCTION FOR NEWTON ITERATION
  fl = flu_f_si(0, 0, t_si, dl)
  if(fl == errorreturn) go to 999
  fl_d = flu_f_si(0, 1, t_si, dl)
  if(fl_d == errorreturn) go to 999
  fl_dd = flu_f_si(0, 2, t_si, dl)
  if(fl_dd == errorreturn) go to 999
  
  pl_old = pl            !KEEP PREVIOUS PL TO CHECK ACCURACY
  !LIQUID AND ICE PRESSURE + LIQUID CHEMICAL POTENTIALS
  pl = dl ** 2 * fl_d    !PRESSURE OF LIQUID
  gl = fl + dl * fl_d    !CHEM. POT. OF LIQUID
  
  !DERIVATIVES OF THE GIBBS FUNCTION OF ICE FOR NEWTON ITERATION
  gi = ice_g_si(0, 0, t_si, pl)
  if(gi == errorreturn) go to 999
  vi = ice_g_si(0, 1, t_si, pl)
  if(vi == errorreturn) go to 999
  if(vi <= 0d0) go to 999

  if(it > 0) then
    !CHECK ABSOLUTE OR RELATIVE ERROR LIMIT
    if((eps > 0d0 .and. abs(pl - pl_old) < eps) .or. &
       (eps < 0 .and. abs(pl - pl_old) < -eps * pl)) then
      ice_liq_iteration_at_t = isok
      p_liq_si = pl
      g_ice_si = gi
      g_liq_si = gl
      d_ice_si = 1d0 / vi
      d_liq_si = dl
      go to 999
    end if
  end if

  if(it == maxit) go to 999
  
  !DO ITERATION STEP
  ddl = (2d0 * fl_d + dl * fl_dd) * (vi * dl - 1d0)
  if(ddl == 0d0) go to 999
  ddl = (gl - gi) / ddl
  
  !UPDATE LIQUID DENSITY
  dl = dl + ddl
  if(dl <= 0d0) go to 999

enddo

999 continue

check_limits = check_limits + 1

if(check_limits == 1) then
  !FLU_LIMITS
  if(d_liq_si <= flu_dmin .or. d_liq_si > flu_dmax .or. &
  p_liq_si <= 0d0) then
    d_ice_si = errorreturn
    d_liq_si = errorreturn
    g_ice_si = errorreturn
    g_liq_si = errorreturn
    p_liq_si = errorreturn
    ice_liq_iteration_at_t = errorreturn
    return
  endif
  !ICE_LIMITS
  if(d_ice_si <= 0d0) then
    d_ice_si = errorreturn
    d_liq_si = errorreturn
    g_ice_si = errorreturn
    g_liq_si = errorreturn
    p_liq_si = errorreturn
    ice_liq_iteration_at_t = errorreturn
    return
  endif
endif

end function

!==========================================================================
function aux_liq_density_correlation(t_si)
!==========================================================================

!THIS FUNCTION IMPLEMENTS THE DENSITY IN KG/M3 OF THE FREEZING LIQUID
!AS A FUNCTION OF ABSOLUTE TEMPERATURE T_SI IN K FROM AN APPROXIMATE
!CORRELATION FIT BETWEEN 252 AND 273 K WITH RMS = 1.2 E-4 IN D/DT

implicit none

real*8 aux_liq_density_correlation
real*8 t_si, tt, dt, a1, a2, a3, tr, dr

tt = tp_temperature_si          !TRIPLE POINT TEMPERATURE IN K
dt = tp_density_liq_iapws95_si  !TRIPLE POINT DENSITY OF LIQUID WATER

a1 = -1.78582981492113d0
a2 = -12.2325084306734d0
a3 = -52.8236936433529d0

aux_liq_density_correlation = errorreturn

if(t_si <= 0d0) return

tr = t_si / tt - 1d0
dr = a1 * tr + a2 * tr ** 2 + a3 * tr ** 3

aux_liq_density_correlation = dt * (dr + 1d0)

return

end function

!==========================================================================
function aux_temperature_correlation(p_si)
!==========================================================================

!THIS FUNCTION IMPLEMENTS THE MELTING TEMPERATURE IN K OF ICE AS AN APPROXIMATE
!FUNCTION OF THE ABSOLUTE PRESSURE IN PA FROM A CORRELATION FIT
!BETWEEN 273 K AND 252 K WITH RMS = 1.4E-5 IN T/TT

implicit none

real*8 aux_temperature_correlation
real*8 p_si
real*8 pt, tt, a1, a2, tr, pr

pt = tp_pressure_iapws95_si  !IAPWS-95 TRIPLE POINT PRESSURE IN PA
tt = tp_temperature_si       !TRIPLE POINT TEMPERATURE OF WATER

a1 = -1.67329759176351d-07
a2 = -2.02262929999658d-13

aux_temperature_correlation = errorreturn

if(p_si <= 0d0) return

pr = p_si / pt - 1d0
tr = a1 * pr + a2 * pr ** 2

aux_temperature_correlation = tt * (tr + 1d0)

return

end function

!==========================================================================
subroutine init_it_ctrl_ice_liq()
!==========================================================================

implicit none

real*8 dl_triple, t_triple 

!TRIPLE POINT
dl_triple = tp_density_liq_iapws95_si
t_triple = tp_temperature_si

if(ctrl_initialized == isok) return

ctrl_initialized = isok

!SET DEFAULT VALUES AND MODES FOR ITERATION
ctrl_mode_ice = 0
ctrl_mode_liquid = 0
ctrl_mode_temperature = 0
ctrl_loop_maximum = 100
ctrl_init_d_liq = dl_triple
ctrl_init_t = t_triple
ctrl_eps_exit_p = -0.0000001d0 !relative, 0.1 ppm

end subroutine

!==========================================================================
subroutine set_it_ctrl_ice_liq(key, value)
!==========================================================================

implicit none

character*13 key
real*8 value

!THIS SUB SETS CONTROL PARAMETERS FOR THE ITERATION USED TO COMPUTE
!ICE-LIQUID EQUILIBRIUM

!KEY                    VALUE
!'IT_STEPS     '        0           SET ITERATION NUMBER TO DEFAULT (100)
!'IT_STEPS     '        N > 0       SET ITERATION NUMBER TO N
!'IT_STEPS     '       -1           DO NOT ITERATE, USE INITIAL LIQUID DENSITY TO COMPUTE LIQUID PRESSURE

!'INIT_LIQ_DENS'        0           USE DEFAULT LIQUID DENSITY TO START =
!                                   LIQUID DENSITY CORRELATION FUNCTION, D = AUX_LIQ_DENSITY_CORRELATION(T)
!'INIT_LIQ_DENS'       -1           USE TRIPLE POINT LIQUID DENSITY TO START
!'INIT_LIQ_DENS'        D > 0       USE VALUE D AS LIQUID DENSITY TO START

!'INIT_TEMP    '        0           USE DEFAULT TEMPERATURE TO START ( = AUX_MELT_TEMPERATURE(P))
!'INIT_TEMP    '       -1           USE TRIPLE POINT TEMPERATURE TO START
!'INIT_TEMP    '        T > 0       USE VALUE T AS TEMPERATURE TO START

!'TOL_LIQ_PRESS'        0           USE DEFAULT EXIT ACCURACY FOR LIQUID PRESSURE (0.1 PPM)
!'TOL_LIQ_PRESS'        EPS         USE EPS AS EXIT ACCURACY FOR LIQUID PRESSURE (EPS < 0 MEANS RELATIVE ERROR)


call init_it_ctrl_ice_liq

call clear_ice_liq_state

select case (trim(key))

  case ('it_steps')                                  !ITERATION STEPS
    if(value == 0d0)then; ctrl_loop_maximum = 100    !DEFAULT = 100
    elseif(value < 0d0)then; ctrl_loop_maximum = -1
    else;   ctrl_loop_maximum = nint(value)
    endif

  case ('init_liq_dens')                             !START LIQUID DENSITY
    if(value == 0d0)then; ctrl_mode_liquid = 0       !DEFAULT = AUX POLYNOMIAL
    elseif(value < (-1d0))then; !ignore it
    elseif(value < 0d0)then;  ctrl_mode_liquid = nint(value)
    else; ctrl_mode_liquid = 1; ctrl_init_d_liq = value
    endif

  case ('init_temp')                                 !START TEMPERATURE
    if(value == 0d0)then; ctrl_mode_temperature = 0  !DEFAULT = AUX POLYNOMIAL
    elseif(value < (-1d0))then;                     !IGNORE IT
    elseif(value < 0d0)then; ctrl_mode_temperature = nint(value)
    else; ctrl_mode_temperature = 1; ctrl_init_t = value
    endif

  case ('tol_liq_press')                             !REQUIRED LIQUID PRESSURE TOLERANCE
    if(value == 0d0)then; ctrl_eps_exit_p = -0.0000001d0   !DEFAULT = 0.1 PPM RELATIVE
    else; ctrl_eps_exit_p = value
    endif

  case default; write(*,*)key,' not supported'

end select

end subroutine

!==========================================================================
subroutine set_ice_liq_state(t, pl, gi, gl, di, dl)
!==========================================================================

implicit none

real*8 t, pl, gi, gl, di, dl

!STORES THE ACTUAL PROPERTIES AS THE CURRENT EQUILIBRIUM STATE DESCRIPTOR

equi_ice_liq_done = isok

equi_ice_liq_t = t
equi_ice_liq_p = pl
equi_ice_liq_g_ice = gi
equi_ice_liq_g_liq = gl
equi_ice_liq_d_ice = di
equi_ice_liq_d_liq = dl

end subroutine

!==========================================================================
subroutine clear_ice_liq_state()
!==========================================================================

implicit none

!CLEARS THE CURRENT EQUILIBRIUM STATE DESCRIPTOR

equi_ice_liq_done = 0

end subroutine

end module ice_liq_4

module flu_3b

!#########################################################################

!THIS MODULE IMPLEMENTS THERMODYNAMIC PROPERTIES OF LIQUID WATER AND VAPOUR
!AS FUNCTIONS OF TEMPERATURE AND PRESSURE, COMPUTED NUMERICALLY FROM
!THE HELMHOLTZ FUNCTION OF FLUID WATER.

!#########################################################################

!IMPLEMENTATION IN FORTRAN BY D.G. WRIGHT
!FOR PUBLICATION IN OCEAN SCIENCE, AS DESCRIBED IN THE PAPERS

!FEISTEL, R., WRIGHT, D.G., JACKETT, D.R., MIYAGAWA, K., REISSMANN, J.H.,
!WAGNER, W., OVERHOFF, U., GUDER, C., FEISTEL, A., MARION, G.M.:
!NUMERICAL IMPLEMENTATION AND OCEANOGRAPHIC APPLICATION OF THE THERMODYNAMIC
!POTENTIALS OF WATER, VAPOUR, ICE, SEAWATER AND AIR. PART I: BACKGROUND AND EQUATIONS. 
!OCEAN SCIENCES, 2009, IN PREPARATION.

!WRIGHT, D.G., FEISTEL, R., JACKETT, D.R., MIYAGAWA, K., REISSMANN, J.H., 
!WAGNER, W., OVERHOFF, U., GUDER, C., FEISTEL, A., MARION, G.M.:
!NUMERICAL IMPLEMENTATION AND OCEANOGRAPHIC APPLICATION OF THE THERMODYNAMIC
!POTENTIALS OF WATER, VAPOUR, ICE, SEAWATER AND AIR. PART II: THE LIBRARY ROUTINES, 
!OCEAN SCIENCES., 2009, IN PREPARATION.

!FEISTEL, R., KRETZSCHMAR, H.-J., SPAN, R., HAGEN, E., WRIGHT, D.G., JACKETT, D.R.:
!THERMODYNAMIC PROPERTIES OF SEA AIR.
!OCEAN SCIENCE DISCUSSION 6(2009)2193-2325.

!#########################################################################

!THIS MODULE REQUIRES THE LIBRARY MODULES:
!     CONSTANTS_0, FILE CONSTANTS_0.F90
!     FLU_2,       FILE FLU_2.F90
!     FLU_3A,      FILE FLU_3A.F90
!NESTED USE ASSOCIATIONS
!     CONVERT_0,   FILE CONVERT_0.F90
!     MATHS_0,     FILE MATHS_0.F90
!     FLU_1,       FILE FLU_1.F90

!#########################################################################

use constants_0
use flu_2
use flu_3a

implicit none
private

character*16, private :: version = '8 Jun 2010'

public :: liq_cp_si, liq_cv_si, liq_enthalpy_si, liq_entropy_si, &
          liq_expansion_si, liq_gibbs_energy_si, liq_internal_energy_si, &
          liq_kappa_s_si, liq_kappa_t_si, liq_lapserate_si, liq_soundspeed_si, &
          vap_cp_si, vap_cv_si, vap_enthalpy_si, vap_entropy_si, &
          vap_expansion_si, vap_gibbs_energy_si, vap_internal_energy_si, &
          vap_kappa_s_si, vap_kappa_t_si, vap_lapserate_si, vap_soundspeed_si

contains

!=========================================================================
function liq_cp_si(t_si, p_si)
!=========================================================================

!OUTPUT:
!CP(T,P) = T * (DETA/DT)_P  ISOBARIC HEAT CAPACITY OF LIQUID WATER IN J/(KG K)

!INPUTS:
!T_SI      ABSOLUTE TEMPERATURE IN K
!P_SI      ABSOLUTE PRESSURE IN PA

!CHECK VALUE WITH DEFAULT SETTINGS: liq_cp_si(300, 1e5) = 4180.63952202

!NOTE: THE ACCURACY OF THIS FUNCTION DEPENDS ON THE ITERATION SETTINGS FOR
!      DENSITY COMPUTED IN FLU_3A

implicit none
real*8 liq_cp_si, t_si, p_si
real*8 d

liq_cp_si = errorreturn

if(t_si <= 0d0) return
if(p_si <= 0d0) return

d = liq_density_si(t_si, p_si)
if(d == errorreturn) return

liq_cp_si = flu_cp_si(t_si, d)

end function

!=========================================================================
function liq_cv_si(t_si, p_si)
!=========================================================================

!OUTPUT:
!CV(T,P) = T * (DETA/DT)_D  ISOCHORIC HEAT CAPACITY OF LIQUID WATER IN J/(KG K)

!INPUTS:
!T_SI      ABSOLUTE TEMPERATURE IN K
!P_SI      ABSOLUTE PRESSURE IN PA

!CHECK VALUE WITH DEFAULT SETTINGS: liq_cv_si(300, 1e5) = 4130.17861503

!NOTE: THE ACCURACY OF THIS FUNCTION DEPENDS ON THE ITERATION SETTINGS FOR
!      DENSITY COMPUTED IN FLU_3A

implicit none
real*8 liq_cv_si, t_si, p_si
real*8 d

liq_cv_si = errorreturn

if(t_si <= 0d0) return
if(p_si <= 0d0) return

d = liq_density_si(t_si, p_si)
if(d == errorreturn) return

liq_cv_si = flu_cv_si(t_si, d)

end function

!=========================================================================
function liq_enthalpy_si(t_si, p_si)
!=========================================================================

!OUTPUT:
!H(T,P) = F - T*(DF/DT)_D + D*(DF/DD)_T ENTHALPY OF LIQUID WATER IN J/KG

!INPUTS:
!T_SI      ABSOLUTE TEMPERATURE IN K
!P_SI      ABSOLUTE PRESSURE IN PA

!CHECK VALUE WITH DEFAULT SETTINGS: liq_enthalpy_si(300, 1e5) = 112653.679689

!NOTE: THE ACCURACY OF THIS FUNCTION DEPENDS ON THE ITERATION SETTINGS FOR
!      DENSITY COMPUTED IN FLU_3A

implicit none
real*8 liq_enthalpy_si, t_si, p_si
real*8 d

liq_enthalpy_si = errorreturn

if(t_si <= 0d0) return
if(p_si <= 0d0) return

d = liq_density_si(t_si, p_si)
if(d == errorreturn) return

liq_enthalpy_si = flu_enthalpy_si(t_si, d)

end function

!=========================================================================
function liq_entropy_si(t_si, p_si)
!=========================================================================

!OUTPUT:
!ETA(T,P) = - (DF/DT)_D ENTROPY OF LIQUID WATER IN J/(KG K)

!INPUTS:
!T_SI      ABSOLUTE TEMPERATURE IN K
!P_SI      ABSOLUTE PRESSURE IN PA

!CHECK VALUE WITH DEFAULT SETTINGS: liq_entropy_si(300, 1e5) = 393.062433815

!NOTE: THE ACCURACY OF THIS FUNCTION DEPENDS ON THE ITERATION SETTINGS FOR
!      DENSITY COMPUTED IN FLU_3A

implicit none
real*8 liq_entropy_si, t_si, p_si
real*8 d

liq_entropy_si = errorreturn

if(t_si <= 0d0) return
if(p_si <= 0d0) return

d = liq_density_si(t_si, p_si)
if(d == errorreturn) return

liq_entropy_si = flu_entropy_si(t_si, d)

end function

!=========================================================================
function liq_expansion_si(t_si, p_si)
!=========================================================================

!OUTPUT:
!ALPHA(T,P) = -(1/D) * (DD/DT)_P  THERMAL EXPANSION OF LIQUID WATER IN 1/K

!INPUTS:
!T_SI      ABSOLUTE TEMPERATURE IN K
!P_SI      ABSOLUTE PRESSURE IN PA

!CHECK VALUE WITH DEFAULT SETTINGS: liq_expansion_si(300, 1e5) = 2.74803716256E-04


!NOTE: THE ACCURACY OF THIS FUNCTION DEPENDS ON THE ITERATION SETTINGS FOR
!      DENSITY COMPUTED IN FLU_3A

implicit none
real*8 liq_expansion_si, t_si, p_si
real*8 d

liq_expansion_si = errorreturn

if(t_si <= 0d0) return
if(p_si <= 0d0) return

d = liq_density_si(t_si, p_si)
if(d == errorreturn) return

liq_expansion_si = flu_expansion_si(t_si, d)

end function

!=========================================================================
function liq_gibbs_energy_si(t_si, p_si)
!=========================================================================

!OUTPUT:
!G(T,P) = F + D*(DF/DD)_T   GIBBS ENERGY OF LIQUID WATER IN J/KG

!INPUTS:
!T_SI      ABSOLUTE TEMPERATURE IN K
!P_SI      ABSOLUTE PRESSURE IN PA

!CHECK VALUE WITH DEFAULT SETTINGS: liq_gibbs_energy_si(300, 1e5) = -5265.05045577

!NOTE: THE ACCURACY OF THIS FUNCTION DEPENDS ON THE ITERATION SETTINGS FOR
!      DENSITY COMPUTED IN FLU_3A

implicit none
real*8 liq_gibbs_energy_si, t_si, p_si
real*8 d

liq_gibbs_energy_si = errorreturn

if(t_si <= 0d0) return
if(p_si <= 0d0) return

d = liq_density_si(t_si, p_si)
if(d == errorreturn) return

liq_gibbs_energy_si = flu_gibbs_energy_si(t_si, d)

end function

!=========================================================================
function liq_internal_energy_si(t_si, p_si)
!=========================================================================

!OUTPUT:
!U(T,P) = F - T*(DF/DT)_D INTERNAL ENERGY OF LIQUID WATER IN J/KG

!INPUTS:
!T_SI      ABSOLUTE TEMPERATURE IN K
!P_SI      ABSOLUTE PRESSURE IN PA

!CHECK VALUE WITH DEFAULT SETTINGS: liq_internal_energy_si(300, 1e5) = 112553.334133


!NOTE: THE ACCURACY OF THIS FUNCTION DEPENDS ON THE ITERATION SETTINGS FOR
!      DENSITY COMPUTED IN FLU_3A

implicit none
real*8 liq_internal_energy_si, t_si, p_si
real*8 d

liq_internal_energy_si = errorreturn

if(t_si <= 0d0) return
if(p_si <= 0d0) return

d = liq_density_si(t_si, p_si)
if(d == errorreturn) return

liq_internal_energy_si = flu_internal_energy_si(t_si, d)

end function

!=========================================================================
function liq_kappa_s_si(t_si, p_si)
!=========================================================================

!OUTPUT:
!KAPPA_S(T,P) = (1/D) * (DD/DP)_ETA  ISOTHERMAL COMPRESSIBILITY OF LIQUID WATER IN 1/PA

!INPUTS:
!T_SI      ABSOLUTE TEMPERATURE IN K
!P_SI      ABSOLUTE PRESSURE IN PA

!CHECK VALUE WITH DEFAULT SETTINGS: liq_kappa_s_si(300, 1e5) = 4.45077521253E-10

!NOTE: THE ACCURACY OF THIS FUNCTION DEPENDS ON THE ITERATION SETTINGS FOR
!      DENSITY COMPUTED IN FLU_3A

implicit none
real*8 liq_kappa_s_si, t_si, p_si
real*8 d

liq_kappa_s_si = errorreturn

if(t_si <= 0d0) return
if(p_si <= 0d0) return

d = liq_density_si(t_si, p_si)
if(d == errorreturn) return

liq_kappa_s_si = flu_kappa_s_si(t_si, d)

end function

!=========================================================================
function liq_kappa_t_si(t_si, p_si)
!=========================================================================

!OUTPUT:
!KAPPA_T(T,P) = (1/D) * (DD/DP)_ETA  ISOTHERMAL COMPRESSIBILITY OF LIQUID WATER IN 1/K

!INPUTS:
!T_SI      ABSOLUTE TEMPERATURE IN K
!P_SI      ABSOLUTE PRESSURE IN PA

!CHECK VALUE WITH DEFAULT SETTINGS: liq_kappa_t_si(300, 1e5) = 4.50515304336E-10

!NOTE: THE ACCURACY OF THIS FUNCTION DEPENDS ON THE ITERATION SETTINGS FOR
!      DENSITY COMPUTED IN FLU_3A

implicit none
real*8 liq_kappa_t_si, t_si, p_si
real*8 d

liq_kappa_t_si = errorreturn

if(t_si <= 0d0) return
if(p_si <= 0d0) return

d = liq_density_si(t_si, p_si)
if(d == errorreturn) return

liq_kappa_t_si = flu_kappa_t_si(t_si, d)

end function

!=========================================================================
function liq_lapserate_si(t_si, p_si)
!=========================================================================

!OUTPUT:
!GAMMA(T,P) = (DT/DP)_ETA  ADIABATIC LAPSE RATE OF LIQUID WATER IN K/PA

!INPUTS:
!T_SI      ABSOLUTE TEMPERATURE IN K
!P_SI      ABSOLUTE PRESSURE IN PA

!CHECK VALUE WITH DEFAULT SETTINGS: liq_lapserate_si(300, 1e5) = 1.97878804448E-08

!NOTE: THE ACCURACY OF THIS FUNCTION DEPENDS ON THE ITERATION SETTINGS FOR
!      DENSITY COMPUTED IN FLU_3A

implicit none
real*8 liq_lapserate_si, t_si, p_si
real*8 d

liq_lapserate_si = errorreturn

if(t_si <= 0d0) return
if(p_si <= 0d0) return

d = liq_density_si(t_si, p_si)
if(d == errorreturn) return

liq_lapserate_si = flu_lapserate_si(t_si, d)

end function

!=========================================================================
function liq_soundspeed_si(t_si, p_si)
!=========================================================================

!OUTPUT:
!C(T,P) = SQRT[ (DP/dD)_ETA ] SOUND SPEED OF LIQUID WATER IN M/S

!INPUTS:
!T_SI      ABSOLUTE TEMPERATURE IN K
!P_SI      ABSOLUTE PRESSURE IN PA

!CHECK VALUE WITH DEFAULT SETTINGS: liq_soundspeed_si(300, 1e5) = 1501.52041506


!NOTE: THE ACCURACY OF THIS FUNCTION DEPENDS ON THE ITERATION SETTINGS FOR
!      DENSITY COMPUTED IN FLU_3A

implicit none
real*8 liq_soundspeed_si, t_si, p_si
real*8 d

liq_soundspeed_si = errorreturn

if(t_si <= 0d0) return
if(p_si <= 0d0) return

d = liq_density_si(t_si, p_si)
if(d == errorreturn) return

liq_soundspeed_si = flu_soundspeed_si(t_si, d)

end function

!=========================================================================
function vap_cp_si(t_si, p_si)
!=========================================================================

!OUTPUT:
!CP(T,P) = T * (DETA/DT)_P  ISOBARIC HEAT CAPACITY OF WATER VAPOUR IN J/(KG K)

!INPUTS:
!T_SI      ABSOLUTE TEMPERATURE IN K
!P_SI      ABSOLUTE PRESSURE IN PA

!CHECK VALUE WITH DEFAULT SETTINGS: vap_cp_si(300, 1e3) = 1874.12149028

!NOTE: THE ACCURACY OF THIS FUNCTION DEPENDS ON THE ITERATION SETTINGS FOR
!      DENSITY COMPUTED IN FLU_3A

implicit none
real*8 vap_cp_si, t_si, p_si
real*8 d

vap_cp_si = errorreturn

if(t_si <= 0d0) return
if(p_si <= 0d0) return

d = vap_density_si(t_si, p_si)
if(d == errorreturn) return

vap_cp_si = flu_cp_si(t_si, d)

end function

!=========================================================================
function vap_cv_si(t_si, p_si)
!=========================================================================

!OUTPUT:
!CV(T,P) = T * (DETA/DT)_D  ISOCHORIC HEAT CAPACITY OF WATER VAPOUR IN J/(KG K)

!INPUTS:
!T_SI      ABSOLUTE TEMPERATURE IN K
!P_SI      ABSOLUTE PRESSURE IN PA

!CHECK VALUE WITH DEFAULT SETTINGS: vap_cv_si(300, 1e3) = 1410.22845789

!NOTE: THE ACCURACY OF THIS FUNCTION DEPENDS ON THE ITERATION SETTINGS FOR
!      DENSITY COMPUTED IN FLU_3A

implicit none
real*8 vap_cv_si, t_si, p_si
real*8 d

vap_cv_si = errorreturn

if(t_si <= 0d0) return
if(p_si <= 0d0) return

d = vap_density_si(t_si, p_si)
if(d == errorreturn) return

vap_cv_si = flu_cv_si(t_si, d)

end function

!=========================================================================
function vap_enthalpy_si(t_si, p_si)
!=========================================================================

!OUTPUT:
!H(T,P) = F - T*(DF/DT)_D + D*(DF/DD)_T ENTHALPY OF WATER VAPOUR IN J/KG

!INPUTS:
!T_SI      ABSOLUTE TEMPERATURE IN K
!P_SI      ABSOLUTE PRESSURE IN PA

!CHECK VALUE WITH DEFAULT SETTINGS: vap_enthalpy_si(300, 1e3) = 2551013.47892

!NOTE: THE ACCURACY OF THIS FUNCTION DEPENDS ON THE ITERATION SETTINGS FOR
!      DENSITY COMPUTED IN FLU_3A

implicit none
real*8 vap_enthalpy_si, t_si, p_si
real*8 d

vap_enthalpy_si = errorreturn

if(t_si <= 0d0) return
if(p_si <= 0d0) return

d = vap_density_si(t_si, p_si)
if(d == errorreturn) return

vap_enthalpy_si = flu_enthalpy_si(t_si, d)

end function

!=========================================================================
function vap_entropy_si(t_si, p_si)
!=========================================================================

!OUTPUT:
!ETA(T,P) = - (DF/DT)_D ENTROPY OF WATER VAPOUR IN J/(KG K)

!INPUTS:
!T_SI      ABSOLUTE TEMPERATURE IN K
!P_SI      ABSOLUTE PRESSURE IN PA

!CHECK VALUE WITH DEFAULT SETTINGS: vap_entropy_si(300, 1e3) = 9103.67940087

!NOTE: THE ACCURACY OF THIS FUNCTION DEPENDS ON THE ITERATION SETTINGS FOR
!      DENSITY COMPUTED IN FLU_3A

implicit none
real*8 vap_entropy_si, t_si, p_si
real*8 d

vap_entropy_si = errorreturn

if(t_si <= 0d0) return
if(p_si <= 0d0) return

d = vap_density_si(t_si, p_si)
if(d == errorreturn) return

vap_entropy_si = flu_entropy_si(t_si, d)

end function

!=========================================================================
function vap_expansion_si(t_si, p_si)
!=========================================================================

!OUTPUT:
!ALPHA(T,P) = -(1/D) * (DD/DT)_P  THERMAL EXPANSION OF WATER VAPOUR IN 1/K

!INPUTS:
!T_SI      ABSOLUTE TEMPERATURE IN K
!P_SI      ABSOLUTE PRESSURE IN PA

!CHECK VALUE WITH DEFAULT SETTINGS: vap_expansion_si(300, 1e3) = 3.34352010567E-03

!NOTE: THE ACCURACY OF THIS FUNCTION DEPENDS ON THE ITERATION SETTINGS FOR
!      DENSITY COMPUTED IN FLU_3A

implicit none
real*8 vap_expansion_si, t_si, p_si
real*8 d

vap_expansion_si = errorreturn

if(t_si <= 0d0) return
if(p_si <= 0d0) return

d = vap_density_si(t_si, p_si)
if(d == errorreturn) return

vap_expansion_si = flu_expansion_si(t_si, d)

end function

!=========================================================================
function vap_gibbs_energy_si(t_si, p_si)
!=========================================================================

!OUTPUT:
!G(T,P) = F + D*(DF/DD)_T   GIBBS ENERGY OF WATER VAPOUR IN J/KG

!INPUTS:
!T_SI      ABSOLUTE TEMPERATURE IN K
!P_SI      ABSOLUTE PRESSURE IN PA

!CHECK VALUE WITH DEFAULT SETTINGS: vap_gibbs_energy_si(300, 1e3) = -180090.341338

!NOTE: THE ACCURACY OF THIS FUNCTION DEPENDS ON THE ITERATION SETTINGS FOR
!      DENSITY COMPUTED IN FLU_3A

implicit none
real*8 vap_gibbs_energy_si, t_si, p_si
real*8 d

vap_gibbs_energy_si = errorreturn

if(t_si <= 0d0) return
if(p_si <= 0d0) return

d = vap_density_si(t_si, p_si)
if(d == errorreturn) return

vap_gibbs_energy_si = flu_gibbs_energy_si(t_si, d)

end function

!=========================================================================
function vap_internal_energy_si(t_si, p_si)
!=========================================================================

!OUTPUT:
!U(T,P) = F - T*(DF/DT)_D INTERNAL ENERGY OF WATER VAPOUR IN J/KG

!INPUTS:
!T_SI      ABSOLUTE TEMPERATURE IN K
!P_SI      ABSOLUTE PRESSURE IN PA

!CHECK VALUE WITH DEFAULT SETTINGS: vap_internal_energy_si(300, 1e3) = 2412625.00085

!NOTE: THE ACCURACY OF THIS FUNCTION DEPENDS ON THE ITERATION SETTINGS FOR
!      DENSITY COMPUTED IN FLU_3A

implicit none
real*8 vap_internal_energy_si, t_si, p_si
real*8 d

vap_internal_energy_si = errorreturn

if(t_si <= 0d0) return
if(p_si <= 0d0) return

d = vap_density_si(t_si, p_si)
if(d == errorreturn) return

vap_internal_energy_si = flu_internal_energy_si(t_si, d)

end function

!=========================================================================
function vap_kappa_s_si(t_si, p_si)
!=========================================================================

!OUTPUT:
!KAPPA_S(T,P) = (1/D) * (DD/DP)_ETA  ISENTROPIC COMPRESSIBILITY OF WATER VAPOUR IN 1/PA

!INPUTS:
!T_SI      ABSOLUTE TEMPERATURE IN K
!P_SI      ABSOLUTE PRESSURE IN PA

!CHECK VALUE WITH DEFAULT SETTINGS: vap_kappa_s_si(300, 1e3) = 7.52840457971E-04

!NOTE: THE ACCURACY OF THIS FUNCTION DEPENDS ON THE ITERATION SETTINGS FOR
!      DENSITY COMPUTED IN FLU_3A

implicit none
real*8 vap_kappa_s_si, t_si, p_si
real*8 d

vap_kappa_s_si = errorreturn

if(t_si <= 0d0) return
if(p_si <= 0d0) return

d = vap_density_si(t_si, p_si)
if(d == errorreturn) return

vap_kappa_s_si = flu_kappa_s_si(t_si, d)

end function

!=========================================================================
function vap_kappa_t_si(t_si, p_si)
!=========================================================================

!OUTPUT:
!KAPPA_T(T,P) = (1/D) * (DD/DP)_ETA  ISOTHERMAL COMPRESSIBILITY OF WATER VAPOUR IN 1/K

!INPUTS:
!T_SI      ABSOLUTE TEMPERATURE IN K
!P_SI      ABSOLUTE PRESSURE IN PA

!CHECK VALUE WITH DEFAULT SETTINGS: vap_kappa_t_si(300, 1e3) = 1.00048646242E-03

!NOTE: THE ACCURACY OF THIS FUNCTION DEPENDS ON THE ITERATION SETTINGS FOR
!      DENSITY COMPUTED IN FLU_3A

implicit none
real*8 vap_kappa_t_si, t_si, p_si
real*8 d

vap_kappa_t_si = errorreturn

if(t_si <= 0d0) return
if(p_si <= 0d0) return

d = vap_density_si(t_si, p_si)
if(d == errorreturn) return

vap_kappa_t_si = flu_kappa_t_si(t_si, d)

end function

!=========================================================================
function vap_lapserate_si(t_si, p_si)
!=========================================================================

!OUTPUT:
!GAMMA(T,P) = (DT/DP)_ETA  ADIABATIC LAPSE RATE OF WATER VAPOUR IN K/PA

!INPUTS:
!T_SI      ABSOLUTE TEMPERATURE IN K
!P_SI      ABSOLUTE PRESSURE IN PA

!CHECK VALUE WITH DEFAULT SETTINGS: vap_lapserate_si(300, 1e3) = 7.40674488635E-02


!NOTE: THE ACCURACY OF THIS FUNCTION DEPENDS ON THE ITERATION SETTINGS FOR
!      DENSITY COMPUTED IN FLU_3A

implicit none
real*8 vap_lapserate_si, t_si, p_si
real*8 d

vap_lapserate_si = errorreturn

if(t_si <= 0d0) return
if(p_si <= 0d0) return

d = vap_density_si(t_si, p_si)
if(d == errorreturn) return

vap_lapserate_si = flu_lapserate_si(t_si, d)

end function

!=========================================================================
function vap_soundspeed_si(t_si, p_si)
!=========================================================================

!OUTPUT:
!C(T,P) = SQRT[ (DP/DD)_ETA ] SOUND SPEED OF WATER VAPOUR IN M/S

!INPUTS:
!T_SI      ABSOLUTE TEMPERATURE IN K,
!P_SI      ABSOLUTE PRESSURE IN PA

!CHECK VALUE WITH DEFAULT SETTINGS: vap_soundspeed_si(300, 1e3) = 428.744430495

!NOTE: THE ACCURACY OF THIS FUNCTION DEPENDS ON THE ITERATION SETTINGS FOR
!      DENSITY COMPUTED IN FLU_3A

implicit none
real*8 vap_soundspeed_si, t_si, p_si
real*8 d

vap_soundspeed_si = errorreturn

if(t_si <= 0d0) return
if(p_si <= 0d0) return

d = vap_density_si(t_si, p_si)
if(d == errorreturn) return

vap_soundspeed_si = flu_soundspeed_si(t_si, d)

end function

end module flu_3b

module flu_3a

!#########################################################################

!THIS MODULE IMPLEMENTS THE GIBBS FUNCTIONS OF LIQUID WATER AND VAPOUR
!DEPENDING ON TEMPERATURE AND PRESSURE, AS WELL AS THEIR PARTIAL DERIVATIVES,
!COMPUTED NUMERICALLY FROM THE HELMHOLTZ FUNCTION OF FLUID WATER, IAPWS-95.

!#########################################################################

!IMPLEMENTATION IN FORTRAN BY D.G. WRIGHT
!FOR PUBLICATION IN OCEAN SCIENCE, AS DESCRIBED IN THE PAPERS

!FEISTEL, R., WRIGHT, D.G., JACKETT, D.R., MIYAGAWA, K., REISSMANN, J.H.,
!WAGNER, W., OVERHOFF, U., GUDER, C., FEISTEL, A., MARION, G.M.:
!NUMERICAL IMPLEMENTATION AND OCEANOGRAPHIC APPLICATION OF THE THERMODYNAMIC
!POTENTIALS OF WATER, VAPOUR, ICE, SEAWATER AND AIR. PART I: BACKGROUND AND EQUATIONS. 
!OCEAN SCIENCES, 2009, IN PREPARATION.

!WRIGHT, D.G., FEISTEL, R., JACKETT, D.R., MIYAGAWA, K., REISSMANN, J.H., 
!WAGNER, W., OVERHOFF, U., GUDER, C., FEISTEL, A., MARION, G.M.:
!NUMERICAL IMPLEMENTATION AND OCEANOGRAPHIC APPLICATION OF THE THERMODYNAMIC
!POTENTIALS OF WATER, VAPOUR, ICE, SEAWATER AND AIR. PART II: THE LIBRARY ROUTINES, 
!OCEAN SCIENCES., 2009, IN PREPARATION.

!FEISTEL, R., KRETZSCHMAR, H.-J., SPAN, R., HAGEN, E., !WRIGHT, D.G., JACKETT, D.R.:
!THERMODYNAMIC PROPERTIES OF SEA AIR.
!OCEAN SCIENCE DISCUSSION 6(2009)2193-2325.

!#########################################################################

!THIS MODULE REQUIRES THE LIBRARY MODULES:
!     CONSTANTS_0, FILE CONSTANTS_0.F90
!     MATHS_0,     FILE MATHS_0.F90
!     CONVERT_0,   FILE CONVERT_0.F90
!     FLU_1,       FILE FLU_1.F90

!#########################################################################

use constants_0
use convert_0
use maths_0
use flu_1

implicit none
private

character*16, private :: version = '8 Jun 2010'

public :: get_it_ctrl_density, liq_density_si, liq_g_si, &
          set_it_ctrl_density, vap_density_si, vap_g_si

integer, private :: ctrl_mode_liquid, ctrl_mode_vapour, ctrl_loop_maximum, &
         ctrl_method_vapour, ctrl_method_liquid, ctrl_initialized 
real*8, private :: ctrl_density_liquid, ctrl_density_vapour, ctrl_eps_exit_liquid,  &
        ctrl_eps_exit_vapour, ctrl_density2_liquid, ctrl_density2_vapour

!Coefficients of IF97
!Coefficients of region 1
integer, private, save :: i1i(34), j1i(34)
real*8,  private, save :: n1i(34)

!Coefficients of region 2, ideal part
integer, private, save :: j0i(9)
real*8,  private, save :: n0i(9)

!Coefficients of region 2, residual part
integer, private, save :: iri(43), jri(43)
real*8,  private, save :: nri(43)

!Coefficients of the F03 Gibbs function
integer, private, save :: maxt = 7, maxp = 6
real*8, private, save :: gc03(0:7, 0:6)

contains

!==========================================================================
function liq_g_si(drv_t, drv_p, t_si, p_si)
!==========================================================================

!THIS IMPLEMENTS THE GIBBS FUNCTION OF LIQUID WATER COMPUTED FROM IAPWS-95
!AND ITS FIRST AND SECOND DERIVATIVES WITH RESPECT TO THE ABSOLUTE TEMPERATURE T_SI
!AND THE ABSOLUTE PRESSURE P_SI

!OUTPUT: LIQ_G_SI = SPECIFIC GIBBS ENERGY IN J/KG OR ITS DERIVATIVE

!INPUT:  DRV_T = ORDER OF TEMPERATURE DERIVATIVE, 0 <= DRV_T <= 2
!        DRV_P = ORDER OF PRESSURE DERIVATIVE, 0 <= DRV_P + DRV_T <= 2
!        T_SI = ABSOLUTE TEMPERATURE, IN K
!        P_SI = ABSOLUTE PRESSURE, IN PA
!
!CHECK VALUES WITH DEFAULT SETTINGS:
!liq_g_si( 0, 0, 300, 1E5) =-5265.05045577
!liq_g_si( 1, 0, 300, 1E5) =-393.062433815
!liq_g_si( 0, 1, 300, 1E5) = 1.00345555938E-03
!liq_g_si( 2, 0, 300, 1E5) =-13.9354650734
!liq_g_si( 1, 1, 300, 1E5) = 2.75753316815E-07
!liq_g_si( 0, 2, 300, 1E5) =-4.52072086722E-13

!NOTE: THE ACCURACY OF THIS FUNCTIONS DEPENDS ON THE ITERATION SETTINGS OF THIS MODULE

implicit none
integer drv_t, drv_p
real*8 liq_g_si, t_si, p_si
real*8 g, d

liq_g_si = errorreturn

if(t_si <= 0d0) return
if(p_si <= 0d0) return

d = liq_density_si(t_si, p_si)  !NUMERICAL INVERSE FUNCTION OF IAPWS-95

if(d == errorreturn) return
if(d <= 0d0) return

g = flu_t_p_derivative_si(drv_t, drv_p, t_si, d)
if(g == errorreturn) return

liq_g_si = g

end function

!==========================================================================
function vap_g_si(drv_t, drv_p, t_si, p_si)
!==========================================================================

!THIS IMPLEMENTS THE GIBBS FUNCTION OF WATER VAPOUR COMPUTED FROM IAPWS-95
!AND ITS FIRST AND SECOND DERIVATIVES WITH RESPECT TO THE ABSOLUTE TEMPERATURE T_SI
!AND THE ABSOLUTE PRESSURE P_SI

!OUTPUT: LIQ_G_SI = SPECIFIC GIBBS ENERGY IN J/KG OR ITS DERIVATIVE

!INPUT:  DRV_T = ORDER OF TEMPERATURE DERIVATIVE, 0 <= DRV_T <= 2
!        DRV_P = ORDER OF PRESSURE DERIVATIVE, 0 <= DRV_P + DRV_T <= 2
!        T_SI = ABSOLUTE TEMPERATURE, IN K
!        P_SI = ABSOLUTE PRESSURE, IN PA

!CHECK VALUES WITH DEFAULT SETTINGS:
!vap_g_si( 0, 0, 300, 1E3) =-180090.341338
!vap_g_si( 1, 0, 300, 1E3) =-9103.67940087
!vap_g_si( 0, 1, 300, 1E3) = 138.388478069
!vap_g_si( 2, 0, 300, 1E3) =-6.24707163427
!vap_g_si( 1, 1, 300, 1E3) = 0.462704658818
!vap_g_si( 0, 2, 300, 1E3) =-0.138455798864

!NOTE: THE ACCURACY OF THIS FUNCTIONS DEPENDS ON THE ITERATION SETTINGS OF THIS MODULE

implicit none
integer drv_t, drv_p
real*8 vap_g_si, t_si, p_si
real*8 g, d

vap_g_si = errorreturn

if(t_si <= 0d0) return
if(p_si <= 0d0) return

d = vap_density_si(t_si, p_si)  !NUMERICAL INVERSE FUNCTION OF IAPWS-95

if(d == errorreturn) return
if(d <= 0) return

g = flu_t_p_derivative_si(drv_t, drv_p, t_si, d)
if(g == errorreturn) return

vap_g_si = g

end function

!==========================================================================
function liq_density_si(t_si, p_si)
!==========================================================================

!THIS FUNCTION RETURNS THE DENSITY OF LIQUID WATER AS A FUNCTION OF TEMPERATURE AND PRESSURE

!OUTPUT: 
!LIQ_DENSITY_SI = DENSITY IN KG/M3

!INPUT:  T_SI = ABSOLUTE TEMPERATURE, IN K
!        P_SI = ABSOLUTE PRESSURE, IN PA

!CHECK VALUE WITH DEFAULT SETTINGS: liq_density_si(300, 1E5) = 996.556340389

implicit none
integer maxit
real*8 liq_density_si, t_si, p_si
real*8 d, d2, eps

liq_density_si = errorreturn

if(t_si <= 0d0) return
if(p_si <= 0d0) return

!AVOID NUMERICAL PROBLEMS AT THE VERY CRITICAL POINT
if (t_si == cp_temperature_si .and. p_si == cp_pressure_si) then
  liq_density_si = cp_density_si
  return
end if

call init_it_ctrl_density

!CONSIDER THE CONTROL SETTINGS FOR THE ITERATION
select case (ctrl_mode_liquid)
  case (1);  d = ctrl_density_liquid
  case (0)
     if(t_si <= 623.15d0 .and. p_si <= 100000000d0) then  !dbg 'or' changed to 'and'
        !IF-97 AT SUBCRITICAL TEMPERATURE, LIQUID
        d = aux_liq_density_if97_si(t_si, p_si)
     elseif (t_si <= cp_temperature_si .and. p_si <= 16529000d0) then
        !IF-97 AT SUBCRITICAL TEMPERATURE, SUPERHEATED LIQUID
        d = aux_liq_density_if97_si(t_si, p_si)
     elseif (t_si <= 1073.15d0 .and. p_si <= 16529000d0) then
        !IF-97 AT SUBCRITICAL PRESSURE, FLUID
        d = aux_vap_density_if97_si(t_si, p_si)
     elseif (t_si <= 650d0 .and. p_si <= 35000000d0) then
        !CUBIC EOF IN THE CRITICAL REGION
        d = aux_liq_density_critical_si(t_si, p_si)
     elseif (t_si <= 650d0) then
        !DENSE FLUID
        d = 1000d0
     else
        !IDEAL GAS ANYWHERE ELSE
        d = aux_density_ideal_si(t_si, p_si)
     end if
  case (-1); d = aux_liq_density_if97_si(t_si, p_si)
  case (-2); d = aux_density_eos80_si(t_si, p_si)
  case (-3); d = aux_liq_density_f03_si(t_si, p_si)
  case default; return
end select

if(d == errorreturn) return
if(d <= 0d0) return

  if(ctrl_loop_maximum == 0)then
     maxit = 100
  elseif(ctrl_loop_maximum == (-1))then
     liq_density_si = d
     return
  elseif(ctrl_loop_maximum > 0)then
     maxit = ctrl_loop_maximum
  else
     return
  endif

eps = ctrl_eps_exit_liquid
if(eps == 0d0) return

if(ctrl_method_liquid > 1) then
  !SPECIFY THE SECOND POINT FOR SECANT OR BRENT METHOD
  if(ctrl_density2_liquid == 0)then
     d2 = densityiteration_newton(t_si, p_si, d, 1, 1d+99)
     if(d2 == errorreturn) return
     if(ctrl_method_liquid == 2) then !BRENT
        d2 = d + 2d0 * (d2 - d)
     end if
   elseif(ctrl_density2_liquid == (-1))then
      d2 = densityiteration_newton(t_si, p_si, d, 1, 1d+99)
      if(d2 == errorreturn) return
   elseif(ctrl_density2_liquid == (-2))then
      d2 = densityiteration_newton(t_si, p_si, d, 1, 1d+99)
      if(d2 == errorreturn) return
      d2 = d + 0.5d0 * (d2 - d)
   elseif(ctrl_density2_liquid == (-3))then
      d2 = densityiteration_newton(t_si, p_si, d, 1, 1d+99)
      if(d2 == errorreturn) return
      d2 = d + 2d0 * (d2 - d)
   elseif(ctrl_density2_liquid > 0)then
      d2 = ctrl_density2_liquid
   else
      return
   endif
end if

select case (ctrl_method_liquid)
  case (0); d = densityiteration_newton(t_si, p_si, d, maxit, eps)
  case (1); d = densityiteration_newton(t_si, p_si, d, maxit, eps)
  case (2); d = densityiteration_brent(t_si, p_si, d, d2, maxit, eps)
  case (3); d = densityiteration_secant(t_si, p_si, d, d2, maxit, eps)
  case default; return
end select

if(d == errorreturn) return
if(d <= 0d0) return

!AVOID ACCIDENTAL VAPOUR DENSITY
if (t_si < cp_temperature_si .and. p_si < cp_pressure_si) then
  if (d < cp_density_si) return
end if

liq_density_si = d

end function

!==========================================================================
function vap_density_si(t_si, p_si)
!==========================================================================

!THIS FUNCTION RETURNS THE DENSITY OF WATER VAPOUR AS A FUNCTION OF TEMPERATURE AND PRESSURE

!OUTPUT: VAP_DENSITY_SI = DENSITY IN KG/M3

!INPUT:  T_SI = ABSOLUTE TEMPERATURE, IN K
!        P_SI = ABSOLUTE PRESSURE, IN PA

!CHECK VALUE WITH DEFAULT SETTINGS: vap_density_si(300, 1e3) = 7.22603510025E-03

implicit none
integer maxit
real*8 vap_density_si, t_si, p_si
real*8 d, d2, eps

vap_density_si = errorreturn

d = errorreturn

if(t_si <= 0d0) return
if(p_si <= 0d0) return

!AVOID NUMERICAL PROBLEMS RIGHT AT THE CRITICAL POINT
if (t_si == cp_temperature_si .and. p_si == cp_pressure_si) then
  vap_density_si = cp_density_si
  return
end if

call init_it_ctrl_density

!CONSIDER THE CONTROL SETTINGS FOR THE ITERATION

select case (ctrl_mode_liquid)
  case (1); d = ctrl_density_vapour
  case (0);
     if (t_si <= 623.15d0 .and. p_si <= cp_pressure_si) then
       !IF-97 AT SUBCRITICAL PRESSURE, VAPOUR
       d = aux_vap_density_if97_si(t_si, p_si)
     elseif (t_si <= 1073.15d0 .and. p_si <= 16529000d0) then
       !IF-97 AT SUBCRITICAL PRESSURE, FLUID
       d = aux_vap_density_if97_si(t_si, p_si)
     elseif (t_si <= 623.15d0 .and. p_si <= 100000000d0) then
       !IF-97 AT SUBCRITICAL TEMPERATURE, LIQUID
       d = aux_liq_density_if97_si(t_si, p_si)
     elseif (t_si <= 650d0 .and. p_si <= cp_pressure_si) then
       !CUBIC EOF IN THE CRITICAL REGION, VAPOUR
       d = aux_vap_density_critical_si(t_si, p_si)
     elseif (t_si <= 650d0 .and. p_si <= 35000000d0) then
       !CUBIC EOF IN THE CRITICAL REGION, LIQUID SINCE P > PC
       d = aux_liq_density_critical_si(t_si, p_si)
     elseif (t_si <= 650d0) then
       !DENSE FLUID
       d = 1000d0
     else
       !IDEAL GAS ANYWHERE ELSE
       d = aux_density_ideal_si(t_si, p_si)
     end if
  case (-1); d = aux_vap_density_if97_si(t_si, p_si)
  case (-2); d = aux_density_ideal_si(t_si, p_si)
  case default; return
end select

if(d == errorreturn) return
if(d <= 0d0) return

if(ctrl_loop_maximum == 0)then
   maxit = 100
elseif(ctrl_loop_maximum == (-1))then
   vap_density_si = d
   return
elseif(ctrl_loop_maximum > 0)then
   maxit = ctrl_loop_maximum
else
   return
endif

eps = ctrl_eps_exit_vapour
if(eps == 0d0) return

if(ctrl_method_vapour > 1) then
  !SPECIFY THE SECOND POINT FOR SECANT OR BRENT METHOD
  if(ctrl_density2_vapour == 0)then
     d2 = densityiteration_newton(t_si, p_si, d, 1, 1d+99)
     if(d2 == errorreturn) return
     if(ctrl_method_vapour == 2) then !BRENT
        d2 = d + 2d0 * (d2 - d)
     end if
   elseif(ctrl_density2_vapour == (-1))then
      d2 = densityiteration_newton(t_si, p_si, d, 1, 1d+99)
      if(d2 == errorreturn) return
   elseif(ctrl_density2_vapour == (-2))then
      d2 = densityiteration_newton(t_si, p_si, d, 1, 1d+99)
      if(d2 == errorreturn) return
      d2 = d + 0.5d0 * (d2 - d)
   elseif(ctrl_density2_vapour == (-3))then
      d2 = densityiteration_newton(t_si, p_si, d, 1, 1d+99)
      if(d2 == errorreturn) return
      d2 = d + 2d0 * (d2 - d)
   elseif(ctrl_density2_vapour > 0)then
      d2 = ctrl_density2_vapour
   else
      return
   endif
end if

!RUN THE ITERATION
select case (ctrl_method_vapour)
  case (0); d = densityiteration_newton(t_si, p_si, d, maxit, eps)
  case (1); d = densityiteration_newton(t_si, p_si, d, maxit, eps)
  case (2); d = densityiteration_brent(t_si, p_si, d, d2, maxit, eps)
  case (3); d = densityiteration_secant(t_si, p_si, d, d2, maxit, eps)
  case default; return
end select


if(d == errorreturn) return
if(d <= 0d0) return

!AVOID ACCIDENTAL LIQUID DENSITY
if (t_si < cp_temperature_si .and. p_si < cp_pressure_si) then
 if (d > cp_density_si) return
end if

vap_density_si = d

end function

!==========================================================================
function densityiteration_newton(t, p, d, maxit, eps)
!==========================================================================

!THE FUNCTION RETURNS THE DENSITY AS A FUNCTION OF TEMPERATURE AND PRESSURE,
!COMPUTED FROM THE HELMHOLTZ FUNCTION BY NEWTON ITERATION
!HTTP://EN.WIKIPEDIA.ORG/WIKI/NEWTON%27S_METHOD

!OUTPUT: 
!        DENSITYITERATION_NEWTON: DENSITY IN KG/M3
!        THE VALUE ERRORRETURN IS RETURNED IF
!        - THE MAXIMUM NUMBER OF ITERATIONS IS EXCEEDED WITHOUT MEETING THE EXIT CRITERION
!        - THE FUNCTION CALL TO FLU_F_SI HAS RETURNED AN ERROR
!        - DENSITY HAS TAKEN A ZERO OR NEGATIVE VALUE DURING THE ITERATION

!INPUT:  
!        T: ABSOLUTE TEMPERATURE IN K
!        P: ABSOLUTE PRESSURE IN PA
!        D: INITIAL GUESS FOR DENSITY IN KG/M3
!    MAXIT: MAXIMUM NUMBER OF ITERATION STEPS TO BE DONE
!      EPS: REQUIRED ACCURACY OF DENSITY
!           EPS > 0: ABSOLUTE DENSITY TOLERANCE IN KG/M3
!           EPS < 0: RELATIVE DENSITY TOLERANCE


implicit none
integer it, maxit
real*8 densityiteration_newton, t, p, d, eps
real*8 dd, f_d, f_dd

densityiteration_newton = errorreturn

if(p <= 0d0) return

if(check_limits == 1) then
  if(t < flu_tmin .or. t > flu_tmax) return
else
  if(t <= 0d0) return
endif

check_limits = check_limits - 1

do it = 1, maxit

  f_d = flu_f_si(0, 1, t, d)
  if(f_d == errorreturn) goto 999
  
  f_dd = flu_f_si(0, 2, t, d)
  if(f_dd == errorreturn) goto 999
  
  dd = d * (2d0 * f_d + d * f_dd)
  if(dd == 0d0) goto 999
  
  dd = (p - d ** 2 * f_d) / dd
  d = d + dd

  if(d <= 0d0) goto 999

  if(eps > 0d0) then           !ABSOLUTE LIMIT
    if(abs(dd) < eps) then
      densityiteration_newton = d
      goto 999
    end if
  else                            !RELATIVE LIMIT
    if(abs(dd) < -eps * d) then
      densityiteration_newton = d
      goto 999
    end if
  end if
  
enddo

999 continue

check_limits = check_limits + 1

if(check_limits == 1) then
  !FLU_LIMITS
  if(d <= flu_dmin .or. d > flu_dmax) then
    densityiteration_newton = errorreturn
    return
  endif
endif

end function

!==========================================================================
function densityiteration_brent(t, p, d1, d2, maxit, eps)
!==========================================================================

!THE FUNCTION RETURNS THE DENSITY AS A FUNCTION OF TEMPERATURE AND PRESSURE,
!COMPUTED FROM THE HELMHOLTZ FUNCTION BY BRENT ITERATION
!HTTP://EN.WIKIPEDIA.ORG/WIKI/BRENT!S_METHOD

!OUTPUT: 
!        DENSITYITERATION_BRENT: DENSITY IN KG/M3
!        THE VALUE ERRORRETURN IS RETURNED IF
!        - THE MAXIMUM NUMBER OF ITERATIONS IS EXCEEDED WITHOUT MEETING THE EXIT CRITERION
!        - THE FUNCTION CALL TO FLU_F_SI HAS RETURNED AN ERROR
!        - DENSITY HAS TAKEN A ZERO OR NEGATIVE VALUE DURING THE ITERATION

!INPUT:  T: ABSOLUTE TEMPERATURE IN K
!        P: ABSOLUTE PRESSURE IN PA
!       D1: INITIAL GUESS FOR DENSITY IN KG/M3
!       D2: COUNTERPOINT DENSITY
!    MAXIT: MAXIMUM NUMBER OF ITERATION STEPS TO BE DONE
!      EPS: REQUIRED ACCURACY OF DENSITY
!           EPS > 0: ABSOLUTE DENSITY TOLERANCE IN KG/M3
!           EPS < 0: RELATIVE DENSITY TOLERANCE


implicit none
integer it, maxit
real*8 densityiteration_brent, t, p, d1, d2, eps
real*8 a, b, c, d, s
real*8 fa, fb, fc, fs
logical mflag

densityiteration_brent = errorreturn

d = errorreturn

if(p <= 0d0) return

if(check_limits == 1) then
  if(t < flu_tmin .or. t > flu_tmax) return
else
  if(t <= 0d0) return
endif

check_limits = check_limits - 1

a = d1
fa = a ** 2 * flu_f_si(0, 1, t, a) - p
b = d2
fb = b ** 2 * flu_f_si(0, 1, t, b) - p
if(fa * fb > 0d0) go to 999

if(abs(fa) < abs(fb)) then
  call swap (a, b)
  call swap (fa, fb)
end if

c = a
fc = fa
mflag = .true.

do it = 1, maxit

  if(fb == 0d0) then
    densityiteration_brent = b
    goto 999
  end if
  if(eps > 0d0) then           !ABSOLUTE LIMIT
    if(abs(a - b) < eps) then
      densityiteration_brent = b
      goto 999
    end if
  else                            !RELATIVE LIMIT
    if(abs(a - b) < -eps * b) then
      densityiteration_brent = b
      goto 999
    end if
  end if

  if(fa == fb) goto 999

  if(fa /= fc .and. fb /= fc) then
    s = a * fb * fc / ((fa - fb) * (fa - fc)) +  &
        b * fa * fc / ((fb - fa) * (fb - fc)) +  &
        c * fa * fb / ((fc - fa) * (fc - fb))
  else
    s = b - (b - a) * fb / (fb - fa)
  end if

  if(((3d0 * a + b) / 4d0 - s) * (b - s) > 0d0 .or. &
     (mflag .and. abs(s - b) >= 0.5d0 * abs(b - c)) .or.  &
     (.not.mflag .and. abs(s - b) >= 0.5d0 * (c - d))) then
    s = 0.5d0 * (a + b)
  else
    mflag = .false.
  end if

  fs = s ** 2 * flu_f_si(0, 1, t, s) - p
  d = c
  c = b
  fc = fb

  if(fa * fs < 0d0) then
    b = s
    fb = fs
  else
    a = s
    fa = fs
  end if

  if(abs(fa) < abs(fb)) then
    call swap (a, b)
    call swap (fa, fb)
  end if

enddo

999 continue

check_limits = check_limits + 1

if(check_limits == 1) then
  !FLU_LIMITS
  if(d <= flu_dmin .or. d > flu_dmax) then
    densityiteration_brent = errorreturn
    return
  endif
endif

end function

!==========================================================================
function densityiteration_secant(t, p, d, d2, maxit, eps)
!==========================================================================

!THE FUNCTION RETURNS THE DENSITY AS A FUNCTION OF TEMPERATURE AND PRESSURE,
!COMPUTED FROM THE HELMHOLTZ FUNCTION BY SECANT ITERATION
!HTTP://EN.WIKIPEDIA.ORG/WIKI/SECANT_METHOD

!OUTPUT: 
!        DENSITYITERATION_SECANT: DENSITY IN KG/M3
!        THE VALUE ERRORRETURN IS RETURNED IF
!        - THE MAXIMUM NUMBER OF ITERATIONS IS EXCEEDED WITHOUT MEETING THE EXIT CRITERION
!        - THE FUNCTION CALL TO FLU_F_SI HAS RETURNED AN ERROR
!        - DENSITY HAS TAKEN A ZERO OR NEGATIVE VALUE DURING THE ITERATION

!INPUT:  
!        T: ABSOLUTE TEMPERATURE IN K
!        P: ABSOLUTE PRESSURE IN PA
!        D: INITIAL GUESS FOR DENSITY IN KG/M3
!       D2: COUNTERPOINT DENSITY
!    MAXIT: MAXIMUM NUMBER OF ITERATION STEPS TO BE DONE
!      EPS: REQUIRED ACCURACY OF DENSITY
!           EPS > 0: ABSOLUTE DENSITY TOLERANCE IN KG/M3
!           EPS < 0: RELATIVE DENSITY TOLERANCE


implicit none
integer it, maxit
real*8 densityiteration_secant, t, p, d, d2, eps
real*8 dd, d1, p1, p2

densityiteration_secant = errorreturn

if(p <= 0d0) return

if(check_limits == 1) then
  if(t < flu_tmin .or. t > flu_tmax) return
else
  if(t <= 0d0) return
endif

check_limits = check_limits - 1

p2 = d2 ** 2 * flu_f_si(0, 1, t, d2)
if(p2 == errorreturn) go to 999

do it = 1, maxit
  d1 = d2
  p1 = p2
  d2 = d
  p2 = d ** 2 * flu_f_si(0, 1, t, d)

  if(p2 == errorreturn) goto 999
  if(p2 == p1) goto 999
  
  dd = -(d2 - d1) * (p2 - p) / (p2 - p1)
  d = d + dd

  if(d <= 0d0) goto 999

  if(eps > 0d0) then           !ABSOLUTE LIMIT
    if(abs(dd) < eps) then
      densityiteration_secant = d
      goto 999
    end if
  else                            !RELATIVE LIMIT
    if(abs(dd) < -eps * d) then
      densityiteration_secant = d
      goto 999
    end if
  end if
  
enddo

999 continue

check_limits = check_limits + 1

if(check_limits == 1) then
  if(d <= flu_dmin .or. d > flu_dmax) then
    densityiteration_secant = errorreturn
    return
  endif
endif

end function

!==========================================================================
function flu_t_p_derivative_si(drv_t, drv_p, t_si, d_si)
!==========================================================================

!THIS FUNCTION COMPUTES T-P DERIVATIVES OF G FROM T-D DERIVATIVES OF F

implicit none
integer drv_t, drv_p
real*8 flu_t_p_derivative_si, t_si, d_si

real*8 g

real*8 f, f_t, f_d
real*8 f_tt, f_td, f_dd

flu_t_p_derivative_si = errorreturn

if(t_si <= 0d0) return
if(d_si <= 0d0) return

select case (drv_t)

  case (0)
    select case (drv_p)

      case (0) 
        f = flu_f_si(0, 0, t_si, d_si)          !G
        if(f == errorreturn) return
        f_d = flu_f_si(0, 1, t_si, d_si)
        if(f_d == errorreturn) return
        g = f + d_si * f_d

      case (1) 
        g = 1d0 / d_si                          !G_P

      case (2) 
        f_d = flu_f_si(0, 1, t_si, d_si)        !G_PP
        if(f_d == errorreturn) return
        f_dd = flu_f_si(0, 2, t_si, d_si)
        if(f_dd == errorreturn) return
        g = d_si ** 3 * (2d0 * f_d + d_si * f_dd)
        if(g == 0d0) return
        g = -1d0 / g

      case default; return
    end select

  case (1)
    select case (drv_p)

      case (0)
        f_t = flu_f_si(1, 0, t_si, d_si)        !G_T
        if(f_t == errorreturn) return
        g = f_t

      case (1)
        f_d = flu_f_si(0, 1, t_si, d_si)        !G_TP
        if(f_d == errorreturn) return
        f_td = flu_f_si(1, 1, t_si, d_si)
        if(f_td == errorreturn) return
        f_dd = flu_f_si(0, 2, t_si, d_si)
        if(f_dd == errorreturn) return
        g = d_si * (2d0 * f_d + d_si * f_dd)
        if(g == 0d0) return
        g = f_td / g

      case default; return
    end select

  case (2)
    select case (drv_p)

      case (0)
        f_d = flu_f_si(0, 1, t_si, d_si)        !G_TT
        if(f_d == errorreturn) return
        f_tt = flu_f_si(2, 0, t_si, d_si)
        if(f_tt == errorreturn) return
        f_td = flu_f_si(1, 1, t_si, d_si)
        if(f_td == errorreturn) return
        f_dd = flu_f_si(0, 2, t_si, d_si)
        if(f_dd == errorreturn) return
        g = 2d0 * f_d + d_si * f_dd
        if(g == 0d0) return
        g = f_tt - d_si * f_td ** 2 / g

      case default; return
    end select

  case default; return
end select

flu_t_p_derivative_si = g

end function

!==========================================================================
function polyf03_gyz(drv_y, drv_z, y, z)
!==========================================================================

!RETURNS THE VALUE OF THE POLYNOMIAL DERIVATIVE
!(D/DY)^DRV_Y (D/DZ)^DRV_Z SUM(J,K) GC03(J,K)*Y^J*Z^K

implicit none

integer drv_y, drv_z
integer j, jmax
integer k, kmax
integer l
real*8 polyf03_gyz, g
real*8 y, z
real*8 yj, zk
real*8 c

g = 0d0
if(y == 0d0) then 
   jmax = drv_y 
else 
   jmax = maxt
endif

if(z == 0d0) then 
   kmax = drv_z 
else 
   kmax = maxp
endif

yj = 1d0
do j = drv_y, jmax   !LOOP OVER POWERS OF Y
  zk = 1d0
  do k = drv_z, kmax    !LOOP OVER POWERS OF Z
    if(gc03(j, k) /= 0d0) then
      c = gc03(j, k) * yj * zk
      do l = 1, drv_y            !FACTORS FROM Y-DERIVATIVES
        c = c * dfloat(j - l + 1)
      enddo
      do l = 1, drv_z            !FACTORS FROM Z-DERIVATIVES
        c = c * dfloat(k - l + 1)
      enddo
      g = g + c
    end if
    if(k < kmax) zk = zk * z
  enddo
  if(j < jmax) yj = yj * y
enddo

polyf03_gyz = g

end function
 
!=========================================================================
function gamma_0(drv_t, drv_p, tau, psi)
!=========================================================================

!THIS FUNCTION IMPLEMENTS THE DERIVATIVES OF GAMMA_0 AS GIVEN IN TABLE 13 OF IF-97

implicit none

integer i, k, drv_t, drv_p
real*8 tau, psi
real*8 gamma_0
real*8 g, pwrt

gamma_0 = errorreturn

if(psi <= 0d0) return
if(tau <= 0d0) return
if(drv_t < 0) return
if(drv_p < 0) return

g = 0d0
if(drv_t == 0) then
  if(drv_p == 0) then
    g = log(psi)
  else
    g = 1d0 / psi
    do k = 2, drv_p
      g = dfloat(1 - k) * g / psi
    enddo
  end if
end if

if(drv_p == 0) then
  do i = 1, 9
    pwrt = tau ** (j0i(i) - drv_t)
    do k = 0, drv_t - 1
      pwrt = pwrt * dfloat(j0i(i) - k)
    enddo
    g = g + n0i(i) * pwrt
  enddo
end if

gamma_0 = g

end function

!=========================================================================
function gamma_1(drv_t, drv_p, tau, psi)
!=========================================================================

!THIS FUNCTION IMPLEMENTS THE DERIVATIVES OF GAMMA AS GIVEN IN TABLE 4 OF IF-97

implicit none

integer drv_t, drv_p
integer i, k
real*8 tau, psi
real*8 gamma_1
real*8 g, pp, tt
real*8 pwrt, pwrp

gamma_1 = errorreturn

if(psi <= 0d0) return
if(tau <= 0d0) return
if(drv_t < 0) return
if(drv_p < 0) return

pp = 7.1d0 - psi
tt = tau - 1.222d0

g = 0d0
do i = 1, 34

  if(tt == 0d0) then
    if(j1i(i) == drv_t) then
      pwrt = 1d0
    elseif(j1i(i) > drv_t) then
      pwrt = 0d0
    else
      return
    endif
  else
    pwrt = tt ** (j1i(i) - drv_t)
  end if
  do k = 0, drv_t - 1
    pwrt = pwrt * dfloat(j1i(i) - k)
  enddo

  if(pp == 0d0) then
    if(i1i(i) == drv_p) then
      pwrp = 1d0
    elseif(i1i(i) > drv_p) then
      pwrp = 0d0
    else
      return
    endif
  else
    pwrp = pp ** (i1i(i) - drv_p)
  end if
  do k = 0, drv_p - 1
    pwrp = -pwrp * dfloat(i1i(i) - k)
  enddo

  g = g + n1i(i) * pwrp * pwrt

enddo

gamma_1 = g

end function

!=========================================================================
function gamma_2(drv_t, drv_p, tau, psi)
!=========================================================================

!THIS FUNCTION IMPLEMENTS THE DERIVATIVES OF GAMMA AS GIVEN IN EQ. 15 OF IF-97

implicit none

integer drv_t, drv_p
real*8 tau, psi
real*8 gamma_2
real*8 g0, gr

call init_if97_2

gamma_2 = errorreturn

g0 = gamma_0(drv_t, drv_p, tau, psi)
if(g0 == errorreturn) return

gr = gamma_r(drv_t, drv_p, tau, psi)
if(gr == errorreturn) return

gamma_2 = g0 + gr

end function

!=========================================================================
function gamma_r(drv_t, drv_p, tau, psi)
!=========================================================================
                         
!THIS FUNCTION IMPLEMENTS THE DERIVATIVES OF GAMMA_R AS GIVEN IN TABLE 14 OF IF-97

implicit none

integer drv_t, drv_p
integer i, k
real*8 gamma_r
real*8 tau, psi
real*8 g, tt
real*8 pwrt, pwrp

gamma_r = errorreturn

if(psi <= 0d0) return
if(tau <= 0d0) return
if(drv_t < 0) return
if(drv_p < 0) return

tt = tau - 0.5d0

g = 0d0
do i = 1, 43

  if(tt == 0d0) then
    if(jri(i) == drv_t) then
      pwrt = 1d0
    elseif(jri(i) > drv_t) then
      pwrt = 0d0
    else
      return
    endif
  else
    pwrt = tt ** (jri(i) - drv_t)
  end if
  do k = 0, drv_t - 1
    pwrt = pwrt * dfloat(jri(i) - k)
  enddo

  pwrp = psi ** (iri(i) - drv_p)
  do k = 0, drv_p - 1
    pwrp = pwrp * dfloat(iri(i) - k)
  enddo

  g = g + nri(i) * pwrp * pwrt

enddo

gamma_r = g

end function

!==========================================================================
function aux_density_eos80_si(t_si, p_si)
!==========================================================================

!THIS FUNCTION RETURNS THE DENSITY OF LIQUID WATER COMPUTED FROM THE
!INTERNATIONAL EQUATION OF STATE OF SEAWATER 1980, EOS-80, AS A FUNCTION OF TEMPERATURE
!AND PRESSURE

!OUTPUT:  
!AUX_DENSITY_EOS80_SI: DENSITY IN KG/M3

!INPUT:   
!T_SI: ABSOLUTE TEMPERATURE IN K
!P_SI: ABSOLUTE PRESSURE IN PA

implicit none
real*8 aux_density_eos80_si, t_si, p_si
real*8 aw, bw, kw, rw
real*8 t, p

aux_density_eos80_si = errorreturn

if(t_si <= 0d0) return
if(p_si <= 0d0) return

!R.C.MILLARD JR.: INTERNATIONAL OCEANOGRAPHIC TABLES VOL.4
!UNESCO TECHNICAL PAPERS IN MARINE SCIENCE 40
!UNESCO 1987

t = 1.00024d0*(t_si - 273.15d0) !CONVERT TO DEGC(T90) THEN USE SAUNDER'S FORMULA
p = (p_si - 101325d0)/1d5

bw = 0.0000850935d0 + t * (-0.00000612293d0 + t * 0.000000052787d0)
aw = 3.239908d0 + t * (0.00143713d0 + t * (0.000116092d0 - t * 0.000000577905d0))
kw = 0.01360477d0 - t * 0.00005155288d0
kw = 19652.21d0 + t * (148.4206d0 + t * (-2.327105d0 + t * kw))
kw = kw + p * (aw + p * bw)
if(kw == 0d0) return

kw = 1d0 - p / kw
if(kw == 0d0) return

rw = 0.0001001685d0 + t * (-0.000001120083d0 + t * 0.000000006536332d0)
rw = 999.842594d0 + t * (0.06793952d0 + t * (-0.00909529d0 + t * rw))

aux_density_eos80_si = rw / kw

end function

!==========================================================================
function aux_density_ideal_si(t_si, p_si)
!==========================================================================

!THIS FUNCTION RETURNS THE DENSITY OF IDEAL-GAS VAPOUR AS A FUNCTION OF TEMPERATURE
!AND PRESSURE

!OUTPUT:  
!AUX_DENSITY_IDEAL_SI: DENSITY IN KG/M3

!INPUT:   
!T_SI: ABSOLUTE TEMPERATURE IN K
!P_SI: ABSOLUTE PRESSURE IN PA


implicit none
real*8 aux_density_ideal_si, t_si, p_si, r

r = gas_constant_h2o_si         !SPECIFIC GAS CONSTANT OF WATER IN J/(KG K)

aux_density_ideal_si = errorreturn

if(t_si <= 0d0) return
if(p_si <= 0d0) return

aux_density_ideal_si = p_si / (r * t_si)

end function

!==========================================================================
subroutine aux_density_critical_si(t_si, p_si, d_liq, d_vap)
!==========================================================================
                                      
!RETURNS APPROXIMATE LIQUID AND/OR VAPOUR DENSITY FROM A CUBIC EQUATION OF STATE AT GIVEN T, P
!USABLE IN THE RANGE 620 K < T < 650 K, 10 MPA < P < 35 MPA
!SUPERCRITICAL RANGE:  RETURN VALID D_LIQ = D_VAP
!2-PHASE REGION:       RETURN VALID D_LIQ /= D_VAP          (INCLUDING THE METASTABLE REGION)
!LIQUID REGION:        RETURN VALID D_LIQ,  INVALID D_VAP
!VAPOUR REGION:        RETURN VALID D_VAP,  INVALID D_LIQ

implicit none
real*8 pr, tr
real*8 r, s, t
real*8 d1, d2, d3
real*8 p1, p2
real*8 dc, pc, tc
real*8 a0, a1, a2, a3
real*8 a10, a20, a11, a21, a12, a22, a03, a13, a23
real*8 d_liq, d_vap, t_si, p_si

!THE CRITICAL PROPERTIES OF IAPWS-95
dc = cp_density_si
pc = cp_pressure_si
tc = cp_temperature_si

a10 = -7.60041479494879d0
a20 = 118.661872386874d0
a11 = -17.463827264079d0
a21 = 186.040087842884d0
a12 = 0.69701967809328d0
a22 = 25.5059905941023d0
a03 = -0.602044738250314d0
a13 = 30.8633119943879d0
a23 = 14.4873846518829d0

d_liq = errorreturn
d_vap = errorreturn
if(p_si <= 0d0) return
if(t_si <= 0d0) return

!REDUCED P AND T
pr = pc / p_si - 1d0
tr = t_si / tc - 1d0

!CUBIC EQ. PR = A0 + A1*DR + A2*DR^2 + A3*DR^3
!WITH REDUCED DENSITY DR = D/DC - 1
a0 = (a10 + a20 * tr) * tr
a1 = (a11 + a21 * tr) * tr
a2 = (a12 + a22 * tr) * tr
a3 = a03 + (a13 + a23 * tr) * tr  !A3 < 0 HOLDS FOR T < 659.6 K

if(a3 >= 0d0) return

if(tr < 0d0) then

  !GET THE PRESSURE RANGE OF 2-PHASE SOLUTIONS AT THE GIVEN TEMPERATURE.
  !SOLUTIONS OF DP/DV = 0, I.E. THE SPINODAL CURVE:
  r = a2 * a2 - 3d0 * a1 * a3
  if(r < 0d0) return
  r = sqrt(r)
  d1 = -(a2 + r) / (3d0 * a3)
  d2 = -(a2 - r) / (3d0 * a3)
  !THE PRESSURE RANGE IS
  p1 = a0 + d1 * (a1 + d1 * (a2 + d1 * a3)) !HIGHEST PRESSURE FOR SUBCOOLED VAPOUR (LOWEST REDUCED PRESSURE)
  p2 = a0 + d2 * (a1 + d2 * (a2 + d2 * a3)) !LOWEST PRESSURE FOR SUPERHEATED LIQUID (HIGHEST REDUCED PRESSURE)

else

  !ONE FLUID STATE
  p1 = pr
  p2 = pr
  
end if

!COEFFICIENTS OF THE CUBIC EQ.   DR^3 + R * DR^2 + S * DR + T = 0
r = a2 / a3
s = a1 / a3
t = (a0 - pr) / a3

select case (get_cubicroots(r, s, t, d1, d2, d3))

  case (1)
     if(d1 <= -1d0) return
     if(pr >= p1) then
       !GET THE VAPOUR DENSITY
       d_vap = (d1 + 1d0) * dc
     end if
     if(pr <= p2) then
       !GET THE LIQUID DENSITY
       d_liq = (d1 + 1d0) * dc
     end if

  case (2) 

  case (3) 
     call sort3up (d1, d2, d3)     !3 SOLUTIONS, MIN IS VAPOUR, MAX IS LIQUID
     if(d1 <= -1d0) return
     if(d3 <= -1d0) return
     d_vap = (d1 + 1d0) * dc
     d_liq = (d3 + 1d0) * dc
          
end select

end subroutine

!==========================================================================
function aux_liq_density_critical_si(t_si, p_si)
!==========================================================================

!RETURNS THE APPROXIMATE LIQUID DENSITY FROM THE CUBIC EQUATION

implicit none
real*8 aux_liq_density_critical_si, t_si, p_si
real*8 d_liq, d_vap

call aux_density_critical_si (t_si, p_si, d_liq, d_vap)
aux_liq_density_critical_si = d_liq

end function

!==========================================================================
function aux_vap_density_critical_si(t_si, p_si)
!==========================================================================

!RETURNS THE APPROXIMATE VAPOUR DENSITY FROM THE CUBIC EQUATION

implicit none
real*8 aux_vap_density_critical_si, t_si, p_si
real*8 d_liq, d_vap

call aux_density_critical_si (t_si, p_si, d_liq, d_vap)
aux_vap_density_critical_si = d_vap

end function

!==========================================================================
function aux_liq_density_f03_si(t_si, p_si)
!==========================================================================

!THIS FUNCTION RETURNS THE DENSITY OF LIQUID WATER COMPUTED FROM THE
!GIBBS FUNCTION 2003 OF SEAWATER AS A FUNCTION OF TEMPERATURE
!AND PRESSURE, PUBLISHED IN

!R. FEISTEL:
!A NEW EXTENDED GIBBS THERMODYNAMIC POTENTIAL OF SEAWATER.
!PROGRESS IN OCEANOGRAPHY, 58/1 (2003) 43-115

!OUTPUT:  
!AUX_LIQ_DENSITY_F03_SI: DENSITY IN KG/M3

!INPUT:   
!T_SI: ABSOLUTE TEMPERATURE IN K
!P_SI: ABSOLUTE PRESSURE IN PA

implicit none

real*8 aux_liq_density_f03_si
real*8 t_si, p_si
real*8 d

aux_liq_density_f03_si = errorreturn

if(t_si <= 0d0) return
if(p_si <= 0d0) return

d = aux_liq_g_f03_si(0, 1, t_si, p_si)

if(d == errorreturn) return
if(d <= 0d0) return

aux_liq_density_f03_si = 1d0 / d

end function

!==========================================================================
function aux_liq_g_f03_si(drv_t, drv_p, t_si, p_si)
!==========================================================================

!THIS FUNCTION IMPLEMENTS THE GIBBS FUNCTION OF PURE WATER AS DEFINED IN
!R. FEISTEL:
!A NEW EXTENDED GIBBS THERMODYNAMIC POTENTIAL OF SEAWATER.
!PROGRESS IN OCEANOGRAPHY, 58 (2003) 43-115

implicit none

integer drv_t, drv_p
real*8 aux_liq_g_f03_si
real*8 t_si, p_si
real*8 t0, tu, p0, pu
real*8 y, z, g

t0 = celsius_temperature_si     !IN K
tu = 40d0                       !IN K
p0 = sealevel_pressure_si       !IN Pa
pu = 100000000d0                !IN Pa

aux_liq_g_f03_si = errorreturn

if(drv_t < 0) return
if(drv_p < 0) return
if(t_si <= 0d0) return
if(p_si <= 0d0) return

call init_f03

y = (t_si - t0) / tu
z = (p_si - p0) / pu

g = polyf03_gyz(drv_t, drv_p, y, z)
if(g == errorreturn) return

aux_liq_g_f03_si = g / (tu ** drv_t * pu ** drv_p)

end function

!=========================================================================
function aux_liq_density_if97_si(t_si, p_si)
!=========================================================================

!THIS FUNCTION RETURNS THE DENSITY OF LIQUID WATER AS A FUNCTION OF TEMPERATURE
!AND PRESSURE, IN THE REGION 1 (LIQUID) IN IAPWS-IF97

!OUTPUT:  
!AUX_LIQ_DENSITY_IF97_SI: DENSITY IN KG/M3

!INPUT:   
!T_SI: ABSOLUTE TEMPERATURE IN K
!P_SI: ABSOLUTE PRESSURE IN PA

implicit none

real*8 aux_liq_density_if97_si
real*8 t_si, p_si
real*8 d

aux_liq_density_if97_si = errorreturn

if(t_si <= 0d0) return
if(p_si <= 0d0) return

d = aux_liq_g_if97_si(0, 1, t_si, p_si)

if(d == errorreturn) return
if(d <= 0d0) return

aux_liq_density_if97_si = 1d0 / d

end function
 
!=========================================================================
function aux_vap_density_if97_si(t_si, p_si)
!=========================================================================

!THIS FUNCTION RETURNS THE DENSITY OF WATER VAPOUR AS A FUNCTION OF TEMPERATURE
!AND PRESSURE, IN THE REGION 2 (VAPOUR) IN IAPWS-IF97

!OUTPUT:  
!AUX_VAP_DENSITY_IF97_SI: DENSITY IN KG/M3

!INPUT:   
!T_SI: ABSOLUTE TEMPERATURE IN K
!P_SI: ABSOLUTE PRESSURE IN PA

implicit none

real*8 aux_vap_density_if97_si
real*8 t_si, p_si
real*8 d

aux_vap_density_if97_si = errorreturn

if(t_si <= 0d0) return
if(p_si <= 0d0) return

d = aux_vap_g_if97_si(0, 1, t_si, p_si)

if(d == errorreturn) return
if(d <= 0d0) return

aux_vap_density_if97_si = 1d0 / d

end function

!=========================================================================
function aux_liq_g_if97_si(drv_t, drv_p, t_si, p_si)
!=========================================================================

!THIS FUNCTION RETURNS THE GIBBS FUNCTION G(T,P) AND ITS 1ST AND 2ND DERIVATIVES
!WITH RESPECT TO TEMPERATURE AND PRESSURE, AS DEFINED FOR THE REGION 1 (LIQUID) IN IAPWS-IF97
!
!OUTPUT: 
!AUX_LIQ_G_IF97_SI: SPECIFIC GIBBS ENERGY IN J/KG OR ITS T-P DERIVATIVE

!INPUT:  
!DRV_T: ORDER OF THE TEMPERATURE DERIVATIVE (0-2)
!DRV_P: ORDER OF THE PRESSURE DERIVATIVE (0-2)
!T_SI:  ABSOLUTE TEMPERATURE IN K
!P_SI:  ABSOLUTE PRESSURE IN PA

implicit none
                          
integer drv_t, drv_p
real*8 aux_liq_g_if97_si
real*8 t_si, p_si
real*8 g, g_t, g_tt
real*8 g_p, g_tp, g_pp
real*8 psi, tau, rt
real*8 tu, pu, r

tu = 1386d0
pu = 16530000d0
r = 461.526d0       !J KG-1 K-1  SPECIFIC GAS CONSTANT
                    !NOTE THIS DEVIATES FROM GAS_CONSTANT_H2O_SI = 461.51805

aux_liq_g_if97_si = errorreturn

if(t_si <= 0d0) return
if(p_si <= 0d0) return

call init_if97_1

psi = p_si / pu
tau = tu / t_si
rt = r * t_si

select case (drv_t)

  case (0)
    select case (drv_p)

      case (0); g = gamma_1(0, 0, tau, psi)
        if(g == errorreturn) return
        aux_liq_g_if97_si = rt * g

      case (1); g_p = gamma_1(0, 1, tau, psi)
        if(g_p == errorreturn) return
        aux_liq_g_if97_si = rt * g_p / pu

      case (2); g_pp = gamma_1(0, 2, tau, psi)
        if(g_pp == errorreturn) return
        aux_liq_g_if97_si = rt * g_pp / pu ** 2

      case default; return
    end select

  case (1)
    select case (drv_p)

      case (0)
        g = gamma_1(0, 0, tau, psi)
        if(g == errorreturn) return
        g_t = gamma_1(1, 0, tau, psi)
        if(g_t == errorreturn) return
        aux_liq_g_if97_si = r * (g - tau * g_t)

      case (1) 
        g_p = gamma_1(0, 1, tau, psi)
        if(g_p == errorreturn) return
        g_tp = gamma_1(1, 1, tau, psi)
        if(g_tp == errorreturn) return
        aux_liq_g_if97_si = r * (g_p - tau * g_tp) / pu

      case default; return
    end select

  case (2)
    select case (drv_p)

      case (0) 
        g_tt = gamma_1(2, 0, tau, psi)
        if(g_tt == errorreturn) return
        aux_liq_g_if97_si = r * tau ** 2 * g_tt / t_si

      case default; return
    end select

  case default; return
end select

end function

!=========================================================================
function aux_vap_g_if97_si(drv_t, drv_p, t_si, p_si)
!=========================================================================

!THIS FUNCTION RETURNS THE GIBBS FUNCTION G(T,P) AND ITS 1ST AND 2ND DERIVATIVES
!WITH RESPECT TO TEMPERATURE AND PRESSURE, AS DEFINED FOR THE REGION 2 (VAPOUR) IN IAPWS-IF97
!
!OUTPUT: 
!AUX_VAP_G_IF97_SI: SPECIFIC GIBBS ENERGY IN J/KG OR ITS T-P DERIVATIVE

!INPUT:  
!DRV_T: ORDER OF THE TEMPERATURE DERIVATIVE (0-2)
!DRV_P: ORDER OF THE PRESSURE DERIVATIVE (0-2)
!T_SI:  ABSOLUTE TEMPERATURE IN K
!P_SI:  ABSOLUTE PRESSURE IN PA

implicit none
                          
integer drv_t, drv_p
real*8 aux_vap_g_if97_si
real*8 t_si, p_si
real*8 g, g_t, g_tt
real*8 g_p, g_tp, g_pp
real*8 psi, tau, rt
real*8 tu, pu, r

tu = 540d0
pu = 1000000d0
r = 461.526d0       !J KG-1 K-1  SPECIFIC GAS CONSTANT
                    !NOTE THIS DEVIATES FROM GAS_CONSTANT_H2O_SI = 461.51805

aux_vap_g_if97_si = errorreturn

if(t_si <= 0d0) return
if(p_si <= 0d0) return

call init_if97_2

psi = p_si / pu
tau = tu / t_si
rt = r * t_si

select case (drv_t)

  case (0)
    select case (drv_p)

      case (0) 
        g = gamma_2(0, 0, tau, psi)
        if(g == errorreturn) return
        aux_vap_g_if97_si = rt * g

      case (1) 
        g_p = gamma_2(0, 1, tau, psi)
        if(g_p == errorreturn) return
        aux_vap_g_if97_si = rt * g_p / pu

      case (2) 
        g_pp = gamma_2(0, 2, tau, psi)
        if(g_pp == errorreturn) return
        aux_vap_g_if97_si = rt * g_pp / pu ** 2

      case default; return
    end select

  case (1)
    select case (drv_p)

      case (0) 
        g = gamma_2(0, 0, tau, psi)
        if(g == errorreturn) return
        g_t = gamma_2(1, 0, tau, psi)
        if(g_t == errorreturn) return
        aux_vap_g_if97_si = r * (g - tau * g_t)

      case (1) 
        g_p = gamma_2(0, 1, tau, psi)
        if(g_p == errorreturn) return
        g_tp = gamma_2(1, 1, tau, psi)
        if(g_tp == errorreturn) return
        aux_vap_g_if97_si = r * (g_p - tau * g_tp) / pu

      case default; return
    end select

  case (2)
    select case (drv_p)

      case (0) 
        g_tt = gamma_2(2, 0, tau, psi)
        if(g_tt == errorreturn) return
        aux_vap_g_if97_si = r * tau ** 2 * g_tt / t_si

      case default; return
    end select

  case default; return
end select

end function

!==========================================================================
subroutine init_it_ctrl_density
!==========================================================================

implicit none

if(ctrl_initialized == -1) return

ctrl_initialized = -1

!SET DEFAULT VALUES AND MODES FOR DENSITY ITERATION
ctrl_mode_liquid = 0
ctrl_mode_vapour = 0
ctrl_loop_maximum = 100
ctrl_density_liquid = 1000
ctrl_density_vapour = 1
ctrl_eps_exit_liquid = -0.0000001d0 !RELATIVE, 0.1 PPM
ctrl_eps_exit_vapour = -0.0000001d0 !RELATIVE, 0.1 PPM

!SET DEFAULT VALUES FOR ALTERNATIVE ITERATION METHODS
ctrl_method_liquid = 0 !DEFAULT = NEWTON
ctrl_method_vapour = 0 !DEFAULT = NEWTON

!SET DEFAULT COUNTERPOINT VALUES FOR ALTERNATIVE ITERATION METHODS
ctrl_density2_liquid = 0d0  !DEFAULT = .5 * NEWTON STEP
ctrl_density2_vapour = 0d0  !DEFAULT = .5 * NEWTON STEP

end subroutine

!==========================================================================
subroutine set_it_ctrl_density(key, value)
!==========================================================================

!THIS SUB SETS CONTROL PARAMETERS FOR THE ITERATION USED TO COMPUTE
!IAPWS-95 DENSITY FROM PRESSURE

!KEY                    VALUE
!IT_STEPS     '        0           SET ITERATION NUMBER TO DEFAULT (100)
!IT_STEPS     '        N > 0       SET ITERATION NUMBER TO N
!IT_STEPS     '       -1           DO NOT ITERATE, USE INITIAL VALUE

!INIT_LIQ_DENS'        0           USE DEFAULT LIQUID DENSITY (IF97) TO START IN THE SUBCRITICAL REGION (T <= 623.16 K OR P <=16.529 MPA)
!                                  USE DEFAULT CUBIC EOS TO START IN THE CRITICAL REGION (623.16 K < T < 650 K AND 16.529 MPA < P < 35 MPA)
!                                  USE DEFAULT 1000 KG/M³ TO START IN THE REMAINING SUPERCRITICAL REGION
!INIT_LIQ_DENS'       -1           USE IF97 LIQUID DENSITY TO START
!INIT_LIQ_DENS'       -2           USE EOS80 LIQUID DENSITY TO START
!INIT_LIQ_DENS'       -3           USE F03 LIQUID DENSITY TO START
!INIT_LIQ_DENS'        D > 0       USE VALUE D AS LIQUID DENSITY TO START

!INIT_VAP_DENS'        0           USE DEFAULT VAPOUR DENSITY (IF97) TO START IN THE SUBCRITICAL REGION (T <= 623.16 K OR P <=16.529 MPA)
!                                  USE DEFAULT CUBIC EOS TO START IN THE CRITICAL REGION (623.16 K < T < 650 K AND 16.529 MPA < P < 35 MPA)
!                                  USE DEFAULT 1000 KG/M³ TO START IN THE REMAINING SUPERCRITICAL REGION
!INIT_VAP_DENS'       -1           USE IF97 VAPOUR DENSITY TO START
!INIT_VAP_DENS'       -2           USE IDEAL-GAS VAPOUR DENSITY TO START
!INIT_VAP_DENS'        D > 0       USE VALUE D AS VAPOUR DENSITY TO START

!TOL_LIQ_DENS '        0           USE DEFAULT EXIT ACCURACY FOR LIQUID DENSITY (0.1 PPM)
!TOL_LIQ_DENS '        EPS         USE EPS AS EXIT ACCURACY FOR LIQUID DENSITY (EPS < 0 MEANS RELATIVE ERROR)

!TOL_VAP_DENS '        0           USE DEFAULT EXIT ACCURACY FOR VAPOUR DENSITY (0.1 PPM)
!TOL_VAP_DENS '        EPS         USE EPS AS EXIT ACCURACY FOR VAPOUR DENSITY (EPS < 0 MEANS RELATIVE ERROR)

!METHOD_LIQ   '        0           USE DEFAULT ITERATION METHOD (NOW: NEWTON METHOD) FOR LIQUID
!METHOD_LIQ   '        1           USE NEWTON METHOD FOR LIQUID
!METHOD_LIQ   '        2           USE BRENT METHOD FOR LIQUID
!METHOD_LIQ   '        3           USE SECANT METHOD FOR LIQUID

!DENS2_LIQ    '        0           USE DEFAULT COUNTERPOINT FOR BRENT/SECANT METHOD FOR LIQUID
!                                  BRENT: 2 * NEWTON STEP, SECANT: 1 * NEWTON STEP
!DENS2_LIQ    '       -1           USE NEWTON STEP AS THE FIRST COUNTERPOINT FOR LIQUID
!DENS2_LIQ    '       -2           USE 0.5 * NEWTON STEP AS THE FIRST COUNTERPOINT FOR LIQUID
!DENS2_LIQ    '       -3           USE 2 * NEWTON STEP AS THE FIRST COUNTERPOINT FOR LIQUID
!DENS2_LIQ    '        D > 0       USE D AS THE FIRST COUNTERPOINT DENSITY FOR LIQUID

!METHOD_VAP   '        0           USE DEFAULT ITERATION METHOD (NOW: NEWTON METHOD) FOR VAPOUR
!METHOD_VAP   '        1           USE NEWTON METHOD FOR VAPOUR
!METHOD_VAP   '        2           USE BRENT METHOD FOR VAPOUR
!METHOD_VAP   '        3           USE SECANT METHOD FOR VAPOUR

!DENS2_VAP    '        0           USE DEFAULT COUNTERPOINT FOR BRENT/SECANT METHOD FOR VAPOUR
!                                  BRENT: 2 * NEWTON STEP, SECANT: 1 * NEWTON STEP
!DENS2_VAP    '       -1           USE NEWTON STEP AS THE FIRST COUNTERPOINT FOR VAPOUR
!DENS2_VAP    '       -2           USE 0.5 * NEWTON STEP AS THE FIRST COUNTERPOINT FOR VAPOUR
!DENS2_VAP    '       -3           USE 2 * NEWTON STEP AS THE FIRST COUNTERPOINT FOR VAPOUR
!DENS2_VAP    '        D > 0       USE D AS THE FIRST COUNTERPOINT DENSITY FOR VAPOUR

implicit none
character*13 key
real*8 value

call init_it_ctrl_density

select case (trim(key))

  case ('it_steps')             !ITERATION STEPS
    if(value == 0d0)then
       ctrl_loop_maximum = 100  !DEFAULT = 100
    elseif(value < 0d0)then
       ctrl_loop_maximum = -1
    else
       ctrl_loop_maximum = nint(value)
    endif

  case ('init_liq_dens')        !START LIQUID DENSITY
    if(value == 0d0)then
       ctrl_mode_liquid = 0     !DEFAULT = IF97
    elseif(value < (-3d0))then
       !exit sub
    elseif(value < 0d0)then
       ctrl_mode_liquid = nint(value)
    else
       ctrl_mode_liquid = 1
       ctrl_density_liquid = value
    endif

  case ('init_vap_dens')        !START VAPOUR DENSITY
    if(value == 0d0)then
       ctrl_mode_vapour = 0     !DEFAULT = IF97
    elseif(value < (-2d0))then
       !exit sub
    elseif(value < 0d0)then
       ctrl_mode_vapour = nint(value)
    else
       ctrl_mode_vapour = 1
       ctrl_density_vapour = value
    endif

  case ('tol_liq_dens')         !REQUIRED LIQUID DENSITY TOLERANCE
    if(value == 0d0)then
       ctrl_eps_exit_liquid = -0.0000001d0   !DEFAULT = 0.1 PPM RELATIVE
    else
       ctrl_eps_exit_liquid = value
    endif

  case ('tol_vap_dens')         !REQUIRED VAPOUR DENSITY TOLERANCE
    if(value == 0d0)then
       ctrl_eps_exit_vapour = -0.0000001d0   !DEFAULT = 0.1 PPM RELATIVE
    else
       ctrl_eps_exit_vapour = value
    endif

  case ('method_liq')
      if(value == 0d0 .or. value == 1d0 .or. value == 2d0 .or. &
      value == 3d0) ctrl_method_liquid = nint(value)

  case ('dens2_liq')
    if(value >= -3d0) ctrl_density2_liquid = value

  case ('method_vap')
      if(value == 0d0 .or. value == 1d0 .or. value == 2d0 .or. &
      value == 3d0) ctrl_method_vapour = nint(value)

  case ('dens2_vap')
      if(value >= -3d0) ctrl_density2_vapour = value

  case default; write(*,*)key,' not supported'
  
end select

end subroutine

!==========================================================================
function get_it_ctrl_density(key)
!==========================================================================

!THIS FUNCTION RETURNS CONTROL PARAMETERS AS SET FOR THE NEWTON ITERATION
!USED TO COMPUTE IAPWS-95 DENSITY FROM PRESSURE

implicit none
character*13 key
real*8 get_it_ctrl_density

get_it_ctrl_density = errorreturn

call init_it_ctrl_density

select case (trim(key))

  case ('it_steps')   !ITERATION STEPS
    get_it_ctrl_density = ctrl_loop_maximum

  case ('init_liq_dens')   !START LIQUID DENSITY
    if(ctrl_mode_liquid == 1) then
      get_it_ctrl_density = ctrl_density_liquid
    else
      get_it_ctrl_density = ctrl_mode_liquid
    end if

  case ('init_vap_dens')   !START VAPOUR DENSITY
    if(ctrl_mode_vapour == 1) then
      get_it_ctrl_density = ctrl_density_vapour
    else
      get_it_ctrl_density = ctrl_mode_vapour
    end if

  case ('tol_liq_dens')      !REQUIRED LIQUID DENSITY TOLERANCE
    get_it_ctrl_density = ctrl_eps_exit_liquid

  case ('tol_vap_dens')      !REQUIRED VAPOUR DENSITY TOLERANCE
    get_it_ctrl_density = ctrl_eps_exit_vapour

  case ('method_liq')        !SELECTED ITERATION METHOD FOR LIQUID
    get_it_ctrl_density = ctrl_method_liquid

  case ('dens2_liq')         !COUNTERPOINT VALUE FOR LIQUID (IRRELEVANT FOR NEWTON)
    get_it_ctrl_density = ctrl_density2_liquid

  case ('method_vap')        !SELECTED ITERATION METHOD FOR VAPOUR
    get_it_ctrl_density = ctrl_method_vapour

  case ('dens2_vap')         !COUNTERPOINT VALUE FOR VAPOUR (IRRELEVANT FOR NEWTON)
    get_it_ctrl_density = ctrl_density2_vapour

  case default;
    get_it_ctrl_density = errorreturn
    
end select

end function

!==========================================================================
subroutine init_f03
!==========================================================================

! G(T,P) = SUM GC03(J,K) * (T/40°C)^J * (P/100 MPA)^K
!          J,K

implicit none

real*8 g, g_t, g_p
real*8 tt, t0, tu, pt, p0, pu, yt, zt

if(gc03(2, 0) == -12357.785933039d0) return

tt = tp_temperature_si
t0 = celsius_temperature_si
tu = 40d0

pt = tp_pressure_iapws95_si !IAPWS-95 TRIPLE POINT PRESSURE
p0 = sealevel_pressure_si
pu = 100000000d0

yt = (tt - t0) / tu
zt = (pt - p0) / pu

gc03 = 0d0

gc03(2, 0) = -12357.785933039d0
gc03(3, 0) = 736.741204151612d0
gc03(4, 0) = -148.185936433658d0
gc03(5, 0) = 58.0259125842571d0
gc03(6, 0) = -18.9843846514172d0
gc03(7, 0) = 3.05081646487967d0
gc03(0, 1) = 100015.695367145d0
gc03(1, 1) = -270.983805184062d0
gc03(2, 1) = 1455.0364540468d0
gc03(3, 1) = -672.50778314507d0
gc03(4, 1) = 397.968445406972d0
gc03(5, 1) = -194.618310617595d0
gc03(6, 1) = 63.5113936641785d0
gc03(7, 1) = -9.63108119393062d0
gc03(0, 2) = -2544.5765420363d0
gc03(1, 2) = 776.153611613101d0
gc03(2, 2) = -756.558385769359d0
gc03(3, 2) = 499.360390819152d0
gc03(4, 2) = -301.815380621876d0
gc03(5, 2) = 120.520654902025d0
gc03(6, 2) = -22.2897317140459d0
gc03(0, 3) = 284.517778446287d0
gc03(1, 3) = -196.51255088122d0
gc03(2, 3) = 273.479662323528d0
gc03(3, 3) = -239.545330654412d0
gc03(4, 3) = 152.196371733841d0
gc03(5, 3) = -55.2723052340152d0
gc03(6, 3) = 8.17060541818112d0
gc03(0, 4) = -33.3146754253611d0
gc03(1, 4) = 28.9796526294175d0
gc03(1, 4) = 28.9796526294175d0
gc03(2, 4) = -55.5604063817218d0
gc03(2, 4) = -55.5604063817218d0
gc03(3, 4) = 48.8012518593872d0
gc03(4, 4) = -26.3748377232802d0
gc03(5, 4) = 6.48190668077221d0
gc03(0, 5) = 4.20263108803084d0
gc03(1, 5) = -2.13290083518327d0
gc03(2, 5) = 4.34420671917197d0
gc03(3, 5) = -1.66307106208905d0
gc03(0, 6) = -0.546428511471039d0

!IAPWS-95 REFERENCE STATE CONDITION
!ENERGY = 0 AND ENTROPY = 0 AT THE TRIPLE POINT:
!THESE ARE ONLY USED AS A FIRST GUESS HERE SO HIGH ACCURACY IS NOT REQUIRED.
gc03(0, 0) = 101.342743139674d0
gc03(1, 0) =  5.90578347909402d0

!NEVERTHELESS, THE ACCURACY CAN BE IMPROVED FOLLOWING KIYOSHI'S SUGGESTION.
!ADJUSTMENT OF COEFFICIENTS

!WRITE(*,*)"GC00, GC10: FIRST ESTIMATES = ", GC03(0,0), GC03(1,0)

g = polyf03_gyz(0, 0, yt, zt)
g_t = polyf03_gyz(1, 0, yt, zt) / tu
g_p = polyf03_gyz(0, 1, yt, zt) / pu

!WRITE(*,*)'G,G_T,G_P=',G,G_T,G_P
gc03(0, 0) = gc03(0, 0) - g + pt * g_p
gc03(1, 0) = gc03(1, 0) - g_t * tu

!WRITE(*,*)"GC00, GC10: SECOND ESTIMATES = ", GC03(0,0), GC03(1,0)

end subroutine
 
!=========================================================================
subroutine init_if97_1
!=========================================================================

implicit none
integer i

if(n1i(1) == 0.14632971213167d0) return

!TABLE 2. NUMERICAL VALUES OF THE COEFFICIENTS AND EXPONENTS OF THE DIMENSIONLESS GIBBS FREE ENERGY
!FOR REGION 1, EQ. (7)
!I     II            JI            NI
i = 1; i1i(i)  = 0;  j1i(i) = -2;  n1i(i) = 0.14632971213167d0
i = 2; i1i(i)  = 0;  j1i(i) = -1;  n1i(i) = -0.84548187169114d0
i = 3; i1i(i)  = 0;  j1i(i) = 0;   n1i(i) = -3.756360367204d0
i = 4; i1i(i)  = 0;  j1i(i) = 1;   n1i(i) = 3.3855169168385d0
i = 5; i1i(i)  = 0;  j1i(i) = 2;   n1i(i) = -0.95791963387872d0
i = 6; i1i(i)  = 0;  j1i(i) = 3;   n1i(i) = 0.15772038513228d0
i = 7; i1i(i)  = 0;  j1i(i) = 4;   n1i(i) = -0.016616417199501d0
i = 8; i1i(i)  = 0;  j1i(i) = 5;   n1i(i) = 8.1214629983568d-04
i = 9; i1i(i)  = 1;  j1i(i) = -9;  n1i(i) = 2.8319080123804d-04
i = 10; i1i(i) = 1;  j1i(i) = -7;  n1i(i) = -6.0706301565874d-04
i = 11; i1i(i) = 1;  j1i(i) = -1;  n1i(i) = -0.018990068218419d0
i = 12; i1i(i) = 1;  j1i(i) = 0;   n1i(i) = -0.032529748770505d0
i = 13; i1i(i) = 1;  j1i(i) = 1;   n1i(i) = -0.021841717175414d0
i = 14; i1i(i) = 1;  j1i(i) = 3;   n1i(i) = -5.283835796993d-05  
i = 15; i1i(i) = 2;  j1i(i) = -3;  n1i(i) = -4.7184321073267d-04
i = 16; i1i(i) = 2;  j1i(i) = 0;   n1i(i) = -3.0001780793026d-04
i = 17; i1i(i) = 2;  j1i(i) = 1;   n1i(i) = 4.7661393906987d-05
i = 18; i1i(i) = 2;  j1i(i) = 3;   n1i(i) = -4.4141845330846d-06
i = 19; i1i(i) = 2;  j1i(i) = 17;  n1i(i) = -7.2694996297594d-16
i = 20; i1i(i) = 3;  j1i(i) = -4;  n1i(i) = -3.1679644845054d-05
i = 21; i1i(i) = 3;  j1i(i) = 0;   n1i(i) = -2.8270797985312d-06
i = 22; i1i(i) = 3;  j1i(i) = 6;   n1i(i) = -8.5205128120103d-10
i = 23; i1i(i) = 4;  j1i(i) = -5;  n1i(i) = -2.2425281908d-06
i = 24; i1i(i) = 4;  j1i(i) = -2;  n1i(i) = -6.5171222895601d-07
i = 25; i1i(i) = 4;  j1i(i) = 10;  n1i(i) = -1.4341729937924d-13
i = 26; i1i(i) = 5;  j1i(i) = -8;  n1i(i) = -4.0516996860117d-07
i = 27; i1i(i) = 8;  j1i(i) = -11; n1i(i) = -1.2734301741641d-09
i = 28; i1i(i) = 8;  j1i(i) = -6;  n1i(i) = -1.7424871230634d-10
i = 29; i1i(i) = 21; j1i(i) = -29; n1i(i) = -6.8762131295531d-19
i = 30; i1i(i) = 23; j1i(i) = -31; n1i(i) = 1.4478307828521d-20
i = 31; i1i(i) = 29; j1i(i) = -38; n1i(i) = 2.6335781662795d-23
i = 32; i1i(i) = 30; j1i(i) = -39; n1i(i) = -1.1947622640071d-23
i = 33; i1i(i) = 31; j1i(i) = -40; n1i(i) = 1.8228094581404d-24
i = 34; i1i(i) = 32; j1i(i) = -41; n1i(i) = -9.3537087292458d-26

end subroutine
 
!=========================================================================
subroutine init_if97_2
!=========================================================================

implicit none
integer i

if(n0i(1) == -9.6927686500217d0) return

!TABLE 10. NUMERICAL VALUES OF THE COEFFICIENTS AND EXPONENTS OF THE IDEAL-GAS PART GAMMA_0 OF THE
!DIMENSIONLESS GIBBS FREE ENERGY FOR REGION 2, EQ. (16)
!I     JI           NI
i = 1; j0i(i) = 0;  n0i(i) = -9.6927686500217d0
i = 2; j0i(i) = 1;  n0i(i) = 10.086655968018d0
i = 3; j0i(i) = -5; n0i(i) = -0.005608791128302d0
i = 4; j0i(i) = -4; n0i(i) = 0.071452738081455d0
i = 5; j0i(i) = -3; n0i(i) = -0.40710498223928d0
i = 6; j0i(i) = -2; n0i(i) = 1.4240819171444d0
i = 7; j0i(i) = -1; n0i(i) = -4.383951131945d0
i = 8; j0i(i) = 2;  n0i(i) = -0.28408632460772d0
i = 9; j0i(i) = 3;  n0i(i) = 0.021268463753307d0
!IF(EQ. (16) IS INCORPORATED INTO EQ. (18), INSTEAD OF THE-VALUES FOR N0I(1) AND N0I(1)
!GIVEN ABOVE, THE FOLLOWING VALUES
!N0I(1) = -0.96937268393049D1
!N0I(2) = 0.10087275970006D2
!SHOULD BE USED


!TABLE 11. NUMERICAL VALUES OF THE COEFFICIENTS AND EXPONENTS OF THE
!RESIDUAL PART GAMMA_R OF THE DIMENSIONLESS GIBBS FREE ENERGY FOR
!REGION 2, EQ. (17)
!I      II           JI           NI
i = 1;  iri(i) = 1;  jri(i) = 0;  nri(i) = -1.7731742473213d-03
i = 2;  iri(i) = 1;  jri(i) = 1;  nri(i) = -0.017834862292358d0
i = 3;  iri(i) = 1;  jri(i) = 2;  nri(i) = -0.045996013696365d0
i = 4;  iri(i) = 1;  jri(i) = 3;  nri(i) = -0.057581259083432d0
i = 5;  iri(i) = 1;  jri(i) = 6;  nri(i) = -0.05032527872793d0
i = 6;  iri(i) = 2;  jri(i) = 1;  nri(i) = -3.3032641670203d-05
i = 7;  iri(i) = 2;  jri(i) = 2;  nri(i) = -1.8948987516315d-04
i = 8;  iri(i) = 2;  jri(i) = 4;  nri(i) = -3.9392777243355d-03
i = 9;  iri(i) = 2;  jri(i) = 7;  nri(i) = -0.043797295650573d0
i = 10; iri(i) = 2;  jri(i) = 36; nri(i) = -2.6674547914087d-05
i = 11; iri(i) = 3;  jri(i) = 0;  nri(i) = 2.0481737692309d-08
i = 12; iri(i) = 3;  jri(i) = 1;  nri(i) = 4.3870667284435d-07
i = 13; iri(i) = 3;  jri(i) = 3;  nri(i) = -3.227767723857d-05
i = 14; iri(i) = 3;  jri(i) = 6;  nri(i) = -1.5033924542148d-03
i = 15; iri(i) = 3;  jri(i) = 35; nri(i) = -0.040668253562649d0
i = 16; iri(i) = 4;  jri(i) = 1;  nri(i) = -7.8847309559367d-10
i = 17; iri(i) = 4;  jri(i) = 2;  nri(i) = 1.2790717852285d-08
i = 18; iri(i) = 4;  jri(i) = 3;  nri(i) = 4.8225372718507d-07
i = 19; iri(i) = 5;  jri(i) = 7;  nri(i) = 2.2922076337661d-06
i = 20; iri(i) = 6;  jri(i) = 3;  nri(i) = -1.6714766451061d-11
i = 21; iri(i) = 6;  jri(i) = 16; nri(i) = -2.1171472321355d-03
i = 22; iri(i) = 6;  jri(i) = 35; nri(i) = -23.895741934104d0
i = 23; iri(i) = 7;  jri(i) = 0;  nri(i) = -5.905956432427d-18
i = 24; iri(i) = 7;  jri(i) = 11; nri(i) = -1.2621808899101d-06
i = 25; iri(i) = 7;  jri(i) = 25; nri(i) = -0.038946842435739d0
i = 26; iri(i) = 8;  jri(i) = 8;  nri(i) = 1.1256211360459d-11
i = 27; iri(i) = 8;  jri(i) = 36; nri(i) = -8.2311340897998d0
i = 28; iri(i) = 9;  jri(i) = 13; nri(i) = 1.9809712802088d-08
i = 29; iri(i) = 10; jri(i) = 4;  nri(i) = 1.0406965210174d-19
i = 30; iri(i) = 10; jri(i) = 10; nri(i) = -1.0234747095929d-13
i = 31; iri(i) = 10; jri(i) = 14; nri(i) = -1.0018179379511d-09
i = 32; iri(i) = 16; jri(i) = 29; nri(i) = -8.0882908646985d-11
i = 33; iri(i) = 16; jri(i) = 50; nri(i) = 0.10693031879409d0
i = 34; iri(i) = 18; jri(i) = 57; nri(i) = -0.33662250574171d0
i = 35; iri(i) = 20; jri(i) = 20; nri(i) = 8.9185845355421d-25
i = 36; iri(i) = 20; jri(i) = 35; nri(i) = 3.0629316876232d-13
i = 37; iri(i) = 20; jri(i) = 48; nri(i) = -4.2002467698208d-06
i = 38; iri(i) = 21; jri(i) = 21; nri(i) = -5.9056029685639d-26
i = 39; iri(i) = 22; jri(i) = 53; nri(i) = 3.7826947613457d-06
i = 40; iri(i) = 23; jri(i) = 39; nri(i) = -1.2768608934681d-15
i = 41; iri(i) = 24; jri(i) = 26; nri(i) = 7.3087610595061d-29
i = 42; iri(i) = 24; jri(i) = 40; nri(i) = 5.5414715350778d-17
i = 43; iri(i) = 24; jri(i) = 58; nri(i) = -9.436970724121d-07

end subroutine

!==========================================================================
subroutine swap(a, b)
!==========================================================================

implicit none
real*8 a, b, c
c = a
a = b
b = c

end subroutine

!==========================================================================
subroutine sort3up(d1, d2, d3)
!==========================================================================

!SORT D1, D2, D3 INCREASING

implicit none
real*8 d1, d2, d3

if(d2 > d3) call swap(d2, d3)
if(d1 > d2) call swap(d1, d2)
if(d2 > d3) call swap(d2, d3)

end subroutine


end module flu_3a

module sea_liq_4

!#########################################################################

!THIS MODULE IMPLEMENTS THE PHASE EQUILBRIUM PROPERTIES OF LIQUID WATER 
!WITH SEAWATER COMPUTED FROM IAPWS-95 AND IAPWS-08:

!RELEASE ON THE IAPWS FORMULATION 1995 FOR THE THERMODYNAMIC PROPERTIES OF
!ORDINARY WATER SUBSTANCE FOR GENERAL AND SCIENTIFIC USE
!THE INTERNATIONAL ASSOCIATION FOR THE PROPERTIES OF WATER AND STEAM
!FREDERICIA, DENMARK, SEPTEMBER 1996

!RELEASE ON THE IAPWS FORMULATION 2008 FOR THE THERMODYNAMIC PROPERTIES OF SEAWATER
!THE INTERNATIONAL ASSOCIATION FOR THE PROPERTIES OF WATER AND STEAM
!BERLIN, GERMANY, SEPTEMBER 2008

!#########################################################################

!IMPLEMENTATION IN FORTRAN BY D.G. WRIGHT
!FOR PUBLICATION IN OCEAN SCIENCE, AS DESCRIBED IN THE PAPERS

!FEISTEL, R., WRIGHT, D.G., JACKETT, D.R., MIYAGAWA, K., REISSMANN, J.H.,
!WAGNER, W., OVERHOFF, U., GUDER, C., FEISTEL, A., MARION, G.M.:
!NUMERICAL IMPLEMENTATION AND OCEANOGRAPHIC APPLICATION OF THE THERMODYNAMIC
!POTENTIALS OF WATER, VAPOUR, ICE, SEAWATER AND AIR. PART I: BACKGROUND AND EQUATIONS. 
!OCEAN SCIENCES, 2009, IN PREPARATION.

!WRIGHT, D.G., FEISTEL, R., JACKETT, D.R., MIYAGAWA, K., REISSMANN, J.H., 
!WAGNER, W., OVERHOFF, U., GUDER, C., FEISTEL, A., MARION, G.M.:
!NUMERICAL IMPLEMENTATION AND OCEANOGRAPHIC APPLICATION OF THE THERMODYNAMIC
!POTENTIALS OF WATER, VAPOUR, ICE, SEAWATER AND AIR. PART II: THE LIBRARY ROUTINES, 
!OCEAN SCIENCES., 2009, IN PREPARATION.

!FEISTEL, R., KRETZSCHMAR, H.-J., SPAN, R., HAGEN, E., WRIGHT, D.G., JACKETT, D.R.:
!THERMODYNAMIC PROPERTIES OF SEA AIR.
!OCEAN SCIENCE DISCUSSION 6(2009)2193-2325.

!#########################################################################

!THIS MODULE REQUIRES THE LIBRARY MODULES:
!     CONSTANTS_0, FILE CONSTANTS_0.F90
!     FLU_1,       FILE FLU_1.F90
!     SAL_1,       FILE SAL_1.F90
!     FLU_2,       FILE FLU_2.F90
!     SAL_2,       FILE SAL_2.F90
!     FLU_3A,      FILE FLU_3A.F90

!NESTED USE ASSOCIATIONS
!     CONVERT_0,   FILE CONVERT_0.F90
!     MATHS_0,     FILE MATHS_0.F90

!=========================================================================

use constants_0
use flu_1
use sal_1
use flu_2
use sal_2
use flu_3a

implicit none
private

character*16, private :: version = '8 Jun 2010'

public :: sea_liq_osmoticpressure_si, set_it_ctrl_sea_liq, &
          set_sea_liq_eq_at_s_t_p

!CONTROL PARAMETERS OF THE SEAWATER-LIQUID ITERATION
real*8, private :: ctrl_init_d_liq, ctrl_eps_exit_p

integer, private :: ctrl_initialized, ctrl_loop_maximum, ctrl_mode_liquid

!PROPERTIES OF THE CURRENT SEAWATER-LIQUID EQUILIBRIUM STATE

integer, private :: equi_sea_liq_done
real*8, private :: equi_sea_liq_d_liq, equi_sea_liq_d_sea, equi_sea_liq_s, &
        equi_sea_liq_t, equi_sea_liq_p_liq, equi_sea_liq_p_sea

contains

!==========================================================================
function sea_liq_osmoticpressure_si(sa_si, t_si, p_si)
!==========================================================================

!THIS FUNCTION COMPUTES THE OSMOTIC PRESSURE IN PA AT THE ABSOLUTE TEMPERATURE T_SI IN K,
!THE ABSOLUTE PRESSURE OF LIQUID WATER P_SI IN PA AND THE SEAWATER SALINITY SA_SI IN KG/KG

!CHECK VALUE WITH DEFAULT SETTINGS: 
!SEA_LIQ_OSMOTICPRESSURE_SI(0.035, 300, 1E5) = 2594603.20968

!NOTE: THE ACCURACY OF THIS FUNCTION DEPENDS ON THE ITERATION SETTINGS IN THIS MODULE
 
implicit none
real*8 sea_liq_osmoticpressure_si, sa_si, t_si, p_si

sea_liq_osmoticpressure_si = errorreturn

if(set_sea_liq_eq_at_s_t_p(sa_si, t_si, p_si) == errorreturn) return

sea_liq_osmoticpressure_si = equi_sea_liq_p_sea - equi_sea_liq_p_liq

end function

!==========================================================================
function set_sea_liq_eq_at_s_t_p(sa_si, t_si, p_liq_si)
!==========================================================================

!THIS FUNCTION COMPUTES THE SEAWATER-WATER EQUILIBRIUM AT GIVEN TEMPERATURE AND SALINITY
!BY NEWTON ITERATION

implicit none

integer maxit
real*8 set_sea_liq_eq_at_s_t_p, sa_si, t_si, p_liq_si
real*8 eps
real*8 d_liq
real*8 d_sea, p_sea

if(equi_sea_liq_done == isok .and. sa_si == equi_sea_liq_s &
  .and. t_si == equi_sea_liq_t .and. p_liq_si == equi_sea_liq_p_liq) then
  !THE REQUESTED STATE HAS ALREADY BEEN COMPUTED EARLIER
  set_sea_liq_eq_at_s_t_p = isok
  return
end if

call clear_sea_liq_state !WASTE ANY PREVIOUS STATE

set_sea_liq_eq_at_s_t_p = errorreturn

if(sa_si <= 0d0) return
if(sa_si >= 1d0) return
if(t_si <= 0d0) return
if(p_liq_si <= 0d0) return

d_liq = liq_density_si(t_si, p_liq_si)
if(d_liq == errorreturn) return

call init_it_ctrl_sea_liq

!SET INITIAL DENSITY GUESS FOR WATER UNDER SEAWATER PRESSURE
select case (ctrl_mode_liquid)
  case (0);  d_sea = d_liq
  case (1);  d_sea = ctrl_init_d_liq
  case default; return
end select
if(d_sea <= 0d0) return
if(d_sea == errorreturn) return

!SET MAX. ITERATION NUMBER
  if(ctrl_loop_maximum == 0) then
    maxit = 100
  elseif(ctrl_loop_maximum == (-1))then
    p_sea = d_sea ** 2 * flu_f_si(0, 1, t_si, d_sea)
    call set_sea_liq_state (d_liq, d_sea, sa_si, t_si, p_liq_si, p_sea)
    set_sea_liq_eq_at_s_t_p = isok
    return
  elseif(ctrl_loop_maximum > 0)then
    maxit = ctrl_loop_maximum
  else
    return
  endif

!SET ITERATION ACCURACY LIMIT
eps = ctrl_eps_exit_p
if(eps == 0d0) return

!RUN ITERATION LOOP
if(sea_liq_iteration_at_s_t_d(sa_si, t_si, d_liq, maxit, eps, d_sea, p_sea) == errorreturn) then
  return
end if

call set_sea_liq_state (d_liq, d_sea, sa_si, t_si, p_liq_si, p_sea)

set_sea_liq_eq_at_s_t_p = isok

end function

!==========================================================================
function sea_liq_iteration_at_s_t_d(sa_si, t_si, d_liq_si, maxit, eps, d_sea_si, p_sea_si)
!==========================================================================

!THIS FUNCTION COMPUTES THE SEAWATER-WATER PHASE EQUILIBRIUM FROM
!EQUAL CHEMICAL POTENTIALS OF WATER AT GIVEN SALINITY, SA_SI, AND TEMPERATURE, T_SI,
!AND LIQUID DENSITY, D_LIQ_SI, FROM AN INITIAL GUESS FOR THE DENSITY, D_SEA_SI.
!D_LIQ_SI IS THE DENSITY IN KG/M3 OF LIQUID WATER UNDER THE PRESSURE OF THE PURE WATER COMPARTMENT.
!D_SEA_SI IS THE DENSITY IN KG/M3 OF LIQUID WATER UNDER THE PRESSURE OF THE SEAWATER COMPARTMENT.
!THE ITERATION LIMIT EPS REFERS TO THE ERROR IN PRESSURE.

!OUTPUT: 
!        SEA_LIQ_ITERATION_AT_S_T_D = ISOK IF SUCCESSFULLY DONE
!        SEA_LIQ_ITERATION_AT_S_T_D = ERRORRETURN IS RETURNED IF
!        - THE MAXIMUM NUMBER OF ITERATIONS IS EXCEEDED WITHOUT MEETING THE EXIT CRITERION
!        - THE FUNCTION CALL TO A GIBBS/HELMHOLTZ FUNCTION HAS RETURNED AN ERROR
!        - DENSITY HAS TAKEN A ZERO OR NEGATIVE VALUE DURING THE ITERATION
! D_SEA_SI: DENSITY OF LIQUID WATER IN KG/M3 AT (T_SI, P_SEA_SI) 
! P_SEA_SI: PRESSURE IN PA ON SEAWATER = PRESSURE ON WATER + OSMOTIC PRESSURE

!INPUT: 
!       SA_SI: ABSOLUTE SALINITY IN KG/KG
!        T_SI: ABSOLUTE TEMPERATURE IN K
!    D_LIQ_SI: DENSITY OF LIQUID WATER IN KG/M3
!       MAXIT: MAXIMUM NUMBER OF ITERATION STEPS TO BE DONE
!         EPS: REQUIRED ACCURACY OF PRESSURE
!              EPS > 0: ABSOLUTE PRESSURE TOLERANCE IN PA
!              EPS < 0: RELATIVE PRESSURE TOLERANCE
!    D_SEA_SI: INITIAL GUESS FOR DENSITY OF WATER IN KG/M3 UNDER OSMOTIC PRESSURE

implicit none

integer it, maxit

real*8 sea_liq_iteration_at_s_t_d, sa_si, t_si, d_liq_si, eps, d_sea_si, p_sea_si
real*8 p, d, dd
real*8 mus, p_old
real*8 gl, gw
real*8 gs_p, gs_sp
real*8 f, f_d, f_dd

sea_liq_iteration_at_s_t_d = errorreturn

if(d_sea_si <= 0d0) then
  d_sea_si = errorreturn
  p_sea_si = errorreturn
  return
endif

if(check_limits == 1) then
  !FLU_LIMITS
  if(t_si < flu_tmin .or. t_si > flu_tmax .or. &
  d_liq_si <= flu_dmin .or. d_liq_si > flu_dmax) then
    d_sea_si = errorreturn
    p_sea_si = errorreturn
    return
  endif
  !SAL_LIMITS
  if(t_si < sal_tmin .or. t_si > sal_tmax .or. &
  sa_si < sal_smin .or. sa_si > sal_smax) then
    d_sea_si = errorreturn
    p_sea_si = errorreturn
    return
  endif
else
  if((d_liq_si <= 0d0) .or. &
    (t_si <= 0d0) .or. &
    (sa_si <= 0d0) .or. (sa_si >= 1d0)) then
    d_sea_si = errorreturn
    p_sea_si = errorreturn
    return
  endif
endif

check_limits = check_limits - 1

gw = flu_gibbs_energy_si(t_si, d_liq_si)
if(gw == errorreturn) go to 999
d = d_sea_si

do it = 0, maxit

  !DERIVATIVES OF THE HELMHOLTZ FUNCTION OF LIQUID WATER FOR NEWTON ITERATION
  f = flu_f_si(0, 0, t_si, d)
  if(f == errorreturn) go to 999
  f_d = flu_f_si(0, 1, t_si, d)
  if(f_d == errorreturn) go to 999
  f_dd = flu_f_si(0, 2, t_si, d)
  if(f_dd == errorreturn) go to 999
  p_old = p
  p = d ** 2 * f_d
  gl = f + d * f_d

  !DERIVATIVES OF THE SALINE GIBBS FUNCTION FOR NEWTON ITERATION
  mus = sal_chempot_h2o_si(sa_si, t_si, p) !SALINE CHEMICAL POTENTIAL GS + S*DG/DS
  if(mus == errorreturn) go to 999
  gs_p = sal_g_si(0, 0, 1, sa_si, t_si, p)
  if(gs_p == errorreturn) go to 999
  gs_sp = sal_g_si(1, 0, 1, sa_si, t_si, p)
  if(gs_sp == errorreturn) go to 999

  if(it > 0) then
    !CHECK ABSOLUTE OR RELATIVE ERROR LIMIT
    if((eps > 0 .and. abs(p - p_old) < eps) .or. &
       (eps < 0 .and. abs(p - p_old) < -eps * abs(p))) then
      if(p <= 0) go to 999
      sea_liq_iteration_at_s_t_d = isok
      p_sea_si = p
      d_sea_si = d
      go to 999
    end if
  end if

  if(it == maxit) go to 999

  !DENSITY ITERATION STEP
  dd = (2d0 * f_d + d * f_dd) * (1d0 + d * (gs_p - sa_si * gs_sp))
  if(dd == 0d0) go to 999
  dd = (gw - gl - mus) / dd

  !UPDATE LIQUID DENSITY
  d = d + dd
  if(d <= 0d0) go to 999

enddo

999 continue

check_limits = check_limits + 1

if(check_limits == 1) then
  !FLU_LIMITS
  if(d_sea_si <= flu_dmin .or. d_sea_si > flu_dmax) then
    d_sea_si = errorreturn
    p_sea_si = errorreturn
    sea_liq_iteration_at_s_t_d = errorreturn
    return
  endif
  !SAL_LIMITS
  if(p_sea_si < sal_pmin .or. p_sea_si > sal_pmax) then
    d_sea_si = errorreturn
    p_sea_si = errorreturn
    sea_liq_iteration_at_s_t_d = errorreturn
    return
  endif
endif

end function

!==========================================================================
subroutine set_it_ctrl_sea_liq(key, value)
!==========================================================================

!THIS SUB SETS CONTROL PARAMETERS FOR THE ITERATION USED TO COMPUTE
!SEAWATER-WATER EQUILIBRIUM

!KEY                    VALUE
!'IT_STEPS     '        0           SET ITERATION NUMBER TO DEFAULT (100)
!'IT_STEPS     '        N > 0       SET ITERATION NUMBER TO N
!'IT_STEPS     '       -1           DO NOT ITERATE, USE INITIAL VALUES TO COMPUTE EQULIBRIUM

!'INIT_LIQ_DENS'        0           USE DEFAULT LIQUID DENSITY TO START =
!                                   LIQUID DENSITY IAPWS95, D = LIQ_DENSITY_SI(T,P)
!'INIT_LIQ_DENS'        D > 0       USE VALUE D AS LIQUID DENSITY TO START

!'TOL_LIQ_PRESS'        0           USE DEFAULT EXIT ACCURACY FOR SEAWATER PRESSURE (0.1 PPM)
!'TOL_LIQ_PRESS'        EPS         USE EPS AS EXIT ACCURACY FOR PRESSURE (EPS < 0 MEANS RELATIVE ERROR)

implicit none

character*13 key
real*8 value

call init_it_ctrl_sea_liq

call clear_sea_liq_state

select case (trim(key))

  case ('it_steps')   !ITERATION STEPS
    if(value == 0d0)then
      ctrl_loop_maximum = 100  !DEFAULT = 100
    elseif(value < 0d0)then
      ctrl_loop_maximum = -1
    else
      ctrl_loop_maximum = nint(value)
    endif

  case ('init_liq_dens')   !START LIQUID DENSITY
    if(value == 0d0)then
      ctrl_mode_liquid = 0    !DEFAULT = PURE WATER DENSITY
    elseif(value < 0d0)then
      !ignore it
    else
      ctrl_mode_liquid = 1
      ctrl_init_d_liq = value
    endif

  case ('tol_liq_press')      !REQUIRED LIQUID PRESSURE TOLERANCE
    if(value == 0d0)then
      ctrl_eps_exit_p = -0.0000001d0   !DEFAULT = 0.1 PPM RELATIVE
    else
      ctrl_eps_exit_p = value
    endif

  case default; write(*,*)key,' not supported'

end select

end subroutine

!==========================================================================
subroutine clear_sea_liq_state()
!==========================================================================

!CLEARS THE CURRENT EQUILIBRIUM STATE DESCRIPTOR

implicit none

equi_sea_liq_done = 0

end subroutine

!==========================================================================
subroutine init_it_ctrl_sea_liq()
!==========================================================================

implicit none

if(ctrl_initialized == isok) return

ctrl_initialized = isok

!SET DEFAULT VALUES AND MODES FOR DENSITY ITERATION
ctrl_mode_liquid = 0
ctrl_loop_maximum = 100
ctrl_init_d_liq = 1000
ctrl_eps_exit_p = -0.0000001d0 !RELATIVE, 0.1 PPM

end subroutine

!==========================================================================
subroutine set_sea_liq_state(d_liq, d, s, t, p_liq, p)
!==========================================================================

implicit none
real*8 d_liq, d, s, t, p_liq, p

equi_sea_liq_d_liq = d_liq    !EQUILIBRIUM DENSITY OF LIQUID WATER
equi_sea_liq_d_sea = d        !EQUILIBRIUM DENSITY OF LIQUID WATER UNDER SEAWATER PRESSURE
equi_sea_liq_s = s            !EQUILIBRIUM SALINITY
equi_sea_liq_t = t            !EQUILIBRIUM TEMPERATURE
equi_sea_liq_p_liq = p_liq    !EQUILIBRIUM PRESSURE OF LIQUID WATER
equi_sea_liq_p_sea = p        !EQUILIBRIUM PRESSURE OF SEAWATER

end subroutine

end module sea_liq_4

module ice_flu_5

!#########################################################################

!THIS MODULE IMPLEMENTS THE CORRELATION FUNCTIONS FOR MELTING AND SUBLIMATION OF ICE,
!AS PROPOSED IN

!RAINER FEISTEL:
!DEVELOPMENT OF NEW EQUATIONS FOR MELTING PRESSURE AND SUBLIMATION PRESSURE.
!TASKGROUP REPORT,
!IAPWS THERMOPHYSICAL PROPERTIES OF WATER AND STEAM WG
!WITNEY, UK, 3 TO 8 SEPTEMBER 2006

!ANd

!REVISED RELEASE ON THE PRESSURE ALONG THE MELTING AND
!SUBLIMATION CURVES OF ORDINARY WATER SUBSTANCE
!THE INTERNATIONAL ASSOCIATION FOR THE PROPERTIES OF WATER AND STEAM
!BERLIN, GERMANY, SEPTEMBER 2008

!IMPLEMENTATION IN VB6 BY RAINER FEISTEL
!FOR PUBLICATION IN OCEAN SCIENCE, AS DESCRIBED IN THE PAPERS

!FEISTEL, R., WRIGHT, D.G., JACKETT, D.R., MIYAGAWA, K., REISSMANN, J.H.,
!WAGNER, W., OVERHOFF, U., GUDER, C., FEISTEL, A., MARION, G.M.:
!NUMERICAL IMPLEMENTATION AND OCEANOGRAPHIC APPLICATION OF THE THERMODYNAMIC
!POTENTIALS OF WATER, VAPOUR, ICE, SEAWATER AND AIR. PART I: BACKGROUND AND EQUATIONS.
!OCEAN SCIENCES, 2009, IN PREPARATION.

!WRIGHT, D.G., FEISTEL, R., JACKETT, D.R., MIYAGAWA, K., REISSMANN, J.H.,
!WAGNER, W., OVERHOFF, U., GUDER, C., FEISTEL, A., MARION, G.M.:
!NUMERICAL IMPLEMENTATION AND OCEANOGRAPHIC APPLICATION OF THE THERMODYNAMIC
!POTENTIALS OF WATER, VAPOUR, ICE, SEAWATER AND AIR. PART II: THE LIBRARY ROUTINES,
!OCEAN SCIENCES., 2009, IN PREPARATION.

!#########################################################################

!THIS MODULE REQUIRES THE LIBRARY MODULE
!     CONSTANTS_0, file CONSTANTS_0.F90

!#########################################################################

use constants_0

implicit none
private

character*16, private :: version = '8 Jun 2010'

public :: fit_ice_liq_pressure_si, fit_ice_liq_temperature_si, &
          fit_ice_vap_pressure_si

contains

!==========================================================================
function fit_ice_liq_pressure_si(t_si)
!==========================================================================

!THIS IMPLEMENTS THE MELTING PRESSURE IN PA AS A FUNCTION OF TEMPERATURE IN K
!DETERMINED FROM A FIT OF THE FUNCTION ICE_LIQ_PRESSURE_SI,
!AS DEFINED IN EQ. (1) OF

!REVISED RELEASE ON THE PRESSURE ALONG THE MELTING AND
!SUBLIMATION CURVES OF ORDINARY WATER SUBSTANCE
!THE INTERNATIONAL ASSOCIATION FOR THE PROPERTIES OF WATER AND STEAM
!BERLIN, GERMANY, SEPTEMBER 2008

real*8 fit_ice_liq_pressure_si, t_si
real*8 pt, tt, a1, b1, a2, b2, a3, b3, tr, pr

pt = tp_pressure_exp_si
tt = tp_temperature_si

a1 = 1195393.37d0
b1 = 3d0
a2 = 80818.3159d0
b2 = 25.75d0
a3 = 3338.2686d0
b3 = 103.75d0

fit_ice_liq_pressure_si = errorreturn

if(t_si <= 0) return

tr = t_si / tt
pr = 1d0 + a1 * (1d0 - tr ** b1) + a2 * (1d0 - tr ** b2) + a3 * (1d0 - tr ** b3)

fit_ice_liq_pressure_si = pt * pr

end function

!==========================================================================
function fit_ice_liq_temperature_si(p_si)
!==========================================================================

!THIS IMPLEMENTS THE MELTING TEMPERATURE OF ICE IN K AS A FUNCTION OF PRESSURE IN PA
!DETERMINED FROM A FIT OF THE FUNCTION ICE_LIQ_TEMPERATURE_SI,
!AS DEFINED IN

!RAINER FEISTEL:
!DEVELOPMENT OF NEW EQUATIONS FOR MELTING PRESSURE AND SUBLIMATION PRESSURE.
!TASK GROUP REPORT, IAPWS THERMOPHYSICAL PROPERTIES OF WATER AND STEAM WG
!WITNEY, UK, 3 TO 8 SEPTEMBER 2006

real*8 fit_ice_liq_temperature_si, p_si
real*8 pt, tt, a1, a2, a3, a4, tr, pr

pt = tp_pressure_exp_si
tt = tp_temperature_si

a1 = -1.66356104484551d-07
a2 = -2.13519241979406d-13
a3 = 3.52967405341877d-20
a4 = -2.73184525236281d-26

fit_ice_liq_temperature_si = errorreturn

if(p_si <= 0) return

pr = p_si / pt

tr = 1d0 + a1 * (pr - 1d0) + a2 * (pr - 1d0) ** 2 + a3 * (pr - 1d0) ** 3 + a4 * (pr - 1d0) ** 4

fit_ice_liq_temperature_si = tt * tr

end function

!==========================================================================
function fit_ice_vap_pressure_si(t_si)
!==========================================================================

!THIS IMPLEMENTS THE SUBLIMATION PRESSURE IN PA AS A FUNCTION OF TEMPERATURE IN K
!DETERMINED FROM A FIT OF THE FUNCTION ICE_VAP_PRESSURE_SI,
!AS DEFINED IN EQ. (6) OF

!REVISED RELEASE ON THE PRESSURE ALONG THE MELTING AND
!SUBLIMATION CURVES OF ORDINARY WATER SUBSTANCE
!THE INTERNATIONAL ASSOCIATION FOR THE PROPERTIES OF WATER AND STEAM
!BERLIN, GERMANY, SEPTEMBER 2008

real*8 fit_ice_vap_pressure_si, t_si
real*8 pt, tt, a1, b1, a2, b2, a3, b3, tr, pr

pt = tp_pressure_exp_si
tt = tp_temperature_si

a1 = -21.2144006d0
b1 = 0.00333333333d0
a2 = 27.3203819d0
b2 = 1.20666667d0
a3 = -6.1059813d0
b3 = 1.70333333d0

fit_ice_vap_pressure_si = errorreturn

if(t_si <= 0) return

tr = t_si / tt
pr = a1 * tr ** b1 + a2 * tr ** b2 + a3 * tr ** b3

fit_ice_vap_pressure_si = pt * Exp(pr / tr)

end function

end module ice_flu_5

module liq_vap_4

!#########################################################################

!THIS MODULE IMPLEMENTS THE PHASE EQUILBRIUM PROPERTIES OF FLUID WATER
!COMPUTED FROM IAPWS-95:

!RELEASE ON THE IAPWS FORMULATION 1995 FOR THE THERMODYNAMIC PROPERTIES OF
!ORDINARY WATER SUBSTANCE FOR GENERAL .AND. SCIENTIFIC USE
!THE INTERNATIONAL ASSOCIATION FOR THE PROPERTIES OF WATER .AND. STEAM
!FREDERICIA, DENMARK, SEPTEMBER 1996

!#########################################################################

!IMPLEMENTATION IN FORTRAN BY D.G. WRIGHT
!FOR PUBLICATION IN OCEAN SCIENCE, AS DESCRIBED IN THE PAPERS

!FEISTEL, R., WRIGHT, D.G., JACKETT, D.R., MIYAGAWA, K., REISSMANN, J.H.,
!WAGNER, W., OVERHOFF, U., GUDER, C., FEISTEL, A., MARION, G.M.:
!NUMERICAL IMPLEMENTATION AND OCEANOGRAPHIC APPLICATION OF THE THERMODYNAMIC
!POTENTIALS OF WATER, VAPOUR, ICE, SEAWATER AND AIR. PART I: BACKGROUND AND EQUATIONS. 
!OCEAN SCIENCES, 2009, IN PREPARATION.

!WRIGHT, D.G., FEISTEL, R., JACKETT, D.R., MIYAGAWA, K., REISSMANN, J.H., 
!WAGNER, W., OVERHOFF, U., GUDER, C., FEISTEL, A., MARION, G.M.:
!NUMERICAL IMPLEMENTATION AND OCEANOGRAPHIC APPLICATION OF THE THERMODYNAMIC
!POTENTIALS OF WATER, VAPOUR, ICE, SEAWATER AND AIR. PART II: THE LIBRARY ROUTINES, 
!OCEAN SCIENCES., 2009, IN PREPARATION.

!FEISTEL, R., KRETZSCHMAR, H.-J., SPAN, R., HAGEN, E., WRIGHT, D.G., JACKETT, D.R.:
!THERMODYNAMIC PROPERTIES OF SEA AIR.
!OCEAN SCIENCE DISCUSSION 6(2009)2193-2325.

!#########################################################################

!THIS MODULE REQUIRES THE LIBRARY MODULES:
!     CONSTANTS_0,  FILE CONSTANTS_0.F90
!     MATHS_0,      FILE MATHS_0.F90
!     FLU_1,        FILE FLU_1.F90
!     FLU_2,        FILE FLU_2.F90
!     FLU_3A,       FILE FLU_3A.F90

!NESTED USE ASSOCIATIONS
!     CONVERT_0,    FILE CONVERT_0.F90

!#########################################################################

use constants_0
use maths_0
use flu_1
use flu_2
use flu_3a

implicit none
private

character*16, private :: version = '8 Jun 2010'

public :: chk_iapws95_table8, &
          liq_vap_boilingtemperature_si, liq_vap_chempot_si, &
          liq_vap_density_liq_si, liq_vap_density_vap_si, &
          liq_vap_enthalpy_evap_si, liq_vap_enthalpy_liq_si, &
          liq_vap_enthalpy_vap_si, liq_vap_entropy_evap_si, &
          liq_vap_entropy_liq_si, liq_vap_entropy_vap_si, &
          liq_vap_pressure_liq_si, liq_vap_pressure_vap_si, &
          liq_vap_temperature_si, liq_vap_vapourpressure_si, &
          liq_vap_volume_evap_si, set_liq_vap_eq_at_p, &
          set_liq_vap_eq_at_t, set_it_ctrl_liq_vap 

integer, private :: equi_liq_vap_done
integer, private :: ctrl_mode_liquid, ctrl_mode_vapour, &
        ctrl_loop_maximum, ctrl_initialized, ctrl_mode_temperature
real*8, private :: ctrl_init_d_liq, ctrl_init_d_vap, ctrl_init_t, ctrl_eps_exit_p_vap
real*8, private :: equi_liq_vap_t, equi_liq_vap_p_liq, &
        equi_liq_vap_p_vap, equi_liq_vap_g_liq, equi_liq_vap_g_vap, &
        equi_liq_vap_d_liq, equi_liq_vap_d_vap
real*8, private :: d_liq_si, d_vap_si, g_liq_si, g_vap_si, p_liq_si, p_vap_si
real*8, private :: t_si

contains

!==========================================================================
function liq_vap_vapourpressure_si(t_si)
!==========================================================================

!RETURNS THE ABSOLUTE PRESSURE OF WATER VAPOUR IN PA AT THE  VAPOUR-LIQUID EQUILIBRIUM
!AS A FUNCTION OF ABSOLUTE TEMPERATURE T_SI IN K

!CHECK VALUE WITH DEFAULT SETTINGS: liq_vap_vapourpressure_si(300) = 3536.80675227

!NOTE: THE ACCURACY OF THIS FUNCTION DEPENDS ON THE ITERATION SETTINGS IN THIS MODULE

implicit none

real*8 liq_vap_vapourpressure_si
real*8 t_si

liq_vap_vapourpressure_si = errorreturn

if(set_liq_vap_eq_at_t(t_si) == errorreturn) then
  return
endif

liq_vap_vapourpressure_si = equi_liq_vap_p_vap

end function

!==========================================================================
function liq_vap_boilingtemperature_si(p_si)
!==========================================================================

!RETURNS THE ABSOLUTE TEMPERATURE IN K AT THE VAPOUR-LIQUID EQUILIBRIUM
!AS A FUNCTION OF ABSOLUTE PRESSURE P_SI IN PA

!CHECK VALUE WITH DEFAULT SETTINGS: liq_vap_boilingtemperature_si(1E4) = 318.956328924

implicit none

real*8 liq_vap_boilingtemperature_si
real*8 p_si

liq_vap_boilingtemperature_si = errorreturn

if(set_liq_vap_eq_at_p(p_si) == errorreturn) return

liq_vap_boilingtemperature_si = equi_liq_vap_t

end function

!==========================================================================
function liq_vap_pressure_vap_si()
!==========================================================================

!RETURNS THE ABSOLUTE PRESSURE OF WATER VAPOUR IN PA AT THE VAPOUR-LIQUID EQUILIBRIUM
!AFTER EXECUTION OF SET_LIQ_VAP_EQUILIBRIUM_TO_T .OR. SET_LIQ_VAP_EQUILIBRIUM_TO_P

!CHECK VALUES WITH DEFAULT SETTINGS:
!set_liq_vap_eq_at_t 300
!liq_vap_pressure_vap_si = 3536.80675227

!set_liq_vap_eq_at_p 1e4
!liq_vap_pressure_vap_si = 10000

!NOTE: THE ACCURACY OF THIS FUNCTION DEPENDS ON THE ITERATION SETTINGS IN THIS MODULE

implicit none

real*8 liq_vap_pressure_vap_si

liq_vap_pressure_vap_si = errorreturn

if(equi_liq_vap_done /= isok) return

liq_vap_pressure_vap_si = equi_liq_vap_p_vap

end function

!==========================================================================
function liq_vap_pressure_liq_si()
!==========================================================================

!RETURNS THE ABSOLUTE PRESSURE OF WATER VAPOUR IN PA AT THE VAPOUR-LIQUID EQUILIBRIUM
!AFTER EXECUTION OF SET_LIQ_VAP_EQUILIBRIUM_TO_T .OR. SET_LIQ_VAP_EQUILIBRIUM_TO_P

!CHECK VALUES WITH DEFAULT SETTINGS:
!set_liq_vap_eq_at_t 300
!liq_vap_pressure_liq_si = 3536.80675|227

!set_liq_vap_eq_at_p 1e4
!liq_vap_pressure_liq_si = 10000.00000|00

!NOTE: THE ACCURACY OF THIS FUNCTION DEPENDS ON THE ITERATION SETTINGS IN THIS MODULE

implicit none

real*8 liq_vap_pressure_liq_si

liq_vap_pressure_liq_si = errorreturn

if(equi_liq_vap_done /= isok) return

liq_vap_pressure_liq_si = equi_liq_vap_p_liq

end function

!==========================================================================
function liq_vap_temperature_si()
!==========================================================================

!RETURNS THE ABSOLUTE TEMPERATUE IN K AT THE VAPOUR-LIQUID EQUILIBRIUM
!AFTER EXECUTION OF SET_LIQ_VAP_EQUILIBRIUM_TO_T .OR. SET_LIQ_VAP_EQUILIBRIUM_TO_P

!CHECK VALUES WITH DEFAULT SETTINGS:
!SET_LIQ_VAP_EQ_AT_T 300
!LIQ_VAP_TEMPERATURE_SI = 300

!SET_LIQ_VAP_EQ_AT_P 1E4
!LIQ_VAP_TEMPERATURE_SI = 318.956328924

!NOTE: THE ACCURACY OF THIS FUNCTION DEPENDS ON THE ITERATION SETTINGS IN THIS MODULE

implicit none

real*8 liq_vap_temperature_si

liq_vap_temperature_si = errorreturn

if(equi_liq_vap_done /= isok) return

liq_vap_temperature_si = equi_liq_vap_t

end function

!==========================================================================
function liq_vap_chempot_si()
!==========================================================================

!RETURNS THE CHEMICAL POTENTIAL OF WATER VAPOUR IN J/KG AT THE VAPOUR-LIQUID EQUILIBRIUM
!AFTER EXECUTION OF SET_LIQ_VAP_EQUILIBRIUM_TO_T .OR. SET_LIQ_VAP_EQUILIBRIUM_TO_P

!CHECK VALUES WITH DEFAULT SETTINGS:
!SET_LIQ_VAP_EQ_AT_T 300
!LIQ_VAP_CHEMPOT_SI = -5361.84908682

!SET_LIQ_VAP_EQ_AT_P 1E4
!LIQ_VAP_CHEMPOT_SI = -15259.1024273

!NOTE: THE ACCURACY OF THIS FUNCTION DEPENDS ON THE ITERATION SETTINGS IN THIS MODULE

implicit none

real*8 liq_vap_chempot_si

liq_vap_chempot_si = errorreturn

if(equi_liq_vap_done /= isok) return

liq_vap_chempot_si = equi_liq_vap_g_vap

end function

!==========================================================================
function liq_vap_density_liq_si()
!==========================================================================

!RETURNS THE DENSITY OF LIQUID WATER IN KG/M3 AT THE VAPOUR-LIQUID EQUILIBRIUM
!AFTER EXECUTION OF SET_LIQ_VAP_EQUILIBRIUM_TO_T .OR. SET_LIQ_VAP_EQUILIBRIUM_TO_P

!CHECK VALUES WITH DEFAULT SETTINGS:
!SET_LIQ_VAP_EQ_AT_T 300
!LIQ_VAP_DENSITY_LIQ_SI = 996.513027468

!SET_LIQ_VAP_EQ_AT_P 1E4
!LIQ_VAP_DENSITY_LIQ_SI = 989.833275365

!NOTE: THE ACCURACY OF THIS FUNCTION DEPENDS ON THE ITERATION SETTINGS IN THIS MODULE

implicit none

real*8 liq_vap_density_liq_si

liq_vap_density_liq_si = errorreturn

if(equi_liq_vap_done /= isok) return

liq_vap_density_liq_si = equi_liq_vap_d_liq

end function

!==========================================================================
function liq_vap_density_vap_si()
!==========================================================================

!RETURNS THE DENSITY OF WATER VAPOUR IN KG/M3 AT THE VAPOUR-LIQUID EQUILIBRIUM
!AFTER EXECUTION OF SET_LIQ_VAP_EQUILIBRIUM_TO_T .OR. SET_LIQ_VAP_EQUILIBRIUM_TO_P

!CHECK VALUES WITH DEFAULT SETTINGS:
!SET_LIQ_VAP_EQ_AT_T 300
!LIQ_VAP_DENSITY_VAP_SI = 2.55896736829e-02

!SET_LIQ_VAP_EQ_AT_P 1E4
!LIQ_VAP_DENSITY_VAP_SI = 6.81657223094e-02

!NOTE: THE ACCURACY OF THIS FUNCTION DEPENDS ON THE ITERATION SETTINGS IN THIS MODULE

implicit none

real*8 liq_vap_density_vap_si

liq_vap_density_vap_si = errorreturn

if(equi_liq_vap_done /= isok) return

liq_vap_density_vap_si = equi_liq_vap_d_vap

end function

!==========================================================================
function liq_vap_entropy_liq_si()
!==========================================================================

!RETURNS THE SPECIFIC ENTROPY OF LIQUID WATER IN J/(KG K) AT THE  VAPOUR-LIQUID EQUILIBRIUM
!AFTER EXECUTION OF SET_LIQ_VAP_EQUILIBRIUM_TO_T .OR. SET_LIQ_VAP_EQUILIBRIUM_TO_P

!CHECK VALUES WITH DEFAULT SETTINGS:
!SET_LIQ_VAP_EQ_AT_T 300
!LIQ_VAP_ENTROPY_LIQ_SI = 393.089029801

!set_liq_vap_eq_at_p 1e4
!liq_vap_entropy_liq_si = 649.195605196

!NOTE: THE ACCURACY OF THIS FUNCTION DEPENDS ON THE ITERATION SETTINGS IN THIS MODULE

implicit none

real*8 liq_vap_entropy_liq_si

liq_vap_entropy_liq_si = errorreturn

if(equi_liq_vap_done /= isok) return

liq_vap_entropy_liq_si = flu_entropy_si(equi_liq_vap_t, equi_liq_vap_d_liq)

end function

!==========================================================================
function liq_vap_entropy_vap_si()
!==========================================================================

!RETURNS THE SPECIFIC ENTROPY OF WATER VAPOUR IN J/(KG K) AT THE VAPOUR-LIQUID EQUILIBRIUM
!AFTER EXECUTION OF SET_LIQ_VAP_EQUILIBRIUM_TO_T .OR. SET_LIQ_VAP_EQUILIBRIUM_TO_P

!CHECK VALUES WITH DEFAULT SETTINGS:
!SET_LIQ_VAP_EQ_AT_T 300
!LIQ_VAP_ENTROPY_VAP_SI = 8517.38650061

!SET_LIQ_VAP_EQ_AT_P 1E4
!LIQ_VAP_ENTROPY_VAP_SI = 8148.82019425

!NOTE: THE ACCURACY OF THIS FUNCTION DEPENDS ON THE ITERATION SETTINGS IN THIS MODULE

implicit none

real*8 liq_vap_entropy_vap_si

liq_vap_entropy_vap_si = errorreturn

if(equi_liq_vap_done /= isok) return

liq_vap_entropy_vap_si = flu_entropy_si(equi_liq_vap_t, equi_liq_vap_d_vap)

end function

!==========================================================================
function liq_vap_enthalpy_liq_si()
!==========================================================================

!RETURNS THE SPECIFIC ENTHALPY OF LIQUID WATER IN J/KG AT THE VAPOUR-LIQUID EQUILIBRIUM
!AFTER EXECUTION OF SET_LIQ_VAP_EQUILIBRIUM_TO_T .OR. SET_LIQ_VAP_EQUILIBRIUM_TO_P

!CHECK VALUES WITH DEFAULT SETTINGS:
!SET_LIQ_VAP_EQ_AT_T 300
!LIQ_VAP_ENTHALPY_LIQ_SI = 112564.859854

!SET_LIQ_VAP_EQ_AT_P 1E4
!LIQ_VAP_ENTHALPY_LIQ_SI = 191805.944559

!NOTE: THE ACCURACY OF THIS FUNCTION DEPENDS ON THE ITERATION SETTINGS IN THIS MODULE

implicit none

real*8 liq_vap_enthalpy_liq_si

liq_vap_enthalpy_liq_si = errorreturn

if(equi_liq_vap_done /= isok) return

liq_vap_enthalpy_liq_si = flu_enthalpy_si(equi_liq_vap_t, equi_liq_vap_d_liq)

end function

!==========================================================================
function liq_vap_enthalpy_vap_si()
!==========================================================================

!RETURNS THE SPECIFIC ENTHALPY OF WATER VAPOUR IN J/KG AT THE VAPOUR-LIQUID EQUILIBRIUM
!AFTER EXECUTION OF SET_LIQ_VAP_EQUILIBRIUM_TO_T .OR. SET_LIQ_VAP_EQUILIBRIUM_TO_P

!CHECK VALUES WITH DEFAULT SETTINGS:
!SET_LIQ_VAP_EQ_AT_T 300
!LIQ_VAP_ENTHALPY_VAP_SI = 2549854.10109

!SET_LIQ_VAP_EQ_AT_P 1E4
!LIQ_VAP_ENTHALPY_VAP_SI = 2583858.67179

!NOTE: THE ACCURACY OF THIS FUNCTION DEPENDS ON THE ITERATION SETTINGS IN THIS MODULE

implicit none

real*8 liq_vap_enthalpy_vap_si

liq_vap_enthalpy_vap_si = errorreturn

if(equi_liq_vap_done /= isok) return

liq_vap_enthalpy_vap_si = flu_enthalpy_si(equi_liq_vap_t, equi_liq_vap_d_vap)

end function

!==========================================================================
function liq_vap_volume_evap_si()
!==========================================================================

!RETURNS THE SPECIFIC EVAPORATION VOLUME IN M3/KG AT THE VAPOUR-LIQUID EQUILIBRIUM
!AFTER EXECUTION OF SET_LIQ_VAP_EQUILIBRIUM_TO_T .OR. SET_LIQ_VAP_EQUILIBRIUM_TO_P

!CHECK VALUES WITH DEFAULT SETTINGS:
!SET_LIQ_VAP_EQ_AT_T 300
!LIQ_VAP_VOLUME_EVAP_SI = 39.0772595686

!SET_LIQ_VAP_EQ_AT_P 1E4
!LIQ_VAP_VOLUME_EVAP_SI = 14.6691196141

!NOTE: THE ACCURACY OF THIS FUNCTION DEPENDS ON THE ITERATION SETTINGS IN THIS MODULE

implicit none

real*8 liq_vap_volume_evap_si

liq_vap_volume_evap_si = errorreturn

if(equi_liq_vap_done /= isok) return

if(equi_liq_vap_d_liq <= 0) return
if(equi_liq_vap_d_vap <= 0) return

liq_vap_volume_evap_si = 1d0 / equi_liq_vap_d_vap - 1d0 / equi_liq_vap_d_liq

end function

!==========================================================================
function liq_vap_entropy_evap_si()
!==========================================================================

!RETURNS THE SPECIFIC EVAPORATION ENTROPY IN J/(KG K) OF WATER
!AFTER EXECUTION OF SET_LIQ_VAP_EQUILIBRIUM_TO_T .OR. SET_LIQ_VAP_EQUILIBRIUM_TO_P

!CHECK VALUES WITH DEFAULT SETTINGS:
!SET_LIQ_VAP_EQ_AT_T 300
!LIQ_VAP_ENTROPY_EVAP_SI = 8124.29747080

!SET_LIQ_VAP_EQ_AT_P 1E4
!LIQ_VAP_ENTROPY_EVAP_SI = 7499.62458905

!NOTE: THE ACCURACY OF THIS FUNCTION DEPENDS ON THE ITERATION SETTINGS IN THIS MODULE

implicit none

real*8 liq_vap_entropy_evap_si
real*8 sl, sv

liq_vap_entropy_evap_si = errorreturn

if(equi_liq_vap_done /= isok) return

sl = flu_entropy_si(equi_liq_vap_t, equi_liq_vap_d_liq)
if(sl == errorreturn) return
sv = flu_entropy_si(equi_liq_vap_t, equi_liq_vap_d_vap)
if(sv == errorreturn) return

liq_vap_entropy_evap_si = sv - sl

end function

!==========================================================================
function liq_vap_enthalpy_evap_si()
!==========================================================================

!RETURNS THE SPECIFIC EVAPORATION ENTHALPY IN J/KG OF WATER
!AFTER EXECUTION OF SET_LIQ_VAP_EQUILIBRIUM_TO_T .OR. SET_LIQ_VAP_EQUILIBRIUM_TO_P

!CHECK VALUES WITH DEFAULT SETTINGS:
!SET_LIQ_VAP_EQ_AT_T 300
!LIQ_VAP_ENTHALPY_EVAP_SI = 2437289.24124

!SET_LIQ_VAP_EQ_AT_P 1E4
!LIQ_VAP_ENTHALPY_EVAP_SI = 2392052.72723

!NOTE: THE ACCURACY OF THIS FUNCTION DEPENDS ON THE ITERATION SETTINGS IN THIS MODULE

implicit none

real*8 liq_vap_enthalpy_evap_si
real*8 hl, hv

liq_vap_enthalpy_evap_si = errorreturn

if(equi_liq_vap_done /= isok) return

hl = flu_enthalpy_si(equi_liq_vap_t, equi_liq_vap_d_liq)
if(hl == errorreturn) return
hv = flu_enthalpy_si(equi_liq_vap_t, equi_liq_vap_d_vap)
if(hv == errorreturn) return

liq_vap_enthalpy_evap_si = hv - hl

end function

!==========================================================================
function set_liq_vap_eq_at_p(p_si)
!==========================================================================

!THIS FUNCTION COMPUTES THE LIQUID-VAPOUR EQUILIBRIUM AT GIVEN PRESSURE IN PA
!BY 3-DIMENSIONAL NEWTON ITERATION

implicit none

integer maxit
real*8 set_liq_vap_eq_at_p
real*8 t_si, p_si
real*8 pl, pv
real*8 gl, gv
real*8 dl, dv
real*8 eps
real*8 dc, pc, tc, gc, dl_triple, dv_triple, t_triple

!CRITICAL POINT
dc = cp_density_si
pc = cp_pressure_si
tc = cp_temperature_si
gc = cp_chempot_si

!TRIPLE POINT
dl_triple = tp_density_liq_iapws95_si
dv_triple = tp_density_vap_iapws95_si
t_triple = tp_temperature_si

if(equi_liq_vap_done == isok .and. &
  p_si == equi_liq_vap_p_vap) then
  !the requested state has already been computed earlier
  set_liq_vap_eq_at_p = isok
  return
end if

call clear_liq_vap_state !waste any previous state

set_liq_vap_eq_at_p = errorreturn

if(p_si <= 0d0) return
if(p_si > pc) return

if(p_si == pc) then
  call set_liq_vap_state(tc, pc, pc, gc, gc, dc, dc)
  set_liq_vap_eq_at_p = isok
  return
end if

call init_it_ctrl_liq_vap

!SET INITIAL TEMPERATURE GUESS
select case (ctrl_mode_temperature)
  case (0); t_si = aux_boil_temperature(p_si)
  case (-1); t_si = t_triple
  case (1); t_si = ctrl_init_t
  case default; return
end select

!SET INITIAL LIQUID DENSITY GUESS
select case (ctrl_mode_liquid)
  case (0); !default liquid density:
    if(t_si < 350d0) then
      dl = aux_liq_density_triplepoint(t_si)
    else
      dl = aux_liq_density_critical(t_si)
    end if
  case (-1); dl = dl_triple
  case (1); dl = ctrl_init_d_liq
  case default; return
end select

!SET INITIAL VAPOUR DENSITY GUESS
select case (ctrl_mode_vapour)
  case (0)
    if(t_si < 550d0) then
      dv = aux_vap_density_triplepoint(t_si)
    else
      dv = aux_vap_density_critical(t_si)
    end if
  case (-1); dv = dv_triple
  case (1);  dv = ctrl_init_d_vap
  case default; return
end select

!SET MAX. ITERATION NUMBER
if(ctrl_loop_maximum == 0)then
  maxit = 100
elseif(ctrl_loop_maximum == (-1))then
  set_liq_vap_eq_at_p = isok
  pl = flu_pressure_si(t_si, dl)
  pv = flu_pressure_si(t_si, dv)
  gl = flu_gibbs_energy_si(t_si, dl)
  gv = flu_gibbs_energy_si(t_si, dv)
  call set_liq_vap_state(t_si, pl, pv, gl, gv, dl, dv)
  return
elseif(ctrl_loop_maximum > 0)then
  maxit = ctrl_loop_maximum
else 
  return
endif

!SET ITERATION ACCURACY LIMIT
eps = ctrl_eps_exit_p_vap
if(eps == 0) return

!RUN ITERATION LOOP
if(liq_vap_iteration_at_p(p_si, maxit, eps, t_si, dl, dv, gl, gv, pl, pv) == errorreturn) then
  return
end if

call set_liq_vap_state(t_si, pl, pv, gl, gv, dl, dv)

set_liq_vap_eq_at_p = isok

end function

!==========================================================================
function set_liq_vap_eq_at_t(t_si)
!==========================================================================

!THIS FUNCTION COMPUTES THE LIQUID-VAPOUR EQUILIBRIUM AT GIVEN TEMPERATURE IN K
!BY 2-DIMENSIONAL NEWTON ITERATION

implicit none

integer maxit
real*8 set_liq_vap_eq_at_t
real*8 t_si
real*8 pl, pv
real*8 gl, gv
real*8 dl, dv
real*8 eps
real*8 dc, pc, tc, gc, dl_triple, dv_triple

!CRITICAL POINT
dc = cp_density_si
pc = cp_pressure_si
tc = cp_temperature_si
gc = cp_chempot_si

!TRIPLE POINT
dl_triple = tp_density_liq_iapws95_si
dv_triple = tp_density_vap_iapws95_si

if(equi_liq_vap_done == isok .and.  &
   t_si == equi_liq_vap_t) then
  !the requested state has already been computed earlier
  set_liq_vap_eq_at_t = isok
  return
end if

call clear_liq_vap_state !waste any previous state

set_liq_vap_eq_at_t = errorreturn

if(t_si <= 0) return
if(t_si > tc) return

if(t_si == tc) then
  call set_liq_vap_state(t_si, pc, pc, gc, gc, dc, dc)
  set_liq_vap_eq_at_t = isok
  return
end if

call init_it_ctrl_liq_vap

!SET INITIAL LIQUID DENSITY GUESS
select case (ctrl_mode_liquid)
  case (0);  !default liquid density:
    if(t_si < 350d0) then
      dl = aux_liq_density_triplepoint(t_si)
    else
      dl = aux_liq_density_critical(t_si)
    end if
  case (-1); dl = dl_triple
  case (1);  dl = ctrl_init_d_liq
  case default; return
end select

!SET INITIAL VAPOUR DENSITY GUESS
select case (ctrl_mode_vapour)
  case (0)
    if(t_si < 550d0) then
      dv = aux_vap_density_triplepoint(t_si)
    else
      dv = aux_vap_density_critical(t_si)
    end if
  case (-1); dv = dv_triple
  case (1);  dv = ctrl_init_d_vap
  case default; return
end select

!SET MAX. ITERATION NUMBER
if(ctrl_loop_maximum == 0)then
  maxit = 100
elseif(ctrl_loop_maximum == (-1))then
  set_liq_vap_eq_at_t = isok
  pl = flu_pressure_si(t_si, dl)
  pv = flu_pressure_si(t_si, dv)
  gl = flu_gibbs_energy_si(t_si, dl)
  gv = flu_gibbs_energy_si(t_si, dv)
  call set_liq_vap_state(t_si, pl, pv, gl, gv, dl, dv)
  return
elseif(ctrl_loop_maximum > 0)then
  maxit = ctrl_loop_maximum
else 
  return
endif

!SET ITERATION ACCURACY LIMIT
eps = ctrl_eps_exit_p_vap
if(eps == 0d0) return

!RUN ITERATION LOOP
if(liq_vap_iteration_at_t(t_si, maxit, eps, dl, dv, gl, gv, pl, pv) == errorreturn) &
  return

call set_liq_vap_state(t_si, pl, pv, gl, gv, dl, dv)

set_liq_vap_eq_at_t = isok

end function

!==========================================================================
function liq_vap_iteration_at_p(p_si, maxit, eps, t_si, d_liq_si, &
         d_vap_si, g_liq_si, g_vap_si, p_liq_si, p_vap_si)
!==========================================================================

!THIS FUNCTION RETURNS THE LIQUID-VAPOUR PHASE EQUILIBRIUM FROM EQUAL PRESSURES,
!TEMPERATURES .AND. CHEMICAL POTENTIALS OF THE TWO PHASES AT GIVEN PRESSURE, P_SI,
!FROM INITIAL GUESSES FOR THE LIQUID DENSITY, D_LIQ_SI, THE VAPOUR DENSITY, D_VAP_SI,
!AND THE TEMPERATURE, T_SI
!THE ITERATION LIMIT EPS REFERS TO THE ERROR IN VAPOUR PRESSURE

!OUTPUT: 
!        LIQ_VAP_ITERATION_AT_T = ISOK IF SUCCESSFUL
!        LIQ_VAP_ITERATION_AT_T = ERRORRETURN IS RETURNED IF
!        - THE MAXIMUM NUMBER OF ITERATIONS IS EXCEEDED WITHOUT MEETING THE EXIT CRITERION
!        - THE FUNCTION CALL TO FLU_F_SI HAS RETURNED AN ERROR
!        - DENSITIES .OR. TEMPERATURE HAVE TAKEN A ZERO .OR. NEGATIVE VALUE DURING THE ITERATION
!     T_SI: ABSOLUTE TEMPERATURE IN K
! D_LIQ_SI: LIQUID DENSITY IN KG/M3 AT THE LIQUID-VAPOUR EQUILIBRIUM
! D_VAP_SI: VAPOUR DENSITY IN KG/M3 AT THE LIQUID-VAPOUR EQUILIBRIUM
! G_LIQ_SI: LIQUID CHEMICAL POTENTIAL IN J/KG AT THE LIQUID-VAPOUR EQUILIBRIUM
! G_VAP_SI: VAPOUR CHEMICAL POTENTIAL IN J/KG AT THE LIQUID-VAPOUR EQUILIBRIUM
! P_LIQ_SI: LIQUID PRESSURE IN PA AT THE LIQUID-VAPOUR EQUILIBRIUM
! P_VAP_SI: VAPOUR PRESSURE IN PA AT THE LIQUID-VAPOUR EQUILIBRIUM

!INPUT: 
!       P_SI: ABSOLUTE PRESSURE IN PA
!      MAXIT: MAXIMUM NUMBER OF ITERATION STEPS TO BE DONE
!        EPS: REQUIRED ACCURACY OF VAPOUR PRESSURE
!             EPS > 0: ABSOLUTE VAPOUR PRESSURE TOLERANCE IN PA
!             EPS < 0: RELATIVE VAPOUR PRESSURE TOLERANCE
!       T_SI: INITIAL GUESS OF ABSOLUTE TEMPERATURE IN K
!   D_LIQ_SI: INITIAL GUESS OF LIQUID DENSITY IN KG/M3
!   D_VAP_SI: INITIAL GUESS OF VAPOUR DENSITY IN KG/M3

implicit none
real*8 liq_vap_iteration_at_p

integer it, maxit
real*8 eps, t_si, d_liq_si, d_vap_si,  &
       g_liq_si, g_vap_si, p_liq_si, p_vap_si
real*8 p_si
real*8 dl, dv
real*8 pl, pv
real*8 gl, gv
real*8 t
real*8 fl, fl_d, fl_dd
real*8 fv, fv_d, fv_dd
real*8 fl_t, fl_td
real*8 fv_t, fv_td
real*8 a(3, 3), b(3), x(3)
real*8 ddl, ddv, dt, pv_old
real*8 dc, pc, tc, gc

!THE CRITICAL PROPERTIES OF IAPWS-95
dc = cp_density_si
pc = cp_pressure_si
tc = cp_temperature_si
gc = cp_chempot_si

liq_vap_iteration_at_p = errorreturn

pv = errorreturn

if(p_si == pc) then !equlibrium = critical point
  t_si = tc
  d_liq_si = dc
  d_vap_si = dc
  g_liq_si = gc
  g_vap_si = gc
  p_liq_si = pc
  p_vap_si = pc
  liq_vap_iteration_at_p = isok
  return
end if

if((d_liq_si < dc) .or. &
  (d_vap_si <= 0) .or. (d_vap_si > dc) .or. &
  (p_si <=  0d0 .or. p_si > pc)) then
  t_si = errorreturn
  d_liq_si = errorreturn
  d_vap_si = errorreturn
  g_liq_si = errorreturn
  g_vap_si = errorreturn
  p_liq_si = errorreturn
  p_vap_si = errorreturn
  return
endif

check_limits = check_limits - 1

dl = d_liq_si
dv = d_vap_si
t = t_si

do it = 0, maxit

  !DERIVATIVES OF THE HELMHOLTZ FUNCTION FOR 3D-NEWTON ITERATION
  fl = flu_f_si(0, 0, t, dl)
  if(fl == errorreturn) go to 999
  fv = flu_f_si(0, 0, t, dv)
  if(fv == errorreturn) go to 999

  fl_d = flu_f_si(0, 1, t, dl)
  if(fl_d == errorreturn) go to 999
  fv_d = flu_f_si(0, 1, t, dv)
  if(fv_d == errorreturn) go to 999
  fl_dd = flu_f_si(0, 2, t, dl)
  if(fl_dd == errorreturn) go to 999
  fv_dd = flu_f_si(0, 2, t, dv)
  if(fv_dd == errorreturn) go to 999
  
  fl_t = flu_f_si(1, 0, t, dl)
  if(fl_t == errorreturn) go to 999
  fv_t = flu_f_si(1, 0, t, dv)
  if(fv_t == errorreturn) go to 999
  fl_td = flu_f_si(1, 1, t, dl)
  if(fl_td == errorreturn) go to 999
  fv_td = flu_f_si(1, 1, t, dv)
  if(fv_td == errorreturn) go to 999

  pv_old = pv  !KEEP PREVIOUS PV TO CHECK ACCURACY
  !LIQUID AND VAPOUR PRESSURES AND CHEMICAL POTENTIALS
  pl = dl ** 2 * fl_d    !PRESSURE OF LIQUID  !THIS OFTEN TAKES NEGATIVE VALUES, TEMPORARILY
  pv = dv ** 2 * fv_d    !PRESSURE OF VAPOUR
  gl = fl + dl * fl_d    !CHEM. POT. OF LIQUID
  gv = fv + dv * fv_d    !CHEM. POT. OF VAPOUR

  if(it > 0) then
    !CHECK ABSOLUTE .OR. RELATIVE ERROR LIMIT
    if((eps > 0d0 .and. abs(pv - pv_old) < eps) .or. &
       (eps < 0d0 .and. abs(pv - pv_old) < -eps * pv)) then
      liq_vap_iteration_at_p = isok
      p_liq_si = pl
      p_vap_si = pv
      g_liq_si = gl
      g_vap_si = gv
      d_liq_si = dl
      d_vap_si = dv
      t_si = t
      go to 999
    end if
  end if
  
  if(it == maxit) go to 999
  
  !COEFFICIENT MATRIX
  a(1, 1) = dl * (2d0 * fl_d + dl * fl_dd)
  a(1, 2) = 0d0
  a(1, 3) = dl ** 2 * fl_td
  a(2, 1) = 0d0
  a(2, 2) = dv * (2d0 * fv_d + dv * fv_dd)
  a(2, 3) = dv ** 2 * fv_td
  a(3, 1) = (2d0 * fl_d + dl * fl_dd)
  a(3, 2) = -(2d0 * fv_d + dv * fv_dd)
  a(3, 3) = fl_t + dl * fl_td - fv_t - dv * fv_td

  !RIGHT-HAND SIDES, MUST VANISH IN EQUILIBRIUM
  b(1) = p_si - pl
  b(2) = p_si - pv
  b(3) = gv - gl

  !SOLVE EQUATIONS
  if(matrix_solve(a, b, x, 3) /= 0) go to 999 !MATRIX SINGULAR
  ddl = x(1)
  ddv = x(2)
  dt = x(3)
  
  !UPDATE DENSITIES & TEMPERATURE
  dl = dl + ddl
  if(dl <= 0d0) go to 999
  dv = dv + ddv
  if(dv <= 0d0) go to 999
  t = t + dt
  if(t <= 0d0) go to 999
  
enddo

999 continue

check_limits = check_limits + 1

if(check_limits == 1) then
  !FLU_LIMITS
  if(t_si < flu_tmin .or. t_si > flu_tmax .or. &
    d_liq_si <= flu_dmin .or. d_liq_si > flu_dmax) then
    t_si = errorreturn
    d_liq_si = errorreturn
    d_vap_si = errorreturn
    g_liq_si = errorreturn
    g_vap_si = errorreturn
    p_liq_si = errorreturn
    p_vap_si = errorreturn
    liq_vap_iteration_at_p = errorreturn
    return
  endif
!dbg  !AIR_LIMITS
!dbg  if(t_si < dry_air_tmin .or. t_si > dry_air_tmax) then
!dbg    t_si = errorreturn
!dbg    d_liq_si = errorreturn
!dbg    d_vap_si = errorreturn
!dbg    g_liq_si = errorreturn
!dbg    g_vap_si = errorreturn
!dbg    p_liq_si = errorreturn
!dbg    p_vap_si = errorreturn
!dbg    liq_vap_iteration_at_p = errorreturn
!dbg    return
!dbg  endif
endif

end function

!==========================================================================
function liq_vap_iteration_at_t(t_si, maxit, eps, d_liq_si, &
                 d_vap_si, g_liq_si, g_vap_si, p_liq_si, p_vap_si)
!==========================================================================

!THIS FUNCTION RETURNS THE LIQUID-VAPOUR PHASE EQUILIBRIUM FROM EQUAL PRESSURES
!AND CHEMICAL POTENTIALS OF THE TWO PHASES AT GIVEN TEMPERATURE, T_SI,
!FROM INITIAL GUESSES FOR THE LIQUID DENSITY, D_LIQ_SI, .AND. THE VAPOUR DENSITY, D_VAP_SI.
!THE ITERATION LIMIT EPS REFERS TO THE ERROR IN VAPOUR PRESSURE

!OUTPUT: 
!        LIQ_VAP_ITERATION_AT_T = ISOK IF SUCCESSFUL
!        LIQ_VAP_ITERATION_AT_T = ERRORRETURN IS RETURNED IF
!        - THE MAXIMUM NUMBER OF ITERATIONS IS EXCEEDED WITHOUT MEETING THE EXIT CRITERION
!        - THE FUNCTION CALL TO FLU_F_SI HAS RETURNED AN ERROR
!        - DENSITIES HAVE TAKEN A ZERO .OR. NEGATIVE VALUE DURING THE ITERATION
! D_LIQ_SI: LIQUID DENSITY IN KG/M3 AT THE LIQUID-VAPOUR EQUILIBRIUM
! D_VAP_SI: VAPOUR DENSITY IN KG/M3 AT THE LIQUID-VAPOUR EQUILIBRIUM
! G_LIQ_SI: LIQUID CHEMICAL POTENTIAL IN J/KG AT THE LIQUID-VAPOUR EQUILIBRIUM
! G_VAP_SI: VAPOUR CHEMICAL POTENTIAL IN J/KG AT THE LIQUID-VAPOUR EQUILIBRIUM
! P_LIQ_SI: LIQUID PRESSURE IN PA AT THE LIQUID-VAPOUR EQUILIBRIUM
! P_VAP_SI: VAPOUR PRESSURE IN PA AT THE LIQUID-VAPOUR EQUILIBRIUM

!INPUT: 
!       T_SI: ABSOLUTE TEMPERATURE IN K
!      MAXIT: MAXIMUM NUMBER OF ITERATION STEPS TO BE DONE
!        EPS: REQUIRED ACCURACY OF VAPOUR PRESSURE
!             EPS > 0: ABSOLUTE VAPOUR PRESSURE TOLERANCE IN PA
!             EPS < 0: RELATIVE VAPOUR PRESSURE TOLERANCE
!   D_LIQ_SI: INITIAL GUESS OF LIQUID DENSITY IN KG/M3
!   D_VAP_SI: INITIAL GUESS OF VAPOUR DENSITY IN KG/M3

implicit none
real*8 liq_vap_iteration_at_t

integer it, maxit
real*8 t_si, eps, d_liq_si, d_vap_si, g_vap_si, g_liq_si, &
       p_liq_si, p_vap_si
real*8 dl, dv
real*8 pl, pv
real*8 gl, gv
real*8 fv, fv_d, fv_dd
real*8 fl, fl_d, fl_dd
real*8 a(2, 2), b(2), x(2)
real*8 ddl, ddv, pv_old
real*8 dc, pc, tc, gc

!THE CRITICAL PROPERTIES OF IAPWS-95
dc = cp_density_si
pc = cp_pressure_si
tc = cp_temperature_si
gc = cp_chempot_si

liq_vap_iteration_at_t = errorreturn

pv = errorreturn

if(t_si == tc) then    !EQULIBRIUM = CRITICAL POINT
  d_liq_si = dc
  d_vap_si = dc
  g_liq_si = gc
  g_vap_si = gc
  p_liq_si = pc
  p_vap_si = pc
  liq_vap_iteration_at_t = isok
  return
end if

if(t_si > tc .or. &
  d_liq_si < dc .or. &
  d_vap_si <= 0d0 .or. d_vap_si > dc) then  !no equilibrium in the supercritical range
  d_liq_si = errorreturn
  d_vap_si = errorreturn
  g_liq_si = errorreturn
  g_vap_si = errorreturn
  p_liq_si = errorreturn
  p_vap_si = errorreturn
  return
endif

if(check_limits == 1) then
  !FLU_LIMITS
  if(t_si < flu_tmin .or. t_si > flu_tmax) then
    d_liq_si = errorreturn
    d_vap_si = errorreturn
    g_liq_si = errorreturn
    g_vap_si = errorreturn
    p_liq_si = errorreturn
    p_vap_si = errorreturn
    return
  endif
else
  if(t_si <= 0d0)then
    d_liq_si = errorreturn
    d_vap_si = errorreturn
    g_liq_si = errorreturn
    g_vap_si = errorreturn
    p_liq_si = errorreturn
    p_vap_si = errorreturn
    return
  endif
endif

If(d_liq_si < dc) return
If(d_vap_si <= 0) return
If(d_vap_si > dc) return

check_limits = check_limits - 1

dl = d_liq_si
dv = d_vap_si

do it = 0, maxit

  !DERIVATIVES OF THE HELMHOLTZ FUNCTION FOR 2D-NEWTON ITERATION
  fl = flu_f_si(0, 0, t_si, dl)
  if(fl == errorreturn) go to 999
  fv = flu_f_si(0, 0, t_si, dv)
  if(fv == errorreturn) go to 999
  fl_d = flu_f_si(0, 1, t_si, dl)
  if(fl_d == errorreturn) go to 999
  fv_d = flu_f_si(0, 1, t_si, dv)
  if(fv_d == errorreturn) go to 999
  fl_dd = flu_f_si(0, 2, t_si, dl)
  if(fl_dd == errorreturn) go to 999
  fv_dd = flu_f_si(0, 2, t_si, dv)
  if(fv_dd == errorreturn) go to 999
  
  pv_old = pv            !KEEP PREVIOUS PV TO CHECK ACCURACY
  !LIQUID AND VAPOUR PRESSURES AND CHEMICAL POTENTIALS
  pl = dl ** 2 * fl_d    !PRESSURE OF LIQUID  !THIS OFTEN TAKES NEGATIVE VALUES TEMPORARILY
  pv = dv ** 2 * fv_d    !PRESSURE OF VAPOUR
  gl = fl + dl * fl_d    !CHEM. POT. OF LIQUID
  gv = fv + dv * fv_d    !CHEM. POT. OF VAPOUR

  if(it > 0) then
    !CHECK ABSOLUTE .OR. RELATIVE ERROR LIMIT
    if((eps > 0d0 .and. abs(pv - pv_old) < eps) .or. &
       (eps < 0d0 .and. abs(pv - pv_old) < -eps * pv)) then
      liq_vap_iteration_at_t = isok
      p_liq_si = pl
      p_vap_si = pv
      g_liq_si = gl
      g_vap_si = gv
      d_liq_si = dl
      d_vap_si = dv
      go to 999
    end if
  end if
  
  if(it == maxit) go to 999
  
  !COEFFICIENT MATRIX
  a(2, 1) = 2d0 * fl_d + dl * fl_dd
  a(1, 1) = dl * a(2, 1)
  a(2, 2) = -2d0 * fv_d - dv * fv_dd
  a(1, 2) = dv * a(2, 2)
  !RIGHT-HAND SIDES, MUST VANISH IN EQUILIBRIUM
  b(1) = pv - pl
  b(2) = gv - gl

  !SOLVE EQUATIONS
  if(matrix_solve(a, b, x, 2) /= 0) go to 999 !MATRIX SINGULAR
  ddl = x(1)
  ddv = x(2)

  !UPDATE DENSITIES
  dl = dl + ddl
  if(dl <= 0d0) go to 999
  dv = dv + ddv
  if(dv <= 0d0) go to 999

enddo

999 continue

check_limits = check_limits + 1

if(check_limits == 1) then
  !FLU_LIMITS
  if(d_liq_si <= flu_dmin .or. d_liq_si > flu_dmax) then
    d_liq_si = errorreturn
    d_vap_si = errorreturn
    g_liq_si = errorreturn
    g_vap_si = errorreturn
    p_liq_si = errorreturn
    p_vap_si = errorreturn
    liq_vap_iteration_at_t = errorreturn
    return
  endif
!dbg  !AIR_LIMITS
!dbg  if(d_vap_si <= dry_air_dmin .or. d_vap_si > dry_air_dmax) then
!dbg    d_liq_si = errorreturn
!dbg    d_vap_si = errorreturn
!dbg    g_liq_si = errorreturn
!dbg    g_vap_si = errorreturn
!dbg    p_liq_si = errorreturn
!dbg    p_vap_si = errorreturn
!dbg    liq_vap_iteration_at_t = errorreturn
!dbg    return
!dbg  endif
endif

end function

!==========================================================================
function aux_liq_density_critical(t_si)
!==========================================================================

!COMPUTES THE LIQUID DENSITY ON THE SATURATION CURVE FROM A CORRELATION POLYNOMIAL
!AS A FIRST GUESS FOR LIQ_VAP_ITERATION_AT_T (300 K < T < TC WITH RMS = 1 K)

! T/TC - 1 = A1 * (D/DC-1)^3 + A2 * (D/DC-1)^6 + A3 * (D/DC-1)^9

implicit none

real*8 aux_liq_density_critical, t_si
real*8 tc, dc
real*8 a1, a2, a3
real*8 r, s, t
real*8 x1, x2, x3
real*8 d

tc = cp_temperature_si
dc = cp_density_si

a1 = -7.34017329598858d-02
a2 = 5.70516487711065d-03
a3 = -4.31313846955949d-04

aux_liq_density_critical = errorreturn

!SOLVE       X^3 + R * X^2 + S * X + T = 0
r = a2 / a3
s = a1 / a3
t = (1d0 - t_si / tc) / a3

if(get_cubicroots(r, s, t, x1, x2, x3) /= 1) return

if(x1 /= 0d0) then
  x1 = sign(1d0, x1) * abs(x1) ** (1d0 / 3d0)
end if
d = (x1 + 1d0) * dc
if(d < dc) return

aux_liq_density_critical = d

end function

!==========================================================================
function aux_vap_density_critical(t_si)
!==========================================================================

!COMPUTES THE VAPOUR DENSITY ON THE SATURATION CURVE FROM A CORRELATION POLYNOMIAL
!AS A FIRST GUESS FOR LIQ_VAP_ITERATION_AT_T (550 K < T < TC WITH RMS = 0.4 K)

! T/TC - 1 = A1 * (1-D/DC)^4 + A2 * (1-D/DC)^8 + A3 * (1-D/DC)^12

implicit none

real*8 aux_vap_density_critical, t_si
real*8 tc, dc
real*8 a1, a2, a3
real*8 r, s, t
real*8 x1, x2, x3
real*8 d

tc = cp_temperature_si
dc = cp_density_si
a1 = -0.237216002118091d0
a2 = 0.186593118426901d0
a3 = -0.258472040504799d0

aux_vap_density_critical = errorreturn

!SOLVE       X^3 + R * X^2 + S * X + T = 0
r = a2 / a3
s = a1 / a3
t = (1d0 - t_si / tc) / a3

if(get_cubicroots(r, s, t, x1, x2, x3) /= 1) return

if(x1 < 0d0) return
if(x1 > 0d0) then
  x1 = abs(x1) ** 0.25d0
end if
d = (1d0 - x1) * dc
if(d <= 0d0) return

aux_vap_density_critical = d

end function

!==========================================================================
function aux_liq_density_triplepoint(t_si)
!==========================================================================

!COMPUTES THE LIQUID DENSITY ON THE SATURATION CURVE FROM A CORRELATION POLYNOMIAL
!AS A FIRST GUESS FOR LIQ_VAP_ITERATION_AT_T (TT < T < 350 K WITH RMS = 0.002 KG/M3)

! (D/DT-1) = A1 * (T/TT-1) + A2 * (T/TT-1)^2 + A3 * (T/TT-1)^3 + A4 * (T/TT-1)^4 + A5 * (T/TT-1)^5

implicit none

real*8 aux_liq_density_triplepoint, t_si
real*8 tt, dt
real*8 a1, a2, a3, a4, a5
real*8 tr
real*8 d

tt = tp_temperature_si
dt = tp_density_liq_iapws95_si

a1 = 1.80066818428501d-02
a2 = -0.648994409718973d0
a3 = 1.56594764908347d0
a4 = -3.18116999660964d0
a5 = 2.98590977093295d0

tr = t_si / tt - 1d0
d = dt*(a1*tr + a2*tr**2 + a3*tr**3 + a4*tr**4 + a5*tr**5 + 1)

aux_liq_density_triplepoint = d

end function

!==========================================================================
function aux_vap_density_triplepoint(t_si)
!==========================================================================

!COMPUTES THE VAPOUR DENSITY ON THE SATURATION CURVE FROM A CORRELATION POLYNOMIAL
!AS A FIRST GUESS FOR LIQ_VAP_ITERATION_AT_T (TT < T < 550 K WITH RMS = 0.01 IN LN(D/DT))

! LN(D/DT) = A1 * (TT/T-1) + A2 * (TT/T-1)^2 + A3 * (TT/T-1)^3

implicit none
real*8 aux_vap_density_triplepoint, t_si
real*8 tt, dt
real*8 a1, a2, a3
real*8 tr
real*8 d

tt = tp_temperature_si
dt = tp_density_vap_iapws95_si

a1 = -19.2235086866063d0
a2 = -6.15770193302955d0
a3 = -4.965736126494d0

tr = tt / t_si - 1d0
d = dt * exp(a1 * tr + a2 * tr ** 2 + a3 * tr ** 3)

aux_vap_density_triplepoint = d

end function

!==========================================================================
function aux_boil_temperature(p_si)
!==========================================================================

!COMPUTES THE BOILING TEMPERATURE ON THE SATURATION CURVE FROM A CORRELATION POLYNOMIAL
!AS A FIRST GUESS FOR LIQ_VAP_ITERATION_AT_P (TT < T < 640 K WITH RMS = 0.01 IN LN(P/PT))

! CLAUSIUS-CLAPEYRON TYPE EQUATION:
! LN(P/PT) = A1 * (TT/T-1) + A2 * (TT/T-1)^2

implicit none
real*8 aux_boil_temperature, p_si
real*8 tt, pt
real*8 a1, a2
real*8 p, q
real*8 tr

tt = tp_temperature_si
pt = tp_pressure_iapws95_si

a1 = -19.8731005709116d0
a2 = -3.08975437352998d0

p = a1 / a2
q = -log(p_si / pt) / a2

tr = -0.5d0*p + sqrt(0.25d0*p**2 - q)

aux_boil_temperature = tt / (tr + 1d0)

end function

!==========================================================================
subroutine set_liq_vap_state(t, pl, pv, gl, gv, dl, dv)
!==========================================================================

!STORES THE ACTUAL PROPERTIES AS THE CURRENT EQUILIBRIUM STATE DESCRIPTOR

implicit none
real*8 t, pl, pv, gl, gv, dl, dv

equi_liq_vap_done = isok

equi_liq_vap_t = t
equi_liq_vap_p_liq = pl
equi_liq_vap_p_vap = pv
equi_liq_vap_g_liq = gl
equi_liq_vap_g_vap = gv
equi_liq_vap_d_liq = dl
equi_liq_vap_d_vap = dv

return
end subroutine

!==========================================================================
subroutine clear_liq_vap_state()
!==========================================================================

!CLEARS THE CURRENT EQUILIBRIUM STATE DESCRIPTOR

implicit none

equi_liq_vap_done = 0

return
end subroutine

!==========================================================================
subroutine init_it_ctrl_liq_vap()
!==========================================================================

implicit none

real*8 dl_triple, dv_triple, t_triple

!TRIPLE POINT
dl_triple = tp_density_liq_iapws95_si
dv_triple = tp_density_vap_iapws95_si
t_triple = tp_temperature_si

if(ctrl_initialized == isok) return

ctrl_initialized = isok

!SET DEFAULT VALUES .AND. MODES FOR DENSITY ITERATION
ctrl_mode_liquid = 0
ctrl_mode_vapour = 0
ctrl_mode_temperature = 0
ctrl_loop_maximum = 100
ctrl_init_d_liq = dl_triple
ctrl_init_d_vap = dv_triple
ctrl_init_t = t_triple
ctrl_eps_exit_p_vap = -0.0000001d0 !RELATIVE, 0.1 PPM

return
end subroutine

!==========================================================================
subroutine set_it_ctrl_liq_vap(key, value)
!==========================================================================

!THIS SUB SETS CONTROL PARAMETERS FOR THE ITERATION USED TO COMPUTE
!IAPWS-95 VAPOUR PRESSURE FROM TEMPERATURE

!KEY                    VALUE
!'IT_STEPS     '        0           SET ITERATION NUMBER TO DEFAULT (100)
!'IT_STEPS     '        N > 0       SET ITERATION NUMBER TO N
!'IT_STEPS     '       -1           DO NOT ITERATE, USE INITIAL VAPOUR DENSITY TO COMPUTE VAPOUR PRESSURE

!'INIT_LIQ_DENS'        0           USE DEFAULT LIQUID DENSITY TO START:
!                                   T < 350 K: LIQUID DENSITY CORRELATION FUNCTION, D = AUX_LIQ_DENSITY_TRIPLEPOINT(T)
!                                   T > 350 K: LIQUID DENSITY CORRELATION FUNCTION, D = AUX_LIQ_DENSITY_CRITICAL(T)
!'INIT_LIQ_DENS'       -1           USE TRIPLE POINT LIQUID DENSITY TO START
!'INIT_LIQ_DENS'        D > 0       USE VALUE D AS LIQUID DENSITY TO START

!'INIT_VAP_DENS'        0           USE DEFAULT VAPOUR DENSITY TO START
!                                   T < 550 K: VAPOUR DENSITY CORRELATION FUNCTION, D = AUX_VAP_DENSITY_TRIPLEPOINT(T)
!                                   T > 550 K: VAPOUR DENSITY CORRELATION FUNCTION, D = AUX_VAP_DENSITY_CRITICAL(T)
!'INIT_VAP_DENS'       -1           USE TRIPLE POINT VAPOUR DENSITY TO START
!'INIT_VAP_DENS'        D > 0       USE VALUE D AS VAPOUR DENSITY TO START

!'INIT_TEMP    '        0           USE DEFAULT TEMPERATURE TO START ( = AUX_BOIL_TEMPERATURE(P))
!'INIT_TEMP    '       -1           USE TRIPLE POINT TEMPERATURE TO START
!'INIT_TEMP    '        T > 0       USE VALUE T AS TEMPERATURE TO START

!'TOL_VAP_PRESS'        0           USE DEFAULT EXIT ACCURACY FOR VAPOUR PRESSURE (0.1 PPM)
!'TOL_VAP_PRESS'        EPS         USE EPS AS EXIT ACCURACY FOR VAPOUR PRESSURE (EPS < 0 MEANS RELATIVE ERROR)

implicit none

character*13 key
real*8 value

call init_it_ctrl_liq_vap

call clear_liq_vap_state

select case (trim(key))

  case ('it_steps')             !ITERATION STEPS
    if(value == 0d0)then
      ctrl_loop_maximum = 100   !DEFAULT = 100
    elseif(value < 0d0)then
      ctrl_loop_maximum = -1
    else
      ctrl_loop_maximum = nint(value)
    endif

  case ('init_liq_dens')        !START LIQUID DENSITY
    if(value == 0d0)then
      ctrl_mode_liquid = 0      !DEFAULT = AUX POLYNOMIAL
    elseif(value < (-1d0))then !IGNORE IT
    elseif(value < 0d0)then
      ctrl_mode_liquid = nint(value)
    else
      ctrl_mode_liquid = 1
      ctrl_init_d_liq = value
    endif

  case ('init_vap_dens')        !START LIQUID DENSITY
    if(value == 0d0)then
      ctrl_mode_vapour = 0      !DEFAULT = AUX POLYNOMIAL
    elseif(value < (-1d0))then !IGNORE IT
      elseif(value < 0d0)then
        ctrl_mode_vapour = nint(value)
      else
        ctrl_mode_vapour = 1
        ctrl_init_d_vap = value
      endif

  case ('init_temp')            !START TEMPERATURE
    if(value == 0d0)then
      ctrl_mode_temperature = 0 !DEFAULT = AUX POLYNOMIAL
    elseif(value < (-1d0))then !IGNORE IT
    elseif(value < 0d0)then
      ctrl_mode_temperature = nint(value)
    else
      ctrl_mode_temperature = 1
      ctrl_init_t = value
    endif

  case ('tol_vap_press')        !REQUIRED VAPOUR PRESSURE TOLERANCE
    if(value == 0d0)then
      ctrl_eps_exit_p_vap = -0.0000001d0   !DEFAULT = 0.1 PPM RELATIVE
    else
      ctrl_eps_exit_p_vap = value
    endif

  case default; write(*,*)key,' not supported'

end select

return
end subroutine

!==========================================================================
subroutine chk_iapws95_table8
!==========================================================================

implicit none
integer it
real*8 pl, pv, rhol, rhov
real*8 t, zt(3)
real*8 g, gt, gp
real*8 temp

write(*,*) " "
write(*,*) " "
write(*,*) " "
write(*,*) "****************************************************************"
write(*,*) "****************************************************************"
write(*,*) "****************************************************************"
write(*,*) " "
write(*,*) "Implementation of IAPWS-95 in Fortran"
write(*,*) "for Publication in Ocean Science, 2009"
write(*,*) "D. Wright, BIO, VERSION ", version
write(*,*) " "
write(*,*) "TABLE A3 OF OS2008 AND TABLE 8 OF IAPWS-95 WITH P CALCULATED INTERNALLY"
write(*,*) "PROPERTIES OF H2O IN THE TWO-PHASE REGION AT SELECTED VALUES OF TEMPERATURE" 

zt(1) = 275d0
zt(2) = 450d0
zt(3) = 625d0

do it = 1,3

  t = zt(it)

#ifdef interactive
  write(*,*)' '
  write(*,*)'ENTER 1 TO SHOW RESULTS FOR T = ',t,'; 0 TO EXIT'
  read(*,*)icheck
  if(icheck /= 1) go to 999
#endif

  !if(it == 1)rhol = 9.99887406119850d2; rhov = 5.50664918504123d-3  
  !if(it == 2)rhol = 8.90341249761673d2; rhov = 4.81200360125671d0
  !if(it == 3)rhol = 5.67090385146353d2; rhov = 1.18290280451157d2
  temp = liq_vap_vapourpressure_si(t)
  rhol = liq_density_si(t,temp)
  rhov = vap_density_si(t,temp)

  pl=flu_pressure_si(t, rhol)
  g =  flu_f_si(0, 0, t, rhol) + pl/rhol
  gt =  flu_f_si(1, 0, t, rhol)
  gp =  1d0/rhol

  write(*,*) " "
  write(*,*) " "
  write(*,*) " "
  write(*,*) "PROPERTIES AT T =", zt(it), " K, P =", pl," Pa"
  write(*,*) " "

  write(*,*) "QUANTITY       TABLE VALUE             COMPUTED VALUE         &
  &UNITS"
  write(*,*) " "

  if(it == 1)then
    write(*,'(" pl             6.9845117e8       ",2x,e24.16,4x,"Pa    ")') pl
    write(*,'(" rhol           999.887406120     ",2x,e24.16,4x,"KG M-3")') rhol
    write(*,'(" hl             7.759722016e3     ",2x,e24.16,4x,"J KG-1")') g- t * gt
    write(*,'(" sigmal         2.83094669595e1   ",2x,e24.16,4x,"J KG-1 K-1")') -gt
  elseif(it == 2)then
    write(*,'(" pl             9.32203563628e5   ",2x,e24.16,4x,"Pa    ")') pl
    write(*,'(" rhol           890.34124976167   ",2x,e24.16,4x,"KG M-3")') rhol
    write(*,'(" hl             7.4916158501217e5 ",2x,e24.16,4x,"J KG-1")') g- t * gt
    write(*,'(" sigmal         2.10865844688447e3",2x,e24.16,4x,"J KG-1 K-1")') -gt
  elseif(it == 3)then
    write(*,'(" pl             1.6908269318578e7 ",2x,e24.16,4x,"Pa    ")') pl
    write(*,'(" rhol           5.670903851464e2  ",2x,e24.16,4x,"KG M-3")') rhol
    write(*,'(" hl             1.6862697594697e6 ",2x,e24.16,4x,"J KG-1")') g- t * gt
    write(*,'(" sigmal         3.8019468301114e3 ",2x,e24.16,4x,"J KG-1 K-1")') -gt
  endif

  write(*,*)' '

  pv=flu_pressure_si(t, rhov)
  g = flu_f_si(0, 0, t, rhov) + pv/rhov
  gt =  flu_f_si(1, 0, t, rhov)

  if(it == 1)then
    write(*,'(" pv             6.98451166701e8   ",2x,e24.16,4x,"Pa    ")') pv
    write(*,'(" rhov           5.506649185041e-3 ",2x,e24.16,4x,"KG M-3")') rhov
    write(*,'(" hv             2.5042899500405e6 ",2x,e24.16,4x,"J KG-1")') g - t * gt
    write(*,'(" sigmav         9.1066012052322e3 ",2x,e24.16,4x,"J KG-1 K-1")') -gt
  elseif(it == 2)then
    write(*,'(" pv             9.322035636282e5  ",2x,e24.16,4x,"Pa    ")') pv
    write(*,'(" rhov           4.812003601257    ",2x,e24.16,4x,"KG M-3")') rhov
    write(*,'(" hv             2.77441077988962e6",2x,e24.16,4x,"J KG-1")') g - t * gt
    write(*,'(" sigmav         6.6092122132788e3 ",2x,e24.16,4x,"J KG-1 K-1")') -gt
  elseif(it == 3)then
    write(*,'(" pv             1.6908269318578e7 ",2x,e24.16,4x,"Pa    ")') pv
    write(*,'(" rhov           1.182902804512e2  ",2x,e24.16,4x,"KG M-3")') rhov
    write(*,'(" hv             2.5507162456235e6 ",2x,e24.16,4x,"J KG-1")') g - t * gt
    write(*,'(" sigmav         5.1850612079574e3 ",2x,e24.16,4x,"J KG-1 K-1")') -gt
  endif

go to 999
999 write(*,*)' '
 
enddo

end subroutine

end module liq_vap_4

module sal_2

!#########################################################################

!THIS MODULE IMPLEMENTS THE SALINE PART OF THE GIBBS FUNCTION OF SEAWATER,
!SAL_G_SI(DRV_S, DRV_T, DRV_P, SA_SI, T_SI, P_SI) AS WELL AS ITS 1ST AND 2ND
!PARTIAL DERIVATIVES WITH RESPECT TO SALINITY, TEMPERATURE AND PRESSURE,
!AS WELL AS THERMODYNAMIC PROPERTIES OF SEA SALT IN SEAWATER AS FUNCTIONS
!COMPUTED FROM THE SALINITY EXPANSION TERMS OF THE GIBBS POTENTIAL,
!AS DEFINED IN

!RELEASE ON THE IAPWS FORMULATION 2008 FOR THE THERMODYNAMIC PROPERTIES OF 
!SEAWATER.  THE INTERNATIONAL ASSOCIATION FOR THE PROPERTIES OF WATER AND STEAM
!BERLIN, GERMANY, SEPTEMBER 2008

!#########################################################################

!IMPLEMENTATION IN FORTRAN BY D.G. WRIGHT
!FOR PUBLICATION IN OCEAN SCIENCE, AS DESCRIBED IN THE PAPERS

!FEISTEL, R., WRIGHT, D.G., JACKETT, D.R., MIYAGAWA, K., REISSMANN, J.H.,
!WAGNER, W., OVERHOFF, U., GUDER, C., FEISTEL, A., MARION, G.M.:
!NUMERICAL IMPLEMENTATION AND OCEANOGRAPHIC APPLICATION OF THE THERMODYNAMIC
!POTENTIALS OF WATER, VAPOUR, ICE, SEAWATER AND AIR. PART I: BACKGROUND AND EQUATIONS. 
!OCEAN SCIENCES, 2009, IN PREPARATION.

!WRIGHT, D.G., FEISTEL, R., JACKETT, D.R., MIYAGAWA, K., REISSMANN, J.H., 
!WAGNER, W., OVERHOFF, U., GUDER, C., FEISTEL, A., MARION, G.M.:
!NUMERICAL IMPLEMENTATION AND OCEANOGRAPHIC APPLICATION OF THE THERMODYNAMIC
!POTENTIALS OF WATER, VAPOUR, ICE, SEAWATER AND AIR. PART II: THE LIBRARY ROUTINES, 
!OCEAN SCIENCES., 2009, IN PREPARATION.

!FEISTEL, R., KRETZSCHMAR, H.-J., SPAN, R., HAGEN, E., WRIGHT, D.G., JACKETT, D.R.:
!THERMODYNAMIC PROPERTIES OF SEA AIR.
!OCEAN SCIENCE DISCUSSION 6(2009)2193-2325.

!#########################################################################

!THIS MODULE REQUIRES THE LIBRARY MODULE 
!     CONSTANTS_0,    FILE CONSTANTS_0.F90
!     SAL_1,          FILE SAL_1.F90 

!#########################################################################

use constants_0
use sal_1

implicit none
private

character*16, private :: version = '8 Jun 2010'

public :: sal_act_coeff_si, sal_act_potential_si, sal_activity_w_si, &
          sal_chem_coeff_si, sal_chempot_h2o_si, sal_chempot_rel_si, &
          sal_dilution_si, sal_g_si, sal_mixenthalpy_si, sal_mixentropy_si, &
          sal_mixvolume_si, sal_molality_si, sal_osm_coeff_si, &
          sal_saltenthalpy_si, sal_saltentropy_si, sal_saltvolume_si

integer, private, parameter :: maxs = 7

contains

!==========================================================================
function sal_g_si(drv_s, drv_t, drv_p, sa_si, t_si, p_si)
!==========================================================================

!RETURNS THE S-T-P DERIVATIVE (D/DS)^DRV_S (D/DT)^DRV_T (D/DP)^DRV_P GS(S,T,P)
!OF THE SALINE GIBBS FUNCTION GS,
!
! GS(S,T,P) = G1(T,P)*S*LN(S) + SUM(I>1) GI(T,P)*S^(I/2)
!
! SA_SI = S = ABSOLUTE SALINITY IN KG/KG, I.E. THE MASS FRACTION OF SALT IN SEAWATER
! T_SI  = T = ABSOLUTE TEMPERATURE IN K, ITS-90
! P_SI  = P = ABSOLUTE PRESSURE IN PA
! SAL_G_SI = GS = SPECIFIC GIBBS ENERGY IN J/KG, RELATIVE TO PURE WATER

!CHECK VALUES:
!SAL_G_SI(0,0,0,0.035,300,1E6)= 127.033640309
!SAL_G_SI(1,0,0,0.035,300,1E6)= 77949.2100395
!SAL_G_SI(0,1,0,0.035,300,1E6)= 18.6360407073
!SAL_G_SI(0,0,1,0.035,300,1E6)= -2.55600080319E-05
!SAL_G_SI(2,0,0,0.035,300,1E6)= 2248200.54660
!SAL_G_SI(1,1,0,0.035,300,1E6)= 790.563810558
!SAL_G_SI(1,0,1,0.035,300,1E6)= -7.15686520588E-04
!SAL_G_SI(0,2,0,0.035,300,1E6)= 0.597842170749
!SAL_G_SI(0,1,1,0.035,300,1E6)= 2.85865076269E-08
!SAL_G_SI(0,0,2,0.035,300,1E6)= 4.09543164905E-14

implicit none

real*8 sal_g_si
integer drv_s, drv_t, drv_p, i
real*8 sa_si, t_si, p_si
real*8 sqr_s, gi, g

dimension gi(7)

sal_g_si = errorreturn

if (drv_s < 0 .or. drv_s > 3) return
if (drv_t < 0) return
if (drv_p < 0) return

if(check_limits == 1) then
  !SAL_LIMITS
  if(t_si < sal_tmin .or. t_si > sal_tmax .or.  &
  sa_si < sal_smin .or. sa_si > sal_smax .or.  &
  p_si < sal_pmin .or. p_si > sal_pmax) return
else
  if (sa_si < 0d0 .or. sa_si >= 1d0) return
  if (t_si <= 0d0) return
  if (p_si <= 0d0) return
endif

!COMPUTE THE LIMIT S = 0:
if (sa_si == 0d0) then

  if (drv_s == 0) then                                          !IF NO S-DERIVATIVE TAKEN, EACH TERM OF GS VANISHES
    sal_g_si = 0d0
    return
  end if
  if ((drv_p > 0 .or. drv_t > 1) .and. drv_s == 1) then   !IF THE LOG TERM IS GONE, THE 1ST S-DERIVATIVE
    sal_g_si = sal_g_term_si(2, drv_t, drv_p, t_si, p_si)        !RETURNS THE LINEAR S TERM
    return
  end if
  return                                                          !ALL OTHER CASES HAVE A SINGULARITY AT S = 0

end if

!COMPUTE THE CASES S > 0:
do i = 1, maxs
  gi(i) = sal_g_term_si(i, drv_t, drv_p, t_si, p_si)             !GET ALL COEFFICIENTS OF THE SALINITY EXPANSION
  if (gi(i) == errorreturn) return
enddo

g = 0d0
if (gi(1) /= 0d0) then                                          !TAKE THE REQUIRED S-DERIVATIVE OF THE LOG TERM
  select case (drv_s)
    case(0); g = gi(1) * sa_si * log(sa_si)
    case(1); g = gi(1) * (log(sa_si) + 1d0)
    case(2); g = gi(1) / sa_si
    case(3); g = -gi(1) / sa_si**2
  end select
end if

sqr_s = sqrt(sa_si)

do i = 2, maxs                                                    !ADD THE S-DERIVATIVES OF EACH ROOT(S) TERM
  if (gi(i) /= 0d0) then
    select case(drv_s)
      case(0); g = g + gi(i) * sqr_s**i
      case(1); g = g + gi(i)*0.5d0*dfloat(i)*sqr_s**(i - 2)
      case(2); g = g + gi(i)*0.5d0*dfloat(i)*(0.5d0*dfloat(i) - 1d0)  &
        *sqr_s**(i - 4)
      case(3); g = g + gi(i)*0.5d0*dfloat(i)*(0.5d0*dfloat(i) - 1d0)  &
        *(0.5d0*dfloat(i) - 2d0)*sqr_s**(i - 6)
    end select
  end if
enddo

sal_g_si = g

end function

!==========================================================================
function sal_act_coeff_si(sa_si, t_si, p_si)
!==========================================================================

!RETURNS THE MEAN ACTIVITY COEFFICIENT, LN(GAMMA), OF SEAWATER

!SA_SI:   ABSOLUTE SALINITY IN KG/KG
!T_SI:    ABSOLUTE TEMPERATURE IN K
!P_SI:    ABSOLUTE PRESSURE IN PA

!CHECK VALUE: 
!SAL_ACT_COEFF_SI(0.035,300,1E6) = -0.527003008913

implicit none

integer i
real*8 sal_act_coeff_si
real*8 sa_si, t_si, p_si
real*8 lng, sqr_s
real*8 gi

dimension gi(7)

sal_act_coeff_si = errorreturn

if (sa_si < 0d0 .or. sa_si >= 1d0) return
if (t_si <= 0d0) return
if (p_si <= 0d0) return

if (sa_si == 0d0) then
  sal_act_coeff_si = 0d0
  return
end if

!COMPUTE THE CASES S > 0:
do i = 1, maxs
  if (i /= 2) then
    gi(i) = sal_g_term_si(i, 0, 0, t_si, p_si)  !GET ALL COEFFICIENTS OF THE SALINITY EXPANSION
    if (gi(i) == errorreturn) return
  end if
enddo

sqr_s = sqrt(sa_si)
lng = 0d0

do i = 3, maxs
  lng = lng + gi(i)*(sa_si*(1d0 - 0.5d0*dfloat(i)) + 0.5d0*dfloat(i))  &
        *sqr_s**(i - 2)
enddo

sal_act_coeff_si = lng / gi(1) + log(1d0 - sa_si) - sa_si

end function

!==========================================================================
function sal_act_potential_si(sa_si, t_si, p_si)
!==========================================================================

!RETURNS THE ACTIVITY POTENTIAL, PSI, OF SEAWATER

!SA_SI:   ABSOLUTE SALINITY IN KG/KG
!T_SI:    ABSOLUTE TEMPERATURE IN K
!P_SI:    ABSOLUTE PRESSURE IN PA

!CHECK VALUE: 
!SAL_ACT_POTENTIAL_SI(0.035,300,1E6) = -0.429940465498

implicit none

integer i
real*8 sal_act_potential_si
real*8 sa_si, t_si, p_si
real*8 sqr_s
real*8 gi
real*8 psi

dimension gi(7)

sal_act_potential_si = errorreturn

if (sa_si < 0d0 .or. sa_si >= 1d0) return
if (t_si <= 0d0) return
if (p_si <= 0d0) return

if (sa_si == 0d0) then
  sal_act_potential_si = 0d0
  return
end if

!COMPUTE THE CASES S > 0:
do i = 1, maxs
  if (i /= 2) then
    gi(i) = sal_g_term_si(i, 0, 0, t_si, p_si)  !GET ALL COEFFICIENTS OF THE SALINITY EXPANSION
    if (gi(i) == errorreturn) return
  end if
enddo

sqr_s = sqrt(sa_si)
psi = 0d0

do i = 3, maxs
  psi = psi + gi(i)*sqr_s**(i - 2)
enddo

sal_act_potential_si = psi/gi(1) + log(1d0 - sa_si)

end function

!==========================================================================
function sal_activity_w_si(sa_si, t_si, p_si)
!==========================================================================

!FUNCTION RETURNS THE ACTIVITY OF WATER IN SEAWATER, A_W AS A FUNCTION OF 
!ABSOLUTE SALINITY IN KG/KG FOR SEAWATER WITH REFERENCE COMPOSITION, SEE 
!MILLERO ET AL., DEEP-SEA RESEARCH I, 55(2008) 50-72.


implicit none

real*8 sa_si, t_si, p_si, sal_activity_w_si
real*8 phi

!RETURNS   ACTIVITY OF WATER IN SEAWATER
!SA_SI     ABSOLUTE SALINITY IN KG/KG
!T_SI      ABSOLUTE TEMPERATURE IN K
!P_SI      ABSOLUTE PRESSURE IN PA

!CHECK VALUE: 
!SAL_ACTIVITY_W_SI(0.035,300,1E6) = 0.981388410188

if(sa_si == 0d0) then
   sal_activity_w_si = 0d0
   return
endif

phi = sal_osm_coeff_si(sa_si, t_si, p_si)

if (phi == errorreturn)then
   sal_activity_w_si = errorreturn
   return
endif

!Begin modified code
!dbg  sal_activity_w_si = exp(-phi*sa_si/(1d0-sa_si))
sal_activity_w_si = exp(-phi*sa_si/(1d0-sa_si)  &
                  * molar_mass_h2o_si/molar_mass_seasalt_si)
!End modified code

end function

!==========================================================================
function sal_dilution_si(sa_si, t_si, p_si)
!==========================================================================

implicit none

integer i
real*8 sa_si, t_si, p_si, sal_dilution_si
real*8 gi
real*8 d, sqr_s

dimension gi(7)

!RETURNS   DILUTION COEFFICIENT OF SEAWATER, D = S * (D2G/DS2)_T_P, IN J/KG
!SA_SI     ABSOLUTE SALINITY IN KG/KG
!T_SI      ABSOLUTE TEMPERATURE IN K
!P_SI      ABSOLUTE PRESSURE IN PA

!CHECK VALUE: 
!SAL_DILUTION_SI(0.035,300,1E6) = 78687.0191309

sal_dilution_si = errorreturn

if (sa_si < 0d0 .or. sa_si >= 1d0) return
if (t_si <= 0d0) return
if (p_si <= 0d0) return

if (sa_si == 0d0) then
  sal_dilution_si = sal_g_term_si(1, 0, 0, t_si, p_si)
end if

do i = 1, maxs
  if (i /= 2) then
    gi(i) = sal_g_term_si(i, 0, 0, t_si, p_si)  !GET ALL COEFFICIENTS OF THE SALINITY EXPANSION
    if (gi(i) == errorreturn) return
  end if
enddo

sqr_s = sqrt(sa_si)
d = gi(1)

do i = 3, maxs
  d = d + gi(i)*0.25d0*dfloat(i)*dfloat(i - 2)*sqr_s**(i - 2)
enddo

sal_dilution_si = d

end function

!==========================================================================
function sal_mixenthalpy_si(sa1_si, sa2_si, w1, t_si, p_si)
!==========================================================================

implicit none

real*8 sa1_si, sa2_si, t_si, p_si, sal_mixenthalpy_si
real*8 w1, w2
real*8 h, h1, h2, s, s1, s2, s12

!RETURNS   MIXING ENTHALPY IN J/KG

!SA1_SI    ABSOLUTE SALINITY OF COMPONENT 1, IN KG/KG
!SA2_SI    ABSOLUTE SALINITY OF COMPONENT 2, IN KG/KG
!W1        MASS FRACTION OF COMPONENT 1, W1 = M1/(M1+M2)
!T_SI      ABSOLUTE TEMPERATURE IN K
!P_SI      ABSOLUTE PRESSURE IN PA

!CHECK VALUE: 
!SAL_MIXENTHALPY_SI(0.01,0.035,0.6,300,1E6) = 16.1539911284

sal_mixenthalpy_si = errorreturn

if (sa1_si < 0d0 .or. sa1_si >= 1d0) return
if (sa2_si < 0d0 .or. sa2_si >= 1d0) return
if (w1 < 0d0 .or. w1 > 1d0) return
if (t_si <= 0d0) return
if (p_si <= 0d0) return

w2 = 1d0 - w1
s12 = w1 * sa1_si + w2 * sa2_si
h = sal_g_si(0, 0, 0, s12, t_si, p_si)
if (h == errorreturn) return
s = -sal_g_si(0, 1, 0, s12, t_si, p_si)
if (s == errorreturn) return
h = h + t_si * s

h1 = sal_g_si(0, 0, 0, sa1_si, t_si, p_si)
if (h1 == errorreturn) return
s1 = -sal_g_si(0, 1, 0, sa1_si, t_si, p_si)
if (s1 == errorreturn) return
h1 = h1 + t_si * s1

h2 = sal_g_si(0, 0, 0, sa2_si, t_si, p_si)
if (h2 == errorreturn) return
s2 = -sal_g_si(0, 1, 0, sa2_si, t_si, p_si)
if (s2 == errorreturn) return
h2 = h2 + t_si * s2

sal_mixenthalpy_si = h - w1*h1 - w2*h2

end function

!==========================================================================
function sal_mixentropy_si(sa1_si, sa2_si, w1, t_si, p_si)
!==========================================================================

implicit none

real*8 sa1_si, sa2_si, w1, w2, t_si, p_si, sal_mixentropy_si
real*8 s, s1, s2, s12

!RETURNS   MIXING ENTROPY OF SEAWATER IN J/KG

!SA1_SI    ABSOLUTE SALINITY OF COMPONENT 1, IN KG/KG
!SA2_SI    ABSOLUTE SALINITY OF COMPONENT 2, IN KG/KG
!W1        MASS FRACTION OF COMPONENT 1, W1 = M1/(M1+M2)
!T_SI      ABSOLUTE TEMPERATURE IN K
!P_SI      ABSOLUTE PRESSURE IN PA

!CHECK VALUE: 
!SAL_MIXENTROPY_SI(0.01,0.035,0.6,300,1E6) = 0.96682942261|7

sal_mixentropy_si = errorreturn

if (sa1_si < 0d0 .or. sa1_si >= 1d0)return
if (sa2_si < 0d0 .or. sa2_si >= 1d0)return
if (w1 < 0d0 .or. w1 > 1d0) return
if (t_si <= 0d0) return
if (p_si <= 0d0) return

w2 = 1d0 - w1
s12 = w1 * sa1_si + w2 * sa2_si
s = -sal_g_si(0, 1, 0, s12, t_si, p_si)
if (s == errorreturn) return

s1 = -sal_g_si(0, 1, 0, sa1_si, t_si, p_si)
if (s1 == errorreturn) return

s2 = -sal_g_si(0, 1, 0, sa2_si, t_si, p_si)
if (s2 == errorreturn) return

sal_mixentropy_si = s - w1*s1 - w2*s2

end function

!==========================================================================
function sal_mixvolume_si(sa1_si, sa2_si, w1, t_si, p_si)
!==========================================================================

implicit none

real*8 sal_mixvolume_si
real*8 sa1_si, sa2_si, w1, t_si, p_si
real*8 v, v1, v2, s12, w2

!RETURNS THE MIXING VOLUME OF SEAWATER, V_MIX, IN M3/KG

!SA1_SI:  SALINITY OF COMPONENT 1, IN KG/KG
!SA2_SI:  SALINITY OF COMPONENT 2, IN KG/KG
!W1:      MASS FRACTION OF COMPONENT 1, W1 = M1 / (M1 + M2)
!T_SI:    ABSOLUTE TEMPERATURE IN K
!P_SI:    ABSOLUTE PRESSURE IN PA

!CHECK VALUE: 
!SAL_MIXVOLUME_SI(0.01,0.035,0.6,300,1E6) = -5.94174956892E-08

sal_mixvolume_si = errorreturn

if (sa1_si < 0d0 .or. sa1_si >= 1d0) return
if (sa2_si < 0d0 .or. sa2_si >= 1d0) return
if (w1 < 0d0 .or. w1 > 1d0) return
if (t_si <= 0d0) return
if (p_si <= 0d0) return

w2 = 1d0 - w1
s12 = w1 * sa1_si + w2 * sa2_si
v = sal_g_si(0, 0, 1, s12, t_si, p_si)
if (v == errorreturn) return

v1 = sal_g_si(0, 0, 1, sa1_si, t_si, p_si)
if (v1 == errorreturn) return

v2 = sal_g_si(0, 0, 1, sa2_si, t_si, p_si)
if (v2 == errorreturn) return

sal_mixvolume_si = v - w1 * v1 - w2 * v2

end function

!==========================================================================
function sal_osm_coeff_si(sa_si, t_si, p_si)
!==========================================================================

implicit none

integer i
real*8 sal_osm_coeff_si
real*8 sa_si, t_si, p_si
real*8 phi, sqr_s, gi

dimension gi(7)

!RETURNS THE OSMOTIC COEFFICIENT OF SEAWATER, PHI

!SA_SI:   ABSOLUTE SALINITY IN KG/KG
!T_SI:    ABSOLUTE TEMPERATURE IN K
!P_SI:    ABSOLUTE PRESSURE IN PA

!CHECK VALUE: 
!SAL_OSM_COEFF_SI(0.035,300,1E6) = 0.902937456585

sal_osm_coeff_si = errorreturn

if (sa_si < 0d0 .or. sa_si >= 1d0) return
if (t_si <= 0d0) return
if (p_si <= 0d0) return

if (sa_si == 0d0) then
  sal_osm_coeff_si = 1d0
  return
end if

!COMPUTE THE CASES S > 0:
do i = 1, maxs
  if (i /= 2) then
    gi(i) = sal_g_term_si(i, 0, 0, t_si, p_si)  !get all coefficients of the salinity expansion
    if (gi(i) == errorreturn) return
  end if
enddo

sqr_s = sqrt(sa_si)
phi = 0d0

do i = 3, maxs
  phi = phi + gi(i) * (0.5d0 * dfloat(i) - 1d0) * sqr_s**(i - 2)
enddo

!Begin code check
sal_osm_coeff_si = phi * (1d0 - sa_si) / gi(1) + 1d0 - sa_si
!rs = gas_constant_molar_si/molar_mass_seasalt_si
!sal_osm_coeff_si = (1d0 - sa_si) * (gi(1) + phi) / (rs * t_si)
!End code check

end function

!==========================================================================
function sal_chempot_h2o_si(sa_si, t_si, p_si)
!==========================================================================

implicit none

integer i
real*8 sal_chempot_h2o_si
real*8 sa_si, t_si, p_si
real*8 g, sqr_s, gi

dimension gi(7)

!RETURNS THE SALINE PART OF CHEMICAL POTENTIAL OF WATER IN SEAWATER, µ_WS, IN J/KG

!SA_SI:   ABSOLUTE SALINITY IN KG/KG
!T_SI:    ABSOLUTE TEMPERATURE IN K
!P_SI:    ABSOLUTE PRESSURE IN PA

!CHECK VALUE: 
!SAL_CHEMPOT_H2O_SI(0.035,300,1E6) = -2601.18871107

sal_chempot_h2o_si = errorreturn

if (sa_si < 0d0 .or. sa_si >= 1d0) return
if (t_si <= 0d0) return
if (p_si <= 0d0) return

do i = 1, maxs
  if (i /= 2) then
    gi(i) = sal_g_term_si(i, 0, 0, t_si, p_si)  !get all coefficients of the salinity expansion
    if (gi(i) == errorreturn) return
  end if
enddo

sqr_s = sqrt(sa_si)
g = gi(1)

do i = 3, maxs
  g = g + gi(i) * (0.5d0 * dfloat(i) - 1d0) * sqr_s**(i - 2)
enddo

sal_chempot_h2o_si = -g * sa_si

end function

!==========================================================================
function sal_chempot_rel_si(sa_si, t_si, p_si)
!==========================================================================

implicit none

real*8 sal_chempot_rel_si
real*8 sa_si, t_si, p_si

!RETURNS THE RELATIVE CHEMICAL POTENTIAL OF SEAWATER, µ, IN J/KG

!SA_SI:   ABSOLUTE SALINITY IN KG/KG
!T_SI:    ABSOLUTE TEMPERATURE IN K
!P_SI:    ABSOLUTE PRESSURE IN PA

!CHECK VALUE: 
!SAL_CHEMPOT_REL_SI(0.035,300,1E6) = 77949.2100395

sal_chempot_rel_si = errorreturn

if (sa_si <= 0d0 .or. sa_si >= 1d0) return
if (t_si <= 0d0) return
if (p_si <= 0d0) return

sal_chempot_rel_si = sal_g_si(1, 0, 0, sa_si, t_si, p_si)

end function

!==========================================================================
function sal_chem_coeff_si(sa_si, t_si, p_si)
!==========================================================================

!RETURNS THE CHEMICAL COEFFICIENT OF SEAWATER, DS, IN J/KG

!SA_SI:   ABSOLUTE SALINITY IN KG/KG
!T_SI:    ABSOLUTE TEMPERATURE IN K
!P_SI:    ABSOLUTE PRESSURE IN PA

!CHECK VALUE: 
!SAL_CHEM_COEFF_SI(0.035,300,1E6) = 2754.04566958

real*8 sal_chem_coeff_si, d
real*8 sa_si, t_si, p_si

sal_chem_coeff_si = errorreturn

d = sal_dilution_si(sa_si, t_si, p_si)
if (d == errorreturn) return

sal_chem_coeff_si = sa_si * d

end function

!==========================================================================
function sal_saltenthalpy_si(sa_si, t_si, p_si)
!==========================================================================

implicit none

integer i
real*8 sal_saltenthalpy_si
real*8 sa_si, t_si, p_si
real*8 h, sqr_s, gi, gti

dimension gi(7), gti(7)

!RETURNS THE SPECIFIC ENTHALPY OF SEASALT IN SEAWATER, H_S, IN J/KG

!SA_SI:   ABSOLUTE SALINITY IN KG/KG
!T_SI:    ABSOLUTE TEMPERATURE IN K
!P_SI:    ABSOLUTE PRESSURE IN PA

!CHECK VALUE: 
!SAL_SALTENTHALPY_SI(0.035,300,1E6) = -156107.959196

sal_saltenthalpy_si = errorreturn

if (sa_si < 0d0 .or. sa_si >= 1d0) return
if (t_si <= 0d0) return
if (p_si <= 0d0) return

do i = 2, maxs
  gi(i) = sal_g_term_si(i, 0, 0, t_si, p_si)  !get all coefficients of the salinity expansion
  if (gi(i) == errorreturn) return
  gti(i) = sal_g_term_si(i, 1, 0, t_si, p_si)  !get all t-derivatives of the salinity expansion
  if (gti(i) == errorreturn) return
enddo

sqr_s = sqrt(sa_si)
h = 0d0

do i = 2, maxs
  h = h + (gi(i) - t_si * gti(i)) * sqr_s**(i - 2)
enddo

sal_saltenthalpy_si = h

end function

!==========================================================================
function sal_saltentropy_si(sa_si, t_si, p_si)
!==========================================================================

implicit none

integer i
real*8 sal_saltentropy_si
real*8 sa_si, t_si, p_si
real*8 eta, sqr_s, gi

dimension gi(7)

!RETURNS THE SPECIFIC ENTROPY OF SEASALT IN SEAWATER, ETA_S, IN J/(KG K)

!SA_SI:   ABSOLUTE SALINITY IN KG/KG
!T_SI:    ABSOLUTE TEMPERATURE IN K
!P_SI:    ABSOLUTE PRESSURE IN PA

!CHECK VALUE: 
!SAL_SALTENTROPY_SI(0.035,300,1E6) = -532.458305922

sal_saltentropy_si = errorreturn

if (sa_si <= 0d0 .or. sa_si >= 1d0) return
if (t_si <= 0d0) return
if (p_si <= 0d0) return

do i = 1, maxs
  gi(i) = sal_g_term_si(i, 1, 0, t_si, p_si)  !get all coefficients of the salinity expansion
  if (gi(i) == errorreturn) return
enddo

sqr_s = sqrt(sa_si)
eta = -gi(1) * log(sa_si)

do i = 2, maxs
  eta = eta - gi(i) * sqr_s**(i - 2)
enddo

sal_saltentropy_si = eta

end function

!==========================================================================
function sal_saltvolume_si(sa_si, t_si, p_si)
!==========================================================================

implicit none

integer i
real*8 sal_saltvolume_si
real*8 sa_si, t_si, p_si
real*8 v, sqr_s, gi

dimension gi(7)

!RETURNS THE SPECIFIC VOLUME OF SEASALT IN SEAWATER, V_S, IN M3/KG

!SA_SI:   ABSOLUTE SALINITY IN KG/KG
!T_SI:    ABSOLUTE TEMPERATURE IN K
!P_SI:    ABSOLUTE PRESSURE IN PA

!CHECK VALUE: 
!SAL_SALTVOLUME_SI(0.035,300,1e6) = -7.30285943768e-04

sal_saltvolume_si = errorreturn

if (sa_si < 0d0 .or. sa_si >= 1d0) return
if (t_si <= 0d0) return
if (p_si <= 0d0) return

if (sa_si == 0d0) then
  sal_saltvolume_si = sal_g_term_si(2, 0, 1, t_si, p_si)
  return
end if

do i = 2, maxs
  gi(i) = sal_g_term_si(i, 0, 1, t_si, p_si)  !GET ALL COEFFICIENTS OF THE SALINITY EXPANSION
  if (gi(i) == errorreturn) return
enddo

sqr_s = sqrt(sa_si)
v = gi(2)

do i = 3, maxs
  v = v + gi(i) * sqr_s**(i - 2)
enddo

sal_saltvolume_si = v

end function

!==========================================================================
function sal_molality_si(sa_si)
!==========================================================================

!FUNCTION RETURNS THE MOLALITY OF SEAWATER IN MOL/KG AS A FUNCTION OF ABSOLUTE 
!SALINITY IN KG/KG FOR SEAWATER WITH REFERENCE COMPOSITION, SEE MILLERO ET AL.,
!DEEP-SEA RESEARCH I, 55(2008) 50-72.


!SA_SI:   ABSOLUTE SALINITY IN KG/KG

!CHECK VALUE: 
!SAL_MOLALITY_SI(0.035) = 1.15493681893

real*8 sal_molality_si, sa_si

sal_molality_si = errorreturn

if (sa_si < 0d0 .or. sa_si >= 1d0) return

sal_molality_si = sa_si / ((1d0 - sa_si) * Molar_mass_seasalt_si)

end function

end module sal_2

module sea_ice_vap_4

!#########################################################################

!THIS MODULE IMPLEMENTS THE PHASE EQUILBRIUM PROPERTIES OF SEA ICE WITH VAPOUR
!COMPUTED FROM IAPWS-95, IAPWS-06 AND IAPWS-08:

!RELEASE ON THE IAPWS FORMULATION 1995 FOR THE THERMODYNAMIC PROPERTIES OF
!ORDINARY WATER SUBSTANCE FOR GENERAL AND SCIENTIFIC USE
!THE INTERNATIONAL ASSOCIATION FOR THE PROPERTIES OF WATER AND STEAM
!FREDERICIA, DENMARK, SEPTEMBER 1996

!RELEASE ON AN EQUATION OF STATE FOR H2O ICE IH
!THE INTERNATIONAL ASSOCIATION FOR THE PROPERTIES OF WATER AND STEAM
!WITNEY, UK, SEPTEMBER 2006

!RELEASE ON THE IAPWS FORMULATION 2008 FOR THE THERMODYNAMIC PROPERTIES OF SEAWATER
!THE INTERNATIONAL ASSOCIATION FOR THE PROPERTIES OF WATER AND STEAM
!BERLIN, GERMANY, SEPTEMBER 2008

!#########################################################################

!IMPLEMENTATION IN FORTRAN BY D.G. WRIGHT
!FOR PUBLICATION IN OCEAN SCIENCE, AS DESCRIBED IN THE PAPERS

!FEISTEL, R., WRIGHT, D.G., JACKETT, D.R., MIYAGAWA, K., REISSMANN, J.H.,
!WAGNER, W., OVERHOFF, U., GUDER, C., FEISTEL, A., MARION, G.M.:
!NUMERICAL IMPLEMENTATION AND OCEANOGRAPHIC APPLICATION OF THE THERMODYNAMIC
!POTENTIALS OF WATER, VAPOUR, ICE, SEAWATER AND AIR. PART I: BACKGROUND AND EQUATIONS. 
!OCEAN SCIENCES, 2009, IN PREPARATION.

!WRIGHT, D.G., FEISTEL, R., JACKETT, D.R., MIYAGAWA, K., REISSMANN, J.H., 
!WAGNER, W., OVERHOFF, U., GUDER, C., FEISTEL, A., MARION, G.M.:
!NUMERICAL IMPLEMENTATION AND OCEANOGRAPHIC APPLICATION OF THE THERMODYNAMIC
!POTENTIALS OF WATER, VAPOUR, ICE, SEAWATER AND AIR. PART II: THE LIBRARY ROUTINES, 
!OCEAN SCIENCES., 2009, IN PREPARATION.

!FEISTEL, R., KRETZSCHMAR, H.-J., SPAN, R., HAGEN, E., WRIGHT, D.G., JACKETT, D.R.:
!THERMODYNAMIC PROPERTIES OF SEA AIR.
!OCEAN SCIENCE DISCUSSION 6(2009)2193-2325.

!#########################################################################

!THIS MODULE REQUIRES THE LIBRARY MODULES:
!     CONSTANTS_0,   FILE CONSTANTS_0.F90
!     MATHS_0,       FILE MATHS_0.F90
!     FLU_1,         FILE FLU_1.F90
!     ICE_1,         FILE ICE_1.F90
!     SAL_1,         FILE SAL_1.F90
!     SAL_2,         FILE SAL_2.F90

!#########################################################################

use constants_0
use maths_0
use flu_1
use ice_1
use sal_1
use sal_2

implicit none
private

character*16, private :: version = '8 Jun 2010'

public :: sea_ice_vap_density_vap_si, sea_ice_vap_pressure_si, &
          sea_ice_vap_salinity_si, sea_ice_vap_temperature_si,  &
          set_it_ctrl_sea_ice_vap, set_sea_ice_vap_eq_at_s, &
          set_sea_ice_vap_eq_at_t, set_sea_ice_vap_eq_at_p

!INTEGER, PRIVATE :: CTRL_INITIALIZED, CTRL_LOOP_MAXIMUM, CTRL_MODE_LIQUID
integer, private :: ctrl_loop_maximum

!CONTROL PARAMETERS OF THE SEA-ICE-VAP ITERATION
integer :: &
ctrl_initialized, ctrl_mode_salinity, &
ctrl_mode_temperature, ctrl_mode_pressure, &
ctrl_mode_liquid, ctrl_mode_vapour

real*8 :: ctrl_init_s, ctrl_init_t, ctrl_init_p, ctrl_init_d_liq, &  
  ctrl_init_d_vap, ctrl_eps_exit_t, ctrl_eps_exit_p 

!PROPERTIES OF THE CURRENT SEA-ICE-VAPOUR EQUILIBRIUM STATE
integer :: equi_sea_ice_vap_done  !FLAG = ISOK IF EQUILIBRIUM WAS SUCCESSFULLY COMPUTED

real*8 :: equi_sea_ice_vap_t, equi_sea_ice_vap_p, equi_sea_ice_vap_s, &  
  equi_sea_ice_vap_d_liq, equi_sea_ice_vap_d_vap 

contains

!==========================================================================
function set_sea_ice_vap_eq_at_s(sa_si)
!==========================================================================

!THIS FUNCTION COMPUTES THE SEA-ICE-VAPOUR EQUILIBRIUM AT GIVEN SALINITY SA_SI IN KG/KG
!BY NEWTON ITERATION

real*8 :: set_sea_ice_vap_eq_at_s, sa_si
real*8 :: tt, pt, dt_liq, dt_vap
real*8 :: t, p, dl, dv, eps
integer maxit

tt = tp_temperature_si
pt = tp_pressure_iapws95_si
dt_liq = tp_density_liq_iapws95_si  !TRIPLE POINT DENSITY OF LIQUID WATER
dt_vap = tp_density_vap_iapws95_si  !TRIPLE POINT DENSITY OF WATER VAPOUR

if (equi_sea_ice_vap_done == isok .and. &
   sa_si == equi_sea_ice_vap_s) then
  !the requested state has already been computed earlier
  set_sea_ice_vap_eq_at_s = isok
  return
end if

call clear_sea_ice_vap_state !waste any previous state

set_sea_ice_vap_eq_at_s = errorreturn

if (sa_si < 0d0) return
if (sa_si >= 1d0) return

if (sa_si == 0) then  !PURE WATER: SET IAPWS-95 TRIPLE POINT
  call set_sea_ice_vap_state(sa_si, tt, pt, dt_vap, dt_liq)
  set_sea_ice_vap_eq_at_s = isok
  return
end if

call init_it_ctrl_sea_ice_vap

!SET INITIAL TEMPERATURE GUESS
select case(ctrl_mode_temperature)
  case (0);  t = aux_temperature_si(sa_si)
  case (-1); t = tt
  case (1);  t = ctrl_init_t
  case default; return
end select
if (t <= 0) return
if (t == errorreturn) return

!SET INITIAL PRESSURE GUESS
select case(ctrl_mode_pressure)
  case (0);  p = aux_pressure_si(sa_si)
  case (-1); p = pt
  case (1);  p = ctrl_init_p
  case default; return
end select
if (p <= 0d0) return
if (p == errorreturn) return

!SET INITIAL LIQUID DENSITY GUESS
select case(ctrl_mode_liquid)
  case (0);  dl = dt_liq
  case (-1); dl = dt_liq
  case (1);  dl = ctrl_init_d_liq
  case default; return
end select
if (dl <= 0d0) return
if (dl == errorreturn) return

!SET INITIAL VAPOUR DENSITY GUESS
select case(ctrl_mode_vapour)
  case (0);  dv = aux_density_ideal_si(t, p)
  case (-1); dv = dt_vap
  case (1);  dv = ctrl_init_d_vap
  case default; return
end select
if (dv <= 0d0) return
if (dv == errorreturn) return

!SET MAX. ITERATION NUMBER
select case(ctrl_loop_maximum)
  case (0); maxit = 100
  case (-1); call set_sea_ice_vap_state(sa_si, t, p, dv, dl)
           set_sea_ice_vap_eq_at_s = isok
           return
  case (1:); maxit = ctrl_loop_maximum
  case default; return
end select

!SET ITERATION ACCURACY LIMIT
eps = ctrl_eps_exit_t
if (eps == 0d0) return

!RUN ITERATION LOOP
if (sea_ice_vap_iteration_at_s(sa_si, maxit, eps, t, p, dv, dl) &
   == errorreturn) return

call set_sea_ice_vap_state(sa_si, t, p, dv, dl)

set_sea_ice_vap_eq_at_s = isok

end function

!==========================================================================
function set_sea_ice_vap_eq_at_t(t_si)
!==========================================================================

!THIS FUNCTION COMPUTES THE SEA-ICE-VAPOUR EQUILIBRIUM AT GIVEN ABSOLUTE TEMPERATURE T_SI IN K
!BY NEWTON ITERATION

real*8 :: set_sea_ice_vap_eq_at_t, t_si
real*8 :: tt, pt, dt_liq, dt_vap
real*8 :: s, p, dl, dv, eps
integer :: maxit

tt = tp_temperature_si
pt = tp_pressure_iapws95_si
dt_liq = tp_density_liq_iapws95_si  !TRIPLE POINT DENSITY OF LIQUID WATER
dt_vap = tp_density_vap_iapws95_si  !TRIPLE POINT DENSITY OF WATER VAPOUR
!

if (equi_sea_ice_vap_done == isok .and. &
  t_si == equi_sea_ice_vap_t) then
  !the requested state has already been computed earlier
  set_sea_ice_vap_eq_at_t = isok
  return
end if

call clear_sea_ice_vap_state !waste any previous state

set_sea_ice_vap_eq_at_t = errorreturn

if (t_si <= 0d0) return
if (t_si > tt) return

if (t_si == tt) then  !pure water: set iapws-95 triple point
  call set_sea_ice_vap_state(0d0, tt, pt, dt_vap, dt_liq)
  set_sea_ice_vap_eq_at_t = isok
  return
end if

call init_it_ctrl_sea_ice_vap

!SET INITIAL SALINITY GUESS
select case(ctrl_mode_salinity)
  case (0);  s = aux_salinity_of_t_si(t_si)
  case (-1); s = so_salinity_si
  case (1);  s = ctrl_init_s
  case default; return
end select
if (s <= 0d0 .or. s >= 1d0) return
if (s == errorreturn) return

!SET INITIAL PRESSURE GUESS
select case(ctrl_mode_pressure)
  case (0);  p = aux_pressure_si(s)
  case (-1); p = pt
  case (1);  p = ctrl_init_p
  case default; return
end select
if (p <= 0d0) return
if (p == errorreturn) return

!SET INITIAL LIQUID DENSITY GUESS
select case(ctrl_mode_liquid)
  case (0);  dl = dt_liq
  case (-1); dl = dt_liq
  case (1);  dl = ctrl_init_d_liq
  case default; return
end select
if (dl <= 0d0) return
if (dl == errorreturn) return

!SET INITIAL VAPOUR DENSITY GUESS
select case(ctrl_mode_vapour)
  case (0);  dv = aux_density_ideal_si(t_si, p)
  case (-1); dv = dt_vap
  case (1);  dv = ctrl_init_d_vap
  case default; return
end select
if (dv <= 0d0) return
if (dv == errorreturn) return

!SET MAX. ITERATION NUMBER
select case(ctrl_loop_maximum)
  case (0); maxit = 100
  case (-1); call set_sea_ice_vap_state(s, t_si, p, dv, dl)
             set_sea_ice_vap_eq_at_t = isok
             return
  case (1:); maxit = ctrl_loop_maximum
  case default; return
end select

!SET ITERATION ACCURACY LIMIT
eps = ctrl_eps_exit_p
if (eps == 0d0) return

!RUN ITERATION LOOP
if (sea_ice_vap_iteration_at_t(t_si, maxit, eps, s, p, dv, dl) &
   == errorreturn) return

call set_sea_ice_vap_state(s, t_si, p, dv, dl)

set_sea_ice_vap_eq_at_t = isok

end function

!==========================================================================
function set_sea_ice_vap_eq_at_p(p_si)
!==========================================================================

!THIS FUNCTION COMPUTES THE SEA-ICE-VAPOUR EQUILIBRIUM AT GIVEN ABSOLUTE PRESSURE P_SI IN PA
!BY NEWTON ITERATION

real*8 :: set_sea_ice_vap_eq_at_p, p_si
real*8 :: tt, pt, dt_liq, dt_vap, s, t, dl, dv, eps
integer :: maxit

tt = tp_temperature_si
pt = tp_pressure_iapws95_si
dt_liq = tp_density_liq_iapws95_si  !TRIPLE POINT DENSITY OF LIQUID WATER
dt_vap = tp_density_vap_iapws95_si  !TRIPLE POINT DENSITY OF WATER VAPOUR

if (equi_sea_ice_vap_done == isok .and. &
   p_si == equi_sea_ice_vap_p) then
  !THE REQUESTED STATE HAS ALREADY BEEN COMPUTED EARLIER
  set_sea_ice_vap_eq_at_p = isok
  return
end if

call clear_sea_ice_vap_state !waste any previous state

set_sea_ice_vap_eq_at_p = errorreturn

if (p_si <= 0d0) return
if (p_si > pt) return

if (p_si == pt) then  !pure water: set iapws-95 triple point
  call set_sea_ice_vap_state(0d0, tt, pt, dt_vap, dt_liq)
  set_sea_ice_vap_eq_at_p = isok
  return
end if

call init_it_ctrl_sea_ice_vap

!SET INITIAL SALINITY GUESS
select case(ctrl_mode_salinity)
  case (0);  s = aux_salinity_of_p_si(p_si)
  case (-1); s = so_salinity_si
  case (1);  s = ctrl_init_s
  case default; return
end select
if (s <= 0d0 .or. s >= 1d0) return
if (s == errorreturn) return

!SET INITIAL TEMPERATURE GUESS
select case(ctrl_mode_temperature)
  case (0);  t = aux_temperature_si(s)
  case (-1); t = tt
  case (1);  t = ctrl_init_t
  case default; return
end select
if (t <= 0d0) return
if (t == errorreturn) return

!SET INITIAL LIQUID DENSITY GUESS
select case(ctrl_mode_liquid)
  case (0);  dl = dt_liq
  case (-1); dl = dt_liq
  case (1);  dl = ctrl_init_d_liq
  case default; return
end select
if (dl <= 0d0) return
if (dl == errorreturn) return

!SET INITIAL VAPOUR DENSITY GUESS
select case(ctrl_mode_vapour)
  case (0);  dv = aux_density_ideal_si(t, p_si)
  case (-1); dv = dt_vap
  case (1);  dv = ctrl_init_d_vap
  case default; return
end select
if (dv <= 0d0) return
if (dv == errorreturn) return

!SET MAX. ITERATION NUMBER
select case(ctrl_loop_maximum)
  case (0); maxit = 100
  case (-1); call set_sea_ice_vap_state(s, t, p_si, dv, dl)
           set_sea_ice_vap_eq_at_p = isok
           return
  case (1:); maxit = ctrl_loop_maximum
  case default; return
end select

!SET ITERATION ACCURACY LIMIT
eps = ctrl_eps_exit_t
if (eps == 0d0) return

!RUN ITERATION LOOP
if (sea_ice_vap_iteration_at_p(p_si, maxit, eps, s, t, dv, dl) &
   == errorreturn) return

call set_sea_ice_vap_state(s, t, p_si, dv, dl)

set_sea_ice_vap_eq_at_p = isok

end function

!==========================================================================
function sea_ice_vap_salinity_si()
!==========================================================================

!THIS FUNCTION RETURNS THE ABSOLUTE BRINE SALINITY IN KG/KG OF SEA ICE AT EQUILIBRIUM WITH VAPOUR,
!SET BY A PREVIOUS CALL OF EITHER SET_SEA_ICE_VAP_EQUILIBRIUM_TO_S,
!SET_SEA_ICE_VAP_EQUILIBRIUM_TO_T OR SET_SEA_ICE_VAP_EQUILIBRIUM_TO_P

!CHECK VALUES WITH DEFAULT SETTINGS:
!SET_SEA_ICE_VAP_EQ_AT_S 0.035
!SEA_ICE_VAP_SALINITY_SI = 0.035

!SET_SEA_ICE_VAP_EQ_AT_T 270
!SEA_ICE_VAP_SALINITY_SI = 5.61489288506E-02

!SET_SEA_ICE_VAP_EQ_AT_P 500
!SEA_ICE_VAP_SALINITY_SI = 4.38955878828E-02

!NOTE: THE ACCURACY OF THIS FUNCTION DEPENDS ON THE ITERATION SETTINGS IN THIS MODULE

real*8 :: sea_ice_vap_salinity_si

sea_ice_vap_salinity_si = errorreturn

if (equi_sea_ice_vap_done /= isok) return

sea_ice_vap_salinity_si = equi_sea_ice_vap_s

end function

!==========================================================================
function sea_ice_vap_density_vap_si()
!==========================================================================

!THIS FUNCTION RETURNS THE VAPOUR DENSITY IN KG M-3 OF SEA ICE AT EQUILIBRIUM WITH VAPOUR,
!SET BY A PREVIOUS CALL OF EITHER SET_SEA_ICE_VAP_EQUILIBRIUM_TO_S,
!SET_SEA_ICE_VAP_EQUILIBRIUM_TO_T OR SET_SEA_ICE_VAP_EQUILIBRIUM_TO_P

!CHECK VALUES WITH DEFAULT SETTINGS:
!SET_SEA_ICE_VAP_EQ_AT_S 0.035
!SEA_ICE_VAP_DENSITY_VAP_SI = 4.17156419318E-03

!SET_SEA_ICE_VAP_EQ_AT_T 270
!SEA_ICE_VAP_DENSITY_VAP_SI = 3.77406140772E-03

!SET_SEA_ICE_VAP_EQ_AT_P 500
!SEA_ICE_VAP_DENSITY_VAP_SI = 4.00364833230E-03

!NOTE: THE ACCURACY OF THIS FUNCTION DEPENDS ON THE ITERATION SETTINGS IN THIS MODULE

real*8 :: sea_ice_vap_density_vap_si

sea_ice_vap_density_vap_si = errorreturn

if (equi_sea_ice_vap_done /= isok) return

sea_ice_vap_density_vap_si = equi_sea_ice_vap_d_vap

end function

!==========================================================================
function sea_ice_vap_temperature_si()
!==========================================================================

!THIS FUNCTION RETURNS THE ABSOLUTE TEMPERATURE IN K OF SEA ICE AT EQUILIBRIUM WITH VAPOUR,
!SET BY A PREVIOUS CALL OF EITHER SET_SEA_ICE_VAP_EQUILIBRIUM_TO_S,
!SET_SEA_ICE_VAP_EQUILIBRIUM_TO_T OR SET_SEA_ICE_VAP_EQUILIBRIUM_TO_P

!NOTE: THE ACCURACY OF THIS FUNCTION DEPENDS ON THE ITERATION SETTINGS IN THIS MODULE

!CHECK VALUES WITH DEFAULT SETTINGS:
!SET_SEA_ICE_VAP_EQ_AT_S 0.035
!SEA_ICE_VAP_TEMPERATURE_SI = 271.247815057

!SET_SEA_ICE_VAP_EQ_AT_T 270
!SEA_ICE_VAP_TEMPERATURE_SI = 270

!SET_SEA_ICE_VAP_EQ_AT_P 500
!SEA_ICE_VAP_TEMPERATURE_SI = 270.734430917

real*8 :: sea_ice_vap_temperature_si

sea_ice_vap_temperature_si = errorreturn

if (equi_sea_ice_vap_done /= isok) return

sea_ice_vap_temperature_si = equi_sea_ice_vap_t

end function

!==========================================================================
function sea_ice_vap_pressure_si()
!==========================================================================

!THIS FUNCTION RETURNS THE ABSOLUTE PRESSURE IN PA OF SEA ICE AT EQUILIBRIUM WITH VAPOUR,
!SET BY A PREVIOUS CALL OF EITHER SET_SEA_ICE_VAP_EQUILIBRIUM_TO_S,
!SET_SEA_ICE_VAP_EQUILIBRIUM_TO_T OR SET_SEA_ICE_VAP_EQUILIBRIUM_TO_P

!CHECK VALUES WITH DEFAULT SETTINGS:
!SET_SEA_ICE_VAP_EQ_AT_S 0.035
!SEA_ICE_VAP_PRESSURE_SI = 521.950349225

!SET_SEA_ICE_VAP_EQ_AT_T 270
!SEA_ICE_VAP_PRESSURE_SI = 470.059067981

!SET_SEA_ICE_VAP_EQ_AT_P 500
!SEA_ICE_VAP_PRESSURE_SI = 500

!NOTE: THE ACCURACY OF THIS FUNCTION DEPENDS ON THE ITERATION SETTINGS IN THIS MODULE

real*8 :: sea_ice_vap_pressure_si

sea_ice_vap_pressure_si = errorreturn

if (equi_sea_ice_vap_done /= isok) return

sea_ice_vap_pressure_si = equi_sea_ice_vap_p

end function

!==========================================================================
function sea_ice_vap_iteration_at_s(sa_si, maxit, eps, t_si, &
                                    p_si, d_vap_si, d_liq_si)
!==========================================================================

!THIS FUNCTION COMPUTES THE SEAWATER-ICE-VAPOUR PHASE EQUILIBRIUM FROM
!EQUAL CHEMICAL POTENTIALS OF WATER AT GIVEN SALINITY, SA_SI,
!FROM INITIAL GUESSES FOR THE TEMPERATURE, T_SI, PRESSURE, P_SI,
!THE VAPOUR DENSITY, DVAP_SI AND THE LIQUID DENSITY, DLIQ_SI.
!THE ITERATION LIMIT EPS REFERS TO THE ERROR IN TEMPERATURE.

!OUTPUT: 
!        SEA_ICE_VAP_ITERATION_AT_S = ISOK IF SUCCESSFULLY DONE
!        SEA_ICE_VAP_ITERATION_AT_S = ERRORRETURN IS RETURNED IF
!        - THE MAXIMUM NUMBER OF ITERATIONS IS EXCEEDED WITHOUT MEETING THE EXIT CRITERION
!        - THE FUNCTION CALL TO A GIBBS/HELMHOLTZ FUNCTION HAS RETURNED AN ERROR
!        - DENSITY, TEMPERATURE OR PRESSURE HAVE TAKEN A ZERO OR NEGATIVE VALUE DURING THE ITERATION
!        - S-T-P VALUES DO NOT PERMIT THE STABLE EXISTENCE OF ICE
!  T_SI: TEMPERATURE IN K OF THE SEAWATER-ICE EQUILIBRIUM
!  P_SI: PRESSURE IN PA OF THE SEAWATER-ICE EQUILIBRIUM
!  DVAP_SI: DENSITY OF VAPOUR IN KG/M3 AT (T_SI, P_SI)
!  DLIQ_SI: DENSITY OF LIQUID IN KG/M3 AT (T_SI, P_SI)

!INPUT: 
!       SA_SI: ABSOLUTE SALINITY IN KG/KG
!       MAXIT: MAXIMUM NUMBER OF ITERATION STEPS TO BE DONE
!         EPS: REQUIRED ACCURACY OF TEMPERATURE
!              EPS > 0: ABSOLUTE TEMPERATURE TOLERANCE IN K
!              EPS < 0: RELATIVE TEMPERATURE TOLERANCE
!        T_SI: INITIAL GUESS FOR ABSOLUTE (FREEZING) TEMPERATURE IN K
!        P_SI: INITIAL GUESS FOR ABSOLUTE PRESSURE IN PA
!        DVAP_SI: INITIAL GUESS FOR DENSITY OF VAPOUR IN KG/M3 AT (T_SI, P_SI)
!        DLIQ_SI: INITIAL GUESS FOR DENSITY OF LIQUID IN KG/M3 AT (T_SI, P_SI)

real*8 :: sea_ice_vap_iteration_at_s, sa_si, eps, t_si, p_si, d_vap_si, d_liq_si
real*8 :: dv, dl, t, p, ddv, ddl, dt, dp, gi, gi_t, gi_p, &
       gs, gs_s, gs_t, gs_st, gs_p, gs_sp, fv, fv_t, fv_td, &
       fv_d, fv_dd, fl, fl_t, fl_td, fl_d, fl_dd
real*8 :: a(4, 4), b(4), x(4)
integer :: maxit, it

sea_ice_vap_iteration_at_s = errorreturn

if(d_vap_si <= 0d0 .or. &
  d_liq_si <= 0d0 .or. &
  t_si <= 0d0 .or. &
  p_si <= 0d0) then
  t_si = errorreturn
  p_si = errorreturn
  d_liq_si = errorreturn 
  d_vap_si = errorreturn
  return
endif

if(check_limits == 1) then
  !SAL_LIMITS
  if(sa_si < sal_smin .or. sa_si > sal_smax) then
    t_si = errorreturn
    p_si = errorreturn
    d_liq_si = errorreturn 
    d_vap_si = errorreturn
    return
  endif
else
  if ((sa_si <= 0d0) .or. (sa_si >= 1d0)) then
    t_si = errorreturn
    p_si = errorreturn
    d_liq_si = errorreturn 
    d_vap_si = errorreturn
    return
  endif
endif

check_limits = check_limits - 1

t = t_si
p = p_si
dl = d_liq_si
dv = d_vap_si

do it = 1, maxit

  !DERIVATIVES OF THE HELMHOLTZ FUNCTION OF WATER VAPOUR FOR 4D NEWTON ITERATION
  fv = flu_f_si(0, 0, t, dv)
  if (fv == errorreturn) go to 999
  fv_t = flu_f_si(1, 0, t, dv)
  if (fv_t == errorreturn) go to 999
  fv_d = flu_f_si(0, 1, t, dv)
  if (fv_d == errorreturn) go to 999
  fv_td = flu_f_si(1, 1, t, dv)
  if (fv_td == errorreturn) go to 999
  fv_dd = flu_f_si(0, 2, t, dv)
  if (fv_dd == errorreturn) go to 999

  !DERIVATIVES OF THE HELMHOLTZ FUNCTION OF LIQUID WATER FOR NEWTON ITERATION
  fl = flu_f_si(0, 0, t, dl)
  if (fl == errorreturn) go to 999
  fl_t = flu_f_si(1, 0, t, dl)
  if (fl_t == errorreturn) go to 999
  fl_d = flu_f_si(0, 1, t, dl)
  if (fl_d == errorreturn) go to 999
  fl_td = flu_f_si(1, 1, t, dl)
  if (fl_td == errorreturn) go to 999
  fl_dd = flu_f_si(0, 2, t, dl)
  if (fl_dd == errorreturn) go to 999

  !DERIVATIVES OF THE GIBBS FUNCTION OF ICE FOR NEWTON ITERATION
  gi = ice_g_si(0, 0, t, p)
  if (gi == errorreturn) go to 999
  gi_t = ice_g_si(1, 0, t, p)
  if (gi_t == errorreturn) go to 999
  gi_p = ice_g_si(0, 1, t, p)
  if (gi_p == errorreturn) go to 999

  !DERIVATIVES OF THE SALINE GIBBS FUNCTION FOR NEWTON ITERATION
  gs = sal_g_si(0, 0, 0, sa_si, t, p)
  if (gs == errorreturn) go to 999
  gs_s = sal_g_si(1, 0, 0, sa_si, t, p)
  if (gs_s == errorreturn) go to 999
  gs_t = sal_g_si(0, 1, 0, sa_si, t, p)
  if (gs_t == errorreturn) go to 999
  gs_st = sal_g_si(1, 1, 0, sa_si, t, p)
  if (gs_st == errorreturn) go to 999
  gs_p = sal_g_si(0, 0, 1, sa_si, t, p)
  if (gs_p == errorreturn) go to 999
  gs_sp = sal_g_si(1, 0, 1, sa_si, t, p)
  if (gs_sp == errorreturn) go to 999

  !COEFFICIENT MATRIX
  a(1, 1) = -fl_t - dl * fl_td + fv_t + dv * fv_td - gs_t + sa_si * gs_st
  a(1, 2) = -gs_p + sa_si * gs_sp
  a(1, 3) = 2d0 * fv_d + dv * fv_dd
  a(1, 4) = -2d0 * fl_d - dl * fl_dd
  a(2, 1) = fv_t + dv * fv_td - gi_t
  a(2, 2) = -gi_p
  a(2, 3) = 2d0 * fv_d + dv * fv_dd
  a(2, 4) = 0d0
  a(3, 1) = -dv * fv_td
  a(3, 2) = 1d0 / dv
  a(3, 3) = -2d0 * fv_d - dv * fv_dd
  a(3, 4) = 0d0
  a(4, 1) = -dl * fl_td
  a(4, 2) = 1d0 / dl
  a(4, 3) = 0d0
  a(4, 4) = -2d0 * fl_d - dl * fl_dd

  !RIGHT-HAND SIDES, MUST VANISH AT EQUILIBRIUM
  b(1) = fl + dl * fl_d - fv - dv * fv_d + gs - sa_si * gs_s
  b(2) = gi - fv - dv * fv_d
  b(3) = dv * fv_d - p / dv
  b(4) = dl * fl_d - p / dl

  !SOLVE EQUATIONS
  if (matrix_solve(a, b, x, 4) /= 0) go to 999 !MATRIX SINGULAR
  dt = x(1)
  dp = x(2)
  ddv = x(3)
  ddl = x(4)
  
  !UPDATE UNKNOWNS
  dv = dv + ddv
  if (dv <= 0d0) go to 999
  dl = dl + ddl
  if (dl <= 0d0) go to 999
  t = t + dt
  if (t <= 0d0) go to 999
  p = p + dp
  if (p <= 0d0) go to 999
  
  !CHECK ABSOLUTE OR RELATIVE ERROR LIMIT
  if ((eps > 0d0 .and. abs(dt) < eps) .or. &
     (eps < 0d0 .and. abs(dt) < -eps * abs(t))) then
    sea_ice_vap_iteration_at_s = isok
    t_si = t
    p_si = p
    d_vap_si = dv
    d_liq_si = dl
    go to 999
  end if

enddo

999 continue

check_limits = check_limits + 1

if(check_limits == 1) then
  !FLU_LIMITS
  if(t_si < flu_tmin .or. t_si > flu_tmax .or. &
  d_liq_si <= flu_dmin .or. d_liq_si > flu_dmax) then
    t_si = errorreturn
    p_si = errorreturn
    d_liq_si = errorreturn
    d_vap_si = errorreturn
    sea_ice_vap_iteration_at_s = errorreturn
    return
  endif
  !SAL_LIMITS
  if(t_si < sal_tmin .or. t_si > sal_tmax .or. &
  sa_si < sal_smin .or. sa_si > sal_smax) then
    t_si = errorreturn
    p_si = errorreturn
    d_liq_si = errorreturn
    d_vap_si = errorreturn
    sea_ice_vap_iteration_at_s = errorreturn
    return
  endif
endif

end function

!==========================================================================
function sea_ice_vap_iteration_at_t(t_si, maxit, eps, sa_si, &
                                    p_si, d_vap_si, d_liq_si)
!==========================================================================

!THIS FUNCTION COMPUTES THE SEAWATER-ICE-VAPOUR PHASE EQUILIBRIUM FROM
!EQUAL CHEMICAL POTENTIALS OF WATER AT GIVEN TEMPERATURE, T_SI,
!FROM INITIAL GUESSES FOR THE SALINITY, SA_SI, PRESSURE, P_SI,
!THE VAPOUR DENSITY, DVAP_SI AND THE LIQUID DENSITY, DLIQ_SI.
!THE ITERATION LIMIT EPS REFERS TO THE ERROR IN PRESSURE.

!OUTPUT: 
!        SEA_ICE_VAP_ITERATION_AT_T = ISOK IF SUCCESSFULLY DONE
!        SEA_ICE_VAP_ITERATION_AT_T = ERRORRETURN IS RETURNED IF
!        - THE MAXIMUM NUMBER OF ITERATIONS IS EXCEEDED WITHOUT MEETING THE EXIT CRITERION
!        - THE FUNCTION CALL TO A GIBBS/HELMHOLTZ FUNCTION HAS RETURNED AN ERROR
!        - DENSITY, SALNITY OR PRESSURE HAVE TAKEN A ZERO OR NEGATIVE VALUE DURING THE ITERATION
!        - S-T-P VALUES DO NOT PERMIT THE STABLE EXISTENCE OF ICE
!  SA_SI: ABSOLUTE SALINITY IN KG/KG AT THE SEAWATER-ICE EQUILIBRIUM
!  P_SI:  ABSOLUTE PRESSURE IN PA AT THE SEAWATER-ICE EQUILIBRIUM
!  DVAP_SI: DENSITY OF VAPOUR IN KG/M3 AT (T_SI, P_SI)
!  DLIQ_SI: DENSITY OF LIQUID IN KG/M3 AT (T_SI, P_SI)

!INPUT:  
!        T_SI: ABSOLUTE TEMPERATURE IN K
!       MAXIT: MAXIMUM NUMBER OF ITERATION STEPS TO BE DONE
!         EPS: REQUIRED ACCURACY OF PRESSURE
!              EPS > 0: ABSOLUTE PRESSURE TOLERANCE IN K
!              EPS < 0: RELATIVE PRESSURE TOLERANCE
!       SA_SI: INITIAL GUESS FOR ABSOLUTE SALINITY IN KG/KG
!        P_SI: INITIAL GUESS FOR ABSOLUTE PRESSURE IN PA
!        DVAP_SI: INITIAL GUESS FOR DENSITY OF WATER VAPOUR IN KG/M3 AT (T_SI, P_SI)
!        DLIQ_SI: INITIAL GUESS FOR DENSITY OF LIQUID WATER IN KG/M3 AT (T_SI, P_SI)

real*8 :: sea_ice_vap_iteration_at_t, t_si, eps, sa_si, p_si, d_vap_si, d_liq_si
real*8 :: dv, dl, s, p, ddv, ddl, ds, dp, &
          gi, gi_p, gs, gs_s, gs_ss, gs_p, gs_sp, &
          fv, fv_d, fv_dd, fl, fl_d, fl_dd
real*8 :: a(4, 4), b(4), x(4)
integer :: maxit, it

sea_ice_vap_iteration_at_t = errorreturn

if(d_vap_si <= 0d0 .or. &
  d_liq_si <= 0d0 .or. &
  p_si <= 0d0 .or. &
  sa_si <= 0d0 .or. sa_si >= 1d0) then
  sa_si = errorreturn
  p_si = errorreturn
  d_liq_si = errorreturn
  d_vap_si = errorreturn
  return
endif

if(check_limits == 1) then
  !FLU_LIMITS
  if(t_si < flu_tmin .or. t_si > flu_tmax) then
    sa_si = errorreturn
    p_si = errorreturn
    d_liq_si = errorreturn
    d_vap_si = errorreturn
    return
  endif
else
  if (t_si <= 0d0) then
    sa_si = errorreturn
    p_si = errorreturn
    d_liq_si = errorreturn
    d_vap_si = errorreturn
    return
  endif
endif

check_limits = check_limits - 1

s = sa_si
p = p_si
dl = d_liq_si
dv = d_vap_si

do it = 1, maxit

  !DERIVATIVES OF THE HELMHOLTZ FUNCTION OF WATER VAPOUR FOR 4D NEWTON ITERATION
  fv = flu_f_si(0, 0, t_si, dv)
  if (fv == errorreturn) go to 999
  fv_d = flu_f_si(0, 1, t_si, dv)
  if (fv_d == errorreturn) go to 999
  fv_dd = flu_f_si(0, 2, t_si, dv)
  if (fv_dd == errorreturn) go to 999

  !DERIVATIVES OF THE HELMHOLTZ FUNCTION OF LIQUID WATER FOR NEWTON ITERATION
  fl = flu_f_si(0, 0, t_si, dl)
  if (fl == errorreturn) go to 999
  fl_d = flu_f_si(0, 1, t_si, dl)
  if (fl_d == errorreturn) go to 999
  fl_dd = flu_f_si(0, 2, t_si, dl)
  if (fl_dd == errorreturn) go to 999

  !DERIVATIVES OF THE GIBBS FUNCTION OF ICE FOR NEWTON ITERATION
  gi = ice_g_si(0, 0, t_si, p)
  if (gi == errorreturn) go to 999
  gi_p = ice_g_si(0, 1, t_si, p)
  if (gi_p == errorreturn) go to 999

  !DERIVATIVES OF THE SALINE GIBBS FUNCTION FOR NEWTON ITERATION
  gs = sal_g_si(0, 0, 0, s, t_si, p)
  if (gs == errorreturn) go to 999
  gs_s = sal_g_si(1, 0, 0, s, t_si, p)
  if (gs_s == errorreturn) go to 999
  gs_ss = sal_g_si(2, 0, 0, s, t_si, p)
  if (gs_ss == errorreturn) go to 999
  gs_p = sal_g_si(0, 0, 1, s, t_si, p)
  if (gs_p == errorreturn) go to 999
  gs_sp = sal_g_si(1, 0, 1, s, t_si, p)
  if (gs_sp == errorreturn) go to 999

  !COEFFICIENT MATRIX
  a(1, 1) = s * gs_ss
  a(1, 2) = -gs_p + s * gs_sp
  a(1, 3) = 2d0 * fv_d + dv * fv_dd
  a(1, 4) = -2d0 * fl_d - dl * fl_dd
  a(2, 1) = 0d0
  a(2, 2) = -gi_p
  a(2, 3) = 2d0 * fv_d + dv * fv_dd
  a(2, 4) = 0d0
  a(3, 1) = 0d0
  a(3, 2) = 1d0 / dv
  a(3, 3) = -2d0 * fv_d - dv * fv_dd
  a(3, 4) = 0d0
  a(4, 1) = 0d0
  a(4, 2) = 1d0 / dl
  a(4, 3) = 0d0
  a(4, 4) = -2d0 * fl_d - dl * fl_dd

  !RIGHT-HAND SIDES, MUST VANISH AT EQUILIBRIUM
  b(1) = fl + dl * fl_d - fv - dv * fv_d + gs - s * gs_s
  b(2) = gi - fv - dv * fv_d
  b(3) = dv * fv_d - p / dv
  b(4) = dl * fl_d - p / dl

  !SOLVE EQUATIONS
  if (matrix_solve(a, b, x, 4) /= 0) go to 999 !MATRIX SINGULAR
  ds = x(1)
  dp = x(2)
  ddv = x(3)
  ddl = x(4)
  
  !UPDATE UNKNOWNS
  dv = dv + ddv
  if (dv <= 0d0) go to 999
  dl = dl + ddl
  if (dl <= 0d0) go to 999
  s = s + ds
  if (s <= 0d0) go to 999
  if (s >= 1d0) go to 999
  p = p + dp
  if (p <= 0d0) go to 999
  
  !CHECK ABSOLUTE OR RELATIVE ERROR LIMIT
  if ((eps > 0d0 .and. abs(dp) < eps) .or. &
     (eps < 0d0 .and. abs(dp) < -eps * abs(p))) then
    sea_ice_vap_iteration_at_t = isok
    sa_si = s
    p_si = p
    d_vap_si = dv
    d_liq_si = dl
    go to 999
  end if

enddo

999 continue

check_limits = check_limits + 1

if(check_limits == 1) then
  !FLU_LIMITS
  if(d_liq_si <= flu_dmin .or. d_liq_si > flu_dmax) then
    sa_si = errorreturn
    p_si = errorreturn
    d_liq_si = errorreturn
    d_vap_si = errorreturn
    sea_ice_vap_iteration_at_t = errorreturn
    return
  endif
  !SAL_LIMITS
  if(sa_si < sal_smin .or. sa_si > sal_smax .or. &
  p_si < sal_pmin .or. p_si > sal_pmax) then
    sa_si = errorreturn
    p_si = errorreturn
    d_liq_si = errorreturn
    d_vap_si = errorreturn
    sea_ice_vap_iteration_at_t = errorreturn
    return
  endif
endif

end function

!==========================================================================
function sea_ice_vap_iteration_at_p(p_si, maxit, eps, sa_si, t_si, &
                                            d_vap_si, d_liq_si)
!==========================================================================

!THIS FUNCTION COMPUTES THE SEAWATER-ICE-VAPOUR PHASE EQUILIBRIUM FROM
!EQUAL CHEMICAL POTENTIALS OF WATER AT GIVEN PRESSURE, P_SI,
!FROM INITIAL GUESSES FOR THE SALINITY, SA_SI, TEMPERATURE, T_SI,
!THE VAPOUR DENSITY, DVAP_SI AND THE LIQUID DENSITY, DLIQ_SI.
!THE ITERATION LIMIT EPS REFERS TO THE ERROR IN TEMPERATURE.

!OUTPUT: 
!        SEA_ICE_VAP_ITERATION_AT_P = ISOK IF SUCCESSFULLY DONE
!        SEA_ICE_VAP_ITERATION_AT_P = ERRORRETURN IS RETURNED IF
!        - THE MAXIMUM NUMBER OF ITERATIONS IS EXCEEDED WITHOUT MEETING THE EXIT CRITERION
!        - THE FUNCTION CALL TO A GIBBS/HELMHOLTZ FUNCTION HAS RETURNED AN ERROR
!        - DENSITY, SALNITY OR PRESSURE HAVE TAKEN A ZERO OR NEGATIVE VALUE DURING THE ITERATION
!        - S-T-P VALUES DO NOT PERMIT THE STABLE EXISTENCE OF ICE
!    SA_SI: ABSOLUTE SALINITY IN KG/KG AT THE SEAWATER-ICE EQUILIBRIUM
!     T_SI: ABSOLUTE TEMPERATURE IN K AT THE SEAWATER-ICE EQUILIBRIUM
!  DVAP_SI: DENSITY OF WATER VAPOUR IN KG/M3 AT (T_SI, P_SI)
!  DLIQ_SI: DENSITY OF LIQUID WATER IN KG/M3 AT (T_SI, P_SI)

!INPUT:  
!        P_SI: ABSOLUTE PRESSURE IN PA
!       MAXIT: MAXIMUM NUMBER OF ITERATION STEPS TO BE DONE
!         EPS: REQUIRED ACCURACY OF TEMPERATURE
!              EPS > 0: ABSOLUTE TEMPERATURE TOLERANCE IN K
!              EPS < 0: RELATIVE TEMPERATURE TOLERANCE
!       SA_SI: INITIAL GUESS FOR ABSOLUTE SALINITY IN KG/KG
!        T_SI: INITIAL GUESS FOR ABSOLUTE TEMPERATURE IN K
!     DVAP_SI: INITIAL GUESS FOR DENSITY OF WATER VAPOUR IN KG/M3 AT (T_SI, P_SI)
!     DLIQ_SI: INITIAL GUESS FOR DENSITY OF LIQUID WATER IN KG/M3 AT (T_SI, P_SI)

real*8 :: sea_ice_vap_iteration_at_p, p_si, eps, sa_si, t_si, d_vap_si, d_liq_si
real*8 :: dv, dl, s, t, ddv, ddl, ds, dt, &
       gi, gi_t, gs, gs_s, gs_ss, gs_t, gs_st, &
       fv, fv_t, fv_td, fv_d, fv_dd, fl, fl_t, fl_td, fl_d, fl_dd
real*8 :: a(4, 4), b(4), x(4)
integer :: maxit, it

sea_ice_vap_iteration_at_p = errorreturn

if(d_vap_si <= 0d0 .or. &
  d_liq_si <= 0d0 .or. &
  t_si <= 0d0 .or. &
  sa_si <= 0d0 .or. sa_si >= 1d0) then
  sa_si = errorreturn
  t_si = errorreturn
  d_liq_si = errorreturn
  d_vap_si = errorreturn
  return
endif

if(check_limits == 1) then
  !SAL_LIMITS
  if(p_si < sal_pmin .or. p_si > sal_pmax) then
    sa_si = errorreturn
    t_si = errorreturn
    d_liq_si = errorreturn
    d_vap_si = errorreturn
    return
  endif
else
  if (p_si <= 0d0) then
    sa_si = errorreturn
    t_si = errorreturn
    d_liq_si = errorreturn
    d_vap_si = errorreturn
    return
  endif
endif

check_limits = check_limits - 1

s = sa_si
t = t_si
dl = d_liq_si
dv = d_vap_si

do it = 1, maxit

  !DERIVATIVES OF THE HELMHOLTZ FUNCTION OF WATER VAPOUR FOR 4D NEWTON ITERATION
  fv = flu_f_si(0, 0, t, dv)
  if (fv == errorreturn) go to 999
  fv_t = flu_f_si(1, 0, t, dv)
  if (fv_t == errorreturn) go to 999
  fv_d = flu_f_si(0, 1, t, dv)
  if (fv_d == errorreturn) go to 999
  fv_td = flu_f_si(1, 1, t, dv)
  if (fv_td == errorreturn) go to 999
  fv_dd = flu_f_si(0, 2, t, dv)
  if (fv_dd == errorreturn) go to 999

  !DERIVATIVES OF THE HELMHOLTZ FUNCTION OF LIQUID WATER FOR NEWTON ITERATION
  fl = flu_f_si(0, 0, t, dl)
  if (fl == errorreturn) go to 999
  fl_t = flu_f_si(1, 0, t, dl)
  if (fl_t == errorreturn) go to 999
  fl_d = flu_f_si(0, 1, t, dl)
  if (fl_d == errorreturn) go to 999
  fl_td = flu_f_si(1, 1, t, dl)
  if (fl_td == errorreturn) go to 999
  fl_dd = flu_f_si(0, 2, t, dl)
  if (fl_dd == errorreturn) go to 999

  !DERIVATIVES OF THE GIBBS FUNCTION OF ICE FOR NEWTON ITERATION
  gi = ice_g_si(0, 0, t, p_si)
  if (gi == errorreturn) go to 999
  gi_t = ice_g_si(1, 0, t, p_si)
  if (gi_t == errorreturn) go to 999

  !DERIVATIVES OF THE SALINE GIBBS FUNCTION FOR NEWTON ITERATION
  gs = sal_g_si(0, 0, 0, s, t, p_si)
  if (gs == errorreturn) go to 999
  gs_s = sal_g_si(1, 0, 0, s, t, p_si)
  if (gs_s == errorreturn) go to 999
  gs_ss = sal_g_si(2, 0, 0, s, t, p_si)
  if (gs_ss == errorreturn) go to 999
  gs_t = sal_g_si(0, 1, 0, s, t, p_si)
  if (gs_t == errorreturn) go to 999
  gs_st = sal_g_si(1, 1, 0, s, t, p_si)
  if (gs_st == errorreturn) go to 999

  !COEFFICIENT MATRIX
  a(1, 1) = s * gs_ss
  a(1, 2) = -fl_t - dl * fl_td + fv_t + dv * fv_td - gs_t + sa_si * gs_st
  a(1, 3) = 2d0 * fv_d + dv * fv_dd
  a(1, 4) = -2d0 * fl_d - dl * fl_dd
  a(2, 1) = 0d0
  a(2, 2) = fv_t + dv * fv_td - gi_t
  a(2, 3) = 2d0 * fv_d + dv * fv_dd
  a(2, 4) = 0d0
  a(3, 1) = 0d0
  a(3, 2) = -dv * fv_td
  a(3, 3) = -2d0 * fv_d - dv * fv_dd
  a(3, 4) = 0d0
  a(4, 1) = 0d0
  a(4, 2) = -dl * fl_td
  a(4, 3) = 0d0
  a(4, 4) = -2d0 * fl_d - dl * fl_dd

  !RIGHT-HAND SIDES, MUST VANISH AT EQUILIBRIUM
  b(1) = fl + dl * fl_d - fv - dv * fv_d + gs - s * gs_s
  b(2) = gi - fv - dv * fv_d
  b(3) = dv * fv_d - p_si / dv
  b(4) = dl * fl_d - p_si / dl

  !SOLVE EQUATIONS
  if (matrix_solve(a, b, x, 4) /= 0) go to 999 !MATRIX SINGULAR
  ds = x(1)
  dt = x(2)
  ddv = x(3)
  ddl = x(4)
  
  !UPDATE UNKNOWNS
  dv = dv + ddv
  if (dv <= 0d0) go to 999
  dl = dl + ddl
  if (dl <= 0d0) go to 999
  s = s + ds
  if (s <= 0d0) go to 999
  if (s >= 1d0) go to 999
  t = t + dt
  if (t <= 0d0) go to 999
  
  !CHECK ABSOLUTE OR RELATIVE ERROR LIMIT
  if ((eps > 0d0 .and. abs(dt) < eps) .or. &
     (eps < 0d0 .and. abs(dt) < -eps * abs(t))) then
    sea_ice_vap_iteration_at_p = isok
    sa_si = s
    t_si = t
    d_vap_si = dv
    d_liq_si = dl
    go to 999
  end if

enddo

999 continue

check_limits = check_limits + 1

if(check_limits == 1) then
  !FLU_LIMITS
  if(t_si < flu_tmin .or. t_si > flu_tmax .or. &
  d_liq_si <= flu_dmin .or. d_liq_si > flu_dmax) then
    sa_si = errorreturn
    t_si = errorreturn
    d_liq_si = errorreturn
    d_vap_si = errorreturn
    sea_ice_vap_iteration_at_p = errorreturn
    return
  endif
  !SAL_LIMITS
  if(t_si < sal_tmin .or. t_si > sal_tmax .or. &
  sa_si < sal_smin .or. sa_si > sal_smax) then
    sa_si = errorreturn
    t_si = errorreturn
    d_liq_si = errorreturn
    d_vap_si = errorreturn
    sea_ice_vap_iteration_at_p = errorreturn
    return
  endif
endif

end function

!==========================================================================
function aux_temperature_si(sa_si)
!==========================================================================

!FUNCTION RETURNS THE ESTIMATED FREEZING TEMPERATURE IN K AT GIVEN SALINITY IN KG/KG

real*8 :: aux_temperature_si, sa_si, tt

tt = tp_temperature_si

aux_temperature_si = tt - 60d0 * sa_si

end function

!==========================================================================
function aux_salinity_of_t_si(t_si)
!==========================================================================

!FUNCTION RETURNS THE ESTIMATED SALINITY IN KG/KG AT GIVEN TEMPERATURE IN K

real*8 :: aux_salinity_of_t_si, t_si, tt

tt = tp_temperature_si

aux_salinity_of_t_si = (tt - t_si) / 60d0

end function

!==========================================================================
function aux_pressure_si(sa_si)
!==========================================================================

!FUNCTION RETURNS THE ESTIMATED FREEZING PRESSURE IN PA AT GIVEN SALINITY IN KG/KG

real*8 :: aux_pressure_si, sa_si, pt

pt = tp_pressure_iapws95_si

aux_pressure_si = pt - 3000d0 * sa_si

end function

!==========================================================================
function aux_salinity_of_p_si(p_si)
!==========================================================================

!FUNCTION RETURNS THE ESTIMATED FREEZING SALINITY IN KG/KG AT GIVEN PRESSURE IN PA

real*8 :: aux_salinity_of_p_si, p_si, pt

pt = tp_pressure_iapws95_si

aux_salinity_of_p_si = (pt - p_si) / 3000d0

end function

!==========================================================================
function aux_density_ideal_si(t_si, p_si)
!==========================================================================

!FUNCTION RETURNS THE IDEAL-GAS DENSITY IN KG M-3 AT GIVEN
!ABSOLUTE TEMPERATURE IN K AND ABSOLUTE PRESSURE IN PA

real*8 :: aux_density_ideal_si, t_si, p_si, pt, rw

pt = tp_pressure_iapws95_si
rw = gas_constant_h2o_si

aux_density_ideal_si = errorreturn
if (t_si <= 0d0) return
if (p_si <= 0d0) return

aux_density_ideal_si = p_si / (rw * t_si)

end function

!==========================================================================
subroutine init_it_ctrl_sea_ice_vap()
!==========================================================================

real*8 :: s_norm, tt, pt, dlt, dvt

s_norm = so_salinity_si  !KG/KG OF KCL NORMALIZED SEAWATER
tt = tp_temperature_si
pt = tp_pressure_iapws95_si
dlt = tp_density_liq_iapws95_si  !TRIPLE POINT DENSITY OF LIQUID WATER
dvt = tp_density_vap_iapws95_si  !TRIPLE POINT DENSITY OF WATER VAPOUR

if (ctrl_initialized == isok) return

ctrl_initialized = isok

!SET DEFAULT VALUES AND MODES FOR THE ITERATION
ctrl_mode_liquid = 0
ctrl_mode_vapour = 0
ctrl_mode_salinity = 0
ctrl_mode_temperature = 0
ctrl_mode_pressure = 0
ctrl_loop_maximum = 100
ctrl_init_s = s_norm
ctrl_init_t = tt
ctrl_init_p = pt
ctrl_init_d_liq = dlt
ctrl_init_d_vap = dvt
!
ctrl_eps_exit_p = -0.0000001d0 !RELATIVE, 0.1 PPM
ctrl_eps_exit_t = -0.0000001d0 !RELATIVE, 0.1 PPM

end subroutine

!==========================================================================
subroutine set_it_ctrl_sea_ice_vap(key, value)

!THIS SUB SETS CONTROL PARAMETERS FOR THE ITERATION USED TO COMPUTE
!SEA-ICE-VAPOUR EQUILIBRIUM

!KEY              VALUE
!IT_STEPS         0           SET ITERATION NUMBER TO DEFAULT (100)
!IT_STEPS         N > 0       SET ITERATION NUMBER TO N
!IT_STEPS        -1           DO NOT ITERATE, USE INITIAL VALUES TO COMPUTE EQULIBRIUM

!INIT_LIQ_DENS    0           USE DEFAULT LIQUID DENSITY TO START, D = TRIPLE POINT LIQUID DENSITY
!INIT_LIQ_DENS   -1           USE TRIPLE POINT LIQUID DENSITY TO START
!INIT_LIQ_DENS    D > 0       USE VALUE D AS LIQUID DENSITY TO START

!INIT_VAP_DENS    0           USE DEFAULT VAPOUR DENSITY TO START, D = AUX_DENSITY_IDEAL_SI(T, P)
!INIT_VAP_DENS   -1           USE TRIPLE POINT VAPOUR DENSITY TO START
!INIT_VAP_DENS    D > 0       USE VALUE D AS VAPOUR DENSITY TO START

!INIT_BRINE_SA    0           USE DEFAULT BRINE SALINITY TO START (FITTED GUESS FUNCTION AUX_SALINITY)
!INIT_BRINE_SA   -1           USE NORMAL SALINITY TO START
!INIT_BRINE_SA    S > 0       USE VALUE S AS TEMPERATURE TO START

!INIT_TEMP        0           USE DEFAULT TEMPERATURE TO START (FITTED GUESS FUNCTION AUX_TEMPERATURE)
!INIT_TEMP       -1           USE TIPLE POINT TEMPERATURE TO START
!INIT_TEMP        T > 0       USE VALUE T AS TEMPERATURE TO START

!INIT_PRESS       0           USE DEFAULT PRESSURE TO START (FITTED GUESS FUNCTION AUX_PRESSURE)
!INIT_PRESS      -1           USE TRIPLE POINT PRESSURE TO START
!INIT_PRESS       P > 0       USE VALUE P AS PRESSURE TO START

!TOL_TEMP         0           USE DEFAULT EXIT ACCURACY FOR FREEZING TEMPERATURE (0.1 PPM)
!TOL_TEMP         EPS         USE EPS AS EXIT ACCURACY FOR TEMPERATURE (EPS < 0 MEANS RELATIVE ERROR)

!TOL_PRESS        0           USE DEFAULT EXIT ACCURACY FOR MELTING PRESSURE (0.1 PPM)
!TOL_PRESS        EPS         USE EPS AS EXIT ACCURACY FOR PRESSURE (EPS < 0 MEANS RELATIVE ERROR)

real*8 :: value
character*13 key

call init_it_ctrl_sea_ice_vap

call clear_sea_ice_vap_state

select case (trim(key))

  case ("it_steps");             !ITERATION STEPS
    if (value == 0d0) then
      ctrl_loop_maximum = 100   !DEFAULT = 100
    elseif (value < 0d0) then
      ctrl_loop_maximum = -1
    else   
      ctrl_loop_maximum = nint(value)
    endif

  case ("init_vap_dens");        !STARTING VAPOUR DENSITY
     if (value == 0d0) then
       ctrl_mode_vapour = 0     !DEFAULT = IDEAL GAS
     elseif (value < -1d0) then
       !ignore it
     elseif (value < 0d0) then
       ctrl_mode_vapour = nint(value)
     else
       ctrl_mode_vapour = 1
       ctrl_init_d_vap = value
     endif

  case ("init_liq_dens");        !STARTING LIQUID DENSITY
    if (value == 0d0) then
      ctrl_mode_liquid = 0      !DEFAULT = TRIPLE POINT
    elseif (value < -1d0) then
      !ignore it
    elseif (value < 0d0) then
      ctrl_mode_liquid = nint(value)
    else
      ctrl_mode_liquid = 1
      ctrl_init_d_liq = value
    endif

  case ("init_brine_sa");        !STARTING BRINE SALINITY
    if (value == 0d0) then
      ctrl_mode_salinity = 0    !DEFAULT = AUX FUNCTION
    elseif (value < -1d0) then
      !ignore it
    elseif (value < 0d0) then
      ctrl_mode_salinity = nint(value)
    else
      ctrl_mode_salinity = 1
      ctrl_init_s = value
    endif

  case ("init_temp");            !STARTING TEMPERATURE
    if (value == 0d0) then
      ctrl_mode_temperature = 0 !DEFAULT = AUX FUNCTION
    elseif (value < -1d0) then
      !ignore it
    elseif (value < 0d0) then
      ctrl_mode_temperature = nint(value)
    else
      ctrl_mode_temperature = 1
      ctrl_init_t = value
    endif

  case ("init_press");           !STARTING PRESSURE
    if (value == 0d0) then
      ctrl_mode_pressure = 0    !DEFAULT = AUX FUNCTION
    elseif (value < -1d0) then
      !ignore it
    elseif (value < 0d0) then
      ctrl_mode_pressure = nint(value)
    else
      ctrl_mode_pressure = 1
      ctrl_init_p = value
    endif

  case ("tol_temp");             !REQUIRED TEMPERATURE TOLERANCE
    if (value == 0d0) then
      ctrl_eps_exit_t = -0.0000001d0  !DEFAULT = 0.1 PPM RELATIVE
    else
      ctrl_eps_exit_t = value
    endif

  case ("tol_press");            !REQUIRED PRESSURE TOLERANCE
    if (value == 0d0) then
      ctrl_eps_exit_p = -0.0000001d0   !DEFAULT = 0.1 PPM RELATIVE
    else
      ctrl_eps_exit_p = value
    endif

  case default; write(*,*)key,' not supported'

end select

end subroutine

!==========================================================================
subroutine clear_sea_ice_vap_state()
!==========================================================================

!CLEARS THE CURRENT EQUILIBRIUM STATE DESCRIPTOR

equi_sea_ice_vap_done = 0

end subroutine

!==========================================================================
subroutine set_sea_ice_vap_state(sa_si, t_si, p_si, d_vap_si, d_liq_si)
!==========================================================================
                                  
!STORES THE ACTUAL PROPERTIES AS THE CURRENT EQUILIBRIUM STATE DESCRIPTOR

real*8 :: sa_si, t_si, p_si, d_vap_si, d_liq_si

equi_sea_ice_vap_done = isok

equi_sea_ice_vap_s = sa_si         !TRIPLE-POINT SALINITY
equi_sea_ice_vap_t = t_si          !TRIPLE-POINT TEMPERATURE
equi_sea_ice_vap_p = p_si          !TRIPLE-POINT PRESSURE
equi_sea_ice_vap_d_liq = d_liq_si   !DENSITY OF LIQUID PURE WATER
equi_sea_ice_vap_d_vap = d_vap_si   !DENSITY OF WATER VAPOUR

end subroutine

end module sea_ice_vap_4

module ice_2

!#########################################################################

!THIS MODULE IMPLEMENTS THERMODYNAMIC PROPERTIES OF HEXAGONAL ICE I
!AS FUNCTIONS OF ABSOLUTE TEMPERATURE IN K AND ABSOLUTE PRESSURE IN PA,
!COMPUTED FROM THE GIBBS POTENTIAL ICE_G_SI(DRV_T, DRV_P, T_SI, P_SI)

!#########################################################################

!IMPLEMENTATION IN FORTRAN BY D.G. WRIGHT
!FOR PUBLICATION IN OCEAN SCIENCE, AS DESCRIBED IN THE PAPERS

!FEISTEL, R., WRIGHT, D.G., JACKETT, D.R., MIYAGAWA, K., REISSMANN, J.H.,
!WAGNER, W., OVERHOFF, U., GUDER, C., FEISTEL, A., MARION, G.M.:
!NUMERICAL IMPLEMENTATION AND OCEANOGRAPHIC APPLICATION OF THE THERMODYNAMIC
!POTENTIALS OF WATER, VAPOUR, ICE, SEAWATER AND AIR. PART I: BACKGROUND AND EQUATIONS. 
!OCEAN SCIENCES, 2009, IN PREPARATION.

!WRIGHT, D.G., FEISTEL, R., JACKETT, D.R., MIYAGAWA, K., REISSMANN, J.H., 
!WAGNER, W., OVERHOFF, U., GUDER, C., FEISTEL, A., MARION, G.M.:
!NUMERICAL IMPLEMENTATION AND OCEANOGRAPHIC APPLICATION OF THE THERMODYNAMIC
!POTENTIALS OF WATER, VAPOUR, ICE, SEAWATER AND AIR. PART II: THE LIBRARY ROUTINES, 
!OCEAN SCIENCES., 2009, IN PREPARATION.

!FEISTEL, R., KRETZSCHMAR, H.-J., SPAN, R., HAGEN, E., WRIGHT, D.G., JACKETT, D.R.:
!THERMODYNAMIC PROPERTIES OF SEA AIR.
!OCEAN SCIENCE DISCUSSION 6(2009)2193-2325.

!#########################################################################

!THIS MODULE REQUIRES THE LIBRARY MODULES 
!     CONSTANTS_0,       FILE CONSTANTS_0.F90
!     ICE_1 (IAPWS06),   FILE ICE_1.F90 

!#########################################################################

use constants_0
use ice_1

implicit none
private

character*16, private :: version = '8 Jun 2010'

public :: ice_chempot_si, ice_cp_si, ice_density_si, ice_enthalpy_si, &
          ice_entropy_si, ice_expansion_si, ice_helmholtz_energy_si, &
          ice_internal_energy_si, ice_kappa_s_si, ice_kappa_t_si, &
          ice_lapserate_si, ice_p_coefficient_si, ice_specific_volume_si

contains

!==========================================================================
function ice_chempot_si(t_si, p_si)
!==========================================================================

implicit none
real*8 t_si, p_si, ice_chempot_si

!OUTPUT:
!G(T,P) GIBBS ENERGY = CHEMICAL POTENTIAL IN J/KG

!INPUTS:
!T_SI      ABSOLUTE TEMPERATURE IN K
!P_SI      ABSOLUTE PRESSURE IN PA

!CHECK VALUE: ice_chempot_si(270,1E5) = -3786.74963128

ice_chempot_si = ice_g_si(0, 0, t_si, p_si)

end function

!==========================================================================
function ice_cp_si(t_si, p_si)
!==========================================================================

implicit none

real*8 t_si, p_si, ice_cp_si
real*8 g_tt

!OUTPUT:
!CP(T,P) =  - T*(D2G/DT2)_P ISOBARIC HEAT CAPACITY IN J/(KG*K)

!INPUTS:
!T_SI      ABSOLUTE TEMPERATURE IN K
!P_SI      ABSOLUTE PRESSURE IN PA

!CHECK VALUE: ice_cp_si(270,1E5) = 2073.47946211

ice_cp_si = errorreturn

g_tt = ice_g_si(2, 0, t_si, p_si)
if (g_tt == errorreturn .or. g_tt >= 0d0) return

ice_cp_si = -t_si * g_tt

end function

!==========================================================================
function ice_density_si(t_si, p_si)
!==========================================================================

implicit none

real*8 t_si, p_si, ice_density_si
real*8 g_p

!OUTPUT:
!1/(DG/DP)_T DENSITY IN KG/M3

!INPUTS:
!T_SI      ABSOLUTE TEMPERATURE IN K
!P_SI      ABSOLUTE PRESSURE IN PA

!CHECK VALUE: ice_density_si(270,1E5) = 917.181167192

ice_density_si = errorreturn

g_p = ice_g_si(0, 1, t_si, p_si)
if (g_p == errorreturn .or. g_p <= 0d0) return

ice_density_si = 1d0 / g_p

end function

!==========================================================================
function ice_enthalpy_si(t_si, p_si)
!==========================================================================

implicit none

real*8 t_si, p_si, ice_enthalpy_si
real*8 g, g_t

!OUTPUT:
!H(T,P) = G - T*(DG/DT)_P ENTHALPY IN J/KG

!INPUTS:
!T_SI      ABSOLUTE TEMPERATURE IN K
!P_SI      ABSOLUTE PRESSURE IN PA

!CHECK VALUE: ice_enthalpy_si(270,1E5) = -339929.555499
 
ice_enthalpy_si = errorreturn

g = ice_g_si(0, 0, t_si, p_si)
g_t = ice_g_si(1, 0, t_si, p_si)
if (g == errorreturn .or. g_t == errorreturn) return

ice_enthalpy_si = g - t_si*g_t

end function

!==========================================================================
function ice_entropy_si(t_si, p_si)
!==========================================================================

implicit none

real*8 t_si, p_si, ice_entropy_si
real*8 g_t

!OUTPUT:
!ETA(T,P) = -(DG/DT)_P ENTROPY IN J/(KG*K)

!INPUTS:
!T_SI      ABSOLUTE TEMPERATURE IN K
!P_SI      ABSOLUTE PRESSURE IN PA

!CHECK VALUE: ice_entropy_si(270,1E5) = -1244.97335506
 
ice_entropy_si = errorreturn

g_t = ice_g_si(1, 0, t_si, p_si)
if (g_t == errorreturn) return

ice_entropy_si = -g_t

end function

!==========================================================================
function ice_expansion_si(t_si, p_si)
!==========================================================================

implicit none

real*8 t_si, p_si, ice_expansion_si
real*8 g_p, g_tp

!OUTPUT:
!ALPHA(T,P) = (D2G/DTDP)/(DG/DP)_T CUBIC THERMAL EXPANSION COEFFICIENT IN 1/K

!INPUTS:
!T_SI      ABSOLUTE TEMPERATURE IN K
!P_SI      ABSOLUTE PRESSURE IN PA

!CHECK VALUE: ice_expansion_si(270,1E5) = 1.58309329594E-04

ice_expansion_si = errorreturn

g_p = ice_g_si(0, 1, t_si, p_si)
g_tp = ice_g_si(1, 1, t_si, p_si)
if (g_tp == errorreturn .or. g_p == errorreturn .or. g_p <= 0d0) return

ice_expansion_si = g_tp / g_p

end function

!==========================================================================
function ice_helmholtz_energy_si(t_si, p_si)
!==========================================================================

implicit none

real*8 t_si, p_si, ice_helmholtz_energy_si
real*8 g, g_p

!OUTPUT:
!F(T,P) = G - P*(DG/DP)_T HELMHOLTZ ENERGY (FREE ENERGY) IN J/KG

!INPUTS:
!T_SI      ABSOLUTE TEMPERATURE IN K
!P_SI      ABSOLUTE PRESSURE IN PA

!CHECK VALUE: ice_helmholtz_energy_si(270,1E5) = -3895.77934490

ice_helmholtz_energy_si = errorreturn

g = ice_g_si(0, 0, t_si, p_si)
g_p = ice_g_si(0, 1, t_si, p_si)
if (g == errorreturn .or. g_p == errorreturn .or. g_p <= 0d0) return

ice_helmholtz_energy_si = g - p_si * g_p

end function

!==========================================================================
function ice_internal_energy_si(t_si, p_si)
!==========================================================================

implicit none

real*8 t_si, p_si, ice_internal_energy_si
real*8 g, g_t, g_p

!OUTPUT:
!U(T,P) = G - P*(DG/DP)_T - T*(DG/DT)_P INTERNAL ENERGY IN J/KG

!INPUTS:
!T_SI      ABSOLUTE TEMPERATURE IN K
!P_SI      ABSOLUTE PRESSURE IN PA

!CHECK VALUE: ice_internal_energy_si(270,1E5) = -340038.585212

ice_internal_energy_si = errorreturn

g = ice_g_si(0, 0, t_si, p_si)
g_t = ice_g_si(1, 0, t_si, p_si)
g_p = ice_g_si(0, 1, t_si, p_si)
if (g == errorreturn .or. g_t == errorreturn .or. g_p == errorreturn) return
if (g_p <= 0d0) return

ice_internal_energy_si = g - p_si * g_p - t_si * g_t

end function

!==========================================================================
function ice_kappa_s_si(t_si, p_si)
!==========================================================================

implicit none

real*8 t_si, p_si, ice_kappa_s_si
real*8 g_p, g_tt, g_tp, g_pp

!OUTPUT:
!-(1/V)(DV/DP)_ETA ISENTROPIC COMPRESSIBILITY IN 1/PA

!INPUTS:
!T_SI      ABSOLUTE TEMPERATURE IN K
!P_SI      ABSOLUTE PRESSURE IN PA

!CHECK VALUE: ice_kappa_s_si(270,1E5) = 1.13667916416E-10
 
ice_kappa_s_si = errorreturn

g_p = ice_g_si(0, 1, t_si, p_si)
if (g_p == errorreturn) return
if (g_p <= 0d0) return
g_tt = ice_g_si(2, 0, t_si, p_si)
if (g_tt == errorreturn) return
if (g_tt >= 0d0) return
g_tp = ice_g_si(1, 1, t_si, p_si)
if (g_tp == errorreturn) return
g_pp = ice_g_si(0, 2, t_si, p_si)
if (g_pp == errorreturn) return
if (g_pp >= 0d0) return

ice_kappa_s_si = (g_tp**2 - g_tt * g_pp) / (g_p * g_tt)

end function

!==========================================================================
function ice_kappa_t_si(t_si, p_si)
!==========================================================================

implicit none

real*8 t_si, p_si, ice_kappa_t_si
real*8 g_p, g_pp

!OUTPUT:
!-(1/V)(DV/DP)_T ISOTHERMAL COMPRESSIBILITY IN 1/PA

!INPUTS:
!T_SI      ABSOLUTE TEMPERATURE IN K
!P_SI      ABSOLUTE PRESSURE IN PA

!CHECK VALUE: ice_kappa_t_si(270,1E5) = 1.17226047281E-10

ice_kappa_t_si = errorreturn

g_p = ice_g_si(0, 1, t_si, p_si)
g_pp = ice_g_si(0, 2, t_si, p_si)
if (g_pp == errorreturn .or. g_pp >= 0d0 .or. &
  g_p == errorreturn .or. g_p <= 0d0) return

ice_kappa_t_si = -g_pp/g_p

end function

!==========================================================================
function ice_lapserate_si(t_si, p_si)
!==========================================================================

implicit none

real*8 t_si, p_si, ice_lapserate_si
real*8 g_tp, g_tt

!OUTPUT:
!(DT/DP)_ETA ADIABATIC LAPSE RATE IN K/PA

!INPUTS:
!T_SI      ABSOLUTE TEMPERATURE IN K
!P_SI      ABSOLUTE PRESSURE IN PA

!CHECK VALUE: ice_lapserate_si(270,1E5) = 2.24758128545E-08
 
ice_lapserate_si = errorreturn

g_tp = ice_g_si(1, 1, t_si, p_si)
g_tt = ice_g_si(2, 0, t_si, p_si)
if (g_tt == errorreturn .or. g_tt >= 0d0 .or. &
g_tp == errorreturn) return

ice_lapserate_si = -g_tp / g_tt

end function

!==========================================================================
function ice_p_coefficient_si(t_si, p_si)
!==========================================================================

implicit none

real*8 ice_p_coefficient_si
real*8 t_si, p_si
real*8 g_tp, g_pp

!OUTPUT:
!(DP/DT)_V  ISOCHORIC PRESSURE COEFFICIENT IN PA/K

!INPUTS:
!T_SI      ABSOLUTE TEMPERATURE IN K
!P_SI      ABSOLUTE PRESSURE IN PA

!CHECK VALUE: ice_p_coefficient_si(270,1E5) = 1350462.06254

ice_p_coefficient_si = errorreturn

g_tp = ice_g_si(1, 1, t_si, p_si)
if (g_tp == errorreturn) return
g_pp = ice_g_si(0, 2, t_si, p_si)
if (g_pp == errorreturn .or. g_pp >= 0d0) return

ice_p_coefficient_si = -g_tp / g_pp

end function

!==========================================================================
function ice_specific_volume_si(t_si, p_si)
!==========================================================================

implicit none

real*8 t_si, p_si, ice_specific_volume_si
real*8 g_p

!OUTPUT:
!V(T,P) = (DG/DP)_T SPECIFIC_VOLUME IN M3/KG

!INPUTS:
!T_SI      ABSOLUTE TEMPERATURE IN K
!P_SI      ABSOLUTE PRESSURE IN PA

!CHECK VALUE: ice_specific_volume_si(270,1E5) = 1.09029713624E-03
 
ice_specific_volume_si = errorreturn

g_p = ice_g_si(0, 1, t_si, p_si)
if (g_p == errorreturn) return

ice_specific_volume_si = g_p

end function

end module ice_2

module liq_ice_air_5c

!#########################################################################

!THIS MODULE IMPLEMENTS THE EQUILIBRIUM PROPERTIES OF WET ICE AIR, 
!I.E., BETWEEN LIQUID WATER, ICE AND HUMID AIR
!
!THIS MODULE ALSO PROVIDES SIMPLE IMPLEMENTATIONS OF DERIVED METEOROLOGICAL
!QUANTITIES LIKE THE EQUIVALENT POTENTIAL TEMPERATURE, ETC.

!#########################################################################

!IMPLEMENTATION IN FORTRAN BY F.B. LALIBERTE AT THE UNIVERSITY OF TORONTO, 2012
!FOR PROBABLE FUTURE PUBLICATION WITH THE DEVELOPERS OF TEOS-10

!#########################################################################

!THIS MODULE REQUIRES THE LIBRARY MODULES:
!     CONSTANTS_0,  FILE CONSTANTS_0.F90
!     CONVERT_0,    FILE CONVERT_0.F90
!     MATHS_0,      FILE MATHS_0.F90
!     AIR_1,        FILE AIR_1.F90
!     FLU_1,        FILE FLU_1.F90
!     ICE_1,        FILE ICE_1.F90
!     AIR_2,        FILE AIR_2.F90
!     FLU_2,        FILE FLU_2.F90
!     ICE_2,        FILE ICE_2.F90
!     AIR_3B,       FILE AIR_3B.F90
!     AIR_3C,       FILE AIR_3C.F90
!     ICE_LIQ_4,    FILE ICE_LIQ_4.F90
!     ICE_VAP_4,    FILE ICE_VAP_4.F90
!     LIQ_VAP_4,    FILE LIQ_VAP_4.F90

!     LIQ_AIR_4A,   FILE LIQ_AIR_4A.F90
!     LIQ_AIR_4B,   FILE LIQ_AIR_4B.F90
!     LIQ_AIR_4C,   FILE LIQ_AIR_4C.F90

!     ICE_AIR_4A,   FILE ICE_AIR_4A.F90
!     ICE_AIR_4B,   FILE ICE_AIR_4B.F90
!     ICE_AIR_4C,   FILE ICE_AIR_4C.F90

!     LIQ_ICE_AIR_4,FILE LIQ_ICE_AIR_4.F90 

!#########################################################################

use constants_0
use convert_0
use maths_0
use air_1
use flu_1
use ice_1
use air_2
use flu_2
use ice_2
use air_3b
use air_3c
use ice_liq_4

use ice_vap_4
use liq_vap_4

use liq_air_4a
use liq_air_4b
use liq_air_4c
use liq_air_4d
use ice_air_4a
use ice_air_4b
use ice_air_4c
use ice_air_4d
use liq_ice_air_4
use liq_ice_air_5b

implicit none
private

character*16, private :: version = 'October 2012'

public :: &
          liq_ice_air_g_cond_entropy_si,&
          liq_ice_air_g_wb_entropy_si,&
          liq_ice_air_g_cond_cp_si

contains

function liq_ice_air_g_wb_entropy_si(a_si, t_si, p_si)
!THIS FUNCTION COMPUTES THE CONDENSATION ENTROPY OF AIR AT FIXED PRESSURE AND FIXED DRY AIR MASS FRACTION.

!OUTPUT:
!ETA(A,T,P,PR) CONDENSATION ENTROPY OF ICE AIR OR LIQUID AIR 

!INPUTS:
!A_SI      ABSOLUTE DRY-AIR MASS FRACTION IN KG/KG
!T_SI      ABSOLUTE IN-SITU TEMPERATURE IN K
!P_SI      ABSOLUTE IN-SITU PRESSURE IN PA
!PR_SI     REFERENCE PRESSURE IN PA

real*8 liq_ice_air_g_wb_entropy_si, a_si, t_si, p_si
real*8 t_freeze, a_sat

liq_ice_air_g_wb_entropy_si = errorreturn

if(a_si < 0d0 .or. a_si > 1d0) return
if(t_si < 0d0) return
if(p_si < 0d0) return

a_sat=liq_ice_air_massfraction_air_si(t_si,p_si)
if(a_sat==errorreturn) return

if(set_liq_ice_air_eq_at_p(p_si) == errorreturn) then
    !Above or at triple point
    t_freeze=liq_ice_air_temperature_si()
    if(t_freeze==errorreturn) return

    if(t_si<t_freeze) then
        !condensation against ice
        liq_ice_air_g_wb_entropy_si=ice_air_g_cond_entropy_si(a_sat, t_si, p_si,a_si)
    elseif(t_si>t_freeze) then
        !condensation against liquid
        liq_ice_air_g_wb_entropy_si=liq_air_g_cond_entropy_si(a_sat, t_si, p_si,a_si)
    else
        liq_ice_air_g_wb_entropy_si=liq_ice_air_entropy_si()
    endif
else
    !Below triple point
    liq_ice_air_g_wb_entropy_si=ice_air_g_cond_entropy_si(a_sat, t_si, p_si,a_si)
endif

end function


function liq_ice_air_g_cond_entropy_si(a_si, t_si, p_si)
!THIS FUNCTION COMPUTES THE CONDENSATION ENTROPY OF AIR AT FIXED PRESSURE AND FIXED DRY AIR MASS FRACTION.

!OUTPUT:
!ETA(A,T,P,PR) CONDENSATION ENTROPY OF ICE AIR OR LIQUID AIR 

!INPUTS:
!A_SI      ABSOLUTE DRY-AIR MASS FRACTION IN KG/KG
!T_SI      ABSOLUTE IN-SITU TEMPERATURE IN K
!P_SI      ABSOLUTE IN-SITU PRESSURE IN PA
!PR_SI     REFERENCE PRESSURE IN PA

real*8 liq_ice_air_g_cond_entropy_si, a_si, t_si, p_si
real*8 t_freeze

liq_ice_air_g_cond_entropy_si = errorreturn

if(a_si < 0d0 .or. a_si > 1d0) return
if(t_si < 0d0) return
if(p_si < 0d0) return

if(set_liq_ice_air_eq_at_p(p_si) == errorreturn) then
    !Above or at triple point
    t_freeze=liq_ice_air_temperature_si()
    if(t_freeze==errorreturn) return

    if(t_si<t_freeze) then
        !condensation against ice
        liq_ice_air_g_cond_entropy_si=ice_air_g_cond_entropy_si(a_si, t_si, p_si,1d0)
    elseif(t_si>t_freeze) then
        !condensation against liquid
        liq_ice_air_g_cond_entropy_si=liq_air_g_cond_entropy_si(a_si, t_si, p_si,1d0)
    else
        !at freezing point: set entropy with only condensates, half in water, half in ice
        liq_ice_air_g_cond_entropy_si=liq_ice_air_entropy_si()
    endif
else
    !Below triple point
    !condensation against ice
    liq_ice_air_g_cond_entropy_si=ice_air_g_cond_entropy_si(a_si, t_si, p_si,1d0)
endif

end function

function liq_ice_air_g_cond_cp_si(a_si, t_si, p_si)
!THIS FUNCTION COMPUTES THE SPECIFIC HEAT OF AIR AT FIXED PRESSURE AND FIXED DRY AIR MASS FRACTION.

!OUTPUT:
!CP(A,T,P,PR) SPECIFIC HEAT OF ICE AIR OR LIQUID AIR 

!INPUTS:
!A_SI      ABSOLUTE DRY-AIR MASS FRACTION IN KG/KG
!T_SI      ABSOLUTE IN-SITU TEMPERATURE IN K
!P_SI      ABSOLUTE IN-SITU PRESSURE IN PA
!PR_SI     REFERENCE PRESSURE IN PA

real*8 liq_ice_air_g_cond_cp_si, a_si, t_si, p_si
real*8 t_freeze

liq_ice_air_g_cond_cp_si = errorreturn

if(a_si < 0d0 .or. a_si > 1d0) return
if(t_si < 0d0) return
if(p_si < 0d0) return

if(set_liq_ice_air_eq_at_p(p_si) == errorreturn) then
    !Above or at triple point
    t_freeze=liq_ice_air_temperature_si()
    if(t_freeze==errorreturn) return

    if(t_si<t_freeze) then
        !equilibrium against ice
        liq_ice_air_g_cond_cp_si=ice_air_g_cond_cp_si(a_si, t_si, p_si,1d0)
    elseif(t_si>=t_freeze) then
    !elseif(t_si>t_freeze) then
        liq_ice_air_g_cond_cp_si=liq_air_g_cond_cp_si(a_si, t_si, p_si,1d0)
    !else
    !    !at freeze point
    !    wt=0.5d0
    !    if(set_liq_ice_air_eq_at_wa_wl_wi(a_si,wt*(1d0-a_si),(1d0-wt)*(1-a_si)) == errorreturn) return
    !    liq_ice_air_g_cond_cp_si=liq_ice_air_entropy_si()
    endif
else
    !Below triple point
        !equilibrium against ice
        liq_ice_air_g_cond_cp_si=ice_air_g_cond_cp_si(a_si, t_si, p_si,1d0)
endif

end function

end module liq_ice_air_5c

module air_2

!#########################################################################

!THIS MODULE IMPLEMENTS THE AIR-WATER MIXING HELMHOLTZ FUNCTION
!AIR_F_MIX_SI(DRV_A, DRV_T, DRV_D, A_SI, A_SI, T_SI, D_SI),
!AND ITS FIRST AND SECOND PARTIAL DERIVATIVES WITH RESPECT TO AIR FRACTION,
!TEMPERATURE AND DENSITY,

!THE HELMHOLTZ POTENTIAL OF HUMID AIR AS A FUNCTION OF THE DRY-AIR FRACTION
!IN KG/KG, ABSOLUTE TEMPERATURE IN K AND HUMID-AIR DENSITY IN KG/M3,
!AIR_F_SI(DRV_A, DRV_T, DRV_D, A_SI, A_SI, T_SI, D_SI),
!AND ITS FIRST AND SECOND PARTIAL DERIVATIVES WITH RESPECT TO AIR FRACTION,
!TEMPERATURE AND DENSITY,

!AND 

!THERMODYNAMIC PROPERTIES OF HUMID AIR COMPUTED FROM THE hELMHOLTZ POTENTIAL.

!#########################################################################

!IMPLEMENTATION IN FORTRAN BY D.G. WRIGHT
!FOR PUBLICATION IN OCEAN SCIENCE, AS DESCRIBED IN THE PAPERS

!FEISTEL, R., WRIGHT, D.G., JACKETT, D.R., MIYAGAWA, K., REISSMANN, J.H.,
!WAGNER, W., OVERHOFF, U., GUDER, C., FEISTEL, A., MARION, G.M.:
!NUMERICAL IMPLEMENTATION AND OCEANOGRAPHIC APPLICATION OF THE THERMODYNAMIC
!POTENTIALS OF WATER, VAPOUR, ICE, SEAWATER AND AIR. PART I: BACKGROUND AND EQUATIONS. 
!OCEAN SCIENCES, 2009, IN PREPARATION.

!WRIGHT, D.G., FEISTEL, R., JACKETT, D.R., MIYAGAWA, K., REISSMANN, J.H., 
!WAGNER, W., OVERHOFF, U., GUDER, C., FEISTEL, A., MARION, G.M.:
!NUMERICAL IMPLEMENTATION AND OCEANOGRAPHIC APPLICATION OF THE THERMODYNAMIC
!POTENTIALS OF WATER, VAPOUR, ICE, SEAWATER AND AIR. PART II: THE LIBRARY ROUTINES, 
!OCEAN SCIENCES., 2009, IN PREPARATION.

!FEISTEL, R., KRETZSCHMAR, H.-J., SPAN, R., HAGEN, E., !WRIGHT, D.G., HERRMANN, S.:
!THERMODYNAMIC PROPERTIES OF SEA AIR.
!OCEAN SCIENCE DISCUSSION 6(2009)2193-2325.

!#########################################################################

!THIS MODULE REQUIRES THE LIBRARY MODULES
!     CONSTANTS_0,  FILE CONSTANTS_0.F90
!     FLU_1,        FILE FLU_1.F90
!     AIR_1,        FILE AIR_1.F90

!#########################################################################

use constants_0
use air_1
use flu_1

implicit none
private

character*16, private :: version = '8 Jun 2010'

public :: air_f_si, air_f_cp_si, air_f_cv_si, &
          air_f_enthalpy_si, air_f_entropy_si, &
          air_f_expansion_si, air_f_gibbs_energy_si, &
          air_f_internal_energy_si, air_f_kappa_s_si, &
          air_f_kappa_t_si, air_f_lapserate_si, &
          air_f_mix_si, air_f_pressure_si, &
          air_f_soundspeed_si, chk_iapws10_table

contains

!==========================================================================
function air_f_mix_si(drv_a, drv_t, drv_d, a_si, t_si, d_si)
!==========================================================================

!THIS FUNCTION IMPLEMENTS THE CROSS-COMPONENT INTERACTION CONTRIBUTION TO 
!THE SPECIFIC  HELMHOLTZ ENERGY OF HUMID AIR AND ITS DERIVATIVES WITH RESPECT 
!TO THE AIR FRACTION, TEMPERATURE AND HUMID-AIR DENSITY

!OUTPUT: 
!air_f_mix_si:  MIXING HELMHOLTZ ENERGY OR ITS DERIVATIVES IN J KG-1 K^-DRV_T (KG/M3)^-DRV_D

!INPUT:  
!DRV_A  ORDER OF DERIVATIVE WITH RESPECT TO THE AIR MASS FRACTION
!DRV_T  ORDER OF DERIVATIVE WITH RESPECT TO TEMPERATURE
!DRV_D  ORDER OF DERIVATIVE WITH RESPECT TO HUMID-AIR DENSITY
!A_SI   MASS FRACTION OF AIR IN HUMID AIR IN KG/KG
!T_SI   ABSOLUTE TEMPERATURE IN K
!D_SI   HUMID-AIR DENSITY IN KG/M3

!CHECK VALUES, V1.0 AND V1.1:
!air_f_mix_si( 0, 0, 0, 0.9,300,1) =-25.8379179182
!air_f_mix_si( 1, 0, 0, 0.9,300,1) = 233.827370434
!air_f_mix_si( 0, 1, 0, 0.9,300,1) = 0.164195952060
!air_f_mix_si( 0, 0, 1, 0.9,300,1) =-26.2357498619
!air_f_mix_si( 2, 0, 0, 0.9,300,1) = 500.273928155
!air_f_mix_si( 1, 1, 0, 0.9,300,1) =-1.53932744055
!air_f_mix_si( 1, 0, 1, 0.9,300,1) = 241.520643317
!air_f_mix_si( 0, 2, 0, 0.9,300,1) =-0.687329742959E-3
!air_f_mix_si( 0, 1, 1, 0.9,300,1) = 0.172192606103
!air_f_mix_si( 0, 0, 2, 0.9,300,1) =-0.795663887493


real*8 air_f_mix_si
integer :: drv_a, drv_t, drv_d
real*8 :: raw, a_si, t_si, d_si
real*8 :: baw, caaw, caww
real*8 :: bawt, caawt, cawwt

real*8 ::  mw = molar_mass_h2o_si   !MOLAR MASS OF H2O IN KG/MOL
real*8 ::  ma = molar_mass_air_si   !MOLAR MASS OF AIR IN KG/MOL
raw = gas_constant_molar_si / (ma * mw)

air_f_mix_si = errorreturn

if (drv_a < 0) return
if (drv_t < 0) return
if (drv_d < 0) return
if (drv_a + drv_t + drv_d > 2) return

if(a_si < 0d0 .or. a_si > 1d0) return

if(check_limits == 1) then
  if(t_si < mix_air_tmin .or. t_si > mix_air_tmax) return
  if(d_si <= mix_air_dmin .or. d_si > mix_air_dmax) return 
else
  if (t_si <= 0d0 .or. &
  d_si <= 0d0) return
endif

!TEMPERATURE DERIVATIVES OF THE VIRIAL COEFFICIENTS
select case (drv_t)
  case (0)
     baw = air_baw_m3mol(0, t_si)
     If(baw == ErrorReturn) return
     bawt = 2d0 * raw * t_si * baw 

     caaw = air_caaw_m6mol2(0, t_si)
     If(caaw == ErrorReturn) return
     caawt = 1.5d0 * Raw * t_si * caaw / ma

     caww = air_caww_m6mol2(0, t_si)
     If(caww == ErrorReturn) return
     cawwt = 1.5d0 * Raw * t_si * caww / mw

  case (1) 
     baw = air_baw_m3mol(1, t_si)
     If(baw == ErrorReturn) return
     bawt = 2d0 * Raw * t_si * baw
     baw = air_baw_m3mol(0, t_si)
     If(baw == ErrorReturn) return
     bawt = (bawt + 2d0 * Raw * baw)

     caaw = air_caaw_m6mol2(1, t_si)
     If(caaw == ErrorReturn) return
     caawt = 1.5d0 * Raw * t_si * caaw / ma
     caaw = air_caaw_m6mol2(0, t_si)
     If(caaw == ErrorReturn) return
     caawt = (caawt + 1.5d0 * Raw * caaw / ma)

     caww = air_caww_m6mol2(1, t_si)
     If(caww == ErrorReturn) return
     cawwt = 1.5d0 * Raw * t_si * caww / mw
     caww = air_caww_m6mol2(0, t_si)
     If(caww == ErrorReturn) return
     cawwt = (cawwt + 1.5d0 * Raw * caww / mw)

  case (2)
     baw = air_baw_m3mol(2, t_si)
     If(baw == ErrorReturn) return
     bawt = 2d0 * Raw * t_si * baw
     baw = air_baw_m3mol(1, t_si)
     If(baw == ErrorReturn) return
     bawt = (bawt + 4d0 * Raw * baw)

     caaw = air_caaw_m6mol2(2, t_si)
     If(caaw == ErrorReturn) return
     caawt = 1.5d0 * Raw * t_si * caaw / ma
     caaw = air_caaw_m6mol2(1, t_si)
     If(caaw == ErrorReturn) return
     caawt = caawt + 1.5d0 * Raw * 2d0 * caaw / ma

     caww = air_caww_m6mol2(2, t_si)
     If(caww == ErrorReturn) return
     cawwt = 1.5d0 * Raw * t_si * caww / mw
     caww = air_caww_m6mol2(1, t_si)
     If(caww == ErrorReturn) return
     cawwt = cawwt + 1.5d0 * Raw * 2d0 * caww / mw
  case default; return
end select

!DENSITY DERIVATIVES OF THE VIRIAL COEFFICIENTS
select case (drv_d)
  case (0)
     bawt  = bawt * d_si
     caawt = caawt * d_si ** 2
     cawwt = cawwt * d_si ** 2
  case (1)
     bawt  = bawt
     caawt = 2d0 * caawt * d_si
     cawwt = 2d0 * cawwt * d_si
  case (2)
     bawt  = 0d0
     caawt = 2d0 * caawt
     cawwt = 2d0 * cawwt
  case default;  return
end select

!AIR-FRACTION DERIVATIVES OF THE VIRIAL COEFFICIENTS
select case (drv_a)
  case (0)
     bawt  = bawt * a_si * (1d0 - a_si)
     caawt = caawt * a_si ** 2 * (1d0 - a_si)
     cawwt = cawwt * a_si * (1d0 - a_si) ** 2
  case (1)
     bawt  = bawt * (1d0 - 2d0 * a_si)
     caawt = caawt * a_si * (2d0 - 3d0 * a_si)
     cawwt = cawwt * (1d0 - 4d0 * a_si + 3d0 * a_si ** 2)
  case (2)
     bawt  = -2d0 * bawt
     caawt = caawt * (2d0 - 6d0 * a_si)
     cawwt = cawwt * (-4d0 + 6d0 * a_si)
  case default; return
end select

air_f_mix_si = bawt + caawt + cawwt

end function

!==========================================================================
function air_f_si(drv_a, drv_t, drv_d, a_si, t_si, d_si)
!==========================================================================

!THIS FUNCTION IMPLEMENTS THE HELMHOLTZ POTENTIAL OF HUMID AIR AND ITS FIRST AND SECOND
!DERIVATIVES WITH RESPECT TO THE AIR FRACTION, TEMPERATURE AND HUMID-AIR DENSITY

!OUTPUT:  
!AIR_F_SI = HELMHOLTZ ENERGY OR ITS DERIVATIVES IN J KG-1 K^-DRV_T (KG/M3)^-DRV_D

!INPUT:   
!DRV_A  ORDER OF THE AIR FRACTION DERIVATIVE
!DRV_T  ORDER OF THE TEMPERATURE DERIVATIVE
!DRV_D  ORDER OF THE DENSITY DERIVATIVE
!A_SI MASS FRACTION OF DRY AIR IN HUMID AIR IN KG/KG
!T_SI ABSOLUTE TEMPERATURE IN K
!D_SI DENSITY OF HUMID AIR IN KG/M3

!CHECK VALUES, V1.0:
!air_f_si( 0, 0, 0, 0.9,300,1) =-95024.7900038
!air_f_si( 1, 0, 0, 0.9,300,1) =-205630.937996
!air_f_si( 0, 1, 0, 0.9,300,1) =-940.150652241
!air_f_si( 0, 0, 1, 0.9,300,1) = 91193.7358460
!air_f_si( 2, 0, 0, 0.9,300,1) = 1447791.10862
!air_f_si( 1, 1, 0, 0.9,300,1) = 7443.19342188
!air_f_si( 1, 0, 1, 0.9,300,1) =-48827.5293333
!air_f_si( 0, 2, 0, 0.9,300,1) =-2.96533251321
!air_f_si( 0, 1, 1, 0.9,300,1) = 312.124501058
!air_f_si( 0, 0, 2, 0.9,300,1) =-91439.8037142

!CHECK VALUES, V1.1:
!air_f_si( 0, 0, 0, 0.9,300,1) =-95019.5943231
!air_f_si( 1, 0, 0, 0.9,300,1) =-205645.554995
!air_f_si( 0, 1, 0, 0.9,300,1) =-940.175394023
!air_f_si( 0, 0, 1, 0.9,300,1) = 91175.3848662
!air_f_si( 2, 0, 0, 0.9,300,1) = 1447768.46379
!air_f_si( 1, 1, 0, 0.9,300,1) = 7443.09771950
!air_f_si( 1, 0, 1, 0.9,300,1) =-48847.9096826
!air_f_si( 0, 2, 0, 0.9,300,1) =-2.96482218054
!air_f_si( 0, 1, 1, 0.9,300,1) = 312.063110700
!air_f_si( 0, 0, 2, 0.9,300,1) =-91421.4440689


real*8 :: air_f_si
integer :: drv_a, drv_t, drv_d
real*8 :: a_si, t_si, d_si
real*8 :: f, da, dw
real*8 :: fw, fa, fm

air_f_si = errorreturn

if (drv_a < 0) return
if (drv_t < 0) return
if (drv_d < 0) return
if (drv_a + drv_t + drv_d > 2) return

if (a_si < 0d0 .or. a_si > 1d0) return
if ((a_si == 0d0 .or. a_si == 1d0) .and. drv_a > 0) return  
if (t_si <= 0d0) return
if (d_si <= 0d0) return

da = a_si * d_si            !PARTIAL DENSITY OF AIR
dw = (1d0 - a_si) * d_si    !PARTIAL DENSITY OF VAPOUR

select case (drv_a)

  case (0)
    f = 0d0
    if(dw > 0d0)then
      fw = flu_f_si(drv_t, drv_d, t_si, dw)
      if(fw == errorreturn) return
      f = f + (1d0 - a_si) ** (drv_d + 1) * fw
    endif
    if(da > 0d0)then
      fa = dry_f_si(drv_t, drv_d, t_si, da)
      if(fa == errorreturn) return
      f = f + a_si ** (drv_d + 1) * fa
    endif
    if(dw > 0d0 .and. da > 0d0)then
      fm = air_f_mix_si(0, drv_t, drv_d, a_si, t_si, d_si)
      if(fm == errorreturn) return
      f = f + fm
    endif

  case (1)
    select case (drv_d)

      case (0)
        f = 0d0
        if(dw > 0d0)then
          fw = flu_f_si(drv_t, 0, t_si, dw) 
          if(fw == errorreturn) return
          f = f - fw
          fw = flu_f_si(drv_t, 1, t_si, dw)
          if(fw == errorreturn) return
          f = f - dw * fw
        endif
        if(da > 0d0)then
          fa = dry_f_si(drv_t, 0, t_si, da)
          if(fa == errorreturn) return
          f = f + fa
          fa = dry_f_si(drv_t, 1, t_si, da)
          if(fa == errorreturn) return
          f = f + da * fa
        endif
        if(dw > 0d0 .and. da > 0d0)then
          fm = air_f_mix_si(1, drv_t, 0, a_si, t_si, d_si)
          if(fm == errorreturn) return
          f = f + fm
        endif

      case (1)
        f = 0d0
        if(dw > 0d0)then
          fw = flu_f_si(drv_t, 1, t_si, dw)
          if(fw == errorreturn) return
          f = f - (1d0 - a_si) * 2d0 * fw
          fw = flu_f_si(drv_t, 2, t_si, dw)
          if(fw == errorreturn) return
          f = f - (1d0 - a_si) * dw * fw
        endif
        if(da > 0d0)then
          fa =  dry_f_si(drv_t, 1, t_si, da)
          if(fa == errorreturn) return
          f = f + a_si * 2d0 * fa
          fa =  dry_f_si(drv_t, 2, t_si, da)
          if(fa == errorreturn) return
          f = f + a_si * da * fa
        endif
        if(dw > 0d0 .and. da > 0d0)then
          fm = air_f_mix_si(1, drv_t, drv_d, a_si, t_si, d_si)
          if(fm == errorreturn) return
          f = f + fm
        endif
      case default; return
    end select

  case (2)
    f = 0d0
    if(dw > 0d0)then
      fw = flu_f_si(drv_t, 1, t_si, dw)
      if(fw == errorreturn) return
      f = f + 2d0 * d_si * fw
      fw = flu_f_si(drv_t, 2, t_si, dw)
      if(fw == errorreturn) return
      f = f + dw * d_si * fw
    endif
    if(da > 0d0)then
      fa = dry_f_si(drv_t, 1, t_si, da)
      if(fa == errorreturn) return
      f = f + 2d0 * d_si * fa
      fa = dry_f_si(drv_t, 2, t_si, da)
      if(fa == errorreturn) return
      f = f + da * d_si * fa
    endif
    if(dw > 0d0 .and. da > 0d0)then
      fm = air_f_mix_si(2, drv_t, 0, a_si, t_si, d_si)
      if(fm == errorreturn) return
      f = f + fm
    endif
  case default; return
end select

air_f_si = f

end function

!==========================================================================
function air_f_cp_si(a_si, t_si, d_si)
!==========================================================================

!THIS FUNCTION COMPUTES THE ISOBARIC HEAT CAPACITY OF HUMID AIR
!FROM THE MASS FRACTION OF AIR, TEMPERATURE AND HUMID-AIR DENSITY

!OUTPUT: 
!CP = T * (DETA/DT)_P  ISOBARIC HEAT CAPACITY IN J/(KG K)

!INPUT: 
!A_SI      MASS FRACTION OF DRY AIR IN HUMID AIR
!T_SI      ABSOLUTE TEMPERATURE IN K
!D_SI      HUMID-AIR DENSITY IN KG/M3

!CHECK VALUE, V1.0: air_f_cp_si(0.9,300,1) = 1210.95501131
!CHECK VALUE, V1.1: air_f_cp_si(0.9,300,1) = 1210.74031058

real*8 air_f_cp_si
real*8 a_si, t_si, d_si
real*8 f_d, f_tt, f_td, f_dd, x

air_f_cp_si = errorreturn

f_d = air_f_si(0, 0, 1, a_si, t_si, d_si)
if (f_d == errorreturn) return
f_tt = air_f_si(0, 2, 0, a_si, t_si, d_si)
if (f_tt == errorreturn) return
f_td = air_f_si(0, 1, 1, a_si, t_si, d_si)
if (f_td == errorreturn) return
f_dd = air_f_si(0, 0, 2, a_si, t_si, d_si)
if (f_dd == errorreturn) return

x = 2d0 * f_d + d_si * f_dd
if (x == 0d0) return

air_f_cp_si = t_si * (f_td ** 2 * d_si / x - f_tt)

end function

!==========================================================================
function air_f_cv_si(a_si, t_si, d_si)
!==========================================================================

!THIS FUNCTION COMPUTES THE ISOCHORIC HEAT CAPACITY OF HUMID AIR
!FROM THE MASS FRACTION OF AIR, TEMPERATURE AND HUMID-AIR DENSITY

!OUTPUT: 
!CV = T * (DETA/DT)_D  ISOCHORIC HEAT CAPACITY IN J/(KG K)

!INPUT:  
!A_SI      MASS FRACTION OF DRY AIR IN HUMID AIR
!T_SI      ABSOLUTE TEMPERATURE IN K
!D_SI      HUMID-AIR DENSITY IN KG/M3

!CHECK VALUE, V1.0: air_f_cv_si(0.9,300,1) = 889.599753963
!CHECK VALUE, V1.1: air_f_cv_si(0.9,300,1) = 889.446654163

real*8 :: air_f_cv_si
real*8 :: a_si, t_si, d_si
real*8 :: f_tt

air_f_cv_si = errorreturn

f_tt = air_f_si(0, 2, 0, a_si, t_si, d_si)
if (f_tt == errorreturn) return

air_f_cv_si = -t_si * f_tt

end function

!==========================================================================
function air_f_enthalpy_si(a_si, t_si, d_si)
!==========================================================================

!THIS FUNCTION COMPUTES THE ENTHALPY OF HUMID AIR
!FROM THE MASS FRACTION OF AIR, TEMPERATURE AND HUMID-AIR DENSITY


!OUTPUT: 
!H = F - T*(DF/DT) + D*(DF/DD) ENTHALPY IN J/KG

!INPUT:  
!A_SI      MASS FRACTION OF DRY AIR IN HUMID AIR
!T_SI      ABSOLUTE TEMPERATURE IN K
!D_SI      HUMID-AIR DENSITY IN KG/M3

!CHECK VALUE, V1.0: air_f_enthalpy_si(0.9,300,1) = 278214.141515
!CHECK VALUE, V1.1: air_f_enthalpy_si(0.9,300,1) = 278208.408750

real*8 :: air_f_enthalpy_si
real*8 :: a_si, t_si, d_si
real*8 :: f, f_t, f_d

air_f_enthalpy_si = errorreturn

f = air_f_si(0, 0, 0, a_si, t_si, d_si)
if (f == errorreturn) return
f_t = air_f_si(0, 1, 0, a_si, t_si, d_si)
if (f_t == errorreturn) return
f_d = air_f_si(0, 0, 1, a_si, t_si, d_si)
if (f_d == errorreturn) return

air_f_enthalpy_si = f - t_si * f_t + d_si * f_d

end function

!==========================================================================
function air_f_entropy_si(a_si, t_si, d_si)
!==========================================================================

!THIS FUNCTION COMPUTES THE ENTROPY OF HUMID AIR
!FROM THE MASS FRACTION OF AIR, TEMPERATURE AND HUMID-AIR DENSITY

!OUTPUT: 
!ETA = - (DF/DT)_A_D ENTROPY in J/(KG K)

!INPUT:  
!A_SI      MASS FRACTION OF DRY AIR IN HUMID AIR
!T_SI      ABSOLUTE TEMPERATURE IN K
!D_SI      HUMID-AIR DENSITY IN KG/M3

!CHECK VALUE, V1.0: air_f_entropy_si(0.9,300,1) = 940.150652241
!CHECK VALUE, V1.1: air_f_entropy_si(0.9,300,1) = 940.175394023

real*8 :: air_f_entropy_si
real*8 :: a_si, t_si, d_si
real*8 :: f_t

air_f_entropy_si = errorreturn

f_t = air_f_si(0, 1, 0, a_si, t_si, d_si)
if (f_t == errorreturn) return

air_f_entropy_si = -f_t

end function

!==========================================================================
function air_f_expansion_si(a_si, t_si, d_si)
!==========================================================================

!THIS FUNCTION COMPUTES THE THERMAL EXPANSION COEFFICIENT OF HUMID AIR
!FROM THE MASS FRACTION OF AIR, TEMPERATURE AND HUMID-AIR DENSITY

!OUTPUT: 
!ALPHA = -(1/D) * (DD/DT)_A_P  THERMAL EXPANSION COEFFICIENT IN 1/K

!INPUT:  
!A_SI      MASS FRACTION OF DRY AIR IN HUMID AIR
!T_SI      ABSOLUTE TEMPERATURE IN K
!D_SI      HUMID-AIR DENSITY IN KG/M3

!CHECK VALUE, V1.0: air_f_expansion_si(0.9,300,1) = 3.43191318698E-03
!CHECK VALUE, V1.1: air_f_expansion_si(0.9,300,1) = 3.43193033077E-03

real*8 :: air_f_expansion_si
real*8 :: a_si, t_si, d_si
real*8 :: f_d, f_td, f_dd, x

air_f_expansion_si = errorreturn

f_d = air_f_si(0, 0, 1, a_si, t_si, d_si)
if (f_d == errorreturn) return
f_td = air_f_si(0, 1, 1, a_si, t_si, d_si)
if (f_td == errorreturn) return
f_dd = air_f_si(0, 0, 2, a_si, t_si, d_si)
if (f_dd == errorreturn) return

x = 2d0 * f_d + d_si * f_dd
if (x == 0d0) return

air_f_expansion_si = f_td / x

end function

!==========================================================================
function air_f_gibbs_energy_si(a_si, t_si, d_si)
!==========================================================================

!THIS FUNCTION COMPUTES THE GIBBS ENERGY OF HUMID AIR
!FROM THE MASS FRACTION OF AIR, TEMPERATURE AND HUMID-AIR DENSITY

!OUTPUT: 
!G = F + D*(DF/DD)   GIBBS ENERGY IN J/KG

!INPUT:  
!A_SI      MASS FRACTION OF DRY AIR IN HUMID AIR
!T_SI      ABSOLUTE TEMPERATURE IN K
!D_SI      HUMID-AIR DENSITY IN KG/M3

!CHECK VALUE, V1.0: air_f_gibbs_energy_si(0.9,300,1) = -3831.05415778
!CHECK VALUE, V1.1: air_f_gibbs_energy_si(0.9,300,1) = -3844.20945693

real*8 :: air_f_gibbs_energy_si
real*8 :: a_si, t_si, d_si
real*8 :: f, f_d

air_f_gibbs_energy_si = errorreturn

f = air_f_si(0, 0, 0, a_si, t_si, d_si)
if (f == errorreturn) return
f_d = air_f_si(0, 0, 1, a_si, t_si, d_si)
if (f_d == errorreturn) return

air_f_gibbs_energy_si = f + d_si * f_d

end function

!==========================================================================
function air_f_internal_energy_si(a_si, t_si, d_si)
!==========================================================================

!THIS FUNCTION COMPUTES THE INTERNAL ENERGY OF HUMID AIR
!FROM THE MASS FRACTION OF AIR, TEMPERATURE AND HUMID-AIR DENSITY

!OUTPUT: 
!U = F - T*(DF/DT) INTERNAL ENERGY IN J/KG

!INPUT:  
!A_SI      MASS FRACTION OF DRY AIR IN HUMID AIR
!T_SI      ABSOLUTE TEMPERATURE IN K
!D_SI      HUMID-AIR DENSITY IN KG/M3

!CHECK VALUE, V1.0: air_f_internal_energy_si(0.9,300,1) = 187020.405669
!CHECK VALUE, V1.1: air_f_internal_energy_si(0.9,300,1) = 187033.023884

real*8 :: air_f_internal_energy_si
real*8 :: a_si, t_si, d_si
real*8 :: f, f_t

air_f_internal_energy_si = errorreturn

f = air_f_si(0, 0, 0, a_si, t_si, d_si)
if (f == errorreturn) return
f_t = air_f_si(0, 1, 0, a_si, t_si, d_si)
if (f_t == errorreturn) return

air_f_internal_energy_si = f - t_si * f_t

end function

!==========================================================================
function air_f_kappa_s_si(a_si, t_si, d_si)
!==========================================================================

!THIS FUNCTION COMPUTES THE ISENTROPIC COMPRESSIBILITY OF HUMID AIR
!FROM THE MASS FRACTION OF AIR, TEMPERATURE AND HUMID-AIR DENSITY

!OUTPUT: 
!KAPPA_S = (1/D) * (DD/DP)_A_ETA  ISENTROPIC COMPRESSIBILITY IN 1/PA

!INPUT:  
!A_SI      MASS FRACTION OF DRY AIR IN HUMID AIR
!T_SI      ABSOLUTE TEMPERATURE IN K
!D_SI      HUMID-AIR DENSITY IN KG/M3

!CHECK VALUE, V1.0: air_f_kappa_s_si(0.9,300,1) = 8.07746486644E-06
!CHECK VALUE, V1.1: air_f_kappa_s_si(0.9,300,1) = 8.07913626816E-06

real*8 :: air_f_kappa_s_si
real*8 :: a_si, t_si, d_si
real*8 :: f_d, f_tt, f_td, f_dd, x

air_f_kappa_s_si = errorreturn

f_d = air_f_si(0, 0, 1, a_si, t_si, d_si)
if (f_d == errorreturn) return
f_tt = air_f_si(0, 2, 0, a_si, t_si, d_si)
if (f_tt == errorreturn) return
f_td = air_f_si(0, 1, 1, a_si, t_si, d_si)
if (f_td == errorreturn) return
f_dd = air_f_si(0, 0, 2, a_si, t_si, d_si)
if (f_dd == errorreturn) return

x = d_si ** 2 * (f_tt * (2d0 * f_d + d_si * f_dd) - d_si * f_td ** 2)
if (x == 0d0) return

air_f_kappa_s_si = f_tt / x

end function

!==========================================================================
function air_f_kappa_t_si(a_si, t_si, d_si)
!==========================================================================

!THIS FUNCTION COMPUTES THE ISOTHERMAL COMPRESSIBILITY OF HUMID AIR
!FROM THE MASS FRACTION OF AIR, TEMPERATURE AND HUMID-AIR DENSITY

!OUTPUT: 
!KAPPA_T = (1/D) * (DD/DP)_A,T  ISOTHERMAL COMPRESSIBILITY IN 1/PA

!INPUT:  
!A_SI      MASS FRACTION OF DRY AIR IN HUMID AIR
!T_SI      ABSOLUTE TEMPERATURE IN K
!D_SI      HUMID-AIR DENSITY IN KG/M3

!CHECK VALUE, V1.0: air_f_kappa_t_si(0.9,300,1) = 1.09953341546E-05
!CHECK VALUE, V1.1: air_f_kappa_t_si(0.9,300,1) = 1.09975521396E-05

real*8 :: air_f_kappa_t_si
real*8 :: a_si, t_si, d_si
real*8 :: f_d, f_dd, x

air_f_kappa_t_si = errorreturn

f_d = air_f_si(0, 0, 1, a_si, t_si, d_si)
if (f_d == errorreturn) return
f_dd = air_f_si(0, 0, 2, a_si, t_si, d_si)
if (f_dd == errorreturn) return

x = d_si ** 2 * (2d0 * f_d + d_si * f_dd)
if (x == 0d0) return

air_f_kappa_t_si = 1d0 / x

end function

!==========================================================================
function air_f_lapserate_si(a_si, t_si, d_si)
!==========================================================================

!THIS FUNCTION COMPUTES THE "DRY" ADIABATIC LAPSE RATE OF HUMID AIR
!FROM THE MASS FRACTION OF AIR, TEMPERATURE AND HUMID-AIR DENSITY

!OUTPUT: 
!GAMMA = (DT/DP)_A_ETA  "DRY" ADIABATIC LAPSE RATE IN K/PA

!INPUT:  
!A_SI      MASS FRACTION OF DRY AIR IN HUMID AIR
!T_SI      ABSOLUTE TEMPERATURE IN K
!D_SI      HUMID-AIR DENSITY IN KG/M3

!CHECK VALUE, V1.0: air_f_lapserate_si(0.9,300,1) = 8.50216520413E-04
!CHECK VALUE, V1.1: air_f_lapserate_si(0.9,300,1) = 8.50371537341E-04

real*8 :: air_f_lapserate_si
real*8 :: a_si, t_si, d_si
real*8 :: f_d, f_tt, f_td, f_dd, x

air_f_lapserate_si = errorreturn

f_d = air_f_si(0, 0, 1, a_si, t_si, d_si)
if (f_d == errorreturn) return
f_tt = air_f_si(0, 2, 0, a_si, t_si, d_si)
if (f_tt == errorreturn) return
f_td = air_f_si(0, 1, 1, a_si, t_si, d_si)
if (f_td == errorreturn) return
f_dd = air_f_si(0, 0, 2, a_si, t_si, d_si)
if (f_dd == errorreturn) return

x = d_si * (f_tt * (2d0 * f_d + d_si * f_dd) - d_si * f_td ** 2)
if (x == 0d0) return

air_f_lapserate_si = -f_td / x

end function

!==========================================================================
function air_f_pressure_si(a_si, t_si, d_si)
!==========================================================================

!THIS FUNCTION COMPUTES THE PRESSURE OF HUMID AIR
!FROM THE MASS FRACTION OF AIR, TEMPERATURE AND HUMID-AIR DENSITY

!OUTPUT: 
!P = D^2*(DF/DD) PRESSURE IN PA

!INPUT:  
!A_SI      MASS FRACTION OF DRY AIR IN HUMID AIR
!T_SI      ABSOLUTE TEMPERATURE IN K
!D_SI      HUMID-AIR DENSITY IN KG/M3

!CHECK VALUE, V1.0: air_f_pressure_si(0.9,300,1) = 91193.7358460
!CHECK VALUE, V1.1: air_f_pressure_si(0.9,300,1) = 91175.3848662

real*8 :: air_f_pressure_si
real*8 :: a_si, t_si, d_si
real*8 :: f_d

air_f_pressure_si = errorreturn

f_d = air_f_si(0, 0, 1, a_si, t_si, d_si)
if (f_d == errorreturn) return

air_f_pressure_si = d_si ** 2 * f_d

end function

!==========================================================================
function air_f_soundspeed_si(a_si, t_si, d_si)
!==========================================================================

!THIS FUNCTION COMPUTES THE SOUND SPEED IN HUMID AIR
!FROM THE MASS FRACTION OF AIR, TEMPERATURE AND HUMID-AIR DENSITY

!OUTPUT: 
!C = SQRT[(DP/DD)_A_ETA]  SOUND SPEED IN M/S

!INPUT:  
!A_SI      MASS FRACTION OF DRY AIR IN HUMID AIR
!T_SI      ABSOLUTE TEMPERATURE IN K
!D_SI      HUMID-AIR DENSITY IN KG/M3

!CHECK VALUE, V1.0: air_f_soundspeed_si(0.9,300,1) = 351.853974518
!CHECK VALUE, V1.1: air_f_soundspeed_si(0.9,300,1) = 351.817577078

real*8 :: air_f_soundspeed_si
real*8 :: a_si, t_si, d_si
real*8 :: f_d, f_tt, f_td, f_dd, x

air_f_soundspeed_si = errorreturn

f_d = air_f_si(0, 0, 1, a_si, t_si, d_si)
if (f_d == errorreturn) return
f_tt = air_f_si(0, 2, 0, a_si, t_si, d_si)
if (f_tt == errorreturn) return
f_td = air_f_si(0, 1, 1, a_si, t_si, d_si)
if (f_td == errorreturn) return
f_dd = air_f_si(0, 0, 2, a_si, t_si, d_si)
if (f_dd == errorreturn) return

if (f_tt == 0d0) return
x = 2d0 * d_si * f_d + d_si ** 2 * (f_dd - f_td ** 2 / f_tt)
if (x < 0d0) return

air_f_soundspeed_si = sqrt(x)

end function


!=========================================================================
subroutine chk_iapws10_table(number)
!=========================================================================

!THIS SUBROUTINE PRINTS SELECTED CHECK TABLES OF IAPWS-10
!FOR EASY VERIFICATION OF THIS IMPLEMENTATION ON A GIVEN PLATFORM

!GUIDELINE ON AN EQUATION OF STATE FOR HUMID AIR IN CONTACT WITH SEAWATER AND ICE,
!CONSISTENT WITH THE IAPWS FORMULATION 2008 FOR THE THERMODYNAMIC PROPERTIES OF SEAWATER
!THE INTERNATIONAL ASSOCIATION FOR THE PROPERTIES OF WATER AND STEAM
!NIAGARA FALLS, CANADA, SEPTEMBER 2010 IN PREPARATION

integer number

select case (number)
  case(13); call chk_iapws10_table13()
  case(14); call chk_iapws10_table14()
  case(15); call chk_iapws10_table15()
  case default; write(*,*) "Tables 13, 14 and 15 are implemented here"; return
end select

end subroutine


!=========================================================================
subroutine chk_iapws10_table13()
!=========================================================================

!TABLE 13:  NUMERICAL CHECK VALUES FOR THE HELMHOLTZ FUNCTION F AND ITS DERIVATIVES,
!TABLE 6, FOR SATURATED AIR, WITH RESPECT TO ICE AT 200 K, AND WITH RESPECT TO LIQUID 
!WATER AT 300 AND 400 K. THE NUMERICAL FUNCTIONS EVALUATED HERE AT GIVEN POINTS
!(A, T, D) ARE DEFINED IN TABLES 5, 6 AND 12.
!
!Quantity       Value               Value              Value              Unit
!
!A              0.892247719         0.977605798        0.825565291        kg kg-1
!T              200                 300                400                K
!d              0.163479657E-4      0.114614216E+1     0.793354063E+1     kg m-3
!p              0.999999998         0.100000000E+6     0.100000000E+7     Pa
!fAV           -0.682093392E+6     -0.927718178E+5     0.240345570E+5     J kg-1
!(df/dA)_T,d   -0.572680404E+6     -0.263453864E+3     0.311096733E+6     J kg-1
!(df/dT)_A,d   -0.405317966E+4     -0.296711481E+3    -0.106891931E+4     J kg-1
!(df/dd)_A,T    0.374173101E+10     0.761242496E+5     0.158878781E+5     m3 kg-1
!(d2f/dA2)_T,d  0.920967684E+6      0.624886233E+7     0.113786423E+7     J kg-1
!(d2f/dAdT)_d   0.915653743E+4      0.822733446E+4     0.702631471E+4     J kg-1
!(d2f/dAdd)    -0.213442099E+10    -0.450004399E+5    -0.727972651E+4     m3 kg-1
!(d2f/dT2)_d   -0.394011921E+1     -0.244742952E+1    -0.222449294E+1     J kg-1
!(d2f/dTdd)     0.187087034E+8      0.254456302E+3     0.414350772E+2     m3 kg-1
!(d2f/dd2)_T   -0.228880603E+15    -0.664465525E+5    -0.201886184E+4     m3 kg-1
!h              0.189712231E+6      0.834908383E+5     0.577649408E+6     J kg-1
!g             -0.620923701E+6     -0.552260595E+4     0.150081684E+6     J kg-1
!s              0.405317966E+4      0.296711481E+3     0.106891931E+4     J kg-1
!muW           -0.109950917E+6     -0.526505193E+4    -0.106748981E+6     J kg-1
!cp             0.109387397E+4      0.102681324E+4     0.123552454E+4     J kg-1
!w              0.291394959E+3      0.349234196E+3     0.416656820E+3     m s-1
!

real*8 a, t, d, q(3)
integer i, j

                                            
write(*,*) " "
write(*,*) " "
write(*,*) " "
write(*,*) "****************************************************************"
write(*,*) "****************************************************************"
write(*,*) "****************************************************************"
write(*,*) " "
write(*,*) " Implementation of IAPWS-10 in Fortran"
write(*,*) " for Publication in Ocean Science, 2009"
write(*,*) " D. Wright, BIO, VERSION ", version
write(*,*) " "
write(*,*) " NUMERICAL CHECK VALUES FOR THE HELMHOLTZ FUNCTION AND ITS DERIVATIVES"
write(*,*) " FOR SATURATED AIR, WRT ICE AT 200 K AND WRT LIQUID WATER AT 300 AND 400 K"
write(*,*) " FUNCTION VALUES AS GIVEN IN TABLE 13 OF IAPWS-10."
write(*,*) " TOP ROW GIVES TABULATED VALUES, BOTTOM ROW COMPUTED NOW"
write(*,*) " "

write(*,*)               "Quantity        Value            Value            Value           Unit"
write(*,*) " "

do i = 1, 20
  select case(i)
    case(1);  write(*,*) "A               0.892247719      0.977605798      0.825565291     kg kg-1"
    case(2);  write(*,*) "T               200              300              400             K"
    case(3);  write(*,*) "d               0.163479657E-4   0.114614216E+1   0.793354063E+1  kg m-3"
    case(4);  write(*,*) "p               0.999999998      0.100000000E+6   0.100000000E+7  Pa"
    case(5);  write(*,*) "f              -0.682093392E+6  -0.927718178E+5   0.240345570E+5  J kg-1"
    case(6);  write(*,*) "(df/dA)_T,d    -0.572680404E+6  -0.263453864E+3   0.311096733E+6  J kg-1"
    case(7);  write(*,*) "(df/dT)_A,d    -0.405317966E+4  -0.296711481E+3  -0.106891931E+4  J kg-1"
    case(8);  write(*,*) "(df/dd)_A,T     0.374173101E+10  0.761242496E+5   0.158878781E+5  m3 kg-1"
    case(9);  write(*,*) "(d2f/dA2)_T,d   0.920967684E+6   0.624886233E+7   0.113786423E+7  J kg-1"
    case(10); write(*,*) "(d2f/dAdT)_d    0.915653743E+4   0.822733446E+4   0.702631471E+4  J kg-1"
    case(11); write(*,*) "(d2f/dAdd)_T   -0.213442099E+10 -0.450004399E+5  -0.727972651E+4  m3 kg-1"
    case(12); write(*,*) "(d2f/dT2)_d    -0.394011921E+1  -0.244742952E+1  -0.222449294E+1  J kg-1"
    case(13); write(*,*) "(d2f/dTdd)      0.187087034E+8   0.254456302E+3   0.414350772E+2  m3 kg-1"
    case(14); write(*,*) "(d2f/dd2)_T    -0.228880603E+15 -0.664465525E+5  -0.201886184E+4  m3 kg-1"
    case(15); write(*,*) "h               0.189712231E+6   0.834908383E+5   0.577649408E+6  J kg-1"
    case(16); write(*,*) "g              -0.620923701E+6  -0.552260595E+4   0.150081684E+6  J kg-1"
    case(17); write(*,*) "s               0.405317966E+4   0.296711481E+3   0.106891931E+4  J kg-1"
    case(18); write(*,*) "muW            -0.109950917E+6  -0.526505193E+4  -0.106748981E+6  J kg-1"
    case(19); write(*,*) "cp              0.109387397E+4   0.102681324E+4   0.123552454E+4  J kg-1"
    case(20); write(*,*) "w               0.291394959E+3   0.349234196E+3   0.416656820E+3  m s-1"
  end select

  do j = 1, 3
    if(j == 1)then
       a = 0.892247719d0
       t = 200d0
       d = 0.163479657d-4
    elseif (j == 2) then
       a = 0.977605798d0
       t = 300d0
       d = 0.114614216d+1
    elseif(j == 3) then
       a = 0.825565291d0
       t = 400d0
       d = 0.793354063d+1
    endif
    q(j) = 0d0
    select case(i)
      case(1); q(j) = a
      case(2); q(j) = t
      case(3); q(j) = d
      case(4); q(j) = air_f_pressure_si(a, t, d)
      case(5); q(j) = air_f_si(0, 0, 0, a, t, d)
      case(6); q(j) = air_f_si(1, 0, 0, a, t, d)
      case(7); q(j) = air_f_si(0, 1, 0, a, t, d)
      case(8); q(j) = air_f_si(0, 0, 1, a, t, d)
      case(9); q(j) = air_f_si(2, 0, 0, a, t, d)
      case(10); q(j) = air_f_si(1, 1, 0, a, t, d)
      case(11); q(j) = air_f_si(1, 0, 1, a, t, d)
      case(12); q(j) = air_f_si(0, 2, 0, a, t, d)
      case(13); q(j) = air_f_si(0, 1, 1, a, t, d)
      case(14); q(j) = air_f_si(0, 0, 2, a, t, d)
      case(15); q(j) = air_f_enthalpy_si(a, t, d)
      case(16); q(j) = air_f_gibbs_energy_si(a, t, d)
      case(17); q(j) = air_f_entropy_si(a, t, d)
      case(18); q(j) = air_f_gibbs_energy_si(a, t, d)
                if(a > 0d0) q(j) = q(j) - a * air_f_si(1, 0, 0, a, t, d)
      case(19); q(j) = air_f_cp_si(a, t, d)
      case(20); q(j) = air_f_soundspeed_si(a, t, d)
    end select
  enddo
  write(*,'( 16x, E16.9,x,E16.9,x,E16.9)')q(1), q(2), q(3)
  write(*,*)' '
enddo
write(*,*)' '
write(*,*)' '
write(*,*)' '

end subroutine

!=========================================================================
subroutine chk_iapws10_table14()
!=========================================================================

!TABLE 14  Numerical check values for the dry-air and water-vapour parts of
!the Helmholtz function f and its derivatives, Table 6, for saturated air, 
!A = Asat, with respect to ice at 200 K, and with respect to liquid water 
!at 300 and 400 K. The numerical functions evaluated here at given
!points (A, T, d) are defined in Tables 7 and 8.
 
!Quantity         Value               Value              Value              Unit
!A                0.892224944         0.977600624        0.825531379        kg kg-1
!T                200                 300                400                K
!d                0.163445112E-04     0.114587678E+1    0.793198757E+1    kg m-3
!Ad               0.145829805901E-4   0.112020985516E+1  0.654810463687E+1  kg m-3
!fA              -0.740041144E+6     -0.916103453E+5     0.895561286E+5     J kg-1
!(dfA/dT)_dA     -0.304774177E+4     -0.108476220E+3     0.193271394E+3     J kg-1 K-1
!(dfA/ddA)_T      0.393583654E+10     0.768326795E+5     0.175560114E+5     m3 kg-1
!(d2fA/dT2)_dA   -0.357677878E+1     -0.239319940E+1    -0.181809877E+1     J kg-1 K-2
!(d2fA/dTddA)     0.196791837E+8      0.256683306E+3     0.442769673E+2     m3 kg-1 K-1
!(d2fA/(ddA)2)_T -0.269828549E+15    -0.685917373E+5    -0.267635928E+4     m3 kg-1 Pa-1
!(1-A)d           0.176153059E-5      0.256669391E-1     0.138388485E+1     kg m-3`
!fV              -0.202254351E+6     -0.143157426E+6    -0.285137534E+6     J kg-1
!(dfV/dT)_Ad     -0.123787544E+5     -0.851598213E+4    -0.705288048E+4     J kg-1 K-1
!(dfV/ddV)_T      0.523995674E+11     0.538480619E+7     0.129645039E+6     m3 kg-1
!(d2fV/dT2)_Ad   -0.694877601E+1     -0.480817011E+1    -0.411710659E+1     J kg-1 K-2
!(d2fV/dTddV)     0.262001885E+9      0.181489502E+5     0.361784086E+3     m3 kg-1 K-1
!(d2fV/(ddV)2)_T -0.297466671E+17    -0.210184992E+9    -0.965539462E+5     m3 kg-1 Pa-1

real*8  a, t, d, q(3)
integer i, j

a = errorreturn
t = errorreturn
d = errorreturn

write(*,*) " "
write(*,*) " "
write(*,*) " "
write(*,*) "****************************************************************"
write(*,*) "****************************************************************"
write(*,*) "****************************************************************"
write(*,*) " "
write(*,*) " Implementation of IAPWS-10 in Fortran"
write(*,*) " for Publication in Ocean Science, 2009"
write(*,*) " D. Wright, BIO, VERSION ", version
write(*,*) " "
write(*,*) " NUMERICAL CHECK VALUES FOR THE DRY-AIR AND WATER VAPOUR PARTS OF THE"
write(*,*) " HELMHOLTZ FUNCTION OF SATURATED AIR, AND ITS DERIVATIVES"
write(*,*) " WRT ICE at 200 K AND WRT LIQUID WATER at 300 AND 400 K"
write(*,*) " FUNCTION VALUES AS GIVEN IN TABLE 14 OF IAPWS-10:"
write(*,*) " TOP ROW GIVES TABULATED VALUES, BOTTOM ROW COMPUTED NOW"
write(*,*) " "

write(*,*)               "Quantity         Value            Value            Value           Unit"
write(*,*) " "

do i = 1, 17
  select case(i)
    case(1);  write(*,*) "A                0.892247719      0.977605798      0.825565291     kg kg-1"
    case(2);  write(*,*) "T                200              300              400             K"
    case(3);  write(*,*) "d                0.163479657E-4   0.114614216E+1   0.793354063E+1  kg m-3"
    case(4);  write(*,*) "dA = d*A         0.145864351E-4   0.112047522E+1   0.654965578E+1  kg m-3"
    case(5);  write(*,*) "fA              -0.740041144E+6  -0.916103453E+5   0.895561286E+5  J kg-1"
    case(6);  write(*,*) "(dfA/dT)_dA     -0.304774177E+4  -0.108476220E+3   0.193271394E+3  J kg-1 K-1"
    case(7);  write(*,*) "(dfA/ddA)_T      0.393583654E+10  0.768326795E+5   0.175560114E+5  m3 kg-1"
    case(8);  write(*,*) "(d2fA/dT2)_dA   -0.357677878E+1  -0.239319940E+1  -0.181809877E+1  J kg-1 K-2"
    case(9);  write(*,*) "(d2fA/dTddA)     0.196791837E+8   0.256683306E+3   0.442769673E+2  m3 kg-1 K-1"
    case(10); write(*,*) "(d2fA/(ddA)2)_T -0.269828549E+15 -0.685917373E+5  -0.267635928E+4  m3 kg-1 Pa-1"
    case(11); write(*,*) "(1-A)d           0.176153059E-5   0.256669391E-1   0.138388485E+1  kg m-3"
    case(12); write(*,*) "fV              -0.202254351E+6  -0.143157426E+6  -0.285137534E+6  J kg-1"
    case(13); write(*,*) "(dfV/dT)_Ad     -0.123787544E+5  -0.851598213E+4  -0.705288048E+4  J kg-1 K-1"
    case(14); write(*,*) "(dfV/ddV)_T      0.523995674E+11  0.538480619E+7   0.129645039E+6  m3 kg-1"
    case(15); write(*,*) "(d2fV/dT2)_Ad   -0.694877601E+1  -0.480817011E+1  -0.411710659E+1  J kg-1 K-2"
    case(16); write(*,*) "(d2fV/dTddV)     0.262001885E+9   0.181489502E+5   0.361784086E+3  m3 kg-1 K-1"
    case(17); write(*,*) "(d2fV/(ddV)2)_T -0.297466671E+17 -0.210184992E+9  -0.965539462E+5  m3 kg-1 Pa-1"
  end select

  do j = 1, 3
    if(j == 1) then
       a = 0.892247719d0
       t = 200d0
       d = 0.163479657d-4
    elseif(j == 2) then
       a = 0.977605798d0
       t = 300d0
       d = 0.114614216d1
    elseif(j == 3) then
       a = 0.825565291d0
       t = 400d0
       d = 0.793354063d1
    endif
    q(j) = 0d0
    select case(i)
      case(1); q(j) = a
      case(2); q(j) = t
      case(3); q(j) = d
      case(4); q(j) = a * d
      case(5); q(j) = dry_f_si(0, 0, t, a*d)
      case(6); q(j) = dry_f_si(1, 0, t, a*d)
      case(7); q(j) = dry_f_si(0, 1, t, a*d)
      case(8); q(j) = dry_f_si(2, 0, t, a*d)
      case(9); q(j) = dry_f_si(1, 1, t, a*d)
      case(10); q(j) = dry_f_si(0, 2, t, a*d)
      case(11); q(j) = (1d0 - a)*d
      case(12); q(j) = flu_f_si(0, 0, t, (1d0 - a) * d)
      case(13); q(j) = flu_f_si(1, 0, t, (1d0 - a) * d)
      case(14); q(j) = flu_f_si(0, 1, t, (1d0 - a) * d)
      case(15); q(j) = flu_f_si(2, 0, t, (1d0 - a) * d)
      case(16); q(j) = flu_f_si(1, 1, t, (1d0 - a) * d)
      case(17); q(j) = flu_f_si(0, 2, t, (1d0 - a) * d)
    end select
  enddo
  write(*,'(17x, E16.9,x,E16.9,x,E16.9)') q(1), q(2), q(3)
  write(*,*)' '
  
enddo
write(*,*)' '
write(*,*)' '
write(*,*)' '

end subroutine


!=========================================================================
subroutine chk_iapws10_table15()
!=========================================================================

!TABLE 15  Numerical check values for the cross-virial part, fmix, and the cross-virial
!coefficients, BAW, CAAW, CAWW, of the Helmholtz function, fav, and its derivatives,
!Table 6, for saturated air, A = Asat, with respect to ice at 200 K, and with respect
!to liquid water at 300 and 400 K. The numerical functions evaluated here at given
!points (A, T, d) are defined in Tables 10 and 11.
 
!Quantity         Value               Value               Value              Unit
!A                0.892224944         0.977600624         0.825531379        kg kg-1
!T                200                 300                 400                K
!D                0.163445112E-04     0.114587678E+1      0.793198757E+1     kg m-3"
!fM              -0.786211837111E-3  -0.711673565972E+1	 -0.161985033872E+3  J kg-1
!(dfM/dA)_T,d     0.641377589024E-2   0.311768500757E+3	  0.830802876130E+3  J kg-1
!(dfM/dT)_A,d     0.456427011454E-5   0.441245367098E-1	  0.178961265299E+1  J kg-1 K-1
!(dfM/dd)_A,T    -0.481026562160E+2  -0.623171267739E+1	 -0.223365431713E+2  m3 kg-1
!(d2fM/dA2)_T,d   0.163518396765E-1   0.534139178420E+3   0.135815609516E+4  J kg-1
!(d2fM/dAdT)_d   -0.372355250910E-4  -0.195026097643E+1	 -0.916586082354E+1  J kg-1 K-1
!(d2fM/dAdd)_T    0.392414346187E+3   0.274152648677E+3	  0.125823777783E+3  m3 kg-1
!(d2fM/dT2)_A,d  -0.378866038500E-7  -0.148782305257E-3	 -0.536718535916E-2  J kg-1 K-2
!(d2fM/dTdd)_A    0.279261664337      0.390100461800E-1	  0.249618216264     m3 kg-1 K-1
!(d2fM/dd2)_A,T  -0.192118914304E+2  -0.366162709444E-1	 -0.482803925450     m3 kg-1 Pa-1
!BAW             -0.784874277752E-4  -0.295672747428E-4	 -0.100804610474E-4  m3 mol-1
!BAW_T            0.848076624222E-6   0.280097360438E-6	  0.135021228495E-6  m3 mol-1 K-1
!BAW_TT          -0.122622146106E-7  -0.242599241306E-8	 -0.839901728946E-9  m3 mol-1 K-2
!CAAW             0.105493575000E-8   0.801977740741E-9	  0.672018171875E-9  m6 mol-2
!CAAW_T          -0.152535000000E-11 -0.196103456790E-11 -0.812416406250E-12 m6 mol-2 K-1
!CAAW_TT         -0.113436375000E-12  0.170055637860E-13  0.683147460938E-14 m6 mol-2 K-2
!CAWW            -0.349872634207E-5  -0.115552783680E-6	 -0.200806020909E-7  m6 mol-2
!CAWW_T           0.188025052349E-6   0.261363277754E-8	  0.274535402840E-9  m6 mol-2 K-1
!CAWW_TT         -0.124996855887E-7  -0.751334581804E-10 -0.491763909891E-11 m6 mol-2 K-2

real*8  a, t, d, q(3)
integer i, j

                                            
write(*,*) " "
write(*,*) " "
write(*,*) " "
write(*,*) "****************************************************************"
write(*,*) "****************************************************************"
write(*,*) "****************************************************************"
write(*,*) " "
write(*,*) " Implementation of IAPWS-10 in Fortran"
write(*,*) " for Publication in Ocean Science, 2009"

write(*,*) " Function values as given in Table 15 of IAPWS-10:"
write(*,*) " TOP ROW GIVES TABULATED VALUES, BOTTOM ROW COMPUTED NOW"
write(*,*) " "

write(*,*)              "Quantity        Value            Value            Value            Unit"

do i = 1, 20
  select case(i)
    case(1);  write(*,*)"A               0.892224944      0.977600624      0.825531379      kg kg-1"
    case(2);  write(*,*)"T               200              300              400              K"
    case(3);  write(*,*)"d               0.163445112E-4   0.114587678E+1   0.793198757E+1   kg m-3"
    case(4);  write(*,*)"fM             -0.786211837E-3  -0.711673566E+1  -0.161985034E+3   J kg-1"
    case(5);  write(*,*)"(dfm/dA)_T,d    0.641377589E-2   0.311768501E+3   0.830802876E+3   J kg-1"
    case(6);  write(*,*)"(dfm/dT)_A,d    0.456427011E-5   0.441245368E-1   0.178961265E+1   J kg-1 K-1"
    case(7);  write(*,*)"(dfm/dd)_A,T   -0.481026562E+2  -0.623171268E+1  -0.223365432E+2   m3 kg-1"
    case(8);  write(*,*)"(d2fm/dA2)_T,d  0.163518397E-1   0.534139178E+3   0.135815610E+4   J kg-1"
    case(9);  write(*,*)"(d2fm/dAdT)_d  -0.372355251E-4  -0.195026098E+1  -0.916586082E+1   J kg-1 K-1"
    case(10); write(*,*)"(d2fm/dAdd)_T   0.392414346E+3   0.274152649E+3   0.125823778E+3   m3 kg-1"
    case(11); write(*,*)"(d2fm/dT2)_A,d -0.378866039E-7  -0.148782305E-3  -0.536718536E-2   J kg-1 K-2"
    case(12); write(*,*)"(d2fm/dTdd)_A   0.279261664      0.390100462E-1   0.249618216      m3 kg-1 K-1"
    case(13); write(*,*)"(d2fm/dd2)_A,T -0.192118914E+2  -0.366162709E-1  -0.482803925      m3 kg-1 Pa-1"
    case(14); write(*,*)"BAW            -0.784874278E-4  -0.295672747E-4  -0.100804610E-4   m3 mol-1"
    case(15); write(*,*)"BAW_T           0.848076624E-6   0.280097360E-6   0.135021228E-6   m3 mol-1 K-1"
    case(16); write(*,*)"BAW_TT         -0.122622146E-7  -0.242599241E-8  -0.839901729E-9   m3 mol-1 K-2"
    case(17); write(*,*)"CAAW            0.105493575E-8   0.801977741E-9   0.672018172E-9   m6 mol-2"
    case(18); write(*,*)"CAAW_T         -0.152535000E-11 -0.196103457E-11 -0.812416406E-12  m6 mol-2 K-1"
    case(19); write(*,*)"CAAW_TT        -0.113436375E-12  0.170055638E-13  0.683147461E-14  m6 mol-2 K-2"
    case(20); write(*,*)"CAWW           -0.349872634E-5  -0.115552784E-6  -0.200806021E-7   m6 mol-2"
    case(21); write(*,*)"CAWW_T          0.188025052E-6   0.261363278E-8   0.274535403E-9   m6 mol-2 K-1"
    case(22); write(*,*)"CAWW_TT        -0.124996856E-7  -0.751334582E-10 -0.491763910E-11  m6 mol-2 K-2"
  end select

  do j = 1, 3
    if(j == 1) then
       a = 0.892224944d0
       t = 200d0
       d = 0.0000163445112d0
    elseif(j == 2) then
       a = 0.977600624d0
       t = 300d0
       d = 1.14587678d0
    elseif(j == 3) then
       a = 0.825531379d0
       t = 400d0
       d = 7.93198757d0
    endif
    q(j) = 0d0
    select case(i)
      case(1); q(j) = a
      case(2); q(j) = t
      case(3); q(j) = d
      case(4); q(j) = air_f_mix_si(0, 0, 0, a, t, d)
      case(5); q(j) = air_f_mix_si(1, 0, 0, a, t, d)
      case(6); q(j) = air_f_mix_si(0, 1, 0, a, t, d)
      case(7); q(j) = air_f_mix_si(0, 0, 1, a, t, d)
      case(8); q(j) = air_f_mix_si(2, 0, 0, a, t, d)
      case(9); q(j) = air_f_mix_si(1, 1, 0, a, t, d)
      case(10); q(j) = air_f_mix_si(1, 0, 1, a, t, d)
      case(11); q(j) = air_f_mix_si(0, 2, 0, a, t, d)
      case(12); q(j) = air_f_mix_si(0, 1, 1, a, t, d)
      case(13); q(j) = air_f_mix_si(0, 0, 2, a, t, d)
      case(14); q(j) = air_baw_m3mol(0, t)
      case(15); q(j) = air_baw_m3mol(1, t)
      case(16); q(j) = air_baw_m3mol(2, t)
      case(17); q(j) = air_caaw_m6mol2(0, t)
      case(18); q(j) = air_caaw_m6mol2(1, t)
      case(19); q(j) = air_caaw_m6mol2(2, t)
      case(20); q(j) = air_caww_m6mol2(0, t)
      case(21); q(j) = air_caww_m6mol2(1, t)
      case(22); q(j) = air_caww_m6mol2(2, t)
    end select
  enddo
  write(*,'(16x, E16.9,x,E16.9,x,E16.9)') q(1), q(2), q(3)
  write(*,*)' '
  
enddo
write(*,*)' '
write(*,*)' '
write(*,*)' '

end subroutine

end module air_2

module sea_3d

!#########################################################################

!THIS MODULE COMPUTES THE PROPERTIES OF SEAWATER AS FUNCTIONS OF TEMPERATURE,
!PRESSURE AND DENSITY, IN PARTICULAR, THE ABSOLUTE SALINITY

!IMPLEMENTATION IN FORTRAN BY D.G. WRIGHT
!FOR PUBLICATION IN OCEAN SCIENCE, AS DESCRIBED IN THE PAPERS

!FEISTEL, R., WRIGHT, D.G., JACKETT, D.R., MIYAGAWA, K., REISSMANN, J.H.,
!WAGNER, W., OVERHOFF, U., GUDER, C., FEISTEL, A., MARION, G.M.:
!NUMERICAL IMPLEMENTATION AND OCEANOGRAPHIC APPLICATION OF THE THERMODYNAMIC
!POTENTIALS OF WATER, VAPOUR, ICE, SEAWATER AND AIR. PART I: BACKGROUND AND EQUATIONS.
!OCEAN SCIENCES, 2009, IN PREPARATION.

!WRIGHT, D.G., FEISTEL, R., JACKETT, D.R., MIYAGAWA, K., REISSMANN, J.H.,
!WAGNER, W., OVERHOFF, U., GUDER, C., FEISTEL, A., MARION, G.M.:
!NUMERICAL IMPLEMENTATION AND OCEANOGRAPHIC APPLICATION OF THE THERMODYNAMIC
!POTENTIALS OF WATER, VAPOUR, ICE, SEAWATER AND AIR. PART II: THE LIBRARY ROUTINES,
!OCEAN SCIENCES., 2009, IN PREPARATION.

!#########################################################################

!THIS MODULE REQUIRES THE LIBRARY MODULES:
!     CONSTANTS_0,   FILE CONSTANTS_0.F90
!     CONVERT_0,     FILE CONVERT_0.F90
!     MATHS_0,       FILE MATHS_0.F90
!     FLU_1,         FILE FLU_1.F90
!     SAL_1,         FILE SAL_1.F90
!     SAL_2,         FILE SAL_2.F90
!     FLU_3A,        FILE FLU_3A.F90

!#########################################################################

use constants_0
use sal_2
use flu_3a

implicit none
private

character*16, private :: version = '8 Jun 2010'

public :: sea_sa_si, set_it_ctrl_salinity

!CONTROL PARAMETERS OF THE SALINITY ITERATION
integer ctrl_initialized

integer ctrl_mode_salinity
integer ctrl_loop_maximum
real*8 ctrl_init_salinity
real*8 ctrl_eps_exit_salinity

contains

!=========================================================================
function sea_sa_si(t_si, p_si, d_si)
!==========================================================================

!THIS FUNCTION COMPUTES THE ABSOLUTE SALINITY SA_SI IN KG/KG FROM
!THE ABSOLUTE TEMPERATURE T_SI IN K, THE ABSOLUTE PRESSURE P_SI IN PA
!AND THE SEAWATER DENSITY D_SI IN KG/M3

!CHECK VALUE WITH DEFAULT SETTINGS:
!SEA_SA_SI(273.15, 101325, 1028) = 3.50315257709E-02

implicit none

integer maxit
real*8 s, eps, sea_sa_si, t_si, p_si, d_si

sea_sa_si = errorreturn

if(t_si <= 0d0 .or. &
  p_si <= 0d0 .or. &
  d_si <= 0d0) return

call init_it_ctrl_salinity

Select Case (ctrl_mode_salinity)
  Case (0);     s = SO_salinity_si
  Case Default; s = ctrl_init_salinity
End Select

if(ctrl_loop_maximum == 0)then
  maxit = 100
elseif(ctrl_loop_maximum == -1)then
  sea_sa_si = s; return
elseif(ctrl_loop_maximum > 0)then
  maxit = ctrl_loop_maximum
else
  return
endif

eps = ctrl_eps_exit_salinity
if(eps == 0d0)return

!RUN THE ITERATION
sea_sa_si = salinity_iteration(t_si, p_si, d_si, s, maxit, eps)

end function

!=========================================================================
function salinity_iteration(t_si, p_si, d_si, s, maxit, eps)
!==========================================================================

!THIS FUNCTION CALCULATES THE ABSOLUTE SALINITY S FROM GIVEN VALUES
!OF THE ABSOLUTE TEMPERATURE, T_SI, IN K, ABSOLUTE PRESSURE, P_SI,
!IN PA AND THE SEAWATER DENSITY, D_SI, IN KG/M3

!OUTPUT: SALINITY_ITERATION IS THE RESULT FOR THE ABSOLUTE SALINITY IN KG/KG

!INPUT: T_SI:  ABSOLUTE TEMPERATURE IN K
!       P_SI:  ABSOLUTE PRESSURE IN PA
!       D_SI:  SEAWATER DENSITY IN KG/M3
!       S:     INITIAL SALINITY ESTIMATE IN KG/KG
!       MAXIT: MAXIUMUM NUMBER OF ITERATION STEPS
!       EPS:   SALINITY TOLERANCE, EPS < 0 MEANS RELATIVE ERROR

implicit none

integer it, maxit
real*8 salinity_iteration, t_si, p_si, d_si, s, eps
real*8 ds, dv, gs_p, gs_sp

salinity_iteration = errorreturn

if(eps <= 0d0) return
if(maxit <= 0d0) return

if(check_limits == 1) then
  !FLU_LIMITS
  if(t_si < flu_tmin .or. t_si > flu_tmax .or. &
  d_si < flu_dmin .or. d_si > flu_dmax) return
  !SAL_LIMITS
  if(t_si < sal_tmin .or. t_si > sal_tmax .or. &
  p_si < sal_pmin .or. p_si > sal_pmax) return
else
  if(t_si <= 0d0 .or. &
  p_si <= 0d0 .or. &
  d_si <= 0d0) return
endif

check_limits = check_limits - 1

!PURE WATER DENSITY
dv = liq_density_si(t_si, p_si)
If(dv == errorreturn .or. dv == 0) go to 999

!SALINE PART OF THE GIVEN SPECIFIC VOLUME
dv = 1d0 / d_si - 1d0 / dv

do it = 1, maxit

  !DERIVATIVES FOR NEWTON ITERATION
  gs_p = sal_g_si(0, 0, 1, s, t_si, p_si)
  If(gs_p == errorreturn) go to 999
  gs_sp = sal_g_si(1, 0, 1, s, t_si, p_si)
  If(gs_sp == errorreturn) go to 999
  If(gs_sp == 0) go to 999
  

  !COMPUTE SALINITY CORRECTION
  ds = (dv - gs_p) / gs_sp
  !UPDATE SALINITY ESTIMATE
  s = s + ds
  If(s < 0 .or. s >= 1) go to 999
  
  If((eps > 0d0 .and. abs(ds) < eps) .or. &
     (eps < 0d0 .and. abs(ds) < eps * s)) Then
    salinity_iteration = s
    go to 999
  End If
  
enddo

999 continue

check_limits = check_limits + 1

if(check_limits == 1) then
  if(s < sal_smin .or. s > sal_smax) then
    salinity_iteration = errorreturn
  endif
endif

end function

!==========================================================================
subroutine init_it_ctrl_salinity()
!==========================================================================

implicit none

if(ctrl_initialized == -1) return

ctrl_initialized = -1

!SET DEFAULT VALUES AND MODES FOR SALINITY ITERATION
ctrl_loop_maximum = 100
ctrl_mode_salinity = 0                !DEFAULT: SA = SO_SALINITY_SI = 36.16504 G/KG
ctrl_init_salinity = SO_salinity_si
ctrl_eps_exit_salinity = 0.0000001d0  !DEFAULT = 0.0001 G/KG

end subroutine

!==========================================================================
subroutine set_it_ctrl_salinity(key, value)
!==========================================================================

!THIS SUB SETS CONTROL PARAMETERS FOR THE NEWTON ITERATION USED TO COMPUTE
!POTENTIAL TEMPERATURE FROM REFERENCE PRESSURE

!KEY             VALUE
!IT_STEPS        0           SET ITERATION NUMBER TO DEFAULT (100)
!IT_STEPS        N > 0       SET ITERATION NUMBER TO N
!IT_STEPS       -1           DO NOT ITERATE, USE INITIAL VALUE

!INIT_SA         0           USE DEFAULT SA = 35.16504 G/KG TO START
!INIT_SA         T > 0       USE VALUE S AS SALINITY TO START

!TOL_SA          0           USE DEFAULT EXIT ACCURACY FOR SALINITY (0.1 MK)
!TOL_SA          EPS > 0     USE EPS AS EXIT ACCURACY FOR SALINITY

implicit none
character*13 key
real*8 value

call init_it_ctrl_salinity

select case(trim(key))

  case("it_steps")                !ITERATION STEPS
    if(value == 0d0)then
      ctrl_loop_maximum = 100     !DEFAULT = 100
    elseif(value < 0d0)then
      ctrl_loop_maximum = -1
    else
      ctrl_loop_maximum = value
    endif

  case("init_sa")                 !START SALINITY
    if(value == 0)then
      ctrl_mode_salinity = 0      !DEFAULT: SA = 35.16504 G/KG
    elseif(value > 0)then
      ctrl_mode_salinity = 1
      ctrl_init_salinity = value
    endif

  case("tol_sa")                  !REQUIRED SALINITY TOLERANCE
      if(value == 0d0)then
        ctrl_eps_exit_salinity = 0.0000001d0 !DEFAULT = 0.1 MG/KG
      elseif(value > 0)then
        ctrl_eps_exit_salinity = value
      endif

  case default; write(*,*)key,' not supported'

end select

end subroutine

end module

module air_1  

!#########################################################################

!THIS MODULE IMPLEMENTS THE HELMHOLTZ POTENTIAL OF DRY AIR AND ITS
!FIRST AND SECOND PARTIAL DERIVATIVES WITH RESPECT TO TEMPERATURE AND
!DENSITY AS DEFINED IN:

!LEMMON, E.W., JACOBSEN, R.T., PENONCELLO, S.G., FRIEND, D.G.:
!THERMODYNAMIC PROPERTIES OF AIR AND MIXTURES OF NITROGEN, ARGON AND OXYGEN
!FROM 60 TO 2000 K AT PRESSURES TO 2000 MPA.
!J. PHYS. CHEM. REF. DATA 29(2000)331-362.

!THIS MODULE ALSO IMPLEMENTS THE CROSS-VIRIAL COEFFICIENTS OF HUMID AIR
!AND THEIR FIRST AND SECOND DERIVATIVES WITH RESPECT TO TEMPERATURE.

!THE 2ND MIXED VIRIAL COEFFICIENT IS DEFINED IN:

!HARVEY, A.H., HUANG, P.H.:  
!FIRST-PRINCIPLES CALCULATION OF THE AIR-WATER SECOND VIRIAL COEFFICIENT. 
!INT. J. THERMOPHYS. 28(2007),556-565.

!THE 3RD MIXED VIRIAL COEFFICIENTS ARE DEFINED IN:

!HYLAND, R.W., WEXLER, A.:
!FORMULATIONS FOR THE THERMODYNAMIC PROPERTIES OF DRY AIR FROM 173.15 K TO 473.15 K,
!AND OF SATURATED MOIST AIR FROM 173.15 K TO 372.15 K, AT PRESSURES UP TO 5 MPA.
!ASHRAE TRANSACT. 89(1983),520-535.

!#########################################################################

!IMPLEMENTATION IN FORTRAN BY D.G. WRIGHT
!FOR PUBLICATION IN OCEAN SCIENCE, AS DESCRIBED IN THE PAPERS

!FEISTEL, R., WRIGHT, D.G., JACKETT, D.R., MIYAGAWA, K., REISSMANN, J.H.,
!WAGNER, W., OVERHOFF, U., GUDER, C., FEISTEL, A., MARION, G.M.:
!NUMERICAL IMPLEMENTATION AND OCEANOGRAPHIC APPLICATION OF THE THERMODYNAMIC
!POTENTIALS OF WATER, VAPOUR, ICE, SEAWATER AND AIR. PART I: BACKGROUND AND EQUATIONS. 
!OCEAN SCIENCES, 2009, IN PREPARATION.

!WRIGHT, D.G., FEISTEL, R., JACKETT, D.R., MIYAGAWA, K., REISSMANN, J.H., 
!WAGNER, W., OVERHOFF, U., GUDER, C., FEISTEL, A., MARION, G.M.:
!NUMERICAL IMPLEMENTATION AND OCEANOGRAPHIC APPLICATION OF THE THERMODYNAMIC
!POTENTIALS OF WATER, VAPOUR, ICE, SEAWATER AND AIR. PART II: THE LIBRARY ROUTINES, 
!OCEAN SCIENCES., 2009, IN PREPARATION.

!FEISTEL, R., KRETZSCHMAR, H.-J., SPAN, R., HAGEN, E., !WRIGHT, D.G., HERRMANN, S.:
!THERMODYNAMIC PROPERTIES OF SEA AIR.
!OCEAN SCIENCE DISCUSSION 6(2009)2193-2325.

!#########################################################################

!THIS MODULE REQUIRES THE LIBRARY MODULE
!     CONSTANTS_0, FILE CONSTANTS_0.F90

!#########################################################################

use constants_0

implicit none
private

character*16, private :: version = '8 Jun 2010'

public :: air_baw_m3mol, air_caaw_m6mol2, air_caww_m6mol2, &
          dry_f_si, dry_init_clear, dry_init_Lemmon2000

real*8 ::  mw = molar_mass_h2o_si      !MOLAR MASS OF H2O IN KG/MOL
real*8 ::  ma = molar_mass_air_L2000   !MOLAR MASS OF AIR IN KG/MOL USED BY LEMMON et al. 2000

!ARRAYS DEFINED IN TABLES 12 AND 13 OF LEMON ET AL. (2000)
!COEFFICIENTS AND EXPONENTS FOR THE FUNDAMENTAL EQUATION (3) FOR AIR

real*8 :: nk0(13), nk(19), ik(19), jk(19), lk(19)

contains

!==========================================================================
function dry_f_si(drv_t, drv_d, t_si, d_si)
!==========================================================================
         
!THIS FUNCTION IMPLEMENTS THE HELMHOLTZ POTENTIAL OF DRY AIR AND
!ITS 1ST AND 2ND DERIVATIVES WITH RESPECT TO TEMPERATURE AND DENSITY
!AS PUBLISHED IN:

!LEMMON, E.W., JACOBSEN, R.T., PENONCELLO, S.G., FRIEND, D.G.
!THERMODYNAMIC PROPERTIES OF AIR AND MIXTURES OF NITROGEN, ARGON AND OXYGEN
!FROM 60 TO 2000 K AT PRESSURES TO 2000 MPA.
!J. PHYS. CHEM. REF. DATA 29(2000)331-362.

!HERE, IN CONTRAST TO THE ORIGINAL ARTICLE, THE COEFFICIENTS OF ABSOLUTE
!ENERGY AND ABSOLUTE ENTROPY ARE ADJUSTED TO THE REFERENCE STATE CONDITION
!OF ZERO ENTROPY AND ZERO ENTHALPY AT THE STANDARD OCEAN STATE, 0°C AND 101325 PA.

!OUTPUT: 
!dry_f_si:  HELMHOLTZ ENERGY OR ITS DERIVATIVES IN J/(KG K^DRV_T) (M3/KG)^DRV_D)


!INPUT PARAMETERS:
!DRV_T:     ORDER OF THE TEMPERATURE DERIVATIVE, DRV_T < 3
!DRV_D:     ORDER OF THE DENSITY DERIVATIVE, DRV_D + DRV_T < 3
!T_SI:      ABSOLUTE ITS-90 TEMPERATURE IN K
!D_SI:      DENSITY IN KG/M3

!CHECK VALUES, V1.0:
!dry_f_si( 0, 0, 300,0.001) =-696384.495286
!dry_f_si( 1, 0, 300,0.001) =-2124.98673214
!dry_f_si( 0, 1, 300,0.001) = 86135114.6608
!dry_f_si( 2, 0, 300,0.001) =-2.39299064929
!dry_f_si( 1, 1, 300,0.001) = 287117.623822
!dry_f_si( 0, 2, 300,0.001) =-86135137748.2

!CHECK VALUES, V1.1:
!dry_f_si( 0, 0, 300,0.001) =-696239.965190
!dry_f_si( 1, 0, 300,0.001) =-2124.55145456
!dry_f_si( 0, 1, 300,0.001) = 86114714.9596
!dry_f_si( 2, 0, 300,0.001) =-2.39242390806
!dry_f_si( 1, 1, 300,0.001) = 287049.624545
!dry_f_si( 0, 2, 300,0.001) =-86114738036.1

integer :: drv_t, drv_d
real*8 :: dry_f_si
real*8 :: t_si, d_si
real*8 :: tr, dr, ra, f, tau, del, a, a_t, a_tt, a_d, a_td, a_dd

ra = gas_constant_air_L2000          !SPECIFIC GAS CONSTANT OF AIR IN J KG-1 K-1 USED BY LEMON ET AL. 2000

tr = 132.6312d0                      !REDUCING TEMPERATURE IN K
dr = 10447.7d0 * ma                  !REDUCING DENSITY IN KG M-3

dry_f_si = errorreturn
f = errorreturn

call init_iapws10

if(check_limits == 1) then
  if(t_si < dry_air_tmin .or. t_si > dry_air_tmax) return
  if(d_si <= dry_air_dmin .or. d_si > dry_air_dmax) return
else
  if (t_si <= 0d0) return
  if (d_si <= 0d0) return
endif

tau = tr / t_si  !REDUCED TEMPERATURE
del = d_si / dr  !REDUCED DENSITY

!HELMHOLTZ FUNCTION AND ITS DERIVATIVES
select case (drv_t)
  case (0)
    select case (drv_d)
      case (0)
        a = log(del) + alpha_ideal(tau) + alpha_res(0, 0, tau, del)
        f = ra * t_si * a
      case (1)
        a_d = 1d0 / del + alpha_res(0, 1, tau, del)
        f = ra * t_si * a_d / dr
      case (2)
        a_dd = -1d0 / del ** 2 + alpha_res(0, 2, tau, del)
        f = ra * t_si * a_dd / dr ** 2
      case default; return  !dbg
    end select
  case (1)
    select case (drv_d)
      case (0)
        a = log(del) + alpha_ideal(tau) + alpha_res(0, 0, tau, del)
        a_t = alpha_ideal_t(tau) + alpha_res(1, 0, tau, del)
        f = ra * (a - tau * a_t)
      case (1)
        a_d = 1d0 / del + alpha_res(0, 1, tau, del)
        a_td = alpha_res(1, 1, tau, del)
        f = ra * (a_d - tau * a_td) / dr
      case default; return  !dbg
    end select
  case (2)
    select case (drv_d)
      case (0)
        a_tt = alpha_ideal_tt(tau) + alpha_res(2, 0, tau, del)
        f = ra * tau ** 2 * a_tt / t_si
      case default; return  !dbg
    end select
end select

dry_f_si = f

end function

!==========================================================================
function air_baw_m3mol(drv_t, t_si)
!==========================================================================

!THIS FUNCTION IMPLEMENTS THE 2ND VIRIAL COEFFICIENT BAW AS DEFINED IN

!HARVEY, A.H., HUANG, P.H.: FIRST-PRINCIPLES CALCULATION OF THE AIR-WATER SECOND
!VIRIAL COEFFICIENT. INT. J. THERMOPHYS. 28(2007)556-565.

!OUTPUT:  
!air_baw_m3mol = MOLAR VIRIAL COEFFICIENT BAW OR ITS DERIVATIVES IN M3/(MOL K^DRV_T)

!INPUT:   
!DRV_T ORDER OF THE TEMPERATURE DERIVATIVE
!T_SI  ABSOLUTE TEMPERATURE IN K

real*8 :: air_baw_m3mol
integer :: drv_t
real*8 :: t_si
real*8 :: c1, c2, c3, tr, d1, d2, d3
real*8 :: t, b

c1 = 66.5687d0; d1 = -0.237d0
c2 = -238.834d0; d2 = -1.048d0
c3 = -176.755d0; d3 = -3.183d0
tr = 100d0 !K

air_baw_m3mol = errorreturn

if (t_si <= 0d0) return

t = t_si / tr

select case (drv_t)
  case (0); b = c1 * t ** d1 + c2 * t ** d2 + c3 * t ** d3
  case (1)
    b = c1 * d1 * t ** (d1 - 1d0) + c2 * d2 * t ** (d2 - 1d0) &
        + c3 * d3 * t ** (d3 - 1d0)
    b = b / tr
  case (2)
    b = c1 * d1 * (d1 - 1d0) * t ** (d1 - 2d0) + &
        c2 * d2 * (d2 - 1d0) * t ** (d2 - 2d0) + &
        c3 * d3 * (d3 - 1d0) * t ** (d3 - 2d0)
    b = b / tr ** 2
  case default; return
end select

air_baw_m3mol = b * 0.000001d0 !FROM CM3/MOL TO M3/MOL

end function

!==========================================================================
function air_caaw_m6mol2(drv_t, t_si)
!==========================================================================

!THIS FUNCTION IMPLEMENTS THE 3RD VIRIAL COEFFICIENT CAAW AS DEFINED IN

!HYLAND, R.W., WEXLER, A.:
!FORMULATIONS FOR THE THERMODYNAMIC PROPERTIES OF DRY AIR FROM 173.15 K TO 473.15 K,
!AND OF SATURATED MOIST AIR FROM 173.15 K TO 372.15 K, AT PRESSURES UP TO 5 MPA.
!ASHRAE TRANSACT. 89(1983)520-535.

!OUTPUT:  
!AIR_CAAW_M6MOL2 = MOLAR VIRIAL COEFFICIENT CAAW OR ITS DERIVATIVES IN M6/(MOL2 K^DRV_T)

!INPUT:   
!DRV_T ORDER OF THE TEMPERATURE DERIVATIVE
!T_SI  ABSOLUTE TEMPERATURE IN K

real*8 :: air_caaw_m6mol2
integer :: drv_t
real*8 :: t_si
real*8 :: c1, c2, c3, c4, c5, tr
real*8 :: t, c

c1 = 482.737d0
c2 = 105678d0
c3 = -65639400d0
c4 = 29444200000d0
c5 = -3193170000000d0
tr = 1d0 !K

air_caaw_m6mol2 = errorreturn

if (t_si <= 0d0) return

t = t_si / tr

select case (drv_t)
  case (0); c = c1 + c2 / t + c3 / t ** 2 + c4 / t ** 3 + c5 / t ** 4
  case (1); c = -c2 / t ** 2 - 2d0 * c3 / t ** 3 - 3d0 * c4 / t ** 4 &
                - 4d0 * c5 / t ** 5
  case (2); c = 2d0 * c2 / t ** 3 + 6d0 * c3 / t ** 4 &
                + 12d0 * c4 / t ** 5 + 20d0 * c5 / t ** 6
  case default; return
end select

air_caaw_m6mol2 = c * 1d-12 !FROM CM6/MOL2 TO M6/MOL2

end function

!==========================================================================
function air_caww_m6mol2(drv_t, t_si)
!==========================================================================

!THIS FUNCTION IMPLEMENTS THE 3RD VIRIAL COEFFICIENT CAWW AS DEFINED IN

!HYLAND, R.W., WEXLER, A.:
!FORMULATIONS FOR THE THERMODYNAMIC PROPERTIES OF DRY AIR FROM 173.15 K TO 473.15 K,
!AND OF SATURATED MOIST AIR FROM 173.15 K TO 372.15 K, AT PRESSURES UP TO 5 MPA.
!ASHRAE TRANSACT. 89(1983)520-535.

!OUTPUT:  
!air_caww_m6mol2 = MOLAR VIRIAL COEFFICIENT CAWW OR ITS DERIVATIVES IN M6/(MOL2 K^DRV_T)

!INPUT:   
!DRV_T ORDER OF THE TEMPERATURE DERIVATIVE
!T_SI  ABSOLUTE TEMPERATURE IN K

real*8 air_caww_m6mol2
integer :: drv_t
real*8 :: t_si
real*8 c1, c2, c3, c4, tr
real*8 t, c

c1 = -10.728876d0
c2 = 3478.02d0
c3 = -383383d0
c4 = 33406000d0
tr = 1d0 !K

air_caww_m6mol2 = errorreturn

if (t_si <= 0d0) return

t = t_si / tr

c = -1d-6 * exp(c1 + c2 / t + c3 / t ** 2 + c4 / t ** 3)
select case (drv_t)
  case (0)
  case (1) 
    c = c * (-c2 / t ** 2 - 2d0 * c3 / t ** 3 - 3d0 * c4 / t ** 4)
  case (2)
    c = c * ((-c2 / t ** 2 - 2d0 * c3 / t ** 3  &
        - 3d0 * c4 / t ** 4) ** 2 + 2d0 * c2 / t ** 3  &
        + 6d0 * c3 / t ** 4 + 12d0 * c4 / t ** 5)
  case default; return
end select

air_caww_m6mol2 = c  

end function

!==========================================================================
subroutine init_iapws10()
!==========================================================================

integer :: k 

if (nk0(1) == 0.00000006057194d0) return

!ARRAYS DEFINED IN TABLE 12 OF LEMMON ET AL. (2000)
!COEFFICIENTS FOR THE IDEAL GAS EXPRESSIONS
!-------------------------------------------------------------------------------
k = 1;  nk0(k) = 0.00000006057194d0
k = 2;  nk0(k) = -0.0000210274769d0
k = 3;  nk0(k) = -0.000158860716d0
k = 4;  nk0(k) = 9.7450251743948d0   !-13.841928076 'original Lemmon et al. 2000
k = 5;  nk0(k) = 10.0986147428912d0  ! 17.275266575 'original Lemmon et al. 2000
k = 6;  nk0(k) = -0.00019536342d0
k = 7;  nk0(k) = 2.490888032d0
k = 8;  nk0(k) = 0.791309509d0
k = 9;  nk0(k) = 0.212236768d0
k = 10; nk0(k) = -0.197938904d0

k = 11; nk0(k) = 25.36365d0
k = 12; nk0(k) = 16.90741d0
k = 13; nk0(k) = 87.31279d0

!ARRAYS DEFINED IN TABLE 13 OF LEMMON ET AL. (2000)
!COEFFICIENTS AND EXPONENTS FOR THE EQUATION OF STATE FOR AIR
!-------------------------------------------------------------------------------
k = 1;  ik(k) = 1d0;  jk(k) = 0d0;    lk(k) = 0d0; nk(k) = 0.118160747229d0
k = 2;  ik(k) = 1d0;  jk(k) = 0.33d0; lk(k) = 0d0; nk(k) = 0.713116392079d0
k = 3;  ik(k) = 1d0;  jk(k) = 1.01d0; lk(k) = 0d0; nk(k) = -1.61824192067d0
k = 4;  ik(k) = 2d0;  jk(k) = 0d0;    lk(k) = 0d0; nk(k) = 0.0714140178971d0
k = 5;  ik(k) = 3d0;  jk(k) = 0d0;    lk(k) = 0d0; nk(k) = -0.0865421396646d0
k = 6;  ik(k) = 3d0;  jk(k) = 0.15d0; lk(k) = 0d0; nk(k) = 0.134211176704d0
k = 7;  ik(k) = 4d0;  jk(k) = 0d0;    lk(k) = 0d0; nk(k) = 0.0112626704218d0
k = 8;  ik(k) = 4d0;  jk(k) = 0.2d0;  lk(k) = 0d0; nk(k) = -0.0420533228842d0
k = 9;  ik(k) = 4d0;  jk(k) = 0.35d0; lk(k) = 0d0; nk(k) = 0.0349008431982d0
k = 10; ik(k) = 6d0;  jk(k) = 1.35d0; lk(k) = 0d0; nk(k) = 0.000164957183186d0

k = 11; ik(k) = 1d0;  jk(k) = 1.6d0;  lk(k) = 1d0; nk(k) = -0.101365037912d0
k = 12; ik(k) = 3d0;  jk(k) = 0.8d0;  lk(k) = 1d0; nk(k) = -0.17381369097d0
k = 13; ik(k) = 5d0;  jk(k) = 0.95d0; lk(k) = 1d0; nk(k) = -0.0472103183731d0
k = 14; ik(k) = 6d0;  jk(k) = 1.25d0; lk(k) = 1d0; nk(k) = -0.0122523554253d0
k = 15; ik(k) = 1d0;  jk(k) = 3.6d0;  lk(k) = 2d0; nk(k) = -0.146629609713d0
k = 16; ik(k) = 3d0;  jk(k) = 6d0;    lk(k) = 2d0; nk(k) = -0.0316055879821d0
k = 17; ik(k) = 11d0; jk(k) = 3.25d0; lk(k) = 2d0; nk(k) = 0.000233594806142d0
k = 18; ik(k) = 1d0;  jk(k) = 3.5d0;  lk(k) = 3d0; nk(k) = 0.0148287891978d0
k = 19; ik(k) = 3d0;  jk(k) = 15d0;   lk(k) = 3d0; nk(k) = -0.00938782884667d0


!dynamic adjustment to the reference state conditions:
!vanishing entropy s = 0 and enthalpy h = f + Ts + pv = 0 at 273.15 K, 101325 Pa
!related density is 1.29275937468394 kg m-3, the reducing temperature 132.6312 K
!nk0(4) = 0
!nk0(4) = -dry_f_si(1, 0, 273.15, 1.29275937468394) * Molar_mass_air_L2000 / (Gas_constant_molar_L2000)
!Debug.Print nk0(4); -dry_f_si(1, 0, 273.15, 1.29275937468394)

!nk0(5) = 0
!nk0(5) = -(dry_f_si(0, 0, 273.15, 1.29275937468394) + 101325 / 1.29275937468394) 
!         * Molar_mass_air_L2000 / (132.6312 * Gas_constant_molar_L2000)
!Debug.Print nk0(5); dry_f_si(0, 0, 273.15, 1.29275937468394) + 101325 / 1.29275937468394

!output:
! 9.7450251743948 -1.05459846463211E-12
! 10.0986147428912  2.75164779850456E-10

end subroutine

!==========================================================================
subroutine dry_init_clear()
!==========================================================================

!clears the initialization of dry_f_si()

nk0(1) = 0d0

end subroutine

!==========================================================================
subroutine dry_init_Lemmon2000()
!==========================================================================

!sets original adjustable coefficients of Lemmon et al (2000)

call init_iapws10

nk0(4) = -13.841928076d0 !original Lemmon et al. 2000
nk0(5) = 17.275266575d0  !original Lemmon et al. 2000

end subroutine

!==========================================================================
function alpha_ideal(tau)
!==========================================================================

!TEMPERATURE PART OF THE IDEAL-GAS DIMENSIONLESS HELMHOLTZ FUNCTION OF AIR

integer :: k
real*8 :: alpha_ideal
real*8 :: tau, a

alpha_ideal = errorreturn

if (tau <= 0d0) return

a = 0d0
do k = 1, 5
  a = a + nk0(k) * tau ** (k - 4)
enddo
a = a + nk0(6) * tau ** 1.5d0 + nk0(7) * log(tau)
a = a + nk0(8) * log(1d0 - exp(-nk0(11) * tau))
a = a + nk0(9) * log(1d0 - exp(-nk0(12) * tau))
a = a + nk0(10) * log(2d0 / 3d0 + exp(nk0(13) * tau))

alpha_ideal = a

end function

!==========================================================================
function alpha_ideal_t(tau)
!==========================================================================

!TEMPERATURE DERIVATIVE OF THE IDEAL-GAS DIMENSIONLESS HELMHOLTZ FUNCTION OF AIR

integer :: k
real*8 :: alpha_ideal_t
real*8 :: tau, a

alpha_ideal_t = errorreturn

if (tau <= 0d0) return

a = 0d0
do k = 1, 5
  a = a + nk0(k) * (k - 4d0) * tau ** (k - 5)
enddo
a = a + 1.5d0 * nk0(6) * sqrt(tau) + nk0(7) / tau
a = a + nk0(8) * nk0(11) / (exp(nk0(11) * tau) - 1d0)
a = a + nk0(9) * nk0(12) / (exp(nk0(12) * tau) - 1d0)
a = a + nk0(10) * nk0(13) / (2d0 * exp(-nk0(13) * tau) / 3d0 + 1d0)

alpha_ideal_t = a

end function

!==========================================================================
function alpha_ideal_tt(tau)
!==========================================================================

!2ND TEMPERATURE DERIVATIVE OF THE IDEAL-GAS DIMENSIONLESS HELMHOLTZ FUNCTION OF AIR

integer k
real*8 alpha_ideal_tt
real*8 :: tau, a, e

alpha_ideal_tt = errorreturn

if (tau <= 0d0) return

a = 0d0
do k = 1, 3
  a = a + nk0(k) * (k - 4d0) * (k - 5d0) * tau ** (k - 6d0)
enddo
a = a + 0.75d0 * nk0(6) / sqrt(tau) - nk0(7) / tau ** 2
e = exp(nk0(11) * tau)
a = a - nk0(8) * nk0(11) ** 2 * e / (e - 1d0) ** 2
e = exp(nk0(12) * tau)
a = a - nk0(9) * nk0(12) ** 2 * e / (e - 1d0) ** 2
e = exp(-nk0(13) * tau)
a = a + nk0(10) * nk0(13) ** 2 * e / (2d0 * e / 3d0 + 1d0) ** 2 * 2d0 / 3d0

alpha_ideal_tt = a

end function

!==========================================================================
function alpha_res(drv_tau, drv_del, tau, del)
!==========================================================================

!THIS IMPLEMENTS EQUATION (28) AND ITS DERIVATIVES WITH RESPECT TO TAU AND DEL OF
!LEMMON, E.W., JACOBSEN, R.T., PENONCELLO, S.G., FRIEND, D.G.
!THERMODYNAMIC PROPERTIES OF AIR AND MIXTURES OF NITROGEN, ARGON AND OXYGEN
!FROM 60 TO 2000 K AT PRESSURES TO 2000 MPA.
!J. PHYS. CHEM. REF. DATA 29(2000)331-362.

integer :: drv_tau, drv_del, k
real*8 alpha_res
real*8 :: tau, del, a, a_tau, a_del, i, j, l

alpha_res = errorreturn

a = 0d0

do k = 1, 19
  i = ik(k)
  j = jk(k)
  l = lk(k)
  select case (drv_tau)
    case (0); a_tau = tau ** j
    case (1); a_tau = j * tau ** (j - 1)
    case (2); a_tau = j * (j - 1d0) * tau ** (j - 2)
    case default; return
  end select
  if (k < 11) then
    select case (drv_del)
      case (0); a_del = del ** i
      case (1); a_del = i * del ** (i - 1)
      case (2); a_del = i * (i - 1d0) * del ** (i - 2)
      case default; return
    end select
  else
    select case (drv_del)
      case (0); a_del = del ** i * exp(-del ** l)
      case (1); a_del = (i - l * del ** l) * del ** (i - 1d0) * exp(-del ** l)
      case (2); a_del = (i * (i - 1d0) - (l + 2d0 * i - 1d0) * l * del ** l &
                      + (l * del ** l) ** 2) * del ** (i - 2d0) * exp(-del ** l)
      case default; return
    end select
  end if
  a = a + nk(k) * a_tau * a_del
enddo

alpha_res = a

end function

end module air_1

module liq_ice_air_5d

!#########################################################################

!THIS MODULE IMPLEMENTS THE EQUILIBRIUM PROPERTIES OF WET ICE AIR, 
!I.E., BETWEEN LIQUID WATER, ICE AND HUMID AIR
!
!THIS MODULE ALSO PROVIDES SIMPLE IMPLEMENTATIONS OF DERIVED METEOROLOGICAL
!QUANTITIES LIKE THE EQUIVALENT POTENTIAL TEMPERATURE, ETC.

!#########################################################################

!IMPLEMENTATION IN FORTRAN BY F.B. LALIBERTE AT THE UNIVERSITY OF TORONTO, 2012
!FOR PROBABLE FUTURE PUBLICATION WITH THE DEVELOPERS OF TEOS-10

!#########################################################################

!THIS MODULE REQUIRES THE LIBRARY MODULES:
!     CONSTANTS_0,  FILE CONSTANTS_0.F90
!     CONVERT_0,    FILE CONVERT_0.F90
!     MATHS_0,      FILE MATHS_0.F90
!     AIR_1,        FILE AIR_1.F90
!     FLU_1,        FILE FLU_1.F90
!     ICE_1,        FILE ICE_1.F90
!     AIR_2,        FILE AIR_2.F90
!     FLU_2,        FILE FLU_2.F90
!     ICE_2,        FILE ICE_2.F90
!     AIR_3B,       FILE AIR_3B.F90
!     AIR_3C,       FILE AIR_3C.F90
!     ICE_LIQ_4,    FILE ICE_LIQ_4.F90
!     ICE_VAP_4,    FILE ICE_VAP_4.F90
!     LIQ_VAP_4,    FILE LIQ_VAP_4.F90

!     LIQ_AIR_4A,   FILE LIQ_AIR_4A.F90
!     LIQ_AIR_4B,   FILE LIQ_AIR_4B.F90
!     LIQ_AIR_4C,   FILE LIQ_AIR_4C.F90

!     ICE_AIR_4A,   FILE ICE_AIR_4A.F90
!     ICE_AIR_4B,   FILE ICE_AIR_4B.F90
!     ICE_AIR_4C,   FILE ICE_AIR_4C.F90

!     LIQ_ICE_AIR_4,FILE LIQ_ICE_AIR_4.F90 

!#########################################################################

use constants_0
use convert_0
use maths_0
use air_1
use flu_1
use ice_1
use air_2
use flu_2
use ice_2
use air_3b
use air_3c
use ice_liq_4

use ice_vap_4
use liq_vap_4

use liq_air_4a
use liq_air_4b
use liq_air_4c
use liq_air_4d
use ice_air_4a
use ice_air_4b
use ice_air_4c
use ice_air_4d
use liq_ice_air_4

use liq_ice_air_5a
use liq_ice_air_5b
use liq_ice_air_5c

implicit none
private

character*16, private :: version = 'October 2012'

public :: liq_ice_air_pottemp_si, liq_ice_air_pottempequi_si, &
          liq_ice_air_pottempequisat_si, liq_ice_air_pottempequipseudo_si, &
          liq_ice_air_g_temperatureequi_si

!CONTROL PARAMETERS OF THE EQUI TEMPERATURE ITERATION
integer ctrl_initialized

integer ctrl_mode_tempequi
integer ctrl_loop_maximum

real*8 ctrl_init_tempequi
real*8 ctrl_eps_exit_tempequi

!CONTROL PARAMETERS OF THE PSEUDO EQUIVALENT POTENTIAL TEMPERATURE ITERATION
integer ctrl_pottemppseudo_initialized

real*8 ctrl_delta_pres_pottemppseudo
real*8 ctrl_min_pres_pottemppseudo
real*8 ctrl_sat_pottemppseudo

contains

function liq_ice_air_pottemp_si(a_si, t_si, p_si, pr_si)
!THIS FUNCTION COMPUTES POTENTIAL TEMPERATURE AND SEAMLESSLY ACCOUNTS FOR ICE AND LIQUID WATER.
!SHOULD BE VALID OVER THE WHOLE REGION OF VALIDILITY OF TEOS-10

!OUTPUT:
!THETA(A,T,P,PR) ABSOLUTE POTENTIAL TEMPERATURE OF ICE AIR IN K

!INPUTS:
!A_SI      ABSOLUTE DRY-AIR MASS FRACTION IN KG/KG
!T_SI      ABSOLUTE IN-SITU TEMPERATURE IN K
!P_SI      ABSOLUTE IN-SITU PRESSURE IN PA
!PR_SI     ABSOLUTE REFERENCE PRESSURE IN PA

real*8 liq_ice_air_pottemp_si, a_si, t_si, p_si, pr_si
real*8 s

liq_ice_air_pottemp_si = errorreturn

if(a_si < 0d0) return
if(t_si < 0d0) return
if(p_si < 0d0) return
if(pr_si < 0d0) return


if(p_si == pr_si) then
  liq_ice_air_pottemp_si = t_si
  return
end if

s=liq_ice_air_g_entropy_si(a_si,t_si,p_si)
if(s == errorreturn) return

liq_ice_air_pottemp_si = liq_ice_air_h_temperature_si(a_si, s, pr_si)

end function

function liq_ice_air_pottempequisat_si(a_si, t_si, p_si, pr_si)
!THIS FUNCTION COMPUTES THE SATURATION EQUIVALENT POTENTIAL TEMPERATURE OF AIR AT FIXED PRESSURE AND FIXED DRY AIR MASS FRACTION.
!THIS FUNCTION GIVES AN EXPRESSION THAT CORRESPONDS TO THE VALUE PRESENTED IN EQUATION (12.2.7) IN EMMANUEL (1994)
!WHEN T_SI IS ABOVE FREEZING AND POTTEMP(A_SI,T_SI,P_SI,PR_SI) IS ABOVE FREEZING.

!OUTPUT:
!THETA_E_STAR(A,T,P,PR) SATURATION EQUIVALENT POTENTIAL TEMPERATURE OF ICE AIR OR LIQUID AIR IN K

!INPUTS:
!A_SI      ABSOLUTE DRY-AIR MASS FRACTION IN KG/KG
!T_SI      ABSOLUTE IN-SITU TEMPERATURE IN K
!P_SI      ABSOLUTE IN-SITU PRESSURE IN PA
!PR_SI     REFERENCE PRESSURE IN PA

real*8 liq_ice_air_pottempequisat_si, a_si, t_si, p_si, pr_si
real*8 a_sat

liq_ice_air_pottempequisat_si = errorreturn

if(a_si < 0d0 .or. a_si > 1d0) return
if(t_si < 0d0) return
if(p_si < 0d0) return
if(pr_si < 0d0) return

!Find the saturation air mass fraction:
a_sat=liq_ice_air_massfraction_air_si(t_si,p_si)

if(a_si==1d0.or.a_si>=a_sat) then
    liq_ice_air_pottempequisat_si=liq_ice_air_pottempequi_si(a_sat, t_si, p_si, pr_si)
else
    liq_ice_air_pottempequisat_si=liq_ice_air_pottempequi_si(a_si, t_si, p_si, pr_si)
endif

end function

function liq_ice_air_pottempequi_si(a_si, t_si, p_si, pr_si)
!THIS FUNCTION COMPUTES THE EQUIVALENT POTENTIAL TEMPERATURE OF AIR AT FIXED PRESSURE AND FIXED DRY AIR MASS FRACTION.
!THIS FUNCTION GIVES AN EXPRESSION THAT CORRESPONDS TO EQUATION (4.5.10) IN EMMANUEL (1994) WHEN
!T_SI IS ABOVE FREEZING AND POTTEMP(A_SI,T_SI,P_SI,PR_SI) IS ABOVE FREEZING.

!OUTPUT:
!THETA_E(A,T,P,PR) EQUIVALENT POTENTIAL TEMPERATURE OF ICE AIR OR LIQUID AIR IN K

!INPUTS:
!A_SI      ABSOLUTE DRY-AIR MASS FRACTION IN KG/KG
!T_SI      ABSOLUTE IN-SITU TEMPERATURE IN K
!P_SI      ABSOLUTE IN-SITU PRESSURE IN PA

real*8 liq_ice_air_pottempequi_si, a_si, t_si, p_si, pr_si

liq_ice_air_pottempequi_si = errorreturn

if(a_si < 0d0 .or. a_si > 1d0) return
if(t_si < 0d0) return
if(p_si < 0d0) return
if(pr_si < 0d0) return


liq_ice_air_pottempequi_si = liq_ice_air_pottemp_si(a_si,t_si,p_si,pr_si)

liq_ice_air_pottempequi_si = liq_ice_air_g_temperatureequi_si(a_si, &
                                                    liq_ice_air_pottempequi_si, pr_si)

end function

function liq_ice_air_g_temperatureequi_si(a_si, t_si, p_si)
!THIS FUNCTION COMPUTES THE EQUIVALENT TEMPERATURE OF AIR AT FIXED PRESSURE AND FIXED DRY AIR MASS FRACTION.
!THIS FUNCTION GIVES AN EXPRESSION THAT CORRESPONDS TO EQUATION (4.5.10) IN EMMANUEL (1994) WHEN
!T_SI IS ABOVE FREEZING AND POTTEMP(A_SI,T_SI,P_SI,PR_SI) IS ABOVE FREEZING.

!OUTPUT:
!TEQ(A,T,P,PR) ABSOLUTE EQUIVALENT TEMPERATURE OF ICE AIR OR LIQUID AIR IN K

!INPUTS:
!A_SI      ABSOLUTE DRY-AIR MASS FRACTION IN KG/KG
!T_SI      ABSOLUTE IN-SITU TEMPERATURE IN K
!P_SI      ABSOLUTE IN-SITU PRESSURE IN PA
!PR_SI     REFERENCE PRESSURE IN PA

real*8 liq_ice_air_g_temperatureequi_si, a_si, t_si, p_si
real*8 t1, t2, eps
integer maxit

liq_ice_air_g_temperatureequi_si = errorreturn

if(a_si < 0d0 .or. a_si > 1d0) return
if(t_si < 0d0) return
if(p_si < 0d0) return

if(a_si==1d0) then
    liq_ice_air_g_temperatureequi_si = t_si
    return
endif

call init_it_ctrl_tempequi

t1=min_liq_ice_air_temperatureequi_si(a_si,t_si,p_si)
t2=max_liq_ice_air_temperatureequi_si(a_si,t_si,p_si)

  if(ctrl_loop_maximum == 0) then
    maxit = 100
  elseif(ctrl_loop_maximum == (-1)) then
    liq_ice_air_g_temperatureequi_si = t1
    return
  elseif(ctrl_loop_maximum > 0) then
    maxit = ctrl_loop_maximum
  else
    return
  endif

eps = ctrl_eps_exit_tempequi
if(eps <= 0d0) return

!RUN THE ITERATION
liq_ice_air_g_temperatureequi_si = temperatureequiiteration_brent(a_si, t_si, p_si, t1, t2, maxit, eps)

end function

function liq_ice_air_pottempequipseudo_si(a_si, t_si, p_si, pr_si)
!THIS FUNCTION COMPUTES THE PSEUDO EQUIVALENT POTENTIAL TEMPERATURE OF AIR AT 
!FIXED PRESSURE AND FIXED DRY AIR MASS FRACTION.

!OUTPUT:
!THETA_E_STAR(A,T,P,PR) PSEUDO EQUIVALENT POTENTIAL TEMPERATURE OF ICE AIR OR LIQUID AIR IN K

!INPUTS:
!A_SI      ABSOLUTE DRY-AIR MASS FRACTION IN KG/KG
!T_SI      ABSOLUTE IN-SITU TEMPERATURE IN K
!P_SI      ABSOLUTE IN-SITU PRESSURE IN PA

real*8 liq_ice_air_pottempequipseudo_si, a_si, t_si, p_si, pr_si
real*8 p_top, dp, t_prev, t_next, p_prev, p_next, a_sat, a_prev
integer i, nlev

liq_ice_air_pottempequipseudo_si=errorreturn

if(a_si < 0d0 .or. a_si > 1d0) return
if(t_si < 0d0) return
if(p_si < 0d0) return
if(pr_si < 0d0) return

!These parameters will influence the convergence of this algorithm
call init_it_ctrl_pottemppseudo
p_top=ctrl_min_pres_pottemppseudo
dp=ctrl_delta_pres_pottemppseudo

nlev = floor((pr_si-p_top)/dp)+1

if(pr_si<=p_top) return

!Move the parcel to the reference pressure:
t_prev=liq_ice_air_pottemp_si(a_si,t_si,p_si,pr_si)

!Remove all condensates
a_sat = liq_ice_air_massfraction_air_si(t_prev,p_si)
if(a_sat==errorreturn) return
if(a_sat>=a_si) then
    a_prev = a_sat
else
    a_prev = a_si
endif

p_prev=pr_si

dp = (pr_si-p_top)/nlev

do i=1,nlev
    p_next=p_prev-dp

    t_next=liq_ice_air_pottemp_si(a_prev,t_prev,p_prev,p_next)
    !print *, p_prev, liq_ice_air_g_entropy_si(a_prev,t_prev,p_prev)+1377.926*(1.0-a_prev), t_next
    if(t_next==errorreturn.or.t_next<mix_air_tmin) exit

    a_sat = liq_ice_air_massfraction_air_si(t_next,p_next)
    if(a_sat==errorreturn) exit
    if(a_sat>=a_prev) a_prev = a_sat

    t_prev=t_next
    p_prev=p_next
enddo
a_sat=liq_ice_air_massfraction_air_si(t_prev,p_prev)
liq_ice_air_pottempequipseudo_si=liq_ice_air_pottemp_si(a_sat, t_prev, p_prev, pr_si)

end function

!==========================================================================
subroutine init_it_ctrl_pottemppseudo()
!=========================================================================

if(ctrl_pottemppseudo_initialized == -1) return

ctrl_pottemppseudo_initialized = -1

!SET DEFAULT VALUES AND MODES FOR DENSITY ITERATION
ctrl_min_pres_pottemppseudo = 1e4
ctrl_delta_pres_pottemppseudo = 1e3
ctrl_sat_pottemppseudo = 0d0
end subroutine

!=========================================================================
function min_liq_ice_air_temperatureequi_si(wa_si, t_si, p_si)
!==========================================================================
!THIS FUNCTION GIVES A LOWER BOUND ESTIMATE FOR THE EQUIVALENT TEMPERATURE OF WET ICE AIR 
!FROM ITS DRY-AIR FRACTION WA_SI IN KG/KG, ITS ABSOLUTE TEMPERATURE, T_SI IN K AND ITS
!PRESSURE P_SI IN PA

real*8 min_liq_ice_air_temperatureequi_si, wa_si, p_si, t_si

real*8 lv, t_temp, a, mixing_eta

min_liq_ice_air_temperatureequi_si = errorreturn

if(t_si <= 0d0) return
if(wa_si < 0d0 .or. wa_si > 1d0) return

if(set_liq_air_eq_at_t_p(tp_temperature_si, sealevel_pressure_si)==errorreturn) return
lv = liq_air_enthalpy_evap_si()

a = liq_ice_air_massfraction_air_si(t_si,p_si)
if(a/=errorreturn.and.a>=wa_si) then
    t_temp = t_si + (1d0-a)*lv/liq_ice_air_g_cond_cp_si(wa_si,t_si,p_si)
else
    t_temp = t_si + (1d0-wa_si)*lv/liq_ice_air_g_cond_cp_si(wa_si,t_si,p_si)
endif

if(p_si<(sealevel_pressure_si-tp_pressure_iapws95_si)) then 
    mixing_eta = -gas_constant_air_si/air_g_cp_si(1d0,t_si,p_si)*wa_si*log(p_si/(sealevel_pressure_si-tp_pressure_iapws95_si))
    t_temp = t_temp*exp(-mixing_eta)
endif

if(t_temp>=mix_air_tmax) then
    min_liq_ice_air_temperatureequi_si = mix_air_tmax
else
    min_liq_ice_air_temperatureequi_si = t_temp
endif

end function

!=========================================================================
function max_liq_ice_air_temperatureequi_si(wa_si, t_si, p_si)
!==========================================================================

!THIS FUNCTION GIVES AN UPPER BOUND ESTIMATE FOR THE EQUIVALENT TEMPERATURE OF WET ICE AIR 
!FROM ITS DRY-AIR FRACTION WA_SI IN KG/KG, ITS ABSOLUTE TEMPERATURE, T_SI IN K AND ITS
!PRESSURE P_SI IN PA

real*8 max_liq_ice_air_temperatureequi_si, wa_si, p_si, t_si

!real*8 tt, pt, cpa, cpi, sat, sit, ra, tmin
!real*8 p, t, eta

real*8 lv, t_freeze, t_temp, mixing_eta

max_liq_ice_air_temperatureequi_si = errorreturn

if(t_si <= 0d0) return
if(wa_si < 0d0 .or. wa_si > 1d0) return

if(set_liq_ice_air_eq_at_p(p_si) == errorreturn) return
t_freeze=liq_ice_air_temperature_si()
if(t_freeze==errorreturn) return

!if(t_si < t_freeze) then
!    if(set_ice_air_eq_at_t_p(t_si, p_si)==errorreturn) return
!else
!    if(set_ice_air_eq_at_t_p(tp_temperature_si, sealevel_pressure_si)==errorreturn) return
!endif
if(set_ice_air_eq_at_t_p(t_freeze, p_si)==errorreturn) return
lv = ice_air_enthalpy_subl_si()/air_g_cp_si(1d0,t_si,p_si)

t_temp = t_si*exp(lv*(1d0-wa_si)/t_freeze)

if(p_si>(sealevel_pressure_si-tp_pressure_iapws95_si)) then 
    mixing_eta = -gas_constant_air_si/liq_ice_air_g_cond_cp_si(1d0,t_si,p_si)*&
                        wa_si*log(p_si/(sealevel_pressure_si-tp_pressure_iapws95_si))
else
    mixing_eta =  gas_constant_air_si/liq_ice_air_g_cond_cp_si(1d0,t_si,p_si)*&
                        wa_si*log(p_si/(sealevel_pressure_si-tp_pressure_iapws95_si))
endif
t_temp=t_temp*exp(-mixing_eta)

if(t_temp>=mix_air_tmax) then
    max_liq_ice_air_temperatureequi_si = mix_air_tmax
else
    max_liq_ice_air_temperatureequi_si = t_temp
endif

end function

!==========================================================================
function temperatureequiiteration_brent(wa_si, t_si, p_si, t1, t2, &
                                    maxit, eps)
!=========================================================================

!THE FUNCTION COMPUTES THE EQUIVALENT TEMPERATURE AS A FUNCTION OF AIR FRACTION, ENTROPY AND PRESSURE,
!COMPUTED BY BRENT ITERATION
!HTTP://EN.WIKIPEDIA.ORG/WIKI/BRENT'S_METHOD

!OUTPUT: 
!        TEMPERATUREITERATION_BRENT: EQUIVALENT TEMPERATURE IN K
!        THE VALUE ERRORRETURN IS RETURNED IF
!        - THE MAXIMUM NUMBER OF ITERATIONS IS EXCEEDED WITHOUT MEETING THE EXIT CRITERION
!        - THE FUNCTION CALL TO LIQ_AIR_G_SI HAS RETURNED AN ERROR
!        - TEMPERATURE HAS TAKEN A ZERO OR NEGATIVE VALUE DURING THE ITERATION

!INPUT: 
!       WA_SI: MASS FRACTION OF DRY AIR IN WET AIR IN KG/KG
!        T_SI: TEMPERATURE IN K
!        P_SI: ABSOLUTE PRESSURE IN PA
!          T1: INITIAL GUESS FOR EQUIVALENT TEMPERATURE IN K
!          T2: COUNTERPOINT EQUIVALENT TEMPERATURE
!       MAXIT: MAXIMUM NUMBER OF ITERATION STEPS TO BE DONE
!         EPS: REQUIRED ACCURACY OF TEMPERATURE
!              EPS > 0: ABSOLUTE TEMPERATURE TOLERANCE IN K
!              EPS < 0: RELATIVE TEMPERATURE TOLERANCE

real*8 temperatureequiiteration_brent, wa_si, t_si, p_si, t1, t2, eps
real*8 a, b, c, d, s
real*8 fa, fb, fc, fs
real*8 eta, mixing_eta
integer it, maxit

logical mflag

temperatureequiiteration_brent = errorreturn
d = errorreturn

if(wa_si < 0d0 .or. wa_si > 1d0 .or. &
  t1 <= 0d0 .or. &
  t2 <= 0d0 .or. &
  p_si <= 0d0 .or. &
  eps == 0d0 .or. &
  maxit <= 0) return

!mixing_eta = -gas_constant_air_si*wa_si*log(p_si/(sealevel_pressure_si-tp_pressure_iapws95_si))
mixing_eta = 0d0

a = t1

eta = liq_ice_air_g_cond_entropy_si(wa_si, a, p_si)+mixing_eta
if(eta>liq_ice_air_g_entropy_si(wa_si, mix_air_tmax, p_si)) then
    fa = -mix_air_tmax
else
    fa = -liq_ice_air_h_temperature_si(wa_si,eta,p_si)
endif
fa = -fa - t_si

b = t2
eta = liq_ice_air_g_cond_entropy_si(wa_si, b, p_si)+mixing_eta
if(eta>liq_ice_air_g_entropy_si(wa_si, mix_air_tmax, p_si)) then
    fb = -mix_air_tmax
else
    fb = -liq_ice_air_h_temperature_si(wa_si,eta,p_si)
endif
fb = -fb - t_si

!write(*,*) a,fa,b,fb
if(fa * fb > 0d0) return


if(abs(fa) < abs(fb)) then
  call swap(a, b)
  call swap(fa, fb)
end if

c = a
fc = fa
mflag = .true.

check_limits = check_limits - 1

do it = 1, maxit

  if(fb == 0d0) then
    temperatureequiiteration_brent = b
    go to 999
  end if

  if(eps > 0d0) then                !ABSOLUTE LIMIT
    if(abs(a - b) < eps) then
      temperatureequiiteration_brent = b
      go to 999
    end if
  else                                 !RELATIVE LIMIT
    if(abs(a - b) < -eps * b) then
      temperatureequiiteration_brent = b
      go to 999
    end if
  end if

  if(fa == fb) go to 999

  if(fa /= fc .and. fb /= fc) then
    s = a * fb * fc / ((fa - fb) * (fa - fc)) +  &
        b * fa * fc / ((fb - fa) * (fb - fc)) +  &
        c * fa * fb / ((fc - fa) * (fc - fb))
  else
    s = b - (b - a) * fb / (fb - fa)
  end if

  if(((3 * a + b) / 4 - s) * (b - s) > 0d0 .or. &
     (mflag .and. abs(s - b) >= 0.5 * abs(b - c)) .or. &
     (.not. mflag .and. abs(s - b) >= 0.5 * (c - d))) then
    s = 0.5 * (a + b)
  else
    mflag = .false.
  end if

  eta = liq_ice_air_g_cond_entropy_si(wa_si, s, p_si) + mixing_eta
  fs = -liq_ice_air_h_temperature_si(wa_si,eta,p_si)
  fs = -fs - t_si

  d = c
  c = b
  fc = fb

  if(fa * fs < 0d0) then
    b = s
    fb = fs
  else
    a = s
    fa = fs
  end if

  if(abs(fa) < abs(fb)) then
    call swap(a, b)
    call swap(fa, fb)
  end if

enddo

999 continue

check_limits = check_limits + 1

if(check_limits == 1) then
  !FLU_LIMITS
  if(b < flu_tmin .or. b > flu_tmax) then
    temperatureequiiteration_brent = errorreturn
    return
  endif
  !AIR_LIMITS
  if(b < dry_air_tmin .or. b > dry_air_tmax) &
    temperatureequiiteration_brent = errorreturn
endif

end function


!==========================================================================
subroutine init_it_ctrl_tempequi()
!=========================================================================

if(ctrl_initialized == -1) return

ctrl_initialized = -1

!SET DEFAULT VALUES AND MODES FOR DENSITY ITERATION
ctrl_loop_maximum = 100
ctrl_mode_tempequi = 0           !default: minimum temperature is equal to absolute temperature
ctrl_init_tempequi = 273.15d0
ctrl_eps_exit_tempequi = 0.0001d0  !default = 0.1 mk

end subroutine

!==========================================================================
subroutine set_it_ctrl_liq_ice_air_tempequi(key, value)
!=========================================================================

!THIS SUB SETS CONTROL PARAMETERS FOR THE NEWTON ITERATION USED TO COMPUTE
!EQUIVALENT TEMPERATURE FROM REFERENCE PRESSURE

!KEY             VALUE
!IT_STEPS        0           SET ITERATION NUMBER TO DEFAULT (100)
!IT_STEPS        N > 0    SET ITERATION NUMBER TO N
!IT_STEPS       -1           DO NOT ITERATE, USE INITIAL VALUE

!INIT_THETA      0           USE DEFAULT EQUIVALENT TEMPERATURE TE=T_SI TO START
!INIT_THETA      T > 0    USE VALUE T AS EQUIVALENT TEMPERATURE TO START

!TOL_THETA       0           USE DEFAULT EXIT ACCURACY FOR EQUIVALENT TEMPERATURE (0.1 MK)
!TOL_THETA       EPS > 0  USE EPS AS EXIT ACCURACY FOR EQUIVALENT TEMPERATURE

character*13 key
real*8 value

call init_it_ctrl_tempequi

select case (trim(key))

  case ("it_steps");                 !ITERATION STEPS
      if(value == 0d0) then
         ctrl_loop_maximum = 100     !DEFAULT = 100
      elseif(value < 0d0) then
         ctrl_loop_maximum = -1
      else
         ctrl_loop_maximum = nint(value)
      endif

  case ("init_theta");               !START THETA
      if(value == 0d0) then
         ctrl_mode_tempequi = 0       !DEFAULT: TE=T_SI
      elseif(value > 0d0) then
         ctrl_mode_tempequi = 1
         ctrl_init_tempequi = nint(value)
      endif

  case ("tol_theta");                !REQUIRED THETA TOLERANCE
      if(value == 0d0) then
         ctrl_eps_exit_tempequi = 0.0001d0 !DEFAULT = 0.1 MK
      elseif(value > 0d0) then
         ctrl_eps_exit_tempequi = value
      endif

  case default; write(*,*)key,' not supported'

  end select

  end subroutine

!==========================================================================
subroutine swap(a, b)
!==========================================================================

real*8 a, b, c
c = a
a = b
b = c

end subroutine

end module liq_ice_air_5d

module liq_air_4c

!#########################################################################

!THIS MODULE IMPLEMENTS THE ENTHALPY OF WET AIR, AS WELL AS ITS PARTIAL
!DERIVATIVES, DEPENDING ON AIR FRACTION, ENTROPY AND PRESSURE.

!#########################################################################

!IMPLEMENTATION IN FORTRAN BY D.G. WRIGHT
!FOR PUBLICATION IN OCEAN SCIENCE, AS DESCRIBED IN THE PAPERS

!FEISTEL, R., WRIGHT, D.G., JACKETT, D.R., MIYAGAWA, K., REISSMANN, J.H.,
!WAGNER, W., OVERHOFF, U., GUDER, C., FEISTEL, A., MARION, G.M.:
!NUMERICAL IMPLEMENTATION AND OCEANOGRAPHIC APPLICATION OF THE THERMODYNAMIC
!POTENTIALS OF WATER, VAPOUR, ICE, SEAWATER AND AIR. PART I: BACKGROUND AND EQUATIONS. 
!OCEAN SCIENCES, 2009, IN PREPARATION.

!WRIGHT, D.G., FEISTEL, R., JACKETT, D.R., MIYAGAWA, K., REISSMANN, J.H., 
!WAGNER, W., OVERHOFF, U., GUDER, C., FEISTEL, A., MARION, G.M.:
!NUMERICAL IMPLEMENTATION AND OCEANOGRAPHIC APPLICATION OF THE THERMODYNAMIC
!POTENTIALS OF WATER, VAPOUR, ICE, SEAWATER AND AIR. PART II: THE LIBRARY ROUTINES, 
!OCEAN SCIENCES., 2009, IN PREPARATION.

!FEISTEL, R., KRETZSCHMAR, H.-J., SPAN, R., HAGEN, E., WRIGHT, D.G., HERRMANN, S.:
!THERMODYNAMIC PROPERTIES OF SEA AIR.
!OCEAN SCIENCE DISCUSSION 6(2009)2193-2325.

!#########################################################################

!THIS MODULE REQUIRES THE LIBRARY MODULES:
!     CONSTANTS_0, FILE CONSTANTS_0.F90
!     AIR_3A,      FILE AIR_3A.F90
!     ICE_LIQ_4,   FILE ICE_LIQ_4.F90
!     LIQ_AIR_4A,  FILE LIQ_AIR_4A.F90
!     LIQ_AIR_4B,  FILE LIQ_AIR_4B.F90

!NESTED USE ASSOCIATIONS
!     CONVERT_0,   FILE CONVERT_0.F90
!     MATHS_0,     FILE MATHS_0.F90
!     AIR_1,       FILE AIR_1.F90
!     FLU_1,       FILE FLU_1.F90
!     ICE_1,       FILE ICE_1.F90
!     ICE_2,       FILE ICE_2.F90
!     AIR_2,       FILE AIR_2.F90
!     FLU_2,       FILE FLU_2.F90
!     AIR_3B,      FILE AIR_3A.F90
!     FLU_3A,      FILE FLU_3A.F90
!     LIQ_VAP_4,   FILE LIQ_VAP_4.F90

!#########################################################################

use constants_0
use air_3a
use ice_liq_4
use liq_air_4a
use liq_air_4b

implicit none
private

character*16, private :: version = '8 Jun 2010'

public :: liq_air_h_si, liq_air_h_cp_si, liq_air_h_density_si, &
          liq_air_h_kappa_s_si, liq_air_h_lapserate_si, &
          liq_air_h_temperature_si, liq_air_potdensity_si,  &
          liq_air_potenthalpy_si, liq_air_pottemp_si, &
          set_it_ctrl_liq_air_pottemp

!CONTROL PARAMETERS OF THE TEMPERATURE ITERATION
integer ctrl_initialized

integer ctrl_mode_pottemp
integer ctrl_loop_maximum

real*8 ctrl_init_pottemp
real*8 ctrl_eps_exit_pottemp

contains

!==========================================================================
function liq_air_h_si(drv_wa, drv_eta, drv_p, wa_si, eta_si, p_si)
!==========================================================================

!THIS FUNCTION IMPLEMENTS ENTHALPY OF WET AIR AS A THERMODYNAMIC POTENTIAL,
!DEPENDING ON AIR MASS FRACTION, ENTROPY AND PRESSURE

!OUTPUT:
!LIQ_AIR_H_SI AS THE WA-ETA-P DERIVATIVE

!(D/DWA)^DRV_WA (D/DETA)^DRV_ETA (D/DP)^DRV_P H(WA,ETA,P)

!OF THE SPECIFIC ENTHALPY OF WET AIR, H(WA,ETA,P), IN J/KG

!INPUTS:
!WA_SI     DRY-AIR MASS FRACTION OF WET AIR IN KG/KG
!ETA_SI    SPECIFIC ENTROPY IN J/(KG K)
!P_SI      ABSOLUTE PRESSURE IN PA

!CHECK VALUES WITH DEFAULT SETTINGS, V1.0:
!LIQ_AIR_H_SI( 0, 0, 0, 0.5, 100, 1E5) = 26898.2871262
!LIQ_AIR_H_SI( 1, 0, 0, 0.5, 100, 1E5) =-1682.2814754|3
!LIQ_AIR_H_SI( 0, 1, 0, 0.5, 100, 1E5) = 280.392597112
!LIQ_AIR_H_SI( 0, 0, 1, 0.5, 100, 1E5) = 0.406967545475
!LIQ_AIR_H_SI( 2, 0, 0, 0.5, 100, 1E5) = 35.6650436194
!LIQ_AIR_H_SI( 1, 1, 0, 0.5, 100, 1E5) = 1.78333840654
!LIQ_AIR_H_SI( 1, 0, 1, 0.5, 100, 1E5) = 0.811934874970
!LIQ_AIR_H_SI( 0, 2, 0, 0.5, 100, 1E5) = 8.91712318143E-02
!LIQ_AIR_H_SI( 0, 1, 1, 0.5, 100, 1E5) = 1.55091234445E-04
!LIQ_AIR_H_SI( 0, 0, 2, 0.5, 100, 1E5) =-3.83855233558E-06

!CHECK VALUES WITH DEFAULT SETTINGS, V1.1:
!LIQ_AIR_H_SI( 0, 0, 0, 0.5, 100, 1E5) = 26898.5215492
!LIQ_AIR_H_SI( 1, 0, 0, 0.5, 100, 1E5) =-1681.7936611|3
!LIQ_AIR_H_SI( 0, 1, 0, 0.5, 100, 1E5) = 280.393544899
!LIQ_AIR_H_SI( 0, 0, 1, 0.5, 100, 1E5) = 0.40687293002
!LIQ_AIR_H_SI( 2, 0, 0, 0.5, 100, 1E5) = 35.768970891|5
!LIQ_AIR_H_SI( 1, 1, 0, 0.5, 100, 1E5) = 1.7859992519|6
!LIQ_AIR_H_SI( 1, 0, 1, 0.5, 100, 1E5) = 0.811745643965
!LIQ_AIR_H_SI( 0, 2, 0, 0.5, 100, 1E5) = 8.91776656830E-02
!LIQ_AIR_H_SI( 0, 1, 1, 0.5, 100, 1E5) = 1.55067379031E-04
!LIQ_AIR_H_SI( 0, 0, 2, 0.5, 100, 1E5) =-3.83770118470E-06

!NOTE: THE ACCURACY OF THIS FUNCTION DEPENDS ON THE ITERATION SETTINGS FOR
!      DENSITY COMPUTED IN FLU_3A AND AIR_3A, AND ON THE ITERATION SETTINGS
!      FOR TEMPERATURE BY SET_IT_CTRL_LIQ_AIR_POTTEMP OF THIS MODULE

real*8 liq_air_h_si, wa_si, eta_si, p_si
real*8 t

integer drv_wa, drv_eta, drv_p

liq_air_h_si = errorreturn

if(drv_wa < 0) return
if(drv_eta < 0) return
if(drv_p < 0) return
if(drv_wa + drv_eta + drv_p > 2) return

if(wa_si < 0d0 .or. wa_si > 1d0) return
if(p_si < 0d0) return

!COMPUTE TEMPERATURE FROM ENTROPY.
!IF P_SI = IN-SITU PRESSURE, THIS IS IN-SITU TEMPERATURE
!IF P_SI = REFERENCE PRESSURE, THIS IS POTENTIAL TEMPERATURE
t = liq_air_h_temperature_si(wa_si, eta_si, p_si)
if(t == errorreturn) return

liq_air_h_si = liq_air_a_eta_p_derivatives_si(drv_wa, drv_eta, drv_p, wa_si, t, p_si)

end function

!=========================================================================
function liq_air_h_cp_si(wa_si, eta_si, p_si)
!=========================================================================
                                 
!OUTPUT:
!CP(A,ETA,P) = T/H_ETA_ETA  HEAT CAPACITY OF WET AIR IN J/(KG K)

!INPUTS:
!WA_SI     DRY-AIR MASS FRACTION IN KG/KG
!ETA_SI    SPECIFIC ENTROPY IN J/(KG K)
!P_SI      ABSOLUTE PRESSURE IN PA

!CHECK VALUE WITH DEFAULT SETTINGS, V1.0:
!LIQ_AIR_H_CP_SI(0.5, 100, 1E5) = 3144.42888595

!CHECK VALUE WITH DEFAULT SETTINGS, V1.1:
!LIQ_AIR_H_CP_SI(0.5, 100, 1E5) = 3144.21265404

!NOTE: THE ACCURACY OF THIS FUNCTION DEPENDS ON THE ITERATION SETTINGS FOR
!      DENSITY COMPUTED IN FLU_3A, AIR_3A AND ON THOSE MADE IN THIS MODULE

real*8 liq_air_h_cp_si, wa_si, eta_si, p_si
real*8 t

liq_air_h_cp_si = errorreturn

t = liq_air_h_temperature_si(wa_si, eta_si, p_si)
if(t == errorreturn) return
if(t <= 0d0) return

liq_air_h_cp_si = liq_air_g_cp_si(wa_si, t, p_si)

end function

!=========================================================================
function liq_air_h_density_si(wa_si, eta_si, p_si)
!=========================================================================
                                 
!OUTPUT:
!D(A,ETA,P) = 1/H_P DENSITY OF WET AIR IN KG/M3

!INPUTS:
!WA_SI     DRY-AIR MASS FRACTION IN KG/KG
!ETA_SI    SPECIFIC ENTROPY IN J/(KG K)
!P_SI      ABSOLUTE PRESSURE IN PA

!CHECK VALUE WITH DEFAULT SETTINGS, V1.0:
!LIQ_AIR_H_DENSITY_SI(0.5, 100, 1E5) = 2.45719839609

!CHECK VALUE WITH DEFAULT SETTINGS, V1.1:
!LIQ_AIR_H_DENSITY_SI(0.5, 100, 1E5) = 2.45776980040

!NOTE: THE ACCURACY OF THIS FUNCTION DEPENDS ON THE ITERATION SETTINGS FOR
!      DENSITY COMPUTED IN FLU_3A, AIR_3A AND ON THOSE MADE IN THIS MODULE

real*8 liq_air_h_density_si, wa_si, eta_si, p_si
real*8 t

liq_air_h_density_si = errorreturn

t = liq_air_h_temperature_si(wa_si, eta_si, p_si)
if(t == errorreturn) return
if(t <= 0d0) return

liq_air_h_density_si = liq_air_g_density_si(wa_si, t, p_si)

end function

!=========================================================================
function liq_air_h_kappa_s_si(wa_si, eta_si, p_si)
!=========================================================================
                                 
!OUTPUT:
!KAPPA(A,ETA,P) = - H_PP/H_P ADIABATIC COMPRESSIBILITY OF WET AIR IN 1/PA

!INPUTS:
!WA_SI     DRY-AIR MASS FRACTION IN KG/KG
!ETA_SI    SPECIFIC ENTROPY IN J/(KG K)
!P_SI      ABSOLUTE PRESSURE IN PA

!CHECK VALUE WITH DEFAULT SETTINGS, V1.0:
!LIQ_AIR_H_KAPPA_S_SI(0.5, 100, 1E5) = 9.43208464228E-06

!CHECK VALUE WITH DEFAULT SETTINGS, V1.1:
!LIQ_AIR_H_KAPPA_S_SI(0.5, 100, 1E5) = 9.43218607469E-06

!NOTE: THE ACCURACY OF THIS FUNCTION DEPENDS ON THE ITERATION SETTINGS FOR
!      DENSITY COMPUTED IN FLU_3A, AIR_3A AND ON THOSE MADE IN THIS MODULE

real*8 liq_air_h_kappa_s_si, wa_si, eta_si, p_si
real*8 d, c

liq_air_h_kappa_s_si = errorreturn

d = liq_air_h_density_si(wa_si, eta_si, p_si)
if(d == errorreturn) return
if(d <= 0d0) return

c = liq_air_h_si(0, 0, 2, wa_si, eta_si, p_si)
if(c == errorreturn) return
if(c >= 0d0) return

liq_air_h_kappa_s_si = -d * c

end function

!=========================================================================
function liq_air_h_lapserate_si(wa_si, eta_si, p_si)
!=========================================================================
                                 
!OUTPUT:
!GAMMA(A,ETA,P) = H_ETA_P  MOIST-ADIABATIC LAPSE RATE IN K/PA

!INPUTS:
!WA_SI     DRY-AIR MASS FRACTION OF WET AIR IN KG/KG
!ETA_SI    SPECIFIC ENTROPY IN J/(KG K)
!P_SI      ABSOLUTE PRESSURE IN PA

!CHECK VALUE WITH DEFAULT SETTINGS, V1.0:
!LIQ_AIR_H_LAPSERATE_SI(0.5, 100, 1E5) = 1.55091234445E-04

!CHECK VALUE WITH DEFAULT SETTINGS, V1.1:
!LIQ_AIR_H_LAPSERATE_SI(0.5, 100, 1E5) = 1.55067379031E-04

!NOTE: THE ACCURACY OF THIS FUNCTION DEPENDS ON THE ITERATION SETTINGS FOR
!      DENSITY COMPUTED IN FLU_3A, AIR_3A AND ON THOSE MADE IN THIS MODULE

real*8  liq_air_h_lapserate_si, wa_si, eta_si, p_si

liq_air_h_lapserate_si = liq_air_h_si(0, 1, 1, wa_si, eta_si, p_si)

end function

!=========================================================================
function liq_air_h_temperature_si(wa_si, eta_si, p_si)
!=========================================================================

!THIS IS THE INVERSE FUNCTION FOR TEMPERATURE OF
!    ETA_SI = LIQ_AIR_G_ENTROPY_SI(WA_SI, T_SI, P_SI) IN LIQ_AIR_4B
                                 
!OUTPUT:
!T(A,ETA,P) (POTENTIAL) TEMPERATURE OF WET AIR IN K

!INPUTS:
!WA_SI     DRY-AIR MASS FRACTION IN KG/KG
!ETA_SI    SPECIFIC ENTROPY IN J/(KG K)
!P_SI      ABSOLUTE (REFERENCE) PRESSURE IN PA

!CHECK VALUE WITH DEFAULT SETTINGS, V1.0:
!LIQ_AIR_H_TEMPERATURE_SI(0.5, 100, 1E5) = 280.392597112

!CHECK VALUE WITH DEFAULT SETTINGS, V1.1:
!LIQ_AIR_H_TEMPERATURE_SI(0.5, 100, 1E5) = 280.393544899

!NOTE: THE ACCURACY OF THIS FUNCTION DEPENDS ON THE ITERATION SETTINGS FOR
!      DENSITY COMPUTED IN FLU_3A, AIR_3A AND ON THOSE MADE IN THIS MODULE

real*8 liq_air_h_temperature_si, wa_si, eta_si, p_si
real*8 t1, t2, eps
integer maxit

liq_air_h_temperature_si = errorreturn

call init_it_ctrl_pottemp

select case(ctrl_mode_pottemp)
  case(0);   t1 = aux_temperature_min_si(wa_si, p_si)
  case default; t1 = ctrl_init_pottemp
end select
t2 = aux_temperature_max_si(wa_si, p_si)

  if(ctrl_loop_maximum == 0) then
    maxit = 100
  elseif(ctrl_loop_maximum == (-1)) then
    liq_air_h_temperature_si = t1
    return
  elseif(ctrl_loop_maximum > 0) then
    maxit = ctrl_loop_maximum
  else
    return
  endif

eps = ctrl_eps_exit_pottemp
if(eps <= 0d0) return

!RUN THE ITERATION
liq_air_h_temperature_si = temperatureiteration_brent(wa_si, eta_si, p_si, t1, t2, maxit, eps)

end function

!==========================================================================
function liq_air_potdensity_si(a_si, t_si, p_si, pr_si)
!=========================================================================
                               
!THIS FUNCTION COMPUTES POTENTIAL DENSITY OF WET AIR

!OUTPUT:
!RHO_THETA(A,T,P,PR) POTENTIAL DENSITY OF WET AIR IN KG/M3

!INPUTS:
!A_SI      ABSOLUTE AIR MASS FRACTION IN KG/KG
!T_SI      ABSOLUTE IN-SITU TEMPERATURE IN K
!P_SI      ABSOLUTE IN-SITU PRESSURE IN PA
!PR_SI     ABSOLUTE REFERENCE PRESSURE IN PA

!CHECK VALUE WITH DEFAULT SETTINGS, V1.0:
!LIQ_AIR_POTDENSITY_SI(0.5, 300, 1E4, 1e5) = 1.22518908856

!CHECK VALUE WITH DEFAULT SETTINGS, V1.1:
!LIQ_AIR_POTDENSITY_SI(0.5, 300, 1E4, 1e5) = 1.22550664945

!NOTE: THE ACCURACY OF THIS FUNCTION DEPENDS ON THE ITERATION SETTINGS FOR
!      DENSITY COMPUTED IN FLU_3A
!      AND ON THE ITERATION SETTINGS FOR TEMPERATURE BY SET_IT_CTRL_LIQ_AIR_POTTEMP OF THIS MODULE

real*8 liq_air_potdensity_si, a_si, t_si, p_si, pr_si
real*8 s, v

liq_air_potdensity_si = errorreturn

if(a_si < 0d0 .or. a_si >= 1d0) return
if(t_si < 0d0) return
if(p_si < 0d0) return
if(pr_si < 0d0) return

s = liq_air_g_entropy_si(a_si, t_si, p_si)  !specific entropy in-situ
if(s == errorreturn) return

v = liq_air_h_si(0, 0, 1, a_si, s, pr_si) !specific volume at reference pressure
if(v == errorreturn) return
if(v <= 0d0) return

liq_air_potdensity_si = 1d0 / v

end function

!==========================================================================
function liq_air_potenthalpy_si(a_si, t_si, p_si, pr_si)
!=========================================================================
                               
!THIS FUNCTION COMPUTES POTENTIAL ENTHALPY OF WET AIR

!OUTPUT:
!H_THETA(A,T,P,PR) POTENTIAL ENTHALPY OF WET AIR IN J/KG

!INPUTS:
!A_SI      ABSOLUTE AIR MASS FRACTION IN KG/KG
!T_SI      ABSOLUTE IN-SITU TEMPERATURE IN K
!P_SI      ABSOLUTE IN-SITU PRESSURE IN PA
!PR_SI     ABSOLUTE REFERENCE PRESSURE IN PA

!CHECK VALUE WITH DEFAULT SETTINGS, V1.0:
!LIQ_AIR_POTENTHALPY_SI(0.5, 300, 1E4, 1E5) = 655299.468706

!CHECK VALUE WITH DEFAULT SETTINGS, V1.1:
!LIQ_AIR_POTENTHALPY_SI(0.5, 300, 1E4, 1E5) = 655155.797982

!NOTE: THE ACCURACY OF THIS FUNCTION DEPENDS ON THE ITERATION SETTINGS FOR
!      DENSITY COMPUTED IN FLU_3A
!      AND ON THE ITERATION SETTINGS FOR TEMPERATURE BY SET_IT_CTRL_LIQ_AIR_POTTEMP OF THIS MODULE

real*8 liq_air_potenthalpy_si, a_si, t_si, p_si, pr_si
real*8 s

liq_air_potenthalpy_si = errorreturn

if(a_si < 0d0 .or. a_si >= 1d0) return
if(t_si < 0d0) return
if(p_si < 0d0) return
if(pr_si < 0d0) return

s = liq_air_g_entropy_si(a_si, t_si, p_si)  !specific entropy in-situ
if(s == errorreturn) return

liq_air_potenthalpy_si = liq_air_h_si(0, 0, 0, a_si, s, pr_si)

end function

!==========================================================================
function liq_air_pottemp_si(a_si, t_si, p_si, pr_si)
!=========================================================================
                               
!THIS FUNCTION COMPUTES POTENTIAL TEMPERATURE OF WET AIR

!OUTPUT:
!THETA(A,T,P,PR) ABSOLUTE POTENTIAL TEMPERATURE OF WET AIR IN K

!INPUTS:
!A_SI      ABSOLUTE AIR MASS FRACTION IN KG/KG
!T_SI      ABSOLUTE IN-SITU TEMPERATURE IN K
!P_SI      ABSOLUTE IN-SITU PRESSURE IN PA
!PR_SI     ABSOLUTE REFERENCE PRESSURE IN PA

!CHECK VALUE WITH DEFAULT SETTINGS, V1.0:
!LIQ_AIR_POTTEMP_SI(0.5, 300, 1E4, 1E5) = 348.223146077

!CHECK VALUE WITH DEFAULT SETTINGS, V1.1:
!LIQ_AIR_POTTEMP_SI(0.5, 300, 1E4, 1E5) = 348.222379217

real*8 liq_air_pottemp_si, a_si, t_si, p_si, pr_si
real*8 s

liq_air_pottemp_si = errorreturn

if(a_si < 0d0 .or. a_si >= 1d0) return
if(t_si < 0d0) return
if(p_si < 0d0) return
if(pr_si < 0d0) return

if(p_si == pr_si) then
  liq_air_pottemp_si = t_si
  return
end if

s = liq_air_g_entropy_si(a_si, t_si, p_si)  !specific entropy in-situ
if(s == errorreturn) return

liq_air_pottemp_si = liq_air_h_temperature_si(a_si, s, pr_si)

end function

!==========================================================================
function temperatureiteration_brent(wa_si, eta_si, p_si, t1, t2, &
!=========================================================================
                                    maxit, eps)

!THE FUNCTION COMPUTES THE TEMPERATURE AS A FUNCTION OF AIR FRACTION, ENTROPY AND PRESSURE,
!COMPUTED BY BRENT ITERATION
!HTTP://EN.WIKIPEDIA.ORG/WIKI/BRENT'S_METHOD

!OUTPUT: 
!        TEMPERATUREITERATION_BRENT: TEMPERATURE IN K
!        THE VALUE ERRORRETURN IS RETURNED IF
!        - THE MAXIMUM NUMBER OF ITERATIONS IS EXCEEDED WITHOUT MEETING THE EXIT CRITERION
!        - THE FUNCTION CALL TO LIQ_AIR_G_SI HAS RETURNED AN ERROR
!        - TEMPERATURE HAS TAKEN A ZERO OR NEG_ATIVE VALUE DURING THE ITERATION

!INPUT: 
!       WA_SI: MASS FRACTION OF DRY AIR IN WET AIR IN KG/KG
!      ETA_SI: SPECIFIC ENTROPY IN J/(KG K)
!        P_SI: ABSOLUTE PRESSURE IN PA
!          T1: INITIAL GUESS FOR TEMPERATURE IN K
!          T2: COUNTERPOINT TEMPERATURE
!       MAXIT: MAXIMUM NUMBER OF ITERATION STEPS TO BE DONE
!         EPS: REQUIRED ACCURACY OF TEMPERATURE
!              EPS > 0: ABSOLUTE TEMPERATURE TOLERANCE IN K
!              EPS < 0: RELATIVE TEMPERATURE TOLERANCE

real*8 temperatureiteration_brent, wa_si, eta_si, p_si, t1, t2, eps
real*8 a, b, c, d, s
real*8 fa, fb, fc, fs
integer it, maxit

logical mflag

temperatureiteration_brent = errorreturn
d = errorreturn

if(wa_si < 0d0 .or. wa_si > 1d0 .or. &
  t1 <= 0d0 .or. &
  t2 <= 0d0 .or. &
  p_si <= 0d0 .or. &
  eps == 0d0 .or. &
  maxit <= 0) return

a = t1
fa = liq_air_g_si(0, 1, 0, wa_si, a, p_si)
if(fa == ErrorReturn) then !permit excursions to the humid-air region
  fa = air_g_si(0, 1, 0, wa_si, a, p_si)
  If(fa == ErrorReturn) return
end if
fa = -fa - eta_si

b = t2
fb = liq_air_g_si(0, 1, 0, wa_si, b, p_si)
If(fb == ErrorReturn)then !permit excursions to the humid-air region
  fb = air_g_si(0, 1, 0, wa_si, b, p_si)
  if(fb == ErrorReturn) return
end if
fb = -fb - eta_si

if(fa * fb > 0d0) return

if(abs(fa) < abs(fb)) then
  call swap(a, b)
  call swap(fa, fb)
end if

c = a
fc = fa
mflag = .true.

check_limits = check_limits - 1

do it = 1, maxit

  if(fb == 0d0) then
    temperatureiteration_brent = b
    go to 999
  end if

  if(eps > 0d0) then                !ABSOLUTE LIMIT
    if(abs(a - b) < eps) then
      temperatureiteration_brent = b
      go to 999
    end if
  else                                 !RELATIVE LIMIT
    if(abs(a - b) < -eps * b) then
      temperatureiteration_brent = b
      go to 999
    end if
  end if

  if(fa == fb) go to 999

  if(fa /= fc .and. fb /= fc) then
    s = a * fb * fc / ((fa - fb) * (fa - fc)) +  &
        b * fa * fc / ((fb - fa) * (fb - fc)) +  &
        c * fa * fb / ((fc - fa) * (fc - fb))
  else
    s = b - (b - a) * fb / (fb - fa)
  end if

  if(((3 * a + b) / 4 - s) * (b - s) > 0d0 .or. &
     (mflag .and. abs(s - b) >= 0.5 * abs(b - c)) .or. &
     (.not. mflag .and. abs(s - b) >= 0.5 * (c - d))) then
    s = 0.5 * (a + b)
  else
    mflag = .false.
  end if

  fs = liq_air_g_si(0, 1, 0, wa_si, s, p_si)
  if(fs == ErrorReturn)then !permit excursions to the humid-air region
    fs = air_g_si(0, 1, 0, wa_si, s, p_si)
    if(fs == ErrorReturn) return
  end if
  fs = -fs - eta_si

  d = c
  c = b
  fc = fb

  if(fa * fs < 0d0) then
    b = s
    fb = fs
  else
    a = s
    fa = fs
  end if

  if(abs(fa) < abs(fb)) then
    call swap(a, b)
    call swap(fa, fb)
  end if

enddo

999 continue

check_limits = check_limits + 1

if(check_limits == 1) then
  !FLU_LIMITS
  if(b < flu_tmin .or. b > flu_tmax) then
    temperatureiteration_brent = errorreturn
    return
  endif
  !AIR_LIMITS
  if(b < dry_air_tmin .or. b > dry_air_tmax) &
    temperatureiteration_brent = errorreturn
endif

end function

!==========================================================================
function liq_air_a_eta_p_derivatives_si(drv_wa, drv_eta, drv_p, &
                                        wa_si, t_si, p_si)
!=========================================================================
                                              
!THIS FUNCTION COMPUTES THE WET-AIR PARTIAL WA-ETA-P DERIVATIVES OF H FROM WA-T-P DERIVATIVES OF G

real*8 liq_air_a_eta_p_derivatives_si, wa_si, t_si, p_si
real*8 g, g_t, g_p, g_a
real*8 g_aa, g_at, g_ap
real*8 g_tt, g_pp, g_tp
real*8 h

integer drv_wa, drv_eta, drv_p

!IN ONE CASE WE DO NOT AT ALL NEED TO COMPUTE THE GIBBS FUNCTION:
if(drv_wa == 0 .and. drv_eta == 1 .and. drv_p == 0) then
  liq_air_a_eta_p_derivatives_si = t_si
  return
end if

liq_air_a_eta_p_derivatives_si = errorreturn
g_tp = errorreturn

select case(drv_wa)

  case(0)
    select case(drv_eta)
    
      case(0)
        select case(drv_p)
        
          case(0)
            g = liq_air_g_si(0, 0, 0, wa_si, t_si, p_si)
            if(g == errorreturn) return
            g_t = liq_air_g_si(0, 1, 0, wa_si, t_si, p_si)
            if(g_t == errorreturn) return
            h = g - t_si * g_t                          !H
          
          case(1)
            g_p = liq_air_g_si(0, 0, 1, wa_si, t_si, p_si)
            if(g_p == errorreturn) return
            h = g_p                                      !DH/DP
                  
          case(2)
            g_tt = liq_air_g_si(0, 2, 0, wa_si, t_si, p_si)
            if(g_tt == errorreturn) return
            if(g_tt == 0d0) return
            g_tp = liq_air_g_si(0, 1, 1, wa_si, t_si, p_si)
            if(g_tp == errorreturn) return
            g_pp = liq_air_g_si(0, 0, 2, wa_si, t_si, p_si)
            if(g_pp == errorreturn) return
            h = (g_tt * g_pp - g_tp**2) / g_tt           !D2H/DP2
                  
          case default; return
        end select
        
      case(1)
        select case(drv_p)
          case(0)
            h = t_si                                     !DH/DETA, HAS ALREADY BEEN HANDLED INITIALLY
          
          case(1)
            g_tt = liq_air_g_si(0, 2, 0, wa_si, t_si, p_si)
            if(g_tt == errorreturn) return
            if(g_tt == 0d0) return
            g_tp = liq_air_g_si(0, 1, 1, wa_si, t_si, p_si)
            if(g_tp == errorreturn) return
            h = -g_tp / g_tt                             !D2H/DETADP
                  
          case default; return
        end select

      case(2)
        select case(drv_p)
          case(0)
            g_tt = liq_air_g_si(0, 2, 0, wa_si, t_si, p_si)
            if(g_tt == errorreturn) return
            if(g_tt == 0d0) return
            h = -1d0 / g_tt                              !D2H/DETA2
                  
          case default; return
        end select

      case default; return
    end select
    
  case(1)
    select case(drv_eta)
    
      case(0)
        select case(drv_p)
        
          case(0)
            g_a = liq_air_g_si(1, 0, 0, wa_si, t_si, p_si)
            if(g_a == errorreturn) return
            h = g_a                                      !DH/DA
          
          case(1)
            g_tt = liq_air_g_si(0, 2, 0, wa_si, t_si, p_si)
            if(g_tt == errorreturn) return
            if(g_tt == 0d0) return
            g_at = liq_air_g_si(1, 1, 0, wa_si, t_si, p_si)
            if(g_at == errorreturn) return
            g_ap = liq_air_g_si(1, 0, 1, wa_si, t_si, p_si)
            if(g_ap == errorreturn) return
            h = (g_tt * g_ap - g_at * g_tp) / g_tt       !D2H/DADP
          
          case default; return
        end select

      case(1)
        select case(drv_p)
        
          case(0)
            g_tt = liq_air_g_si(0, 2, 0, wa_si, t_si, p_si)
            if(g_tt == errorreturn) return
            if(g_tt == 0d0) return
            g_at = liq_air_g_si(1, 1, 0, wa_si, t_si, p_si)
            if(g_at == errorreturn) return
            h = -g_at / g_tt                             !D2H/DADETA
          
          case default; return
        end select

      case default; return
    end select

  
  case(2)
    select case(drv_eta)
    
      case(0)
        select case(drv_p)
        
          case(0)
            g_tt = liq_air_g_si(0, 2, 0, wa_si, t_si, p_si)
            if(g_tt == errorreturn) return
            if(g_tt == 0d0) return
            g_at = liq_air_g_si(1, 1, 0, wa_si, t_si, p_si)
            if(g_at == errorreturn) return
            g_aa = liq_air_g_si(2, 0, 0, wa_si, t_si, p_si)
            if(g_aa == errorreturn) return
            h = (g_tt * g_aa - g_at**2) / g_tt           !D2H/DA2
          
          case default; return
        end select

      case default; return
    end select

  case default; return
end select

liq_air_a_eta_p_derivatives_si = h

end function

!==========================================================================
function aux_temperature_max_si(wa_si, p_si)
!=========================================================================

!THIS FUNCTION ESTIMATES THE TEMPERATURE OF WET AIR AS A FUNCTION OF
!THE DRY-AIR FRACTION WA_SI AND THE PRESSURE P_SI
!IN THE ASYMPTOTIC LIMIT OF A VANISHING LIQUID FRACTION, WW << 1.

real*8 aux_temperature_max_si, wa_si, p_si, error_flag

aux_temperature_max_si = errorreturn
if(wa_si < 0d0 .or. wa_si > 1d0) return
if(p_si <= 0d0) return

!MAXIMUM ENTROPY AT THE SATURATION POINT:
error_flag = set_liq_air_eq_at_a_p(wa_si, p_si)
aux_temperature_max_si = liq_air_temperature_si()

end function

!==========================================================================
function aux_temperature_min_si(wa_si, p_si)
!=========================================================================

!THIS FUNCTION ESTIMATES THE TEMPERATURE OF WET AIR AS A FUNCTION OF
!THE DRY-AIR FRACTION WA_SI AND THE PRESSURE P_SI
!IN THE ASYMPTOTIC LIMIT OF A FREEZING LIQUID FRACTION.

real*8 aux_temperature_min_si, wa_si, p_si

aux_temperature_min_si = errorreturn
if(wa_si < 0d0 .or. wa_si > 1d0) return
if(p_si <= 0d0) return

!MINIMUM ENTROPY AT THE FREEZING POINT:
aux_temperature_min_si = ice_liq_meltingtemperature_si(p_si)

end function

!==========================================================================
subroutine init_it_ctrl_pottemp()
!=========================================================================

if(ctrl_initialized == -1) return

ctrl_initialized = -1

!SET DEFAULT VALUES AND MODES FOR DENSITY ITERATION
ctrl_loop_maximum = 100
ctrl_mode_pottemp = 0           !default: theta = aux_temperature_min_si to start
ctrl_init_pottemp = 273.15d0
ctrl_eps_exit_pottemp = 0.0001d0  !default = 0.1 mk

end subroutine

!==========================================================================
subroutine set_it_ctrl_liq_air_pottemp(key, value)
!=========================================================================

!THIS SUB SETS CONTROL PARAMETERS FOR THE NEWTON ITERATION USED TO COMPUTE
!POTENTIAL TEMPERATURE FROM REFERENCE PRESSURE

!KEY             VALUE
!IT_STEPS        0           SET ITERATION NUMBER TO DEFAULT (100)
!IT_STEPS        N > 0    SET ITERATION NUMBER TO N
!IT_STEPS       -1           DO NOT ITERATE, USE INITIAL VALUE

!INIT_THETA      0           USE DEFAULT POTENTIAL TEMPERATURE THETA = AUX_TEMPERATURE_MIN_SI TO START
!INIT_THETA      T > 0    USE VALUE T AS POTENTIAL TEMPERATURE TO START

!TOL_THETA       0           USE DEFAULT EXIT ACCURACY FOR POTENTIAL TEMPERATURE (0.1 MK)
!TOL_THETA       EPS > 0  USE EPS AS EXIT ACCURACY FOR POTENTIAL TEMPERATURE

character*13 key
real*8 value

call init_it_ctrl_pottemp

select case (trim(key))

  case ("it_steps");                 !ITERATION STEPS
      if(value == 0d0) then
         ctrl_loop_maximum = 100     !DEFAULT = 100
      elseif(value < 0d0) then
         ctrl_loop_maximum = -1
      else
         ctrl_loop_maximum = nint(value)
      endif

  case ("init_theta");               !START THETA
      if(value == 0d0) then
         ctrl_mode_pottemp = 0       !DEFAULT: THETA = AUX_TEMPERATURE_MIN_SI
      elseif(value > 0d0) then
         ctrl_mode_pottemp = 1
         ctrl_init_pottemp = nint(value)
      endif

  case ("tol_theta");                !REQUIRED THETA TOLERANCE
      if(value == 0d0) then
         ctrl_eps_exit_pottemp = 0.0001d0 !DEFAULT = 0.1 MK
      elseif(value > 0d0) then
         ctrl_eps_exit_pottemp = value
      endif

  case default; write(*,*)key,' not supported'

end select

end subroutine

!==========================================================================
subroutine swap(a, b)
!==========================================================================

real*8 a, b, c
c = a
a = b
b = c

end subroutine

end module liq_air_4c

module air_3a

!#########################################################################

!THIS MODULE IMPLEMENTS THE GIBBS FUNCTION OF HUMID AIR, DEPENDING ON
!DRY-AIR FRACTION, TEMPERATURE AND PRESSURE, AS WELL AS THEIR PARTIAL 
!DERIVATIVES, COMPUTED NUMERICALLY FROM THE HELMHOLTZ FUNCTION OF HUMID AIR.

!#########################################################################

!IMPLEMENTATION IN FORTRAN BY D.G. WRIGHT
!FOR PUBLICATION IN OCEAN SCIENCE, AS DESCRIBED IN THE PAPERS

!FEISTEL, R., WRIGHT, D.G., JACKETT, D.R., MIYAGAWA, K., REISSMANN, J.H.,
!WAGNER, W., OVERHOFF, U., GUDER, C., FEISTEL, A., MARION, G.M.:
!NUMERICAL IMPLEMENTATION AND OCEANOGRAPHIC APPLICATION OF THE THERMODYNAMIC
!POTENTIALS OF WATER, VAPOUR, ICE, SEAWATER AND AIR. PART I: BACKGROUND AND EQUATIONS. 
!OCEAN SCIENCES, 2009, IN PREPARATION.

!WRIGHT, D.G., FEISTEL, R., JACKETT, D.R., MIYAGAWA, K., REISSMANN, J.H., 
!WAGNER, W., OVERHOFF, U., GUDER, C., FEISTEL, A., MARION, G.M.:
!NUMERICAL IMPLEMENTATION AND OCEANOGRAPHIC APPLICATION OF THE THERMODYNAMIC
!POTENTIALS OF WATER, VAPOUR, ICE, SEAWATER AND AIR. PART II: THE LIBRARY ROUTINES, 
!OCEAN SCIENCES., 2009, IN PREPARATION.

!FEISTEL, R., KRETZSCHMAR, H.-J., SPAN, R., HAGEN, E., !WRIGHT, D.G., HERRMANN, S.:
!THERMODYNAMIC PROPERTIES OF SEA AIR.
!OCEAN SCIENCE DISCUSSION 6(2009)2193-2325.

!#########################################################################

!THIS MODULE REQUIRES THE LIBRARY MODULES:
!     CONSTANTS_0, FILE CONSTANTS_0.F90
!     CONVERT_0,   FILE CONVERT_0.F90
!     MATHS_0,     FILE MATHS_0.F90
!     AIR_1,       FILE AIR_1.F90
!     AIR_2,       FILE AIR_2.F90

!NESTED USE ASSOCIATIONS
!     FLU_1,       FILE FLU_1.F90

!#########################################################################

use constants_0
use convert_0
use maths_0
use air_1
use air_2

implicit none
private

character*16, private :: version = '8 Jun 2010'

public :: air_density_si, air_g_si, get_it_ctrl_airdensity, &
          set_it_ctrl_airdensity

!CONTROL PARAMETERS OF THE DENSITY ITERATION
integer ctrl_initialized
integer ctrl_mode_air
integer ctrl_loop_maximum
integer ctrl_method_air

real*8 ctrl_density_air
real*8 ctrl_eps_exit_air
real*8 ctrl_density2_air

contains 

!==========================================================================
function air_g_si(drv_a, drv_t, drv_p, a_si, t_si, p_si)
!==========================================================================

!THIS ROUTINE IMPLEMENTS THE GIBBS FUNCTION OF HUMID AIR COMPUTED FROM ITS 
!HELMHOLTZ FUNCTION AND ITS FIRST AND SECOND DERIVATIVES WITH RESPECT TO THE 
!AIR FRACTION A_SI, THE ABSOLUTE TEMPERATURE T_SI AND THE ABSOLUTE PRESSURE P_SI

!NOTE: THIS GIBBS FUNCTION IS NOT DESIGNED FOR LIQUID OR CRITICAL AIR STATES
!NOTE: THE ACCURACY OF THIS FUNCTIONS DEPENDS ON THE ITERATION SETTINGS OF THIS MODULE

!OUTPUT: 
!AIR_G_SI = SPECIFIC GIBBS ENERGY OR ITS DERIVATIVES IN J KG-1 K^-DRV_T PA^-DRV_P

!INPUT:  
!DRV_A = ORDER OF AIR-FRACTION DERIVATIVE, 0 <= DRV_A <= 2
!DRV_T = ORDER OF TEMPERATURE DERIVATIVE, 0 <= DRV_T + DRV_A <= 2
!DRV_P = ORDER OF PRESSURE DERIVATIVE, 0 <= DRV_P + DRV_T + DRV_A <= 2
!A_SI  = MASS FRACTION OF DRY AIR IN HUMID AIR IN KG/KG
!T_SI  = ABSOLUTE TEMPERATURE IN K
!P_SI  = ABSOLUTE PRESSURE IN PA


!CHECK VALUES WITH DEFAULT SETTINGS, V1.0:
!air_g_si( 0, 0, 0, 0.9, 300, 1E5) = 4574.43347102
!air_g_si( 1, 0, 0, 0.9, 300, 1E5) =-210115.722120
!air_g_si( 0, 1, 0, 0.9, 300, 1E5) =-911.203092171
!air_g_si( 0, 0, 1, 0.9, 300, 1E5) = 0.911688234199
!air_g_si( 2, 0, 0, 0.9, 300, 1E5) = 1415842.71443
!air_g_si( 1, 1, 0, 0.9, 300, 1E5) = 7566.48354961
!air_g_si( 1, 0, 1, 0.9, 300, 1E5) =-0.483164035114
!air_g_si( 0, 2, 0, 0.9, 300, 1E5) =-4.15491953969
!air_g_si( 0, 1, 1, 0.9, 300, 1E5) = 3.15167187428E-03
!air_g_si( 0, 0, 2, 0.9, 300, 1E5) =-9.14645118671E-06

!CHECK VALUES WITH DEFAULT SETTINGS, V1.1:
!air_g_si( 0, 0, 0, 0.9, 300, 1E5) = 4577.93065689
!air_g_si( 1, 0, 0, 0.9, 300, 1E5) =-210141.953243
!air_g_si( 0, 1, 0, 0.9, 300, 1E5) =-911.170080461
!air_g_si( 0, 0, 1, 0.9, 300, 1E5) = 0.911504137473
!air_g_si( 2, 0, 0, 0.9, 300, 1E5) = 1415779.23410
!air_g_si( 1, 1, 0, 0.9, 300, 1E5) = 7566.34779196
!air_g_si( 1, 0, 1, 0.9, 300, 1E5) =-0.483353002176
!air_g_si( 0, 2, 0, 0.9, 300, 1E5) =-4.15449972148
!air_g_si( 0, 1, 1, 0.9, 300, 1E5) = 3.15111222847E-03
!air_g_si( 0, 0, 2, 0.9, 300, 1E5) =-9.14462130186E-06

real*8 air_g_si, a_si, t_si, p_si
integer drv_a, drv_t, drv_p
real*8 g, d

air_g_si = errorreturn

if (a_si < 0d0 .or. a_si > 1d0) return
if (p_si <= 0d0) return

if(check_limits == 1) then
  if(t_si < dry_air_tmin .or. t_si > dry_air_tmax) return
  if(a_si /= 1d0 .and. (t_si < mix_air_tmin .or. t_si > mix_air_tmax)) return
else
  if (t_si <= 0d0) return
endif

d = air_density_si(a_si, t_si, p_si)  !NUMERICAL INVERSE FUNCTION TO p = -df/dv

if(d == errorreturn) return
if(d <= 0d0) return

if(check_limits == 1) then
  if(d <= dry_air_dmin .or. d > dry_air_dmax) return
endif

g = air_a_t_p_derivative_si(drv_a, drv_t, drv_p, a_si, t_si, d)
if(g == errorreturn) return

air_g_si = g

end function

!==========================================================================
function air_density_si(a_si, t_si, p_si)
!==========================================================================

!THIS FUNCTION RETURNS HUMID-AIR DENSITY AS A FUNCTION OF AIR FRACTION, TEMPERATURE AND PRESSURE
!FROM NUMERICAL ITERATION OF THE HELMHOLTZ FUNCTION DERIVATIVE, P = - (DF/DV)_A,T

!OUTPUT:
!AIR_DENSITY_SI: DENSITY OF HUMID AIR IN KG/M3

!INPUT:
!A_SI:  MASS FRACTION OF DRY AIR IN KG/KG
!T_SI:  ABSOLUTE TEMPERATURE IN K
!P_SI:  ABSOLUTE PRESSURE IN PA

!CHECK VALUE WITH DEFAULT SETTINGS, V1.0: 
!air_density_si(0.9, 300, 1E5) = 1.09686619009

!CHECK VALUE WITH DEFAULT SETTINGS, V1.1: 
!air_density_si(0.9, 300, 1E5) = 1.09708772444

real*8 air_density_si, a_si, t_si, p_si
real*8 d, d2, eps
integer maxit

air_density_si = errorreturn

if(a_si < 0d0 .or. a_si > 1d0) return
if(t_si <= 0d0) return
if(p_si <= 0d0) return

call init_it_ctrl_airdensity

!CONSIDER THE CONTROL SETTINGS FOR THE ITERATION
select case(ctrl_mode_air)
  case (1); d = ctrl_density_air
  case (0); d = aux_density_ideal_si(a_si, t_si, p_si)
  case (-1); d = aux_density_ideal_si(a_si, t_si, p_si)
  case default; return
end select

if(d == errorreturn) return
if(d <= 0d0) return

if(ctrl_loop_maximum == 0) then
   maxit = 100
elseif(ctrl_loop_maximum == (-1)) then
   air_density_si = d
   return
elseif(ctrl_loop_maximum > 0) then
   maxit = ctrl_loop_maximum
else
   return
endif

eps = ctrl_eps_exit_air
if(eps == 0d0) return

if(ctrl_method_air > 1) then
  !SPECIFY THE SECOND POINT FOR SECANT OR BRENT METHOD
  if(ctrl_density2_air == 0d0) then
    d2 = densityiteration_newton(a_si, t_si, p_si, d, 1, 1d99)
    if(d2 == errorreturn) return
    if(ctrl_method_air == 2) then !BRENT
      d2 = d + 2d0 * (d2 - d)
    end if
  elseif(ctrl_density2_air == (-1d0)) then
    d2 = densityiteration_newton(a_si, t_si, p_si, d, 1, 1d99)
    if(d2 == errorreturn) return
  elseif(ctrl_density2_air == (-2d0)) then
    d2 = densityiteration_newton(a_si, t_si, p_si, d, 1, 1d99)
    if(d2 == errorreturn) return
    d2 = d + 0.5d0 * (d2 - d)
  elseif(ctrl_density2_air == (-3d0)) then
    d2 = densityiteration_newton(a_si, t_si, p_si, d, 1, 1d99)
    if(d2 == errorreturn) return
    d2 = d + 2d0 * (d2 - d)
  elseif(ctrl_density2_air > 0d0) then
    d2 = ctrl_density2_air
  else 
    return
  endif
end if

!RUN THE ITERATION
select case(ctrl_method_air)
  case(0); d = densityiteration_newton(a_si, t_si, p_si, d, maxit, eps)
  case(1); d = densityiteration_newton(a_si, t_si, p_si, d, maxit, eps)
  case(2); d = densityiteration_brent(a_si, t_si, p_si, d, d2, maxit, eps)
  case(3); d = densityiteration_secant(a_si, t_si, p_si, d, d2, maxit, eps)
  case default; return
end select

if(d == errorreturn) return
if(d <= 0) return

air_density_si = d

end function

!==========================================================================
function densityiteration_newton(a, t, p, d, maxit, eps)
!==========================================================================

!THIS FUNCTION RETURNS THE DENSITY OF HUMID AIR AS A FUNCTION OF AIR FRACTION, TEMPERATURE AND PRESSURE
!COMPUTED FROM THE HELMHOLTZ FUNCTION BY NEWTON ITERATION
!HTTP://EN.WIKIPEDIA.ORG/WIKI/NEWTON%27S_METHOD

!OUTPUT: 
!DENSITYITERATION_NEWTON: DENSITY OF HUMID AIR IN KG/M3
!THE VALUE ERRORRETURN IS RETURNED IF
!    - THE MAXIMUM NUMBER OF ITERATIONS IS EXCEEDED WITHOUT MEETING THE EXIT CRITERION
!    - THE FUNCTION CALL TO AIR_F_SI HAS RETURNED AN ERROR
!    - DENSITY HAS TAKEN A ZERO OR NEGATIVE VALUE DURING THE ITERATION

!INPUT:  
!A: MASS FRACTION OF DRY AIR IN KG/KG
!T: ABSOLUTE TEMPERATURE IN K
!P: ABSOLUTE PRESSURE IN PA
!D: INITIAL GUESS FOR DENSITY IN KG/M3
!MAXIT: MAXIMUM NUMBER OF ITERATION STEPS TO BE DONE
!EPS: REQUIRED ACCURACY OF DENSITY
!     EPS > 0: ABSOLUTE DENSITY TOLERANCE IN KG/M3
!     EPS < 0: RELATIVE DENSITY TOLERANCE

real*8 densityiteration_newton, a, t, p, d, eps
real*8 dd, f_d, f_dd
integer it, maxit

densityiteration_newton = errorreturn

if(a < 0d0 .or. a > 1d0) return
if (p <= 0d0) return

if(check_limits == 1) then
  if(t < dry_air_tmin .or. t > dry_air_tmax) return
  if(a /= 1d0 .and. (t < mix_air_tmin .or. t > mix_air_tmax)) return
else
  if(t <= 0d0) return
endif

check_limits = check_limits - 1

do it = 1, maxit

  f_d = air_f_si(0, 0, 1, a, t, d)
  if(f_d == errorreturn) goto 999
  
  f_dd = air_f_si(0, 0, 2, a, t, d)
  if(f_dd == errorreturn) goto 999
  
  dd = d * (2d0 * f_d + d * f_dd)
  if(dd <= 0d0) goto 999

  dd = (p - d**2 * f_d) / dd
  d = d + dd

  if(d <= 0d0) goto 999

  if(eps > 0d0) then            !ABSOLUTE LIMIT
    if(abs(dd) < eps) then
      densityiteration_newton = d
      goto 999
    end if
  else                             !RELATIVE LIMIT
    if(abs(dd) < -eps * d) then
      densityiteration_newton = d
      goto 999
    end if
  end if
  
enddo

999 continue

check_limits = check_limits + 1

end function

!==========================================================================
function densityiteration_brent(a_si, t, p, d1, d2, maxit, eps)
!==========================================================================

!THIS FUNCTION RETURNS THE DENSITY OF HUMID AIR AS A FUNCTION OF AIR FRACTION, TEMPERATURE AND PRESSURE
!COMPUTED FROM THE HELMHOLTZ FUNCTION BY BRENT ITERATION
!HTTP://EN.WIKIPEDIA.ORG/WIKI/BRENT'S_METHOD

!OUTPUT: 
!DENSITYITERATION_BRENT: DENSITY OF HUMID AIR IN KG/M3
!THE VALUE ERRORRETURN IS RETURNED IF
!    - THE MAXIMUM NUMBER OF ITERATIONS IS EXCEEDED WITHOUT MEETING THE EXIT CRITERION
!    - THE FUNCTION CALL TO AIR_F_SI HAS RETURNED AN ERROR
!    - DENSITY HAS TAKEN A ZERO OR NEGATIVE VALUE DURING THE ITERATION

!INPUT:  
!A_SI: MASS FRACTION OF DRY AIR IN KG/KG
!T: ABSOLUTE TEMPERATURE IN K
!P: ABSOLUTE PRESSURE IN PA
!D1: INITIAL GUESS FOR DENSITY IN KG/M3
!D2: COUNTERPOINT DENSITY
!MAXIT: MAXIMUM NUMBER OF ITERATION STEPS TO BE DONE
!EPS: REQUIRED ACCURACY OF DENSITY
!     EPS > 0: ABSOLUTE DENSITY TOLERANCE IN KG/M3
!     EPS < 0: RELATIVE DENSITY TOLERANCE

real*8 densityiteration_brent, a_si, t, p, d1, d2, eps
real*8 a, b, c, d, s
real*8 fa, fb, fc, fs
integer maxit, it
logical mflag

densityiteration_brent = errorreturn

d = errorreturn

If (d1 < d2) then
  a = d1
  b = d2
else
  b = d1
  a = d2
endif

if(a_si < 0d0 .or. a_si > 1d0) return
if(p <= 0d0) return

if(check_limits == 1) then
  if(t < dry_air_tmin .or. t > dry_air_tmax) return
  if(a /=1d0 .and. (t < mix_air_tmin .or. t > mix_air_tmax)) return
  if(a == 0d0) a= 1d-6
  if(b > dry_air_dmax) b = dry_air_dmax
else
  if(t <= 0d0) return
endif

check_limits = check_limits - 1

fa = a**2 * air_f_si(0, 0, 1, a_si, t, a) - p
fb = b**2 * air_f_si(0, 0, 1, a_si, t, b) - p
if(fa * fb > 0) go to 999

if(abs(fa) < abs(fb)) then
  call swap(a, b)
  call swap(fa, fb)
end if

c = a
fc = fa
mflag = .true.

do it = 1, maxit

  if(fb == 0d0) then
    densityiteration_brent = b
    go to 999
  end if
  if(eps > 0d0) then          !ABSOLUTE LIMIT
    if(abs(a - b) < eps) then
      densityiteration_brent = b
      go to 999
    end if
  else                           !RELATIVE LIMIT
    if(abs(a - b) < -eps * b) then
      densityiteration_brent = b
      go to 999
    end if
  end if

  if(fa == fb) go to 999

  if(fa /= fc .and. fb /= fc) then
    s = a * fb * fc / ((fa - fb) * (fa - fc)) + &
        b * fa * fc / ((fb - fa) * (fb - fc)) + &
        c * fa * fb / ((fc - fa) * (fc - fb))
  else
    s = b - (b - a) * fb / (fb - fa)
  end if

  if(((3d0 * a + b) / 4d0 - s) * (b - s) > 0d0 .or. &
    (mflag .and. abs(s - b) >= 0.5d0 * abs(b - c)) .or. &
    (.not. mflag .and. abs(s - b) >= 0.5d0 * (c - d))) then
    s = 0.5d0 * (a + b)
  else
    mflag = .false.
  end if

  fs = s**2 * air_f_si(0, 0, 1, a_si, t, s) - p
  d = c
  c = b
  fc = fb

  if(fa * fs < 0d0) then
    b = s
    fb = fs
  else
    a = s
    fa = fs
  end if

  if(abs(fa) < abs(fb)) then
    call swap(a, b)
    call swap(fa, fb)
  end if

enddo

999 continue

check_limits = check_limits + 1

end function

!==========================================================================
function densityiteration_secant(a, t, p, d, d2, maxit, eps)
!==========================================================================

!THIS FUNCTION RETURNS THE DENSITY OF HUMID AIR AS A FUNCTION AIR FRACTION, TEMPERATURE AND PRESSURE
!COMPUTED FROM THE HELMHOLTZ FUNCTION BY SECANT ITERATION
!HTTP://EN.WIKIPEDIA.ORG/WIKI/SECANT_METHOD

!OUTPUT: 
!DENSITYITERATION_SECANT: DENSITY OF HUMID AIR IN KG/M3
!THE VALUE ERRORRETURN IS RETURNED IF
!    - THE MAXIMUM NUMBER OF ITERATIONS IS EXCEEDED WITHOUT MEETING THE EXIT CRITERION
!    - THE FUNCTION CALL TO AIR_F_SI HAS RETURNED AN ERROR
!    - DENSITY HAS TAKEN A ZERO OR NEGATIVE VALUE DURING THE ITERATION

!INPUT:  
!A: MASS FRACTION OF DRY AIR IN KG/KG
!T: ABSOLUTE TEMPERATURE IN K
!P: ABSOLUTE PRESSURE IN PA
!D: INITIAL GUESS FOR DENSITY IN KG/M3
!D2: COUNTERPOINT DENSITY
!MAXIT: MAXIMUM NUMBER OF ITERATION STEPS TO BE DONE
!EPS: REQUIRED ACCURACY OF DENSITY
!     EPS > 0: ABSOLUTE DENSITY TOLERANCE IN KG/M3
!     EPS < 0: RELATIVE DENSITY TOLERANCE

real*8 densityiteration_secant, a, t, p, d, d2, eps
real*8 dd, d1, p1, p2
integer it, maxit

densityiteration_secant = errorreturn

if(a < 0d0 .or. a > 1d0) return
if(p <= 0d0) return

if(check_limits == 1) then
  if(t < dry_air_tmin .or. t > dry_air_tmax) return
  if(a /=1d0 .and. (t < mix_air_tmin .or. t > mix_air_tmax)) return
else
  if(t <= 0d0) return
endif

check_limits = check_limits - 1

p2 = d2**2 * air_f_si(0, 0, 1, a, t, d2)
if(p2 == errorreturn) go to 999

do it = 1, maxit
  d1 = d2
  p1 = p2
  d2 = d
  p2 = d**2 * air_f_si(0, 0, 1, a, t, d)

  if(p2 == errorreturn) go to 999
  if(p2 == p1) go to 999
  
  dd = -(d2 - d1) * (p2 - p) / (p2 - p1)
  d = d + dd

  if(d <= 0) go to 999

  if(eps > 0d0) then           !ABSOLUTE LIMIT
    if(abs(dd) < eps) then
      densityiteration_secant = d
      go to 999
    end if
  else                            !RELATIVE LIMIT
    if(abs(dd) < -eps * d) then
      densityiteration_secant = d
      go to 999
    end if
  end if
  
enddo

999 continue

check_limits = check_limits + 1

if(check_limits == 1) then
  if(d <= dry_air_dmin .or. d > dry_air_dmax) then
    densityiteration_secant = errorreturn
    return
  endif
endif

end function

!==========================================================================
function air_a_t_p_derivative_si(drv_a, drv_t, drv_p, a_si, t_si, d_si)
!==========================================================================

!THIS FUNCTION CONPUTES A-T-P DERIVATIVES OF G FROM A-T-D DERIVATIVES OF F
!AT GIVEN AIR FRACTION, TEMPERATURE AND DENSITY

!OUTPUT:
!AIR_A_T_P_DERIVATEVE_SI = SPECIFIC GIBBS ENERGY OR ITS DERIVATIVES IN J KG-1 K^-DRV_T PA^-DRV_P

!INPUT:
!DRV_A = ORDER OF AIR-FRACTION DERIVATIVE, 0 <= DRV_A <= 2
!DRV_T = ORDER OF TEMPERATURE DERIVATIVE, 0 <= DRV_T + DRV_A <= 2
!DRV_P = ORDER OF PRESSURE DERIVATIVE, 0 <= DRV_P + DRV_T + DRV_A <= 2
!A_SI  = MASS FRACTION OF DRY AIR IN HUMID AIR IN KG/KG
!T_SI  = ABSOLUTE TEMPERATURE IN K
!D_SI  = DENSITY OF HUMID AIR IN KG/M3

real*8 air_a_t_p_derivative_si, a_si, t_si, d_si
real*8 g
real*8 n
real*8 f, f_t, f_d, f_tt, f_td, f_dd, f_at, f_ad, f_aa
integer drv_a, drv_t, drv_p

air_a_t_p_derivative_si = errorreturn

n = errorreturn

if(drv_a < 0) return
if(drv_t < 0) return
if(drv_p < 0) return
if(drv_a + drv_t + drv_p > 2) return

if(a_si < 0d0 .or. a_si > 1d0) return
if(t_si <= 0d0) return
if(d_si <= 0d0) return

if(drv_a + drv_t + drv_p == 2) then !COMPUTE COMMON DENOMINATOR OF EACH 2ND DERIVATIVE
  f_d = air_f_si(0, 0, 1, a_si, t_si, d_si)
  if(f_d == errorreturn) return
  f_dd = air_f_si(0, 0, 2, a_si, t_si, d_si)
  if(f_dd == errorreturn) return
  n = 2d0 * f_d + d_si * f_dd
  if(n == 0d0) return
  n = 1d0 / n
end if

g = errorreturn

select case(drv_a)
  case(0)
    select case(drv_t)
      case(0)
        select case(drv_p)
          case(0)
            f = air_f_si(0, 0, 0, a_si, t_si, d_si)
            if(f == errorreturn) return
            f_d = air_f_si(0, 0, 1, a_si, t_si, d_si)
            if(f_d == errorreturn) return
            g = f + d_si * f_d                              !G
          case(1); g = 1d0 / d_si                           !G_P
          case(2); g = -n / d_si**3                        !G_PP
        end select
      case(1)
        select case(drv_p)
          case(0) 
            f_t = air_f_si(0, 1, 0, a_si, t_si, d_si)       !G_T
            if(f_t == errorreturn) return
            g = f_t
          case(1) 
            f_td = air_f_si(0, 1, 1, a_si, t_si, d_si)
            if(f_td == errorreturn) return
            g = f_td * n / d_si                             !G_TP
        end select
      case(2)
        select case(drv_p)
          case (0)
            f_tt = air_f_si(0, 2, 0, a_si, t_si, d_si)
            if(f_tt == errorreturn) return
            f_td = air_f_si(0, 1, 1, a_si, t_si, d_si)
            if(f_td == errorreturn) return
            g = f_tt - d_si * n * f_td**2                    !G_TT
        end select
    end select

  case(1)
    select case(drv_t)
      case(0)
        select case(drv_p)
          case(0)
            g = air_f_si(1, 0, 0, a_si, t_si, d_si)          !G_A
          case(1) 
            f_ad = air_f_si(1, 0, 1, a_si, t_si, d_si)
            if(f_ad == errorreturn) return
            g = f_ad * n / d_si                              !G_AP
        end select
      case(1)
        select case(drv_p)
          case(0) 
            f_at = air_f_si(1, 1, 0, a_si, t_si, d_si)
            if(f_at == errorreturn) return
            f_ad = air_f_si(1, 0, 1, a_si, t_si, d_si)
            if(f_ad == errorreturn) return
            f_td = air_f_si(0, 1, 1, a_si, t_si, d_si)
            if(f_td == errorreturn) return
            g = f_at - d_si * f_ad * f_td * n                !G_AT
        end select
    end select

  case(2)
    select case(drv_t)
      case(0)
        select case(drv_p)
          case(0)
            f_aa = air_f_si(2, 0, 0, a_si, t_si, d_si)
            if(f_aa == errorreturn) return
            f_ad = air_f_si(1, 0, 1, a_si, t_si, d_si)
            if(f_ad == errorreturn) return
            g = f_aa - d_si * f_ad**2 * n                    !G_AA
        end select
    end select
end select

air_a_t_p_derivative_si = g

end function

!==========================================================================
subroutine set_it_ctrl_airdensity(key, value)
!==========================================================================

!THIS SUBROUTINE SETS CONTROL PARAMETERS FOR THE ITERATION USED TO COMPUTE
!HUMID-AIR DENSITY FROM AIR-FRACTION, TEMPERATURE AND PRESSURE

!KEY              VALUE
!IT_STEPS         0           SET ITERATION NUMBER TO DEFAULT (100)
!IT_STEPS         N > 0       SET ITERATION NUMBER TO N
!IT_STEPS        -1           DO NOT ITERATE, USE INITIAL VALUE

!INIT_AIR_DENS    0           USE DEFAULT DENSITY TO START (IDEAL GAS)
!INIT_AIR_DENS   -1           USE IDEAL-GAS DENSITY TO START
!INIT_AIR_DENS    D > 0       USE VALUE D AS DENSITY TO START

!TOL_AIR_DENS     0           USE DEFAULT EXIT ACCURACY FOR DENSITY (0.1 PPM)
!TOL_AIR_DENS     EPS         USE EPS AS EXIT ACCURACY FOR DENSITY (EPS < 0 MEANS RELATIVE ERROR)

!METHOD_AIR       0           USE DEFAULT ITERATION METHOD (NOW: NEWTON METHOD) FOR DENSITY
!METHOD_AIR       1           USE NEWTON METHOD FOR DENSITY
!METHOD_AIR       2           USE BRENT METHOD FOR DENSITY
!METHOD_AIR       3           USE SECANT METHOD FOR DENSITY

!DENS2_AIR        0           USE DEFAULT COUNTERPOINT FOR BRENT/SECANT METHOD FOR DENSITY
!                             BRENT: 2 * NEWTON STEP, SECANT: 1 * NEWTON STEP
!DENS2_AIR       -1           USE NEWTON STEP AS THE FIRST COUNTERPOINT FOR DENSITY
!DENS2_AIR       -2           USE 0.5 * NEWTON STEP AS THE FIRST COUNTERPOINT FOR DENSITY
!DENS2_AIR       -3           USE 2 * NEWTON STEP AS THE FIRST COUNTERPOINT FOR DENSITY
!DENS2_AIR        D > 0       USE D AS THE FIRST COUNTERPOINT FOR DENSITY

character*13 key
real*8 value

call init_it_ctrl_airdensity

select case (trim(key))

  case ("it_steps");            !ITERATION STEPS
    if(value == 0d0) then
       ctrl_loop_maximum = 100  !DEFAULT = 100
    elseif(value < 0d0) then
       ctrl_loop_maximum = -1
    else   
       ctrl_loop_maximum = nint(value)
    endif

  case ("init_air_dens");       !START DENSITY
    if(value == 0d0) then
       ctrl_mode_air = 0        !DEFAULT = IDEAL GAS
    elseif(value < -1d0) then
       !return
    elseif(value < 0d0) then
       ctrl_mode_air = nint(value)
    else   
       ctrl_mode_air = 1
       ctrl_density_air = value
    endif

  case ("tol_air_dens");        !REQUIRED DENSITY TOLERANCE
    if(value == 0d0)then
       ctrl_eps_exit_air = -0.0000001d0   !DEFAULT = 0.1 PPM RELATIVE
    else
       ctrl_eps_exit_air = value
    endif

  case ("method_air");
    if(value == 0d0 .or. value == 1d0 .or. value == 2d0 .or. value == 3d0) &
       ctrl_method_air = nint(value)

  case ("dens2_air");
    if(value >= (-3d0)) ctrl_density2_air = value

  case default; write(*,*)key, " not supported"
end select

end subroutine

!==========================================================================
function get_it_ctrl_airdensity(key)
!==========================================================================

!THIS FUNCTION RETURNS CONTROL PARAMETERS AS SET FOR THE NEWTON OR OTHER ITERATION
!METHOD USED TO COMPUTE HUMID-AIR DENSITY FROM  AIR FRACTION, TEMPERATURE AND PRESSURE 

real*8 get_it_ctrl_airdensity
character*13 key

get_it_ctrl_airdensity = errorreturn

call init_it_ctrl_airdensity

select case (trim(key))

  case ("it_steps");            !MAX. ITERATION STEPS
    get_it_ctrl_airdensity = ctrl_loop_maximum

  case ("init_air_dens");       !INITIAL HUMID AIR DENSITY
    if(ctrl_mode_air == 1) then
      get_it_ctrl_airdensity = ctrl_density_air
    else
      get_it_ctrl_airdensity = ctrl_mode_air
    end if

  case ("tol_air_dens");        !REQUIRED HUMID AIR DENSITY TOLERANCE
    get_it_ctrl_airdensity = ctrl_eps_exit_air

  case ("method_air");          !SELECTED ITERATION METHOD FOR HUMID AIR
    get_it_ctrl_airdensity = ctrl_method_air

  case ("dens2_air");           !COUNTERPOINT VALUE FOR HUMID AIR (IRRELEVANT FOR NEWTON)
    get_it_ctrl_airdensity = ctrl_density2_air

  case default;
    get_it_ctrl_airdensity = errorreturn
    
end select

end function

!==========================================================================
function aux_density_ideal_si(a_si, t_si, p_si)
!==========================================================================

!THIS FUNCTION RETURNS THE DENSITY OF IDEAL-GAS HUMID AIR AS A FUNCTION OF
!AIR FRACTION, TEMPERATURE AND PRESSURE

!OUTPUT:  
!AUX_DENSITY_IDEAL_SI: DENSITY IN KG/M3

!INPUT:   
!A_SI: MASS FRACTION OF DRY AIR IN KG/KG
!T_SI: ABSOLUTE TEMPERATURE IN K
!p_si: ABSOLUTE PRESSURE IN PA

real*8 aux_density_ideal_si, a_si, t_si, p_si
real*8 ma, r

r = gas_constant_molar_si        !MOLAR GAS CONSTANT R IN J/(MOL K)

aux_density_ideal_si = errorreturn

if(a_si < 0d0 .or. a_si > 1d0) return
if(t_si <= 0d0) return
if(p_si <= 0d0) return

ma = air_molar_mass_si(a_si)

aux_density_ideal_si = ma * p_si / (r * t_si)

end function

!==========================================================================
subroutine init_it_ctrl_airdensity()
!==========================================================================

if(ctrl_initialized == -1) return

ctrl_initialized = -1

!SET DEFAULT VALUES AND MODES FOR DENSITY ITERATION
ctrl_mode_air = 0
ctrl_loop_maximum = 100
ctrl_density_air = 1d0
ctrl_eps_exit_air = -0.0000001d0 !RELATIVE, 0.1 PPM

!SET DEFAULT VALUES FOR ALTERNATIVE ITERATION METHODS
ctrl_method_air = 0 !DEFAULT = NEWTON

!SET DEFAULT COUNTERPOINT VALUES FOR ALTERNATIVE ITERATION METHODS
ctrl_density2_air = 0d0  !DEFAULT = .5 * NEWTON STEP

end subroutine

!==========================================================================
subroutine swap(a, b)
!==========================================================================

real*8 a, b, c
c = a
a = b
b = c
end subroutine

end module air_3a

module sea_3b

!#########################################################################

!THIS MODULE IMPLEMENTS THE ENTHALPY OF SEAWATER DEPENDING ON SALINITY, ENTROPY
!AND PRESSURE, AS WELL AS ITS PARTIAL DERIVATIVES, AS DEFINED IN:

!FEISTEL, R.
!A GIBBS FUNCTION FOR SEAWATER THERMODYNAMICS
!FOR -6 DEG C TO 80 DEG C AND SALINITY UP TO 120 G KG-1
!DEEP-SEA RESEARCH I, SUBMITTED 2007

!#########################################################################

!IMPLEMENTATION IN FORTRAN BY D.G. WRIGHT
!FOR PUBLICATION IN OCEAN SCIENCE, AS DESCRIBED IN THE PAPERS

!FEISTEL, R., WRIGHT, D.G., JACKETT, D.R., MIYAGAWA, K., REISSMANN, J.H.,
!WAGNER, W., OVERHOFF, U., GUDER, C., FEISTEL, A., MARION, G.M.:
!NUMERICAL IMPLEMENTATION AND OCEANOGRAPHIC APPLICATION OF THE THERMODYNAMIC
!POTENTIALS OF WATER, VAPOUR, ICE, SEAWATER AND AIR. PART I: BACKGROUND AND EQUATIONS. 
!OCEAN SCIENCES, 2009, IN PREPARATION.

!WRIGHT, D.G., FEISTEL, R., JACKETT, D.R., MIYAGAWA, K., REISSMANN, J.H., 
!WAGNER, W., OVERHOFF, U., GUDER, C., FEISTEL, A., MARION, G.M.:
!NUMERICAL IMPLEMENTATION AND OCEANOGRAPHIC APPLICATION OF THE THERMODYNAMIC
!POTENTIALS OF WATER, VAPOUR, ICE, SEAWATER AND AIR. PART II: THE LIBRARY ROUTINES, 
!OCEAN SCIENCES., 2009, IN PREPARATION.

!FEISTEL, R., KRETZSCHMAR, H.-J., SPAN, R., HAGEN, E., WRIGHT, D.G., HERRMANN, S.:
!THERMODYNAMIC PROPERTIES OF SEA AIR.
!OCEAN SCIENCE DISCUSSION 6(2009)2193-2325.

!#########################################################################

!THIS MODULE REQUIRES THE LIBRARY MODULES:
!     CONSTANTS_0, FILE CONSTANTS_0.F90
!     SAL_2,       FILE SAL_2.F90
!     FLU_3A,      FILE FLU_3A.F90
!     SEA_3A,      FILE SEA_3A.F90

!NESTED USE ASSOCIATIONS
!     CONVERT_0,   FILE CONVERT_0.F90
!     MATHS_0,     FILE MATHS_0.F90
!     FLU_1,       FILE FLU_1.F90
!     SAL_1,       FILE SAL_1.F90

!#########################################################################

use constants_0
use sal_2
use flu_3a
use sea_3a

implicit none
private

character*16, private :: version = '8 Jun 2010'

public :: sea_h_si, sea_h_contraction_h_si, sea_h_contraction_t_si, &
          sea_h_contraction_theta_si, sea_h_expansion_h_si, &
          sea_h_expansion_t_si, sea_h_expansion_theta_si, &
          sea_potdensity_si, sea_potenthalpy_si,  &
          sea_pottemp_si, sea_temperature_si, set_it_ctrl_pottemp

integer, private :: ctrl_initialized, ctrl_loop_maximum, ctrl_mode_pottemp
real*8, private :: ctrl_init_pottemp, ctrl_eps_exit_pottemp

contains

!==========================================================================
function sea_h_si(drv_s, drv_eta, drv_p, sa_si, eta_si, p_si)
!==========================================================================

!THIS FUNCTION IMPLEMENTS ENTHALPY AS A THERMODYNAMIC POTENTIAL, DEPENDING
!ON SALINITY, ENTROPY AND PRESSURE

!OUTPUT:
!SEA_H_SI AS THE S-ETA-P DERIVATIVE

!(D/DS)^DRV_S (D/DETA)^DRV_ETA (D/DP)^DRV_P H(S,ETA,P)

!OF THE SPECIFIC ENTHALPY OF SEAWATER, H(S,ETA,P), IN J/KG

!INPUT:
!SA_SI     ABSOLUTE SALINITY IN KG/KG
!ETA_SI    SPECIFIC ENTROPY IN J/(KG K)
!P_SI      ABSOLUTE PRESSURE IN PA

!CHECK VALUES WITH DEFAULT SETTINGS:
!SEA_H_SI( 0, 0, 0, 0.035, 500, 1E5) = 145481.970750
!SEA_H_SI( 1, 0, 0, 0.035, 500, 1E5) = 86860.7980486
!SEA_H_SI( 0, 1, 0, 0.035, 500, 1E5) = 309.557955853
!SEA_H_SI( 0, 0, 1, 0.035, 500, 1E5) = 9.81092930969E-04
!SEA_H_SI( 2, 0, 0, 0.035, 500, 1E5) = 2393730.16716
!SEA_H_SI( 1, 1, 0, 0.035, 500, 1E5) = 72.5298236488
!SEA_H_SI( 1, 0, 1, 0.035, 500, 1E5) =-6.84629317367E-04
!SEA_H_SI( 0, 2, 0, 0.035, 500, 1E5) = 7.72873234085E-02
!SEA_H_SI( 0, 1, 1, 0.035, 500, 1E5) = 2.86305358702E-08
!SEA_H_SI( 0, 0, 2, 0.035, 500, 1E5) =-3.96880481108E-13

!NOTE: THE ACCURACY OF THIS FUNCTION DEPENDS ON THE ITERATION SETTINGS FOR
!      DENSITY COMPUTED IN FLU_3A
!      AND ON THE ITERATION SETTINGS FOR TEMPERATURE BY SET_IT_CTRL_POTTEMP OF THIS MODULE

implicit none
integer drv_s, drv_eta, drv_p
real*8 sea_h_si, sa_si, eta_si, p_si
real*8 t

sea_h_si = errorreturn

if(drv_s < 0 .or. drv_s > 2) return
if(drv_eta < 0 .or. drv_eta > 2) return
if(drv_p < 0 .or. drv_p > 2) return

if(sa_si < 0d0 .or. sa_si >= 1d0) return
if(p_si < 0d0) return

!COMPUTE TEMPERATURE FROM ENTROPY.
!IF P_SI = IN-SITU PRESSURE, THIS IS IN-SITU TEMPERATURE
!IF P_SI = REFERENCE PRESSURE, THIS IS POTENTIAL TEMPERATURE
t = sea_temperature_si(sa_si, eta_si, p_si)
if(t == errorreturn) return

sea_h_si = sea_s_eta_p_derivatives_si(drv_s, drv_eta, drv_p, sa_si, t, p_si)

end function

!==========================================================================
function sea_pottemp_si(sa_si, t_si, p_si, pr_si)
!==========================================================================
                               
!THIS FUNCTION COMPUTES POTENTIAL TEMPERATURE OF SEAWATER

!OUTPUT:
!THETA(S,T,P,PR) ABSOLUTE POTENTIAL TEMPERATURE OF SEAWATER IN K

!INPUT:
!SA_SI     ABSOLUTE SALINITY IN KG/KG
!T_SI      ABSOLUTE IN-SITU TEMPERATURE IN K
!P_SI      ABSOLUTE IN-SITU PRESSURE IN PA
!PR_SI     ABSOLUTE REFERENCE PRESSURE IN PA

!CHECK VALUE WITH DEFAULT SETTINGS: 
!SEA_POTTEMP_SI(0.035,300,1e7,1e5) = 299.771869405

implicit none
real*8 sea_pottemp_si, sa_si, t_si, p_si, pr_si
real*8 s

sea_pottemp_si = errorreturn

if(sa_si < 0d0 .or. sa_si >= 1d0) return
if(t_si < 0d0) return
if(p_si < 0d0) return
if(pr_si < 0d0) return

if(p_si == pr_si) then
  sea_pottemp_si = t_si
  return
end if

s = sea_entropy_si(sa_si, t_si, p_si)  !SPECIFIC ENTROPY IN-SITU
if(s == errorreturn) return

sea_pottemp_si = sea_temperature_si(sa_si, s, pr_si)

end function

!==========================================================================
function sea_potdensity_si(sa_si, t_si, p_si, pr_si)
!==========================================================================
                               
!THIS FUNCTION COMPUTES POTENTIAL DENSITY OF SEAWATER

!OUTPUT:
!RHO_THETA(S,T,P,PR) POTENTIAL DENSITY OF SEAWATER IN KG/M³,

!INPUT:
!SA_SI     ABSOLUTE SALINITY IN KG/KG
!T_SI      ABSOLUTE IN-SITU TEMPERATURE IN K
!P_SI      ABSOLUTE IN-SITU PRESSURE IN PA
!PR_SI     ABSOLUTE REFERENCE PRESSURE IN PA

!CHECK VALUE WITH DEFAULT SETTINGS: 
!SEA_POTDENSITY_SI(0.035,300,1e7,1e5) = 1022.71520130

!NOTE: THE ACCURACY OF THIS FUNCTION DEPENDS ON THE ITERATION SETTINGS FOR
!      DENSITY COMPUTED IN FLU_3A
!      AND ON THE ITERATION SETTINGS FOR TEMPERATURE BY SET_IT_CTRL_POTTEMP OF THIS MODULE

implicit none
real*8 sea_potdensity_si, sa_si, t_si, p_si, pr_si
real*8 s, v

sea_potdensity_si = errorreturn

if(sa_si < 0d0 .or. sa_si >= 1d0) return
if(t_si < 0d0) return
if(p_si < 0d0) return
if(pr_si < 0d0) return

s = sea_entropy_si(sa_si, t_si, p_si)  !specific entropy in-situ
if(s == errorreturn) return

v = sea_h_si(0, 0, 1, sa_si, s, pr_si) !specific volume at reference pressure
if(v == errorreturn) return
if(v <= 0d0) return

sea_potdensity_si = 1d0 / v

end function

!==========================================================================
function sea_potenthalpy_si(sa_si, t_si, p_si, pr_si)
!==========================================================================
                               
!THIS FUNCTION COMPUTES POTENTIAL ENTHALPY OF SEAWATER

!OUTPUT:
!H_THETA(S,T,P,PR) POTENTIAL ENTHALPY OF SEAWATER IN J/KG

!INPUT:
!SA_SI     ABSOLUTE SALINITY IN KG/KG
!T_SI      ABSOLUTE IN-SITU TEMPERATURE IN K
!P_SI      ABSOLUTE IN-SITU PRESSURE IN PA
!PR_SI     ABSOLUTE REFERENCE PRESSURE IN PA

!CHECK VALUE WITH DEFAULT SETTINGS: 
!SEA_POTENTHALPY_SI(0.035,300,1e7,1e5) = 106307.996083

!NOTE: THE ACCURACY OF THIS FUNCTION DEPENDS ON THE ITERATION SETTINGS FOR
!      DENSITY COMPUTED IN FLU_3A
!      AND ON THE ITERATION SETTINGS FOR TEMPERATURE BY SET_IT_CTRL_POTTEMP OF THIS MODULE

implicit none
real*8 sea_potenthalpy_si, sa_si, t_si, p_si, pr_si
real*8 s

sea_potenthalpy_si = errorreturn

if(sa_si < 0d0 .or. sa_si >= 1d0) return
if(t_si < 0d0) return
if(p_si < 0d0) return
if(pr_si < 0d0) return

s = sea_entropy_si(sa_si, t_si, p_si)  !SPECIFIC ENTROPY IN-SITU
if(s == errorreturn) return

sea_potenthalpy_si = sea_h_si(0, 0, 0, sa_si, s, pr_si)

end function

!==========================================================================
Function sea_h_expansion_t_si(sa_si, eta_si, p_si)
!==========================================================================
                               
!THIS FUNCTION COMPUTES THERMAL EXPANSION COEFFICIENT OF SEAWATER AS FUNCTION OF ENTROPY

!RETURNS   SEA_H_EXPANSION_T_SI(S,ETA,P) = (1/V)*(DV/DT)_S_P THERMAL EXPANSION COEFFICIENT IN 1/K,
!                                          AT CONSTANT SALINITY AND PRESSURE
!SA_SI     ABSOLUTE SALINITY IN KG/KG
!ETA_SI    ENTROPY IN J/(KG K)
!P_SI      ABSOLUTE IN-SITU PRESSURE IN PA

!CHECK VALUE WITH DEFAULT SETTINGS: 
!SEA_H_EXPANSION_T_SI(0.035, 500, 1e5) = 3.77581809091E-04

!NOTE: THE ACCURACY OF THIS FUNCTION DEPENDS ON THE ITERATION SETTINGS FOR
!      DENSITY COMPUTED IN FLU_3A
!      AND ON THE ITERATION SETTINGS FOR TEMPERATURE BY SET_IT_CTRL_POTTEMP OF THIS MODULE

Real*8 sea_h_expansion_t_si, sa_si, eta_si, p_si
Real*8 hp, hep, hee

sea_h_expansion_t_si = ErrorReturn

If (sa_si < 0d0 .or. sa_si >= 1d0) Return
If (p_si <= 0d0) Return

hp = sea_h_si(0, 0, 1, sa_si, eta_si, p_si)
If (hp == ErrorReturn .or. hp == 0d0) Return
hep = sea_h_si(0, 1, 1, sa_si, eta_si, p_si)
If (hep == ErrorReturn) Return
hee = sea_h_si(0, 2, 0, sa_si, eta_si, p_si)
If (hee == ErrorReturn .or. hee == 0d0) Return

sea_h_expansion_t_si = hep / (hp * hee)

End Function

!==========================================================================
Function sea_h_expansion_theta_si(sa_si, eta_si, p_si, pref_si)
!==========================================================================
                               
!THIS FUNCTION COMPUTES THERMAL EXPANSION COEFFICIENT WRT POTENTIAL TEMPERATURE 
!OF SEAWATER AS A FUNCTION OF ENTROPY

!RETURNS   SEA_H_EXPANSION_THETA_SI(S,ETA,P) = (1/V)*(DV/DTHETA)_S_P THERMAL EXPANSION COEFFICIENT 
!                                              IN 1/K, AT CONSTANT SALINITY AND PRESSURE
!SA_SI     ABSOLUTE SALINITY IN KG/KG
!ETA_SI    ENTROPY IN J/(KG K)
!P_SI      ABSOLUTE IN-SITU PRESSURE IN PA
!PREF_SI   ABSOLUTE REFERENCE PRESSURE IN PA

!CHECK VALUE WITH DEFAULT SETTINGS: 
!SEA_H_EXPANSION_THETA_SI(0.035, 500, 1e7, 1e5) = 3.84755380181E-04

!NOTE: THE ACCURACY OF THIS FUNCTION DEPENDS ON THE ITERATION SETTINGS FOR DENSITY COMPUTED IN FLU_3A
!      AND ON THE ITERATION SETTINGS FOR TEMPERATURE BY SET_IT_CTRL_POTTEMP OF THIS MODULE

Real*8 sea_h_expansion_theta_si, sa_si, eta_si, p_si, pref_si
Real*8 hp, hep, hee

sea_h_expansion_theta_si = ErrorReturn

If (sa_si < 0d0 .or. sa_si >= 1d0) Return
If (p_si <= 0d0) Return
If (pref_si <= 0d0) Return

hp = sea_h_si(0, 0, 1, sa_si, eta_si, p_si)
If (hp == ErrorReturn .or. hp == 0d0) Return
hep = sea_h_si(0, 1, 1, sa_si, eta_si, p_si)
If (hep == ErrorReturn) Return
hee = sea_h_si(0, 2, 0, sa_si, eta_si, pref_si)
If (hee == ErrorReturn .or. hee == 0d0) Return

sea_h_expansion_theta_si = hep / (hp * hee)

End Function

!==========================================================================
Function sea_h_expansion_h_si(sa_si, eta_si, p_si, pref_si)
!==========================================================================
                               
!THIS FUNCTION COMPUTES THE THERMAL EXPANSION COEFFICIENT WRT POTENTIAL ENTHALPY
!OF SEAWATER AS FUNCTION OF ENTROPY

!RETURNS   SEA_H_EXPANSION_H_SI(S,ETA,P) = (1/V)*(DV/DH)_S_P THERMAL EXPANSION COEFFICIENT IN (KG K)/J,
!                                          AT CONSTANT SALINITY AND PRESSURE. HPOT IS POTENTIAL ENTHALPY
!SA_SI     ABSOLUTE SALINITY IN KG/KG
!ETA_SI    ENTROPY IN J/(KG K)
!P_SI      ABSOLUTE IN-SITU PRESSURE IN PA
!PREF_SI   ABSOLUTE REFERENCE PRESSURE IN PA

!CHECK VALUE WITH DEFAULT SETTINGS: 
!SEA_H_EXPANSION_H_SI(0.035, 500, 1e7, 1e5) = 9.60618615640E-08

!NOTE: THE ACCURACY OF THIS FUNCTION DEPENDS ON THE ITERATION SETTINGS FOR
!      DENSITY COMPUTED IN FLU_3A
!      AND ON THE ITERATION SETTINGS FOR TEMPERATURE BY SET_IT_CTRL_POTTEMP OF THIS MODULE

Real*8 sea_h_expansion_h_si, sa_si, eta_si, p_si, pref_si
Real*8 hp, hep, he

sea_h_expansion_h_si = ErrorReturn

If (sa_si < 0d0 .or. sa_si >= 1d0) Return
If (p_si <= 0d0) Return
If (pref_si <= 0d0) Return

hp = sea_h_si(0, 0, 1, sa_si, eta_si, p_si)
If (hp == ErrorReturn .or. hp == 0d0) Return
hep = sea_h_si(0, 1, 1, sa_si, eta_si, p_si)
If (hep == ErrorReturn) Return
he = sea_h_si(0, 1, 0, sa_si, eta_si, pref_si)
If (he == ErrorReturn .or. he == 0d0) Return

sea_h_expansion_h_si = hep / (hp * he)

End Function

!==========================================================================
Function sea_h_contraction_t_si(sa_si, eta_si, p_si)
!==========================================================================
                               
!THIS FUNCTION COMPUTES THE ADIABATIC HALINE CONTRACTION COEFFICIENT OF SEAWATER

!RETURNS   SEA_H_CONTRACTION_T_SI(S,ETA,P) = - (1/V)*(DV/DS)_T_P HALINE CONTRACTION COEFFICIENT IN KG/KG,
!                                            (KG SEAWATER / KG SALT) AT CONSTANT TEMPERATURE AND PRESSURE
!SA_SI     ABSOLUTE SALINITY IN KG/KG
!ETA_SI    ENTROPY IN J/(KG K)
!P_SI      ABSOLUTE IN-SITU PRESSURE IN PA

!CHECK VALUE WITH DEFAULT SETTINGS: 
!SEA_H_CONTRACTION_T_SI(0.035, 500, 1e5) = 0.717342103505

!NOTE: THE ACCURACY OF THIS FUNCTION DEPENDS ON THE ITERATION SETTINGS FOR
!      DENSITY COMPUTED IN FLU_3A
!      AND ON THE ITERATION SETTINGS FOR TEMPERATURE BY SET_IT_CTRL_POTTEMP OF THIS MODULE

Real*8 sea_h_contraction_t_si, sa_si, eta_si, p_si
Real*8 hp, hep, hse, hee, hsp

sea_h_contraction_t_si = ErrorReturn

If (sa_si < 0d0 .or. sa_si >= 1d0) Return
If (p_si <= 0d0) Return

hp = sea_h_si(0, 0, 1, sa_si, eta_si, p_si)
If (hp == ErrorReturn .or. hp == 0d0) Return
hse = sea_h_si(1, 1, 0, sa_si, eta_si, p_si)
If (hse == ErrorReturn) Return
hep = sea_h_si(0, 1, 1, sa_si, eta_si, p_si)
If (hep == ErrorReturn) Return
hsp = sea_h_si(1, 0, 1, sa_si, eta_si, p_si)
If (hsp == ErrorReturn) Return
hee = sea_h_si(0, 2, 0, sa_si, eta_si, p_si)
If (hee == ErrorReturn .or. hee == 0d0) Return

sea_h_contraction_t_si = (hse * hep - hsp * hee) / (hp * hee)

End Function

!==========================================================================
Function sea_h_contraction_theta_si(sa_si, eta_si, p_si, pref_si)
!==========================================================================
                               
!THIS FUNCTION COMPUTES THE ADIABATIC HALINE CONTRACTION COEFFICIENT OF SEAWATER
!AT CONSTANT POTENTIAL TEMPERATURE

!RETURNS   SEA_H_CONTRACTION_THETA_SI(S,ETA,P) = - (1/V)*(DV/DS)_THETA_P HALINE CONTRACTION COEFFICIENT 
!                                                IN KG/KG, (KG SEAWATER / KG SALT) AT CONSTANT 
!                                                POTENTIAL TEMPERATURE AND PRESSURE

!SA_SI     ABSOLUTE SALINITY IN KG/KG
!ETA_SI    ENTROPY IN J/(KG K)
!P_SI      ABSOLUTE IN-SITU PRESSURE IN PA
!PREF_SI   ABSOLUTE REFERENCE PRESSURE IN PA

!CHECK VALUE WITH DEFAULT SETTINGS: 
!SEA_H_CONTRACTION_THETA_SI(0.035, 500, 1e7, 1e5) = 0.697779873590

!NOTE: THE ACCURACY OF THIS FUNCTION DEPENDS ON THE ITERATION SETTINGS FOR
!      DENSITY COMPUTED IN FLU_3A
!      AND ON THE ITERATION SETTINGS FOR TEMPERATURE BY SET_IT_CTRL_POTTEMP OF THIS MODULE

Real*8 sea_h_contraction_theta_si, sa_si, eta_si, p_si, pref_si
Real*8 hp, hep, hse, hee, hsp

sea_h_contraction_theta_si = ErrorReturn

If (sa_si < 0d0 .or. sa_si >= 1d0) Return
If (p_si <= 0d0) Return
If (pref_si <= 0d0) Return

hp = sea_h_si(0, 0, 1, sa_si, eta_si, p_si)
If (hp == ErrorReturn .or. hp == 0d0) Return
hse = sea_h_si(1, 1, 0, sa_si, eta_si, pref_si)
If (hse == ErrorReturn) Return
hep = sea_h_si(0, 1, 1, sa_si, eta_si, p_si)
If (hep == ErrorReturn) Return
hsp = sea_h_si(1, 0, 1, sa_si, eta_si, p_si)
If (hsp == ErrorReturn) Return
hee = sea_h_si(0, 2, 0, sa_si, eta_si, pref_si)
If (hee == ErrorReturn .or. hee == 0d0) Return

sea_h_contraction_theta_si = (hse * hep - hsp * hee) / (hp * hee)

End Function

!==========================================================================
Function sea_h_contraction_h_si(sa_si, eta_si, p_si, pref_si)
!==========================================================================
                               
!THIS FUNCTION COMPUTES THE HALINE CONTRACTION COEFFICIENT OF SEAWATER AT CONSTANT POTENTIAL ENTHALPY

!RETURNS   SEA_H_CONTRACTION_H_SI(S,ETA,P) = - (1/V)*(DV/DS)_H_P HALINE CONTRACTION COEFFICIENT IN KG/KG,
!                                              (KG SEAWATER / KG SALT) AT CONSTANT POTENTIAL ENTHALPY 
!                                              AND PRESSURE
!SA_SI     ABSOLUTE SALINITY IN KG/KG
!ETA_SI    ENTROPY IN J/(KG K)
!P_SI      ABSOLUTE IN-SITU PRESSURE IN PA
!PREF_SI   ABSOLUTE REFERENCE PRESSURE IN PA

!CHECK VALUE WITH DEFAULT SETTINGS: 
!SEA_H_CONTRACTION_H_SI(0.035, 500, 1e7, 1e5) = 0.697779873590

!NOTE: THE ACCURACY OF THIS FUNCTION DEPENDS ON THE ITERATION SETTINGS FOR
!      DENSITY COMPUTED IN FLU_3A
!      AND ON THE ITERATION SETTINGS FOR TEMPERATURE BY SET_IT_CTRL_POTTEMP OF THIS MODULE

Real*8 sea_h_contraction_h_si, sa_si, eta_si, p_si, pref_si
Real*8 hp, hep, hs, he, hsp

sea_h_contraction_h_si = ErrorReturn

If (sa_si < 0d0 .or. sa_si >= 1d0) Return
If (p_si <= 0d0) Return
If (pref_si <= 0d0) Return

hp = sea_h_si(0, 0, 1, sa_si, eta_si, p_si)
If (hp == ErrorReturn .or. hp == 0d0) Return
hs = sea_h_si(1, 0, 0, sa_si, eta_si, pref_si)
If (hs == ErrorReturn) Return
hep = sea_h_si(0, 1, 1, sa_si, eta_si, p_si)
If (hep == ErrorReturn) Return
hsp = sea_h_si(1, 0, 1, sa_si, eta_si, p_si)
If (hsp == ErrorReturn) Return
he = sea_h_si(0, 1, 0, sa_si, eta_si, pref_si)
If (he == ErrorReturn .or. he == 0d0) Return

sea_h_contraction_h_si = (hs * hep - hsp * he) / (hp * he)

End Function

!=========================================================================
function sea_temperature_si(sa_si, eta_si, p_si)
!==========================================================================
                                 
!OUTPUT:
!T(S,ETA,P) (POTENTIAL) TEMPERATURE OF SEAWATER IN K

!INPUT:
!SA_SI     ABSOLUTE SALINITY IN KG/KG
!ETA_SI    ENTROPY IN J/(KG K)
!P_SI      ABSOLUTE (REFERENCE) PRESSURE IN PA

!CHECK VALUE WITH DEFAULT SETTINGS: 
!SEA_TEMPERATURE_SI(0.035, 500, 1e5) = 309.557955853

!THIS IS THE INVERSE FUNCTION TO SEA_ENTROPY_SI(SA_SI, T_SI, P_SI) IN SEA_3A

!NOTE: THE ACCURACY OF THIS FUNCTION DEPENDS ON THE ITERATION SETTINGS FOR
!      DENSITY COMPUTED IN FLU_3A AND ON THOSE MADE IN THIS MODULE

implicit none
integer maxit
real*8 sea_temperature_si, sa_si, eta_si, p_si
real*8 t, eps

sea_temperature_si = errorreturn

call init_it_ctrl_pottemp

select case (ctrl_mode_pottemp)
  case (0);    t = 273.15d0 + eta_si / 4000d0
  case default; t = ctrl_init_pottemp
end select

if(ctrl_loop_maximum == 0)then
   maxit = 100
elseif(ctrl_loop_maximum == (-1))then
   sea_temperature_si = t
   return
elseif(ctrl_loop_maximum > 0)then
   maxit = ctrl_loop_maximum
else
   return
endif

eps = ctrl_eps_exit_pottemp
if(eps <= 0d0) return

!RUN THE ITERATION
sea_temperature_si = pottemp_iteration(sa_si, eta_si, p_si, t, maxit, eps)

end function

!==========================================================================
function sea_s_eta_p_derivatives_si(drv_s, drv_eta, drv_p, sa_si, t_si, p_si)
!==========================================================================
                                              
!THIS FUNCTION COMPUTES SEAWATER S-ETA-P DERIVATIVES OF H FROM S-T-P DERIVATIVES OF G

implicit none
integer drv_s, drv_eta, drv_p
real*8 sea_s_eta_p_derivatives_si, sa_si, t_si, p_si
real*8 g, g_t, g_p, g_s
real*8 g_ss, g_st, g_sp
real*8 g_tt, g_pp, g_tp
real*8 h

!IN ONE CASE WE DO NOT AT ALL NEED TO COMPUTE THE GIBBS FUNCTION:
if(drv_s == 0 .and. drv_eta == 1 .and. drv_p == 0) then
  sea_s_eta_p_derivatives_si = t_si
  return
end if

sea_s_eta_p_derivatives_si = errorreturn

select case (drv_s)

  case (0)
    select case (drv_eta)
    
      case (0)
        select case (drv_p)
        
          case (0)
            g = sea_g_si(0, 0, 0, sa_si, t_si, p_si)
            if(g == errorreturn) go to 999
            g_t = sea_g_si(0, 1, 0, sa_si, t_si, p_si)
            if(g_t == errorreturn) go to 999
            h = g - t_si * g_t                           !H
          
          case (1)
            g_p = sea_g_si(0, 0, 1, sa_si, t_si, p_si)
            if(g_p == errorreturn) go to 999
            h = g_p                                      !DH/DP
                  
          case (2)
            g_tt = sea_g_si(0, 2, 0, sa_si, t_si, p_si)
            if(g_tt == errorreturn) go to 999
            if(g_tt == 0d0) go to 999
            g_tp = sea_g_si(0, 1, 1, sa_si, t_si, p_si)
            if(g_tp == errorreturn) go to 999
            g_pp = sea_g_si(0, 0, 2, sa_si, t_si, p_si)
            if(g_pp == errorreturn) go to 999
            h = (g_tt * g_pp - g_tp ** 2) / g_tt         !D2H/DP2
                  
          case default; go to 999
        end select
        
      case (1)
        select case (drv_p)
          case (0); h = t_si                             !DH/DETA, HAS ALREADY BEEN HANDLED INITIALLY
          
          case (1)
            g_tt = sea_g_si(0, 2, 0, sa_si, t_si, p_si)
            if(g_tt == errorreturn) go to 999
            if(g_tt == 0d0) go to 999
            g_tp = sea_g_si(0, 1, 1, sa_si, t_si, p_si)
            if(g_tp == errorreturn) go to 999
            h = -g_tp / g_tt                             !D2H/DETADP
             
          case default; go to 999
        end select

      case (2)
        select case (drv_p)
          case (0) 
            g_tt = sea_g_si(0, 2, 0, sa_si, t_si, p_si)
            if(g_tt == errorreturn) go to 999
            if(g_tt == 0d0) go to 999
            h = -1d0 / g_tt                              !D2H/DETA2
                  
          case default; go to 999
        end select

      case default; go to 999
    end select
    
  case (1)
    select case (drv_eta)
    
      case (0)
        select case (drv_p)
        
          case (0)
            g_s = sea_g_si(1, 0, 0, sa_si, t_si, p_si)
            if(g_s == errorreturn) go to 999
            h = g_s                                      !DH/DS
          
          case (1)
            g_tt = sea_g_si(0, 2, 0, sa_si, t_si, p_si)
            if(g_tt == errorreturn) go to 999
            if(g_tt == 0d0) go to 999
            g_st = sea_g_si(1, 1, 0, sa_si, t_si, p_si)
            if(g_st == errorreturn) go to 999
            g_sp = sea_g_si(1, 0, 1, sa_si, t_si, p_si)
            if(g_sp == errorreturn) go to 999
            g_tp = sea_g_si(0, 1, 1, sa_si, t_si, p_si)
            if(g_tp == errorreturn) go to 999
            h = (g_tt * g_sp - g_st * g_tp) / g_tt       !D2H/DSDP
          
          case default; go to 999
        end select

      case (1)
        select case (drv_p)
        
          case (0)
            g_tt = sea_g_si(0, 2, 0, sa_si, t_si, p_si)
            if(g_tt == errorreturn) go to 999
            if(g_tt == 0d0) go to 999
            g_st = sea_g_si(1, 1, 0, sa_si, t_si, p_si)
            if(g_st == errorreturn) go to 999
            h = -g_st / g_tt                             !D2H/DSDETA
          
          case default; go to 999
        end select

      case default; go to 999
    end select

  
  case (2)
    select case (drv_eta)
    
      case (0)
        select case (drv_p)
        
          case (0)
            g_tt = sea_g_si(0, 2, 0, sa_si, t_si, p_si)
            if(g_tt == errorreturn) go to 999
            if(g_tt == 0d0) go to 999
            g_st = sea_g_si(1, 1, 0, sa_si, t_si, p_si)
            if(g_st == errorreturn) go to 999
            g_ss = sea_g_si(2, 0, 0, sa_si, t_si, p_si)
            if(g_ss == errorreturn) go to 999
            h = (g_tt * g_ss - g_st ** 2) / g_tt         !D2H/DS2
          
          case default; go to 999
        end select

      case default; go to 999
    end select

  case default; go to 999
end select

sea_s_eta_p_derivatives_si = h

999 continue

end function

!=========================================================================
function pottemp_iteration(sa_si, eta_si, p_si, t_si, maxit, eps)
!==========================================================================

!OUTPUT:
!THETA =   POTENTIAL TEMPERATURE OF SEAWATER IN K
!          I.E. THE TEMPERATURE THAT SOLVES ETA_SI = SEA_ENTROPY_SI(SA_SI, T_SI, P_SI)

!INPUT:
!SA_SI     ABSOLUTE SALINITY IN KG/KG
!ETA_SI    ENTROPY IN J/(KG K)
!P_SI      ABSOLUTE (REFERENCE) PRESSURE IN PA
!T_SI      ABSOLUTE (POTENTIAL) TEMPERATURE IN K, INITIAL VALUE
!MAXIT     MAX. NUMBER OF ITERATIONS
!EPS       REQUIRED TOLERANCE IN K

implicit none
integer i, maxit
real*8 pottemp_iteration, sa_si, eta_si, p_si, t_si, eps
real*8 s, theta, cp, dt

pottemp_iteration = errorreturn

if(eps <= 0d0) return
if(maxit <= 0d0) return

if(check_limits == 1) then
  !FLU_LIMITS
  if(t_si < flu_tmin .or. t_si > flu_tmax) return
  !SAL_LIMITS
  if(t_si < sal_tmin .or. t_si > sal_tmax .or. &
  sa_si > sal_smax .or. &
  p_si < sal_pmin .or. p_si > sal_pmax) return
else
if(sa_si < 0d0 .or. sa_si > 1d0 .or. &
  t_si <= 0d0 .or. &
  p_si <= 0d0) return
endif

check_limits = check_limits - 1

theta = t_si

do i = 1, maxit

  !get entropy and its first derivative for newton iteration
  s = sea_entropy_si(sa_si, theta, p_si)
  cp = sea_cp_si(sa_si, theta, p_si)
  
  if(s == errorreturn) go to 999
  if(cp == errorreturn) go to 999
  if(cp <= 0d0) go to 999
  
  !next temperature improvement step
  dt = theta * (eta_si - s) / cp
  theta = theta + dt
  if(theta <= 0d0) go to 999
  
  if(abs(dt) < eps) then
    pottemp_iteration = theta
    go to 999
  end if
  
enddo

999 continue

check_limits = check_limits + 1

end function

!==========================================================================
subroutine init_it_ctrl_pottemp()
!==========================================================================

implicit none

if(ctrl_initialized == -1) return

ctrl_initialized = -1

!SET DEFAULT VALUES AND MODES FOR TEMPERATURE ITERATION
ctrl_loop_maximum = 100
ctrl_mode_pottemp = 0           !default: theta = t0 + 273*eta/4000
ctrl_init_pottemp = 273.15d0
ctrl_eps_exit_pottemp = 0.0001d0  !default = 0.1 mk

end subroutine

!==========================================================================
subroutine set_it_ctrl_pottemp(key, value)
!==========================================================================

!THIS SUB SETS CONTROL PARAMETERS FOR THE NEWTON ITERATION USED TO COMPUTE
!POTENTIAL TEMPERATURE FROM REFERENCE PRESSURE

!KEY                    VALUE
!'IT_STEPS     '        0           SET ITERATION NUMBER TO DEFAULT (100)
!'IT_STEPS     '        N > 0       SET ITERATION NUMBER TO N
!'IT_STEPS     '       -1           DO NOT ITERATE, USE INITIAL VALUE

!'INIT_THETA   '        0           USE DEFAULT POTENTIAL TEMPERATURE THETA = T0 + 273*ETA/4000 TO START
!'INIT_THETA   '        T > 0       USE VALUE T AS POTENTIAL TEMPERATURE TO START

!'TOL_THETA    '        0           USE DEFAULT EXIT ACCURACY FOR POTENTIAL TEMPERATURE (0.1 MK)
!'TOL_THETA    '        EPS > 0     USE EPS AS EXIT ACCURACY FOR POTENTIAL TEMPERATURE

implicit none
character*13 key
real*8 value

call init_it_ctrl_pottemp

select case (trim(key))

  case ('it_steps')               !ITERATION STEPS
    if(value == 0d0)then
      ctrl_loop_maximum = 100     !DEFAULT = 100
    elseif(value < 0d0)then
      ctrl_loop_maximum = -1
    else
      ctrl_loop_maximum = nint(value)
    endif

  case ('init_theta')             !START THETA
    if(value == 0d0)then
      ctrl_mode_pottemp = 0       !DEFAULT: THETA = T0 + ETA/4000
    elseif(value > 0d0)then
      ctrl_mode_pottemp = 1
      ctrl_init_pottemp = value
    endif

  case ('tol_theta')              !REQUIRED THETA TOLERANCE
    if(value == 0d0)then
      ctrl_eps_exit_pottemp = 0.0001d0 !DEFAULT = 0.1 MK
    elseif(value > 0d0)then
      ctrl_eps_exit_pottemp = value
    endif

  case default; write(*,*)key,' not supported'

end select

end subroutine

end module sea_3b

module liq_ice_air_5a

!#########################################################################

!THIS MODULE IMPLEMENTS THE EQUILIBRIUM PROPERTIES OF WET ICE AIR, 
!I.E., BETWEEN LIQUID WATER, ICE AND HUMID AIR
!
!THIS MODULE ALSO PROVIDES SIMPLE IMPLEMENTATIONS OF DERIVED METEOROLOGICAL
!QUANTITIES LIKE THE EQUIVALENT POTENTIAL TEMPERATURE, ETC.

!#########################################################################

!IMPLEMENTATION IN FORTRAN BY F.B. LALIBERTE AT THE UNIVERSITY OF TORONTO, 2012
!FOR PROBABLE FUTURE PUBLICATION WITH THE DEVELOPERS OF TEOS-10

!#########################################################################

!THIS MODULE REQUIRES THE LIBRARY MODULES:
!     CONSTANTS_0,  FILE CONSTANTS_0.F90
!     CONVERT_0,    FILE CONVERT_0.F90
!     MATHS_0,      FILE MATHS_0.F90
!     AIR_1,        FILE AIR_1.F90
!     FLU_1,        FILE FLU_1.F90
!     ICE_1,        FILE ICE_1.F90
!     AIR_2,        FILE AIR_2.F90
!     FLU_2,        FILE FLU_2.F90
!     ICE_2,        FILE ICE_2.F90
!     AIR_3A,       FILE AIR_3A.F90
!     AIR_3B,       FILE AIR_3B.F90
!     AIR_3C,       FILE AIR_3C.F90
!     ICE_LIQ_4,    FILE ICE_LIQ_4.F90
!     ICE_VAP_4,    FILE ICE_VAP_4.F90
!     LIQ_VAP_4,    FILE LIQ_VAP_4.F90

!     LIQ_AIR_4A,   FILE LIQ_AIR_4A.F90
!     LIQ_AIR_4B,   FILE LIQ_AIR_4B.F90
!     LIQ_AIR_4C,   FILE LIQ_AIR_4C.F90

!     ICE_AIR_4A,   FILE ICE_AIR_4A.F90
!     ICE_AIR_4B,   FILE ICE_AIR_4B.F90
!     ICE_AIR_4C,   FILE ICE_AIR_4C.F90

!     LIQ_ICE_AIR_4,FILE LIQ_ICE_AIR_4.F90 

!#########################################################################

use constants_0
use convert_0
use maths_0
use air_1
use flu_1
use ice_1
use air_2
use flu_2
use ice_2
use air_3a
use air_3b
use air_3c
use ice_liq_4

use flu_3a

use ice_vap_4
use liq_vap_4

use liq_air_4a
use liq_air_4b
use liq_air_4c
use liq_air_4d
use ice_air_4a
use ice_air_4b
use ice_air_4c
use ice_air_4d
use liq_ice_air_4

implicit none
private

character*16, private :: version = 'October 2012'

public :: &
          liq_ice_air_h_temperature_si, &
          liq_ice_air_h_density_si, &
          liq_ice_air_h_enthalpy_si, &
          liq_ice_air_h_gc_gv_si, &
          liq_ice_air_h_gd_gc_si, &
          liq_ice_air_h_gd_si, &
          liq_ice_air_h_gc_si, &
          liq_ice_air_h_gh_gc_si


!CONTROL PARAMETERS OF THE EQUI TEMPERATURE ITERATION
integer ctrl_initialized

integer ctrl_mode_liquidfraction
integer ctrl_loop_maximum

real*8 ctrl_eps_exit_liquidfraction

contains

function liq_ice_air_h_temperature_si(wa_si, eta_si, p_si)
!THIS FUNCTION COMPUTES THE TEMPERATURE OF AIR
!SHOULD BE VALID OVER THE WHOLE REGION OF VALIDILITY OF TEOS-10

!OUTPUT:
!T(A,ETA,P) ABSOLUTE TEMPERATURE OF MOIST AIR (LIQ-VAP-AIR OR ICE-VAP-AIR OR VAP-AIR) IN K

!INPUTS:
!A_SI      ABSOLUTE DRY-AIR MASS FRACTION IN KG/KG
!ETA_SI      ABSOLUTE IN-SITU ENTROPY
!P_SI      ABSOLUTE IN-SITU PRESSURE IN PA

real*8 liq_ice_air_h_temperature_si, wa_si, eta_si, p_si
real*8 t_freeze, icl, wt, t

liq_ice_air_h_temperature_si = errorreturn

if(wa_si < 0d0 .or. wa_si > 1d0) return
if(p_si < 0d0) return

if(wa_si == 1d0) then
    !No water:
    liq_ice_air_h_temperature_si = air_temperature_si(wa_si, eta_si, p_si)
else
    !Try equilibrium without condensate:
    t = air_temperature_si(wa_si, eta_si, p_si)
    !Check if no condensation makes sense:
    if(t/=errorreturn) then
        if(set_liq_ice_air_eq_at_p(p_si) == errorreturn) return
        t_freeze=liq_ice_air_temperature_si()
        if(t_freeze==errorreturn) return

        if(t<t_freeze) then
            icl = ice_air_icl_si(wa_si,t,p_si)
            if(icl==errorreturn.or.(icl/=errorreturn.and.icl<p_si)) then
                liq_ice_air_h_temperature_si = t
                return
            endif
        else
            icl = liq_air_icl_si(wa_si,t,p_si)
            if(icl==errorreturn.or.(icl/=errorreturn.and.icl<p_si)) then
                liq_ice_air_h_temperature_si = t
                return
            endif
        endif
    endif

    !If we have not returned, must check for condensation and mixed state:
    wt = liq_ice_air_h_liquidfraction_of_condensate_si(wa_si,eta_si,p_si)
    if(wt==1d0) then
        !Pure water condensate:
        liq_ice_air_h_temperature_si = liq_air_h_temperature_si(wa_si, eta_si, p_si)
    elseif(wt==0d0) then
        !Pure ice condensate:
        liq_ice_air_h_temperature_si = ice_air_h_temperature_si(wa_si, eta_si, p_si)
    else
        !Mixed state water/ice:
        if(set_liq_ice_air_eq_at_wa_eta_wt(wa_si,eta_si,wt) == errorreturn) return
        liq_ice_air_h_temperature_si = liq_ice_air_temperature_si()
    endif
endif
end function

function liq_ice_air_h_density_si(wa_si, eta_si, p_si)
!THIS FUNCTION COMPUTES THE DENSITY OF AIR
!SHOULD BE VALID OVER THE WHOLE REGION OF VALIDILITY OF TEOS-10

!OUTPUT:
!D(A,ETA,P) = 1/(DG/DP)  DENSITY OF MOIST (LIQ-VAP-AIR OR ICE-VAP-AIR OR VAP-AIR) AIR IN KG/M3

!INPUTS:
!A_SI      ABSOLUTE DRY-AIR MASS FRACTION IN KG/KG
!ETA_SI      ABSOLUTE IN-SITU ENTROPY
!P_SI      ABSOLUTE IN-SITU PRESSURE IN PA
!
!Note that this is a good template for converting liq_air_g* and ice_air_g* functions to
!liq_ice_air_h*. The liq_ice_air_h* functions are more robust at the triple point since it is
!possible to obtain an exact expression for the mixed liquid/ice state.

real*8 liq_ice_air_h_density_si, wa_si, eta_si, p_si
real*8 t_freeze, icl, wt, t_si, a_si

liq_ice_air_h_density_si = errorreturn

if(wa_si < 0d0 .or. wa_si > 1d0) return
if(p_si < 0d0) return

if(wa_si == 1d0) then
    !No water:
    t_si = air_temperature_si(wa_si, eta_si, p_si)
    liq_ice_air_h_density_si = air_density_si(wa_si, t_si, p_si)
else
    !Try equilibrium without condensate:
    t_si = air_temperature_si(wa_si, eta_si, p_si)
    !Check if no condensation makes sense:
    if(t_si/=errorreturn) then
        if(set_liq_ice_air_eq_at_p(p_si) == errorreturn) return
        t_freeze=liq_ice_air_temperature_si()
        !If the freezing temperature returns an error this function will return an error:
        if(t_freeze==errorreturn) return

        if(t_si<t_freeze) then
            !Freezing conditions, use ice_air:
            icl = ice_air_icl_si(wa_si,t_si,p_si)
            if(icl==errorreturn.or.(icl/=errorreturn.and.icl<p_si)) then
                !Air is below the isentropic condensation level -> no condensation
                liq_ice_air_h_density_si = air_density_si(wa_si, t_si, p_si)
                return
            endif
        else
            !Non-Freezing conditions, use ice_air:
            icl = liq_air_icl_si(wa_si,t_si,p_si)
            if(icl==errorreturn.or.(icl/=errorreturn.and.icl<p_si)) then
                !Air is below the isentropic condensation level -> no condensation
                liq_ice_air_h_density_si = air_density_si(wa_si, t_si, p_si)
                return
            endif
        endif
    endif

    !If we have not returned, must check for condensation and mixed state:
    wt = liq_ice_air_h_liquidfraction_of_condensate_si(wa_si,eta_si,p_si)
    if(wt==1d0) then
        !Pure water condensate:
        t_si = liq_air_h_temperature_si(wa_si, eta_si, p_si)
        liq_ice_air_h_density_si = liq_air_g_density_si(wa_si, t_si, p_si)
    elseif(wt==0d0) then
        !Pure ice condensate:
        t_si = ice_air_h_temperature_si(wa_si, eta_si, p_si)
        liq_ice_air_h_density_si = ice_air_g_density_si(wa_si, t_si, p_si)
    else
        !Mixed state water/ice:
        if(set_liq_ice_air_eq_at_wa_eta_wt(wa_si,eta_si,wt) == errorreturn) return
        liq_ice_air_h_density_si = liq_ice_air_density_si()
    endif

    if(liq_ice_air_h_density_si==errorreturn) then
        !If it fails, it is likely that we are outside the region of validity of moist air.
        !For lack of better alternative, use dry air values:
        a_si=1.0
        liq_ice_air_h_density_si = air_g_density_si(a_si, t_si, p_si)
    endif
endif
end function

function liq_ice_air_h_enthalpy_si(wa_si, eta_si, p_si)
!THIS FUNCTION COMPUTES THE ENTHALPY OF AIR
!SHOULD BE VALID OVER THE WHOLE REGION OF VALIDILITY OF TEOS-10

!OUTPUT:
!H - ENTHALPY

!INPUTS:
!A_SI      ABSOLUTE DRY-AIR MASS FRACTION IN KG/KG
!ETA_SI      ABSOLUTE IN-SITU ENTROPY
!P_SI      ABSOLUTE IN-SITU PRESSURE IN PA
!
!Note that this is a good template for converting liq_air_g* and ice_air_g* functions to
!liq_ice_air_h*. The liq_ice_air_h* functions are more robust at the triple point since it is
!possible to obtain an exact expression for the mixed liquid/ice state.

real*8 liq_ice_air_h_enthalpy_si, wa_si, eta_si, p_si
real*8 t_freeze, icl, wt, t_si, a_si

liq_ice_air_h_enthalpy_si = errorreturn

if(wa_si < 0d0 .or. wa_si > 1d0) return
if(p_si < 0d0) return

if(wa_si == 1d0) then
    !No water:
    t_si = air_temperature_si(wa_si, eta_si, p_si)
    liq_ice_air_h_enthalpy_si = air_g_enthalpy_si(wa_si, t_si, p_si)
else
    !Try equilibrium without condensate:
    t_si = air_temperature_si(wa_si, eta_si, p_si)
    !Check if no condensation makes sense:
    if(t_si/=errorreturn) then
        if(set_liq_ice_air_eq_at_p(p_si) == errorreturn) return
        t_freeze=liq_ice_air_temperature_si()
        !If the freezing temperature returns an error this function will return an error:
        if(t_freeze==errorreturn) return

        if(t_si<t_freeze) then
            !Freezing conditions, use ice_air:
            icl = ice_air_icl_si(wa_si,t_si,p_si)
            if(icl==errorreturn.or.(icl/=errorreturn.and.icl<p_si)) then
                !Air is below the isentropic condensation level -> no condensation
                liq_ice_air_h_enthalpy_si = air_g_enthalpy_si(wa_si, t_si, p_si)
                return
            endif
        else
            !Non-Freezing conditions, use ice_air:
            icl = liq_air_icl_si(wa_si,t_si,p_si)
            if(icl==errorreturn.or.(icl/=errorreturn.and.icl<p_si)) then
                !Air is below the isentropic condensation level -> no condensation
                liq_ice_air_h_enthalpy_si = air_g_enthalpy_si(wa_si, t_si, p_si)
                return
            endif
        endif
    endif

    !If we have not returned, must check for condensation and mixed state:
    wt = liq_ice_air_h_liquidfraction_of_condensate_si(wa_si,eta_si,p_si)
    if(wt==1d0) then
        !Pure water condensate:
        t_si = liq_air_h_temperature_si(wa_si, eta_si, p_si)
        liq_ice_air_h_enthalpy_si = liq_air_g_enthalpy_si(wa_si, t_si, p_si)
    elseif(wt==0d0) then
        !Pure ice condensate:
        t_si = ice_air_h_temperature_si(wa_si, eta_si, p_si)
        liq_ice_air_h_enthalpy_si = ice_air_g_enthalpy_si(wa_si, t_si, p_si)
    else
        !Mixed state water/ice:
        if(set_liq_ice_air_eq_at_wa_eta_wt(wa_si,eta_si,wt) == errorreturn) return
        liq_ice_air_h_enthalpy_si = liq_ice_air_enthalpy_si()
    endif

    if(liq_ice_air_h_enthalpy_si==errorreturn) then
        !If it fails, it is likely that we are outside the region of validity of moist air.
        !For lack of better alternative, use dry air values:
        a_si=1.0
        liq_ice_air_h_enthalpy_si = air_g_enthalpy_si(a_si, t_si, p_si)
    endif

endif
end function

function liq_ice_air_h_gc_gv_si(wa_si, eta_si, p_si)
!THIS FUNCTION COMPUTES THE DIFFERENCE BETWEEN THE GIBBS FUNCTION OF THE CONDENSATE AND
!THE GIBBS FUNCTION OF WATER VAPOR
!SHOULD BE VALID OVER THE WHOLE REGION OF VALIDILITY OF TEOS-10

!OUTPUT:
!GC-GV - DIFFERENCE BETWEEN CONDENSATE AND VAPOR GIBBS

!INPUTS:
!WA_SI      ABSOLUTE DRY-AIR MASS FRACTION IN KG/KG
!ETA_SI      ABSOLUTE IN-SITU ENTROPY
!P_SI      ABSOLUTE IN-SITU PRESSURE IN PA
!
!Note that this is a good template for converting liq_air_g* and ice_air_g* functions to
!liq_ice_air_h*. The liq_ice_air_h* functions are more robust at the triple point since it is
!possible to obtain an exact expression for the mixed liquid/ice state.

real*8 liq_ice_air_h_gc_gv_si, wa_si, eta_si, p_si
real*8 t_freeze, icl, wt, t_si, a, gv

liq_ice_air_h_gc_gv_si = errorreturn

if(wa_si < 0d0 .or. wa_si > 1d0) return
if(p_si < 0d0) return

if(wa_si == 1d0) then
    !No water:
    t_si = air_temperature_si(wa_si, eta_si, p_si)

    !To find condensate, Find freezing temperature:
    if(set_liq_ice_air_eq_at_p(p_si) /= errorreturn) then
        !Above or at triple point
        t_freeze=liq_ice_air_temperature_si()
        if(t_freeze==errorreturn) return
        if(t_si<t_freeze) then
            !Freezing
            a = ice_air_massfraction_air_si(t_si, p_si) 
            gv = air_g_si(0,0,0,wa_si, t_si, p_si)-wa_si*air_g_si(1,0,0,wa_si, t_si, p_si)
            liq_ice_air_h_gc_gv_si = (ice_g_si(0,0, t_si, p_si) - gv)*(1.0/a-1.0)
        else
            !Not freezing
            a = liq_air_massfraction_air_si(t_si, p_si) 
            gv = air_g_si(0,0,0,wa_si, t_si, p_si)-wa_si*air_g_si(1,0,0,wa_si, t_si, p_si)
            liq_ice_air_h_gc_gv_si = (liq_g_si(0,0, t_si, p_si) - gv)*(1.0/a-1.0)
        endif
    else
        !Below triple point: pure Ice
        a = ice_air_massfraction_air_si(t_si, p_si) 
        gv = air_g_si(0,0,0,wa_si, t_si, p_si)-wa_si*air_g_si(1,0,0,wa_si, t_si, p_si)
        liq_ice_air_h_gc_gv_si = (ice_g_si(0,0, t_si, p_si) - gv)*(1.0/a-1.0)
    endif
else
    !Try equilibrium without condensate:
    t_si = air_temperature_si(wa_si, eta_si, p_si)
    !Check if no condensation makes sense:
    if(t_si/=errorreturn) then

        if(set_liq_ice_air_eq_at_p(p_si) /= errorreturn) then
            !Aboce triple point
            t_freeze=liq_ice_air_temperature_si()
            !If the freezing temperature returns an error this function will return an error:
            if(t_freeze==errorreturn) return

            if(t_si<t_freeze) then
                !Freezing conditions, use ice_air:
                icl = ice_air_icl_si(wa_si,t_si,p_si)
                if(icl==errorreturn.or.(icl/=errorreturn.and.icl<p_si)) then
                    !Air is below the isentropic condensation level -> no condensation
                    a = ice_air_massfraction_air_si(t_si, p_si) 
                    gv = air_g_si(0,0,0,wa_si, t_si, p_si)-wa_si*air_g_si(1,0,0,wa_si, t_si, p_si)
                    liq_ice_air_h_gc_gv_si = (ice_g_si(0,0, t_si, p_si) - gv)
                    return
                endif
            else
                !Non-Freezing conditions, use liq_air:
                icl = liq_air_icl_si(wa_si,t_si,p_si)
                if(icl==errorreturn.or.(icl/=errorreturn.and.icl<p_si)) then
                    !Air is below the isentropic condensation level -> no condensation
                    a = liq_air_massfraction_air_si(t_si, p_si) 
                    gv = air_g_si(0,0,0,wa_si, t_si, p_si)-wa_si*air_g_si(1,0,0,wa_si, t_si, p_si)
                    liq_ice_air_h_gc_gv_si = (liq_g_si(0,0, t_si, p_si) - gv)
                    return
                endif
            endif
        else
            !Below triple point:
            icl = ice_air_icl_si(wa_si,t_si,p_si)
            if(icl==errorreturn.or.(icl/=errorreturn.and.icl<p_si)) then
                !Air is below the isentropic condensation level -> no condensation
                a = ice_air_massfraction_air_si(t_si, p_si) 
                gv = air_g_si(0,0,0,wa_si, t_si, p_si)-wa_si*air_g_si(1,0,0,wa_si, t_si, p_si)
                liq_ice_air_h_gc_gv_si = (ice_g_si(0,0, t_si, p_si) - gv)
                return
            endif
        endif
    endif

    !If we have not returned, must check for condensation and mixed state:
    wt = liq_ice_air_h_liquidfraction_of_condensate_si(wa_si,eta_si,p_si)
    if(wt==1d0) then
        !Pure water condensate:
        t_si = liq_air_h_temperature_si(wa_si, eta_si, p_si)
        a = liq_air_massfraction_air_si(t_si, p_si) 
        gv = air_g_si(0,0,0,a, t_si, p_si)-a*air_g_si(1,0,0,a, t_si, p_si)
        liq_ice_air_h_gc_gv_si = (liq_g_si(0,0, t_si, p_si) - gv)*(1.0/a-1.0)
    elseif(wt==0d0) then
        !Pure ice condensate:
        t_si = ice_air_h_temperature_si(wa_si, eta_si, p_si)
        a = ice_air_massfraction_air_si(t_si, p_si) 
        gv = air_g_si(0,0,0,a, t_si, p_si)-a*air_g_si(1,0,0,a, t_si, p_si)
        liq_ice_air_h_gc_gv_si = (ice_g_si(0,0, t_si, p_si) - gv)*(1.0/a-1.0)
    else
        !Mixed state water/ice:
        if(set_liq_ice_air_eq_at_wa_eta_wt(wa_si,eta_si,wt) == errorreturn) return
        t_si = liq_ice_air_temperature_si()
        a = liq_ice_air_airfraction_si()
        gv = air_g_si(0,0,0,a, t_si, p_si)-a*air_g_si(1,0,0,a, t_si, p_si)
        liq_ice_air_h_gc_gv_si = (wt*liq_g_si(0,0, t_si, p_si)+(1.0-wt)*ice_g_si(0,0, t_si, p_si) - gv)*(1.0/a-1.0)
    endif
endif
end function

function liq_ice_air_h_gc_si(wa_si, eta_si, p_si)
!THIS FUNCTION COMPUTES 
!THE GIBBS FUNCTION OF THE CONDENSATE
!SHOULD BE VALID OVER THE WHOLE REGION OF VALIDILITY OF TEOS-10

!OUTPUT:
!GD-GC - DIFFERENCE BETWEEN CONDENSATE AND VAPOR GIBBS

!INPUTS:
!WA_SI      ABSOLUTE DRY-AIR MASS FRACTION IN KG/KG
!ETA_SI      ABSOLUTE IN-SITU ENTROPY
!P_SI      ABSOLUTE IN-SITU PRESSURE IN PA
!
!Note that this is a good template for converting liq_air_g* and ice_air_g* functions to
!liq_ice_air_h*. The liq_ice_air_h* functions are more robust at the triple point since it is
!possible to obtain an exact expression for the mixed liquid/ice state.

real*8 liq_ice_air_h_gc_si, wa_si, eta_si, p_si
real*8 t_freeze, icl, wt, t_si, a_si

liq_ice_air_h_gc_si = errorreturn

if(wa_si < 0d0 .or. wa_si > 1d0) return
if(p_si < 0d0) return

if(wa_si == 1d0) then
    !No water:
    t_si = air_temperature_si(wa_si, eta_si, p_si)

    !To find condensate, Find freezing temperature:
    if(set_liq_ice_air_eq_at_p(p_si) == errorreturn) return
    t_freeze=liq_ice_air_temperature_si()
    if(t_freeze==errorreturn) return
    if(t_si<t_freeze) then
        !Freezing
        liq_ice_air_h_gc_si = ice_g_si(0,0, t_si, p_si)
    else
        !Not freezing
        liq_ice_air_h_gc_si = liq_g_si(0,0, t_si, p_si)
    endif
else
    !Try equilibrium without condensate:
    t_si = air_temperature_si(wa_si, eta_si, p_si)
    !Check if no condensation makes sense:
    if(t_si/=errorreturn) then

        if(set_liq_ice_air_eq_at_p(p_si) == errorreturn) return
        t_freeze=liq_ice_air_temperature_si()
        !If the freezing temperature returns an error this function will return an error:
        if(t_freeze==errorreturn) return

        if(t_si<t_freeze) then
            !Freezing conditions, use ice_air:
            icl = ice_air_icl_si(wa_si,t_si,p_si)
            if(icl==errorreturn.or.(icl/=errorreturn.and.icl<p_si)) then
                !Air is below the isentropic condensation level -> no condensation
                liq_ice_air_h_gc_si = ice_g_si(0,0, t_si, p_si)
                return
            endif
        else
            !Non-Freezing conditions, use ice_air:
            icl = liq_air_icl_si(wa_si,t_si,p_si)
            if(icl==errorreturn.or.(icl/=errorreturn.and.icl<p_si)) then
                !Air is below the isentropic condensation level -> no condensation
                liq_ice_air_h_gc_si = liq_g_si(0,0, t_si, p_si)
                return
            endif
        endif
    endif

    !If we have not returned, must check for condensation and mixed state:
    wt = liq_ice_air_h_liquidfraction_of_condensate_si(wa_si,eta_si,p_si)
    if(wt==1d0) then
        !Pure water condensate:
        t_si = liq_air_h_temperature_si(wa_si, eta_si, p_si)
        liq_ice_air_h_gc_si = liq_g_si(0,0, t_si, p_si)
    elseif(wt==0d0) then
        !Pure ice condensate:
        t_si = ice_air_h_temperature_si(wa_si, eta_si, p_si)
        liq_ice_air_h_gc_si = ice_g_si(0,0, t_si, p_si)
    else
        !Mixed state water/ice:
        if(set_liq_ice_air_eq_at_wa_eta_wt(wa_si,eta_si,wt) == errorreturn) return
        t_si = liq_ice_air_temperature_si()
        liq_ice_air_h_gc_si = (wt*liq_g_si(0,0, t_si, p_si)+(1.0-wt)*ice_g_si(0,0, t_si, p_si))
    endif
    if(liq_ice_air_h_gc_si==errorreturn) then
        !If it fails, it is likely that we are outside the region of validity of moist air.
        !For lack of better alternative, use dry air values:
        !No water and ice:
        t_si = air_temperature_si(a_si, eta_si, p_si)
        liq_ice_air_h_gc_si = ice_g_si(0,0, t_si, p_si)
    endif
endif
end function

function liq_ice_air_h_gd_si(wa_si, eta_si, p_si)
!THIS FUNCTION COMPUTES THE CHEMICAL POTENTIAL OF DRY AIR 
!SHOULD BE VALID OVER THE WHOLE REGION OF VALIDILITY OF TEOS-10

!OUTPUT:
!GD-GC - DIFFERENCE BETWEEN CONDENSATE AND VAPOR GIBBS

!INPUTS:
!WA_SI      ABSOLUTE DRY-AIR MASS FRACTION IN KG/KG
!ETA_SI      ABSOLUTE IN-SITU ENTROPY
!P_SI      ABSOLUTE IN-SITU PRESSURE IN PA
!
!Note that this is a good template for converting liq_air_g* and ice_air_g* functions to
!liq_ice_air_h*. The liq_ice_air_h* functions are more robust at the triple point since it is
!possible to obtain an exact expression for the mixed liquid/ice state.

real*8 liq_ice_air_h_gd_si, wa_si, eta_si, p_si
real*8 t_freeze, icl, wt, t_si, a, gd, a_si

liq_ice_air_h_gd_si = errorreturn

if(wa_si < 0d0 .or. wa_si > 1d0) return
if(p_si < 0d0) return

if(wa_si == 1d0) then
    !No water:
    t_si = air_temperature_si(wa_si, eta_si, p_si)

    !To find condensate, Find freezing temperature:
    if(set_liq_ice_air_eq_at_p(p_si) == errorreturn) return
    t_freeze=liq_ice_air_temperature_si()
    if(t_freeze==errorreturn) return
    if(t_si<t_freeze) then
        !Freezing
        gd = air_g_si(0,0,0,wa_si, t_si, p_si)+(1.0-wa_si)*air_g_si(1,0,0,wa_si, t_si, p_si)
        liq_ice_air_h_gd_si = gd
    else
        !Not freezing
        gd = air_g_si(0,0,0,wa_si, t_si, p_si)+(1.0-wa_si)*air_g_si(1,0,0,wa_si, t_si, p_si)
        liq_ice_air_h_gd_si = gd
    endif
else
    !Try equilibrium without condensate:
    t_si = air_temperature_si(wa_si, eta_si, p_si)
    !Check if no condensation makes sense:
    if(t_si/=errorreturn) then

        if(set_liq_ice_air_eq_at_p(p_si) == errorreturn) return
        t_freeze=liq_ice_air_temperature_si()
        !If the freezing temperature returns an error this function will return an error:
        if(t_freeze==errorreturn) return

        if(t_si<t_freeze) then
            !Freezing conditions, use ice_air:
            icl = ice_air_icl_si(wa_si,t_si,p_si)
            if(icl==errorreturn.or.(icl/=errorreturn.and.icl<p_si)) then
                !Air is below the isentropic condensation level -> no condensation
                gd = air_g_si(0,0,0,wa_si, t_si, p_si)+(1.0-wa_si)*air_g_si(1,0,0,wa_si, t_si, p_si)
                liq_ice_air_h_gd_si = gd
                return
            endif
        else
            !Non-Freezing conditions, use ice_air:
            icl = liq_air_icl_si(wa_si,t_si,p_si)
            if(icl==errorreturn.or.(icl/=errorreturn.and.icl<p_si)) then
                !Air is below the isentropic condensation level -> no condensation
                gd = air_g_si(0,0,0,wa_si, t_si, p_si)+(1.0-wa_si)*air_g_si(1,0,0,wa_si, t_si, p_si)
                liq_ice_air_h_gd_si = gd
                return
            endif
        endif
    endif

    !If we have not returned, must check for condensation and mixed state:
    wt = liq_ice_air_h_liquidfraction_of_condensate_si(wa_si,eta_si,p_si)
    if(wt==1d0) then
        !Pure water condensate:
        t_si = liq_air_h_temperature_si(wa_si, eta_si, p_si)
        a = liq_air_massfraction_air_si(t_si, p_si) 
        gd = air_g_si(0,0,0,a, t_si, p_si)+(1.0-a)*air_g_si(1,0,0,a, t_si, p_si)
        liq_ice_air_h_gd_si = gd
    elseif(wt==0d0) then
        !Pure ice condensate:
        t_si = ice_air_h_temperature_si(wa_si, eta_si, p_si)
        a = ice_air_massfraction_air_si(t_si, p_si) 
        gd = air_g_si(0,0,0,a, t_si, p_si)+(1.0-a)*air_g_si(1,0,0,a, t_si, p_si)
        liq_ice_air_h_gd_si = gd
    else
        !Mixed state water/ice:
        if(set_liq_ice_air_eq_at_wa_eta_wt(wa_si,eta_si,wt) == errorreturn) return
        t_si = liq_ice_air_temperature_si()
        a = liq_ice_air_airfraction_si()
        gd = air_g_si(0,0,0,a, t_si, p_si)+(1.0-a)*air_g_si(1,0,0,a, t_si, p_si)
        liq_ice_air_h_gd_si = gd
    endif
    if(liq_ice_air_h_gd_si==errorreturn) then
        !If it fails, it is likely that we are outside the region of validity of moist air.
        !For lack of better alternative, use dry air values:
        !No water and ice:
        a_si=1.0
        t_si = air_temperature_si(a_si, eta_si, p_si)
        gd = air_g_si(0,0,0,a_si, t_si, p_si)
        liq_ice_air_h_gd_si = gd
    endif
endif
end function



function liq_ice_air_h_gd_gc_si(wa_si, eta_si, p_si)
!THIS FUNCTION COMPUTES THE DIFFERENCE BETWEEN THE GIBBS FUNCTION OF THE DRY AIR AND
!THE GIBBS FUNCTION OF THE CONDENSATE
!SHOULD BE VALID OVER THE WHOLE REGION OF VALIDILITY OF TEOS-10

!OUTPUT:
!GD-GC - DIFFERENCE BETWEEN CONDENSATE AND VAPOR GIBBS

!INPUTS:
!WA_SI      ABSOLUTE DRY-AIR MASS FRACTION IN KG/KG
!ETA_SI      ABSOLUTE IN-SITU ENTROPY
!P_SI      ABSOLUTE IN-SITU PRESSURE IN PA
!
!Note that this is a good template for converting liq_air_g* and ice_air_g* functions to
!liq_ice_air_h*. The liq_ice_air_h* functions are more robust at the triple point since it is
!possible to obtain an exact expression for the mixed liquid/ice state.

real*8 liq_ice_air_h_gd_gc_si, wa_si, eta_si, p_si
real*8 t_freeze, icl, wt, t_si, a, gd, a_si

liq_ice_air_h_gd_gc_si = errorreturn

if(wa_si < 0d0 .or. wa_si > 1d0) return
if(p_si < 0d0) return

if(wa_si == 1d0) then
    !No water:
    t_si = air_temperature_si(wa_si, eta_si, p_si)

    !To find condensate, Find freezing temperature:
    if(set_liq_ice_air_eq_at_p(p_si) == errorreturn) return
    t_freeze=liq_ice_air_temperature_si()
    if(t_freeze==errorreturn) return
    if(t_si<t_freeze) then
        !Freezing
        gd = air_g_si(0,0,0,wa_si, t_si, p_si)+(1.0-wa_si)*air_g_si(1,0,0,wa_si, t_si, p_si)
        liq_ice_air_h_gd_gc_si = gd - ice_g_si(0,0, t_si, p_si)
    else
        !Not freezing
        gd = air_g_si(0,0,0,wa_si, t_si, p_si)+(1.0-wa_si)*air_g_si(1,0,0,wa_si, t_si, p_si)
        liq_ice_air_h_gd_gc_si = gd - liq_g_si(0,0, t_si, p_si)
    endif
else
    !Try equilibrium without condensate:
    t_si = air_temperature_si(wa_si, eta_si, p_si)
    !Check if no condensation makes sense:
    if(t_si/=errorreturn) then

        if(set_liq_ice_air_eq_at_p(p_si) == errorreturn) return
        t_freeze=liq_ice_air_temperature_si()
        !If the freezing temperature returns an error this function will return an error:
        if(t_freeze==errorreturn) return

        if(t_si<t_freeze) then
            !Freezing conditions, use ice_air:
            icl = ice_air_icl_si(wa_si,t_si,p_si)
            if(icl==errorreturn.or.(icl/=errorreturn.and.icl<p_si)) then
                !Air is below the isentropic condensation level -> no condensation
                gd = air_g_si(0,0,0,wa_si, t_si, p_si)+(1.0-wa_si)*air_g_si(1,0,0,wa_si, t_si, p_si)
                liq_ice_air_h_gd_gc_si = gd - ice_g_si(0,0, t_si, p_si)
                return
            endif
        else
            !Non-Freezing conditions, use ice_air:
            icl = liq_air_icl_si(wa_si,t_si,p_si)
            if(icl==errorreturn.or.(icl/=errorreturn.and.icl<p_si)) then
                !Air is below the isentropic condensation level -> no condensation
                gd = air_g_si(0,0,0,wa_si, t_si, p_si)+(1.0-wa_si)*air_g_si(1,0,0,wa_si, t_si, p_si)
                liq_ice_air_h_gd_gc_si = gd - liq_g_si(0,0, t_si, p_si)
                return
            endif
        endif
    endif

    !If we have not returned, must check for condensation and mixed state:
    wt = liq_ice_air_h_liquidfraction_of_condensate_si(wa_si,eta_si,p_si)
    if(wt==1d0) then
        !Pure water condensate:
        t_si = liq_air_h_temperature_si(wa_si, eta_si, p_si)
        a = liq_air_massfraction_air_si(t_si, p_si) 
        gd = air_g_si(0,0,0,a, t_si, p_si)+(1.0-a)*air_g_si(1,0,0,a, t_si, p_si)
        liq_ice_air_h_gd_gc_si = gd - liq_g_si(0,0, t_si, p_si)
    elseif(wt==0d0) then
        !Pure ice condensate:
        t_si = ice_air_h_temperature_si(wa_si, eta_si, p_si)
        a = ice_air_massfraction_air_si(t_si, p_si) 
        gd = air_g_si(0,0,0,a, t_si, p_si)+(1.0-a)*air_g_si(1,0,0,a, t_si, p_si)
        liq_ice_air_h_gd_gc_si = gd - ice_g_si(0,0, t_si, p_si)
    else
        !Mixed state water/ice:
        if(set_liq_ice_air_eq_at_wa_eta_wt(wa_si,eta_si,wt) == errorreturn) return
        t_si = liq_ice_air_temperature_si()
        a = liq_ice_air_airfraction_si()
        gd = air_g_si(0,0,0,a, t_si, p_si)+(1.0-a)*air_g_si(1,0,0,a, t_si, p_si)
        liq_ice_air_h_gd_gc_si = gd - (wt*liq_g_si(0,0, t_si, p_si)+(1.0-wt)*ice_g_si(0,0, t_si, p_si))
    endif
    if(liq_ice_air_h_gd_gc_si==errorreturn) then
        !If it fails, it is likely that we are outside the region of validity of moist air.
        !For lack of better alternative, use dry air values:
        !No water and ice:
        a_si=1.0
        t_si = air_temperature_si(a_si, eta_si, p_si)
        gd = air_g_si(0,0,0,a_si, t_si, p_si)
        liq_ice_air_h_gd_gc_si = gd - ice_g_si(0,0, t_si, p_si)
    endif
endif
end function

function liq_ice_air_h_gh_gc_si(wa_si, eta_si, p_si)
!THIS FUNCTION COMPUTES THE DERIVATIVE OF THE GIBBS FUNCTION WRT TO WA_SI
!SHOULD BE VALID OVER THE WHOLE REGION OF VALIDILITY OF TEOS-10

!OUTPUT:
!GH-GC - DIFFERENCE BETWEEN CONDENSATE AND VAPOR GIBBS

!INPUTS:
!WA_SI      ABSOLUTE DRY-AIR MASS FRACTION IN KG/KG
!ETA_SI      ABSOLUTE IN-SITU ENTROPY
!P_SI      ABSOLUTE IN-SITU PRESSURE IN PA
!
!Note that this is a good template for converting liq_air_g* and ice_air_g* functions to
!liq_ice_air_h*. The liq_ice_air_h* functions are more robust at the triple point since it is
!possible to obtain an exact expression for the mixed liquid/ice state.

real*8 liq_ice_air_h_gh_gc_si, wa_si, eta_si, p_si
real*8 t_freeze, icl, wt, t_si, a_si

liq_ice_air_h_gh_gc_si = errorreturn

if(wa_si < 0d0 .or. wa_si > 1d0) return
if(p_si < 0d0) return

if(wa_si == 1d0) then
    !No water:
    t_si = air_temperature_si(wa_si, eta_si, p_si)
    liq_ice_air_h_gh_gc_si = air_g_si(1,0,0,wa_si, t_si, p_si)
else
    !Try equilibrium without condensate:
    t_si = air_temperature_si(wa_si, eta_si, p_si)
    !Check if no condensation makes sense:
    if(t_si/=errorreturn) then

        if(set_liq_ice_air_eq_at_p(p_si) == errorreturn) return
        t_freeze=liq_ice_air_temperature_si()
        !If the freezing temperature returns an error this function will return an error:
        if(t_freeze==errorreturn) return

        if(t_si<t_freeze) then
            !Freezing conditions, use ice_air:
            icl = ice_air_icl_si(wa_si,t_si,p_si)
            if(icl==errorreturn.or.(icl/=errorreturn.and.icl<p_si)) then
                !Air is below the isentropic condensation level -> no condensation
                liq_ice_air_h_gh_gc_si = air_g_si(1,0,0,wa_si, t_si, p_si)
                return
            endif
        else
            !Non-Freezing conditions, use ice_air:
            icl = liq_air_icl_si(wa_si,t_si,p_si)
            if(icl==errorreturn.or.(icl/=errorreturn.and.icl<p_si)) then
                !Air is below the isentropic condensation level -> no condensation
                liq_ice_air_h_gh_gc_si = air_g_si(1,0,0,wa_si, t_si, p_si)
                return
            endif
        endif
    endif

    !If we have not returned, must check for condensation and mixed state:
    wt = liq_ice_air_h_liquidfraction_of_condensate_si(wa_si,eta_si,p_si)
    if(wt==1d0) then
        !Pure water condensate:
        t_si = liq_air_h_temperature_si(wa_si, eta_si, p_si)
        liq_ice_air_h_gh_gc_si = liq_air_g_si(1,0,0,wa_si, t_si, p_si)
    elseif(wt==0d0) then
        !Pure ice condensate:
        t_si = ice_air_h_temperature_si(wa_si, eta_si, p_si)
        liq_ice_air_h_gh_gc_si = ice_air_g_si(1,0,0,wa_si, t_si, p_si)
    else
        !Mixed state water/ice:
        if(set_liq_ice_air_eq_at_wa_eta_wt(wa_si,eta_si,wt) == errorreturn) return
        t_si = liq_ice_air_temperature_si()
        liq_ice_air_h_gh_gc_si = wt*liq_air_g_si(1,0,0,wa_si, t_si, p_si)+(1.0-wt)*ice_air_g_si(1,0,0,wa_si, t_si, p_si)
    endif
    if(liq_ice_air_h_gh_gc_si==errorreturn) then
        !If it fails, it is likely that we are outside the region of validity of moist air.
        !For lack of better alternative, use dry air values:
        !No water:
        a_si=1.0
        t_si = air_temperature_si(a_si, eta_si, p_si)
        liq_ice_air_h_gh_gc_si = air_g_si(1,0,0,a_si, t_si, p_si)
    endif
endif
end function

function liq_ice_air_h_liquidfraction_of_condensate_si(wa_si,eta_si,p_si)
!THIS FUNCTION RETURNS THE FRACTION OF LIQUID WATER IN WET ICE AIR IN KG/KG
!WHEN WATER + ICE ARE AT EQUILIBRIUM WITH HUMID AIR.
!
!RETURNS     
!LIQUIDFRACTION=1D0        ALL THE CONDENSATE IS WATER
!LIQUIDFRACTION=0D0        ALL THE CONDENSATE IS ICE
!0D0<LIQUIDFRACTION<1D0    MIXTURE OF THE TWO STATES          
!
!IF THERE IS NO CONDENSATE IT RETURNS ERRORRETURN
real*8 liq_ice_air_h_liquidfraction_of_condensate_si, wa_si, eta_si, p_si
real*8 ifl, iml, t_freeze, t
real*8 eps
integer maxit

liq_ice_air_h_liquidfraction_of_condensate_si = errorreturn

if(wa_si < 0d0 .or. wa_si > 1d0) return
if(p_si < 0d0) return

!Try mixed equilibrium using isentropic melting and freezing levels:
iml=liq_ice_air_iml_si(wa_si,eta_si)
ifl=liq_ice_air_ifl_si(wa_si,eta_si)
if(iml==errorreturn.or.ifl==errorreturn) then
    !One the isentropic levels did not converge.
    !Try ice and then liquid.
    if(set_liq_ice_air_eq_at_p(p_si) == errorreturn) return
    t_freeze=liq_ice_air_temperature_si()
    if(t_freeze==errorreturn) return

    t = ice_air_h_temperature_si(wa_si, eta_si, p_si)
    if(t/=errorreturn.and.t<t_freeze) then
        liq_ice_air_h_liquidfraction_of_condensate_si=0d0 
        return
    endif

    t = liq_air_h_temperature_si(wa_si, eta_si, p_si)
    if(t/=errorreturn.and.t>=t_freeze) then
        liq_ice_air_h_liquidfraction_of_condensate_si=1d0 
        return
    endif
else
    !The isentropic levels converged.
    if(p_si>=ifl) then
        !Below freezing level -> pure liquid water
        liq_ice_air_h_liquidfraction_of_condensate_si=1d0 
    elseif(p_si<=iml) then
        !Above melting level -> pure ice
        liq_ice_air_h_liquidfraction_of_condensate_si=0d0 
    else !(p_si > iml .and. p_si < ifl)
        !Between the levels -> linear combination of the two
        !From comments in Liq_Ice_Air_4.F90:
        !set_liq_ice_air_eq_at_wa_eta_wt(wa_si,eta_si,0d0)
        !iml=liq_ice_air_pressure_si()
        !liq_air_h_temperature_si(wa_si, eta_si, iml) = liq_ice_air_temperature()
        !set_liq_ice_air_eq_at_wa_eta_wt(wa_si,eta_si,1d0)
        !ifl=liq_ice_air_pressure_si()
        !ice_air_h_temperature_si(wa_si, eta_si, ifl) = liq_ice_air_temperature()
        !
        !When p_si==iml --> liq_air_h_temperature
        !When p_si==ifl --> ice_air_h_temperature
        !
        call init_it_ctrl_liquidfraction
        if(ctrl_loop_maximum == 0) then
            maxit = 100
        elseif(ctrl_loop_maximum > 0) then
            maxit = ctrl_loop_maximum
        else
            return
        endif
        eps = ctrl_eps_exit_liquidfraction
        if(eps <= 0d0) return
        liq_ice_air_h_liquidfraction_of_condensate_si=&
                liquidfractioniteration_brent(wa_si,eta_si,p_si,0d0,1d0,maxit,eps)
    endif
endif
end function

!==========================================================================
function liquidfractioniteration_brent(wa_si, eta_si, p_si, wt1, wt2, &
                                    maxit, eps)
!=========================================================================

!THE FUNCTION COMPUTES THE EQUIVALENT TEMPERATURE AS A FUNCTION OF AIR FRACTION, ENTROPY AND PRESSURE,
!COMPUTED BY BRENT ITERATION
!HTTP://EN.WIKIPEDIA.ORG/WIKI/BRENT'S_METHOD

!OUTPUT: 
!        TEMPERATUREITERATION_BRENT: EQUIVALENT TEMPERATURE IN K
!        THE VALUE ERRORRETURN IS RETURNED IF
!        - THE MAXIMUM NUMBER OF ITERATIONS IS EXCEEDED WITHOUT MEETING THE EXIT CRITERION
!        - THE FUNCTION CALL TO LIQ_AIR_G_SI HAS RETURNED AN ERROR
!        - TEMPERATURE HAS TAKEN A ZERO OR NEGATIVE VALUE DURING THE ITERATION

!INPUT: 
!       WA_SI: MASS FRACTION OF DRY AIR IN WET AIR IN KG/KG
!        T_SI: TEMPERATURE IN K
!        P_SI: ABSOLUTE PRESSURE IN PA
!          T1: INITIAL GUESS FOR EQUIVALENT TEMPERATURE IN K
!          T2: COUNTERPOINT EQUIVALENT TEMPERATURE
!       MAXIT: MAXIMUM NUMBER OF ITERATION STEPS TO BE DONE
!         EPS: REQUIRED ACCURACY OF TEMPERATURE
!              EPS > 0: ABSOLUTE TEMPERATURE TOLERANCE IN K
!              EPS < 0: RELATIVE TEMPERATURE TOLERANCE

real*8 liquidfractioniteration_brent, wa_si, eta_si, p_si, wt1, wt2, eps
real*8 a, b, c, d, s
real*8 fa, fb, fc, fs
integer it, maxit

logical mflag

liquidfractioniteration_brent = errorreturn
d = errorreturn

if(wa_si < 0d0 .or. wa_si > 1d0 .or. &
  p_si <= 0d0 .or. &
  eps == 0d0 .or. &
  maxit <= 0) return

a = wt1
if(set_liq_ice_air_eq_at_wa_eta_wt(wa_si,eta_si,a) == errorreturn) return
fa = -liq_ice_air_pressure_si()
fa = -fa - p_si

b = wt2
if(set_liq_ice_air_eq_at_wa_eta_wt(wa_si,eta_si,b) == errorreturn) return
fb = -liq_ice_air_pressure_si()
fb = -fb - p_si

!write(*,*) a,fa,b,fb
if(fa * fb > 0d0) return

if(abs(fa) < abs(fb)) then
  call swap(a, b)
  call swap(fa, fb)
end if

c = a
fc = fa
mflag = .true.

check_limits = check_limits - 1

do it = 1, maxit

  if(fb == 0d0) then
    liquidfractioniteration_brent = b
    go to 999
  end if

  if(eps > 0d0) then                !ABSOLUTE LIMIT
    if(abs(a - b) < eps) then
      liquidfractioniteration_brent = b
      go to 999
    end if
  else                                 !RELATIVE LIMIT
    if(abs(a - b) < -eps * b) then
      liquidfractioniteration_brent = b
      go to 999
    end if
  end if

  if(fa == fb) go to 999

  if(fa /= fc .and. fb /= fc) then
    s = a * fb * fc / ((fa - fb) * (fa - fc)) +  &
        b * fa * fc / ((fb - fa) * (fb - fc)) +  &
        c * fa * fb / ((fc - fa) * (fc - fb))
  else
    s = b - (b - a) * fb / (fb - fa)
  end if

  if(((3 * a + b) / 4 - s) * (b - s) > 0d0 .or. &
     (mflag .and. abs(s - b) >= 0.5 * abs(b - c)) .or. &
     (.not. mflag .and. abs(s - b) >= 0.5 * (c - d))) then
    s = 0.5 * (a + b)
  else
    mflag = .false.
  end if

  if(set_liq_ice_air_eq_at_wa_eta_wt(wa_si,eta_si,s) == errorreturn) return
  fs = -liq_ice_air_pressure_si()
  fs = -fs - p_si

  d = c
  c = b
  fc = fb

  if(fa * fs < 0d0) then
    b = s
    fb = fs
  else
    a = s
    fa = fs
  end if

  if(abs(fa) < abs(fb)) then
    call swap(a, b)
    call swap(fa, fb)
  end if

enddo

999 continue

check_limits = check_limits + 1

if(check_limits == 1) then
  if(b < 0d0 .or. b > 1d0) then
    liquidfractioniteration_brent = errorreturn
    return
  endif
endif

end function

!==========================================================================
subroutine init_it_ctrl_liquidfraction()
!=========================================================================

if(ctrl_initialized == -1) return

ctrl_initialized = -1

!SET DEFAULT VALUES AND MODES FOR DENSITY ITERATION
ctrl_loop_maximum = 100
ctrl_mode_liquidfraction = 0           !default: minimum temperature is equal to absolute temperature
ctrl_eps_exit_liquidfraction = 0.0001d0  !default = 0.1 mk

end subroutine

!==========================================================================
subroutine set_it_ctrl_liq_ice_air_liquidfraction(key, value)
!=========================================================================

!THIS SUB SETS CONTROL PARAMETERS FOR THE NEWTON ITERATION USED TO COMPUTE
!EQUIVALENT TEMPERATURE FROM REFERENCE PRESSURE

!KEY             VALUE
!IT_STEPS        0           SET ITERATION NUMBER TO DEFAULT (100)
!IT_STEPS        N > 0    SET ITERATION NUMBER TO N
!IT_STEPS       -1           DO NOT ITERATE, USE INITIAL VALUE

!TOL_THETA       0           USE DEFAULT EXIT ACCURACY FOR EQUIVALENT TEMPERATURE (0.1 MK)
!TOL_THETA       EPS > 0  USE EPS AS EXIT ACCURACY FOR EQUIVALENT TEMPERATURE

character*13 key
real*8 value

call init_it_ctrl_liquidfraction

select case (trim(key))

  case ("it_steps");                 !ITERATION STEPS
      if(value == 0d0) then
         ctrl_loop_maximum = 100     !DEFAULT = 100
      elseif(value < 0d0) then
         ctrl_loop_maximum = -1
      else
         ctrl_loop_maximum = nint(value)
      endif

  case ("tol_theta");                !REQUIRED THETA TOLERANCE
      if(value == 0d0) then
         ctrl_eps_exit_liquidfraction = 0.0001d0 !DEFAULT = 0.1 MK
      elseif(value > 0d0) then
         ctrl_eps_exit_liquidfraction = value
      endif

  case default; write(*,*)key,' not supported'

  end select

  end subroutine

!==========================================================================
subroutine swap(a, b)
!==========================================================================

real*8 a, b, c
c = a
a = b
b = c

end subroutine

end module liq_ice_air_5a

module liq_air_4b

!#########################################################################

!THIS MODULE IMPLEMENTS THE GIBBS FUNCTION OF WET AIR, I.E., OF THE COMPOSITE
!SYSTEM OF LIQUID WATER AND HUMID AIR AT MUTUAL EQUILIBRIUM ("CLOUDY AIR")
!THEREFORE, THE HUMID-AIR PROPERTIES COMPUTED HERE REFER TO SATURATED AIR.

!#########################################################################

!IMPLEMENTATION IN FORTRAN BY D.G. WRIGHT
!FOR PUBLICATION IN OCEAN SCIENCE, AS DESCRIBED IN THE PAPERS

!FEISTEL, R., WRIGHT, D.G., JACKETT, D.R., MIYAGAWA, K., REISSMANN, J.H.,
!WAGNER, W., OVERHOFF, U., GUDER, C., FEISTEL, A., MARION, G.M.:
!NUMERICAL IMPLEMENTATION AND OCEANOGRAPHIC APPLICATION OF THE THERMODYNAMIC
!POTENTIALS OF WATER, VAPOUR, ICE, SEAWATER AND AIR. PART I: BACKGROUND AND EQUATIONS. 
!OCEAN SCIENCES, 2009, IN PREPARATION.

!WRIGHT, D.G., FEISTEL, R., JACKETT, D.R., MIYAGAWA, K., REISSMANN, J.H., 
!WAGNER, W., OVERHOFF, U., GUDER, C., FEISTEL, A., MARION, G.M.:
!NUMERICAL IMPLEMENTATION AND OCEANOGRAPHIC APPLICATION OF THE THERMODYNAMIC
!POTENTIALS OF WATER, VAPOUR, ICE, SEAWATER AND AIR. PART II: THE LIBRARY ROUTINES, 
!OCEAN SCIENCES., 2009, IN PREPARATION.

!FEISTEL, R., KRETZSCHMAR, H.-J., SPAN, R., HAGEN, E., WRIGHT, D.G., HERRMANN, S.:
!THERMODYNAMIC PROPERTIES OF SEA AIR.
!OCEAN SCIENCE DISCUSSION 6(2009)2193-2325.

!#########################################################################

!THIS MODULE REQUIRES THE LIBRARY MODULES:
!     CONSTANTS_0,   FILE CONSTANTS_0.F90
!     AIR_3A,        FILE AIR_3A.F90
!     FLU_3A,        FILE FLU_3A.F90
!     LIQ_AIR_4A,    FILE LIQ_AIR_4A.F90

!NESTED USE ASSOCIATIONS
!     CONVERT_0,     FILE CONVERT_0.F90
!     MATHS_0,       FILE MATHS_0.F90
!     AIR_1,         FILE AIR_1.F90
!     FLU_1,         FILE FLU_1.F90
!     FLU_2,         FILE FLU_2.F90
!     AIR_2,         FILE AIR_2.F90
!     AIR_3B,        FILE AIR_3A.F90
!     LIQ_VAP_4,     FILE LIQ_VAP_4.F90

!#########################################################################

use constants_0
use air_3a
use flu_3a
use liq_air_4a

implicit none
private

character*16, private :: version = '8 Jun 2010'

public :: liq_air_g_si, liq_air_g_cp_si, liq_air_g_density_si, &
          liq_air_g_enthalpy_si,  liq_air_g_entropy_si, &
          liq_air_g_expansion_si, liq_air_g_kappa_t_si,  &
          liq_air_g_lapserate_si, liq_air_liquidfraction_si, &
          liq_air_vapourfraction_si

contains

!==========================================================================
function liq_air_g_si(drv_wa, drv_t, drv_p, wa_si, t_si, p_si)
!==========================================================================

!THIS IMPLEMENTS THE GIBBS FUNCTION OF WET AIR COMPUTED FROM ITS HELMHOLTZ FUNCTION
!AND ITS FIRST AND SECOND DERIVATIVES WITH RESPECT TO THE AIR FRACTION WA_SI,
!THE ABSOLUTE TEMPERATURE T_SI AND THE ABSOLUTE PRESSURE P_SI

!NOTE: THIS GIBBS FUNCTION IS NOT DESIGNED FOR LIQUID AIR OR CRITICAL AIR STATES
!NOTE: THE ACCURACY OF THIS FUNCTIONS DEPENDS ON THE ITERATION SETTINGS
!IN AIR_3A TO COMPUTE THE GIBBS FUNCTION OF HUMID AIR AND ON THE SETTINGS
!IN FLU_3A TO COMPUTE THE GIBBS FUNCTION OF LIQUID WATER

!OUTPUT: 
!LIQ_AIR_G = SPECIFIC GIBBS ENERGY IN J/KG OR ITS DERIVATIVE

!G(WA,T,P) = (1-W) * GL(T,P) + W * GH(A(T,P),T,P)

!W =     MASS FRACTION OF HUMID AIR IN WET AIR, W(WA, T, P) = WA/A(T,P)
!(1-W) = LIQUID MASS FRACTION OF WET AIR
!A =     SATURATED AIR MASS FRACTION OF HUMID AIR
!(1-A) = SATURATED SPECIFIC HUMIDITY OF THE HUMID-AIR COMPONENT
!GL =    GIBBS FUNCTION OF LIQUID WATER
!GH =    GIBBS FUNCTION OF HUMID AIR

!INPUTS:
!DRV_WA = ORDER OF THE PARTIAL WA-DERIVATIVE
!DRV_T = ORDER OF THE PARTIAL T-DERIVATIVE
!DRV_P = ORDER OF THE PARTIAL P-DERIVATIVE
!WA_SI = ABSOLUTE AIR FRACTION IN KG/KG, I.E. THE MASS FRACTION OF DRY AIR IN WET AIR
!T_SI  = T = ABSOLUTE TEMPERATURE IN K, ITS-90
!P_SI  = P = ABSOLUTE PRESSURE IN PA

!CHECK VALUES WITH DEFAULT SETTINGS, V1.0:
!LIQ_AIR_G_SI( 0, 0, 0, 0.5, 300, 1E5) =-5397.43216342
!LIQ_AIR_G_SI( 1, 0, 0, 0.5, 300, 1E5) =-264.763415292
!LIQ_AIR_G_SI( 0, 1, 0, 0.5, 300, 1E5) =-343.818233768
!LIQ_AIR_G_SI( 0, 0, 1, 0.5, 300, 1E5) = 0.446835172414
!LIQ_AIR_G_SI( 2, 0, 0, 0.5, 300, 1E5) = 0
!LIQ_AIR_G_SI( 1, 1, 0, 0.5, 300, 1E5) = 98.4884000933
!LIQ_AIR_G_SI( 1, 0, 1, 0.5, 300, 1E5) = 0.891663433710
!LIQ_AIR_G_SI( 0, 2, 0, 0.5, 300, 1E5) =-14.1012539816
!LIQ_AIR_G_SI( 0, 1, 1, 0.5, 300, 1E5) = 2.43241086432E-03
!LIQ_AIR_G_SI( 0, 0, 2, 0.5, 300, 1E5) =-4.62469737987E-06

!CHECK VALUES WITH DEFAULT SETTINGS, V1.1:
!LIQ_AIR_G_SI( 0, 0, 0, 0.5, 300, 1E5) =-5396.77820137
!LIQ_AIR_G_SI( 1, 0, 0, 0.5, 300, 1E5) =-263.45549120|3
!LIQ_AIR_G_SI( 0, 1, 0, 0.5, 300, 1E5) =-343.783393872
!LIQ_AIR_G_SI( 0, 0, 1, 0.5, 300, 1E5) = 0.446729465555
!LIQ_AIR_G_SI( 2, 0, 0, 0.5, 300, 1E5) = 0
!LIQ_AIR_G_SI( 1, 1, 0, 0.5, 300, 1E5) = 98.5580798842
!LIQ_AIR_G_SI( 1, 0, 1, 0.5, 300, 1E5) = 0.891452019991
!LIQ_AIR_G_SI( 0, 2, 0, 0.5, 300, 1E5) =-14.0995955397
!LIQ_AIR_G_SI( 0, 1, 1, 0.5, 300, 1E5) = 2.43183979422E-03
!LIQ_AIR_G_SI( 0, 0, 2, 0.5, 300, 1E5) =-4.62360294023E-06

real*8 liq_air_g_si, wa_si, t_si, p_si
real*8 g, a, w, d
real*8 gh, gl
real*8 gh_p, gl_p
real*8 gh_t, gl_t
real*8 gh_pp, gl_pp, gc_pp
real*8 gh_tp, gl_tp, gc_tp
real*8 gh_tt, gl_tt, gc_tt
real*8 a_p, a_t

integer drv_wa, drv_t, drv_p

liq_air_g_si = errorreturn
d = errorreturn

if(wa_si < 0d0 .or. wa_si > 1d0) return
if(t_si <= 0d0) return
if(p_si <= 0d0) return

if(drv_wa < 0) return
if(drv_t < 0) return
if(drv_p < 0) return
if(drv_wa + drv_t + drv_p > 2) return

if(drv_wa > 1) then                        !G IS LINEAR IN WA_SI
  liq_air_g_si = 0d0
  return
end if

a = liq_air_massfraction_air_si(t_si, p_si)    !SATURATED AIR MASS FRACTION
if(a == errorreturn) return
if(a <= 0d0 .or. a >= 1d0) return

if(a < wa_si) then                         !NO LIQUID FRACTION AT THIS T AND P
                                           !INSTEAD, INVOKE THE GIBBS FUNCTION 
                                           !OF UNSATURATED HUMID AIR
  !liq_air_g_si = air_g_si(drv_wa, drv_t, drv_p, wa_si, t_si, p_si)  !dbg
  return
end if

w = wa_si / a                                 !GASEOUS MASS FRACTION OF WET AIR

if(drv_t + drv_p > 1) then
  d = a**2 * air_g_si(2, 0, 0, a, t_si, p_si) !AIR COEFFICIENT DA = A^2 * G_AA
end if

select case(drv_wa)

  case(0)

    select case(drv_t)

      case(0)     !D/DT

        select case(drv_p)

          case(0) 
            gh = air_g_si(0, 0, 0, a, t_si, p_si)
            if(gh == errorreturn) return
            gl = liq_g_si(0, 0, t_si, p_si)
            if(gl == errorreturn) return
            g = (1d0 - w) * gl + w * gh                      !g

          case(1)
            gh_p = air_g_si(0, 0, 1, a, t_si, p_si)
            if(gh_p == errorreturn) return
            gl_p = liq_g_si(0, 1, t_si, p_si)
            if(gl_p == errorreturn) return
            g = (1d0 - w) * gl_p + w * gh_p                  !V = G_P

          case(2) 
            a_p = liq_air_a_si(0, 1, t_si, p_si)
            if(a_p == errorreturn) return
            gc_pp = -d * a_p**2 / a                          !LATENT CONDENSATION DERIVATIVE
            gh_pp = air_g_si(0, 0, 2, a, t_si, p_si)
            if(gh_pp == errorreturn) return
            gl_pp = liq_g_si(0, 2, t_si, p_si)
            if(gl_pp == errorreturn) return
            g = (1d0 - w) * gl_pp + w * (gh_pp + gc_pp)      !G_PP

          case default; return
        end select

      case(1)     !D/DT

        select case(drv_p)

          case(0)
            gh_t = air_g_si(0, 1, 0, a, t_si, p_si)
            if(gh_t == errorreturn) return
            gl_t = liq_g_si(1, 0, t_si, p_si)
            if(gl_t == errorreturn) return
            g = (1d0 - w) * gl_t + w * gh_t                  !-ETA = G_T

          case(1)
            a_t = liq_air_a_si(1, 0, t_si, p_si)
            if(a_t == errorreturn) return
            a_p = liq_air_a_si(0, 1, t_si, p_si)
            if(a_p == errorreturn) return
            gc_tp = -d * a_t * a_p / a                       !LATENT DERIVATIVE
            gh_tp = air_g_si(0, 1, 1, a, t_si, p_si)
            if(gh_tp == errorreturn) return
            gl_tp = liq_g_si(1, 1, t_si, p_si)
            if(gl_tp == errorreturn) return
            g = (1d0 - w) * gl_tp + w * (gh_tp + gc_tp)      !G_TP

          case default; return
        end select

      case(2)     !D2/DT2

        select case(drv_p)

          case(0)
            a_t = liq_air_a_si(1, 0, t_si, p_si)
            if(a_t == errorreturn) return
            gc_tt = -d * a_t**2 / a                          !LATENT DERIVATIVE
            gh_tt = air_g_si(0, 2, 0, a, t_si, p_si)
            if(gh_tt == errorreturn) return
            gl_tt = liq_g_si(2, 0, t_si, p_si)
            if(gl_tt == errorreturn) return
            g = (1d0 - w) * gl_tt + w * (gh_tt + gc_tt)      !G_TT

          case default; return
        end select

       case default; return
    end select

  case(1)       !g_w, g_wp, g_wt
    gh = air_g_si(0, drv_t, drv_p, a, t_si, p_si)
    if (gh == errorreturn) return
    gl = liq_g_si(drv_t, drv_p, t_si, p_si)
    if (gl == errorreturn) return
    g = (gh - gl) / a

  case(2); g = 0d0
    
  case default; return

end select

liq_air_g_si = g

end function

!=========================================================================
function liq_air_g_cp_si(wa_si, t_si, p_si)
!==========================================================================

!OUTPUT:
!CP(WA,T,P) = T * (D2G/DT2) HEAT CAPACITY OF WET AIR IN J/(KG K)

!INPUT:
!WA_SI     MASS FRACTION OF DRY AIR IN WET AIR IN KG/KG
!T_SI      ABSOLUTE TEMPERATURE IN K
!P_SI      ABSOLUTE PRESSURE IN PA

!CHECK VALUE WITH DEFAULT SETTINGS, V1.0:
!LIQ_AIR_G_CP_SI(0.5, 300, 1E5) = 4230.37619447

!CHECK VALUE WITH DEFAULT SETTINGS, V1.1:
!LIQ_AIR_G_CP_SI(0.5, 300, 1E5) = 4229.87866191

real*8 liq_air_g_cp_si, wa_si, t_si, p_si
real*8 g_tt

liq_air_g_cp_si = errorreturn

if(wa_si < 0d0 .or. wa_si > 1d0) return
if(t_si <= 0d0) return
if(p_si <= 0d0) return

g_tt = liq_air_g_si(0, 2, 0, wa_si, t_si, p_si)
if(g_tt == errorreturn) return

liq_air_g_cp_si = -t_si * g_tt

end function

!=========================================================================
function liq_air_g_density_si(wa_si, t_si, p_si)
!==========================================================================

!OUTPUT:
!D(WA,T,P) = 1/(DG/DP)  DENSITY OF WET AIR IN KG/M3

!INPUT:
!WA_SI     MASS FRACTION OF DRY AIR IN WET AIR IN KG/KG
!T_SI      ABSOLUTE TEMPERATURE IN K
!P_SI      ABSOLUTE PRESSURE IN PA

!CHECK VALUE WITH DEFAULT SETTINGS, V1.0:
!LIQ_AIR_G_DENSITY_SI(0.5, 300, 1E5) = 2.23796169535

!CHECK VALUE WITH DEFAULT SETTINGS, V1.1:
!LIQ_AIR_G_DENSITY_SI(0.5, 300, 1E5) = 2.23849125053

real*8 liq_air_g_density_si, wa_si, t_si, p_si
real*8 g_p

liq_air_g_density_si = errorreturn

if(wa_si < 0d0 .or. wa_si > 1d0) return
if(t_si <= 0d0) return
if(p_si <= 0d0) return

g_p = liq_air_g_si(0, 0, 1, wa_si, t_si, p_si)
if(g_p == errorreturn) return
if(g_p <= 0d0) return

liq_air_g_density_si = 1d0 / g_p

end function

!=========================================================================
function liq_air_g_enthalpy_si(wa_si, t_si, p_si)
!==========================================================================

!OUTPUT:
!H(WA,T,P) = G - T * (DG/DT)  ENTHALPY OF WET AIR IN J/KG

!INPUT:
!WA_SI     MASS FRACTION OF DRY AIR IN WET AIR IN KG/KG
!T_SI      ABSOLUTE TEMPERATURE IN K
!P_SI      ABSOLUTE PRESSURE IN PA

!CHECK VALUE WITH DEFAULT SETTINGS, V1.0:
!LIQ_AIR_G_ENTHALPY_SI(0.5, 300, 1E5) = 97748.0379670

!CHECK VALUE WITH DEFAULT SETTINGS, V1.1:
!LIQ_AIR_G_ENTHALPY_SI(0.5, 300, 1E5) = 97738.2399604

real*8 liq_air_g_enthalpy_si, wa_si, t_si, p_si
real*8 g, g_t

liq_air_g_enthalpy_si = errorreturn

if(wa_si < 0d0 .or. wa_si > 1d0) return
if(t_si <= 0d0) return
if(p_si <= 0d0) return

g = liq_air_g_si(0, 0, 0, wa_si, t_si, p_si)
if(g == errorreturn) return
g_t = liq_air_g_si(0, 1, 0, wa_si, t_si, p_si)
if(g_t == errorreturn) return

liq_air_g_enthalpy_si = g - t_si * g_t

end function

!=========================================================================
function liq_air_g_entropy_si(wa_si, t_si, p_si)
!==========================================================================

!OUTPUT:
!ETA(WA,T,P) = - (DG/DT)  ENTROPY OF WET AIR IN J/(KG K)

!INPUT:
!WA_SI     MASS FRACTION OF DRY AIR IN WET AIR IN KG/KG
!T_SI      ABSOLUTE TEMPERATURE IN K
!P_SI      ABSOLUTE PRESSURE IN PA

!CHECK VALUE WITH DEFAULT SETTINGS, V1.0:
!LIQ_AIR_G_ENTROPY_SI(0.5, 300, 1E5) = 343.818233768

!CHECK VALUE WITH DEFAULT SETTINGS, V1.1:
!LIQ_AIR_G_ENTROPY_SI(0.5, 300, 1E5) = 343.783393872

real*8 liq_air_g_entropy_si, wa_si, t_si, p_si
real*8 g_t

liq_air_g_entropy_si = errorreturn

if(wa_si < 0d0 .or. wa_si > 1d0) return
if(t_si <= 0d0) return
if(p_si <= 0d0) return

g_t = liq_air_g_si(0, 1, 0, wa_si, t_si, p_si)
if(g_t == errorreturn) return

liq_air_g_entropy_si = -g_t

end function

!=========================================================================
function liq_air_g_expansion_si(wa_si, t_si, p_si)
!==========================================================================

!OUTPUT:
!ALPHA(WA,T,P) = (D2G/DTDP)/(DG/DP)  THERMAL EXPANSION OF WET AIR IN 1/K

!INPUT:
!WA_SI     MASS FRACTION OF DRY AIR IN WET AIR IN KG/KG
!T_SI      ABSOLUTE TEMPERATURE IN K
!P_SI      ABSOLUTE PRESSURE IN PA

!CHECK VALUE WITH DEFAULT SETTINGS, V1.0:
!LIQ_AIR_G_EXPANSION_SI(0.5, 300, 1E5) = 5.44364234170E-03

!CHECK VALUE WITH DEFAULT SETTINGS, V1.1:
!LIQ_AIR_G_EXPANSION_SI(0.5, 300, 1E5) = 5.44365210207E-03

real*8 liq_air_g_expansion_si, wa_si, t_si, p_si
real*8 g_p, g_tp

liq_air_g_expansion_si = errorreturn

if(wa_si < 0d0 .or. wa_si > 1d0) return
if(t_si <= 0d0) return
if(p_si <= 0d0) return

g_p = liq_air_g_si(0, 0, 1, wa_si, t_si, p_si)
if(g_p == errorreturn) return
if(g_p <= 0d0) return
g_tp = liq_air_g_si(0, 1, 1, wa_si, t_si, p_si)
if(g_tp == errorreturn) return

liq_air_g_expansion_si = g_tp / g_p

end function

!=========================================================================
function liq_air_g_kappa_t_si(wa_si, t_si, p_si)
!==========================================================================

!OUTPUT:
!KAPPA_T(WA,T,P) = - (D2G/DP2)/(DG/DP)  ISOTHERMAL COMPRESSIBILITY OF WET AIR IN 1/PA

!INPUT:
!WA_SI     MASS FRACTION OF DRY AIR IN WET AIR IN KG/KG
!T_SI      ABSOLUTE TEMPERATURE IN K
!P_SI      ABSOLUTE PRESSURE IN PA

!CHECK VALUE WITH DEFAULT SETTINGS, V1.0:
!LIQ_AIR_G_KAPPA_T_SI(0.5, 300, 1E5) = 1.03498955887E-05

!CHECK VALUE WITH DEFAULT SETTINGS, V1.1:
!LIQ_AIR_G_KAPPA_T_SI(0.5, 300, 1E5) = 1.03498947276E-05

real*8 liq_air_g_kappa_t_si, wa_si, t_si, p_si
real*8 g_p, g_pp

liq_air_g_kappa_t_si = errorreturn

if(wa_si < 0d0 .or. wa_si > 1d0) return
if(t_si <= 0d0) return
if(p_si <= 0d0) return

g_p = liq_air_g_si(0, 0, 1, wa_si, t_si, p_si)
if(g_p == errorreturn) return
if(g_p <= 0d0) return
g_pp = liq_air_g_si(0, 0, 2, wa_si, t_si, p_si)
if(g_pp == errorreturn) return

liq_air_g_kappa_t_si = -g_pp / g_p

end function

!=========================================================================
function liq_air_g_lapserate_si(wa_si, t_si, p_si)
!==========================================================================

!OUTPUT:
!GAMMA(WA,T,P) = - (D2G/DTDP)/(D2G/DT2) "MOIST" ADIABATIC LAPSE RATE OF WET AIR IN K/PA

!INPUT:
!WA_SI     MASS FRACTION OF DRY AIR IN WET AIR IN KG/KG
!T_SI      ABSOLUTE TEMPERATURE IN K
!P_SI      ABSOLUTE PRESSURE IN PA

!CHECK VALUE WITH DEFAULT SETTINGS, V1.0:
!LIQ_AIR_G_LAPSERATE_SI(0.5, 300, 1E5) = 1.72496067902E-04

!CHECK VALUE WITH DEFAULT SETTINGS, V1.1:
!LIQ_AIR_G_LAPSERATE_SI(0.5, 300, 1E5) = 1.72475854884E-04

real*8 liq_air_g_lapserate_si, wa_si, t_si, p_si
real*8 g_tp, g_tt

liq_air_g_lapserate_si = errorreturn

if(wa_si < 0d0 .or. wa_si > 1d0) return
if(t_si <= 0d0) return
if(p_si <= 0d0) return

g_tp = liq_air_g_si(0, 1, 1, wa_si, t_si, p_si)
if(g_tp == errorreturn) return
if(g_tp <= 0d0) return
g_tt = liq_air_g_si(0, 2, 0, wa_si, t_si, p_si)
if(g_tt == errorreturn) return
if(g_tt >= 0d0) return

liq_air_g_lapserate_si = -g_tp / g_tt

end function

!=========================================================================
function liq_air_liquidfraction_si(wa_si, t_si, p_si)
!==========================================================================

!OUTPUT:
!WW = 1 - WA/A(T,P) MASS FRACTION OF LIQUID WATER IN WET AIR (0 < WW < 1)

!INPUT:
!WA_SI     MASS FRACTION OF DRY AIR IN WET AIR IN KG/KG
!T_SI      ABSOLUTE TEMPERATURE IN K
!P_SI      ABSOLUTE PRESSURE IN PA

!CHECK VALUE WITH DEFAULT SETTINGS, V1.0:
!LIQ_AIR_LIQUIDFRACTION_SI(0.5, 300, 1E5) = 0.488543697765

!CHECK VALUE WITH DEFAULT SETTINGS, V1.1:
!LIQ_AIR_LIQUIDFRACTION_SI(0.5, 300, 1E5) = 0.488546404734

real*8 liq_air_liquidfraction_si, wa_si, t_si, p_si
real*8 a

liq_air_liquidfraction_si = errorreturn

if(wa_si < 0d0 .or. wa_si > 1d0) return
if(t_si <= 0d0) return
if(p_si <= 0d0) return

a = liq_air_massfraction_air_si(t_si, p_si)
if(a == errorreturn) return
if(a < wa_si) return

liq_air_liquidfraction_si = 1d0 - wa_si / a

end function

!=========================================================================
function liq_air_vapourfraction_si(wa_si, t_si, p_si)
!==========================================================================

!OUTPUT:
!WV = WA*(1/A(T,P)-1) MASS FRACTION OF VAPOUR IN WET AIR (0 < WV < 1)

!INPUT:
!WA_SI     DRY-AIR MASS FRACTION OF WET AIR IN KG/KG
!T_SI      ABSOLUTE TEMPERATURE IN K
!P_SI      ABSOLUTE PRESSURE IN PA

!CHECK VALUE WITH DEFAULT SETTINGS, V1.0:
!LIQ_AIR_VAPOURFRACTION_SI(0.5, 300, 1E5) = 1.14563022353E-02

!CHECK VALUE WITH DEFAULT SETTINGS, V1.1:
!LIQ_AIR_VAPOURFRACTION_SI(0.5, 300, 1E5) = 1.14535952655E-02

real*8 liq_air_vapourfraction_si, wa_si, t_si, p_si
real*8 a

liq_air_vapourfraction_si = errorreturn

if(wa_si < 0d0 .or. wa_si > 1d0) return
if(t_si <= 0d0) return
if(p_si <= 0d0) return

a = liq_air_massfraction_air_si(t_si, p_si)
if(a == errorreturn) return
if(a < wa_si) return

liq_air_vapourfraction_si = wa_si * (1d0 / a - 1d0)

end function

!=========================================================================
function liq_air_a_si(drv_t, drv_p, t_si, p_si)
!==========================================================================

!THIS FUNCTION RETURNS THE AIR FRACTION A OF SATURATED HUMID AIR IN KG/KG,
!AND ITS PARTIAL DERIVATIVES (D/DT)^DRV_T (D/DP)^DRV_P A(T,P)
!AS A FUNCTION OF ABSOLUTE TEMPERATURE, T_SI, IN K, AND ABSOLUTE PRESSURE, P_SI, IN PA

real*8 liq_air_a_si, t_si, p_si
real*8 d  !da coefficient
real*8 a  !air fraction

real*8 gh_p, gl_p, gh_ap
real*8 gh_t, gl_t, gh_at

integer drv_t, drv_p

liq_air_a_si = errorreturn
d = errorreturn

if(drv_t < 0 .or. drv_t > 1) return
if(drv_p < 0 .or. drv_p > 1) return

if(t_si < 0d0) return
if(p_si < 0d0) return

a = liq_air_massfraction_air_si(t_si, p_si)
if(a == errorreturn) return
if(a < 0d0 .or. a >= 1d0) return

if(drv_t > 0 .or. drv_p > 0) then
  d = a**2 * air_g_si(2, 0, 0, a, t_si, p_si) !air coefficient da = a^2 * g_aa
  if(d == errorreturn) return
  if(d <= 0d0) return
end if

select case(drv_t)

  case(0)

    select case(drv_p)

      case(0)
        liq_air_a_si = a

      case(1)
        gh_p = air_g_si(0, 0, 1, a, t_si, p_si)
        if(gh_p == errorreturn) return
        gh_ap = air_g_si(1, 0, 1, a, t_si, p_si)
        if(gh_ap == errorreturn) return
        gl_p = liq_g_si(0, 1, t_si, p_si)
        if(gl_p == errorreturn) return
        liq_air_a_si = a * (gh_p - gl_p - a * gh_ap) / d

    end select

  case(1)

    select case(drv_p)

      case(0)
        gh_t = air_g_si(0, 1, 0, a, t_si, p_si)
        if(gh_t == errorreturn) return
        gh_at = air_g_si(1, 1, 0, a, t_si, p_si)
        if(gh_at == errorreturn) return
        gl_t = liq_g_si(1, 0, t_si, p_si)
        if(gl_t == errorreturn) return
        liq_air_a_si = a * (gh_t - gl_t - a * gh_at) / d
    
    end select

end select

end function

end module liq_air_4b

module liq_ice_air_4

!#########################################################################

!THIS MODULE IMPLEMENTS THE EQUILIBRIUM PROPERTIES OF WET ICE AIR, 
!I.E., BETWEEN LIQUID WATER, ICE AND HUMID AIR

!#########################################################################

!IMPLEMENTATION IN FORTRAN BY D.G. WRIGHT
!FOR PUBLICATION IN OCEAN SCIENCE, AS DESCRIBED IN THE PAPERS

!FEISTEL, R., WRIGHT, D.G., JACKETT, D.R., MIYAGAWA, K., REISSMANN, J.H.,
!WAGNER, W., OVERHOFF, U., GUDER, C., FEISTEL, A., MARION, G.M.:
!NUMERICAL IMPLEMENTATION AND OCEANOGRAPHIC APPLICATION OF THE THERMODYNAMIC
!POTENTIALS OF WATER, VAPOUR, ICE, SEAWATER AND AIR. PART I: BACKGROUND AND EQUATIONS. 
!OCEAN SCIENCES, 2009, IN PREPARATION.

!WRIGHT, D.G., FEISTEL, R., JACKETT, D.R., MIYAGAWA, K., REISSMANN, J.H., 
!WAGNER, W., OVERHOFF, U., GUDER, C., FEISTEL, A., MARION, G.M.:
!NUMERICAL IMPLEMENTATION AND OCEANOGRAPHIC APPLICATION OF THE THERMODYNAMIC
!POTENTIALS OF WATER, VAPOUR, ICE, SEAWATER AND AIR. PART II: THE LIBRARY ROUTINES, 
!OCEAN SCIENCES., 2009, IN PREPARATION.

!FEISTEL, R., KRETZSCHMAR, H.-J., SPAN, R., HAGEN, E., WRIGHT, D.G., HERRMANN, S.:
!THERMODYNAMIC PROPERTIES OF SEA AIR.
!OCEAN SCIENCE DISCUSSION 6(2009)2193-2325.

!#########################################################################

!THIS MODULE REQUIRES THE LIBRARY MODULES:
!     CONSTANTS_0,  FILE CONSTANTS_0.F90
!     CONVERT_0,    FILE CONVERT_0.F90
!     MATHS_0,      FILE MATHS_0.F90
!     AIR_1,        FILE AIR_1.F90
!     FLU_1,        FILE FLU_1.F90
!     ICE_1,        FILE ICE_1.F90
!     AIR_2,        FILE AIR_2.F90
!     FLU_2,        FILE FLU_2.F90
!     ICE_2,        FILE ICE_2.F90
!     AIR_3B,       FILE AIR_3B.F90
!     ICE_LIQ_4,    FILE ICE_LIQ_4.F90

!NESTED USE ASSOCIATIONS
!     AIR_3A,       FILE AIR_3A.F90

!#########################################################################

use constants_0
use convert_0
use maths_0
use air_1
use flu_1
use ice_1
use air_2
use flu_2
use ice_2
use air_3b
use ice_liq_4

implicit none
private

character*16, private :: version = '8 Jun 2010'

public :: liq_ice_air_airfraction_si, liq_ice_air_density_si, &
          liq_ice_air_dryairfraction_si, liq_ice_air_enthalpy_si, &
          liq_ice_air_entropy_si, liq_ice_air_ifl_si, &
          liq_ice_air_iml_si, liq_ice_air_liquidfraction_si, &
          liq_ice_air_pressure_si, liq_ice_air_solidfraction_si, &
          liq_ice_air_temperature_si, liq_ice_air_vapourfraction_si, &
          set_it_ctrl_liq_ice_air, set_liq_ice_air_eq_at_a, &
          set_liq_ice_air_eq_at_p, set_liq_ice_air_eq_at_t, &
          set_liq_ice_air_eq_at_wa_eta_wt, &
          set_liq_ice_air_eq_at_wa_wl_wi

!CONTROL PARAMETERS OF THE LIQ-ICE-AIR ITERATION
integer ctrl_initialized

integer ctrl_mode_humidity
integer ctrl_mode_temperature
integer ctrl_mode_pressure
integer ctrl_mode_liquid
integer ctrl_mode_air
integer ctrl_loop_maximum

real*8 ctrl_init_a             !initial dry-air fraction of humid air
real*8 ctrl_init_t             !initial temperature
real*8 ctrl_init_p             !initial pressure
real*8 ctrl_init_d_liq         !initial liquid density
real*8 ctrl_init_d_air         !initial humid-air density

real*8 ctrl_eps_exit_t         !temperature exit tolerance
real*8 ctrl_eps_exit_p         !pressure exit tolerance

!PROPERTIES OF THE CURRENT WATER-ICE-HUMID-AIR EQUILIBRIUM STATE
integer equi_liq_ice_air_done  !flag = isok if equilibrium was successfully computed

real*8 equi_liq_ice_air_t      !equilibrium temperature
real*8 equi_liq_ice_air_p      !equilibrium pressure
real*8 equi_liq_ice_air_a      !equilibrium dry-air fraction in humid air
real*8 equi_liq_ice_air_d_liq  !equilibrium density of liquid water at a, t, p
real*8 equi_liq_ice_air_d_air  !equilibrium density of humid air at a, t, p

!IF ONLY A-T-P WAS FIXED BY EQUILIBRIUM SETTING, THE FOLLOWING VALUES MAY REMAIN UNSPECIFIED
real*8 equi_liq_ice_air_wa     !equilibrium dry-air fraction
real*8 equi_liq_ice_air_wt    !equilibrium liquid fraction of the condensed part
real*8 equi_liq_ice_air_eta    !equilibrium entropy

contains

!==========================================================================
function liq_ice_air_airfraction_si()
!==========================================================================

!THIS FUNCTION RETURNS THE FRACTION A IN KG/KG OF DRY AIR IN HUMID AIR
!WHEN WATER + ICE ARE AT EQUILIBRIUM WITH HUMID AIR,
!SET BY A PREVIOUS CALL OF SET_LIQ_ICE_AIR_EQUILIBRIUM_TO_A, ETC

!NOTE: THE ACCURACY OF THIS FUNCTION DEPENDS ON THE ITERATION SETTINGS IN THIS MODULE

!CHECK VALUES WITH DEFAULT SETTINGS, V1.0:
!SET_LIQ_ICE_AIR_EQ_AT_A(0.99)
!LIQ_ICE_AIR_AIRFRACTION_SI = 0.99

!SET_LIQ_ICE_AIR_EQ_AT_P(1E4)
!LIQ_ICE_AIR_AIRFRACTION_SI = 0.961015437341

!SET_LIQ_ICE_AIR_EQ_AT_T(273.155)
!LIQ_ICE_AIR_AIRFRACTION_SI = 0.99436473982|6

!SET_LIQ_ICE_AIR_EQ_AT_WA_ETA_WT(0.99, 0, 0.5)
!LIQ_ICE_AIR_AIRFRACTION_SI = 0.996582564510

!SET_LIQ_ICE_AIR_EQ_AT_WA_WL_WI(.1, .2, .3)
!LIQ_ICE_AIR_AIRFRACTION_SI = 0.2

!CHECK VALUES WITH DEFAULT SETTINGS, V1.1:
!SET_LIQ_ICE_AIR_EQ_AT_A(0.99)
!LIQ_ICE_AIR_AIRFRACTION_SI = 0.99

!SET_LIQ_ICE_AIR_EQ_AT_P(1E4)
!LIQ_ICE_AIR_AIRFRACTION_SI = 0.961024307544

!SET_LIQ_ICE_AIR_EQ_AT_T(273.155)
!LIQ_ICE_AIR_AIRFRACTION_SI = 0.994366063923

!SET_LIQ_ICE_AIR_EQ_AT_WA_ETA_WT(0.99, 0, 0.5)
!LIQ_ICE_AIR_AIRFRACTION_SI = 0.996583352944

!SET_LIQ_ICE_AIR_EQ_AT_WA_WL_WI(.1, .2, .3)
!LIQ_ICE_AIR_AIRFRACTION_SI = 0.2

real*8 liq_ice_air_airfraction_si

liq_ice_air_airfraction_si = errorreturn

if(equi_liq_ice_air_done /= isok) return

liq_ice_air_airfraction_si = equi_liq_ice_air_a

end function

!==========================================================================
function liq_ice_air_density_si()
!==========================================================================

!FUNCTION COMPUTES THE DENSITY OF WET ICE AIR AFTER PREVIOUSLY CALLING
!SET_LIQ_ICE_AIR_EQUILIBRIUM_TO_WA_WL_WI,... ETC

!Note: the accuracy of this function depends on the iteration settings in this module

!CHECK VALUES WITH DEFAULT SETTINGS, V1.0:
!SET_LIQ_ICE_AIR_EQ_AT_A(0.99)
!LIQ_ICE_AIR_DENSITY_SI = 9.99999999E+98

!SET_LIQ_ICE_AIR_EQ_AT_P(1E4)
!LIQ_ICE_AIR_DENSITY_SI = 9.99999999E+98

!SET_LIQ_ICE_AIR_EQ_AT_T(273.155)
!LIQ_ICE_AIR_DENSITY_SI = 9.99999999E+98

!SET_LIQ_ICE_AIR_EQ_AT_WA_ETA_WT(0.99, 0, 0.5)
!LIQ_ICE_AIR_DENSITY_SI = 7.74649959202

!SET_LIQ_ICE_AIR_EQ_AT_WA_WL_WI(.1, .2, .3)
!LIQ_ICE_AIR_DENSITY_SI = 474.974398772

!CHECK VALUES WITH DEFAULT SETTINGS, V1.1:
!SET_LIQ_ICE_AIR_EQ_AT_A(0.99)
!LIQ_ICE_AIR_DENSITY_SI = 9.99999999E+98

!SET_LIQ_ICE_AIR_EQ_AT_P(1E4)
!LIQ_ICE_AIR_DENSITY_SI = 9.99999999E+98

!SET_LIQ_ICE_AIR_EQ_AT_T(273.155)
!LIQ_ICE_AIR_DENSITY_SI = 9.99999999E+98

!SET_LIQ_ICE_AIR_EQ_AT_WA_ETA_WT(0.99, 0, 0.5)
!LIQ_ICE_AIR_DENSITY_SI = 7.74757979404

!SET_LIQ_ICE_AIR_EQ_AT_WA_WL_WI(.1, .2, .3)
!LIQ_ICE_AIR_DENSITY_SI = 474.974398769

real*8 liq_ice_air_density_si
real*8 t, p
real*8 dh, dl, di
real*8 wl, wi

liq_ice_air_density_si = errorreturn

if(equi_liq_ice_air_done /= isok) return

p = liq_ice_air_pressure_si()
if(p == errorreturn) return
t = liq_ice_air_temperature_si()
if(t == errorreturn) return
dh = equi_liq_ice_air_d_air
if(dh == errorreturn) return
dl = equi_liq_ice_air_d_liq
if(dl == errorreturn) return

if(equi_liq_ice_air_wt == errorreturn) return
if(equi_liq_ice_air_wa == errorreturn) return
if(equi_liq_ice_air_a == errorreturn) return
if(equi_liq_ice_air_a == 0d0) then !air-free triple point is not supported here
  return
end if
wl = equi_liq_ice_air_wt * (1d0 - equi_liq_ice_air_wa / equi_liq_ice_air_a)
wi = (1d0 - equi_liq_ice_air_wt) * (1d0 - equi_liq_ice_air_wa / equi_liq_ice_air_a)
di = ice_density_si(t, p)
if(di == errorreturn) return

liq_ice_air_density_si = (1d0 - wi - wl) * dh + wl * dl + wi * di

end function

!==========================================================================
function liq_ice_air_dryairfraction_si()
!==========================================================================

!THIS FUNCTION RETURNS THE FRACTION A OF DRY AIR IN WET ICE AIR IN KG/KG
!WHEN WATER + ICE ARE AT EQUILIBRIUM WITH HUMID AIR,
!SET BY A PREVIOUS CALL OF SET_LIQ_ICE_AIR_EQUILIBRIUM_TO_A, ETC

!NOTE: THE ACCURACY OF THIS FUNCTION DEPENDS ON THE ITERATION SETTINGS IN THIS MODULE

!CHECK VALUES WITH DEFAULT SETTINGS, V1.0 AND V1.1:
!SET_LIQ_ICE_AIR_EQ_AT_A(0.99)
!LIQ_ICE_AIR_DRYAIRFRACTION_SI = 9.99999999E+98
!
!SET_LIQ_ICE_AIR_EQ_AT_P(1E4)
!LIQ_ICE_AIR_DRYAIRFRACTION_SI = 9.99999999E+98
!
!SET_LIQ_ICE_AIR_EQ_AT_T(273.155)
!LIQ_ICE_AIR_DRYAIRFRACTION_SI = 9.99999999E+98
!
!SET_LIQ_ICE_AIR_EQ_AT_WA_ETA_WT(0.99, 0, 0.5)
!LIQ_ICE_AIR_DRYAIRFRACTION_SI = 0.99
!
!SET_LIQ_ICE_AIR_EQ_AT_WA_WL_WI(.1, .2, .3)
!LIQ_ICE_AIR_DRYAIRFRACTION_SI = 0.1

real*8 liq_ice_air_dryairfraction_si

liq_ice_air_dryairfraction_si = errorreturn

if(equi_liq_ice_air_done /= isok) return

liq_ice_air_dryairfraction_si = equi_liq_ice_air_wa

end function

!==========================================================================
function liq_ice_air_enthalpy_si()
!==========================================================================

!FUNCTION COMPUTES THE ENTHALPY OF WET ICE AIR AFTER PREVIOUSLY CALLING
!SET_LIQ_ICE_AIR_EQUILIBRIUM_TO_WA_WL_WI,... ETC

!Note: the accuracy of this function depends on the iteration settings in this module

!CHECK VALUES WITH DEFAULT SETTINGS, V1.0:
!SET_LIQ_ICE_AIR_EQ_AT_A(0.99)
!LIQ_ICE_AIR_ENTHALPY_SI = 9.99999999E+98

!SET_LIQ_ICE_AIR_EQ_AT_P(1E4)
!LIQ_ICE_AIR_ENTHALPY_SI = 9.99999999E+98

!SET_LIQ_ICE_AIR_EQ_AT_T(273.155)
!LIQ_ICE_AIR_ENTHALPY_SI = 9.99999999E+98

!SET_LIQ_ICE_AIR_EQ_AT_WA_ETA_WT(0.99, 0, 0.5)
!LIQ_ICE_AIR_ENTHALPY_SI = 7358.21843392

!SET_LIQ_ICE_AIR_EQ_AT_WA_WL_WI(.1, .2, .3)
!LIQ_ICE_AIR_ENTHALPY_SI = 900361.142094

!CHECK VALUES WITH DEFAULT SETTINGS, V1.1:
!SET_LIQ_ICE_AIR_EQ_AT_A(0.99)
!LIQ_ICE_AIR_ENTHALPY_SI = 9.99999999E+98

!SET_LIQ_ICE_AIR_EQ_AT_P(1E4)
!LIQ_ICE_AIR_ENTHALPY_SI = 9.99999999E+98

!SET_LIQ_ICE_AIR_EQ_AT_T(273.155)
!LIQ_ICE_AIR_ENTHALPY_SI = 9.99999999E+98

!SET_LIQ_ICE_AIR_EQ_AT_WA_ETA_WT(0.99, 0, 0.5)
!LIQ_ICE_AIR_ENTHALPY_SI = 7356.12943724

!SET_LIQ_ICE_AIR_EQ_AT_WA_WL_WI(.1, .2, .3)
!LIQ_ICE_AIR_ENTHALPY_SI = 900361.135280

real*8 liq_ice_air_enthalpy_si

real*8 a, t, p
real*8 dh, dl, wet
real*8 wa, wh, wl, wi
real*8 hh, hl, hi

liq_ice_air_enthalpy_si = errorreturn

if(equi_liq_ice_air_done /= isok) return

if(equi_liq_ice_air_wa == errorreturn .or. &
   equi_liq_ice_air_wt == errorreturn) return

a = equi_liq_ice_air_a
t = equi_liq_ice_air_t
p = equi_liq_ice_air_p
dh = equi_liq_ice_air_d_air
dl = equi_liq_ice_air_d_liq
wa = equi_liq_ice_air_wa
wet = equi_liq_ice_air_wt

if(a == 0d0) return                       !THE AIR-FREE TRIPLE POINT CANNOT BE COMPUTED HERE

wh = wa / a                               !WH IS THE HUMID-AIR FRACTION, 1-WH IS THE CONDENSED FRACTION
if(wh < 0d0 .or. wh > 1d0) return
wl = wet * (1d0 - wh)                     !THE LIQUID FRACTION
if(wl < 0d0 .or. wl > 1d0) return
wi = (1d0 - wet) * (1d0 - wh)             !THE ICE FRACTION
if(wi < 0d0 .or. wi > 1d0) return

hh = air_f_enthalpy_si(a, t, dh)          !ENTHALPY OF HUMID AIR
if(hh == errorreturn) return
hl = flu_enthalpy_si(t, dl)               !ENTHALPY OF LIQUID WATER
if(hl == errorreturn) return
hi = ice_enthalpy_si(t, p)                !ENTHALPY OF ICE
if(hi == errorreturn) return

liq_ice_air_enthalpy_si = wh * hh + wl * hl + wi * hi

end function

!==========================================================================
function liq_ice_air_entropy_si()
!==========================================================================

!FUNCTION COMPUTES THE ENTROPY OF WET ICE AIR AFTER PREVIOUSLY CALLING
!SET_LIQ_ICE_AIR_EQUILIBRIUM_TO_WA_WL_WI,... ETC


!NOTE: THE ACCURACY OF THIS FUNCTION DEPENDS ON THE ITERATION SETTINGS IN THIS MODULE

!CHECK VALUES WITH DEFAULT SETTINGS, V1.0:
!SET_LIQ_ICE_AIR_EQ_AT_A(0.99)
!LIQ_ICE_AIR_ENTROPY_SI = 9.99999999e+98

!SET_LIQ_ICE_AIR_EQ_AT_P(1E4)
!LIQ_ICE_AIR_ENTROPY_SI = 9.99999999E+98

!SET_LIQ_ICE_AIR_EQ_AT_T(273.155)
!LIQ_ICE_AIR_ENTROPY_SI = 9.99999999E+98

!SET_LIQ_ICE_AIR_EQ_AT_WA_ETA_WT(0.99, 0, 0.5)
!LIQ_ICE_AIR_ENTROPY_SI = 0

!SET_LIQ_ICE_AIR_EQ_AT_WA_WL_WI(.1, .2, .3)
!LIQ_ICE_AIR_ENTROPY_SI = 3496.20368786

!CHECK VALUES WITH DEFAULT SETTINGS, V1.1:
!SET_LIQ_ICE_AIR_EQ_AT_A(0.99)
!LIQ_ICE_AIR_ENTROPY_SI = 9.99999999e+98

!SET_LIQ_ICE_AIR_EQ_AT_P(1E4)
!LIQ_ICE_AIR_ENTROPY_SI = 9.99999999E+98

!SET_LIQ_ICE_AIR_EQ_AT_T(273.155)
!LIQ_ICE_AIR_ENTROPY_SI = 9.99999999E+98

!SET_LIQ_ICE_AIR_EQ_AT_WA_ETA_WT(0.99, 0, 0.5)
!LIQ_ICE_AIR_ENTROPY_SI = 0

!SET_LIQ_ICE_AIR_EQ_AT_WA_WL_WI(.1, .2, .3)
!LIQ_ICE_AIR_ENTROPY_SI = 3496.16306903

real*8 liq_ice_air_entropy_si

liq_ice_air_entropy_si = errorreturn

if(equi_liq_ice_air_done /= isok) return

liq_ice_air_entropy_si = equi_liq_ice_air_eta

end function

!==========================================================================
function liq_ice_air_ifl_si(wa_si, eta_si)
!==========================================================================

!THIS FUNCTION COMPUTES THE ISENTROPIC FREEZING LEVEL (IFL) IN PA
!FROM THE DRY-AIR FRACTION, WA_SI IN KG/KG, AND THE ENTROPY, ETA_SI IN J/(KG K)
!OF WET AIR

!Note: the accuracy of this function depends on the iteration settings in this module

!CHECK VALUE WITH DEFAULT SETTINGS, V1.0:
!LIQ_ICE_AIR_IFL_SI(.99, 100) = 83240.7163330

!CHECK VALUE WITH DEFAULT SETTINGS, V1.1:
!LIQ_ICE_AIR_IFL_SI(.99, 100) = 83234.7314360

real*8 liq_ice_air_ifl_si, wa_si, eta_si

liq_ice_air_ifl_si = errorreturn

if(set_liq_ice_air_eq_at_wa_eta_wt(wa_si, eta_si, 1d0) == errorreturn) return

liq_ice_air_ifl_si = equi_liq_ice_air_p

end function

!==========================================================================
function liq_ice_air_iml_si(wa_si, eta_si)
!==========================================================================

!THIS FUNCTION COMPUTES THE ISENTROPIC MELTING LEVEL (IML) IN PA
!FROM THE DRY-AIR FRACTION, WA_SI IN KG/KG, AND THE ENTROPY, ETA_SI IN J/(KG K)
!OF ICE AIR

!Note: the accuracy of this function depends on the iteration settings in this module

!CHECK VALUE WITH DEFAULT SETTINGS, V1.0:
!LIQ_ICE_AIR_IML_SI(.99, 100) = 81612.0101048

!CHECK VALUE WITH DEFAULT SETTINGS, V1.1:
!LIQ_ICE_AIR_IML_SI(.99, 100) = 81605.5557728

real*8 liq_ice_air_iml_si, wa_si, eta_si

liq_ice_air_iml_si = errorreturn

if(set_liq_ice_air_eq_at_wa_eta_wt(wa_si, eta_si, 0d0) == errorreturn) return

liq_ice_air_iml_si = equi_liq_ice_air_p

end function

!==========================================================================
function liq_ice_air_liquidfraction_si()
!==========================================================================

!THIS FUNCTION RETURNS THE FRACTION OF LIQUID WATER IN WET ICE AIR IN KG/KG
!WHEN WATER + ICE ARE AT EQUILIBRIUM WITH HUMID AIR,
!SET BY A PREVIOUS CALL OF SET_LIQ_ICE_AIR_EQUILIBRIUM_TO_WA_ETA_WT, ETC

!CHECK VALUES WITH DEFAULT SETTINGS, V1.0:
!SET_LIQ_ICE_AIR_EQ_AT_A(0.99)
!LIQ_ICE_AIR_LIQUIDFRACTION_SI = 9.99999999E+98

!SET_LIQ_ICE_AIR_EQ_AT_P(1E4)
!LIQ_ICE_AIR_LIQUIDFRACTION_SI = 9.99999999E+98

!SET_LIQ_ICE_AIR_EQ_AT_T(273.155)
!LIQ_ICE_AIR_LIQUIDFRACTION_SI = 9.99999999E+98

!SET_LIQ_ICE_AIR_EQ_AT_WA_ETA_WT(0.99, 0, 0.5)
!LIQ_ICE_AIR_LIQUIDFRACTION_SI = 3.30256857013E-03

!CHECK VALUES WITH DEFAULT SETTINGS, V1.1:
!SET_LIQ_ICE_AIR_EQ_AT_A(0.99)
!LIQ_ICE_AIR_LIQUIDFRACTION_SI = 9.99999999E+98

!SET_LIQ_ICE_AIR_EQ_AT_P(1E4)
!LIQ_ICE_AIR_LIQUIDFRACTION_SI = 9.99999999E+98

!SET_LIQ_ICE_AIR_EQ_AT_T(273.155)
!LIQ_ICE_AIR_LIQUIDFRACTION_SI = 9.99999999E+98

!SET_LIQ_ICE_AIR_EQ_AT_WA_ETA_WT(0.99, 0, 0.5)
!LIQ_ICE_AIR_LIQUIDFRACTION_SI = 3.30296152581E-03

!SET_LIQ_ICE_AIR_EQ_AT_WA_WL_WI(.1, .2, .3)
!LIQ_ICE_AIR_LIQUIDFRACTION_SI = 0.2

!NOTE: THE ACCURACY OF THIS FUNCTION DEPENDS ON THE ITERATION SETTINGS IN THIS MODULE

real*8 liq_ice_air_liquidfraction_si

liq_ice_air_liquidfraction_si = errorreturn

if(equi_liq_ice_air_done /= isok) return
if(equi_liq_ice_air_wa == errorreturn .or. &
  equi_liq_ice_air_wt == errorreturn) return
if(equi_liq_ice_air_a == 0d0) return

liq_ice_air_liquidfraction_si = equi_liq_ice_air_wt &
  * (1d0 - equi_liq_ice_air_wa / equi_liq_ice_air_a)

end function

!==========================================================================
function liq_ice_air_pressure_si()
!==========================================================================

!THIS FUNCTION RETURNS THE PRESSURE IN PA OF WATER + ICE AT EQUILIBRIUM WITH HUMID AIR,
!SET BY A PREVIOUS CALL OF SET_LIQ_ICE_AIR_EQUILIBRIUM_TO_A, ETC

!NOTE: THE ACCURACY OF THIS FUNCTION DEPENDS ON THE ITERATION SETTINGS IN THIS MODULE

!CHECK VALUES WITH DEFAULT SETTINGS, V1.0:
!SET_LIQ_ICE_AIR_EQ_AT_A(0.99)
!LIQ_ICE_AIR_PRESSURE_SI = 38347.8983147

!SET_LIQ_ICE_AIR_EQ_AT_P(1E4)
!LIQ_ICE_AIR_PRESSURE_SI = 10000

!SET_LIQ_ICE_AIR_EQ_AT_T(273.155)
!LIQ_ICE_AIR_PRESSURE_SI = 67931.6010|764

!SET_LIQ_ICE_AIR_EQ_AT_WA_ETA_WT(0.99, 0, 0.5)
!LIQ_ICE_AIR_PRESSURE_SI = 112016.572992

!SET_LIQ_ICE_AIR_EQ_AT_WA_WL_WI(.1, .2, .3)
!LIQ_ICE_AIR_PRESSURE_SI = 706.839968365

!CHECK VALUES WITH DEFAULT SETTINGS, V1.1:
!SET_LIQ_ICE_AIR_EQ_AT_A(0.99)
!LIQ_ICE_AIR_PRESSURE_SI = 38338.9622424

!SET_LIQ_ICE_AIR_EQ_AT_P(1E4)
!LIQ_ICE_AIR_PRESSURE_SI = 10000

!SET_LIQ_ICE_AIR_EQ_AT_T(273.155)
!LIQ_ICE_AIR_PRESSURE_SI = 67931.6010|764

!SET_LIQ_ICE_AIR_EQ_AT_WA_ETA_WT(0.99, 0, 0.5)
!LIQ_ICE_AIR_PRESSURE_SI = 112016.075795

!SET_LIQ_ICE_AIR_EQ_AT_WA_WL_WI(.1, .2, .3)
!LIQ_ICE_AIR_PRESSURE_SI = 706.817425301

real*8 liq_ice_air_pressure_si

liq_ice_air_pressure_si = errorreturn

if(equi_liq_ice_air_done /= isok) return

liq_ice_air_pressure_si = equi_liq_ice_air_p

end function

!==========================================================================
function liq_ice_air_solidfraction_si()
!==========================================================================

!THIS FUNCTION RETURNS THE FRACTION OF ICE IN WET ICE AIR IN KG/KG
!WHEN WATER + ICE ARE AT EQUILIBRIUM WITH HUMID AIR,
!SET BY A PREVIOUS CALL OF SET_LIQ_ICE_AIR_EQUILIBRIUM_TO_WA_ETA_WT, ETC

!CHECK VALUES WITH DEFAULT SETTINGS, V1.0:
!SET_LIQ_ICE_AIR_EQ_AT_A(0.99)
!LIQ_ICE_AIR_SOLIDFRACTION_SI = 9.99999999E+98
!
!SET_LIQ_ICE_AIR_EQ_AT_P(1E4)
!LIQ_ICE_AIR_SOLIDFRACTION_SI = 9.99999999E+98
!
!SET_LIQ_ICE_AIR_EQ_AT_T(273.155)
!LIQ_ICE_AIR_SOLIDFRACTION_SI = 9.99999999E+98
!
!SET_LIQ_ICE_AIR_EQ_AT_WA_ETA_WT((0.99, 0, 0.5)
!LIQ_ICE_AIR_SOLIDFRACTION_SI = 3.30256857013E-03
!
!SET_LIQ_ICE_AIR_EQ_AT_WA_WL_WI(.1, .2, .3)
!LIQ_ICE_AIR_SOLIDFRACTION_SI = 0.3

!CHECK VALUES WITH DEFAULT SETTINGS, V1.1:
!SET_LIQ_ICE_AIR_EQ_AT_A(0.99)
!LIQ_ICE_AIR_SOLIDFRACTION_SI = 9.99999999E+98
!
!SET_LIQ_ICE_AIR_EQ_AT_P(1E4)
!LIQ_ICE_AIR_SOLIDFRACTION_SI = 9.99999999E+98
!
!SET_LIQ_ICE_AIR_EQ_AT_T(273.155)
!LIQ_ICE_AIR_SOLIDFRACTION_SI = 9.99999999E+98
!
!SET_LIQ_ICE_AIR_EQ_AT_WA_ETA_WT((0.99, 0, 0.5)
!LIQ_ICE_AIR_SOLIDFRACTION_SI = 3.30296152581E-03
!
!SET_LIQ_ICE_AIR_EQ_AT_WA_WL_WI(.1, .2, .3)
!LIQ_ICE_AIR_SOLIDFRACTION_SI = 0.3

!NOTE: THE ACCURACY OF THIS FUNCTION DEPENDS ON THE ITERATION SETTINGS IN THIS MODULE

real*8 liq_ice_air_solidfraction_si

liq_ice_air_solidfraction_si = errorreturn

if(equi_liq_ice_air_done /= isok) return
if(equi_liq_ice_air_wa == errorreturn .or. &
  equi_liq_ice_air_wt == errorreturn) return
if(equi_liq_ice_air_a == 0d0) return

liq_ice_air_solidfraction_si = (1d0 - equi_liq_ice_air_wt) &
  * (1d0 - equi_liq_ice_air_wa / equi_liq_ice_air_a)

end function

!==========================================================================
function liq_ice_air_temperature_si()
!==========================================================================

!THIS FUNCTION RETURNS THE TEMPERATURE IN K OF WATER + ICE AT EQUILIBRIUM WITH HUMID AIR,
!SET BY A PREVIOUS CALL OF SET_LIQ_ICE_AIR_EQUILIBRIUM_TO_A, ETC

!CHECK VALUES WITH DEFAULT SETTINGS, V1.0:
!SET_LIQ_ICE_AIR_EQ_AT_A(0.99)
!LIQ_ICE_AIR_TEMPERATURE_SI = 273.157197424

!SET_LIQ_ICE_AIR_EQ_AT_P(1E4)
!LIQ_ICE_AIR_TEMPERATURE_SI = 273.159302793

!SET_LIQ_ICE_AIR_EQ_AT_T(273.155)
!LIQ_ICE_AIR_TEMPERATURE_SI = 273.155

!SET_LIQ_ICE_AIR_EQ_AT_WA_ETA_WT(0.99, 0, 0.5)
!LIQ_ICE_AIR_TEMPERATURE_SI = 273.151724933

!SET_LIQ_ICE_AIR_EQ_AT_WA_WL_WI(.1, .2, .3)
!LIQ_ICE_AIR_TEMPERATURE_SI = 273.159992931

!CHECK VALUES WITH DEFAULT SETTINGS, V1.1:
!SET_LIQ_ICE_AIR_EQ_AT_A(0.99)
!LIQ_ICE_AIR_TEMPERATURE_SI = 273.157198087

!SET_LIQ_ICE_AIR_EQ_AT_P(1E4)
!LIQ_ICE_AIR_TEMPERATURE_SI = 273.159302793

!SET_LIQ_ICE_AIR_EQ_AT_T(273.155)
!LIQ_ICE_AIR_TEMPERATURE_SI = 273.155

!SET_LIQ_ICE_AIR_EQ_AT_WA_ETA_WT(0.99, 0, 0.5)
!LIQ_ICE_AIR_TEMPERATURE_SI = 273.151724970

!SET_LIQ_ICE_AIR_EQ_AT_WA_WL_WI(.1, .2, .3)
!LIQ_ICE_AIR_TEMPERATURE_SI = 273.159992933

!NOTE: THE ACCURACY OF THIS FUNCTION DEPENDS ON THE ITERATION SETTINGS IN THIS MODULE

real*8 liq_ice_air_temperature_si

liq_ice_air_temperature_si = errorreturn

if(equi_liq_ice_air_done /= isok) return

liq_ice_air_temperature_si = equi_liq_ice_air_t

end function

!==========================================================================
function liq_ice_air_vapourfraction_si()
!==========================================================================

!THIS FUNCTION RETURNS THE FRACTION OF VAPOUR IN WET ICE AIR IN KG/KG
!WHEN WATER + ICE ARE AT EQUILIBRIUM WITH HUMID AIR,
!SET BY A PREVIOUS CALL OF SET_LIQ_ICE_AIR_EQUILIBRIUM_TO_WA_ETA_WT, ETC

!CHECK VALUES WITH DEFAULT SETTINGS, V1.0:
!SET_LIQ_ICE_AIR_EQ_AT_A(0.99)
!LIQ_ICE_AIR_VAPOURFRACTION_SI = 9.99999999E+98

!SET_LIQ_ICE_AIR_EQ_AT_P(1E4)
!LIQ_ICE_AIR_VAPOURFRACTION_SI = 9.99999999E+98

!SET_LIQ_ICE_AIR_EQ_AT_T(273.155)
!LIQ_ICE_AIR_VAPOURFRACTION_SI = 9.99999999E+98

!SET_LIQ_ICE_AIR_EQ_AT_WA_ETA_WT(0.99, 0, 0.5)
!LIQ_ICE_AIR_VAPOURFRACTION_SI = 3.39486285975E-03

!SET_LIQ_ICE_AIR_EQ_AT_WA_WL_WI(.1, .2, .3)
!LIQ_ICE_AIR_VAPOURFRACTION_SI = 0.4

!CHECK VALUES WITH DEFAULT SETTINGS, V1.1:
!SET_LIQ_ICE_AIR_EQ_AT_A(0.99)
!LIQ_ICE_AIR_VAPOURFRACTION_SI = 9.99999999E+98

!SET_LIQ_ICE_AIR_EQ_AT_P(1E4)
!LIQ_ICE_AIR_VAPOURFRACTION_SI = 9.99999999E+98

!SET_LIQ_ICE_AIR_EQ_AT_T(273.155)
!LIQ_ICE_AIR_VAPOURFRACTION_SI = 9.99999999E+98

!SET_LIQ_ICE_AIR_EQ_AT_WA_ETA_WT(0.99, 0, 0.5)
!LIQ_ICE_AIR_VAPOURFRACTION_SI = 3.39407694837E-03

!SET_LIQ_ICE_AIR_EQ_AT_WA_WL_WI(.1, .2, .3)
!LIQ_ICE_AIR_VAPOURFRACTION_SI = 0.4

!NOTE: THE ACCURACY OF THIS FUNCTION DEPENDS ON THE ITERATION SETTINGS IN THIS MODULE

real*8 liq_ice_air_vapourfraction_si

liq_ice_air_vapourfraction_si = errorreturn

if(equi_liq_ice_air_done /= isok) return
if(equi_liq_ice_air_wa == errorreturn .or. &
  equi_liq_ice_air_wt == errorreturn) return
if(equi_liq_ice_air_a == 0d0) return

liq_ice_air_vapourfraction_si = equi_liq_ice_air_wa * (1d0 / equi_liq_ice_air_a - 1d0)

end function

!==========================================================================
function set_liq_ice_air_eq_at_a(a_si)
!==========================================================================

!THIS FUNCTION COMPUTES THE WATER-ICE-HUMID-AIR EQUILIBRIUM AT GIVEN DRY-AIR FRACTION
!IN HUMID AIR BY NEWTON ITERATION

real*8 set_liq_ice_air_eq_at_a, a_si
real*8 tt, pt, dt_liq, dt_vap

real*8 t, p, dl, dh, eps
real*8 wa, wet, eta
integer maxit

tt = tp_temperature_si
pt = tp_pressure_iapws95_si
dt_liq = tp_density_liq_iapws95_si  !triple point density of liquid water
dt_vap = tp_density_vap_iapws95_si  !triple point density of water vapour

if(equi_liq_ice_air_done == isok .and. &
  a_si == equi_liq_ice_air_a) then
 !the requested state has already been computed earlier
 set_liq_ice_air_eq_at_a = isok
 return
end if

call clear_liq_ice_air_state !waste any previous state

set_liq_ice_air_eq_at_a = errorreturn

if(a_si < 0d0) return
if(a_si >= 1d0) return

!AT THIS EQUILIBRIUM, THE MASS FRACTIONS OF DRY AIR, WA, LIQUID, WET,
!AND ENTROPY ETA ARE STILL AMBIGUOUS AND MUST BE SPECIFIED BY ADDITIONAL CONSTRAINTS
wa = errorreturn
wet = errorreturn
eta = errorreturn

if(a_si == 0d0) then  !pure water: set iapws-95 triple point
  call set_liq_ice_air_state(a_si, tt, pt, dt_vap, dt_liq, wa, wet, eta)
  set_liq_ice_air_eq_at_a = isok
  return
end if

call init_it_ctrl_liq_ice_air

!SET INITIAL TEMPERATURE GUESS
select case(ctrl_mode_temperature)
  case(0);  t = tt
  case(-1); t = tt
  case(1);  t = ctrl_init_t
  case default; return
end select
if(t <= 0d0) return
if(t == errorreturn) return

!SET INITIAL PRESSURE GUESS
select case(ctrl_mode_pressure)
  case(0);  p = aux_pressure_si(a_si)
  case(-1); p = pt
  case(1);  p = ctrl_init_p
  case default; return
end select
if(p <= 0d0) return
if(p == errorreturn) return

!SET INITIAL LIQUID DENSITY GUESS
select case(ctrl_mode_liquid)
  case(0);  dl = dt_liq
  case(-1); dl = dt_liq
  case(1);  dl = ctrl_init_d_liq
  case default; return
end select
if(dl <= 0d0) return
if(dl == errorreturn) return

!SET INITIAL HUMID-AIR DENSITY GUESS
select case(ctrl_mode_air)
  case(0);  dh = air_g_density_si(a_si, t, p)
  case(-1); dh = dt_vap
  case(1);  dh = ctrl_init_d_air
  case default; return
end select
if(dh <= 0d0) return
if(dh == errorreturn) return

!SET MAX. ITERATION NUMBER
  if(ctrl_loop_maximum == 0) then
    maxit = 100
  elseif(ctrl_loop_maximum == (-1)) then
    call set_liq_ice_air_state(a_si, t, p, dh, dl, wa, wet, eta)
    set_liq_ice_air_eq_at_a = isok
    return
  elseif(ctrl_loop_maximum > 0) then
    maxit = ctrl_loop_maximum
  else
    return
  endif

!SET ITERATION ACCURACY LIMIT
eps = ctrl_eps_exit_p
if(eps == 0d0) return

!RUN ITERATION LOOP
if(liq_ice_air_iter_at_a(a_si, maxit, eps, t, p, dh, dl) == errorreturn) then
  return
end if

call set_liq_ice_air_state(a_si, t, p, dh, dl, wa, wet, eta)

set_liq_ice_air_eq_at_a = isok

end function

!==========================================================================
function set_liq_ice_air_eq_at_p(p_si)
!==========================================================================

!THIS FUNCTION COMPUTES THE WATER-ICE-HUMID-AIR EQUILIBRIUM AT GIVEN PRESSURE
! BY NEWTON ITERATION

real*8 set_liq_ice_air_eq_at_p, p_si
real*8 tt, pt, dt_liq, dt_vap

real*8 t, a, dl, dh, eps
real*8 wa, wet, eta
integer maxit

tt = tp_temperature_si
pt = tp_pressure_iapws95_si
dt_liq = tp_density_liq_iapws95_si  !triple point density of liquid water
dt_vap = tp_density_vap_iapws95_si  !triple point density of water vapour

if(equi_liq_ice_air_done == isok .and. &
  p_si == equi_liq_ice_air_p) then
  !the requested state has already been computed earlier
  set_liq_ice_air_eq_at_p = isok
  return
end if

call clear_liq_ice_air_state !waste any previous state

set_liq_ice_air_eq_at_p = errorreturn

if(p_si < pt) return

!AT THIS EQUILIBRIUM, THE MASS FRACTIONS OF DRY AIR, WA, LIQUID, WET,
!AND ENTROPY ETA ARE STILL AMBIGUOUS AND MUST BE SPECIFIED BY ADDITIONAL CONSTRAINTS
wa = errorreturn
wet = errorreturn
eta = errorreturn

if(p_si == pt) then  !pure water: set iapws-95 triple point
  call set_liq_ice_air_state(0d0, tt, pt, dt_vap, dt_liq, wa, wet, eta)
  set_liq_ice_air_eq_at_p = isok
  return
end if

call init_it_ctrl_liq_ice_air

!SET INITIAL TEMPERATURE GUESS
select case(ctrl_mode_temperature)
  case(0);  t = tt
  case(-1); t = tt
  case(1);  t = ctrl_init_t
  case default; return
end select
if(t <= 0d0) return
if(t == errorreturn) return

a = air_massfraction_air_si(1d0 - pt / p_si)
if(a == errorreturn) return

!SET INITIAL LIQUID DENSITY GUESS
select case(ctrl_mode_liquid)
  case(0);  dl = dt_liq
  case(-1); dl = dt_liq
  case(1);  dl = ctrl_init_d_liq
  case default; return
end select
if(dl <= 0d0) return
if(dl == errorreturn) return

!SET INITIAL HUMID-AIR DENSITY GUESS
select case(ctrl_mode_air)
  case(0);  dh = air_g_density_si(a, t, p_si)
  case(-1); dh = dt_vap
  case(1);  dh = ctrl_init_d_air
  case default; return
end select
if(dh <= 0d0) return
if(dh == errorreturn) return

!SET MAX. ITERATION NUMBER
if(ctrl_loop_maximum == 0) then
  maxit = 100
elseif(ctrl_loop_maximum == (-1)) then
  call set_liq_ice_air_state(a, t, p_si, dh, dl, wa, wet, eta)
  set_liq_ice_air_eq_at_p = isok
  return
elseif(ctrl_loop_maximum > 0) then
  maxit = ctrl_loop_maximum
else
  return
endif

!SET ITERATION ACCURACY LIMIT
eps = ctrl_eps_exit_p
if(eps == 0d0) return

!RUN ITERATION LOOP
if(liq_ice_air_iter_at_p(p_si, maxit, eps, a, t, dh, dl) == errorreturn) then
  return
end if

call set_liq_ice_air_state(a, t, p_si, dh, dl, wa, wet, eta)

set_liq_ice_air_eq_at_p = isok

end function

!==========================================================================
function set_liq_ice_air_eq_at_t(t_si)
!==========================================================================

!THIS FUNCTION COMPUTES THE WATER-ICE-HUMID-AIR EQUILIBRIUM AT GIVEN TEMPERATURE
!BY NEWTON ITERATION

real*8 set_liq_ice_air_eq_at_t, t_si
real*8 tt, pt, dt_liq, dt_vap
real*8 p, a, dl, dh, eps
real*8 wa, wet, eta
integer maxit

tt = tp_temperature_si
pt = tp_pressure_iapws95_si
dt_liq = tp_density_liq_iapws95_si  !triple point density of liquid water
dt_vap = tp_density_vap_iapws95_si  !triple point density of water vapour

if(equi_liq_ice_air_done == isok .and. &
  t_si == equi_liq_ice_air_t) then
  !the requested state has already been computed earlier
  set_liq_ice_air_eq_at_t = isok
  return
end if

call clear_liq_ice_air_state !waste any previous state

set_liq_ice_air_eq_at_t = errorreturn

if(t_si > tt) return

!AT THIS EQUILIBRIUM, THE MASS FRACTIONS OF DRY AIR, WA, LIQUID, WET,
!AND ENTROPY ETA ARE STILL AMBIGUOUS AND MUST BE SPECIFIED BY ADDITIONAL CONSTRAINTS
wa = errorreturn
wet = errorreturn
eta = errorreturn

if(t_si == tt) then  !pure water: set iapws-95 triple point
  call set_liq_ice_air_state(0d0, tt, pt, dt_vap, dt_liq, wa, wet, eta)
  set_liq_ice_air_eq_at_t = isok
  return
end if

call init_it_ctrl_liq_ice_air

!SET INITIAL PRESSURE GUESS
select case(ctrl_mode_pressure)
  case(0);  p = ice_liq_meltingpressure_si(t_si)
  case(-1); p = pt
  case(1);  p = ctrl_init_p
  case default; return
end select
if(p <= 0d0) return
if(p == errorreturn) return

a = air_massfraction_air_si(1d0 - pt / p)
if(a == errorreturn) return

!SET INITIAL LIQUID DENSITY GUESS
select case(ctrl_mode_liquid)
  case(0);  dl = dt_liq
  case(-1); dl = dt_liq
  case(1);  dl = ctrl_init_d_liq
  case default; return
end select
if(dl <= 0d0) return
if(dl == errorreturn) return

!SET INITIAL HUMID-AIR DENSITY GUESS
select case(ctrl_mode_air)
  case(0);  dh = air_g_density_si(a, t_si, p)
  case(-1); dh = dt_vap
  case(1);  dh = ctrl_init_d_air
  case default; return
end select
if(dh <= 0d0) return
if(dh == errorreturn) return

!SET MAX. ITERATION NUMBER
  if(ctrl_loop_maximum == 0) then
    maxit = 100
  elseif(ctrl_loop_maximum == (-1)) then
    call set_liq_ice_air_state(a, t_si, p, dh, dl, wa, wet, eta)
    set_liq_ice_air_eq_at_t = isok
    return
  elseif(ctrl_loop_maximum > 0) then
    maxit = ctrl_loop_maximum
  else
    return
  endif

!SET ITERATION ACCURACY LIMIT
eps = ctrl_eps_exit_p
if(eps == 0d0) return

!RUN ITERATION LOOP
if(liq_ice_air_iter_at_t(t_si, maxit, eps, a, p, dh, dl) == errorreturn) then
  return
end if

call set_liq_ice_air_state(a, t_si, p, dh, dl, wa, wet, eta)

set_liq_ice_air_eq_at_t = isok

end function

!==========================================================================
function set_liq_ice_air_eq_at_wa_eta_wt(wa_si, eta_si, wet_si)
!==========================================================================

!THIS FUNCTION COMPUTES THE WATER-ICE-HUMID-AIR EQUILIBRIUM AT GIVEN AIR FRACTION WA_SI,
!ENTROPY ETA_SI, AND THE LIQUID FRACTION, WET_SI, OF THE CONDENSED PART BY NEWTON ITERATION.
!IN PARTICULAR, AT WET_SI = 0, THE ISENTROPIC MELTING LEVEL IML IS COMPUTED,
!AND AT WET_SI = 1, THE ISENTROPIC FREEZING LEVEL IFL

real*8 set_liq_ice_air_eq_at_wa_eta_wt, wa_si, eta_si, wet_si
real*8 tt, pt, dt_liq, dt_vap
real*8 a, t, p, dl, dh, eps
integer maxit

tt = tp_temperature_si
pt = tp_pressure_iapws95_si
dt_liq = tp_density_liq_iapws95_si  !TRIPLE POINT DENSITY OF LIQUID WATER
dt_vap = tp_density_vap_iapws95_si  !TRIPLE POINT DENSITY OF WATER VAPOUR

if(equi_liq_ice_air_done == isok .and. &
  wa_si == equi_liq_ice_air_wa .and. &
  eta_si == equi_liq_ice_air_eta .and. &
  wet_si == equi_liq_ice_air_wt) then
  !the requested state has already been computed earlier
  set_liq_ice_air_eq_at_wa_eta_wt = isok
  return
end if

call clear_liq_ice_air_state !waste any previous state

set_liq_ice_air_eq_at_wa_eta_wt = errorreturn

if(wa_si < 0d0 .or. wa_si > 1d0) return

if(wa_si == 0d0) then               !PURE WATER: SET IAPWS-95 TRIPLE POINT
  call set_liq_ice_air_state(0d0, tt, pt, dt_vap, dt_liq, wa_si, wet_si, eta_si)
  set_liq_ice_air_eq_at_wa_eta_wt = isok
  return
end if

call init_it_ctrl_liq_ice_air

!SET INITIAL MASS FRACTIONS GUESS
select case(ctrl_mode_humidity)
  case(0);  a = aux_airfraction_si(wa_si)
  case(-1); a = 0.999
  case(1);  a = ctrl_init_a
  case default; return
end select
if(a < 0d0 .or. a > 1d0) return
if(a == errorreturn) return

!SET INITIAL TEMPERATURE GUESS
select case(ctrl_mode_temperature)
  case(0);  t = tt
  case(-1); t = tt
  case(1);  t = ctrl_init_t
  case default; return
end select
if(t <= 0d0) return
if(t == errorreturn) return

!SET INITIAL PRESSURE GUESS
select case(ctrl_mode_pressure)
  case(0);  p = aux_pressure_si(a)
  case(-1); p = pt
  case(1);  p = ctrl_init_p
  case default; return
end select
if(p <= 0d0) return
if(p == errorreturn) return

!SET INITIAL LIQUID DENSITY GUESS
select case(ctrl_mode_liquid)
  case(0);  dl = dt_liq
  case(-1); dl = dt_liq
  case(1);  dl = ctrl_init_d_liq
  case default; return
end select
if(dl <= 0d0) return
if(dl == errorreturn) return

!SET INITIAL HUMID-AIR DENSITY GUESS
select case(ctrl_mode_air)
  case(0);  dh = air_g_density_si(a, t, p)
  case(-1); dh = dt_vap
  case(1);  dh = ctrl_init_d_air
  case default; return
end select
if(dh <= 0d0) return
if(dh == errorreturn) return

!SET MAX. ITERATION NUMBER
  if(ctrl_loop_maximum == 0) then
    maxit = 100
  elseif(ctrl_loop_maximum == (-1)) then
    call set_liq_ice_air_state(a, t, p, dh, dl, wa_si, wet_si, eta_si)
    set_liq_ice_air_eq_at_wa_eta_wt = isok
    return
  elseif(ctrl_loop_maximum > 0) then
    maxit = ctrl_loop_maximum
  else
    return
  endif

!SET ITERATION ACCURACY LIMIT
eps = ctrl_eps_exit_p
if(eps == 0d0) return

!RUN ITERATION LOOP
if(liq_ice_air_iter_at_wa_eta_wt(wa_si, eta_si, wet_si, maxit,  &
  eps, a, t, p, dh, dl) == errorreturn) then
  return
end if

call set_liq_ice_air_state(a, t, p, dh, dl, wa_si, wet_si, eta_si)

set_liq_ice_air_eq_at_wa_eta_wt = isok

end function

!==========================================================================
function set_liq_ice_air_eq_at_wa_wl_wi(wa_si, wl_si, wi_si)
!==========================================================================

!THIS FUNCTION COMPUTES BY NEWTON INTERATION THE WATER-ICE-HUMID-AIR EQUILIBRIUM
!AT GIVEN AIR FRACTION WA_SI (0 <= WA_SI < 1D0) OF AIR IN KG/KG,
!GIVEN LIQUID FRACTION WL_SI (0 <= WL_SI < 1D0) IN KG/KG,
!AND THE ICE FRACTION WI_SI (0 <= WI_SI < 1D0) IN KG/KG.
!NOTE THAT WA + WL + WI < 1 MUST HOLD FOR A VAPOUR FRACTION WV > 0

real*8 set_liq_ice_air_eq_at_wa_wl_wi, wa_si, wl_si, wi_si
real*8 t, p, a, s, wet
real*8 sh, si, sl
real*8 dh, dl

set_liq_ice_air_eq_at_wa_wl_wi = errorreturn

if(wa_si < 0d0 .or. wa_si > 1d0) return
if(wl_si < 0d0 .or. wl_si > 1d0) return
if(wi_si < 0d0 .or. wi_si > 1d0) return
if(wa_si + wl_si + wi_si >= 1d0) return
if(wl_si + wi_si == 0d0) return

a = wa_si / (1d0 - wl_si - wi_si)  !AIR FRACTION IN HUMID AIR
wet = wl_si / (wl_si + wi_si)      !LIQUID FRACTION OF THE CONDENSED PART

!ITERATIVELY COMPUTE EQUILIBRIUM TEMPERATURE AND PRESSURE
if(set_liq_ice_air_eq_at_a(a) == errorreturn) return

p = liq_ice_air_pressure_si()
if(p == errorreturn) return
t = liq_ice_air_temperature_si()
if(t == errorreturn) return

!COMPUTE ENTROPIES OF THE COMPONENTS
!HUMID AIR:
dh = equi_liq_ice_air_d_air  != air_g_density_si(a, t, p)
if(dh == errorreturn) return
sh = air_f_entropy_si(a, t, dh)
if(sh == errorreturn) return

!ICE:
si = ice_entropy_si(t, p)
if(si == errorreturn) return

!LIQUID WATER
dl = equi_liq_ice_air_d_liq  !liq_density_si(t, p)
if(dl == errorreturn) return
sl = flu_entropy_si(t, dl)
if(sl == errorreturn) return

!TOTAL ENTROPY
s = (1d0 - wl_si - wi_si) * sh + wl_si * sl + wi_si * si

!STORE THE COMPUTED EQUILIBRIUM VALUES
call set_liq_ice_air_state(a, t, p, dh, dl, wa_si, wet, s)

set_liq_ice_air_eq_at_wa_wl_wi = isok

end function

!==========================================================================
function liq_ice_air_iter_at_a(a_si, maxit, eps, t_si, &
                                    p_si, d_air_si, d_liq_si)
!==========================================================================

!THIS FUNCTION RETURNS THE WATER-ICE-HUMID-AIR PHASE EQUILIBRIUM FROM
!EQUAL CHEMICAL POTENTIALS OF WATER AT GIVEN AIR FRACTION, A_SI,
!FROM AN INITIAL GUESSES FOR THE TEMPERATURE, T_SI, PRESSURE, P_SI,
!THE HUMID-AIR DENSITY, DAIR_SI AND THE LIQUID DENSITY, DLIQ_SI.
!THE ITERATION LIMIT EPS REFERS TO THE ERROR IN PRESSURE.

!OUTPUT: 
!        LIQ_ICE_AIR_ITER_AT_A = ISOK IF SUCCESSFULLY DONE
!        LIQ_ICE_AIR_ITER_AT_A = ERRORRETURN IS RETURNED IF
!        - THE MAXIMUM NUMBER OF ITERATIONS IS EXCEEDED WITHOUT MEETING THE EXIT CRITERION
!        - THE FUNCTION CALL TO A GIBBS/HELMHOLTZ FUNCTION HAS RETURNED AN ERROR
!        - DENSITY, TEMPERATURE OR PRESSURE HAVE TAKEN A ZERO OR NEGATIVE VALUE DURING THE ITERATION
!        - A-T-P VALUES DO NOT PERMIT THE STABLE EXISTENCE OF ICE OR WATER
!  T_SI: TEMPERATURE IN K OF THE WATER-ICE-AIR EQUILIBRIUM
!  P_SI: PRESSURE IN PA OF THE WATER-ICE-AIR EQUILIBRIUM
!  DAIR_SI: DENSITY OF HUMID AIR AT (A_SI, T_SI, P_SI)
!  DLIQ_SI: DENSITY OF LIQUID WATER AT (T_SI, P_SI)

!INPUT: 
!        A_SI: AIR FRACTION OF DRY AIR IN HUMID AIR IN KG/KG
!       MAXIT: MAXIMUM NUMBER OF ITERATION STEPS TO BE DONE
!         EPS: REQUIRED ACCURACY OF PRESSURE
!              EPS > 0: ABSOLUTE PRESSURE TOLERANCE IN PA
!              EPS < 0: RELATIVE PRESSURE TOLERANCE
!        T_SI: INITIAL GUESS FOR ABSOLUTE TEMPERATURE IN K
!        P_SI: INITIAL GUESS FOR ABSOLUTE PRESSURE IN PA
!        DAIR_SI: INITIAL GUESS FOR DENSITY OF HUMID AIR AT (A_SI, T_SI, P_SI)
!        DLIQ_SI: INITIAL GUESS FOR DENSITY OF LIQUID AT (T_SI, P_SI)

real*8 liq_ice_air_iter_at_a, a_si, eps, t_si, &
       p_si, d_air_si, d_liq_si
real*8 dh, dl, t, p
real*8 ddh, ddl, dt, dp
real*8 gi, gi_t, gi_p
real*8 fh, fh_a, fh_t, fh_td
real*8 fh_d, fh_dd, fh_at, fh_ad
real*8 fl, fl_t, fl_td
real*8 fl_d, fl_dd
real*8 a(4, 4), b(4), x(4)

integer it, maxit

liq_ice_air_iter_at_a = errorreturn

if(a_si <= 0d0 .or. a_si >= 1d0 .or. &
  d_air_si <= 0d0 .or. &
  d_liq_si <= 0d0 .or. &
  t_si <= 0d0 .or. &
  p_si <= 0d0) then
  t_si = errorreturn
  p_si = errorreturn
  d_air_si = errorreturn
  d_liq_si = errorreturn
  return
endif

check_limits = check_limits - 1

t = t_si
p = p_si
dl = d_liq_si
dh = d_air_si

do it = 1, maxit

  !DERIVATIVES OF THE HELMHOLTZ FUNCTION OF HUMID AIR FOR 4D-NEWTON ITERATION
  fh = air_f_si(0, 0, 0, a_si, t, dh)
  if(fh == errorreturn) go to 999
  fh_a = air_f_si(1, 0, 0, a_si, t, dh)
  if(fh_a == errorreturn) go to 999
  fh_t = air_f_si(0, 1, 0, a_si, t, dh)
  if(fh_t == errorreturn) go to 999
  fh_d = air_f_si(0, 0, 1, a_si, t, dh)
  if(fh_d == errorreturn) go to 999
  fh_at = air_f_si(1, 1, 0, a_si, t, dh)
  if(fh_at == errorreturn) go to 999
  fh_ad = air_f_si(1, 0, 1, a_si, t, dh)
  if(fh_ad == errorreturn) go to 999
  fh_td = air_f_si(0, 1, 1, a_si, t, dh)
  if(fh_td == errorreturn) go to 999
  fh_dd = air_f_si(0, 0, 2, a_si, t, dh)
  if(fh_dd == errorreturn) go to 999

  !DERIVATIVES OF THE HELMHOLTZ FUNCTION OF LIQUID WATER FOR NEWTON ITERATION
  fl = flu_f_si(0, 0, t, dl)
  if(fl == errorreturn) go to 999
  fl_t = flu_f_si(1, 0, t, dl)
  if(fl_t == errorreturn) go to 999
  fl_d = flu_f_si(0, 1, t, dl)
  if(fl_d == errorreturn) go to 999
  fl_td = flu_f_si(1, 1, t, dl)
  if(fl_td == errorreturn) go to 999
  fl_dd = flu_f_si(0, 2, t, dl)
  if(fl_dd == errorreturn) go to 999

  !DERIVATIVES OF THE GIBBS FUNCTION OF ICE FOR NEWTON ITERATION
  gi = ice_g_si(0, 0, t, p)
  if(gi == errorreturn) go to 999
  gi_t = ice_g_si(1, 0, t, p)
  if(gi_t == errorreturn) go to 999
  gi_p = ice_g_si(0, 1, t, p)
  if(gi_p == errorreturn) go to 999

  !COEFFICIENT MATRIX
  a(1, 1) = gi_t - fl_t
  a(1, 2) = gi_p - 1d0 / dl
  a(1, 3) = p / dl**2 - fl_d
  a(1, 4) = 0d0
  a(2, 1) = -dl * fl_td
  a(2, 2) = 1d0 / dl
  a(2, 3) = -fl_d - dl * fl_dd - p / dl**2
  a(2, 4) = 0d0
  a(3, 1) = gi_t - fh_t + a_si * fh_at
  a(3, 2) = gi_p - 1d0 / dh
  a(3, 3) = 0d0
  a(3, 4) = p / dh**2 + a_si * fh_ad - fh_d
  a(4, 1) = -dh * fh_td
  a(4, 2) = 1d0 / dh
  a(4, 3) = 0d0
  a(4, 4) = -p / dh**2 - fh_d - dh * fh_dd

  !RIGHT-HAND SIDES, MUST VANISH AT EQUILIBRIUM
  b(1) = fl + p / dl - gi
  b(2) = dl * fl_d - p / dl
  b(3) = -gi + fh + p / dh - a_si * fh_a
  b(4) = dh * fh_d - p / dh
  
  !SOLVE EQUATIONS
  if(matrix_solve(a, b, x, 4) /= 0) go to 999 !MATRIX SINGULAR
  dt = x(1)
  dp = x(2)
  ddl = x(3)
  ddh = x(4)
  
  !UPDATE UNKNOWNS
  dh = dh + ddh
  if(dh <= 0d0) go to 999
  dl = dl + ddl
  if(dl <= 0d0) go to 999
  t = t + dt
  if(t <= 0d0) go to 999
  p = p + dp
  if(p <= 0d0) go to 999
  
  !CHECK ABSOLUTE OR RELATIVE ERROR LIMIT
  if((eps > 0d0 .and. abs(dp) < eps) .or. &
     (eps < 0d0 .and. abs(dp) < -eps * abs(p))) then
    liq_ice_air_iter_at_a = isok
    t_si = t
    p_si = p
    d_air_si = dh
    d_liq_si = dl
    go to 999
  end if

enddo

999 continue

check_limits = check_limits + 1

if(check_limits == 1) then
  !FLU_LIMITS
  if(t_si < flu_tmin .or. t_si > flu_tmax .or. &
  d_liq_si <= flu_dmin .or. d_liq_si > flu_dmax) then
    t_si = errorreturn
    p_si = errorreturn
    d_liq_si = errorreturn
    d_air_si = errorreturn
    liq_ice_air_iter_at_a = errorreturn
    return
  endif
  !ICE_LIMITS
  if(t_si <= ice_tmin .or. t_si > ice_tmax .or. &
  p_si <= ice_pmin .or. p_si > ice_pmax) then
    t_si = errorreturn
    p_si = errorreturn
    d_liq_si = errorreturn
    d_air_si = errorreturn
    liq_ice_air_iter_at_a = errorreturn
    return
  endif
  !AIR_LIMITS
  if(t_si < dry_air_tmin .or. t_si > dry_air_tmax .or. &
  d_air_si <= dry_air_dmin .or. d_air_si > dry_air_dmax) then
    t_si = errorreturn
    p_si = errorreturn
    d_liq_si = errorreturn
    d_air_si = errorreturn
    liq_ice_air_iter_at_a = errorreturn
    return
  endif
endif

end function

!==========================================================================
function liq_ice_air_iter_at_p(p_si, maxit, eps, a_si, t_si, &
         d_air_si, d_liq_si)
!==========================================================================

!THIS FUNCTION RETURNS THE WATER-ICE-HUMID-AIR PHASE EQUILIBRIUM FROM
!EQUAL CHEMICAL POTENTIALS OF WATER AT GIVEN PRESSURE, P_SI,
!FROM AN INITIAL GUESSES FOR THE TEMPERATURE, T_SI, AIR FRACTION, A_SI,
!THE HUMID-AIR DENSITY, DAIR_SI AND THE LIQUID DENSITY, DLIQ_SI.
!THE ITERATION LIMIT EPS REFERS TO THE ERROR IN AIR FRACTION.

!OUTPUT: 
!        LIQ_ICE_AIR_ITER_AT_P = ISOK IF SUCCESSFULLY DONE
!        LIQ_ICE_AIR_ITER_AT_P = ERRORRETURN IS RETURNED IF
!        - THE MAXIMUM NUMBER OF ITERATIONS IS EXCEEDED WITHOUT MEETING THE EXIT CRITERION
!        - THE FUNCTION CALL TO A GIBBS/HELMHOLTZ FUNCTION HAS RETURNED AN ERROR
!        - DENSITY, TEMPERATURE OR AIR FRACTION HAVE TAKEN AN INVALID VALUE DURING THE ITERATION
!        - A-T-P VALUES DO NOT PERMIT THE STABLE EXISTENCE OF ICE OR WATER
!  T_SI: TEMPERATURE IN K OF THE WATER-ICE-AIR EQUILIBRIUM
!  A_SI: AIR FRACTION OF DRY AIR IN HUMID AIR IN KG/KG
!  DAIR_SI: DENSITY OF HUMID AIR AT (A_SI, T_SI, P_SI)
!  DLIQ_SI: DENSITY OF LIQUID WATER AT (T_SI, P_SI)

!INPUT: 
!        P_SI: ABSOLUTE PRESSURE IN PA
!       MAXIT: MAXIMUM NUMBER OF ITERATION STEPS TO BE DONE
!         EPS: REQUIRED ACCURACY OF AIR FRACTION
!              EPS > 0: AIR FRACTION TOLERANCE IN KG/KG
!              EPS < 0: RELATIVE AIR FRACTION TOLERANCE
!        A_SI: AIR FRACTION OF DRY AIR IN HUMID AIR IN KG/KG
!        T_SI: INITIAL GUESS FOR ABSOLUTE TEMPERATURE IN K
!        DAIR_SI: INITIAL GUESS FOR DENSITY OF HUMID AIR AT (A_SI, T_SI, P_SI)
!        DLIQ_SI: INITIAL GUESS FOR DENSITY OF LIQUID AT (T_SI, P_SI)

real*8 liq_ice_air_iter_at_p, p_si, eps, a_si, t_si, &
         d_air_si, d_liq_si
real*8 dh, dl, t
real*8 gi, gi_t, a
real*8 fh, fh_a, fh_t, fh_td
real*8 fh_d, fh_dd, fh_at, fh_ad
real*8 fl, fl_t, fl_td, fh_aa
real*8 fl_d, fl_dd
real*8 aa(4, 4), b(4), x(4)

integer it, maxit

liq_ice_air_iter_at_p = errorreturn

If(d_air_si <= 0) return
If(d_liq_si <= 0) return
If(t_si <= 0) return
If(p_si <= 0) return
If(a_si <= 0) return
If(a_si >= 1) return

if(d_air_si <= 0d0 .or. &
  d_liq_si <= 0d0 .or. &
  t_si <= 0d0 .or. &
  a_si <= 0d0 .or. a_si >= 1d0) then
  t_si = errorreturn
  a_si = errorreturn
  d_air_si = errorreturn
  d_liq_si = errorreturn
  return
endif

if(check_limits == 1) then
  !ICE_LIMITS
  if(p_si <= ice_pmin .or. p_si > ice_pmax) then
    t_si = errorreturn
    a_si = errorreturn
    d_air_si = errorreturn
    d_liq_si = errorreturn
    return
  endif
else
  if(p_si <= 0d0) then
    t_si = errorreturn
    a_si = errorreturn
    d_air_si = errorreturn
    d_liq_si = errorreturn
    return
  endif
endif

check_limits = check_limits - 1

t = t_si
a = a_si
dl = d_liq_si
dh = d_air_si

do it = 1, maxit

  !DERIVATIVES OF THE HELMHOLTZ FUNCTION OF HUMID AIR FOR 4D-NEWTON ITERATION
  fh = air_f_si(0, 0, 0, a, t, dh)
  if(fh == errorreturn) go to 999
  fh_a = air_f_si(1, 0, 0, a, t, dh)
  if(fh_a == errorreturn) go to 999
  fh_t = air_f_si(0, 1, 0, a, t, dh)
  if(fh_t == errorreturn) go to 999
  fh_d = air_f_si(0, 0, 1, a, t, dh)
  if(fh_d == errorreturn) go to 999
  fh_aa = air_f_si(2, 0, 0, a, t, dh)
  if(fh_aa == errorreturn) go to 999
  fh_at = air_f_si(1, 1, 0, a, t, dh)
  if(fh_at == errorreturn) go to 999
  fh_ad = air_f_si(1, 0, 1, a, t, dh)
  if(fh_ad == errorreturn) go to 999
  fh_td = air_f_si(0, 1, 1, a, t, dh)
  if(fh_td == errorreturn) go to 999
  fh_dd = air_f_si(0, 0, 2, a, t, dh)
  if(fh_dd == errorreturn) go to 999

  !DERIVATIVES OF THE HELMHOLTZ FUNCTION OF LIQUID WATER FOR NEWTON ITERATION
  fl = flu_f_si(0, 0, t, dl)
  if(fl == errorreturn) go to 999
  fl_t = flu_f_si(1, 0, t, dl)
  if(fl_t == errorreturn) go to 999
  fl_d = flu_f_si(0, 1, t, dl)
  if(fl_d == errorreturn) go to 999
  fl_td = flu_f_si(1, 1, t, dl)
  if(fl_td == errorreturn) go to 999
  fl_dd = flu_f_si(0, 2, t, dl)
  if(fl_dd == errorreturn) go to 999

  !DERIVATIVES OF THE GIBBS FUNCTION OF ICE FOR NEWTON ITERATION
  gi = ice_g_si(0, 0, t, p_si)
  if(gi == errorreturn) go to 999
  gi_t = ice_g_si(1, 0, t, p_si)
  if(gi_t == errorreturn) go to 999

  !COEFFICIENT MATRIX
  aa(1, 1) = gi_t - fl_t
  aa(1, 2) = p_si / dl**2 - fl_d
  aa(1, 3) = 0d0
  aa(1, 4) = 0d0
  
  aa(2, 1) = -dl * fl_td
  aa(2, 2) = -fl_d - dl * fl_dd - p_si / dl**2
  aa(2, 3) = 0d0
  aa(2, 4) = 0d0
  
  aa(3, 1) = gi_t - fh_t + a * fh_at
  aa(3, 2) = 0d0
  aa(3, 3) = p_si / dh**2 + a * fh_ad - fh_d
  aa(3, 4) = a * fh_aa
  
  aa(4, 1) = -dh * fh_td
  aa(4, 2) = 0d0
  aa(4, 3) = -p_si / dh**2 - fh_d - dh * fh_dd
  aa(4, 4) = -dh * fh_ad

  !RIGHT-HAND SIDES, MUST VANISH AT EQUILIBRIUM
  b(1) = fl + p_si / dl - gi
  b(2) = dl * fl_d - p_si / dl
  b(3) = -gi + fh + p_si / dh - a * fh_a
  b(4) = dh * fh_d - p_si / dh

  !SOLVE EQUATIONS
  if(matrix_solve(aa, b, x, 4) /= 0) go to 999 !MATRIX SINGULAR
  
  !UPDATE UNKNOWNS
  t = t + x(1)
  if(t <= 0d0) go to 999
  dl = dl + x(2)
  if(dl <= 0d0) go to 999
  dh = dh + x(3)
  if(dh <= 0d0) go to 999
  a = a + x(4)
  if(a <= 0d0 .or. a >= 1d0) go to 999

  !CHECK ABSOLUTE OR RELATIVE ERROR LIMIT
  if((eps > 0d0 .and. abs(x(4)) < eps) .or. &
    (eps < 0d0 .and. abs(x(4)) < -eps * a)) then
    liq_ice_air_iter_at_p = isok
    a_si = a
    t_si = t
    d_air_si = dh
    d_liq_si = dl
    go to 999
  end if

enddo

999 continue

check_limits = check_limits + 1

if(check_limits == 1) then
  !FLU_LIMITS
  if(t_si < flu_tmin .or. t_si > flu_tmax .or. &
  d_liq_si <= flu_dmin .or. d_liq_si > flu_dmax) then
    t_si = errorreturn
    a_si = errorreturn
    d_air_si = errorreturn
    d_liq_si = errorreturn
    liq_ice_air_iter_at_p = errorreturn
    return
  endif
  !ICE_LIMITS
  if(t_si <= ice_tmin .or. t_si > ice_tmax) then
    t_si = errorreturn
    a_si = errorreturn
    d_air_si = errorreturn
    d_liq_si = errorreturn
    liq_ice_air_iter_at_p = errorreturn
    return
  endif
  !AIR_LIMITS
  if(t_si < dry_air_tmin .or. t_si > dry_air_tmax .or. &
  a_si < 0d0 .or. a_si > 1d0 .or. & 
  d_air_si <= dry_air_dmin .or. d_air_si > dry_air_dmax) then
    t_si = errorreturn
    a_si = errorreturn
    d_air_si = errorreturn
    d_liq_si = errorreturn
    liq_ice_air_iter_at_p = errorreturn
    return
  endif
endif

end function

!==========================================================================
function liq_ice_air_iter_at_t(t_si, maxit, eps, a_si, p_si, &
                                    d_air_si, d_liq_si)
!==========================================================================

!THIS FUNCTION RETURNS THE WATER-ICE-HUMID-AIR PHASE EQUILIBRIUM FROM
!EQUAL CHEMICAL POTENTIALS OF WATER AT GIVEN TEMPERATURE, T_SI,
!FROM AN INITIAL GUESSES FOR THE PRESSURE, P_SI, AIR FRACTION, A_SI,
!THE HUMID-AIR DENSITY, DAIR_SI AND THE LIQUID DENSITY, DLIQ_SI.
!THE ITERATION LIMIT EPS REFERS TO THE ERROR IN AIR FRACTION.

!OUTPUT: 
!        LIQ_ICE_AIR_ITER_AT_T = ISOK IF SUCCESSFULLY DONE
!        LIQ_ICE_AIR_ITER_AT_T = ERRORRETURN IS RETURNED IF
!        - THE MAXIMUM NUMBER OF ITERATIONS IS EXCEEDED WITHOUT MEETING THE EXIT CRITERION
!        - THE FUNCTION CALL TO A GIBBS/HELMHOLTZ FUNCTION HAS RETURNED AN ERROR
!        - DENSITY, TEMPERATURE OR AIR FRACTION HAVE TAKEN AN INVALID VALUE DURING THE ITERATION
!        - A-T-P VALUES DO NOT PERMIT THE STABLE EXISTENCE OF ICE OR WATER
!  P_SI: PRESSURE IN PA OF THE WATER-ICE-AIR EQUILIBRIUM
!  A_SI: AIR FRACTION OF DRY AIR IN HUMID AIR IN KG/KG
!  DAIR_SI: DENSITY OF HUMID AIR AT (A_SI, T_SI, P_SI)
!  DLIQ_SI: DENSITY OF LIQUID WATER AT (T_SI, P_SI)

!INPUT: 
!        T_SI: ABSOLUTE TEMPERATURE IN K
!       MAXIT: MAXIMUM NUMBER OF ITERATION STEPS TO BE DONE
!         EPS: REQUIRED ACCURACY OF PRESSURE
!              EPS > 0: ABSOLUTE PRESSURE TOLERANCE IN PA
!              EPS < 0: RELATIVE PRESSURE TOLERANCE
!        A_SI: AIR FRACTION OF DRY AIR IN HUMID AIR IN KG/KG
!        P_SI: INITIAL GUESS FOR ABSOLUTE PRESSURE IN PA
!        DAIR_SI: INITIAL GUESS FOR DENSITY OF HUMID AIR AT (A_SI, T_SI, P_SI)
!        DLIQ_SI: INITIAL GUESS FOR DENSITY OF LIQUID AT (T_SI, P_SI)

real*8 liq_ice_air_iter_at_t, t_si, eps, a_si, p_si, d_air_si, d_liq_si
real*8 dh, dl, p
real*8 gi, gi_p, a
real*8 fh, fh_a
real*8 fh_d, fh_dd, fh_ad
real*8 fl, fh_aa
real*8 fl_d, fl_dd
real*8 aa(4, 4), b(4), x(4)

integer it, maxit

liq_ice_air_iter_at_t = errorreturn

if((d_air_si <= 0d0) .or. &
  (d_liq_si <= 0d0) .or. &
  (p_si <= 0d0) .or. &
  (a_si <= 0d0) .or. &
  (a_si >= 1d0)) then
  p_si = errorreturn
  a_si = errorreturn
  d_air_si = errorreturn
  d_liq_si = errorreturn
  return
endif

if(check_limits == 1) then
  !FLU_LIMITS
  if(t_si < flu_tmin .or. t_si > flu_tmax) then
    p_si = errorreturn
    a_si = errorreturn
    d_air_si = errorreturn
    d_liq_si = errorreturn
    return
  endif
  !ICE_LIMITS
  if(t_si <= ice_tmin .or. t_si > ice_tmax) then
    p_si = errorreturn
    a_si = errorreturn
    d_air_si = errorreturn
    d_liq_si = errorreturn
    return
  endif
  !AIR_LIMITS
  if(t_si < dry_air_tmin .or. t_si > dry_air_tmax) then
    p_si = errorreturn
    a_si = errorreturn
    d_air_si = errorreturn
    d_liq_si = errorreturn
    return
  endif
else
  if(t_si <= 0d0) then
    p_si = errorreturn
    a_si = errorreturn
    d_air_si = errorreturn
    d_liq_si = errorreturn
    return
  endif
endif

check_limits = check_limits - 1

p = p_si
a = a_si
dl = d_liq_si
dh = d_air_si

do it = 1, maxit

  !DERIVATIVES OF THE HELMHOLTZ FUNCTION OF HUMID AIR FOR 4D-NEWTON ITERATION
  fh = air_f_si(0, 0, 0, a, t_si, dh)
  if(fh == errorreturn) go to 999
  fh_a = air_f_si(1, 0, 0, a, t_si, dh)
  if(fh_a == errorreturn) go to 999
  fh_d = air_f_si(0, 0, 1, a, t_si, dh)
  if(fh_d == errorreturn) go to 999
  fh_aa = air_f_si(2, 0, 0, a, t_si, dh)
  if(fh_aa == errorreturn) go to 999
  fh_ad = air_f_si(1, 0, 1, a, t_si, dh)
  if(fh_ad == errorreturn) go to 999
  fh_dd = air_f_si(0, 0, 2, a, t_si, dh)
  if(fh_dd == errorreturn) go to 999

  !DERIVATIVES OF THE HELMHOLTZ FUNCTION OF LIQUID WATER FOR NEWTON ITERATION
  fl = flu_f_si(0, 0, t_si, dl)
  if(fl == errorreturn) go to 999
  fl_d = flu_f_si(0, 1, t_si, dl)
  if(fl_d == errorreturn) go to 999
  fl_dd = flu_f_si(0, 2, t_si, dl)
  if(fl_dd == errorreturn) go to 999

  !DERIVATIVES OF THE GIBBS FUNCTION OF ICE FOR NEWTON ITERATION
  gi = ice_g_si(0, 0, t_si, p)
  if(gi == errorreturn) go to 999
  gi_p = ice_g_si(0, 1, t_si, p)
  if(gi_p == errorreturn) go to 999

  !COEFFICIENT MATRIX
  aa(1, 1) = gi_p - 1d0 / dl
  aa(1, 2) = p / dl**2 - fl_d
  aa(1, 3) = 0d0
  aa(1, 4) = 0d0
  
  aa(2, 1) = 1d0 / dl
  aa(2, 2) = -fl_d - dl * fl_dd - p / dl**2
  aa(2, 3) = 0d0
  aa(2, 4) = 0d0
  
  aa(3, 1) = gi_p - 1d0 / dh
  aa(3, 2) = 0d0
  aa(3, 3) = p / dh**2 + a * fh_ad - fh_d
  aa(3, 4) = a * fh_aa
  
  aa(4, 1) = 1d0 / dh
  aa(4, 2) = 0d0
  aa(4, 3) = -p / dh**2 - fh_d - dh * fh_dd
  aa(4, 4) = -dh * fh_ad

  !RIGHT-HAND SIDES, MUST VANISH AT EQUILIBRIUM
  b(1) = fl + p / dl - gi
  b(2) = dl * fl_d - p / dl
  b(3) = -gi + fh + p / dh - a * fh_a
  b(4) = dh * fh_d - p / dh

  !SOLVE EQUATIONS
  if(matrix_solve(aa, b, x, 4) /= 0) go to 999 !MATRIX SINGULAR
  
  !UPDATE UNKNOWNS
  p = p + x(1)
  if(p <= 0d0) go to 999
  dl = dl + x(2)
  if(dl <= 0d0) go to 999
  dh = dh + x(3)
  if(dh <= 0d0) go to 999
  a = a + x(4)
  if(a <= 0d0) go to 999

  !CHECK ABSOLUTE OR RELATIVE ERROR LIMIT
  if((eps > 0d0 .and. abs(x(1)) < eps) .or. &
     (eps < 0d0 .and. abs(x(1)) < -eps * p)) then
    liq_ice_air_iter_at_t = isok
    a_si = a
    p_si = p
    d_air_si = dh
    d_liq_si = dl
    go to 999
  end if

enddo

999 continue

check_limits = check_limits + 1

if(check_limits == 1) then
  !FLU_LIMITS
  if(d_liq_si <= flu_dmin .or. d_liq_si > flu_dmax .or. &
  p_si <= 0d0) then
    p_si = errorreturn
    a_si = errorreturn
    d_air_si = errorreturn
    d_liq_si = errorreturn
    liq_ice_air_iter_at_t = errorreturn
    return
  endif
  !ICE_LIMITS
  if(p_si <= ice_pmin .or. p_si > ice_pmax) then
    p_si = errorreturn
    a_si = errorreturn
    d_air_si = errorreturn
    d_liq_si = errorreturn
    liq_ice_air_iter_at_t = errorreturn
    return
  endif
  !AIR_LIMITS
  if(a_si < 0d0 .or. a_si > 1d0 .or. &
  p_si <= 0d0 .or. &
  d_air_si <= dry_air_dmin .or. d_air_si > dry_air_dmax) then
    p_si = errorreturn
    a_si = errorreturn
    d_air_si = errorreturn
    d_liq_si = errorreturn
    liq_ice_air_iter_at_t = errorreturn
    return
  endif
endif

end function

!==========================================================================
function liq_ice_air_iter_at_wa_eta_wt(wa_si, eta_si, wet_si, &
                                             maxit, eps, a_si, t_si, p_si, &
                                             d_air_si, d_liq_si)
!==========================================================================

!THIS FUNCTION RETURNS THE WATER-ICE-HUMID-AIR PHASE EQUILIBRIUM FROM
!EQUAL CHEMICAL POTENTIALS OF WATER AT GIVEN AIR FRACTION, WA_SI,
!ENTROPY, ETA_SI, AND THE WETNESS, WET_SI, OF THE CONDENSATE, FROM AN INITIAL GUESS
!FOR THE AIR FRACTION A_SI OF THE HUMID-AIR PART, TEMPERATURE, T_SI, PRESSURE, P_SI,
!THE HUMID-AIR DENSITY, DAIR_SI, AND THE LIQUID DENSITY, DLIQ_SI.
!WET_SI = 0 MEANS THE CONDENSED PART IS ICE, WET_SI = 1 MEANS THE CONDENSED PART IS LIQUID.
!THE ITERATION LIMIT EPS REFERS TO THE ERROR IN PRESSURE.

!OUTPUT: 
!        LIQ_ICE_AIR_ITER_AT_WA_ETA_WT = ISOK IF SUCCESSFULLY DONE
!        LIQ_ICE_AIR_ITER_AT_WA_ETA_WT = ERRORRETURN IS RETURNED IF
!        - THE MAXIMUM NUMBER OF ITERATIONS IS EXCEEDED WITHOUT MEETING THE EXIT CRITERION
!        - THE FUNCTION CALL TO A GIBBS/HELMHOLTZ FUNCTION HAS RETURNED AN ERROR
!        - DENSITY, TEMPERATURE, PRESSURE OR AIR FRACTION HAVE TAKEN AN INVALID VALUE DURING THE ITERATION
!        - A-T-P VALUES DO NOT PERMIT THE STABLE EXISTENCE OF ICE OR WATER
!     A_SI: MASS FRACTION OF DRY AIR IN HUMID AIR IN KG/KG
!     T_SI: TEMPERATURE IN K OF THE WATER-ICE-AIR EQUILIBRIUM
!     P_SI: PRESSURE IN PA OF THE WATER-ICE-AIR EQUILIBRIUM
!  DAIR_SI: DENSITY OF HUMID AIR AT (A_SI, T_SI, P_SI)
!  DLIQ_SI: DENSITY OF LIQUID WATER AT (T_SI, P_SI)

!INPUT: 
!       WA_SI: AIR FRACTION OF DRY AIR IN WET ICE AIR IN KG/KG
!      ETA_SI: SPECIFIC ENTROPY OF WET ICE AIR IN J/(KG K)
!      WET_SI: LIQUID FRACTION OF WET ICE IN KG/KG, (1-WET_SI) IS THE ICE FRACTION
!       MAXIT: MAXIMUM NUMBER OF ITERATION STEPS TO BE DONE
!         EPS: REQUIRED ACCURACY OF PRESSURE
!              EPS > 0: ABSOLUTE PRESSURE TOLERANCE IN PA
!              EPS < 0: RELATIVE PRESSURE TOLERANCE
!        A_SI: INITIAL GUESS FOR THE DRY-AIR FRACTION IN HUMID AIR IN KG/KG
!        T_SI: INITIAL GUESS FOR ABSOLUTE TEMPERATURE IN K
!        P_SI: INITIAL GUESS FOR ABSOLUTE PRESSURE IN PA
!     DAIR_SI: INITIAL GUESS FOR DENSITY OF HUMID AIR AT (A_SI, T_SI, P_SI)
!     DLIQ_SI: INITIAL GUESS FOR DENSITY OF LIQUID AT (T_SI, P_SI)

real*8 liq_ice_air_iter_at_wa_eta_wt, wa_si, eta_si, wet_si, &
       eps, a_si, t_si, p_si, d_air_si, d_liq_si
real*8 dh, dl, t, p, a
real*8 gi, gi_t, gi_p, gi_tt, gi_tp
real*8 fh, fh_a, fh_t, fh_td
real*8 fh_d, fh_dd, fh_at, fh_ad
real*8 fh_aa, fh_tt
real*8 fl, fl_t, fl_tt, fl_td
real*8 fl_d, fl_dd

!THE 5 UNKNOWNS ARE, INDEX 1-5: T, P, DL, DH, A
real*8 aa(5, 5), b(5), x(5)

integer it, maxit

liq_ice_air_iter_at_wa_eta_wt = errorreturn

If(d_air_si <= 0) return
If(d_liq_si <= 0) return
If(a_si < 0 .or. a_si >= 1) return
If(t_si <= 0) return
If(p_si <= 0) return
If(wa_si < 0 .or. wa_si >= a_si) return
If(wet_si < 0 .or. wet_si > 1) return

if(d_air_si <= 0d0 .or. &
  d_liq_si <= 0d0 .or. &
  a_si < 0d0 .or. a_si >= 1d0 .or. &
  wa_si < 0d0 .or. wa_si > 1d0 .or.  &
  wet_si < 0d0 .or. wet_si > 1d0 .or. &
  t_si <= 0d0 .or. &
  p_si <= 0d0) then
  a_si = errorreturn
  t_si = errorreturn
  p_si = errorreturn
  d_air_si = errorreturn
  d_liq_si = errorreturn
  return
endif

check_limits = check_limits - 1

a = a_si
t = t_si
p = p_si
dl = d_liq_si
dh = d_air_si

do it = 1, maxit

  !DERIVATIVES OF THE HELMHOLTZ FUNCTION OF HUMID AIR FOR 5D-NEWTON ITERATION
  fh = air_f_si(0, 0, 0, a, t, dh)
  if(fh == errorreturn) go to 999
  fh_a = air_f_si(1, 0, 0, a, t, dh)
  if(fh_a == errorreturn) go to 999
  fh_t = air_f_si(0, 1, 0, a, t, dh)
  if(fh_t == errorreturn) go to 999
  fh_d = air_f_si(0, 0, 1, a, t, dh)
  if(fh_d == errorreturn) go to 999
  fh_aa = air_f_si(2, 0, 0, a, t, dh)
  if(fh_aa == errorreturn) go to 999
  fh_at = air_f_si(1, 1, 0, a, t, dh)
  if(fh_at == errorreturn) go to 999
  fh_ad = air_f_si(1, 0, 1, a, t, dh)
  if(fh_ad == errorreturn) go to 999
  fh_tt = air_f_si(0, 2, 0, a, t, dh)
  if(fh_tt == errorreturn) go to 999
  fh_td = air_f_si(0, 1, 1, a, t, dh)
  if(fh_td == errorreturn) go to 999
  fh_dd = air_f_si(0, 0, 2, a, t, dh)
  if(fh_dd == errorreturn) go to 999

  !DERIVATIVES OF THE HELMHOLTZ FUNCTION OF LIQUID WATER FOR NEWTON ITERATION
  fl = flu_f_si(0, 0, t, dl)
  if(fl == errorreturn) go to 999
  fl_t = flu_f_si(1, 0, t, dl)
  if(fl_t == errorreturn) go to 999
  fl_d = flu_f_si(0, 1, t, dl)
  if(fl_d == errorreturn) go to 999
  fl_tt = flu_f_si(2, 0, t, dl)
  if(fl_tt == errorreturn) go to 999
  fl_td = flu_f_si(1, 1, t, dl)
  if(fl_td == errorreturn) go to 999
  fl_dd = flu_f_si(0, 2, t, dl)
  if(fl_dd == errorreturn) go to 999

  !DERIVATIVES OF THE GIBBS FUNCTION OF ICE FOR NEWTON ITERATION
  gi = ice_g_si(0, 0, t, p)
  if(gi == errorreturn) go to 999
  gi_t = ice_g_si(1, 0, t, p)
  if(gi_t == errorreturn) go to 999
  gi_p = ice_g_si(0, 1, t, p)
  if(gi_p == errorreturn) go to 999
  gi_tt = ice_g_si(2, 0, t, p)
  if(gi_tt == errorreturn) go to 999
  gi_tp = ice_g_si(1, 1, t, p)
  if(gi_tp == errorreturn) go to 999

  !COEFFICIENT MATRIX
  aa(1, 1) = gi_t - fl_t
  aa(1, 2) = gi_p - 1d0 / dl
  aa(1, 3) = p / dl**2 - fl_d
  aa(1, 4) = 0d0
  aa(1, 5) = 0d0
  
  aa(2, 1) = -dl * fl_td
  aa(2, 2) = 1d0 / dl
  aa(2, 3) = -fl_d - dl * fl_dd - p / dl**2
  aa(2, 4) = 0d0
  aa(2, 5) = 0d0

  aa(3, 1) = gi_t - fh_t + a * fh_at
  aa(3, 2) = gi_p - 1d0 / dh
  aa(3, 3) = 0d0
  aa(3, 4) = p / dh**2 + a * fh_ad - fh_d
  aa(3, 5) = a * fh_aa

  aa(4, 1) = -dh * fh_td
  aa(4, 2) = 1d0 / dh
  aa(4, 3) = 0d0
  aa(4, 4) = -p / dh**2 - fh_d - dh * fh_dd
  aa(4, 5) = -dh * fh_ad

  aa(5, 1) = (a - wa_si) * (wet_si * fl_tt + (1d0 - wet_si) * gi_tt) + wa_si * fh_tt
  aa(5, 2) = (a - wa_si) * (1d0 - wet_si) * gi_tp
  aa(5, 3) = (a - wa_si) * wet_si * fl_td
  aa(5, 4) = wa_si * fh_td
  aa(5, 5) = wet_si * fl_t + (1d0 - wet_si) * gi_t + wa_si * fh_at

  !RIGHT-HAND SIDES, MUST VANISH AT EQUILIBRIUM
  b(1) = fl + p / dl - gi
  b(2) = dl * fl_d - p / dl
  b(3) = -gi + fh + p / dh - a * fh_a
  b(4) = dh * fh_d - p / dh
  b(5) = (wa_si - a) * (wet_si * fl_t + (1d0 - wet_si) * gi_t) - wa_si * fh_t - a * eta_si
  
  !SOLVE EQUATIONS
  if(matrix_solve(aa, b, x, 5) /= 0) go to 999 !MATRIX SINGULAR
  
  !UPDATE UNKNOWNS
  t = t + x(1)
  if(t <= 0d0) go to 999
  p = p + x(2)
  if(p <= 0d0) go to 999
  dl = dl + x(3)
  if(dl <= 0d0) go to 999
  dh = dh + x(4)
  if(dh <= 0d0) go to 999
  a = a + x(5)
  if(a < 0d0 .or. a >= 1d0) go to 999

  !CHECK ABSOLUTE OR RELATIVE ERROR LIMIT
  if((eps > 0d0 .and. abs(x(2)) < eps) .or. &
     (eps < 0d0 .and. abs(x(2)) < -eps * abs(p))) then
    liq_ice_air_iter_at_wa_eta_wt = isok
    a_si = a
    t_si = t
    p_si = p
    d_air_si = dh
    d_liq_si = dl
    go to 999
  end if

enddo

999 continue

check_limits = check_limits + 1

if(check_limits == 1) then
  !FLU_LIMITS
  if(t_si < flu_tmin .or. t_si > flu_tmax .or. &
  d_liq_si <= flu_dmin .or. d_liq_si > flu_dmax) then
    a_si = errorreturn
    t_si = errorreturn
    p_si = errorreturn
    d_air_si = errorreturn
    d_liq_si = errorreturn
    liq_ice_air_iter_at_wa_eta_wt = errorreturn
    return
  endif
  !ICE_LIMITS
  if(t_si <= ice_tmin .or. t_si > ice_tmax .or. &
  p_si <= ice_pmin .or. p_si > ice_pmax) then
    a_si = errorreturn
    t_si = errorreturn
    p_si = errorreturn
    d_air_si = errorreturn
    d_liq_si = errorreturn
    liq_ice_air_iter_at_wa_eta_wt = errorreturn
    return
  endif
  !AIR_LIMITS
  if(t_si < dry_air_tmin .or. t_si > dry_air_tmax .or. &
  d_air_si <= dry_air_dmin .or. d_air_si > dry_air_dmax) then
    a_si = errorreturn
    t_si = errorreturn
    p_si = errorreturn
    d_air_si = errorreturn
    d_liq_si = errorreturn
    liq_ice_air_iter_at_wa_eta_wt = errorreturn
    return
  endif
endif

end function

!==========================================================================
function aux_airfraction_si(wa_si)
!==========================================================================

!FUNCTION RETURNS THE ESTIMATED DRY-AIR FRACTION A IN KG/KG OF HUMID AIR
!AT GIVEN DRY-AIR FRACTION WA IN KG/KG OF WET ICE AIR

!A = WA /(WA + WV)                   !DRY-AIR FRACTION OF HUMID AIR, WV = VAPOUR FRACTION
!WL = WET / (1D0 - WA / A)           !LIQUID FRACTION OF WET ICE AIR
!WI = (1D0 - WET) / (1D0 - WA / A)   !ICE FRACTION OF WET ICE AIR
!WA + WV + WL + WI = 1               !MASS BALANCE: AIR + VAPOUR + LIQUID + ICE = 100%

real*8 aux_airfraction_si, wa_si
real*8 wv

aux_airfraction_si = errorreturn

!WI+WL=WV, ROUGH GUESS FOR THE VAPOUR FRACTION WV, 50% OF THE WATER MAY BE VAPOUR
wv = 0.5d0 * (1d0 - wa_si)
if(wa_si + wv <= 0d0) return

aux_airfraction_si = wa_si / (wa_si + wv)

end function

!==========================================================================
function aux_pressure_si(a_si)
!==========================================================================

!FUNCTION RETURNS THE ESTIMATED TRIPLE-POINT PRESSURE IN PA AT GIVEN AIR FRACTION A_SI
!IN KG/KG OF THE HUMID-AIR PART

real*8 aux_pressure_si, a_si
real*8 xv
real*8 pt

pt = tp_pressure_iapws95_si

aux_pressure_si = errorreturn

!ASSUME THE PARTIAL VAPOUR PRESSURE = TRIPLE-POINT PRESSURE
xv = air_molfraction_vap_si(a_si)
if(xv == errorreturn) return
if(xv <= 0d0 .or. xv > 1d0) return

aux_pressure_si = pt / xv

end function

!==========================================================================
subroutine set_it_ctrl_liq_ice_air(key, value)
!==========================================================================

!THIS SUB SETS CONTROL PARAMETERS FOR THE ITERATION USED TO COMPUTE
!WET ICE AIR PROPERTIES

!KEY              VALUE
!IT_STEPS         0           SET ITERATION NUMBER TO DEFAULT (100)
!IT_STEPS         N > 0    SET ITERATION NUMBER TO N
!IT_STEPS        -1           DO NOT ITERATE, USE INITIAL VALUES

!INIT_AIR         0           USE DEFAULT AIR DENSITY TO START ( = RHO(CTRL_INIT_P, CTRL_INIT_T))
!INIT_AIR         D > 0    USE VALUE D AS AIR DENSITY TO START

!INIT_LIQ         0           USE DEFAULT LIQUID DENSITY TO START ( = RHO(CTRL_INIT_P, CTRL_INIT_T))
!INIT_LIQ         D > 0    USE VALUE D AS LIQUID DENSITY TO START

!INIT_HUM         0           USE DEFAULT AIR FRACTION TO START ( = AUX_AIRFRACTION_SI(WA_SI))
!INIT_HUM         A > 0    USE VALUE A AS AIR FRACTION TO START

!INIT_TEMP        0           USE DEFAULT TEMPERATURE TO START ( = TRIPLE POINT TEMPERATURE)
!INIT_TEMP        T > 0    USE VALUE T AS TEMPERATURE TO START

!INIT_PRESS       0           USE DEFAULT PRESSURE TO START ( = AUX_PRESSURE_SI(WA_SI))
!INIT_PRESS       P > 0    USE VALUE P AS PRESSURE TO START

!TOL_TEMP         0           USE DEFAULT EXIT ACCURACY FOR TEMPERATURE (0.1 PPM)
!TOL_TEMP         EPS         USE EPS AS EXIT ACCURACY FOR TEMPERATURE (EPS < 0 MEANS RELATIVE ERROR)

!TOL_PRESS        0           USE DEFAULT EXIT ACCURACY FOR PRESSURE (0.1 PPM)
!TOL_PRESS        EPS         USE EPS AS EXIT ACCURACY FOR PRESSURE (EPS < 0 MEANS RELATIVE ERROR)

character*13 key
real*8 value

call init_it_ctrl_liq_ice_air

call clear_liq_ice_air_state

select case (trim(key))

  case ("it_steps");               !ITERATION STEPS
    if(value == 0d0) then
      ctrl_loop_maximum = 100   !DEFAULT = 100
    elseif(value < 0d0) then
      ctrl_loop_maximum = -1
    else
      ctrl_loop_maximum = nint(value)
    endif

  case ("init_air");               !START AIR DENSITY
    if(value == 0d0) then
      ctrl_mode_air = 0         !DEFAULT = RHO(CTRL_INIT_P, CTRL_INIT_T)
    else
      ctrl_mode_air = 1
      ctrl_init_d_air = value
    endif
    
  case ("init_liq");               !START LIQUID WATER DENSITY
    if(value == 0d0) then
      ctrl_mode_liquid = 0      !DEFAULT = RHO(CTRL_INIT_P, CTRL_INIT_T)
    else
      ctrl_mode_liquid = 1
      ctrl_init_d_liq = value
    endif

  case ("init_hum");               !START AIR FRACTION
    if(value == 0d0) then
      ctrl_mode_humidity = 0    !DEFAULT = AUX FUNCTION
    else
      ctrl_mode_humidity = 1
      ctrl_init_a = value
    endif
    
  case ("init_temp");              !START TEMPERATURE
    if(value == 0d0) then
      ctrl_mode_temperature = 0 !DEFAULT = TRIPLE POINT TEMPERATURE
    else
      ctrl_mode_temperature = 1
      ctrl_init_t = value
    endif

  case ("init_press");             !START PRESSURE
    if(value == 0d0) then
      ctrl_mode_pressure = 0    !DEFAULT = AUX FUNCTION
    else
      ctrl_mode_pressure = 1
      ctrl_init_p = value
    endif

  case ("tol_temp");               !REQUIRED TEMPERATURE TOLERANCE
    if(value == 0d0) then
      ctrl_eps_exit_t = -0.0000001d0   !DEFAULT = 0.1 PPM RELATIVE
    else
      ctrl_eps_exit_t = value
    endif

  case ("tol_press");              !REQUIRED TOTAL PRESSURE TOLERANCE
    if(value == 0d0) then
      ctrl_eps_exit_p = -0.0000001d0   !DEFAULT = 0.1 PPM RELATIVE
    else
      ctrl_eps_exit_p = value
    endif

  case default; write(*,*)key,' not supported'

end select


end subroutine

!==========================================================================
subroutine clear_liq_ice_air_state()
!==========================================================================

!CLEARS THE CURRENT EQUILIBRIUM STATE DESCRIPTOR

equi_liq_ice_air_done = 0

end subroutine

!==========================================================================
subroutine set_liq_ice_air_state(a_si, t_si, p_si, d_air_si, d_liq_si, &
                                 wa_si, wet_si, eta_si)
!==========================================================================
                                  
!STORES THE ACTUAL PROPERTIES AS THE CURRENT EQUILIBRIUM STATE DESCRIPTOR

real*8 a_si, t_si, p_si, d_air_si, d_liq_si, wa_si, wet_si, eta_si

equi_liq_ice_air_done = isok

!INTENSIVE PROPERTIES, WELL DEFINED AT THE TRIPLE POINT
equi_liq_ice_air_a = a_si          !TRIPLE-POINT AIR FRACTION
equi_liq_ice_air_t = t_si          !TRIPLE-POINT TEMPERATURE
equi_liq_ice_air_p = p_si          !TRIPLE-POINT PRESSURE
equi_liq_ice_air_d_liq = d_liq_si   !DENSITY OF PURE WATER
equi_liq_ice_air_d_air = d_air_si   !DENSITY OF HUMID AIR

!"EXTENSIVE PROPERTIES", DEPEND ON ADDITIONAL CONSTRAINTS
!AND MAY BE UNDEFINED (I.E. = ERRORRETURN) IN CERTAIN COMPUTED STATES

equi_liq_ice_air_wa = wa_si        !DRY-AIR MASS FRACTION IN KG/KG OF WET ICE AIR
equi_liq_ice_air_wt = wet_si      !LIQUID-WATER MASS FRACTION IN KG/KG OF THE CONDENSED PART
equi_liq_ice_air_eta = eta_si      !TOTAL SPECIFIC ENTROPY OF THE PARCEL

end subroutine

!==========================================================================
subroutine init_it_ctrl_liq_ice_air()
!==========================================================================

real*8 tt, pt, dlt, dvt

tt = tp_temperature_si
pt = tp_pressure_iapws95_si
dlt = tp_density_liq_iapws95_si    !TRIPLE POINT DENSITY OF LIQUID WATER
dvt = tp_density_vap_iapws95_si    !TRIPLE POINT DENSITY OF WATER VAPOUR

if(ctrl_initialized == isok) return

ctrl_initialized = isok

!SET DEFAULT VALUES AND MODES FOR ITERATION
ctrl_mode_humidity = 0
ctrl_mode_liquid = 0
ctrl_mode_air = 0
ctrl_mode_temperature = 0
ctrl_mode_pressure = 0
ctrl_loop_maximum = 100

ctrl_init_a = 0.999d0
ctrl_init_t = tt
ctrl_init_p = pt
ctrl_init_d_liq = dlt
ctrl_init_d_air = dvt

ctrl_eps_exit_t = -0.0000001d0 !RELATIVE, 0.1 PPM
ctrl_eps_exit_p = -0.0000001d0 !RELATIVE, 0.1 PPM

end subroutine

end module liq_ice_air_4

module flu_2

!#########################################################################

!THIS MODULE IMPLEMENTS THERMODYNAMIC PROPERTIES OF PURE WATER
!AS FUNCTIONS OF ABSOLUTE TEMPERATURE IN K AND DENSITY IN KG/M3,
!COMPUTED FROM THE HELMHOLTZ FUNCTION FLU_F_SI(DRV_T, DRV_D, T_SI, D_SI)

!#########################################################################

!IMPLEMENTATION IN FORTRAN BY D.G. WRIGHT
!FOR PUBLICATION IN OCEAN SCIENCE, AS DESCRIBED IN THE PAPERS

!FEISTEL, R., WRIGHT, D.G., JACKETT, D.R., MIYAGAWA, K., REISSMANN, J.H.,
!WAGNER, W., OVERHOFF, U., GUDER, C., FEISTEL, A., MARION, G.M.:
!NUMERICAL IMPLEMENTATION AND OCEANOGRAPHIC APPLICATION OF THE THERMODYNAMIC
!POTENTIALS OF WATER, VAPOUR, ICE, SEAWATER AND AIR. PART I: BACKGROUND AND EQUATIONS. 
!OCEAN SCIENCES, 2009, IN PREPARATION.

!WRIGHT, D.G., FEISTEL, R., JACKETT, D.R., MIYAGAWA, K., REISSMANN, J.H., 
!WAGNER, W., OVERHOFF, U., GUDER, C., FEISTEL, A., MARION, G.M.:
!NUMERICAL IMPLEMENTATION AND OCEANOGRAPHIC APPLICATION OF THE THERMODYNAMIC
!POTENTIALS OF WATER, VAPOUR, ICE, SEAWATER AND AIR. PART II: THE LIBRARY ROUTINES, 
!OCEAN SCIENCES., 2009, IN PREPARATION.

!FEISTEL, R., KRETZSCHMAR, H.-J., SPAN, R., HAGEN, E., !WRIGHT, D.G., JACKETT, D.R.:
!THERMODYNAMIC PROPERTIES OF SEA AIR.
!OCEAN SCIENCE DISCUSSION 6(2009)2193-2325.

!#########################################################################

!THIS MODULE REQUIRES THE LIBRARY MODULES
!     CONSTANTS_0,     FILE CONSTANTS_0.F90
!     FLU_1 (IAPWS95), FILE FLU_1.F90 

!#########################################################################

use constants_0
use flu_1

implicit none
private

character*16, private :: version = '8 Jun 2010'

public :: flu_cp_si, flu_cv_si, flu_enthalpy_si, flu_entropy_si, &
          flu_expansion_si, flu_gibbs_energy_si, flu_internal_energy_si, &
          flu_kappa_s_si, flu_kappa_t_si, flu_lapserate_si, flu_pressure_si, &
          flu_soundspeed_si

contains

!*******************************************************************
function flu_cp_si(t_si, d_si)
!*******************************************************************

implicit none 

real*8 t_si, d_si, flu_cp_si
real*8 temp, f_d, f_dd, f_td, f_tt

!OUTPUT:
!CP(T,D) = T * (DETA/DT)_P 
!        = ISOBARIC HEAT CAPACITY IN J/(KG*K)

!INPUTS:
!T_SI      ABSOLUTE TEMPERATURE IN K,
!D_SI      ABSOLUTE DENSITY IN KG/M3

!CHECK VALUE: flu_cp_si(300,1000) = 4159.37519963

flu_cp_si = errorreturn

f_d  = flu_f_si(0, 1, t_si, d_si)
if(f_d == errorreturn) return
f_dd = flu_f_si(0, 2, t_si, d_si)
if(f_dd == errorreturn) return
f_td = flu_f_si(1, 1, t_si, d_si)
if(f_td == errorreturn) return
f_tt = flu_f_si(2, 0, t_si, d_si)
if(f_tt == errorreturn) return

temp = 2d0*f_d + d_si*f_dd
if(temp == 0d0) return

flu_cp_si = t_si * (f_td**2*d_si/temp - f_tt)

end function

!*******************************************************************
function flu_cv_si(t_si, d_si)
!*******************************************************************

implicit none 

real*8 t_si, d_si, flu_cv_si
real*8 f_tt

!OUTPUT:
!CV(T,D) = T * (DETA/DT)_D 
!        = ISOCHORIC HEAT CAPACITY IN J/(KG*K)

!INPUTS:
!T_SI      ABSOLUTE TEMPERATURE IN K,
!D_SI      ABSOLUTE DENSITY IN KG/M3

!CHECK VALUE: flu_cv_si(300,1000) = 4105.20614776

flu_cv_si = errorreturn

f_tt = flu_f_si(2, 0, t_si, d_si)
if(f_tt == errorreturn) return

flu_cv_si = -t_si * f_tt

end function

!*******************************************************************
function flu_enthalpy_si(t_si, d_si)
!*******************************************************************

implicit none 

real*8 t_si, d_si, flu_enthalpy_si
real*8 f, f_t, f_d

!OUTPUT:
!H(T,D) = F - T*(DF/DT)_D + D*(DF/DD)_T ENTHALPY IN J/KG

!INPUTS:
!T_SI      ABSOLUTE TEMPERATURE IN K
!D_SI      ABSOLUTE DENSITY IN KG/M3

!CHECK VALUE: flu_enthalpy_si(300,1000) = 119752.511434

flu_enthalpy_si = errorreturn

f = flu_f_si(0, 0, t_si, d_si)
if(f == errorreturn) return
f_t = flu_f_si(1, 0, t_si, d_si)
if(f_t == errorreturn) return
f_d = flu_f_si(0, 1, t_si, d_si)
if(f_d == errorreturn) return

flu_enthalpy_si = f - t_si * f_t + d_si * f_d

end function

!*******************************************************************
function flu_entropy_si(t_si, d_si)
!*******************************************************************

implicit none 

real*8 t_si, d_si, flu_entropy_si
real*8 f_t

!OUTPUT:
!S(T,D) = - (DF/DT)_D ENTROPY IN J/KG K

!INPUTS:
!T_SI      ABSOLUTE TEMPERATURE IN K
!D_SI      ABSOLUTE DENSITY IN KG/M3

!CHECK VALUE: flu_entropy_si(300,1000) = 390.904170767

flu_entropy_si = errorreturn

f_t = flu_f_si(1, 0, t_si, d_si)
if(f_t == errorreturn) return

flu_entropy_si = -flu_f_si(1, 0, t_si, d_si)

end function

!*******************************************************************
function flu_expansion_si(t_si, d_si)
!*******************************************************************

implicit none 

real*8 t_si, d_si, flu_expansion_si
real*8 temp, f_d, f_dd, f_td

!OUTPUT:
!THERMAL EXPANSION COEFFICIENT IN 1/K

!INPUTS:
!T_SI      ABSOLUTE TEMPERATURE IN K
!D_SI      ABSOLUTE DENSITY IN KG/M3

!CHECK VALUE: flu_expansion_si(300,1000) = 2.82413312531E-04

flu_expansion_si = errorreturn

f_d = flu_f_si(0, 1, t_si, d_si)
if(f_d == errorreturn) return
f_td = flu_f_si(1, 1, t_si, d_si)
if(f_td == errorreturn) return
f_dd = flu_f_si(0, 2, t_si, d_si)
if(f_dd == errorreturn) return

temp = 2d0*f_d + d_si*f_dd
if(temp == 0d0) return

flu_expansion_si = f_td/temp

end function

!*******************************************************************
function flu_gibbs_energy_si(t_si, d_si)
!*******************************************************************

implicit none 

real*8 t_si, d_si, flu_gibbs_energy_si
real*8 f, f_d

!OUTPUT:
!G(T,D) = F + D*(DF/DD)_T   GIBBS ENERGY IN J/KG

!INPUTS:
!T_SI      ABSOLUTE TEMPERATURE IN K,
!D_SI      ABSOLUTE DENSITY IN KG/M3

!CHECK VALUE: flu_gibbs_energy_si(300,1000) = 2481.26020392

flu_gibbs_energy_si = errorreturn

f = flu_f_si(0, 0, t_si, d_si)
if(f == errorreturn) return
f_d = flu_f_si(0, 1, t_si, d_si)
if(f_d == errorreturn) return

flu_gibbs_energy_si = f + d_si * f_d

end function

!*******************************************************************
function flu_internal_energy_si(t_si, d_si)
!*******************************************************************

implicit none 

real*8 t_si, d_si, flu_internal_energy_si
real*8 f, f_t

!OUTPUT:
!U(T,D) = F - T*(DF/DT)_D INTERNAL ENERGY IN J/KG

!INPUTS:
!T_SI      ABSOLUTE TEMPERATURE IN K
!D_SI      ABSOLUTE DENSITY IN KG/M3

!CHECK VALUE: flu_internal_energy_si(300,1000) = 111919.510078

flu_internal_energy_si = errorreturn

f = flu_f_si(0, 0, t_si, d_si)
if(f == errorreturn) return
f_t = flu_f_si(1, 0, t_si, d_si)
if(f_t == errorreturn) return

flu_internal_energy_si = f - t_si * f_t

end function

!*******************************************************************
function flu_kappa_s_si(t_si, d_si)
!*******************************************************************

implicit none 

real*8 t_si, d_si, flu_kappa_s_si
real*8 f_d, f_tt, f_td, f_dd, temp

!OUTPUT:
!KAPPA_S(T,D) = (1/D) * (DD/DP)_ETA 
!             = ISENTROPIC COMPRESSIBILITY IN 1/PA

!INPUTS:
!T_SI      ABSOLUTE TEMPERATURE IN K
!D_SI      ABSOLUTE DENSITY IN KG/M3

!CHECK VALUE: flu_kappa_s_si(300,1000) = 4.35960581171E-10

flu_kappa_s_si = errorreturn

f_d = flu_f_si(0, 1, t_si, d_si)
if(f_d == errorreturn) return
f_tt = flu_f_si(2, 0, t_si, d_si)
if(f_tt == errorreturn) return
f_td = flu_f_si(1, 1, t_si, d_si)
if(f_td == errorreturn) return
f_dd = flu_f_si(0, 2, t_si, d_si)
if(f_dd == errorreturn) return

temp = f_tt*(2d0*f_d+d_si*f_dd)-d_si*f_td**2
if(temp == 0d0) return

flu_kappa_s_si = f_tt/d_si**2 / temp

end function

!*******************************************************************
function flu_kappa_t_si(t_si, d_si)
!*******************************************************************

implicit none 

real*8 t_si, d_si, flu_kappa_t_si
real*8 temp, f_d, f_dd

!OUTPUT:
!ISOTHERMAL COMPRESSIBILITY IN 1/PA

!INPUTS:
!T_SI      ABSOLUTE TEMPERATURE IN K
!D_SI      ABSOLUTE DENSITY IN KG/M3

!CHECK VALUE: flu_kappa_t_si(300,1000) = 4.41713172024E-10

flu_kappa_t_si = errorreturn

f_d = flu_f_si(0, 1, t_si, d_si)
if(f_d == errorreturn) return
f_dd = flu_f_si(0, 2, t_si, d_si)
if(f_dd == errorreturn) return

temp = 2d0*f_d + d_si*f_dd
if(temp == 0d0 .or. d_si == 0d0) return

flu_kappa_t_si = 1d0/(d_si**2*temp)

end function

!*******************************************************************
function flu_lapserate_si(t_si, d_si)
!*******************************************************************

implicit none 

real*8 t_si, d_si, flu_lapserate_si
real*8 temp, f_d, f_tt, f_dd, f_td

!OUTPUT:
!GAMMA(T,D) = (DT/DP)_ETA  
!           = ADIABATIC LAPSE RATE IN K/PA

!INPUTS:
!T_SI      ABSOLUTE TEMPERATURE IN K
!D_SI      ABSOLUTE DENSITY IN KG/M3

!CHECK VALUE: flu_lapserate_si(300,1000) = 2.0369403983|3E-08

flu_lapserate_si = errorreturn

f_d  = flu_f_si(0, 1, t_si, d_si)
if(f_d == errorreturn) return
f_tt = flu_f_si(2, 0, t_si, d_si)
if(f_tt == errorreturn) return
f_td = flu_f_si(1, 1, t_si, d_si)
if(f_td == errorreturn) return
f_dd = flu_f_si(0, 2, t_si, d_si)
if(f_dd == errorreturn) return

temp = d_si*f_td**2-f_tt*(2d0*f_d + d_si*f_dd)
if(temp == 0d0 .or. d_si == 0d0) return

flu_lapserate_si = (f_td/d_si)/temp

end function

!*******************************************************************
function flu_pressure_si(t_si, d_si)
!*******************************************************************

implicit none 

real*8 t_si, d_si, flu_pressure_si
real*8 f_d

!OUTPUT:
!P(T,D) = D^2*(df/dD)_T PRESSURE IN PA

!INPUTS:
!T_SI      ABSOLUTE TEMPERATURE IN K
!D_SI      ABSOLUTE DENSITY IN KG/M3

!CHECK VALUE: flu_pressure_si(300,1000) = 7833001.35597

flu_pressure_si = errorreturn

f_d = flu_f_si(0, 1, t_si, d_si)
if(f_d == errorreturn) return

flu_pressure_si = d_si**2 * f_d

end function

!*******************************************************************
function flu_soundspeed_si(t_si, d_si)
!*******************************************************************

implicit none 

real*8 t_si, d_si, flu_soundspeed_si
real*8 f_d, f_tt, f_td, f_dd, c2

!OUTPUT:
!C(T,D) = SQRT[ (DP/DD)_ETA ] SOUND SPEED IN M/S

!INPUTS:
!T_SI      ABSOLUTE TEMPERATURE IN K
!D_SI      ABSOLUTE DENSITY IN KG/M3

!CHECK VALUE: flu_soundspeed_si(300,1000) = 1514.52479780

flu_soundspeed_si = errorreturn

f_d = flu_f_si(0, 1, t_si, d_si)
if(f_d == errorreturn) return
f_tt = flu_f_si(2, 0, t_si, d_si)
if(f_tt == errorreturn) return
f_td = flu_f_si(1, 1, t_si, d_si)
if(f_td == errorreturn) return
f_dd = flu_f_si(0, 2, t_si, d_si)
if(f_dd == errorreturn) return

c2 = 2d0*d_si*f_d + d_si**2*(f_dd - f_td**2/f_tt)

if(c2 < 0d0)return

flu_soundspeed_si = sqrt(c2)

end function

end module flu_2

module sea_ice_4

!#########################################################################

!THIS MODULE IMPLEMENTS THE PHASE EQUILBRIA PROPERTIES OF ICE WITH SEAWATER
!COMPUTED FROM IAPWS-95, IAPWS-06 AND IAPWS-08:

!RELEASE ON THE IAPWS FORMULATION 1995 FOR THE THERMODYNAMIC PROPERTIES OF
!ORDINARY WATER SUBSTANCE FOR GENERAL AND SCIENTIFIC USE
!THE INTERNATIONAL ASSOCIATION FOR THE PROPERTIES OF WATER AND STEAM
!FREDERICIA, DENMARK, SEPTEMBER 1996

!RELEASE ON AN EQUATION OF STATE FOR H2O ICE IH
!THE INTERNATIONAL ASSOCIATION FOR THE PROPERTIES OF WATER AND STEAM
!WITNEY, UK, SEPTEMBER 2006

!RELEASE ON THE IAPWS FORMULATION 2008 FOR THE THERMODYNAMIC PROPERTIES OF SEAWATER
!THE INTERNATIONAL ASSOCIATION FOR THE PROPERTIES OF WATER AND STEAM
!BERLIN, GERMANY, SEPTEMBER 2008

!#########################################################################

!IMPLEMENTATION IN FORTRAN BY D.G. WRIGHT
!FOR PUBLICATION IN OCEAN SCIENCE, AS DESCRIBED IN THE PAPERS

!FEISTEL, R., WRIGHT, D.G., JACKETT, D.R., MIYAGAWA, K., REISSMANN, J.H.,
!WAGNER, W., OVERHOFF, U., GUDER, C., FEISTEL, A., MARION, G.M.:
!NUMERICAL IMPLEMENTATION AND OCEANOGRAPHIC APPLICATION OF THE THERMODYNAMIC
!POTENTIALS OF WATER, VAPOUR, ICE, SEAWATER AND AIR. PART I: BACKGROUND AND EQUATIONS. 
!OCEAN SCIENCES, 2009, IN PREPARATION.

!WRIGHT, D.G., FEISTEL, R., JACKETT, D.R., MIYAGAWA, K., REISSMANN, J.H., 
!WAGNER, W., OVERHOFF, U., GUDER, C., FEISTEL, A., MARION, G.M.:
!NUMERICAL IMPLEMENTATION AND OCEANOGRAPHIC APPLICATION OF THE THERMODYNAMIC
!POTENTIALS OF WATER, VAPOUR, ICE, SEAWATER AND AIR. PART II: THE LIBRARY ROUTINES, 
!OCEAN SCIENCES., 2009, IN PREPARATION.

!FEISTEL, R., KRETZSCHMAR, H.-J., SPAN, R., HAGEN, E., WRIGHT, D.G., JACKETT, D.R.:
!THERMODYNAMIC PROPERTIES OF SEA AIR.
!OCEAN SCIENCE DISCUSSION 6(2009)2193-2325.

!#########################################################################

!THIS MODULE REQUIRES THE LIBRARY MODULES:
!     CONSTANTS_0,  FILE CONSTANTS_0.F90
!     CONVERT_0,    FILE CONVERT_0.F90
!     MATHS_0,      FILE MATHS_0.F90
!     FLU_1,        FILE FLU_1.F90
!     ICE_1,        FILE ICE_1.F90
!     SAL_1,        FILE SAL_1.F90
!     ICE_2,        FILE ICE_2.F90
!     SAL_2,        FILE SAL_2.F90
!     FLU_3A,       FILE FLU_3A.F90
!     FLU_3B,       FILE FLU_3B.F90
!     SEA_3A,       FILE SEA_3A.F90

!NESTED USE ASSOCIATIONS
!     FLU_2,        FILE FLU_2.F90

!#########################################################################

use constants_0
use convert_0
use maths_0
use flu_1
use ice_1
use sal_1
use ice_2
use sal_2
use flu_3a
use flu_3b
use sea_3a

implicit none
private

character*16, private :: version = '8 Jun 2010'

public :: sea_ice_brinefraction_seaice_si, sea_ice_brinesalinity_si, &
          sea_ice_cp_seaice_si, sea_ice_density_ice_si, &
          sea_ice_density_sea_si, sea_ice_density_seaice_si, &
          sea_ice_dtfdp_si, sea_ice_dtfds_si, &
          sea_ice_enthalpy_ice_si, sea_ice_enthalpy_melt_si, &
          sea_ice_enthalpy_sea_si, sea_ice_enthalpy_seaice_si, &
          sea_ice_entropy_ice_si, sea_ice_entropy_sea_si, &
          sea_ice_entropy_seaice_si, sea_ice_expansion_seaice_si, &
          sea_ice_freezingtemperature_si, sea_ice_g_si, &
          sea_ice_kappa_t_seaice_si, sea_ice_meltingpressure_si, &
          sea_ice_pressure_si, sea_ice_salinity_si, &
          sea_ice_temperature_si, sea_ice_volume_melt_si, &
          set_it_ctrl_sea_ice, set_sea_ice_eq_at_s_p, &
          set_sea_ice_eq_at_s_t, set_sea_ice_eq_at_t_p

integer, private :: equi_sea_ice_done
integer, private :: ctrl_loop_maximum, ctrl_mode_sea, ctrl_mode_temperature, &
         ctrl_mode_liquid, ctrl_initialized
real*8, private :: ctrl_init_s_sea, ctrl_init_t, ctrl_init_d_liq, &
        ctrl_eps_exit_s, ctrl_eps_exit_t, ctrl_eps_exit_p
real*8, private :: equi_sea_ice_s, equi_sea_ice_t, equi_sea_ice_p, &
        equi_sea_ice_d_liq

contains

!==========================================================================
function sea_ice_brinesalinity_si(t_si, p_si)
!==========================================================================

implicit none
real*8 sea_ice_brinesalinity_si, t_si, p_si

!THIS FUNCTION RETURNS THE ABSOLUTE SALINITY IN KG/KG OF BRINE POCKETS AT THE
!ABSOLUTE TEMPERATURE T_SI IN K AND THE ABSOLUTE PRESSURE P_SI IN PA

!NOTE: THE ACCURACY OF THIS FUNCTION DEPENDS ON THE ITERATION SETTINGS OF THIS MODULE

!CHECK VALUE WITH DEFAULT SETTINGS: 
!SEA_ICE_BRINESALINITY_SI(270, 1E5) = 0.0560264150322

sea_ice_brinesalinity_si = errorreturn

if(set_sea_ice_eq_at_t_p(t_si, p_si) == errorreturn) return

sea_ice_brinesalinity_si = equi_sea_ice_s

end function

!=========================================================================
function sea_ice_brinefraction_seaice_si(ssi_si, t_si, p_si)
!==========================================================================

!OUTPUT:   
!W(SSI,T,P) = SSI/S(T,P)  MASS FRACTION OF BRINE IN SEA ICE (0 < W < 1)

!INPUT:
!SSI_SI    ABSOLUTE SEA-ICE SALINITY IN KG/KG
!T_SI      ABSOLUTE TEMPERATURE IN K
!p_si      ABSOLUTE PRESSURE IN PA

!CHECK VALUE WITH DEFAULT SETTINGS: 
!SEA_ICE_BRINEFRACTION_SEAICE_SI(0.035, 270, 1E5) = 0.624705328368

!NOTE: THE ACCURACY OF THIS FUNCTION DEPENDS ON THE ITERATION SETTINGS OF THIS MODULE

implicit none
real*8 sea_ice_brinefraction_seaice_si, ssi_si, t_si, p_si
real*8 s

sea_ice_brinefraction_seaice_si = errorreturn

if(ssi_si < 0d0 .or. ssi_si >= 1d0) return
if(t_si <= 0d0) return
if(p_si <= 0d0) return

s = sea_ice_brinesalinity_si(t_si, p_si)
if(s == errorreturn) return
if(s <= ssi_si) return

sea_ice_brinefraction_seaice_si = ssi_si / s

end function

!==========================================================================
function sea_ice_meltingpressure_si(sa_si, t_si)
!==========================================================================

!THIS FUNCTION RETURNS THE ABSOLUTE PRESSURE IN PA AT WHICH ICE MELTS AT THE
!ABSOLUTE TEMPERATURE T_SI IN K AND THE AMBIENT SEAWATER SALINITY SA_SI IN KG/KG

!NOTE: THE ACCURACY OF THIS FUNCTION DEPENDS ON THE ITERATION SETTINGS OF THIS MODULE

!CHECK VALUE WITH DEFAULT SETTINGS: 
!SEA_ICE_MELTINGPRESSURE_SI(0.035, 270) = 16132047.4385

implicit none
real*8 sea_ice_meltingpressure_si, sa_si, t_si

sea_ice_meltingpressure_si = errorreturn

if(set_sea_ice_eq_at_s_t(sa_si, t_si) == errorreturn) return

sea_ice_meltingpressure_si = equi_sea_ice_p

end function

!==========================================================================
function sea_ice_freezingtemperature_si(sa_si, p_si)
!==========================================================================

!THIS FUNCTION RETURNS THE ABSOLUTE TEMPERATURE IN K AT WHICH SEAWATER WITH
!ABSOLUTE SALINITY SA_SI IN KG/KG FREEZES AT THE ABSOLUTE PRESSURE P IN PA

!CHECK VALUE WITH DEFAULT SETTINGS: 
!SEA_ICE_FREEZINGTEMPERATURE_SI(0.035, 1E5) = 271.240373585

!NOTE: THE ACCURACY OF THIS FUNCTION DEPENDS ON THE ITERATION SETTINGS OF THIS MODULE

implicit none
real*8 sea_ice_freezingtemperature_si, sa_si, p_si

sea_ice_freezingtemperature_si = errorreturn

if(set_sea_ice_eq_at_s_p(sa_si, p_si) == errorreturn) return

sea_ice_freezingtemperature_si = equi_sea_ice_t

end function

!==========================================================================
function sea_ice_dtfdp_si(sa_si, p_si)
!==========================================================================

!CLAUSIUS-CLAPEYRON: FREEZING POINT LOWERING DUE TO PRESSURE, DT/DP

!CHECKVALUE: SEA_ICE_DTDP_SI(0.035,1E5) = 7.48210942879E-08

real*8 sea_ice_dtfdp_si, sa_si, p_si
real*8 tf, s_t, s_p

sea_ice_dtfdp_si = ErrorReturn

tf = sea_ice_freezingtemperature_si(sa_si, p_si)
if(tf == errorreturn) return
s_t = sea_ice_s_si(1, 0, tf, p_si)
if(s_t == errorreturn .or. s_t == 0d0) return
s_p = sea_ice_s_si(0, 1, tf, p_si)
if(s_p == errorreturn) return

sea_ice_dtfdp_si = s_p / s_t

end function

!==========================================================================
function sea_ice_dtfds_si(sa_si, p_si)
!==========================================================================

!RAOULT'S LAW: FREEZING POINT LOWERING DUE TO SALT, DT/DS

!CHECKVALUE: SEA_ICE_DTDS_SI(0.035,1E5) = -56.8751336296

real*8 sea_ice_dtfds_si, sa_si, p_si
real*8 tf, s_t

sea_ice_dtfds_si = errorreturn

tf = sea_ice_freezingtemperature_si(sa_si, p_si)
if(tf == errorreturn) return
s_t = sea_ice_s_si(1, 0, tf, p_si)
if(s_t == errorreturn .or. s_t == 0) return

sea_ice_dtfds_si = 1d0 / s_t

End Function

!==========================================================================
function sea_ice_g_si(drv_s, drv_t, drv_p, s_si, t_si, p_si)
!==========================================================================

!OUTPUT: 
!THE S-T-P DERIVATIVE (D/DS)^DRV_S (D/DT)^DRV_T (D/DP)^DRV_P GSI(S,T,P)
!OF THE GIBBS FUNCTION GSI OF SEA ICE, AS A FUNCTION OF SEA-ICE SALINITY IN KG/KG,
!ABSOLUTE TEMPERATURE IN K AND ABSOLUTE PRESSURE IN PA

! GSI(S,T,P) = (1-W) * GIH(T,P) + W * GSW(SB(T,P),T,P)

! W = MASS FRACTION OF BRINE, W(S, T, P) = S/SB(T,P)
! SB = BRINE SALINITY

!INPUT:
!S_SI = S = ABSOLUTE SEA-ICE SALINITY IN KG/KG, I.E. THE MASS FRACTION OF SALT IN SEA ICE
!T_SI  = T = ABSOLUTE TEMPERATURE IN K, ITS-90
!P_SI  = P = ABSOLUTE PRESSURE IN PA
!SAL_G_SI  = SPECIFIC GIBBS ENERGY IN J/KG

!CHECK VALUES WITH DEFAULT SETTINGS:
!SEA_ICE_G_SI( 0, 0, 0, 0.035, 270, 1E5) =-414.017574547
!SEA_ICE_G_SI( 1, 0, 0, 0.035, 270, 1E5) = 96363.7730495
!SEA_ICE_G_SI( 0, 1, 0, 0.035, 270, 1E5) = 500.44544418|1
!SEA_ICE_G_SI( 0, 0, 1, 0.035, 270, 1E5) = 1.00689072300E-03
!SEA_ICE_G_SI( 2, 0, 0, 0.035, 270, 1E5) = 0
!SEA_ICE_G_SI( 1, 1, 0, 0.035, 270, 1E5) =-1144.02883419
!SEA_ICE_G_SI( 1, 0, 1, 0.035, 270, 1E5) =-8.62856321467E-04
!SEA_ICE_G_SI( 0, 2, 0, 0.035, 270, 1E5) =-232.847783380
!SEA_ICE_G_SI( 0, 1, 1, 0.035, 270, 1E5) =-1.6586644669|4E-05
!SEA_ICE_G_SI( 0, 0, 2, 0.035, 270, 1E5) =-1.5759193211|8E-12

!NOTE: THE ACCURACY OF THIS FUNCTION DEPENDS ON THE ITERATION SETTINGS OF THIS MODULE

implicit none
integer drv_t, drv_s, drv_p
real*8 sea_ice_g_si, s_si, t_si, p_si
real*8 g, s, w, d
real*8 gb, gi
real*8 gb_p, gi_p
real*8 gb_t, gi_t
real*8 gb_pp, gi_pp, gm_pp
real*8 gb_tp, gi_tp, gm_tp
real*8 gb_tt, gi_tt, gm_tt
real*8 gb_s, gb_sp, gb_st
real*8 s_p, s_t

sea_ice_g_si = errorreturn
g = errorreturn
d = errorreturn

if(s_si < 0d0 .or. s_si >= 1d0) return
if(t_si <= 0d0) return
if(p_si <= 0d0) return

if(drv_s < 0) return
if(drv_t < 0) return
if(drv_p < 0) return
if(drv_s + drv_t +drv_p > 2) return

if(drv_s > 1) then       !G IS LINEAR IN S_SI
  sea_ice_g_si = 0d0
  return
end if

if(set_sea_ice_eq_at_t_p(t_si, p_si) == errorreturn) return

s = sea_ice_salinity_si()   !BRINE SALINITY
if(s == errorreturn) return
if(s <= 0d0 .or. s >= 1d0) return
if(s < s_si) return

w = s_si / s                !LIQUID MASS FRACTION OF SEA ICE

if(drv_t + drv_p > 1) then
  d = sal_dilution_si(s, t_si, p_si)
end if

select case (drv_s)

  case (0)
    select case (drv_t)

      case (0)     !D/DT
        select case (drv_p)

          case (0)
            gb = sea_g_si(0, 0, 0, s, t_si, p_si)
            if(gb == errorreturn) return
            gi = ice_g_si(0, 0, t_si, p_si)
            if(gi == errorreturn) return
            g = (1d0 - w) * gi + w * gb                    !G

          case (1) 
            gb_p = sea_g_si(0, 0, 1, s, t_si, p_si)
            if(gb_p == errorreturn) return
            gi_p = ice_g_si(0, 1, t_si, p_si)
            if(gi_p == errorreturn) return
            g = (1d0 - w) * gi_p + w * gb_p                !V = G_P

          case (2) 
            s_p = sea_ice_s_si(0, 1, t_si, p_si)
            if(s_p == errorreturn) return
            gm_pp = -d * s_p ** 2 / s                      !LATENT DERIVATIVE
            gb_pp = sea_g_si(0, 0, 2, s, t_si, p_si)
            if(gb_pp == errorreturn) return
            gi_pp = ice_g_si(0, 2, t_si, p_si)
            if(gi_pp == errorreturn) return
            g = (1d0 - w) * gi_pp + w * (gb_pp + gm_pp)    !G_PP

          case default; return
        end select

      case (1)     !D/DT

        select case (drv_p)

          case (0) 
            gb_t = sea_g_si(0, 1, 0, s, t_si, p_si)
            if(gb_t == errorreturn) return
            gi_t = ice_g_si(1, 0, t_si, p_si)
            if(gi_t == errorreturn) return
            g = (1d0 - w) * gi_t + w * gb_t                !-ETA = G_T

          case (1) 
            s_t = sea_ice_s_si(1, 0, t_si, p_si)
            if(s_t == errorreturn) return
            s_p = sea_ice_s_si(0, 1, t_si, p_si)
            if(s_p == errorreturn) return
            gm_tp = -d * s_t * s_p / s                     !LATENT DERIVATIVE
            gb_tp = sea_g_si(0, 1, 1, s, t_si, p_si)
            if(gb_tp == errorreturn) return
            gi_tp = ice_g_si(1, 1, t_si, p_si)
            if(gi_tp == errorreturn) return
            g = (1d0 - w) * gi_tp + w * (gb_tp + gm_tp)    !G_TP

          case default; return
        end select

      case (2)     !D2/DT2
        select case (drv_p)

          case (0) 
            s_t = sea_ice_s_si(1, 0, t_si, p_si)
            if(s_t == errorreturn) return
            gm_tt = -d * s_t ** 2 / s                      !LATENT DERIVATIVE
            gb_tt = sea_g_si(0, 2, 0, s, t_si, p_si)
            if(gb_tt == errorreturn) return
            gi_tt = ice_g_si(2, 0, t_si, p_si)
            if(gi_tt == errorreturn) return
            g = (1d0 - w) * gi_tt + w * (gb_tt + gm_tt)    !G_TT

          case default; return
        end select

       case default; return
    end select

  case (1)       !D/DS
  
    select case (drv_t)
    
      case (0)
        select case (drv_p)

          case (0) 
            g = sal_g_si(1, 0, 0, s, t_si, p_si)           !G_S

          case (1) 
            gb_sp = sal_g_si(1, 0, 1, s, t_si, p_si)       !G_SP
            if(gb_sp == errorreturn) return
            gb_s = sal_g_si(1, 0, 0, s, t_si, p_si)
            if(gb_s == errorreturn) return
            s_p = sea_ice_s_si(0, 1, t_si, p_si)
            if(s_p == errorreturn) return
            g = gb_sp + gb_s * s_p

          case default; return
        end select

      case (1)   !D2/DSDT

        select case (drv_p)

          case (0) 
            gb_st = sal_g_si(1, 1, 0, s, t_si, p_si)       !G_ST
            if(gb_st == errorreturn) return
            gb_s = sal_g_si(1, 0, 0, s, t_si, p_si)
            if(gb_s == errorreturn) return
            s_t = sea_ice_s_si(1, 0, t_si, p_si)
            if(s_t == errorreturn) return
            g = gb_st + gb_s * s_t

          case default; return
        end select

       case default; return
    end select
end select

sea_ice_g_si = g

end function

!=========================================================================
function sea_ice_cp_seaice_si(ssi_si, t_si, p_si)
!==========================================================================

!OUTPUT:   
!CP(SSI,T,P) = T * (D2G/DT2)_SSI_P ISOBARIC HEAT CAPACITY OF SEA ICE IN J/(KG K),

!INPUT:
!SSI_SI    ABSOLUTE SEA-ICE SALINITY IN KG/KG
!T_SI      ABSOLUTE TEMPERATURE IN K
!P_SI      ABSOLUTE PRESSURE IN PA

!CHECK VALUE WITH DEFAULT SETTINGS: 
!SEA_ICE_CP_SEAICE_SI(0.035, 270, 1E5) = 62868.9015126

!NOTE: THE ACCURACY OF THIS FUNCTION DEPENDS ON THE ITERATION SETTINGS OF THIS MODULE

implicit none
real*8 sea_ice_cp_seaice_si, ssi_si, t_si, p_si
real*8 g_tt

sea_ice_cp_seaice_si = errorreturn

if(ssi_si < 0d0 .or. ssi_si >= 1d0) return
if(t_si <= 0d0) return
if(p_si <= 0d0) return

g_tt = sea_ice_g_si(0, 2, 0, ssi_si, t_si, p_si)
if(g_tt == errorreturn) return

sea_ice_cp_seaice_si = -t_si * g_tt

end function

!=========================================================================
function sea_ice_density_seaice_si(ssi_si, t_si, p_si)
!==========================================================================

!OUTPUT:   
!D(SSI,T,P) = 1/(DG/DP)_SSI_T  DENSITY OF SEA ICE IN KG/M3

!INPUT:
!ssi_si    ABSOLUTE SEA-ICE SALINITY IN KG/KG
!T_SI      ABSOLUTE TEMPERATURE IN K
!p_si      ABSOLUTE PRESSURE IN PA

!CHECK VALUE WITH DEFAULT SETTINGS: 
!SEA_ICE_DENSITY_SEAICE_SI(0.035, 270, 1E5) = 993.156434117

!NOTE: THE ACCURACY OF THIS FUNCTION DEPENDS ON THE ITERATION SETTINGS OF THIS MODULE

implicit none
real*8 sea_ice_density_seaice_si, ssi_si, t_si, p_si
real*8 g_p

sea_ice_density_seaice_si = errorreturn

if(ssi_si < 0d0 .or. ssi_si >= 1d0) return
if(t_si <= 0d0) return
if(p_si <= 0d0) return

g_p = sea_ice_g_si(0, 0, 1, ssi_si, t_si, p_si)
if(g_p == errorreturn) return
if(g_p <= 0d0) return

sea_ice_density_seaice_si = 1d0 / g_p

end function

!=========================================================================
function sea_ice_enthalpy_seaice_si(ssi_si, t_si, p_si)
!==========================================================================

!OUTPUT:   
!H(SSI,T,P) = G - T * (DG/DT)_SSI_P  ENTHALPY OF SEA ICE IN J/KG

!INPUT:
!SSI_SI    ABSOLUTE SEA-ICE SALINITY IN KG/KG
!T_SI      ABSOLUTE TEMPERATURE IN K
!P_SI      ABSOLUTE PRESSURE IN PA

!CHECK VALUE WITH DEFAULT SETTINGS: 
!SEA_ICE_ENTHALPY_SEAICE_SI(0.035, 270, 1E5) = -135534.287503

!NOTE: THE ACCURACY OF THIS FUNCTION DEPENDS ON THE ITERATION SETTINGS OF THIS MODULE

implicit none
real*8 sea_ice_enthalpy_seaice_si, ssi_si, t_si, p_si
real*8 g, g_t

sea_ice_enthalpy_seaice_si = errorreturn

if(ssi_si < 0d0 .or. ssi_si >= 1d0) return
if(t_si <= 0d0) return
if(p_si <= 0d0) return

g = sea_ice_g_si(0, 0, 0, ssi_si, t_si, p_si)
if(g == errorreturn) return
g_t = sea_ice_g_si(0, 1, 0, ssi_si, t_si, p_si)
if(g_t == errorreturn) return

sea_ice_enthalpy_seaice_si = g - t_si * g_t

end function

!=========================================================================
function sea_ice_entropy_seaice_si(ssi_si, t_si, p_si)
!==========================================================================

!OUTPUT:   
!ETA(SSI,T,P) = - (DGSI/DT)_SSI_P  ENTROPY OF SEA ICE IN J/(KG K)

!INPUT:
!SSI_SI    ABSOLUTE SEA-ICE SALINITY IN KG/KG
!T_SI      ABSOLUTE TEMPERATURE IN K
!P_SI      ABSOLUTE PRESSURE IN PA

!CHECK VALUE WITH DEFAULT SETTINGS: 
!SEA_ICE_ENTROPY_SEAICE_SI(0.035, 270, 1E5) = -500.44544418|1

!NOTE: THE ACCURACY OF THIS FUNCTION DEPENDS ON THE ITERATION SETTINGS OF THIS MODULE

implicit none
real*8 sea_ice_entropy_seaice_si, ssi_si, t_si, p_si
real*8 g_t

sea_ice_entropy_seaice_si = errorreturn

if(ssi_si < 0d0 .or. ssi_si >= 1d0) return
if(t_si <= 0d0) return
if(p_si <= 0d0) return

g_t = sea_ice_g_si(0, 1, 0, ssi_si, t_si, p_si)
if(g_t == errorreturn) return

sea_ice_entropy_seaice_si = -g_t

end function

!=========================================================================
function sea_ice_expansion_seaice_si(ssi_si, t_si, p_si)
!==========================================================================

!OUTPUT:   
!ALPHA(SSI,T,P) = (D2G/DTDP)_SSA/(DG/DP)_SSI_T  THERMAL EXPANSION OF SEA ICE IN 1/K

!INPUT:
!SSI_SI    ABSOLUTE SEA-ICE SALINITY IN KG/KG
!T_SI      ABSOLUTE TEMPERATURE IN K
!P_SI      ABSOLUTE PRESSURE IN PA

!CHECK VALUE WITH DEFAULT SETTINGS: 
!SEA_ICE_EXPANSION_SEAICE_SI(0.035, 270, 1E5) = -1.64731328738

!NOTE: THE ACCURACY OF THIS FUNCTION DEPENDS ON THE ITERATION SETTINGS OF THIS MODULE

implicit none
real*8 sea_ice_expansion_seaice_si, ssi_si, t_si, p_si
real*8 g_p, g_tp

sea_ice_expansion_seaice_si = errorreturn

if(ssi_si < 0d0 .or. ssi_si >= 1d0) return
if(t_si <= 0d0) return
if(p_si <= 0d0) return

g_p = sea_ice_g_si(0, 0, 1, ssi_si, t_si, p_si)
if(g_p == errorreturn) return
if(g_p <= 0d0) return
g_tp = sea_ice_g_si(0, 1, 1, ssi_si, t_si, p_si)
if(g_tp == errorreturn) return

sea_ice_expansion_seaice_si = g_tp / g_p

end function

!=========================================================================
function sea_ice_kappa_t_seaice_si(ssi_si, t_si, p_si)
!==========================================================================

!OUTPUT:   
!KAPPA_T(SSI,T,P) = - (D2G/DP2)_SSI_T/(DG/DP)_SSI_T  ISOTHERMAL COMPRESSIBILITY OF SEA ICE IN 1/PA,

!INPUT:
!SSI_SI    ABSOLUTE SEA-ICE SALINITY IN KG/KG
!T_SI      ABSOLUTE TEMPERATURE IN K
!P_SI      ABSOLUTE PRESSURE IN PA

!CHECK VALUE WITH DEFAULT SETTINGS: 
!SEA_ICE_KAPPA_T_SEAICE_SI(0.035, 270, 1E5) = 1.56513441348E-09

!NOTE: THE ACCURACY OF THIS FUNCTION DEPENDS ON THE ITERATION SETTINGS OF THIS MODULE

implicit none
real*8 sea_ice_kappa_t_seaice_si, t_si, p_si, ssi_si
real*8 g_p, g_pp

sea_ice_kappa_t_seaice_si = errorreturn

if(ssi_si < 0d0 .or. ssi_si >= 1d0) return
if(t_si <= 0d0) return
if(p_si <= 0d0) return

g_p = sea_ice_g_si(0, 0, 1, ssi_si, t_si, p_si)
if(g_p == errorreturn) return
if(g_p <= 0d0) return
g_pp = sea_ice_g_si(0, 0, 2, ssi_si, t_si, p_si)
if(g_pp == errorreturn) return

sea_ice_kappa_t_seaice_si = -g_pp / g_p

end function

!=========================================================================
function sea_ice_s_si(drv_t, drv_p, t_si, p_si)
!==========================================================================

!THIS FUNCTION RETURNS ABSOLUTE BRINE SALINITY S IN KG/KG, AND ITS PARTIAL DERIVATIVES
!(D/DT)^DRV_T (D/DP)^DRV_P S(T,P)
!AS A FUNCTION OF ABSOLUTE TEMPERATURE, T_SI, IN K, AND ABSOLUTE PRESSURE, P_SI, IN PA

!AS DEFINED IN EQ. (4.10) OF
!R. FEISTEL, E. HAGEN
!A GIBBS THERMODYNAMIC POTENTIAL OF SEA ICE
!COLD REGIONS SCIENCE AND TECHNOLOGY 28 (1998) 83–142

implicit none
integer drv_t, drv_p
real*8 sea_ice_s_si, t_si, p_si
real*8 d  !DILUTION COEFF
real*8 s  !BRINE SALINITY

real*8 gb_p, gi_p, gb_sp
real*8 gb_t, gi_t, gb_st

sea_ice_s_si = errorreturn
d = errorreturn

if(drv_t < 0 .or. drv_t > 1) return
if(drv_p < 0 .or. drv_p > 1) return

if(t_si < 0d0) return
if(p_si < 0d0) return

!THIS MUST BE CALLED OUTSIDE BEFORE  !dbg comment is unclear
!IF(SET_SEA_ICE_EQUILIBRIUM_TO_T_P(T_SI, P_SI) == ERRORRETURN) RETURN

!IF NOT, EXIT HERE
if(equi_sea_ice_done /= isok) return

s = sea_ice_salinity_si()  !BRINE SALINITY
if(s == errorreturn) return
if(s < 0d0 .or. s >= 1d0) return

if(drv_t > 0 .or. drv_p > 0) then
  d = sal_dilution_si(s, t_si, p_si)
  if(d == errorreturn) return
  if(d <= 0d0) return
end if

select case (drv_t)

  case (0)
    select case (drv_p)

      case (0) 
        sea_ice_s_si = s

      case (1) 
        gb_p = sea_g_si(0, 0, 1, s, t_si, p_si)
        if(gb_p == errorreturn) return
        gb_sp = sea_g_si(1, 0, 1, s, t_si, p_si)
        if(gb_sp == errorreturn) return
        gi_p = ice_g_si(0, 1, t_si, p_si)
        if(gi_p == errorreturn) return
        sea_ice_s_si = (gb_p - gi_p - s * gb_sp) / d
    end select

  case (1)

    select case (drv_p)

      case (0) 
        gb_t = sea_g_si(0, 1, 0, s, t_si, p_si)
        if(gb_t == errorreturn) return
        gb_st = sea_g_si(1, 1, 0, s, t_si, p_si)
        if(gb_st == errorreturn) return
        gi_t = ice_g_si(1, 0, t_si, p_si)
        if(gi_t == errorreturn) return
        sea_ice_s_si = (gb_t - gi_t - s * gb_st) / d
    end select

end select

end function

!==========================================================================
function set_sea_ice_eq_at_t_p(t_si, p_si)
!==========================================================================

!THIS FUNCTION COMPUTES THE SEAWATER-ICE EQUILIBRIUM AT GIVEN ABSOLUTE TEMPERATURE T_SI 
!IN K AND ABSOLUTE PRESSURE P_SI IN PA BY NEWTON ITERATION

implicit none
integer maxit
real*8 set_sea_ice_eq_at_t_p, t_si, p_si
real*8 s_norm
real*8 d
real*8 s, eps

s_norm = so_salinity_si  !KG/KG OF KCL NORMALISED SEAWATER

if(equi_sea_ice_done == isok .and. &
  t_si == equi_sea_ice_t .and. p_si == equi_sea_ice_p) then
  !THE REQUESTED STATE HAS ALREADY BEEN COMPUTED EARLIER
  set_sea_ice_eq_at_t_p = isok
  return
end if

call clear_sea_ice_state !WASTE ANY PREVIOUS STATE

set_sea_ice_eq_at_t_p = errorreturn

if(t_si <= 0d0) return
if(p_si <= 0d0) return

call init_it_ctrl_sea_ice

!SET INITIAL BRINE SALINITY GUESS
select case (ctrl_mode_sea)
  case (0);  s = aux_brinesalinity_si(t_si, p_si)
  case (-1); s = s_norm
  case (1);  s = ctrl_init_s_sea
  case default; return
end select

if(s <= 0d0 .or. s >= 1d0) return
if(s == errorreturn) return

!SET MAX. ITERATION NUMBER
if(ctrl_loop_maximum == 0)then
  maxit = 100
elseif(ctrl_loop_maximum == (-1))then
  d = liq_density_si(t_si, p_si)
  call set_sea_ice_state (s, t_si, p_si, d)
  set_sea_ice_eq_at_t_p = isok
  return
elseif(ctrl_loop_maximum > 0)then
  maxit = ctrl_loop_maximum
else  
  return
endif

!SET ITERATION ACCURACY LIMIT
eps = ctrl_eps_exit_s
if(eps == 0d0) return

!RUN ITERATION LOOP
if(sea_ice_iteration_at_t_p(t_si, p_si, maxit, eps, s) == errorreturn) then
  return
end if

d = liq_density_si(t_si, p_si)     !ONLY FOR COMPLETENESS OF THE STATE DESCRIPTOR
call set_sea_ice_state (s, t_si, p_si, d)

set_sea_ice_eq_at_t_p = isok

end function

!==========================================================================
function set_sea_ice_eq_at_s_p(sa_si, p_si)
!==========================================================================

!THIS FUNCTION COMPUTES THE SEAWATER-ICE EQUILIBRIUM AT GIVEN ABSOLUTE SALINITY SA_SI
!IN KG/KG AND ABSOLUTE PRESSURE P_SI IN PA BY NEWTON ITERATION

implicit none
integer maxit
real*8 set_sea_ice_eq_at_s_p, sa_si, p_si
real*8 t, d, eps
real*8 tt, dt

tt = tp_temperature_si
dt = tp_density_liq_iapws95_si  !TRIPLE POINT DENSITY OF LIQUID WATER

if(equi_sea_ice_done == isok .and. &
  sa_si == equi_sea_ice_s .and. p_si == equi_sea_ice_p) then
  !THE REQUESTED STATE HAS ALREADY BEEN COMPUTED EARLIER
  set_sea_ice_eq_at_s_p = isok
  return
end if

call clear_sea_ice_state !WASTE ANY PREVIOUS STATE

set_sea_ice_eq_at_s_p = errorreturn

if(sa_si <= 0d0) return
if(sa_si >= 1d0) return
if(p_si <= 0d0) return

call init_it_ctrl_sea_ice

!SET INITIAL TEMPERATURE GUESS
select case (ctrl_mode_temperature)
  case (0);  t = aux_freezingtemperature_si(sa_si, p_si)
  case (-1); t = tt
  case (1);  t = ctrl_init_t
  case default; return
end select
if(t <= 0d0) return
if(t == errorreturn) return

!SET INITIAL LIQUID DENSITY GUESS
select case (ctrl_mode_liquid)
  case (0);  d = aux_density_eos80_si(t, p_si)
  case (-1); d = dt
  case (1);  d = ctrl_init_d_liq
  case default; return
end select
if(d <= 0d0) return
if(d == errorreturn) return

!SET MAX. ITERATION NUMBER
if(ctrl_loop_maximum == 0)then
  maxit = 100
elseif(ctrl_loop_maximum == (-1))then
  call set_sea_ice_state (sa_si, t, p_si, d)
  set_sea_ice_eq_at_s_p = isok
  return
elseif(ctrl_loop_maximum > 0)then
  maxit = ctrl_loop_maximum
else
  return
endif

!SET ITERATION ACCURACY LIMIT
eps = ctrl_eps_exit_t
if(eps == 0d0) return

!RUN ITERATION LOOP
if(sea_ice_iteration_at_s_p(sa_si, p_si, maxit, eps, d, t) == errorreturn) then
  return
end if

call set_sea_ice_state (sa_si, t, p_si, d)

set_sea_ice_eq_at_s_p = isok

end function

!==========================================================================
function set_sea_ice_eq_at_s_t(sa_si, t_si)
!==========================================================================

!THIS FUNCTION COMPUTES THE SEAWATER-ICE EQUILIBRIUM AT GIVEN ABSOLUTE TEMPERATURE T_SI
!IN K AND ABSOLUTE SALINITY SA_SI IN KG/KG BY NEWTON ITERATION

implicit none
integer maxit
real*8 set_sea_ice_eq_at_s_t, sa_si, t_si
real*8 eps
real*8 d_si, p_si
real*8 dt

dt = tp_density_liq_iapws95_si  !TRIPLE POINT DENSITY OF LIQUID WATER

if(equi_sea_ice_done == isok .and. &
  sa_si == equi_sea_ice_s .and. t_si == equi_sea_ice_t) then
  !THE REQUESTED STATE HAS ALREADY BEEN COMPUTED EARLIER
  set_sea_ice_eq_at_s_t = isok
  return
end if

call clear_sea_ice_state !WASTE ANY PREVIOUS STATE

set_sea_ice_eq_at_s_t = errorreturn

if(sa_si <= 0d0) return
if(sa_si >= 1d0) return
if(t_si <= 0d0) return

call init_it_ctrl_sea_ice

!SET INITIAL LIQUID WATER DENSITY GUESS
select case (ctrl_mode_liquid)
  case (0)
    d_si = aux_liq_density_correlation_si(t_si)
    if(d_si == errorreturn) return
    if(d_si <= 0d0) return
  case (-1); d_si = dt
  case (1);  d_si = ctrl_init_d_liq
  case default; return
end select
if(d_si <= 0d0) return
if(d_si == errorreturn) return

!SET MAX. ITERATION NUMBER
if(ctrl_loop_maximum == 0)then
  maxit = 100
elseif(ctrl_loop_maximum == (-1))then
  p_si = d_si ** 2 * flu_f_si(0, 1, t_si, d_si)
  call set_sea_ice_state (sa_si, t_si, p_si, d_si)
  set_sea_ice_eq_at_s_t = isok
  return
elseif(ctrl_loop_maximum > 0)then
  maxit = ctrl_loop_maximum
else
  return
endif

!SET ITERATION ACCURACY LIMIT
eps = ctrl_eps_exit_p
if(eps == 0d0) return

!RUN ITERATION LOOP
if(sea_ice_iteration_at_s_t(sa_si, t_si, maxit, eps, d_si, p_si) == errorreturn) then
  return
end if

call set_sea_ice_state (sa_si, t_si, p_si, d_si)

set_sea_ice_eq_at_s_t = isok

end function

!==========================================================================
function sea_ice_density_ice_si()
!==========================================================================

!THIS FUNCTION RETURNS THE DENSITY IN KG/M3 OF ICE AT THE EQUILIBRIUM WITH SEAWATER,
!SET BY A PREVIOUS CALL OF EITHER SET_SEA_ICE_EQUILIBRIUM_TO_S_P,
!SET_SEA_ICE_EQUILIBRIUM_TO_S_T OR SET_SEA_ICE_EQUILIBRIUM_TO_T_P

!NOTE: THE ACCURACY OF THIS FUNCTION DEPENDS ON THE ITERATION SETTINGS OF THIS MODULE

!CHECK VALUES WITH DEFAULT SETTINGS:
!SET_SEA_ICE_EQ_AT_S_P 0.035, 1E5
!SEA_ICE_DENSITY_ICE_SI = 917.000739687

!SET_SEA_ICE_EQ_AT_S_T 0.035, 270
!SEA_ICE_DENSITY_ICE_SI = 918.898527655

!SET_SEA_ICE_EQ_AT_T_P 270, 1E5
!SEA_ICE_DENSITY_ICE_SI = 917.181167192

implicit none
real*8 sea_ice_density_ice_si

sea_ice_density_ice_si = errorreturn

if(equi_sea_ice_done /= isok) return

sea_ice_density_ice_si = ice_density_si(equi_sea_ice_t, equi_sea_ice_p)

end function

!==========================================================================
function sea_ice_density_sea_si()
!==========================================================================

!THIS FUNCTION RETURNS THE DENSITY IN KG/M3 OF SEAWATER AT THE EQUILIBRIUM WITH ICE,
!SET BY A PREVIOUS CALL OF EITHER SET_SEA_ICE_EQUILIBRIUM_TO_S_P,
!SET_SEA_ICE_EQUILIBRIUM_TO_S_T OR SET_SEA_ICE_EQUILIBRIUM_TO_T_P

!CHECK VALUES WITH DEFAULT SETTINGS:
!SET_SEA_ICE_EQ_AT_S_P 0.035, 1E5
!SEA_ICE_DENSITY_SEA_SI = 1028.05199645

!SET_SEA_ICE_EQ_AT_S_T 0.035, 270
!SEA_ICE_DENSITY_SEA_SI = 1035.73670169

!SET_SEA_ICE_EQ_AT_T_P 270, 1E5
!SEA_ICE_DENSITY_SEA_SI = 1045.16805918

!NOTE: THE ACCURACY OF THIS FUNCTION DEPENDS ON THE ITERATION SETTINGS OF THIS MODULE

implicit none
real*8 sea_ice_density_sea_si

sea_ice_density_sea_si = errorreturn

if(equi_sea_ice_done /= isok) return

sea_ice_density_sea_si = sea_density_si(equi_sea_ice_s, equi_sea_ice_t, equi_sea_ice_p)

end function

!==========================================================================
function sea_ice_enthalpy_melt_si()
!==========================================================================

!THIS FUNCTION RETURNS THE MELTING ENTHALPY IN J/KG OF ICE IN SEAWATER,
!SET BY A PREVIOUS CALL OF EITHER SET_SEA_ICE_EQUILIBRIUM_TO_S_P,
!SET_SEA_ICE_EQUILIBRIUM_TO_S_T OR SET_SEA_ICE_EQUILIBRIUM_TO_T_P

!CHECK VALUES WITH DEFAULT SETTINGS:
!SET_SEA_ICE_EQ_AT_S_P 0.035, 1E5
!SEA_ICE_ENTHALPY_MELT_si = 329942.976285

!SET_SEA_ICE_EQ_AT_S_T 0.035, 270
!SEA_ICE_ENTHALPY_MELT_SI = 326829.393605

!SET_SEA_ICE_EQ_AT_T_P 270, 1E5
!SEA_ICE_ENTHALPY_MELT_SI = 328249.119579

!NOTE: THE ACCURACY OF THIS FUNCTION DEPENDS ON THE ITERATION SETTINGS OF THIS MODULE

implicit none
real*8 sea_ice_enthalpy_melt_si
real*8 s, t, p, d

sea_ice_enthalpy_melt_si = errorreturn

if(equi_sea_ice_done /= isok) return

s = equi_sea_ice_s
t = equi_sea_ice_t
p = equi_sea_ice_p

d = sal_dilution_si(s, t, p)
if(d == errorreturn) return

sea_ice_enthalpy_melt_si = -t * d * sea_ice_s_si(1, 0, t, p)

end function

!==========================================================================
function sea_ice_volume_melt_si()
!==========================================================================

!THIS FUNCTION RETURNS THE MELTING VOLUME IN M3/KG OF ICE IN SEAWATER,
!SET BY A PREVIOUS CALL OF EITHER SET_SEA_ICE_EQUILIBRIUM_TO_S_P,
!SET_SEA_ICE_EQUILIBRIUM_TO_S_T OR SET_SEA_ICE_EQUILIBRIUM_TO_T_P

!NOTE: THE ACCURACY OF THIS FUNCTION DEPENDS ON THE ITERATION SETTINGS OF THIS MODULE

!CHECK VALUES WITH DEFAULT SETTINGS:
!SET_SEA_ICE_EQ_AT_S_P 0.035, 1E5
!SEA_ICE_VOLUME_MELT_SI = -9.10140854473E-05

!SET_SEA_ICE_EQ_AT_S_T 0.035, 270
!SEA_ICE_VOLUME_MELT_SI = -9.67135426848E-05

!SET_SEA_ICE_EQ_AT_T_P 270, 1E5
!SEA_ICE_VOLUME_MELT_SI = -9.18186917900E-05

implicit none
real*8 sea_ice_volume_melt_si
real*8 s, t, p, d

sea_ice_volume_melt_si = errorreturn

if(equi_sea_ice_done /= isok) return

s = equi_sea_ice_s
t = equi_sea_ice_t
p = equi_sea_ice_p

d = sal_dilution_si(s, t, p)
if(d == errorreturn) return

sea_ice_volume_melt_si = d * sea_ice_s_si(0, 1, t, p)

end function

!==========================================================================
function sea_ice_enthalpy_ice_si()
!==========================================================================

!THIS FUNCTION RETURNS THE ENTHALPY IN J/KG OF ICE AT THE EQUILIBRIUM WITH SEAWATER,
!SET BY A PREVIOUS CALL OF EITHER SET_SEA_ICE_EQUILIBRIUM_TO_S_P,
!SET_SEA_ICE_EQUILIBRIUM_TO_S_T OR SET_SEA_ICE_EQUILIBRIUM_TO_T_P

!CHECK VALUES WITH DEFAULT SETTINGS:
!SET_SEA_ICE_EQ_AT_S_P 0.035, 1E5
!SEA_ICE_ENTHALPY_ICE_SI = -337351.999358

!SET_SEA_ICE_EQ_AT_S_T 0.035, 270
!SEA_ICE_ENTHALPY_ICE_SI = -323205.968289

!SET_SEA_ICE_EQ_AT_T_P 270, 1E5
!SEA_ICE_ENTHALPY_ICE_SI = -339929.555499

!NOTE: THE ACCURACY OF THIS FUNCTION DEPENDS ON THE ITERATION SETTINGS OF THIS MODULE

implicit none
real*8 sea_ice_enthalpy_ice_si

sea_ice_enthalpy_ice_si = errorreturn

if(equi_sea_ice_done /= isok) return

sea_ice_enthalpy_ice_si = ice_enthalpy_si(equi_sea_ice_t, equi_sea_ice_p)

end function

!==========================================================================
function sea_ice_enthalpy_sea_si()
!==========================================================================

!THIS FUNCTION RETURNS THE ENTHALPY IN J/KG OF SEAWATER AT THE EQUILIBRIUM WITH ICE,
!SET BY A PREVIOUS CALL OF EITHER SET_SEA_ICE_EQUILIBRIUM_TO_S_P,
!SET_SEA_ICE_EQUILIBRIUM_TO_S_T OR SET_SEA_ICE_EQUILIBRIUM_TO_T_P

!CHECK VALUES WITH DEFAULT SETTINGS:
!SET_SEA_ICE_EQ_AT_S_P 0.035, 1E5
!SEA_ICE_ENTHALPY_SEA_SI = -7613.1933791|9

!SET_SEA_ICE_EQ_AT_S_T 0.035, 270
!SEA_ICE_ENTHALPY_SEA_SI = 2832.9491040|7

!SET_SEA_ICE_EQ_AT_T_P 270, 1E5
!SEA_ICE_ENTHALPY_SEA_SI = -12742.8664892

!NOTE: THE ACCURACY OF THIS FUNCTION DEPENDS ON THE ITERATION SETTINGS OF THIS MODULE

implicit none
real*8 sea_ice_enthalpy_sea_si

sea_ice_enthalpy_sea_si = errorreturn

if(equi_sea_ice_done /= isok) return

sea_ice_enthalpy_sea_si = sea_enthalpy_si(equi_sea_ice_s, equi_sea_ice_t, equi_sea_ice_p)

end function

!==========================================================================
function sea_ice_entropy_ice_si()
!==========================================================================

!THIS FUNCTION RETURNS THE ENTROPY IN J/(KG K) OF ICE AT THE EQUILIBRIUM WITH SEAWATER,
!SET BY A PREVIOUS CALL OF EITHER SET_SEA_ICE_EQUILIBRIUM_TO_S_P,
!SET_SEA_ICE_EQUILIBRIUM_TO_S_T OR SET_SEA_ICE_EQUILIBRIUM_TO_T_P

!CHECK VALUES WITH DEFAULT SETTINGS:
!SET_SEA_ICE_EQ_AT_S_P 0.035, 1E5
!SEA_ICE_ENTROPY_ICE_SI = -1235.44872812

!SET_SEA_ICE_EQ_AT_S_T 0.035, 270
!SEA_ICE_ENTROPY_ICE_SI = -1247.71314646

!SET_SEA_ICE_EQ_AT_T_P 270, 1E5
!SEA_ICE_ENTROPY_ICE_SI = -1244.97335506

!NOTE: THE ACCURACY OF THIS FUNCTION DEPENDS ON THE ITERATION SETTINGS OF THIS MODULE

implicit none
real*8 sea_ice_entropy_ice_si 

sea_ice_entropy_ice_si = errorreturn

if(equi_sea_ice_done /= isok) return

sea_ice_entropy_ice_si = ice_entropy_si(equi_sea_ice_t, equi_sea_ice_p)

end function

!==========================================================================
function sea_ice_entropy_sea_si()
!==========================================================================

!THIS FUNCTION RETURNS THE ENTHALPY IN J/KG OF SEAWATER AT THE EQUILIBRIUM WITH ICE,
!SET BY A PREVIOUS CALL OF EITHER SET_SEA_ICE_EQUILIBRIUM_TO_S_P,
!SET_SEA_ICE_EQUILIBRIUM_TO_S_T OR SET_SEA_ICE_EQUILIBRIUM_TO_T_P

!CHECK VALUES WITH DEFAULT SETTINGS:
!SET_SEA_ICE_EQ_AT_S_P 0.035, 1E5
!SEA_ICE_ENTROPY_SEA_SI = -27.926459810|3

!SET_SEA_ICE_EQ_AT_S_T 0.035, 270
!SEA_ICE_ENTROPY_SEA_SI = -46.7361169560

!SET_SEA_ICE_EQ_AT_T_P 270, 1E5
!SEA_ICE_ENTROPY_SEA_SI = -53.1667911144

!NOTE: THE ACCURACY OF THIS FUNCTION DEPENDS ON THE ITERATION SETTINGS OF THIS MODULE

implicit none
real*8 sea_ice_entropy_sea_si

sea_ice_entropy_sea_si = errorreturn

if(equi_sea_ice_done /= isok) return

sea_ice_entropy_sea_si = sea_entropy_si(equi_sea_ice_s, equi_sea_ice_t, equi_sea_ice_p)

end function

!==========================================================================
function sea_ice_pressure_si()
!==========================================================================

!THIS FUNCTION RETURNS THE ABSOLUTE PRESSURE IN PA OF ICE AT THE EQUILIBRIUM WITH SEAWATER,
!SET BY A PREVIOUS CALL OF EITHER SET_SEA_ICE_EQUILIBRIUM_TO_S_P,
!SET_SEA_ICE_EQUILIBRIUM_TO_S_T OR SET_SEA_ICE_EQUILIBRIUM_TO_T_P

!CHECK VALUES WITH DEFAULT SETTINGS:
!SET_SEA_ICE_EQ_AT_S_P 0.035, 1E5
!SEA_ICE_PRESSURE_SI = 100000

!SET_SEA_ICE_EQ_AT_S_T 0.035, 270
!SEA_ICE_PRESSURE_SI = 16132047.4385

!SET_SEA_ICE_EQ_AT_T_P 270, 1E5
!SEA_ICE_PRESSURE_SI = 100000

!NOTE: THE ACCURACY OF THIS FUNCTION DEPENDS ON THE ITERATION SETTINGS OF THIS MODULE

implicit none
real*8 sea_ice_pressure_si

sea_ice_pressure_si = errorreturn

if(equi_sea_ice_done /= isok) return

sea_ice_pressure_si = equi_sea_ice_p

end function

!==========================================================================
function sea_ice_temperature_si()
!==========================================================================

!THIS FUNCTION RETURNS THE ABSOLUTE TEMPERATURE IN K OF ICE AT THE EQUILIBRIUM WITH SEAWATER,
!SET BY A PREVIOUS CALL OF EITHER SET_SEA_ICE_EQUILIBRIUM_TO_S_P,
!SET_SEA_ICE_EQUILIBRIUM_TO_S_T OR SET_SEA_ICE_EQUILIBRIUM_TO_T_P

!CHECK VALUES WITH DEFAULT SETTINGS:
!SET_SEA_ICE_EQ_AT_S_P 0.035, 1E5
!SEA_ICE_TEMPERATURE_SI = 271.240373585159

!SET_SEA_ICE_EQ_AT_S_T 0.035, 270
!SEA_ICE_TEMPERATURE_SI = 270

!SET_SEA_ICE_EQ_AT_T_P 270, 1E5
!SEA_ICE_TEMPERATURE_SI = 270


!NOTE: THE ACCURACY OF THIS FUNCTION DEPENDS ON THE ITERATION SETTINGS OF THIS MODULE

implicit none
real*8 sea_ice_temperature_si

sea_ice_temperature_si = errorreturn

if(equi_sea_ice_done /= isok) return

sea_ice_temperature_si = equi_sea_ice_t

end function

!==========================================================================
function sea_ice_salinity_si()
!==========================================================================

!THIS FUNCTION RETURNS THE ABSOLUTE BRINE SALINITY IN KG/KG OF ICE AT THE EQUILIBRIUM WITH SEAWATER,
!SET BY A PREVIOUS CALL OF EITHER SET_SEA_ICE_EQUILIBRIUM_TO_S_P,
!SET_SEA_ICE_EQUILIBRIUM_TO_S_T OR SET_SEA_ICE_EQUILIBRIUM_TO_T_P

!CHECK VALUES WITH DEFAULT SETTINGS:
!SET_SEA_ICE_EQ_AT_S_P 0.035, 1E5
!SEA_ICE_SALINITY_SI = 0.035

!SET_SEA_ICE_EQ_AT_S_T 0.035, 270
!SEA_ICE_SALINITY_SI = 0.035

!SET_SEA_ICE_EQ_AT_T_P 270, 1E5
!SEA_ICE_SALINITY_SI = 0.0560264150322

!NOTE: THE ACCURACY OF THIS FUNCTION DEPENDS ON THE ITERATION SETTINGS OF THIS MODULE

implicit none
real*8 sea_ice_salinity_si

sea_ice_salinity_si = errorreturn

if(equi_sea_ice_done /= isok) return

sea_ice_salinity_si = equi_sea_ice_s

end function

!==========================================================================
function sea_ice_iteration_at_t_p(t_si, p_si, maxit, eps, s_sea_si)
!==========================================================================

!THIS FUNCTION COMPUTES THE SEAWATER-ICE PHASE EQUILIBRIUM FROM
!EQUAL CHEMICAL POTENTIALS OF WATER IN THE TWO PHASES AT GIVEN ABSOLUTE TEMPERATURE T_SI IN K
!AND ABSOLUTE PRESSURE P_SI IN PA FROM AN INITIAL GUESS FOR ABSOLUTE BRINE SALINITY S_SEA_SI 
!IN KG/KG.
!THE ITERATION LIMIT EPS REFERS TO THE ERROR IN BRINE SALINITY.

!OUTPUT: 
!        SEA_ICE_ITERATION_AT_T_P = ISOK IF SUCCESSFULLY DONE
!        SEA_ICE_ITERATION_AT_T_P = ERRORRETURN IS RETURNED IF
!        - THE MAXIMUM NUMBER OF ITERATIONS IS EXCEEDED WITHOUT MEETING THE EXIT CRITERION
!        - THE FUNCTION CALL TO A GIBBS FUNCTION HAS RETURNED AN ERROR
!        - SALINITY HAS TAKEN A ZERO OR NEGATIVE VALUE DURING THE ITERATION
!        - T-P VALUES DO NOT PERMIT THE STABLE EXISTENCE OF ICE
! S_SEA_SI: BRINE SALINITY IN KG/KG IN THE SEAWATER-ICE EQUILIBRIUM

!INPUT: 
!       T_SI: ABSOLUTE TEMPERATURE IN K
!       P_SI: ABSOLUTE PRESSURE IN PA
!      MAXIT: MAXIMUM NUMBER OF ITERATION STEPS TO BE DONE
!        EPS: REQUIRED ACCURACY OF SALINITY
!             EPS > 0: ABSOLUTE SALINITY TOLERANCE IN KG/KG
!             EPS < 0: RELATIVE SALINITY TOLERANCE
!   S_SEA_SI: INITIAL GUESS OF BRINE SALINITY IN KG/KG

implicit none
integer it, maxit
real*8 sea_ice_iteration_at_t_p, t_si, p_si, eps, s_sea_si
real*8 s, ds
real*8 mus, sgss
real*8 gl, gi

sea_ice_iteration_at_t_p = errorreturn

if(s_sea_si <= 0d0 .or. s_sea_si >= 1d0) then
  s_sea_si = errorreturn
  return
endif

if(check_limits == 1) then
  !FLU_LIMITS
  if(t_si < flu_tmin .or. t_si > flu_tmax) then
    s_sea_si = errorreturn
    return
  endif
  !SAL_LIMITS
  if(t_si < sal_tmin .or. t_si > sal_tmax  &
  .or. p_si < sal_pmin .or. p_si > sal_pmax) then
    s_sea_si = errorreturn
    return
  endif
  !ICE_LIMITS
  if(t_si <= ice_tmin .or. t_si > ice_tmax .or. &
  p_si <= ice_pmin .or. p_si > ice_pmax) then
    s_sea_si = errorreturn
    return
  endif
else
  if(p_si <= 0d0 .or. &
    t_si <= 0d0) then
    s_sea_si = errorreturn
    return
  endif
endif

check_limits = check_limits - 1

!GET THE CHEMICAL POTENTIAL OF LIQUID WATER GL(T,P) (THIS IMPLIES ITERATION)
gl = liq_gibbs_energy_si(t_si, p_si)
if(gl == errorreturn) go to 999

!GET THE CHEMICAL POTENTIAL OF ICE GI(T,P)
gi = ice_g_si(0, 0, t_si, p_si)
if(gi == errorreturn) go to 999

if(gl <= gi) go to 999  !NO ICE IN SEAWATER

s = s_sea_si

do it = 1, maxit

  !DERIVATIVES OF THE GIBBS FUNCTIONS FOR NEWTON ITERATION
  mus = sal_chempot_h2o_si(s, t_si, p_si) !SALINE CHEMICAL POTENTIAL GS + S*DG/DS
  if(mus == errorreturn) goto 999
  sgss = sal_dilution_si(s, t_si, p_si)  !S* D2G/DS2
  if(sgss == errorreturn) goto 999
  if(sgss <= 0d0) goto 999  !PHYSICALLY, THIS IS IMPOSSIBLE

  !BRINE SALINITY ITERATION STEP
  ds = (gl + mus - gi) / sgss

  !UPDATE BRINE SALINITY
  s = s + ds
  if(s <= 0d0) goto 999

  !CHECK ABSOLUTE OR RELATIVE ERROR LIMIT
  if((eps > 0d0 .and. abs(ds) < eps) .or. &
     (eps < 0 .and. abs(ds) < -eps * s)) then
    if(s >= 1d0) goto 999
    sea_ice_iteration_at_t_p = isok
    s_sea_si = s
    goto 999
  end if

enddo

999 continue

check_limits = check_limits + 1

if(check_limits == 1) then
  !SAL_LIMITS
  if(s_sea_si < sal_smin .or. s_sea_si > sal_smax) then
    s_sea_si = errorreturn
    sea_ice_iteration_at_t_p = errorreturn
    return
  endif
endif

end function

!==========================================================================
function sea_ice_iteration_at_s_t(sa_si, t_si, maxit, eps, d_si, p_si)
!==========================================================================

!THIS FUNCTION COMPUTES THE SEAWATER-ICE PHASE EQUILIBRIUM FROM
!EQUAL CHEMICAL POTENTIALS OF WATER IN THE TWO PHASES AT GIVEN ABSOLUTE SALINITY SA_SI IN KG/KG 
!AND ABSOLUTE TEMPERATURE T_SI IN K, FROM AN INITIAL GUESS FOR THE LIQUID DENSITY D_SI IN KG/KG.
!THE ITERATION LIMIT EPS REFERS TO THE ERROR IN PRESSURE.

!OUTPUT: 
!        SEA_ICE_ITERATION_AT_S_T = ISOK IF SUCCESSFULLY DONE
!        SEA_ICE_ITERATION_AT_S_T = ERRORRETURN IS RETURNED IF
!        - THE MAXIMUM NUMBER OF ITERATIONS IS EXCEEDED WITHOUT MEETING THE EXIT CRITERION
!        - THE FUNCTION CALL TO A GIBBS/HELMHOLTZ FUNCTION HAS RETURNED AN ERROR
!        - DENSITY HAS TAKEN A ZERO OR NEGATIVE VALUE DURING THE ITERATION
!        - S-T VALUES DO NOT PERMIT THE STABLE EXISTENCE OF ICE
! D_SI: DENSITY OF WATER AT (T_SI, P_SI) IN KG/M3
! P_SI: ABSOLUTE PRESSURE IN PA AT THE SEAWATER-ICE EQUILIBRIUM

!INPUT: 
!      SA_SI: ABSOLUTE SALINITY IN KG/KG
!       T_SI: ABSOLUTE TEMPERATURE IN K
!      MAXIT: MAXIMUM NUMBER OF ITERATION STEPS TO BE DONE
!        EPS: REQUIRED ACCURACY OF PRESSURE
!             EPS > 0: ABSOLUTE PRESSURE TOLERANCE IN PA
!             EPS < 0: RELATIVE PRESSURE TOLERANCE
!       D_SI: INITIAL GUESS FOR DENSITY OF WATER IN KG/M3 AT (T_SI, P_SI)

implicit none
integer it, maxit
real*8 sea_ice_iteration_at_s_t, sa_si, t_si, eps, d_si, p_si
real*8 p, d, dd
real*8 mus, p_old
real*8 gl, gi, gi_p
real*8 gs_p, gs_sp
real*8 f, f_d, f_dd

sea_ice_iteration_at_s_t = errorreturn

if(d_si <= 0d0) then
  p_si = errorreturn
  d_si = errorreturn
  return
endif

if(check_limits == 1) then
  !FLU_LIMITS
  if(t_si < flu_tmin .or. t_si > flu_tmax) then
    p_si = errorreturn
    d_si = errorreturn
    return
  endif
  !SAL_LIMITS
  if(t_si < sal_tmin .or. t_si > sal_tmax .or. &
  sa_si < sal_smin .or. sa_si > sal_smax) then
    p_si = errorreturn
    d_si = errorreturn
    return
  endif
  !ICE_LIMITS
  if(t_si <= ice_tmin .or. t_si > ice_tmax) then
    p_si = errorreturn
    d_si = errorreturn
    return
  endif
else
  if(t_si <= 0d0 .or. &
    sa_si <= 0d0 .or. sa_si >= 1d0) then
    p_si = errorreturn
    d_si = errorreturn
    return
  endif
endif

check_limits = check_limits - 1

d = d_si

do it = 0, maxit

  !DERIVATIVES OF THE HELMHOLTZ FUNCTION OF FLUID WATER FOR NEWTON ITERATION
  f = flu_f_si(0, 0, t_si, d)
  if(f == errorreturn) go to 999
  f_d = flu_f_si(0, 1, t_si, d)
  if(f_d == errorreturn) go to 999
  f_dd = flu_f_si(0, 2, t_si, d)
  if(f_dd == errorreturn) go to 999
  p_old = p
  p = d ** 2 * f_d
  gl = f + d * f_d

  !DERIVATIVES OF THE GIBBS FUNCTION OF ICE FOR NEWTON ITERATION
  gi = ice_g_si(0, 0, t_si, p)
  if(gi == errorreturn) go to 999
  gi_p = ice_g_si(0, 1, t_si, p)
  if(gi_p == errorreturn) go to 999

  !DERIVATIVES OF THE SALINE GIBBS FUNCTION FOR NEWTON ITERATION
  mus = sal_chempot_h2o_si(sa_si, t_si, p) !SALINE CHEMICAL POTENTIAL GS + S*DG/DS
  if(mus == errorreturn) go to 999
  gs_p = sal_g_si(0, 0, 1, sa_si, t_si, p)
  if(gs_p == errorreturn) go to 999
  gs_sp = sal_g_si(1, 0, 1, sa_si, t_si, p)
  if(gs_sp == errorreturn) go to 999

  if(it > 0) then
    !CHECK ABSOLUTE OR RELATIVE ERROR LIMIT
    if((eps > 0d0 .and. abs(p - p_old) < eps) .or. &
      (eps < 0 .and. abs(p - p_old) < -eps * abs(p))) then
      if(p <= 0d0) go to 999
      sea_ice_iteration_at_s_t = isok
      p_si = p
      d_si = d
      go to 999
    end if
  end if

  if(it == maxit) go to 999

  !DENSITY ITERATION STEP
  dd = (2d0 * f_d + d * f_dd) * (1d0 + d * (-gi_p + gs_p - sa_si * gs_sp))
  if(dd == 0d0) go to 999
  dd = (gi - gl - mus) / dd

  !UPDATE LIQUID DENSITY
  d = d + dd
  if(d <= 0d0) go to 999

enddo

999 continue

check_limits = check_limits + 1

if(check_limits == 1) then
  !FLU_LIMITS
  if(d_si <= flu_dmin .or. d_si > flu_dmax) then
    p_si = errorreturn
    d_si = errorreturn
    sea_ice_iteration_at_s_t = errorreturn
    return
  endif
  !SAL_LIMITS
  if(p_si < sal_pmin .or. p_si > sal_pmax) then
    p_si = errorreturn
    d_si = errorreturn
    sea_ice_iteration_at_s_t = errorreturn
    return
  endif
  !ICE_LIMITS
  if(p_si <= ice_pmin .or. p_si > ice_pmax) then
    p_si = errorreturn
    d_si = errorreturn
    sea_ice_iteration_at_s_t = errorreturn
    return
  endif
endif

end function

!==========================================================================
function sea_ice_iteration_at_s_p(sa_si, p_si, maxit, eps, d_si, t_si)
!==========================================================================

!THIS FUNCTION COMPUTES THE SEAWATER-ICE PHASE EQUILIBRIUM FROM EQUAL CHEMICAL POTENTIALS 
!OF WATER AT GIVEN ABSOLUTE SALINITY SA_SI IN KG/KG AND ABSOLUTE PRESSURE P_SI IN PA,
!FROM AN INITIAL GUESSES FOR THE ABSOLUTE TEMPERATURE T_SI IN K AND THE LIQUID DENSITY D_SI
!IN KG/M3.
!THE ITERATION LIMIT EPS REFERS TO THE ERROR IN TEMPERATURE.

!OUTPUT: 
!        SEA_ICE_ITERATION_AT_S_P = ISOK IF SUCCESSFULLY DONE
!        SEA_ICE_ITERATION_AT_S_P = ERRORRETURN IS RETURNED IF
!        - THE MAXIMUM NUMBER OF ITERATIONS IS EXCEEDED WITHOUT MEETING THE EXIT CRITERION
!        - THE FUNCTION CALL TO A GIBBS/HELMHOLTZ FUNCTION HAS RETURNED AN ERROR
!        - DENSITY OR TEMPERATURE HAS TAKEN A ZERO OR NEGATIVE VALUE DURING THE ITERATION
!        - S-P VALUES DO NOT PERMIT THE STABLE EXISTENCE OF ICE
!  D_SI: DENSITY OF WATER AT (T_SI, P_SI)
!  T_SI: ABSOLUTE TEMPERATURE IN K OF THE SEAWATER-ICE EQUILIBRIUM

!INPUT: 
!       SA_SI: ABSOLUTE SALINITY IN KG/KG
!        P_SI: ABSOLUTE PRESSURE IN PA
!       MAXIT: MAXIMUM NUMBER OF ITERATION STEPS TO BE DONE
!         EPS: REQUIRED ACCURACY OF PRESSURE
!              EPS > 0: ABSOLUTE TEMPERATURE TOLERANCE IN K
!              EPS < 0: RELATIVE TEMPERATURE TOLERANCE
!        D_SI: INITIAL GUESS FOR DENSITY OF WATER IN KG/M3 AT (T_SI, P_SI)
!        T_SI: INITIAL GUESS FOR ABSOLUTE FREEZING TEMPERATURE IN K

implicit none
integer it, maxit
real*8 sea_ice_iteration_at_s_p, sa_si, p_si, eps, d_si, t_si
real*8 d, dd, t, dt
real*8 mus, p
real*8 gl, gi, gi_t
real*8 gs_t, gs_st
real*8 f, f_t, f_td
real*8 f_d, f_dd

real*8 a(2, 2), b(2), x(2)

sea_ice_iteration_at_s_p = errorreturn

if((d_si <= 0d0) .or. &
  (t_si <= 0d0)) then
  d_si = errorreturn
  t_si = errorreturn
  return
endif

if(check_limits == 1) then
  !SAL_LIMITS
  if(sa_si < sal_smin .or. sa_si > sal_smax &
  .or. p_si < sal_pmin .or. p_si > sal_pmax) then
    d_si = errorreturn
    t_si = errorreturn
    return
  endif
  !ICE_LIMITS
  if(p_si <= ice_pmin .or. p_si > ice_pmax) then
    d_si = errorreturn
    t_si = errorreturn
    return
  endif
else
  if(p_si <= 0d0 .or. &
    sa_si <= 0d0 .or. sa_si >= 1d0) then
    d_si = errorreturn
    t_si = errorreturn
    return
  endif
endif

check_limits = check_limits - 1

t = t_si
d = d_si

do it = 1, maxit

  !DERIVATIVES OF THE HELMHOLTZ FUNCTION OF FLUID WATER FOR NEWTON ITERATION
  f = flu_f_si(0, 0, t, d)
  if(f == errorreturn) go to 999
  f_t = flu_f_si(1, 0, t, d)
  if(f_t == errorreturn) go to 999
  f_d = flu_f_si(0, 1, t, d)
  if(f_d == errorreturn) go to 999
  f_td = flu_f_si(1, 1, t, d)
  if(f_td == errorreturn) go to 999
  f_dd = flu_f_si(0, 2, t, d)
  if(f_dd == errorreturn) go to 999
  p = d ** 2 * f_d
  gl = f + d * f_d

  !DERIVATIVES OF THE GIBBS FUNCTION OF ICE FOR NEWTON ITERATION
  gi = ice_g_si(0, 0, t, p_si)  !dbg DW chnaged p to p_si
  if(gi == errorreturn) go to 999
  gi_t = ice_g_si(1, 0, t, p_si)
  if(gi_t == errorreturn) go to 999

  !DERIVATIVES OF THE SALINE GIBBS FUNCTION FOR NEWTON ITERATION
  mus = sal_chempot_h2o_si(sa_si, t, p_si) !SALINE CHEMICAL POTENTIAL GS + S*DG/DS
  if(mus == errorreturn) go to 999
  gs_t = sal_g_si(0, 1, 0, sa_si, t, p_si)
  if(gs_t == errorreturn) go to 999
  gs_st = sal_g_si(1, 1, 0, sa_si, t, p_si)
  if(gs_st == errorreturn) go to 999

  !COEFFICIENT MATRIX
  a(1, 1) = f_t + d * f_td + gs_t - sa_si * gs_st - gi_t
  a(1, 2) = 2d0 * f_d + d * f_dd
  a(2, 1) = d ** 2 * f_td
  a(2, 2) = d * (2d0 * f_d + d * f_dd)
  !RIGHT-HAND SIDES, MUST VANISH IN EQUILIBRIUM
  b(1) = gi - gl - mus
  b(2) = p_si - p

  !SOLVE EQUATIONS
  if(matrix_solve(a, b, x, 2) /= 0) go to 999 !MATRIX SINGULAR
  dt = x(1)
  dd = x(2)

  !UPDATE DENSITY AND TEMPERATURE
  d = d + dd
  if(d <= 0d0) go to 999
  t = t + dt
  if(t <= 0d0) go to 999

  !CHECK ABSOLUTE OR RELATIVE ERROR LIMIT
  if((eps > 0d0 .and. abs(dt) < eps) .or. &
    (eps < 0 .and. abs(dt) < -eps * abs(t))) then
    if(t <= 0d0) go to 999
    sea_ice_iteration_at_s_p = isok
    t_si = t
    d_si = d
    go to 999
  end if

enddo

999 continue

check_limits = check_limits + 1

if(check_limits == 1) then
  !FLU_LIMITS
  if(t_si < flu_tmin .or. t_si > flu_tmax .or. &
  d_si <= flu_dmin .or. d_si > flu_dmax) then
    t_si = errorreturn
    d_si = errorreturn
    sea_ice_iteration_at_s_p = errorreturn
    return
  endif
  !SAL_LIMITS
  if(t_si < sal_tmin .or. t_si > sal_tmax) then
    t_si = errorreturn
    d_si = errorreturn
    sea_ice_iteration_at_s_p = errorreturn
    return
  endif
  !ICE_LIMITS
  if(t_si <= ice_tmin .or. t_si > ice_tmax) then
    t_si = errorreturn
    d_si = errorreturn
    sea_ice_iteration_at_s_p = errorreturn
    return
  endif
endif

end function

!==========================================================================
function aux_brinesalinity_si(t_si, p_si)
!==========================================================================

!COMPUTES A BRINE SALINITY ESTIMATE IN KG/KG FOR SEAWATER-ICE EQUILIBRIUM AT GIVEN
!ABSOLUTE TEMPERATURE IN K AND ABSOLUTE PRESSURE IN PA FROM CLAUSIUS-CLAPEYRON
!AND RAOULT LAWS

implicit none
real*8 aux_brinesalinity_si, t_si, p_si
real*8 tt, pt, alpha, chi

tt = tp_temperature_si
pt = tp_pressure_iapws95_si !IAPWS-95 TRIPLE POINT PRESSURE IN Pa

alpha = -0.217d0            !RAOULT COFFICIENT, (T-TT)/T = ALPHA * S,  IN KG/KG
chi = -0.0000000743d0       !CLAUSIUS-CLAPEYRON COEFFICIENT,  (T-TT) = CHI * (P-PT), IN K/PA !dbg [CHI] in K/PA?

aux_brinesalinity_si = errorreturn
if(p_si <= 0d0) return
if(t_si <= 0d0) return

aux_brinesalinity_si = (t_si - tt - chi * (p_si - pt)) / (alpha * t_si)

end function

!==========================================================================
function aux_freezingtemperature_si(sa_si, p_si)
!==========================================================================

!COMPUTES A FREEZING TEMPERATURE ESTIMATE IN K FOR SEAWATER-ICE EQUILIBRIUM AT GIVEN
!BRINE SALINITY IN KG/KG AND ABSOLUTE PRESSURE IN PA FROM CLAUSIUS-CLAPEYRON
!AND RAOULT LAWS

implicit none
real*8 aux_freezingtemperature_si, sa_si, p_si
real*8 tt, pt, alpha, chi

tt = tp_temperature_si
pt = tp_pressure_iapws95_si !IAPWS-95 TRIPLE POINT PRESSURE IN Pa

alpha = -0.217d0            !RAOULT COFFICIENT, (T-TT)/T = ALPHA * S,  IN KG/KG
chi = -0.0000000743d0       !CLAUSIUS-CLAPEYRON COEFFICIENT,  (T-TT) = CHI * (P-PT), IN K/PA !dbg [CHI] in K/PA

aux_freezingtemperature_si = errorreturn
if(p_si <= 0d0) return
if(sa_si < 0d0) return
if(sa_si >= 1d0) return

aux_freezingtemperature_si = (tt + chi * (p_si - pt)) / (1 - alpha * sa_si)

end function

!==========================================================================
function aux_liq_density_correlation_si(t_si)
!==========================================================================

!THIS FUNCTION IMPLEMENTS THE DENSITY IN KG/M3 OF THE FREEZING LIQUID
!AS A FUNCTION OF ABSOLUTE TEMPERATURE T_SI IN K FROM AN APPROXIMATE
!CORRELATION FIT BETWEEN 252 AND 273 K WITH RMS = 1.2 E-4 IN D/DT

implicit none
real*8 aux_liq_density_correlation_si, t_si
real*8 tt, dt, a1, a2, a3
real*8 tr, dr

tt = tp_temperature_si
dt = tp_density_liq_iapws95_si !TRIPLE POINT DENSITY OF LIQUID WATER

a1 = -1.78582981492113d0
a2 = -12.2325084306734d0
a3 = -52.8236936433529d0

aux_liq_density_correlation_si = errorreturn

if(t_si <= 0d0) return

tr = t_si / tt - 1d0
dr = a1 * tr + a2 * tr ** 2 + a3 * tr ** 3

aux_liq_density_correlation_si = dt * (dr + 1d0)

end function

!==========================================================================
function aux_meltingpressure_si(sa_si, t_si)
!==========================================================================

!COMPUTES A MELTING PRESSURE ESTIMATE IN PA FOR SEAWATER-ICE EQUILIBRIUM AT GIVEN
!ABSOLUTE TEMPERATURE IN K AND BRINE SALINITY IN KG/KG FROM CLAUSIUS-CLAPEYRON
!AND RAOULT LAWS

implicit none
real*8 aux_meltingpressure_si, sa_si, t_si
real*8 tt, pt, alpha, chi

tt = tp_temperature_si
pt = tp_pressure_iapws95_si !IAPWS-95 TRIPLE POINT PRESSURE IN Pa

alpha = -0.217d0            !RAOULT COFFICIENT, (T-TT)/T = ALPHA * S,  S IN KG/KG
chi = -0.0000000743d0       !CLAUSIUS-CLAPEYRON COEFFICIENT,  (T-TT) = CHI * (P-PT)

aux_meltingpressure_si = errorreturn
if(sa_si < 0d0) return
if(sa_si >= 1d0) return
if(t_si <= 0d0) return

aux_meltingpressure_si = pt + (t_si - tt - alpha * t_si * sa_si) / chi

end function

!==========================================================================
function aux_density_eos80_si(t_si, p_si)
!==========================================================================

!THIS FUNCTION RETURNS THE DENSITY OF LIQUID WATER COMPUTED FROM THE
!INTERNATIONAL EQUATION OF STATE OF SEAWATER 1980, EOS-80, AS A FUNCTION OF TEMPERATURE
!AND PRESSURE

!OUTPUT:  
!aux_density_eos80_si: DENSITY IN KG/M3

!INPUT:   
!T_SI: ABSOLUTE TEMPERATURE IN K
!p_si: ABSOLUTE PRESSURE IN PA

implicit none
real*8 aux_density_eos80_si, t_si, p_si
real*8 aw, bw, kw, rw
real*8 t, p

aux_density_eos80_si = errorreturn

if(t_si <= 0d0) return
if(p_si <= 0d0) return

!R.C.MILLARD JR.: INTERNATIONAL OCEANOGRAPHIC TABLES VOL.4
!UNESCO TECHNICAL PAPERS IN MARINE SCIENCE 40
!UNESCO 1987

t = 1.00024d0*(t_si - 273.15d0) !CONVERT TO DEGC(T90) THEN USE SAUNDER'S FORMULA
p = (p_si - 101325d0)/1d5

bw = 0.0000850935d0 + t * (-0.00000612293d0 + t * 0.000000052787d0)
aw = 3.239908d0 + t * (0.00143713d0 + t * (0.000116092d0 - t * 0.000000577905d0))
kw = 0.01360477d0 - t * 0.00005155288d0
kw = 19652.21d0 + t * (148.4206d0 + t * (-2.327105d0 + t * kw))
kw = kw + p * (aw + p * bw)
if(kw == 0) return

kw = 1d0 - p / kw
if(kw == 0d0) return

rw = 0.0001001685d0 + t * (-0.000001120083d0 + t * 0.000000006536332d0)
rw = 999.842594d0 + t * (0.06793952d0 + t * (-0.00909529d0 + t * rw))

aux_density_eos80_si = rw / kw

end function

!==========================================================================
subroutine set_it_ctrl_sea_ice(key, value)
!==========================================================================

!THIS SUB SETS CONTROL PARAMETERS FOR THE ITERATION USED TO COMPUTE
!SEAWATER-ICE EQUILIBRIUM

!KEY                    VALUE
!'IT_STEPS     '        0           SET ITERATION NUMBER TO DEFAULT (100)
!'IT_STEPS     '        N > 0       SET ITERATION NUMBER TO N
!'IT_STEPS     '       -1           DO NOT ITERATE, USE INITIAL VALUES TO COMPUTE EQUILIBRIUM

!'INIT_LIQ_DENS'        0           USE DEFAULT LIQUID DENSITY TO START =
!                                   LIQUID DENSITY CORRELATION FUNCTION, D = AUX_LIQ_DENSITY_CORRELATION(T)
!'INIT_LIQ_DENS'       -1           USE TRIPLE POINT LIQUID DENSITY TO START
!'INIT_LIQ_DENS'        D > 0       USE VALUE D AS LIQUID DENSITY TO START

!'INIT_BRINE_SA'        0           USE DEFAULT BRINE SALINITY TO START ( = AUX_BRINESALINITY_SI(T, P))
!'INIT_BRINE_SA'       -1           USE NORMAL SALINITY TO START
!'INIT_BRINE_SA'        S > 0       USE VALUE S AS TEMPERATURE TO START

!'INIT_TEMP    '        0           USE DEFAULT TEMPERATURE TO START ( = AUX_FREEZINGTEMPERATURE_SI(S, P))
!'INIT_TEMP    '       -1           USE 0°C TEMPERATURE TO START
!'INIT_TEMP    '        T > 0       USE VALUE T AS TEMPERATURE TO START

!'TOL_BRINE_SA '        0           USE DEFAULT EXIT ACCURACY FOR BRINE SALINITY (0.1 PPM)
!'TOL_BRINE_SA '        EPS         USE EPS AS EXIT ACCURACY FOR BRINE SALINITY (EPS < 0 MEANS RELATIVE ERROR)

!'TOL_TEMP     '        0           USE DEFAULT EXIT ACCURACY FOR FREEZING TEMPERATURE (0.1 PPM)
!'TOL_TEMP     '        EPS         USE EPS AS EXIT ACCURACY FOR TEMPERATURE (EPS < 0 MEANS RELATIVE ERROR)

!'TOL_PRESS    '        0           USE DEFAULT EXIT ACCURACY FOR MELTING PRESSURE (0.1 PPM)
!'TOL_PRESS    '        EPS         USE EPS AS EXIT ACCURACY FOR PRESSURE (EPS < 0 MEANS RELATIVE ERROR)

implicit none
character*13 key
real*8 value

call init_it_ctrl_sea_ice

call clear_sea_ice_state

select case (trim(key))

  case ('it_steps')              !ITERATION STEPS
    if(value == 0d0)then
      ctrl_loop_maximum = 100    !DEFAULT = 100
    elseif(value < 0d0)then
      ctrl_loop_maximum = -1
    else
      ctrl_loop_maximum = nint(value)
    endif

  case ('init_liq_dens')         !START LIQUID DENSITY
    if(value == 0d0)then
      ctrl_mode_liquid = 0       !DEFAULT = AUX POLYNOMIAL
    elseif(value < (-1d0))then
      !ignore it
    elseif(value < 0d0)then
      ctrl_mode_liquid = nint(value)
    else
      ctrl_mode_liquid = 1
      ctrl_init_d_liq = value
    endif

  case ('init_brine_sa')         !START LIQUID DENSITY
    if(value == 0d0)then
      ctrl_mode_sea = 0          !DEFAULT = AUX POLYNOMIAL
    elseif(value < (-1d0))then
      !ignore it
    elseif(value < 0d0)then
      ctrl_mode_sea = nint(value)
    else
      ctrl_mode_sea = 1
      ctrl_init_s_sea = value
    endif

  case ('init_temp')             !START TEMPERATURE
    if(value == 0d0)then
      ctrl_mode_temperature = 0  !DEFAULT = AUX POLYNOMIAL
    elseif(value < (-1d0))then
      !ignore it
    elseif(value < 0d0)then
      ctrl_mode_temperature = nint(value)
    else
      ctrl_mode_temperature = 1
      ctrl_init_t = value
    endif

  case ('tol_brine_sa')          !REQUIRED TOLERANCE FOR BRINE SALINITY
    if(value == 0d0)then
      ctrl_eps_exit_s = -0.0000001d0   !DEFAULT = 0.1 PPM RELATIVE
    else
      ctrl_eps_exit_s = value
    endif

  case ('tol_temp')              !REQUIRED TOLERANCE FOR TEMPERATURE
    if(value == 0d0)then
      ctrl_eps_exit_t = -0.0000001d0   !DEFAULT = 0.1 PPM RELATIVE
    else
      ctrl_eps_exit_t = value
    endif

  case ('tol_press')             !REQUIRED TOLERANCE FOR PRESSURE
    if(value == 0d0)then
      ctrl_eps_exit_p = -0.0000001d0   !DEFAULT = 0.1 PPM RELATIVE
    else
      ctrl_eps_exit_p = value
    endif

  case default; write(*,*)key,' not supported'

end select

end subroutine

!==========================================================================
subroutine set_sea_ice_state(sa_si, t_si, p_si, d_si)
!==========================================================================

!STORES THE ACTUAL PROPERTIES AS THE CURRENT EQUILIBRIUM STATE DESCRIPTOR

implicit none
real*8 sa_si, t_si, p_si, d_si

equi_sea_ice_done = isok

equi_sea_ice_s = sa_si
equi_sea_ice_t = t_si
equi_sea_ice_p = p_si
equi_sea_ice_d_liq = d_si   !DENSITY OF PURE WATER

end subroutine

!==========================================================================
subroutine clear_sea_ice_state
!==========================================================================

!CLEARS THE CURRENT EQUILIBRIUM STATE DESCRIPTOR

implicit none

equi_sea_ice_done = 0

end subroutine

!==========================================================================
subroutine init_it_ctrl_sea_ice
!==========================================================================

implicit none
real*8 s_norm, tt, dt

s_norm = so_salinity_si  !KG/KG OF KCL NORMALISED SEAWATER
tt = tp_temperature_si
dt = tp_density_liq_iapws95_si  !TRIPLE POINT DENSITY OF LIQUID WATER

if(ctrl_initialized == isok) return

ctrl_initialized = isok

!SET DEFAULT VALUES AND MODES FOR THE ITERATION
ctrl_mode_liquid = 0
ctrl_mode_sea = 0
ctrl_mode_temperature = 0
ctrl_loop_maximum = 100
ctrl_init_s_sea = s_norm
ctrl_init_t = tt
ctrl_init_d_liq = dt

ctrl_eps_exit_s = -0.0000001d0 !RELATIVE, 0.1 PPM
ctrl_eps_exit_t = -0.0000001d0 !RELATIVE, 0.1 PPM
ctrl_eps_exit_p = -0.0000001d0 !RELATIVE, 0.1 PPM

end subroutine

end module sea_ice_4

module convert_5

!#########################################################################

!THIS MODULE IMPLEMENTS CONVERSION FORMULAS BETWEEN DIFFERENT SCALES AND UNITS

!#########################################################################

!IMPLEMENTATION IN FORTRAN BY D.G. WRIGHT
!FOR PUBLICATION IN OCEAN SCIENCE, AS DESCRIBED IN THE PAPERS

!FEISTEL, R., WRIGHT, D.G., JACKETT, D.R., MIYAGAWA, K., REISSMANN, J.H.,
!WAGNER, W., OVERHOFF, U., GUDER, C., FEISTEL, A., MARION, G.M.:
!NUMERICAL IMPLEMENTATION AND OCEANOGRAPHIC APPLICATION OF THE THERMODYNAMIC
!POTENTIALS OF WATER, VAPOUR, ICE, SEAWATER AND AIR. PART I: BACKGROUND AND EQUATIONS. 
!OCEAN SCIENCES, 2009, IN PREPARATION.

!WRIGHT, D.G., FEISTEL, R., JACKETT, D.R., MIYAGAWA, K., REISSMANN, J.H., 
!WAGNER, W., OVERHOFF, U., GUDER, C., FEISTEL, A., MARION, G.M.:
!NUMERICAL IMPLEMENTATION AND OCEANOGRAPHIC APPLICATION OF THE THERMODYNAMIC
!POTENTIALS OF WATER, VAPOUR, ICE, SEAWATER AND AIR. PART II: THE LIBRARY ROUTINES, 
!OCEAN SCIENCES., 2009, IN PREPARATION.

!FEISTEL, R., KRETZSCHMAR, H.-J., SPAN, R., HAGEN, E., !WRIGHT, D.G., JACKETT, D.R.:
!THERMODYNAMIC PROPERTIES OF SEA AIR.
!OCEAN SCIENCE DISCUSSION 6(2009)2193-2325.

!#########################################################################

!THIS MODULE REQUIRES THE LIBRARY MODULE
!     CONSTANTS_0,   FILE CONSTANTS_0.F90
!     CONVERT_0,     FILE CONVERT_0.F90

!#########################################################################

use constants_0
use convert_0

implicit none
private

character*16, private :: version = '8 Jun 2010'

public :: cnv_pressure, cnv_salinity, cnv_temperature

contains

!==========================================================================
function cnv_pressure(unit_out, p_in , unit_in, lat0)
!==========================================================================

!NOTE: UNIT_IN AND UNIT_OUT ARE CASE SENSITIVE. mPa IS NOT THE SAME AS MPA.
!      ALL UNITS MUST BE IN CAPITAL LETTERS

! CHECK VALUES:
! CNV_PRESSURE("MPA",4000,"DBAR")               = 40.101325
! CNV_PRESSURE("DBAR",10331325,"PA")            = 0.102300000000E+04
! CNV_PRESSURE("PA",1023,"DBAR")                = 0.103313250000E+08
! CNV_PRESSURE("TORR",10331325,"PA")            = 0.774913101406E+05
! CNV_PRESSURE("PA",0.774913101406d5,"TORR")    = 0.103313250000E+08
! CNV_PRESSURE("KGF",10331325,"PA")             = 0.105350196040E+06
! CNV_PRESSURE("PA",0.105350196040d6,"KGF")     = 0.103313250000E+08
! CNV_PRESSURE("ATM",10331325,"PA")             = 0.105350196040E+06
! CNV_PRESSURE("PA",0.105350196040d6,"ATM")     = 0.103313250000E+08
! CNV_PRESSURE("LBF/IN2",10331325,"PA")         = 0.149842272437E+04
! CNV_PRESSURE("PA",0.149842272437d4,"LBF/IN2") = 0.103313250000E+08
! CNV_PRESSURE("PSI",10331325,"PA")             = 0.149842272437E+04
! CNV_PRESSURE("PA",0.149842272437d4,"PSI")     = 0.103313250000E+08
! CNV_PRESSURE("M", 1023d0, "DBAR")             = 1011.94563591
! CNV_PRESSURE("DBAR", 1011.94563591d0, "M")    = 1023

character*(*) unit_out, unit_in
real*8 cnv_pressure, p_in
real*8 p_si, lat
real*8, optional :: lat0

cnv_pressure = ErrorReturn
p_si = ErrorReturn

if(.not. present(lat0))then
   lat = 45d0
else
   lat = lat0
endif

!CONVERT INPUT TO SI
Select Case(unit_in)
  Case ("PA"); p_si = p_in
  Case ("HPA"); p_si = p_in * 100d0
  Case ("MPA"); p_si = p_in * 1000000d0
  Case ("KPA"); p_si = p_in * 1000d0
  Case ("DBAR"); p_si = p_in * 10000d0 + 101325d0  !SEA PRESSURE ASSUMED
  Case ("MBAR"); p_si = p_in * 100d0
  Case ("BAR"); p_si = p_in * 100000d0
  Case ("KBAR"); p_si = p_in * 100000000d0
  Case ("TORR"); p_si = p_in * 101325d0 / 760d0
  Case ("MMHG"); p_si = p_in * 101325d0 / 760d0
  Case ("KGF"); p_si = p_in * 98.0665d0 !ATM = KG/CM2 GAUGE
  Case ("ATM"); p_si = p_in * 98.0665d0 !ATM = KG/CM2 GAUGE
  Case ("LBF/IN2"); p_si = p_in * 6894.8d0  !POUND PER SQUARE INCH
  Case ("PSI"); p_si = p_in * 6894.8d0  !POUND PER SQUARE INCH
  Case ("M"); p_si = 101325d0 + 1d4 * sw_pres(p_in, lat)
  Case default; write(*,*)'default P input--dbg'; return
End Select

!CONVERT SI TO OUTPUT
Select Case(unit_out)
  Case ("PA"); cnv_pressure = p_si
  Case ("HPA"); cnv_pressure = p_si / 100d0
  Case ("MPA"); cnv_pressure = p_si / 1000000d0
  Case ("KPA"); cnv_pressure = p_si / 1000d0
  Case ("DBAR"); cnv_pressure = (p_si - 101325d0) / 10000d0 !SEA PRESSURE ASSUMED
  Case ("MBAR"); cnv_pressure = p_si / 100d0
  Case ("BAR"); cnv_pressure = p_si / 100000d0
  Case ("KBAR"); cnv_pressure = p_si / 100000000d0
  Case ("TORR"); cnv_pressure = p_si / 101325d0 * 760d0
  Case ("MMHG"); cnv_pressure = p_si / 101325d0 * 760d0
  Case ("KGF"); cnv_pressure = p_si / 98.0665d0 !ATM = KG/CM2 GAUGE
  Case ("ATM"); cnv_pressure = p_si / 98.0665d0 !ATM = KG/CM2 GAUGE
  Case ("LBF/IN2"); cnv_pressure = p_si / 6894.8d0  !POUND PER SQUARE INCH
  Case ("PSI"); cnv_pressure = p_si / 6894.8d0  !POUND PER SQUARE INCH
  Case ("M"); cnv_pressure =  sw_dpth((p_si - 101325d0) / 10000d0, lat) !SEA PRESSURE ASSUMED
  Case default; write(*,*)'default P output--dbg';  return
End Select
                         
End Function

!==========================================================================
function cnv_temperature(unit_out, t_in, unit_in)
!==========================================================================

!NOTE: UNIT_IN AND UNIT_OUT ARE CASE SENSITIVE. DegC IS NOT THE SAME AS DEGC.
!      ALL UNITS MUST BE IN CAPITAL LETTERS

! CHECK VALUES:

! CNV_TEMPERATURE("DEGF(T48)",300,"K(T48)")           = 0.803300000000E+02
! CNV_TEMPERATURE("DEGF(T68)",300,"K(T48)")           = 0.803139948158E+02
! CNV_TEMPERATURE("DEGF(T90)",300,"K(T48)")           = 0.803018730496E+02
! CNV_TEMPERATURE("DEGC(T48)",300,"K(T48)")           = 0.268500000000E+02
! CNV_TEMPERATURE("DEGC(T68)",300,"K(T48)")           = 0.26841108231|2E+02
! CNV_TEMPERATURE("DEGC(T90)",300,"K(T48)")           = 0.26834373916|7E+02
! CNV_TEMPERATURE("K(T68)",300,"K(T48)")              = 0.299991108231E+03
! CNV_TEMPERATURE("K(T90)",300,"K(T48)")              = 0.29998437391|7E+03
! CNV_TEMPERATURE("DEGF(T68)",299.991108231,"K(T68)") = 0.803139916338E+02
! CNV_TEMPERATURE("DEGF(T90)",299.991108231,"K(T68)") = 0.803018698685E+02
! CNV_TEMPERATURE("DEGC(T68)",299.991108231,"K(T68)") = 0.268411064632E+02
! CNV_TEMPERATURE("DEGC(T90)",299.991108231,"K(T68)") = 0.268343721491E+02
! CNV_TEMPERATURE("K(T90)",299.991108231,"K(T68)")    = 0.299984372149E+03
! CNV_TEMPERATURE("DEGF(T90)",299.984372149,"K(T90)") = 0.803018698682E+02
! CNV_TEMPERATURE("DEGC(T90)",299.984373917,"K(T90)") = 0.268343739170E+02

character*(*) unit_out, unit_in
real*8 cnv_temperature, t_in, t_c
real*8 t_si

if(unit_out == unit_in) then; cnv_temperature = t_in; return; endif

cnv_temperature = ErrorReturn

!CONVERT INPUT TO T90
Select Case(unit_in)
  !Note: ISO(1993), ANNEX A, P. 86, GIVES T_F/DEGF = 32 + 1.8 * T_C/DEGC
  Case ("DEGF(T48)"); t_c = (t_in -32d0)/1.8d0; t_si = t_si_from_t48_k(t_k_from_t_c(t_c))
  Case ("DEGF(T68)"); t_c = (t_in -32d0)/1.8d0; t_si = t_si_from_t68_k(t_k_from_t_c(t_c))
  Case ("DEGF(T90)"); t_c = (t_in -32d0)/1.8d0; t_si = t_k_from_t_c(t_c)
  Case ("DEGC(T48)"); t_si = t_si_from_t48_k(t_k_from_t_c(t_in))
  Case ("DEGC(T68)"); t_si = t_si_from_t68_k(t_k_from_t_c(t_in))
  Case ("DEGC(T90)"); t_si = t_k_from_t_c(t_in)
  Case ("K(T48)"); t_si = t_si_from_t48_k(t_in)
  Case ("K(T68)"); t_si = t_si_from_t68_k(t_in)
  Case ("K(T90)"); t_si = t_in
  Case default; write(*,*)'TEMPERATURE INPUT UNIT NOT SUPPORTED'; return
End Select

!CONVERT T90 TO OUTPUT
Select Case(unit_out)
  Case ("DEGF(T48)")
    if(unit_in == "K(T48)")then
       cnv_temperature = 32d0 + 1.8d0 * t_c_from_t_k(t_in)
    elseif(unit_in == "DEGC(T48)")then
       cnv_temperature = 32d0 + 1.8d0 * t_in
    else
       write(*,*)'t48_f is not a valid output except for t48_k or t48_c input'; return
    endif
  Case ("DEGF(T68)"); cnv_temperature = 32d0 + 1.8d0 * t_c_from_t_k(t68_k_from_t_si(t_si))
  Case ("DEGF(T90)"); cnv_temperature = 32d0 + 1.8d0 * t_c_from_t_k(t_si)
  Case ("DEGC(T48)")
    if(unit_in == "K(T48)")then
       cnv_temperature = t_c_from_t_k(t_in)
    else
       write(*,*)'t48_c is not a valid output except for t48_k input'; return
    endif
  Case ("DEGC(T68)"); cnv_temperature = t_c_from_t_k(t68_k_from_t_si(t_si))
  Case ("DEGC(T90)"); cnv_temperature = t_c_from_t_k(t_si)
  Case ("K(T48)"); write(*,*)'t48_k is not a valid output'; return
  Case ("K(T68)"); cnv_temperature = t68_k_from_t_si(t_si)
  Case ("K(T90)"); cnv_temperature = t_si
  Case default; write(*,*)'TEMPERATURE OUTPUT UNIT NOT SUPPORTED';  return
End Select
                         
End Function

!==========================================================================
function cnv_salinity(unit_out, s_in, unit_in, t0_si, p0_si, lon0, lat0)
!==========================================================================

!NOTE: UNIT_IN AND UNIT_OUT ARE CASE SENSITIVE. Cl IS NOT THE SAME AS CL.

! CHECK VALUES:
! CNV_SALINITY("CL",0.0357,"KG/KG(ABS)",
!              lon0=201,lat0=-21,p_si=101325+1023d4)  = 0.196660177563E+02
! CNV_SALINITY("KN",0.0357,"KG/KG(ABS)",
!              lon0=201,lat0=-21,p_si=101325+1023d4)  = 0.355271620502E+02
! CNV_SALINITY("CND",0.0357,"KG/KG(ABS)",t_si=273.15+25.5,
!              lon0=201,lat0=-21,p_si=101325+1023d4)  = 0.127556680822E+01
! CNV_SALINITY("PSS",0.0357,"KG/KG(ABS)",
!              lon0=201,lat0=-21,p_si=101325+1023d4)  = 0.355276443777E+02
! CNV_SALINITY("KG/KG(REF)",0.0357d0,"KG/KG(ABS)",
!              lon0=201,lat0=-21,p_si=101325+1023d4)  = 0.356951724471E-01
! CNV_SALINITY("KG/KG(ABS)",0.0356951724471,"KG/KG(REF)",
!              lon0=201,lat0=-21,p_si=101325+1023d4)  = 0.0357
! CNV_SALINITY("CL",35.52764437773386,"PSS")         = 0.196660177563E+02
! cnv_salinity("KN",35.52764437773386,"PSS")         = 0.355271620502E+02
! CNV_SALINITY("CND",35.52764437773386,"PSS",
!              t_si=273.15+25.5,p_si=101325+1023d4)  = 0.127556680822E+01
! CNV_SALINITY("KG/KG(REF)",35.52764437773386,"PSS") = 0.356951724471E-01
! CNV_SALINITY("KG/KG(ABS)",35.52764437773386,"PSS",
!              lon0=201,lat0=-21,p_si=101325+1023d4)  = 0.0357
! CNV_SALINITY("KG/KG(ABS)", 35d0, "PSS", &
!              lon0=179d0, lat0=40d0, p0_si=101325d0+2d7), "3.51888478029404E-2"
! CNV_SALINITY("KG/KG(ABS)", 8d0, "PSS", &
!              lon0=20d0, lat0=57d0, p0_si=101325d0), "8.13338057142857E-03"
! CNV_SALINITY("PSS",0.355271620502E+02,"KN")        = 0.355276443777E+02
! CNV_SALINITY("KG/KG(ABS)",0.355271620502E+02,"KN",
!              lon0=201,lat0=-21,p_si=101325+1023d4)  = 0.357000000000E-01
! CNV_SALINITY("PSS",0.127556680822E+01,"CND",
!              t_si=273.15+25.5,p_si=101325+1023d4)  = 0.355226965418E+02
! CNV_SALINITY("KG/KG(ABS)",0.127556680822E+01,"CND",t_si=273.15+25.5,
!              lon0=201,lat0=-21,p_si=101325+1023d4)  = 0.0357

character*(*) unit_out, unit_in
real*8 cnv_salinity, s_in
real*8 t, p
real*8, optional :: lat0, lon0, t0_si, p0_si
real*8 :: t_si, p_si, ploc_si, lon, lat
real*8 ups, ucl, c35, t68_c, p_dbar, psal, s_si, c_ratio

if (unit_in == unit_out)then
   cnv_salinity = s_in
   return
endif

ups = SO_salinity_si / 35d0  !SR = SP * ups
ucl = 1.80655d0 * ups        !SR = Cl * ucl
c35 = 4.2914d0               !C(35,15,0) = 42.914 mS/CM = 4.2914 S/M,  CULKIN & SMITH

if(unit_in == unit_out) then
   cnv_salinity = s_in
   return
endif

cnv_salinity = ErrorReturn
s_si = ErrorReturn

if(present(lon0) .and. present(lat0) .and. present(p0_si)) then
   lon = lon0
   lat = lat0
   ploc_si = p0_si
else
   lon = -20d0
   lat = 50d0
   ploc_si = 101325d0
endif
if(present(t0_si)) then
   t_si = t0_si
else
   t_si = 298.15d0
endif
if(present(p0_si)) then
   p_si = p0_si
else
   p_si = 101325d0
endif
t = t_si - 273.15d0
p = (p_si - 101325d0)/1d4

!CONVERT INPUT TO REFERENCE SALINITY IN KG/KG

Select Case(unit_in)

  !Chlorinity
  Case ("CL"); s_si = s_in * ucl

  !Knudsen Salinity
  Case ("KN"); s_si = (s_in - 0.03d0) / 1.805d0 * ucl

  !Conductivity
  Case ("MS/CM")  !CONDUCTIVITY IN mS/CM = MMHO/CM
     if(.not. present(p0_si)) then
        write(*,*) 'Warning: pressure is needed to convert between conductivity and salinity'
        write(*,*) 'Proceeding with atmospheric pressure'
     endif
     if(.not. present(t0_si)) then
        write(*,*) 'Warning: temperature is needed to convert conductivity to salinity'
        write(*,*) 'Proceeding with T90 = 273.15 + 25'
     endif
     s_si = sal78_from_cnd(s_in, t, p) * ups
     t68_c = cnv_temperature("DEGC(T68)", t_si, "K(T90)")
     p_dbar = cnv_pressure("DBAR", p_si, "PA")
     c_ratio = 0.1 * s_in / c35
     s_si = sal78_from_cnd(c_ratio, t68_c, p_dbar) * ups
  Case ("MMHO/CM")
     if(.not. present(p0_si)) then
        write(*,*) 'Warning: pressure is needed to convert between conductivity and salinity'
        write(*,*) 'Proceeding with atmospheric pressure'
     endif
     if(.not. present(t0_si)) then
        write(*,*) 'Warning: temperature is needed to convert conductivity to salinity'
        write(*,*) 'Proceeding with T90 = 273.15 + 25'
     endif
     s_si = sal78_from_cnd(s_in, t, p) * ups
     t68_c = cnv_temperature("DEGC(T68)", t_si, "K(T90)")
     p_dbar = cnv_pressure("DBAR", p_si, "PA")
     c_ratio = 0.1 * s_in / c35
     s_si = sal78_from_cnd(c_ratio, t68_c, p_dbar) * ups
  Case ("S/M")
     if(.not. present(p0_si)) then
        write(*,*) 'Warning: pressure is needed to convert between conductivity and salinity'
        write(*,*) 'Proceeding with atmospheric pressure'
     endif
     if(.not. present(t0_si)) then
        write(*,*) 'Warning: temperature is needed to convert conductivity to salinity'
        write(*,*) 'Proceeding with T90 = 273.15 + 25'
     endif
     t68_c = cnv_temperature("DEGC(T68)", t_si, "K(T90)")
     p_dbar = cnv_pressure("DBAR", p_si, "PA")
     c_ratio = s_in / c35
     s_si = sal78_from_cnd(c_ratio, t68_c, p_dbar) * ups
  Case ("CND")
     if(.not. present(p0_si)) then
        write(*,*) 'Warning: pressure is needed to convert between conductivity and salinity'
        write(*,*) 'Proceeding with atmospheric pressure'
     endif
     if(.not. present(t0_si)) then
        write(*,*) 'Warning: temperature is needed to convert conductivity to salinity'
        write(*,*) 'Proceeding with T90 = 273.15 + 25'
     endif
     t68_c = cnv_temperature("DEGC(T68)", t_si, "K(T90)")
     p_dbar = cnv_pressure("DBAR", p_si, "PA")
     c_ratio = s_in
     s_si = sal78_from_cnd(c_ratio, t68_c, p_dbar) * ups

  !PRACTICAL SALINITY
  Case ("PSU"); s_si = s_in * ups
  Case ("PSS"); s_si = s_in * ups
  Case ("ONE"); s_si = s_in * ups

  !REFERENCE SALINITY
  Case ("KG/KG(REF)"); s_si = s_in
  Case ("G/KG(REF)"); s_si = 0.001d0 * s_in


  !ABSOLUTE SALINITY
  Case ("KG/KG(ABS)")
     if(.not. (present(lat0) .and. present(lon0) .and. present(p0_si))) then
        write(*,*) 'Position and pressure are needed to convert from or to Absolute Salinity'
        write(*,*) 'in order to determine the Absolute Salinity anomaly'
        write(*,*) 'Proceeding value from surface North Atlantic (near zero)'
     endif
     s_si = sp_from_sa(s_in, lon, lat, ploc_si) * ups
  Case ("G/KG(ABS)")
     if(.not. (present(lat0) .and. present(lon0) .and. present(p0_si))) then
        write(*,*) 'Position and pressure are needed to convert from or to Absolute Salinity'
        write(*,*) 'in order to determine the Absolute Salinity anomaly'
        write(*,*) 'Proceeding value from surface North Atlantic (near zero)'
     endif
     s_si = sp_from_sa(0.001d0 * s_in, lon, lat, ploc_si) * ups

  Case default; return
End Select


!CONVERT SI REFERENCE SALINITY TO OUTPUT
Select Case(unit_out)

  !Chlorinity
  Case ("CL"); cnv_salinity = s_si / ucl

  !Knudsen Salinity
  Case ("KN"); cnv_salinity = 0.03d0 + 1.805d0 * s_si / ucl

  !Conductivity
  Case ("MS/CM")  !conductivity in mS/cm = mmho/cm
     if(.not. present(p0_si)) then
        write(*,*) 'Warning: pressure is needed to convert between conductivity and salinity'
        write(*,*) 'Proceeding with atmospheric pressure'
     endif
     if(.not. present(t0_si)) then
        write(*,*) 'Warning: temperature is needed to convert between conductivity and salinity'
        write(*,*) 'Proceeding with T90 = 273.15 + 25'
     endif
     t68_c = cnv_temperature("DEGC(T68)", t_si, "K(T90)")
     p_dbar = cnv_pressure("DBAR", p_si, "PA")
     psal = s_si / ups
     cnv_salinity = 10 * c35 * cnd_from_sal78(psal, t68_c, p_dbar)
  Case ("MMHO/CM")
     if(.not. present(p0_si)) then
        write(*,*) 'Warning: pressure is needed to convert between conductivity and salinity'
        write(*,*) 'Proceeding with atmospheric pressure'
     endif
     if(.not. present(t0_si)) then
        write(*,*) 'Warning: temperature is needed to convert between conductivity and salinity'
        write(*,*) 'Proceeding with T90 = 273.15 + 25'
     endif
     t68_c = cnv_temperature("DEGC(T68)", t_si, "K(T90)")
     p_dbar = cnv_pressure("DBAR", p_si, "PA")
     psal = s_si / ups
     cnv_salinity = 10 * c35 * cnd_from_sal78(psal, t68_c, p_dbar)
  Case ("S/M")  !conductivity in S/m
     if(.not. present(p0_si)) then
        write(*,*) 'Warning: pressure is needed to convert between conductivity and salinity'
        write(*,*) 'Proceeding with atmospheric pressure'
     endif
     if(.not. present(t0_si)) then
        write(*,*) 'Warning: temperature is needed to convert between conductivity and salinity'
        write(*,*) 'Proceeding with T90 = 273.15 + 25'
     endif
     t68_c = cnv_temperature("DEGC(T68)", t_si, "K(T90)")
     p_dbar = cnv_pressure("DBAR", p_si, "PA")
     psal = s_si / ups
     cnv_salinity = c35 * cnd_from_sal78(psal, t68_c, p_dbar)
  Case ("CND")    !conductivity ratio
     if(.not. present(p0_si)) then
        write(*,*) 'Warning: pressure is needed to convert between conductivity and salinity'
        write(*,*) 'Proceeding with atmospheric pressure'
     endif
     if(.not. present(t0_si)) then
        write(*,*) 'Warning: temperature is needed to convert between conductivity and salinity'
        write(*,*) 'Proceeding with T90 = 273.15 + 25'
     endif
     t68_c = cnv_temperature("DEGC(T68)", t_si, "K(T90)")
     p_dbar = cnv_pressure("DBAR", p_si, "PA")
     psal = s_si / ups
     cnv_salinity = cnd_from_sal78(psal, t68_c, p_dbar)

  Case ("PSU"); cnv_salinity = s_si / ups
  Case ("PSS"); cnv_salinity = s_si / ups
  Case ("ONE"); cnv_salinity = s_si / ups

  !Reference Salinity
  Case ("KG/KG(REF)"); cnv_salinity = s_si
  Case ("G/KG(REF)"); cnv_salinity = 1d3 * s_si

  !Absolute Salinity
  Case ("KG/KG(ABS)")
     if(.not. (present(lat0) .and. present(lon0) .and. present(p0_si))) then
        write(*,*) 'Position and pressure are needed to convert from or to Absolute Salinity'
        write(*,*) 'in order to determine the Absolute Salinity anomaly'
        write(*,*) 'Proceeding value from surface North Atlantic (near zero)'
     endif
     psal = s_si / ups
     cnv_salinity = sa_from_sp(psal, lon, lat, ploc_si)
  Case ("G/KG(ABS)")
     if(.not. (present(lat0) .and. present(lon0) .and. present(p0_si))) then
        write(*,*) 'Position and pressure are needed to convert from or to Absolute Salinity'
        write(*,*) 'in order to determine the Absolute Salinity anomaly'
        write(*,*) 'Proceeding value from surface North Atlantic (near zero)'
     endif
     psal = s_si / ups
     cnv_salinity = 1d3 * sa_from_sp(psal, lon, lat, ploc_si)

  Case default; return
End Select
                         
End Function

!==========================================================================
function t_k_from_t_c(t_c)
!==========================================================================

!THIS FUNCTION COMPUTES TEMPERATURE IN K FROM TEMPERATURE IN deg C (ITS-90, IPTS-68, IPTS-48)

implicit none
real*8 t_k_from_t_c, t_c

t_k_from_t_c = 273.15d0 + t_c

end function

!==========================================================================
function t_c_from_t_k(t_k)
!==========================================================================

!THIS FUNCTION COMPUTES TEMPERATURE IN °C FROM TEMPERATURE IN K (ITS-90, IPTS-68, IPTS-48)

implicit none
real*8 t_c_from_t_k, t_k

t_c_from_t_k = t_k - 273.15d0

end function

!==========================================================================
function t68_k_from_t48_k(t48_k)
!==========================================================================

!THIS FUNCTION RETURNS IPTS-68 TEMPERATURE IN K COMPUTED FROM IPTS-48 TEMPERATURE IN K.

!VB CODE ADAPTED FROM:

!****************************************************************************
!
!                          RUHR-UNIVERSITAET BOCHUM
!                        LEHRSTUHL FUER THERMODYNAMIK
!                          PROF. DR.-ING. W. WAGNER
!                              D - 44780 BOCHUM
!                             TEL.: 0234/700-3033
!                             FAX : 0234/7094 -163
!
!****************************************************************************

! PROGRAMM ZUR TEMPERATURUMRECHNUNG: IPTS-48 IN IPTS-68

! DER WERT !T48_K! IN DER IPTS-48 (IN KELVIN) WIRD VOM RUFENDEN PROGRAMM UEBENOMMEN
! UND IN T68_K_FROM_T48_K (IN KELVIN) WIEDER UEBERGEBEN.

implicit none
real*8 t68_k_from_t48_k, t48_k
integer i, k
real*8 a48a4, b48, c48c4, a48a68, b48b68, a68, b68
real*8 t48, t68, t68alt, tstri
real*8 hg1, hg2, hg3, fkt
real*8 a(21)

a48a4 = 0.003984517d0
b48 = -0.000000585502d0
c48c4 = -4.35716d-12
a48a68 = -0.00000019539d0
b48b68 = 0.0000000019539d0
a68 = 0.003984712d0
b68 = -0.000000587456d0

a(1) = 273.15d0
a(2) = 250.846209678803d0
a(3) = 135.099869965d0
a(4) = 52.78567590085d0
a(5) = 27.6768548854105d0
a(6) = 39.1053205376684d0
a(7) = 65.5613230578069d0
a(8) = 80.8035868559867d0
a(9) = 70.5242118234052d0
a(10) = 44.7847589638966d0
a(11) = 21.2525653556078d0
a(12) = 7.67976358170846d0
a(13) = 2.1368945938285d0
a(14) = 0.459843348928069d0
a(15) = 7.63614629231648d-02
a(16) = 9.69328620373121d-03
a(17) = 9.23069154007008d-04
a(18) = 6.38116590952654d-05
a(19) = 3.02293237874619d-06
a(20) = 8.7755139130376d-08
a(21) = 1.17702613125477d-09

if (t48_k < 90d0) then
  !MSGBOX "ACHTUNG: KEINE UMRECHNUNG T48T68 FUER T48_K < 90 K !"
  t68_k_from_t48_k = t48_k
  return
end if

if (t48_k > 273.15d0) goto 10

t48 = t48_k - 273.15d0
hg1 = 1d0 + a48a4*t48 + b48*t48*t48 + c48c4*t48*t48*t48*(t48 - 100d0)
hg1 = log(hg1)
t68 = 0d0
do k = 1, 21
  i = 22 - k
  t68 = t68 * hg1 + a(i)
enddo

t68_k_from_t48_k = t68
return

10    continue
t48 = t48_k - 273.15d0
hg1 = a68 + 2d0 * b68 * t48
hg2 = a48a68 * t48 + b48b68 * t48 * t48
t68 = t48
t68alt = t48
tstri = t48

11    continue
fkt = 0.045d0*tstri/100d0*(tstri/100d0 - 1d0)  &
      *(tstri/419.58d0 - 1d0)*(tstri/630.74d0 - 1d0)
hg3 = b68 * (t68 - t48 - fkt) * (t68 - t48 - fkt)
t68 = t48 + fkt + hg2 / hg1 - hg3 / hg1
if (abs(t68 - t68alt) < 1d-12) goto 12  !dbg NOTE 1D-5 REPLACED BY 1D-12
t68alt = t68
tstri = t68
goto 11

12    continue
t68_k_from_t48_k = t68 + 273.15d0

end function

!==========================================================================
function t_si_from_t48_k(t48_k)
!==========================================================================

implicit none 
real*8 t_si_from_t48_k, t48_k

t_si_from_t48_k = t_si_from_t68_k(t68_k_from_t48_k(t48_k))

end function

!==========================================================================
function t_si_from_t68_k(t68_k)
!==========================================================================

!THIS FUNCTION RETURNS ITS-90 TEMPERATURE IN K COMPUTED FROM IPTS-68 TEMPERATURE IN K.

!VB CODE ADAPTED FROM:

!****************************************************************************
!
!                          RUHR-UNIVERSITAET BOCHUM
!                        LEHRSTUHL FUER THERMODYNAMIK
!                          PROF. DR.-ING. W. WAGNER
!                              D - 44780 BOCHUM
!                             TEL.: 0234/700-3033
!                             FAX : 0234/7094 -163
!
!****************************************************************************
!
!   REGION 1:  13.8 K  < T68_K <   83.8 K
!
!   REGION 2:  83.8 K  < T68_K <  903.75 K
!
!   REGION 3: 903.89 K < T68 < 1337.58 K
!
!   REGION 4:     1337.58 < T68
!
!   INPUT:  T68_K      TEMPERATURE IN K (IPTS-68)
!
!   OUTPUT: T90_K_FROM_T68_K   TEMPERATURE IN K (ITS-90)
!
! FROM:
!
!  SUPPLEMENTARY INFORMATION FOR THE ITS-90, BUREAU INTERNATIONAL DES POIDS ET
!  MESURES, PAV BRETEUIL, 92312 SEVRES CEDEX, FRANCE, 1990.
!
!  R.L.RUSBY: THE CONVERSION OF THERMAL REFERENCE VALUES TO THE
!             ITS-90. J. CHEM. THERMODYNAMICS, 1991, 23, 1153 - 1161.
!
!  RUSBY ET AL.: INTERNATIONAL REPORT. REVISED VALUES FOR (T90-T68) FROM
!                630C TO 1064C. METROLOGIA, 1994, 31, 149 - 153.
!
!****************************************************************************


implicit none
real*8 t_si_from_t68_k, t68_k
integer j
real*8 deltat, tn
real*8 a(0:12), b(1:8), c(0:5)


a(0) = -0.005903d0
a(1) = 0.008174d0
a(2) = -0.061924d0
a(3) = -0.193388d0
a(4) = 1.490793d0
a(5) = 1.252347d0
a(6) = -9.835868d0
a(7) = 1.411912d0
a(8) = 25.277595d0
a(9) = -19.183815d0
a(10) = -18.437089d0
a(11) = 27.000895d0
a(12) = -8.716324d0

b(1) = -0.148759d0
b(2) = -0.267408d0
b(3) = 1.08076d0
b(4) = 1.269056d0
b(5) = -4.089591d0
b(6) = -1.871251d0
b(7) = 7.438081d0
b(8) = -3.536296d0

c(0) = 78.687209d0
c(1) = -0.47135991d0
c(2) = 0.0010954715d0
c(3) = -0.0000012357884d0
c(4) = 6.7736583d-10
c(5) = -1.4458081d-13

deltat = 0d0

if (t68_k < 13.8d0) goto 999

!*** REGION 4 ***
if (t68_k >= 1337.58d0) then
  deltat = -0.25d0 * (t68_k / 1337.33d0) ** 2
  goto 1000

!*** REGION 3 ***
!DIE GLEICHUNG IST IN ABHAENGIGKEIT VON T90 FORMULIERT, FUER DIE
!BERECHNUNG VON DELTAT WIRD HIER T68=T90 GESETZT /AK 16.7.96
elseif (t68_k >= 903.89d0) then
  tn = t68_k - 273.15d0
  do j = 1, 5
    deltat = deltat + c(j) * tn ** j
  enddo

  deltat = deltat + c(0)
  goto 1000

! *** REGION 2 ***
elseif (t68_k >= 83.8d0) then
  tn = (t68_k - 273.15d0) / 630d0
  do j = 1, 8
    deltat = deltat + b(j) * tn ** j
  enddo
  goto 1000

!*** REGION 1 ***
elseif (t68_k >= 13.8d0) then
  tn = (t68_k - 40d0) / 40d0
  do j = 1, 12
    deltat = deltat + a(j) * tn ** j
  enddo

  deltat = deltat + a(0)
  goto 1000
end if

999   write(*,*) "temperature out of range of validity, no conversion."
      t_si_from_t68_k = t68_k
      return

1000  t_si_from_t68_k = t68_k + deltat

end function

!==========================================================================
function t68_k_from_t_si(t_si)
!==========================================================================

!THIS FUNCTION RETURNS IPTS-68 TEMPERATURE IN K COMPUTED FROM ITS-90 TEMPERATURE IN K.

!VB CODE ADAPTED FROM:

!****************************************************************************
!
!                          RUHR-UNIVERSITAET BOCHUM
!                        LEHRSTUHL FUER THERMODYNAMIK
!                          PROF. DR.-ING. W. WAGNER
!                              D - 44780 BOCHUM
!                             TEL.: 0234/700-3033
!                             FAX : 0234/7094 -163
!
!****************************************************************************
!
!   REGION 1:  13.8 K  < T_SI <   83.8 K
!
!   REGION 2:  83.8 K  < T_SI <  903.75 K
!
!   REGION 3: 903.765 K < T_SI < 1337.33 K
!
!   REGION 4:     1337.33 < T_SI
!
!   INPUT:  T_SI      TEMPERATURE IN K (ITS-90)
!
!   OUTPUT: T68_K_FROM_T_SI   TEMPERATURE IN K (IPTS-68)
!
! FROM:
!
!  SUPPLEMENTARY INFORMATION FOR THE ITS-90, BUREAU INTERNATIONAL DES POIDS ET
!  MESURES, PAV BRETEUIL, 92312 SEVRES CEDEX, FRANCE, 1990.
!
!  R.L.RUSBY: THE CONVERSION OF THERMAL REFERENCE VALUES TO THE
!             ITS-90. J. CHEM. THERMODYNAMICS, 1991, 23, 1153 - 1161.
!
!  RUSBY ET AL.: INTERNATIONAL REPORT. REVISED VALUES FOR (T90-T68) FROM
!                630C TO 1064C. METROLOGIA, 1994, 31, 149 - 153.
!
!****************************************************************************

implicit none 
integer j
real*8 t68_k_from_t_si, t_si
real*8 deltat, tn
real*8 a(0:12), b(1:8), c(0:5)

a(0) = -0.005903d0
a(1) = 0.008174d0
a(2) = -0.061924d0
a(3) = -0.193388d0
a(4) = 1.490793d0
a(5) = 1.252347d0
a(6) = -9.835868d0
a(7) = 1.411912d0
a(8) = 25.277595d0
a(9) = -19.183815d0
a(10) = -18.437089d0
a(11) = 27.000895d0
a(12) = -8.716324d0

b(1) = -0.148759d0
b(2) = -0.267408d0
b(3) = 1.08076d0
b(4) = 1.269056d0
b(5) = -4.089591d0
b(6) = -1.871251d0
b(7) = 7.438081d0
b(8) = -3.536296d0

c(0) = 78.687209d0
c(1) = -0.47135991d0
c(2) = 0.0010954715d0
c(3) = -0.0000012357884d0
c(4) = 6.7736583d-10
c(5) = -1.4458081d-13

deltat = 0d0
if (t_si < 13.8d0) goto 999

!*** REGION 4 ***
if (t_si >= 1337.33d0) then
  deltat = -0.25d0 * (t_si / 1337.33d0) ** 2
  goto 1000

!*** REGION 3 ***
elseif (t_si >= 903.765d0) then
  tn = t_si - 273.15d0
  do j = 1, 5
    deltat = deltat + c(j) * tn ** j
  enddo
  deltat = deltat + c(0)
  goto 1000

!*** REGION 2 ***
elseif (t_si >= 83.8d0) then
  tn = (t_si - 273.15d0) / 630d0
  do j = 1, 8
    deltat = deltat + b(j) * tn ** j
  enddo
  goto 1000

!*** REGION 1 ***
elseif (t_si >= 13.8d0) then
  tn = (t_si - 40d0) / 40d0
  do j = 1, 12
    deltat = deltat + a(j) * tn ** j
  enddo

  deltat = deltat + a(0)
  goto 1000
end if

999   write(*,*) "temperature out of range of validity, no conversion."
      t68_k_from_t_si = t_si
      return

1000  t68_k_from_t_si = t_si - deltat

end function

!==========================================================================
function p_si_from_psea_pa(psea_pa)
!==========================================================================

!THIS FUNCTION COMPUTES ABSOLUTE PRESSURE IN PA FROM SEA PRESSURE IN PA

implicit none
real*8 p_si_from_psea_pa, psea_pa

p_si_from_psea_pa = psea_pa + 101325d0

end function

!==========================================================================
function psea_pa_from_p_si(p_si)
!==========================================================================

!THIS FUNCTION COMPUTES SEA PRESSURE IN PA FROM ABSOLUTE PRESSURE IN PA

implicit none 
real*8 psea_pa_from_p_si, p_si

psea_pa_from_p_si = p_si - 101325d0

end function

!==========================================================================
function psea_pa_from_psea_bar(psea_bar)
!==========================================================================

!THIS FUNCTION COMPUTES SEA PRESSURE IN PA FROM ABSOLUTE PRESSURE IN PA

implicit none
real*8 psea_pa_from_psea_bar, psea_bar

psea_pa_from_psea_bar = psea_bar * 100000d0

end function

!==========================================================================
function psea_bar_from_psea_pa(psea_pa)
!==========================================================================

!THIS FUNCTION COMPUTES SEA PRESSURE IN PA FROM ABSOLUTE PRESSURE IN PA

implicit none
real*8 psea_bar_from_psea_pa, psea_pa

psea_bar_from_psea_pa = psea_pa * 0.00001d0

end function

!=====================================================
function sal78_from_cnd(cnd, t, p)
!=====================================================

!THE CONDUCTIVITY RATIO (CND)=1.0000000 FOR SALINITY=35 PSS-78
!TEMPERATURE=15.0 DEG. CELSIUS AND ATMOSPHERIC PRESSURE.
!FUNCTION TO CONVERT CONDUCTIVITY RATIO TO SALINITY

!REFERENCES: ALSO LOCATED IN UNESCO REPORT NO. 37 1981
!PRACTICAL SALINITY SCALE 1978: E.L. LEWIS IEEE OCEAN ENG. JAN. 1980

!----------------------------------------------------------
!UNITS:
!  PRESSURE      P      DECIBARS
!  TEMPERATURE   T      DEG CELSIUS IPTS-68
!  CONDUCTIVITY  CND    RATIO
!  SALINITY      SAL78  PSS-78
!----------------------------------------------------------
!CHECKVALUES:
!  SAL78=40.00000 for CND=1.8880911555787682, T=40 DEG C, P=10000 DECIBARS
!----------------------------------------------------------
!SAL78 RATIO: RETURNS ZERO FOR CONDUCTIVITY RATIO: < 0.0005
!----------------------------------------------------------
!ORIGINAL FORTRAN CODE IS FOUND IN:
!  UNESCO TECHNICAL PAPERS IN MARINE SCIENCE 44 (1983) -
!  'ALGORITHMS FOR COMPUTATION OF FUNDAMENTAL PROPERTIES OF SEAWATER'
!----------------------------------------------------------
!TRANSLATED TO OBJECT PASCAL BY:
!  DR. JAN SCHULZ, 19 MAY 2008, WWW.CODE10.INFO
!----------------------------------------------------------
!TRANSLATED BACK TO FORTRAN BY:
!  D. WRIGHT, BIO, 23 SEPT., 2009
!----------------------------------------------------------

real*8 sal78_from_cnd, cnd, t, p
real*8 dt, res, rt

sal78_from_cnd = 0d0

! ZERO SALINITY/CONDUCTIVITY TRAP
if (cnd <= 5d-4) return

dt = t - 15d0

! CONVERT CONDUCTIVITY TO SALINITY
res   = cnd
rt    = res / (rt35(t) * (1d0 + c(p) / (b(t) + a(t) * res)))
rt    = sqrt (abs(rt))
sal78_from_cnd = sal (rt, dt)

end function


!=====================================================
function cnd_from_sal78 (sal78, t, p)
!=====================================================

!THE CONDUCTIVITY RATIO (CND)=1.0000000 FOR SALINITY=35 PSS-78
!TEMPERATURE=15.0 DEG. CELSIUS AND ATMOSPHERIC PRESSURE.
!Function to convert SALINITY TO CONDUCTIVITY RATIO

!REFERENCES: ALSO LOCATED IN UNESCO REPORT NO. 37 1981
!PRACTICAL SALINITY SCALE 1978: E.L. LEWIS IEEE OCEAN ENG. JAN. 1980

!----------------------------------------------------------
!UNITS:
!  PRESSURE      P      DECIBARS
!  TEMPERATURE   T      DEG CELSIUS IPTS-68
!  CONDUCTIVITY  CND    RATIO
!  SALINITY      SAL78  PSS-78
!----------------------------------------------------------
!CHECKVALUES:
!  CND=1.8880911555787682 for SAL78=40.0000, T=40 DEG C, P=10000 DECIBARS
!----------------------------------------------------------
!CND: RETURNS ZERO FOR SALINITY: < 0.02
!----------------------------------------------------------
!ORIGINAL FORTRAN CODE IS FOUND IN:
!  UNESCO TECHNICAL PAPERS IN MARINE SCIENCE 44 (1983) -
!  'ALGORITHMS FOR COMPUTATION OF FUNDAMENTAL PROPERTIES OF SEAWATER'
!----------------------------------------------------------
!TRANSLATED TO OBJECT PASCAL BY:
!  DR. JAN SCHULZ, 19 MAY 2008, WWW.CODE10.INFO
!----------------------------------------------------------
!TRANSLATED BACK TO FORTRAN BY:
!  D. WRIGHT, BIO, 23 SEPT., 2009
!----------------------------------------------------------

integer n
real*8 cnd_from_sal78, cnd, sal78, t, p
real*8 dt, rt, si, dels, rtt, at, bt, cp, res

cnd_from_sal78 = errorreturn
cnd = 0d0

!ZERO SALINITY/CONDUCTIVITY TRAP
if (sal78 <= 0.2d0) return

dt = t - 15d0

!INVERT SALINITY TO CONDUCTIVITY BY THE
!NEWTON-RAPHSON ITERATIVE METHOD

!FIRST APPROXIMATION
rt = sqrt(sal78 / 35d0)
si = sal(rt, dt)

!ITERATION LOOP BEGINS HERE WITH A MAXIMUM OF 20 CYCLES
do n = 1, 20
   rt   = rt + (sal78 - si) / dsal(rt, dt)
   si   = sal(rt, dt)
   dels = abs(si - sal78)
   if (n.gt.1 .and. dels < 1d-20) go to 99
enddo

99 continue

!COMPUTE CONDUCTIVITY RATIO
rtt = rt35(t) * rt * rt
at  = a(t)
bt  = b(t)
cp  = c(p)
cp  = rtt * (cp + bt)
bt  = bt - rtt * at

!SOLVE QUADRATIC EQUATION FOR R: R=RT35*RT*(1+C/AR+B)
res = sqrt(abs (bt * bt + 4d0 * at * cp)) - bt

!RETURN CONDUCTIVITY
cnd_from_sal78 = 0.5d0 * res / at

end function


!=====================================================
function sal(xr, xt)
!=====================================================

!PRACTICAL SALINITY SCALE 1978 DEFINITION WITH TEMPERATURE
!CORRECTION;XT :=T-15.0; XR:=SQRT(RT)

real*8 sal, xr, xt

sal = ((((2.7081d0*xr-7.0261d0)*xr+14.0941d0)*xr+25.3851d0)*xr &
    - 0.1692d0)*xr+0.0080d0 &
    + (xt/(1d0+0.0162d0*xt))*(((((-0.0144d0*xr &
    + 0.0636d0)*xr-0.0375d0)*xr-0.0066d0)*xr &
    - 0.0056d0)*xr+0.0005d0)

end function


!=====================================================
function dsal(xr, xt)
!=====================================================

!FUNCTION FOR DERIVATIVE OF SAL(XR,XT) WITH XR

real*8 dsal, xr, xt

dsal = ((((13.5405d0 * xr - 28.1044d0) * xr + 42.2823d0) * xr + 50.7702d0) &
     * xr - 0.1692d0) + (xt / (1d0 + 0.0162d0 * xt)) * ((((-0.0720d0 &
     * xr + 0.2544d0) * xr - 0.1125d0) * xr - 0.0132d0) * xr - 0.0056d0)

end function


!=====================================================
function rt35(xt)
!=====================================================

!FUNCTION RT35: C(35,T,0)/C(35,15,0) VARIATION WITH TEMPERATURE

real*8 rt35, xt

rt35 = (((1.0031d-9 * xt - 6.9698d-7) * xt + 1.104259d-4) * xt &
     + 2.00564d-2) * xt + 0.6766097d0

end function


!=====================================================
function c(xp)
!=====================================================

!C(XP) POLYNOMIAL CORRESPONDS TO A1-A3 CONSTANTS: LEWIS 1980

real*8 c, xp

c = ((3.989d-15 * xp - 6.370d-10) * xp + 2.070d-5) * xp

end function


!=====================================================
function b(xt)
!=====================================================

real*8 b, xt

b = (4.464d-4 * xt + 3.426d-2) * xt + 1d0

end function


!=====================================================
function a(xt)
!=====================================================

!A(XT) POLYNOMIAL CORRESPONDS TO B3 AND B4 CONSTANTS: LEWIS 1980

real*8 a, xt

a = -3.107d-3 * xt + 0.4215d0

end function

!=========================================================================
function sw_dpth(P,LAT)
!=========================================================================

! SW_DPTH    DEPTH FROM PRESSURE
!=========================================================================
! SW_DPTH   IS A MODIFICATION OF THE MATLAB ROUTINE WRITTEN BY PHIL MORGAN
!           OF CSIRO FOR THE SEAWATER LIBRARY DEVELOPED BY HIM AROUND 1992.
!
! USAGE:  DPTH = SW_DPTH(P,LAT)
!
! DESCRIPTION:
!    CALCULATES DEPTH IN METRES FROM PRESSURE IN DBARS. 
!    BASED ON EQN 25, P26.  UNESCO 1983.
!
! INPUT:
!   P   = PRESSURE    [DB]
!   LAT = LATITUDE IN DECIMAL DEGRESS NORTH [-90..+90]
!
! OUTPUT:
!  DPTH = DEPTH [METRES]
!
! DISCLAIMER:
!   THIS SOFTWARE IS PROVIDED "AS IS" WITHOUT WARRANTY OF ANY KIND.
!
! REFERENCES: 
!    SAUNDERS, P.M. 1981
!    "PRACTICAL CONVERSION OF PRESSURE TO DEPTH"
!    JOURNAL OF PHYSICAL OCEANOGRAPHY, 11, 573-574
!=========================================================================

real*8 p, sw_dpth
real*8 deg2rad, x, c1
real*8, optional :: lat

if(.not. present(lat))lat=45d0

sw_dpth = errorreturn

! CHECK INPUTS
if(p .lt. 0d0 .or. abs(lat) .gt. 90d0)return

! The following commented code is the original
! It is not an exact inverse of sw_press
!deg2rad = 3.1415926535d0/180d0
!c1 = +9.72659d0
!c2 = -2.2512d-5
!c3 = +2.279d-10
!c4 = -1.82d-15
!gam_dash = 2.184d-6
!x   = sin(lat*deg2rad)**2  ! CONVERT TO RADIANS
!sw_dpth = (((c4*p+c3)*p+c2)*p+c1)*p
!sw_dpth = sw_dpth / (9.780318d0*(1d0+(5.2788d-3+2.36d-5*x)*x) + gam_dash*0.5d0*p)

! The following code is simply the analyticalinverse of swpres
deg2rad = 3.1415926535d0/180d0
x       = sin(abs(lat)*deg2rad)  ! convert to radians
c1      = 5.92d-3 + x**2 * 5.25d-3
sw_dpth = ((1d0-c1)**2 - (1d0 - c1 - 4.42d-6*p)**2)/8.84d-6

return
end function

!===========================================================================
function sw_pres(depth,lat)
!===========================================================================

! SW_PRES    PRESSURE FROM DEPTH
!===========================================================================
! SW_PRES   IS A MODIFICATION OF THE MATLAB ROUTINE WRITTEN BY PHIL MORGAN
!           OF CSIRO FOR THE SEAWATER LIBRARY DEVELOPED BY HIM AROUND 1992.
!
! USAGE:  PRES = SW_PRES(DEPTH,LAT)
!
! DESCRIPTION:
!    CALCULATES PRESSURE IN DBARS FROM DEPTH IN METERS.
!
! INPUT: 
!   DEPTH = DEPTH [METRES]
!   LAT   = LATITUDE IN DECIMAL DEGRESS NORTH [-90..+90]
!
! OUTPUT:
!  PRES   = PRESSURE    [DB]
!
! DISCLAIMER:
!   THIS SOFTWARE IS PROVIDED "AS IS" WITHOUT WARRANTY OF ANY KIND.
!
! REFERENCES:
!    SAUNDERS, P.M. 1981
!    "PRACTICAL CONVERSION OF PRESSURE TO DEPTH"
!    JOURNAL OF PHYSICAL OCEANOGRAPHY, 11, 573-574
!
! CHECK VALUE:
!    P=7500.00 DB for LAT=30 DEG, DEPTH=7321.45 METERS
!=========================================================================

real*8 depth, sw_pres
real*8 deg2rad, c1, x
real*8, optional :: lat

if(.not. present(lat))lat=45d0

sw_pres = errorreturn

! CHECK INPUTS
if(depth .lt. 0d0 .or. abs(lat) .gt. 90d0)return

deg2rad = 3.1415926535d0/180d0
x       = sin(abs(lat)*deg2rad)  ! convert to radians
c1      = 5.92d-3 + x**2 * 5.25d-3
sw_pres = ((1d0-c1) - sqrt((1d0-c1)**2 - 8.84d-6*depth))/4.42d-6
return
end function

end module convert_5

module sea_vap_4

!#########################################################################

!THIS MODULE IMPLEMENTS THE PHASE EQUILBRIUM PROPERTIES OF VAPOUR WITH SEAWATER
!COMPUTED FROM IAPWS-95 AND IAPWS-08:

!RELEASE ON THE IAPWS FORMULATION 1995 FOR THE THERMODYNAMIC PROPERTIES OF
!ORDINARY WATER SUBSTANCE FOR GENERAL AND SCIENTIFIC USE
!THE INTERNATIONAL ASSOCIATION FOR THE PROPERTIES OF WATER AND STEAM
!FREDERICIA, DENMARK, SEPTEMBER 1996

!RELEASE ON THE IAPWS FORMULATION 2008 FOR THE THERMODYNAMIC PROPERTIES OF SEAWATER
!THE INTERNATIONAL ASSOCIATION FOR THE PROPERTIES OF WATER AND STEAM
!BERLIN, GERMANY, SEPTEMBER 2008

!#########################################################################

!IMPLEMENTATION IN FORTRAN BY D.G. WRIGHT
!FOR PUBLICATION IN OCEAN SCIENCE, AS DESCRIBED IN THE PAPERS

!FEISTEL, R., WRIGHT, D.G., JACKETT, D.R., MIYAGAWA, K., REISSMANN, J.H.,
!WAGNER, W., OVERHOFF, U., GUDER, C., FEISTEL, A., MARION, G.M.:
!NUMERICAL IMPLEMENTATION AND OCEANOGRAPHIC APPLICATION OF THE THERMODYNAMIC
!POTENTIALS OF WATER, VAPOUR, ICE, SEAWATER AND AIR. PART I: BACKGROUND AND EQUATIONS. 
!OCEAN SCIENCES, 2009, IN PREPARATION.

!WRIGHT, D.G., FEISTEL, R., JACKETT, D.R., MIYAGAWA, K., REISSMANN, J.H., 
!WAGNER, W., OVERHOFF, U., GUDER, C., FEISTEL, A., MARION, G.M.:
!NUMERICAL IMPLEMENTATION AND OCEANOGRAPHIC APPLICATION OF THE THERMODYNAMIC
!POTENTIALS OF WATER, VAPOUR, ICE, SEAWATER AND AIR. PART II: THE LIBRARY ROUTINES, 
!OCEAN SCIENCES., 2009, IN PREPARATION.

!FEISTEL, R., KRETZSCHMAR, H.-J., SPAN, R., HAGEN, E., WRIGHT, D.G., JACKETT, D.R.:
!THERMODYNAMIC PROPERTIES OF SEA AIR.
!OCEAN SCIENCE DISCUSSION 6(2009)2193-2325.

!#########################################################################

!THIS MODULE REQUIRES THE LIBRARY MODULES:
!     CONSTANTS_0,  FILE CONSTANTS_0.F90
!     MATHS_0,      FILE MATHS_0.F90
!     FLU_1,        FILE FLU_1.F90
!     SAL_1,        FILE SAL_1.F90
!     SAL_2,        FILE SAL_2.F90
!     FLU_3A,       FILE FLU_3A.F90
!     FLU_3B,       FILE FLU_3B.F90
!     SEA_3A,       FILE SEA_3A.F90

!NESTED USE ASSOCIATIONS
!     CONVERT_0,    FILE CONVERT_0.F90
!     FLU_2,        FILE FLU_2.F90

!#########################################################################

use constants_0
use maths_0
use flu_1
use sal_1
use sal_2
use flu_3a
use flu_3b
use sea_3a

implicit none
private

character*16, private :: version = '8 Jun 2010'

public :: sea_vap_boilingtemperature_si, sea_vap_brinefraction_seavap_si, &
          sea_vap_brinesalinity_si, sea_vap_cp_seavap_si, &
          sea_vap_density_sea_si, sea_vap_density_seavap_si, &
          sea_vap_density_vap_si, sea_vap_enthalpy_evap_si, &
          sea_vap_enthalpy_sea_si, sea_vap_enthalpy_seavap_si, &
          sea_vap_enthalpy_vap_si, sea_vap_entropy_sea_si, &
          sea_vap_entropy_seavap_si, sea_vap_entropy_vap_si, &
          sea_vap_expansion_seavap_si, sea_vap_g_si, &
          sea_vap_kappa_t_seavap_si, sea_vap_pressure_si, &
          sea_vap_salinity_si, sea_vap_temperature_si, &
          sea_vap_vapourpressure_si, sea_vap_volume_evap_si, &
          set_it_ctrl_sea_vap, set_sea_vap_eq_at_t_p, &
          set_sea_vap_eq_at_s_p, set_sea_vap_eq_at_s_t

integer, private :: ctrl_mode_sea, ctrl_mode_temperature, ctrl_mode_liquid, &
         ctrl_mode_vapour, ctrl_loop_maximum, ctrl_initialized
real*8,  private :: ctrl_init_s_sea, ctrl_init_t, ctrl_init_d_liq, ctrl_init_d_vap, &
         ctrl_eps_exit_s, ctrl_eps_exit_t, ctrl_eps_exit_p
real*8,  private :: equi_sea_vap_t, equi_sea_vap_s, equi_sea_vap_p
real*8,  private :: equi_sea_vap_d_vap, equi_sea_vap_d_liq
integer, private :: equi_sea_vap_done

!IF97 COEFFICIENTS FROM:
!IF97 coefficients from:
!Revised Release on the IAPWS Industrial Formulation 1997
!for the Thermodynamic Properties of Water and Steam
!The International Association for the Properties of Water and Steam
!Lucerne, Switzerland, August 2007

!COEFFICIENTS OF REGION 1
integer, private, save :: i1i(34), j1i(34)
real*8,  private, save :: n1i(34)

!COEFFICIENTS OF REGION 2, IDEAL PART
integer, private, save :: j0i(9)
real*8,  private, save :: n0i(9)

!COEFFICIENTS OF REGION 2, RESIDUAL PART
integer, private, save :: iri(43), jri(43)
real*8,  private, save :: nri(43)

contains

!==========================================================================
function sea_vap_boilingtemperature_si(sa_si, p_si)
!==========================================================================

!THIS FUNCTION RETURNS THE ABSOLUTE TEMPERATURE IN K AT WHICH SEAWATER WITH
!ABSOLUTE SALINITY SA_SI IN KG/KG BOILS AT THE ABSOLUTE PRESSURE P_SI IN PA

!CHECK VALUE WITH DEFAULT SETTINGS: 
!SEA_VAP_BOILINGTEMPERATURE_SI(0.035, 640) = 274.042416829

!NOTE: THE ACCURACY OF THIS FUNCTION DEPENDS ON THE ITERATION SETTINGS OF THIS MODULE

implicit none
real*8 sea_vap_boilingtemperature_si, sa_si, p_si

sea_vap_boilingtemperature_si = errorreturn

if(set_sea_vap_eq_at_s_p(sa_si, p_si) == errorreturn) return

sea_vap_boilingtemperature_si = equi_sea_vap_t

end function

!==========================================================================
function sea_vap_brinesalinity_si(t_si, p_si)
!==========================================================================

!THIS FUNCTION RETURNS THE ABSOLUTE SALINITY SA_SI IN KG/KG WITH WHICH SEAWATER BOILS AT THE
!ABSOLUTE TEMPERATURE IN K AND THE ABSOLUTE PRESSURE P_SI IN PA

!NOTE: THE ACCURACY OF THIS FUNCTION DEPENDS ON THE ITERATION SETTINGS OF THIS MODULE
!AND OF THOSE IN FLU_3A

!CHECK VALUE WITH DEFAULT SETTINGS: 
!SEA_VAP_BRINESALINITY_SI(274, 640) = 2.9439629829|4E-02


implicit none
real*8 sea_vap_brinesalinity_si, t_si, p_si

sea_vap_brinesalinity_si = errorreturn

if(set_sea_vap_eq_at_t_p(t_si, p_si) == errorreturn) return

sea_vap_brinesalinity_si = equi_sea_vap_s

end function

!=========================================================================
function sea_vap_cp_seavap_si(ssv_si, t_si, p_si)
!==========================================================================

!OUTPUT:   
!CP(SSV,T,P) = -T * (D2G/DT2)_SSV_P ISOBARIC HEAT CAPACITY OF SEA VAPOUR IN J/(KG K)

!INPUT:
!SSV_SI    ABSOLUTE SEA-VAPOUR SALINITY IN KG/KG
!T_SI      ABSOLUTE TEMPERATURE IN K
!P_SI      ABSOLUTE PRESSURE IN PA

!CHECK VALUE WITH DEFAULT SETTINGS: 
!SEA_VAP_CP_SEAVAP_SI(0.035, 274, 600) = 756270.431593

!NOTE: THE ACCURACY OF THIS FUNCTion DEPENDS ON THE ITERATION SETTINGS OF THIS MODULE

implicit none
real*8 sea_vap_cp_seavap_si, ssv_si, t_si, p_si
real*8 g_tt

sea_vap_cp_seavap_si = errorreturn

if(ssv_si < 0d0 .or. ssv_si >= 1d0) return
if(t_si <= 0d0) return
if(p_si <= 0d0) return

g_tt = sea_vap_g_si(0, 2, 0, ssv_si, t_si, p_si)
if(g_tt == errorreturn) return

sea_vap_cp_seavap_si = -t_si * g_tt

end function

!==========================================================================
function sea_vap_density_sea_si()
!==========================================================================

!THIS FUNCTION RETURNS THE DENSITY IN KG/M3 OF SEAWATER AT EQUILIBRIUM WITH VAPOUR,
!SET BY A PREVIOUS CALL OF EITHER SET_SEA_VAP_EQUILIBRIUM_TO_S_P,
!SET_SEA_VAP_EQUILIBRIUM_TO_S_T OR SET_SEA_VAP_EQUILIBRIUM_TO_T_P

!NOTE: THE ACCURACY OF THIS FUNCTION DEPENDS ON THE ITERATION SETTINGS IN THIS MODULE,
!AND, IN THE CASE OF SET_SEA_VAP_EQUILIBRIUM_TO_T_P, OF THOSE IN fLU_3A

!check values with default settings:
!SET_SEA_VAP_EQ_AT_S_P 0.035, 640
!SEA_VAP_DENSITY_SEA_SI = 1027.87349556

!SET_SEA_VAP_EQ_AT_S_T 0.035, 274
!SEA_VAP_DENSITY_SEA_SI = 1027.87626132

!SET_SEA_VAP_EQ_AT_T_P 274, 640
!SEA_VAP_DENSITY_SEA_SI = 1023.42713047

implicit none
real*8 sea_vap_density_sea_si

sea_vap_density_sea_si = errorreturn

if(equi_sea_vap_done /= isok) return

sea_vap_density_sea_si = sea_density_si(equi_sea_vap_s, equi_sea_vap_t, equi_sea_vap_p)

end function

!=========================================================================
function sea_vap_density_seavap_si(ssv_si, t_si, p_si)
!==========================================================================

!OUTPUT:
!D(SSV,T,P) = 1/(DG/DP)_SSV_T  DENSITY OF SEA VAPOUR IN KG/M3

!INPUT:
!SSV_SI    ABSOLUTE SEA-VAPOUR SALINITY IN KG/KG
!T_SI      ABSOLUTE TEMPERATURE IN K
!P_SI      ABSOLUTE PRESSURE IN PA

!CHECK VALUE WITH DEFAULT SETTINGS: 
!SEA_VAP_DENSITY_SEAVAP_SI(0.035, 274, 600) = 7.27092786882E-03

!NOTE: THE ACCURACY OF THIS FUNCTION DEPENDS ON THE ITERATION SETTINGS OF THIS MODULE

implicit none
real*8 sea_vap_density_seavap_si, ssv_si, t_si, p_si
real*8 g_p

sea_vap_density_seavap_si = errorreturn

if(ssv_si < 0d0 .or. ssv_si >= 1d0) return
if(t_si <= 0d0) return
if(p_si <= 0d0) return

g_p = sea_vap_g_si(0, 0, 1, ssv_si, t_si, p_si)
if(g_p == errorreturn) return
if(g_p <= 0d0) return

sea_vap_density_seavap_si = 1d0 / g_p

end function

!==========================================================================
function sea_vap_density_vap_si()
!==========================================================================

!THIS FUNCTION RETURNS THE DENSITY IN KG/M3 OF VAPOUR AT EQUILIBRIUM WITH SEAWATER,
!SET BY A PREVIOUS CALL OF EITHER SET_SEA_VAP_EQUILIBRIUM_TO_S_P,
!SET_SEA_VAP_EQUILIBRIUM_TO_S_T OR SET_SEA_VAP_EQUILIBRIUM_TO_T_P

!NOTE: THE ACCURACY OF THIS FUNCTION DEPENDS ON THE ITERATION SETTINGS IN THIS MODULE
!AND, IN THE CASE OF SET_SEA_VAP_EQUILIBRIUM_TO_T_P, OF THOSE IN FLU_3A

!CHECK VALUES WITH DEFAULT SETTINGS:
!SET_SEA_VAP_EQ_AT_S_P 0.035, 640
!SEA_VAP_DENSITY_VAP_SI = 5.06324890264E-03

!SET_SEA_VAP_EQ_AT_S_T 0.035, 274
!SEA_VAP_DENSITY_VAP_SI = 5.04855547811E-03

!SET_SEA_VAP_EQ_AT_T_P 274, 640
!SEA_VAP_DENSITY_VAP_SI = 5.06403699513E-03
 
implicit none
real*8 sea_vap_density_vap_si

sea_vap_density_vap_si = errorreturn

if(equi_sea_vap_done /= isok) return

sea_vap_density_vap_si = vap_density_si(equi_sea_vap_t, equi_sea_vap_p)

end function

!==========================================================================
function sea_vap_enthalpy_evap_si()
!==========================================================================

!THIS FUNCTION RETURNS THE EVAPORATION ENTHALPY IN J/KG OF SEAWATER,
!SET BY A PREVIOUS CALL OF EITHER SET_SEA_VAP_EQUILIBRIUM_TO_S_P,
!SET_SEA_VAP_EQUILIBRIUM_TO_S_T OR SET_SEA_VAP_EQUILIBRIUM_TO_T_P

!CHECK VALUES WITH DEFAULT SETTINGS:
!SET_SEA_VAP_EQ_AT_S_P 0.035, 640
!SEA_VAP_ENTHALPY_EVAP_SI = 2498295.32187

!SET_SEA_VAP_EQ_AT_S_T 0.035, 274
!SEA_VAP_ENTHALPY_EVAP_SI = 2498395.40101

!SET_SEA_VAP_EQ_AT_T_P 274, 640
!SEA_VAP_ENTHALPY_EVAP_SI = 2498551.19875

!NOTE: THE ACCURACY OF THIS FUNCTION DEPENDS ON THE ITERATION SETTINGS IN THIS MODULE
!AND, IN THE CASE OF SET_SEA_VAP_EQUILIBRIUM_TO_T_P, OF THOSE IN FLU_3A

implicit none
real*8 sea_vap_enthalpy_evap_si
real*8 s, t, p, d

sea_vap_enthalpy_evap_si = errorreturn

if(equi_sea_vap_done /= isok) return

s = equi_sea_vap_s
t = equi_sea_vap_t
p = equi_sea_vap_p

d = sal_dilution_si(s, t, p)
if(d == errorreturn) return

sea_vap_enthalpy_evap_si = t * d * sea_vap_s_si(1, 0, t, p)

end function

!==========================================================================
function sea_vap_enthalpy_sea_si()
!==========================================================================

!THIS FUNCTION RETURNS THE ENTHALPY IN KG/M3 OF SEAWATER AT EQUILIBRIUM WITH VAPOUR,
!SET BY A PREVIOUS CALL OF EITHER SET_SEA_VAP_EQUILIBRIUM_TO_S_P,
!SET_SEA_VAP_EQUILIBRIUM_TO_S_T OR SET_SEA_VAP_EQUILIBRIUM_TO_T_P

!CHECK VALUES WITH DEFAULT SETTINGS:
!SET_SEA_VAP_EQ_AT_S_P 0.035, 640
!SEA_VAP_ENTHALPY_SEA_SI = 3465.11896144

!SET_SEA_VAP_EQ_AT_S_T 0.035, 274
!SEA_VAP_ENTHALPY_SEA_SI = 3295.96629299

!SET_SEA_VAP_EQ_AT_T_P 274, 640
!SEA_VAP_ENTHALPY_SEA_SI = 3405.93353730

!NOTE: THE ACCURACY OF THIS FUNCTION DEPENDS ON THE ITERATION SETTINGS IN THIS MODULE
!AND, IN THE CASE OF SET_SEA_VAP_EQ_AT_T_P, OF THOSE IN FLU_3A

implicit none
real*8 sea_vap_enthalpy_sea_si

sea_vap_enthalpy_sea_si = errorreturn

if(equi_sea_vap_done /= isok) return

sea_vap_enthalpy_sea_si = sea_enthalpy_si(equi_sea_vap_s, equi_sea_vap_t, equi_sea_vap_p)

end function

!=========================================================================
function sea_vap_enthalpy_seavap_si(ssv_si, t_si, p_si)
!==========================================================================

!OUTPUT:
!H(SSV,T,P) = GSV - T * (DG/DT)_SSV_P  ENTHALPY OF SEA VAPOUR IN J/KG

!INPUT:
!SSV_SI    ABSOLUTE SEA-VAPOUR SALINITY IN KG/KG
!T_SI      ABSOLUTE TEMPERATURE IN K
!P_SI      ABSOLUTE PRESSURE IN PA

!CHECK VALUE WITH DEFAULT SETTINGS: 
!SEA_VAP_ENTHALPY_SEAVAP_SI(0.035, 274, 600) = 1661118.41089

!NOTE: THE ACCURACY OF THIS FUNCTION DEPENDS ON THE ITERATION SETTINGS OF THIS MODULE

implicit none
real*8 sea_vap_enthalpy_seavap_si, ssv_si, t_si, p_si
real*8 g, g_t

sea_vap_enthalpy_seavap_si = errorreturn

if(ssv_si < 0d0 .or. ssv_si >= 1d0) return
if(t_si <= 0d0) return
if(p_si <= 0d0) return

g = sea_vap_g_si(0, 0, 0, ssv_si, t_si, p_si)
if(g == errorreturn) return
g_t = sea_vap_g_si(0, 1, 0, ssv_si, t_si, p_si)
if(g_t == errorreturn) return

sea_vap_enthalpy_seavap_si = g - t_si * g_t

end function

!==========================================================================
function sea_vap_enthalpy_vap_si()
!==========================================================================

!THIS FUNCTION RETURNS THE ENTHALPY IN KG/M3 OF VAPOUR AT EQUILIBRIUM WITH SEAWATER,
!SET BY A PREVIOUS CALL OF EITHER SET_SEA_VAP_EQUILIBRIUM_TO_S_P,
!SET_SEA_VAP_EQUILIBRIUM_TO_S_T OR SET_SEA_VAP_EQUILIBRIUM_TO_T_P

!CHECK VALUES WITH DEFAULT SETTINGS:
!SET_SEA_VAP_EQ_AT_S_P 0.035, 640
!SEA_VAP_ENTHALPY_VAP_SI = 2502546.89358

!SET_SEA_VAP_EQ_AT_S_T 0.035, 274
!SEA_VAP_ENTHALPY_VAP_SI = 2502469.07187

!SET_SEA_VAP_EQ_AT_T_P 274, 640
!SEA_VAP_ENTHALPY_VAP_SI = 2502466.96633

!NOTE: THE ACCURACY OF THIS FUNCTION DEPENDS ON THE ITERATION SETTINGS IN THIS MODULE
!AND, IN THE CASE OF SET_SEA_VAP_EQUILIBRIUM_TO_T_P, OF THOSE IN FLU_3A

implicit none
real *8 sea_vap_enthalpy_vap_si

sea_vap_enthalpy_vap_si = errorreturn

if(equi_sea_vap_done /= isok) return

sea_vap_enthalpy_vap_si = vap_enthalpy_si(equi_sea_vap_t, equi_sea_vap_p)

end function

!==========================================================================
function sea_vap_entropy_sea_si()
!==========================================================================

!THIS FUNCTION RETURNS THE ENTROPY IN J/(KG K) OF SEAWATER AT EQUILIBRIUM WITH VAPOUR,
!SET BY A PREVIOUS CALL OF EITHER SET_SEA_VAP_EQUILIBRIUM_TO_S_P,
!SET_SEA_VAP_EQUILIBRIUM_TO_S_T OR SET_SEA_VAP_EQUILIBRIUM_TO_T_P

!CHECK VALUES WITH DEFAULT SETTINGS:
!SET_SEA_VAP_EQ_AT_S_P 0.035, 640
!SEA_VAP_ENTROPY_SEA_SI = 13.0616891215

!SET_SEA_VAP_EQ_AT_S_T 0.035, 274
!SEA_VAP_ENTROPY_SEA_SI = 12.4443983378

!SET_SEA_VAP_EQ_AT_T_P 274, 640
!SEA_VAP_ENTROPY_SEA_SI = 14.0256815112

!NOTE: THE ACCURACY OF THIS FUNCTION DEPENDS ON THE ITERATION SETTINGS IN THIS MODULE,
!AND, IN THE CASE OF SET_SEA_VAP_EQUILIBRIUM_TO_T_P, OF THOSE IN FLU_3A

implicit none
real*8 sea_vap_entropy_sea_si

sea_vap_entropy_sea_si = errorreturn

if(equi_sea_vap_done /= isok) return

sea_vap_entropy_sea_si = sea_entropy_si(equi_sea_vap_s, equi_sea_vap_t, equi_sea_vap_p)

end function

!=========================================================================
function sea_vap_entropy_seavap_si(ssv_si, t_si, p_si)
!==========================================================================

!OUTPUT:
!ETA(SSV,T,P) = - (DG/DT)_SSV_P  ENTROPY OF SEA VAPOUR IN J/(KG K)

!INPUT:
!SSV_SI    ABSOLUTE SEA-VAPOUR SALINITY IN KG/KG
!T_SI      ABSOLUTE TEMPERATURE IN K
!P_SI      ABSOLUTE PRESSURE IN PA

!CHECK VALUE WITH DEFAULT SETTINGS: 
!SEA_VAP_ENTROPY_SEAVAP_SI(0.035, 274, 600) = 6072.50817709

!NOTE: THE ACCURACY OF THIS FUNCTION DEPENDS ON THE ITERATION SETTINGS OF THIS MODULE

implicit none
real*8 sea_vap_entropy_seavap_si, ssv_si, t_si, p_si
real*8 g_t

sea_vap_entropy_seavap_si = errorreturn

if(ssv_si < 0d0 .or. ssv_si >= 1d0) return
if(t_si <= 0d0) return
if(p_si <= 0d0) return

g_t = sea_vap_g_si(0, 1, 0, ssv_si, t_si, p_si)
if(g_t == errorreturn) return

sea_vap_entropy_seavap_si = -g_t

end function

!==========================================================================
function sea_vap_entropy_vap_si()
!==========================================================================

!THIS FUNCTION RETURNS THE ENTROPY IN J/(KG K) OF VAPOUR AT EQUILIBRIUM WITH SEAWATER,
!SET BY A PREVIOUS CALL OF EITHER SET_SEA_VAP_EQUILIBRIUM_TO_S_P,
!SET_SEA_VAP_EQUILIBRIUM_TO_S_T OR SET_SEA_VAP_EQUILIBRIUM_TO_T_P

!CHECK VALUES WITH DEFAULT SETTINGS:
!SET_SEA_VAP_EQ_AT_S_P 0.035, 640
!SEA_VAP_ENTROPY_VAP_SI = 9140.56256065

!SET_SEA_VAP_EQ_AT_S_T 0.035, 274
!SEA_VAP_ENTROPY_VAP_SI = 9141.68990452

!SET_SEA_VAP_EQ_AT_T_P 274, 640
!SEA_VAP_ENTROPY_VAP_SI = 9140.27087793

!NOTE: THE ACCURACY OF THIS FUNCTION DEPENDS ON THE ITERATION SETTINGS IN THIS MODULE
!AND, IN THE CASE OF SET_SEA_VAP_EQUILIBRIUM_TO_T_P, OF THOSE IN FLU_3A

implicit none
real*8 sea_vap_entropy_vap_si

sea_vap_entropy_vap_si = errorreturn

if(equi_sea_vap_done /= isok) return

sea_vap_entropy_vap_si = vap_entropy_si(equi_sea_vap_t, equi_sea_vap_p)

end function

!=========================================================================
function sea_vap_expansion_seavap_si(ssv_si, t_si, p_si)
!==========================================================================

!OUTPUT:
!ALPHA(SSV,T,P) = (D2G/DTDP)_SSV/(DG/DP)_SSV_T  THERMAL EXPANSION OF SEA VAPOUR IN 1/K,

!INPUT:
!SSV_SI    ABSOLUTE SEA-VAPOUR SALINITY IN KG/KG
!T_SI      ABSOLUTE TEMPERATURE IN K,
!P_SI      ABSOLUTE PRESSURE IN PA

!CHECK VALUE WITH DEFAULT SETTINGS: 
!SEA_VAP_EXPANSION_SEAVAP_SI(0.035, 274, 600) = 0.458863421347

!NOTE: THE ACCURACY OF THIS FUNCTION DEPENDS ON THE ITERATION SETTINGS OF THIS MODULE

implicit none
real*8 sea_vap_expansion_seavap_si, ssv_si, t_si, p_si
real*8 g_p, g_tp

sea_vap_expansion_seavap_si = errorreturn

if(ssv_si < 0d0 .or. ssv_si >= 1d0) return
if(t_si <= 0d0) return
if(p_si <= 0d0) return

g_p = sea_vap_g_si(0, 0, 1, ssv_si, t_si, p_si)
if(g_p == errorreturn) return
if(g_p <= 0d0) return
g_tp = sea_vap_g_si(0, 1, 1, ssv_si, t_si, p_si)
if(g_tp == errorreturn) return

sea_vap_expansion_seavap_si = g_tp / g_p

end function

!==========================================================================
function sea_vap_g_si(drv_s, drv_t, drv_p, ssv_si, t_si, p_si)
!==========================================================================

!RETURNS THE SSV-T-P DERIVATIVE (D/DSSV)^DRV_S (D/DT)^DRV_T (D/DP)^DRV_P G(SSV,T,P)
!OF THE GIBBS FUNCTION G OF SEA VAPOUR, AS A FUNCTION OF SEA-VAPOUR SALINITY IN KG/KG,
!ABSOLUTE TEMPERATURE IN K AND ABSOLUTE PRESSURE IN PA
!
!G(S,T,P) = (1-W) * GV(T,P) + W * GSW(S(T,P),T,P)
!
!W = MASS FRACTION OF BRINE, W(SSV, T, P) = SSV/S(T,P)
!S = BRINE SALINITY
!
!SSV_SI = ABSOLUTE SEA-VAPOUR SALINITY IN KG/KG, I.E. THE MASS FRACTION OF SALT IN SEAWATER + VAPOUR
!T_SI  = T = ABSOLUTE TEMPERATURE IN K, ITS-90
!P_SI  = P = ABSOLUTE PRESSURE IN PA
!SAL_G_SI  = SPECIFIC GIBBS ENERGY IN J/KG


!CHECK VALUES WITH DEFAULT SETTINGS:
!SEA_VAP_G_SI( 0, 0, 0, 0.035, 274, 610) =-2748.82963245
!SEA_VAP_G_SI( 1, 0, 0, 0.035, 274, 610) = 151028.257424
!SEA_VAP_G_SI( 0, 1, 0, 0.035, 274, 610) =-6072.50817709
!SEA_VAP_G_SI( 0, 0, 1, 0.035, 274, 610) = 137.534028399
!SEA_VAP_G_SI( 2, 0, 0, 0.035, 274, 610) = 0
!SEA_VAP_G_SI( 1, 1, 0, 0.035, 274, 610) = 14965.0677011
!SEA_VAP_G_SI( 1, 0, 1, 0.035, 274, 610) =-321.591932572
!SEA_VAP_G_SI( 0, 2, 0, 0.035, 274, 610) =-2760.11106421
!SEA_VAP_G_SI( 0, 1, 1, 0.035, 274, 610) = 63.1093348229
!SEA_VAP_G_SI( 0, 0, 2, 0.035, 274, 610) =-1.65027885871

implicit none
integer drv_s, drv_t, drv_p
real*8 sea_vap_g_si, ssv_si, t_si, p_si
real*8 g, s, w, d
real*8 gb, gv
real*8 gb_p, gv_p
real*8 gb_t, gv_t
real*8 gb_pp, gv_pp, gm_pp
real*8 gb_tp, gv_tp, gm_tp
real*8 gb_tt, gv_tt, gm_tt
real*8 gb_s, gb_sp, gb_st
real*8 s_p, s_t

sea_vap_g_si = errorreturn
d = errorreturn
g = errorreturn

if(ssv_si < 0d0 .or. ssv_si >= 1d0) return
if(t_si <= 0d0) return
if(p_si <= 0d0) return

if(drv_s < 0) return
if(drv_t < 0 .or. drv_t > 2) return
if(drv_p < 0 .or. drv_p > 2) return

if(drv_s > 1) then    !G IS LINEAR IN SSV
  sea_vap_g_si = 0d0
  return
end if

if(set_sea_vap_eq_at_t_p(t_si, p_si) == errorreturn) return

s = sea_vap_salinity_si()
if(s == errorreturn) return
if(s <= 0d0 .or. s >= 1d0) return
if(s < ssv_si) return

w = ssv_si / s               !LIQUID MASS FRACTION OF SEA VAPOUR

if(drv_t + drv_p > 1d0) then
  d = sal_dilution_si(s, t_si, p_si)
end if

select case (drv_s)

  case (0)

    select case (drv_t)

      case (0)     !D/DT

        select case (drv_p)

          case (0)
            gb = sea_g_si(0, 0, 0, s, t_si, p_si)
            if(gb == errorreturn) return
            gv = vap_g_si(0, 0, t_si, p_si)
            if(gv == errorreturn) return
            g = (1d0 - w) * gv + w * gb                      !G

          case (1)
            gb_p = sea_g_si(0, 0, 1, s, t_si, p_si)
            if(gb_p == errorreturn) return
            gv_p = vap_g_si(0, 1, t_si, p_si)
            if(gv_p == errorreturn) return
            g = (1d0 - w) * gv_p + w * gb_p                  !V = G_P

          case (2)
            s_p = sea_vap_s_si(0, 1, t_si, p_si)
            if(s_p == errorreturn) return
            gm_pp = -d * s_p ** 2 / s                      !LATENT DERIVATIVE
            gb_pp = sea_g_si(0, 0, 2, s, t_si, p_si)
            if(gb_pp == errorreturn) return
            gv_pp = vap_g_si(0, 2, t_si, p_si)
            if(gv_pp == errorreturn) return
            g = (1d0 - w) * gv_pp + w * (gb_pp + gm_pp)      !G_PP

          case default; return
        end select

      case (1)     !D/DT

        select case (drv_p)

          case (0)
            gb_t = sea_g_si(0, 1, 0, s, t_si, p_si)
            if(gb_t == errorreturn) return
            gv_t = vap_g_si(1, 0, t_si, p_si)
            if(gv_t == errorreturn) return
            g = (1d0 - w) * gv_t + w * gb_t                  !-ETA = G_T

          case (1)
            s_t = sea_vap_s_si(1, 0, t_si, p_si)
            if(s_t == errorreturn) return
            s_p = sea_vap_s_si(0, 1, t_si, p_si)
            if(s_p == errorreturn) return
            gm_tp = -d * s_t * s_p / s                     !LATENT DERIVATIVE
            gb_tp = sea_g_si(0, 1, 1, s, t_si, p_si)
            if(gb_tp == errorreturn) return
            gv_tp = vap_g_si(1, 1, t_si, p_si)
            if(gv_tp == errorreturn) return
            g = (1d0 - w) * gv_tp + w * (gb_tp + gm_tp)                 !G_TP

          case default; return
        end select

      case (2)     !D2/DT2

        select case (drv_p)

          case (0)
            s_t = sea_vap_s_si(1, 0, t_si, p_si)
            if(s_t == errorreturn) return
            gm_tt = -d * s_t ** 2 / s                      !LATENT DERIVATIVE
            gb_tt = sea_g_si(0, 2, 0, s, t_si, p_si)
            if(gb_tt == errorreturn) return
            gv_tt = vap_g_si(2, 0, t_si, p_si)
            if(gv_tt == errorreturn) return
            g = (1d0 - w) * gv_tt + w * (gb_tt + gm_tt)                 !G_TT

          case default; return
        end select

      case default; return
    end select

  case (1)       !D/DS
  
    select case (drv_t)
    
      case (0)
        select case (drv_p)

          case (0)
             g = sal_g_si(1, 0, 0, s, t_si, p_si)                     !G_S

          case (1)
             gb_sp = sal_g_si(1, 0, 1, s, t_si, p_si)                 !G_SP
             if(gb_sp == errorreturn) return
             gb_s = sal_g_si(1, 0, 0, s, t_si, p_si)
             if(gb_s == errorreturn) return
             s_p = sea_vap_s_si(0, 1, t_si, p_si)
             if(s_p == errorreturn) return
             g = gb_sp + gb_s * s_p

          case default; return
        end select

      case (1)   !D2/DSDT

        select case (drv_p)

          case (0)
             gb_st = sal_g_si(1, 1, 0, s, t_si, p_si)                 !G_ST
             if(gb_st == errorreturn) return
             gb_s = sal_g_si(1, 0, 0, s, t_si, p_si)
             if(gb_s == errorreturn) return
             s_t = sea_vap_s_si(1, 0, t_si, p_si)
             if(s_t == errorreturn) return
             g = gb_st + gb_s * s_t

          case default; return
        end select

       case default; return
    end select
end select

sea_vap_g_si = g

end function

!=========================================================================
function sea_vap_kappa_t_seavap_si(ssv_si, t_si, p_si)
!==========================================================================

!OUTPUT:
!KAPPA_T(SSV,T,P) = - (D2G/DP2)_SSV_T/(DG/DP)_SSV_T  ISOTHERMAL COMPRESSIBILITY OF SEA VAPOUR IN 1/PA

!INPUT:
!SSV_SI    ABSOLUTE SEA-VAPOUR SALINITY IN KG/KG
!T_SI      ABSOLUTE TEMPERATURE IN K
!P_SI      ABSOLUTE PRESSURE IN PA

!CHECK VALUE WITH DEFAULT SETTINGS: 
!SEA_VAP_KAPPA_T_SEAVAP_SI(0.035, 274, 600) = 1.19990585451E-02

!NOTE: THE ACCURACY OF THIS FUNCTION DEPENDS ON THE ITERATION SETTINGS OF THIS MODULE

implicit none
real*8 sea_vap_kappa_t_seavap_si, ssv_si, t_si, p_si
real*8 g_p, g_pp

sea_vap_kappa_t_seavap_si = errorreturn

if(ssv_si < 0d0 .or. ssv_si >= 1d0) return
if(t_si <= 0d0) return
if(p_si <= 0d0) return

g_p = sea_vap_g_si(0, 0, 1, ssv_si, t_si, p_si)
if(g_p == errorreturn) return
if(g_p <= 0d0) return
g_pp = sea_vap_g_si(0, 0, 2, ssv_si, t_si, p_si)
if(g_pp == errorreturn) return

sea_vap_kappa_t_seavap_si = -g_pp / g_p

end function

!==========================================================================
function sea_vap_pressure_si()
!==========================================================================

!THIS FUNCTION RETURNS THE PRESSURE IN PA OF VAPOUR AT EQUILIBRIUM WITH SEAWATER,
!SET BY A PREVIOUS CALL OF EITHER SET_SEA_VAP_EQUILIBRIUM_TO_S_P,
!SET_SEA_VAP_EQUILIBRIUM_TO_S_T OR SET_SEA_VAP_EQUILIBRIUM_TO_T_P

!CHECK VALUES WITH DEFAULT SETTINGS:
!SET_SEA_VAP_EQ_AT_S_P 0.035, 640
!SEA_VAP_PRESSURE_SI = 640

!SET_SEA_VAP_EQ_AT_S_T 0.035, 274
!SEA_VAP_PRESSURE_SI = 638.044692615

!SET_SEA_VAP_EQ_AT_T_P 274, 640
!SEA_VAP_PRESSURE_SI = 640

!NOTE: THE ACCURACY OF THIS FUNCTION DEPENDS ON THE ITERATION SETTINGS IN THIS MODULE
!AND, IN THE CASE OF SET_SEA_VAP_EQUILIBRIUM_TO_T_P, OF THOSE IN FLU_3A

implicit none
real*8 sea_vap_pressure_si

sea_vap_pressure_si = errorreturn

if(equi_sea_vap_done /= isok) return

sea_vap_pressure_si = equi_sea_vap_p

end function

!=========================================================================
function sea_vap_s_si(drv_t, drv_p, t_si, p_si)
!==========================================================================

!THIS FUNCTION RETURNS ABSOLUTE BRINE SALINITY S IN KG/KG, AND ITS PARTIAL DERIVATIVES
!  (D/DT)^DRV_T (D/DP)^DRV_P S(T,P)
!AS A FUNCTION OF ABSOLUTE TEMPERATURE, T_SI, IN K, AND ABSOLUTE PRESSURE, P_SI, IN PA

implicit none
integer drv_t, drv_p
real*8 sea_vap_s_si, t_si, p_si
real*8 d  !DILUTION COEFF
real*8 s  !BRINE SALINITY

real*8 gb_p, gv_p, gb_sp
real*8 gb_t, gv_t, gb_st

sea_vap_s_si = errorreturn

d = errorreturn

if(drv_t < 0 .or. drv_t > 1) return
if(drv_p < 0 .or. drv_p > 1) return

if(t_si < 0d0) return
if(p_si < 0d0) return

!THIS MUST BE CALLED OUTSIDE BEFORE:
!IF(SET_SEA_ICE_EQUILIBRIUM_TO_T_P(T_SI, P_SI) == ERRORRETURN) RETURN

!IF NOT, EXIT HERE
if(equi_sea_vap_done /= isok) return

s = sea_vap_salinity_si()
if(s == errorreturn) return
if(s < 0d0 .or. s >= 1d0) return

if(drv_t > 0 .or. drv_p > 0) then
  d = sal_dilution_si(s, t_si, p_si)
  if(d == errorreturn) return
  if(d <= 0d0) return
end if

select case (drv_t)

  case (0)

    select case (drv_p)

      case (0)
        sea_vap_s_si = s

      case (1)
        gb_p = sea_g_si(0, 0, 1, s, t_si, p_si)
        if(gb_p == errorreturn) return
        gb_sp = sea_g_si(1, 0, 1, s, t_si, p_si)
        if(gb_sp == errorreturn) return
        gv_p = vap_g_si(0, 1, t_si, p_si)
        if(gv_p == errorreturn) return
        sea_vap_s_si = (gb_p - gv_p - s * gb_sp) / d
    end select

  case (1)

    select case (drv_p)

      case (0)
        gb_t = sea_g_si(0, 1, 0, s, t_si, p_si)
        if(gb_t == errorreturn) return
        gb_st = sea_g_si(1, 1, 0, s, t_si, p_si)
        if(gb_st == errorreturn) return
        gv_t = vap_g_si(1, 0, t_si, p_si)
        if(gv_t == errorreturn) return
        sea_vap_s_si = (gb_t - gv_t - s * gb_st) / d
    end select

end select

end function

!==========================================================================
function sea_vap_salinity_si()
!==========================================================================

!THIS FUNCTION RETURNS THE BRINE SALINITY IN KG/KG OF SEAWATER AT EQUILIBRIUM WITH VAPOUR,
!SET BY A PREVIOUS CALL OF EITHER SET_SEA_VAP_EQUILIBRIUM_TO_S_P,
!SET_SEA_VAP_EQUILIBRIUM_TO_S_T OR SET_SEA_VAP_EQUILIBRIUM_TO_T_P

!CHECK VALUES WITH DEFAULT SETTINGS:
!SET_SEA_VAP_EQ_AT_S_P 0.035, 640
!SEA_VAP_SALINITY_SI = 0.035

!SET_SEA_VAP_EQ_AT_S_T 0.035, 274
!SEA_VAP_SALINITY_SI = 0.035

!SET_SEA_VAP_EQ_AT_T_P 274, 640
!SEA_VAP_SALINITY_SI = 2.9439629829|4E-02

!NOTE: THE ACCURACY OF THIS FUNCTION DEPENDS ON THE ITERATION SETTINGS IN THIS MODULE
!AND, IN THE CASE OF SET_SEA_VAP_EQUILIBRIUM_TO_T_P, OF THOSE IN FLU_3A

implicit none
real*8 sea_vap_salinity_si

sea_vap_salinity_si = errorreturn

if(equi_sea_vap_done /= isok) return

sea_vap_salinity_si = equi_sea_vap_s

end function

!==========================================================================
function sea_vap_temperature_si()
!==========================================================================

!THIS FUNCTION RETURNS THE TEMPERATURE IN K OF VAPOUR AT EQUILIBRIUM WITH SEAWATER,
!SET BY A PREVIOUS CALL OF EITHER SET_SEA_VAP_EQUILIBRIUM_TO_S_P,
!SET_SEA_VAP_EQUILIBRIUM_TO_S_T OR SET_SEA_VAP_EQUILIBRIUM_TO_T_P

!CHECK VALUES WITH DEFAULT SETTINGS:
!SET_SEA_VAP_EQ_AT_S_P 0.035, 640
!SEA_VAP_TEMPERATURE_SI = 274.042416829

!SET_SEA_VAP_EQ_AT_S_T 0.035, 274
!SEA_VAP_TEMPERATURE_SI = 274

!SET_SEA_VAP_EQ_AT_T_P 274, 640
!SEA_VAP_TEMPERATURE_SI = 274

!NOTE: THE ACCURACY OF THIS FUNCTION DEPENDS ON THE ITERATION SETTINGS IN THIS MODULE
!AND, IN THE CASE OF SET_SEA_VAP_EQUILIBRIUM_TO_T_P, OF THOSE IN FLU_3A

implicit none
real*8 sea_vap_temperature_si

sea_vap_temperature_si = errorreturn

if(equi_sea_vap_done /= isok) return

sea_vap_temperature_si = equi_sea_vap_t

end function

!==========================================================================
function sea_vap_vapourpressure_si(sa_si, t_si)
!==========================================================================

!THIS FUNCTION RETURNS THE ABSOLUTE VAPOUR PRESSURE IN PA AT THE
!ABSOLUTE TEMPERATURE T_SI IN K AND THE AMBIENT SEAWATER SALINITY SA_SI IN KG/KG

!CHECK VALUE WITH DEFAULT SETTINGS: 
!SEA_VAP_VAPOURPRESSURE_SI(0.035, 274) = 638.044692615

!NOTE: THE ACCURACY OF THIS FUNCTION DEPENDS ON THE ITERATION SETTINGS OF THIS MODULE

implicit none
real*8 sea_vap_vapourpressure_si, sa_si, t_si

sea_vap_vapourpressure_si = errorreturn

if(set_sea_vap_eq_at_s_t(sa_si, t_si) == errorreturn) return

sea_vap_vapourpressure_si = equi_sea_vap_p

end function

!==========================================================================
function sea_vap_volume_evap_si()
!==========================================================================

!THIS FUNCTION RETURNS THE EVAPORATION VOLUME IN M3/KG OF SEAWATER,
!SET BY A PREVIOUS CALL OF EITHER SET_SEA_VAP_EQUILIBRIUM_TO_S_P,
!SET_SEA_VAP_EQUILIBRIUM_TO_S_T OR SET_SEA_VAP_EQUILIBRIUM_TO_T_P

!CHECK VALUES WITH DEFAULT SETTINGS:
!SET_SEA_VAP_EQ_AT_S_P 0.035, 640
!SEA_VAP_VOLUME_EVAP_SI = 197.500648110

!SET_SEA_VAP_EQ_AT_S_T 0.035, 274
!SEA_VAP_VOLUME_EVAP_SI = 198.075461154

!SET_SEA_VAP_EQ_AT_T_P 274, 640
!SEA_VAP_VOLUME_EVAP_SI = 197.469911653

!NOTE: THE ACCURACY OF THIS FUNCTION DEPENDS ON THE ITERATION SETTINGS IN THIS MODULE
!AND, IN THE CASE OF SET_SEA_VAP_EQUILIBRIUM_TO_T_P, OF THOSE IN FLU_3A

implicit none
real*8 sea_vap_volume_evap_si
real*8 s, t, p, d

sea_vap_volume_evap_si = errorreturn

if(equi_sea_vap_done /= isok) return

s = equi_sea_vap_s
t = equi_sea_vap_t
p = equi_sea_vap_p

d = sal_dilution_si(s, t, p)
if(d == errorreturn) return

sea_vap_volume_evap_si = -d * sea_vap_s_si(0, 1, t, p)

end function

!==========================================================================
function set_sea_vap_eq_at_s_p(sa_si, p_si)
!==========================================================================

!THIS FUNCTION COMPUTES THE SEAWATER-VAPOUR EQUILIBRIUM AT GIVEN SALINITY AND PRESSURE
!BY NEWTON ITERATION

implicit none
integer maxit
real*8 set_sea_vap_eq_at_s_p
real*8 sa_si, p_si
real*8 t, d_liq, d_vap, eps, dvt, dlt, tt

tt = tp_temperature_si
dlt = tp_density_liq_iapws95_si   !TRIPLE POINT DENSITY OF LIQUID WATER
dvt = tp_density_vap_iapws95_si   !TRIPLE POINT DENSITY OF WATER VAPOUR

if(equi_sea_vap_done == isok .and. &
  sa_si == equi_sea_vap_s .and. p_si == equi_sea_vap_p) then
  !THE REQUESTED STATE HAS ALREADY BEEN COMPUTED EARLIER
  set_sea_vap_eq_at_s_p = isok
  return
end if

call clear_sea_vap_state !WASTE ANY PREVIOUS STATE

set_sea_vap_eq_at_s_p = errorreturn

if(sa_si <= 0d0) return
if(sa_si >= 1d0) return
if(p_si <= 0d0) return

call init_it_ctrl_sea_vap

!SET INITIAL TEMPERATURE GUESS
select case (ctrl_mode_temperature)
  case (0);  t = aux_boilingtemperature_si(sa_si, p_si)
  case (-1); t = tt
  case (1);  t = ctrl_init_t
  case default; return
end select
if(t <= 0d0) return
if(t == errorreturn) return

!SET INITIAL LIQUID DENSITY GUESS
select case (ctrl_mode_liquid)
  case (0);  d_liq = aux_liq_density_if97_si(t, p_si)
  case (-1); d_liq = dlt
  case (1);  d_liq = ctrl_init_d_liq
  case default; return
end select
if(d_liq <= 0d0) return
if(d_liq == errorreturn) return

!SET INITIAL VAPOUR DENSITY GUESS
select case (ctrl_mode_vapour)
  case (0);  d_vap = aux_density_ideal_si(t, p_si)
  case (-1); d_vap = dvt
  case (1);  d_vap = ctrl_init_d_vap
  case default; return
end select
if(d_vap <= 0d0) return
if(d_vap == errorreturn) return

!SET MAX. ITERATION NUMBER
if(ctrl_loop_maximum == 0)then
   maxit = 100
elseif(ctrl_loop_maximum == (-1))then
   call set_sea_vap_state (sa_si, t, p_si, d_liq, d_vap)
   set_sea_vap_eq_at_s_p = isok
   return
elseif(ctrl_loop_maximum > 0)then
   maxit = ctrl_loop_maximum
else
   return
endif

!SET ITERATION ACCURACY LIMIT
eps = ctrl_eps_exit_t
if(eps == 0d0) return

!RUN ITERATION LOOP
if(sea_vap_iteration_at_s_p(sa_si, p_si, maxit, eps, d_liq, d_vap, t) == errorreturn) then
  return
end if

call set_sea_vap_state (sa_si, t, p_si, d_liq, d_vap)

set_sea_vap_eq_at_s_p = isok

end function

!==========================================================================
function set_sea_vap_eq_at_s_t(sa_si, t_si)
!==========================================================================

!THIS FUNCTION COMPUTES THE SEAWATER-VAPOUR EQUILIBRIUM AT GIVEN TEMPERATURE AND SALINITY
!BY NEWTON ITERATION

implicit none
integer maxit
real*8 set_sea_vap_eq_at_s_t
real*8 sa_si, t_si
real*8 eps
real*8 d_liq, d_vap, p_si, dvt, dlt

dlt = tp_density_liq_iapws95_si   !TRIPLE POINT DENSITY OF LIQUID WATER
dvt = tp_density_vap_iapws95_si   !TRIPLE POINT DENSITY OF WATER VAPOUR

if(equi_sea_vap_done == isok .and. &
  sa_si == equi_sea_vap_s .and. t_si == equi_sea_vap_t) then
  !THE REQUESTED STATE HAS ALREADY BEEN COMPUTED EARLIER
  set_sea_vap_eq_at_s_t = isok
  return
end if

call clear_sea_vap_state !WASTE ANY PREVIOUS STATE

set_sea_vap_eq_at_s_t = errorreturn

if(sa_si <= 0d0) return
if(sa_si >= 1d0) return
if(t_si <= 0d0) return

call init_it_ctrl_sea_vap

if(ctrl_mode_liquid == 0 .or. ctrl_mode_vapour == 0) then
  p_si = aux_vapourpressure_wp80_si(sa_si, t_si)
end if

!SET INITIAL LIQUID DENSITY GUESS
select case (ctrl_mode_liquid)
  case (0);  d_liq = aux_liq_density_if97_si(t_si, p_si)
  case (-1); d_liq = dlt
  case (1);  d_liq = ctrl_init_d_liq
  case default; return
end select
if(d_liq <= 0d0) return
if(d_liq == errorreturn) return

!SET INITIAL VAPOUR DENSITY GUESS
select case (ctrl_mode_vapour)
  case (0);  d_vap = aux_density_ideal_si(t_si, p_si)
  case (-1); d_vap = dvt
  case (1);  d_vap = ctrl_init_d_vap
  case default; return
end select
if(d_vap <= 0d0) return
if(d_vap == errorreturn) return

!SET MAX. ITERATION NUMBER
if(ctrl_loop_maximum == 0)then
  maxit = 100
elseif(ctrl_loop_maximum == (-1))then
  p_si = d_vap ** 2 * flu_f_si(0, 1, t_si, d_vap)
  call set_sea_vap_state (sa_si, t_si, p_si, d_liq, d_vap)
  set_sea_vap_eq_at_s_t = isok
  return
elseif(ctrl_loop_maximum > 0)then
  maxit = ctrl_loop_maximum
else
  return
endif

!SET ITERATION ACCURACY LIMIT
eps = ctrl_eps_exit_p
if(eps == 0d0) return

!RUN ITERATION LOOP
if(sea_vap_iteration_at_s_t(sa_si, t_si, maxit, eps, d_liq, d_vap, p_si) == errorreturn) then
  return
end if

call set_sea_vap_state (sa_si, t_si, p_si, d_liq, d_vap)

set_sea_vap_eq_at_s_t = isok

end function

!==========================================================================
function set_sea_vap_eq_at_t_p(t_si, p_si)
!==========================================================================

!THIS FUNCTION COMPUTES THE SEAWATER-ICE EQUILIBRIUM AT GIVEN ABSOLUTE TEMPERATURE 
!T_SI IN K AND ABSOLUTE PRESSURE P_SI IN PA BY NEWTON ITERATION

implicit none
integer maxit
real*8 set_sea_vap_eq_at_t_p, t_si, p_si
real*8 d_liq, d_vap, s_norm
real*8 s, eps

s_norm = so_salinity_si  !KG/KG OF KCL NORMALISED SEAWATER

if(equi_sea_vap_done == isok .and. &
  t_si == equi_sea_vap_t .and. p_si == equi_sea_vap_p) then
  !THE REQUESTED STATE HAS ALREADY BEEN COMPUTED EARLIER
  set_sea_vap_eq_at_t_p = isok
  return
end if

call clear_sea_vap_state !WASTE ANY PREVIOUS STATE

set_sea_vap_eq_at_t_p = errorreturn

if(t_si <= 0d0) return
if(p_si <= 0d0) return

call init_it_ctrl_sea_vap

!SET INITIAL BRINE SALINITY GUESS
select case (ctrl_mode_sea)
  case (0);  s = aux_brinesalinity_si(t_si, p_si)
  case (-1); s = s_norm
  case (1);  s = ctrl_init_s_sea
  case default; return
end select

if(s <= 0d0 .or. s >= 1d0) return
if(s == errorreturn) return

!SET MAX. ITERATION NUMBER
if(ctrl_loop_maximum == 0)then
  maxit = 100
elseif(ctrl_loop_maximum == (-1))then
  d_liq = liq_density_si(t_si, p_si)
  d_vap = vap_density_si(t_si, p_si)
  call set_sea_vap_state (s, t_si, p_si, d_liq, d_vap)
  set_sea_vap_eq_at_t_p = isok
  return
elseif(ctrl_loop_maximum > 0)then
  maxit = ctrl_loop_maximum
else
  return
endif

!SET ITERATION ACCURACY LIMIT
eps = ctrl_eps_exit_s
if(eps == 0d0) return

!RUN ITERATION LOOP
if(sea_vap_iteration_at_t_p(t_si, p_si, maxit, eps, s) == errorreturn) then
  return
end if

d_liq = liq_density_si(t_si, p_si) !ONLY FOR COMPLETENESS OF THE STATE DESCRIPTOR
d_vap = vap_density_si(t_si, p_si)
call set_sea_vap_state (s, t_si, p_si, d_liq, d_vap)

set_sea_vap_eq_at_t_p = isok

end function

!==========================================================================
function sea_vap_iteration_at_s_p(sa_si, p_si, maxit, eps, d_liq_si, d_vap_si, t_si)
!==========================================================================

!THIS FUNCTION COMPUTES THE SEAWATER-VAPOUR PHASE EQUILIBRIUM FROM
!EQUAL CHEMICAL POTENTIALS OF WATER AT GIVEN SALINITY, SA_SI, AND PRESSURE, P_SI,
!FROM INITIAL GUESSES FOR THE TEMPERATURE, T_SI, THE LIQUID WATER DENSITY, D_LIQ_SI,
!AND THE VAPOUR DENSITY, D_VAP_SI.
!THE ITERATION LIMIT EPS REFERS TO THE ERROR IN TEMPERATURE.

!OUTPUT:  
!         SEA_VAP_ITERATION_AT_S_P = ISOK IF SUCCESSFULLY DONE
!         SEA_VAP_ITERATION_AT_S_P = ERRORRETURN IS RETURNED IF
!         - THE MAXIMUM NUMBER OF ITERATIONS IS EXCEEDED WITHOUT MEETING THE EXIT CRITERION
!         - THE FUNCTION CALL TO A GIBBS/HELMHOLTZ FUNCTION HAS RETURNED AN ERROR
!         - DENSITY OR TEMPERATURE HAS TAKEN A ZERO OR NEGATIVE VALUE DURING THE ITERATION
!         - S-P VALUES DO NOT PERMIT THE STABLE EXISTENCE OF ICE
! D_LIQ_SI: DENSITY OF LIQUID WATER IN KG/M3 AT (T_SI, P_SI)
! D_VAP_SI: DENSITY OF WATER VAPOUR IN KG/M3 AT (T_SI, P_SI)
!     T_SI: ABSOLUTE TEMPERATURE IN K OF THE SEAWATER-VAPOUR EQUILIBRIUM

!INPUT: 
!       SA_SI: ABSOLUTE SALINITY IN KG/KG
!        P_SI: ABSOLUTE PRESSURE IN PA
!       MAXIT: MAXIMUM NUMBER OF ITERATION STEPS TO BE DONE
!         EPS: REQUIRED ACCURACY OF TEMPERATURE
!              EPS > 0: ABSOLUTE TEMPERATURE TOLERANCE IN K
!              EPS < 0: RELATIVE TEMPERATURE TOLERANCE
!    D_LIQ_SI: INITIAL GUESS FOR DENSITY OF LIQUID WATER IN KG/M3 AT (T_SI, P_SI)
!    D_VAP_SI: INITIAL GUESS FOR DENSITY OF WATER VAPOUR IN KG/M3 AT (T_SI, P_SI)
!        T_SI: INITIAL GUESS FOR THE FREEZING TEMPERATURE


implicit none
integer it, maxit
real*8 sea_vap_iteration_at_s_p, sa_si, p_si, eps, d_liq_si, d_vap_si, t_si
real*8 dl, ddl
real*8 dv, ddv
real*8 t, dt
real*8 mus, p
real*8 gl, gv
real*8 gs_t, gs_st
real*8 fl, fl_t, fl_td
real*8 fl_d, fl_dd
real*8 fv, fv_t, fv_td
real*8 fv_d, fv_dd

real*8 a(3, 3), b(3), x(3)

sea_vap_iteration_at_s_p = errorreturn

if((d_liq_si <= 0d0) .or. &
  (d_vap_si <= 0d0) .or. &
  (t_si <= 0d0)) then
  d_liq_si = errorreturn
  d_vap_si = errorreturn
  t_si = errorreturn
  return
endif

if(check_limits == 1) then
  !SAL_LIMITS
  if(sa_si < sal_smin .or. sa_si > sal_smax .or. &
  p_si < sal_pmin .or. p_si > sal_pmax) then
    d_liq_si = errorreturn
    d_vap_si = errorreturn
    t_si = errorreturn
    return
  endif
else
  if((p_si <= 0d0) .or. &
    (sa_si <= 0d0 .or. sa_si >= 1d0)) then
    d_liq_si = errorreturn
    d_vap_si = errorreturn
    t_si = errorreturn
    return
  endif
endif

check_limits = check_limits - 1

t = t_si
dv = d_vap_si
dl = d_liq_si

do it = 1, maxit

  !DERIVATIVES OF THE HELMHOLTZ FUNCTION OF FLUID WATER FOR 3D NEWTON ITERATION
  fl = flu_f_si(0, 0, t, dl)
  if(fl == errorreturn) go to 999
  fv = flu_f_si(0, 0, t, dv)
  if(fv == errorreturn) go to 999

  fl_t = flu_f_si(1, 0, t, dl)
  if(fl_t == errorreturn) go to 999
  fv_t = flu_f_si(1, 0, t, dv)
  if(fv_t == errorreturn) go to 999

  fl_d = flu_f_si(0, 1, t, dl)
  if(fl_d == errorreturn) go to 999
  fv_d = flu_f_si(0, 1, t, dv)
  if(fv_d == errorreturn) go to 999

  fl_td = flu_f_si(1, 1, t, dl)
  if(fl_td == errorreturn) go to 999
  fv_td = flu_f_si(1, 1, t, dv)
  if(fv_td == errorreturn) go to 999

  fl_dd = flu_f_si(0, 2, t, dl)
  if(fl_dd == errorreturn) go to 999
  fv_dd = flu_f_si(0, 2, t, dv)
  if(fv_dd == errorreturn) go to 999

  p = dv ** 2 * fv_d
  gl = fl + dl * fl_d
  gv = fv + dv * fv_d

  !DERIVATIVES OF THE SALINE GIBBS FUNCTION FOR NEWTON ITERATION
  mus = sal_chempot_h2o_si(sa_si, t, p) !SALINE CHEMICAL POTENTIAL GS + S*DG/DS
  if(mus == errorreturn) go to 999
  gs_t = sal_g_si(0, 1, 0, sa_si, t, p)
  if(gs_t == errorreturn) go to 999
  gs_st = sal_g_si(1, 1, 0, sa_si, t, p)
  if(gs_st == errorreturn) go to 999

  !COEFFICIENT MATRIX
  a(1, 1) = fl_t + dl * fl_td + gs_t - sa_si * gs_st - fv_t - dv * fv_td
  a(1, 2) = 2d0 * fl_d + dl * fl_dd
  a(1, 3) = 2d0 * fv_d + dv * fv_dd

  a(2, 1) = dl ** 2 * fl_td
  a(2, 2) = dl * (2d0 * fl_d + dl * fl_dd)
  a(2, 3) = 0d0

  a(3, 1) = dv ** 2 * fv_td
  a(3, 2) = 0d0
  a(3, 3) = dv * (2d0 * fv_d + dv * fv_dd)

  !RIGHT-HAND SIDES, MUST VANISH AT EQUILIBRIUM
  b(1) = gv - gl - mus
  b(2) = p_si - dl ** 2 * fl_d
  b(3) = p_si - dv ** 2 * fv_d

  !SOLVE EQUATIONS
  if(matrix_solve(a, b, x, 3) /= 0) go to 999 !MATRIX SINGULAR
  dt = x(1)
  ddl = x(2)
  ddv = x(3)

  !UPDATE DENSITIES AND TEMPERATURE
  t = t + dt
  if(t <= 0d0) go to 999
  dl = dl + ddl
  if(dl <= 0d0) go to 999
  dv = dv + ddv
  if(dv <= 0d0) go to 999

  !CHECK ABSOLUTE OR RELATIVE ERROR LIMIT
  if((eps > 0d0 .and. abs(dt) < eps) .or. &
     (eps < 0d0 .and. abs(dt) < -eps * abs(t))) then
    if(t <= 0d0) go to 999
    sea_vap_iteration_at_s_p = isok
    t_si = t
    d_liq_si = dl
    d_vap_si = dv
    go to 999
  end if

enddo

999 continue

check_limits = check_limits + 1

if(check_limits == 1) then
  !FLU_LIMITS
  if(t_si < flu_tmin .or. t_si > flu_tmax .or. &
  d_liq_si <= flu_dmin .or. d_liq_si > flu_dmax) then
    t_si = errorreturn
    d_liq_si = errorreturn
    d_vap_si = errorreturn
    sea_vap_iteration_at_s_p = errorreturn
    return
  endif
  !SAL_LIMITS
  if(t_si < sal_tmin .or. t_si > sal_tmax .or. &
  sa_si < sal_smin .or. sa_si > sal_smax .or. &
  p_si < sal_pmin .or. p_si > sal_pmax) then
    t_si = errorreturn
    d_liq_si = errorreturn
    d_vap_si = errorreturn
    sea_vap_iteration_at_s_p = errorreturn
    return
  endif
endif

end function

!==========================================================================
function sea_vap_iteration_at_s_t(sa_si, t_si, maxit, eps, d_liq_si, d_vap_si, p_si)
!==========================================================================

!THIS FUNCTION COMPUTES THE SEAWATER-VAPOUR PHASE EQUILIBRIUM FROM
!EQUAL CHEMICAL POTENTIALS OF WATER AT GIVEN SALINITY, SA_SI, AND TEMPERATURE, T_SI,
!FROM AN INITIAL GUESS FOR THE LIQUID & VAPOUR DENSITY, D_LIQ_SI, D_VAP_SI.
!THE ITERATION LIMIT EPS REFERS TO THE ERROR IN PRESSURE.

!OUTPUT:  
!          SEA_VAP_ITERATION_AT_S_T = ISOK IF SUCCESSFULLY DONE
!          SEA_VAP_ITERATION_AT_S_T = ERRORRETURN IS RETURNED IF
!          - THE MAXIMUM NUMBER OF ITERATIONS IS EXCEEDED WITHOUT MEETING THE EXIT CRITERION
!          - THE FUNCTION CALL TO A GIBBS/HELMHOLTZ FUNCTION HAS RETURNED AN ERROR
!          - DENSITY HAS TAKEN A ZERO OR NEGATIVE VALUE DURING THE ITERATION
! D_LIQ_SI: DENSITY OF LIQUID WATER IN KG/M3 AT (T_SI, P_SI)
! D_VAP_SI: DENSITY OF WATER VAPOUR IN KG/M3 AT (T_SI, P_SI)
!     P_SI: ABSOLUTE PRESSURE IN PA IN THE SEAWATER-ICE EQUILIBRIUM

!INPUT: 
!      SA_SI: ABSOLUTE SALINITY IN KG/KG
!       T_SI: ABSOLUTE TEMPERATURE IN K
!      MAXIT: MAXIMUM NUMBER OF ITERATION STEPS TO BE DONE
!        EPS: REQUIRED ACCURACY OF PRESSURE
!             EPS > 0: ABSOLUTE PRESSURE TOLERANCE IN PA
!             EPS < 0: RELATIVE PRESSURE TOLERANCE
!   D_LIQ_SI: INITIAL GUESS FOR DENSITY OF LIQUID WATER IN KG/M3 AT (T_SI, P_SI)
!   D_VAP_SI: INITIAL GUESS FOR DENSITY OF WATER VAPOUR IN KG/M3 AT (T_SI, P_SI)


implicit none
integer it, maxit
real*8 sea_vap_iteration_at_s_t, sa_si, t_si, eps, d_liq_si, d_vap_si, p_si
real*8 dl, ddl
real*8 dv, ddv
real*8 mus, p, p_old
real*8 gl, gv
real*8 gs_p, gs_sp
real*8 fl, fl_d, fl_dd
real*8 fv, fv_d, fv_dd

real*8 a(2, 2), b(2), x(2)

sea_vap_iteration_at_s_t = errorreturn

if((d_liq_si <= 0d0) .or. &
  (d_vap_si <= 0d0)) then
  t_si = errorreturn
  d_liq_si = errorreturn
  d_vap_si = errorreturn
  return
endif

if(check_limits == 1) then
  !FLU_LIMITS
  if(t_si < flu_tmin .or. t_si > flu_tmax) then
    t_si = errorreturn
    d_liq_si = errorreturn
    d_vap_si = errorreturn
    return
  endif
  !SAL_LIMITS
  if(sa_si < sal_smin .or. sa_si > sal_smax .or. &
  t_si < sal_tmin .or. t_si > sal_tmax) then
    t_si = errorreturn
    d_liq_si = errorreturn
    d_vap_si = errorreturn
    return
  endif
else
  if((t_si <= 0d0) .or. &
    (sa_si < 0d0 .or. sa_si > 1d0)) then
    t_si = errorreturn
    d_liq_si = errorreturn
    d_vap_si = errorreturn
    return
  endif
endif

check_limits = check_limits - 1

dv = d_vap_si
dl = d_liq_si

do it = 0, maxit

  !DERIVATIVES OF THE HELMHOLTZ FUNCTION OF FLUID WATER FOR 3D NEWTON ITERATION
  fl = flu_f_si(0, 0, t_si, dl)
  if(fl == errorreturn) go to 999
  fv = flu_f_si(0, 0, t_si, dv)
  if(fv == errorreturn) go to 999

  fl_d = flu_f_si(0, 1, t_si, dl)
  if(fl_d == errorreturn) go to 999
  fv_d = flu_f_si(0, 1, t_si, dv)
  if(fv_d == errorreturn) go to 999

  fl_dd = flu_f_si(0, 2, t_si, dl)
  if(fl_dd == errorreturn) go to 999
  fv_dd = flu_f_si(0, 2, t_si, dv)
  if(fv_dd == errorreturn) go to 999

  p_old = p
  p = dv ** 2 * fv_d
  gl = fl + dl * fl_d
  gv = fv + dv * fv_d

  !DERIVATIVES OF THE SALINE GIBBS FUNCTION FOR NEWTON ITERATION
  mus = sal_chempot_h2o_si(sa_si, t_si, p) !SALINE CHEMICAL POTENTIAL GS + S*DG/DS
  if(mus == errorreturn) go to 999
  gs_p = sal_g_si(0, 0, 1, sa_si, t_si, p)
  if(gs_p == errorreturn) go to 999
  gs_sp = sal_g_si(1, 0, 1, sa_si, t_si, p)
  if(gs_sp == errorreturn) go to 999

  if(it > 0) then
    !CHECK ABSOLUTE OR RELATIVE ERROR LIMIT
    if((eps > 0d0 .and. abs(p - p_old) < eps) .or. &
      (eps < 0d0 .and. abs(p - p_old) < -eps * abs(p))) then
      if(p <= 0d0) go to 999
      sea_vap_iteration_at_s_t = isok
      p_si = p
      d_liq_si = dl
      d_vap_si = dv
      go to 999
    end if
  end if

  if(it == maxit) go to 999

  !COEFFICIENT MATRIX
  a(1, 1) = (2d0 * fl_d + dl * fl_dd) * (1d0 + (gs_p - sa_si * gs_sp) * dl)
  a(1, 2) = -2d0 * fv_d - dv * fv_dd

  a(2, 1) = dl * (2d0 * fl_d + dl * fl_dd)
  a(2, 2) = -dv * (2d0 * fv_d + dv * fv_dd)

  !RIGHT-HAND SIDES, MUST VANISH AT EQUILIBRIUM
  b(1) = gv - gl - mus
  b(2) = dv ** 2 * fv_d - dl ** 2 * fl_d

  !SOLVE EQUATIONS
  if(matrix_solve(a, b, x, 2) /= 0) go to 999 !MATRIX SINGULAR
  ddl = x(1)
  ddv = x(2)

  !UPDATE DENSITIES
  dl = dl + ddl
  if(dl <= 0d0) go to 999
  dv = dv + ddv
  if(dv <= 0d0) go to 999

enddo

999 continue

check_limits = check_limits + 1

if(check_limits == 1) then
  !FLU_LIMITS
  if(d_liq_si <= flu_dmin .or. d_liq_si > flu_dmax) then
    p_si = errorreturn
    d_liq_si = errorreturn
    d_vap_si = errorreturn
    sea_vap_iteration_at_s_t = errorreturn
    return
  endif
  !SAL_LIMITS
  if(p_si < sal_pmin .or. p_si > sal_pmax) then
    p_si = errorreturn
    d_liq_si = errorreturn
    d_vap_si = errorreturn
    sea_vap_iteration_at_s_t = errorreturn
    return
  endif
endif

end function

!==========================================================================
function sea_vap_iteration_at_t_p(t_si, p_si, maxit, eps, s_sea_si)
!==========================================================================

!THIS FUNCTION COMPUTES THE SEAWATER-VAPOUR PHASE EQUILIBRIUM FROM
!EQUAL CHEMICAL POTENTIALS OF WATER AT GIVEN TEMPERATURE, T_SI, AND PRESSURE, P_SI,
!FROM AN INITIAL GUESS FOR THE BRINE SALINITY, S_SEA_SI.
!THE ITERATION LIMIT EPS REFERS TO THE ERROR IN BRINE SALINITY.

!OUTPUT: 
!        SEA_VAP_ITERATION_AT_T_P = ISOK IF SUCCESSFULLY DONE
!        SEA_VAP_ITERATION_AT_T_P = ERRORRETURN IS RETURNED IF
!        - THE MAXIMUM NUMBER OF ITERATIONS IS EXCEEDED WITHOUT MEETING THE EXIT CRITERION
!        - THE FUNCTION CALL TO A GIBBS FUNCTION HAS RETURNED AN ERROR
!        - SALINITY HAS TAKEN A ZERO OR NEGATIVE VALUE DURING THE ITERATION
! S_SEA_SI: BRINE SALINITY IN KG/KG IN THE SEAWATER-ICE EQUILIBRIUM

!INPUT: 
!       T_SI: ABSOLUTE TEMPERATURE IN K
!       P_SI: ABSOLUTE PRESSURE IN PA
!      MAXIT: MAXIMUM NUMBER OF ITERATION STEPS TO BE DONE
!        EPS: REQUIRED ACCURACY OF SALINITY
!             EPS > 0: ABSOLUTE SALINITY TOLERANCE IN KG/KG
!             EPS < 0: RELATIVE SALINITY TOLERANCE
!   S_SEA_SI: INITIAL GUESS OF BRINE SALINITY IN KG/KG

implicit none
integer it, maxit
real*8 sea_vap_iteration_at_t_p, t_si, p_si, eps, s_sea_si
real*8 s, ds
real*8 mus, sgss
real*8 gl, gv

sea_vap_iteration_at_t_p = errorreturn

if(s_sea_si <= 0d0 .or. s_sea_si >= 1d0) then
  s_sea_si = errorreturn
  return
endif

if(check_limits == 1) then
  !FLU_LIMITS
  if(t_si < flu_tmin .or. t_si > flu_tmax) then
    s_sea_si = errorreturn
    return
  endif
  !SAL_LIMITS
  if(t_si < sal_tmin .or. t_si > sal_tmax .or. &
  p_si < sal_pmin .or. p_si > sal_pmax) then
    s_sea_si = errorreturn
    return
  endif
else
  if(p_si <= 0d0 .or. &
    t_si <= 0d0) then
    s_sea_si = errorreturn
    return
  endif
endif

check_limits = check_limits - 1

!GET THE CHEMICAL POTENTIAL OF FLUID WATER (THIS IMPLIES ITERATION IN FLU_3A))
gl = liq_gibbs_energy_si(t_si, p_si)
if(gl == errorreturn) go to 999

gv = vap_gibbs_energy_si(t_si, p_si)
if(gv == errorreturn) go to 999

s = s_sea_si

do it = 1, maxit

  !DERIVATIVES OF THE GIBBS FUNCTIONS FOR NEWTON ITERATION
  mus = sal_chempot_h2o_si(s, t_si, p_si) !SALINE CHEMICAL POTENTIAL GS + S*DG/DS
  if(mus == errorreturn) go to 999
  sgss = sal_dilution_si(s, t_si, p_si)  !S* D2G/DS2
  if(sgss == errorreturn) go to 999
  if(sgss <= 0) go to 999  !PHYSICALLY, THIS IS IMPOSSIBLE

  !BRINE SALINITY ITERATION STEP
  ds = (gl + mus - gv) / sgss

  !UPDATE BRINE SALINITY
  s = s + ds
  if(s <= 0d0 .or. s >= 1d0) go to 999

  !CHECK ABSOLUTE OR RELATIVE ERROR LIMIT
  if((eps > 0d0 .and. abs(ds) < eps) .or. &
     (eps < 0 .and. abs(ds) < -eps * s)) then
    if(s >= 1d0) go to 999
    sea_vap_iteration_at_t_p = isok
    s_sea_si = s
    go to 999
  end if

enddo

999 continue

check_limits = check_limits + 1

if(check_limits == 1) then
  !SAL_LIMITS
  if(s_sea_si < sal_smin .or. s_sea_si > sal_smax) then
    s_sea_si = errorreturn
    sea_vap_iteration_at_t_p = errorreturn
    return
  endif
endif

end function

!=========================================================================
function sea_vap_brinefraction_seavap_si(ssv_si, t_si, p_si)
!==========================================================================

!OUTPUT:
!W(SSV,T,P) = SSV/S(T,P)  MASS FRACTION OF BRINE IN SEA VAPOUR (0 < W < 1)

!INPUT:
!SSV_SI    ABSOLUTE SEA-VAPOUR SALINITY IN KG/KG
!T_SI      ABSOLUTE TEMPERATURE IN K
!P_SI      ABSOLUTE PRESSURE IN PA

!NOTE: THE ACCURACY OF THIS FUNCTION DEPENDS ON THE ITERATION SETTINGS FOR
!      DENSITY COMPUTED IN FLU_3A AND ON THOSE OF THIS MODULE

!CHECK VALUE:
!SEA_VAP_BRINEFRACTION_SEAVAP_SI(0.0035,274,640)  =   0.11888736442|5E+00 

implicit none
real*8 sea_vap_brinefraction_seavap_si
real*8 ssv_si, t_si, p_si
real*8 s

sea_vap_brinefraction_seavap_si = errorreturn

if(ssv_si < 0d0 .or. ssv_si >= 1d0) return
if(t_si <= 0d0) return
if(p_si <= 0d0) return

s = sea_vap_brinesalinity_si(t_si, p_si)
if(s == errorreturn) return
if(s <= ssv_si) return

sea_vap_brinefraction_seavap_si = ssv_si / s

end function

!==========================================================================
function aux_boilingtemperature_si(sa_si, p_si)
!==========================================================================

!COMPUTES A BOILING TEMPERATURE ESTIMATE IN K FOR SEAWATER-VAPOUR EQUILIBRIUM AT GIVEN
!BRINE SALINITY IN KG/KG AND ABSOLUTE PRESSURE IN PA FROM CLAUSIUS-CLAPEYRON
!AND RAOULT LAWS

implicit none
real*8 aux_boilingtemperature_si, sa_si, p_si
real*8 tt, pt, a1, a2, alpha
real*8 p, q
real*8 tr, ps

tt = tp_temperature_si
pt = tp_pressure_iapws95_si

a1 = -19.8731005709116d0
a2 = -3.08975437352998d0

alpha = -0.57d0       !RAOULT COEFFICIENT, (P(S)-P(0))/P(S) = ALPHA * S,  S IN KG/KG

aux_boilingtemperature_si = errorreturn
if(p_si <= 0d0) return
if(sa_si < 0d0) return
if(sa_si >= 1d0) return

!PRESSURE IS CORRECTED FOR SALINITY BY RAOULT!S LAW
ps = p_si / (1d0 - alpha * sa_si)

!BOILING TEMPERATURE OF H2O ON THE SATURATION CURVE FROM A CORRELATION POLYNOMIAL
!AS A FIRST GUESS FOR LIQ_VAP_ITERATION_AT_P (TT < T < 640 K WITH RMS = 0.01 IN LN(P/PT))

! CLAUSIUS-CLAPEYRON TYPE EQUATION:
! LN(P/PT) = A1 * (TT/T-1) + A2 * (TT/T-1)^2

p = a1 / a2
q = -log(ps / pt) / a2

tr = -0.5d0 * p + sqrt(0.25d0 * p ** 2 - q)

aux_boilingtemperature_si = tt / (tr + 1d0)

end function

!==========================================================================
function aux_brinesalinity_si(t_si, p_si)
!==========================================================================

!COMPUTES A BRINE SALINITY ESTIMATE IN KG/KG FOR SEAWATER-VAPOUR EQUILIBRIUM AT GIVEN
!ABSOLUTE TEMPERATURE IN K AND ABSOLUTE PRESSURE IN PA FROM WEISS & PRICE 1980 AND
!AND RAOULT LAWS

implicit none
real*8 aux_brinesalinity_si, t_si, p_si
real*8 p0, alpha

alpha = -0.57d0       !RAOULT COEFFICIENT, (P(S)-P(0))/P(S) = ALPHA * S,  S IN KG/KG

aux_brinesalinity_si = errorreturn
if(p_si <= 0d0) return
if(t_si <= 0d0) return

p0 = aux_vapourpressure_wp80_si(0d0, t_si)
aux_brinesalinity_si = (1d0 - p0/p_si)/alpha

end function

!==========================================================================
function aux_vapourpressure_wp80_si(sa_si, t_si)
!==========================================================================

!COMPUTES A VAPOUR PRESSURE ESTIMATE IN PA FOR SEAWATER-VAPOUR EQUILIBRIUM AT GIVEN
!BRINE SALINITY IN KG/KG AND ABSOLUTE TEMPERATURE IN K FROM WEISS & PRICE (1980)

implicit none
real*8 aux_vapourpressure_wp80_si, sa_si, t_si
real*8 spsu
real*8 tabs48_k
real*8 psw

!CRUDE CONVERSION IS SUFFICIENT FOR A GUESS
spsu = 1000d0 * sa_si
tabs48_k = t_si

!WEISS, R.F. AND B.A. PRICE, 1980. NITROUS OXIDE SOLUBILITY IN WATER AND SEAWATER. MARINE CHEM., 8, 347-359.
!SATURATION WATER VAPOUR PRESSURE OF SEAWATER OVER THE TEMPERATURE RANGE 273 TO 313 K AND THE
!SALINITY RANGE 0 TO 40:

psw = exp(24.4543d0 - 67.4509d0*(100d0/tabs48_k) &
      - 4.8489d0*log(tabs48_k/100d0) - 0.000544d0*spsu)

!PSW IS THE WATER VAPOUR PRESSURE (IN ATM), TABS48_K IS THE TEMPERATURE (IN K), 
!AND SPSS IS THE SALINITY ON THE PRACTICAL SALINITY SCALE.

aux_vapourpressure_wp80_si = psw*101325d0

end function

!==========================================================================
function aux_density_ideal_si(t_si, p_si)
!==========================================================================

!THIS FUNCTION RETURNS THE DENSITY OF IDEAL-GAS VAPOUR AS A FUNCTION OF TEMPERATURE
!AND PRESSURE

!OUTPUT:  
!AUX_DENSITY_IDEAL_SI: DENSITY IN KG/M3

!INPUT:   
!T_SI: ABSOLUTE TEMPERATURE IN K
!P_SI: ABSOLUTE PRESSURE IN PA


implicit none
real*8 aux_density_ideal_si, t_si, p_si, r

r = gas_constant_h2o_si         !SPECIFIC GAS CONSTANT OF WATER IN J/(KG K)

aux_density_ideal_si = errorreturn

if(t_si <= 0d0) return
if(p_si <= 0d0) return

aux_density_ideal_si = p_si / (r * t_si)

end function

!=========================================================================
function aux_liq_density_if97_si(t_si, p_si)
!=========================================================================

!THIS FUNCTION RETURNS THE DENSITY OF LIQUID WATER AS A FUNCTION OF TEMPERATURE
!AND PRESSURE, IN THE REGION 1 (LIQUID) IN IAPWS-IF97

!OUTPUT:  
!AUX_LIQ_DENSITY_IF97_SI: DENSITY IN KG/M3

!INPUT:   
!T_SI: ABSOLUTE TEMPERATURE IN K
!P_SI: ABSOLUTE PRESSURE IN PA

implicit none

real*8 aux_liq_density_if97_si
real*8 t_si, p_si
real*8 d

aux_liq_density_if97_si = errorreturn

if(t_si <= 0d0) return
if(p_si <= 0d0) return

d = aux_liq_g_if97_si(0, 1, t_si, p_si)

if(d == errorreturn) return
if(d <= 0d0) return

aux_liq_density_if97_si = 1d0 / d

end function

!=========================================================================
function aux_vap_density_if97_si(t_si, p_si)
!=========================================================================

!THIS FUNCTION RETURNS THE DENSITY OF WATER AS A FUNCTION OF TEMPERATURE
!AND PRESSURE, IN THE REGION 2 (VAPOUR) IN IAPWS-IF97

!OUTPUT:  
!AUX_VAP_DENSITY_IF97_SI: DENSITY OF LIQUID WATER IN KG/M3

!INPUT:   
!T_SI: ABSOLUTE TEMPERATURE IN K
!P_SI: ABSOLUTE PRESSURE IN PA

implicit none

real*8 aux_vap_density_if97_si
real*8 t_si, p_si
real*8 d

aux_vap_density_if97_si = errorreturn

if(t_si <= 0d0) return
if(p_si <= 0d0) return

d = aux_vap_g_if97_si(0, 1, t_si, p_si)

if(d == errorreturn) return
if(d <= 0d0) return

aux_vap_density_if97_si = 1d0 / d

end function

!=========================================================================
function aux_liq_g_if97_si(drv_t, drv_p, t_si, p_si)
!=========================================================================

!THIS FUNCTION RETURNS THE GIBBS FUNCTION G(T,P) AND ITS 1ST AND 2ND DERIVATIVES
!WITH RESPECT TO TEMPERATURE AND PRESSURE, AS DEFINED FOR THE REGION 1 (LIQUID) IN IAPWS-IF97
!
!OUTPUT: 
!AUX_LIQ_G_IF97_SI: SPECIFIC GIBBS ENERGY IN J/KG OR ITS T-P DERIVATIVE

!INPUT:  
!DRV_T: ORDER OF THE TEMPERATURE DERIVATIVE (0-2)
!DRV_P: ORDER OF THE PRESSURE DERIVATIVE (0-2)
! T_SI:  ABSOLUTE TEMPERATURE IN K
! P_SI:  ABSOLUTE PRESSURE IN PA

implicit none
                          
integer drv_t, drv_p
real*8 aux_liq_g_if97_si
real*8 t_si, p_si
real*8 g, g_t, g_tt
real*8 g_p, g_tp, g_pp
real*8 psi, tau, rt
real*8 tu, pu, r

tu = 1386d0
pu = 16530000d0
r = 461.526d0       !J KG-1 K-1  SPECIFIC GAS CONSTANT
                    !NOTE THIS DEVIATES FROM GAS_CONSTANT_H2O_SI = 461.51805

aux_liq_g_if97_si = errorreturn

if(t_si <= 0d0) return
if(p_si <= 0d0) return

call init_if97_1

psi = p_si / pu
tau = tu / t_si
rt = r * t_si

select case (drv_t)

  case (0)
    select case (drv_p)

      case (0); g = gamma_1(0, 0, tau, psi)
        if(g == errorreturn) return
        aux_liq_g_if97_si = rt * g

      case (1); g_p = gamma_1(0, 1, tau, psi)
        if(g_p == errorreturn) return
        aux_liq_g_if97_si = rt * g_p / pu

      case (2); g_pp = gamma_1(0, 2, tau, psi)
        if(g_pp == errorreturn) return
        aux_liq_g_if97_si = rt * g_pp / pu ** 2

      case default; return
    end select

  case (1)
    select case (drv_p)

      case (0)
        g = gamma_1(0, 0, tau, psi)
        if(g == errorreturn) return
        g_t = gamma_1(1, 0, tau, psi)
        if(g_t == errorreturn) return
        aux_liq_g_if97_si = r * (g - tau * g_t)

      case (1) 
        g_p = gamma_1(0, 1, tau, psi)
        if(g_p == errorreturn) return
        g_tp = gamma_1(1, 1, tau, psi)
        if(g_tp == errorreturn) return
        aux_liq_g_if97_si = r * (g_p - tau * g_tp) / pu

      case default; return
    end select

  case (2)
    select case (drv_p)

      case (0) 
        g_tt = gamma_1(2, 0, tau, psi)
        if(g_tt == errorreturn) return
        aux_liq_g_if97_si = r * tau ** 2 * g_tt / t_si

      case default; return
    end select

  case default; return
end select

end function
 
!=========================================================================
function aux_vap_g_if97_si(drv_t, drv_p, t_si, p_si)
!=========================================================================

!THIS FUNCTION RETURNS THE GIBBS FUNCTION G(T,P) AND ITS 1ST AND 2ND DERIVATIVES
!WITH RESPECT TO TEMPERATURE AND PRESSURE, AS DEFINED FOR THE REGION 2 (VAPOUR) IN IAPWS-IF97

!OUTPUT: 
!AUX_VAP_G_IF97_SI: SPECIFIC GIBBS ENERGY IN J/KG OR ITS T-P DERIVATIVE

!INPUT:  
!DRV_T: ORDER OF THE TEMPERATURE DERIVATIVE (0-2)
!DRV_P: ORDER OF THE PRESSURE DERIVATIVE (0-2)
! T_SI:  ABSOLUTE TEMPERATURE IN K
! P_SI:  ABSOLUTE PRESSURE IN PA

implicit none
                          
integer drv_t, drv_p
real*8 aux_vap_g_if97_si
real*8 t_si, p_si
real*8 g, g_t, g_tt
real*8 g_p, g_tp, g_pp
real*8 psi, tau, rt
real*8 tu, pu, r

tu = 540d0
pu = 1000000d0
r = 461.526d0       !J KG-1 K-1  SPECIFIC GAS CONSTANT
                    !NOTE THIS DEVIATES FROM GAS_CONSTANT_H2O_SI = 461.51805

aux_vap_g_if97_si = errorreturn

if(t_si <= 0d0) return
if(p_si <= 0d0) return

call init_if97_2

psi = p_si / pu
tau = tu / t_si
rt = r * t_si

select case (drv_t)

  case (0)
    select case (drv_p)

      case (0) 
        g = gamma_2(0, 0, tau, psi)
        if(g == errorreturn) return
        aux_vap_g_if97_si = rt * g

      case (1) 
        g_p = gamma_2(0, 1, tau, psi)
        if(g_p == errorreturn) return
        aux_vap_g_if97_si = rt * g_p / pu

      case (2) 
        g_pp = gamma_2(0, 2, tau, psi)
        if(g_pp == errorreturn) return
        aux_vap_g_if97_si = rt * g_pp / pu ** 2

      case default; return
    end select

  case (1)
    select case (drv_p)

      case (0) 
        g = gamma_2(0, 0, tau, psi)
        if(g == errorreturn) return
        g_t = gamma_2(1, 0, tau, psi)
        if(g_t == errorreturn) return
        aux_vap_g_if97_si = r * (g - tau * g_t)

      case (1) 
        g_p = gamma_2(0, 1, tau, psi)
        if(g_p == errorreturn) return
        g_tp = gamma_2(1, 1, tau, psi)
        if(g_tp == errorreturn) return
        aux_vap_g_if97_si = r * (g_p - tau * g_tp) / pu

      case default; return
    end select

  case (2)
    select case (drv_p)

      case (0) 
        g_tt = gamma_2(2, 0, tau, psi)
        if(g_tt == errorreturn) return
        aux_vap_g_if97_si = r * tau ** 2 * g_tt / t_si

      case default; return
    end select

  case default; return
end select

end function
 
!=========================================================================
function gamma_0(drv_t, drv_p, tau, psi)
!=========================================================================

!THIS FUNCTION IMPLEMENTS THE DERIVATIVES OF GAMMA_0 AS GIVEN IN TABLE 13 OF IF-97

implicit none

integer i, k, drv_t, drv_p
real*8 tau, psi
real*8 gamma_0
real*8 g, pwrt

gamma_0 = errorreturn

if(psi <= 0d0) return
if(tau <= 0d0) return
if(drv_t < 0) return
if(drv_p < 0) return

g = 0d0
if(drv_t == 0) then
  if(drv_p == 0) then
    g = log(psi)
  else
    g = 1d0 / psi
    do k = 2, drv_p
      g = dfloat(1 - k) * g / psi
    enddo
  end if
end if

if(drv_p == 0) then
  do i = 1, 9
    pwrt = tau ** (j0i(i) - drv_t)
    do k = 0, drv_t - 1
      pwrt = pwrt * dfloat(j0i(i) - k)
    enddo
    g = g + n0i(i) * pwrt
  enddo
end if

gamma_0 = g

end function
 
!=========================================================================
function gamma_1(drv_t, drv_p, tau, psi)
!=========================================================================

!THIS FUNCTION IMPLEMENTS THE DERIVATIVES OF GAMMA AS GIVEN IN TABLE 4 OF IF-97

implicit none

integer drv_t, drv_p
integer i, k
real*8 tau, psi
real*8 gamma_1
real*8 g, pp, tt
real*8 pwrt, pwrp

gamma_1 = errorreturn

if(psi <= 0d0) return
if(tau <= 0d0) return
if(drv_t < 0) return
if(drv_p < 0) return

pp = 7.1d0 - psi
tt = tau - 1.222d0

g = 0d0
do i = 1, 34

  if(tt == 0d0) then
    if(j1i(i) == drv_t) then
      pwrt = 1d0
    elseif(j1i(i) > drv_t) then
      pwrt = 0d0
    else
      return
    endif
  else
    pwrt = tt ** (j1i(i) - drv_t)
  end if
  do k = 0, drv_t - 1
    pwrt = pwrt * dfloat(j1i(i) - k)
  enddo

  if(pp == 0d0) then
    if(i1i(i) == drv_p) then
      pwrp = 1d0
    elseif(i1i(i) > drv_p) then
      pwrp = 0d0
    else
      return
    endif
  else
    pwrp = pp ** (i1i(i) - drv_p)
  end if
  do k = 0, drv_p - 1
    pwrp = -pwrp * dfloat(i1i(i) - k)
  enddo

  g = g + n1i(i) * pwrp * pwrt

enddo

gamma_1 = g

end function
 
!=========================================================================
function gamma_2(drv_t, drv_p, tau, psi)
!=========================================================================

!THIS FUNCTION IMPLEMENTS THE DERIVATIVES OF GAMMA AS GIVEN IN EQ. 15 OF IF-97

implicit none

integer drv_t, drv_p
real*8 tau, psi
real*8 gamma_2
real*8 g0, gr

call init_if97_2

gamma_2 = errorreturn

g0 = gamma_0(drv_t, drv_p, tau, psi)
if(g0 == errorreturn) return

gr = gamma_r(drv_t, drv_p, tau, psi)
if(gr == errorreturn) return

gamma_2 = g0 + gr

end function

!=========================================================================
function gamma_r(drv_t, drv_p, tau, psi)
!=========================================================================
                         
!THIS FUNCTION IMPLEMENTS THE DERIVATIVES OF GAMMA_R AS GIVEN IN TABLE 14 OF IF-97

implicit none

integer drv_t, drv_p
integer i, k
real*8 gamma_r
real*8 tau, psi
real*8 g, tt
real*8 pwrt, pwrp

gamma_r = errorreturn

if(psi <= 0d0) return
if(tau <= 0d0) return
if(drv_t < 0) return
if(drv_p < 0) return

tt = tau - 0.5d0

g = 0d0
do i = 1, 43

  if(tt == 0d0) then
    if(jri(i) == drv_t) then
      pwrt = 1d0
    elseif(jri(i) > drv_t) then
      pwrt = 0d0
    else
      return
    endif
  else
    pwrt = tt ** (jri(i) - drv_t)
  end if
  do k = 0, drv_t - 1
    pwrt = pwrt * dfloat(jri(i) - k)
  enddo

  pwrp = psi ** (iri(i) - drv_p)
  do k = 0, drv_p - 1
    pwrp = pwrp * dfloat(iri(i) - k)
  enddo

  g = g + nri(i) * pwrp * pwrt

enddo

gamma_r = g

end function

!==========================================================================
subroutine set_sea_vap_state(sa_si, t_si, p_si, d_liq_si, d_vap_si)
!==========================================================================

!STORES THE ACTUAL PROPERTIES AS THE CURRENT EQUILIBRIUM STATE DESCRIPTOR

implicit none
real*8 sa_si, t_si, p_si, d_liq_si, d_vap_si

equi_sea_vap_done = isok

equi_sea_vap_s = sa_si
equi_sea_vap_t = t_si
equi_sea_vap_p = p_si
equi_sea_vap_d_vap = d_vap_si   !DENSITY OF WATER VAPOUR
equi_sea_vap_d_liq = d_liq_si   !DENSITY OF LIQUID WATER

return
end subroutine

!==========================================================================
subroutine clear_sea_vap_state
!==========================================================================

!CLEARS THE CURRENT EQUILIBRIUM STATE DESCRIPTOR

implicit none

equi_sea_vap_done = 0

return
end subroutine

!==========================================================================
subroutine init_it_ctrl_sea_vap
!==========================================================================

implicit none
real*8 s_norm, tt, dlt, dvt

s_norm = so_salinity_si          !KG/KG OF KCL NORMALISED SEAWATER
tt = tp_temperature_si
dlt = tp_density_liq_iapws95_si  !TRIPLE POINT DENSITY OF LIQUID WATER
dvt = tp_density_vap_iapws95_si  !TRIPLE POINT DENSITY OF WATER VAPOUR

if(ctrl_initialized == isok) return

ctrl_initialized = isok

!SET DEFAULT VALUES AND MODES FOR THE ITERATION
ctrl_mode_liquid = 0
ctrl_mode_vapour = 0
ctrl_mode_sea = 0
ctrl_mode_temperature = 0
ctrl_loop_maximum = 100
ctrl_init_s_sea = s_norm
ctrl_init_t = tt
ctrl_init_d_liq = dlt
ctrl_init_d_vap = dvt

ctrl_eps_exit_s = -0.0000001d0 !RELATIVE, 0.1 PPM
ctrl_eps_exit_t = -0.0000001d0 !RELATIVE, 0.1 PPM
ctrl_eps_exit_p = -0.0000001d0 !RELATIVE, 0.1 PPM

return
end subroutine

!==========================================================================
subroutine set_it_ctrl_sea_vap(key, value)
!==========================================================================

!THIS SUB SETS CONTROL PARAMETERS FOR THE ITERATION USED TO COMPUTE
!SEAWATER-VAPOUR EQUILIBRIUM

!KEY                    VALUE
!'IT_STEPS     '        0           SET ITERATION NUMBER TO DEFAULT (100)
!'IT_STEPS     '        N > 0       SET ITERATION NUMBER TO N
!'IT_STEPS     '       -1           DO NOT ITERATE, USE INITIAL VALUES TO COMPUTE EQUILIBRIUM

!'INIT_LIQ_DENS'        0           USE DEFAULT LIQUID DENSITY TO START =
!                                   LIQUID DENSITY CORRELATION FUNCTION, D = AUX_LIQ_DENSITY_IF97_SI(T)
!'INIT_LIQ_DENS'       -1           USE TRIPLE POINT LIQUID DENSITY TO START
!'INIT_LIQ_DENS'        D > 0       USE VALUE D AS LIQUID DENSITY TO START

!'INIT_VAP_DENS'        0           USE DEFAULT VAPOUR DENSITY TO START =
!                                   VAPOUR DENSITY CORRELATION FUNCTION, D = AUX_DENSITY_IDEAL_SI(T)
!'INIT_VAP_DENS'       -1           USE TRIPLE POINT VAPOUR DENSITY TO START
!'INIT_VAP_DENS'        D > 0       USE VALUE D AS VAPOUR DENSITY TO START

!'INIT_BRINE_SA'        0           USE DEFAULT BRINE SALINITY TO START ( = AUX_BRINESALINITY_SI(T, P))
!'INIT_BRINE_SA'       -1           USE NORMAL SALINITY TO START
!'INIT_BRINE_SA'        S > 0       USE VALUE S AS BRINE SALINITY TO START

!'INIT_TEMP    '        0           USE DEFAULT TEMPERATURE TO START ( = AUX_BOILINGTEMPERATURE_SI(S, P))
!'INIT_TEMP    '       -1           USE 0°C TEMPERATURE TO START
!'INIT_TEMP    '        T > 0       USE VALUE T AS TEMPERATURE TO START

!'TOL_BRINE_SA '        0           USE DEFAULT EXIT TOLERANCE FOR BRINE SALINITY (0.1 PPM)
!'TOL_BRINE_SA '        EPS         USE EPS AS EXIT TOLERANCE FOR BRINE SALINITY (EPS < 0 MEANS RELATIVE ERROR)

!'TOL_TEMP     '        0           USE DEFAULT EXIT TOLERANCE FOR TEMPERATURE (0.1 PPM)
!'TOL_TEMP     '        EPS         USE EPS AS EXIT TOLERANCE FOR TEMPERATURE (EPS < 0 MEANS RELATIVE ERROR)

!'TOL_PRESS    '        0           USE DEFAULT EXIT TOLERANCE FOR PRESSURE (0.1 PPM)
!'TOL_PRESS    '        EPS         USE EPS AS EXIT TOLERANCE FOR PRESSURE (EPS < 0 MEANS RELATIVE ERROR)

implicit none
character*13 key
real*8 value

call init_it_ctrl_sea_vap

call clear_sea_vap_state

select case (trim(key))

  case ('it_steps')                !ITERATION STEPS
    if(value == 0d0)then
      ctrl_loop_maximum = 100   !DEFAULT = 100
    elseif(value < 0d0)then
      ctrl_loop_maximum = -1
    else
      ctrl_loop_maximum = nint(value)
    endif

  case ('init_liq_dens')           !START LIQUID DENSITY
    if(value == 0d0)then
      ctrl_mode_liquid = 0      !DEFAULT = AUX POLYNOMIAL
    elseif(value < (-1d0))then
      !ignore it
    elseif(value < 0d0)then
      ctrl_mode_liquid = nint(value)
    else
      ctrl_mode_liquid = 1
      ctrl_init_d_liq = value
    endif

  case ('init_vap_dens')           !START VAPOUR DENSITY
    if(value == 0d0)then
      ctrl_mode_vapour = 0      !DEFAULT = AUX POLYNOMIAL
    elseif(value < (-1d0))then
      !ignore it
    elseif(value < 0d0)then
      ctrl_mode_vapour = nint(value)
    else
      ctrl_mode_vapour = 1
      ctrl_init_d_vap = value
    endif

  case ('init_brine_sa')           !START BRINE SALINITY
    if(value == 0d0)then
      ctrl_mode_sea = 0         !DEFAULT = AUX POLYNOMIAL
    elseif(value < (-1d0))then
      !ignore it
    elseif(value < 0d0)then
      ctrl_mode_sea = nint(value)
    else
      ctrl_mode_sea = 1
      ctrl_init_s_sea = value
    endif

  case ('init_temp')               !START TEMPERATURE
    if(value == 0d0)then
      ctrl_mode_temperature = 0 !DEFAULT = AUX POLYNOMIAL
    elseif(value < (-1d0))then
      !ignore it
    elseif(value < 0d0)then
      ctrl_mode_temperature = nint(value)
    else
      ctrl_mode_temperature = 1
      ctrl_init_t = value
    endif

  case ('tol_brine_sa')            !TOLERANCE FOR BRINE SALINITY
    if(value == 0d0)then
      ctrl_eps_exit_s = -0.0000001d0   !DEFAULT = 0.1 PPM RELATIVE
    else
      ctrl_eps_exit_s = value
    endif

  case ('tol_temp')                !TOLERANCE FOR TEMPERATURE
    if(value == 0d0)then
      ctrl_eps_exit_t = -0.0000001d0   !DEFAULT = 0.1 PPM RELATIVE
    else
      ctrl_eps_exit_t = value
    endif

  case ('tol_press')               !TOLERANCE FOR TEMPERATURE
    if(value == 0d0)then
      ctrl_eps_exit_p = -0.0000001d0   !DEFAULT = 0.1 PPM RELATIVE
    else
      ctrl_eps_exit_p = value
    endif

  case default; write(*,*)key,' not supported'

end select

return
end subroutine
 
!=========================================================================
subroutine init_if97_1
!=========================================================================

implicit none
integer i

if(n1i(1) == 0.14632971213167d0) return

!TABLE-2. NUMERICAL VALUES OF THE COEFFICIENTS AND EXPONENTS OF THE DIMENSIONLESS GIBBS FREE ENERGY
!FOR REGION 1, EQ. (7)
!I II JI NI I II JI NI
i = 1; i1i(i)  = 0;  j1i(i) = -2;  n1i(i) = 0.14632971213167d0
i = 2; i1i(i)  = 0;  j1i(i) = -1;  n1i(i) = -0.84548187169114d0
i = 3; i1i(i)  = 0;  j1i(i) = 0;   n1i(i) = -3.756360367204d0
i = 4; i1i(i)  = 0;  j1i(i) = 1;   n1i(i) = 3.3855169168385d0
i = 5; i1i(i)  = 0;  j1i(i) = 2;   n1i(i) = -0.95791963387872d0
i = 6; i1i(i)  = 0;  j1i(i) = 3;   n1i(i) = 0.15772038513228d0
i = 7; i1i(i)  = 0;  j1i(i) = 4;   n1i(i) = -0.016616417199501d0
i = 8; i1i(i)  = 0;  j1i(i) = 5;   n1i(i) = 8.1214629983568d-04
i = 9; i1i(i)  = 1;  j1i(i) = -9;  n1i(i) = 2.8319080123804d-04
i = 10; i1i(i) = 1;  j1i(i) = -7;  n1i(i) = -6.0706301565874d-04
i = 11; i1i(i) = 1;  j1i(i) = -1;  n1i(i) = -0.018990068218419d0
i = 12; i1i(i) = 1;  j1i(i) = 0;   n1i(i) = -0.032529748770505d0
i = 13; i1i(i) = 1;  j1i(i) = 1;   n1i(i) = -0.021841717175414d0
i = 14; i1i(i) = 1;  j1i(i) = 3;   n1i(i) = -5.283835796993d-05  
i = 15; i1i(i) = 2;  j1i(i) = -3;  n1i(i) = -4.7184321073267d-04
i = 16; i1i(i) = 2;  j1i(i) = 0;   n1i(i) = -3.0001780793026d-04
i = 17; i1i(i) = 2;  j1i(i) = 1;   n1i(i) = 4.7661393906987d-05
i = 18; i1i(i) = 2;  j1i(i) = 3;   n1i(i) = -4.4141845330846d-06
i = 19; i1i(i) = 2;  j1i(i) = 17;  n1i(i) = -7.2694996297594d-16
i = 20; i1i(i) = 3;  j1i(i) = -4;  n1i(i) = -3.1679644845054d-05
i = 21; i1i(i) = 3;  j1i(i) = 0;   n1i(i) = -2.8270797985312d-06
i = 22; i1i(i) = 3;  j1i(i) = 6;   n1i(i) = -8.5205128120103d-10
i = 23; i1i(i) = 4;  j1i(i) = -5;  n1i(i) = -2.2425281908d-06
i = 24; i1i(i) = 4;  j1i(i) = -2;  n1i(i) = -6.5171222895601d-07
i = 25; i1i(i) = 4;  j1i(i) = 10;  n1i(i) = -1.4341729937924d-13
i = 26; i1i(i) = 5;  j1i(i) = -8;  n1i(i) = -4.0516996860117d-07
i = 27; i1i(i) = 8;  j1i(i) = -11; n1i(i) = -1.2734301741641d-09
i = 28; i1i(i) = 8;  j1i(i) = -6;  n1i(i) = -1.7424871230634d-10
i = 29; i1i(i) = 21; j1i(i) = -29; n1i(i) = -6.8762131295531d-19
i = 30; i1i(i) = 23; j1i(i) = -31; n1i(i) = 1.4478307828521d-20
i = 31; i1i(i) = 29; j1i(i) = -38; n1i(i) = 2.6335781662795d-23
i = 32; i1i(i) = 30; j1i(i) = -39; n1i(i) = -1.1947622640071d-23
i = 33; i1i(i) = 31; j1i(i) = -40; n1i(i) = 1.8228094581404d-24
i = 34; i1i(i) = 32; j1i(i) = -41; n1i(i) = -9.3537087292458d-26

return
end subroutine

!=========================================================================
subroutine init_if97_2
!=========================================================================

implicit none
integer i

if(n0i(1) == -9.6927686500217d0) return

!TABLE 10. NUMERICAL VALUES OF THE COEFFICIENTS AND EXPONENTS OF THE IDEAL-GAS PART GAMMA_0 OF THE
!DIMENSIONLESS GIBBS FREE ENERGY FOR REGION 2, EQ. (16)
!I JI NI I JI NI
i = 1; j0i(i) = 0;  n0i(i) = -9.6927686500217d0
i = 2; j0i(i) = 1;  n0i(i) = 10.086655968018d0
i = 3; j0i(i) = -5; n0i(i) = -0.005608791128302d0
i = 4; j0i(i) = -4; n0i(i) = 0.071452738081455d0
i = 5; j0i(i) = -3; n0i(i) = -0.40710498223928d0
i = 6; j0i(i) = -2; n0i(i) = 1.4240819171444d0
i = 7; j0i(i) = -1; n0i(i) = -4.383951131945d0
i = 8; j0i(i) = 2;  n0i(i) = -0.28408632460772d0
i = 9; j0i(i) = 3;  n0i(i) = 0.021268463753307d0
!IF(EQ. (16) IS INCORPORATED INTO EQ. (18), INSTEAD OF THE-VALUES FOR N0I(1) AND N0I(1)
!GIVEN ABOVE, THE FOLLOWING VALUES
!N0I(1) = -0.96937268393049D1
!N0I(2) = 0.10087275970006D2
!SHOULD BE USED

!TABLE 11. NUMERICAL VALUES OF THE COEFFICIENTS AND EXPONENTS OF THE
!RESIDUAL PART GAMMA_R OF THE DIMENSIONLESS GIBBS FREE ENERGY FOR
!REGION 2, EQ. (17)
!I II JI NI
i = 1;  iri(i) = 1;  jri(i) = 0;  nri(i) = -1.7731742473213d-03
i = 2;  iri(i) = 1;  jri(i) = 1;  nri(i) = -0.017834862292358d0
i = 3;  iri(i) = 1;  jri(i) = 2;  nri(i) = -0.045996013696365d0
i = 4;  iri(i) = 1;  jri(i) = 3;  nri(i) = -0.057581259083432d0
i = 5;  iri(i) = 1;  jri(i) = 6;  nri(i) = -0.05032527872793d0
i = 6;  iri(i) = 2;  jri(i) = 1;  nri(i) = -3.3032641670203d-05
i = 7;  iri(i) = 2;  jri(i) = 2;  nri(i) = -1.8948987516315d-04
i = 8;  iri(i) = 2;  jri(i) = 4;  nri(i) = -3.9392777243355d-03
i = 9;  iri(i) = 2;  jri(i) = 7;  nri(i) = -0.043797295650573d0
i = 10; iri(i) = 2;  jri(i) = 36; nri(i) = -2.6674547914087d-05
i = 11; iri(i) = 3;  jri(i) = 0;  nri(i) = 2.0481737692309d-08
i = 12; iri(i) = 3;  jri(i) = 1;  nri(i) = 4.3870667284435d-07
i = 13; iri(i) = 3;  jri(i) = 3;  nri(i) = -3.227767723857d-05
i = 14; iri(i) = 3;  jri(i) = 6;  nri(i) = -1.5033924542148d-03
i = 15; iri(i) = 3;  jri(i) = 35; nri(i) = -0.040668253562649d0
i = 16; iri(i) = 4;  jri(i) = 1;  nri(i) = -7.8847309559367d-10
i = 17; iri(i) = 4;  jri(i) = 2;  nri(i) = 1.2790717852285d-08
i = 18; iri(i) = 4;  jri(i) = 3;  nri(i) = 4.8225372718507d-07
i = 19; iri(i) = 5;  jri(i) = 7;  nri(i) = 2.2922076337661d-06
i = 20; iri(i) = 6;  jri(i) = 3;  nri(i) = -1.6714766451061d-11
i = 21; iri(i) = 6;  jri(i) = 16; nri(i) = -2.1171472321355d-03
i = 22; iri(i) = 6;  jri(i) = 35; nri(i) = -23.895741934104d0
i = 23; iri(i) = 7;  jri(i) = 0;  nri(i) = -5.905956432427d-18
i = 24; iri(i) = 7;  jri(i) = 11; nri(i) = -1.2621808899101d-06
i = 25; iri(i) = 7;  jri(i) = 25; nri(i) = -0.038946842435739d0
i = 26; iri(i) = 8;  jri(i) = 8;  nri(i) = 1.1256211360459d-11
i = 27; iri(i) = 8;  jri(i) = 36; nri(i) = -0.082311340897998d0
i = 28; iri(i) = 9;  jri(i) = 13; nri(i) = 1.9809712802088d-08
i = 29; iri(i) = 10; jri(i) = 4;  nri(i) = 1.0406965210174d-19
i = 30; iri(i) = 10; jri(i) = 10; nri(i) = -1.0234747095929d-13
i = 31; iri(i) = 10; jri(i) = 14; nri(i) = -1.0018179379511d-09
i = 32; iri(i) = 16; jri(i) = 29; nri(i) = -8.0882908646985d-11
i = 33; iri(i) = 16; jri(i) = 50; nri(i) = 0.10693031879409d0
i = 34; iri(i) = 18; jri(i) = 57; nri(i) = -0.33662250574171d0
i = 35; iri(i) = 20; jri(i) = 20; nri(i) = 8.9185845355421d-25
i = 36; iri(i) = 20; jri(i) = 35; nri(i) = 3.0629316876232d-13
i = 37; iri(i) = 20; jri(i) = 48; nri(i) = -4.2002467698208d-06
i = 38; iri(i) = 21; jri(i) = 21; nri(i) = -5.9056029685639d-26
i = 39; iri(i) = 22; jri(i) = 53; nri(i) = 3.7826947613457d-06
i = 40; iri(i) = 23; jri(i) = 39; nri(i) = -1.2768608934681d-15
i = 41; iri(i) = 24; jri(i) = 26; nri(i) = 7.3087610595061d-29
i = 42; iri(i) = 24; jri(i) = 40; nri(i) = 5.5414715350778d-17
i = 43; iri(i) = 24; jri(i) = 58; nri(i) = -9.436970724121d-07

return
end subroutine

end module sea_vap_4

module air_3c

!#########################################################################

!THIS MODULE IMPLEMENTS THE ENTHALPY OF HUMID AIR DEPENDING ON AIR FRACTION, 
!ENTROPY AND PRESSURE, AS WELL AS ITS PARTIAL DERIVATIVES.

!#########################################################################

!IMPLEMENTATION IN FORTRAN BY D.G. WRIGHT
!FOR PUBLICATION IN OCEAN SCIENCE, AS DESCRIBED IN THE PAPERS

!FEISTEL, R., WRIGHT, D.G., JACKETT, D.R., MIYAGAWA, K., REISSMANN, J.H.,
!WAGNER, W., OVERHOFF, U., GUDER, C., FEISTEL, A., MARION, G.M.:
!NUMERICAL IMPLEMENTATION AND OCEANOGRAPHIC APPLICATION OF THE THERMODYNAMIC
!POTENTIALS OF WATER, VAPOUR, ICE, SEAWATER AND AIR. PART I: BACKGROUND AND EQUATIONS. 
!OCEAN SCIENCES, 2009, IN PREPARATION.

!WRIGHT, D.G., FEISTEL, R., JACKETT, D.R., MIYAGAWA, K., REISSMANN, J.H., 
!WAGNER, W., OVERHOFF, U., GUDER, C., FEISTEL, A., MARION, G.M.:
!NUMERICAL IMPLEMENTATION AND OCEANOGRAPHIC APPLICATION OF THE THERMODYNAMIC
!POTENTIALS OF WATER, VAPOUR, ICE, SEAWATER AND AIR. PART II: THE LIBRARY ROUTINES, 
!OCEAN SCIENCES., 2009, IN PREPARATION.

!FEISTEL, R., KRETZSCHMAR, H.-J., SPAN, R., HAGEN, E., !WRIGHT, D.G., HERRMANN, S.:
!THERMODYNAMIC PROPERTIES OF SEA AIR.
!OCEAN SCIENCE DISCUSSION 6(2009)2193-2325.

!#########################################################################

!THIS MODULE REQUIRES THE LIBRARY MODULES:
!     CONSTANTS_0,  FILE CONSTANTS_0.F90
!     CONVERT_0,    FILE CONVERT_0.F90
!     AIR_2,        FILE AIR_2.F90
!     AIR_3A,       FILE AIR_3A.F90
!     AIR_3B,       FILE AIR_3B.F90

!NESTED USE ASSOCIATIONS
!     MATHS_0,      FILE MATHS_0.F90
!     AIR_1,        FILE AIR_1.F90
!     FLU_1,        FILE FLU_1.F90

!#########################################################################

use constants_0
use convert_0
use air_2
use air_3a
use air_3b

implicit none
private

character*16, private :: version = '8 Jun 2010'

public :: air_h_si, air_potdensity_si, air_potenthalpy_si, &
          air_pottemp_si, air_temperature_si, set_it_ctrl_air_pottemp

!CONTROL PARAMETERS OF THE TEMPERATURE ITERATION
integer ctrl_initialized, ctrl_mode_pottemp
integer ctrl_loop_maximum
real*8 ctrl_init_pottemp, ctrl_eps_exit_pottemp

contains

!==========================================================================
function air_h_si(drv_a, drv_eta, drv_p, a_si, eta_si, p_si)
!==========================================================================

!THIS FUNCTION IMPLEMENTS ENTHALPY AS A THERMODYNAMIC POTENTIAL OF HUMID AIR, DEPENDING
!ON THE DRY-AIR MASS FRACTION, SPECIFIC ENTROPY AND PRESSURE

!OUTPUT:
!AIR_H_SI AS THE A-ETA-P DERIVATIVE
!(D/DA)^DRV_A (D/DETA)^DRV_ETA (D/DP)^DRV_P H(A,ETA,P)
!OF THE SPECIFIC ENTHALPY OF HUMID AIR, H(A,ETA,P), IN J/KG

!INPUT:
!A_SI      MASS FRACTION OF DRY AIR IN KG/KG
!ETA_SI    SPECIFIC ENTROPY IN J/(KG K),
!P_SI      ABSOLUTE PRESSURE IN PA

!CHECK VALUES WITH DEFAULT SETTINGS, V1.0:
!air_h_si( 0, 0, 0, 0.9, 900, 1E5) = 274589.199192
!air_h_si( 1, 0, 0, 0.9, 900, 1E5) =-229734.926517
!air_h_si( 0, 1, 0, 0.9, 900, 1E5) = 297.395859294
!air_h_si( 0, 0, 1, 0.9, 900, 1E5) = 0.903422384672
!air_h_si( 2, 0, 0, 0.9, 900, 1E5) = 13959323.1016
!air_h_si( 1, 1, 0, 0.9, 900, 1E5) = 1676.33822835
!air_h_si( 1, 0, 1, 0.9, 900, 1E5) =-0.467305898316
!air_h_si( 0, 2, 0, 0.9, 900, 1E5) = 0.223618143111
!air_h_si( 0, 1, 1, 0.9, 900, 1E5) = 7.15646251375E-04
!air_h_si( 0, 0, 2, 0.9, 900, 1E5) =-6.78234488400E-06

!CHECK VALUES WITH DEFAULT SETTINGS, V1.1:
!air_h_si( 0, 0, 0, 0.9, 900, 1E5) = 274592.611783
!air_h_si( 1, 0, 0, 0.9, 900, 1E5) =-229706.905765
!air_h_si( 0, 1, 0, 0.9, 900, 1E5) = 297.403043058
!air_h_si( 0, 0, 1, 0.9, 900, 1E5) = 0.903262695636
!air_h_si( 2, 0, 0, 0.9, 900, 1E5) = 13963273.0104
!air_h_si( 1, 1, 0, 0.9, 900, 1E5) = 1676.85098552
!air_h_si( 1, 0, 1, 0.9, 900, 1E5) =-0.467537679038
!air_h_si( 0, 2, 0, 0.9, 900, 1E5) = 0.223684689765
!air_h_si( 0, 1, 1, 0.9, 900, 1E5) = 7.15703143992E-04
!air_h_si( 0, 0, 2, 0.9, 900, 1E5) =-6.78105152859E-06


!NOTE: THE ACCURACY OF THIS FUNCTION DEPENDS ON THE ITERATION SETTINGS FOR
!      DENSITY COMPUTED IN AIR_3A
!      AND ON THE ITERATION SETTINGS FOR TEMPERATURE BY SET_IT_CTRL_AIR_POTTEMP OF THIS MODULE

real*8 air_h_si, a_si, eta_si, p_si
real*8 t
integer drv_a, drv_eta, drv_p

air_h_si = errorreturn

if(drv_a < 0 .or. drv_a > 2) return
if(drv_eta < 0 .or. drv_eta > 2) return
if(drv_p < 0 .or. drv_p > 2) return

if(a_si < 0d0 .or. a_si >= 1d0) return
if(p_si < 0d0) return

!COMPUTE TEMPERATURE FROM ENTROPY.
!IF P_SI = IN-SITU PRESSURE, THIS IS IN-SITU TEMPERATURE
!IF P_SI = REFERENCE PRESSURE, THIS IS POTENTIAL TEMPERATURE
t = air_temperature_si(a_si, eta_si, p_si)
if(t == errorreturn) return
if(t <= 0d0) return

air_h_si = air_a_eta_p_derivatives_si(drv_a, drv_eta, drv_p, a_si, t, p_si)

end function

!==========================================================================
function air_potdensity_si(a_si, t_si, p_si, pr_si)
!==========================================================================
                               
!THIS FUNCTION COMPUTES THE POTENTIAL DENSITY OF HUMID AIR
!FROM THE MASS FRACTION OF AIR, TEMPERATURE, PRESSURE AND REFERENCE PRESSURE

!OUTPUT:
!RHO_THETA(A,T,P,PR) POTENTIAL DENSITY OF HUMID AIR IN KG/M3

!INPUT:
!A_SI      MASS FRACTION OF DRY AIR IN KG/KG
!T_SI      ABSOLUTE IN-SITU TEMPERATURE IN K
!P_SI      ABSOLUTE IN-SITU PRESSURE IN PA
!PR_SI     ABSOLUTE REFERENCE PRESSURE IN PA

!CHECK VALUE WITH DEFAULT SETTINGS, V1.0: 
!AIR_POTDENSITY_SI(0.9, 300, 5e4, 1E5) = 0.903326577188

!CHECK VALUE WITH DEFAULT SETTINGS, V1.1: 
!AIR_POTDENSITY_SI(0.9, 300, 5e4, 1E5) = 0.903509489711

!NOTE: THE ACCURACY OF THIS FUNCTION DEPENDS ON THE ITERATION SETTINGS FOR
!      DENSITY COMPUTED IN AIR_3A
!      AND ON THE ITERATION SETTINGS FOR TEMPERATURE BY SET_IT_CTRL_AIR_POTTEMP OF THIS MODULE

real*8 air_potdensity_si, a_si, t_si, p_si, pr_si
real*8 s, v

air_potdensity_si = errorreturn

if(a_si < 0d0 .or. a_si >= 1d0) return
if(t_si < 0d0) return
if(p_si < 0d0) return
if(pr_si < 0d0) return

s = air_g_entropy_si(a_si, t_si, p_si)  !SPECIFIC ENTROPY IN-SITU
if(s == errorreturn) return

v = air_h_si(0, 0, 1, a_si, s, pr_si) !SPECIFIC VOLUME AT REFERENCE PRESSURE
if(v == errorreturn) return
if(v <= 0d0) return

air_potdensity_si = 1d0 / v

end function

!==========================================================================
function air_potenthalpy_si(a_si, t_si, p_si, pr_si)
!==========================================================================
                               
!THIS FUNCTION COMPUTES THE POTENTIAL ENTHALPY OF HUMID AIR
!FROM THE MASS FRACTION OF AIR, TEMPERATURE, PRESSURE AND REFERENCE PRESSURE

!OUTPUT:
!H_THETA(A,T,P,PR) POTENTIAL ENTHALPY OF HUMID AIR IN J/KG

!INPUT:
!A_SI      MASS FRACTION OF DRY AIR IN KG/KG
!T_SI      ABSOLUTE IN-SITU TEMPERATURE IN K
!P_SI      ABSOLUTE IN-SITU PRESSURE IN PA
!PR_SI     ABSOLUTE REFERENCE PRESSURE IN PA

!CHECK VALUE WITH DEFAULT SETTINGS, V1.0: 
!AIR_POTENTHALPY_SI(0.9, 300, 5e4, 1E5) = 348892.581997

!CHECK VALUE WITH DEFAULT SETTINGS, V1.1: 
!AIR_POTENTHALPY_SI(0.9, 300, 5e4, 1E5) = 348872.568665

!NOTE: THE ACCURACY OF THIS FUNCTION DEPENDS ON THE ITERATION SETTINGS FOR
!      DENSITY COMPUTED IN AIR_3A
!      AND ON THE ITERATION SETTINGS FOR TEMPERATURE BY SET_IT_CTRL_AIR_POTTEMP OF THIS MODULE

real*8 air_potenthalpy_si, a_si, t_si, p_si, pr_si
real*8  s

air_potenthalpy_si = errorreturn

if(a_si < 0d0 .or. a_si >= 1d0) return
if(t_si < 0d0) return
if(p_si < 0d0) return
if(pr_si < 0d0) return

s = air_g_entropy_si(a_si, t_si, p_si)  !SPECIFIC ENTROPY IN-SITU
if(s == errorreturn) return

air_potenthalpy_si = air_h_si(0, 0, 0, a_si, s, pr_si)

end function

!==========================================================================
function air_pottemp_si(a_si, t_si, p_si, pr_si) 
!==========================================================================
                               
!THIS FUNCTION COMPUTES THE ABSOLUTE POTENTIAL TEMPERATURE OF HUMID AIR
!FROM THE MASS FRACTION OF AIR, TEMPERATURE, PRESSURE AND REFERENCE PRESSURE

!OUTPUT:
!THETA(A,T,P,PR) ABSOLUTE POTENTIAL TEMPERATURE OF HUMID AIR IN K

!INPUT:
!A_SI      MASS FRACTION OF DRY AIR IN KG/KG
!T_SI      ABSOLUTE IN-SITU TEMPERATURE IN K,
!P_SI      ABSOLUTE IN-SITU PRESSURE IN PA
!PR_SI     ABSOLUTE REFERENCE PRESSURE IN PA

!CHECK VALUE WITH DEFAULT SETTINGS, V1.0: 
!AIR_POTTEMP_SI(0.9, 300, 5E4, 1e5) = 363.654373179

!CHECK VALUE WITH DEFAULT SETTINGS, V1.1: 
!AIR_POTTEMP_SI(0.9, 300, 5E4, 1e5) = 363.653905688

real*8 air_pottemp_si, a_si, t_si, p_si, pr_si
real*8 s

air_pottemp_si = errorreturn

if(a_si < 0d0 .or. a_si > 1d0) return
if(t_si < 0d0) return
if(p_si < 0d0) return
if(pr_si < 0d0) return

if(p_si == pr_si) then
  air_pottemp_si = t_si
  return
end if

s = air_g_entropy_si(a_si, t_si, p_si)  !SPECIFIC ENTROPY IN-SITU
if(s == errorreturn) return

air_pottemp_si = air_temperature_si(a_si, s, pr_si)

end function

!=========================================================================
function air_temperature_si(a_si, eta_si, p_si)
!==========================================================================

!THIS IS THE INVERSE FUNCTION TO AIR_G_ENTROPY_SI(A_SI, T_SI, P_SI) IN AIR_3B
!COMPUTING THE ABSOLUTE (POTENTIAL) TEMPERATURE OF HUMID AIR
!FROM THE MASS FRACTION OF AIR, SPECIFIC ENTROPY AND PRESSURE

!OUTPUT:
!T(A,ETA,P) (POTENTIAL) TEMPERATURE OF HUMID AIR IN K

!INPUT:
!A_SI      MASS FRACTION OF DRY AIR IN KG/KG
!ETA_SI    SPECIFIC ENTROPY IN J/(KG K)
!P_SI      ABSOLUTE (REFERENCE) PRESSURE IN PA

!CHECK VALUE WITH DEFAULT SETTINGS, V1.0: 
!AIR_TEMPERATURE_SI(0.9, 900, 1E5) = 297.395859294

!CHECK VALUE WITH DEFAULT SETTINGS, V1.1: 
!AIR_TEMPERATURE_SI(0.9, 900, 1E5) = 297.403043058

!NOTE: THE ACCURACY OF THIS FUNCTION DEPENDS ON THE ITERATION SETTINGS FOR
!      DENSITY COMPUTED IN AIR_3A AND ON THOSE MADE IN THIS MODULE

real*8 air_temperature_si, a_si, eta_si, p_si
real*8 t, eps
integer maxit

air_temperature_si = errorreturn

call init_it_ctrl_pottemp

select case(ctrl_mode_pottemp)
  case(0);    t = aux_temperature_si(a_si, eta_si, p_si)  !IDEAL-GAS APPROXIMATION
  case default; t = ctrl_init_pottemp
end select

  if(ctrl_loop_maximum == 0d0) then
     maxit = 100
  elseif(ctrl_loop_maximum == (-1)) then
     air_temperature_si = t
     return
  elseif(ctrl_loop_maximum > 0) then
     maxit = ctrl_loop_maximum
  else
     return
  endif

eps = ctrl_eps_exit_pottemp
if(eps <= 0d0) return

!RUN THE ITERATION
air_temperature_si = pottemp_iteration(a_si, eta_si, p_si, t, maxit, eps)

end function

!==========================================================================
function air_a_eta_p_derivatives_si(drv_a, drv_eta, drv_p, a_si, t_si, p_si)
!==========================================================================
                                              
!THIS FUNCTION COMPUTES HUMID AIR A-ETA-P DERIVATIVES OF H FROM A-T-P DERIVATIVES OF G
!THIS FUNCTION COMPUTES A-ETA-P DERIVATIVES OF H FROM A-T-P DERIVATIVES OF G
!AT GIVEN AIR FRACTION, TEMPERATURE AND PRESSURE

!OUTPUT:
!AIR_A_ETA_P_DERIVATEVE_SI = SPECIFIC ENTHAPY OR ITS DERIVATIVES IN J KG-1 (J KG-1 K-1)^-DRV_ETA PA^-DRV_P

!INPUT:
!DRV_A = ORDER OF AIR-FRACTION DERIVATIVE, 0 <= DRV_A <= 2
!DRV_ETA = ORDER OF SPECIFIC ENTROPY DERIVATIVE, 0 <= DRV_ETA + DRV_A <= 2
!DRV_P = ORDER OF PRESSURE DERIVATIVE, 0 <= DRV_P + DRV_ETA + DRV_A <= 2
!A_SI  = MASS FRACTION OF DRY AIR IN HUMID AIR IN KG/KG
!T_SI  = ABSOLUTE TEMPERATURE IN K
!P_SI  = PRESSURE IN PA

real*8 air_a_eta_p_derivatives_si, a_si, t_si, p_si

real*8 g, g_t, g_p, g_a
real*8  g_aa, g_at, g_ap
real*8  g_tt, g_pp, g_tp

real*8  h

integer drv_a, drv_eta, drv_p

!IN ONE CASE WE DO NOT AT ALL NEED TO COMPUTE THE GIBBS FUNCTION:
if(drv_a == 0 .and. drv_eta == 1 .and. drv_p == 0) then
  air_a_eta_p_derivatives_si = t_si
  return
end if

air_a_eta_p_derivatives_si = errorreturn

g_tp = errorreturn

select case(drv_a)

  case(0)
    select case(drv_eta)
    
      case(0)
        select case(drv_p)
        
          case(0) 
            g = air_g_si(0, 0, 0, a_si, t_si, p_si)
            if(g == errorreturn) return
            g_t = air_g_si(0, 1, 0, a_si, t_si, p_si)
            if(g_t == errorreturn) return
            h = g - t_si * g_t                             !H
          
          case(1)
            g_p = air_g_si(0, 0, 1, a_si, t_si, p_si)
            if(g_p == errorreturn) return
            h = g_p                                        !DH/DP
             
          case(2)
            g_tt = air_g_si(0, 2, 0, a_si, t_si, p_si)
            if(g_tt == errorreturn) return
            if(g_tt == 0d0) return
            g_tp = air_g_si(0, 1, 1, a_si, t_si, p_si)
            if(g_tp == errorreturn) return
            g_pp = air_g_si(0, 0, 2, a_si, t_si, p_si)
            if(g_pp == errorreturn) return
            h = (g_tt * g_pp - g_tp**2) / g_tt             !D2H/DP2
                  
          case default; return
        end select
        
      case(1)
        select case(drv_p)

          case(0) 
            h = t_si                                       !DH/DETA, HAS ALREADY BEEN HANDLED INITIALLY
          
          case(1) 
            g_tt = air_g_si(0, 2, 0, a_si, t_si, p_si)
            if(g_tt == errorreturn) return
            if(g_tt == 0d0) return
            g_tp = air_g_si(0, 1, 1, a_si, t_si, p_si)
            if(g_tp == errorreturn) return
            h = -g_tp / g_tt                               !D2H/DETADP
             
          case default; return
        end select

      case(2)
        select case(drv_p)
          case(0) 
            g_tt = air_g_si(0, 2, 0, a_si, t_si, p_si)
            if(g_tt == errorreturn) return
            if(g_tt == 0d0) return
            h = -1d0 / g_tt                                !D2H/DETA2
             
          case default; return
        end select

      case default; return
    end select
    
  case(1)
    select case(drv_eta)
    
      case(0)
        select case(drv_p)
        
          case(0) 
            g_a = air_g_si(1, 0, 0, a_si, t_si, p_si)
            if(g_a == errorreturn) return
            h = g_a                                        !DH/DA
          
          case(1)
            g_tt = air_g_si(0, 2, 0, a_si, t_si, p_si)
            if(g_tt == errorreturn) return
            if(g_tt == 0d0) return
            g_at = air_g_si(1, 1, 0, a_si, t_si, p_si)
            if(g_at == errorreturn) return
            g_ap = air_g_si(1, 0, 1, a_si, t_si, p_si)
            if(g_ap == errorreturn) return
            h = (g_tt * g_ap - g_at * g_tp) / g_tt         !D2H/DADP
         
          case default; return
        end select

      case(1)
        select case(drv_p)
        
          case(0) 
            g_tt = air_g_si(0, 2, 0, a_si, t_si, p_si)
            if(g_tt == errorreturn) return
            if(g_tt == 0d0) return
            g_at = air_g_si(1, 1, 0, a_si, t_si, p_si)
            if(g_at == errorreturn) return
            h = -g_at / g_tt                               !D2H/DADETA
         
          case default; return
        end select

      case default; return

    end select

  
  case(2)
    select case(drv_eta)
    
      case(0)
        select case(drv_p)
        
          case(0) 
            g_tt = air_g_si(0, 2, 0, a_si, t_si, p_si)
            if(g_tt == errorreturn) return
            if(g_tt == 0d0) return
            g_at = air_g_si(1, 1, 0, a_si, t_si, p_si)
            if(g_at == errorreturn) return
            g_aa = air_g_si(2, 0, 0, a_si, t_si, p_si)
            if(g_aa == errorreturn) return
            h = (g_tt * g_aa - g_at**2) / g_tt             !D2H/DA2
          
          case default; return
        end select

      case default; return
    end select

  case default; return
end select

air_a_eta_p_derivatives_si = h

end function

!==========================================================================
subroutine init_it_ctrl_pottemp()
!==========================================================================

if(ctrl_initialized == -1) return

ctrl_initialized = -1

!SET DEFAULT VALUES AND MODES FOR DENSITY ITERATION
ctrl_loop_maximum = 100
ctrl_mode_pottemp = 0           !default: theta = ideal-gas approximation
ctrl_init_pottemp = 273.15d0
ctrl_eps_exit_pottemp = 0.0001d0  !default = 0.1 mk

end subroutine

!=========================================================================
function pottemp_iteration(a_si, eta_si, p_si, t_si, maxit, eps)
!==========================================================================

!THIS FUNCTION COMPUTES THE ABSOLUTE (POTENTIAL) TEMPERATURE OF HUMID AIR
!FROM THE MASS FRACTION OF AIR, SPECIFIC ENTROPY AND (REFERENCE) PRESSURE

!OUTPUT:
!THETA =   (POTENTIAL) TEMPERATURE OF HUMID AIR IN K,
!          I.E. THE TEMPERATURE T_SI THAT SOLVES ETA_SI = AIR_G_ENTROPY_SI(A_SI, T_SI, P_SI)

!INPUT:
!A_SI      MASS FRACTION OF DRY AIR IN KG/KG
!ETA_SI    SPECIFIC ENTROPY IN J/(KG K)
!P_SI      ABSOLUTE (REFERENCE) PRESSURE IN PA
!T_SI      ABSOLUTE (POTENTIAL) TEMPERATURE IN K, INITIAL VALUE
!MAXIT     MAX. NUMBER OF ITERATIONS
!EPS       REQUIRED TOLERANCE IN K

real*8 pottemp_iteration, a_si, eta_si, p_si, t_si, eps
real*8  s, theta, cp, dt
integer maxit, i

pottemp_iteration = errorreturn

if(a_si < 0d0 .or. a_si > 1d0) return
if(t_si <= 0d0) return
if(p_si <= 0d0) return
if(eps <= 0d0) return
if(maxit <= 0) return

check_limits = check_limits - 1

theta = t_si
do i = 1, maxit

  !GET ENTROPY AND ITS FIRST DERIVATIVE FOR NEWTON ITERATION
  s = air_g_entropy_si(a_si, theta, p_si)
  cp = air_g_cp_si(a_si, theta, p_si)
  
  if(s == errorreturn) go to 999
  if(cp == errorreturn) go to 999
  if(cp <= 0d0) go to 999
  
  !NEXT TEMPERATURE IMPROVEMENT STEP
  dt = theta * (eta_si - s) / cp
  theta = theta + dt
  if(theta <= 0d0) go to 999
  
  if(abs(dt) < eps) then
    pottemp_iteration = theta
    go to 999
  end if
  
enddo

999 continue

check_limits = check_limits + 1

if(check_limits == 1) then
  !AIR_LIMITS
  if(theta < dry_air_tmin .or. theta > dry_air_tmax) then
    pottemp_iteration = errorreturn
    return
  endif
  if(a_si.ne.1d0 .and. &
  (theta < mix_air_tmin .or. theta > mix_air_tmax)) then
    pottemp_iteration = errorreturn
    return
  endif
endif

end function

!==========================================================================
subroutine set_it_ctrl_air_pottemp(key, value)
!==========================================================================

!THIS SUB SETS CONTROL PARAMETERS FOR THE NEWTON ITERATION USED TO COMPUTE
!POTENTIAL TEMPERATURE FROM REFERENCE PRESSURE

!KEY             VALUE
!IT_STEPS        0           SET ITERATION NUMBER TO DEFAULT (100)
!IT_STEPS        N > 0       SET ITERATION NUMBER TO N
!IT_STEPS       -1           DO NOT ITERATE, USE INITIAL VALUE

!INIT_THETA      0           USE DEFAULT POTENTIAL TEMPERATURE THETA = IDEAL-GAS APPROXIMATION
!INIT_THETA      T > 0       USE VALUE T AS POTENTIAL TEMPERATURE TO START

!TOL_THETA       0           USE DEFAULT EXIT ACCURACY FOR POTENTIAL TEMPERATURE (0.1 MK)
!TOL_THETA       EPS > 0     USE EPS AS EXIT ACCURACY FOR POTENTIAL TEMPERATURE

real*8 value
character*13 key

call init_it_ctrl_pottemp

select case (trim(key))

  case ("it_steps");              !ITERATION STEPS
    if(value == 0d0) then
      ctrl_loop_maximum = 100     !DEFAULT = 100
    elseif(value < 0d0) then
      ctrl_loop_maximum = -1
    else   
      ctrl_loop_maximum = nint(value)
    endif

  case ("init_theta");            !START THETA
    if(value == 0d0) then
      ctrl_mode_pottemp = 0       !DEFAULT: IDEAL-GAS APPROXIMATION
    elseif(value > 0d0) then
      ctrl_mode_pottemp = 1
      ctrl_init_pottemp = value
    endif

  case ("tol_theta");             !REQUIRED THETA TOLERANCE
    if(value == 0d0) then
      ctrl_eps_exit_pottemp = 0.0001d0 !DEFAULT = 0.1 MK
    elseif(value > 0d0) then
      ctrl_eps_exit_pottemp = value
    endif

  case default;write(*,*)key, " not supported"
end select

end subroutine

!==========================================================================
function aux_temperature_si(a_si, eta_si, p_si)
!==========================================================================

!THIS FUNCTION COMPUTES AN IDEAL-GAS APPROX. OF ABSOLUTE (POTENTIAL) TEMPERATURE OF HUMID AIR
!FROM THE MASS FRACTION OF AIR, SPECIFIC ENTROPY AND (REFERENCE) PRESSURE
                                    
!OUTPUT:
!T(A,ETA,P) IDEAL-GAS APPROX. OF TEMPERATURE OF HUMID AIR IN K

!INPUT:
!A_SI       MASS FRACTION OF DRY AIR IN KG/KG
!ETA_SI     SPECIFIC ENTROPY IN J/(KG K)
!P_SI       ABSOLUTE (REFERENCE) PRESSURE IN PA

real*8 aux_temperature_si, a_si, eta_si, p_si
real*8 tt, pt, ra, rw, cpa, cpv

real*8 etat, rav, xv
real*8 numer, denom

tt = tp_temperature_si
pt = tp_pressure_iapws95_si

ra = gas_constant_air_si ! R / MA
rw = gas_constant_h2o_si ! R / MW

!PROPERTIES AT THE TRIPLE POINT OF WATER
cpa = 1003.69d0  !HEAT CAPACITY OF DRY AIR, IN J/(KG K)
cpv = 1884.352d0 !HEAT CAPACITY OF VAPOUR, IN J/(KG K)

aux_temperature_si = errorreturn
if(a_si < 0d0 .or. a_si > 1d0) return
if(p_si <= 0d0) return

if(a_si == errorreturn) return
if(eta_si == errorreturn) return
if(p_si == errorreturn) return

etat = air_g_entropy_si(a_si, tt, pt)  !ENTROPY OF HUMID AIR AT THE TRIPLE POINT
if(etat == errorreturn) return
rav = a_si * ra + (1d0 - a_si) * rw    !GAS CONSTANT OF HUMID AIR
xv = air_molfraction_vap_si(a_si)
if(xv == errorreturn) return
if(xv < 0d0 .or. xv > 1d0) return

denom = a_si * (cpa + ra) + (1d0 - a_si) * (cpv + rw)
if(denom == 0d0) return

numer = eta_si - etat + rav * log(p_si / pt)
aux_temperature_si = tt * exp(numer / denom)

end function

end module air_3c

module flu_if97_5

!#########################################################################

!THIS MODULE IMPLEMENTS THE GIBBS POTENTIALS OF LIQUID WATER AND VAPOUR AND ITS
!FIRST AND SECOND PARTIAL DERIVATIVES WITH RESPECT TO TEMPERATURE AND
!DENSITY AS DEFINED IN IAPWS-IF97 FOR THE REGIONS 1 AND 2:

!REVISED RELEASE ON THE IAPWS INDUSTRIAL FORMULATION 1997
!FOR THE THERMODYNAMIC PROPERTIES OF WATER AND STEAM
!(THE REVISION ONLY RELATES TO THE EXTENSION OF REGION 5 TO 50 MPA)
!THE INTERNATIONAL ASSOCIATION FOR THE PROPERTIES OF WATER AND STEAM
!LUCERNE , SWITZERLAND, AUGUST 2007

!#########################################################################

!IMPLEMENTATION IN FORTRAN BY D.G. WRIGHT
!FOR PUBLICATION IN OCEAN SCIENCE, AS DESCRIBED IN THE PAPERS

!FEISTEL, R., WRIGHT, D.G., JACKETT, D.R., MIYAGAWA, K., REISSMANN, J.H.,
!WAGNER, W., OVERHOFF, U., GUDER, C., FEISTEL, A., MARION, G.M.:
!NUMERICAL IMPLEMENTATION AND OCEANOGRAPHIC APPLICATION OF THE THERMODYNAMIC
!POTENTIALS OF WATER, VAPOUR, ICE, SEAWATER AND AIR. PART I: BACKGROUND AND EQUATIONS. 
!OCEAN SCIENCES, 2009, IN PREPARATION.

!WRIGHT, D.G., FEISTEL, R., JACKETT, D.R., MIYAGAWA, K., REISSMANN, J.H., 
!WAGNER, W., OVERHOFF, U., GUDER, C., FEISTEL, A., MARION, G.M.:
!NUMERICAL IMPLEMENTATION AND OCEANOGRAPHIC APPLICATION OF THE THERMODYNAMIC
!POTENTIALS OF WATER, VAPOUR, ICE, SEAWATER AND AIR. PART II: THE LIBRARY ROUTINES, 
!OCEAN SCIENCES., 2009, IN PREPARATION.

!FEISTEL, R., KRETZSCHMAR, H.-J., SPAN, R., HAGEN, E., WRIGHT, D.G., JACKETT, D.R.:
!THERMODYNAMIC PROPERTIES OF SEA AIR.
!OCEAN SCIENCE DISCUSSION 6(2009)2193-2325.

!#########################################################################

!THIS MODULE REQUIRES THE LIBRARY MODULE
!     CONSTANTS_0, FILE CONSTANTS_0.F90

!#########################################################################

use constants_0

implicit none
private

character*16, private :: version = '8 Jun 2010'

public :: chk_iapws97_table, fit_liq_density_if97_si,  fit_liq_g_if97_si, &
          fit_vap_density_if97_si, fit_vap_g_if97_si

!COEFFICIENTS OF REGION 1
integer, private :: i1i(34), j1i(34)
!COEFFICIENTS OF REGION 2, IDEAL PART
integer, private :: j0i(9), iri(43), jri(43)
!COEFFICIENTS OF REGION 2, RESIDUAL PART
real*8,  private :: n0i(9), n1i(34), nri(43)

contains

!=========================================================================
function fit_liq_g_if97_si(drv_t, drv_p, t_si, p_si)
!=========================================================================

!THIS FUNCTION RETURNS THE GIBBS FUNCTION G(T,P) AND ITS 1ST AND 2ND DERIVATIVES
!WITH RESPECT TO TEMPERATURE AND PRESSURE, AS DEFINED FOR THE REGION 1 (LIQUID) IN IAPWS-IF97

!OUTPUT: 
!FIT_LIQ_G_IF97_SI: SPECIFIC GIBBS ENERGY IN J/KG OR ITS T-P DERIVATIVE

!INPUT:  
!DRV_T: ORDER OF THE TEMPERATURE DERIVATIVE (0-2)
!DRV_P: ORDER OF THE PRESSURE DERIVATIVE (0-2)
!T_SI:  ABSOLUTE TEMPERATURE IN K
!P_SI:  ABSOLUTE PRESSURE IN PA

implicit none
                          
integer drv_t, drv_p
real*8 fit_liq_g_if97_si
real*8 t_si, p_si
real*8 g, g_t, g_tt
real*8 g_p, g_tp, g_pp
real*8 psi, tau, rt
real*8 tu, pu, r

tu = 1386d0
pu = 16530000d0
r = 461.526d0       !J KG-1 K-1  SPECIFIC GAS CONSTANT
                    !NOTE THIS DEVIATES FROM GAS_CONSTANT_H2O_SI = 461.51805

fit_liq_g_if97_si = errorreturn

if(t_si <= 0d0) return
if(p_si <= 0d0) return

call init_if97_1

psi = p_si / pu
tau = tu / t_si
rt = r * t_si

select case (drv_t)

  case (0)
    select case (drv_p)

      case (0); g = gamma_1(0, 0, tau, psi)
         if(g == errorreturn) return
         fit_liq_g_if97_si = rt * g

      case (1); g_p = gamma_1(0, 1, tau, psi)
         if(g_p == errorreturn) return
         fit_liq_g_if97_si = rt * g_p / pu

      case (2); g_pp = gamma_1(0, 2, tau, psi)
         if(g_pp == errorreturn) return
         fit_liq_g_if97_si = rt * g_pp / pu ** 2

      case default; return
    end select

  case (1)
    select case (drv_p)

      case (0)
         g = gamma_1(0, 0, tau, psi)
         if(g == errorreturn) return
         g_t = gamma_1(1, 0, tau, psi)
         if(g_t == errorreturn) return
         fit_liq_g_if97_si = r * (g - tau * g_t)

      case (1) 
         g_p = gamma_1(0, 1, tau, psi)
         if(g_p == errorreturn) return
         g_tp = gamma_1(1, 1, tau, psi)
         if(g_tp == errorreturn) return
         fit_liq_g_if97_si = r * (g_p - tau * g_tp) / pu

      case default; return
    end select

  case (2)
    select case (drv_p)

      case (0) 
         g_tt = gamma_1(2, 0, tau, psi)
         if(g_tt == errorreturn) return
         fit_liq_g_if97_si = r * tau ** 2 * g_tt / t_si

      case default; return
    end select

  case default; return
end select

end function

!=========================================================================
function fit_vap_g_if97_si(drv_t, drv_p, t_si, p_si)
!=========================================================================

!THIS FUNCTION RETURNS THE GIBBS FUNCTION G(T,P) AND ITS 1ST AND 2ND DERIVATIVES
!WITH RESPECT TO TEMPERATURE AND PRESSURE, AS DEFINED FOR THE REGION 2 (VAPOUR) IN IAPWS-IF97

!OUTPUT: 
!FIT_VAP_G_IF97_SI: SPECIFIC GIBBS ENERGY IN J/KG OR ITS T-P DERIVATIVE

!INPUT:  
!DRV_T: ORDER OF THE TEMPERATURE DERIVATIVE (0-2)
!ORDER OF THE PRESSURE DERIVATIVE (0-2)
!T_SI:  ABSOLUTE TEMPERATURE IN K
!P_SI:  ABSOLUTE PRESSURE IN PA

implicit none
                          
integer drv_t, drv_p
real*8 fit_vap_g_if97_si
real*8 t_si, p_si
real*8 g, g_t, g_tt
real*8 g_p, g_tp, g_pp
real*8 psi, tau, rt
real*8 tu, pu, r

tu = 540d0
pu = 1000000d0
r = 461.526d0       !J KG-1 K-1  SPECIFIC GAS CONSTANT
                    !NOTE THIS DEVIATES FROM GAS_CONSTANT_H2O_Si = 461.51805

fit_vap_g_if97_si = errorreturn

if(t_si <= 0d0) return
if(p_si <= 0d0) return

call init_if97_2

psi = p_si / pu
tau = tu / t_si
rt = r * t_si

select case (drv_t)

  case (0)
    select case (drv_p)

      case (0) 
         g = gamma_2(0, 0, tau, psi)
         if(g == errorreturn) return
         fit_vap_g_if97_si = rt * g

      case (1) 
         g_p = gamma_2(0, 1, tau, psi)
         if(g_p == errorreturn) return
         fit_vap_g_if97_si = rt * g_p / pu

      case (2) 
         g_pp = gamma_2(0, 2, tau, psi)
         if(g_pp == errorreturn) return
         fit_vap_g_if97_si = rt * g_pp / pu ** 2

      case default; return
    end select

  case (1)
    select case (drv_p)

      case (0) 
         g = gamma_2(0, 0, tau, psi)
         if(g == errorreturn) return
         g_t = gamma_2(1, 0, tau, psi)
         if(g_t == errorreturn) return
         fit_vap_g_if97_si = r * (g - tau * g_t)

      case (1) 
         g_p = gamma_2(0, 1, tau, psi)
         if(g_p == errorreturn) return
         g_tp = gamma_2(1, 1, tau, psi)
         if(g_tp == errorreturn) return
         fit_vap_g_if97_si = r * (g_p - tau * g_tp) / pu

      case default; return
    end select

  case (2)
    select case (drv_p)

      case (0) 
         g_tt = gamma_2(2, 0, tau, psi)
         if(g_tt == errorreturn) return
         fit_vap_g_if97_si = r * tau ** 2 * g_tt / t_si

      case default; return
    end select

  case default; return
end select

end function

!=========================================================================
function fit_liq_density_if97_si(t_si, p_si)
!=========================================================================

!THIS FUNCTION RETURNS THE DENSITY OF LIQUID WATER AS A FUNCTION OF TEMPERATURE
!AND PRESSURE, IN THE REGION 1 (LIQUID) IN IAPWS-IF97

!OUTPUT:  
!FIT_LIQ_DENSITY_IF97_SI: DENSITY IN KG/M3

!INPUT:   
!T_SI: ABSOLUTE TEMPERATURE IN K
!P_SI: ABSOLUTE PRESSURE IN PA

implicit none

real*8 fit_liq_density_if97_si
real*8 t_si, p_si
real*8 d

fit_liq_density_if97_si = errorreturn

if(t_si <= 0d0) return
if(p_si <= 0d0) return

d = fit_liq_g_if97_si(0, 1, t_si, p_si)

if(d == errorreturn) return
if(d <= 0d0) return

fit_liq_density_if97_si = 1d0 / d

end function

!=========================================================================
function fit_vap_density_if97_si(t_si, p_si)
!=========================================================================

!THIS FUNCTION RETURNS THE DENSITY OF LIQUID WATER AS A FUNCTION OF TEMPERATURE
!AND PRESSURE, IN THE REGION 2 (VAPOUR) IN IAPWS-IF97

!OUTPUT:  
!FIT_VAP_DENSITY_IF97_SI: DENSITY IN KG/M3

!INPUT:   
!T_SI: ABSOLUTE TEMPERATURE IN K
!P_SI: ABSOLUTE PRESSURE IN PA

implicit none

real*8 fit_vap_density_if97_si
real*8 t_si, p_si
real*8 d

fit_vap_density_if97_si = errorreturn

if(t_si <= 0d0) return
if(p_si <= 0d0) return

d = fit_vap_g_if97_si(0, 1, t_si, p_si)

if(d == errorreturn) return
if(d <= 0d0) return

fit_vap_density_if97_si = 1d0 / d

end function

!=========================================================================
function gamma_0(drv_t, drv_p, tau, psi)
!=========================================================================

!THIS FUNCTION IMPLEMENTS THE DERIVATIVES OF GAMMA_0 AS GIVEN IN TABLE 13 OF IF-97

implicit none

integer i, k, drv_t, drv_p
real*8 tau, psi
real*8 gamma_0
real*8 g, pwrt

gamma_0 = errorreturn

if(psi <= 0d0) return
if(tau <= 0d0) return
if(drv_t < 0) return
if(drv_p < 0) return

g = 0d0
if(drv_t == 0) then
  if(drv_p == 0) then
    g = log(psi)
  else
    g = 1d0 / psi
    do k = 2, drv_p
      g = dfloat(1 - k) * g / psi
    enddo
  end if
end if

if(drv_p == 0) then
  do i = 1, 9
    pwrt = tau ** (j0i(i) - drv_t)
    do k = 0, drv_t - 1
      pwrt = pwrt * dfloat(j0i(i) - k)
    enddo
    g = g + n0i(i) * pwrt
  enddo
end if

gamma_0 = g

end function

!=========================================================================
function gamma_1(drv_t, drv_p, tau, psi)
!=========================================================================

!THIS FUNCTION IMPLEMENTS THE DERIVATIVES OF GAMMA AS GIVEN IN TABLE 4 OF IF-97

implicit none

integer drv_t, drv_p
integer i, k
real*8 tau, psi
real*8 gamma_1
real*8 g, pp, tt
real*8 pwrt, pwrp

gamma_1 = errorreturn

if(psi <= 0d0) return
if(tau <= 0d0) return
if(drv_t < 0) return
if(drv_p < 0) return

pp = 7.1d0 - psi
tt = tau - 1.222d0

g = 0d0
do i = 1, 34

  if(tt == 0d0) then
    if(j1i(i) == drv_t) then
       pwrt = 1d0
    elseif(j1i(i) > drv_t) then
       pwrt = 0d0
    else
       return
    endif
  else
    pwrt = tt ** (j1i(i) - drv_t)
  end if
  do k = 0, drv_t - 1
    pwrt = pwrt * dfloat(j1i(i) - k)
  enddo

  if(pp == 0d0) then
    if(i1i(i) == drv_p) then
       pwrp = 1d0
    elseif(i1i(i) > drv_p) then
       pwrp = 0d0
    else
       return
    endif
  else
    pwrp = pp ** (i1i(i) - drv_p)
  end if
  do k = 0, drv_p - 1
    pwrp = -pwrp * dfloat(i1i(i) - k)
  enddo

  g = g + n1i(i) * pwrp * pwrt

enddo

gamma_1 = g

end function

!=========================================================================
function gamma_2(drv_t, drv_p, tau, psi)
!=========================================================================

!THIS FUNCTION IMPLEMENTS THE DERIVATIVES OF GAMMA AS GIVEN IN EQ. 15 OF IF-97

implicit none

integer drv_t, drv_p
real*8 tau, psi
real*8 gamma_2
real*8 g0, gr

call init_if97_2

gamma_2 = errorreturn

g0 = gamma_0(drv_t, drv_p, tau, psi)
if(g0 == errorreturn) return

gr = gamma_r(drv_t, drv_p, tau, psi)
if(gr == errorreturn) return

gamma_2 = g0 + gr

end function

!=========================================================================
function gamma_r(drv_t, drv_p, tau, psi)
!=========================================================================
                         
!THIS FUNCTION IMPLEMENTS THE DERIVATIVES OF GAMMA_R AS GIVEN IN TABLE 14 OF IF-97

implicit none

integer drv_t, drv_p
integer i, k
real*8 gamma_r
real*8 tau, psi
real*8 g, tt
real*8 pwrt, pwrp

gamma_r = errorreturn

if(psi <= 0d0) return
if(tau <= 0d0) return
if(drv_t < 0) return
if(drv_p < 0) return

tt = tau - 0.5d0

g = 0d0
do i = 1, 43

  if(tt == 0d0) then
    if(jri(i) == drv_t) then
       pwrt = 1d0
    elseif(jri(i) > drv_t) then
       pwrt = 0d0
    else
       return
    endif
  else
    pwrt = tt ** (jri(i) - drv_t)
  end if
  do k = 0, drv_t - 1
    pwrt = pwrt * dfloat(jri(i) - k)
  enddo

  pwrp = psi ** (iri(i) - drv_p)
  do k = 0, drv_p - 1
    pwrp = pwrp * dfloat(iri(i) - k)
  enddo

  g = g + nri(i) * pwrp * pwrt

enddo

gamma_r = g

end function

!=========================================================================
subroutine init_if97_1
!=========================================================================

implicit none
integer i

if(n1i(1) == 0.14632971213167d0) return

!TABLE-2. NUMERICAL VALUES OF THE COEFFICIENTS AND EXPONENTS OF THE DIMENSIONLESS GIBBS FREE ENERGY
!FOR REGION 1, EQ. (7)
!I II JI NI I II JI NI
i = 1; i1i(i)  = 0;  j1i(i) = -2;  n1i(i) = 0.14632971213167d0
i = 2; i1i(i)  = 0;  j1i(i) = -1;  n1i(i) = -0.84548187169114d0
i = 3; i1i(i)  = 0;  j1i(i) = 0;   n1i(i) = -3.756360367204d0
i = 4; i1i(i)  = 0;  j1i(i) = 1;   n1i(i) = 3.3855169168385d0
i = 5; i1i(i)  = 0;  j1i(i) = 2;   n1i(i) = -0.95791963387872d0
i = 6; i1i(i)  = 0;  j1i(i) = 3;   n1i(i) = 0.15772038513228d0
i = 7; i1i(i)  = 0;  j1i(i) = 4;   n1i(i) = -0.016616417199501d0
i = 8; i1i(i)  = 0;  j1i(i) = 5;   n1i(i) = 8.1214629983568d-04
i = 9; i1i(i)  = 1;  j1i(i) = -9;  n1i(i) = 2.8319080123804d-04
i = 10; i1i(i) = 1;  j1i(i) = -7;  n1i(i) = -6.0706301565874d-04
i = 11; i1i(i) = 1;  j1i(i) = -1;  n1i(i) = -0.018990068218419d0
i = 12; i1i(i) = 1;  j1i(i) = 0;   n1i(i) = -0.032529748770505d0
i = 13; i1i(i) = 1;  j1i(i) = 1;   n1i(i) = -0.021841717175414d0
i = 14; i1i(i) = 1;  j1i(i) = 3;   n1i(i) = -5.283835796993d-05  
i = 15; i1i(i) = 2;  j1i(i) = -3;  n1i(i) = -4.7184321073267d-04
i = 16; i1i(i) = 2;  j1i(i) = 0;   n1i(i) = -3.0001780793026d-04
i = 17; i1i(i) = 2;  j1i(i) = 1;   n1i(i) = 4.7661393906987d-05
i = 18; i1i(i) = 2;  j1i(i) = 3;   n1i(i) = -4.4141845330846d-06
i = 19; i1i(i) = 2;  j1i(i) = 17;  n1i(i) = -7.2694996297594d-16
i = 20; i1i(i) = 3;  j1i(i) = -4;  n1i(i) = -3.1679644845054d-05
i = 21; i1i(i) = 3;  j1i(i) = 0;   n1i(i) = -2.8270797985312d-06
i = 22; i1i(i) = 3;  j1i(i) = 6;   n1i(i) = -8.5205128120103d-10
i = 23; i1i(i) = 4;  j1i(i) = -5;  n1i(i) = -2.2425281908d-06
i = 24; i1i(i) = 4;  j1i(i) = -2;  n1i(i) = -6.5171222895601d-07
i = 25; i1i(i) = 4;  j1i(i) = 10;  n1i(i) = -1.4341729937924d-13
i = 26; i1i(i) = 5;  j1i(i) = -8;  n1i(i) = -4.0516996860117d-07
i = 27; i1i(i) = 8;  j1i(i) = -11; n1i(i) = -1.2734301741641d-09
i = 28; i1i(i) = 8;  j1i(i) = -6;  n1i(i) = -1.7424871230634d-10
i = 29; i1i(i) = 21; j1i(i) = -29; n1i(i) = -6.8762131295531d-19
i = 30; i1i(i) = 23; j1i(i) = -31; n1i(i) = 1.4478307828521d-20
i = 31; i1i(i) = 29; j1i(i) = -38; n1i(i) = 2.6335781662795d-23
i = 32; i1i(i) = 30; j1i(i) = -39; n1i(i) = -1.1947622640071d-23
i = 33; i1i(i) = 31; j1i(i) = -40; n1i(i) = 1.8228094581404d-24
i = 34; i1i(i) = 32; j1i(i) = -41; n1i(i) = -9.3537087292458d-26

end subroutine

!=========================================================================
subroutine init_if97_2
!=========================================================================

implicit none
integer i

if(n0i(1) == -9.6927686500217d0) return

!TABLE 10. NUMERICAL VALUES OF THE COEFFICIENTS AND EXPONENTS OF THE IDEAL-GAS PART GAMMA_0 OF THE
!DIMENSIONLESS GIBBS FREE ENERGY FOR REGION 2, EQ. (16)
!I JI NI I JI NI
i = 1; j0i(i) = 0;  n0i(i) = -9.6927686500217d0
i = 2; j0i(i) = 1;  n0i(i) = 10.086655968018d0
i = 3; j0i(i) = -5; n0i(i) = -0.005608791128302d0
i = 4; j0i(i) = -4; n0i(i) = 0.071452738081455d0
i = 5; j0i(i) = -3; n0i(i) = -0.40710498223928d0
i = 6; j0i(i) = -2; n0i(i) = 1.4240819171444d0
i = 7; j0i(i) = -1; n0i(i) = -4.383951131945d0
i = 8; j0i(i) = 2;  n0i(i) = -0.28408632460772d0
i = 9; j0i(i) = 3;  n0i(i) = 0.021268463753307d0
!IF(EQ. (16) IS INCORPORATED INTO EQ. (18), INSTEAD OF THE-VALUES FOR N0I(1) AND N0I(1)
!GIVEN ABOVE, THE FOLLOWING VALUES
!N0I(1) = -0.96937268393049D1
!N0I(2) = 0.10087275970006D2
!SHOULD BE USED


!TABLE 11. NUMERICAL VALUES OF THE COEFFICIENTS AND EXPONENTS OF THE
!RESIDUAL PART GAMMA_R OF THE DIMENSIONLESS GIBBS FREE ENERGY FOR
!REGION 2, EQ. (17)
!I II JI NI
i = 1;  iri(i) = 1;  jri(i) = 0;  nri(i) = -1.7731742473213d-03
i = 2;  iri(i) = 1;  jri(i) = 1;  nri(i) = -0.017834862292358d0
i = 3;  iri(i) = 1;  jri(i) = 2;  nri(i) = -0.045996013696365d0
i = 4;  iri(i) = 1;  jri(i) = 3;  nri(i) = -0.057581259083432d0
i = 5;  iri(i) = 1;  jri(i) = 6;  nri(i) = -0.05032527872793d0
i = 6;  iri(i) = 2;  jri(i) = 1;  nri(i) = -3.3032641670203d-05
i = 7;  iri(i) = 2;  jri(i) = 2;  nri(i) = -1.8948987516315d-04
i = 8;  iri(i) = 2;  jri(i) = 4;  nri(i) = -3.9392777243355d-03
i = 9;  iri(i) = 2;  jri(i) = 7;  nri(i) = -0.043797295650573d0
i = 10; iri(i) = 2;  jri(i) = 36; nri(i) = -2.6674547914087d-05
i = 11; iri(i) = 3;  jri(i) = 0;  nri(i) = 2.0481737692309d-08
i = 12; iri(i) = 3;  jri(i) = 1;  nri(i) = 4.3870667284435d-07
i = 13; iri(i) = 3;  jri(i) = 3;  nri(i) = -3.227767723857d-05
i = 14; iri(i) = 3;  jri(i) = 6;  nri(i) = -1.5033924542148d-03
i = 15; iri(i) = 3;  jri(i) = 35; nri(i) = -0.040668253562649d0
i = 16; iri(i) = 4;  jri(i) = 1;  nri(i) = -7.8847309559367d-10
i = 17; iri(i) = 4;  jri(i) = 2;  nri(i) = 1.2790717852285d-08
i = 18; iri(i) = 4;  jri(i) = 3;  nri(i) = 4.8225372718507d-07
i = 19; iri(i) = 5;  jri(i) = 7;  nri(i) = 2.2922076337661d-06
i = 20; iri(i) = 6;  jri(i) = 3;  nri(i) = -1.6714766451061d-11
i = 21; iri(i) = 6;  jri(i) = 16; nri(i) = -2.1171472321355d-03
i = 22; iri(i) = 6;  jri(i) = 35; nri(i) = -23.895741934104d0
i = 23; iri(i) = 7;  jri(i) = 0;  nri(i) = -5.905956432427d-18
i = 24; iri(i) = 7;  jri(i) = 11; nri(i) = -1.2621808899101d-06
i = 25; iri(i) = 7;  jri(i) = 25; nri(i) = -0.038946842435739d0
i = 26; iri(i) = 8;  jri(i) = 8;  nri(i) = 1.1256211360459d-11
i = 27; iri(i) = 8;  jri(i) = 36; nri(i) = -8.2311340897998d0
i = 28; iri(i) = 9;  jri(i) = 13; nri(i) = 1.9809712802088d-08
i = 29; iri(i) = 10; jri(i) = 4;  nri(i) = 1.0406965210174d-19
i = 30; iri(i) = 10; jri(i) = 10; nri(i) = -1.0234747095929d-13
i = 31; iri(i) = 10; jri(i) = 14; nri(i) = -1.0018179379511d-09
i = 32; iri(i) = 16; jri(i) = 29; nri(i) = -8.0882908646985d-11
i = 33; iri(i) = 16; jri(i) = 50; nri(i) = 0.10693031879409d0
i = 34; iri(i) = 18; jri(i) = 57; nri(i) = -0.33662250574171d0
i = 35; iri(i) = 20; jri(i) = 20; nri(i) = 8.9185845355421d-25
i = 36; iri(i) = 20; jri(i) = 35; nri(i) = 3.0629316876232d-13
i = 37; iri(i) = 20; jri(i) = 48; nri(i) = -4.2002467698208d-06
i = 38; iri(i) = 21; jri(i) = 21; nri(i) = -5.9056029685639d-26
i = 39; iri(i) = 22; jri(i) = 53; nri(i) = 3.7826947613457d-06
i = 40; iri(i) = 23; jri(i) = 39; nri(i) = -1.2768608934681d-15
i = 41; iri(i) = 24; jri(i) = 26; nri(i) = 7.3087610595061d-29
i = 42; iri(i) = 24; jri(i) = 40; nri(i) = 5.5414715350778d-17
i = 43; iri(i) = 24; jri(i) = 58; nri(i) = -9.436970724121d-07

end subroutine

!=========================================================================
subroutine chk_iapws97_table(number)
!=========================================================================

!THIS FUNCTION RETURNS SELECTED CHECK TABLES OF IAPWS-IF97
!IN COMPARISON TO VALUES COMPUTED FROM THIS MODULE
!AS A FORMATTED STRING, TO BE PRINTED INTO A WINDOW OR FILE,
!FOR EASY VERIFICATION OF THIS IMPLEMENTATION ON A GIVEN PLATFORM
!
!IAPWS-IF97:
!REVISED RELEASE ON THE IAPWS INDUSTRIAL FORMULATION 1997
!FOR THE THERMODYNAMIC PROPERTIES OF WATER AND STEAM
!(THE REVISION ONLY RELATES TO THE EXTENSION OF REGION 5 TO 50 MPA)
!THE INTERNATIONAL ASSOCIATION FOR THE PROPERTIES OF WATER AND STEAM
!LUCERNE, SWITZERLAND, AUGUST 2007
!AVAILABLE AT: HTTP://WWW.IAPWS.ORG

implicit none
integer number

if(number == 5) then
   call chk_iapws97_table5
elseif(number == 15) then
   call chk_iapws97_table15
else
   write(*,*)"ERROR: 5 AND 15 ARE THE ONLY LEGAL TABLE NUMBERS FOR IF15"
endif

return
end subroutine

!=========================================================================
subroutine chk_iapws97_table5
!=========================================================================

!IAPWS-IF97 CHECK TABLE:
!REVISED RELEASE ON THE IAPWS INDUSTRIAL FORMULATION 1997
!FOR THE THERMODYNAMIC PROPERTIES OF WATER AND STEAM
!(THE REVISION ONLY RELATES TO THE EXTENSION OF REGION 5 TO 50 MPA)
!THE INTERNATIONAL ASSOCIATION FOR THE PROPERTIES OF WATER AND STEAM
!LUCERNE , SWITZERLAND, AUGUST 2007
!AVAILABLE AT: HTTP://WWW.IAPWS.ORG

!TABLE 5. THERMODYNAMIC PROPERTY VALUES CALCULATED FROM EQ. (7) FOR SELECTED VALUES OF T AND P
!                  T = 300 K,              T = 300 K,          T = 500 K,
!                  P = 3 MPA               P = 80 MPA          P = 3 MPA
!V  / (M3/KG)      0.100 215 168 E-2       0.971 180 894 E-3   0.120 241 800 E-2
!H  / (KJ/KG)      0.115 331 273 E3        0.184 142 828 E3    0.975 542 239 E3
!U  / (KJ/KG)      0.112 324 818 E3        0.106 448 356 E3    0.971 934 985 E3
!S  / (KJ/KG/K)    0.392 294 792           0.368 563 852       0.258 041 912 E1
!CP / (KJ/KG/K)    0.417 301 218 E1        0.401 008 987 E1    0.465 580 682 E1
!W  / (M/S)        0.150 773 921 E4        0.163 469 054 E4    0.124 071 337 E4

implicit none
integer i, j
real*8 p, t, d(3)
real*8 g(3), g_t(3), g_tt(3), g_tp(3), g_p(3), g_pp(3)
real*8 chooset(3), choosep(3)

                                            
write(*,*) " "
write(*,*) " "
write(*,*) " "
write(*,*) "****************************************************************"
write(*,*) "****************************************************************"
write(*,*) "****************************************************************"
write(*,*) " "
write(*,*) "IMPLEMENTATION OF IAPWS-IF97 IN FORTRAN"
write(*,*) "FOR PUBLICATION IN OCEAN SCIENCE, 2009"
write(*,*) "D. WRIGHT, BIO, VERSION ", version
write(*,*) " "

write(*,*) "FUNCTION VALUES AS GIVEN IN TABLE 5 OF IF-97:"
write(*,*) "TABLE 5. THERMODYNAMIC PROPERTY VALUES CALCULATED FROM EQ. (7)"
write(*,*) "FOR SELECTED VALUES OF T AND P"
write(*,*) " "

write(*,*) "               T = 300 K           T = 300 K           T = 500 K"
write(*,*) "               P = 3 MPA           P = 80 MPA          P = 3 MPA"

chooset(1) = 300d0
chooset(2) = 300d0
chooset(3) = 500d0
choosep(1) = 3d0
choosep(2) = 80d0
choosep(3) = 3d0

do i = 1, 6
  write(*,*)' '
  select case (i)
    case (1);  write(*,*) "v/(M3/KG)      0.100215168e-2      0.971180894e-3      0.120241800e-2"
    case (2);  write(*,*) "h/(KJ/KG)      0.115331273e3       0.184142828e3       0.975542239e3"
    case (3);  write(*,*) "u/(KJ/KG)      0.112324818e3       0.106448356e3       0.971934985e3"
    case (4);  write(*,*) "s/(KJ/KG/K)    0.392294792         0.368563852         0.258041912e1"
    case (5);  write(*,*) "cp/(KJ/KG/K)   0.417301218e1       0.401008987e1       0.465580682e1"
    case (6);  write(*,*) "w/(M/S)        0.150773921e4       0.163469054e4       0.124071337e4"
  end select
  
  do j = 1, 3
    !GET TEMPERATURE AND PRESSURE INPUT
    t = chooset(j)
    p = choosep(j) * 1d6

    g(j)    = fit_liq_g_if97_si(0, 0, t, p)
    g_t(j)  = fit_liq_g_if97_si(1, 0, t, p)
    g_p(j)  = fit_liq_g_if97_si(0, 1, t, p)
    g_tt(j) = fit_liq_g_if97_si(2, 0, t, p)
    g_tp(j) = fit_liq_g_if97_si(1, 1, t, p)
    g_pp(j) = fit_liq_g_if97_si(0, 2, t, p)

  enddo

  select case (i)
    case (1);  do j = 1,3; d(j) = g_p(j); enddo
    case (2);  do j = 1,3; d(j) = 0.001d0 * (g(j) - chooset(j) * g_t(j)); enddo
    case (3);  do j = 1,3; d(j) = 0.001d0 * (g(j) - chooset(j) * g_t(j) - 1d6 * choosep(j) * g_p(j)); enddo
    case (4);  do j = 1,3; d(j) = -0.001d0 * g_t(j); enddo
    case (5);  do j = 1,3; d(j) = -0.001d0 * chooset(j) * g_tt(j); enddo
    case (6)  
      do j = 1,3
        d(j) = g_tp(j) * g_tp(j) - g_tt(j) * g_pp(j)
        if(d (j) /= 0d0) then
          d(j) = g_tt(j) / d(j)
          if(d(j) >= 0d0) then
            d(j) = g_p(j) * sqrt(d(j))
          else
            d(j) = errorreturn
          end if
        else
          d(j) = errorreturn
        end if
      enddo
  end select

  write(*,"('COMPUTED NOW:'2x,e16.9,x,e19.9,x,e19.9)") d(1),d(2),d(3)

enddo

end subroutine

!=========================================================================
subroutine chk_iapws97_table15
!=========================================================================

!IAPWS-IF97 CHECK TABLE:
!REVISED RELEASE ON THE IAPWS INDUSTRIAL FORMULATION 1997
!FOR THE THERMODYNAMIC PROPERTIES OF WATER AND STEAM
!(THE REVISION ONLY RELATES TO THE EXTENSION OF REGION 5 TO 50 MPA)
!THE INTERNATIONAL ASSOCIATION FOR THE PROPERTIES OF WATER AND STEAM
!LUCERNE , SWITZERLAND, AUGUST 2007
!AVAILABLE AT: HTTP://WWW.IAPWS.ORG

!TABLE 15. THERMODYNAMIC PROPERTY VALUES CALCULATED FROM EQ. (15) FOR SELECTED VALUES OF T AND P A
!                      T = 300 K,       T = 700 K,       T = 700 K
!                      P = 0.0035 MPA   P = 0.0035 MPA   P = 30 MPA
!V  / (M3/KG)          0.394 913 866 E2 0.923 015 898 E2 0.542 946 619 E-2
!H  / (KJ/KG)          0.254 991 145 E4 0.333 568 375 E4 0.263 149 474 E4
!U  / (KJ/KG)          0.241 169 160 E4 0.301 262 819 E4 0.246 861 076 E4
!S  / (KJ/KG/K)        0.852 238 967 E1 0.101 749 996 E2 0.517 540 298 E1
!CP / (KJ/KG/K)        0.191 300 162 E1 0.208 141 274 E1 0.103 505 092 E2
!W  / (M/S)            0.427 920 172 E3 0.644 289 068 E3 0.480 386 523 E3

implicit none
integer i, j
real*8 t, p, d(3)
real*8 g(3), g_t(3), g_tt(3), g_tp(3), g_p(3), g_pp(3)
real*8 chooset(3), choosep(3)


                                            
write(*,*) " "
write(*,*) " "
write(*,*) " "
write(*,*) "****************************************************************"
write(*,*) "****************************************************************"
write(*,*) "****************************************************************"
write(*,*) " "
write(*,*) "IMPLEMENTATION OF IAPWS-IF97 IN FORTRAN"
write(*,*) "FOR PUBLICATION IN OCEAN SCIENCE, 2009"
write(*,*) "D. WRIGHT, BIO, VERSION ", version
write(*,*) " "

write(*,*) "FUNCTION VALUES AS GIVEN IN TABLE 15 OF IF-97:"
write(*,*) "TABLE 15. THERMODYNAMIC PROPERTY VALUES CALCULATED FROM EQ. (15)"
write(*,*) "FOR SELECTED VALUES OF T AND P"
write(*,*) " "

write(*,*) "               T = 300 K           T = 700 K           T = 700 K"
write(*,*) "               P = 3500 PA         P = 3500 PA         P = 30 MPA"

chooset(1) = 300d0
chooset(2) = 700d0
chooset(3) = 700d0
choosep(1) = 3500d0
choosep(2) = 3500d0
choosep(3) = 30000000d0

do i = 1, 6

  write(*,*) " "
  select case (i)
    case (1);  write(*,*) "v/(M3/KG)      0.394913866e2       0.923015898e2       0.542946619e-2"
    case (2);  write(*,*) "h/(KJ/KG)      0.254991145e4       0.333568375e4       0.263149474e4"
    case (3);  write(*,*) "u/(KJ/KG)      0.241169160e4       0.301262819e4       0.246861076e4"
    case (4);  write(*,*) "s/(KJ/KG/K)    0.852238967e1       0.101749996e2       0.517540298e1"
    case (5);  write(*,*) "cp/(KJ/KG/K)   0.191300162e1       0.208141274e1       0.103505092e2"
    case (6);  write(*,*) "w/(M/S)        0.427920172e3       0.644289068e3       0.480386523e3"
  end select
  
  do j = 1, 3
    t = chooset(j)
    p = choosep(j)

    g(j)    = fit_vap_g_if97_si(0, 0, t, p)
    g_t(j)  = fit_vap_g_if97_si(1, 0, t, p)
    g_p(j)  = fit_vap_g_if97_si(0, 1, t, p)
    g_tt(j) = fit_vap_g_if97_si(2, 0, t, p)
    g_tp(j) = fit_vap_g_if97_si(1, 1, t, p)
    g_pp(j) = fit_vap_g_if97_si(0, 2, t, p)
  enddo

  select case (i)
    case (1); do j=1,3; d(j) = g_p(j); enddo
    case (2); do j=1,3; d(j) = 0.001d0 * (g(j) - chooset(j) * g_t(j)); enddo
    case (3); do j=1,3; d(j) = 0.001d0 * (g(j) - chooset(j) * g_t(j) - choosep(j) * g_p(j)); enddo
    case (4); do j=1,3; d(j) = -0.001d0 * g_t(j); enddo
    case (5); do j=1,3; d(j) = -0.001d0 * chooset(j) * g_tt(j); enddo
    case (6) 
              do j=1,3 
                 d(j) = g_tp(j) * g_tp(j) - g_tt(j) * g_pp(j)
                 if(d(j) /= 0d0) then
                   d(j) = g_tt(j) / d(j)
                   if(d(j) >= 0d0) then
                     d(j) = g_p(j) * sqrt(d(j))
                   else
                     d(j) = errorreturn
                   end if
                 else
                   d(j) = errorreturn
                 end if
              enddo
  end select

  write(*,"('COMPUTED NOW:'2x,e16.9,x,e19.9,x,e19.9)") d(1),d(2),d(3)

enddo

end subroutine

end module flu_if97_5

!FBL October 2012, University of Toronto

!This f2py interface to the python code is structured the following way:
! 1. a subroutine for each type of inputs (e.g. a_si, t_si, p_si) is created
!    and can be called with the function name and the numerical inputs.
! 2. for each subroutine, there is a companion subroutine with the suffix _desc
!    that serves to communicate with python. It lists the available functions
!    and give a simple description of the outputs with units.
! 3. the numerical inputs are three-dimensional, to minimize calls to the fortran
!    interface when applying a function point-wise on an array. The python bindings
!    make sure that the numerical inputs are broadcast to the right size, making most
!    these functions act like typical numpy functions for arrays with 3 or less 
!    dimensions.

subroutine liq_ice_air_sat(in_name,in_t,in_p, k, l, m, out_val)
    !This subroutine is a wrapper for the Gibbs function formulation for wet air saturation.
    !Available routines:
    !
    ! Liq_Air_4a:
    ! massfraction_air

    use liq_ice_air_5b
    implicit none
    integer :: k, l, m, idk, idl, idm
    real(8) :: in_t(k,l,m), in_p(k,l,m)
    real(8) :: out_val(k,l,m)
    character (len = *) :: in_name

!f2py real(8), intent(out), dimension(k,l,m) :: out_val
!f2py real(8), intent(in), dimension(k,l,m) :: in_t, in_p
!f2py character(len = *), intent(in) :: in_name
!f2py integer, intent(in) :: k,l,m

    do idk=1,k
    do idl=1,l
    do idm=1,m
            select case(in_name)
                case( 'massfraction_air' )
                    out_val(idk,idl,idm)=liq_ice_air_massfraction_air_si(&
                    in_t(idk,idl,idm), in_p(idk,idl,idm))
                case default
                    write(*,*) 'Unknown function'
            end select
    enddo
    enddo
    enddo
 
end subroutine liq_ice_air_sat

subroutine liq_ice_air_g_ref(in_name,in_q,in_t,in_p, in_ref, k, l, m, out_val)
    !This subroutine is a wrapper for the Gibbs function formulation of humid air thermodynamics.
    !All of these functions require a reference value
    !Available routines:
    !
    ! Liq_Ice_Air_5
    ! pottemp
    ! pottempequi
    ! pottempequipseudo

    use liq_ice_air_5d
    implicit none
    integer :: k, l, m, idk, idl, idm
    real(8) :: in_q(k,l,m), in_t(k,l,m), in_p(k,l,m), in_ref(k,l,m)
    real(8) :: out_val(k,l,m)
    character (len = *) :: in_name

!f2py real(8), intent(out), dimension(k,l,m) :: out_val
!f2py real(8), intent(in), dimension(k,l,m) :: in_q, in_t, in_p, in_ref
!f2py integer, intent(in) :: k,l,m
!f2py character(len = *), intent(in) :: in_name

    do idk=1,k
    do idl=1,l
    do idm=1,m
            select case(in_name)
                case( 'pottemp' )
                    out_val(idk,idl,idm)=liq_ice_air_pottemp_si(in_q(idk,idl,idm),&
                    in_t(idk,idl,idm), in_p(idk,idl,idm), in_ref(idk,idl,idm))
                case( 'pottempequisat' )
                    out_val(idk,idl,idm)=liq_ice_air_pottempequisat_si(in_q(idk,idl,idm),&
                    in_t(idk,idl,idm), in_p(idk,idl,idm), in_ref(idk,idl,idm))
                case( 'pottempequi' )
                    out_val(idk,idl,idm)=liq_ice_air_pottempequi_si(in_q(idk,idl,idm),&
                    in_t(idk,idl,idm), in_p(idk,idl,idm), in_ref(idk,idl,idm))
                case( 'pottempequipseudo' )
                    out_val(idk,idl,idm)=liq_ice_air_pottempequipseudo_si(in_q(idk,idl,idm),&
                    in_t(idk,idl,idm), in_p(idk,idl,idm), in_ref(idk,idl,idm))
                case default
                    write(*,*) 'Unknown function'
            end select
    enddo
    enddo
    enddo
 
end subroutine liq_ice_air_g_ref

subroutine liq_ice_air_g(in_name,in_q,in_t,in_p, k, l, m, out_val)
    !This subroutine is a wrapper for the Gibbs function formulation of humid air thermodynamics.
    !All of these functions require a reference value
    !Available routines:
    !
    ! Liq_Ice_Air_5
    ! entropy

    use liq_ice_air_5b
    use liq_ice_air_5c
    use liq_ice_air_5d
    !use liq_ice_air_5e
    implicit none
    integer :: k, l, m, idk, idl, idm
    real(8) :: in_q(k,l,m), in_t(k,l,m), in_p(k,l,m)
    real(8) :: out_val(k,l,m)
    character (len = *) :: in_name

!f2py real(8), intent(out), dimension(k,l,m) :: out_val
!f2py real(8), intent(in), dimension(k,l,m) :: in_q, in_t, in_p
!f2py integer, intent(in) :: k,l,m
!f2py character(len = *), intent(in) :: in_name

    do idk=1,k
    do idl=1,l
    do idm=1,m
            select case(in_name)
                case( 'rh_wmo' )
                    out_val(idk,idl,idm)=liq_ice_air_g_rh_wmo_si(in_q(idk,idl,idm),&
                    in_t(idk,idl,idm), in_p(idk,idl,idm))
                case( 'entropy' )
                    out_val(idk,idl,idm)=liq_ice_air_g_entropy_si(in_q(idk,idl,idm),&
                    in_t(idk,idl,idm), in_p(idk,idl,idm))
                case( 'density' )
                    out_val(idk,idl,idm)=liq_ice_air_g_density_si(in_q(idk,idl,idm),&
                    in_t(idk,idl,idm), in_p(idk,idl,idm))
                case( 'enthalpy' )
                    out_val(idk,idl,idm)=liq_ice_air_g_enthalpy_si(in_q(idk,idl,idm),&
                    in_t(idk,idl,idm), in_p(idk,idl,idm))
                case( 'cond_entropy' )
                    out_val(idk,idl,idm)=liq_ice_air_g_cond_entropy_si(in_q(idk,idl,idm),&
                    in_t(idk,idl,idm), in_p(idk,idl,idm))
                case( 'temperatureequi' )
                    out_val(idk,idl,idm)=liq_ice_air_g_temperatureequi_si(&
                    in_q(idk,idl,idm),&
                    in_t(idk,idl,idm), in_p(idk,idl,idm))
                !case( 'temperaturewetbulb' )
                !    out_val(idk,idl,idm)=liq_ice_air_g_temperaturewetbulb_si(&
                !    in_q(idk,idl,idm),&
                !    in_t(idk,idl,idm), in_p(idk,idl,idm))
                case default
                    write(*,*) 'Unknown function'
            end select
    enddo
    enddo
    enddo
 
end subroutine liq_ice_air_g

subroutine liq_ice_air_h(in_name,in_q,in_s,in_p, k, l, m, out_val)
    !This subroutine is a wrapper for the Gibbs function formulation of humid air thermodynamics.
    !All of these functions require a reference value
    !Available routines:
    !
    ! Liq_Ice_Air_5
    ! temperature

    use liq_ice_air_5a
    implicit none
    integer :: k, l, m, idk, idl, idm
    real(8) :: in_q(k,l,m), in_s(k,l,m), in_p(k,l,m)
    real(8) :: out_val(k,l,m)
    character (len = *) :: in_name

!f2py real(8), intent(out), dimension(k,l,m) :: out_val
!f2py real(8), intent(in), dimension(k,l,m) :: in_q, in_s, in_p
!f2py integer, intent(in) :: k,l,m
!f2py character(len = *), intent(in) :: in_name

    do idk=1,k
    do idl=1,l
    do idm=1,m
            select case(in_name)
                case( 'temperature' )
                    out_val(idk,idl,idm)=liq_ice_air_h_temperature_si(in_q(idk,idl,idm),&
                    in_s(idk,idl,idm), in_p(idk,idl,idm))
                case( 'density' )
                    out_val(idk,idl,idm)=liq_ice_air_h_density_si(in_q(idk,idl,idm),&
                    in_s(idk,idl,idm), in_p(idk,idl,idm))
                case( 'enthalpy' )
                    out_val(idk,idl,idm)=liq_ice_air_h_enthalpy_si(in_q(idk,idl,idm),&
                    in_s(idk,idl,idm), in_p(idk,idl,idm))
                case( 'gc_gv' )
                    out_val(idk,idl,idm)=liq_ice_air_h_gc_gv_si(in_q(idk,idl,idm),&
                    in_s(idk,idl,idm), in_p(idk,idl,idm))
                case( 'gd_gc' )
                    out_val(idk,idl,idm)=liq_ice_air_h_gd_gc_si(in_q(idk,idl,idm),&
                    in_s(idk,idl,idm), in_p(idk,idl,idm))
                case( 'gd' )
                    out_val(idk,idl,idm)=liq_ice_air_h_gd_si(in_q(idk,idl,idm),&
                    in_s(idk,idl,idm), in_p(idk,idl,idm))
                case( 'gc' )
                    out_val(idk,idl,idm)=liq_ice_air_h_gc_si(in_q(idk,idl,idm),&
                    in_s(idk,idl,idm), in_p(idk,idl,idm))
                case( 'gh_gc' )
                    out_val(idk,idl,idm)=liq_ice_air_h_gh_gc_si(in_q(idk,idl,idm),&
                    in_s(idk,idl,idm), in_p(idk,idl,idm))
                case default
                    write(*,*) 'Unknown function'
            end select
    enddo
    enddo
    enddo
 
end subroutine liq_ice_air_h

subroutine liq_ice_air_il(in_name,in_q,in_s, k, l, m, out_val)
    !This subroutine is a wrapper for the Gibbs function formulation of humid air thermodynamics.
    !All of these functions require a reference value
    !Available routines:
    !
    ! Liq_Ice_Air_4
    ! iml
    ! ifl

    use liq_ice_air_4
    implicit none
    integer :: k, l, m, idk, idl, idm
    real(8) :: in_q(k,l,m), in_s(k,l,m)
    real(8) :: out_val(k,l,m)
    character (len = *) :: in_name

!f2py real(8), intent(out), dimension(k,l,m) :: out_val
!f2py real(8), intent(in), dimension(k,l,m) :: in_q, in_s
!f2py integer, intent(in) :: k,l,m
!f2py character(len = *), intent(in) :: in_name

    do idk=1,k
    do idl=1,l
    do idm=1,m
            select case(in_name)
                case( 'iml' )
                    out_val(idk,idl,idm)=liq_ice_air_iml_si(in_q(idk,idl,idm),&
                                                                      in_s(idk,idl,idm))
                case( 'ifl' )
                    out_val(idk,idl,idm)=liq_ice_air_ifl_si(in_q(idk,idl,idm),&
                                                                      in_s(idk,idl,idm))
                case default
                    write(*,*) 'Unknown function'
            end select
    enddo
    enddo
    enddo
 
end subroutine liq_ice_air_il
